-- =================================================================================
-- Generated reference-SQL-dump (hopefully of latest prod-release).
-- See: net.hostsharing.hsadminng.hs.migration.LiquibaseCompatibilityIntegrationTest
-- ---------------------------------------------------------------------------------

--
-- Explicit pre-initialization because we cannot use `pg_dump --create ...`
-- because the database is already created by Testcontainers.
--

DO
'
    BEGIN
        IF NOT EXISTS (SELECT FROM pg_catalog.pg_roles WHERE  rolname = $$postgres$$) THEN
            CREATE ROLE postgres;
        END IF;
        IF NOT EXISTS (SELECT FROM pg_catalog.pg_roles WHERE  rolname = $$admin$$) THEN
            CREATE ROLE admin;
        END IF;
        IF NOT EXISTS (SELECT FROM pg_catalog.pg_roles WHERE  rolname = $$restricted$$) THEN
            CREATE ROLE restricted;
        END IF;
    END
';


--
-- PostgreSQL database dump
--

-- Dumped from database version 15.5 (Debian 15.5-1.pgdg120+1)
-- Dumped by pg_dump version 16.6 (Ubuntu 16.6-0ubuntu0.24.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: base; Type: SCHEMA; Schema: -; Owner: test
--

CREATE SCHEMA base;


ALTER SCHEMA base OWNER TO admin;

--
-- Name: hs_integration; Type: SCHEMA; Schema: -; Owner: test
--

CREATE SCHEMA hs_integration;


ALTER SCHEMA hs_integration OWNER TO admin;

--
-- Name: hs_office; Type: SCHEMA; Schema: -; Owner: test
--

CREATE SCHEMA hs_office;


ALTER SCHEMA hs_office OWNER TO admin;

--
-- Name: rbac; Type: SCHEMA; Schema: -; Owner: test
--

CREATE SCHEMA rbac;


ALTER SCHEMA rbac OWNER TO admin;

--
-- Name: rbactest; Type: SCHEMA; Schema: -; Owner: test
--

CREATE SCHEMA rbactest;


ALTER SCHEMA rbactest OWNER TO admin;

--
-- Name: uuid-ossp; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS "uuid-ossp" WITH SCHEMA public;


--
-- Name: EXTENSION "uuid-ossp"; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION "uuid-ossp" IS 'generate universally unique identifiers (UUIDs)';


--
-- Name: tx_operation; Type: TYPE; Schema: base; Owner: test
--

CREATE TYPE base.tx_operation AS ENUM (
    'INSERT',
    'UPDATE',
    'DELETE',
    'TRUNCATE'
);


ALTER TYPE base.tx_operation OWNER TO admin;

--
-- Name: coopassetstransactiontype; Type: TYPE; Schema: hs_office; Owner: test
--

CREATE TYPE hs_office.coopassetstransactiontype AS ENUM (
    'REVERSAL',
    'DEPOSIT',
    'DISBURSAL',
    'TRANSFER',
    'ADOPTION',
    'CLEARING',
    'LOSS',
    'LIMITATION'
);


ALTER TYPE hs_office.coopassetstransactiontype OWNER TO admin;

--
-- Name: coopsharestransactiontype; Type: TYPE; Schema: hs_office; Owner: test
--

CREATE TYPE hs_office.coopsharestransactiontype AS ENUM (
    'REVERSAL',
    'SUBSCRIPTION',
    'CANCELLATION'
);


ALTER TYPE hs_office.coopsharestransactiontype OWNER TO admin;

--
-- Name: hsofficemembershipstatus; Type: TYPE; Schema: hs_office; Owner: test
--

CREATE TYPE hs_office.hsofficemembershipstatus AS ENUM (
    'INVALID',
    'ACTIVE',
    'CANCELLED',
    'TRANSFERRED',
    'DECEASED',
    'LIQUIDATED',
    'EXPULSED',
    'UNKNOWN'
);


ALTER TYPE hs_office.hsofficemembershipstatus OWNER TO admin;

--
-- Name: persontype; Type: TYPE; Schema: hs_office; Owner: test
--

CREATE TYPE hs_office.persontype AS ENUM (
    '??',
    'NP',
    'LP',
    'OU',
    'IF',
    'UF',
    'PI'
);


ALTER TYPE hs_office.persontype OWNER TO admin;

--
-- Name: relationtype; Type: TYPE; Schema: hs_office; Owner: test
--

CREATE TYPE hs_office.relationtype AS ENUM (
    'UNKNOWN',
    'PARTNER',
    'EX_PARTNER',
    'REPRESENTATIVE',
    'DEBITOR',
    'VIP_CONTACT',
    'OPERATIONS',
    'OPERATIONS_ALERT',
    'SUBSCRIBER'
);


ALTER TYPE hs_office.relationtype OWNER TO admin;

--
-- Name: rbacop; Type: DOMAIN; Schema: rbac; Owner: test
--

CREATE DOMAIN rbac.rbacop AS character varying(6)
	CONSTRAINT rbacop_check CHECK ((((VALUE)::text = 'DELETE'::text) OR ((VALUE)::text = 'UPDATE'::text) OR ((VALUE)::text = 'SELECT'::text) OR ((VALUE)::text = 'INSERT'::text) OR ((VALUE)::text = 'ASSUME'::text)));


ALTER DOMAIN rbac.rbacop OWNER TO admin;

--
-- Name: referencetype; Type: TYPE; Schema: rbac; Owner: test
--

CREATE TYPE rbac.referencetype AS ENUM (
    'rbac.subject',
    'rbac.role',
    'rbac.permission'
);


ALTER TYPE rbac.referencetype OWNER TO admin;

--
-- Name: roletype; Type: TYPE; Schema: rbac; Owner: test
--

CREATE TYPE rbac.roletype AS ENUM (
    'OWNER',
    'ADMIN',
    'AGENT',
    'TENANT',
    'GUEST',
    'REFERRER'
);


ALTER TYPE rbac.roletype OWNER TO admin;

--
-- Name: roledescriptor; Type: TYPE; Schema: rbac; Owner: test
--

CREATE TYPE rbac.roledescriptor AS (
	objecttable character varying(63),
	objectuuid uuid,
	roletype rbac.roletype,
	assumed boolean
);


ALTER TYPE rbac.roledescriptor OWNER TO admin;

--
-- Name: CAST (character varying AS hs_office.coopassetstransactiontype); Type: CAST; Schema: -; Owner: -
--

CREATE CAST (character varying AS hs_office.coopassetstransactiontype) WITH INOUT AS IMPLICIT;


--
-- Name: CAST (character varying AS hs_office.coopsharestransactiontype); Type: CAST; Schema: -; Owner: -
--

CREATE CAST (character varying AS hs_office.coopsharestransactiontype) WITH INOUT AS IMPLICIT;


--
-- Name: CAST (character varying AS hs_office.hsofficemembershipstatus); Type: CAST; Schema: -; Owner: -
--

CREATE CAST (character varying AS hs_office.hsofficemembershipstatus) WITH INOUT AS IMPLICIT;


--
-- Name: CAST (character varying AS hs_office.persontype); Type: CAST; Schema: -; Owner: -
--

CREATE CAST (character varying AS hs_office.persontype) WITH INOUT AS IMPLICIT;


--
-- Name: CAST (character varying AS hs_office.relationtype); Type: CAST; Schema: -; Owner: -
--

CREATE CAST (character varying AS hs_office.relationtype) WITH INOUT AS IMPLICIT;


--
-- Name: asserttrue(boolean, text); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.asserttrue(expectedtrue boolean, msg text) RETURNS boolean
    LANGUAGE plpgsql
    AS '
begin
    assert expectedTrue, msg;
    return expectedTrue;
end; ';


ALTER FUNCTION base.asserttrue(expectedtrue boolean, msg text) OWNER TO admin;

--
-- Name: assumedroles(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.assumedroles() RETURNS character varying[]
    LANGUAGE plpgsql STABLE
    AS '
begin
    return string_to_array(current_setting(''hsadminng.assumedRoles'', true), '';'');
end; ';


ALTER FUNCTION base.assumedroles() OWNER TO admin;

--
-- Name: biginthash(text); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.biginthash(text) RETURNS bigint
    LANGUAGE sql
    AS '
select (''x''||substr(md5($1),1,16))::bit(64)::bigint;
';


ALTER FUNCTION base.biginthash(text) OWNER TO admin;

--
-- Name: cleanidentifier(character varying); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.cleanidentifier(rawidentifier character varying) RETURNS character varying
    LANGUAGE plpgsql STRICT
    AS '
declare
    cleanIdentifier varchar;
begin
    cleanIdentifier := regexp_replace(rawIdentifier, ''[^A-Za-z0-9\-._|]+'', '''', ''g'');
    return cleanIdentifier;
end; ';


ALTER FUNCTION base.cleanidentifier(rawidentifier character varying) OWNER TO admin;

--
-- Name: combine_table_schema_and_name(name, name); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.combine_table_schema_and_name(tableschema name, tablename name) RETURNS text
    LANGUAGE plpgsql
    AS '
begin
    assert  LEFT(tableSchema, 1) <> ''"'', ''tableSchema must not start with "'';
    assert  LEFT(tableName, 1) <> ''"'', ''tableName must not start with "'';

    if tableSchema is null or tableSchema = ''public'' or tableSchema = '''' then
        return tableName::text;
    else
        return tableSchema::text || ''.'' || tableName::text;
    end if;
end; ';


ALTER FUNCTION base.combine_table_schema_and_name(tableschema name, tablename name) OWNER TO admin;

--
-- Name: contextdefined(character varying, text, character varying, character varying); Type: PROCEDURE; Schema: base; Owner: test
--

CREATE PROCEDURE base.contextdefined(IN currenttask character varying, IN currentrequest text, IN currentsubject character varying, IN assumedroles character varying)
    LANGUAGE plpgsql
    AS '
declare
    currentSubjectUuid uuid;
begin
    execute format(''set local hsadminng.currentTask to %L'', currentTask);

    execute format(''set local hsadminng.currentRequest to %L'', currentRequest);

    execute format(''set local hsadminng.currentSubject to %L'', currentSubject);
    select rbac.determineCurrentSubjectUuid(currentSubject) into currentSubjectUuid;
    execute format(''set local hsadminng.currentSubjectUuid to %L'', coalesce(currentSubjectUuid::text, ''''));

    execute format(''set local hsadminng.assumedRoles to %L'', assumedRoles);
    execute format(''set local hsadminng.currentSubjectOrAssumedRolesUuids to %L'',
       (select array_to_string(rbac.determineCurrentSubjectOrAssumedRolesUuids(currentSubjectUuid, assumedRoles), '';'')));

    raise notice ''Context defined as: %, %, %, [%]'', currentTask, currentRequest, currentSubject, assumedRoles;
end; ';


ALTER PROCEDURE base.contextdefined(IN currenttask character varying, IN currentrequest text, IN currentsubject character varying, IN assumedroles character varying) OWNER TO admin;

--
-- Name: create_journal(character varying); Type: PROCEDURE; Schema: base; Owner: test
--

CREATE PROCEDURE base.create_journal(IN targettable character varying)
    LANGUAGE plpgsql
    AS '
declare
    createTriggerSQL varchar;
begin
    targetTable := lower(targetTable);

    
    createTriggerSQL = ''CREATE TRIGGER tx_0_journal_tg'' ||
                       '' AFTER INSERT OR UPDATE OR DELETE ON '' || targetTable ||
                       ''   FOR EACH ROW EXECUTE PROCEDURE base.tx_journal_trigger()'';
    execute createTriggerSQL;
end; ';


ALTER PROCEDURE base.create_journal(IN targettable character varying) OWNER TO admin;

--
-- Name: currentrequest(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.currentrequest() RETURNS text
    LANGUAGE plpgsql STABLE
    AS '
declare
    currentRequest text;
begin
    begin
        currentRequest := current_setting(''hsadminng.currentRequest'');
    exception
        when others then
            currentRequest := null;
    end;
    return currentRequest;
end; ';


ALTER FUNCTION base.currentrequest() OWNER TO admin;

--
-- Name: currentsubject(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.currentsubject() RETURNS character varying
    LANGUAGE plpgsql STABLE
    AS '
declare
    currentSubject varchar(63);
begin
    begin
        currentSubject := current_setting(''hsadminng.currentSubject'');
    exception
        when others then
            currentSubject := null;
    end;
    return currentSubject;
end; ';


ALTER FUNCTION base.currentsubject() OWNER TO admin;

--
-- Name: currentsubjects(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.currentsubjects() RETURNS character varying[]
    LANGUAGE plpgsql STABLE
    AS '
declare
    assumedRoles varchar(1023)[];
begin
    assumedRoles := base.assumedRoles();
    if array_length(assumedRoles, 1) > 0 then
        return assumedRoles;
    else
        return array [base.currentSubject()]::varchar(1023)[];
    end if;
end; ';


ALTER FUNCTION base.currentsubjects() OWNER TO admin;

--
-- Name: currenttask(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.currenttask() RETURNS character varying
    LANGUAGE plpgsql STABLE
    AS '
declare
    currentTask varchar(127);
begin
    begin
        currentTask := current_setting(''hsadminng.currentTask'');
    exception
        when others then
            currentTask := null;
    end;
    if (currentTask is null or currentTask = '''') then
        raise exception ''[401] currentTask must be defined, please call `base.defineContext(...)`'';
    end if;
    return currentTask;
end; ';


ALTER FUNCTION base.currenttask() OWNER TO admin;

--
-- Name: definecontext(character varying, text, character varying, text); Type: PROCEDURE; Schema: base; Owner: test
--

CREATE PROCEDURE base.definecontext(IN currenttask character varying, IN currentrequest text DEFAULT NULL::text, IN currentsubject character varying DEFAULT NULL::character varying, IN assumedroles text DEFAULT NULL::text)
    LANGUAGE plpgsql
    AS '
begin
    currentTask := coalesce(currentTask, '''');
    assert length(currentTask) <= 127, FORMAT(''currentTask must not be longer than 127 characters: "%s"'', currentTask);
    assert length(currentTask) >= 12, FORMAT(''currentTask must be at least 12 characters long: "%s""'', currentTask);
    execute format(''set local hsadminng.currentTask to %L'', currentTask);

    currentRequest := coalesce(currentRequest, '''');
    execute format(''set local hsadminng.currentRequest to %L'', currentRequest);

    currentSubject := coalesce(currentSubject, '''');
    assert length(currentSubject) <= 63, FORMAT(''currentSubject must not be longer than 63 characters: "%s"'', currentSubject);
    execute format(''set local hsadminng.currentSubject to %L'', currentSubject);

    assumedRoles := coalesce(assumedRoles, '''');
    assert length(assumedRoles) <= 4096, FORMAT(''assumedRoles must not be longer than 4096 characters: "%s"'', assumedRoles);
    execute format(''set local hsadminng.assumedRoles to %L'', assumedRoles);

    call base.contextDefined(currentTask, currentRequest, currentSubject, assumedRoles);
end; ';


ALTER PROCEDURE base.definecontext(IN currenttask character varying, IN currentrequest text, IN currentsubject character varying, IN assumedroles text) OWNER TO admin;

--
-- Name: hasassumedrole(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.hasassumedrole() RETURNS boolean
    LANGUAGE plpgsql STABLE
    AS '
begin
    return array_length(base.assumedRoles(), 1) > 0;
end; ';


ALTER FUNCTION base.hasassumedrole() OWNER TO admin;

--
-- Name: inttovarchar(integer, integer); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.inttovarchar(i integer, len integer) RETURNS character varying
    LANGUAGE plpgsql
    AS '
declare
    partial varchar;
begin
    select chr(ascii(''a'') + i % 26) into partial;
    if len > 1 then
        return base.intToVarChar(i / 26, len - 1) || partial;
    else
        return partial;
    end if;
end; ';


ALTER FUNCTION base.inttovarchar(i integer, len integer) OWNER TO admin;

--
-- Name: jsonb_changes_delta(jsonb, jsonb); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.jsonb_changes_delta(oldjson jsonb, newjson jsonb) RETURNS jsonb
    LANGUAGE plpgsql
    AS '
declare
    diffJson       jsonb;
    oldJsonElement record;
begin
    if oldJson is null or jsonb_typeof(oldJson) = ''null'' or
        newJson is null or jsonb_typeof(newJson) = ''null'' then
        return newJson;
    end if;

    diffJson = newJson;
    for oldJsonElement in select * from jsonb_each(oldJson)
        loop
            if diffJson @> jsonb_build_object(oldJsonElement.key, oldJsonElement.value) then
                diffJson = diffJson - oldJsonElement.key;
            elsif diffJson ? oldJsonElement.key then
                if jsonb_typeof(newJson -> (oldJsonElement.key)) = ''object'' then
                    diffJson = diffJson ||
                               jsonb_build_object(oldJsonElement.key,
                                                  base.jsonb_changes_delta(oldJsonElement.value, newJson -> (oldJsonElement.key)));
                end if;
            else
                diffJson = diffJson || jsonb_build_object(oldJsonElement.key, null);
            end if;
        end loop;
    return diffJson;
end; ';


ALTER FUNCTION base.jsonb_changes_delta(oldjson jsonb, newjson jsonb) OWNER TO admin;

--
-- Name: lastrowcount(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.lastrowcount() RETURNS bigint
    LANGUAGE plpgsql
    AS '
declare
    lastRowCount bigint;
begin
    get diagnostics lastRowCount = row_count;
    return lastRowCount;
end; ';


ALTER FUNCTION base.lastrowcount() OWNER TO admin;

--
-- Name: pureidentifier(character varying); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.pureidentifier(rawidentifier character varying) RETURNS character varying
    LANGUAGE plpgsql STRICT
    AS '
declare
    cleanIdentifier varchar;
begin
    cleanIdentifier := base.cleanIdentifier(rawIdentifier);
    if cleanIdentifier != rawIdentifier then
        raise exception ''identifier "%" contains invalid characters, maybe use "%"'', rawIdentifier, cleanIdentifier;
    end if;
    return cleanIdentifier;
end; ';


ALTER FUNCTION base.pureidentifier(rawidentifier character varying) OWNER TO admin;

--
-- Name: raiseexception(text); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.raiseexception(msg text) RETURNS character varying
    LANGUAGE plpgsql
    AS '
begin
    raise exception using message = msg;
end; ';


ALTER FUNCTION base.raiseexception(msg text) OWNER TO admin;

--
-- Name: randominrange(integer, integer); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.randominrange(min integer, max integer) RETURNS integer
    LANGUAGE plpgsql STRICT
    AS '
begin
    return floor(random() * (max - min + 1) + min);
end; ';


ALTER FUNCTION base.randominrange(min integer, max integer) OWNER TO admin;

--
-- Name: tablecolumnnames(text); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.tablecolumnnames(oftablename text) RETURNS text
    LANGUAGE plpgsql STABLE
    AS '
declare
    tableName   text;
    tableSchema text;
    columns     text[];
begin
    tableSchema := CASE
                       WHEN position(''.'' in ofTableName) > 0 THEN split_part(ofTableName, ''.'', 1)
                       ELSE ''public''
                   END;

    tableName := CASE
                     WHEN position(''.'' in ofTableName) > 0 THEN split_part(ofTableName, ''.'', 2)
                     ELSE ofTableName
        END;

    columns := (select array(select column_name::text
                               from information_schema.columns
                              where table_name = tableName
                                and table_schema = tableSchema));
    assert cardinality(columns) > 0, ''cannot determine columns of table '' || ofTableName ||
                                     ''("'' || tableSchema || ''"."'' || tableName || ''")'';
    return array_to_string(columns, '', '');
end; ';


ALTER FUNCTION base.tablecolumnnames(oftablename text) OWNER TO admin;

--
-- Name: tx_create_historicization(character varying); Type: PROCEDURE; Schema: base; Owner: test
--

CREATE PROCEDURE base.tx_create_historicization(IN basetable character varying)
    LANGUAGE plpgsql
    AS '
declare
    createHistTableSql varchar;
    createTriggerSQL   varchar;
    viewName           varchar;
    exVersionsTable    varchar;
    createViewSQL      varchar;
    baseCols           varchar;
begin

    
    createHistTableSql = '''' ||
                         ''CREATE TABLE '' || baseTable || ''_ex ('' ||
                         ''   version_id serial PRIMARY KEY,'' ||
                         ''   txid xid8 NOT NULL REFERENCES base.tx_context(txid),'' ||
                         ''   trigger_op base.tx_operation NOT NULL,'' ||
                         ''   alive boolean not null,'' ||
                         ''   LIKE '' || baseTable ||
                         ''       EXCLUDING CONSTRAINTS'' ||
                         ''       EXCLUDING STATISTICS'' ||
                         '')'';
    
    execute createHistTableSql;

    
    viewName = baseTable || ''_hv'';
    exVersionsTable = baseTable || ''_ex'';
    baseCols = (select string_agg(quote_ident(column_name), '', '')
                    from information_schema.columns
                    where table_schema = ''public''
                      and table_name = baseTable);

    createViewSQL = format(
            ''CREATE OR REPLACE VIEW %1$s AS'' ||
            ''('' ||
                
            ''  WITH txh AS (SELECT base.tx_history_txid() AS txid) '' ||
            ''  SELECT %2$s'' ||
            ''    FROM %3$s'' ||
            ''   WHERE alive = TRUE'' ||
            ''     AND version_id IN'' ||
            ''         ('' ||
            ''             SELECT max(ex.version_id) AS history_id'' ||
            ''               FROM %3$s AS ex'' ||
            ''               JOIN base.tx_context as txc ON ex.txid = txc.txid'' ||
            ''              WHERE txc.txid <= (SELECT txid FROM txh)'' ||
            ''              GROUP BY uuid'' ||
            ''         )'' ||
            '')'',
            viewName, baseCols, exVersionsTable
        );
    
    execute createViewSQL;

    
    createTriggerSQL = ''CREATE TRIGGER tx_9_historicize_tg'' ||
                       '' AFTER INSERT OR DELETE OR UPDATE ON '' || baseTable ||
                       ''   FOR EACH ROW EXECUTE PROCEDURE base.tx_historicize_tf()'';
    execute createTriggerSQL;

end; ';


ALTER PROCEDURE base.tx_create_historicization(IN basetable character varying) OWNER TO admin;

--
-- Name: tx_historicize_tf(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.tx_historicize_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
declare
    currentSubject varchar(63);
    currentTask varchar(127);
    "row"       record;
    "alive"     boolean;
    "sql"       varchar;
begin
    
    begin
        currentSubject := current_setting(''hsadminng.currentSubject'');
    exception
        when others then
            currentSubject := null;
    end;
    if (currentSubject is null or currentSubject = '''') then
        raise exception ''hsadminng.currentSubject must be defined, please use "SET LOCAL ...;"'';
    end if;

    
    currentTask = current_setting(''hsadminng.currentTask'');
    assert currentTask is not null and length(currentTask) >= 12,
        format(''hsadminng.currentTask (%s) must be defined and min 12 characters long, please use "SET LOCAL ...;"'',
               currentTask);
    assert length(currentTask) <= 127,
        format(''hsadminng.currentTask (%s) must not be longer than 127 characters"'', currentTask);

    if (TG_OP = ''INSERT'') or (TG_OP = ''UPDATE'') then
        "row" := NEW;
        "alive" := true;
    else 
        "row" := OLD;
        "alive" := false;
    end if;

    sql := format(''INSERT INTO %3$s_ex VALUES (DEFAULT, pg_current_xact_id(), %1$L, %2$L, $1.*)'',
                  TG_OP, alive, base.combine_table_schema_and_name(tg_table_schema, tg_table_name)::name);
    
    execute sql using "row";

    return "row";
end; ';


ALTER FUNCTION base.tx_historicize_tf() OWNER TO admin;

--
-- Name: tx_history_txid(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.tx_history_txid() RETURNS xid8
    LANGUAGE plpgsql STABLE
    AS '
declare
    historicalTxIdSetting text;
    historicalTimestampSetting text;
    historicalTxId xid8;
    historicalTimestamp timestamp;
begin
    select coalesce(current_setting(''hsadminng.tx_history_txid'', true), '''') into historicalTxIdSetting;
    select coalesce(current_setting(''hsadminng.tx_history_timestamp'', true), '''') into historicalTimestampSetting;
    if historicalTxIdSetting > '''' and historicalTimestampSetting > '''' then
        raise exception ''either hsadminng.tx_history_txid or hsadminng.tx_history_timestamp must be set, but both are set: (%, %)'',
            historicalTxIdSetting, historicalTimestampSetting;
    end if;
    if historicalTxIdSetting = '''' and historicalTimestampSetting = '''' then
        raise exception ''either hsadminng.tx_history_txid or hsadminng.tx_history_timestamp must be set, but both are unset or empty: (%, %)'',
            historicalTxIdSetting, historicalTimestampSetting;
    end if;
    
    

    if historicalTxIdSetting is null or historicalTxIdSetting = '''' then
        select historicalTimestampSetting::timestamp into historicalTimestamp;
        select max(txc.txid) from base.tx_context txc where txc.txtimestamp <= historicalTimestamp into historicalTxId;
    else
        historicalTxId = historicalTxIdSetting::xid8;
    end if;
    return historicalTxId;
end; ';


ALTER FUNCTION base.tx_history_txid() OWNER TO admin;

--
-- Name: tx_journal_trigger(); Type: FUNCTION; Schema: base; Owner: test
--

CREATE FUNCTION base.tx_journal_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    curTask text;
    curTxId xid8;
    tableSchemaAndName text;
begin
    curTask := base.currentTask();
    curTxId := pg_current_xact_id();
    tableSchemaAndName := base.combine_table_schema_and_name(tg_table_schema, tg_table_name);

    insert
        into base.tx_context (txId, txTimestamp, currentSubject, assumedRoles, currentTask, currentRequest)
            values ( curTxId, now(),
                     base.currentSubject(), base.assumedRoles(), curTask, base.currentRequest())
        on conflict do nothing;

    case tg_op
        when ''INSERT'' then insert
                               into base.tx_journal
                               values (curTxId, tableSchemaAndName,
                                       new.uuid, tg_op::base.tx_operation,
                                       to_jsonb(new));
        when ''UPDATE'' then insert
                               into base.tx_journal
                               values (curTxId, tableSchemaAndName,
                                       old.uuid, tg_op::base.tx_operation,
                                       base.jsonb_changes_delta(to_jsonb(old), to_jsonb(new)));
        when ''DELETE'' then insert
                               into base.tx_journal
                               values (curTxId,tableSchemaAndName,
                                       old.uuid, ''DELETE''::base.tx_operation,
                                       null::jsonb);
        else raise exception ''Trigger op % not supported for %.'', tg_op, tableSchemaAndName;
        end case;
    return null;
end; ';


ALTER FUNCTION base.tx_journal_trigger() OWNER TO admin;

SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- Name: bankaccount; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.bankaccount (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    holder character varying(64) NOT NULL,
    iban character varying(34) NOT NULL,
    bic character varying(11) NOT NULL
);


ALTER TABLE hs_office.bankaccount OWNER TO admin;

--
-- Name: bankaccount_admin(hs_office.bankaccount, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_admin(entity hs_office.bankaccount, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.bankaccount'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.bankaccount_admin(entity hs_office.bankaccount, assumed boolean) OWNER TO admin;

--
-- Name: bankaccount_agent(hs_office.bankaccount, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_agent(entity hs_office.bankaccount, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.bankaccount'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.bankaccount_agent(entity hs_office.bankaccount, assumed boolean) OWNER TO admin;

--
-- Name: bankaccount_build_rbac_system(hs_office.bankaccount); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.bankaccount_build_rbac_system(IN new hs_office.bankaccount)
    LANGUAGE plpgsql
    AS '

declare

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    perform rbac.defineRoleWithGrants(
        hs_office.bankaccount_OWNER(NEW),
            permissions => array[''DELETE''],
            incomingSuperRoles => array[rbac.global_ADMIN()],
            subjectUuids => array[rbac.currentSubjectUuid()]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.bankaccount_ADMIN(NEW),
            permissions => array[''UPDATE''],
            incomingSuperRoles => array[hs_office.bankaccount_OWNER(NEW)]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.bankaccount_REFERRER(NEW),
            permissions => array[''SELECT''],
            incomingSuperRoles => array[hs_office.bankaccount_ADMIN(NEW)]
    );

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.bankaccount_build_rbac_system(IN new hs_office.bankaccount) OWNER TO admin;

--
-- Name: bankaccount_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.bankaccount_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.bankaccount_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: bankaccount_create_test_data(character varying, character varying, character varying); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.bankaccount_create_test_data(IN givenholder character varying, IN giveniban character varying, IN givenbic character varying)
    LANGUAGE plpgsql
    AS '
declare
    emailAddr varchar;
begin
    emailAddr = ''bankaccount-admin@'' || TRIM(SUBSTRING(base.cleanIdentifier(givenHolder) FOR 32)) || ''.example.com'';
    perform rbac.create_subject(emailAddr);
    call base.defineContext(''creating bankaccount test-data'', null, emailAddr);

    raise notice ''creating test bankaccount: %'', givenHolder;
    insert
        into hs_office.bankaccount(uuid, holder, iban, bic)
        values (uuid_generate_v4(), givenHolder, givenIBAN, givenBIC);
end; ';


ALTER PROCEDURE hs_office.bankaccount_create_test_data(IN givenholder character varying, IN giveniban character varying, IN givenbic character varying) OWNER TO admin;

--
-- Name: bankaccount_guest(hs_office.bankaccount, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_guest(entity hs_office.bankaccount, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.bankaccount'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.bankaccount_guest(entity hs_office.bankaccount, assumed boolean) OWNER TO admin;

--
-- Name: bankaccount_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.bankaccount_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.bankaccount_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: bankaccount_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.bankaccount'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.bankaccount p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.bankaccount uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.bankaccount_instead_of_delete_tf() OWNER TO admin;

--
-- Name: bankaccount_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.bankaccount;
    begin
        insert
            into hs_office.bankaccount (uuid, version, holder, iban, bic)
            values (new.uuid, new.version, new.holder, new.iban, new.bic)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.bankaccount_instead_of_insert_tf() OWNER TO admin;

--
-- Name: bankaccount_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.bankaccount'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.bankaccount
                        set 
        holder = new.holder,
        iban = new.iban,
        bic = new.bic
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.bankaccount uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.bankaccount_instead_of_update_tf() OWNER TO admin;

--
-- Name: bankaccount_owner(hs_office.bankaccount, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_owner(entity hs_office.bankaccount, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.bankaccount'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.bankaccount_owner(entity hs_office.bankaccount, assumed boolean) OWNER TO admin;

--
-- Name: bankaccount_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.bankaccount_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.bankaccount;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.bankaccount LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.bankaccount_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.bankaccount_rebuild_rbac_system() OWNER TO admin;

--
-- Name: bankaccount_referrer(hs_office.bankaccount); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_referrer(entity hs_office.bankaccount) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.bankaccount'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.bankaccount_referrer(entity hs_office.bankaccount) OWNER TO admin;

--
-- Name: bankaccount_tenant(hs_office.bankaccount, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_tenant(entity hs_office.bankaccount, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.bankaccount'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.bankaccount_tenant(entity hs_office.bankaccount, assumed boolean) OWNER TO admin;

--
-- Name: bankaccount_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.bankaccount_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.bankaccount_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.bankaccount_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: contact; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.contact (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    caption character varying(128) NOT NULL,
    postaladdress jsonb NOT NULL,
    emailaddresses jsonb NOT NULL,
    phonenumbers jsonb NOT NULL
);


ALTER TABLE hs_office.contact OWNER TO admin;

--
-- Name: contact_admin(hs_office.contact, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_admin(entity hs_office.contact, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.contact'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.contact_admin(entity hs_office.contact, assumed boolean) OWNER TO admin;

--
-- Name: contact_agent(hs_office.contact, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_agent(entity hs_office.contact, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.contact'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.contact_agent(entity hs_office.contact, assumed boolean) OWNER TO admin;

--
-- Name: contact_build_rbac_system(hs_office.contact); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.contact_build_rbac_system(IN new hs_office.contact)
    LANGUAGE plpgsql
    AS '

declare

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    perform rbac.defineRoleWithGrants(
        hs_office.contact_OWNER(NEW),
            permissions => array[''DELETE''],
            incomingSuperRoles => array[rbac.global_ADMIN()],
            subjectUuids => array[rbac.currentSubjectUuid()]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.contact_ADMIN(NEW),
            permissions => array[''UPDATE''],
            incomingSuperRoles => array[hs_office.contact_OWNER(NEW)]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.contact_REFERRER(NEW),
            permissions => array[''SELECT''],
            incomingSuperRoles => array[hs_office.contact_ADMIN(NEW)]
    );

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.contact_build_rbac_system(IN new hs_office.contact) OWNER TO admin;

--
-- Name: contact_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.contact_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.contact_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: contact_create_test_data(character varying); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.contact_create_test_data(IN contcaption character varying)
    LANGUAGE plpgsql
    AS '
declare
    emailAddr       varchar;
begin
    emailAddr = ''contact-admin@'' || base.cleanIdentifier(contCaption) || ''.example.com'';
    call base.defineContext(''creating contact test-data'');
    perform rbac.create_subject(emailAddr);
    call base.defineContext(''creating contact test-data'', null, emailAddr);

    raise notice ''creating test contact: %'', contCaption;
    insert
        into hs_office.contact (caption, postaladdress, emailaddresses, phonenumbers)
        values (
            contCaption,
            ( ''{ '' ||




                ''"country": "Germany"'' ||
              ''}'')::jsonb,
            (''{ "main": "'' || emailAddr || ''" }'')::jsonb,
            (''{ "phone_office": "+49 123 1234567" }'')::jsonb
        );
end; ';


ALTER PROCEDURE hs_office.contact_create_test_data(IN contcaption character varying) OWNER TO admin;

--
-- Name: contact_create_test_data(integer, integer); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.contact_create_test_data(IN startcount integer, IN endcount integer)
    LANGUAGE plpgsql
    AS '
begin
    for t in startCount..endCount
        loop
            call hs_office.contact_create_test_data(base.intToVarChar(t, 4) || ''#'' || t);
            commit;
        end loop;
end; ';


ALTER PROCEDURE hs_office.contact_create_test_data(IN startcount integer, IN endcount integer) OWNER TO admin;

--
-- Name: contact_delete_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_delete_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''DELETE'' then
        raise exception ''invalid usage of trigger'';
    end if;

    DELETE FROM hs_office.contact_legacy_id
           WHERE uuid = OLD.uuid;

    return OLD;
end; ';


ALTER FUNCTION hs_office.contact_delete_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: contact_guest(hs_office.contact, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_guest(entity hs_office.contact, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.contact'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.contact_guest(entity hs_office.contact, assumed boolean) OWNER TO admin;

--
-- Name: contact_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.contact_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.contact_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: contact_insert_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_insert_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''INSERT'' then
        raise exception ''invalid usage of trigger'';
    end if;

    INSERT INTO hs_office.contact_legacy_id VALUES
        (NEW.uuid, nextVal(''hs_office.contact_legacy_id_seq''));

    return NEW;
end; ';


ALTER FUNCTION hs_office.contact_insert_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: contact_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.contact'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.contact p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.contact uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.contact_instead_of_delete_tf() OWNER TO admin;

--
-- Name: contact_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.contact;
    begin
        insert
            into hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers)
            values (new.uuid, new.version, new.caption, new.postaladdress, new.emailaddresses, new.phonenumbers)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.contact_instead_of_insert_tf() OWNER TO admin;

--
-- Name: contact_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.contact'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.contact
                        set 
        caption = new.caption,
        postalAddress = new.postalAddress,
        emailAddresses = new.emailAddresses,
        phoneNumbers = new.phoneNumbers
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.contact uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.contact_instead_of_update_tf() OWNER TO admin;

--
-- Name: contact_owner(hs_office.contact, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_owner(entity hs_office.contact, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.contact'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.contact_owner(entity hs_office.contact, assumed boolean) OWNER TO admin;

--
-- Name: contact_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.contact_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.contact;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.contact LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.contact_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.contact_rebuild_rbac_system() OWNER TO admin;

--
-- Name: contact_referrer(hs_office.contact); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_referrer(entity hs_office.contact) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.contact'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.contact_referrer(entity hs_office.contact) OWNER TO admin;

--
-- Name: contact_tenant(hs_office.contact, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_tenant(entity hs_office.contact, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.contact'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.contact_tenant(entity hs_office.contact, assumed boolean) OWNER TO admin;

--
-- Name: contact_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.contact_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.contact_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.contact_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: coopassetstx_check_positive_total(uuid, numeric); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassetstx_check_positive_total(formembershipuuid uuid, newassetvalue numeric) RETURNS boolean
    LANGUAGE plpgsql
    AS '
declare
    currentAssetValue numeric(12,2);
    totalAssetValue numeric(12,2);
begin
    select sum(cat.assetValue)
        from hs_office.coopassettx cat
        where cat.membershipUuid = forMembershipUuid
        into currentAssetValue;
    totalAssetValue := currentAssetValue + newAssetValue;
    if totalAssetValue::numeric < 0 then
        raise exception ''[400] coop assets transaction would result in a negative balance of assets'';
    end if;
    return true;
end; ';


ALTER FUNCTION hs_office.coopassetstx_check_positive_total(formembershipuuid uuid, newassetvalue numeric) OWNER TO admin;

--
-- Name: coopassettx; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.coopassettx (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    membershipuuid uuid NOT NULL,
    transactiontype hs_office.coopassetstransactiontype NOT NULL,
    valuedate date NOT NULL,
    assetvalue numeric(12,2) NOT NULL,
    reference character varying(48) NOT NULL,
    revertedassettxuuid uuid,
    assetadoptiontxuuid uuid,
    comment character varying(512),
    CONSTRAINT check_positive_total CHECK (hs_office.coopassetstx_check_positive_total(membershipuuid, assetvalue))
);


ALTER TABLE hs_office.coopassettx OWNER TO admin;

--
-- Name: coopassettx_admin(hs_office.coopassettx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_admin(entity hs_office.coopassettx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopassettx'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopassettx_admin(entity hs_office.coopassettx, assumed boolean) OWNER TO admin;

--
-- Name: coopassettx_agent(hs_office.coopassettx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_agent(entity hs_office.coopassettx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopassettx'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopassettx_agent(entity hs_office.coopassettx, assumed boolean) OWNER TO admin;

--
-- Name: coopassettx_build_rbac_system(hs_office.coopassettx); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.coopassettx_build_rbac_system(IN new hs_office.coopassettx)
    LANGUAGE plpgsql
    AS '

declare
    newMembership hs_office.membership;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM hs_office.membership WHERE uuid = NEW.membershipUuid    INTO newMembership;
    assert newMembership.uuid is not null, format(''newMembership must not be null for NEW.membershipUuid = %s of hs_office.coopassettx'', NEW.membershipUuid);

    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''SELECT''), hs_office.membership_AGENT(newMembership));
    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''UPDATE''), hs_office.membership_ADMIN(newMembership));

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.coopassettx_build_rbac_system(IN new hs_office.coopassettx) OWNER TO admin;

--
-- Name: coopassettx_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.coopassettx_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.coopassettx_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: coopassettx_create_test_data(numeric, character); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.coopassettx_create_test_data(IN givenpartnernumber numeric, IN givenmembernumbersuffix character)
    LANGUAGE plpgsql
    AS '
declare
    membership              hs_office.membership;
    invalidLossTx           uuid;
    transferTx              uuid;
    adoptionTx              uuid;
begin
    select m.uuid
        from hs_office.membership m
                 join hs_office.partner p on p.uuid = m.partneruuid
        where p.partnerNumber = givenPartnerNumber
          and m.memberNumberSuffix = givenMemberNumberSuffix
        into membership;

    raise notice ''creating test coopAssetsTransaction: %'', givenPartnerNumber || givenMemberNumberSuffix;
    invalidLossTx := uuid_generate_v4();
    transferTx := uuid_generate_v4();
    adoptionTx := uuid_generate_v4();
    insert
        into hs_office.coopassettx(uuid, membershipuuid, transactiontype, valuedate, assetvalue, reference, comment, revertedAssetTxUuid, assetAdoptionTxUuid)
        values
            (uuid_generate_v4(),  membership.uuid, ''DEPOSIT'',    ''2010-03-15'',  320.00, ''ref ''||givenPartnerNumber || givenMemberNumberSuffix||''-1'', ''initial deposit'', null, null),
            (uuid_generate_v4(),  membership.uuid, ''DISBURSAL'',  ''2021-09-01'', -128.00, ''ref ''||givenPartnerNumber || givenMemberNumberSuffix||''-2'', ''partial disbursal'', null, null),
            (invalidLossTx,       membership.uuid, ''DEPOSIT'',    ''2022-10-20'',  128.00, ''ref ''||givenPartnerNumber || givenMemberNumberSuffix||''-3'', ''some loss'', null, null),
            (uuid_generate_v4(),  membership.uuid, ''REVERSAL'', ''2022-10-21'', -128.00, ''ref ''||givenPartnerNumber || givenMemberNumberSuffix||''-3'', ''some reversal'', invalidLossTx, null),
            (transferTx,          membership.uuid, ''TRANSFER'', ''2023-12-31'', -192.00, ''ref ''||givenPartnerNumber || givenMemberNumberSuffix||''-3'', ''some reversal'', null, adoptionTx),
            (adoptionTx,            membership.uuid, ''ADOPTION'', ''2023-12-31'', 192.00, ''ref ''||givenPartnerNumber || givenMemberNumberSuffix||''-3'', ''some reversal'', null, null);
end; ';


ALTER PROCEDURE hs_office.coopassettx_create_test_data(IN givenpartnernumber numeric, IN givenmembernumbersuffix character) OWNER TO admin;

--
-- Name: coopassettx_delete_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_delete_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''DELETE'' then
        raise exception ''invalid usage of trigger'';
    end if;

    DELETE FROM hs_office.coopassettx_legacy_id
           WHERE uuid = OLD.uuid;

    return OLD;
end; ';


ALTER FUNCTION hs_office.coopassettx_delete_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: coopassettx_grants_insert_to_membership_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_grants_insert_to_membership_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''hs_office.coopassettx''),
            hs_office.membership_ADMIN(NEW));
    
    return NEW;
end; ';


ALTER FUNCTION hs_office.coopassettx_grants_insert_to_membership_tf() OWNER TO admin;

--
-- Name: coopassettx_guest(hs_office.coopassettx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_guest(entity hs_office.coopassettx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopassettx'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopassettx_guest(entity hs_office.coopassettx, assumed boolean) OWNER TO admin;

--
-- Name: coopassettx_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.coopassettx_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.coopassettx_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: coopassettx_insert_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_insert_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''INSERT'' then
        raise exception ''invalid usage of trigger'';
    end if;

    INSERT INTO hs_office.coopassettx_legacy_id VALUES
        (NEW.uuid, nextVal(''hs_office.coopassettx_legacy_id_seq''));

    return NEW;
end; ';


ALTER FUNCTION hs_office.coopassettx_insert_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: coopassettx_insert_permission_check_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.hasInsertPermission(NEW.membershipUuid, ''hs_office.coopassettx'') then
        return NEW;
    end if;

    raise exception ''[403] insert into hs_office.coopassettx values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION hs_office.coopassettx_insert_permission_check_tf() OWNER TO admin;

--
-- Name: coopassettx_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.coopassettx'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.coopassettx p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.coopassettx uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.coopassettx_instead_of_delete_tf() OWNER TO admin;

--
-- Name: coopassettx_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.coopassettx;
    begin
        insert
            into hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment)
            values (new.uuid, new.version, new.membershipuuid, new.transactiontype, new.valuedate, new.assetvalue, new.reference, new.revertedassettxuuid, new.assetadoptiontxuuid, new.comment)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.coopassettx_instead_of_insert_tf() OWNER TO admin;

--
-- Name: coopassettx_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.coopassettx'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.coopassettx
                        set 
        comment = new.comment
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.coopassettx uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.coopassettx_instead_of_update_tf() OWNER TO admin;

--
-- Name: coopassettx_owner(hs_office.coopassettx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_owner(entity hs_office.coopassettx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopassettx'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopassettx_owner(entity hs_office.coopassettx, assumed boolean) OWNER TO admin;

--
-- Name: coopassettx_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.coopassettx_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.coopassettx;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.coopassettx LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.coopassettx_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.coopassettx_rebuild_rbac_system() OWNER TO admin;

--
-- Name: coopassettx_referrer(hs_office.coopassettx); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_referrer(entity hs_office.coopassettx) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopassettx'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.coopassettx_referrer(entity hs_office.coopassettx) OWNER TO admin;

--
-- Name: coopassettx_tenant(hs_office.coopassettx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_tenant(entity hs_office.coopassettx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopassettx'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopassettx_tenant(entity hs_office.coopassettx, assumed boolean) OWNER TO admin;

--
-- Name: coopassettx_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopassettx_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.coopassettx_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.coopassettx_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: coopsharestx_check_positive_total(uuid, integer); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharestx_check_positive_total(formembershipuuid uuid, newsharecount integer) RETURNS boolean
    LANGUAGE plpgsql
    AS '
declare
    currentShareCount integer;
    totalShareCount integer;
begin
    select sum(cst.shareCount)
    from hs_office.coopsharetx cst
    where cst.membershipUuid = forMembershipUuid
    into currentShareCount;
    totalShareCount := currentShareCount + newShareCount;
    if totalShareCount < 0 then
        raise exception ''[400] coop shares transaction would result in a negative number of shares'';
    end if;
    return true;
end; ';


ALTER FUNCTION hs_office.coopsharestx_check_positive_total(formembershipuuid uuid, newsharecount integer) OWNER TO admin;

--
-- Name: coopsharetx; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.coopsharetx (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    membershipuuid uuid NOT NULL,
    transactiontype hs_office.coopsharestransactiontype NOT NULL,
    valuedate date NOT NULL,
    sharecount integer NOT NULL,
    reference character varying(48) NOT NULL,
    revertedsharetxuuid uuid,
    comment character varying(512),
    CONSTRAINT check_positive_total_shares_count CHECK (hs_office.coopsharestx_check_positive_total(membershipuuid, sharecount)),
    CONSTRAINT reverse_entry_missing CHECK ((((transactiontype = 'REVERSAL'::hs_office.coopsharestransactiontype) AND (revertedsharetxuuid IS NOT NULL)) OR ((transactiontype <> 'REVERSAL'::hs_office.coopsharestransactiontype) AND (revertedsharetxuuid IS NULL))))
);


ALTER TABLE hs_office.coopsharetx OWNER TO admin;

--
-- Name: coopsharetx_admin(hs_office.coopsharetx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_admin(entity hs_office.coopsharetx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopsharetx'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopsharetx_admin(entity hs_office.coopsharetx, assumed boolean) OWNER TO admin;

--
-- Name: coopsharetx_agent(hs_office.coopsharetx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_agent(entity hs_office.coopsharetx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopsharetx'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopsharetx_agent(entity hs_office.coopsharetx, assumed boolean) OWNER TO admin;

--
-- Name: coopsharetx_build_rbac_system(hs_office.coopsharetx); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.coopsharetx_build_rbac_system(IN new hs_office.coopsharetx)
    LANGUAGE plpgsql
    AS '

declare
    newMembership hs_office.membership;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM hs_office.membership WHERE uuid = NEW.membershipUuid    INTO newMembership;
    assert newMembership.uuid is not null, format(''newMembership must not be null for NEW.membershipUuid = %s of hs_office.coopsharetx'', NEW.membershipUuid);

    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''SELECT''), hs_office.membership_AGENT(newMembership));
    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''UPDATE''), hs_office.membership_ADMIN(newMembership));

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.coopsharetx_build_rbac_system(IN new hs_office.coopsharetx) OWNER TO admin;

--
-- Name: coopsharetx_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.coopsharetx_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.coopsharetx_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: coopsharetx_create_test_data(numeric, character); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.coopsharetx_create_test_data(IN givenpartnernumber numeric, IN givenmembernumbersuffix character)
    LANGUAGE plpgsql
    AS '
declare
    membership              hs_office.membership;
    subscriptionEntryUuid   uuid;
begin
    select m.uuid
        from hs_office.membership m
        join hs_office.partner p on p.uuid = m.partneruuid
        where p.partnerNumber = givenPartnerNumber
            and m.memberNumberSuffix = givenMemberNumberSuffix
        into membership;

    raise notice ''creating test coopSharesTransaction: %'', givenPartnerNumber::text || givenMemberNumberSuffix;
    subscriptionEntryUuid := uuid_generate_v4();
    insert
        into hs_office.coopsharetx(uuid, membershipuuid, transactiontype, valuedate, sharecount, reference, comment, revertedShareTxUuid)
        values
            (uuid_generate_v4(), membership.uuid, ''SUBSCRIPTION'', ''2010-03-15'', 4, ''ref ''||givenPartnerNumber::text || givenMemberNumberSuffix||''-1'', ''initial subscription'', null),
            (uuid_generate_v4(), membership.uuid, ''CANCELLATION'', ''2021-09-01'', -2, ''ref ''||givenPartnerNumber::text || givenMemberNumberSuffix||''-2'', ''cancelling some'', null),
            (subscriptionEntryUuid,       membership.uuid, ''SUBSCRIPTION'',    ''2022-10-20'',  2, ''ref ''||givenPartnerNumber::text || givenMemberNumberSuffix||''-3'', ''some subscription'', null),
            (uuid_generate_v4(), membership.uuid, ''REVERSAL'', ''2022-10-21'', -2, ''ref ''||givenPartnerNumber::text || givenMemberNumberSuffix||''-4'', ''some reversal'', subscriptionEntryUuid);
end; ';


ALTER PROCEDURE hs_office.coopsharetx_create_test_data(IN givenpartnernumber numeric, IN givenmembernumbersuffix character) OWNER TO admin;

--
-- Name: coopsharetx_delete_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_delete_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''DELETE'' then
        raise exception ''invalid usage of trigger'';
    end if;

    DELETE FROM hs_office.coopsharetx_legacy_id
           WHERE uuid = OLD.uuid;

    return OLD;
end; ';


ALTER FUNCTION hs_office.coopsharetx_delete_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: coopsharetx_grants_insert_to_membership_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_grants_insert_to_membership_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''hs_office.coopsharetx''),
            hs_office.membership_ADMIN(NEW));
    
    return NEW;
end; ';


ALTER FUNCTION hs_office.coopsharetx_grants_insert_to_membership_tf() OWNER TO admin;

--
-- Name: coopsharetx_guest(hs_office.coopsharetx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_guest(entity hs_office.coopsharetx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopsharetx'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopsharetx_guest(entity hs_office.coopsharetx, assumed boolean) OWNER TO admin;

--
-- Name: coopsharetx_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.coopsharetx_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.coopsharetx_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: coopsharetx_insert_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_insert_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''INSERT'' then
        raise exception ''invalid usage of trigger'';
    end if;

    INSERT INTO hs_office.coopsharetx_legacy_id VALUES
        (NEW.uuid, nextVal(''hs_office.coopsharetx_legacy_id_seq''));

    return NEW;
end; ';


ALTER FUNCTION hs_office.coopsharetx_insert_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: coopsharetx_insert_permission_check_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.hasInsertPermission(NEW.membershipUuid, ''hs_office.coopsharetx'') then
        return NEW;
    end if;

    raise exception ''[403] insert into hs_office.coopsharetx values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION hs_office.coopsharetx_insert_permission_check_tf() OWNER TO admin;

--
-- Name: coopsharetx_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.coopsharetx'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.coopsharetx p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.coopsharetx uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.coopsharetx_instead_of_delete_tf() OWNER TO admin;

--
-- Name: coopsharetx_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.coopsharetx;
    begin
        insert
            into hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment)
            values (new.uuid, new.version, new.membershipuuid, new.transactiontype, new.valuedate, new.sharecount, new.reference, new.revertedsharetxuuid, new.comment)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.coopsharetx_instead_of_insert_tf() OWNER TO admin;

--
-- Name: coopsharetx_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.coopsharetx'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.coopsharetx
                        set 
        comment = new.comment
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.coopsharetx uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.coopsharetx_instead_of_update_tf() OWNER TO admin;

--
-- Name: coopsharetx_owner(hs_office.coopsharetx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_owner(entity hs_office.coopsharetx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopsharetx'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopsharetx_owner(entity hs_office.coopsharetx, assumed boolean) OWNER TO admin;

--
-- Name: coopsharetx_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.coopsharetx_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.coopsharetx;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.coopsharetx LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.coopsharetx_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.coopsharetx_rebuild_rbac_system() OWNER TO admin;

--
-- Name: coopsharetx_referrer(hs_office.coopsharetx); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_referrer(entity hs_office.coopsharetx) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopsharetx'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.coopsharetx_referrer(entity hs_office.coopsharetx) OWNER TO admin;

--
-- Name: coopsharetx_tenant(hs_office.coopsharetx, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_tenant(entity hs_office.coopsharetx, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.coopsharetx'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.coopsharetx_tenant(entity hs_office.coopsharetx, assumed boolean) OWNER TO admin;

--
-- Name: coopsharetx_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.coopsharetx_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.coopsharetx_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.coopsharetx_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: debitor; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.debitor (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    debitornumbersuffix character(2) NOT NULL,
    debitorreluuid uuid NOT NULL,
    billable boolean DEFAULT true NOT NULL,
    vatid character varying(24),
    vatcountrycode character varying(2),
    vatbusiness boolean NOT NULL,
    vatreversecharge boolean NOT NULL,
    refundbankaccountuuid uuid,
    defaultprefix character(3) NOT NULL,
    CONSTRAINT check_default_prefix CHECK (((defaultprefix)::text ~ '^([a-z]{3}|al0|bh1|c4s|f3k|k8i|l3d|mh1|o13|p2m|s80|t4w)$'::text)),
    CONSTRAINT debitor_debitornumbersuffix_check CHECK (((debitornumbersuffix)::text ~ '^[0-9][0-9]$'::text))
);


ALTER TABLE hs_office.debitor OWNER TO admin;

--
-- Name: debitor_admin(hs_office.debitor, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_admin(entity hs_office.debitor, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.debitor'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.debitor_admin(entity hs_office.debitor, assumed boolean) OWNER TO admin;

--
-- Name: debitor_agent(hs_office.debitor, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_agent(entity hs_office.debitor, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.debitor'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.debitor_agent(entity hs_office.debitor, assumed boolean) OWNER TO admin;

--
-- Name: debitor_build_rbac_system(hs_office.debitor); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.debitor_build_rbac_system(IN new hs_office.debitor)
    LANGUAGE plpgsql
    AS '

declare
    newPartnerRel hs_office.relation;
    newDebitorRel hs_office.relation;
    newRefundBankAccount hs_office.bankaccount;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT partnerRel.*
        FROM hs_office.relation AS partnerRel
        JOIN hs_office.relation AS debitorRel
            ON debitorRel.type = ''DEBITOR'' AND debitorRel.anchorUuid = partnerRel.holderUuid
        WHERE partnerRel.type = ''PARTNER''
            AND NEW.debitorRelUuid = debitorRel.uuid
        INTO newPartnerRel;
    assert newPartnerRel.uuid is not null, format(''newPartnerRel must not be null for NEW.debitorRelUuid = %s of hs_office.debitor'', NEW.debitorRelUuid);

    SELECT * FROM hs_office.relation WHERE uuid = NEW.debitorRelUuid    INTO newDebitorRel;
    assert newDebitorRel.uuid is not null, format(''newDebitorRel must not be null for NEW.debitorRelUuid = %s of hs_office.debitor'', NEW.debitorRelUuid);

    SELECT * FROM hs_office.bankaccount WHERE uuid = NEW.refundBankAccountUuid    INTO newRefundBankAccount;

    call rbac.grantRoleToRole(hs_office.bankaccount_REFERRER(newRefundBankAccount), hs_office.relation_AGENT(newDebitorRel));
    call rbac.grantRoleToRole(hs_office.relation_ADMIN(newDebitorRel), hs_office.relation_ADMIN(newPartnerRel));
    call rbac.grantRoleToRole(hs_office.relation_AGENT(newDebitorRel), hs_office.bankaccount_ADMIN(newRefundBankAccount));
    call rbac.grantRoleToRole(hs_office.relation_AGENT(newDebitorRel), hs_office.relation_AGENT(newPartnerRel));
    call rbac.grantRoleToRole(hs_office.relation_TENANT(newPartnerRel), hs_office.relation_AGENT(newDebitorRel));

    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''DELETE''), hs_office.relation_OWNER(newDebitorRel));
    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''SELECT''), hs_office.relation_TENANT(newDebitorRel));
    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''UPDATE''), hs_office.relation_ADMIN(newDebitorRel));

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.debitor_build_rbac_system(IN new hs_office.debitor) OWNER TO admin;

--
-- Name: debitor_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.debitor_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.debitor_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: debitor_create_test_data(numeric, character varying, character varying, character varying); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.debitor_create_test_data(IN withdebitornumbersuffix numeric, IN forpartnerpersonname character varying, IN forbillingcontactcaption character varying, IN withdefaultprefix character varying)
    LANGUAGE plpgsql
    AS '
declare
    idName                  varchar;
    relatedDebitorRelUuid   uuid;
    relatedBankAccountUuid  uuid;
begin
    idName := base.cleanIdentifier( forPartnerPersonName|| ''-'' || forBillingContactCaption);

    select debitorRel.uuid
            into relatedDebitorRelUuid
            from hs_office.relation debitorRel
            join hs_office.person person on person.uuid = debitorRel.holderUuid
                and (person.tradeName = forPartnerPersonName or person.familyName = forPartnerPersonName)
            where debitorRel.type = ''DEBITOR'';

    select b.uuid
            into relatedBankAccountUuid
            from hs_office.bankaccount b
            where b.holder = forPartnerPersonName;

    raise notice ''creating test debitor: % (#%)'', idName, withDebitorNumberSuffix;
    
    
    insert
        into hs_office.debitor (uuid,   debitorRelUuid,        debitornumbersuffix,     billable, vatbusiness, vatreversecharge, refundbankaccountuuid,  defaultprefix)
            values (uuid_generate_v4(), relatedDebitorRelUuid, withDebitorNumberSuffix, true,     true,        false,            relatedBankAccountUuid, withDefaultPrefix);
end; ';


ALTER PROCEDURE hs_office.debitor_create_test_data(IN withdebitornumbersuffix numeric, IN forpartnerpersonname character varying, IN forbillingcontactcaption character varying, IN withdefaultprefix character varying) OWNER TO admin;

--
-- Name: debitor_delete_dependents_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_delete_dependents_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    counter integer;
begin
    DELETE FROM hs_office.relation r WHERE r.uuid = OLD.debitorRelUuid;
    GET DIAGNOSTICS counter = ROW_COUNT;
    if counter = 0 then
        raise exception ''debitor relation % could not be deleted'', OLD.debitorRelUuid;
    end if;

    RETURN OLD;
end; ';


ALTER FUNCTION hs_office.debitor_delete_dependents_tf() OWNER TO admin;

--
-- Name: debitor_grants_insert_to_global_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_grants_insert_to_global_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''hs_office.debitor''),
            rbac.global_ADMIN());
    
    return NEW;
end; ';


ALTER FUNCTION hs_office.debitor_grants_insert_to_global_tf() OWNER TO admin;

--
-- Name: debitor_guest(hs_office.debitor, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_guest(entity hs_office.debitor, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.debitor'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.debitor_guest(entity hs_office.debitor, assumed boolean) OWNER TO admin;

--
-- Name: debitor_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.debitor_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.debitor_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: debitor_insert_permission_check_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.isGlobalAdmin() then
        return NEW;
    end if;

    raise exception ''[403] insert into hs_office.debitor values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION hs_office.debitor_insert_permission_check_tf() OWNER TO admin;

--
-- Name: debitor_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.debitor'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.debitor p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.debitor uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.debitor_instead_of_delete_tf() OWNER TO admin;

--
-- Name: debitor_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.debitor;
    begin
        insert
            into hs_office.debitor (uuid, version, debitornumbersuffix, debitorreluuid, billable, vatid, vatcountrycode, vatbusiness, vatreversecharge, refundbankaccountuuid, defaultprefix)
            values (new.uuid, new.version, new.debitornumbersuffix, new.debitorreluuid, new.billable, new.vatid, new.vatcountrycode, new.vatbusiness, new.vatreversecharge, new.refundbankaccountuuid, new.defaultprefix)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.debitor_instead_of_insert_tf() OWNER TO admin;

--
-- Name: debitor_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.debitor'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.debitor
                        set 
        debitorRelUuid = new.debitorRelUuid,
        billable = new.billable,
        refundBankAccountUuid = new.refundBankAccountUuid,
        vatId = new.vatId,
        vatCountryCode = new.vatCountryCode,
        vatBusiness = new.vatBusiness,
        vatReverseCharge = new.vatReverseCharge,
        defaultPrefix = new.defaultPrefix
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.debitor uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.debitor_instead_of_update_tf() OWNER TO admin;

--
-- Name: debitor_owner(hs_office.debitor, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_owner(entity hs_office.debitor, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.debitor'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.debitor_owner(entity hs_office.debitor, assumed boolean) OWNER TO admin;

--
-- Name: debitor_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.debitor_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.debitor;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.debitor LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.debitor_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.debitor_rebuild_rbac_system() OWNER TO admin;

--
-- Name: debitor_referrer(hs_office.debitor); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_referrer(entity hs_office.debitor) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.debitor'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.debitor_referrer(entity hs_office.debitor) OWNER TO admin;

--
-- Name: debitor_tenant(hs_office.debitor, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_tenant(entity hs_office.debitor, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.debitor'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.debitor_tenant(entity hs_office.debitor, assumed boolean) OWNER TO admin;

--
-- Name: debitor_update_rbac_system(hs_office.debitor, hs_office.debitor); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.debitor_update_rbac_system(IN old hs_office.debitor, IN new hs_office.debitor)
    LANGUAGE plpgsql
    AS '
begin

    if NEW.debitorRelUuid is distinct from OLD.debitorRelUuid
    or NEW.refundBankAccountUuid is distinct from OLD.refundBankAccountUuid then
        delete from rbac.grant g where g.grantedbytriggerof = OLD.uuid;
        call hs_office.debitor_build_rbac_system(NEW);
    end if;
end; ';


ALTER PROCEDURE hs_office.debitor_update_rbac_system(IN old hs_office.debitor, IN new hs_office.debitor) OWNER TO admin;

--
-- Name: debitor_update_rbac_system_after_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_update_rbac_system_after_update_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.debitor_update_rbac_system(OLD, NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.debitor_update_rbac_system_after_update_tf() OWNER TO admin;

--
-- Name: debitor_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.debitor_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.debitor_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.debitor_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: membership; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.membership (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    partneruuid uuid NOT NULL,
    membernumbersuffix character(2) NOT NULL,
    validity daterange NOT NULL,
    status hs_office.hsofficemembershipstatus DEFAULT 'ACTIVE'::hs_office.hsofficemembershipstatus NOT NULL,
    membershipfeebillable boolean DEFAULT true NOT NULL,
    CONSTRAINT membership_membernumbersuffix_check CHECK (((membernumbersuffix)::text ~ '^[0-9][0-9]$'::text))
);


ALTER TABLE hs_office.membership OWNER TO admin;

--
-- Name: membership_admin(hs_office.membership, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_admin(entity hs_office.membership, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.membership'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.membership_admin(entity hs_office.membership, assumed boolean) OWNER TO admin;

--
-- Name: membership_agent(hs_office.membership, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_agent(entity hs_office.membership, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.membership'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.membership_agent(entity hs_office.membership, assumed boolean) OWNER TO admin;

--
-- Name: membership_build_rbac_system(hs_office.membership); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.membership_build_rbac_system(IN new hs_office.membership)
    LANGUAGE plpgsql
    AS '

declare
    newPartnerRel hs_office.relation;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT partnerRel.*
        FROM hs_office.partner AS partner
        JOIN hs_office.relation AS partnerRel ON partnerRel.uuid = partner.partnerRelUuid
        WHERE partner.uuid = NEW.partnerUuid
        INTO newPartnerRel;
    assert newPartnerRel.uuid is not null, format(''newPartnerRel must not be null for NEW.partnerUuid = %s of hs_office.membership'', NEW.partnerUuid);


    perform rbac.defineRoleWithGrants(
        hs_office.membership_OWNER(NEW),
            subjectUuids => array[rbac.currentSubjectUuid()]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.membership_ADMIN(NEW),
            permissions => array[''DELETE'', ''UPDATE''],
            incomingSuperRoles => array[
            	hs_office.membership_OWNER(NEW),
            	hs_office.relation_ADMIN(newPartnerRel)]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.membership_AGENT(NEW),
            permissions => array[''SELECT''],
            incomingSuperRoles => array[
            	hs_office.membership_ADMIN(NEW),
            	hs_office.relation_AGENT(newPartnerRel)],
            outgoingSubRoles => array[hs_office.relation_TENANT(newPartnerRel)]
    );

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.membership_build_rbac_system(IN new hs_office.membership) OWNER TO admin;

--
-- Name: membership_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.membership_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.membership_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: membership_create_test_data(numeric, character); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.membership_create_test_data(IN forpartnernumber numeric, IN newmembernumbersuffix character)
    LANGUAGE plpgsql
    AS '
declare
    relatedPartner          hs_office.partner;
begin
    select partner.* from hs_office.partner partner
                     where partner.partnerNumber = forPartnerNumber into relatedPartner;

    raise notice ''creating test Membership: M-% %'', forPartnerNumber, newMemberNumberSuffix;
    raise notice ''- using partner (%): %'', relatedPartner.uuid, relatedPartner;
    insert
        into hs_office.membership (uuid, partneruuid, memberNumberSuffix, validity, status)
        values (uuid_generate_v4(), relatedPartner.uuid, newMemberNumberSuffix, daterange(''20221001'' , null, ''[]''), ''ACTIVE'');
end; ';


ALTER PROCEDURE hs_office.membership_create_test_data(IN forpartnernumber numeric, IN newmembernumbersuffix character) OWNER TO admin;

--
-- Name: membership_grants_insert_to_global_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_grants_insert_to_global_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''hs_office.membership''),
            rbac.global_ADMIN());
    
    return NEW;
end; ';


ALTER FUNCTION hs_office.membership_grants_insert_to_global_tf() OWNER TO admin;

--
-- Name: membership_guest(hs_office.membership, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_guest(entity hs_office.membership, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.membership'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.membership_guest(entity hs_office.membership, assumed boolean) OWNER TO admin;

--
-- Name: membership_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.membership_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.membership_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: membership_insert_permission_check_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.isGlobalAdmin() then
        return NEW;
    end if;

    raise exception ''[403] insert into hs_office.membership values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION hs_office.membership_insert_permission_check_tf() OWNER TO admin;

--
-- Name: membership_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.membership'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.membership p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.membership uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.membership_instead_of_delete_tf() OWNER TO admin;

--
-- Name: membership_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.membership;
    begin
        insert
            into hs_office.membership (uuid, version, partneruuid, membernumbersuffix, validity, status, membershipfeebillable)
            values (new.uuid, new.version, new.partneruuid, new.membernumbersuffix, new.validity, new.status, new.membershipfeebillable)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.membership_instead_of_insert_tf() OWNER TO admin;

--
-- Name: membership_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.membership'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.membership
                        set 
        validity = new.validity,
        membershipFeeBillable = new.membershipFeeBillable,
        status = new.status
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.membership uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.membership_instead_of_update_tf() OWNER TO admin;

--
-- Name: membership_owner(hs_office.membership, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_owner(entity hs_office.membership, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.membership'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.membership_owner(entity hs_office.membership, assumed boolean) OWNER TO admin;

--
-- Name: membership_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.membership_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.membership;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.membership LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.membership_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.membership_rebuild_rbac_system() OWNER TO admin;

--
-- Name: membership_referrer(hs_office.membership); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_referrer(entity hs_office.membership) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.membership'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.membership_referrer(entity hs_office.membership) OWNER TO admin;

--
-- Name: membership_tenant(hs_office.membership, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_tenant(entity hs_office.membership, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.membership'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.membership_tenant(entity hs_office.membership, assumed boolean) OWNER TO admin;

--
-- Name: membership_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.membership_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.membership_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.membership_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: partner; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.partner (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    partnernumber numeric(5,0) NOT NULL,
    partnerreluuid uuid NOT NULL,
    detailsuuid uuid NOT NULL
);


ALTER TABLE hs_office.partner OWNER TO admin;

--
-- Name: partner_admin(hs_office.partner, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_admin(entity hs_office.partner, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_admin(entity hs_office.partner, assumed boolean) OWNER TO admin;

--
-- Name: partner_agent(hs_office.partner, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_agent(entity hs_office.partner, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_agent(entity hs_office.partner, assumed boolean) OWNER TO admin;

--
-- Name: partner_build_rbac_system(hs_office.partner); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.partner_build_rbac_system(IN new hs_office.partner)
    LANGUAGE plpgsql
    AS '

declare
    newPartnerRel hs_office.relation;
    newPartnerDetails hs_office.partner_details;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM hs_office.relation WHERE uuid = NEW.partnerRelUuid    INTO newPartnerRel;
    assert newPartnerRel.uuid is not null, format(''newPartnerRel must not be null for NEW.partnerRelUuid = %s of hs_office.partner'', NEW.partnerRelUuid);

    SELECT * FROM hs_office.partner_details WHERE uuid = NEW.detailsUuid    INTO newPartnerDetails;
    assert newPartnerDetails.uuid is not null, format(''newPartnerDetails must not be null for NEW.detailsUuid = %s of hs_office.partner'', NEW.detailsUuid);

    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''DELETE''), hs_office.relation_OWNER(newPartnerRel));
    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''SELECT''), hs_office.relation_TENANT(newPartnerRel));
    call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''UPDATE''), hs_office.relation_ADMIN(newPartnerRel));
    call rbac.grantPermissionToRole(rbac.createPermission(newPartnerDetails.uuid, ''DELETE''), hs_office.relation_OWNER(newPartnerRel));
    call rbac.grantPermissionToRole(rbac.createPermission(newPartnerDetails.uuid, ''SELECT''), hs_office.relation_AGENT(newPartnerRel));
    call rbac.grantPermissionToRole(rbac.createPermission(newPartnerDetails.uuid, ''UPDATE''), hs_office.relation_AGENT(newPartnerRel));

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.partner_build_rbac_system(IN new hs_office.partner) OWNER TO admin;

--
-- Name: partner_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.partner_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.partner_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: partner_create_test_data(character varying, numeric, character varying, character varying); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.partner_create_test_data(IN mandanttradename character varying, IN newpartnernumber numeric, IN partnerpersonname character varying, IN contactcaption character varying)
    LANGUAGE plpgsql
    AS '
declare
    idName              varchar;
    mandantPerson       hs_office.person;
    partnerRel         hs_office.relation;
    relatedPerson       hs_office.person;
    relatedDetailsUuid  uuid;
begin
    idName := base.cleanIdentifier( partnerPersonName|| ''-'' || contactCaption);

    select p.* from hs_office.person p
               where p.tradeName = mandantTradeName
               into mandantPerson;
    if mandantPerson is null then
        raise exception ''mandant "%" not found'', mandantTradeName;
    end if;

    select p.* from hs_office.person p
               where p.tradeName = partnerPersonName or p.familyName = partnerPersonName
               into relatedPerson;

    select r.* from hs_office.relation r
            where r.type = ''PARTNER''
                and r.anchoruuid = mandantPerson.uuid and r.holderuuid = relatedPerson.uuid
            into partnerRel;
    if partnerRel is null then
        raise exception ''partnerRel "%"-"%" not found'', mandantPerson.tradename, partnerPersonName;
    end if;

    raise notice ''creating test partner: %'', idName;
    raise notice ''- using partnerRel (%): %'', partnerRel.uuid, partnerRel;
    raise notice ''- using person (%): %'', relatedPerson.uuid, relatedPerson;

    if relatedPerson.persontype = ''NP'' then
        insert
            into hs_office.partner_details (uuid, birthName, birthday, birthPlace)
            values (uuid_generate_v4(), ''Meyer'', ''1987-10-31'', ''Hamburg'')
            returning uuid into relatedDetailsUuid;
    else
        insert
            into hs_office.partner_details (uuid, registrationOffice, registrationNumber)
            values (uuid_generate_v4(), ''Hamburg'', ''RegNo123456789'')
            returning uuid into relatedDetailsUuid;
    end if;

    insert
        into hs_office.partner (uuid, partnerNumber, partnerRelUuid, detailsUuid)
        values (uuid_generate_v4(), newPartnerNumber, partnerRel.uuid, relatedDetailsUuid);
end; ';


ALTER PROCEDURE hs_office.partner_create_test_data(IN mandanttradename character varying, IN newpartnernumber numeric, IN partnerpersonname character varying, IN contactcaption character varying) OWNER TO admin;

--
-- Name: partner_delete_dependents_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_delete_dependents_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    counter integer;
begin
    DELETE FROM hs_office.partner_details d WHERE d.uuid = OLD.detailsUuid;
    GET DIAGNOSTICS counter = ROW_COUNT;
    if counter = 0 then
        raise exception ''partner details % could not be deleted'', OLD.detailsUuid;
    end if;

    DELETE FROM hs_office.relation r WHERE r.uuid = OLD.partnerRelUuid;
    GET DIAGNOSTICS counter = ROW_COUNT;
    if counter = 0 then
        raise exception ''partner relation % could not be deleted'', OLD.partnerRelUuid;
    end if;

    RETURN OLD;
end; ';


ALTER FUNCTION hs_office.partner_delete_dependents_tf() OWNER TO admin;

--
-- Name: partner_delete_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_delete_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''DELETE'' then
        raise exception ''invalid usage of trigger'';
    end if;

    DELETE FROM hs_office.partner_legacy_id
        WHERE uuid = OLD.uuid;

    return OLD;
end; ';


ALTER FUNCTION hs_office.partner_delete_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: partner_details; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.partner_details (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    registrationoffice character varying(96),
    registrationnumber character varying(96),
    birthplace character varying(96),
    birthname character varying(96),
    birthday date,
    dateofdeath date
);


ALTER TABLE hs_office.partner_details OWNER TO admin;

--
-- Name: partner_details_admin(hs_office.partner_details, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_admin(entity hs_office.partner_details, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner_details'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_details_admin(entity hs_office.partner_details, assumed boolean) OWNER TO admin;

--
-- Name: partner_details_agent(hs_office.partner_details, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_agent(entity hs_office.partner_details, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner_details'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_details_agent(entity hs_office.partner_details, assumed boolean) OWNER TO admin;

--
-- Name: partner_details_build_rbac_system(hs_office.partner_details); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.partner_details_build_rbac_system(IN new hs_office.partner_details)
    LANGUAGE plpgsql
    AS '

declare

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.partner_details_build_rbac_system(IN new hs_office.partner_details) OWNER TO admin;

--
-- Name: partner_details_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.partner_details_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.partner_details_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: partner_details_grants_insert_to_global_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_grants_insert_to_global_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''hs_office.partner_details''),
            rbac.global_ADMIN());
    
    return NEW;
end; ';


ALTER FUNCTION hs_office.partner_details_grants_insert_to_global_tf() OWNER TO admin;

--
-- Name: partner_details_guest(hs_office.partner_details, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_guest(entity hs_office.partner_details, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner_details'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_details_guest(entity hs_office.partner_details, assumed boolean) OWNER TO admin;

--
-- Name: partner_details_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.partner_details_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.partner_details_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: partner_details_insert_permission_check_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.isGlobalAdmin() then
        return NEW;
    end if;

    raise exception ''[403] insert into hs_office.partner_details values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION hs_office.partner_details_insert_permission_check_tf() OWNER TO admin;

--
-- Name: partner_details_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.partner_details'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.partner_details p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.partner_details uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.partner_details_instead_of_delete_tf() OWNER TO admin;

--
-- Name: partner_details_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.partner_details;
    begin
        insert
            into hs_office.partner_details (uuid, version, registrationoffice, registrationnumber, birthplace, birthname, birthday, dateofdeath)
            values (new.uuid, new.version, new.registrationoffice, new.registrationnumber, new.birthplace, new.birthname, new.birthday, new.dateofdeath)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.partner_details_instead_of_insert_tf() OWNER TO admin;

--
-- Name: partner_details_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.partner_details'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.partner_details
                        set 
        registrationOffice = new.registrationOffice,
        registrationNumber = new.registrationNumber,
        birthPlace = new.birthPlace,
        birthName = new.birthName,
        birthday = new.birthday,
        dateOfDeath = new.dateOfDeath
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.partner_details uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.partner_details_instead_of_update_tf() OWNER TO admin;

--
-- Name: partner_details_owner(hs_office.partner_details, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_owner(entity hs_office.partner_details, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner_details'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_details_owner(entity hs_office.partner_details, assumed boolean) OWNER TO admin;

--
-- Name: partner_details_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.partner_details_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.partner_details;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.partner_details LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.partner_details_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.partner_details_rebuild_rbac_system() OWNER TO admin;

--
-- Name: partner_details_referrer(hs_office.partner_details); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_referrer(entity hs_office.partner_details) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner_details'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.partner_details_referrer(entity hs_office.partner_details) OWNER TO admin;

--
-- Name: partner_details_tenant(hs_office.partner_details, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_tenant(entity hs_office.partner_details, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner_details'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_details_tenant(entity hs_office.partner_details, assumed boolean) OWNER TO admin;

--
-- Name: partner_details_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_details_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.partner_details_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.partner_details_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: partner_grants_insert_to_global_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_grants_insert_to_global_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''hs_office.partner''),
            rbac.global_ADMIN());
    
    return NEW;
end; ';


ALTER FUNCTION hs_office.partner_grants_insert_to_global_tf() OWNER TO admin;

--
-- Name: partner_guest(hs_office.partner, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_guest(entity hs_office.partner, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_guest(entity hs_office.partner, assumed boolean) OWNER TO admin;

--
-- Name: partner_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.partner_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.partner_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: partner_insert_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_insert_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''INSERT'' then
        raise exception ''invalid usage of trigger'';
    end if;

    INSERT INTO hs_office.partner_legacy_id VALUES
        (NEW.uuid, nextVal(''hs_office.partner_legacy_id_seq''));

    return NEW;
end; ';


ALTER FUNCTION hs_office.partner_insert_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: partner_insert_permission_check_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.isGlobalAdmin() then
        return NEW;
    end if;

    raise exception ''[403] insert into hs_office.partner values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION hs_office.partner_insert_permission_check_tf() OWNER TO admin;

--
-- Name: partner_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.partner'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.partner p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.partner uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.partner_instead_of_delete_tf() OWNER TO admin;

--
-- Name: partner_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.partner;
    begin
        insert
            into hs_office.partner (uuid, version, partnernumber, partnerreluuid, detailsuuid)
            values (new.uuid, new.version, new.partnernumber, new.partnerreluuid, new.detailsuuid)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.partner_instead_of_insert_tf() OWNER TO admin;

--
-- Name: partner_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.partner'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.partner
                        set 
        partnerRelUuid = new.partnerRelUuid
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.partner uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.partner_instead_of_update_tf() OWNER TO admin;

--
-- Name: partner_owner(hs_office.partner, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_owner(entity hs_office.partner, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_owner(entity hs_office.partner, assumed boolean) OWNER TO admin;

--
-- Name: partner_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.partner_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.partner;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.partner LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.partner_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.partner_rebuild_rbac_system() OWNER TO admin;

--
-- Name: partner_referrer(hs_office.partner); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_referrer(entity hs_office.partner) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.partner_referrer(entity hs_office.partner) OWNER TO admin;

--
-- Name: partner_tenant(hs_office.partner, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_tenant(entity hs_office.partner, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.partner'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.partner_tenant(entity hs_office.partner, assumed boolean) OWNER TO admin;

--
-- Name: partner_update_rbac_system(hs_office.partner, hs_office.partner); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.partner_update_rbac_system(IN old hs_office.partner, IN new hs_office.partner)
    LANGUAGE plpgsql
    AS '

declare
    oldPartnerRel hs_office.relation;
    newPartnerRel hs_office.relation;
    oldPartnerDetails hs_office.partner_details;
    newPartnerDetails hs_office.partner_details;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM hs_office.relation WHERE uuid = OLD.partnerRelUuid    INTO oldPartnerRel;
    assert oldPartnerRel.uuid is not null, format(''oldPartnerRel must not be null for OLD.partnerRelUuid = %s of hs_office.partner'', OLD.partnerRelUuid);

    SELECT * FROM hs_office.relation WHERE uuid = NEW.partnerRelUuid    INTO newPartnerRel;
    assert newPartnerRel.uuid is not null, format(''newPartnerRel must not be null for NEW.partnerRelUuid = %s of hs_office.partner'', NEW.partnerRelUuid);

    SELECT * FROM hs_office.partner_details WHERE uuid = OLD.detailsUuid    INTO oldPartnerDetails;
    assert oldPartnerDetails.uuid is not null, format(''oldPartnerDetails must not be null for OLD.detailsUuid = %s of hs_office.partner'', OLD.detailsUuid);

    SELECT * FROM hs_office.partner_details WHERE uuid = NEW.detailsUuid    INTO newPartnerDetails;
    assert newPartnerDetails.uuid is not null, format(''newPartnerDetails must not be null for NEW.detailsUuid = %s of hs_office.partner'', NEW.detailsUuid);


    if NEW.partnerRelUuid <> OLD.partnerRelUuid then

        call rbac.revokePermissionFromRole(rbac.getPermissionId(OLD.uuid, ''DELETE''), hs_office.relation_OWNER(oldPartnerRel));
        call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''DELETE''), hs_office.relation_OWNER(newPartnerRel));

        call rbac.revokePermissionFromRole(rbac.getPermissionId(OLD.uuid, ''UPDATE''), hs_office.relation_ADMIN(oldPartnerRel));
        call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''UPDATE''), hs_office.relation_ADMIN(newPartnerRel));

        call rbac.revokePermissionFromRole(rbac.getPermissionId(OLD.uuid, ''SELECT''), hs_office.relation_TENANT(oldPartnerRel));
        call rbac.grantPermissionToRole(rbac.createPermission(NEW.uuid, ''SELECT''), hs_office.relation_TENANT(newPartnerRel));

        call rbac.revokePermissionFromRole(rbac.getPermissionId(oldPartnerDetails.uuid, ''DELETE''), hs_office.relation_OWNER(oldPartnerRel));
        call rbac.grantPermissionToRole(rbac.createPermission(newPartnerDetails.uuid, ''DELETE''), hs_office.relation_OWNER(newPartnerRel));

        call rbac.revokePermissionFromRole(rbac.getPermissionId(oldPartnerDetails.uuid, ''UPDATE''), hs_office.relation_AGENT(oldPartnerRel));
        call rbac.grantPermissionToRole(rbac.createPermission(newPartnerDetails.uuid, ''UPDATE''), hs_office.relation_AGENT(newPartnerRel));

        call rbac.revokePermissionFromRole(rbac.getPermissionId(oldPartnerDetails.uuid, ''SELECT''), hs_office.relation_AGENT(oldPartnerRel));
        call rbac.grantPermissionToRole(rbac.createPermission(newPartnerDetails.uuid, ''SELECT''), hs_office.relation_AGENT(newPartnerRel));

    end if;

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.partner_update_rbac_system(IN old hs_office.partner, IN new hs_office.partner) OWNER TO admin;

--
-- Name: partner_update_rbac_system_after_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_update_rbac_system_after_update_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.partner_update_rbac_system(OLD, NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.partner_update_rbac_system_after_update_tf() OWNER TO admin;

--
-- Name: partner_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.partner_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.partner_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.partner_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: person; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.person (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    persontype hs_office.persontype NOT NULL,
    tradename character varying(96),
    salutation character varying(30),
    title character varying(20),
    givenname character varying(48),
    familyname character varying(48)
);


ALTER TABLE hs_office.person OWNER TO admin;

--
-- Name: person_admin(hs_office.person, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_admin(entity hs_office.person, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.person'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.person_admin(entity hs_office.person, assumed boolean) OWNER TO admin;

--
-- Name: person_agent(hs_office.person, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_agent(entity hs_office.person, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.person'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.person_agent(entity hs_office.person, assumed boolean) OWNER TO admin;

--
-- Name: person_build_rbac_system(hs_office.person); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.person_build_rbac_system(IN new hs_office.person)
    LANGUAGE plpgsql
    AS '

declare

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    perform rbac.defineRoleWithGrants(
        hs_office.person_OWNER(NEW),
            permissions => array[''DELETE''],
            incomingSuperRoles => array[rbac.global_ADMIN()],
            subjectUuids => array[rbac.currentSubjectUuid()]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.person_ADMIN(NEW),
            permissions => array[''UPDATE''],
            incomingSuperRoles => array[hs_office.person_OWNER(NEW)]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.person_REFERRER(NEW),
            permissions => array[''SELECT''],
            incomingSuperRoles => array[hs_office.person_ADMIN(NEW)]
    );

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.person_build_rbac_system(IN new hs_office.person) OWNER TO admin;

--
-- Name: person_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.person_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.person_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: person_create_test_data(hs_office.persontype, character varying, character varying, character varying); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.person_create_test_data(IN newpersontype hs_office.persontype, IN newtradename character varying, IN newfamilyname character varying DEFAULT NULL::character varying, IN newgivenname character varying DEFAULT NULL::character varying)
    LANGUAGE plpgsql
    AS '
declare
    fullName    varchar;
    emailAddr   varchar;
begin
    fullName := concat_ws('', '', newTradeName, newFamilyName, newGivenName);
    emailAddr = ''person-'' || left(base.cleanIdentifier(fullName), 32) || ''@example.com'';
    call base.defineContext(''creating person test-data'');
    perform rbac.create_subject(emailAddr);
    call base.defineContext(''creating person test-data'', null, emailAddr);

    raise notice ''creating test person: % by %'', fullName, emailAddr;
    insert
        into hs_office.person (persontype, tradename, givenname, familyname)
        values (newPersonType, newTradeName, newGivenName, newFamilyName);
end; ';


ALTER PROCEDURE hs_office.person_create_test_data(IN newpersontype hs_office.persontype, IN newtradename character varying, IN newfamilyname character varying, IN newgivenname character varying) OWNER TO admin;

--
-- Name: person_guest(hs_office.person, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_guest(entity hs_office.person, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.person'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.person_guest(entity hs_office.person, assumed boolean) OWNER TO admin;

--
-- Name: person_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.person_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.person_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: person_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.person'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.person p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.person uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.person_instead_of_delete_tf() OWNER TO admin;

--
-- Name: person_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.person;
    begin
        insert
            into hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname)
            values (new.uuid, new.version, new.persontype, new.tradename, new.salutation, new.title, new.givenname, new.familyname)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.person_instead_of_insert_tf() OWNER TO admin;

--
-- Name: person_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.person'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.person
                        set 
        personType = new.personType,
        title = new.title,
        salutation = new.salutation,
        tradeName = new.tradeName,
        givenName = new.givenName,
        familyName = new.familyName
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.person uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.person_instead_of_update_tf() OWNER TO admin;

--
-- Name: person_owner(hs_office.person, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_owner(entity hs_office.person, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.person'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.person_owner(entity hs_office.person, assumed boolean) OWNER TO admin;

--
-- Name: person_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.person_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.person;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.person LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.person_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.person_rebuild_rbac_system() OWNER TO admin;

--
-- Name: person_referrer(hs_office.person); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_referrer(entity hs_office.person) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.person'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.person_referrer(entity hs_office.person) OWNER TO admin;

--
-- Name: person_tenant(hs_office.person, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_tenant(entity hs_office.person, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.person'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.person_tenant(entity hs_office.person, assumed boolean) OWNER TO admin;

--
-- Name: person_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.person_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.person_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.person_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: relation; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.relation (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    anchoruuid uuid NOT NULL,
    holderuuid uuid NOT NULL,
    contactuuid uuid,
    type hs_office.relationtype NOT NULL,
    mark character varying(24)
);


ALTER TABLE hs_office.relation OWNER TO admin;

--
-- Name: relation_admin(hs_office.relation, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_admin(entity hs_office.relation, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.relation'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.relation_admin(entity hs_office.relation, assumed boolean) OWNER TO admin;

--
-- Name: relation_agent(hs_office.relation, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_agent(entity hs_office.relation, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.relation'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.relation_agent(entity hs_office.relation, assumed boolean) OWNER TO admin;

--
-- Name: relation_build_rbac_system(hs_office.relation); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.relation_build_rbac_system(IN new hs_office.relation)
    LANGUAGE plpgsql
    AS '

declare
    newHolderPerson hs_office.person;
    newAnchorPerson hs_office.person;
    newContact hs_office.contact;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM hs_office.person WHERE uuid = NEW.holderUuid    INTO newHolderPerson;
    assert newHolderPerson.uuid is not null, format(''newHolderPerson must not be null for NEW.holderUuid = %s of hs_office.relation'', NEW.holderUuid);

    SELECT * FROM hs_office.person WHERE uuid = NEW.anchorUuid    INTO newAnchorPerson;
    assert newAnchorPerson.uuid is not null, format(''newAnchorPerson must not be null for NEW.anchorUuid = %s of hs_office.relation'', NEW.anchorUuid);

    SELECT * FROM hs_office.contact WHERE uuid = NEW.contactUuid    INTO newContact;
    assert newContact.uuid is not null, format(''newContact must not be null for NEW.contactUuid = %s of hs_office.relation'', NEW.contactUuid);


    perform rbac.defineRoleWithGrants(
        hs_office.relation_OWNER(NEW),
            permissions => array[''DELETE''],
            incomingSuperRoles => array[rbac.global_ADMIN()],
            subjectUuids => array[rbac.currentSubjectUuid()]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.relation_ADMIN(NEW),
            permissions => array[''UPDATE''],
            incomingSuperRoles => array[hs_office.relation_OWNER(NEW)]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.relation_AGENT(NEW),
            incomingSuperRoles => array[hs_office.relation_ADMIN(NEW)]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.relation_TENANT(NEW),
            permissions => array[''SELECT''],
            incomingSuperRoles => array[
            	hs_office.contact_ADMIN(newContact),
            	hs_office.relation_AGENT(NEW)],
            outgoingSubRoles => array[
            	hs_office.contact_REFERRER(newContact),
            	hs_office.person_REFERRER(newAnchorPerson),
            	hs_office.person_REFERRER(newHolderPerson)]
    );

    IF NEW.type = ''REPRESENTATIVE'' THEN
        call rbac.grantRoleToRole(hs_office.person_OWNER(newAnchorPerson), hs_office.relation_ADMIN(NEW));
        call rbac.grantRoleToRole(hs_office.relation_AGENT(NEW), hs_office.person_ADMIN(newAnchorPerson));
        call rbac.grantRoleToRole(hs_office.relation_OWNER(NEW), hs_office.person_ADMIN(newHolderPerson));
    ELSE
        call rbac.grantRoleToRole(hs_office.relation_AGENT(NEW), hs_office.person_ADMIN(newHolderPerson));
        call rbac.grantRoleToRole(hs_office.relation_OWNER(NEW), hs_office.person_ADMIN(newAnchorPerson));
    END IF;

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.relation_build_rbac_system(IN new hs_office.relation) OWNER TO admin;

--
-- Name: relation_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.relation_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.relation_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: relation_create_test_data(integer, integer); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.relation_create_test_data(IN startcount integer, IN endcount integer)
    LANGUAGE plpgsql
    AS '
declare
    person hs_office.person;
    contact hs_office.contact;
begin
    for t in startCount..endCount
        loop
            select p.* from hs_office.person p where tradeName = base.intToVarChar(t, 4) into person;
            select c.* from hs_office.contact c where c.caption = base.intToVarChar(t, 4) || ''#'' || t into contact;

            call hs_office.relation_create_test_data(person.uuid, contact.uuid, ''REPRESENTATIVE'');
            commit;
        end loop;
end; ';


ALTER PROCEDURE hs_office.relation_create_test_data(IN startcount integer, IN endcount integer) OWNER TO admin;

--
-- Name: relation_create_test_data(character varying, hs_office.relationtype, character varying, character varying, character varying); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.relation_create_test_data(IN holderpersonname character varying, IN relationtype hs_office.relationtype, IN anchorpersonname character varying, IN contactcaption character varying, IN mark character varying DEFAULT NULL::character varying)
    LANGUAGE plpgsql
    AS '
declare
    idName          varchar;
    anchorPerson    hs_office.person;
    holderPerson    hs_office.person;
    contact         hs_office.contact;

begin
    idName := base.cleanIdentifier( anchorPersonName || ''-'' || holderPersonName);

    select p.*
            into anchorPerson
            from hs_office.person p
            where p.tradeName = anchorPersonName or p.familyName = anchorPersonName;
    if anchorPerson is null then
        raise exception ''anchorPerson "%" not found'', anchorPersonName;
    end if;

    select p.*
            into holderPerson
            from hs_office.person p
            where p.tradeName = holderPersonName or p.familyName = holderPersonName;
    if holderPerson is null then
        raise exception ''holderPerson "%" not found'', holderPersonName;
    end if;

    select c.* into contact from hs_office.contact c where c.caption = contactCaption;
    if contact is null then
        raise exception ''contact "%" not found'', contactCaption;
    end if;

    raise notice ''creating test relation: %'', idName;
    raise notice ''- using anchor person (%): %'', anchorPerson.uuid, anchorPerson;
    raise notice ''- using holder person (%): %'', holderPerson.uuid, holderPerson;
    raise notice ''- using contact (%): %'', contact.uuid, contact;
    insert
        into hs_office.relation (uuid, anchoruuid, holderuuid, type, mark, contactUuid)
        values (uuid_generate_v4(), anchorPerson.uuid, holderPerson.uuid, relationType, mark, contact.uuid);
end; ';


ALTER PROCEDURE hs_office.relation_create_test_data(IN holderpersonname character varying, IN relationtype hs_office.relationtype, IN anchorpersonname character varying, IN contactcaption character varying, IN mark character varying) OWNER TO admin;

--
-- Name: relation_grants_insert_to_person_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_grants_insert_to_person_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''hs_office.relation''),
            hs_office.person_ADMIN(NEW));
    
    return NEW;
end; ';


ALTER FUNCTION hs_office.relation_grants_insert_to_person_tf() OWNER TO admin;

--
-- Name: relation_guest(hs_office.relation, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_guest(entity hs_office.relation, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.relation'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.relation_guest(entity hs_office.relation, assumed boolean) OWNER TO admin;

--
-- Name: relation_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.relation_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.relation_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: relation_insert_permission_check_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.hasInsertPermission(NEW.anchorUuid, ''hs_office.relation'') then
        return NEW;
    end if;

    raise exception ''[403] insert into hs_office.relation values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION hs_office.relation_insert_permission_check_tf() OWNER TO admin;

--
-- Name: relation_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.relation'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.relation p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.relation uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.relation_instead_of_delete_tf() OWNER TO admin;

--
-- Name: relation_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.relation;
    begin
        insert
            into hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark)
            values (new.uuid, new.version, new.anchoruuid, new.holderuuid, new.contactuuid, new.type, new.mark)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.relation_instead_of_insert_tf() OWNER TO admin;

--
-- Name: relation_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.relation'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.relation
                        set 
        contactUuid = new.contactUuid
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.relation uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.relation_instead_of_update_tf() OWNER TO admin;

--
-- Name: relation_owner(hs_office.relation, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_owner(entity hs_office.relation, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.relation'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.relation_owner(entity hs_office.relation, assumed boolean) OWNER TO admin;

--
-- Name: relation_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.relation_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.relation;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.relation LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.relation_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.relation_rebuild_rbac_system() OWNER TO admin;

--
-- Name: relation_referrer(hs_office.relation); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_referrer(entity hs_office.relation) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.relation'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.relation_referrer(entity hs_office.relation) OWNER TO admin;

--
-- Name: relation_tenant(hs_office.relation, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_tenant(entity hs_office.relation, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.relation'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.relation_tenant(entity hs_office.relation, assumed boolean) OWNER TO admin;

--
-- Name: relation_update_rbac_system(hs_office.relation, hs_office.relation); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.relation_update_rbac_system(IN old hs_office.relation, IN new hs_office.relation)
    LANGUAGE plpgsql
    AS '
begin

    if NEW.contactUuid is distinct from OLD.contactUuid then
        delete from rbac.grant g where g.grantedbytriggerof = OLD.uuid;
        call hs_office.relation_build_rbac_system(NEW);
    end if;
end; ';


ALTER PROCEDURE hs_office.relation_update_rbac_system(IN old hs_office.relation, IN new hs_office.relation) OWNER TO admin;

--
-- Name: relation_update_rbac_system_after_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_update_rbac_system_after_update_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.relation_update_rbac_system(OLD, NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.relation_update_rbac_system_after_update_tf() OWNER TO admin;

--
-- Name: relation_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.relation_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.relation_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.relation_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: sepamandate; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.sepamandate (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    debitoruuid uuid NOT NULL,
    bankaccountuuid uuid NOT NULL,
    reference character varying(96) NOT NULL,
    agreement date NOT NULL,
    validity daterange NOT NULL
);


ALTER TABLE hs_office.sepamandate OWNER TO admin;

--
-- Name: sepamandate_admin(hs_office.sepamandate, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_admin(entity hs_office.sepamandate, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.sepamandate'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION hs_office.sepamandate_admin(entity hs_office.sepamandate, assumed boolean) OWNER TO admin;

--
-- Name: sepamandate_agent(hs_office.sepamandate, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_agent(entity hs_office.sepamandate, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.sepamandate'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION hs_office.sepamandate_agent(entity hs_office.sepamandate, assumed boolean) OWNER TO admin;

--
-- Name: sepamandate_build_rbac_system(hs_office.sepamandate); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.sepamandate_build_rbac_system(IN new hs_office.sepamandate)
    LANGUAGE plpgsql
    AS '

declare
    newBankAccount hs_office.bankaccount;
    newDebitorRel hs_office.relation;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM hs_office.bankaccount WHERE uuid = NEW.bankAccountUuid    INTO newBankAccount;
    assert newBankAccount.uuid is not null, format(''newBankAccount must not be null for NEW.bankAccountUuid = %s of hs_office.sepamandate'', NEW.bankAccountUuid);

    SELECT debitorRel.*
        FROM hs_office.relation debitorRel
        JOIN hs_office.debitor debitor ON debitor.debitorRelUuid = debitorRel.uuid
        WHERE debitor.uuid = NEW.debitorUuid
        INTO newDebitorRel;
    assert newDebitorRel.uuid is not null, format(''newDebitorRel must not be null for NEW.debitorUuid = %s of hs_office.sepamandate'', NEW.debitorUuid);


    perform rbac.defineRoleWithGrants(
        hs_office.sepamandate_OWNER(NEW),
            permissions => array[''DELETE''],
            incomingSuperRoles => array[rbac.global_ADMIN()],
            subjectUuids => array[rbac.currentSubjectUuid()]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.sepamandate_ADMIN(NEW),
            permissions => array[''UPDATE''],
            incomingSuperRoles => array[hs_office.sepamandate_OWNER(NEW)]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.sepamandate_AGENT(NEW),
            incomingSuperRoles => array[hs_office.sepamandate_ADMIN(NEW)],
            outgoingSubRoles => array[
            	hs_office.bankaccount_REFERRER(newBankAccount),
            	hs_office.relation_AGENT(newDebitorRel)]
    );

    perform rbac.defineRoleWithGrants(
        hs_office.sepamandate_REFERRER(NEW),
            permissions => array[''SELECT''],
            incomingSuperRoles => array[
            	hs_office.bankaccount_ADMIN(newBankAccount),
            	hs_office.relation_AGENT(newDebitorRel),
            	hs_office.sepamandate_AGENT(NEW)],
            outgoingSubRoles => array[hs_office.relation_TENANT(newDebitorRel)]
    );

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE hs_office.sepamandate_build_rbac_system(IN new hs_office.sepamandate) OWNER TO admin;

--
-- Name: sepamandate_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call hs_office.sepamandate_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION hs_office.sepamandate_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: sepamandate_create_test_data(numeric, character, character varying, character varying); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.sepamandate_create_test_data(IN forpartnernumber numeric, IN fordebitorsuffix character, IN foriban character varying, IN withreference character varying)
    LANGUAGE plpgsql
    AS '
declare
    relatedDebitor      hs_office.debitor;
    relatedBankAccount  hs_office.bankAccount;
begin
    select debitor.* into relatedDebitor
        from hs_office.debitor debitor
        join hs_office.relation debitorRel on debitorRel.uuid = debitor.debitorRelUuid
        join hs_office.relation partnerRel on partnerRel.holderUuid = debitorRel.anchorUuid
        join hs_office.partner partner on partner.partnerRelUuid = partnerRel.uuid
        where partner.partnerNumber = forPartnerNumber and debitor.debitorNumberSuffix = forDebitorSuffix;
    select b.* into relatedBankAccount
        from hs_office.bankAccount b where b.iban = forIban;

    raise notice ''creating test SEPA-mandate: %'', forPartnerNumber::text || forDebitorSuffix::text;
    raise notice ''- using debitor (%): %'', relatedDebitor.uuid, relatedDebitor;
    raise notice ''- using bankAccount (%): %'', relatedBankAccount.uuid, relatedBankAccount;
    insert
        into hs_office.sepamandate (uuid, debitoruuid, bankAccountuuid, reference, agreement, validity)
        values (uuid_generate_v4(), relatedDebitor.uuid, relatedBankAccount.uuid, withReference, ''20220930'', daterange(''20221001'' , ''20261231'', ''[]''));
end; ';


ALTER PROCEDURE hs_office.sepamandate_create_test_data(IN forpartnernumber numeric, IN fordebitorsuffix character, IN foriban character varying, IN withreference character varying) OWNER TO admin;

--
-- Name: sepamandate_delete_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_delete_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''DELETE'' then
        raise exception ''invalid usage of trigger'';
    end if;

    DELETE FROM hs_office.sepamandate_legacy_id
           WHERE uuid = OLD.uuid;

    return OLD;
end; ';


ALTER FUNCTION hs_office.sepamandate_delete_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: sepamandate_grants_insert_to_relation_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_grants_insert_to_relation_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if NEW.type = ''DEBITOR'' then
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''hs_office.sepamandate''),
            hs_office.relation_ADMIN(NEW));
    end if;
    return NEW;
end; ';


ALTER FUNCTION hs_office.sepamandate_grants_insert_to_relation_tf() OWNER TO admin;

--
-- Name: sepamandate_guest(hs_office.sepamandate, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_guest(entity hs_office.sepamandate, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.sepamandate'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION hs_office.sepamandate_guest(entity hs_office.sepamandate, assumed boolean) OWNER TO admin;

--
-- Name: sepamandate_id_name_by_uuid(uuid); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from hs_office.sepamandate_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION hs_office.sepamandate_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: sepamandate_insert_legacy_id_mapping_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_insert_legacy_id_mapping_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP <> ''INSERT'' then
        raise exception ''invalid usage of trigger'';
    end if;

    INSERT INTO hs_office.sepamandate_legacy_id VALUES
        (NEW.uuid, nextVal(''hs_office.sepamandate_legacy_id_seq''));

    return NEW;
end; ';


ALTER FUNCTION hs_office.sepamandate_insert_legacy_id_mapping_tf() OWNER TO admin;

--
-- Name: sepamandate_insert_permission_check_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    superObjectUuid := (SELECT debitorRel.uuid
        FROM hs_office.relation debitorRel
        JOIN hs_office.debitor debitor ON debitor.debitorRelUuid = debitorRel.uuid
        WHERE debitor.uuid = NEW.debitorUuid
    );
    assert superObjectUuid is not null, ''object uuid fetched depending on hs_office.sepamandate.debitorUuid must not be null, also check fetchSql in RBAC DSL'';
    if rbac.hasInsertPermission(superObjectUuid, ''hs_office.sepamandate'') then
        return NEW;
    end if;

    raise exception ''[403] insert into hs_office.sepamandate values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION hs_office.sepamandate_insert_permission_check_tf() OWNER TO admin;

--
-- Name: sepamandate_instead_of_delete_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''hs_office.sepamandate'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from hs_office.sepamandate p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete hs_office.sepamandate uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION hs_office.sepamandate_instead_of_delete_tf() OWNER TO admin;

--
-- Name: sepamandate_instead_of_insert_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow hs_office.sepamandate;
    begin
        insert
            into hs_office.sepamandate (uuid, version, debitoruuid, bankaccountuuid, reference, agreement, validity)
            values (new.uuid, new.version, new.debitoruuid, new.bankaccountuuid, new.reference, new.agreement, new.validity)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION hs_office.sepamandate_instead_of_insert_tf() OWNER TO admin;

--
-- Name: sepamandate_instead_of_update_tf(); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''hs_office.sepamandate'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update hs_office.sepamandate
                        set 
        reference = new.reference,
        agreement = new.agreement,
        validity = new.validity
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update hs_office.sepamandate uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION hs_office.sepamandate_instead_of_update_tf() OWNER TO admin;

--
-- Name: sepamandate_owner(hs_office.sepamandate, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_owner(entity hs_office.sepamandate, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.sepamandate'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION hs_office.sepamandate_owner(entity hs_office.sepamandate, assumed boolean) OWNER TO admin;

--
-- Name: sepamandate_rebuild_rbac_system(); Type: PROCEDURE; Schema: hs_office; Owner: test
--

CREATE PROCEDURE hs_office.sepamandate_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row hs_office.sepamandate;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM hs_office.sepamandate LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL hs_office.sepamandate_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE hs_office.sepamandate_rebuild_rbac_system() OWNER TO admin;

--
-- Name: sepamandate_referrer(hs_office.sepamandate); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_referrer(entity hs_office.sepamandate) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.sepamandate'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION hs_office.sepamandate_referrer(entity hs_office.sepamandate) OWNER TO admin;

--
-- Name: sepamandate_tenant(hs_office.sepamandate, boolean); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_tenant(entity hs_office.sepamandate, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''hs_office.sepamandate'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION hs_office.sepamandate_tenant(entity hs_office.sepamandate, assumed boolean) OWNER TO admin;

--
-- Name: sepamandate_uuid_by_id_name(character varying); Type: FUNCTION; Schema: hs_office; Owner: test
--

CREATE FUNCTION hs_office.sepamandate_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from hs_office.sepamandate_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION hs_office.sepamandate_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: validate_transaction_type(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION public.validate_transaction_type() RETURNS trigger
    LANGUAGE plpgsql
    AS '
BEGIN
    
    IF NEW.transactionType = ''REVERSAL'' AND NEW.revertedAssetTxUuid IS NULL THEN
        RAISE EXCEPTION ''REVERSAL transactions must have revertedAssetTxUuid'';
    END IF;

    
    IF NEW.transactionType != ''REVERSAL'' AND NEW.revertedAssetTxUuid IS NOT NULL THEN
        RAISE EXCEPTION ''Non-REVERSAL transactions must not have revertedAssetTxUuid'';
    END IF;

    
    IF NEW.transactionType = ''TRANSFER'' AND NEW.assetAdoptionTxUuid IS NULL THEN
        RAISE EXCEPTION ''TRANSFER transactions must have assetAdoptionTxUuid'';
    END IF;

    
    IF NEW.transactionType != ''TRANSFER'' AND NEW.assetAdoptionTxUuid IS NOT NULL THEN
        RAISE EXCEPTION ''Non-TRANSFER transactions must not have assetAdoptionTxUuid'';
    END IF;

    RETURN NEW;
END;
';


ALTER FUNCTION public.validate_transaction_type() OWNER TO admin;

--
-- Name: assertreferencetype(character varying, uuid, rbac.referencetype); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.assertreferencetype(argument character varying, referenceid uuid, expectedtype rbac.referencetype) RETURNS rbac.referencetype
    LANGUAGE plpgsql
    AS '
declare
    actualType rbac.ReferenceType;
begin
    if referenceId is null then
        raise exception ''% must be a % and not null'', argument, expectedType;
    end if;

    actualType = (select type from  rbac.reference where uuid = referenceId);
    if (actualType <> expectedType) then
        raise exception ''% must reference a %, but got a %'', argument, expectedType, actualType;
    end if;
    return expectedType;
end; ';


ALTER FUNCTION rbac.assertreferencetype(argument character varying, referenceid uuid, expectedtype rbac.referencetype) OWNER TO admin;

--
-- Name: assumed(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.assumed() RETURNS boolean
    LANGUAGE sql STABLE
    AS '
        select true;
';


ALTER FUNCTION rbac.assumed() OWNER TO admin;

--
-- Name: assumedroleuuid(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.assumedroleuuid() RETURNS uuid
    LANGUAGE plpgsql STABLE
    AS '
declare
    currentSubjectOrAssumedRolesUuids uuid[];
begin
    
    if cardinality(base.assumedRoles()) <> 1 then
        raise exception ''[400] Granting roles to user is only possible if exactly one role is assumed, given: %'', base.assumedRoles();
    end if;

    currentSubjectOrAssumedRolesUuids := rbac.currentSubjectOrAssumedRolesUuids();
    return currentSubjectOrAssumedRolesUuids[1];
end; ';


ALTER FUNCTION rbac.assumedroleuuid() OWNER TO admin;

--
-- Name: checkrevokerolefromsubjectpreconditions(uuid, uuid, uuid); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.checkrevokerolefromsubjectpreconditions(IN grantedbyroleuuid uuid, IN grantedroleuuid uuid, IN subjectuuid uuid)
    LANGUAGE plpgsql
    AS '
begin
    perform rbac.assertReferenceType(''grantedByRoleUuid'', grantedByRoleUuid, ''rbac.role'');
    perform rbac.assertReferenceType(''grantedRoleUuid (descendant)'', grantedRoleUuid, ''rbac.role'');
    perform rbac.assertReferenceType(''subjectUuid (ascendant)'', subjectUuid, ''rbac.subject'');

    if NOT rbac.isGranted(rbac.currentSubjectOrAssumedRolesUuids(), grantedByRoleUuid) then
        raise exception ''[403] Revoking role created by % is forbidden for %.'', grantedByRoleUuid, base.currentSubjects();
    end if;

    if NOT rbac.isGranted(grantedByRoleUuid, grantedRoleUuid) then
        raise exception ''[403] Revoking role % is forbidden for %.'', grantedRoleUuid, base.currentSubjects();
    end if;

    
    if NOT rbac.isGranted(rbac.currentSubjectOrAssumedRolesUuids(), grantedByRoleUuid) then
        raise exception ''[403] Revoking role granted by % is forbidden for %.'', grantedByRoleUuid, base.currentSubjects();
    end if;

    if NOT rbac.isGranted(subjectUuid, grantedRoleUuid) then
        raise exception ''[404] No such grant found granted by % for subject % to role %.'', grantedByRoleUuid, subjectUuid, grantedRoleUuid;
    end if;
end; ';


ALTER PROCEDURE rbac.checkrevokerolefromsubjectpreconditions(IN grantedbyroleuuid uuid, IN grantedroleuuid uuid, IN subjectuuid uuid) OWNER TO admin;

--
-- Name: create_subject(character varying); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.create_subject(subjectname character varying) RETURNS uuid
    LANGUAGE plpgsql STRICT
    AS '
declare
    objectId uuid;
begin
    insert
        into  rbac.reference (type)
        values (''rbac.subject'')
        returning uuid into objectId;
    insert
        into rbac.subject (uuid, name)
        values (objectid, subjectName);
    return objectId;
end;
';


ALTER FUNCTION rbac.create_subject(subjectname character varying) OWNER TO admin;

--
-- Name: create_subject(uuid, character varying); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.create_subject(refuuid uuid, subjectname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
begin
    insert
        into  rbac.reference as r (uuid, type)
        values (coalesce(refUuid, uuid_generate_v4()), ''rbac.subject'')
        returning r.uuid into refUuid;
    insert
        into rbac.subject (uuid, name)
        values (refUuid, subjectName);
    return refUuid;
end;
';


ALTER FUNCTION rbac.create_subject(refuuid uuid, subjectname character varying) OWNER TO admin;

--
-- Name: createpermission(uuid, rbac.rbacop, text); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.createpermission(forobjectuuid uuid, forop rbac.rbacop, foroptablename text DEFAULT NULL::text) RETURNS uuid
    LANGUAGE plpgsql
    AS '
declare
    permissionUuid uuid;
begin
    if (forObjectUuid is null) then
        raise exception ''forObjectUuid must not be null'';
    end if;
    if (forOp = ''INSERT'' and forOpTableName is null) then
        raise exception ''INSERT permissions needs forOpTableName'';
    end if;
    if (forOp <> ''INSERT'' and forOpTableName is not null) then
        raise exception ''forOpTableName must only be specified for ops: [INSERT]''; 
    end if;

    permissionUuid := (
        select uuid from rbac.permission
         where objectUuid = forObjectUuid
           and op = forOp and opTableName is not distinct from forOpTableName);
    if (permissionUuid is null) then
        insert into  rbac.reference ("type")
            values (''rbac.permission'')
            returning uuid into permissionUuid;
        begin
            insert into rbac.permission (uuid, objectUuid, op, opTableName)
                values (permissionUuid, forObjectUuid, forOp, forOpTableName);
        exception
            when others then
                raise exception ''insert into rbac.permission (uuid, objectUuid, op, opTableName)
                values (%, %, %, %);'', permissionUuid, forObjectUuid, forOp, forOpTableName;
        end;
    end if;
    return permissionUuid;
end; ';


ALTER FUNCTION rbac.createpermission(forobjectuuid uuid, forop rbac.rbacop, foroptablename text) OWNER TO admin;

--
-- Name: createrole(rbac.roledescriptor); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.createrole(roledescriptor rbac.roledescriptor) RETURNS uuid
    LANGUAGE plpgsql STRICT
    AS '
declare
    referenceId uuid;
begin
    insert
        into  rbac.reference (type)
        values (''rbac.role'')
        returning uuid into referenceId;
    insert
        into rbac.role (uuid, objectUuid, roleType)
        values (referenceId, roleDescriptor.objectUuid, roleDescriptor.roleType);
    return referenceId;
end;
';


ALTER FUNCTION rbac.createrole(roledescriptor rbac.roledescriptor) OWNER TO admin;

--
-- Name: currentsubjectorassumedrolesuuids(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.currentsubjectorassumedrolesuuids() RETURNS uuid[]
    LANGUAGE plpgsql STABLE
    AS '
declare
    currentSubjectOrAssumedRolesUuids text;
    currentSubjectName text;
begin
    begin
        currentSubjectOrAssumedRolesUuids := current_setting(''hsadminng.currentSubjectOrAssumedRolesUuids'');
    exception
        when others then
            currentSubjectOrAssumedRolesUuids := null;
    end;
    if (currentSubjectOrAssumedRolesUuids is null or length(currentSubjectOrAssumedRolesUuids) = 0 ) then
        currentSubjectName := base.currentSubject();
        if (length(currentSubjectName) > 0) then
            raise exception ''[401] currentSubjectOrAssumedRolesUuids (%) cannot be determined, unknown subject name "%"'', currentSubjectOrAssumedRolesUuids, currentSubjectName;
        else
            raise exception ''[401] currentSubjectOrAssumedRolesUuids cannot be determined, please call `base.defineContext(...)` with a valid subject;"'';
        end if;
    end if;
    return string_to_array(currentSubjectOrAssumedRolesUuids, '';'');
end; ';


ALTER FUNCTION rbac.currentsubjectorassumedrolesuuids() OWNER TO admin;

--
-- Name: currentsubjectuuid(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.currentsubjectuuid() RETURNS uuid
    LANGUAGE plpgsql STABLE
    AS '
declare
    currentSubjectUuid text;
    currentSubjectName text;
begin
    begin
        currentSubjectUuid := current_setting(''hsadminng.currentSubjectUuid'');
    exception
        when others then
            currentSubjectUuid := null;
    end;
    if (currentSubjectUuid is null or currentSubjectUuid = '''') then
        currentSubjectName := base.currentSubject();
        if (length(currentSubjectName) > 0) then
            raise exception ''[401] currentSubjectUuid cannot be determined, unknown subject name "%"'', currentSubjectName;
        else
            raise exception ''[401] currentSubjectUuid cannot be determined, please call `base.defineContext(...)` first;"'';
        end if;
    end if;
    return currentSubjectUuid::uuid;
end; ';


ALTER FUNCTION rbac.currentsubjectuuid() OWNER TO admin;

--
-- Name: currenttriggerobjectuuid(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.currenttriggerobjectuuid() RETURNS uuid
    LANGUAGE plpgsql STABLE
    AS '
declare
    currentObjectUuid uuid;
begin
    begin
        currentObjectUuid = current_setting(''hsadminng.currentObjectUuid'')::uuid;
        return currentObjectUuid;
    exception
        when others then
            return null::uuid;
    end;
end; ';


ALTER FUNCTION rbac.currenttriggerobjectuuid() OWNER TO admin;

--
-- Name: definerolewithgrants(rbac.roledescriptor, rbac.rbacop[], rbac.roledescriptor[], rbac.roledescriptor[], uuid[], rbac.roledescriptor); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.definerolewithgrants(roledescriptor rbac.roledescriptor, permissions rbac.rbacop[] DEFAULT ARRAY[]::rbac.rbacop[], incomingsuperroles rbac.roledescriptor[] DEFAULT ARRAY[]::rbac.roledescriptor[], outgoingsubroles rbac.roledescriptor[] DEFAULT ARRAY[]::rbac.roledescriptor[], subjectuuids uuid[] DEFAULT ARRAY[]::uuid[], grantedbyrole rbac.roledescriptor DEFAULT NULL::rbac.roledescriptor) RETURNS uuid
    LANGUAGE plpgsql
    AS '
declare
    roleUuid                uuid;
    permission              rbac.RbacOp;
    permissionUuid          uuid;
    subRoleDesc             rbac.RoleDescriptor;
    superRoleDesc           rbac.RoleDescriptor;
    subRoleUuid             uuid;
    superRoleUuid           uuid;
    subjectUuid             uuid;
    userGrantsByRoleUuid    uuid;
begin
    roleUuid := coalesce(rbac.findRoleId(roleDescriptor), rbac.createRole(roleDescriptor));

    foreach permission in array permissions
        loop
            permissionUuid := rbac.createPermission(roleDescriptor.objectuuid, permission);
            call rbac.grantPermissionToRole(permissionUuid, roleUuid);
        end loop;

    foreach superRoleDesc in array array_remove(incomingSuperRoles, null)
        loop
            superRoleUuid := rbac.getRoleId(superRoleDesc);
            call rbac.grantRoleToRole(roleUuid, superRoleUuid, superRoleDesc.assumed);
        end loop;

    foreach subRoleDesc in array array_remove(outgoingSubRoles, null)
        loop
            subRoleUuid := rbac.getRoleId(subRoleDesc);
            call rbac.grantRoleToRole(subRoleUuid, roleUuid, subRoleDesc.assumed);
        end loop;

    if cardinality(subjectUuids) > 0 then
        
        if grantedByRole is null then
            userGrantsByRoleUuid := roleUuid; 
        else
            userGrantsByRoleUuid := rbac.getRoleId(grantedByRole);
        end if;
        foreach subjectUuid in array subjectUuids
            loop
                call rbac.grantRoleToSubjectUnchecked(userGrantsByRoleUuid, roleUuid, subjectUuid);
            end loop;
    end if;

    return roleUuid;
end; ';


ALTER FUNCTION rbac.definerolewithgrants(roledescriptor rbac.roledescriptor, permissions rbac.rbacop[], incomingsuperroles rbac.roledescriptor[], outgoingsubroles rbac.roledescriptor[], subjectuuids uuid[], grantedbyrole rbac.roledescriptor) OWNER TO admin;

--
-- Name: delete_grant_tf(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.delete_grant_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
begin
    call rbac.revokeRoleFromSubject(old.grantedByRoleUuid, old.grantedRoleUuid, old.subjectUuid);
    return old;
end; ';


ALTER FUNCTION rbac.delete_grant_tf() OWNER TO admin;

--
-- Name: delete_grants_of_role_tf(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.delete_grants_of_role_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP = ''DELETE'' then
        delete from rbac.grant g where old.uuid in (g.grantedbyroleuuid, g.ascendantuuid, g.descendantuuid);
    else
        raise exception ''invalid usage of TRIGGER BEFORE DELETE'';
    end if;
    return old;
end; ';


ALTER FUNCTION rbac.delete_grants_of_role_tf() OWNER TO admin;

--
-- Name: delete_related_rbac_rules_tf(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.delete_related_rbac_rules_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP = ''DELETE'' then
        delete from rbac.object where rbac.object.uuid = old.uuid;
    else
        raise exception ''invalid usage of TRIGGER BEFORE DELETE'';
    end if;
    return old;
end; ';


ALTER FUNCTION rbac.delete_related_rbac_rules_tf() OWNER TO admin;

--
-- Name: delete_roles_of_object_tf(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.delete_roles_of_object_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    if TG_OP = ''DELETE'' then
        delete from rbac.permission p where p.objectuuid = old.uuid;
        delete from rbac.role r where r.objectUuid = old.uuid;
    else
        raise exception ''invalid usage of TRIGGER BEFORE DELETE'';
    end if;
    return old;
end; ';


ALTER FUNCTION rbac.delete_roles_of_object_tf() OWNER TO admin;

--
-- Name: delete_subject_tf(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.delete_subject_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
begin
    if rbac.currentSubjectUuid() = old.uuid or rbac.hasGlobalRoleGranted(rbac.currentSubjectUuid()) then
        delete from rbac.subject where uuid = old.uuid;
        return old;
    end if;
    raise exception ''[403] User % not allowed to delete user uuid %'', base.currentSubject(), old.uuid;
end; ';


ALTER FUNCTION rbac.delete_subject_tf() OWNER TO admin;

--
-- Name: deleterole(uuid); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.deleterole(IN roleuuid uuid)
    LANGUAGE plpgsql
    AS '
begin
    
    delete from rbac.role where uuid = roleUUid;
end;
';


ALTER PROCEDURE rbac.deleterole(IN roleuuid uuid) OWNER TO admin;

--
-- Name: determinecurrentsubjectorassumedrolesuuids(uuid, text); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.determinecurrentsubjectorassumedrolesuuids(currentsubjectorassumedrolesuuids uuid, assumedroles text) RETURNS uuid[]
    LANGUAGE plpgsql STABLE
    AS '
declare
    roleName            text;
    roleNameParts       text;
    objectTableToAssume varchar(63);
    objectNameToAssume  varchar(1024); 
    objectUuidToAssume  uuid;
    roleTypeToAssume    rbac.RoleType;
    roleIdsToAssume     uuid[];
    roleUuidToAssume    uuid;
begin
    if currentSubjectOrAssumedRolesUuids is null then
        if length(coalesce(assumedRoles, '''')) > 0 then
            raise exception ''[403] undefined has no permission to assume role %'', assumedRoles;
        else
            return array[]::uuid[];
        end if;
    end if;
    if  length(coalesce(assumedRoles, '''')) = 0 then
        return array [currentSubjectOrAssumedRolesUuids];
    end if;

    foreach roleName in array string_to_array(assumedRoles, '';'')
        loop
            roleNameParts = overlay(roleName placing ''#'' from length(roleName) + 1 - strpos(reverse(roleName), '':''));
            objectTableToAssume = split_part(roleNameParts, ''#'', 1);
            objectNameToAssume = split_part(roleNameParts, ''#'', 2);
            roleTypeToAssume = split_part(roleNameParts, ''#'', 3);

            begin
                objectUuidToAssume = objectNameToAssume::uuid;
            exception when invalid_text_representation then
                objectUuidToAssume = rbac.findObjectUuidByIdName(objectTableToAssume, objectNameToAssume);
            end;

            if objectUuidToAssume is null then
                raise exception ''[401] object % cannot be found in table % (from roleNameParts=%)'', objectNameToAssume, objectTableToAssume, roleNameParts;
            end if;

            select uuid
                from rbac.role r
                where r.objectUuid = objectUuidToAssume
                  and r.roleType = roleTypeToAssume
                into roleUuidToAssume;
            if roleUuidToAssume is null then
                raise exception ''[403] role % does not exist or is not accessible for subject %'', roleName, base.currentSubject();
            end if;
            if not rbac.isGranted(currentSubjectOrAssumedRolesUuids, roleUuidToAssume) then
                raise exception ''[403] subject % has no permission to assume role %'', base.currentSubject(), roleName;
            end if;
            roleIdsToAssume := roleIdsToAssume || roleUuidToAssume;
        end loop;

    return roleIdsToAssume;
end; ';


ALTER FUNCTION rbac.determinecurrentsubjectorassumedrolesuuids(currentsubjectorassumedrolesuuids uuid, assumedroles text) OWNER TO admin;

--
-- Name: determinecurrentsubjectuuid(character varying); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.determinecurrentsubjectuuid(currentsubject character varying) RETURNS uuid
    LANGUAGE plpgsql STABLE
    AS '
declare
    currentSubjectUuid uuid;
begin
    if currentSubject = '''' then
        return null;
    end if;

    select uuid from rbac.subject where name = currentSubject into currentSubjectUuid;
    if currentSubjectUuid is null then
        raise exception ''[401] subject % given in `base.defineContext(...)` does not exist'', currentSubject;
    end if;
    return currentSubjectUuid;
end; ';


ALTER FUNCTION rbac.determinecurrentsubjectuuid(currentsubject character varying) OWNER TO admin;

--
-- Name: entertriggerforobjectuuid(uuid); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.entertriggerforobjectuuid(IN currentobjectuuid uuid)
    LANGUAGE plpgsql
    AS '
declare
    existingObjectUuid text;
begin
    existingObjectUuid = current_setting(''hsadminng.currentObjectUuid'', true);
    if (existingObjectUuid > '''' ) then
        raise exception ''[500] currentObjectUuid already defined, already in trigger of "%"'', existingObjectUuid;
    end if;
    execute format(''set local hsadminng.currentObjectUuid to %L'', currentObjectUuid);
end; ';


ALTER PROCEDURE rbac.entertriggerforobjectuuid(IN currentobjectuuid uuid) OWNER TO admin;

--
-- Name: find_subject_id(character varying); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.find_subject_id(subjectname character varying) RETURNS uuid
    LANGUAGE sql STRICT
    AS '
select uuid from rbac.subject where name = subjectName
';


ALTER FUNCTION rbac.find_subject_id(subjectname character varying) OWNER TO admin;

--
-- Name: findeffectivepermissionid(uuid, rbac.rbacop, text); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.findeffectivepermissionid(forobjectuuid uuid, forop rbac.rbacop, foroptablename text DEFAULT NULL::text) RETURNS uuid
    LANGUAGE sql STABLE STRICT
    AS '
select uuid
    from rbac.permission p
    where p.objectUuid = forObjectUuid
      and (forOp = ''SELECT'' or p.op = forOp) 
      and p.opTableName = forOpTableName
';


ALTER FUNCTION rbac.findeffectivepermissionid(forobjectuuid uuid, forop rbac.rbacop, foroptablename text) OWNER TO admin;

--
-- Name: reference; Type: TABLE; Schema: rbac; Owner: test
--

CREATE TABLE rbac.reference (
    uuid uuid DEFAULT public.uuid_generate_v4(),
    type rbac.referencetype NOT NULL
);


ALTER TABLE rbac.reference OWNER TO admin;

--
-- Name: findgrantees(uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.findgrantees(grantedid uuid) RETURNS SETOF rbac.reference
    LANGUAGE sql STRICT
    AS '
with recursive grants as (
    select descendantUuid, ascendantUuid
        from rbac.grant
        where descendantUuid = grantedId
    union all
    select g.descendantUuid, g.ascendantUuid
        from rbac.grant g
                 inner join grants on grants.ascendantUuid = g.descendantUuid
)
select ref.*
    from grants
             join rbac.reference ref on ref.uuid = grants.ascendantUuid;
';


ALTER FUNCTION rbac.findgrantees(grantedid uuid) OWNER TO admin;

--
-- Name: findidnamebyobjectuuid(character varying, uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.findidnamebyobjectuuid(objecttable character varying, objectuuid uuid) RETURNS character varying
    LANGUAGE plpgsql STRICT
    AS '
declare
    sql    varchar;
    idName varchar;
begin
    objectTable := base.pureIdentifier(objectTable);
    sql := format(''select * from %s_id_name_by_uuid(%L::uuid);'', objectTable, objectUuid);
    begin
        execute sql into idName;
    exception
        when others then
            raise exception ''function %_id_name_by_uuid(''''%'''') failed: %, SQLSTATE: %. If the function itself could not be found, add identity view support to %'',
                objectTable, objectUuid, SQLERRM, SQLSTATE, objectTable;
    end;
    return idName;
end ; ';


ALTER FUNCTION rbac.findidnamebyobjectuuid(objecttable character varying, objectuuid uuid) OWNER TO admin;

--
-- Name: findobjectuuidbyidname(character varying, character varying); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.findobjectuuidbyidname(objecttable character varying, objectidname character varying) RETURNS uuid
    LANGUAGE plpgsql STRICT
    AS '
declare
    sql  varchar;
    uuid uuid;
begin
    objectTable := base.pureIdentifier(objectTable);
    objectIdName := base.pureIdentifier(objectIdName);
    sql := format(''select * from %s_uuid_by_id_name(%L);'', objectTable, objectIdName);
    begin
        execute sql into uuid;
    exception
        when others then
            raise exception ''function %_uuid_by_id_name(''''%'''') failed: %, SQLSTATE: %. If the function itself could not be found, add identity view support to %\nSQL:%'',
                objectTable, objectIdName, SQLERRM, SQLSTATE, objectTable, sql;
    end;
    if uuid is null then
        raise exception ''SQL returned null: %'', sql;
    else
        return uuid;
    end if;
end ; ';


ALTER FUNCTION rbac.findobjectuuidbyidname(objecttable character varying, objectidname character varying) OWNER TO admin;

--
-- Name: findpermissionid(uuid, rbac.rbacop, text); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.findpermissionid(forobjectuuid uuid, forop rbac.rbacop, foroptablename text DEFAULT NULL::text) RETURNS uuid
    LANGUAGE sql STABLE STRICT
    AS '
select uuid
    from rbac.permission p
    where p.objectUuid = forObjectUuid
      and p.op = forOp
      and p.opTableName = forOpTableName
';


ALTER FUNCTION rbac.findpermissionid(forobjectuuid uuid, forop rbac.rbacop, foroptablename text) OWNER TO admin;

--
-- Name: findroleid(character varying); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.findroleid(roleidname character varying) RETURNS uuid
    LANGUAGE plpgsql STRICT
    AS '
declare
    roleParts                 text;
    roleTypeFromRoleIdName    rbac.RoleType;
    objectNameFromRoleIdName  text;
    objectTableFromRoleIdName text;
    objectUuidOfRole          uuid;
    roleUuid                  uuid;
begin
    
    roleParts = overlay(roleIdName placing ''#'' from length(roleIdName) + 1 - strpos(reverse(roleIdName), '':''));
    objectTableFromRoleIdName = split_part(roleParts, ''#'', 1);
    objectNameFromRoleIdName = split_part(roleParts, ''#'', 2);
    roleTypeFromRoleIdName = split_part(roleParts, ''#'', 3);
    objectUuidOfRole = rbac.findObjectUuidByIdName(objectTableFromRoleIdName, objectNameFromRoleIdName);

    select uuid
        from rbac.role
        where objectUuid = objectUuidOfRole
          and roleType = roleTypeFromRoleIdName
        into roleUuid;
    return roleUuid;
end; ';


ALTER FUNCTION rbac.findroleid(roleidname character varying) OWNER TO admin;

--
-- Name: findroleid(rbac.roledescriptor); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.findroleid(roledescriptor rbac.roledescriptor) RETURNS uuid
    LANGUAGE sql STRICT
    AS '
select uuid from rbac.role where objectUuid = roleDescriptor.objectUuid and roleType = roleDescriptor.roleType;
';


ALTER FUNCTION rbac.findroleid(roledescriptor rbac.roledescriptor) OWNER TO admin;

--
-- Name: generaterbacidentityviewfromprojection(text, text); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.generaterbacidentityviewfromprojection(IN targettable text, IN sqlprojection text)
    LANGUAGE plpgsql
    AS '
declare
    sqlQuery text;
begin
    targettable := lower(targettable);

    sqlQuery = format($sql$
            select target.uuid, base.cleanIdentifier(%2$s) as idName
                from %1$s as target;
        $sql$, targetTable, sqlProjection);
    call rbac.generateRbacIdentityViewFromQuery(targetTable, sqlQuery);
end; ';


ALTER PROCEDURE rbac.generaterbacidentityviewfromprojection(IN targettable text, IN sqlprojection text) OWNER TO admin;

--
-- Name: generaterbacidentityviewfromquery(text, text); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.generaterbacidentityviewfromquery(IN targettable text, IN sqlquery text)
    LANGUAGE plpgsql
    AS '
declare
    sql text;
begin
    targettable := lower(targettable);

    
    sql = format($sql$
            create or replace view %1$s_iv as %2$s;
            grant all privileges on %1$s_iv to restricted;
        $sql$, targetTable, sqlQuery);
    execute sql;

    
    sql = format($sql$
        create or replace function %1$s_uuid_by_id_name(givenIdName varchar)
            returns uuid
            language plpgsql as $f$
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from %1$s_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; $f$;
        $sql$, targetTable);
    execute sql;

    
    sql = format($sql$
        create or replace function %1$s_id_name_by_uuid(givenUuid uuid)
            returns varchar
            language sql
            strict as $f$
        select idName from %1$s_iv iv where iv.uuid = givenUuid;
        $f$;
    $sql$, targetTable);
    execute sql;
end; ';


ALTER PROCEDURE rbac.generaterbacidentityviewfromquery(IN targettable text, IN sqlquery text) OWNER TO admin;

--
-- Name: generaterbacrestrictedview(text, text, text, text); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.generaterbacrestrictedview(IN targettable text, IN orderby text, IN columnupdates text DEFAULT NULL::text, IN columnnames text DEFAULT '*'::text)
    LANGUAGE plpgsql
    AS '
declare
    sql text;
    newColumns text;
begin
    targetTable := lower(targetTable);
    if columnNames = ''*'' then
        columnNames := base.tableColumnNames(targetTable);
    end if;

    
    sql := format($sql$
        create or replace view %1$s_rv as
            with accessible_uuids as (
                     with recursive
                          recursive_grants as
                              (select distinct rbac.grant.descendantuuid,
                                               rbac.grant.ascendantuuid,
                                               1 as level,
                                               true
                                   from rbac.grant
                                   where rbac.grant.assumed
                                     and (rbac.grant.ascendantuuid = any (rbac.currentSubjectOrAssumedRolesUuids()))
                               union all
                               select distinct g.descendantuuid,
                                               g.ascendantuuid,
                                               grants.level + 1 as level,
                                               base.assertTrue(grants.level < 22, ''too many grant-levels: '' || grants.level)
                                   from rbac.grant g
                                            join recursive_grants grants on grants.descendantuuid = g.ascendantuuid
                                   where g.assumed),
                          grant_count AS (
                            SELECT COUNT(*) AS grant_count FROM recursive_grants
                          ),
                          count_check as (select base.assertTrue((select count(*) as grant_count from recursive_grants) < 400000,
                                ''too many grants for current subjects: '' || (select count(*) as grant_count from recursive_grants))
                                                     as valid)
                      select distinct perm.objectuuid
                          from recursive_grants
                                   join rbac.permission perm on recursive_grants.descendantuuid = perm.uuid
                                   join rbac.object obj on obj.uuid = perm.objectuuid
                                   join count_check cc on cc.valid
                          where obj.objectTable = ''%1$s'' 
            )
            select target.*
                from %1$s as target
                where rbac.hasGlobalAdminRole() or target.uuid in (select * from accessible_uuids)
                order by %2$s;

        grant all privileges on %1$s_rv to restricted;
        $sql$, targetTable, orderBy);
    execute sql;

    
    newColumns := ''new.'' || replace(columnNames, '', '', '', new.'');
    sql := format($sql$
    create function %1$s_instead_of_insert_tf()
        returns trigger
        language plpgsql as $f$
    declare
        newTargetRow %1$s;
    begin
        insert
            into %1$s (%2$s)
            values (%3$s)
            returning * into newTargetRow;
        return newTargetRow;
    end; $f$;
    $sql$, targetTable, columnNames, newColumns);
    execute sql;

    
    sql := format($sql$
        create trigger instead_of_insert_tg
            instead of insert
            on %1$s_rv
            for each row
        execute function %1$s_instead_of_insert_tf();
    $sql$, targetTable);
    execute sql;

    
    sql := format($sql$
        create function %1$s_instead_of_delete_tf()
            returns trigger
            language plpgsql as $f$
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''%1$s'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from %1$s p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject %% is not allowed to delete %1$s uuid %%'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; $f$;
    $sql$, targetTable);
    execute sql;

    
    sql := format($sql$
        create trigger instead_of_delete_tg
            instead of delete
            on %1$s_rv
            for each row
        execute function %1$s_instead_of_delete_tf();
    $sql$, targetTable);
    execute sql;

    
    if columnUpdates is not null then
        sql := format($sql$
            create function %1$s_instead_of_update_tf()
                returns trigger
                language plpgsql as $f$
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''%1$s'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update %1$s
                        set %2$s
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject %% is not allowed to update %1$s uuid %%'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; $f$;
        $sql$, targetTable, columnUpdates);
        execute sql;

        
        sql = format($sql$
            create trigger instead_of_update_tg
                instead of update
                on %1$s_rv
                for each row
            execute function %1$s_instead_of_update_tf();
        $sql$, targetTable);
        execute sql;
    end if;
end; ';


ALTER PROCEDURE rbac.generaterbacrestrictedview(IN targettable text, IN orderby text, IN columnupdates text, IN columnnames text) OWNER TO admin;

--
-- Name: generaterbacroledescriptors(text); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.generaterbacroledescriptors(IN targettable text)
    LANGUAGE plpgsql
    AS '
declare
    sql text;
begin
    sql = format($sql$
        create or replace function %1$s_OWNER(entity %1$s, assumed boolean = true)
            returns rbac.RoleDescriptor
            language plpgsql
            strict as $f$
        begin
            return rbac.roleDescriptorOf(''%1$s'', entity.uuid, ''OWNER'', assumed);
        end; $f$;

        create or replace function %1$s_ADMIN(entity %1$s, assumed boolean = true)
            returns rbac.RoleDescriptor
            language plpgsql
            strict as $f$
        begin
            return rbac.roleDescriptorOf(''%1$s'', entity.uuid, ''ADMIN'', assumed);
        end; $f$;

        create or replace function %1$s_AGENT(entity %1$s, assumed boolean = true)
            returns rbac.RoleDescriptor
            language plpgsql
            strict as $f$
        begin
            return rbac.roleDescriptorOf(''%1$s'', entity.uuid, ''AGENT'', assumed);
        end; $f$;

        create or replace function %1$s_TENANT(entity %1$s, assumed boolean = true)
            returns rbac.RoleDescriptor
            language plpgsql
            strict as $f$
        begin
            return rbac.roleDescriptorOf(''%1$s'', entity.uuid, ''TENANT'', assumed);
        end; $f$;

        
        create or replace function %1$s_GUEST(entity %1$s, assumed boolean = true)
            returns rbac.RoleDescriptor
            language plpgsql
            strict as $f$
        begin
            return rbac.roleDescriptorOf(''%1$s'', entity.uuid, ''GUEST'', assumed);
        end; $f$;

        create or replace function %1$s_REFERRER(entity %1$s)
            returns rbac.RoleDescriptor
            language plpgsql
            strict as $f$
        begin
            return rbac.roleDescriptorOf(''%1$s'', entity.uuid, ''REFERRER'');
        end; $f$;

        $sql$, targetTable);
    execute sql;
end; ';


ALTER PROCEDURE rbac.generaterbacroledescriptors(IN targettable text) OWNER TO admin;

--
-- Name: generaterelatedrbacobject(character varying); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.generaterelatedrbacobject(IN targettable character varying)
    LANGUAGE plpgsql
    AS '
declare
    targetTableName text;
    targetSchemaPrefix text;
    createInsertTriggerSQL text;
    createDeleteTriggerSQL text;
begin
    if POSITION(''.'' IN targetTable) > 0 then
        targetSchemaPrefix := SPLIT_PART(targetTable, ''.'', 1) || ''.'';
        targetTableName := SPLIT_PART(targetTable, ''.'', 2);
    else
        targetSchemaPrefix := '''';
        targetTableName := targetTable;
    end if;

    if targetSchemaPrefix = '''' and targetTableName = ''customer'' then
        raise exception ''missing targetShemaPrefix: %'', targetTable;
    end if;

    createInsertTriggerSQL = format($sql$
        create trigger createRbacObjectFor_%s_insert_tg_1058_25
            before insert on %s%s
            for each row
                execute procedure rbac.insert_related_object();
        $sql$, targetTableName, targetSchemaPrefix, targetTableName);
    execute createInsertTriggerSQL;

    createDeleteTriggerSQL = format($sql$
        create trigger createRbacObjectFor_%s_delete_tg_1058_35
            after delete on %s%s
            for each row
                execute procedure rbac.delete_related_rbac_rules_tf();
        $sql$, targetTableName, targetSchemaPrefix, targetTableName);
    execute createDeleteTriggerSQL;
end;
';


ALTER PROCEDURE rbac.generaterelatedrbacobject(IN targettable character varying) OWNER TO admin;

--
-- Name: getpermissionid(uuid, rbac.rbacop, text); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.getpermissionid(forobjectuuid uuid, forop rbac.rbacop, foroptablename text DEFAULT NULL::text) RETURNS uuid
    LANGUAGE plpgsql STABLE
    AS '
declare
    permissionUuid uuid;
begin
    select uuid into permissionUuid
        from rbac.permission p
        where p.objectUuid = forObjectUuid
          and p.op = forOp
          and forOpTableName is null or p.opTableName = forOpTableName;
    assert permissionUuid is not null,
        format(''permission %s %s for object UUID %s cannot be found'', forOp, forOpTableName, forObjectUuid);
    return permissionUuid;
end; ';


ALTER FUNCTION rbac.getpermissionid(forobjectuuid uuid, forop rbac.rbacop, foroptablename text) OWNER TO admin;

--
-- Name: getroleid(rbac.roledescriptor); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.getroleid(roledescriptor rbac.roledescriptor) RETURNS uuid
    LANGUAGE plpgsql
    AS '
declare
    roleUuid uuid;
begin
    assert roleDescriptor is not null, ''roleDescriptor must not be null'';

    roleUuid := rbac.findRoleId(roleDescriptor);
    if (roleUuid is null) then
        raise exception ''rbac.role "%#%.%" not found'', roleDescriptor.objectTable, roleDescriptor.objectUuid, roleDescriptor.roleType;
    end if;
    return roleUuid;
end;
';


ALTER FUNCTION rbac.getroleid(roledescriptor rbac.roledescriptor) OWNER TO admin;

--
-- Name: global_admin(boolean); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.global_admin(assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE sql STABLE STRICT
    AS '
select ''rbac.global'', (select uuid from rbac.object where objectTable = ''rbac.global''), ''ADMIN''::rbac.RoleType, assumed;
';


ALTER FUNCTION rbac.global_admin(assumed boolean) OWNER TO admin;

--
-- Name: global_id_name_by_uuid(uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.global_id_name_by_uuid(uuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
select idName from rbac.global_iv iv where iv.uuid = global_id_name_by_uuid.uuid;
';


ALTER FUNCTION rbac.global_id_name_by_uuid(uuid uuid) OWNER TO admin;

--
-- Name: global_uuid_by_id_name(character varying); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.global_uuid_by_id_name(idname character varying) RETURNS uuid
    LANGUAGE sql STRICT
    AS '
select uuid from rbac.global_iv iv where iv.idName = global_uuid_by_id_name.idName;
';


ALTER FUNCTION rbac.global_uuid_by_id_name(idname character varying) OWNER TO admin;

--
-- Name: globalglobalguest(boolean); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.globalglobalguest(assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE sql STABLE STRICT
    AS '
select ''rbac.global'', (select uuid from rbac.object where objectTable = ''rbac.global''), ''GUEST''::rbac.RoleType, assumed;
';


ALTER FUNCTION rbac.globalglobalguest(assumed boolean) OWNER TO admin;

--
-- Name: grantedpermissions(uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.grantedpermissions(targetsubjectuuid uuid) RETURNS TABLE(roleuuid uuid, rolename text, permissionuuid uuid, op rbac.rbacop, optablename character varying, objecttable character varying, objectidname character varying, objectuuid uuid)
    LANGUAGE sql STRICT
    AS '
    select * from rbac.grantedPermissionsRaw(targetSubjectUuid)
    union all
    select roleUuid, roleName, permissionUuid, ''SELECT''::rbac.RbacOp, opTableName, objectTable, objectIdName, objectUuid
        from rbac.grantedPermissionsRaw(targetSubjectUuid)
        where op <> ''SELECT''::rbac.RbacOp;
';


ALTER FUNCTION rbac.grantedpermissions(targetsubjectuuid uuid) OWNER TO admin;

--
-- Name: grantedpermissionsraw(uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.grantedpermissionsraw(targetsubjectuuid uuid) RETURNS TABLE(roleuuid uuid, rolename text, permissionuuid uuid, op rbac.rbacop, optablename character varying, objecttable character varying, objectidname character varying, objectuuid uuid)
    LANGUAGE plpgsql STRICT
    AS '
declare
    currentSubjectUuid uuid;
begin
    
    currentSubjectUuid := rbac.currentSubjectUuid();

    if rbac.hasGlobalRoleGranted(targetSubjectUuid) and not rbac.hasGlobalRoleGranted(currentSubjectUuid) then
        raise exception ''[403] permissions of user "%" are not accessible to user "%"'', targetSubjectUuid, base.currentSubject();
    end if;

    return query select
        xp.roleUuid,
        (xp.roleObjectTable || ''#'' || xp.roleObjectIdName || '':'' || xp.roleType) as roleName,
        xp.permissionUuid, xp.op, xp.opTableName,
        xp.permissionObjectTable, xp.permissionObjectIdName, xp.permissionObjectUuid
        from (select
                  r.uuid as roleUuid, r.roletype, ro.objectTable as roleObjectTable,
                  rbac.findIdNameByObjectUuid(ro.objectTable, ro.uuid) as roleObjectIdName,
                  p.uuid as permissionUuid, p.op, p.opTableName,
                  po.objecttable as permissionObjectTable,
                  rbac.findIdNameByObjectUuid(po.objectTable, po.uuid) as permissionObjectIdName,
                  po.uuid as permissionObjectUuid
              from rbac.queryPermissionsGrantedToSubjectId( targetSubjectUuid) as p
              join rbac.grant as g on g.descendantUuid = p.uuid
              join rbac.object as po on po.uuid = p.objectUuid
              join rbac.role_rv as r on r.uuid = g.ascendantUuid
              join rbac.object as ro on ro.uuid = r.objectUuid
              where rbac.isGranted(targetSubjectUuid, r.uuid)
             ) xp;
    
end; ';


ALTER FUNCTION rbac.grantedpermissionsraw(targetsubjectuuid uuid) OWNER TO admin;

--
-- Name: grantpermissiontorole(uuid, uuid); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.grantpermissiontorole(IN permissionuuid uuid, IN roleuuid uuid)
    LANGUAGE plpgsql
    AS '
begin
    perform rbac.assertReferenceType(''roleId (ascendant)'', roleUuid, ''rbac.role'');
    perform rbac.assertReferenceType(''permissionId (descendant)'', permissionUuid, ''rbac.permission'');

    insert
        into rbac.grant (grantedByTriggerOf, ascendantUuid, descendantUuid, assumed)
        values (rbac.currentTriggerObjectUuid(), roleUuid, permissionUuid, true)
    on conflict do nothing; 
end;
';


ALTER PROCEDURE rbac.grantpermissiontorole(IN permissionuuid uuid, IN roleuuid uuid) OWNER TO admin;

--
-- Name: grantpermissiontorole(uuid, rbac.roledescriptor); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.grantpermissiontorole(IN permissionuuid uuid, IN roledesc rbac.roledescriptor)
    LANGUAGE plpgsql
    AS '
begin
    call rbac.grantPermissionToRole(permissionUuid, rbac.findRoleId(roleDesc));
end;
';


ALTER PROCEDURE rbac.grantpermissiontorole(IN permissionuuid uuid, IN roledesc rbac.roledescriptor) OWNER TO admin;

--
-- Name: grantroletorole(uuid, uuid, boolean); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.grantroletorole(IN subroleid uuid, IN superroleid uuid, IN doassume boolean DEFAULT true)
    LANGUAGE plpgsql
    AS '
begin
    perform rbac.assertReferenceType(''superRoleId (ascendant)'', superRoleId, ''rbac.role'');
    perform rbac.assertReferenceType(''subRoleId (descendant)'', subRoleId, ''rbac.role'');

    if rbac.isGranted(subRoleId, superRoleId) then
        call rbac.raiseDuplicateRoleGrantException(subRoleId, superRoleId);
    end if;

    insert
        into rbac.grant (grantedByTriggerOf, ascendantuuid, descendantUuid, assumed)
        values (rbac.currentTriggerObjectUuid(), superRoleId, subRoleId, doAssume)
    on conflict do nothing; 
end; ';


ALTER PROCEDURE rbac.grantroletorole(IN subroleid uuid, IN superroleid uuid, IN doassume boolean) OWNER TO admin;

--
-- Name: grantroletorole(rbac.roledescriptor, rbac.roledescriptor, boolean); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.grantroletorole(IN subrole rbac.roledescriptor, IN superrole rbac.roledescriptor, IN doassume boolean DEFAULT true)
    LANGUAGE plpgsql
    AS '
declare
    superRoleId uuid;
    subRoleId uuid;
begin
    
    if superRole.objectUuid is null or subRole.objectuuid is null then
        return;
    end if;

    superRoleId := rbac.findRoleId(superRole);
    subRoleId := rbac.findRoleId(subRole);

    perform rbac.assertReferenceType(''superRoleId (ascendant)'', superRoleId, ''rbac.role'');
    perform rbac.assertReferenceType(''subRoleId (descendant)'', subRoleId, ''rbac.role'');

    if rbac.isGranted(subRoleId, superRoleId) then
        call rbac.raiseDuplicateRoleGrantException(subRoleId, superRoleId);
    end if;

    insert
        into rbac.grant (grantedByTriggerOf, ascendantuuid, descendantUuid, assumed)
        values (rbac.currentTriggerObjectUuid(), superRoleId, subRoleId, doAssume)
    on conflict do nothing; 
end; ';


ALTER PROCEDURE rbac.grantroletorole(IN subrole rbac.roledescriptor, IN superrole rbac.roledescriptor, IN doassume boolean) OWNER TO admin;

--
-- Name: grantroletosubject(uuid, uuid, uuid, boolean); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.grantroletosubject(IN grantedbyroleuuid uuid, IN grantedroleuuid uuid, IN subjectuuid uuid, IN doassume boolean DEFAULT true)
    LANGUAGE plpgsql
    AS '
declare
    grantedByRoleIdName text;
    grantedRoleIdName text;
begin
    perform rbac.assertReferenceType(''grantingRoleUuid'', grantedByRoleUuid, ''rbac.role'');
    perform rbac.assertReferenceType(''grantedRoleUuid (descendant)'', grantedRoleUuid, ''rbac.role'');
    perform rbac.assertReferenceType(''subjectUuid (ascendant)'', subjectUuid, ''rbac.subject'');

    assert grantedByRoleUuid is not null, ''grantedByRoleUuid must not be null'';
    assert grantedRoleUuid is not null, ''grantedRoleUuid must not be null'';
    assert subjectUuid is not null, ''subjectUuid must not be null'';

    if NOT rbac.isGranted(rbac.currentSubjectOrAssumedRolesUuids(), grantedByRoleUuid) then
        select roleIdName from rbac.role_ev where uuid=grantedByRoleUuid into grantedByRoleIdName;
        raise exception ''[403] Access to granted-by-role % (%) forbidden for % (%)'',
                grantedByRoleIdName, grantedByRoleUuid, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
    end if;
    if NOT rbac.isGranted(grantedByRoleUuid, grantedRoleUuid) then
        select roleIdName from rbac.role_ev where uuid=grantedByRoleUuid into grantedByRoleIdName;
        select roleIdName from rbac.role_ev where uuid=grantedRoleUuid into grantedRoleIdName;
        raise exception ''[403] Access to granted role % (%) forbidden for % (%)'',
                grantedRoleIdName, grantedRoleUuid, grantedByRoleIdName, grantedByRoleUuid;
    end if;

    insert
        into rbac.grant (grantedByRoleUuid, ascendantUuid, descendantUuid, assumed)
        values (grantedByRoleUuid, subjectUuid, grantedRoleUuid, doAssume);
    
    
    
end; ';


ALTER PROCEDURE rbac.grantroletosubject(IN grantedbyroleuuid uuid, IN grantedroleuuid uuid, IN subjectuuid uuid, IN doassume boolean) OWNER TO admin;

--
-- Name: grantroletosubjectunchecked(uuid, uuid, uuid, boolean); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.grantroletosubjectunchecked(IN grantedbyroleuuid uuid, IN grantedroleuuid uuid, IN subjectuuid uuid, IN doassume boolean DEFAULT true)
    LANGUAGE plpgsql
    AS '
begin
    perform rbac.assertReferenceType(''grantingRoleUuid'', grantedByRoleUuid, ''rbac.role'');
    perform rbac.assertReferenceType(''roleId (descendant)'', grantedRoleUuid, ''rbac.role'');
    perform rbac.assertReferenceType(''subjectUuid (ascendant)'', subjectUuid, ''rbac.subject'');

    insert
        into rbac.grant (grantedByRoleUuid, ascendantUuid, descendantUuid, assumed)
        values (grantedByRoleUuid, subjectUuid, grantedRoleUuid, doAssume)
    
    on conflict do nothing; 
end; ';


ALTER PROCEDURE rbac.grantroletosubjectunchecked(IN grantedbyroleuuid uuid, IN grantedroleuuid uuid, IN subjectuuid uuid, IN doassume boolean) OWNER TO admin;

--
-- Name: hasglobaladminrole(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.hasglobaladminrole() RETURNS boolean
    LANGUAGE plpgsql STABLE
    AS '
declare
    assumedRoles text;
begin
    begin
        assumedRoles := current_setting(''hsadminng.assumedRoles'');
    exception
        when others then
            assumedRoles := null;
    end;
    return TRIM(COALESCE(assumedRoles, '''')) = '''' and rbac.isGlobalAdmin();
end; ';


ALTER FUNCTION rbac.hasglobaladminrole() OWNER TO admin;

--
-- Name: hasglobalpermission(rbac.rbacop); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.hasglobalpermission(op rbac.rbacop) RETURNS boolean
    LANGUAGE sql
    AS '
    
select (select uuid from rbac.global) in
       (select rbac.queryAccessibleObjectUuidsOfSubjectIds(op, ''rbac.global'', rbac.currentSubjectOrAssumedRolesUuids()));
';


ALTER FUNCTION rbac.hasglobalpermission(op rbac.rbacop) OWNER TO admin;

--
-- Name: hasglobalrolegranted(uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.hasglobalrolegranted(forascendantuuid uuid) RETURNS boolean
    LANGUAGE sql STABLE
    AS '
select exists(
           select r.uuid
               from rbac.grant as g
                        join rbac.role as r on r.uuid = g.descendantuuid
                        join rbac.object as o on o.uuid = r.objectuuid
               where g.ascendantuuid = forAscendantUuid
                 and o.objecttable = ''rbac.global''
           );
';


ALTER FUNCTION rbac.hasglobalrolegranted(forascendantuuid uuid) OWNER TO admin;

--
-- Name: hasinsertpermission(uuid, text); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.hasinsertpermission(objectuuid uuid, tablename text) RETURNS boolean
    LANGUAGE plpgsql STABLE
    AS '
declare
    permissionUuid uuid;
begin
    permissionUuid = rbac.findPermissionId(objectUuid, ''INSERT''::rbac.RbacOp, tableName);
    return permissionUuid is not null;
end;
';


ALTER FUNCTION rbac.hasinsertpermission(objectuuid uuid, tablename text) OWNER TO admin;

--
-- Name: insert_grant_tf(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.insert_grant_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    newGrant rbac.grant_rv;
begin
    call rbac.grantRoleToSubject(rbac.assumedRoleUuid(), new.grantedRoleUuid, new.subjectUuid, new.assumed);
    select grv.*
        from rbac.grant_rv grv
        where grv.subjectUuid=new.subjectUuid and grv.grantedRoleUuid=new.grantedRoleUuid
        into newGrant;
    return newGrant;
end; ';


ALTER FUNCTION rbac.insert_grant_tf() OWNER TO admin;

--
-- Name: insert_related_object(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.insert_related_object() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
declare
    objectUuid uuid;
    tableSchemaAndName text;
begin
    tableSchemaAndName := base.combine_table_schema_and_name(TG_TABLE_SCHEMA, TG_TABLE_NAME);
    if TG_OP = ''INSERT'' then
        if NEW.uuid is null then
            insert
                into rbac.object (objectTable)
                values (tableSchemaAndName)
                returning uuid into objectUuid;
            NEW.uuid = objectUuid;
        else
            insert
                into rbac.object (uuid, objectTable)
                values (NEW.uuid, tableSchemaAndName)
                returning uuid into objectUuid;
        end if;
        return NEW;
    else
        raise exception ''invalid usage of TRIGGER AFTER INSERT'';
    end if;
end; ';


ALTER FUNCTION rbac.insert_related_object() OWNER TO admin;

--
-- Name: insert_subject_tf(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.insert_subject_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    refUuid uuid;
    newUser rbac.subject;
begin
    insert
        into  rbac.reference as r (uuid, type)
        values( new.uuid, ''rbac.subject'')
        returning r.uuid into refUuid;
    insert
        into rbac.subject (uuid, name)
        values (refUuid, new.name)
        returning * into newUser;
    return newUser;
end;
';


ALTER FUNCTION rbac.insert_subject_tf() OWNER TO admin;

--
-- Name: isglobaladmin(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.isglobaladmin() RETURNS boolean
    LANGUAGE plpgsql
    AS '
begin
    return rbac.isGranted(rbac.currentSubjectOrAssumedRolesUuids(), rbac.findRoleId(rbac.global_ADMIN()));
end; ';


ALTER FUNCTION rbac.isglobaladmin() OWNER TO admin;

--
-- Name: isgranted(uuid[], uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.isgranted(granteeids uuid[], grantedid uuid) RETURNS boolean
    LANGUAGE sql STRICT
    AS '
with recursive grants as (
    select descendantUuid, ascendantUuid
        from rbac.grant
        where descendantUuid = grantedId
    union all
    select "grant".descendantUuid, "grant".ascendantUuid
        from rbac.grant "grant"
                 inner join grants recur on recur.ascendantUuid = "grant".descendantUuid
)
select exists (
    select true
        from grants
        where ascendantUuid = any(granteeIds)
) or grantedId = any(granteeIds);
';


ALTER FUNCTION rbac.isgranted(granteeids uuid[], grantedid uuid) OWNER TO admin;

--
-- Name: isgranted(uuid, uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.isgranted(granteeid uuid, grantedid uuid) RETURNS boolean
    LANGUAGE sql STRICT
    AS '
select * from rbac.isGranted(array[granteeId], grantedId);
';


ALTER FUNCTION rbac.isgranted(granteeid uuid, grantedid uuid) OWNER TO admin;

--
-- Name: ispermissiongrantedtosubject(uuid, uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.ispermissiongrantedtosubject(permissionid uuid, subjectid uuid) RETURNS boolean
    LANGUAGE sql STABLE
    AS '
with recursive grants as (
    select descendantUuid, ascendantUuid
        from rbac.grant
        where descendantUuid = permissionId
    union all
    select g.descendantUuid, g.ascendantUuid
        from rbac.grant g
                 inner join grants on grants.ascendantUuid = g.descendantUuid
)
select exists(
    select true
        from grants
        where ascendantUuid = subjectId
);
';


ALTER FUNCTION rbac.ispermissiongrantedtosubject(permissionid uuid, subjectid uuid) OWNER TO admin;

--
-- Name: leavetriggerforobjectuuid(uuid); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.leavetriggerforobjectuuid(IN currentobjectuuid uuid)
    LANGUAGE plpgsql
    AS '
declare
    existingObjectUuid uuid;
begin
    existingObjectUuid = current_setting(''hsadminng.currentObjectUuid'', true);
    if ( existingObjectUuid <> currentObjectUuid ) then
        raise exception ''[500] currentObjectUuid does not match: "%"'', existingObjectUuid;
    end if;
    execute format(''reset hsadminng.currentObjectUuid'');
end; ';


ALTER PROCEDURE rbac.leavetriggerforobjectuuid(IN currentobjectuuid uuid) OWNER TO admin;

--
-- Name: queryaccessibleobjectuuidsofsubjectids(rbac.rbacop, character varying, uuid[], integer); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.queryaccessibleobjectuuidsofsubjectids(requiredop rbac.rbacop, forobjecttable character varying, subjectids uuid[], maxobjects integer DEFAULT 8000) RETURNS SETOF uuid
    LANGUAGE plpgsql STRICT
    AS '
declare
    foundRows bigint;
begin
    return query
        WITH RECURSIVE grants AS (
            SELECT descendantUuid, ascendantUuid, 1 AS level
                FROM rbac.grant
                WHERE assumed
                  AND ascendantUuid = any(subjectIds)
            UNION ALL
            SELECT g.descendantUuid, g.ascendantUuid, grants.level + 1 AS level
                FROM rbac.grant g
                         INNER JOIN grants ON grants.descendantUuid = g.ascendantUuid
                WHERE g.assumed
        ),
       granted AS (
           SELECT DISTINCT descendantUuid
               FROM grants
       )
        SELECT DISTINCT perm.objectUuid
            FROM granted
                     JOIN rbac.permission perm ON granted.descendantUuid = perm.uuid
                     JOIN rbac.object obj ON obj.uuid = perm.objectUuid
            WHERE (requiredOp = ''SELECT'' OR perm.op = requiredOp)
              AND obj.objectTable = forObjectTable
            LIMIT maxObjects+1;

    foundRows = base.lastRowCount();
    if foundRows > maxObjects then
        raise exception ''[400] Too many accessible objects, limit is %, found %.'', maxObjects, foundRows
            using
                errcode = ''P0003'',
                hint = ''Please assume a sub-role and try again.'';
    end if;
end;
';


ALTER FUNCTION rbac.queryaccessibleobjectuuidsofsubjectids(requiredop rbac.rbacop, forobjecttable character varying, subjectids uuid[], maxobjects integer) OWNER TO admin;

--
-- Name: subject; Type: TABLE; Schema: rbac; Owner: test
--

CREATE TABLE rbac.subject (
    uuid uuid NOT NULL,
    name character varying(63) NOT NULL
);


ALTER TABLE rbac.subject OWNER TO admin;

--
-- Name: queryallrbacsubjectswithpermissionsfor(uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.queryallrbacsubjectswithpermissionsfor(objectid uuid) RETURNS SETOF rbac.subject
    LANGUAGE sql STRICT
    AS '
select *
    from rbac.subject
    where uuid in (
        
        with recursive grants as (
            select descendantUuid, ascendantUuid
                from rbac.grant
                where descendantUuid = objectId
            union all
            select "grant".descendantUuid, "grant".ascendantUuid
                from rbac.grant "grant"
                inner join grants recur on recur.ascendantUuid = "grant".descendantUuid
        )
        
        select ascendantUuid
            from grants);
';


ALTER FUNCTION rbac.queryallrbacsubjectswithpermissionsfor(objectid uuid) OWNER TO admin;

--
-- Name: permission; Type: TABLE; Schema: rbac; Owner: test
--

CREATE TABLE rbac.permission (
    uuid uuid NOT NULL,
    objectuuid uuid NOT NULL,
    op rbac.rbacop NOT NULL,
    optablename character varying(60)
);


ALTER TABLE rbac.permission OWNER TO admin;

--
-- Name: querypermissionsgrantedtosubjectid(uuid); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.querypermissionsgrantedtosubjectid(subjectid uuid) RETURNS SETOF rbac.permission
    LANGUAGE sql STRICT
    AS '
with recursive grants as (
    select descendantUuid, ascendantUuid
        from rbac.grant
        where ascendantUuid = subjectId
    union all
    select g.descendantUuid, g.ascendantUuid
        from rbac.grant g
                 inner join grants on grants.descendantUuid = g.ascendantUuid
)
select perm.*
    from rbac.permission perm
    where perm.uuid in (
        select descendantUuid
            from grants
    );
';


ALTER FUNCTION rbac.querypermissionsgrantedtosubjectid(subjectid uuid) OWNER TO admin;

--
-- Name: raiseduplicaterolegrantexception(uuid, uuid); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.raiseduplicaterolegrantexception(IN subroleid uuid, IN superroleid uuid)
    LANGUAGE plpgsql
    AS '
declare
    subRoleIdName text;
    superRoleIdName text;
begin
    select roleIdName from rbac.role_ev where uuid=subRoleId into subRoleIdName;
    select roleIdName from rbac.role_ev where uuid=superRoleId into superRoleIdName;
    raise exception ''[400] Duplicate role grant detected: role % (%) already granted to % (%)'', subRoleId, subRoleIdName, superRoleId, superRoleIdName;
end;
';


ALTER PROCEDURE rbac.raiseduplicaterolegrantexception(IN subroleid uuid, IN superroleid uuid) OWNER TO admin;

--
-- Name: revokepermissionfromrole(uuid, uuid); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.revokepermissionfromrole(IN permissionuuid uuid, IN superroleuuid uuid)
    LANGUAGE plpgsql
    AS '
begin
    raise INFO ''delete from rbac.grant where ascendantUuid = % and descendantUuid = %'', superRoleUuid, permissionUuid;
    delete from rbac.grant as g
           where g.ascendantUuid = superRoleUuid and g.descendantUuid = permissionUuid;
end; ';


ALTER PROCEDURE rbac.revokepermissionfromrole(IN permissionuuid uuid, IN superroleuuid uuid) OWNER TO admin;

--
-- Name: revokepermissionfromrole(uuid, rbac.roledescriptor); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.revokepermissionfromrole(IN permissionid uuid, IN superrole rbac.roledescriptor)
    LANGUAGE plpgsql
    AS '
declare
    superRoleId uuid;
    permissionOp text;
    objectTable text;
    objectUuid uuid;
begin
    superRoleId := rbac.findRoleId(superRole);

    perform rbac.assertReferenceType(''superRoleId (ascendant)'', superRoleId, ''rbac.role'');
    perform rbac.assertReferenceType(''permission (descendant)'', permissionId, ''rbac.permission'');

    if (rbac.isGranted(superRoleId, permissionId)) then
        delete from rbac.grant where ascendantUuid = superRoleId and descendantUuid = permissionId;
    else
        select p.op, o.objectTable, o.uuid
            from rbac.grant g
                     join rbac.permission p on p.uuid=g.descendantUuid
                     join rbac.object o on o.uuid=p.objectUuid
            where g.uuid=permissionId
            into permissionOp, objectTable, objectUuid;

        raise exception ''cannot revoke permission % (% on %#% (%) from % (%)) because it is not granted'',
            permissionId, permissionOp, objectTable, objectUuid, permissionId, superRole, superRoleId;
    end if;
end; ';


ALTER PROCEDURE rbac.revokepermissionfromrole(IN permissionid uuid, IN superrole rbac.roledescriptor) OWNER TO admin;

--
-- Name: revokerolefromrole(rbac.roledescriptor, rbac.roledescriptor); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.revokerolefromrole(IN subrole rbac.roledescriptor, IN superrole rbac.roledescriptor)
    LANGUAGE plpgsql
    AS '
declare
    superRoleId uuid;
    subRoleId uuid;
begin
    superRoleId := rbac.findRoleId(superRole);
    subRoleId := rbac.findRoleId(subRole);

    perform rbac.assertReferenceType(''superRoleId (ascendant)'', superRoleId, ''rbac.role'');
    perform rbac.assertReferenceType(''subRoleId (descendant)'', subRoleId, ''rbac.role'');

    if (rbac.isGranted(superRoleId, subRoleId)) then
        delete from rbac.grant where ascendantUuid = superRoleId and descendantUuid = subRoleId;
    else
        raise exception ''cannot revoke role % (%) from % (%) because it is not granted'',
            subRole, subRoleId, superRole, superRoleId;
    end if;
end; ';


ALTER PROCEDURE rbac.revokerolefromrole(IN subrole rbac.roledescriptor, IN superrole rbac.roledescriptor) OWNER TO admin;

--
-- Name: revokerolefromsubject(uuid, uuid, uuid); Type: PROCEDURE; Schema: rbac; Owner: test
--

CREATE PROCEDURE rbac.revokerolefromsubject(IN grantedbyroleuuid uuid, IN grantedroleuuid uuid, IN subjectuuid uuid)
    LANGUAGE plpgsql
    AS '
begin
    call rbac.checkRevokeRoleFromSubjectPreconditions(grantedByRoleUuid, grantedRoleUuid, subjectUuid);

    raise INFO ''delete from rbac.grant where ascendantUuid = % and descendantUuid = %'', subjectUuid, grantedRoleUuid;
    delete from rbac.grant as g
       where g.ascendantUuid = subjectUuid and g.descendantUuid = grantedRoleUuid
         and g.grantedByRoleUuid = revokeRoleFromSubject.grantedByRoleUuid;
end; ';


ALTER PROCEDURE rbac.revokerolefromsubject(IN grantedbyroleuuid uuid, IN grantedroleuuid uuid, IN subjectuuid uuid) OWNER TO admin;

--
-- Name: roledescriptorof(character varying, uuid, rbac.roletype, boolean); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.roledescriptorof(objecttable character varying, objectuuid uuid, roletype rbac.roletype, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE sql STABLE STRICT
    AS '
        select objectTable, objectUuid, roleType::rbac.RoleType, assumed;
';


ALTER FUNCTION rbac.roledescriptorof(objecttable character varying, objectuuid uuid, roletype rbac.roletype, assumed boolean) OWNER TO admin;

--
-- Name: unassumed(); Type: FUNCTION; Schema: rbac; Owner: test
--

CREATE FUNCTION rbac.unassumed() RETURNS boolean
    LANGUAGE sql STABLE
    AS '
select false;
';


ALTER FUNCTION rbac.unassumed() OWNER TO admin;

--
-- Name: customer; Type: TABLE; Schema: rbactest; Owner: test
--

CREATE TABLE rbactest.customer (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    reference integer NOT NULL,
    prefix character(3),
    adminusername character varying(63),
    CONSTRAINT customer_reference_check CHECK (((reference >= 10000) AND (reference <= 99999)))
);


ALTER TABLE rbactest.customer OWNER TO admin;

--
-- Name: customer_admin(rbactest.customer, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_admin(entity rbactest.customer, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.customer'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION rbactest.customer_admin(entity rbactest.customer, assumed boolean) OWNER TO admin;

--
-- Name: customer_agent(rbactest.customer, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_agent(entity rbactest.customer, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.customer'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION rbactest.customer_agent(entity rbactest.customer, assumed boolean) OWNER TO admin;

--
-- Name: customer_build_rbac_system(rbactest.customer); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.customer_build_rbac_system(IN new rbactest.customer)
    LANGUAGE plpgsql
    AS '

declare

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    perform rbac.defineRoleWithGrants(
        rbactest.customer_OWNER(NEW),
            permissions => array[''DELETE''],
            incomingSuperRoles => array[rbac.global_ADMIN(rbac.unassumed())],
            subjectUuids => array[rbac.currentSubjectUuid()]
    );

    perform rbac.defineRoleWithGrants(
        rbactest.customer_ADMIN(NEW),
            permissions => array[''UPDATE''],
            incomingSuperRoles => array[rbactest.customer_OWNER(NEW)]
    );

    perform rbac.defineRoleWithGrants(
        rbactest.customer_TENANT(NEW),
            permissions => array[''SELECT''],
            incomingSuperRoles => array[rbactest.customer_ADMIN(NEW)]
    );

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE rbactest.customer_build_rbac_system(IN new rbactest.customer) OWNER TO admin;

--
-- Name: customer_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call rbactest.customer_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION rbactest.customer_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: customer_create_test_data(integer); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_create_test_data(customercount integer) RETURNS integer
    LANGUAGE plpgsql STRICT
    AS '
begin
    return 10000 + customerCount;
end; ';


ALTER FUNCTION rbactest.customer_create_test_data(customercount integer) OWNER TO admin;

--
-- Name: customer_create_test_data(integer, integer); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.customer_create_test_data(IN startcount integer, IN endcount integer)
    LANGUAGE plpgsql
    AS '
begin
    for t in startCount..endCount
        loop
            call rbactest.customer_create_test_data(rbactest.testCustomerReference(t), base.intToVarChar(t, 3));
            commit;
        end loop;
end; ';


ALTER PROCEDURE rbactest.customer_create_test_data(IN startcount integer, IN endcount integer) OWNER TO admin;

--
-- Name: customer_create_test_data(integer, character varying); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.customer_create_test_data(IN custreference integer, IN custprefix character varying)
    LANGUAGE plpgsql
    AS '
declare
    custRowId     uuid;
    custAdminName varchar;
    custAdminUuid uuid;
    newCust       rbactest.customer;
begin
    custRowId = uuid_generate_v4();
    custAdminName = ''customer-admin@'' || custPrefix || ''.example.com'';
    custAdminUuid = rbac.create_subject(custAdminName);

    insert
        into rbactest.customer (reference, prefix, adminUserName)
        values (custReference, custPrefix, custAdminName);

    select * into newCust
             from rbactest.customer where reference=custReference;
    call rbac.grantRoleToSubject(
            rbac.getRoleId(rbactest.customer_OWNER(newCust)),
            rbac.getRoleId(rbactest.customer_ADMIN(newCust)),
            custAdminUuid,
            true);
end; ';


ALTER PROCEDURE rbactest.customer_create_test_data(IN custreference integer, IN custprefix character varying) OWNER TO admin;

--
-- Name: customer_grants_insert_to_global_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_grants_insert_to_global_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''rbactest.customer''),
            rbac.global_ADMIN());
    
    return NEW;
end; ';


ALTER FUNCTION rbactest.customer_grants_insert_to_global_tf() OWNER TO admin;

--
-- Name: customer_guest(rbactest.customer, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_guest(entity rbactest.customer, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.customer'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION rbactest.customer_guest(entity rbactest.customer, assumed boolean) OWNER TO admin;

--
-- Name: customer_id_name_by_uuid(uuid); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from rbactest.customer_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION rbactest.customer_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: customer_insert_permission_check_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.isGlobalAdmin() then
        return NEW;
    end if;

    raise exception ''[403] insert into rbactest.customer values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION rbactest.customer_insert_permission_check_tf() OWNER TO admin;

--
-- Name: customer_instead_of_delete_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''rbactest.customer'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from rbactest.customer p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete rbactest.customer uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION rbactest.customer_instead_of_delete_tf() OWNER TO admin;

--
-- Name: customer_instead_of_insert_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow rbactest.customer;
    begin
        insert
            into rbactest.customer (uuid, version, reference, prefix, adminusername)
            values (new.uuid, new.version, new.reference, new.prefix, new.adminusername)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION rbactest.customer_instead_of_insert_tf() OWNER TO admin;

--
-- Name: customer_instead_of_update_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''rbactest.customer'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update rbactest.customer
                        set 
        reference = new.reference,
        prefix = new.prefix,
        adminUserName = new.adminUserName
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update rbactest.customer uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION rbactest.customer_instead_of_update_tf() OWNER TO admin;

--
-- Name: customer_owner(rbactest.customer, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_owner(entity rbactest.customer, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.customer'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION rbactest.customer_owner(entity rbactest.customer, assumed boolean) OWNER TO admin;

--
-- Name: customer_rebuild_rbac_system(); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.customer_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row rbactest.customer;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM rbactest.customer LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL rbactest.customer_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE rbactest.customer_rebuild_rbac_system() OWNER TO admin;

--
-- Name: customer_referrer(rbactest.customer); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_referrer(entity rbactest.customer) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.customer'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION rbactest.customer_referrer(entity rbactest.customer) OWNER TO admin;

--
-- Name: customer_tenant(rbactest.customer, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_tenant(entity rbactest.customer, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.customer'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION rbactest.customer_tenant(entity rbactest.customer, assumed boolean) OWNER TO admin;

--
-- Name: customer_uuid_by_id_name(character varying); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.customer_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from rbactest.customer_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION rbactest.customer_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: domain; Type: TABLE; Schema: rbactest; Owner: test
--

CREATE TABLE rbactest.domain (
    uuid uuid,
    packageuuid uuid,
    name character varying(253),
    description character varying(96)
);


ALTER TABLE rbactest.domain OWNER TO admin;

--
-- Name: domain_admin(rbactest.domain, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_admin(entity rbactest.domain, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.domain'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION rbactest.domain_admin(entity rbactest.domain, assumed boolean) OWNER TO admin;

--
-- Name: domain_agent(rbactest.domain, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_agent(entity rbactest.domain, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.domain'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION rbactest.domain_agent(entity rbactest.domain, assumed boolean) OWNER TO admin;

--
-- Name: domain_build_rbac_system(rbactest.domain); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.domain_build_rbac_system(IN new rbactest.domain)
    LANGUAGE plpgsql
    AS '

declare
    newPackage rbactest.package;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM rbactest.package WHERE uuid = NEW.packageUuid    INTO newPackage;
    assert newPackage.uuid is not null, format(''newPackage must not be null for NEW.packageUuid = %s of rbactest.domain'', NEW.packageUuid);


    perform rbac.defineRoleWithGrants(
        rbactest.domain_OWNER(NEW),
            permissions => array[''DELETE'', ''UPDATE''],
            incomingSuperRoles => array[rbactest.package_ADMIN(newPackage)],
            outgoingSubRoles => array[rbactest.package_TENANT(newPackage)]
    );

    perform rbac.defineRoleWithGrants(
        rbactest.domain_ADMIN(NEW),
            permissions => array[''SELECT''],
            incomingSuperRoles => array[rbactest.domain_OWNER(NEW)],
            outgoingSubRoles => array[rbactest.package_TENANT(newPackage)]
    );

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE rbactest.domain_build_rbac_system(IN new rbactest.domain) OWNER TO admin;

--
-- Name: domain_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call rbactest.domain_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION rbactest.domain_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: domain_create_test_data(integer); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.domain_create_test_data(IN domainperpackage integer)
    LANGUAGE plpgsql
    AS '
declare
    pac         record;
begin
    for pac in
        (select p.uuid, p.name
             from rbactest.package p
                      join rbactest.customer c on p.customeruuid = c.uuid
             where c.reference < 90000) 
        loop
            call rbactest.domain_create_test_data(pac.name, 2);
            commit;
        end loop;

end; ';


ALTER PROCEDURE rbactest.domain_create_test_data(IN domainperpackage integer) OWNER TO admin;

--
-- Name: domain_create_test_data(character varying, integer); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.domain_create_test_data(IN packagename character varying, IN domaincount integer)
    LANGUAGE plpgsql
    AS '
declare
    pac         record;
    pacAdmin    varchar;
begin
    select p.uuid, p.name, c.prefix as custPrefix
        from rbactest.package p
        join rbactest.customer c on p.customeruuid = c.uuid
        where p.name = packageName
        into pac;

    for t in 0..(domainCount-1)
        loop
            pacAdmin = ''pac-admin-'' || pac.name || ''@'' || pac.custPrefix || ''.example.com'';
            call base.defineContext(''creating RBAC test domain'', null, pacAdmin, null);

            insert
                into rbactest.domain (name, packageUuid)
                values (pac.name || ''-'' || base.intToVarChar(t, 4), pac.uuid);
        end loop;
end; ';


ALTER PROCEDURE rbactest.domain_create_test_data(IN packagename character varying, IN domaincount integer) OWNER TO admin;

--
-- Name: domain_grants_insert_to_package_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_grants_insert_to_package_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''rbactest.domain''),
            rbactest.package_ADMIN(NEW));
    
    return NEW;
end; ';


ALTER FUNCTION rbactest.domain_grants_insert_to_package_tf() OWNER TO admin;

--
-- Name: domain_guest(rbactest.domain, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_guest(entity rbactest.domain, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.domain'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION rbactest.domain_guest(entity rbactest.domain, assumed boolean) OWNER TO admin;

--
-- Name: domain_id_name_by_uuid(uuid); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from rbactest.domain_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION rbactest.domain_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: domain_insert_permission_check_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.hasInsertPermission(NEW.packageUuid, ''rbactest.domain'') then
        return NEW;
    end if;

    raise exception ''[403] insert into rbactest.domain values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION rbactest.domain_insert_permission_check_tf() OWNER TO admin;

--
-- Name: domain_instead_of_delete_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''rbactest.domain'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from rbactest.domain p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete rbactest.domain uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION rbactest.domain_instead_of_delete_tf() OWNER TO admin;

--
-- Name: domain_instead_of_insert_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow rbactest.domain;
    begin
        insert
            into rbactest.domain (uuid, packageuuid, name, description)
            values (new.uuid, new.packageuuid, new.name, new.description)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION rbactest.domain_instead_of_insert_tf() OWNER TO admin;

--
-- Name: domain_instead_of_update_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''rbactest.domain'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update rbactest.domain
                        set 
        version = new.version,
        packageUuid = new.packageUuid,
        description = new.description
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update rbactest.domain uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION rbactest.domain_instead_of_update_tf() OWNER TO admin;

--
-- Name: domain_owner(rbactest.domain, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_owner(entity rbactest.domain, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.domain'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION rbactest.domain_owner(entity rbactest.domain, assumed boolean) OWNER TO admin;

--
-- Name: domain_rebuild_rbac_system(); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.domain_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row rbactest.domain;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM rbactest.domain LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL rbactest.domain_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE rbactest.domain_rebuild_rbac_system() OWNER TO admin;

--
-- Name: domain_referrer(rbactest.domain); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_referrer(entity rbactest.domain) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.domain'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION rbactest.domain_referrer(entity rbactest.domain) OWNER TO admin;

--
-- Name: domain_tenant(rbactest.domain, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_tenant(entity rbactest.domain, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.domain'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION rbactest.domain_tenant(entity rbactest.domain, assumed boolean) OWNER TO admin;

--
-- Name: domain_update_rbac_system(rbactest.domain, rbactest.domain); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.domain_update_rbac_system(IN old rbactest.domain, IN new rbactest.domain)
    LANGUAGE plpgsql
    AS '

declare
    oldPackage rbactest.package;
    newPackage rbactest.package;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM rbactest.package WHERE uuid = OLD.packageUuid    INTO oldPackage;
    assert oldPackage.uuid is not null, format(''oldPackage must not be null for OLD.packageUuid = %s of rbactest.domain'', OLD.packageUuid);

    SELECT * FROM rbactest.package WHERE uuid = NEW.packageUuid    INTO newPackage;
    assert newPackage.uuid is not null, format(''newPackage must not be null for NEW.packageUuid = %s of rbactest.domain'', NEW.packageUuid);


    if NEW.packageUuid <> OLD.packageUuid then

        call rbac.revokeRoleFromRole(rbactest.domain_OWNER(OLD), rbactest.package_ADMIN(oldPackage));
        call rbac.grantRoleToRole(rbactest.domain_OWNER(NEW), rbactest.package_ADMIN(newPackage));

        call rbac.revokeRoleFromRole(rbactest.package_TENANT(oldPackage), rbactest.domain_OWNER(OLD));
        call rbac.grantRoleToRole(rbactest.package_TENANT(newPackage), rbactest.domain_OWNER(NEW));

        call rbac.revokeRoleFromRole(rbactest.package_TENANT(oldPackage), rbactest.domain_ADMIN(OLD));
        call rbac.grantRoleToRole(rbactest.package_TENANT(newPackage), rbactest.domain_ADMIN(NEW));

    end if;

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE rbactest.domain_update_rbac_system(IN old rbactest.domain, IN new rbactest.domain) OWNER TO admin;

--
-- Name: domain_update_rbac_system_after_update_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_update_rbac_system_after_update_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call rbactest.domain_update_rbac_system(OLD, NEW);
    return NEW;
end; ';


ALTER FUNCTION rbactest.domain_update_rbac_system_after_update_tf() OWNER TO admin;

--
-- Name: domain_uuid_by_id_name(character varying); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.domain_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from rbactest.domain_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION rbactest.domain_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: package; Type: TABLE; Schema: rbactest; Owner: test
--

CREATE TABLE rbactest.package (
    uuid uuid,
    version integer DEFAULT 0 NOT NULL,
    customeruuid uuid,
    name character varying(5),
    description character varying(96)
);


ALTER TABLE rbactest.package OWNER TO admin;

--
-- Name: package_admin(rbactest.package, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_admin(entity rbactest.package, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.package'', entity.uuid, ''ADMIN'', assumed);
        end; ';


ALTER FUNCTION rbactest.package_admin(entity rbactest.package, assumed boolean) OWNER TO admin;

--
-- Name: package_agent(rbactest.package, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_agent(entity rbactest.package, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.package'', entity.uuid, ''AGENT'', assumed);
        end; ';


ALTER FUNCTION rbactest.package_agent(entity rbactest.package, assumed boolean) OWNER TO admin;

--
-- Name: package_build_rbac_system(rbactest.package); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.package_build_rbac_system(IN new rbactest.package)
    LANGUAGE plpgsql
    AS '

declare
    newCustomer rbactest.customer;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM rbactest.customer WHERE uuid = NEW.customerUuid    INTO newCustomer;
    assert newCustomer.uuid is not null, format(''newCustomer must not be null for NEW.customerUuid = %s of rbactest.package'', NEW.customerUuid);


    perform rbac.defineRoleWithGrants(
        rbactest.package_OWNER(NEW),
            permissions => array[''DELETE'', ''UPDATE''],
            incomingSuperRoles => array[rbactest.customer_ADMIN(newCustomer)]
    );

    perform rbac.defineRoleWithGrants(
        rbactest.package_ADMIN(NEW),
            incomingSuperRoles => array[rbactest.package_OWNER(NEW)]
    );

    perform rbac.defineRoleWithGrants(
        rbactest.package_TENANT(NEW),
            permissions => array[''SELECT''],
            incomingSuperRoles => array[rbactest.package_ADMIN(NEW)],
            outgoingSubRoles => array[rbactest.customer_TENANT(newCustomer)]
    );

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE rbactest.package_build_rbac_system(IN new rbactest.package) OWNER TO admin;

--
-- Name: package_build_rbac_system_after_insert_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_build_rbac_system_after_insert_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call rbactest.package_build_rbac_system(NEW);
    return NEW;
end; ';


ALTER FUNCTION rbactest.package_build_rbac_system_after_insert_tf() OWNER TO admin;

--
-- Name: package_create_test_data(); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.package_create_test_data()
    LANGUAGE plpgsql
    AS '
declare
    cust rbactest.customer;
begin
    for cust in (select * from rbactest.customer)
        loop
            continue when cust.reference >= 90000; 
            call rbactest.package_create_test_data(cust.prefix, 3);
        end loop;

    commit;
end ;
';


ALTER PROCEDURE rbactest.package_create_test_data() OWNER TO admin;

--
-- Name: package_create_test_data(character varying, integer); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.package_create_test_data(IN customerprefix character varying, IN paccount integer)
    LANGUAGE plpgsql
    AS '
declare
    cust          rbactest.customer;
    custAdminUser varchar;
    custAdminRole varchar;
    pacName       varchar;
    pac           rbactest.package;
begin
    select * from rbactest.customer where rbactest.customer.prefix = customerPrefix into cust;

    for t in 0..(pacCount-1)
        loop
            pacName = cust.prefix || to_char(t, ''fm00'');
            custAdminUser = ''customer-admin@'' || cust.prefix || ''.example.com'';
            custAdminRole = ''rbactest.customer#'' || cust.prefix || '':ADMIN'';
            call base.defineContext(''creating RBAC test package'', null, ''superuser-fran@hostsharing.net'', custAdminRole);

            insert
                into rbactest.package (customerUuid, name, description)
                values (cust.uuid, pacName, ''Here you can add your own description of package '' || pacName || ''.'')
                returning * into pac;

            call rbac.grantRoleToSubject(
                    rbac.getRoleId(rbactest.customer_ADMIN(cust)),
                    rbac.findRoleId(rbactest.package_ADMIN(pac)),
                    rbac.create_subject(''pac-admin-'' || pacName || ''@'' || cust.prefix || ''.example.com''),
                    true);

        end loop;
end; ';


ALTER PROCEDURE rbactest.package_create_test_data(IN customerprefix character varying, IN paccount integer) OWNER TO admin;

--
-- Name: package_grants_insert_to_customer_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_grants_insert_to_customer_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    
        call rbac.grantPermissionToRole(
            rbac.createPermission(NEW.uuid, ''INSERT'', ''rbactest.package''),
            rbactest.customer_ADMIN(NEW));
    
    return NEW;
end; ';


ALTER FUNCTION rbactest.package_grants_insert_to_customer_tf() OWNER TO admin;

--
-- Name: package_guest(rbactest.package, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_guest(entity rbactest.package, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.package'', entity.uuid, ''GUEST'', assumed);
        end; ';


ALTER FUNCTION rbactest.package_guest(entity rbactest.package, assumed boolean) OWNER TO admin;

--
-- Name: package_id_name_by_uuid(uuid); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_id_name_by_uuid(givenuuid uuid) RETURNS character varying
    LANGUAGE sql STRICT
    AS '
        select idName from rbactest.package_iv iv where iv.uuid = givenUuid;
        ';


ALTER FUNCTION rbactest.package_id_name_by_uuid(givenuuid uuid) OWNER TO admin;

--
-- Name: package_insert_permission_check_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_insert_permission_check_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
declare
    superObjectUuid uuid;
begin
    
    if rbac.hasInsertPermission(NEW.customerUuid, ''rbactest.package'') then
        return NEW;
    end if;

    raise exception ''[403] insert into rbactest.package values(%) not allowed for current subjects % (%)'',
            NEW, base.currentSubjects(), rbac.currentSubjectOrAssumedRolesUuids();
end; ';


ALTER FUNCTION rbactest.package_insert_permission_check_tf() OWNER TO admin;

--
-- Name: package_instead_of_delete_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_instead_of_delete_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
        begin
            if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''DELETE'', ''rbactest.package'', rbac.currentSubjectOrAssumedRolesUuids())) then
                delete from rbactest.package p where p.uuid = old.uuid;
                return old;
            end if;
            raise exception ''[403] Subject % is not allowed to delete rbactest.package uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
        end; ';


ALTER FUNCTION rbactest.package_instead_of_delete_tf() OWNER TO admin;

--
-- Name: package_instead_of_insert_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_instead_of_insert_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
    declare
        newTargetRow rbactest.package;
    begin
        insert
            into rbactest.package (uuid, version, customeruuid, name, description)
            values (new.uuid, new.version, new.customeruuid, new.name, new.description)
            returning * into newTargetRow;
        return newTargetRow;
    end; ';


ALTER FUNCTION rbactest.package_instead_of_insert_tf() OWNER TO admin;

--
-- Name: package_instead_of_update_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_instead_of_update_tf() RETURNS trigger
    LANGUAGE plpgsql
    AS '
            begin
                if old.uuid in (select rbac.queryAccessibleObjectUuidsOfSubjectIds(''UPDATE'', ''rbactest.package'', rbac.currentSubjectOrAssumedRolesUuids())) then
                    update rbactest.package
                        set 
        version = new.version,
        customerUuid = new.customerUuid,
        description = new.description
    
                        where uuid = old.uuid;
                    return old;
                end if;
                raise exception ''[403] Subject % is not allowed to update rbactest.package uuid %'', rbac.currentSubjectOrAssumedRolesUuids(), old.uuid;
            end; ';


ALTER FUNCTION rbactest.package_instead_of_update_tf() OWNER TO admin;

--
-- Name: package_owner(rbactest.package, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_owner(entity rbactest.package, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.package'', entity.uuid, ''OWNER'', assumed);
        end; ';


ALTER FUNCTION rbactest.package_owner(entity rbactest.package, assumed boolean) OWNER TO admin;

--
-- Name: package_rebuild_rbac_system(); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.package_rebuild_rbac_system()
    LANGUAGE plpgsql
    AS '
DECLARE
    DECLARE
    row rbactest.package;
    grantsAfter numeric;
    grantsBefore numeric;
BEGIN
    SELECT count(*) INTO grantsBefore FROM rbac.grant;

    FOR row IN SELECT * FROM rbactest.package LOOP
            
            DELETE FROM rbac.grant g
                   WHERE g.grantedbytriggerof = row.uuid;

            
            CALL rbactest.package_build_rbac_system(row);
        END LOOP;

    select count(*) into grantsAfter from rbac.grant;

    
    raise notice ''total grant count before -> after: % -> %'', grantsBefore, grantsAfter;
END;
';


ALTER PROCEDURE rbactest.package_rebuild_rbac_system() OWNER TO admin;

--
-- Name: package_referrer(rbactest.package); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_referrer(entity rbactest.package) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.package'', entity.uuid, ''REFERRER'');
        end; ';


ALTER FUNCTION rbactest.package_referrer(entity rbactest.package) OWNER TO admin;

--
-- Name: package_tenant(rbactest.package, boolean); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_tenant(entity rbactest.package, assumed boolean DEFAULT true) RETURNS rbac.roledescriptor
    LANGUAGE plpgsql STRICT
    AS '
        begin
            return rbac.roleDescriptorOf(''rbactest.package'', entity.uuid, ''TENANT'', assumed);
        end; ';


ALTER FUNCTION rbactest.package_tenant(entity rbactest.package, assumed boolean) OWNER TO admin;

--
-- Name: package_update_rbac_system(rbactest.package, rbactest.package); Type: PROCEDURE; Schema: rbactest; Owner: test
--

CREATE PROCEDURE rbactest.package_update_rbac_system(IN old rbactest.package, IN new rbactest.package)
    LANGUAGE plpgsql
    AS '

declare
    oldCustomer rbactest.customer;
    newCustomer rbactest.customer;

begin
    call rbac.enterTriggerForObjectUuid(NEW.uuid);

    SELECT * FROM rbactest.customer WHERE uuid = OLD.customerUuid    INTO oldCustomer;
    assert oldCustomer.uuid is not null, format(''oldCustomer must not be null for OLD.customerUuid = %s of rbactest.package'', OLD.customerUuid);

    SELECT * FROM rbactest.customer WHERE uuid = NEW.customerUuid    INTO newCustomer;
    assert newCustomer.uuid is not null, format(''newCustomer must not be null for NEW.customerUuid = %s of rbactest.package'', NEW.customerUuid);


    if NEW.customerUuid <> OLD.customerUuid then

        call rbac.revokeRoleFromRole(rbactest.package_OWNER(OLD), rbactest.customer_ADMIN(oldCustomer));
        call rbac.grantRoleToRole(rbactest.package_OWNER(NEW), rbactest.customer_ADMIN(newCustomer));

        call rbac.revokeRoleFromRole(rbactest.customer_TENANT(oldCustomer), rbactest.package_TENANT(OLD));
        call rbac.grantRoleToRole(rbactest.customer_TENANT(newCustomer), rbactest.package_TENANT(NEW));

    end if;

    call rbac.leaveTriggerForObjectUuid(NEW.uuid);
end; ';


ALTER PROCEDURE rbactest.package_update_rbac_system(IN old rbactest.package, IN new rbactest.package) OWNER TO admin;

--
-- Name: package_update_rbac_system_after_update_tf(); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_update_rbac_system_after_update_tf() RETURNS trigger
    LANGUAGE plpgsql STRICT
    AS '
begin
    call rbactest.package_update_rbac_system(OLD, NEW);
    return NEW;
end; ';


ALTER FUNCTION rbactest.package_update_rbac_system_after_update_tf() OWNER TO admin;

--
-- Name: package_uuid_by_id_name(character varying); Type: FUNCTION; Schema: rbactest; Owner: test
--

CREATE FUNCTION rbactest.package_uuid_by_id_name(givenidname character varying) RETURNS uuid
    LANGUAGE plpgsql
    AS '
        declare
            singleMatch uuid;
        begin
            select uuid into strict singleMatch from rbactest.package_iv iv where iv.idName = givenIdName;
            return singleMatch;
        end; ';


ALTER FUNCTION rbactest.package_uuid_by_id_name(givenidname character varying) OWNER TO admin;

--
-- Name: tx_context; Type: TABLE; Schema: base; Owner: test
--

CREATE TABLE base.tx_context (
    txid xid8 NOT NULL,
    txtimestamp timestamp without time zone NOT NULL,
    currentsubject character varying(63) NOT NULL,
    assumedroles character varying(1023) NOT NULL,
    currenttask character varying(127) NOT NULL,
    currentrequest text NOT NULL
);


ALTER TABLE base.tx_context OWNER TO admin;

--
-- Name: tx_journal; Type: TABLE; Schema: base; Owner: test
--

CREATE TABLE base.tx_journal (
    txid xid8 NOT NULL,
    targettable text NOT NULL,
    targetuuid uuid NOT NULL,
    targetop base.tx_operation NOT NULL,
    targetdelta jsonb
);


ALTER TABLE base.tx_journal OWNER TO admin;

--
-- Name: tx_journal_v; Type: VIEW; Schema: base; Owner: test
--

CREATE VIEW base.tx_journal_v AS
 SELECT txc.txid,
    txc.txtimestamp,
    txc.currentsubject,
    txc.assumedroles,
    txc.currenttask,
    txc.currentrequest,
    txj.targettable,
    txj.targetop,
    txj.targetuuid,
    txj.targetdelta
   FROM (base.tx_journal txj
     LEFT JOIN base.tx_context txc USING (txid))
  ORDER BY txc.txtimestamp;


ALTER VIEW base.tx_journal_v OWNER TO admin;

--
-- Name: partner_legacy_id; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.partner_legacy_id (
    uuid uuid NOT NULL,
    bp_id integer NOT NULL
);


ALTER TABLE hs_office.partner_legacy_id OWNER TO admin;

--
-- Name: contact; Type: VIEW; Schema: hs_integration; Owner: test
--

CREATE VIEW hs_integration.contact AS
 SELECT DISTINCT ON (c.uuid) partner.partnernumber,
    debitor.defaultprefix,
    partner.uuid AS partner_uuid,
    c.uuid AS contact_uuid,
        CASE
            WHEN ((per.salutation)::text <> ''::text) THEN per.salutation
            ELSE NULL::character varying
        END AS salutation,
        CASE
            WHEN ((per.givenname)::text <> ''::text) THEN per.givenname
            ELSE NULL::character varying
        END AS givenname,
        CASE
            WHEN ((per.familyname)::text <> ''::text) THEN per.familyname
            ELSE NULL::character varying
        END AS familyname,
        CASE
            WHEN ((per.title)::text <> ''::text) THEN per.title
            ELSE NULL::character varying
        END AS title,
        CASE
            WHEN ((per.tradename)::text <> ''::text) THEN per.tradename
            ELSE NULL::character varying
        END AS tradename,
        CASE
            WHEN ((c.postaladdress ->> 'co'::text) <> ''::text) THEN (c.postaladdress ->> 'co'::text)
            ELSE NULL::text
        END AS co,
    (c.postaladdress ->> 'street'::text) AS street,
    (c.postaladdress ->> 'zipcode'::text) AS zipcode,
    (c.postaladdress ->> 'city'::text) AS city,
    (c.postaladdress ->> 'country'::text) AS country,
    (c.phonenumbers ->> 'phone_private'::text) AS phone_private,
    (c.phonenumbers ->> 'phone_office'::text) AS phone_office,
    (c.phonenumbers ->> 'phone_mobile'::text) AS phone_mobile,
    (c.phonenumbers ->> 'fax'::text) AS fax,
    (c.emailaddresses ->> 'main'::text) AS email
   FROM ((((((hs_office.partner partner
     JOIN hs_office.partner_legacy_id partner_lid ON ((partner_lid.uuid = partner.uuid)))
     JOIN hs_office.relation prel ON (((prel.type = 'PARTNER'::hs_office.relationtype) AND (prel.uuid = partner.partnerreluuid))))
     JOIN hs_office.relation drel ON (((drel.type = 'DEBITOR'::hs_office.relationtype) AND (drel.anchoruuid = prel.holderuuid))))
     JOIN hs_office.debitor debitor ON (((debitor.debitorreluuid = drel.uuid) AND (debitor.debitornumbersuffix = '00'::bpchar))))
     JOIN hs_office.contact c ON ((c.uuid = prel.contactuuid)))
     JOIN hs_office.person per ON ((per.uuid = prel.holderuuid)))
UNION
 SELECT DISTINCT ON (c.uuid) partner.partnernumber,
    debitor.defaultprefix,
    partner.uuid AS partner_uuid,
    c.uuid AS contact_uuid,
        CASE
            WHEN ((per.salutation)::text <> ''::text) THEN per.salutation
            ELSE NULL::character varying
        END AS salutation,
        CASE
            WHEN ((per.givenname)::text <> ''::text) THEN per.givenname
            ELSE NULL::character varying
        END AS givenname,
        CASE
            WHEN ((per.familyname)::text <> ''::text) THEN per.familyname
            ELSE NULL::character varying
        END AS familyname,
        CASE
            WHEN ((per.title)::text <> ''::text) THEN per.title
            ELSE NULL::character varying
        END AS title,
        CASE
            WHEN ((per.tradename)::text <> ''::text) THEN per.tradename
            ELSE NULL::character varying
        END AS tradename,
        CASE
            WHEN ((c.postaladdress ->> 'co'::text) <> ''::text) THEN (c.postaladdress ->> 'co'::text)
            ELSE NULL::text
        END AS co,
    (c.postaladdress ->> 'street'::text) AS street,
    (c.postaladdress ->> 'zipcode'::text) AS zipcode,
    (c.postaladdress ->> 'city'::text) AS city,
    (c.postaladdress ->> 'country'::text) AS country,
    (c.phonenumbers ->> 'phone_private'::text) AS phone_private,
    (c.phonenumbers ->> 'phone_office'::text) AS phone_office,
    (c.phonenumbers ->> 'phone_mobile'::text) AS phone_mobile,
    (c.phonenumbers ->> 'fax'::text) AS fax,
    (c.emailaddresses ->> 'main'::text) AS email
   FROM (((((((hs_office.partner partner
     JOIN hs_office.relation prel ON (((prel.type = 'PARTNER'::hs_office.relationtype) AND (prel.uuid = partner.partnerreluuid))))
     JOIN hs_office.relation drel ON (((drel.type = 'DEBITOR'::hs_office.relationtype) AND (drel.anchoruuid = prel.holderuuid))))
     JOIN hs_office.debitor debitor ON (((debitor.debitorreluuid = drel.uuid) AND (debitor.debitornumbersuffix = '00'::bpchar))))
     JOIN hs_office.relation rs1 ON (((rs1.uuid = partner.partnerreluuid) AND (rs1.type = 'PARTNER'::hs_office.relationtype))))
     JOIN hs_office.relation relation ON ((relation.anchoruuid = rs1.holderuuid)))
     JOIN hs_office.contact c ON ((c.uuid = relation.contactuuid)))
     JOIN hs_office.person per ON ((per.uuid = relation.holderuuid)));


ALTER VIEW hs_integration.contact OWNER TO admin;

--
-- Name: subscription; Type: VIEW; Schema: hs_integration; Owner: test
--

CREATE VIEW hs_integration.subscription AS
 SELECT DISTINCT relation.mark AS subscription,
    (contact.emailaddresses ->> 'main'::text) AS email
   FROM (hs_office.contact contact
     JOIN hs_office.relation relation ON (((relation.contactuuid = contact.uuid) AND (relation.type = 'SUBSCRIBER'::hs_office.relationtype))))
  ORDER BY relation.mark, (contact.emailaddresses ->> 'main'::text);


ALTER VIEW hs_integration.subscription OWNER TO admin;

--
-- Name: ticket_customer_company; Type: VIEW; Schema: hs_integration; Owner: test
--

CREATE VIEW hs_integration.ticket_customer_company AS
 SELECT (partner.partnernumber)::text AS number,
    debitor.defaultprefix AS code,
    concat_ws('/'::text, to_char((lower(membership.validity))::timestamp with time zone, 'YYYY-MM-DD'::text), to_char((upper(membership.validity) - '1 day'::interval), 'YYYY-MM-DD'::text)) AS comment,
    1 AS valid
   FROM ((((hs_office.partner partner
     JOIN hs_office.relation prel ON (((prel.type = 'PARTNER'::hs_office.relationtype) AND (prel.uuid = partner.partnerreluuid))))
     JOIN hs_office.relation drel ON (((drel.type = 'DEBITOR'::hs_office.relationtype) AND (drel.anchoruuid = prel.holderuuid))))
     JOIN hs_office.debitor debitor ON (((debitor.debitorreluuid = drel.uuid) AND (debitor.debitornumbersuffix = '00'::bpchar))))
     LEFT JOIN hs_office.membership membership ON ((membership.partneruuid = partner.uuid)))
  ORDER BY (partner.partnernumber)::text;


ALTER VIEW hs_integration.ticket_customer_company OWNER TO admin;

--
-- Name: ticket_customer_user; Type: VIEW; Schema: hs_integration; Owner: test
--

CREATE VIEW hs_integration.ticket_customer_user AS
 SELECT c.contact_uuid,
    (max(c.partnernumber))::text AS number,
    max(c.defaultprefix) AS code,
    max(c.email) AS login,
    max((c.salutation)::text) AS salut,
    max((c.givenname)::text) AS firstname,
    max((c.familyname)::text) AS lastname,
    max((c.title)::text) AS title,
    max((c.tradename)::text) AS firma,
    max(c.co) AS co,
    max(c.street) AS street,
    max(c.zipcode) AS zipcode,
    max(c.city) AS city,
    max(c.country) AS country,
    max(concat_ws(', '::text, c.phone_office, c.phone_private)) AS phone,
    max(c.phone_private) AS phone_private,
    max(c.phone_office) AS phone_office,
    max(c.phone_mobile) AS mobile,
    max(c.fax) AS fax,
    max(c.email) AS email,
    string_agg(
        CASE
            WHEN (relation.mark IS NULL) THEN (relation.type)::text
            ELSE concat((relation.type)::text, ':', (relation.mark)::text)
        END, '/'::text) AS comment,
    1 AS valid
   FROM (hs_integration.contact c
     JOIN hs_office.relation relation ON ((c.contact_uuid = relation.contactuuid)))
  WHERE ((c.defaultprefix <> 'hsh'::bpchar) OR ((c.partnernumber = (10000)::numeric) AND (c.email = 'hostmaster@hostsharing.net'::text)))
  GROUP BY c.contact_uuid;


ALTER VIEW hs_integration.ticket_customer_user OWNER TO admin;

--
-- Name: time_customer; Type: VIEW; Schema: hs_integration; Owner: test
--

CREATE VIEW hs_integration.time_customer AS
 SELECT p.partnernumber,
    debitor.defaultprefix
   FROM (((hs_office.partner p
     JOIN hs_office.relation prel ON (((prel.type = 'PARTNER'::hs_office.relationtype) AND (prel.uuid = p.partnerreluuid))))
     JOIN hs_office.relation drel ON (((drel.type = 'DEBITOR'::hs_office.relationtype) AND (drel.anchoruuid = prel.holderuuid))))
     JOIN hs_office.debitor debitor ON (((debitor.debitorreluuid = drel.uuid) AND (debitor.debitornumbersuffix = '00'::bpchar))));


ALTER VIEW hs_integration.time_customer OWNER TO admin;

--
-- Name: bankaccount_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.bankaccount_iv AS
 SELECT target.uuid,
    base.cleanidentifier(target.iban) AS idname
   FROM hs_office.bankaccount target;


ALTER VIEW hs_office.bankaccount_iv OWNER TO admin;

--
-- Name: grant; Type: TABLE; Schema: rbac; Owner: test
--

CREATE TABLE rbac."grant" (
    uuid uuid DEFAULT public.uuid_generate_v4() NOT NULL,
    grantedbytriggerof uuid,
    grantedbyroleuuid uuid,
    ascendantuuid uuid,
    descendantuuid uuid,
    assumed boolean DEFAULT true NOT NULL,
    CONSTRAINT rbacgrant_createdby CHECK (((grantedbyroleuuid IS NULL) OR (grantedbytriggerof IS NULL)))
);


ALTER TABLE rbac."grant" OWNER TO admin;

--
-- Name: object; Type: TABLE; Schema: rbac; Owner: test
--

CREATE TABLE rbac.object (
    uuid uuid DEFAULT public.uuid_generate_v4() NOT NULL,
    serialid integer NOT NULL,
    objecttable character varying(64) NOT NULL
);


ALTER TABLE rbac.object OWNER TO admin;

--
-- Name: bankaccount_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.bankaccount_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.bankaccount'::text)
        )
 SELECT target.uuid,
    target.version,
    target.holder,
    target.iban,
    target.bic
   FROM hs_office.bankaccount target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.iban;


ALTER VIEW hs_office.bankaccount_rv OWNER TO admin;

--
-- Name: contact_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.contact_iv AS
 SELECT target.uuid,
    base.cleanidentifier(target.caption) AS idname
   FROM hs_office.contact target;


ALTER VIEW hs_office.contact_iv OWNER TO admin;

--
-- Name: contact_legacy_id; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.contact_legacy_id (
    uuid uuid NOT NULL,
    contact_id integer NOT NULL
);


ALTER TABLE hs_office.contact_legacy_id OWNER TO admin;

--
-- Name: contact_legacy_id_seq; Type: SEQUENCE; Schema: hs_office; Owner: test
--

CREATE SEQUENCE hs_office.contact_legacy_id_seq
    AS integer
    START WITH 1000000000
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE hs_office.contact_legacy_id_seq OWNER TO admin;

--
-- Name: contact_legacy_id_seq; Type: SEQUENCE OWNED BY; Schema: hs_office; Owner: test
--

ALTER SEQUENCE hs_office.contact_legacy_id_seq OWNED BY hs_office.contact_legacy_id.contact_id;


--
-- Name: contact_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.contact_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.contact'::text)
        )
 SELECT target.uuid,
    target.version,
    target.caption,
    target.postaladdress,
    target.emailaddresses,
    target.phonenumbers
   FROM hs_office.contact target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.caption;


ALTER VIEW hs_office.contact_rv OWNER TO admin;

--
-- Name: coopassettx_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.coopassettx_iv AS
 SELECT target.uuid,
    base.cleanidentifier(target.reference) AS idname
   FROM hs_office.coopassettx target;


ALTER VIEW hs_office.coopassettx_iv OWNER TO admin;

--
-- Name: coopassettx_legacy_id; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.coopassettx_legacy_id (
    uuid uuid NOT NULL,
    member_asset_id integer NOT NULL
);


ALTER TABLE hs_office.coopassettx_legacy_id OWNER TO admin;

--
-- Name: coopassettx_legacy_id_seq; Type: SEQUENCE; Schema: hs_office; Owner: test
--

CREATE SEQUENCE hs_office.coopassettx_legacy_id_seq
    AS integer
    START WITH 1000000000
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE hs_office.coopassettx_legacy_id_seq OWNER TO admin;

--
-- Name: coopassettx_legacy_id_seq; Type: SEQUENCE OWNED BY; Schema: hs_office; Owner: test
--

ALTER SEQUENCE hs_office.coopassettx_legacy_id_seq OWNED BY hs_office.coopassettx_legacy_id.member_asset_id;


--
-- Name: coopassettx_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.coopassettx_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.coopassettx'::text)
        )
 SELECT target.uuid,
    target.version,
    target.membershipuuid,
    target.transactiontype,
    target.valuedate,
    target.assetvalue,
    target.reference,
    target.revertedassettxuuid,
    target.assetadoptiontxuuid,
    target.comment
   FROM hs_office.coopassettx target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.reference;


ALTER VIEW hs_office.coopassettx_rv OWNER TO admin;

--
-- Name: coopsharetx_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.coopsharetx_iv AS
 SELECT target.uuid,
    base.cleanidentifier(target.reference) AS idname
   FROM hs_office.coopsharetx target;


ALTER VIEW hs_office.coopsharetx_iv OWNER TO admin;

--
-- Name: coopsharetx_legacy_id; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.coopsharetx_legacy_id (
    uuid uuid NOT NULL,
    member_share_id integer NOT NULL
);


ALTER TABLE hs_office.coopsharetx_legacy_id OWNER TO admin;

--
-- Name: coopsharetx_legacy_id_seq; Type: SEQUENCE; Schema: hs_office; Owner: test
--

CREATE SEQUENCE hs_office.coopsharetx_legacy_id_seq
    AS integer
    START WITH 1000000000
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE hs_office.coopsharetx_legacy_id_seq OWNER TO admin;

--
-- Name: coopsharetx_legacy_id_seq; Type: SEQUENCE OWNED BY; Schema: hs_office; Owner: test
--

ALTER SEQUENCE hs_office.coopsharetx_legacy_id_seq OWNED BY hs_office.coopsharetx_legacy_id.member_share_id;


--
-- Name: coopsharetx_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.coopsharetx_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.coopsharetx'::text)
        )
 SELECT target.uuid,
    target.version,
    target.membershipuuid,
    target.transactiontype,
    target.valuedate,
    target.sharecount,
    target.reference,
    target.revertedsharetxuuid,
    target.comment
   FROM hs_office.coopsharetx target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.reference;


ALTER VIEW hs_office.coopsharetx_rv OWNER TO admin;

--
-- Name: debitor_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.debitor_iv AS
 SELECT debitor.uuid,
    (('D-'::text || ( SELECT partner.partnernumber
           FROM ((hs_office.partner partner
             JOIN hs_office.relation partnerrel ON (((partnerrel.uuid = partner.partnerreluuid) AND (partnerrel.type = 'PARTNER'::hs_office.relationtype))))
             JOIN hs_office.relation debitorrel ON (((debitorrel.anchoruuid = partnerrel.holderuuid) AND (debitorrel.type = 'DEBITOR'::hs_office.relationtype))))
          WHERE (debitorrel.uuid = debitor.debitorreluuid))) || (debitor.debitornumbersuffix)::text) AS idname
   FROM hs_office.debitor debitor;


ALTER VIEW hs_office.debitor_iv OWNER TO admin;

--
-- Name: debitor_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.debitor_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.debitor'::text)
        )
 SELECT target.uuid,
    target.version,
    target.debitornumbersuffix,
    target.debitorreluuid,
    target.billable,
    target.vatid,
    target.vatcountrycode,
    target.vatbusiness,
    target.vatreversecharge,
    target.refundbankaccountuuid,
    target.defaultprefix
   FROM hs_office.debitor target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.defaultprefix;


ALTER VIEW hs_office.debitor_rv OWNER TO admin;

--
-- Name: membership_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.membership_iv AS
 SELECT m.uuid,
    (('M-'::text || p.partnernumber) || (m.membernumbersuffix)::text) AS idname
   FROM (hs_office.membership m
     JOIN hs_office.partner p ON ((p.uuid = m.partneruuid)));


ALTER VIEW hs_office.membership_iv OWNER TO admin;

--
-- Name: membership_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.membership_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.membership'::text)
        )
 SELECT target.uuid,
    target.version,
    target.partneruuid,
    target.membernumbersuffix,
    target.validity,
    target.status,
    target.membershipfeebillable
   FROM hs_office.membership target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.validity;


ALTER VIEW hs_office.membership_rv OWNER TO admin;

--
-- Name: partner_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.partner_iv AS
 SELECT target.uuid,
    base.cleanidentifier((('P-'::text || target.partnernumber))::character varying) AS idname
   FROM hs_office.partner target;


ALTER VIEW hs_office.partner_iv OWNER TO admin;

--
-- Name: partner_details_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.partner_details_iv AS
 SELECT partnerdetails.uuid,
    partner_iv.idname
   FROM ((hs_office.partner_details partnerdetails
     JOIN hs_office.partner partner ON ((partner.detailsuuid = partnerdetails.uuid)))
     JOIN hs_office.partner_iv partner_iv ON ((partner_iv.uuid = partner.uuid)));


ALTER VIEW hs_office.partner_details_iv OWNER TO admin;

--
-- Name: partner_details_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.partner_details_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.partner_details'::text)
        )
 SELECT target.uuid,
    target.version,
    target.registrationoffice,
    target.registrationnumber,
    target.birthplace,
    target.birthname,
    target.birthday,
    target.dateofdeath
   FROM hs_office.partner_details target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.uuid;


ALTER VIEW hs_office.partner_details_rv OWNER TO admin;

--
-- Name: partner_legacy_id_seq; Type: SEQUENCE; Schema: hs_office; Owner: test
--

CREATE SEQUENCE hs_office.partner_legacy_id_seq
    AS integer
    START WITH 1000000000
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE hs_office.partner_legacy_id_seq OWNER TO admin;

--
-- Name: partner_legacy_id_seq; Type: SEQUENCE OWNED BY; Schema: hs_office; Owner: test
--

ALTER SEQUENCE hs_office.partner_legacy_id_seq OWNED BY hs_office.partner_legacy_id.bp_id;


--
-- Name: partner_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.partner_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.partner'::text)
        )
 SELECT target.uuid,
    target.version,
    target.partnernumber,
    target.partnerreluuid,
    target.detailsuuid
   FROM hs_office.partner target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY ('P-'::text || target.partnernumber);


ALTER VIEW hs_office.partner_rv OWNER TO admin;

--
-- Name: person_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.person_iv AS
 SELECT target.uuid,
    base.cleanidentifier((concat(target.tradename, target.familyname, target.givenname))::character varying) AS idname
   FROM hs_office.person target;


ALTER VIEW hs_office.person_iv OWNER TO admin;

--
-- Name: person_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.person_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.person'::text)
        )
 SELECT target.uuid,
    target.version,
    target.persontype,
    target.tradename,
    target.salutation,
    target.title,
    target.givenname,
    target.familyname
   FROM hs_office.person target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY (concat(target.tradename, target.familyname, target.givenname));


ALTER VIEW hs_office.person_rv OWNER TO admin;

--
-- Name: relation_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.relation_iv AS
 SELECT target.uuid,
    base.cleanidentifier(((((((( SELECT p.idname
           FROM hs_office.person_iv p
          WHERE (p.uuid = target.anchoruuid)))::text || '-with-'::text) || target.type) || '-'::text) || (( SELECT p.idname
           FROM hs_office.person_iv p
          WHERE (p.uuid = target.holderuuid)))::text))::character varying) AS idname
   FROM hs_office.relation target;


ALTER VIEW hs_office.relation_iv OWNER TO admin;

--
-- Name: relation_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.relation_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.relation'::text)
        )
 SELECT target.uuid,
    target.version,
    target.anchoruuid,
    target.holderuuid,
    target.contactuuid,
    target.type,
    target.mark
   FROM hs_office.relation target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY ( SELECT p.idname
           FROM hs_office.person_iv p
          WHERE (p.uuid = target.holderuuid));


ALTER VIEW hs_office.relation_rv OWNER TO admin;

--
-- Name: sepamandate_iv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.sepamandate_iv AS
 SELECT sm.uuid,
    (((ba.iban)::text || '-'::text) || sm.validity) AS idname
   FROM (hs_office.sepamandate sm
     JOIN hs_office.bankaccount ba ON ((ba.uuid = sm.bankaccountuuid)));


ALTER VIEW hs_office.sepamandate_iv OWNER TO admin;

--
-- Name: sepamandate_legacy_id; Type: TABLE; Schema: hs_office; Owner: test
--

CREATE TABLE hs_office.sepamandate_legacy_id (
    uuid uuid NOT NULL,
    sepa_mandate_id integer NOT NULL
);


ALTER TABLE hs_office.sepamandate_legacy_id OWNER TO admin;

--
-- Name: sepamandate_legacy_id_seq; Type: SEQUENCE; Schema: hs_office; Owner: test
--

CREATE SEQUENCE hs_office.sepamandate_legacy_id_seq
    AS integer
    START WITH 1000000000
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE hs_office.sepamandate_legacy_id_seq OWNER TO admin;

--
-- Name: sepamandate_legacy_id_seq; Type: SEQUENCE OWNED BY; Schema: hs_office; Owner: test
--

ALTER SEQUENCE hs_office.sepamandate_legacy_id_seq OWNED BY hs_office.sepamandate_legacy_id.sepa_mandate_id;


--
-- Name: sepamandate_rv; Type: VIEW; Schema: hs_office; Owner: test
--

CREATE VIEW hs_office.sepamandate_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'hs_office.sepamandate'::text)
        )
 SELECT target.uuid,
    target.version,
    target.debitoruuid,
    target.bankaccountuuid,
    target.reference,
    target.agreement,
    target.validity
   FROM hs_office.sepamandate target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.validity;


ALTER VIEW hs_office.sepamandate_rv OWNER TO admin;

--
-- Name: databasechangelog; Type: TABLE; Schema: public; Owner: test
--

CREATE TABLE public.databasechangelog (
    id character varying(255) NOT NULL,
    author character varying(255) NOT NULL,
    filename character varying(255) NOT NULL,
    dateexecuted timestamp without time zone NOT NULL,
    orderexecuted integer NOT NULL,
    exectype character varying(10) NOT NULL,
    md5sum character varying(35),
    description character varying(255),
    comments character varying(255),
    tag character varying(255),
    liquibase character varying(20),
    contexts character varying(255),
    labels character varying(255),
    deployment_id character varying(10)
);


ALTER TABLE public.databasechangelog OWNER TO admin;

--
-- Name: databasechangeloglock; Type: TABLE; Schema: public; Owner: test
--

CREATE TABLE public.databasechangeloglock (
    id integer NOT NULL,
    locked boolean NOT NULL,
    lockgranted timestamp without time zone,
    lockedby character varying(255)
);


ALTER TABLE public.databasechangeloglock OWNER TO admin;

--
-- Name: global; Type: TABLE; Schema: rbac; Owner: test
--

CREATE TABLE rbac.global (
    uuid uuid NOT NULL,
    name character varying(63)
);


ALTER TABLE rbac.global OWNER TO admin;

--
-- Name: global_iv; Type: VIEW; Schema: rbac; Owner: test
--

CREATE VIEW rbac.global_iv AS
 SELECT target.uuid,
    target.name AS idname
   FROM rbac.global target;


ALTER VIEW rbac.global_iv OWNER TO admin;

--
-- Name: role; Type: TABLE; Schema: rbac; Owner: test
--

CREATE TABLE rbac.role (
    uuid uuid NOT NULL,
    objectuuid uuid NOT NULL,
    roletype rbac.roletype NOT NULL
);


ALTER TABLE rbac.role OWNER TO admin;

--
-- Name: grant_ev; Type: VIEW; Schema: rbac; Owner: test
--

CREATE VIEW rbac.grant_ev AS
 SELECT x.grantuuid AS uuid,
    x.grantedbytriggerof,
    (((((go.objecttable)::text || '#'::text) || (rbac.findidnamebyobjectuuid(go.objecttable, go.uuid))::text) || ':'::text) || r.roletype) AS grantedbyroleidname,
    x.ascendingidname AS ascendantidname,
    x.descendingidname AS descendantidname,
    x.grantedbyroleuuid,
    x.ascendantuuid,
    x.descendantuuid,
    x.op AS permop,
    x.optablename AS permoptablename,
    x.assumed
   FROM (((( SELECT g.uuid AS grantuuid,
            g.grantedbytriggerof,
            g.grantedbyroleuuid,
            g.ascendantuuid,
            g.descendantuuid,
            g.assumed,
            COALESCE(('user:'::text || (au.name)::text), ((((('role:'::text || (aro.objecttable)::text) || '#'::text) || (rbac.findidnamebyobjectuuid(aro.objecttable, aro.uuid))::text) || ':'::text) || ar.roletype)) AS ascendingidname,
            aro.objecttable,
            aro.uuid,
                CASE
                    WHEN (dro.* IS NOT NULL) THEN ((((('role:'::text || (dro.objecttable)::text) || '#'::text) || (rbac.findidnamebyobjectuuid(dro.objecttable, dro.uuid))::text) || ':'::text) || dr.roletype)
                    WHEN ((dp.op)::text = 'INSERT'::text) THEN ((((((('perm:'::text || (dpo.objecttable)::text) || '#'::text) || (rbac.findidnamebyobjectuuid(dpo.objecttable, dpo.uuid))::text) || ':'::text) || (dp.op)::text) || '>'::text) || (dp.optablename)::text)
                    ELSE ((((('perm:'::text || (dpo.objecttable)::text) || '#'::text) || (rbac.findidnamebyobjectuuid(dpo.objecttable, dpo.uuid))::text) || ':'::text) || (dp.op)::text)
                END AS descendingidname,
            dro.objecttable,
            dro.uuid,
            dp.op,
            dp.optablename
           FROM (((((((rbac."grant" g
             LEFT JOIN rbac.role ar ON ((ar.uuid = g.ascendantuuid)))
             LEFT JOIN rbac.object aro ON ((aro.uuid = ar.objectuuid)))
             LEFT JOIN rbac.subject au ON ((au.uuid = g.ascendantuuid)))
             LEFT JOIN rbac.role dr ON ((dr.uuid = g.descendantuuid)))
             LEFT JOIN rbac.object dro ON ((dro.uuid = dr.objectuuid)))
             LEFT JOIN rbac.permission dp ON ((dp.uuid = g.descendantuuid)))
             LEFT JOIN rbac.object dpo ON ((dpo.uuid = dp.objectuuid)))) x(grantuuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed, ascendingidname, objecttable, uuid, descendingidname, objecttable_1, uuid_1, op, optablename)
     LEFT JOIN rbac.role r ON ((r.uuid = x.grantedbyroleuuid)))
     LEFT JOIN rbac.subject u ON ((u.uuid = x.ascendantuuid)))
     LEFT JOIN rbac.object go ON ((go.uuid = r.objectuuid)))
  ORDER BY x.ascendingidname, x.descendingidname;


ALTER VIEW rbac.grant_ev OWNER TO admin;

--
-- Name: grant_rv; Type: VIEW; Schema: rbac; Owner: test
--

CREATE VIEW rbac.grant_rv AS
 SELECT (((((o.objecttable)::text || '#'::text) || (rbac.findidnamebyobjectuuid(o.objecttable, o.uuid))::text) || ':'::text) || r.roletype) AS grantedbyroleidname,
    (((((g.objecttable)::text || '#'::text) || (g.objectidname)::text) || ':'::text) || g.roletype) AS grantedroleidname,
    g.username,
    g.assumed,
    g.grantedbyroleuuid,
    g.descendantuuid AS grantedroleuuid,
    g.ascendantuuid AS subjectuuid,
    g.objecttable,
    g.objectuuid,
    g.objectidname,
    g.roletype AS grantedroletype
   FROM ((( SELECT g_1.grantedbyroleuuid,
            g_1.ascendantuuid,
            g_1.descendantuuid,
            g_1.assumed,
            u.name AS username,
            o_1.objecttable,
            r_1.objectuuid,
            r_1.roletype,
            rbac.findidnamebyobjectuuid(o_1.objecttable, o_1.uuid) AS objectidname
           FROM (((rbac."grant" g_1
             JOIN rbac.role r_1 ON ((r_1.uuid = g_1.descendantuuid)))
             JOIN rbac.object o_1 ON ((o_1.uuid = r_1.objectuuid)))
             LEFT JOIN rbac.subject u ON ((u.uuid = g_1.ascendantuuid)))
          WHERE rbac.isgranted(rbac.currentsubjectorassumedrolesuuids(), r_1.uuid)) g
     JOIN rbac.role r ON ((r.uuid = g.grantedbyroleuuid)))
     JOIN rbac.object o ON ((o.uuid = r.objectuuid)))
  ORDER BY (((((g.objecttable)::text || '#'::text) || (g.objectidname)::text) || ':'::text) || g.roletype);


ALTER VIEW rbac.grant_rv OWNER TO admin;

--
-- Name: object_serialid_seq; Type: SEQUENCE; Schema: rbac; Owner: test
--

CREATE SEQUENCE rbac.object_serialid_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE rbac.object_serialid_seq OWNER TO admin;

--
-- Name: object_serialid_seq; Type: SEQUENCE OWNED BY; Schema: rbac; Owner: test
--

ALTER SEQUENCE rbac.object_serialid_seq OWNED BY rbac.object.serialid;


--
-- Name: role_rv; Type: VIEW; Schema: rbac; Owner: test
--

CREATE VIEW rbac.role_rv AS
 SELECT unordered.uuid,
    unordered.objectuuid,
    unordered.roletype,
    unordered.objecttable,
    unordered.objectidname
   FROM ( SELECT r.uuid,
            r.objectuuid,
            r.roletype,
            o.objecttable,
            rbac.findidnamebyobjectuuid(o.objecttable, o.uuid) AS objectidname
           FROM (rbac.role r
             JOIN rbac.object o ON ((o.uuid = r.objectuuid)))
          WHERE rbac.isgranted(rbac.currentsubjectorassumedrolesuuids(), r.uuid)) unordered
  ORDER BY (((((unordered.objecttable)::text || '#'::text) || (unordered.objectidname)::text) || ':'::text) || unordered.roletype);


ALTER VIEW rbac.role_rv OWNER TO admin;

--
-- Name: own_granted_permissions_rv; Type: VIEW; Schema: rbac; Owner: test
--

CREATE VIEW rbac.own_granted_permissions_rv AS
 SELECT r.uuid AS roleuuid,
    p.uuid AS permissionuuid,
    (((((r.objecttable)::text || ':'::text) || (r.objectidname)::text) || ':'::text) || r.roletype) AS rolename,
    p.op,
    o.objecttable,
    r.objectidname,
    o.uuid AS objectuuid
   FROM (((rbac.role_rv r
     JOIN rbac."grant" g ON ((g.ascendantuuid = r.uuid)))
     JOIN rbac.permission p ON ((p.uuid = g.descendantuuid)))
     JOIN rbac.object o ON ((o.uuid = p.objectuuid)));


ALTER VIEW rbac.own_granted_permissions_rv OWNER TO admin;

--
-- Name: role_ev; Type: VIEW; Schema: rbac; Owner: test
--

CREATE VIEW rbac.role_ev AS
 SELECT (((((unordered.objecttable)::text || '#'::text) || (unordered.objectidname)::text) || ':'::text) || unordered.roletype) AS roleidname,
    unordered.uuid,
    unordered.objectuuid,
    unordered.roletype,
    unordered.objecttable,
    unordered.objectidname
   FROM ( SELECT r.uuid,
            r.objectuuid,
            r.roletype,
            o.objecttable,
            rbac.findidnamebyobjectuuid(o.objecttable, o.uuid) AS objectidname
           FROM (rbac.role r
             JOIN rbac.object o ON ((o.uuid = r.objectuuid)))) unordered
  ORDER BY (((((unordered.objecttable)::text || '#'::text) || (unordered.objectidname)::text) || ':'::text) || unordered.roletype);


ALTER VIEW rbac.role_ev OWNER TO admin;

--
-- Name: statistics_v; Type: VIEW; Schema: rbac; Owner: test
--

CREATE VIEW rbac.statistics_v AS
 SELECT totals.no,
    to_char(totals.count, '9 999 999 999'::text) AS count,
    totals."table"
   FROM ( SELECT 1 AS no,
            count(*) AS count,
            'login users'::text AS "table"
           FROM rbac.subject
        UNION
         SELECT 2 AS no,
            count(*) AS count,
            'roles'::text AS "table"
           FROM rbac.role
        UNION
         SELECT 3 AS no,
            count(*) AS count,
            'permissions'::text AS "table"
           FROM rbac.permission
        UNION
         SELECT 4 AS no,
            count(*) AS count,
            'references'::text AS "table"
           FROM rbac.reference
        UNION
         SELECT 5 AS no,
            count(*) AS count,
            'grants'::text AS "table"
           FROM rbac."grant"
        UNION
         SELECT 6 AS no,
            count(*) AS count,
            'objects'::text AS "table"
           FROM rbac.object) totals
  ORDER BY totals.no;


ALTER VIEW rbac.statistics_v OWNER TO admin;

--
-- Name: subject_ev; Type: VIEW; Schema: rbac; Owner: test
--

CREATE VIEW rbac.subject_ev AS
 SELECT DISTINCT unordered.uuid,
    unordered.name
   FROM ( SELECT usersinrolesofcurrentsubject.uuid,
            usersinrolesofcurrentsubject.name
           FROM ((rbac.subject usersinrolesofcurrentsubject
             JOIN rbac."grant" g ON ((g.ascendantuuid = usersinrolesofcurrentsubject.uuid)))
             JOIN rbac.role_ev r ON ((r.uuid = g.descendantuuid)))
        UNION
         SELECT users.uuid,
            users.name
           FROM rbac.subject users) unordered
  ORDER BY unordered.name;


ALTER VIEW rbac.subject_ev OWNER TO admin;

--
-- Name: subject_rv; Type: VIEW; Schema: rbac; Owner: test
--

CREATE VIEW rbac.subject_rv AS
 SELECT DISTINCT unordered.uuid,
    unordered.name
   FROM ( SELECT usersinrolesofcurrentsubject.uuid,
            usersinrolesofcurrentsubject.name
           FROM ((rbac.subject usersinrolesofcurrentsubject
             JOIN rbac."grant" g ON ((g.ascendantuuid = usersinrolesofcurrentsubject.uuid)))
             JOIN rbac.role_rv r ON ((r.uuid = g.descendantuuid)))
        UNION
         SELECT users.uuid,
            users.name
           FROM rbac.subject users
          WHERE ((cardinality(base.assumedroles()) = 0) AND ((rbac.currentsubjectuuid() = users.uuid) OR rbac.hasglobalrolegranted(rbac.currentsubjectuuid())))) unordered
  ORDER BY unordered.name;


ALTER VIEW rbac.subject_rv OWNER TO admin;

--
-- Name: customer_iv; Type: VIEW; Schema: rbactest; Owner: test
--

CREATE VIEW rbactest.customer_iv AS
 SELECT target.uuid,
    base.cleanidentifier((target.prefix)::character varying) AS idname
   FROM rbactest.customer target;


ALTER VIEW rbactest.customer_iv OWNER TO admin;

--
-- Name: customer_rv; Type: VIEW; Schema: rbactest; Owner: test
--

CREATE VIEW rbactest.customer_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'rbactest.customer'::text)
        )
 SELECT target.uuid,
    target.version,
    target.reference,
    target.prefix,
    target.adminusername
   FROM rbactest.customer target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.reference;


ALTER VIEW rbactest.customer_rv OWNER TO admin;

--
-- Name: domain_iv; Type: VIEW; Schema: rbactest; Owner: test
--

CREATE VIEW rbactest.domain_iv AS
 SELECT target.uuid,
    base.cleanidentifier(target.name) AS idname
   FROM rbactest.domain target;


ALTER VIEW rbactest.domain_iv OWNER TO admin;

--
-- Name: domain_rv; Type: VIEW; Schema: rbactest; Owner: test
--

CREATE VIEW rbactest.domain_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'rbactest.domain'::text)
        )
 SELECT target.uuid,
    target.packageuuid,
    target.name,
    target.description
   FROM rbactest.domain target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.name;


ALTER VIEW rbactest.domain_rv OWNER TO admin;

--
-- Name: package_iv; Type: VIEW; Schema: rbactest; Owner: test
--

CREATE VIEW rbactest.package_iv AS
 SELECT target.uuid,
    base.cleanidentifier(target.name) AS idname
   FROM rbactest.package target;


ALTER VIEW rbactest.package_iv OWNER TO admin;

--
-- Name: package_rv; Type: VIEW; Schema: rbactest; Owner: test
--

CREATE VIEW rbactest.package_rv AS
 WITH accessible_uuids AS (
         WITH RECURSIVE recursive_grants AS (
                 SELECT DISTINCT "grant".descendantuuid,
                    "grant".ascendantuuid,
                    1 AS level,
                    true AS "?column?"
                   FROM rbac."grant"
                  WHERE ("grant".assumed AND ("grant".ascendantuuid = ANY (rbac.currentsubjectorassumedrolesuuids())))
                UNION ALL
                 SELECT DISTINCT g.descendantuuid,
                    g.ascendantuuid,
                    (grants.level + 1) AS level,
                    base.asserttrue((grants.level < 22), ('too many grant-levels: '::text || grants.level)) AS asserttrue
                   FROM (rbac."grant" g
                     JOIN recursive_grants grants ON ((grants.descendantuuid = g.ascendantuuid)))
                  WHERE g.assumed
                ), grant_count AS (
                 SELECT count(*) AS grant_count
                   FROM recursive_grants recursive_grants_1
                ), count_check AS (
                 SELECT base.asserttrue((( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1) < 400000), ('too many grants for current subjects: '::text || ( SELECT count(*) AS grant_count
                           FROM recursive_grants recursive_grants_1))) AS valid
                )
         SELECT DISTINCT perm.objectuuid
           FROM (((recursive_grants
             JOIN rbac.permission perm ON ((recursive_grants.descendantuuid = perm.uuid)))
             JOIN rbac.object obj ON ((obj.uuid = perm.objectuuid)))
             JOIN count_check cc ON (cc.valid))
          WHERE ((obj.objecttable)::text = 'rbactest.package'::text)
        )
 SELECT target.uuid,
    target.version,
    target.customeruuid,
    target.name,
    target.description
   FROM rbactest.package target
  WHERE (rbac.hasglobaladminrole() OR (target.uuid IN ( SELECT accessible_uuids.objectuuid
           FROM accessible_uuids)))
  ORDER BY target.name;


ALTER VIEW rbactest.package_rv OWNER TO admin;

--
-- Name: contact_legacy_id contact_id; Type: DEFAULT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.contact_legacy_id ALTER COLUMN contact_id SET DEFAULT nextval('hs_office.contact_legacy_id_seq'::regclass);


--
-- Name: coopassettx_legacy_id member_asset_id; Type: DEFAULT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx_legacy_id ALTER COLUMN member_asset_id SET DEFAULT nextval('hs_office.coopassettx_legacy_id_seq'::regclass);


--
-- Name: coopsharetx_legacy_id member_share_id; Type: DEFAULT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopsharetx_legacy_id ALTER COLUMN member_share_id SET DEFAULT nextval('hs_office.coopsharetx_legacy_id_seq'::regclass);


--
-- Name: partner_legacy_id bp_id; Type: DEFAULT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner_legacy_id ALTER COLUMN bp_id SET DEFAULT nextval('hs_office.partner_legacy_id_seq'::regclass);


--
-- Name: sepamandate_legacy_id sepa_mandate_id; Type: DEFAULT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.sepamandate_legacy_id ALTER COLUMN sepa_mandate_id SET DEFAULT nextval('hs_office.sepamandate_legacy_id_seq'::regclass);


--
-- Name: object serialid; Type: DEFAULT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.object ALTER COLUMN serialid SET DEFAULT nextval('rbac.object_serialid_seq'::regclass);


--
-- Data for Name: tx_context; Type: TABLE DATA; Schema: base; Owner: test
--

INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('1692', '2025-01-30 16:36:11.049546', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');
INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('1750', '2025-01-30 16:36:11.58435', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');
INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('1823', '2025-01-30 16:36:11.810066', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');
INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('2033', '2025-01-30 16:36:13.382336', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');
INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('2082', '2025-01-30 16:36:13.699862', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');
INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('2107', '2025-01-30 16:36:13.924092', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');
INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('2143', '2025-01-30 16:36:14.091721', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');
INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('2165', '2025-01-30 16:36:14.17407', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');
INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('2187', '2025-01-30 16:36:14.382939', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');
INSERT INTO base.tx_context (txid, txtimestamp, currentsubject, assumedroles, currenttask, currentrequest) VALUES ('2210', '2025-01-30 16:36:14.478165', 'superuser-alex@hostsharing.net', '{}', 'persistOfficeEntities()', '');


--
-- Data for Name: tx_journal; Type: TABLE DATA; Schema: base; Owner: test
--

INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'INSERT', '{"uuid": "691db509-b67e-46ec-a859-c4cb05fbbd70", "serialid": 129, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '7fe86d82-1b9d-485e-a206-a4c9bb39125c', 'INSERT', '{"uuid": "7fe86d82-1b9d-485e-a206-a4c9bb39125c", "roletype": "OWNER", "objectuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '8a96713c-f52a-494b-9856-5a7cc869449b', 'INSERT', '{"op": "DELETE", "uuid": "8a96713c-f52a-494b-9856-5a7cc869449b", "objectuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '255896f7-49d0-4818-a8ef-ab89e09fe220', 'INSERT', '{"uuid": "255896f7-49d0-4818-a8ef-ab89e09fe220", "assumed": true, "ascendantuuid": "7fe86d82-1b9d-485e-a206-a4c9bb39125c", "descendantuuid": "8a96713c-f52a-494b-9856-5a7cc869449b", "grantedbyroleuuid": null, "grantedbytriggerof": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'b7267fb0-0ba2-4e9a-ac10-7fa7d23b252b', 'INSERT', '{"uuid": "b7267fb0-0ba2-4e9a-ac10-7fa7d23b252b", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "7fe86d82-1b9d-485e-a206-a4c9bb39125c", "grantedbyroleuuid": null, "grantedbytriggerof": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'dce4e633-96ab-42a0-91d8-d70d968fa9c3', 'INSERT', '{"uuid": "dce4e633-96ab-42a0-91d8-d70d968fa9c3", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "7fe86d82-1b9d-485e-a206-a4c9bb39125c", "grantedbyroleuuid": "7fe86d82-1b9d-485e-a206-a4c9bb39125c", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', 'INSERT', '{"uuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "roletype": "ADMIN", "objectuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '0debf423-4128-4959-94b6-c4e17adfd25f', 'INSERT', '{"op": "UPDATE", "uuid": "0debf423-4128-4959-94b6-c4e17adfd25f", "objectuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'aee0fd67-8819-4c8c-b2a1-9b6b2724d985', 'INSERT', '{"uuid": "aee0fd67-8819-4c8c-b2a1-9b6b2724d985", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "0debf423-4128-4959-94b6-c4e17adfd25f", "grantedbyroleuuid": null, "grantedbytriggerof": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '6d33a2d2-8318-412a-b2a2-f4903e243634', 'INSERT', '{"uuid": "6d33a2d2-8318-412a-b2a2-f4903e243634", "assumed": true, "ascendantuuid": "7fe86d82-1b9d-485e-a206-a4c9bb39125c", "descendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "grantedbyroleuuid": null, "grantedbytriggerof": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '38aa2ac2-71e5-4805-94ae-61361288f235', 'INSERT', '{"uuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "roletype": "REFERRER", "objectuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'bd35e25f-a9d7-41f9-835d-55026654c03c', 'INSERT', '{"op": "SELECT", "uuid": "bd35e25f-a9d7-41f9-835d-55026654c03c", "objectuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '8886335c-b86c-4482-855a-8bba58430513', 'INSERT', '{"uuid": "8886335c-b86c-4482-855a-8bba58430513", "assumed": true, "ascendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "descendantuuid": "bd35e25f-a9d7-41f9-835d-55026654c03c", "grantedbyroleuuid": null, "grantedbytriggerof": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '3fe9949e-fe13-4ebe-ac9c-175d91704d68', 'INSERT', '{"uuid": "3fe9949e-fe13-4ebe-ac9c-175d91704d68", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '3cdad6bf-60f7-4dd7-80b8-4b1bfbc0f7b7', 'INSERT', '{"op": "SELECT", "uuid": "3cdad6bf-60f7-4dd7-80b8-4b1bfbc0f7b7", "objectuuid": "d363745a-e94f-48be-8397-4b361570a54d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '9444adae-37a0-434e-97b7-3304b5577498', 'INSERT', '{"op": "DELETE", "uuid": "9444adae-37a0-434e-97b7-3304b5577498", "objectuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'INSERT', '{"uuid": "691db509-b67e-46ec-a859-c4cb05fbbd70", "caption": "Michael Mellis, Herr Michael Mellis", "version": 0, "phonenumbers": {"fax": "+49 40 912345-9", "phone_mobile": "+49/1522123455", "phone_office": "+49 4931/1234567"}, "postaladdress": {"city": "Hage", "firm": "Herr Michael Mellis", "name": "Herr Michael Mellis", "street": "Dr. Bolte Str. 50", "country": "Germany", "zipcode": "26524"}, "emailaddresses": {"main": "michael@Mellis.example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'INSERT', '{"uuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42", "serialid": 130, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'eba5fbe1-b196-4df3-8d92-fd9023668744', 'INSERT', '{"uuid": "eba5fbe1-b196-4df3-8d92-fd9023668744", "roletype": "OWNER", "objectuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'd0ee13fb-5f61-40d3-b38e-02eafd89160f', 'INSERT', '{"op": "DELETE", "uuid": "d0ee13fb-5f61-40d3-b38e-02eafd89160f", "objectuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'cb309ec8-023d-4a2f-8fc7-33ea3b0a17ee', 'INSERT', '{"uuid": "cb309ec8-023d-4a2f-8fc7-33ea3b0a17ee", "assumed": true, "ascendantuuid": "eba5fbe1-b196-4df3-8d92-fd9023668744", "descendantuuid": "d0ee13fb-5f61-40d3-b38e-02eafd89160f", "grantedbyroleuuid": null, "grantedbytriggerof": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'fff94117-2a2b-4640-912f-054e98076714', 'INSERT', '{"uuid": "fff94117-2a2b-4640-912f-054e98076714", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "eba5fbe1-b196-4df3-8d92-fd9023668744", "grantedbyroleuuid": null, "grantedbytriggerof": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'a5da7c37-b49f-481e-af99-be5f00420901', 'INSERT', '{"uuid": "a5da7c37-b49f-481e-af99-be5f00420901", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "eba5fbe1-b196-4df3-8d92-fd9023668744", "grantedbyroleuuid": "eba5fbe1-b196-4df3-8d92-fd9023668744", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'a6ff0898-04e1-49b7-8621-b42846df06e1', 'INSERT', '{"uuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "roletype": "ADMIN", "objectuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'e6970814-b140-4805-95f3-610c215eb5ab', 'INSERT', '{"op": "UPDATE", "uuid": "e6970814-b140-4805-95f3-610c215eb5ab", "objectuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '9bf28023-0b2e-4ecf-8b19-e2c33708aac5', 'INSERT', '{"uuid": "9bf28023-0b2e-4ecf-8b19-e2c33708aac5", "assumed": true, "ascendantuuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "descendantuuid": "e6970814-b140-4805-95f3-610c215eb5ab", "grantedbyroleuuid": null, "grantedbytriggerof": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'ad469a06-3a5c-4501-947b-4cbff6d3c4be', 'INSERT', '{"uuid": "ad469a06-3a5c-4501-947b-4cbff6d3c4be", "assumed": true, "ascendantuuid": "eba5fbe1-b196-4df3-8d92-fd9023668744", "descendantuuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "grantedbyroleuuid": null, "grantedbytriggerof": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '5c9372e0-cb21-4ae7-a461-df086ad19426', 'INSERT', '{"uuid": "5c9372e0-cb21-4ae7-a461-df086ad19426", "roletype": "REFERRER", "objectuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'e3c18d7e-cb24-4063-b0ac-dcb8fd3d2b68', 'INSERT', '{"op": "SELECT", "uuid": "e3c18d7e-cb24-4063-b0ac-dcb8fd3d2b68", "objectuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '030d63fc-2357-4bb7-8828-527aeddb3f37', 'INSERT', '{"uuid": "030d63fc-2357-4bb7-8828-527aeddb3f37", "assumed": true, "ascendantuuid": "5c9372e0-cb21-4ae7-a461-df086ad19426", "descendantuuid": "e3c18d7e-cb24-4063-b0ac-dcb8fd3d2b68", "grantedbyroleuuid": null, "grantedbytriggerof": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'dec9b37f-9f1c-414c-b499-15d6c2ac2633', 'INSERT', '{"uuid": "dec9b37f-9f1c-414c-b499-15d6c2ac2633", "assumed": true, "ascendantuuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "descendantuuid": "5c9372e0-cb21-4ae7-a461-df086ad19426", "grantedbyroleuuid": null, "grantedbytriggerof": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'INSERT', '{"uuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42", "caption": "Ragnar IT-Beratung, Herr Ragnar Richter", "version": 0, "phonenumbers": {"fax": "+49 711 87654-3", "phone_office": "+49 711 987654-2", "phone_private": "+49 711 987654-1"}, "postaladdress": {"city": "Stuttgart", "firm": "Herr Ragnar Richter", "name": "Herr Ragnar Richter", "street": "Vioktoriastraße 114", "country": "Germany", "zipcode": "70197"}, "emailaddresses": {"main": "hostsharing@ragnar-richter.de"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', 'd363745a-e94f-48be-8397-4b361570a54d', 'INSERT', '{"uuid": "d363745a-e94f-48be-8397-4b361570a54d", "serialid": 131, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'a930208f-7ef8-4296-9f70-24c50656ac58', 'INSERT', '{"uuid": "a930208f-7ef8-4296-9f70-24c50656ac58", "roletype": "OWNER", "objectuuid": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'eb43edcb-0d20-4614-b45c-736ef4f56380', 'INSERT', '{"op": "DELETE", "uuid": "eb43edcb-0d20-4614-b45c-736ef4f56380", "objectuuid": "d363745a-e94f-48be-8397-4b361570a54d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'd2fb1e9f-ccc3-4316-9aed-b4ddd25cd865', 'INSERT', '{"uuid": "d2fb1e9f-ccc3-4316-9aed-b4ddd25cd865", "assumed": true, "ascendantuuid": "a930208f-7ef8-4296-9f70-24c50656ac58", "descendantuuid": "eb43edcb-0d20-4614-b45c-736ef4f56380", "grantedbyroleuuid": null, "grantedbytriggerof": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '52f8abd9-2cc0-42d1-a514-8f03b8ae64db', 'INSERT', '{"uuid": "52f8abd9-2cc0-42d1-a514-8f03b8ae64db", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "a930208f-7ef8-4296-9f70-24c50656ac58", "grantedbyroleuuid": null, "grantedbytriggerof": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'ee92f6ef-83f7-42c3-9987-7a2849b7392d', 'INSERT', '{"uuid": "ee92f6ef-83f7-42c3-9987-7a2849b7392d", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "a930208f-7ef8-4296-9f70-24c50656ac58", "grantedbyroleuuid": "a930208f-7ef8-4296-9f70-24c50656ac58", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'b9592474-79f3-42d9-828f-8cc2e5c8ba7c', 'INSERT', '{"uuid": "b9592474-79f3-42d9-828f-8cc2e5c8ba7c", "roletype": "ADMIN", "objectuuid": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'db94672f-1fbf-4898-bff8-2bfb5b2450a3', 'INSERT', '{"op": "UPDATE", "uuid": "db94672f-1fbf-4898-bff8-2bfb5b2450a3", "objectuuid": "d363745a-e94f-48be-8397-4b361570a54d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '097f8881-5e6b-4870-8d07-307ee55359c9', 'INSERT', '{"uuid": "097f8881-5e6b-4870-8d07-307ee55359c9", "assumed": true, "ascendantuuid": "b9592474-79f3-42d9-828f-8cc2e5c8ba7c", "descendantuuid": "db94672f-1fbf-4898-bff8-2bfb5b2450a3", "grantedbyroleuuid": null, "grantedbytriggerof": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '5dcf4fa9-caca-4c5f-911c-0556ee8526cc', 'INSERT', '{"uuid": "5dcf4fa9-caca-4c5f-911c-0556ee8526cc", "assumed": true, "ascendantuuid": "a930208f-7ef8-4296-9f70-24c50656ac58", "descendantuuid": "b9592474-79f3-42d9-828f-8cc2e5c8ba7c", "grantedbyroleuuid": null, "grantedbytriggerof": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '1280183b-c71a-4b86-bdec-7f3800679ef4', 'INSERT', '{"uuid": "1280183b-c71a-4b86-bdec-7f3800679ef4", "roletype": "REFERRER", "objectuuid": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '18de6002-7109-44c8-b001-38af17fbb126', 'INSERT', '{"uuid": "18de6002-7109-44c8-b001-38af17fbb126", "assumed": true, "ascendantuuid": "1280183b-c71a-4b86-bdec-7f3800679ef4", "descendantuuid": "3cdad6bf-60f7-4dd7-80b8-4b1bfbc0f7b7", "grantedbyroleuuid": null, "grantedbytriggerof": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '422119f8-cf6b-47a7-a6e5-f07fc59d1ff3', 'INSERT', '{"uuid": "422119f8-cf6b-47a7-a6e5-f07fc59d1ff3", "assumed": true, "ascendantuuid": "b9592474-79f3-42d9-828f-8cc2e5c8ba7c", "descendantuuid": "1280183b-c71a-4b86-bdec-7f3800679ef4", "grantedbyroleuuid": null, "grantedbytriggerof": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', 'd363745a-e94f-48be-8397-4b361570a54d', 'INSERT', '{"uuid": "d363745a-e94f-48be-8397-4b361570a54d", "caption": "Hostsharing e.G., Hostmaster Hostsharing", "version": 0, "phonenumbers": {}, "postaladdress": {"firm": "Hostmaster Hostsharing", "name": "Hostmaster Hostsharing", "country": "Germany"}, "emailaddresses": {"main": "hostmaster@hostsharing.net"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '7a334268-7d11-4765-8fa9-17e2c36cca7a', 'INSERT', '{"uuid": "7a334268-7d11-4765-8fa9-17e2c36cca7a", "serialid": 132, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'd1d8fae9-566a-4a6b-8a1c-372b63108fe6', 'INSERT', '{"uuid": "d1d8fae9-566a-4a6b-8a1c-372b63108fe6", "roletype": "OWNER", "objectuuid": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '684d7313-c093-4da0-83e8-bd73c6cc0bb6', 'INSERT', '{"op": "DELETE", "uuid": "684d7313-c093-4da0-83e8-bd73c6cc0bb6", "objectuuid": "7a334268-7d11-4765-8fa9-17e2c36cca7a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '5341c201-1e05-4750-ad24-7bba63bbb0a4', 'INSERT', '{"uuid": "5341c201-1e05-4750-ad24-7bba63bbb0a4", "assumed": true, "ascendantuuid": "d1d8fae9-566a-4a6b-8a1c-372b63108fe6", "descendantuuid": "684d7313-c093-4da0-83e8-bd73c6cc0bb6", "grantedbyroleuuid": null, "grantedbytriggerof": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '2fc7b67b-c746-475c-b2fb-f2140117db64', 'INSERT', '{"uuid": "2fc7b67b-c746-475c-b2fb-f2140117db64", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "d1d8fae9-566a-4a6b-8a1c-372b63108fe6", "grantedbyroleuuid": null, "grantedbytriggerof": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '069f69db-d07b-47c1-a7dc-2c02f32599b3', 'INSERT', '{"uuid": "069f69db-d07b-47c1-a7dc-2c02f32599b3", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "d1d8fae9-566a-4a6b-8a1c-372b63108fe6", "grantedbyroleuuid": "d1d8fae9-566a-4a6b-8a1c-372b63108fe6", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '939dafca-fe72-499d-979d-6fe0288e6807', 'INSERT', '{"uuid": "939dafca-fe72-499d-979d-6fe0288e6807", "roletype": "ADMIN", "objectuuid": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '42a22abb-f604-4980-b6fa-adb1aa4e0adf', 'INSERT', '{"op": "UPDATE", "uuid": "42a22abb-f604-4980-b6fa-adb1aa4e0adf", "objectuuid": "7a334268-7d11-4765-8fa9-17e2c36cca7a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'dc86a67f-b62e-45b4-b14b-d93272c79756', 'INSERT', '{"uuid": "dc86a67f-b62e-45b4-b14b-d93272c79756", "assumed": true, "ascendantuuid": "939dafca-fe72-499d-979d-6fe0288e6807", "descendantuuid": "42a22abb-f604-4980-b6fa-adb1aa4e0adf", "grantedbyroleuuid": null, "grantedbytriggerof": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '2296270c-0122-4ebf-a894-5eba96a788cc', 'INSERT', '{"uuid": "2296270c-0122-4ebf-a894-5eba96a788cc", "assumed": true, "ascendantuuid": "d1d8fae9-566a-4a6b-8a1c-372b63108fe6", "descendantuuid": "939dafca-fe72-499d-979d-6fe0288e6807", "grantedbyroleuuid": null, "grantedbytriggerof": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'b91f7dd8-b4a4-4f9b-9192-300f8e982c6d', 'INSERT', '{"uuid": "b91f7dd8-b4a4-4f9b-9192-300f8e982c6d", "roletype": "REFERRER", "objectuuid": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'd226bd12-192c-43f1-bc65-45803a17c4a3', 'INSERT', '{"op": "SELECT", "uuid": "d226bd12-192c-43f1-bc65-45803a17c4a3", "objectuuid": "7a334268-7d11-4765-8fa9-17e2c36cca7a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'b693f79e-8185-4c6f-9b30-5160c6f5d5fb', 'INSERT', '{"uuid": "b693f79e-8185-4c6f-9b30-5160c6f5d5fb", "assumed": true, "ascendantuuid": "b91f7dd8-b4a4-4f9b-9192-300f8e982c6d", "descendantuuid": "d226bd12-192c-43f1-bc65-45803a17c4a3", "grantedbyroleuuid": null, "grantedbytriggerof": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '0485fd95-27e8-484c-8bba-e8144bc0ba15', 'INSERT', '{"uuid": "0485fd95-27e8-484c-8bba-e8144bc0ba15", "assumed": true, "ascendantuuid": "939dafca-fe72-499d-979d-6fe0288e6807", "descendantuuid": "b91f7dd8-b4a4-4f9b-9192-300f8e982c6d", "grantedbyroleuuid": null, "grantedbytriggerof": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '7a334268-7d11-4765-8fa9-17e2c36cca7a', 'INSERT', '{"uuid": "7a334268-7d11-4765-8fa9-17e2c36cca7a", "caption": "JM e.K.", "version": 0, "phonenumbers": {"fax": "+49 30 6666666", "phone_office": "+49 30 5555555", "phone_private": "+49 30 6666666"}, "postaladdress": {"city": "Berlin", "firm": "", "street": "Wiesenweg 15", "country": "DE", "zipcode": "12335"}, "emailaddresses": {"main": "jm-ex-partner@example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '33b40eee-30ed-4924-859d-6c58b5aa4124', 'INSERT', '{"uuid": "33b40eee-30ed-4924-859d-6c58b5aa4124", "serialid": 133, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '2b70b335-e6b6-4b11-b138-4e7b3c4c50d4', 'INSERT', '{"uuid": "2b70b335-e6b6-4b11-b138-4e7b3c4c50d4", "roletype": "OWNER", "objectuuid": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'deebf94a-2ef8-40bd-8538-9227bb901fee', 'INSERT', '{"op": "DELETE", "uuid": "deebf94a-2ef8-40bd-8538-9227bb901fee", "objectuuid": "33b40eee-30ed-4924-859d-6c58b5aa4124", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'e98e8e5a-a249-4da7-bfca-0c74d828d0db', 'INSERT', '{"uuid": "e98e8e5a-a249-4da7-bfca-0c74d828d0db", "assumed": true, "ascendantuuid": "2b70b335-e6b6-4b11-b138-4e7b3c4c50d4", "descendantuuid": "deebf94a-2ef8-40bd-8538-9227bb901fee", "grantedbyroleuuid": null, "grantedbytriggerof": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '3a7316b4-ca96-4991-a2dd-b3404ebe7ccb', 'INSERT', '{"uuid": "3a7316b4-ca96-4991-a2dd-b3404ebe7ccb", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "2b70b335-e6b6-4b11-b138-4e7b3c4c50d4", "grantedbyroleuuid": null, "grantedbytriggerof": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'e3046b32-105c-45dd-a5e4-9684f43ef739', 'INSERT', '{"uuid": "e3046b32-105c-45dd-a5e4-9684f43ef739", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "2b70b335-e6b6-4b11-b138-4e7b3c4c50d4", "grantedbyroleuuid": "2b70b335-e6b6-4b11-b138-4e7b3c4c50d4", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '06bf2ac2-61c5-42e9-917b-8b68afcc0d47', 'INSERT', '{"uuid": "06bf2ac2-61c5-42e9-917b-8b68afcc0d47", "roletype": "ADMIN", "objectuuid": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'a3aee0e9-b8f3-4262-80ae-5cc6154cdc10', 'INSERT', '{"op": "UPDATE", "uuid": "a3aee0e9-b8f3-4262-80ae-5cc6154cdc10", "objectuuid": "33b40eee-30ed-4924-859d-6c58b5aa4124", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'd0c4f7e2-feb4-4559-894a-6d60593f7935', 'INSERT', '{"uuid": "d0c4f7e2-feb4-4559-894a-6d60593f7935", "assumed": true, "ascendantuuid": "06bf2ac2-61c5-42e9-917b-8b68afcc0d47", "descendantuuid": "a3aee0e9-b8f3-4262-80ae-5cc6154cdc10", "grantedbyroleuuid": null, "grantedbytriggerof": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'caa58c78-6540-4f75-a24c-d4ea5f218cb0', 'INSERT', '{"op": "DELETE", "uuid": "caa58c78-6540-4f75-a24c-d4ea5f218cb0", "objectuuid": "eead6995-dd54-475f-8194-74445c421305", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'd0480f7e-3066-4cc5-b5a4-dcbe3e661b2a', 'INSERT', '{"uuid": "d0480f7e-3066-4cc5-b5a4-dcbe3e661b2a", "assumed": true, "ascendantuuid": "2b70b335-e6b6-4b11-b138-4e7b3c4c50d4", "descendantuuid": "06bf2ac2-61c5-42e9-917b-8b68afcc0d47", "grantedbyroleuuid": null, "grantedbytriggerof": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '7a8959c2-e6c0-4af3-9d64-117811ec0d02', 'INSERT', '{"uuid": "7a8959c2-e6c0-4af3-9d64-117811ec0d02", "roletype": "REFERRER", "objectuuid": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '4fe450ed-3a24-49b8-98cc-fa85de9ce889', 'INSERT', '{"op": "SELECT", "uuid": "4fe450ed-3a24-49b8-98cc-fa85de9ce889", "objectuuid": "33b40eee-30ed-4924-859d-6c58b5aa4124", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '2edfcd56-1985-4bec-b683-f23909acb1ee', 'INSERT', '{"uuid": "2edfcd56-1985-4bec-b683-f23909acb1ee", "assumed": true, "ascendantuuid": "7a8959c2-e6c0-4af3-9d64-117811ec0d02", "descendantuuid": "4fe450ed-3a24-49b8-98cc-fa85de9ce889", "grantedbyroleuuid": null, "grantedbytriggerof": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '558ee33d-5b2a-44e2-a5b8-31b80bcc32ca', 'INSERT', '{"uuid": "558ee33d-5b2a-44e2-a5b8-31b80bcc32ca", "assumed": true, "ascendantuuid": "06bf2ac2-61c5-42e9-917b-8b68afcc0d47", "descendantuuid": "7a8959c2-e6c0-4af3-9d64-117811ec0d02", "grantedbyroleuuid": null, "grantedbytriggerof": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '33b40eee-30ed-4924-859d-6c58b5aa4124', 'INSERT', '{"uuid": "33b40eee-30ed-4924-859d-6c58b5aa4124", "caption": "JM GmbH, Frau Dr. Jenny Meyer-Billing", "version": 0, "phonenumbers": {"fax": "+49 30 2222222", "phone_office": "+49 30 1111111", "phone_private": "+49 30 7777777"}, "postaladdress": {"city": "Berlin", "firm": "Frau Dr. Jenny Meyer-Billing", "name": "Frau Dr. Jenny Meyer-Billing", "street": "Waldweg 5", "country": "DE", "zipcode": "11001"}, "emailaddresses": {"main": "jm-billing@example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'INSERT', '{"uuid": "16da0560-e134-41c5-aafb-1f7a5b33692b", "serialid": 134, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '9d6a3750-0d32-469a-a476-2d8525f7e692', 'INSERT', '{"uuid": "9d6a3750-0d32-469a-a476-2d8525f7e692", "roletype": "OWNER", "objectuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'c11382ee-e0e3-4b25-b8ba-640dde8c20bf', 'INSERT', '{"op": "DELETE", "uuid": "c11382ee-e0e3-4b25-b8ba-640dde8c20bf", "objectuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'ea2432fa-f049-4858-8279-8a039d9c6d30', 'INSERT', '{"uuid": "ea2432fa-f049-4858-8279-8a039d9c6d30", "assumed": true, "ascendantuuid": "9d6a3750-0d32-469a-a476-2d8525f7e692", "descendantuuid": "c11382ee-e0e3-4b25-b8ba-640dde8c20bf", "grantedbyroleuuid": null, "grantedbytriggerof": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '5147ee1c-b04a-4add-96a7-c52e72186004', 'INSERT', '{"uuid": "5147ee1c-b04a-4add-96a7-c52e72186004", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "9d6a3750-0d32-469a-a476-2d8525f7e692", "grantedbyroleuuid": null, "grantedbytriggerof": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'a3c0ef7e-f9ac-43e3-9674-7d4a4d3f935a', 'INSERT', '{"uuid": "a3c0ef7e-f9ac-43e3-9674-7d4a4d3f935a", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "9d6a3750-0d32-469a-a476-2d8525f7e692", "grantedbyroleuuid": "9d6a3750-0d32-469a-a476-2d8525f7e692", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '82d6e2a0-3c2d-4a8e-8638-4903696927d5', 'INSERT', '{"uuid": "82d6e2a0-3c2d-4a8e-8638-4903696927d5", "roletype": "ADMIN", "objectuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '0d98be37-8ae9-48c8-9bff-6b7581e256fa', 'INSERT', '{"op": "UPDATE", "uuid": "0d98be37-8ae9-48c8-9bff-6b7581e256fa", "objectuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '25ec885b-5885-47a0-89ea-cbaf2838f16d', 'INSERT', '{"uuid": "25ec885b-5885-47a0-89ea-cbaf2838f16d", "assumed": true, "ascendantuuid": "82d6e2a0-3c2d-4a8e-8638-4903696927d5", "descendantuuid": "0d98be37-8ae9-48c8-9bff-6b7581e256fa", "grantedbyroleuuid": null, "grantedbytriggerof": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '3e4bcbd6-e9e8-4667-b082-65ab49cdd047', 'INSERT', '{"uuid": "3e4bcbd6-e9e8-4667-b082-65ab49cdd047", "assumed": true, "ascendantuuid": "9d6a3750-0d32-469a-a476-2d8525f7e692", "descendantuuid": "82d6e2a0-3c2d-4a8e-8638-4903696927d5", "grantedbyroleuuid": null, "grantedbytriggerof": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '25acc71c-db8f-46e4-950a-8ea76637bb9b', 'INSERT', '{"uuid": "25acc71c-db8f-46e4-950a-8ea76637bb9b", "roletype": "REFERRER", "objectuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'de8da2bb-9e4d-44e7-ad03-e9763db4331f', 'INSERT', '{"op": "SELECT", "uuid": "de8da2bb-9e4d-44e7-ad03-e9763db4331f", "objectuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '7df1503a-19d3-4c58-bce8-72dcabf3ee17', 'INSERT', '{"uuid": "7df1503a-19d3-4c58-bce8-72dcabf3ee17", "assumed": true, "ascendantuuid": "25acc71c-db8f-46e4-950a-8ea76637bb9b", "descendantuuid": "de8da2bb-9e4d-44e7-ad03-e9763db4331f", "grantedbyroleuuid": null, "grantedbytriggerof": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '97a3cb59-87c2-4aa5-a20d-c49726d852cb', 'INSERT', '{"uuid": "97a3cb59-87c2-4aa5-a20d-c49726d852cb", "assumed": true, "ascendantuuid": "82d6e2a0-3c2d-4a8e-8638-4903696927d5", "descendantuuid": "25acc71c-db8f-46e4-950a-8ea76637bb9b", "grantedbyroleuuid": null, "grantedbytriggerof": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'INSERT', '{"uuid": "16da0560-e134-41c5-aafb-1f7a5b33692b", "caption": "JM GmbH, Herr Andrew Meyer-Operation", "version": 0, "phonenumbers": {"fax": "+49 30 4444444", "phone_office": "+49 30 3333333", "phone_private": "+49 30 6666666"}, "postaladdress": {"city": "Berlin", "firm": "Herr Andrew Meyer-Operation", "name": "Herr Andrew Meyer-Operation", "street": "Waldweg 5", "country": "DE", "zipcode": "11001"}, "emailaddresses": {"main": "am-operation@example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'INSERT', '{"uuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb", "serialid": 135, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '0b754d22-82a2-4349-af85-2cee67716f66', 'INSERT', '{"uuid": "0b754d22-82a2-4349-af85-2cee67716f66", "roletype": "OWNER", "objectuuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '390087c9-9c6f-4c2f-9c77-af65112c520a', 'INSERT', '{"op": "DELETE", "uuid": "390087c9-9c6f-4c2f-9c77-af65112c520a", "objectuuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '1234271b-e26d-4f40-91ce-b88639be5579', 'INSERT', '{"uuid": "1234271b-e26d-4f40-91ce-b88639be5579", "assumed": true, "ascendantuuid": "0b754d22-82a2-4349-af85-2cee67716f66", "descendantuuid": "390087c9-9c6f-4c2f-9c77-af65112c520a", "grantedbyroleuuid": null, "grantedbytriggerof": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '313ed510-dd9c-4336-94cc-49f4b9764237', 'INSERT', '{"uuid": "313ed510-dd9c-4336-94cc-49f4b9764237", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0b754d22-82a2-4349-af85-2cee67716f66", "grantedbyroleuuid": null, "grantedbytriggerof": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '680b8464-0536-4f87-a952-56e549a70a99', 'INSERT', '{"uuid": "680b8464-0536-4f87-a952-56e549a70a99", "roletype": "OWNER", "objectuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '534ad46c-147e-4223-9965-14c1b80fc096', 'INSERT', '{"uuid": "534ad46c-147e-4223-9965-14c1b80fc096", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0b754d22-82a2-4349-af85-2cee67716f66", "grantedbyroleuuid": "0b754d22-82a2-4349-af85-2cee67716f66", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b', 'INSERT', '{"uuid": "42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b", "roletype": "ADMIN", "objectuuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'ea4baec8-4128-4e59-b0e1-69b450c46755', 'INSERT', '{"op": "UPDATE", "uuid": "ea4baec8-4128-4e59-b0e1-69b450c46755", "objectuuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '482020d5-4755-47e3-8e37-2a53dbfc51da', 'INSERT', '{"uuid": "482020d5-4755-47e3-8e37-2a53dbfc51da", "assumed": true, "ascendantuuid": "42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b", "descendantuuid": "ea4baec8-4128-4e59-b0e1-69b450c46755", "grantedbyroleuuid": null, "grantedbytriggerof": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '7ba8e044-7762-4b42-9383-dfca5f38f2d5', 'INSERT', '{"uuid": "7ba8e044-7762-4b42-9383-dfca5f38f2d5", "assumed": true, "ascendantuuid": "0b754d22-82a2-4349-af85-2cee67716f66", "descendantuuid": "42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b", "grantedbyroleuuid": null, "grantedbytriggerof": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '24f9488b-412f-4314-b160-2897f4dcff1b', 'INSERT', '{"uuid": "24f9488b-412f-4314-b160-2897f4dcff1b", "roletype": "REFERRER", "objectuuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'e9887f07-65e4-4b5b-a134-f023fb127cbf', 'INSERT', '{"op": "SELECT", "uuid": "e9887f07-65e4-4b5b-a134-f023fb127cbf", "objectuuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '04398c2b-0517-4dde-a377-c3bb6aa6acbb', 'INSERT', '{"uuid": "04398c2b-0517-4dde-a377-c3bb6aa6acbb", "assumed": true, "ascendantuuid": "24f9488b-412f-4314-b160-2897f4dcff1b", "descendantuuid": "e9887f07-65e4-4b5b-a134-f023fb127cbf", "grantedbyroleuuid": null, "grantedbytriggerof": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'a48c0d05-44c2-4f14-9bf6-6872a0e643a3', 'INSERT', '{"uuid": "a48c0d05-44c2-4f14-9bf6-6872a0e643a3", "assumed": true, "ascendantuuid": "42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b", "descendantuuid": "24f9488b-412f-4314-b160-2897f4dcff1b", "grantedbyroleuuid": null, "grantedbytriggerof": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'INSERT', '{"uuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb", "caption": "JM GmbH, Herr Philip Meyer-Contract", "version": 0, "phonenumbers": {"fax": "+49 30 6666666", "phone_office": "+49 30 5555555", "phone_private": "+49 30 6666666"}, "postaladdress": {"city": "Berlin", "firm": "Herr Philip Meyer-Contract", "name": "Herr Philip Meyer-Contract", "street": "Waldweg 5", "country": "DE", "zipcode": "11001"}, "emailaddresses": {"main": "pm-partner@example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', 'caac18bd-9277-47ac-99bb-368e2d64dac0', 'INSERT', '{"uuid": "caac18bd-9277-47ac-99bb-368e2d64dac0", "serialid": 136, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '310cdf00-c863-4ea0-9e4e-9eac8a74f51a', 'INSERT', '{"uuid": "310cdf00-c863-4ea0-9e4e-9eac8a74f51a", "roletype": "OWNER", "objectuuid": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '2e07da63-f1f6-4342-b090-f3c465e9093a', 'INSERT', '{"op": "DELETE", "uuid": "2e07da63-f1f6-4342-b090-f3c465e9093a", "objectuuid": "caac18bd-9277-47ac-99bb-368e2d64dac0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '1ec460a0-94c2-4faf-869e-02a6edf7d16c', 'INSERT', '{"uuid": "1ec460a0-94c2-4faf-869e-02a6edf7d16c", "assumed": true, "ascendantuuid": "310cdf00-c863-4ea0-9e4e-9eac8a74f51a", "descendantuuid": "2e07da63-f1f6-4342-b090-f3c465e9093a", "grantedbyroleuuid": null, "grantedbytriggerof": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'be53f5ee-7a75-45fe-b438-2b11efbf210d', 'INSERT', '{"uuid": "be53f5ee-7a75-45fe-b438-2b11efbf210d", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "310cdf00-c863-4ea0-9e4e-9eac8a74f51a", "grantedbyroleuuid": null, "grantedbytriggerof": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'eac7fcd2-b8db-4b32-834c-41c717ba4a56', 'INSERT', '{"uuid": "eac7fcd2-b8db-4b32-834c-41c717ba4a56", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "310cdf00-c863-4ea0-9e4e-9eac8a74f51a", "grantedbyroleuuid": "310cdf00-c863-4ea0-9e4e-9eac8a74f51a", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'f9d5ba94-1514-4400-88af-7b7d3798f473', 'INSERT', '{"uuid": "f9d5ba94-1514-4400-88af-7b7d3798f473", "roletype": "ADMIN", "objectuuid": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'c8cc9a24-e3d0-412d-867b-8e617e40f1e3', 'INSERT', '{"op": "UPDATE", "uuid": "c8cc9a24-e3d0-412d-867b-8e617e40f1e3", "objectuuid": "caac18bd-9277-47ac-99bb-368e2d64dac0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'f29ecf53-d978-406a-9b5d-06af83228fb2', 'INSERT', '{"uuid": "f29ecf53-d978-406a-9b5d-06af83228fb2", "assumed": true, "ascendantuuid": "f9d5ba94-1514-4400-88af-7b7d3798f473", "descendantuuid": "c8cc9a24-e3d0-412d-867b-8e617e40f1e3", "grantedbyroleuuid": null, "grantedbytriggerof": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '6236b09e-2522-435a-850a-734c1951691b', 'INSERT', '{"uuid": "6236b09e-2522-435a-850a-734c1951691b", "assumed": true, "ascendantuuid": "310cdf00-c863-4ea0-9e4e-9eac8a74f51a", "descendantuuid": "f9d5ba94-1514-4400-88af-7b7d3798f473", "grantedbyroleuuid": null, "grantedbytriggerof": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '20926d99-1f1f-497a-8e13-ce3cb4b1eb73', 'INSERT', '{"uuid": "20926d99-1f1f-497a-8e13-ce3cb4b1eb73", "roletype": "REFERRER", "objectuuid": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '32b78d45-4a5c-48a5-bec2-efacd97dc76b', 'INSERT', '{"op": "SELECT", "uuid": "32b78d45-4a5c-48a5-bec2-efacd97dc76b", "objectuuid": "caac18bd-9277-47ac-99bb-368e2d64dac0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '653a28d9-f2c5-414a-a31a-b9fc2afd9a08', 'INSERT', '{"uuid": "653a28d9-f2c5-414a-a31a-b9fc2afd9a08", "assumed": true, "ascendantuuid": "20926d99-1f1f-497a-8e13-ce3cb4b1eb73", "descendantuuid": "32b78d45-4a5c-48a5-bec2-efacd97dc76b", "grantedbyroleuuid": null, "grantedbytriggerof": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '1aaddb85-a79a-48fd-a09e-27aff2656351', 'INSERT', '{"uuid": "1aaddb85-a79a-48fd-a09e-27aff2656351", "assumed": true, "ascendantuuid": "f9d5ba94-1514-4400-88af-7b7d3798f473", "descendantuuid": "20926d99-1f1f-497a-8e13-ce3cb4b1eb73", "grantedbyroleuuid": null, "grantedbytriggerof": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', 'caac18bd-9277-47ac-99bb-368e2d64dac0', 'INSERT', '{"uuid": "caac18bd-9277-47ac-99bb-368e2d64dac0", "caption": "JM GmbH, Frau Tammy Meyer-VIP", "version": 0, "phonenumbers": {"fax": "+49 30 6666666", "phone_office": "+49 30 999999", "phone_private": "+49 30 999999"}, "postaladdress": {"city": "Berlin", "firm": "Frau Tammy Meyer-VIP", "name": "Frau Tammy Meyer-VIP", "street": "Waldweg 5", "country": "DE", "zipcode": "11001"}, "emailaddresses": {"main": "tm-vip@example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', 'eead6995-dd54-475f-8194-74445c421305', 'INSERT', '{"uuid": "eead6995-dd54-475f-8194-74445c421305", "serialid": 137, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'b54d5034-1898-4712-a472-5ecac0e22a1a', 'INSERT', '{"uuid": "b54d5034-1898-4712-a472-5ecac0e22a1a", "roletype": "OWNER", "objectuuid": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'c890dba3-59b0-43ce-b4a7-8b72d56c9bd5', 'INSERT', '{"uuid": "c890dba3-59b0-43ce-b4a7-8b72d56c9bd5", "assumed": true, "ascendantuuid": "b54d5034-1898-4712-a472-5ecac0e22a1a", "descendantuuid": "caa58c78-6540-4f75-a24c-d4ea5f218cb0", "grantedbyroleuuid": null, "grantedbytriggerof": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '566a1aaa-cf4c-4af0-abab-f2df16e450e0', 'INSERT', '{"uuid": "566a1aaa-cf4c-4af0-abab-f2df16e450e0", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "b54d5034-1898-4712-a472-5ecac0e22a1a", "grantedbyroleuuid": null, "grantedbytriggerof": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '4787badb-20d1-4e0e-864c-0077a956f204', 'INSERT', '{"uuid": "4787badb-20d1-4e0e-864c-0077a956f204", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "b54d5034-1898-4712-a472-5ecac0e22a1a", "grantedbyroleuuid": "b54d5034-1898-4712-a472-5ecac0e22a1a", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '57ee73c6-769e-461e-9cea-7bfe56970bf7', 'INSERT', '{"uuid": "57ee73c6-769e-461e-9cea-7bfe56970bf7", "roletype": "ADMIN", "objectuuid": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'ae30faa4-b82e-4e65-8324-360fdba2d504', 'INSERT', '{"op": "UPDATE", "uuid": "ae30faa4-b82e-4e65-8324-360fdba2d504", "objectuuid": "eead6995-dd54-475f-8194-74445c421305", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'aa6b4d7a-976f-4ae2-a60b-91e0db033b4f', 'INSERT', '{"uuid": "aa6b4d7a-976f-4ae2-a60b-91e0db033b4f", "assumed": true, "ascendantuuid": "57ee73c6-769e-461e-9cea-7bfe56970bf7", "descendantuuid": "ae30faa4-b82e-4e65-8324-360fdba2d504", "grantedbyroleuuid": null, "grantedbytriggerof": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '65aeb029-27df-41e0-9ece-d8530348e84f', 'INSERT', '{"uuid": "65aeb029-27df-41e0-9ece-d8530348e84f", "assumed": true, "ascendantuuid": "b54d5034-1898-4712-a472-5ecac0e22a1a", "descendantuuid": "57ee73c6-769e-461e-9cea-7bfe56970bf7", "grantedbyroleuuid": null, "grantedbytriggerof": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'e65ad361-79d6-46a3-a7c7-a18048b7237a', 'INSERT', '{"uuid": "e65ad361-79d6-46a3-a7c7-a18048b7237a", "roletype": "REFERRER", "objectuuid": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'f38fcb66-ea16-41fb-abdc-ea3df857d5e4', 'INSERT', '{"op": "SELECT", "uuid": "f38fcb66-ea16-41fb-abdc-ea3df857d5e4", "objectuuid": "eead6995-dd54-475f-8194-74445c421305", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'ba911597-a4e0-4850-80dc-570d22a66b38', 'INSERT', '{"uuid": "ba911597-a4e0-4850-80dc-570d22a66b38", "assumed": true, "ascendantuuid": "e65ad361-79d6-46a3-a7c7-a18048b7237a", "descendantuuid": "f38fcb66-ea16-41fb-abdc-ea3df857d5e4", "grantedbyroleuuid": null, "grantedbytriggerof": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '180e3c3c-0f8f-4403-9892-fecd79374318', 'INSERT', '{"uuid": "180e3c3c-0f8f-4403-9892-fecd79374318", "assumed": true, "ascendantuuid": "57ee73c6-769e-461e-9cea-7bfe56970bf7", "descendantuuid": "e65ad361-79d6-46a3-a7c7-a18048b7237a", "grantedbyroleuuid": null, "grantedbytriggerof": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', 'eead6995-dd54-475f-8194-74445c421305', 'INSERT', '{"uuid": "eead6995-dd54-475f-8194-74445c421305", "caption": "Test PS, Petra Schmidt", "version": 0, "phonenumbers": {}, "postaladdress": {"firm": "Petra Schmidt", "name": "Petra Schmidt"}, "emailaddresses": {"main": "ps@example.com"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '4b68de11-a658-44bb-be49-ad592e73e3d8', 'INSERT', '{"uuid": "4b68de11-a658-44bb-be49-ad592e73e3d8", "serialid": 138, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '97344c39-24d3-4df5-8dba-ba41ff28a020', 'INSERT', '{"uuid": "97344c39-24d3-4df5-8dba-ba41ff28a020", "roletype": "OWNER", "objectuuid": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '81ea98dc-258a-4ab6-8537-8de22e9e90be', 'INSERT', '{"op": "DELETE", "uuid": "81ea98dc-258a-4ab6-8537-8de22e9e90be", "objectuuid": "4b68de11-a658-44bb-be49-ad592e73e3d8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '03f51fe7-db78-4b8d-996f-cbee3ba752ab', 'INSERT', '{"uuid": "03f51fe7-db78-4b8d-996f-cbee3ba752ab", "assumed": true, "ascendantuuid": "97344c39-24d3-4df5-8dba-ba41ff28a020", "descendantuuid": "81ea98dc-258a-4ab6-8537-8de22e9e90be", "grantedbyroleuuid": null, "grantedbytriggerof": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'd0280cb3-1d1d-4ec4-b00b-c220caa3729f', 'INSERT', '{"uuid": "d0280cb3-1d1d-4ec4-b00b-c220caa3729f", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "97344c39-24d3-4df5-8dba-ba41ff28a020", "grantedbyroleuuid": null, "grantedbytriggerof": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '9682d9f3-0cd6-4a25-8d44-8adf95190ad3', 'INSERT', '{"uuid": "9682d9f3-0cd6-4a25-8d44-8adf95190ad3", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "97344c39-24d3-4df5-8dba-ba41ff28a020", "grantedbyroleuuid": "97344c39-24d3-4df5-8dba-ba41ff28a020", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'd206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e', 'INSERT', '{"uuid": "d206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e", "roletype": "ADMIN", "objectuuid": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '0a2e575c-9d22-42e7-8446-546ac3cda8ed', 'INSERT', '{"op": "UPDATE", "uuid": "0a2e575c-9d22-42e7-8446-546ac3cda8ed", "objectuuid": "4b68de11-a658-44bb-be49-ad592e73e3d8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'e948b309-9135-4960-9694-a299c6b71082', 'INSERT', '{"uuid": "e948b309-9135-4960-9694-a299c6b71082", "assumed": true, "ascendantuuid": "d206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e", "descendantuuid": "0a2e575c-9d22-42e7-8446-546ac3cda8ed", "grantedbyroleuuid": null, "grantedbytriggerof": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '595b65be-6f68-4ec5-9413-e546774b27b7', 'INSERT', '{"uuid": "595b65be-6f68-4ec5-9413-e546774b27b7", "assumed": true, "ascendantuuid": "97344c39-24d3-4df5-8dba-ba41ff28a020", "descendantuuid": "d206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e", "grantedbyroleuuid": null, "grantedbytriggerof": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '6c787015-c910-455d-8b2c-c3ae7bece7e7', 'INSERT', '{"uuid": "6c787015-c910-455d-8b2c-c3ae7bece7e7", "roletype": "REFERRER", "objectuuid": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'b1efc8c9-2f6c-4ec2-84e5-29444c0fcd29', 'INSERT', '{"op": "SELECT", "uuid": "b1efc8c9-2f6c-4ec2-84e5-29444c0fcd29", "objectuuid": "4b68de11-a658-44bb-be49-ad592e73e3d8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'ed3d99d6-01d6-47f4-afcd-fc6960dc94be', 'INSERT', '{"uuid": "ed3d99d6-01d6-47f4-afcd-fc6960dc94be", "assumed": true, "ascendantuuid": "6c787015-c910-455d-8b2c-c3ae7bece7e7", "descendantuuid": "b1efc8c9-2f6c-4ec2-84e5-29444c0fcd29", "grantedbyroleuuid": null, "grantedbytriggerof": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '96aa9986-9d0c-4303-9eb3-34f0cc531cd0', 'INSERT', '{"uuid": "96aa9986-9d0c-4303-9eb3-34f0cc531cd0", "assumed": true, "ascendantuuid": "d206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e", "descendantuuid": "6c787015-c910-455d-8b2c-c3ae7bece7e7", "grantedbyroleuuid": null, "grantedbytriggerof": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '4b68de11-a658-44bb-be49-ad592e73e3d8', 'INSERT', '{"uuid": "4b68de11-a658-44bb-be49-ad592e73e3d8", "caption": "Frau Frauke Fanninga", "version": 0, "phonenumbers": {}, "postaladdress": {"city": "Hitzacker", "name": "Frau Frauke Fanninga", "street": "Am Walde 1", "country": "DE", "zipcode": "29456"}, "emailaddresses": {"main": "ff@example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'INSERT', '{"uuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f", "serialid": 139, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '5e8e7789-e43a-4b38-8693-e79f25490293', 'INSERT', '{"uuid": "5e8e7789-e43a-4b38-8693-e79f25490293", "assumed": true, "ascendantuuid": "680b8464-0536-4f87-a952-56e549a70a99", "descendantuuid": "9444adae-37a0-434e-97b7-3304b5577498", "grantedbyroleuuid": null, "grantedbytriggerof": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'a939473c-c689-453d-a436-5abff20fa354', 'INSERT', '{"uuid": "a939473c-c689-453d-a436-5abff20fa354", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "680b8464-0536-4f87-a952-56e549a70a99", "grantedbyroleuuid": null, "grantedbytriggerof": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '7691369b-8338-436e-b4c9-97fdda157ad9', 'INSERT', '{"uuid": "7691369b-8338-436e-b4c9-97fdda157ad9", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "680b8464-0536-4f87-a952-56e549a70a99", "grantedbyroleuuid": "680b8464-0536-4f87-a952-56e549a70a99", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '93ec1b20-de2b-4af1-924f-047a7afa0276', 'INSERT', '{"uuid": "93ec1b20-de2b-4af1-924f-047a7afa0276", "roletype": "ADMIN", "objectuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'e17045f7-b4ef-4c12-beee-56b1b5ef7190', 'INSERT', '{"op": "UPDATE", "uuid": "e17045f7-b4ef-4c12-beee-56b1b5ef7190", "objectuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'a2121061-5baa-4333-88da-95df06ddc21a', 'INSERT', '{"uuid": "a2121061-5baa-4333-88da-95df06ddc21a", "assumed": true, "ascendantuuid": "93ec1b20-de2b-4af1-924f-047a7afa0276", "descendantuuid": "e17045f7-b4ef-4c12-beee-56b1b5ef7190", "grantedbyroleuuid": null, "grantedbytriggerof": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '0bcd4e3e-e6c5-48df-aa5e-bc4b31f241ec', 'INSERT', '{"uuid": "0bcd4e3e-e6c5-48df-aa5e-bc4b31f241ec", "assumed": true, "ascendantuuid": "680b8464-0536-4f87-a952-56e549a70a99", "descendantuuid": "93ec1b20-de2b-4af1-924f-047a7afa0276", "grantedbyroleuuid": null, "grantedbytriggerof": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '4330591d-61d5-4435-827a-c71b8328a700', 'INSERT', '{"uuid": "4330591d-61d5-4435-827a-c71b8328a700", "roletype": "REFERRER", "objectuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'd6d69027-db1a-444c-be6a-e14232b71647', 'INSERT', '{"op": "SELECT", "uuid": "d6d69027-db1a-444c-be6a-e14232b71647", "objectuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '32bff958-41ea-4b9f-972c-c7dfbca82caa', 'INSERT', '{"uuid": "32bff958-41ea-4b9f-972c-c7dfbca82caa", "assumed": true, "ascendantuuid": "4330591d-61d5-4435-827a-c71b8328a700", "descendantuuid": "d6d69027-db1a-444c-be6a-e14232b71647", "grantedbyroleuuid": null, "grantedbytriggerof": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '4ecaab39-97ff-4034-9826-0023beaa8f75', 'INSERT', '{"uuid": "4ecaab39-97ff-4034-9826-0023beaa8f75", "assumed": true, "ascendantuuid": "93ec1b20-de2b-4af1-924f-047a7afa0276", "descendantuuid": "4330591d-61d5-4435-827a-c71b8328a700", "grantedbyroleuuid": null, "grantedbytriggerof": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'INSERT', '{"uuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f", "caption": "Frau Cecilia Camus", "version": 0, "phonenumbers": {}, "postaladdress": {"city": "Orléans", "name": "Frau Cecilia Camus", "street": "Rue d''Avignion 60", "country": "FR", "zipcode": "45000"}, "emailaddresses": {"main": "cc@example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'INSERT', '{"uuid": "25358342-4f90-4397-b4c4-d90524ac0b7b", "serialid": 140, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '0ca35f5d-778f-4207-88ae-beb5a648a6f6', 'INSERT', '{"uuid": "0ca35f5d-778f-4207-88ae-beb5a648a6f6", "roletype": "OWNER", "objectuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '511d8f3d-266d-4c3a-9091-a7b16d8e61bc', 'INSERT', '{"op": "DELETE", "uuid": "511d8f3d-266d-4c3a-9091-a7b16d8e61bc", "objectuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '65143c28-70ba-4227-aca5-44d39e0fb9b0', 'INSERT', '{"uuid": "65143c28-70ba-4227-aca5-44d39e0fb9b0", "assumed": true, "ascendantuuid": "0ca35f5d-778f-4207-88ae-beb5a648a6f6", "descendantuuid": "511d8f3d-266d-4c3a-9091-a7b16d8e61bc", "grantedbyroleuuid": null, "grantedbytriggerof": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '35ba2de2-3f5c-4f0d-82e0-ca7cfaf14bb4', 'INSERT', '{"uuid": "35ba2de2-3f5c-4f0d-82e0-ca7cfaf14bb4", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0ca35f5d-778f-4207-88ae-beb5a648a6f6", "grantedbyroleuuid": null, "grantedbytriggerof": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '261bdd26-069f-492d-94c1-37002eeeaad2', 'INSERT', '{"uuid": "261bdd26-069f-492d-94c1-37002eeeaad2", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0ca35f5d-778f-4207-88ae-beb5a648a6f6", "grantedbyroleuuid": "0ca35f5d-778f-4207-88ae-beb5a648a6f6", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', 'INSERT', '{"uuid": "5b391d1b-439d-4ba6-9be1-dc9e8c161c7c", "roletype": "ADMIN", "objectuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '61aef2e8-ca62-4a62-8a4c-6a56f6fa6880', 'INSERT', '{"op": "UPDATE", "uuid": "61aef2e8-ca62-4a62-8a4c-6a56f6fa6880", "objectuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'b08f5236-cdc2-44b9-b9a9-d7696970d60e', 'INSERT', '{"uuid": "b08f5236-cdc2-44b9-b9a9-d7696970d60e", "assumed": true, "ascendantuuid": "5b391d1b-439d-4ba6-9be1-dc9e8c161c7c", "descendantuuid": "61aef2e8-ca62-4a62-8a4c-6a56f6fa6880", "grantedbyroleuuid": null, "grantedbytriggerof": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '98c73e4b-bf68-4de3-8b95-522b70836830', 'INSERT', '{"uuid": "98c73e4b-bf68-4de3-8b95-522b70836830", "assumed": true, "ascendantuuid": "0ca35f5d-778f-4207-88ae-beb5a648a6f6", "descendantuuid": "5b391d1b-439d-4ba6-9be1-dc9e8c161c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '5167487b-90ee-40b9-9c34-535b74b3186e', 'INSERT', '{"uuid": "5167487b-90ee-40b9-9c34-535b74b3186e", "roletype": "REFERRER", "objectuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'f03d3fab-a32c-40a8-9fb3-ff456bbb7f45', 'INSERT', '{"op": "SELECT", "uuid": "f03d3fab-a32c-40a8-9fb3-ff456bbb7f45", "objectuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'cbc774db-9885-4387-89e7-a07bd21d1197', 'INSERT', '{"uuid": "cbc774db-9885-4387-89e7-a07bd21d1197", "assumed": true, "ascendantuuid": "5167487b-90ee-40b9-9c34-535b74b3186e", "descendantuuid": "f03d3fab-a32c-40a8-9fb3-ff456bbb7f45", "grantedbyroleuuid": null, "grantedbytriggerof": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '639d2da7-6cde-485e-a12c-047e5345ec38', 'INSERT', '{"uuid": "639d2da7-6cde-485e-a12c-047e5345ec38", "assumed": true, "ascendantuuid": "5b391d1b-439d-4ba6-9be1-dc9e8c161c7c", "descendantuuid": "5167487b-90ee-40b9-9c34-535b74b3186e", "grantedbyroleuuid": null, "grantedbytriggerof": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'INSERT', '{"uuid": "25358342-4f90-4397-b4c4-d90524ac0b7b", "caption": "Wasserwerk Südholstein, Frau Christiane Milberg", "version": 0, "phonenumbers": {"phone_mobile": "+49 4103 12345-1"}, "postaladdress": {"city": "Hetlingen", "firm": "Frau Christiane Milberg", "name": "Frau Christiane Milberg", "street": "Am Wasserwerk 1-3", "country": "Germany", "zipcode": "25491"}, "emailaddresses": {"main": "rechnung@ww-sholst.example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'INSERT', '{"uuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9", "serialid": 141, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'a0a8a5e1-e11f-44ec-984f-163e049c81e1', 'INSERT', '{"uuid": "a0a8a5e1-e11f-44ec-984f-163e049c81e1", "roletype": "OWNER", "objectuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '4a861961-b89b-4ed1-8a22-076edb1fe182', 'INSERT', '{"op": "DELETE", "uuid": "4a861961-b89b-4ed1-8a22-076edb1fe182", "objectuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'e58bbe06-9100-4157-8366-e69f6535d72c', 'INSERT', '{"uuid": "e58bbe06-9100-4157-8366-e69f6535d72c", "assumed": true, "ascendantuuid": "a0a8a5e1-e11f-44ec-984f-163e049c81e1", "descendantuuid": "4a861961-b89b-4ed1-8a22-076edb1fe182", "grantedbyroleuuid": null, "grantedbytriggerof": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '0cb20f17-8aa9-462d-bae3-4f7cae45bb4a', 'INSERT', '{"uuid": "0cb20f17-8aa9-462d-bae3-4f7cae45bb4a", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "a0a8a5e1-e11f-44ec-984f-163e049c81e1", "grantedbyroleuuid": null, "grantedbytriggerof": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '0489eda3-8f56-426a-9be6-f9f689c0e29c', 'INSERT', '{"uuid": "0489eda3-8f56-426a-9be6-f9f689c0e29c", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "a0a8a5e1-e11f-44ec-984f-163e049c81e1", "grantedbyroleuuid": "a0a8a5e1-e11f-44ec-984f-163e049c81e1", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '4241127c-1c6d-41b4-9350-3aa73785f6c5', 'INSERT', '{"uuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "roletype": "ADMIN", "objectuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '0c9f6461-5ab3-4c39-870d-e66aacd5d522', 'INSERT', '{"op": "UPDATE", "uuid": "0c9f6461-5ab3-4c39-870d-e66aacd5d522", "objectuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '70d7d9f3-1b2e-4257-88c3-28884d0d6c03', 'INSERT', '{"uuid": "70d7d9f3-1b2e-4257-88c3-28884d0d6c03", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "0c9f6461-5ab3-4c39-870d-e66aacd5d522", "grantedbyroleuuid": null, "grantedbytriggerof": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '88d40a3a-1282-4655-a268-c2095662d402', 'INSERT', '{"uuid": "88d40a3a-1282-4655-a268-c2095662d402", "assumed": true, "ascendantuuid": "a0a8a5e1-e11f-44ec-984f-163e049c81e1", "descendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "grantedbyroleuuid": null, "grantedbytriggerof": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '206fcdf2-c22e-480f-9029-42183cc2990e', 'INSERT', '{"uuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "roletype": "REFERRER", "objectuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '7d188b98-3755-4753-b776-7226df8db3bb', 'INSERT', '{"op": "SELECT", "uuid": "7d188b98-3755-4753-b776-7226df8db3bb", "objectuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '6d609f65-3a9a-4ef3-a184-29c63d54bb41', 'INSERT', '{"uuid": "6d609f65-3a9a-4ef3-a184-29c63d54bb41", "assumed": true, "ascendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "descendantuuid": "7d188b98-3755-4753-b776-7226df8db3bb", "grantedbyroleuuid": null, "grantedbytriggerof": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'c84f3466-1307-4db5-87e0-69216ef0e261', 'INSERT', '{"uuid": "c84f3466-1307-4db5-87e0-69216ef0e261", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "grantedbyroleuuid": null, "grantedbytriggerof": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'INSERT', '{"uuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9", "caption": "Das Perfekte Haus, Herr Richard Wiese", "version": 0, "phonenumbers": {"phone_mobile": "+49-172-12345"}, "postaladdress": {"city": "Essen", "firm": "Herr Richard Wiese", "name": "Herr Richard Wiese", "street": "Kennedyplatz 11", "country": "Germany", "zipcode": "45279"}, "emailaddresses": {"main": "admin@das-perfekte-haus.example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '9dcab961-1465-40e3-8d83-357b22af2674', 'INSERT', '{"uuid": "9dcab961-1465-40e3-8d83-357b22af2674", "serialid": 142, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '51c51fa2-3706-470a-9d15-0bad421ea7d4', 'INSERT', '{"uuid": "51c51fa2-3706-470a-9d15-0bad421ea7d4", "roletype": "OWNER", "objectuuid": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '8973550c-23a8-40d5-bd36-4b4f8608841e', 'INSERT', '{"op": "DELETE", "uuid": "8973550c-23a8-40d5-bd36-4b4f8608841e", "objectuuid": "9dcab961-1465-40e3-8d83-357b22af2674", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'd18a6927-8a9f-45ce-8554-99aabdc230c0', 'INSERT', '{"uuid": "d18a6927-8a9f-45ce-8554-99aabdc230c0", "assumed": true, "ascendantuuid": "51c51fa2-3706-470a-9d15-0bad421ea7d4", "descendantuuid": "8973550c-23a8-40d5-bd36-4b4f8608841e", "grantedbyroleuuid": null, "grantedbytriggerof": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '5b65a62a-3150-4e79-a90e-58b7a31cbada', 'INSERT', '{"uuid": "5b65a62a-3150-4e79-a90e-58b7a31cbada", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "51c51fa2-3706-470a-9d15-0bad421ea7d4", "grantedbyroleuuid": null, "grantedbytriggerof": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '7bc4246e-62a8-41a4-a057-93d2d0554b06', 'INSERT', '{"uuid": "7bc4246e-62a8-41a4-a057-93d2d0554b06", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "51c51fa2-3706-470a-9d15-0bad421ea7d4", "grantedbyroleuuid": "51c51fa2-3706-470a-9d15-0bad421ea7d4", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'd3aa37e9-88d7-4099-8fa8-0bb25f6db328', 'INSERT', '{"uuid": "d3aa37e9-88d7-4099-8fa8-0bb25f6db328", "roletype": "ADMIN", "objectuuid": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'e887ff28-0576-46a5-8faa-b4167f9cab6a', 'INSERT', '{"op": "UPDATE", "uuid": "e887ff28-0576-46a5-8faa-b4167f9cab6a", "objectuuid": "9dcab961-1465-40e3-8d83-357b22af2674", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '770efe1f-9453-43ee-afcb-5cd49c3892c3', 'INSERT', '{"uuid": "770efe1f-9453-43ee-afcb-5cd49c3892c3", "assumed": true, "ascendantuuid": "d3aa37e9-88d7-4099-8fa8-0bb25f6db328", "descendantuuid": "e887ff28-0576-46a5-8faa-b4167f9cab6a", "grantedbyroleuuid": null, "grantedbytriggerof": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '1b729cee-fb30-418a-a54a-36e1451ff572', 'INSERT', '{"uuid": "1b729cee-fb30-418a-a54a-36e1451ff572", "assumed": true, "ascendantuuid": "51c51fa2-3706-470a-9d15-0bad421ea7d4", "descendantuuid": "d3aa37e9-88d7-4099-8fa8-0bb25f6db328", "grantedbyroleuuid": null, "grantedbytriggerof": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '3f62e7fa-ffed-4a15-88c2-2d4a231c7db0', 'INSERT', '{"uuid": "3f62e7fa-ffed-4a15-88c2-2d4a231c7db0", "roletype": "REFERRER", "objectuuid": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '6becffbf-7ca9-422d-a429-c022f023d9ae', 'INSERT', '{"op": "SELECT", "uuid": "6becffbf-7ca9-422d-a429-c022f023d9ae", "objectuuid": "9dcab961-1465-40e3-8d83-357b22af2674", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '037d9131-fdbd-4a05-9713-571bc29a4c5f', 'INSERT', '{"uuid": "037d9131-fdbd-4a05-9713-571bc29a4c5f", "assumed": true, "ascendantuuid": "3f62e7fa-ffed-4a15-88c2-2d4a231c7db0", "descendantuuid": "6becffbf-7ca9-422d-a429-c022f023d9ae", "grantedbyroleuuid": null, "grantedbytriggerof": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'cc1ad7a3-7342-42a8-b4e7-7fb740cb582f', 'INSERT', '{"uuid": "cc1ad7a3-7342-42a8-b4e7-7fb740cb582f", "assumed": true, "ascendantuuid": "d3aa37e9-88d7-4099-8fa8-0bb25f6db328", "descendantuuid": "3f62e7fa-ffed-4a15-88c2-2d4a231c7db0", "grantedbyroleuuid": null, "grantedbytriggerof": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '9dcab961-1465-40e3-8d83-357b22af2674', 'INSERT', '{"uuid": "9dcab961-1465-40e3-8d83-357b22af2674", "caption": "Wasswerwerk Südholstein, Herr Karim Metzger", "version": 0, "phonenumbers": {"phone_office": "+49 4103 12345-2"}, "postaladdress": {"city": "Hetlingen", "firm": "Herr Karim Metzger", "name": "Herr Karim Metzger", "street": "Am Wasserwerk 1-3", "country": "Germany", "zipcode": "25491"}, "emailaddresses": {"main": "karim.metzger@ww-sholst.example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', 'INSERT', '{"uuid": "29e2d42f-5f00-467f-ab73-f2ff59f2792d", "serialid": 143, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'e1947aaf-5b7f-4597-b296-25830e9c945b', 'INSERT', '{"uuid": "e1947aaf-5b7f-4597-b296-25830e9c945b", "roletype": "OWNER", "objectuuid": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '32860409-f9d0-41f3-b19e-25a38bdabc3f', 'INSERT', '{"op": "DELETE", "uuid": "32860409-f9d0-41f3-b19e-25a38bdabc3f", "objectuuid": "29e2d42f-5f00-467f-ab73-f2ff59f2792d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'cfae6716-5c5d-4660-860a-23a4e38d7195', 'INSERT', '{"uuid": "cfae6716-5c5d-4660-860a-23a4e38d7195", "assumed": true, "ascendantuuid": "e1947aaf-5b7f-4597-b296-25830e9c945b", "descendantuuid": "32860409-f9d0-41f3-b19e-25a38bdabc3f", "grantedbyroleuuid": null, "grantedbytriggerof": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'fae58d16-9c53-4135-b39d-992743c48c95', 'INSERT', '{"uuid": "fae58d16-9c53-4135-b39d-992743c48c95", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "e1947aaf-5b7f-4597-b296-25830e9c945b", "grantedbyroleuuid": null, "grantedbytriggerof": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '45c1954e-b8f8-47fe-b0cc-d458567060f9', 'INSERT', '{"uuid": "45c1954e-b8f8-47fe-b0cc-d458567060f9", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "e1947aaf-5b7f-4597-b296-25830e9c945b", "grantedbyroleuuid": "e1947aaf-5b7f-4597-b296-25830e9c945b", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'a822e970-7b6a-417d-81d0-a8db0c985427', 'INSERT', '{"uuid": "a822e970-7b6a-417d-81d0-a8db0c985427", "roletype": "ADMIN", "objectuuid": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '44f00bec-0091-4523-9235-84aa669de6df', 'INSERT', '{"op": "UPDATE", "uuid": "44f00bec-0091-4523-9235-84aa669de6df", "objectuuid": "29e2d42f-5f00-467f-ab73-f2ff59f2792d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '97a6f3c4-8311-42b1-a519-cdf832ea682f', 'INSERT', '{"uuid": "97a6f3c4-8311-42b1-a519-cdf832ea682f", "assumed": true, "ascendantuuid": "a822e970-7b6a-417d-81d0-a8db0c985427", "descendantuuid": "44f00bec-0091-4523-9235-84aa669de6df", "grantedbyroleuuid": null, "grantedbytriggerof": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'dbde9321-b71c-4e2e-a4d0-fc7233d09904', 'INSERT', '{"uuid": "dbde9321-b71c-4e2e-a4d0-fc7233d09904", "assumed": true, "ascendantuuid": "e1947aaf-5b7f-4597-b296-25830e9c945b", "descendantuuid": "a822e970-7b6a-417d-81d0-a8db0c985427", "grantedbyroleuuid": null, "grantedbytriggerof": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '6fc5eacb-5328-41c3-a71b-e7712338862a', 'INSERT', '{"uuid": "6fc5eacb-5328-41c3-a71b-e7712338862a", "roletype": "REFERRER", "objectuuid": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'efb67518-722d-4f1b-8280-e3f894406dd5', 'INSERT', '{"op": "SELECT", "uuid": "efb67518-722d-4f1b-8280-e3f894406dd5", "objectuuid": "29e2d42f-5f00-467f-ab73-f2ff59f2792d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'db770b7e-a585-4a52-9bdb-586c846f50f4', 'INSERT', '{"uuid": "db770b7e-a585-4a52-9bdb-586c846f50f4", "assumed": true, "ascendantuuid": "6fc5eacb-5328-41c3-a71b-e7712338862a", "descendantuuid": "efb67518-722d-4f1b-8280-e3f894406dd5", "grantedbyroleuuid": null, "grantedbytriggerof": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '9802498c-ba4f-455b-99e0-7d3d74aaf888', 'INSERT', '{"uuid": "9802498c-ba4f-455b-99e0-7d3d74aaf888", "assumed": true, "ascendantuuid": "a822e970-7b6a-417d-81d0-a8db0c985427", "descendantuuid": "6fc5eacb-5328-41c3-a71b-e7712338862a", "grantedbyroleuuid": null, "grantedbytriggerof": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', 'INSERT', '{"uuid": "29e2d42f-5f00-467f-ab73-f2ff59f2792d", "caption": "Das Perfekte Haus, Herr Inhaber R. Wiese", "version": 0, "phonenumbers": {}, "postaladdress": {"co": "Client-ID 515217", "city": "Hannover", "firm": "Herr Inhaber R. Wiese", "name": "Herr Inhaber R. Wiese", "street": "Essen, Kastanienallee 81", "country": "Germany", "zipcode": "30127"}, "emailaddresses": {"main": "515217@kkemail.example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'INSERT', '{"uuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4", "serialid": 144, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '87f8ac1d-b082-4961-979c-cd3de0e46b21', 'INSERT', '{"uuid": "87f8ac1d-b082-4961-979c-cd3de0e46b21", "roletype": "OWNER", "objectuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'b8a958a1-b18b-4198-995c-7057791c7b6f', 'INSERT', '{"op": "DELETE", "uuid": "b8a958a1-b18b-4198-995c-7057791c7b6f", "objectuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'e0c6a190-5a5b-49cb-b6cd-3aa97d65effd', 'INSERT', '{"uuid": "e0c6a190-5a5b-49cb-b6cd-3aa97d65effd", "assumed": true, "ascendantuuid": "87f8ac1d-b082-4961-979c-cd3de0e46b21", "descendantuuid": "b8a958a1-b18b-4198-995c-7057791c7b6f", "grantedbyroleuuid": null, "grantedbytriggerof": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '7a7b3b25-55a2-45a7-8e73-3965f6d42114', 'INSERT', '{"uuid": "7a7b3b25-55a2-45a7-8e73-3965f6d42114", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "87f8ac1d-b082-4961-979c-cd3de0e46b21", "grantedbyroleuuid": null, "grantedbytriggerof": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '9cc8dbdf-4ffa-4c8c-9eeb-3dc4f291cb58', 'INSERT', '{"uuid": "9cc8dbdf-4ffa-4c8c-9eeb-3dc4f291cb58", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "87f8ac1d-b082-4961-979c-cd3de0e46b21", "grantedbyroleuuid": "87f8ac1d-b082-4961-979c-cd3de0e46b21", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'ba7a634b-c352-418c-a8c0-58918f32f8a7', 'INSERT', '{"uuid": "ba7a634b-c352-418c-a8c0-58918f32f8a7", "roletype": "ADMIN", "objectuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'e3eeab03-d7bd-4dcc-b076-3bca06fcedcd', 'INSERT', '{"op": "UPDATE", "uuid": "e3eeab03-d7bd-4dcc-b076-3bca06fcedcd", "objectuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'a24d7161-01ec-47ee-8290-1881e4330e97', 'INSERT', '{"uuid": "a24d7161-01ec-47ee-8290-1881e4330e97", "assumed": true, "ascendantuuid": "ba7a634b-c352-418c-a8c0-58918f32f8a7", "descendantuuid": "e3eeab03-d7bd-4dcc-b076-3bca06fcedcd", "grantedbyroleuuid": null, "grantedbytriggerof": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '1f5371fd-18c4-452c-bf30-f45a8c955118', 'INSERT', '{"uuid": "1f5371fd-18c4-452c-bf30-f45a8c955118", "assumed": true, "ascendantuuid": "87f8ac1d-b082-4961-979c-cd3de0e46b21", "descendantuuid": "ba7a634b-c352-418c-a8c0-58918f32f8a7", "grantedbyroleuuid": null, "grantedbytriggerof": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'ed0f7762-a094-4a88-abde-8472da33bcfb', 'INSERT', '{"uuid": "ed0f7762-a094-4a88-abde-8472da33bcfb", "roletype": "REFERRER", "objectuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '1be4a900-49fe-4fef-b4f5-47643f463859', 'INSERT', '{"op": "SELECT", "uuid": "1be4a900-49fe-4fef-b4f5-47643f463859", "objectuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '8b2e92c5-76d2-44a9-88b8-72059bf35a81', 'INSERT', '{"uuid": "8b2e92c5-76d2-44a9-88b8-72059bf35a81", "assumed": true, "ascendantuuid": "ed0f7762-a094-4a88-abde-8472da33bcfb", "descendantuuid": "1be4a900-49fe-4fef-b4f5-47643f463859", "grantedbyroleuuid": null, "grantedbytriggerof": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '3b14bdbd-9cb9-4aeb-8e52-bec6d5560cda', 'INSERT', '{"uuid": "3b14bdbd-9cb9-4aeb-8e52-bec6d5560cda", "assumed": true, "ascendantuuid": "ba7a634b-c352-418c-a8c0-58918f32f8a7", "descendantuuid": "ed0f7762-a094-4a88-abde-8472da33bcfb", "grantedbyroleuuid": null, "grantedbytriggerof": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'INSERT', '{"uuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4", "caption": "Ragnar Richter", "version": 0, "phonenumbers": {}, "postaladdress": {"name": "Ragnar Richter"}, "emailaddresses": {"main": "mail@ragnar-richter..example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'INSERT', '{"uuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1", "serialid": 145, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '9455fccb-71fa-4cff-bf89-5dfc719f3374', 'INSERT', '{"uuid": "9455fccb-71fa-4cff-bf89-5dfc719f3374", "roletype": "OWNER", "objectuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'ea674a43-6195-4c02-8bbf-88c2255030ce', 'INSERT', '{"op": "DELETE", "uuid": "ea674a43-6195-4c02-8bbf-88c2255030ce", "objectuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '77236f22-0606-4573-a7c3-7d5f21cf9486', 'INSERT', '{"uuid": "77236f22-0606-4573-a7c3-7d5f21cf9486", "assumed": true, "ascendantuuid": "9455fccb-71fa-4cff-bf89-5dfc719f3374", "descendantuuid": "ea674a43-6195-4c02-8bbf-88c2255030ce", "grantedbyroleuuid": null, "grantedbytriggerof": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'd13c0466-206b-4584-ac93-2be555771c4b', 'INSERT', '{"uuid": "d13c0466-206b-4584-ac93-2be555771c4b", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "9455fccb-71fa-4cff-bf89-5dfc719f3374", "grantedbyroleuuid": null, "grantedbytriggerof": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '4804c996-c47f-4784-beae-80a51ee0d044', 'INSERT', '{"uuid": "4804c996-c47f-4784-beae-80a51ee0d044", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "9455fccb-71fa-4cff-bf89-5dfc719f3374", "grantedbyroleuuid": "9455fccb-71fa-4cff-bf89-5dfc719f3374", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'fdcffa04-a455-4869-ab8f-2f2fa05e4b02', 'INSERT', '{"uuid": "fdcffa04-a455-4869-ab8f-2f2fa05e4b02", "roletype": "ADMIN", "objectuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'e6b918a1-edaa-4170-b6eb-9c8257b9a72a', 'INSERT', '{"op": "UPDATE", "uuid": "e6b918a1-edaa-4170-b6eb-9c8257b9a72a", "objectuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '6f889e57-27bc-4441-be05-633783ab6321', 'INSERT', '{"uuid": "6f889e57-27bc-4441-be05-633783ab6321", "assumed": true, "ascendantuuid": "fdcffa04-a455-4869-ab8f-2f2fa05e4b02", "descendantuuid": "e6b918a1-edaa-4170-b6eb-9c8257b9a72a", "grantedbyroleuuid": null, "grantedbytriggerof": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'bd9e86d9-db1d-4fae-9ad6-79692780436a', 'INSERT', '{"uuid": "bd9e86d9-db1d-4fae-9ad6-79692780436a", "assumed": true, "ascendantuuid": "9455fccb-71fa-4cff-bf89-5dfc719f3374", "descendantuuid": "fdcffa04-a455-4869-ab8f-2f2fa05e4b02", "grantedbyroleuuid": null, "grantedbytriggerof": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '67b756a8-aff9-439d-8ac8-b8965b63ac32', 'INSERT', '{"uuid": "67b756a8-aff9-439d-8ac8-b8965b63ac32", "roletype": "REFERRER", "objectuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'c3fa6a59-6d7a-4f1a-a5a5-3ebf64250a5d', 'INSERT', '{"op": "SELECT", "uuid": "c3fa6a59-6d7a-4f1a-a5a5-3ebf64250a5d", "objectuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '090e641c-573b-47d3-b254-f0ce4c80861b', 'INSERT', '{"uuid": "090e641c-573b-47d3-b254-f0ce4c80861b", "assumed": true, "ascendantuuid": "67b756a8-aff9-439d-8ac8-b8965b63ac32", "descendantuuid": "c3fa6a59-6d7a-4f1a-a5a5-3ebf64250a5d", "grantedbyroleuuid": null, "grantedbytriggerof": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'c65ea937-2e00-4ac5-8662-3411d66bca56', 'INSERT', '{"uuid": "c65ea937-2e00-4ac5-8662-3411d66bca56", "assumed": true, "ascendantuuid": "fdcffa04-a455-4869-ab8f-2f2fa05e4b02", "descendantuuid": "67b756a8-aff9-439d-8ac8-b8965b63ac32", "grantedbyroleuuid": null, "grantedbytriggerof": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'INSERT', '{"uuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1", "caption": "Eike Henning", "version": 0, "phonenumbers": {}, "postaladdress": {"name": "Eike Henning"}, "emailaddresses": {"main": "hostsharing@eike-henning..example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'INSERT', '{"uuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007", "serialid": 146, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'd85c013c-e791-4bec-ac0d-a217472cf425', 'INSERT', '{"uuid": "d85c013c-e791-4bec-ac0d-a217472cf425", "roletype": "OWNER", "objectuuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'c21abea9-6973-44c7-91f4-2d163d97764d', 'INSERT', '{"op": "DELETE", "uuid": "c21abea9-6973-44c7-91f4-2d163d97764d", "objectuuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '47db507d-3dd0-47db-bed5-e37816975659', 'INSERT', '{"uuid": "47db507d-3dd0-47db-bed5-e37816975659", "assumed": true, "ascendantuuid": "d85c013c-e791-4bec-ac0d-a217472cf425", "descendantuuid": "c21abea9-6973-44c7-91f4-2d163d97764d", "grantedbyroleuuid": null, "grantedbytriggerof": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'cd5c0a3d-5b3c-4f9f-953d-a2950af2ca73', 'INSERT', '{"uuid": "cd5c0a3d-5b3c-4f9f-953d-a2950af2ca73", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "d85c013c-e791-4bec-ac0d-a217472cf425", "grantedbyroleuuid": null, "grantedbytriggerof": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'ce7f6e0e-e793-4c9f-921c-4432f946d110', 'INSERT', '{"uuid": "ce7f6e0e-e793-4c9f-921c-4432f946d110", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "d85c013c-e791-4bec-ac0d-a217472cf425", "grantedbyroleuuid": "d85c013c-e791-4bec-ac0d-a217472cf425", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '60297e5d-2f7d-4734-9a25-f2639ffb7fb4', 'INSERT', '{"uuid": "60297e5d-2f7d-4734-9a25-f2639ffb7fb4", "roletype": "ADMIN", "objectuuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'b94eb65e-0105-4cf9-b238-cd3e4715c08d', 'INSERT', '{"op": "UPDATE", "uuid": "b94eb65e-0105-4cf9-b238-cd3e4715c08d", "objectuuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'e3dd23a9-7be6-4ba0-8799-4a420de0b930', 'INSERT', '{"uuid": "e3dd23a9-7be6-4ba0-8799-4a420de0b930", "assumed": true, "ascendantuuid": "60297e5d-2f7d-4734-9a25-f2639ffb7fb4", "descendantuuid": "b94eb65e-0105-4cf9-b238-cd3e4715c08d", "grantedbyroleuuid": null, "grantedbytriggerof": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '31a6e718-6d5a-4c09-b12f-076bec7e334d', 'INSERT', '{"uuid": "31a6e718-6d5a-4c09-b12f-076bec7e334d", "assumed": true, "ascendantuuid": "d85c013c-e791-4bec-ac0d-a217472cf425", "descendantuuid": "60297e5d-2f7d-4734-9a25-f2639ffb7fb4", "grantedbyroleuuid": null, "grantedbytriggerof": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', '7454ce37-a2ba-4f52-a5da-2190203ca089', 'INSERT', '{"uuid": "7454ce37-a2ba-4f52-a5da-2190203ca089", "roletype": "REFERRER", "objectuuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '98ecef93-9816-44dc-a028-61cc9403efb9', 'INSERT', '{"op": "SELECT", "uuid": "98ecef93-9816-44dc-a028-61cc9403efb9", "objectuuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'de0e18ad-bff5-42bd-9384-30a5eec6ef5f', 'INSERT', '{"uuid": "de0e18ad-bff5-42bd-9384-30a5eec6ef5f", "assumed": true, "ascendantuuid": "7454ce37-a2ba-4f52-a5da-2190203ca089", "descendantuuid": "98ecef93-9816-44dc-a028-61cc9403efb9", "grantedbyroleuuid": null, "grantedbytriggerof": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'c58f4061-42f2-4606-9ea7-ffbcf8889610', 'INSERT', '{"uuid": "c58f4061-42f2-4606-9ea7-ffbcf8889610", "assumed": true, "ascendantuuid": "60297e5d-2f7d-4734-9a25-f2639ffb7fb4", "descendantuuid": "7454ce37-a2ba-4f52-a5da-2190203ca089", "grantedbyroleuuid": null, "grantedbytriggerof": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'INSERT', '{"uuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007", "caption": "Jan Henning", "version": 0, "phonenumbers": {"phone_office": "01577 12345678"}, "postaladdress": {"name": "Jan Henning"}, "emailaddresses": {"main": "mail@jan-henning.example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.object', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', 'INSERT', '{"uuid": "c3b8c521-37f4-46b8-89f7-1931159e9a14", "serialid": 147, "objecttable": "hs_office.contact"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'd8bc6523-20de-42c3-93e6-5884924a7cdb', 'INSERT', '{"uuid": "d8bc6523-20de-42c3-93e6-5884924a7cdb", "roletype": "OWNER", "objectuuid": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'eed193d1-f65d-4738-b8ee-d991aeea4389', 'INSERT', '{"op": "DELETE", "uuid": "eed193d1-f65d-4738-b8ee-d991aeea4389", "objectuuid": "c3b8c521-37f4-46b8-89f7-1931159e9a14", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '54f14461-8203-4ba6-a130-81ece6161f31', 'INSERT', '{"uuid": "54f14461-8203-4ba6-a130-81ece6161f31", "assumed": true, "ascendantuuid": "d8bc6523-20de-42c3-93e6-5884924a7cdb", "descendantuuid": "eed193d1-f65d-4738-b8ee-d991aeea4389", "grantedbyroleuuid": null, "grantedbytriggerof": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '5b48c930-e321-426a-a187-8f91c01d9e35', 'INSERT', '{"uuid": "5b48c930-e321-426a-a187-8f91c01d9e35", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "d8bc6523-20de-42c3-93e6-5884924a7cdb", "grantedbyroleuuid": null, "grantedbytriggerof": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'c5de6e0e-6325-4985-b5da-83c71d1cfd7e', 'INSERT', '{"uuid": "c5de6e0e-6325-4985-b5da-83c71d1cfd7e", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "d8bc6523-20de-42c3-93e6-5884924a7cdb", "grantedbyroleuuid": "d8bc6523-20de-42c3-93e6-5884924a7cdb", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'da9600c2-7dcc-4a7d-87f1-33f4a441e807', 'INSERT', '{"uuid": "da9600c2-7dcc-4a7d-87f1-33f4a441e807", "roletype": "ADMIN", "objectuuid": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', '03602c91-9c55-4264-8c24-9f9d3cbaf869', 'INSERT', '{"op": "UPDATE", "uuid": "03602c91-9c55-4264-8c24-9f9d3cbaf869", "objectuuid": "c3b8c521-37f4-46b8-89f7-1931159e9a14", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', 'f52af204-37d3-428e-a836-5ee0b68136e2', 'INSERT', '{"uuid": "f52af204-37d3-428e-a836-5ee0b68136e2", "assumed": true, "ascendantuuid": "da9600c2-7dcc-4a7d-87f1-33f4a441e807", "descendantuuid": "03602c91-9c55-4264-8c24-9f9d3cbaf869", "grantedbyroleuuid": null, "grantedbytriggerof": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '3bdcb54f-c406-4e62-9240-b03ed38f3589', 'INSERT', '{"uuid": "3bdcb54f-c406-4e62-9240-b03ed38f3589", "assumed": true, "ascendantuuid": "d8bc6523-20de-42c3-93e6-5884924a7cdb", "descendantuuid": "da9600c2-7dcc-4a7d-87f1-33f4a441e807", "grantedbyroleuuid": null, "grantedbytriggerof": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.role', 'f1afc7a2-588d-4b7e-9975-7b0eda21f846', 'INSERT', '{"uuid": "f1afc7a2-588d-4b7e-9975-7b0eda21f846", "roletype": "REFERRER", "objectuuid": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.permission', 'f8a806d8-a37b-4513-a77d-26cf05108c68', 'INSERT', '{"op": "SELECT", "uuid": "f8a806d8-a37b-4513-a77d-26cf05108c68", "objectuuid": "c3b8c521-37f4-46b8-89f7-1931159e9a14", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '4ab945c4-6298-4b12-84ab-6df6fd717d71', 'INSERT', '{"uuid": "4ab945c4-6298-4b12-84ab-6df6fd717d71", "assumed": true, "ascendantuuid": "f1afc7a2-588d-4b7e-9975-7b0eda21f846", "descendantuuid": "f8a806d8-a37b-4513-a77d-26cf05108c68", "grantedbyroleuuid": null, "grantedbytriggerof": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'rbac.grant', '1543772a-3456-474b-926f-6b03d2c47866', 'INSERT', '{"uuid": "1543772a-3456-474b-926f-6b03d2c47866", "assumed": true, "ascendantuuid": "da9600c2-7dcc-4a7d-87f1-33f4a441e807", "descendantuuid": "f1afc7a2-588d-4b7e-9975-7b0eda21f846", "grantedbyroleuuid": null, "grantedbytriggerof": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1692', 'hs_office.contact', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', 'INSERT', '{"uuid": "c3b8c521-37f4-46b8-89f7-1931159e9a14", "caption": "Jan Henning", "version": 0, "phonenumbers": {"phone_office": "01577 12345678"}, "postaladdress": {"name": "Jan Henning"}, "emailaddresses": {"main": "lists@jan-henning.example.org"}}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', '137fb47a-07d4-42cc-b2ef-8e371041cf41', 'INSERT', '{"uuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "serialid": 148, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'c184a3f4-ab4e-4263-a14c-70243c83e166', 'INSERT', '{"uuid": "c184a3f4-ab4e-4263-a14c-70243c83e166", "roletype": "OWNER", "objectuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'd53e98ff-47a8-4be8-a668-c3b45398f278', 'INSERT', '{"op": "DELETE", "uuid": "d53e98ff-47a8-4be8-a668-c3b45398f278", "objectuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '8d35045d-6964-481a-8073-ddc2553fe80f', 'INSERT', '{"uuid": "8d35045d-6964-481a-8073-ddc2553fe80f", "assumed": true, "ascendantuuid": "c184a3f4-ab4e-4263-a14c-70243c83e166", "descendantuuid": "d53e98ff-47a8-4be8-a668-c3b45398f278", "grantedbyroleuuid": null, "grantedbytriggerof": "137fb47a-07d4-42cc-b2ef-8e371041cf41"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '2fb0cd1f-5746-4352-8eab-99c9c7b253be', 'INSERT', '{"uuid": "2fb0cd1f-5746-4352-8eab-99c9c7b253be", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "c184a3f4-ab4e-4263-a14c-70243c83e166", "grantedbyroleuuid": null, "grantedbytriggerof": "137fb47a-07d4-42cc-b2ef-8e371041cf41"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '068b7e74-a547-4ad7-988a-ec1193a9b829', 'INSERT', '{"uuid": "068b7e74-a547-4ad7-988a-ec1193a9b829", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "c184a3f4-ab4e-4263-a14c-70243c83e166", "grantedbyroleuuid": "c184a3f4-ab4e-4263-a14c-70243c83e166", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', 'INSERT', '{"uuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "roletype": "ADMIN", "objectuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'cad96a06-91b7-43d8-897d-7bfb1d7054fc', 'INSERT', '{"op": "UPDATE", "uuid": "cad96a06-91b7-43d8-897d-7bfb1d7054fc", "objectuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '5091c7fa-0b70-4a94-a588-925d1f424c62', 'INSERT', '{"uuid": "5091c7fa-0b70-4a94-a588-925d1f424c62", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "cad96a06-91b7-43d8-897d-7bfb1d7054fc", "grantedbyroleuuid": null, "grantedbytriggerof": "137fb47a-07d4-42cc-b2ef-8e371041cf41"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '23447319-b6db-408b-8619-4b5dff4af765', 'INSERT', '{"uuid": "23447319-b6db-408b-8619-4b5dff4af765", "assumed": true, "ascendantuuid": "c184a3f4-ab4e-4263-a14c-70243c83e166", "descendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "grantedbyroleuuid": null, "grantedbytriggerof": "137fb47a-07d4-42cc-b2ef-8e371041cf41"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '8806c446-5551-4059-ba53-850a2d147c7c', 'INSERT', '{"uuid": "8806c446-5551-4059-ba53-850a2d147c7c", "roletype": "REFERRER", "objectuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '11749bf4-1bba-4698-93cc-41cd8d261166', 'INSERT', '{"op": "SELECT", "uuid": "11749bf4-1bba-4698-93cc-41cd8d261166", "objectuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '309ef53b-eb20-4341-b25e-cff936c534e5', 'INSERT', '{"uuid": "309ef53b-eb20-4341-b25e-cff936c534e5", "assumed": true, "ascendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "descendantuuid": "11749bf4-1bba-4698-93cc-41cd8d261166", "grantedbyroleuuid": null, "grantedbytriggerof": "137fb47a-07d4-42cc-b2ef-8e371041cf41"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'a7fd6d4d-db5f-422b-a4bc-6784cf5276ac', 'INSERT', '{"uuid": "a7fd6d4d-db5f-422b-a4bc-6784cf5276ac", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "137fb47a-07d4-42cc-b2ef-8e371041cf41"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '3807de9b-30c6-4a1a-a434-85e80560d3b5', 'INSERT', '{"op": "INSERT", "uuid": "3807de9b-30c6-4a1a-a434-85e80560d3b5", "objectuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '6f3efb91-1a3a-45a2-8026-5c961b89178c', 'INSERT', '{"uuid": "6f3efb91-1a3a-45a2-8026-5c961b89178c", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "3807de9b-30c6-4a1a-a434-85e80560d3b5", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', '137fb47a-07d4-42cc-b2ef-8e371041cf41', 'INSERT', '{"uuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "title": "", "version": 0, "givenname": "Michael", "tradename": "Michael Mellis", "familyname": "Mellis", "persontype": "??", "salutation": "Herr"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'INSERT', '{"uuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "serialid": 149, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b', 'INSERT', '{"uuid": "a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b", "roletype": "OWNER", "objectuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '0beca0d8-2895-476e-afce-0923bba7e701', 'INSERT', '{"op": "DELETE", "uuid": "0beca0d8-2895-476e-afce-0923bba7e701", "objectuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '3ac85c19-6eb7-47d7-8f20-537a040385bb', 'INSERT', '{"uuid": "3ac85c19-6eb7-47d7-8f20-537a040385bb", "assumed": true, "ascendantuuid": "a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b", "descendantuuid": "0beca0d8-2895-476e-afce-0923bba7e701", "grantedbyroleuuid": null, "grantedbytriggerof": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '5ec2354d-edde-4757-96da-970c87e89500', 'INSERT', '{"uuid": "5ec2354d-edde-4757-96da-970c87e89500", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b", "grantedbyroleuuid": null, "grantedbytriggerof": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'f4f90dbf-44f4-492a-a6b4-8d7991d8fcc0', 'INSERT', '{"uuid": "f4f90dbf-44f4-492a-a6b4-8d7991d8fcc0", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b", "grantedbyroleuuid": "a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'e03da822-f071-4c66-890f-f93a458aec28', 'INSERT', '{"uuid": "e03da822-f071-4c66-890f-f93a458aec28", "roletype": "ADMIN", "objectuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'c8f5fe32-5429-4991-8d88-ba9a79aead8a', 'INSERT', '{"op": "UPDATE", "uuid": "c8f5fe32-5429-4991-8d88-ba9a79aead8a", "objectuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '0b9344e1-c62d-4e82-b513-5b45513dc96b', 'INSERT', '{"uuid": "0b9344e1-c62d-4e82-b513-5b45513dc96b", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "c8f5fe32-5429-4991-8d88-ba9a79aead8a", "grantedbyroleuuid": null, "grantedbytriggerof": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'dad9011e-c9c9-4779-b743-fdf4f50a3bbe', 'INSERT', '{"uuid": "dad9011e-c9c9-4779-b743-fdf4f50a3bbe", "assumed": true, "ascendantuuid": "a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b", "descendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "grantedbyroleuuid": null, "grantedbytriggerof": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', 'INSERT', '{"uuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "roletype": "REFERRER", "objectuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'ff0dff7c-9ef6-4ffd-916b-7a4fad718e8e', 'INSERT', '{"op": "SELECT", "uuid": "ff0dff7c-9ef6-4ffd-916b-7a4fad718e8e", "objectuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '6ed6fa54-5b96-4dbb-a5c7-c3fbedf24aee', 'INSERT', '{"uuid": "6ed6fa54-5b96-4dbb-a5c7-c3fbedf24aee", "assumed": true, "ascendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "descendantuuid": "ff0dff7c-9ef6-4ffd-916b-7a4fad718e8e", "grantedbyroleuuid": null, "grantedbytriggerof": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '0d0534a7-6e05-4f81-b748-0402a99351b1', 'INSERT', '{"uuid": "0d0534a7-6e05-4f81-b748-0402a99351b1", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '7880ca8d-9bf6-4ae4-9056-5677ef591442', 'INSERT', '{"op": "INSERT", "uuid": "7880ca8d-9bf6-4ae4-9056-5677ef591442", "objectuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '26da6601-35ce-4b64-98c7-96c61c2a2f2f', 'INSERT', '{"uuid": "26da6601-35ce-4b64-98c7-96c61c2a2f2f", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "7880ca8d-9bf6-4ae4-9056-5677ef591442", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'INSERT', '{"uuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "title": "", "version": 0, "givenname": "Ragnar", "tradename": "Ragnar IT-Beratung", "familyname": "Richter", "persontype": "??", "salutation": "Herr"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'INSERT', '{"uuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "serialid": 150, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'e811eb41-9645-43d9-86b4-d3b522acede9', 'INSERT', '{"uuid": "e811eb41-9645-43d9-86b4-d3b522acede9", "roletype": "OWNER", "objectuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '3f16c617-f9ff-4634-b4b6-2cee590e2cd0', 'INSERT', '{"op": "DELETE", "uuid": "3f16c617-f9ff-4634-b4b6-2cee590e2cd0", "objectuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '5e5b44c3-3e7d-4fe2-bde4-97dbb16454ed', 'INSERT', '{"uuid": "5e5b44c3-3e7d-4fe2-bde4-97dbb16454ed", "assumed": true, "ascendantuuid": "e811eb41-9645-43d9-86b4-d3b522acede9", "descendantuuid": "3f16c617-f9ff-4634-b4b6-2cee590e2cd0", "grantedbyroleuuid": null, "grantedbytriggerof": "cd48cfd6-6313-408f-ae7d-9af047d0c22e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '823337c9-d747-4b49-8790-14852096547c', 'INSERT', '{"uuid": "823337c9-d747-4b49-8790-14852096547c", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "e811eb41-9645-43d9-86b4-d3b522acede9", "grantedbyroleuuid": null, "grantedbytriggerof": "cd48cfd6-6313-408f-ae7d-9af047d0c22e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '22225af4-299f-4f44-b72c-c6be5446566b', 'INSERT', '{"uuid": "22225af4-299f-4f44-b72c-c6be5446566b", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "e811eb41-9645-43d9-86b4-d3b522acede9", "grantedbyroleuuid": "e811eb41-9645-43d9-86b4-d3b522acede9", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', 'INSERT', '{"uuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "roletype": "ADMIN", "objectuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '4812d3ef-02dc-4a03-8d13-7661dd92477d', 'INSERT', '{"op": "UPDATE", "uuid": "4812d3ef-02dc-4a03-8d13-7661dd92477d", "objectuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '21b50e96-4f64-4e8d-8165-3801e3f86512', 'INSERT', '{"uuid": "21b50e96-4f64-4e8d-8165-3801e3f86512", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "4812d3ef-02dc-4a03-8d13-7661dd92477d", "grantedbyroleuuid": null, "grantedbytriggerof": "cd48cfd6-6313-408f-ae7d-9af047d0c22e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'c45c3ae4-41a5-4285-92ab-e00121bee2ab', 'INSERT', '{"uuid": "c45c3ae4-41a5-4285-92ab-e00121bee2ab", "assumed": true, "ascendantuuid": "e811eb41-9645-43d9-86b4-d3b522acede9", "descendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "grantedbyroleuuid": null, "grantedbytriggerof": "cd48cfd6-6313-408f-ae7d-9af047d0c22e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', 'INSERT', '{"uuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "roletype": "REFERRER", "objectuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '624f1c38-a8ba-40a3-8f6b-dfe76cc36034', 'INSERT', '{"op": "SELECT", "uuid": "624f1c38-a8ba-40a3-8f6b-dfe76cc36034", "objectuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '204f5c32-4252-4adc-9fd7-469b54468378', 'INSERT', '{"uuid": "204f5c32-4252-4adc-9fd7-469b54468378", "assumed": true, "ascendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "descendantuuid": "624f1c38-a8ba-40a3-8f6b-dfe76cc36034", "grantedbyroleuuid": null, "grantedbytriggerof": "cd48cfd6-6313-408f-ae7d-9af047d0c22e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '257ace34-9815-492a-b745-785738584840', 'INSERT', '{"uuid": "257ace34-9815-492a-b745-785738584840", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "cd48cfd6-6313-408f-ae7d-9af047d0c22e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '195afe34-3bc9-43cb-86f7-7eadfb5d25cf', 'INSERT', '{"op": "INSERT", "uuid": "195afe34-3bc9-43cb-86f7-7eadfb5d25cf", "objectuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'df3d2b46-0a7d-4aee-92b6-d54733b3eeea', 'INSERT', '{"uuid": "df3d2b46-0a7d-4aee-92b6-d54733b3eeea", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "195afe34-3bc9-43cb-86f7-7eadfb5d25cf", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'INSERT', '{"uuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "title": "", "version": 0, "givenname": "Hostmaster", "tradename": "Hostsharing e.G.", "familyname": "Hostsharing", "persontype": "LP", "salutation": "Firma"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 'INSERT', '{"uuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50", "serialid": 151, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '02e3a73a-07fc-46df-a14f-569f31249c16', 'INSERT', '{"uuid": "02e3a73a-07fc-46df-a14f-569f31249c16", "roletype": "OWNER", "objectuuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '08a3ffd0-77e4-4759-ad73-d42ca4d2d807', 'INSERT', '{"op": "DELETE", "uuid": "08a3ffd0-77e4-4759-ad73-d42ca4d2d807", "objectuuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'b3cbea4e-8ccf-4922-a338-052705e9d0ef', 'INSERT', '{"uuid": "b3cbea4e-8ccf-4922-a338-052705e9d0ef", "assumed": true, "ascendantuuid": "02e3a73a-07fc-46df-a14f-569f31249c16", "descendantuuid": "08a3ffd0-77e4-4759-ad73-d42ca4d2d807", "grantedbyroleuuid": null, "grantedbytriggerof": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '7f83a692-c740-4cff-a20e-92bcf4c18035', 'INSERT', '{"uuid": "7f83a692-c740-4cff-a20e-92bcf4c18035", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "02e3a73a-07fc-46df-a14f-569f31249c16", "grantedbyroleuuid": null, "grantedbytriggerof": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '64b9ff61-121d-43f0-b9a1-0f7eb0246a16', 'INSERT', '{"uuid": "64b9ff61-121d-43f0-b9a1-0f7eb0246a16", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "02e3a73a-07fc-46df-a14f-569f31249c16", "grantedbyroleuuid": "02e3a73a-07fc-46df-a14f-569f31249c16", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'f87398bc-225a-4eee-bea8-7983be6ae529', 'INSERT', '{"uuid": "f87398bc-225a-4eee-bea8-7983be6ae529", "roletype": "ADMIN", "objectuuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '6e962b9c-39cd-4cec-9750-c36419ff6319', 'INSERT', '{"op": "UPDATE", "uuid": "6e962b9c-39cd-4cec-9750-c36419ff6319", "objectuuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'c2e7ae6a-e0db-4209-91b6-4999c8d03f73', 'INSERT', '{"uuid": "c2e7ae6a-e0db-4209-91b6-4999c8d03f73", "assumed": true, "ascendantuuid": "f87398bc-225a-4eee-bea8-7983be6ae529", "descendantuuid": "6e962b9c-39cd-4cec-9750-c36419ff6319", "grantedbyroleuuid": null, "grantedbytriggerof": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'bc56b982-1a71-4c2b-89e4-e0a39549780e', 'INSERT', '{"uuid": "bc56b982-1a71-4c2b-89e4-e0a39549780e", "assumed": true, "ascendantuuid": "02e3a73a-07fc-46df-a14f-569f31249c16", "descendantuuid": "f87398bc-225a-4eee-bea8-7983be6ae529", "grantedbyroleuuid": null, "grantedbytriggerof": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '236b88d3-09bc-4750-9219-61529f7740af', 'INSERT', '{"uuid": "236b88d3-09bc-4750-9219-61529f7740af", "roletype": "REFERRER", "objectuuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'a5eeaa7d-bf09-41e9-9414-470442665789', 'INSERT', '{"op": "SELECT", "uuid": "a5eeaa7d-bf09-41e9-9414-470442665789", "objectuuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'e0827c85-5cc3-4910-97c3-583c99f782a1', 'INSERT', '{"uuid": "e0827c85-5cc3-4910-97c3-583c99f782a1", "assumed": true, "ascendantuuid": "236b88d3-09bc-4750-9219-61529f7740af", "descendantuuid": "a5eeaa7d-bf09-41e9-9414-470442665789", "grantedbyroleuuid": null, "grantedbytriggerof": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '13f0edf1-7d44-46bc-86d1-cc993ca16624', 'INSERT', '{"uuid": "13f0edf1-7d44-46bc-86d1-cc993ca16624", "assumed": true, "ascendantuuid": "f87398bc-225a-4eee-bea8-7983be6ae529", "descendantuuid": "236b88d3-09bc-4750-9219-61529f7740af", "grantedbyroleuuid": null, "grantedbytriggerof": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '1f552123-71ce-43f0-b091-a43adb7a8a0c', 'INSERT', '{"op": "INSERT", "uuid": "1f552123-71ce-43f0-b091-a43adb7a8a0c", "objectuuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '4a2a86e1-b2b5-40d2-b9f1-d1dfc4440845', 'INSERT', '{"uuid": "4a2a86e1-b2b5-40d2-b9f1-d1dfc4440845", "assumed": true, "ascendantuuid": "f87398bc-225a-4eee-bea8-7983be6ae529", "descendantuuid": "1f552123-71ce-43f0-b091-a43adb7a8a0c", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 'INSERT', '{"uuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50", "title": "", "version": 0, "givenname": "", "tradename": "JM e.K.", "familyname": "", "persontype": "LP", "salutation": ""}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 'INSERT', '{"uuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a", "serialid": 152, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '09a6064d-a472-48e9-9755-d0117f2af6fe', 'INSERT', '{"uuid": "09a6064d-a472-48e9-9755-d0117f2af6fe", "roletype": "OWNER", "objectuuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '4cc5242e-7cc3-426c-9025-ccab1d8a895a', 'INSERT', '{"op": "DELETE", "uuid": "4cc5242e-7cc3-426c-9025-ccab1d8a895a", "objectuuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'e17d863a-af45-4f34-9af7-32054e6c8cd4', 'INSERT', '{"uuid": "e17d863a-af45-4f34-9af7-32054e6c8cd4", "assumed": true, "ascendantuuid": "09a6064d-a472-48e9-9755-d0117f2af6fe", "descendantuuid": "4cc5242e-7cc3-426c-9025-ccab1d8a895a", "grantedbyroleuuid": null, "grantedbytriggerof": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '2cd5f7a6-1c48-40b6-85dd-97b4730d1e6e', 'INSERT', '{"uuid": "2cd5f7a6-1c48-40b6-85dd-97b4730d1e6e", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "09a6064d-a472-48e9-9755-d0117f2af6fe", "grantedbyroleuuid": null, "grantedbytriggerof": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'cfec797b-bb3f-460b-a498-1d3d18eb7ba5', 'INSERT', '{"uuid": "cfec797b-bb3f-460b-a498-1d3d18eb7ba5", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "09a6064d-a472-48e9-9755-d0117f2af6fe", "grantedbyroleuuid": "09a6064d-a472-48e9-9755-d0117f2af6fe", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'bab68a5a-2016-454e-b143-8c334188d2c4', 'INSERT', '{"uuid": "bab68a5a-2016-454e-b143-8c334188d2c4", "roletype": "ADMIN", "objectuuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '60dbf8ee-3263-4878-990f-ab43fe96e48c', 'INSERT', '{"op": "UPDATE", "uuid": "60dbf8ee-3263-4878-990f-ab43fe96e48c", "objectuuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '0f0fd76f-bd0f-47bf-b9a9-88c77f533484', 'INSERT', '{"uuid": "0f0fd76f-bd0f-47bf-b9a9-88c77f533484", "assumed": true, "ascendantuuid": "bab68a5a-2016-454e-b143-8c334188d2c4", "descendantuuid": "60dbf8ee-3263-4878-990f-ab43fe96e48c", "grantedbyroleuuid": null, "grantedbytriggerof": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'ed2e685b-1e10-4252-a32c-7377cf225c03', 'INSERT', '{"uuid": "ed2e685b-1e10-4252-a32c-7377cf225c03", "assumed": true, "ascendantuuid": "09a6064d-a472-48e9-9755-d0117f2af6fe", "descendantuuid": "bab68a5a-2016-454e-b143-8c334188d2c4", "grantedbyroleuuid": null, "grantedbytriggerof": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '9115be3d-2bef-40ce-b0c9-339e460c751d', 'INSERT', '{"uuid": "9115be3d-2bef-40ce-b0c9-339e460c751d", "roletype": "REFERRER", "objectuuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'ba27345e-0699-437d-b4ca-24a8e326c345', 'INSERT', '{"op": "SELECT", "uuid": "ba27345e-0699-437d-b4ca-24a8e326c345", "objectuuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '10659beb-ccc1-47c6-afca-0821a2b3587e', 'INSERT', '{"uuid": "10659beb-ccc1-47c6-afca-0821a2b3587e", "assumed": true, "ascendantuuid": "9115be3d-2bef-40ce-b0c9-339e460c751d", "descendantuuid": "ba27345e-0699-437d-b4ca-24a8e326c345", "grantedbyroleuuid": null, "grantedbytriggerof": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'a4b8b81e-4b83-4a44-bc00-1496f9697af7', 'INSERT', '{"uuid": "a4b8b81e-4b83-4a44-bc00-1496f9697af7", "assumed": true, "ascendantuuid": "bab68a5a-2016-454e-b143-8c334188d2c4", "descendantuuid": "9115be3d-2bef-40ce-b0c9-339e460c751d", "grantedbyroleuuid": null, "grantedbytriggerof": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'f2850544-cbc8-4add-ad35-4b634370b913', 'INSERT', '{"op": "INSERT", "uuid": "f2850544-cbc8-4add-ad35-4b634370b913", "objectuuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '164308f2-2289-4518-bc42-3770b0725b15', 'INSERT', '{"uuid": "164308f2-2289-4518-bc42-3770b0725b15", "assumed": true, "ascendantuuid": "bab68a5a-2016-454e-b143-8c334188d2c4", "descendantuuid": "f2850544-cbc8-4add-ad35-4b634370b913", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 'INSERT', '{"uuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a", "title": "Dr.", "version": 0, "givenname": "Jenny", "tradename": "JM GmbH", "familyname": "Meyer-Billing", "persontype": "LP", "salutation": "Frau"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 'INSERT', '{"uuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "serialid": 153, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'ce0b0564-7cda-4c03-afcc-0854f3c5e519', 'INSERT', '{"uuid": "ce0b0564-7cda-4c03-afcc-0854f3c5e519", "roletype": "OWNER", "objectuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'd1767f98-0fc1-48e6-ab30-0cab02504ee2', 'INSERT', '{"op": "DELETE", "uuid": "d1767f98-0fc1-48e6-ab30-0cab02504ee2", "objectuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'a0d0e550-c7fd-4b7c-b33b-fdffba64003f', 'INSERT', '{"uuid": "a0d0e550-c7fd-4b7c-b33b-fdffba64003f", "assumed": true, "ascendantuuid": "ce0b0564-7cda-4c03-afcc-0854f3c5e519", "descendantuuid": "d1767f98-0fc1-48e6-ab30-0cab02504ee2", "grantedbyroleuuid": null, "grantedbytriggerof": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '55281d1d-424a-4c7e-80a1-907d61c30b64', 'INSERT', '{"uuid": "55281d1d-424a-4c7e-80a1-907d61c30b64", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "ce0b0564-7cda-4c03-afcc-0854f3c5e519", "grantedbyroleuuid": null, "grantedbytriggerof": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '910b67d8-af35-4af5-b349-023fdf38e40f', 'INSERT', '{"uuid": "910b67d8-af35-4af5-b349-023fdf38e40f", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "ce0b0564-7cda-4c03-afcc-0854f3c5e519", "grantedbyroleuuid": "ce0b0564-7cda-4c03-afcc-0854f3c5e519", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'da979efd-9d87-4dc5-a839-493e883cf292', 'INSERT', '{"uuid": "da979efd-9d87-4dc5-a839-493e883cf292", "roletype": "ADMIN", "objectuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'c1816e75-de8d-480d-9a62-30805b9d2f99', 'INSERT', '{"op": "UPDATE", "uuid": "c1816e75-de8d-480d-9a62-30805b9d2f99", "objectuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'f9ae28dd-a2fb-4141-aa60-75c2faf05f18', 'INSERT', '{"uuid": "f9ae28dd-a2fb-4141-aa60-75c2faf05f18", "assumed": true, "ascendantuuid": "da979efd-9d87-4dc5-a839-493e883cf292", "descendantuuid": "c1816e75-de8d-480d-9a62-30805b9d2f99", "grantedbyroleuuid": null, "grantedbytriggerof": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '9e773e6e-6a9a-45a0-870d-7b56be46e253', 'INSERT', '{"uuid": "9e773e6e-6a9a-45a0-870d-7b56be46e253", "assumed": true, "ascendantuuid": "ce0b0564-7cda-4c03-afcc-0854f3c5e519", "descendantuuid": "da979efd-9d87-4dc5-a839-493e883cf292", "grantedbyroleuuid": null, "grantedbytriggerof": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'f913c978-1afc-4af0-9bb6-8c21eed95991', 'INSERT', '{"uuid": "f913c978-1afc-4af0-9bb6-8c21eed95991", "roletype": "REFERRER", "objectuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '374b8a48-00ec-4df2-9320-848bedfad9de', 'INSERT', '{"op": "SELECT", "uuid": "374b8a48-00ec-4df2-9320-848bedfad9de", "objectuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '5ea26201-6404-4ad8-a066-d6a4a355da56', 'INSERT', '{"uuid": "5ea26201-6404-4ad8-a066-d6a4a355da56", "assumed": true, "ascendantuuid": "f913c978-1afc-4af0-9bb6-8c21eed95991", "descendantuuid": "374b8a48-00ec-4df2-9320-848bedfad9de", "grantedbyroleuuid": null, "grantedbytriggerof": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '37ccbf6b-e3c7-4b19-b884-0bfef6a98517', 'INSERT', '{"uuid": "37ccbf6b-e3c7-4b19-b884-0bfef6a98517", "assumed": true, "ascendantuuid": "da979efd-9d87-4dc5-a839-493e883cf292", "descendantuuid": "f913c978-1afc-4af0-9bb6-8c21eed95991", "grantedbyroleuuid": null, "grantedbytriggerof": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'c55c0032-b1a4-47ac-89da-bb9c527a4a73', 'INSERT', '{"op": "INSERT", "uuid": "c55c0032-b1a4-47ac-89da-bb9c527a4a73", "objectuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '082d7c3b-6070-4ff0-999c-fb4be3b5dc62', 'INSERT', '{"uuid": "082d7c3b-6070-4ff0-999c-fb4be3b5dc62", "assumed": true, "ascendantuuid": "da979efd-9d87-4dc5-a839-493e883cf292", "descendantuuid": "c55c0032-b1a4-47ac-89da-bb9c527a4a73", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 'INSERT', '{"uuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "title": "", "version": 0, "givenname": "Andrew", "tradename": "JM GmbH", "familyname": "Meyer-Operation", "persontype": "LP", "salutation": "Herr"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'ff030436-d19e-4606-9d48-7e192eaf469f', 'INSERT', '{"uuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "serialid": 154, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8', 'INSERT', '{"uuid": "cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8", "roletype": "OWNER", "objectuuid": "ff030436-d19e-4606-9d48-7e192eaf469f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'cf0de0eb-126c-4c60-aaf0-626f5c17820a', 'INSERT', '{"op": "DELETE", "uuid": "cf0de0eb-126c-4c60-aaf0-626f5c17820a", "objectuuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'bd6475f8-ba0c-4b5b-b820-74c8c8a26c13', 'INSERT', '{"uuid": "bd6475f8-ba0c-4b5b-b820-74c8c8a26c13", "assumed": true, "ascendantuuid": "cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8", "descendantuuid": "cf0de0eb-126c-4c60-aaf0-626f5c17820a", "grantedbyroleuuid": null, "grantedbytriggerof": "ff030436-d19e-4606-9d48-7e192eaf469f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'f0c593c3-6aa7-43b0-b622-b036d303e7e6', 'INSERT', '{"uuid": "f0c593c3-6aa7-43b0-b622-b036d303e7e6", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8", "grantedbyroleuuid": null, "grantedbytriggerof": "ff030436-d19e-4606-9d48-7e192eaf469f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '2f3d60a9-93d1-43b7-9e05-905451f01c3a', 'INSERT', '{"uuid": "2f3d60a9-93d1-43b7-9e05-905451f01c3a", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8", "grantedbyroleuuid": "cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'b4224d96-af95-4008-9a96-9ae04b44913f', 'INSERT', '{"uuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "roletype": "ADMIN", "objectuuid": "ff030436-d19e-4606-9d48-7e192eaf469f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '38061696-b53f-42a9-86c0-77b7196a871a', 'INSERT', '{"op": "UPDATE", "uuid": "38061696-b53f-42a9-86c0-77b7196a871a", "objectuuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '0601a335-404a-4943-8e99-569022721247', 'INSERT', '{"uuid": "0601a335-404a-4943-8e99-569022721247", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "38061696-b53f-42a9-86c0-77b7196a871a", "grantedbyroleuuid": null, "grantedbytriggerof": "ff030436-d19e-4606-9d48-7e192eaf469f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'efe4417b-8511-40fd-b9d8-9c543cb11579', 'INSERT', '{"uuid": "efe4417b-8511-40fd-b9d8-9c543cb11579", "assumed": true, "ascendantuuid": "cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8", "descendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "grantedbyroleuuid": null, "grantedbytriggerof": "ff030436-d19e-4606-9d48-7e192eaf469f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'e668cce4-9f01-4c71-b28c-79859e02971b', 'INSERT', '{"uuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "roletype": "REFERRER", "objectuuid": "ff030436-d19e-4606-9d48-7e192eaf469f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '594d657f-567a-4e69-b28d-f2b79136ca2d', 'INSERT', '{"op": "SELECT", "uuid": "594d657f-567a-4e69-b28d-f2b79136ca2d", "objectuuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '9a46f201-3a46-4d72-bf3d-682fd0068c18', 'INSERT', '{"uuid": "9a46f201-3a46-4d72-bf3d-682fd0068c18", "assumed": true, "ascendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "descendantuuid": "594d657f-567a-4e69-b28d-f2b79136ca2d", "grantedbyroleuuid": null, "grantedbytriggerof": "ff030436-d19e-4606-9d48-7e192eaf469f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'fe29d736-dd13-4a6c-8525-d6eb3bbcdab8', 'INSERT', '{"uuid": "fe29d736-dd13-4a6c-8525-d6eb3bbcdab8", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "ff030436-d19e-4606-9d48-7e192eaf469f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '99c49e4f-cfe3-41d3-940e-915c2a2e9641', 'INSERT', '{"op": "INSERT", "uuid": "99c49e4f-cfe3-41d3-940e-915c2a2e9641", "objectuuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'db43eeac-3853-4784-a242-f338a986f32c', 'INSERT', '{"uuid": "db43eeac-3853-4784-a242-f338a986f32c", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "99c49e4f-cfe3-41d3-940e-915c2a2e9641", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'ff030436-d19e-4606-9d48-7e192eaf469f', 'INSERT', '{"uuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "title": "", "version": 0, "givenname": "Philip", "tradename": "JM GmbH", "familyname": "Meyer-Contract", "persontype": "LP", "salutation": "Herr"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'INSERT', '{"uuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1", "serialid": 155, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '22600f05-6955-48f7-8930-c884c9c31b06', 'INSERT', '{"uuid": "22600f05-6955-48f7-8930-c884c9c31b06", "roletype": "OWNER", "objectuuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'd7a0d94a-c274-439a-b500-0f69b13c49fc', 'INSERT', '{"op": "DELETE", "uuid": "d7a0d94a-c274-439a-b500-0f69b13c49fc", "objectuuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'f69144bb-368b-4d22-b69d-af23526ba7a4', 'INSERT', '{"uuid": "f69144bb-368b-4d22-b69d-af23526ba7a4", "assumed": true, "ascendantuuid": "22600f05-6955-48f7-8930-c884c9c31b06", "descendantuuid": "d7a0d94a-c274-439a-b500-0f69b13c49fc", "grantedbyroleuuid": null, "grantedbytriggerof": "c8050a1b-0d28-4aa7-ac77-958c99152cd1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '111141e6-d131-4706-ae7a-95f3552e1bdd', 'INSERT', '{"uuid": "111141e6-d131-4706-ae7a-95f3552e1bdd", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "22600f05-6955-48f7-8930-c884c9c31b06", "grantedbyroleuuid": null, "grantedbytriggerof": "c8050a1b-0d28-4aa7-ac77-958c99152cd1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'dd532bd8-a252-4365-8e4c-2735d5fc5878', 'INSERT', '{"uuid": "dd532bd8-a252-4365-8e4c-2735d5fc5878", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "22600f05-6955-48f7-8930-c884c9c31b06", "grantedbyroleuuid": "22600f05-6955-48f7-8930-c884c9c31b06", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'b28425cc-f859-43db-b3f5-64b5fb6a668b', 'INSERT', '{"uuid": "b28425cc-f859-43db-b3f5-64b5fb6a668b", "roletype": "ADMIN", "objectuuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'eb7e6ebf-472b-40b5-9d88-47263fdb01cf', 'INSERT', '{"op": "UPDATE", "uuid": "eb7e6ebf-472b-40b5-9d88-47263fdb01cf", "objectuuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '7cd9022a-9f45-4d2a-bf6b-27b831272c43', 'INSERT', '{"uuid": "7cd9022a-9f45-4d2a-bf6b-27b831272c43", "assumed": true, "ascendantuuid": "b28425cc-f859-43db-b3f5-64b5fb6a668b", "descendantuuid": "eb7e6ebf-472b-40b5-9d88-47263fdb01cf", "grantedbyroleuuid": null, "grantedbytriggerof": "c8050a1b-0d28-4aa7-ac77-958c99152cd1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '8cb620e9-a1c8-43bd-b617-07124fab53a9', 'INSERT', '{"uuid": "8cb620e9-a1c8-43bd-b617-07124fab53a9", "assumed": true, "ascendantuuid": "22600f05-6955-48f7-8930-c884c9c31b06", "descendantuuid": "b28425cc-f859-43db-b3f5-64b5fb6a668b", "grantedbyroleuuid": null, "grantedbytriggerof": "c8050a1b-0d28-4aa7-ac77-958c99152cd1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'ecdbb376-51c5-4de3-82f5-c5e73c0f43c5', 'INSERT', '{"uuid": "ecdbb376-51c5-4de3-82f5-c5e73c0f43c5", "roletype": "REFERRER", "objectuuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'de1d831c-b96c-44fa-80a3-725856c6f998', 'INSERT', '{"op": "SELECT", "uuid": "de1d831c-b96c-44fa-80a3-725856c6f998", "objectuuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'a42f0b71-244c-444f-9e90-891b760e40b0', 'INSERT', '{"uuid": "a42f0b71-244c-444f-9e90-891b760e40b0", "assumed": true, "ascendantuuid": "ecdbb376-51c5-4de3-82f5-c5e73c0f43c5", "descendantuuid": "de1d831c-b96c-44fa-80a3-725856c6f998", "grantedbyroleuuid": null, "grantedbytriggerof": "c8050a1b-0d28-4aa7-ac77-958c99152cd1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '2a2ce413-d255-4aaf-b59d-ec55fd4c0a4c', 'INSERT', '{"uuid": "2a2ce413-d255-4aaf-b59d-ec55fd4c0a4c", "assumed": true, "ascendantuuid": "b28425cc-f859-43db-b3f5-64b5fb6a668b", "descendantuuid": "ecdbb376-51c5-4de3-82f5-c5e73c0f43c5", "grantedbyroleuuid": null, "grantedbytriggerof": "c8050a1b-0d28-4aa7-ac77-958c99152cd1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '8cc95b98-8edc-4652-ae4b-9752d3cfd6b1', 'INSERT', '{"op": "INSERT", "uuid": "8cc95b98-8edc-4652-ae4b-9752d3cfd6b1", "objectuuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '25b98f12-7a6b-45a4-b080-0e45097c58fd', 'INSERT', '{"uuid": "25b98f12-7a6b-45a4-b080-0e45097c58fd", "assumed": true, "ascendantuuid": "b28425cc-f859-43db-b3f5-64b5fb6a668b", "descendantuuid": "8cc95b98-8edc-4652-ae4b-9752d3cfd6b1", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'INSERT', '{"uuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1", "title": "", "version": 0, "givenname": "Tammy", "tradename": "JM GmbH", "familyname": "Meyer-VIP", "persontype": "LP", "salutation": "Frau"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'INSERT', '{"uuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "serialid": 156, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'c573267e-79c1-4e2a-9e95-55613006a3c8', 'INSERT', '{"uuid": "c573267e-79c1-4e2a-9e95-55613006a3c8", "roletype": "OWNER", "objectuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '1bcffd04-b60d-4cdc-8fe7-df9bd04caf47', 'INSERT', '{"op": "DELETE", "uuid": "1bcffd04-b60d-4cdc-8fe7-df9bd04caf47", "objectuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '86a4a239-e595-41ad-828a-c18f2e0177f7', 'INSERT', '{"uuid": "86a4a239-e595-41ad-828a-c18f2e0177f7", "assumed": true, "ascendantuuid": "c573267e-79c1-4e2a-9e95-55613006a3c8", "descendantuuid": "1bcffd04-b60d-4cdc-8fe7-df9bd04caf47", "grantedbyroleuuid": null, "grantedbytriggerof": "89bca3fd-d7b2-46f5-821a-64c5566d03f1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'aa038d8f-8369-4dcc-888a-8c8e67a66105', 'INSERT', '{"uuid": "aa038d8f-8369-4dcc-888a-8c8e67a66105", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "c573267e-79c1-4e2a-9e95-55613006a3c8", "grantedbyroleuuid": null, "grantedbytriggerof": "89bca3fd-d7b2-46f5-821a-64c5566d03f1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'e3891199-3367-4c2c-91e1-15dc790f84dc', 'INSERT', '{"uuid": "e3891199-3367-4c2c-91e1-15dc790f84dc", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "c573267e-79c1-4e2a-9e95-55613006a3c8", "grantedbyroleuuid": "c573267e-79c1-4e2a-9e95-55613006a3c8", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '6ef557f3-0b1e-41e9-bde7-8abea686f965', 'INSERT', '{"uuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "roletype": "ADMIN", "objectuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '7637bd59-9da5-4cdc-a37c-dd588769d092', 'INSERT', '{"op": "UPDATE", "uuid": "7637bd59-9da5-4cdc-a37c-dd588769d092", "objectuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'cc5145e3-55d3-48f2-ba2f-c45ae131b1ae', 'INSERT', '{"uuid": "cc5145e3-55d3-48f2-ba2f-c45ae131b1ae", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "7637bd59-9da5-4cdc-a37c-dd588769d092", "grantedbyroleuuid": null, "grantedbytriggerof": "89bca3fd-d7b2-46f5-821a-64c5566d03f1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '0b0c83b0-8990-4712-ad91-de9339fa1304', 'INSERT', '{"uuid": "0b0c83b0-8990-4712-ad91-de9339fa1304", "assumed": true, "ascendantuuid": "c573267e-79c1-4e2a-9e95-55613006a3c8", "descendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "grantedbyroleuuid": null, "grantedbytriggerof": "89bca3fd-d7b2-46f5-821a-64c5566d03f1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'ea1789f5-11fe-4ec3-8d12-2623ba592c7f', 'INSERT', '{"uuid": "ea1789f5-11fe-4ec3-8d12-2623ba592c7f", "roletype": "REFERRER", "objectuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'b66e76e3-086f-4edd-86f7-b052ada8397d', 'INSERT', '{"op": "SELECT", "uuid": "b66e76e3-086f-4edd-86f7-b052ada8397d", "objectuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '252fb082-66ff-4c49-8dcd-a3b9d109cd09', 'INSERT', '{"uuid": "252fb082-66ff-4c49-8dcd-a3b9d109cd09", "assumed": true, "ascendantuuid": "ea1789f5-11fe-4ec3-8d12-2623ba592c7f", "descendantuuid": "b66e76e3-086f-4edd-86f7-b052ada8397d", "grantedbyroleuuid": null, "grantedbytriggerof": "89bca3fd-d7b2-46f5-821a-64c5566d03f1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '73e6cc12-8b24-4691-9401-5dcb37bfbb5e', 'INSERT', '{"uuid": "73e6cc12-8b24-4691-9401-5dcb37bfbb5e", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "ea1789f5-11fe-4ec3-8d12-2623ba592c7f", "grantedbyroleuuid": null, "grantedbytriggerof": "89bca3fd-d7b2-46f5-821a-64c5566d03f1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'c1d3e826-4d68-4ec3-b3c4-5617a1c14371', 'INSERT', '{"op": "INSERT", "uuid": "c1d3e826-4d68-4ec3-b3c4-5617a1c14371", "objectuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'a7ff4f1c-7c33-43e0-b264-37339141f7f9', 'INSERT', '{"uuid": "a7ff4f1c-7c33-43e0-b264-37339141f7f9", "roletype": "REFERRER", "objectuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '3c2baaa2-96b1-4840-9a60-d8359ec4e959', 'INSERT', '{"uuid": "3c2baaa2-96b1-4840-9a60-d8359ec4e959", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "c1d3e826-4d68-4ec3-b3c4-5617a1c14371", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'INSERT', '{"uuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "title": "", "version": 0, "givenname": "Petra", "tradename": "Test PS", "familyname": "Schmidt", "persontype": "??", "salutation": ""}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', 'INSERT', '{"uuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b", "serialid": 157, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '32defb6c-2a81-44f2-ae79-7d8544d807dc', 'INSERT', '{"uuid": "32defb6c-2a81-44f2-ae79-7d8544d807dc", "roletype": "OWNER", "objectuuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '0144b94f-8302-4eeb-bc90-d09e06966ac7', 'INSERT', '{"op": "DELETE", "uuid": "0144b94f-8302-4eeb-bc90-d09e06966ac7", "objectuuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '4acc2c76-ba7f-4074-b649-4f2e2aa99c51', 'INSERT', '{"uuid": "4acc2c76-ba7f-4074-b649-4f2e2aa99c51", "assumed": true, "ascendantuuid": "32defb6c-2a81-44f2-ae79-7d8544d807dc", "descendantuuid": "0144b94f-8302-4eeb-bc90-d09e06966ac7", "grantedbyroleuuid": null, "grantedbytriggerof": "2fd1ba30-936a-41a8-8fbe-e93be547f44b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'fa04af88-ae33-4ab5-bcc8-1c36fb1afd9f', 'INSERT', '{"uuid": "fa04af88-ae33-4ab5-bcc8-1c36fb1afd9f", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "32defb6c-2a81-44f2-ae79-7d8544d807dc", "grantedbyroleuuid": null, "grantedbytriggerof": "2fd1ba30-936a-41a8-8fbe-e93be547f44b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '705609ae-4009-47e5-99a4-57798dfe93e4', 'INSERT', '{"uuid": "705609ae-4009-47e5-99a4-57798dfe93e4", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "32defb6c-2a81-44f2-ae79-7d8544d807dc", "grantedbyroleuuid": "32defb6c-2a81-44f2-ae79-7d8544d807dc", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '9e5fa680-2abc-4f25-bb22-bd2fe04fd860', 'INSERT', '{"uuid": "9e5fa680-2abc-4f25-bb22-bd2fe04fd860", "roletype": "ADMIN", "objectuuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '6587000d-2225-474f-a5c3-480188036398', 'INSERT', '{"op": "UPDATE", "uuid": "6587000d-2225-474f-a5c3-480188036398", "objectuuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '82ec6c0e-0e4a-425a-9410-38747ceab809', 'INSERT', '{"uuid": "82ec6c0e-0e4a-425a-9410-38747ceab809", "assumed": true, "ascendantuuid": "9e5fa680-2abc-4f25-bb22-bd2fe04fd860", "descendantuuid": "6587000d-2225-474f-a5c3-480188036398", "grantedbyroleuuid": null, "grantedbytriggerof": "2fd1ba30-936a-41a8-8fbe-e93be547f44b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '75c4a5d5-b64d-4aa6-9b68-34a7666c6511', 'INSERT', '{"uuid": "75c4a5d5-b64d-4aa6-9b68-34a7666c6511", "assumed": true, "ascendantuuid": "32defb6c-2a81-44f2-ae79-7d8544d807dc", "descendantuuid": "9e5fa680-2abc-4f25-bb22-bd2fe04fd860", "grantedbyroleuuid": null, "grantedbytriggerof": "2fd1ba30-936a-41a8-8fbe-e93be547f44b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7', 'INSERT', '{"uuid": "4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7", "roletype": "REFERRER", "objectuuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '353d7a47-2248-4875-9776-469e7a028cae', 'INSERT', '{"op": "SELECT", "uuid": "353d7a47-2248-4875-9776-469e7a028cae", "objectuuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '4c4a01d2-ef9c-4b38-800b-48e24561e0fb', 'INSERT', '{"uuid": "4c4a01d2-ef9c-4b38-800b-48e24561e0fb", "assumed": true, "ascendantuuid": "4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7", "descendantuuid": "353d7a47-2248-4875-9776-469e7a028cae", "grantedbyroleuuid": null, "grantedbytriggerof": "2fd1ba30-936a-41a8-8fbe-e93be547f44b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'ca9bb2f8-49af-452c-a0aa-283c283ba4d1', 'INSERT', '{"uuid": "ca9bb2f8-49af-452c-a0aa-283c283ba4d1", "assumed": true, "ascendantuuid": "9e5fa680-2abc-4f25-bb22-bd2fe04fd860", "descendantuuid": "4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7", "grantedbyroleuuid": null, "grantedbytriggerof": "2fd1ba30-936a-41a8-8fbe-e93be547f44b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '0488a5bf-a825-4105-965f-3fa793d5b9c4', 'INSERT', '{"op": "INSERT", "uuid": "0488a5bf-a825-4105-965f-3fa793d5b9c4", "objectuuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '06ff60b9-6bdc-44e9-98f6-1a32d6f30512', 'INSERT', '{"uuid": "06ff60b9-6bdc-44e9-98f6-1a32d6f30512", "assumed": true, "ascendantuuid": "9e5fa680-2abc-4f25-bb22-bd2fe04fd860", "descendantuuid": "0488a5bf-a825-4105-965f-3fa793d5b9c4", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', 'INSERT', '{"uuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b", "title": "", "version": 0, "givenname": "Frauke", "tradename": "", "familyname": "Fanninga", "persontype": "NP", "salutation": "Frau"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 'INSERT', '{"uuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "serialid": 158, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '7c817da8-f355-4456-8074-7bf433924285', 'INSERT', '{"uuid": "7c817da8-f355-4456-8074-7bf433924285", "roletype": "OWNER", "objectuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '2d7800a6-63a8-4017-9613-6c693d3cd171', 'INSERT', '{"op": "DELETE", "uuid": "2d7800a6-63a8-4017-9613-6c693d3cd171", "objectuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '34695474-4403-4045-a3f5-2e77f28a3257', 'INSERT', '{"uuid": "34695474-4403-4045-a3f5-2e77f28a3257", "assumed": true, "ascendantuuid": "7c817da8-f355-4456-8074-7bf433924285", "descendantuuid": "2d7800a6-63a8-4017-9613-6c693d3cd171", "grantedbyroleuuid": null, "grantedbytriggerof": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '96b0229c-13b6-48ef-a5c1-d5202c716c52', 'INSERT', '{"uuid": "96b0229c-13b6-48ef-a5c1-d5202c716c52", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "7c817da8-f355-4456-8074-7bf433924285", "grantedbyroleuuid": null, "grantedbytriggerof": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '9c5c8582-9832-4bbf-8bf1-0c828c121337', 'INSERT', '{"uuid": "9c5c8582-9832-4bbf-8bf1-0c828c121337", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "7c817da8-f355-4456-8074-7bf433924285", "grantedbyroleuuid": "7c817da8-f355-4456-8074-7bf433924285", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'f32f51d5-3384-426e-a1c1-b5b6a263b647', 'INSERT', '{"uuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "roletype": "ADMIN", "objectuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '2f06897d-859c-4e56-b9c2-947d128e3d63', 'INSERT', '{"op": "UPDATE", "uuid": "2f06897d-859c-4e56-b9c2-947d128e3d63", "objectuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '6839d4c2-94b8-4fa2-84c8-ebda6ae471f9', 'INSERT', '{"uuid": "6839d4c2-94b8-4fa2-84c8-ebda6ae471f9", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "2f06897d-859c-4e56-b9c2-947d128e3d63", "grantedbyroleuuid": null, "grantedbytriggerof": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '0798a57d-c298-47e9-9942-dbc39bb20c9b', 'INSERT', '{"uuid": "0798a57d-c298-47e9-9942-dbc39bb20c9b", "assumed": true, "ascendantuuid": "7c817da8-f355-4456-8074-7bf433924285", "descendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "grantedbyroleuuid": null, "grantedbytriggerof": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '4d6a853b-5d93-4400-ba4c-a28a96721af5', 'INSERT', '{"op": "SELECT", "uuid": "4d6a853b-5d93-4400-ba4c-a28a96721af5", "objectuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'fc136f9e-2bbc-4f9a-b9d7-277e1818e141', 'INSERT', '{"uuid": "fc136f9e-2bbc-4f9a-b9d7-277e1818e141", "assumed": true, "ascendantuuid": "a7ff4f1c-7c33-43e0-b264-37339141f7f9", "descendantuuid": "4d6a853b-5d93-4400-ba4c-a28a96721af5", "grantedbyroleuuid": null, "grantedbytriggerof": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'f3a2f756-33e9-421c-bed1-b3ba44b61a97', 'INSERT', '{"uuid": "f3a2f756-33e9-421c-bed1-b3ba44b61a97", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "a7ff4f1c-7c33-43e0-b264-37339141f7f9", "grantedbyroleuuid": null, "grantedbytriggerof": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'cb9db0cb-6a60-4f56-85e9-97ca9734071e', 'INSERT', '{"op": "INSERT", "uuid": "cb9db0cb-6a60-4f56-85e9-97ca9734071e", "objectuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'f4afe3a7-e4c7-4d56-b1da-53af2568bfc9', 'INSERT', '{"uuid": "f4afe3a7-e4c7-4d56-b1da-53af2568bfc9", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "cb9db0cb-6a60-4f56-85e9-97ca9734071e", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 'INSERT', '{"uuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "title": "", "version": 0, "givenname": "Cecilia", "tradename": "", "familyname": "Camus", "persontype": "NP", "salutation": "Frau"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', '38cc5d59-085f-449e-aeb3-439febbabd9b', 'INSERT', '{"uuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "serialid": 159, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'b70eca31-fcf6-40f6-9792-2fdb66bb129b', 'INSERT', '{"uuid": "b70eca31-fcf6-40f6-9792-2fdb66bb129b", "roletype": "OWNER", "objectuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'b38a6e56-e439-44d2-9ed6-3223e21c6224', 'INSERT', '{"op": "DELETE", "uuid": "b38a6e56-e439-44d2-9ed6-3223e21c6224", "objectuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'e156520b-d63f-4bf3-8a02-32fa64cdd3e2', 'INSERT', '{"uuid": "e156520b-d63f-4bf3-8a02-32fa64cdd3e2", "assumed": true, "ascendantuuid": "b70eca31-fcf6-40f6-9792-2fdb66bb129b", "descendantuuid": "b38a6e56-e439-44d2-9ed6-3223e21c6224", "grantedbyroleuuid": null, "grantedbytriggerof": "38cc5d59-085f-449e-aeb3-439febbabd9b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '7d856866-730a-4037-95dd-a50906705098', 'INSERT', '{"uuid": "7d856866-730a-4037-95dd-a50906705098", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "b70eca31-fcf6-40f6-9792-2fdb66bb129b", "grantedbyroleuuid": null, "grantedbytriggerof": "38cc5d59-085f-449e-aeb3-439febbabd9b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'a68e0755-9441-4b22-ae6b-1bdfef94e3e4', 'INSERT', '{"uuid": "a68e0755-9441-4b22-ae6b-1bdfef94e3e4", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "b70eca31-fcf6-40f6-9792-2fdb66bb129b", "grantedbyroleuuid": "b70eca31-fcf6-40f6-9792-2fdb66bb129b", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'INSERT', '{"uuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "roletype": "ADMIN", "objectuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'c3a212dc-036f-4e84-84b9-6e7367b407a1', 'INSERT', '{"op": "UPDATE", "uuid": "c3a212dc-036f-4e84-84b9-6e7367b407a1", "objectuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '443f5495-98be-4580-89eb-a2afa2d7f7d9', 'INSERT', '{"uuid": "443f5495-98be-4580-89eb-a2afa2d7f7d9", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "c3a212dc-036f-4e84-84b9-6e7367b407a1", "grantedbyroleuuid": null, "grantedbytriggerof": "38cc5d59-085f-449e-aeb3-439febbabd9b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'ed164724-8168-4a4f-8445-ff973110a77f', 'INSERT', '{"uuid": "ed164724-8168-4a4f-8445-ff973110a77f", "assumed": true, "ascendantuuid": "b70eca31-fcf6-40f6-9792-2fdb66bb129b", "descendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "grantedbyroleuuid": null, "grantedbytriggerof": "38cc5d59-085f-449e-aeb3-439febbabd9b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'e97003a9-9162-4142-8d08-814e6c8fabd9', 'INSERT', '{"uuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "roletype": "REFERRER", "objectuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'd96f1d59-085b-4c42-9e01-1513b232a067', 'INSERT', '{"op": "SELECT", "uuid": "d96f1d59-085b-4c42-9e01-1513b232a067", "objectuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '8dea3c47-7171-4101-a215-15c7371b3a6d', 'INSERT', '{"uuid": "8dea3c47-7171-4101-a215-15c7371b3a6d", "assumed": true, "ascendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "descendantuuid": "d96f1d59-085b-4c42-9e01-1513b232a067", "grantedbyroleuuid": null, "grantedbytriggerof": "38cc5d59-085f-449e-aeb3-439febbabd9b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '6a3344ed-1f0d-43a5-8e0a-a791472b7ffc', 'INSERT', '{"uuid": "6a3344ed-1f0d-43a5-8e0a-a791472b7ffc", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "38cc5d59-085f-449e-aeb3-439febbabd9b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'd8d23634-f1c6-4a13-bb39-bae8e187df04', 'INSERT', '{"op": "INSERT", "uuid": "d8d23634-f1c6-4a13-bb39-bae8e187df04", "objectuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '7340d2f8-170d-4eb6-8218-1cac9432d709', 'INSERT', '{"uuid": "7340d2f8-170d-4eb6-8218-1cac9432d709", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "d8d23634-f1c6-4a13-bb39-bae8e187df04", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', '38cc5d59-085f-449e-aeb3-439febbabd9b', 'INSERT', '{"uuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "title": "", "version": 0, "givenname": "Christiane", "tradename": "Wasserwerk Südholstein", "familyname": "Milberg", "persontype": "??", "salutation": "Frau"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'INSERT', '{"uuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "serialid": 160, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3', 'INSERT', '{"uuid": "4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3", "roletype": "OWNER", "objectuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'f3e17013-eb06-49e1-94a8-2e81e0f8a706', 'INSERT', '{"op": "DELETE", "uuid": "f3e17013-eb06-49e1-94a8-2e81e0f8a706", "objectuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '26d1fa5a-b06c-40d0-829b-f014bf33975e', 'INSERT', '{"uuid": "26d1fa5a-b06c-40d0-829b-f014bf33975e", "assumed": true, "ascendantuuid": "4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3", "descendantuuid": "f3e17013-eb06-49e1-94a8-2e81e0f8a706", "grantedbyroleuuid": null, "grantedbytriggerof": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '76e9493e-a2db-4b94-b324-77f11f2d5b80', 'INSERT', '{"uuid": "76e9493e-a2db-4b94-b324-77f11f2d5b80", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3", "grantedbyroleuuid": null, "grantedbytriggerof": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '97286182-f6c9-4684-8634-7c28a099043d', 'INSERT', '{"uuid": "97286182-f6c9-4684-8634-7c28a099043d", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3", "grantedbyroleuuid": "4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '1373e547-4804-4c8d-9014-ce51c65f3a06', 'INSERT', '{"uuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "roletype": "ADMIN", "objectuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '6712a948-ac81-455e-8d87-cb05438ac85d', 'INSERT', '{"op": "UPDATE", "uuid": "6712a948-ac81-455e-8d87-cb05438ac85d", "objectuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '4a0f7682-96b0-4078-bf24-b816ffe12616', 'INSERT', '{"uuid": "4a0f7682-96b0-4078-bf24-b816ffe12616", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "6712a948-ac81-455e-8d87-cb05438ac85d", "grantedbyroleuuid": null, "grantedbytriggerof": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '0a4bd37d-fe74-4667-8832-81acfd7d88dd', 'INSERT', '{"uuid": "0a4bd37d-fe74-4667-8832-81acfd7d88dd", "assumed": true, "ascendantuuid": "4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3", "descendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "grantedbyroleuuid": null, "grantedbytriggerof": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'bdeffe17-405f-4ad0-8131-82728ea0e382', 'INSERT', '{"uuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "roletype": "REFERRER", "objectuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '3e298df0-8c98-4e48-a103-cfd3bbe2bec6', 'INSERT', '{"op": "SELECT", "uuid": "3e298df0-8c98-4e48-a103-cfd3bbe2bec6", "objectuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '88771617-b8ff-48ed-86e1-24a097fdc443', 'INSERT', '{"uuid": "88771617-b8ff-48ed-86e1-24a097fdc443", "assumed": true, "ascendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "descendantuuid": "3e298df0-8c98-4e48-a103-cfd3bbe2bec6", "grantedbyroleuuid": null, "grantedbytriggerof": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'b11a3cd2-4e11-4cb7-b704-640e80d04647', 'INSERT', '{"uuid": "b11a3cd2-4e11-4cb7-b704-640e80d04647", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'afceedea-4a23-4f6f-a0a2-a210ac148935', 'INSERT', '{"op": "INSERT", "uuid": "afceedea-4a23-4f6f-a0a2-a210ac148935", "objectuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'a9787820-a6e2-43ca-8934-63e56a28b694', 'INSERT', '{"uuid": "a9787820-a6e2-43ca-8934-63e56a28b694", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "afceedea-4a23-4f6f-a0a2-a210ac148935", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'INSERT', '{"uuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "title": "", "version": 0, "givenname": "Richard", "tradename": "Das Perfekte Haus", "familyname": "Wiese", "persontype": "??", "salutation": "Herr"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', 'INSERT', '{"uuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "serialid": 161, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '3f156460-0b5e-4e31-9ffe-bd27ad172ade', 'INSERT', '{"uuid": "3f156460-0b5e-4e31-9ffe-bd27ad172ade", "roletype": "OWNER", "objectuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '9fe16585-5125-43c0-a683-f4d1579f784b', 'INSERT', '{"op": "DELETE", "uuid": "9fe16585-5125-43c0-a683-f4d1579f784b", "objectuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '576f1a0c-739b-42b5-a888-2dd8c5789baa', 'INSERT', '{"uuid": "576f1a0c-739b-42b5-a888-2dd8c5789baa", "assumed": true, "ascendantuuid": "3f156460-0b5e-4e31-9ffe-bd27ad172ade", "descendantuuid": "9fe16585-5125-43c0-a683-f4d1579f784b", "grantedbyroleuuid": null, "grantedbytriggerof": "d7485220-e4f2-4683-9e84-7728a2ef4ebf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'd326a63a-bcfa-44ca-91db-c6de702e9bd4', 'INSERT', '{"uuid": "d326a63a-bcfa-44ca-91db-c6de702e9bd4", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "3f156460-0b5e-4e31-9ffe-bd27ad172ade", "grantedbyroleuuid": null, "grantedbytriggerof": "d7485220-e4f2-4683-9e84-7728a2ef4ebf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '85c18c00-90e0-462c-bdb4-60428d3e7b0e', 'INSERT', '{"uuid": "85c18c00-90e0-462c-bdb4-60428d3e7b0e", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "3f156460-0b5e-4e31-9ffe-bd27ad172ade", "grantedbyroleuuid": "3f156460-0b5e-4e31-9ffe-bd27ad172ade", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '957da54d-43eb-45d5-a3c4-34976d178bf3', 'INSERT', '{"uuid": "957da54d-43eb-45d5-a3c4-34976d178bf3", "roletype": "ADMIN", "objectuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '9405dc92-3dc7-4f4a-b799-514ce78ac05a', 'INSERT', '{"op": "UPDATE", "uuid": "9405dc92-3dc7-4f4a-b799-514ce78ac05a", "objectuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '060c2174-e50d-4912-91c1-f1572a148dad', 'INSERT', '{"uuid": "060c2174-e50d-4912-91c1-f1572a148dad", "assumed": true, "ascendantuuid": "957da54d-43eb-45d5-a3c4-34976d178bf3", "descendantuuid": "9405dc92-3dc7-4f4a-b799-514ce78ac05a", "grantedbyroleuuid": null, "grantedbytriggerof": "d7485220-e4f2-4683-9e84-7728a2ef4ebf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '10790a03-fb59-468f-ad85-d7ab74d790f6', 'INSERT', '{"uuid": "10790a03-fb59-468f-ad85-d7ab74d790f6", "assumed": true, "ascendantuuid": "3f156460-0b5e-4e31-9ffe-bd27ad172ade", "descendantuuid": "957da54d-43eb-45d5-a3c4-34976d178bf3", "grantedbyroleuuid": null, "grantedbytriggerof": "d7485220-e4f2-4683-9e84-7728a2ef4ebf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '96d81c1c-7d32-4b58-b7d3-7d7d88d250b7', 'INSERT', '{"uuid": "96d81c1c-7d32-4b58-b7d3-7d7d88d250b7", "roletype": "REFERRER", "objectuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '0b519921-7548-446f-a6e2-0986f0cec622', 'INSERT', '{"op": "SELECT", "uuid": "0b519921-7548-446f-a6e2-0986f0cec622", "objectuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'cb3b7398-6065-4c42-a456-41bc192ce327', 'INSERT', '{"uuid": "cb3b7398-6065-4c42-a456-41bc192ce327", "assumed": true, "ascendantuuid": "96d81c1c-7d32-4b58-b7d3-7d7d88d250b7", "descendantuuid": "0b519921-7548-446f-a6e2-0986f0cec622", "grantedbyroleuuid": null, "grantedbytriggerof": "d7485220-e4f2-4683-9e84-7728a2ef4ebf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'bdd47305-1888-4f01-9320-e68d3dd73b9e', 'INSERT', '{"uuid": "bdd47305-1888-4f01-9320-e68d3dd73b9e", "assumed": true, "ascendantuuid": "957da54d-43eb-45d5-a3c4-34976d178bf3", "descendantuuid": "96d81c1c-7d32-4b58-b7d3-7d7d88d250b7", "grantedbyroleuuid": null, "grantedbytriggerof": "d7485220-e4f2-4683-9e84-7728a2ef4ebf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '6d013dc5-c320-4873-99bb-d3cbd287ccf5', 'INSERT', '{"op": "INSERT", "uuid": "6d013dc5-c320-4873-99bb-d3cbd287ccf5", "objectuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '40085698-b003-4234-86c6-76eff547ea0f', 'INSERT', '{"uuid": "40085698-b003-4234-86c6-76eff547ea0f", "assumed": true, "ascendantuuid": "957da54d-43eb-45d5-a3c4-34976d178bf3", "descendantuuid": "6d013dc5-c320-4873-99bb-d3cbd287ccf5", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', 'INSERT', '{"uuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "title": "", "version": 0, "givenname": "Karim", "tradename": "Wasswerwerk Südholstein", "familyname": "Metzger", "persontype": "??", "salutation": "Herr"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', 'INSERT', '{"uuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4", "serialid": 162, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '5c561605-0895-4a2b-b850-9572156e6635', 'INSERT', '{"uuid": "5c561605-0895-4a2b-b850-9572156e6635", "roletype": "OWNER", "objectuuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '08008ffa-675e-46e6-8f5c-bbb701d67fd1', 'INSERT', '{"op": "DELETE", "uuid": "08008ffa-675e-46e6-8f5c-bbb701d67fd1", "objectuuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '507a9fe5-cf54-4d19-927b-ce85943cc782', 'INSERT', '{"uuid": "507a9fe5-cf54-4d19-927b-ce85943cc782", "assumed": true, "ascendantuuid": "5c561605-0895-4a2b-b850-9572156e6635", "descendantuuid": "08008ffa-675e-46e6-8f5c-bbb701d67fd1", "grantedbyroleuuid": null, "grantedbytriggerof": "d6488771-b5c0-4f39-a6d6-81af6ca982f4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '3f28348f-ce57-4a07-80b6-7fc85ca9153c', 'INSERT', '{"uuid": "3f28348f-ce57-4a07-80b6-7fc85ca9153c", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "5c561605-0895-4a2b-b850-9572156e6635", "grantedbyroleuuid": null, "grantedbytriggerof": "d6488771-b5c0-4f39-a6d6-81af6ca982f4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '5da8c927-3d13-486e-b3c5-dad2a31a70fd', 'INSERT', '{"uuid": "5da8c927-3d13-486e-b3c5-dad2a31a70fd", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "5c561605-0895-4a2b-b850-9572156e6635", "grantedbyroleuuid": "5c561605-0895-4a2b-b850-9572156e6635", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '8bfcdf97-8c34-46ca-8159-1314cbb42105', 'INSERT', '{"uuid": "8bfcdf97-8c34-46ca-8159-1314cbb42105", "roletype": "ADMIN", "objectuuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'c8583847-e84a-4286-b04f-368c61118b00', 'INSERT', '{"op": "UPDATE", "uuid": "c8583847-e84a-4286-b04f-368c61118b00", "objectuuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'c4ab1a59-0e67-47bc-a48f-a553a8b50794', 'INSERT', '{"uuid": "c4ab1a59-0e67-47bc-a48f-a553a8b50794", "assumed": true, "ascendantuuid": "8bfcdf97-8c34-46ca-8159-1314cbb42105", "descendantuuid": "c8583847-e84a-4286-b04f-368c61118b00", "grantedbyroleuuid": null, "grantedbytriggerof": "d6488771-b5c0-4f39-a6d6-81af6ca982f4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '284fd022-3236-4ee0-ae0e-1a2899a8f2c9', 'INSERT', '{"uuid": "284fd022-3236-4ee0-ae0e-1a2899a8f2c9", "assumed": true, "ascendantuuid": "5c561605-0895-4a2b-b850-9572156e6635", "descendantuuid": "8bfcdf97-8c34-46ca-8159-1314cbb42105", "grantedbyroleuuid": null, "grantedbytriggerof": "d6488771-b5c0-4f39-a6d6-81af6ca982f4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'd8c41124-ff96-4bc4-b3be-d0a8091128b6', 'INSERT', '{"uuid": "d8c41124-ff96-4bc4-b3be-d0a8091128b6", "roletype": "REFERRER", "objectuuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'ea2e5ea3-6e8e-473e-9bca-3972c30c727a', 'INSERT', '{"op": "SELECT", "uuid": "ea2e5ea3-6e8e-473e-9bca-3972c30c727a", "objectuuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '94be11ba-9d31-480d-b264-47adfa74df20', 'INSERT', '{"uuid": "94be11ba-9d31-480d-b264-47adfa74df20", "assumed": true, "ascendantuuid": "d8c41124-ff96-4bc4-b3be-d0a8091128b6", "descendantuuid": "ea2e5ea3-6e8e-473e-9bca-3972c30c727a", "grantedbyroleuuid": null, "grantedbytriggerof": "d6488771-b5c0-4f39-a6d6-81af6ca982f4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'c695866c-6901-442a-a657-c32fb5320bd4', 'INSERT', '{"uuid": "c695866c-6901-442a-a657-c32fb5320bd4", "assumed": true, "ascendantuuid": "8bfcdf97-8c34-46ca-8159-1314cbb42105", "descendantuuid": "d8c41124-ff96-4bc4-b3be-d0a8091128b6", "grantedbyroleuuid": null, "grantedbytriggerof": "d6488771-b5c0-4f39-a6d6-81af6ca982f4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'c33ab3ab-3d3d-44be-987e-9f1ad950f25c', 'INSERT', '{"op": "INSERT", "uuid": "c33ab3ab-3d3d-44be-987e-9f1ad950f25c", "objectuuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'b631b878-8ffe-4a79-9e49-30f7b0c08c6c', 'INSERT', '{"uuid": "b631b878-8ffe-4a79-9e49-30f7b0c08c6c", "assumed": true, "ascendantuuid": "8bfcdf97-8c34-46ca-8159-1314cbb42105", "descendantuuid": "c33ab3ab-3d3d-44be-987e-9f1ad950f25c", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', 'INSERT', '{"uuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4", "title": "", "version": 0, "givenname": "Inhaber R.", "tradename": "Das Perfekte Haus", "familyname": "Wiese", "persontype": "??", "salutation": "Herr"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', 'INSERT', '{"uuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "serialid": 163, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '84f70526-107d-4b57-b7c2-653c8efc2737', 'INSERT', '{"uuid": "84f70526-107d-4b57-b7c2-653c8efc2737", "roletype": "OWNER", "objectuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'ede31012-fbaa-4a4a-b5db-001a2ded08ea', 'INSERT', '{"op": "DELETE", "uuid": "ede31012-fbaa-4a4a-b5db-001a2ded08ea", "objectuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'cafa308f-ea72-49c3-b221-a6aba5fcfb74', 'INSERT', '{"uuid": "cafa308f-ea72-49c3-b221-a6aba5fcfb74", "assumed": true, "ascendantuuid": "84f70526-107d-4b57-b7c2-653c8efc2737", "descendantuuid": "ede31012-fbaa-4a4a-b5db-001a2ded08ea", "grantedbyroleuuid": null, "grantedbytriggerof": "7c10a7d7-bac2-41e2-a5c0-963e191239a8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '85fb9a91-865f-4f7c-84db-df341ae37a8f', 'INSERT', '{"uuid": "85fb9a91-865f-4f7c-84db-df341ae37a8f", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "84f70526-107d-4b57-b7c2-653c8efc2737", "grantedbyroleuuid": null, "grantedbytriggerof": "7c10a7d7-bac2-41e2-a5c0-963e191239a8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '3019aa7a-378d-4f1e-8805-5ed585007161', 'INSERT', '{"uuid": "3019aa7a-378d-4f1e-8805-5ed585007161", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "84f70526-107d-4b57-b7c2-653c8efc2737", "grantedbyroleuuid": "84f70526-107d-4b57-b7c2-653c8efc2737", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '2812b2d9-15c6-479c-b59d-bf980f4bc9d7', 'INSERT', '{"uuid": "2812b2d9-15c6-479c-b59d-bf980f4bc9d7", "roletype": "ADMIN", "objectuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'dbc52a0b-fe89-46a8-89a8-f155a437fe07', 'INSERT', '{"op": "UPDATE", "uuid": "dbc52a0b-fe89-46a8-89a8-f155a437fe07", "objectuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '81204f4a-102e-49f9-a5d9-f32c3854109f', 'INSERT', '{"uuid": "81204f4a-102e-49f9-a5d9-f32c3854109f", "assumed": true, "ascendantuuid": "2812b2d9-15c6-479c-b59d-bf980f4bc9d7", "descendantuuid": "dbc52a0b-fe89-46a8-89a8-f155a437fe07", "grantedbyroleuuid": null, "grantedbytriggerof": "7c10a7d7-bac2-41e2-a5c0-963e191239a8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '69cde6f0-839d-4b94-8045-f65521ef864e', 'INSERT', '{"uuid": "69cde6f0-839d-4b94-8045-f65521ef864e", "assumed": true, "ascendantuuid": "84f70526-107d-4b57-b7c2-653c8efc2737", "descendantuuid": "2812b2d9-15c6-479c-b59d-bf980f4bc9d7", "grantedbyroleuuid": null, "grantedbytriggerof": "7c10a7d7-bac2-41e2-a5c0-963e191239a8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'b29939d1-67c0-4527-88fd-41812023f402', 'INSERT', '{"uuid": "b29939d1-67c0-4527-88fd-41812023f402", "roletype": "REFERRER", "objectuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'cd5218c0-fc28-464c-bb9e-ea0eb9698f66', 'INSERT', '{"op": "SELECT", "uuid": "cd5218c0-fc28-464c-bb9e-ea0eb9698f66", "objectuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '0e9156e0-bfc5-4e7b-aa50-29bb214577cd', 'INSERT', '{"uuid": "0e9156e0-bfc5-4e7b-aa50-29bb214577cd", "assumed": true, "ascendantuuid": "b29939d1-67c0-4527-88fd-41812023f402", "descendantuuid": "cd5218c0-fc28-464c-bb9e-ea0eb9698f66", "grantedbyroleuuid": null, "grantedbytriggerof": "7c10a7d7-bac2-41e2-a5c0-963e191239a8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'e0b94c3c-ea4c-485e-9ad9-a58cddffa3cb', 'INSERT', '{"uuid": "e0b94c3c-ea4c-485e-9ad9-a58cddffa3cb", "assumed": true, "ascendantuuid": "2812b2d9-15c6-479c-b59d-bf980f4bc9d7", "descendantuuid": "b29939d1-67c0-4527-88fd-41812023f402", "grantedbyroleuuid": null, "grantedbytriggerof": "7c10a7d7-bac2-41e2-a5c0-963e191239a8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '10cd909b-0099-491f-9a73-0cf1d7765f35', 'INSERT', '{"op": "INSERT", "uuid": "10cd909b-0099-491f-9a73-0cf1d7765f35", "objectuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'aeeb2346-c0c5-44c3-9378-2c28cd25ccf5', 'INSERT', '{"uuid": "aeeb2346-c0c5-44c3-9378-2c28cd25ccf5", "assumed": true, "ascendantuuid": "2812b2d9-15c6-479c-b59d-bf980f4bc9d7", "descendantuuid": "10cd909b-0099-491f-9a73-0cf1d7765f35", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', 'INSERT', '{"uuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "title": "", "version": 0, "givenname": "Ragnar", "tradename": "", "familyname": "Richter", "persontype": "NP", "salutation": ""}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'INSERT', '{"uuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "serialid": 164, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'db6edaf5-7e57-4e26-8172-20fe06d19e16', 'INSERT', '{"uuid": "db6edaf5-7e57-4e26-8172-20fe06d19e16", "roletype": "OWNER", "objectuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'bd7f4de4-1435-42c2-a275-b56e49670e52', 'INSERT', '{"op": "DELETE", "uuid": "bd7f4de4-1435-42c2-a275-b56e49670e52", "objectuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '75de0bbe-b77e-4328-a30a-3173eb7ac971', 'INSERT', '{"uuid": "75de0bbe-b77e-4328-a30a-3173eb7ac971", "assumed": true, "ascendantuuid": "db6edaf5-7e57-4e26-8172-20fe06d19e16", "descendantuuid": "bd7f4de4-1435-42c2-a275-b56e49670e52", "grantedbyroleuuid": null, "grantedbytriggerof": "c3d97013-0ceb-4cc7-a59b-a4f70107acea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '54a35482-3a81-4513-a2a4-6f820ee9ca7e', 'INSERT', '{"uuid": "54a35482-3a81-4513-a2a4-6f820ee9ca7e", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "db6edaf5-7e57-4e26-8172-20fe06d19e16", "grantedbyroleuuid": null, "grantedbytriggerof": "c3d97013-0ceb-4cc7-a59b-a4f70107acea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'a0755eae-b481-4e5d-80de-867fc275bbcf', 'INSERT', '{"uuid": "a0755eae-b481-4e5d-80de-867fc275bbcf", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "db6edaf5-7e57-4e26-8172-20fe06d19e16", "grantedbyroleuuid": "db6edaf5-7e57-4e26-8172-20fe06d19e16", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '5f936257-6096-4792-a496-b92e46d93d0a', 'INSERT', '{"uuid": "5f936257-6096-4792-a496-b92e46d93d0a", "roletype": "ADMIN", "objectuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '3086d58a-42c3-4c88-ba4c-a1025e79218d', 'INSERT', '{"op": "UPDATE", "uuid": "3086d58a-42c3-4c88-ba4c-a1025e79218d", "objectuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '9ef9980c-19c0-4387-b05d-b036f03bd1ae', 'INSERT', '{"uuid": "9ef9980c-19c0-4387-b05d-b036f03bd1ae", "assumed": true, "ascendantuuid": "5f936257-6096-4792-a496-b92e46d93d0a", "descendantuuid": "3086d58a-42c3-4c88-ba4c-a1025e79218d", "grantedbyroleuuid": null, "grantedbytriggerof": "c3d97013-0ceb-4cc7-a59b-a4f70107acea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'b368b9e7-c014-4179-838f-5e5f39a319c2', 'INSERT', '{"uuid": "b368b9e7-c014-4179-838f-5e5f39a319c2", "assumed": true, "ascendantuuid": "db6edaf5-7e57-4e26-8172-20fe06d19e16", "descendantuuid": "5f936257-6096-4792-a496-b92e46d93d0a", "grantedbyroleuuid": null, "grantedbytriggerof": "c3d97013-0ceb-4cc7-a59b-a4f70107acea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '814e38c8-c053-4c27-9487-997cf318a550', 'INSERT', '{"uuid": "814e38c8-c053-4c27-9487-997cf318a550", "roletype": "REFERRER", "objectuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', 'c123b9c1-7755-4fa5-a0c8-ab6bcb0c7156', 'INSERT', '{"op": "SELECT", "uuid": "c123b9c1-7755-4fa5-a0c8-ab6bcb0c7156", "objectuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'd404ab50-71f3-4e9f-8d11-d9a79c724b4d', 'INSERT', '{"uuid": "d404ab50-71f3-4e9f-8d11-d9a79c724b4d", "assumed": true, "ascendantuuid": "814e38c8-c053-4c27-9487-997cf318a550", "descendantuuid": "c123b9c1-7755-4fa5-a0c8-ab6bcb0c7156", "grantedbyroleuuid": null, "grantedbytriggerof": "c3d97013-0ceb-4cc7-a59b-a4f70107acea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '76051553-cbf2-4278-b0b0-c3359028d7e6', 'INSERT', '{"uuid": "76051553-cbf2-4278-b0b0-c3359028d7e6", "assumed": true, "ascendantuuid": "5f936257-6096-4792-a496-b92e46d93d0a", "descendantuuid": "814e38c8-c053-4c27-9487-997cf318a550", "grantedbyroleuuid": null, "grantedbytriggerof": "c3d97013-0ceb-4cc7-a59b-a4f70107acea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '529abd87-8855-4eab-a795-a83717bfa4b1', 'INSERT', '{"op": "INSERT", "uuid": "529abd87-8855-4eab-a795-a83717bfa4b1", "objectuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'b9b34809-b46f-4557-9a2a-c05d8ffdd1b9', 'INSERT', '{"uuid": "b9b34809-b46f-4557-9a2a-c05d8ffdd1b9", "assumed": true, "ascendantuuid": "5f936257-6096-4792-a496-b92e46d93d0a", "descendantuuid": "529abd87-8855-4eab-a795-a83717bfa4b1", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'INSERT', '{"uuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "title": "", "version": 0, "givenname": "Eike", "tradename": "", "familyname": "Henning", "persontype": "NP", "salutation": ""}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.object', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'INSERT', '{"uuid": "e50c983a-060c-47c9-9d47-efd552b1e618", "serialid": 165, "objecttable": "hs_office.person"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '0e51c89f-6101-4b6e-be17-53df018b88f5', 'INSERT', '{"uuid": "0e51c89f-6101-4b6e-be17-53df018b88f5", "roletype": "OWNER", "objectuuid": "e50c983a-060c-47c9-9d47-efd552b1e618"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '6aa26a03-2515-4b88-97aa-1d100dfe872b', 'INSERT', '{"op": "DELETE", "uuid": "6aa26a03-2515-4b88-97aa-1d100dfe872b", "objectuuid": "e50c983a-060c-47c9-9d47-efd552b1e618", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '41d012ed-2283-4f2b-beb3-837b6da3359c', 'INSERT', '{"uuid": "41d012ed-2283-4f2b-beb3-837b6da3359c", "assumed": true, "ascendantuuid": "0e51c89f-6101-4b6e-be17-53df018b88f5", "descendantuuid": "6aa26a03-2515-4b88-97aa-1d100dfe872b", "grantedbyroleuuid": null, "grantedbytriggerof": "e50c983a-060c-47c9-9d47-efd552b1e618"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '3c9fa558-256a-446c-bc5f-48f9d61d8fcb', 'INSERT', '{"uuid": "3c9fa558-256a-446c-bc5f-48f9d61d8fcb", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0e51c89f-6101-4b6e-be17-53df018b88f5", "grantedbyroleuuid": null, "grantedbytriggerof": "e50c983a-060c-47c9-9d47-efd552b1e618"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '37138c2b-aa91-4cf2-8c2b-45dd96aaa5f4', 'INSERT', '{"uuid": "37138c2b-aa91-4cf2-8c2b-45dd96aaa5f4", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0e51c89f-6101-4b6e-be17-53df018b88f5", "grantedbyroleuuid": "0e51c89f-6101-4b6e-be17-53df018b88f5", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', 'de10229b-be9d-45dc-b1bf-8f832ebffe68', 'INSERT', '{"uuid": "de10229b-be9d-45dc-b1bf-8f832ebffe68", "roletype": "ADMIN", "objectuuid": "e50c983a-060c-47c9-9d47-efd552b1e618"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '8695131e-a5fe-4e01-81da-99769f924a12', 'INSERT', '{"op": "UPDATE", "uuid": "8695131e-a5fe-4e01-81da-99769f924a12", "objectuuid": "e50c983a-060c-47c9-9d47-efd552b1e618", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '6f109a2d-c0c0-4fa4-8efb-2ebe1eb7b9de', 'INSERT', '{"uuid": "6f109a2d-c0c0-4fa4-8efb-2ebe1eb7b9de", "assumed": true, "ascendantuuid": "de10229b-be9d-45dc-b1bf-8f832ebffe68", "descendantuuid": "8695131e-a5fe-4e01-81da-99769f924a12", "grantedbyroleuuid": null, "grantedbytriggerof": "e50c983a-060c-47c9-9d47-efd552b1e618"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '09b015f6-1d81-42ca-a008-c0b3f48a4aba', 'INSERT', '{"uuid": "09b015f6-1d81-42ca-a008-c0b3f48a4aba", "assumed": true, "ascendantuuid": "0e51c89f-6101-4b6e-be17-53df018b88f5", "descendantuuid": "de10229b-be9d-45dc-b1bf-8f832ebffe68", "grantedbyroleuuid": null, "grantedbytriggerof": "e50c983a-060c-47c9-9d47-efd552b1e618"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.role', '779e4c3b-97f0-4218-8eab-5575a6afa54a', 'INSERT', '{"uuid": "779e4c3b-97f0-4218-8eab-5575a6afa54a", "roletype": "REFERRER", "objectuuid": "e50c983a-060c-47c9-9d47-efd552b1e618"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '10063dba-d6d4-43fa-ab89-d682c47a91fe', 'INSERT', '{"op": "SELECT", "uuid": "10063dba-d6d4-43fa-ab89-d682c47a91fe", "objectuuid": "e50c983a-060c-47c9-9d47-efd552b1e618", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', 'd0cf16aa-f119-492d-8b84-c1d904b7da07', 'INSERT', '{"uuid": "d0cf16aa-f119-492d-8b84-c1d904b7da07", "assumed": true, "ascendantuuid": "779e4c3b-97f0-4218-8eab-5575a6afa54a", "descendantuuid": "10063dba-d6d4-43fa-ab89-d682c47a91fe", "grantedbyroleuuid": null, "grantedbytriggerof": "e50c983a-060c-47c9-9d47-efd552b1e618"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '3298e787-5a10-45a0-a0dc-51cb4c595eb3', 'INSERT', '{"uuid": "3298e787-5a10-45a0-a0dc-51cb4c595eb3", "assumed": true, "ascendantuuid": "de10229b-be9d-45dc-b1bf-8f832ebffe68", "descendantuuid": "779e4c3b-97f0-4218-8eab-5575a6afa54a", "grantedbyroleuuid": null, "grantedbytriggerof": "e50c983a-060c-47c9-9d47-efd552b1e618"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.permission', '70cf4eb5-99e5-49d1-9c03-70316381bb21', 'INSERT', '{"op": "INSERT", "uuid": "70cf4eb5-99e5-49d1-9c03-70316381bb21", "objectuuid": "e50c983a-060c-47c9-9d47-efd552b1e618", "optablename": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'rbac.grant', '84c142bb-1cd2-41bc-b4d0-be850a736ef0', 'INSERT', '{"uuid": "84c142bb-1cd2-41bc-b4d0-be850a736ef0", "assumed": true, "ascendantuuid": "de10229b-be9d-45dc-b1bf-8f832ebffe68", "descendantuuid": "70cf4eb5-99e5-49d1-9c03-70316381bb21", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1750', 'hs_office.person', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'INSERT', '{"uuid": "e50c983a-060c-47c9-9d47-efd552b1e618", "title": "", "version": 0, "givenname": "Jan", "tradename": "", "familyname": "Henning", "persontype": "NP", "salutation": ""}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '48618c28-9304-4ccb-b022-e2cbb1832944', 'INSERT', '{"uuid": "48618c28-9304-4ccb-b022-e2cbb1832944", "serialid": 166, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1b453f97-a12c-4d51-bf95-2e782b425385', 'INSERT', '{"uuid": "1b453f97-a12c-4d51-bf95-2e782b425385", "roletype": "OWNER", "objectuuid": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'cf95f6ed-2e24-45ae-824d-8cc58ee2c2e4', 'INSERT', '{"op": "DELETE", "uuid": "cf95f6ed-2e24-45ae-824d-8cc58ee2c2e4", "objectuuid": "48618c28-9304-4ccb-b022-e2cbb1832944", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b1863909-c091-4e66-b1ee-eeb427986f97', 'INSERT', '{"uuid": "b1863909-c091-4e66-b1ee-eeb427986f97", "assumed": true, "ascendantuuid": "1b453f97-a12c-4d51-bf95-2e782b425385", "descendantuuid": "cf95f6ed-2e24-45ae-824d-8cc58ee2c2e4", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '53c8a05d-7dd8-4faa-9c1b-02c02dff47df', 'INSERT', '{"uuid": "53c8a05d-7dd8-4faa-9c1b-02c02dff47df", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "1b453f97-a12c-4d51-bf95-2e782b425385", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8213d9da-f8ca-437e-aa92-cbc5d9d458ba', 'INSERT', '{"uuid": "8213d9da-f8ca-437e-aa92-cbc5d9d458ba", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "1b453f97-a12c-4d51-bf95-2e782b425385", "grantedbyroleuuid": "1b453f97-a12c-4d51-bf95-2e782b425385", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3b195996-371c-41e4-9b66-a50553582e17', 'INSERT', '{"uuid": "3b195996-371c-41e4-9b66-a50553582e17", "roletype": "ADMIN", "objectuuid": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '8e9ae339-2166-48b7-82e7-f319413db079', 'INSERT', '{"op": "UPDATE", "uuid": "8e9ae339-2166-48b7-82e7-f319413db079", "objectuuid": "48618c28-9304-4ccb-b022-e2cbb1832944", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '17e46161-8f22-4300-afec-7cb6d8644ca9', 'INSERT', '{"uuid": "17e46161-8f22-4300-afec-7cb6d8644ca9", "assumed": true, "ascendantuuid": "3b195996-371c-41e4-9b66-a50553582e17", "descendantuuid": "8e9ae339-2166-48b7-82e7-f319413db079", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4c13c9aa-805a-4030-9543-a594366d3dd5', 'INSERT', '{"uuid": "4c13c9aa-805a-4030-9543-a594366d3dd5", "assumed": true, "ascendantuuid": "1b453f97-a12c-4d51-bf95-2e782b425385", "descendantuuid": "3b195996-371c-41e4-9b66-a50553582e17", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', 'INSERT', '{"uuid": "7de2ab25-6b6a-4b59-ba8d-818110ae4ccb", "roletype": "AGENT", "objectuuid": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a291504c-661a-439f-8724-3b57ca8da672', 'INSERT', '{"uuid": "a291504c-661a-439f-8724-3b57ca8da672", "assumed": true, "ascendantuuid": "3b195996-371c-41e4-9b66-a50553582e17", "descendantuuid": "7de2ab25-6b6a-4b59-ba8d-818110ae4ccb", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', 'INSERT', '{"uuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "roletype": "TENANT", "objectuuid": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'ddcd1293-8e77-4cef-91ac-9abfbc2bcd44', 'INSERT', '{"op": "SELECT", "uuid": "ddcd1293-8e77-4cef-91ac-9abfbc2bcd44", "objectuuid": "48618c28-9304-4ccb-b022-e2cbb1832944", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f50b89e6-f34a-463f-af85-aeb520a7d831', 'INSERT', '{"uuid": "f50b89e6-f34a-463f-af85-aeb520a7d831", "assumed": true, "ascendantuuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "descendantuuid": "ddcd1293-8e77-4cef-91ac-9abfbc2bcd44", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '41b763e3-60c6-40d7-ac4a-89e75e49eec6', 'INSERT', '{"uuid": "41b763e3-60c6-40d7-ac4a-89e75e49eec6", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '350cabf5-9716-493a-9cd2-2f954536faa4', 'INSERT', '{"uuid": "350cabf5-9716-493a-9cd2-2f954536faa4", "assumed": true, "ascendantuuid": "7de2ab25-6b6a-4b59-ba8d-818110ae4ccb", "descendantuuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2f4f0313-b62e-4932-9f41-cae6963a88af', 'INSERT', '{"uuid": "2f4f0313-b62e-4932-9f41-cae6963a88af", "assumed": true, "ascendantuuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd7196d34-18f9-4ed4-b703-6534333cf8e2', 'INSERT', '{"uuid": "d7196d34-18f9-4ed4-b703-6534333cf8e2", "assumed": true, "ascendantuuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3c25862f-829c-49fb-90a2-61bd22edf060', 'INSERT', '{"uuid": "3c25862f-829c-49fb-90a2-61bd22edf060", "assumed": true, "ascendantuuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bc27b1c7-0d02-49cb-959d-023a49c84fd7', 'INSERT', '{"uuid": "bc27b1c7-0d02-49cb-959d-023a49c84fd7", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "7de2ab25-6b6a-4b59-ba8d-818110ae4ccb", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2c78b77e-b708-4198-835c-2fbcabcea7c1', 'INSERT', '{"uuid": "2c78b77e-b708-4198-835c-2fbcabcea7c1", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "1b453f97-a12c-4d51-bf95-2e782b425385", "grantedbyroleuuid": null, "grantedbytriggerof": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '48618c28-9304-4ccb-b022-e2cbb1832944', 'INSERT', '{"mark": null, "type": "PARTNER", "uuid": "48618c28-9304-4ccb-b022-e2cbb1832944", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "contactuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'INSERT', '{"uuid": "f415978e-b5c2-4a99-962e-3d31a4658780", "serialid": 167, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '98d81696-7c71-4ffe-bfc2-1fea37613440', 'INSERT', '{"uuid": "98d81696-7c71-4ffe-bfc2-1fea37613440", "roletype": "OWNER", "objectuuid": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '43b09570-1e0c-43b9-811c-4aeb27eba284', 'INSERT', '{"op": "DELETE", "uuid": "43b09570-1e0c-43b9-811c-4aeb27eba284", "objectuuid": "f415978e-b5c2-4a99-962e-3d31a4658780", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '13875afa-e93d-4e1b-83f6-666292ebae24', 'INSERT', '{"uuid": "13875afa-e93d-4e1b-83f6-666292ebae24", "assumed": true, "ascendantuuid": "98d81696-7c71-4ffe-bfc2-1fea37613440", "descendantuuid": "43b09570-1e0c-43b9-811c-4aeb27eba284", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '73eb3d48-4daf-4dfe-9c23-2928dea6de58', 'INSERT', '{"uuid": "73eb3d48-4daf-4dfe-9c23-2928dea6de58", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "98d81696-7c71-4ffe-bfc2-1fea37613440", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '760fbe86-6b00-4c68-bd19-a65fd477a818', 'INSERT', '{"uuid": "760fbe86-6b00-4c68-bd19-a65fd477a818", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "98d81696-7c71-4ffe-bfc2-1fea37613440", "grantedbyroleuuid": "98d81696-7c71-4ffe-bfc2-1fea37613440", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0f5c3f08-d249-404a-b740-d759fced2d09', 'INSERT', '{"uuid": "0f5c3f08-d249-404a-b740-d759fced2d09", "roletype": "ADMIN", "objectuuid": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '756acc01-691c-46c1-b2f4-53321cc442a2', 'INSERT', '{"op": "UPDATE", "uuid": "756acc01-691c-46c1-b2f4-53321cc442a2", "objectuuid": "f415978e-b5c2-4a99-962e-3d31a4658780", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '50d75c09-191f-4132-8e8a-d1a1aa072443', 'INSERT', '{"uuid": "50d75c09-191f-4132-8e8a-d1a1aa072443", "assumed": true, "ascendantuuid": "0f5c3f08-d249-404a-b740-d759fced2d09", "descendantuuid": "756acc01-691c-46c1-b2f4-53321cc442a2", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b30af129-1376-4bcb-9538-f21a660dd6cb', 'INSERT', '{"uuid": "b30af129-1376-4bcb-9538-f21a660dd6cb", "assumed": true, "ascendantuuid": "98d81696-7c71-4ffe-bfc2-1fea37613440", "descendantuuid": "0f5c3f08-d249-404a-b740-d759fced2d09", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6c0656b5-472b-4859-af3a-b8f1c53231a5', 'INSERT', '{"uuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "roletype": "AGENT", "objectuuid": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '23259cd9-4388-43ec-9d6f-4f8fdac89b91', 'INSERT', '{"uuid": "23259cd9-4388-43ec-9d6f-4f8fdac89b91", "assumed": true, "ascendantuuid": "0f5c3f08-d249-404a-b740-d759fced2d09", "descendantuuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8ad792c1-10e1-43fa-8d5a-a6f3810878a2', 'INSERT', '{"uuid": "8ad792c1-10e1-43fa-8d5a-a6f3810878a2", "roletype": "TENANT", "objectuuid": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '75550e48-c62e-4734-9406-ad720b5b1f90', 'INSERT', '{"op": "SELECT", "uuid": "75550e48-c62e-4734-9406-ad720b5b1f90", "objectuuid": "f415978e-b5c2-4a99-962e-3d31a4658780", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c9f10142-c1f0-4639-a9b3-08b195830787', 'INSERT', '{"uuid": "c9f10142-c1f0-4639-a9b3-08b195830787", "assumed": true, "ascendantuuid": "8ad792c1-10e1-43fa-8d5a-a6f3810878a2", "descendantuuid": "75550e48-c62e-4734-9406-ad720b5b1f90", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fb781f97-f5ee-44a6-a83b-89952ceb9706', 'INSERT', '{"uuid": "fb781f97-f5ee-44a6-a83b-89952ceb9706", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "8ad792c1-10e1-43fa-8d5a-a6f3810878a2", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '73ffa08f-31ae-4101-bd02-a0de9144f82b', 'INSERT', '{"uuid": "73ffa08f-31ae-4101-bd02-a0de9144f82b", "assumed": true, "ascendantuuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "descendantuuid": "8ad792c1-10e1-43fa-8d5a-a6f3810878a2", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'eea1adff-7c6b-47ae-9bc4-1a54dbfd027d', 'INSERT', '{"uuid": "eea1adff-7c6b-47ae-9bc4-1a54dbfd027d", "assumed": true, "ascendantuuid": "8ad792c1-10e1-43fa-8d5a-a6f3810878a2", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '818fd81d-cca1-4416-a26d-8f02d8a19a2d', 'INSERT', '{"uuid": "818fd81d-cca1-4416-a26d-8f02d8a19a2d", "assumed": true, "ascendantuuid": "8ad792c1-10e1-43fa-8d5a-a6f3810878a2", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9b8a35d0-0790-4749-90ad-bbaf2a62753f', 'INSERT', '{"uuid": "9b8a35d0-0790-4749-90ad-bbaf2a62753f", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '67455246-3c3c-410d-9465-574f5651c698', 'INSERT', '{"uuid": "67455246-3c3c-410d-9465-574f5651c698", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "98d81696-7c71-4ffe-bfc2-1fea37613440", "grantedbyroleuuid": null, "grantedbytriggerof": "f415978e-b5c2-4a99-962e-3d31a4658780"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'f3bf0870-b546-4607-a032-a3da135dda48', 'INSERT', '{"op": "INSERT", "uuid": "f3bf0870-b546-4607-a032-a3da135dda48", "objectuuid": "f415978e-b5c2-4a99-962e-3d31a4658780", "optablename": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '134c2594-fd40-4cf9-b55d-34a2c0927521', 'INSERT', '{"uuid": "134c2594-fd40-4cf9-b55d-34a2c0927521", "assumed": true, "ascendantuuid": "0f5c3f08-d249-404a-b740-d759fced2d09", "descendantuuid": "f3bf0870-b546-4607-a032-a3da135dda48", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'INSERT', '{"mark": null, "type": "DEBITOR", "uuid": "f415978e-b5c2-4a99-962e-3d31a4658780", "version": 0, "anchoruuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "holderuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "contactuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '201b417e-4ebe-458b-a7ce-a287c0ad9287', 'INSERT', '{"uuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287", "serialid": 168, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b26cca89-03f0-4498-bf64-7385c0b7244a', 'INSERT', '{"uuid": "b26cca89-03f0-4498-bf64-7385c0b7244a", "roletype": "OWNER", "objectuuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '9998b7f8-aa0f-44b9-813c-61a2861e242e', 'INSERT', '{"op": "DELETE", "uuid": "9998b7f8-aa0f-44b9-813c-61a2861e242e", "objectuuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '20ae8592-3c34-4ff5-a08a-4b78b6f06ec4', 'INSERT', '{"uuid": "20ae8592-3c34-4ff5-a08a-4b78b6f06ec4", "assumed": true, "ascendantuuid": "b26cca89-03f0-4498-bf64-7385c0b7244a", "descendantuuid": "9998b7f8-aa0f-44b9-813c-61a2861e242e", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f0e59d15-a201-4e8a-8429-d12f6c5e85d1', 'INSERT', '{"uuid": "f0e59d15-a201-4e8a-8429-d12f6c5e85d1", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "b26cca89-03f0-4498-bf64-7385c0b7244a", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '199a84b3-9e30-4a9e-a7e4-1a1e193c7744', 'INSERT', '{"uuid": "199a84b3-9e30-4a9e-a7e4-1a1e193c7744", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "b26cca89-03f0-4498-bf64-7385c0b7244a", "grantedbyroleuuid": "b26cca89-03f0-4498-bf64-7385c0b7244a", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '76968391-174d-4530-b310-1244c4b1897a', 'INSERT', '{"uuid": "76968391-174d-4530-b310-1244c4b1897a", "roletype": "ADMIN", "objectuuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7ffabc42-58db-42c2-a3cb-e4ed830f47af', 'INSERT', '{"op": "UPDATE", "uuid": "7ffabc42-58db-42c2-a3cb-e4ed830f47af", "objectuuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '27356c34-8a36-42c9-8df3-b631c85beb9f', 'INSERT', '{"uuid": "27356c34-8a36-42c9-8df3-b631c85beb9f", "assumed": true, "ascendantuuid": "76968391-174d-4530-b310-1244c4b1897a", "descendantuuid": "7ffabc42-58db-42c2-a3cb-e4ed830f47af", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c8ec3f73-a9da-437b-8210-5fac4f461a76', 'INSERT', '{"uuid": "c8ec3f73-a9da-437b-8210-5fac4f461a76", "assumed": true, "ascendantuuid": "b26cca89-03f0-4498-bf64-7385c0b7244a", "descendantuuid": "76968391-174d-4530-b310-1244c4b1897a", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '863eea7c-8b49-494a-9654-9963f2dbb4e5', 'INSERT', '{"uuid": "863eea7c-8b49-494a-9654-9963f2dbb4e5", "roletype": "AGENT", "objectuuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4147266e-d023-4753-92ec-07a66f831815', 'INSERT', '{"uuid": "4147266e-d023-4753-92ec-07a66f831815", "assumed": true, "ascendantuuid": "76968391-174d-4530-b310-1244c4b1897a", "descendantuuid": "863eea7c-8b49-494a-9654-9963f2dbb4e5", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', 'INSERT', '{"uuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "roletype": "TENANT", "objectuuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '11a4c50e-451c-4041-92c6-671263f82f2d', 'INSERT', '{"op": "SELECT", "uuid": "11a4c50e-451c-4041-92c6-671263f82f2d", "objectuuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bdf804a6-d255-43bf-b752-934d962f7a9a', 'INSERT', '{"uuid": "bdf804a6-d255-43bf-b752-934d962f7a9a", "assumed": true, "ascendantuuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "descendantuuid": "11a4c50e-451c-4041-92c6-671263f82f2d", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ce23e4aa-4648-4b1c-871b-0e23b3913ef1', 'INSERT', '{"uuid": "ce23e4aa-4648-4b1c-871b-0e23b3913ef1", "assumed": true, "ascendantuuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "descendantuuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1a1ec60e-8a1e-472e-80c4-c795e0705237', 'INSERT', '{"uuid": "1a1ec60e-8a1e-472e-80c4-c795e0705237", "assumed": true, "ascendantuuid": "863eea7c-8b49-494a-9654-9963f2dbb4e5", "descendantuuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b67f3a92-1dc2-4375-b581-7e2f6984c6ff', 'INSERT', '{"uuid": "b67f3a92-1dc2-4375-b581-7e2f6984c6ff", "assumed": true, "ascendantuuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "descendantuuid": "5c9372e0-cb21-4ae7-a461-df086ad19426", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '81fd75b4-f29e-4a07-91fe-579bc357d4ad', 'INSERT', '{"uuid": "81fd75b4-f29e-4a07-91fe-579bc357d4ad", "assumed": true, "ascendantuuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1a8ac30e-dfc4-4a15-a89f-5ae76e346844', 'INSERT', '{"uuid": "1a8ac30e-dfc4-4a15-a89f-5ae76e346844", "assumed": true, "ascendantuuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a454e188-5f6a-4ce7-bf19-16b55f88482a', 'INSERT', '{"uuid": "a454e188-5f6a-4ce7-bf19-16b55f88482a", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "863eea7c-8b49-494a-9654-9963f2dbb4e5", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ab85381b-5249-47ac-88d0-c89c412d0fda', 'INSERT', '{"uuid": "ab85381b-5249-47ac-88d0-c89c412d0fda", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "b26cca89-03f0-4498-bf64-7385c0b7244a", "grantedbyroleuuid": null, "grantedbytriggerof": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '201b417e-4ebe-458b-a7ce-a287c0ad9287', 'INSERT', '{"mark": null, "type": "PARTNER", "uuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "contactuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'INSERT', '{"uuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc", "serialid": 169, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', 'INSERT', '{"uuid": "eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe", "roletype": "OWNER", "objectuuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a78188dd-3129-488c-b6e1-4889725f5215', 'INSERT', '{"op": "DELETE", "uuid": "a78188dd-3129-488c-b6e1-4889725f5215", "objectuuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b8350678-d30a-422a-bb5d-79c65af2f890', 'INSERT', '{"uuid": "b8350678-d30a-422a-bb5d-79c65af2f890", "roletype": "ADMIN", "objectuuid": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '957e1c17-2ade-4622-b9c1-958a3ddda746', 'INSERT', '{"uuid": "957e1c17-2ade-4622-b9c1-958a3ddda746", "assumed": true, "ascendantuuid": "eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe", "descendantuuid": "a78188dd-3129-488c-b6e1-4889725f5215", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6d28e53e-2724-4968-bdcd-e9bbba70bf30', 'INSERT', '{"uuid": "6d28e53e-2724-4968-bdcd-e9bbba70bf30", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7da60e3d-0309-46d0-afbc-da2269a30e81', 'INSERT', '{"uuid": "7da60e3d-0309-46d0-afbc-da2269a30e81", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe", "grantedbyroleuuid": "eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8255ff29-5961-496b-9fda-c71078e47e51', 'INSERT', '{"uuid": "8255ff29-5961-496b-9fda-c71078e47e51", "roletype": "ADMIN", "objectuuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '19382a5a-b982-49ac-9005-9358fa7a670a', 'INSERT', '{"op": "UPDATE", "uuid": "19382a5a-b982-49ac-9005-9358fa7a670a", "objectuuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '16bd32c5-1fb8-47c8-835b-ef21c321916a', 'INSERT', '{"uuid": "16bd32c5-1fb8-47c8-835b-ef21c321916a", "assumed": true, "ascendantuuid": "8255ff29-5961-496b-9fda-c71078e47e51", "descendantuuid": "19382a5a-b982-49ac-9005-9358fa7a670a", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b5a66d0f-f2e8-4ad4-9048-f23e80d29869', 'INSERT', '{"uuid": "b5a66d0f-f2e8-4ad4-9048-f23e80d29869", "assumed": true, "ascendantuuid": "eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe", "descendantuuid": "8255ff29-5961-496b-9fda-c71078e47e51", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'fe0228ea-649c-45a4-b729-181aba7f3294', 'INSERT', '{"uuid": "fe0228ea-649c-45a4-b729-181aba7f3294", "roletype": "AGENT", "objectuuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '31338810-20f5-449d-8270-13a4d48162a2', 'INSERT', '{"uuid": "31338810-20f5-449d-8270-13a4d48162a2", "assumed": true, "ascendantuuid": "8255ff29-5961-496b-9fda-c71078e47e51", "descendantuuid": "fe0228ea-649c-45a4-b729-181aba7f3294", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f218c4d9-d10b-4445-b381-b73a71f5848c', 'INSERT', '{"uuid": "f218c4d9-d10b-4445-b381-b73a71f5848c", "roletype": "TENANT", "objectuuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '6ebe0c4d-1649-4d08-897e-805019faced9', 'INSERT', '{"op": "SELECT", "uuid": "6ebe0c4d-1649-4d08-897e-805019faced9", "objectuuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e1f74e4b-3283-4892-b61a-3d73d3c2232b', 'INSERT', '{"uuid": "e1f74e4b-3283-4892-b61a-3d73d3c2232b", "assumed": true, "ascendantuuid": "f218c4d9-d10b-4445-b381-b73a71f5848c", "descendantuuid": "6ebe0c4d-1649-4d08-897e-805019faced9", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e6958262-cfeb-4a7c-8004-1943ab79b429', 'INSERT', '{"uuid": "e6958262-cfeb-4a7c-8004-1943ab79b429", "assumed": true, "ascendantuuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "descendantuuid": "f218c4d9-d10b-4445-b381-b73a71f5848c", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6b066f12-6113-4016-a776-45feb5fa565d', 'INSERT', '{"uuid": "6b066f12-6113-4016-a776-45feb5fa565d", "assumed": true, "ascendantuuid": "fe0228ea-649c-45a4-b729-181aba7f3294", "descendantuuid": "f218c4d9-d10b-4445-b381-b73a71f5848c", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f84e3e07-910e-40cc-9b82-bd739fa3754d', 'INSERT', '{"uuid": "f84e3e07-910e-40cc-9b82-bd739fa3754d", "assumed": true, "ascendantuuid": "f218c4d9-d10b-4445-b381-b73a71f5848c", "descendantuuid": "5c9372e0-cb21-4ae7-a461-df086ad19426", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c05042dd-31c3-4353-99aa-7b2728751fd3', 'INSERT', '{"uuid": "c05042dd-31c3-4353-99aa-7b2728751fd3", "assumed": true, "ascendantuuid": "f218c4d9-d10b-4445-b381-b73a71f5848c", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'af03a3ed-0a14-42ea-b6cd-60675f1785ac', 'INSERT', '{"uuid": "af03a3ed-0a14-42ea-b6cd-60675f1785ac", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "fe0228ea-649c-45a4-b729-181aba7f3294", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd9f780ca-ba82-4279-85c8-6ca168938d2e', 'INSERT', '{"uuid": "d9f780ca-ba82-4279-85c8-6ca168938d2e", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe", "grantedbyroleuuid": null, "grantedbytriggerof": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'f5fc0f70-790b-460b-a072-d1f9c01bc7de', 'INSERT', '{"op": "INSERT", "uuid": "f5fc0f70-790b-460b-a072-d1f9c01bc7de", "objectuuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc", "optablename": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2458ddeb-be02-4d0d-b7c7-c3c75981b32d', 'INSERT', '{"uuid": "2458ddeb-be02-4d0d-b7c7-c3c75981b32d", "assumed": true, "ascendantuuid": "8255ff29-5961-496b-9fda-c71078e47e51", "descendantuuid": "f5fc0f70-790b-460b-a072-d1f9c01bc7de", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'INSERT', '{"mark": null, "type": "DEBITOR", "uuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "contactuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'INSERT', '{"uuid": "f85f9a58-7651-417f-b1b2-cf522bcce415", "serialid": 170, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5242e0b6-12e3-4a59-bf06-de114cb69ff4', 'INSERT', '{"uuid": "5242e0b6-12e3-4a59-bf06-de114cb69ff4", "roletype": "OWNER", "objectuuid": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'fc09e45c-99c6-46ff-a51f-39de6d561c93', 'INSERT', '{"op": "DELETE", "uuid": "fc09e45c-99c6-46ff-a51f-39de6d561c93", "objectuuid": "f85f9a58-7651-417f-b1b2-cf522bcce415", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '213b814a-4f8f-4eb5-9a06-ef7ebd9006bd', 'INSERT', '{"uuid": "213b814a-4f8f-4eb5-9a06-ef7ebd9006bd", "assumed": true, "ascendantuuid": "5242e0b6-12e3-4a59-bf06-de114cb69ff4", "descendantuuid": "fc09e45c-99c6-46ff-a51f-39de6d561c93", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e24b7e89-1446-4179-af6e-ffff06252b2d', 'INSERT', '{"uuid": "e24b7e89-1446-4179-af6e-ffff06252b2d", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "5242e0b6-12e3-4a59-bf06-de114cb69ff4", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c47f555a-4a8e-4bdb-a879-bbcf15fd9b43', 'INSERT', '{"uuid": "c47f555a-4a8e-4bdb-a879-bbcf15fd9b43", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "5242e0b6-12e3-4a59-bf06-de114cb69ff4", "grantedbyroleuuid": "5242e0b6-12e3-4a59-bf06-de114cb69ff4", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '87567caf-5abc-4511-9191-27dbdbbee88b', 'INSERT', '{"op": "UPDATE", "uuid": "87567caf-5abc-4511-9191-27dbdbbee88b", "objectuuid": "f85f9a58-7651-417f-b1b2-cf522bcce415", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e38a8794-b4db-46e4-b67d-837a7c1a3b14', 'INSERT', '{"uuid": "e38a8794-b4db-46e4-b67d-837a7c1a3b14", "assumed": true, "ascendantuuid": "b8350678-d30a-422a-bb5d-79c65af2f890", "descendantuuid": "87567caf-5abc-4511-9191-27dbdbbee88b", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '068f8780-cc84-478f-a854-bf547462928c', 'INSERT', '{"uuid": "068f8780-cc84-478f-a854-bf547462928c", "assumed": true, "ascendantuuid": "5242e0b6-12e3-4a59-bf06-de114cb69ff4", "descendantuuid": "b8350678-d30a-422a-bb5d-79c65af2f890", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0f833f5a-8afb-4934-a8a6-9dadbdcf89dd', 'INSERT', '{"uuid": "0f833f5a-8afb-4934-a8a6-9dadbdcf89dd", "roletype": "AGENT", "objectuuid": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '451ef309-629c-4ae8-8a77-2ea3031ddf5b', 'INSERT', '{"uuid": "451ef309-629c-4ae8-8a77-2ea3031ddf5b", "assumed": true, "ascendantuuid": "b8350678-d30a-422a-bb5d-79c65af2f890", "descendantuuid": "0f833f5a-8afb-4934-a8a6-9dadbdcf89dd", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'c85e8116-355e-408a-93fa-c699da2a76f3', 'INSERT', '{"uuid": "c85e8116-355e-408a-93fa-c699da2a76f3", "roletype": "TENANT", "objectuuid": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '5fe9a533-2cd3-4433-811c-fcc415acdf60', 'INSERT', '{"op": "SELECT", "uuid": "5fe9a533-2cd3-4433-811c-fcc415acdf60", "objectuuid": "f85f9a58-7651-417f-b1b2-cf522bcce415", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'da4d7c96-becf-4375-91eb-2796ad6a6080', 'INSERT', '{"uuid": "da4d7c96-becf-4375-91eb-2796ad6a6080", "assumed": true, "ascendantuuid": "c85e8116-355e-408a-93fa-c699da2a76f3", "descendantuuid": "5fe9a533-2cd3-4433-811c-fcc415acdf60", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5398a652-1892-4d2c-8a04-d9e4797e7b74', 'INSERT', '{"uuid": "5398a652-1892-4d2c-8a04-d9e4797e7b74", "assumed": true, "ascendantuuid": "b9592474-79f3-42d9-828f-8cc2e5c8ba7c", "descendantuuid": "c85e8116-355e-408a-93fa-c699da2a76f3", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cd8cea28-0a51-4138-b8f4-c4ab1434be57', 'INSERT', '{"uuid": "cd8cea28-0a51-4138-b8f4-c4ab1434be57", "assumed": true, "ascendantuuid": "0f833f5a-8afb-4934-a8a6-9dadbdcf89dd", "descendantuuid": "c85e8116-355e-408a-93fa-c699da2a76f3", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '03061e1b-65d1-4d11-abc7-d8e7ec1fe19f', 'INSERT', '{"uuid": "03061e1b-65d1-4d11-abc7-d8e7ec1fe19f", "assumed": true, "ascendantuuid": "c85e8116-355e-408a-93fa-c699da2a76f3", "descendantuuid": "1280183b-c71a-4b86-bdec-7f3800679ef4", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a37e1b17-c3d5-4a4d-bfc5-3acbdf1f6aa3', 'INSERT', '{"uuid": "a37e1b17-c3d5-4a4d-bfc5-3acbdf1f6aa3", "assumed": true, "ascendantuuid": "c85e8116-355e-408a-93fa-c699da2a76f3", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1ece18ff-7bab-4131-a86f-29e228905d29', 'INSERT', '{"uuid": "1ece18ff-7bab-4131-a86f-29e228905d29", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "0f833f5a-8afb-4934-a8a6-9dadbdcf89dd", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f0ef38f9-1f74-4ece-9545-becfca68e4b0', 'INSERT', '{"uuid": "f0ef38f9-1f74-4ece-9545-becfca68e4b0", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "5242e0b6-12e3-4a59-bf06-de114cb69ff4", "grantedbyroleuuid": null, "grantedbytriggerof": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'INSERT', '{"mark": null, "type": "PARTNER", "uuid": "f85f9a58-7651-417f-b1b2-cf522bcce415", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "contactuuid": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'INSERT', '{"uuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe", "serialid": 171, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3de42185-1e32-4936-b305-d990b85c45c2', 'INSERT', '{"uuid": "3de42185-1e32-4936-b305-d990b85c45c2", "roletype": "OWNER", "objectuuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '359d8691-dc07-4b5a-9179-0f78927b4660', 'INSERT', '{"op": "DELETE", "uuid": "359d8691-dc07-4b5a-9179-0f78927b4660", "objectuuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f0e8cfe6-a221-45da-9365-1db2038523a7', 'INSERT', '{"uuid": "f0e8cfe6-a221-45da-9365-1db2038523a7", "assumed": true, "ascendantuuid": "3de42185-1e32-4936-b305-d990b85c45c2", "descendantuuid": "359d8691-dc07-4b5a-9179-0f78927b4660", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '76b536c1-96bb-400b-bb19-428eabb921bf', 'INSERT', '{"uuid": "76b536c1-96bb-400b-bb19-428eabb921bf", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "3de42185-1e32-4936-b305-d990b85c45c2", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '28073fd9-9f01-4cb8-9d16-253af4a81e30', 'INSERT', '{"uuid": "28073fd9-9f01-4cb8-9d16-253af4a81e30", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "3de42185-1e32-4936-b305-d990b85c45c2", "grantedbyroleuuid": "3de42185-1e32-4936-b305-d990b85c45c2", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'bb8fc553-9dbe-4ea5-a3ea-02d129841f68', 'INSERT', '{"uuid": "bb8fc553-9dbe-4ea5-a3ea-02d129841f68", "roletype": "ADMIN", "objectuuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2698d560-1c07-48e5-9d9a-78ccfb2c0631', 'INSERT', '{"op": "UPDATE", "uuid": "2698d560-1c07-48e5-9d9a-78ccfb2c0631", "objectuuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '27d55740-9964-46b5-9442-6db33186a8ff', 'INSERT', '{"uuid": "27d55740-9964-46b5-9442-6db33186a8ff", "assumed": true, "ascendantuuid": "bb8fc553-9dbe-4ea5-a3ea-02d129841f68", "descendantuuid": "2698d560-1c07-48e5-9d9a-78ccfb2c0631", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c3164a0f-34dc-4915-84c6-cbf8447290e4', 'INSERT', '{"uuid": "c3164a0f-34dc-4915-84c6-cbf8447290e4", "assumed": true, "ascendantuuid": "3de42185-1e32-4936-b305-d990b85c45c2", "descendantuuid": "bb8fc553-9dbe-4ea5-a3ea-02d129841f68", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'bbfb4fc6-80f7-4a82-aa82-3d787539ebeb', 'INSERT', '{"uuid": "bbfb4fc6-80f7-4a82-aa82-3d787539ebeb", "roletype": "AGENT", "objectuuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '223e16ac-ae1d-41f0-bd5a-97ad8d7a8f02', 'INSERT', '{"uuid": "223e16ac-ae1d-41f0-bd5a-97ad8d7a8f02", "assumed": true, "ascendantuuid": "bb8fc553-9dbe-4ea5-a3ea-02d129841f68", "descendantuuid": "bbfb4fc6-80f7-4a82-aa82-3d787539ebeb", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '07aa8ca8-e06f-4335-9cb0-99e98d45b2c6', 'INSERT', '{"uuid": "07aa8ca8-e06f-4335-9cb0-99e98d45b2c6", "roletype": "TENANT", "objectuuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '21bc4186-042f-4643-bbea-61f44563225d', 'INSERT', '{"op": "SELECT", "uuid": "21bc4186-042f-4643-bbea-61f44563225d", "objectuuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7083d2a0-ecb2-47c7-a857-60b9d4c52044', 'INSERT', '{"uuid": "7083d2a0-ecb2-47c7-a857-60b9d4c52044", "assumed": true, "ascendantuuid": "07aa8ca8-e06f-4335-9cb0-99e98d45b2c6", "descendantuuid": "21bc4186-042f-4643-bbea-61f44563225d", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5015e0ca-124a-4250-9e0b-8ead9f6595f9', 'INSERT', '{"uuid": "5015e0ca-124a-4250-9e0b-8ead9f6595f9", "assumed": true, "ascendantuuid": "b9592474-79f3-42d9-828f-8cc2e5c8ba7c", "descendantuuid": "07aa8ca8-e06f-4335-9cb0-99e98d45b2c6", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '308a364e-b65d-4599-a29d-c0948a1c79a4', 'INSERT', '{"uuid": "308a364e-b65d-4599-a29d-c0948a1c79a4", "assumed": true, "ascendantuuid": "bbfb4fc6-80f7-4a82-aa82-3d787539ebeb", "descendantuuid": "07aa8ca8-e06f-4335-9cb0-99e98d45b2c6", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '026ce7a1-3001-441f-b1e0-c4634da6e3a0', 'INSERT', '{"uuid": "026ce7a1-3001-441f-b1e0-c4634da6e3a0", "assumed": true, "ascendantuuid": "07aa8ca8-e06f-4335-9cb0-99e98d45b2c6", "descendantuuid": "1280183b-c71a-4b86-bdec-7f3800679ef4", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6fc95ac7-9ceb-45f2-86b8-dc1fe34c3cce', 'INSERT', '{"uuid": "6fc95ac7-9ceb-45f2-86b8-dc1fe34c3cce", "assumed": true, "ascendantuuid": "07aa8ca8-e06f-4335-9cb0-99e98d45b2c6", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fefb4326-1b6b-451a-b502-67094bb01d18', 'INSERT', '{"uuid": "fefb4326-1b6b-451a-b502-67094bb01d18", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "bbfb4fc6-80f7-4a82-aa82-3d787539ebeb", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '36a2fb6f-578c-41e4-9581-0ff42f0d1aac', 'INSERT', '{"uuid": "36a2fb6f-578c-41e4-9581-0ff42f0d1aac", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "3de42185-1e32-4936-b305-d990b85c45c2", "grantedbyroleuuid": null, "grantedbytriggerof": "78123dac-fed2-4e3e-817b-0c13a2129dfe"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7ceb0f31-aa57-433f-a2e3-0408c2b88b10', 'INSERT', '{"op": "INSERT", "uuid": "7ceb0f31-aa57-433f-a2e3-0408c2b88b10", "objectuuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe", "optablename": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a28bf37e-a03d-4b03-98e5-498b1ada6ea2', 'INSERT', '{"uuid": "a28bf37e-a03d-4b03-98e5-498b1ada6ea2", "assumed": true, "ascendantuuid": "bb8fc553-9dbe-4ea5-a3ea-02d129841f68", "descendantuuid": "7ceb0f31-aa57-433f-a2e3-0408c2b88b10", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'INSERT', '{"mark": null, "type": "DEBITOR", "uuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "contactuuid": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'INSERT', '{"uuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5", "serialid": 172, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0726dd6c-118e-4cbc-9077-d4dcb0e61643', 'INSERT', '{"uuid": "0726dd6c-118e-4cbc-9077-d4dcb0e61643", "roletype": "OWNER", "objectuuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '24c34e16-c5e6-4571-b850-fb64b5ddb61f', 'INSERT', '{"op": "DELETE", "uuid": "24c34e16-c5e6-4571-b850-fb64b5ddb61f", "objectuuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '242a0315-97b6-47a0-a863-2f7c98806c03', 'INSERT', '{"uuid": "242a0315-97b6-47a0-a863-2f7c98806c03", "assumed": true, "ascendantuuid": "0726dd6c-118e-4cbc-9077-d4dcb0e61643", "descendantuuid": "24c34e16-c5e6-4571-b850-fb64b5ddb61f", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ae05d838-209a-4997-89f9-21d4b03bc0ee', 'INSERT', '{"uuid": "ae05d838-209a-4997-89f9-21d4b03bc0ee", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0726dd6c-118e-4cbc-9077-d4dcb0e61643", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6e48a3f5-7017-43ec-8ced-b6ce9e72cd2d', 'INSERT', '{"uuid": "6e48a3f5-7017-43ec-8ced-b6ce9e72cd2d", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0726dd6c-118e-4cbc-9077-d4dcb0e61643", "grantedbyroleuuid": "0726dd6c-118e-4cbc-9077-d4dcb0e61643", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8dfb5e53-1554-4e5c-a045-85121ce4bd71', 'INSERT', '{"uuid": "8dfb5e53-1554-4e5c-a045-85121ce4bd71", "roletype": "ADMIN", "objectuuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '8aa371b8-dd2d-4471-95ae-149e30502e54', 'INSERT', '{"op": "UPDATE", "uuid": "8aa371b8-dd2d-4471-95ae-149e30502e54", "objectuuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9381ce69-6119-44b8-828b-09aa0cc57960', 'INSERT', '{"uuid": "9381ce69-6119-44b8-828b-09aa0cc57960", "assumed": true, "ascendantuuid": "8dfb5e53-1554-4e5c-a045-85121ce4bd71", "descendantuuid": "8aa371b8-dd2d-4471-95ae-149e30502e54", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f498d771-bf9c-41fb-9566-26de20cf27cf', 'INSERT', '{"uuid": "f498d771-bf9c-41fb-9566-26de20cf27cf", "assumed": true, "ascendantuuid": "0726dd6c-118e-4cbc-9077-d4dcb0e61643", "descendantuuid": "8dfb5e53-1554-4e5c-a045-85121ce4bd71", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '13a3ca39-6352-48e1-b1fb-82f3fc5558f2', 'INSERT', '{"uuid": "13a3ca39-6352-48e1-b1fb-82f3fc5558f2", "roletype": "AGENT", "objectuuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8b1cdea5-a267-4c69-82ae-58fcaae807d3', 'INSERT', '{"uuid": "8b1cdea5-a267-4c69-82ae-58fcaae807d3", "assumed": true, "ascendantuuid": "8dfb5e53-1554-4e5c-a045-85121ce4bd71", "descendantuuid": "13a3ca39-6352-48e1-b1fb-82f3fc5558f2", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd04aeefe-4ba4-466f-a563-b811674c6de9', 'INSERT', '{"uuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "roletype": "TENANT", "objectuuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '6aa35ccf-fc0c-4fa9-baf3-383bd7c6bc42', 'INSERT', '{"op": "SELECT", "uuid": "6aa35ccf-fc0c-4fa9-baf3-383bd7c6bc42", "objectuuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '407f1720-30d6-43e9-a867-00a4d074e948', 'INSERT', '{"uuid": "407f1720-30d6-43e9-a867-00a4d074e948", "assumed": true, "ascendantuuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "descendantuuid": "6aa35ccf-fc0c-4fa9-baf3-383bd7c6bc42", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '164d3cde-e2ab-4239-9dbf-de1c963158ac', 'INSERT', '{"uuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac", "serialid": 176, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '33b013b4-54f5-4d45-86f4-f60db0af72f7', 'INSERT', '{"uuid": "33b013b4-54f5-4d45-86f4-f60db0af72f7", "assumed": true, "ascendantuuid": "5b391d1b-439d-4ba6-9be1-dc9e8c161c7c", "descendantuuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5e79c737-6e71-4ba3-a7e2-b5ca9a882536', 'INSERT', '{"uuid": "5e79c737-6e71-4ba3-a7e2-b5ca9a882536", "assumed": true, "ascendantuuid": "13a3ca39-6352-48e1-b1fb-82f3fc5558f2", "descendantuuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a46e4f67-0994-4181-9ef4-dd8a56c92a56', 'INSERT', '{"uuid": "a46e4f67-0994-4181-9ef4-dd8a56c92a56", "assumed": true, "ascendantuuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "descendantuuid": "5167487b-90ee-40b9-9c34-535b74b3186e", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7ba2475f-ffc9-4cd6-80bf-98699d50ad1c', 'INSERT', '{"uuid": "7ba2475f-ffc9-4cd6-80bf-98699d50ad1c", "assumed": true, "ascendantuuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '13ff71cb-74b0-4da6-b531-352cc8103e88', 'INSERT', '{"uuid": "13ff71cb-74b0-4da6-b531-352cc8103e88", "assumed": true, "ascendantuuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a0a06ef2-c846-444c-b9e8-955a69675e0e', 'INSERT', '{"uuid": "a0a06ef2-c846-444c-b9e8-955a69675e0e", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "13a3ca39-6352-48e1-b1fb-82f3fc5558f2", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c1f1f854-ce70-4ef5-bc5d-04ec3910964d', 'INSERT', '{"uuid": "c1f1f854-ce70-4ef5-bc5d-04ec3910964d", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "0726dd6c-118e-4cbc-9077-d4dcb0e61643", "grantedbyroleuuid": null, "grantedbytriggerof": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'INSERT', '{"mark": null, "type": "PARTNER", "uuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "contactuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'INSERT', '{"uuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd", "serialid": 173, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'e5871fb2-3928-4139-9468-10f0f12d5e5f', 'INSERT', '{"uuid": "e5871fb2-3928-4139-9468-10f0f12d5e5f", "roletype": "OWNER", "objectuuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '12bf1e90-3965-415a-b2fa-de48afca81f5', 'INSERT', '{"op": "DELETE", "uuid": "12bf1e90-3965-415a-b2fa-de48afca81f5", "objectuuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2613adb7-f2b0-4d19-b369-8341afa1111e', 'INSERT', '{"uuid": "2613adb7-f2b0-4d19-b369-8341afa1111e", "assumed": true, "ascendantuuid": "e5871fb2-3928-4139-9468-10f0f12d5e5f", "descendantuuid": "12bf1e90-3965-415a-b2fa-de48afca81f5", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '427f8a0e-c26d-452c-b014-8788b80170a7', 'INSERT', '{"uuid": "427f8a0e-c26d-452c-b014-8788b80170a7", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "e5871fb2-3928-4139-9468-10f0f12d5e5f", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2cf9cc9c-6158-435d-8659-bd875bcbe273', 'INSERT', '{"uuid": "2cf9cc9c-6158-435d-8659-bd875bcbe273", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "e5871fb2-3928-4139-9468-10f0f12d5e5f", "grantedbyroleuuid": "e5871fb2-3928-4139-9468-10f0f12d5e5f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '834d7138-e338-4517-aacb-1c6319fa34d8', 'INSERT', '{"uuid": "834d7138-e338-4517-aacb-1c6319fa34d8", "roletype": "ADMIN", "objectuuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'e3026ecc-4a37-438b-b53e-e4ac2d4acd87', 'INSERT', '{"op": "UPDATE", "uuid": "e3026ecc-4a37-438b-b53e-e4ac2d4acd87", "objectuuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '634ef36a-4dce-4fc2-b4be-43c1b8a12327', 'INSERT', '{"uuid": "634ef36a-4dce-4fc2-b4be-43c1b8a12327", "assumed": true, "ascendantuuid": "834d7138-e338-4517-aacb-1c6319fa34d8", "descendantuuid": "e3026ecc-4a37-438b-b53e-e4ac2d4acd87", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '79861ade-1702-4c55-99bf-ada2f02af12e', 'INSERT', '{"uuid": "79861ade-1702-4c55-99bf-ada2f02af12e", "assumed": true, "ascendantuuid": "e5871fb2-3928-4139-9468-10f0f12d5e5f", "descendantuuid": "834d7138-e338-4517-aacb-1c6319fa34d8", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'e6409531-6513-43a9-84a7-eff44b18285a', 'INSERT', '{"uuid": "e6409531-6513-43a9-84a7-eff44b18285a", "roletype": "AGENT", "objectuuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'db6cea6c-2d27-4e85-8b38-77fad5a97678', 'INSERT', '{"uuid": "db6cea6c-2d27-4e85-8b38-77fad5a97678", "assumed": true, "ascendantuuid": "834d7138-e338-4517-aacb-1c6319fa34d8", "descendantuuid": "e6409531-6513-43a9-84a7-eff44b18285a", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd00a14ad-fe79-40fc-8f72-722fb5cd30bd', 'INSERT', '{"uuid": "d00a14ad-fe79-40fc-8f72-722fb5cd30bd", "roletype": "TENANT", "objectuuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a9296dcc-a040-460e-9319-d93938975fc1', 'INSERT', '{"op": "SELECT", "uuid": "a9296dcc-a040-460e-9319-d93938975fc1", "objectuuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'df1e3b6b-beb5-4797-b5b6-a8762c0f1b13', 'INSERT', '{"uuid": "df1e3b6b-beb5-4797-b5b6-a8762c0f1b13", "assumed": true, "ascendantuuid": "d00a14ad-fe79-40fc-8f72-722fb5cd30bd", "descendantuuid": "a9296dcc-a040-460e-9319-d93938975fc1", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '77ed9bdb-9264-4997-9b33-2997a3203acd', 'INSERT', '{"uuid": "77ed9bdb-9264-4997-9b33-2997a3203acd", "assumed": true, "ascendantuuid": "5b391d1b-439d-4ba6-9be1-dc9e8c161c7c", "descendantuuid": "d00a14ad-fe79-40fc-8f72-722fb5cd30bd", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8f24b7d8-6c62-4b60-9fef-7d79d0d3e931', 'INSERT', '{"uuid": "8f24b7d8-6c62-4b60-9fef-7d79d0d3e931", "assumed": true, "ascendantuuid": "e6409531-6513-43a9-84a7-eff44b18285a", "descendantuuid": "d00a14ad-fe79-40fc-8f72-722fb5cd30bd", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd344d956-9fe8-4d35-b363-ee47c946fae1', 'INSERT', '{"uuid": "d344d956-9fe8-4d35-b363-ee47c946fae1", "assumed": true, "ascendantuuid": "d00a14ad-fe79-40fc-8f72-722fb5cd30bd", "descendantuuid": "5167487b-90ee-40b9-9c34-535b74b3186e", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7db53bc9-99f3-478e-abb0-437dcbd32051', 'INSERT', '{"uuid": "7db53bc9-99f3-478e-abb0-437dcbd32051", "roletype": "OWNER", "objectuuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '102f6591-fa00-4465-9e71-ee89f913f98f', 'INSERT', '{"uuid": "102f6591-fa00-4465-9e71-ee89f913f98f", "assumed": true, "ascendantuuid": "d00a14ad-fe79-40fc-8f72-722fb5cd30bd", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9070bb47-7db9-4937-b262-4503e9e429a7', 'INSERT', '{"uuid": "9070bb47-7db9-4937-b262-4503e9e429a7", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "e6409531-6513-43a9-84a7-eff44b18285a", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '147bc926-4d72-47f5-bab4-88736d9fad9b', 'INSERT', '{"uuid": "147bc926-4d72-47f5-bab4-88736d9fad9b", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "e5871fb2-3928-4139-9468-10f0f12d5e5f", "grantedbyroleuuid": null, "grantedbytriggerof": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7b9008d5-0555-4209-8594-8d2c11e376d2', 'INSERT', '{"op": "INSERT", "uuid": "7b9008d5-0555-4209-8594-8d2c11e376d2", "objectuuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd", "optablename": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '57e9cd92-8b26-4c73-bb31-364522a91b60', 'INSERT', '{"uuid": "57e9cd92-8b26-4c73-bb31-364522a91b60", "assumed": true, "ascendantuuid": "834d7138-e338-4517-aacb-1c6319fa34d8", "descendantuuid": "7b9008d5-0555-4209-8594-8d2c11e376d2", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'INSERT', '{"mark": null, "type": "DEBITOR", "uuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd", "version": 0, "anchoruuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "holderuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "contactuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', 'INSERT', '{"uuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3", "serialid": 174, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '256083e7-90ac-4f38-9bc1-deedb0f78d2c', 'INSERT', '{"uuid": "256083e7-90ac-4f38-9bc1-deedb0f78d2c", "roletype": "OWNER", "objectuuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'c470f55a-75fd-4754-95d8-02db7679b5e6', 'INSERT', '{"op": "DELETE", "uuid": "c470f55a-75fd-4754-95d8-02db7679b5e6", "objectuuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e5cc260e-4aed-4440-b9b1-8adf3b00c2f2', 'INSERT', '{"uuid": "e5cc260e-4aed-4440-b9b1-8adf3b00c2f2", "assumed": true, "ascendantuuid": "256083e7-90ac-4f38-9bc1-deedb0f78d2c", "descendantuuid": "c470f55a-75fd-4754-95d8-02db7679b5e6", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b169456f-0f65-4ce0-9ea1-1b183da6768e', 'INSERT', '{"uuid": "b169456f-0f65-4ce0-9ea1-1b183da6768e", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "256083e7-90ac-4f38-9bc1-deedb0f78d2c", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3ce3aae9-6498-4e4c-9786-b649933facde', 'INSERT', '{"uuid": "3ce3aae9-6498-4e4c-9786-b649933facde", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "256083e7-90ac-4f38-9bc1-deedb0f78d2c", "grantedbyroleuuid": "256083e7-90ac-4f38-9bc1-deedb0f78d2c", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '28bf24da-eb68-4a99-8ff9-6e4145f5e805', 'INSERT', '{"uuid": "28bf24da-eb68-4a99-8ff9-6e4145f5e805", "roletype": "ADMIN", "objectuuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '306c497c-f967-41e4-88a6-6d357955a6b4', 'INSERT', '{"op": "UPDATE", "uuid": "306c497c-f967-41e4-88a6-6d357955a6b4", "objectuuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7dbe679a-2572-4055-a6e1-853e56732c13', 'INSERT', '{"uuid": "7dbe679a-2572-4055-a6e1-853e56732c13", "assumed": true, "ascendantuuid": "28bf24da-eb68-4a99-8ff9-6e4145f5e805", "descendantuuid": "306c497c-f967-41e4-88a6-6d357955a6b4", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '25dc18d5-53b0-46fe-9fbc-42617019c65c', 'INSERT', '{"uuid": "25dc18d5-53b0-46fe-9fbc-42617019c65c", "assumed": true, "ascendantuuid": "256083e7-90ac-4f38-9bc1-deedb0f78d2c", "descendantuuid": "28bf24da-eb68-4a99-8ff9-6e4145f5e805", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f93693fa-7dc5-4513-8537-be9541d6e5dc', 'INSERT', '{"uuid": "f93693fa-7dc5-4513-8537-be9541d6e5dc", "roletype": "AGENT", "objectuuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd36852bf-fee9-4762-b982-c5c1180f1021', 'INSERT', '{"uuid": "d36852bf-fee9-4762-b982-c5c1180f1021", "assumed": true, "ascendantuuid": "28bf24da-eb68-4a99-8ff9-6e4145f5e805", "descendantuuid": "f93693fa-7dc5-4513-8537-be9541d6e5dc", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '33a45f49-ac74-4444-a193-2ed1e0be110d', 'INSERT', '{"uuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "roletype": "TENANT", "objectuuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a43a17b9-e207-4edd-9184-790b10b105ce', 'INSERT', '{"op": "SELECT", "uuid": "a43a17b9-e207-4edd-9184-790b10b105ce", "objectuuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd49e8c2a-9535-4791-b5b2-27b4c6449571', 'INSERT', '{"uuid": "d49e8c2a-9535-4791-b5b2-27b4c6449571", "assumed": true, "ascendantuuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "descendantuuid": "a43a17b9-e207-4edd-9184-790b10b105ce", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd62c308b-5aeb-4b38-bf3c-1971873ebb7e', 'INSERT', '{"uuid": "d62c308b-5aeb-4b38-bf3c-1971873ebb7e", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bae734bf-c252-413a-9f8f-0db3f5fe41da', 'INSERT', '{"uuid": "bae734bf-c252-413a-9f8f-0db3f5fe41da", "assumed": true, "ascendantuuid": "f93693fa-7dc5-4513-8537-be9541d6e5dc", "descendantuuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1b06c14e-8822-4076-a95c-53c23fae06e7', 'INSERT', '{"uuid": "1b06c14e-8822-4076-a95c-53c23fae06e7", "assumed": true, "ascendantuuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "descendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bb5d5c36-8545-4b0c-83b3-3e6ffe79d064', 'INSERT', '{"uuid": "bb5d5c36-8545-4b0c-83b3-3e6ffe79d064", "assumed": true, "ascendantuuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2fb41844-154f-49af-afe1-f145ac823698', 'INSERT', '{"uuid": "2fb41844-154f-49af-afe1-f145ac823698", "assumed": true, "ascendantuuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7be6ff60-48f4-4727-a3b1-ccc76c4bf5f9', 'INSERT', '{"uuid": "7be6ff60-48f4-4727-a3b1-ccc76c4bf5f9", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "f93693fa-7dc5-4513-8537-be9541d6e5dc", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b54d49d5-8b35-4a08-8062-15f1488e1248', 'INSERT', '{"uuid": "b54d49d5-8b35-4a08-8062-15f1488e1248", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "256083e7-90ac-4f38-9bc1-deedb0f78d2c", "grantedbyroleuuid": null, "grantedbytriggerof": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', 'INSERT', '{"mark": null, "type": "PARTNER", "uuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "contactuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'INSERT', '{"uuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0", "serialid": 175, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd5a60c82-347b-4ebb-b95f-afff297bf966', 'INSERT', '{"uuid": "d5a60c82-347b-4ebb-b95f-afff297bf966", "roletype": "OWNER", "objectuuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'b93cca78-ac4f-497a-90b4-2fbb41ece3a5', 'INSERT', '{"op": "DELETE", "uuid": "b93cca78-ac4f-497a-90b4-2fbb41ece3a5", "objectuuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd1581eac-a086-44fb-bb09-61971de7d2fd', 'INSERT', '{"uuid": "d1581eac-a086-44fb-bb09-61971de7d2fd", "assumed": true, "ascendantuuid": "d5a60c82-347b-4ebb-b95f-afff297bf966", "descendantuuid": "b93cca78-ac4f-497a-90b4-2fbb41ece3a5", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '33d71c3e-14d6-4360-b2a1-7cfe03fc8e7c', 'INSERT', '{"uuid": "33d71c3e-14d6-4360-b2a1-7cfe03fc8e7c", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "d5a60c82-347b-4ebb-b95f-afff297bf966", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '55d421be-867d-484d-81cf-b4435b645647', 'INSERT', '{"uuid": "55d421be-867d-484d-81cf-b4435b645647", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "d5a60c82-347b-4ebb-b95f-afff297bf966", "grantedbyroleuuid": "d5a60c82-347b-4ebb-b95f-afff297bf966", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'bb40b3e2-f355-491e-a3cd-fb3ee258d4b8', 'INSERT', '{"uuid": "bb40b3e2-f355-491e-a3cd-fb3ee258d4b8", "roletype": "ADMIN", "objectuuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '78de8932-0d41-49a3-bd52-4b01648d77c4', 'INSERT', '{"op": "UPDATE", "uuid": "78de8932-0d41-49a3-bd52-4b01648d77c4", "objectuuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ee7dcf77-7d14-4ac3-ac68-75848ce80b37', 'INSERT', '{"uuid": "ee7dcf77-7d14-4ac3-ac68-75848ce80b37", "assumed": true, "ascendantuuid": "bb40b3e2-f355-491e-a3cd-fb3ee258d4b8", "descendantuuid": "78de8932-0d41-49a3-bd52-4b01648d77c4", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6ac62d07-14f8-4e7b-b32a-cdbc01d233d7', 'INSERT', '{"uuid": "6ac62d07-14f8-4e7b-b32a-cdbc01d233d7", "assumed": true, "ascendantuuid": "d5a60c82-347b-4ebb-b95f-afff297bf966", "descendantuuid": "bb40b3e2-f355-491e-a3cd-fb3ee258d4b8", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6e7feeb7-4891-4ea3-96b6-00d883da37c5', 'INSERT', '{"uuid": "6e7feeb7-4891-4ea3-96b6-00d883da37c5", "roletype": "AGENT", "objectuuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1ef30096-215a-4465-af6e-df991c630f42', 'INSERT', '{"uuid": "1ef30096-215a-4465-af6e-df991c630f42", "assumed": true, "ascendantuuid": "bb40b3e2-f355-491e-a3cd-fb3ee258d4b8", "descendantuuid": "6e7feeb7-4891-4ea3-96b6-00d883da37c5", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1ed7ff07-778c-4920-a550-563b27223228', 'INSERT', '{"uuid": "1ed7ff07-778c-4920-a550-563b27223228", "roletype": "TENANT", "objectuuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '73fbb1f4-99ac-43f3-8d7c-e032f636754d', 'INSERT', '{"op": "SELECT", "uuid": "73fbb1f4-99ac-43f3-8d7c-e032f636754d", "objectuuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5225abae-81af-491d-8e67-d0d955af7a6b', 'INSERT', '{"uuid": "5225abae-81af-491d-8e67-d0d955af7a6b", "assumed": true, "ascendantuuid": "1ed7ff07-778c-4920-a550-563b27223228", "descendantuuid": "73fbb1f4-99ac-43f3-8d7c-e032f636754d", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '58f3482b-0190-433d-8169-dda40ccdefd6', 'INSERT', '{"uuid": "58f3482b-0190-433d-8169-dda40ccdefd6", "assumed": true, "ascendantuuid": "a822e970-7b6a-417d-81d0-a8db0c985427", "descendantuuid": "1ed7ff07-778c-4920-a550-563b27223228", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '132567eb-499c-41ed-8306-0bb3f70fd887', 'INSERT', '{"uuid": "132567eb-499c-41ed-8306-0bb3f70fd887", "assumed": true, "ascendantuuid": "6e7feeb7-4891-4ea3-96b6-00d883da37c5", "descendantuuid": "1ed7ff07-778c-4920-a550-563b27223228", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e2b5210b-9f82-4aa3-a5e4-db165eff8c82', 'INSERT', '{"uuid": "e2b5210b-9f82-4aa3-a5e4-db165eff8c82", "assumed": true, "ascendantuuid": "1ed7ff07-778c-4920-a550-563b27223228", "descendantuuid": "6fc5eacb-5328-41c3-a71b-e7712338862a", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '323c5ab0-83d2-499d-843c-3e2087d129a7', 'INSERT', '{"uuid": "323c5ab0-83d2-499d-843c-3e2087d129a7", "assumed": true, "ascendantuuid": "1ed7ff07-778c-4920-a550-563b27223228", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd47916af-37ad-4693-90b9-ab5861a26b19', 'INSERT', '{"uuid": "d47916af-37ad-4693-90b9-ab5861a26b19", "assumed": true, "ascendantuuid": "1ed7ff07-778c-4920-a550-563b27223228", "descendantuuid": "d8c41124-ff96-4bc4-b3be-d0a8091128b6", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f958dfdb-2482-4a6c-b04f-c48adef089b3', 'INSERT', '{"uuid": "f958dfdb-2482-4a6c-b04f-c48adef089b3", "assumed": true, "ascendantuuid": "8bfcdf97-8c34-46ca-8159-1314cbb42105", "descendantuuid": "6e7feeb7-4891-4ea3-96b6-00d883da37c5", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3978866a-2fd9-4fe5-829f-cb20953123d2', 'INSERT', '{"uuid": "3978866a-2fd9-4fe5-829f-cb20953123d2", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "d5a60c82-347b-4ebb-b95f-afff297bf966", "grantedbyroleuuid": null, "grantedbytriggerof": "dd0eae3e-7f45-45dd-b686-f39e046918b0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '57083628-836d-4f19-9359-5fb11537f81d', 'INSERT', '{"op": "INSERT", "uuid": "57083628-836d-4f19-9359-5fb11537f81d", "objectuuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0", "optablename": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c59e8c34-016f-4cde-8f01-d26ce93dfd19', 'INSERT', '{"uuid": "c59e8c34-016f-4cde-8f01-d26ce93dfd19", "assumed": true, "ascendantuuid": "bb40b3e2-f355-491e-a3cd-fb3ee258d4b8", "descendantuuid": "57083628-836d-4f19-9359-5fb11537f81d", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'INSERT', '{"mark": null, "type": "DEBITOR", "uuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0", "version": 0, "anchoruuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "holderuuid": "d6488771-b5c0-4f39-a6d6-81af6ca982f4", "contactuuid": "29e2d42f-5f00-467f-ab73-f2ff59f2792d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '65238cdd-b9f4-40ce-87db-581432f3c7b8', 'INSERT', '{"op": "DELETE", "uuid": "65238cdd-b9f4-40ce-87db-581432f3c7b8", "objectuuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e638e901-b72b-445d-bccd-010251464101', 'INSERT', '{"uuid": "e638e901-b72b-445d-bccd-010251464101", "assumed": true, "ascendantuuid": "7db53bc9-99f3-478e-abb0-437dcbd32051", "descendantuuid": "65238cdd-b9f4-40ce-87db-581432f3c7b8", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '181658a3-893e-4d06-ace8-513ddf36c13f', 'INSERT', '{"uuid": "181658a3-893e-4d06-ace8-513ddf36c13f", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "7db53bc9-99f3-478e-abb0-437dcbd32051", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8accb64a-32a0-46c8-8cf2-8444799bf14b', 'INSERT', '{"uuid": "8accb64a-32a0-46c8-8cf2-8444799bf14b", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "7db53bc9-99f3-478e-abb0-437dcbd32051", "grantedbyroleuuid": "7db53bc9-99f3-478e-abb0-437dcbd32051", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '9771d06d-8352-404c-aaba-743800e621e9', 'INSERT', '{"uuid": "9771d06d-8352-404c-aaba-743800e621e9", "roletype": "ADMIN", "objectuuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '31b17fc6-f132-43a5-8e48-652c48306331', 'INSERT', '{"op": "UPDATE", "uuid": "31b17fc6-f132-43a5-8e48-652c48306331", "objectuuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3c27d5a9-f3e3-4d78-815b-eac8aacbac70', 'INSERT', '{"uuid": "3c27d5a9-f3e3-4d78-815b-eac8aacbac70", "assumed": true, "ascendantuuid": "9771d06d-8352-404c-aaba-743800e621e9", "descendantuuid": "31b17fc6-f132-43a5-8e48-652c48306331", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '53650829-a412-4b78-8071-23af27a3767a', 'INSERT', '{"uuid": "53650829-a412-4b78-8071-23af27a3767a", "assumed": true, "ascendantuuid": "7db53bc9-99f3-478e-abb0-437dcbd32051", "descendantuuid": "9771d06d-8352-404c-aaba-743800e621e9", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b34392da-5070-40dd-ab44-d411a9742f6d', 'INSERT', '{"uuid": "b34392da-5070-40dd-ab44-d411a9742f6d", "roletype": "AGENT", "objectuuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '21990b68-f8c1-492e-8b58-584f9373f011', 'INSERT', '{"uuid": "21990b68-f8c1-492e-8b58-584f9373f011", "assumed": true, "ascendantuuid": "9771d06d-8352-404c-aaba-743800e621e9", "descendantuuid": "b34392da-5070-40dd-ab44-d411a9742f6d", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'e37e21bc-4d4f-4d41-8c24-399be1680a15', 'INSERT', '{"uuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "roletype": "TENANT", "objectuuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'aa9b0636-bcef-4296-bfc4-2beb3c99da38', 'INSERT', '{"op": "SELECT", "uuid": "aa9b0636-bcef-4296-bfc4-2beb3c99da38", "objectuuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '254c6299-81b1-40b6-80bc-01140b2e3f21', 'INSERT', '{"uuid": "254c6299-81b1-40b6-80bc-01140b2e3f21", "assumed": true, "ascendantuuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "descendantuuid": "aa9b0636-bcef-4296-bfc4-2beb3c99da38", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3ffc38c4-6668-4096-b172-1f6d2d4dc409', 'INSERT', '{"uuid": "3ffc38c4-6668-4096-b172-1f6d2d4dc409", "assumed": true, "ascendantuuid": "42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b", "descendantuuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd6cdd1c4-0d36-48f2-8747-a47762496474', 'INSERT', '{"uuid": "d6cdd1c4-0d36-48f2-8747-a47762496474", "assumed": true, "ascendantuuid": "b34392da-5070-40dd-ab44-d411a9742f6d", "descendantuuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9e939ad9-00b2-4a23-8875-72a5ac7ff728', 'INSERT', '{"uuid": "9e939ad9-00b2-4a23-8875-72a5ac7ff728", "assumed": true, "ascendantuuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "descendantuuid": "24f9488b-412f-4314-b160-2897f4dcff1b", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9d271802-89ff-4d61-bb61-21f47e44c357', 'INSERT', '{"uuid": "9d271802-89ff-4d61-bb61-21f47e44c357", "assumed": true, "ascendantuuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0e3b55cc-cda2-4c8a-980c-aa0824656de2', 'INSERT', '{"uuid": "0e3b55cc-cda2-4c8a-980c-aa0824656de2", "assumed": true, "ascendantuuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2b6cbd8c-5a91-4081-a2df-01ab5d477416', 'INSERT', '{"uuid": "2b6cbd8c-5a91-4081-a2df-01ab5d477416", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "b34392da-5070-40dd-ab44-d411a9742f6d", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '96f807f2-391c-49f1-aa63-d14cf9fe4c7f', 'INSERT', '{"uuid": "96f807f2-391c-49f1-aa63-d14cf9fe4c7f", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "7db53bc9-99f3-478e-abb0-437dcbd32051", "grantedbyroleuuid": null, "grantedbytriggerof": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '164d3cde-e2ab-4239-9dbf-de1c963158ac', 'INSERT', '{"mark": null, "type": "PARTNER", "uuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "contactuuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'INSERT', '{"uuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac", "serialid": 177, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0d96a253-347e-4903-9db9-b362335e4341', 'INSERT', '{"uuid": "0d96a253-347e-4903-9db9-b362335e4341", "roletype": "OWNER", "objectuuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '1350b6fe-91ee-4c79-bc87-e2632a01100f', 'INSERT', '{"op": "DELETE", "uuid": "1350b6fe-91ee-4c79-bc87-e2632a01100f", "objectuuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9efd3573-3fd0-4838-b700-9e2d528d6dae', 'INSERT', '{"uuid": "9efd3573-3fd0-4838-b700-9e2d528d6dae", "assumed": true, "ascendantuuid": "0d96a253-347e-4903-9db9-b362335e4341", "descendantuuid": "1350b6fe-91ee-4c79-bc87-e2632a01100f", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0fcaf240-6815-4712-a320-6463135f4624', 'INSERT', '{"uuid": "0fcaf240-6815-4712-a320-6463135f4624", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0d96a253-347e-4903-9db9-b362335e4341", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3ff9ad8b-f7fc-4d25-aaf7-8c5937ca379f', 'INSERT', '{"uuid": "3ff9ad8b-f7fc-4d25-aaf7-8c5937ca379f", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0d96a253-347e-4903-9db9-b362335e4341", "grantedbyroleuuid": "0d96a253-347e-4903-9db9-b362335e4341", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ba80c834-f5a8-4243-98a6-9a3be63c4f47', 'INSERT', '{"uuid": "ba80c834-f5a8-4243-98a6-9a3be63c4f47", "roletype": "ADMIN", "objectuuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'bff60077-ab16-4e5d-8667-1ad2b801b961', 'INSERT', '{"op": "UPDATE", "uuid": "bff60077-ab16-4e5d-8667-1ad2b801b961", "objectuuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ae6cb6c2-c690-4527-8ec8-1c2b1d7e44df', 'INSERT', '{"uuid": "ae6cb6c2-c690-4527-8ec8-1c2b1d7e44df", "assumed": true, "ascendantuuid": "ba80c834-f5a8-4243-98a6-9a3be63c4f47", "descendantuuid": "bff60077-ab16-4e5d-8667-1ad2b801b961", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '308438c8-a6b8-4e79-8d69-67f7589d9175', 'INSERT', '{"uuid": "308438c8-a6b8-4e79-8d69-67f7589d9175", "assumed": true, "ascendantuuid": "0d96a253-347e-4903-9db9-b362335e4341", "descendantuuid": "ba80c834-f5a8-4243-98a6-9a3be63c4f47", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', 'INSERT', '{"uuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "roletype": "AGENT", "objectuuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1d4f1080-13a6-4011-bf9f-bb67a3c7be94', 'INSERT', '{"uuid": "1d4f1080-13a6-4011-bf9f-bb67a3c7be94", "assumed": true, "ascendantuuid": "ba80c834-f5a8-4243-98a6-9a3be63c4f47", "descendantuuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '42f0c634-d86b-4129-822b-f103cd6e0755', 'INSERT', '{"uuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "roletype": "TENANT", "objectuuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2b36563d-caee-4170-b444-ec02ca919165', 'INSERT', '{"op": "SELECT", "uuid": "2b36563d-caee-4170-b444-ec02ca919165", "objectuuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '77f6392c-dc17-4c22-92af-4462666916c1', 'INSERT', '{"uuid": "77f6392c-dc17-4c22-92af-4462666916c1", "assumed": true, "ascendantuuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "descendantuuid": "2b36563d-caee-4170-b444-ec02ca919165", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '744c3088-f933-4c59-ae37-d83f2357f83c', 'INSERT', '{"uuid": "744c3088-f933-4c59-ae37-d83f2357f83c", "assumed": true, "ascendantuuid": "06bf2ac2-61c5-42e9-917b-8b68afcc0d47", "descendantuuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '077b5b92-2620-489c-97c8-f32c5013437b', 'INSERT', '{"uuid": "077b5b92-2620-489c-97c8-f32c5013437b", "assumed": true, "ascendantuuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "descendantuuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4e176c48-1f1f-4e8d-8698-565f62041d2b', 'INSERT', '{"uuid": "4e176c48-1f1f-4e8d-8698-565f62041d2b", "assumed": true, "ascendantuuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "descendantuuid": "7a8959c2-e6c0-4af3-9d64-117811ec0d02", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e8ba8789-050f-4ac4-9bd2-ea16bd83ac7a', 'INSERT', '{"uuid": "e8ba8789-050f-4ac4-9bd2-ea16bd83ac7a", "assumed": true, "ascendantuuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ef21d6e1-e714-4d9e-bdbe-86408d6acc87', 'INSERT', '{"uuid": "ef21d6e1-e714-4d9e-bdbe-86408d6acc87", "assumed": true, "ascendantuuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "descendantuuid": "9115be3d-2bef-40ce-b0c9-339e460c751d", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8c126907-db23-4e7f-b375-7109fe72f2c6', 'INSERT', '{"uuid": "8c126907-db23-4e7f-b375-7109fe72f2c6", "assumed": true, "ascendantuuid": "bab68a5a-2016-454e-b143-8c334188d2c4", "descendantuuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bc3130a1-8534-426a-9dea-7744b423ee9c', 'INSERT', '{"uuid": "bc3130a1-8534-426a-9dea-7744b423ee9c", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "0d96a253-347e-4903-9db9-b362335e4341", "grantedbyroleuuid": null, "grantedbytriggerof": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'dbead323-2088-4b0b-ac6c-599696219411', 'INSERT', '{"op": "INSERT", "uuid": "dbead323-2088-4b0b-ac6c-599696219411", "objectuuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac", "optablename": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd5a8ffce-04bb-4fa3-b9a7-d4f9e15564aa', 'INSERT', '{"uuid": "d5a8ffce-04bb-4fa3-b9a7-d4f9e15564aa", "assumed": true, "ascendantuuid": "ba80c834-f5a8-4243-98a6-9a3be63c4f47", "descendantuuid": "dbead323-2088-4b0b-ac6c-599696219411", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'INSERT', '{"mark": null, "type": "DEBITOR", "uuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "f5dd291e-f8f5-4240-93d5-9fc1e56c376a", "contactuuid": "33b40eee-30ed-4924-859d-6c58b5aa4124"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'INSERT', '{"uuid": "a85fd289-2383-4abe-b796-9b0b47d702d2", "serialid": 178, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', 'INSERT', '{"uuid": "0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d", "roletype": "OWNER", "objectuuid": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'b6f28163-8b15-403b-ad8e-8322ae8bb5b9', 'INSERT', '{"op": "DELETE", "uuid": "b6f28163-8b15-403b-ad8e-8322ae8bb5b9", "objectuuid": "a85fd289-2383-4abe-b796-9b0b47d702d2", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd5305aaf-e2ab-4f48-8a2e-374e8d5b181e', 'INSERT', '{"uuid": "d5305aaf-e2ab-4f48-8a2e-374e8d5b181e", "assumed": true, "ascendantuuid": "0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d", "descendantuuid": "b6f28163-8b15-403b-ad8e-8322ae8bb5b9", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '36f25015-ab5d-478b-b8e9-bcfb12daa23f', 'INSERT', '{"uuid": "36f25015-ab5d-478b-b8e9-bcfb12daa23f", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0d5c34e2-7fd3-4008-806f-c71fbc354439', 'INSERT', '{"uuid": "0d5c34e2-7fd3-4008-806f-c71fbc354439", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d", "grantedbyroleuuid": "0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'cb295fdb-e294-4b05-944e-f0a4929ebeeb', 'INSERT', '{"uuid": "cb295fdb-e294-4b05-944e-f0a4929ebeeb", "roletype": "ADMIN", "objectuuid": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '9cf4d386-c968-40c4-8af9-401c58cca6b4', 'INSERT', '{"op": "UPDATE", "uuid": "9cf4d386-c968-40c4-8af9-401c58cca6b4", "objectuuid": "a85fd289-2383-4abe-b796-9b0b47d702d2", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7d632200-5506-4856-a3c0-d806b1ee708b', 'INSERT', '{"uuid": "7d632200-5506-4856-a3c0-d806b1ee708b", "roletype": "TENANT", "objectuuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '97bb7d46-c076-472f-9210-7756f0d3b1de', 'INSERT', '{"uuid": "97bb7d46-c076-472f-9210-7756f0d3b1de", "assumed": true, "ascendantuuid": "cb295fdb-e294-4b05-944e-f0a4929ebeeb", "descendantuuid": "9cf4d386-c968-40c4-8af9-401c58cca6b4", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '77bb249a-a506-4b22-8ade-3c3a211e98fc', 'INSERT', '{"uuid": "77bb249a-a506-4b22-8ade-3c3a211e98fc", "assumed": true, "ascendantuuid": "0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d", "descendantuuid": "cb295fdb-e294-4b05-944e-f0a4929ebeeb", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f3af3c81-a512-47ea-8b47-0386291e6590', 'INSERT', '{"uuid": "f3af3c81-a512-47ea-8b47-0386291e6590", "roletype": "AGENT", "objectuuid": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5fb16788-c6df-4a8e-b9f5-9b32668de76c', 'INSERT', '{"uuid": "5fb16788-c6df-4a8e-b9f5-9b32668de76c", "assumed": true, "ascendantuuid": "cb295fdb-e294-4b05-944e-f0a4929ebeeb", "descendantuuid": "f3af3c81-a512-47ea-8b47-0386291e6590", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', 'INSERT', '{"uuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "roletype": "TENANT", "objectuuid": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '14b3a0c2-46d5-409e-bd0d-ff369c37950a', 'INSERT', '{"op": "SELECT", "uuid": "14b3a0c2-46d5-409e-bd0d-ff369c37950a", "objectuuid": "a85fd289-2383-4abe-b796-9b0b47d702d2", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c49d231c-9b99-4bf1-a5b3-9fd54ea13026', 'INSERT', '{"uuid": "c49d231c-9b99-4bf1-a5b3-9fd54ea13026", "assumed": true, "ascendantuuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "descendantuuid": "14b3a0c2-46d5-409e-bd0d-ff369c37950a", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b02fa45d-4e3f-4117-b702-6567d9197965', 'INSERT', '{"uuid": "b02fa45d-4e3f-4117-b702-6567d9197965", "assumed": true, "ascendantuuid": "57ee73c6-769e-461e-9cea-7bfe56970bf7", "descendantuuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c1061599-40fe-498d-b569-e66220a277fa', 'INSERT', '{"uuid": "c1061599-40fe-498d-b569-e66220a277fa", "assumed": true, "ascendantuuid": "f3af3c81-a512-47ea-8b47-0386291e6590", "descendantuuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3a244791-44c8-4eff-8361-7e12ebc10375', 'INSERT', '{"uuid": "3a244791-44c8-4eff-8361-7e12ebc10375", "assumed": true, "ascendantuuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "descendantuuid": "e65ad361-79d6-46a3-a7c7-a18048b7237a", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2852d47f-a898-42ff-aa68-0d63a4bfd696', 'INSERT', '{"uuid": "2852d47f-a898-42ff-aa68-0d63a4bfd696", "assumed": true, "ascendantuuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6af132d3-5e42-4379-bceb-c27b9a4a27c7', 'INSERT', '{"uuid": "6af132d3-5e42-4379-bceb-c27b9a4a27c7", "assumed": true, "ascendantuuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "descendantuuid": "ea1789f5-11fe-4ec3-8d12-2623ba592c7f", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3537239c-f45c-4357-abd7-7ff36e7bc90b', 'INSERT', '{"uuid": "3537239c-f45c-4357-abd7-7ff36e7bc90b", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "f3af3c81-a512-47ea-8b47-0386291e6590", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e7352fb4-4789-4398-bca1-5e02ffb184af', 'INSERT', '{"uuid": "e7352fb4-4789-4398-bca1-5e02ffb184af", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d", "grantedbyroleuuid": null, "grantedbytriggerof": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'INSERT', '{"mark": null, "type": "PARTNER", "uuid": "a85fd289-2383-4abe-b796-9b0b47d702d2", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "contactuuid": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'INSERT', '{"uuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e", "serialid": 179, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'dc8ae2b6-d20e-4592-8356-3547bcc58f80', 'INSERT', '{"uuid": "dc8ae2b6-d20e-4592-8356-3547bcc58f80", "roletype": "OWNER", "objectuuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'd6ea4d88-241f-4430-9590-918a5de2a3d4', 'INSERT', '{"op": "DELETE", "uuid": "d6ea4d88-241f-4430-9590-918a5de2a3d4", "objectuuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bf8dc5e3-3d2b-4a20-82c9-345b886a902f', 'INSERT', '{"uuid": "bf8dc5e3-3d2b-4a20-82c9-345b886a902f", "assumed": true, "ascendantuuid": "dc8ae2b6-d20e-4592-8356-3547bcc58f80", "descendantuuid": "d6ea4d88-241f-4430-9590-918a5de2a3d4", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e824602d-53bf-49ba-b6c5-c78b826bf94c', 'INSERT', '{"uuid": "e824602d-53bf-49ba-b6c5-c78b826bf94c", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "dc8ae2b6-d20e-4592-8356-3547bcc58f80", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bef40c9e-b569-417c-a8c3-a46bd4a1c43c', 'INSERT', '{"uuid": "bef40c9e-b569-417c-a8c3-a46bd4a1c43c", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "dc8ae2b6-d20e-4592-8356-3547bcc58f80", "grantedbyroleuuid": "dc8ae2b6-d20e-4592-8356-3547bcc58f80", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3010c421-5c96-4f0d-b214-c773e0915564', 'INSERT', '{"uuid": "3010c421-5c96-4f0d-b214-c773e0915564", "roletype": "ADMIN", "objectuuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '5c038c2d-e3f8-4593-9733-0e1d2c85e318', 'INSERT', '{"op": "UPDATE", "uuid": "5c038c2d-e3f8-4593-9733-0e1d2c85e318", "objectuuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8be44ea3-3a15-45bf-80cf-da0dd7168dcf', 'INSERT', '{"uuid": "8be44ea3-3a15-45bf-80cf-da0dd7168dcf", "assumed": true, "ascendantuuid": "3010c421-5c96-4f0d-b214-c773e0915564", "descendantuuid": "5c038c2d-e3f8-4593-9733-0e1d2c85e318", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e72f6461-12f1-49dd-8fee-e7e4b1cd0ab4', 'INSERT', '{"uuid": "e72f6461-12f1-49dd-8fee-e7e4b1cd0ab4", "assumed": true, "ascendantuuid": "dc8ae2b6-d20e-4592-8356-3547bcc58f80", "descendantuuid": "3010c421-5c96-4f0d-b214-c773e0915564", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '270aac69-03bb-4429-b925-3019bd92cf32', 'INSERT', '{"uuid": "270aac69-03bb-4429-b925-3019bd92cf32", "roletype": "AGENT", "objectuuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3985a8c6-9cbf-4e1a-a95f-1f83030eb7a4', 'INSERT', '{"uuid": "3985a8c6-9cbf-4e1a-a95f-1f83030eb7a4", "assumed": true, "ascendantuuid": "3010c421-5c96-4f0d-b214-c773e0915564", "descendantuuid": "270aac69-03bb-4429-b925-3019bd92cf32", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '63a0e010-3a4d-4ec7-bcd5-2fa63a1cca23', 'INSERT', '{"op": "SELECT", "uuid": "63a0e010-3a4d-4ec7-bcd5-2fa63a1cca23", "objectuuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '81b68632-0cb7-41d8-bf15-61048ff1bc3c', 'INSERT', '{"uuid": "81b68632-0cb7-41d8-bf15-61048ff1bc3c", "assumed": true, "ascendantuuid": "7d632200-5506-4856-a3c0-d806b1ee708b", "descendantuuid": "63a0e010-3a4d-4ec7-bcd5-2fa63a1cca23", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '24b19f50-1f29-4879-a6d4-d5f40fcab1c2', 'INSERT', '{"uuid": "24b19f50-1f29-4879-a6d4-d5f40fcab1c2", "assumed": true, "ascendantuuid": "57ee73c6-769e-461e-9cea-7bfe56970bf7", "descendantuuid": "7d632200-5506-4856-a3c0-d806b1ee708b", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0084180b-3df7-42bd-976d-54d2f30fe5e6', 'INSERT', '{"uuid": "0084180b-3df7-42bd-976d-54d2f30fe5e6", "assumed": true, "ascendantuuid": "270aac69-03bb-4429-b925-3019bd92cf32", "descendantuuid": "7d632200-5506-4856-a3c0-d806b1ee708b", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2d7e7850-06e8-4f75-9a32-bc7af55f0187', 'INSERT', '{"uuid": "2d7e7850-06e8-4f75-9a32-bc7af55f0187", "assumed": true, "ascendantuuid": "7d632200-5506-4856-a3c0-d806b1ee708b", "descendantuuid": "e65ad361-79d6-46a3-a7c7-a18048b7237a", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b0be56d6-9d14-4de6-8b86-c67b8466a25c', 'INSERT', '{"uuid": "b0be56d6-9d14-4de6-8b86-c67b8466a25c", "assumed": true, "ascendantuuid": "7d632200-5506-4856-a3c0-d806b1ee708b", "descendantuuid": "ea1789f5-11fe-4ec3-8d12-2623ba592c7f", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0f722b48-de60-4b11-a39f-e3dfcf5aa326', 'INSERT', '{"uuid": "0f722b48-de60-4b11-a39f-e3dfcf5aa326", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "270aac69-03bb-4429-b925-3019bd92cf32", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '358cfa61-0b40-46eb-a240-dc3320284148', 'INSERT', '{"uuid": "358cfa61-0b40-46eb-a240-dc3320284148", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "dc8ae2b6-d20e-4592-8356-3547bcc58f80", "grantedbyroleuuid": null, "grantedbytriggerof": "bc8c4b35-c55b-4c3e-9122-94485909b17e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'fc2159a0-53c2-416b-9daf-506258c420e3', 'INSERT', '{"op": "INSERT", "uuid": "fc2159a0-53c2-416b-9daf-506258c420e3", "objectuuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e", "optablename": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2155b641-8562-4ad5-a883-3d5c12b71564', 'INSERT', '{"uuid": "2155b641-8562-4ad5-a883-3d5c12b71564", "assumed": true, "ascendantuuid": "3010c421-5c96-4f0d-b214-c773e0915564", "descendantuuid": "fc2159a0-53c2-416b-9daf-506258c420e3", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'INSERT', '{"mark": null, "type": "DEBITOR", "uuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e", "version": 0, "anchoruuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "holderuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "contactuuid": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'INSERT', '{"uuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be", "serialid": 180, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', 'INSERT', '{"uuid": "7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff", "roletype": "OWNER", "objectuuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '9de4eb42-73cf-4178-ad43-0bc7b9042c76', 'INSERT', '{"op": "DELETE", "uuid": "9de4eb42-73cf-4178-ad43-0bc7b9042c76", "objectuuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '14b41604-025f-45cf-a1fa-92b91a7b060e', 'INSERT', '{"uuid": "14b41604-025f-45cf-a1fa-92b91a7b060e", "assumed": true, "ascendantuuid": "7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff", "descendantuuid": "9de4eb42-73cf-4178-ad43-0bc7b9042c76", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c2077db5-79fb-481f-bc9d-95337bfb2577', 'INSERT', '{"uuid": "c2077db5-79fb-481f-bc9d-95337bfb2577", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4cda3b7b-bf01-4342-b3db-fc8998b6ef1e', 'INSERT', '{"uuid": "4cda3b7b-bf01-4342-b3db-fc8998b6ef1e", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff", "grantedbyroleuuid": "7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f101cc07-ed84-4e34-9f70-62ec6a646e81', 'INSERT', '{"uuid": "f101cc07-ed84-4e34-9f70-62ec6a646e81", "roletype": "ADMIN", "objectuuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'e1cd9ef3-11e4-4907-bb78-b30f83f576e8', 'INSERT', '{"op": "UPDATE", "uuid": "e1cd9ef3-11e4-4907-bb78-b30f83f576e8", "objectuuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '670460c6-e47b-48b6-bf0e-e5a5dbf0d43b', 'INSERT', '{"uuid": "670460c6-e47b-48b6-bf0e-e5a5dbf0d43b", "assumed": true, "ascendantuuid": "f101cc07-ed84-4e34-9f70-62ec6a646e81", "descendantuuid": "e1cd9ef3-11e4-4907-bb78-b30f83f576e8", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0a0f5572-7ef2-4996-b7f9-9092b99b70ba', 'INSERT', '{"uuid": "0a0f5572-7ef2-4996-b7f9-9092b99b70ba", "assumed": true, "ascendantuuid": "7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff", "descendantuuid": "f101cc07-ed84-4e34-9f70-62ec6a646e81", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1d4c6f1f-200f-4a68-ae7b-6fda13687e41', 'INSERT', '{"uuid": "1d4c6f1f-200f-4a68-ae7b-6fda13687e41", "roletype": "AGENT", "objectuuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4e574ad9-8a38-413e-8bfa-55930363707f', 'INSERT', '{"uuid": "4e574ad9-8a38-413e-8bfa-55930363707f", "assumed": true, "ascendantuuid": "f101cc07-ed84-4e34-9f70-62ec6a646e81", "descendantuuid": "1d4c6f1f-200f-4a68-ae7b-6fda13687e41", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', 'INSERT', '{"uuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "roletype": "TENANT", "objectuuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2877af8d-ece8-4b33-8b68-a4985caa2635', 'INSERT', '{"op": "SELECT", "uuid": "2877af8d-ece8-4b33-8b68-a4985caa2635", "objectuuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5dc0084d-25cb-4af7-a2a9-ff2446a4a797', 'INSERT', '{"uuid": "5dc0084d-25cb-4af7-a2a9-ff2446a4a797", "assumed": true, "ascendantuuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "descendantuuid": "2877af8d-ece8-4b33-8b68-a4985caa2635", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '60ca4436-2f6e-4152-8551-4e9a465a7b29', 'INSERT', '{"uuid": "60ca4436-2f6e-4152-8551-4e9a465a7b29", "assumed": true, "ascendantuuid": "93ec1b20-de2b-4af1-924f-047a7afa0276", "descendantuuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6be28944-7289-4924-adfa-9d613a1903d0', 'INSERT', '{"uuid": "6be28944-7289-4924-adfa-9d613a1903d0", "assumed": true, "ascendantuuid": "1d4c6f1f-200f-4a68-ae7b-6fda13687e41", "descendantuuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4589acd9-b04f-432a-91ea-f157d75e0b16', 'INSERT', '{"uuid": "4589acd9-b04f-432a-91ea-f157d75e0b16", "assumed": true, "ascendantuuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "descendantuuid": "4330591d-61d5-4435-827a-c71b8328a700", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e30e4485-5f53-41aa-9d5c-e580d98e8adf', 'INSERT', '{"uuid": "e30e4485-5f53-41aa-9d5c-e580d98e8adf", "assumed": true, "ascendantuuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7969599c-5bef-42c7-8513-9c7e545e804c', 'INSERT', '{"uuid": "7969599c-5bef-42c7-8513-9c7e545e804c", "assumed": true, "ascendantuuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "descendantuuid": "a7ff4f1c-7c33-43e0-b264-37339141f7f9", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c0c021ee-8650-4478-964f-0e7297484724', 'INSERT', '{"uuid": "c0c021ee-8650-4478-964f-0e7297484724", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "1d4c6f1f-200f-4a68-ae7b-6fda13687e41", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '25a3a86f-88d4-48b5-8b49-9ab3a0cb9d41', 'INSERT', '{"uuid": "25a3a86f-88d4-48b5-8b49-9ab3a0cb9d41", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff", "grantedbyroleuuid": null, "grantedbytriggerof": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'INSERT', '{"mark": null, "type": "PARTNER", "uuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "contactuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '268c2ce6-8945-4393-9916-ac90050f064a', 'INSERT', '{"uuid": "268c2ce6-8945-4393-9916-ac90050f064a", "serialid": 181, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', 'INSERT', '{"uuid": "3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c", "roletype": "OWNER", "objectuuid": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a4b7dd17-bc12-4152-80e0-4186caab003a', 'INSERT', '{"op": "DELETE", "uuid": "a4b7dd17-bc12-4152-80e0-4186caab003a", "objectuuid": "268c2ce6-8945-4393-9916-ac90050f064a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '014daf58-1e7c-4367-8913-001885ac18ba', 'INSERT', '{"uuid": "014daf58-1e7c-4367-8913-001885ac18ba", "assumed": true, "ascendantuuid": "3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c", "descendantuuid": "a4b7dd17-bc12-4152-80e0-4186caab003a", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '55252844-1a23-453b-86da-d8a61347ea8e', 'INSERT', '{"uuid": "55252844-1a23-453b-86da-d8a61347ea8e", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0897358d-6a31-4239-840a-5643616ceefa', 'INSERT', '{"uuid": "0897358d-6a31-4239-840a-5643616ceefa", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c", "grantedbyroleuuid": "3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6ec65964-76d1-4e7d-aacc-6a18e4eadf67', 'INSERT', '{"uuid": "6ec65964-76d1-4e7d-aacc-6a18e4eadf67", "roletype": "ADMIN", "objectuuid": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '3dec9bdf-06fc-4a27-b26d-5918ad1e5990', 'INSERT', '{"op": "UPDATE", "uuid": "3dec9bdf-06fc-4a27-b26d-5918ad1e5990", "objectuuid": "268c2ce6-8945-4393-9916-ac90050f064a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '472f52b4-1b7b-4194-b8f0-d7c23686f721', 'INSERT', '{"uuid": "472f52b4-1b7b-4194-b8f0-d7c23686f721", "assumed": true, "ascendantuuid": "6ec65964-76d1-4e7d-aacc-6a18e4eadf67", "descendantuuid": "3dec9bdf-06fc-4a27-b26d-5918ad1e5990", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1741dfae-e362-4172-a594-d9c43da3c695', 'INSERT', '{"uuid": "1741dfae-e362-4172-a594-d9c43da3c695", "assumed": true, "ascendantuuid": "3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c", "descendantuuid": "6ec65964-76d1-4e7d-aacc-6a18e4eadf67", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7e71f107-6953-42c7-a560-dc9036094198', 'INSERT', '{"uuid": "7e71f107-6953-42c7-a560-dc9036094198", "roletype": "AGENT", "objectuuid": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f8534a79-f9a6-433e-ad0a-670a242adb12', 'INSERT', '{"uuid": "f8534a79-f9a6-433e-ad0a-670a242adb12", "assumed": true, "ascendantuuid": "6ec65964-76d1-4e7d-aacc-6a18e4eadf67", "descendantuuid": "7e71f107-6953-42c7-a560-dc9036094198", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '51bb98dd-9201-40e4-b008-221337eeb471', 'INSERT', '{"uuid": "51bb98dd-9201-40e4-b008-221337eeb471", "roletype": "TENANT", "objectuuid": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7efca22b-d9ff-4331-a718-ddfca5ebac59', 'INSERT', '{"op": "SELECT", "uuid": "7efca22b-d9ff-4331-a718-ddfca5ebac59", "objectuuid": "268c2ce6-8945-4393-9916-ac90050f064a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '71f86f97-8d99-488a-837d-63fb7391647b', 'INSERT', '{"uuid": "71f86f97-8d99-488a-837d-63fb7391647b", "assumed": true, "ascendantuuid": "51bb98dd-9201-40e4-b008-221337eeb471", "descendantuuid": "7efca22b-d9ff-4331-a718-ddfca5ebac59", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '57645ef6-c6b1-42f2-a8ff-d92ff3c5728f', 'INSERT', '{"uuid": "57645ef6-c6b1-42f2-a8ff-d92ff3c5728f", "assumed": true, "ascendantuuid": "93ec1b20-de2b-4af1-924f-047a7afa0276", "descendantuuid": "51bb98dd-9201-40e4-b008-221337eeb471", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f1a7d8e4-712d-4e30-bf71-4b0c79489a29', 'INSERT', '{"uuid": "f1a7d8e4-712d-4e30-bf71-4b0c79489a29", "assumed": true, "ascendantuuid": "7e71f107-6953-42c7-a560-dc9036094198", "descendantuuid": "51bb98dd-9201-40e4-b008-221337eeb471", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6fbae586-ade0-46b4-9d3d-abd641e5da1e', 'INSERT', '{"uuid": "6fbae586-ade0-46b4-9d3d-abd641e5da1e", "assumed": true, "ascendantuuid": "51bb98dd-9201-40e4-b008-221337eeb471", "descendantuuid": "4330591d-61d5-4435-827a-c71b8328a700", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ab6f00c4-88be-4613-b44c-4760760877a3', 'INSERT', '{"uuid": "ab6f00c4-88be-4613-b44c-4760760877a3", "assumed": true, "ascendantuuid": "51bb98dd-9201-40e4-b008-221337eeb471", "descendantuuid": "a7ff4f1c-7c33-43e0-b264-37339141f7f9", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '86b706e2-9225-482e-b82a-d4ac4adab065', 'INSERT', '{"uuid": "86b706e2-9225-482e-b82a-d4ac4adab065", "serialid": 183, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '869d177e-9bf1-44ad-b890-efab238568ac', 'INSERT', '{"uuid": "869d177e-9bf1-44ad-b890-efab238568ac", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "7e71f107-6953-42c7-a560-dc9036094198", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fa3d3a8c-40e6-4c39-9be7-3225af11ad34', 'INSERT', '{"uuid": "fa3d3a8c-40e6-4c39-9be7-3225af11ad34", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c", "grantedbyroleuuid": null, "grantedbytriggerof": "268c2ce6-8945-4393-9916-ac90050f064a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '85505863-6857-4ae9-82de-f9394eebd7df', 'INSERT', '{"op": "INSERT", "uuid": "85505863-6857-4ae9-82de-f9394eebd7df", "objectuuid": "268c2ce6-8945-4393-9916-ac90050f064a", "optablename": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'afc35729-f746-43f6-bfe2-cdc1688c89a3', 'INSERT', '{"uuid": "afc35729-f746-43f6-bfe2-cdc1688c89a3", "assumed": true, "ascendantuuid": "6ec65964-76d1-4e7d-aacc-6a18e4eadf67", "descendantuuid": "85505863-6857-4ae9-82de-f9394eebd7df", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '268c2ce6-8945-4393-9916-ac90050f064a', 'INSERT', '{"mark": null, "type": "DEBITOR", "uuid": "268c2ce6-8945-4393-9916-ac90050f064a", "version": 0, "anchoruuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "holderuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "contactuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 'INSERT', '{"uuid": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4", "serialid": 182, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '9a93e3c2-b1c1-47d1-8761-0cafe9b42917', 'INSERT', '{"uuid": "9a93e3c2-b1c1-47d1-8761-0cafe9b42917", "roletype": "OWNER", "objectuuid": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'ccdf92f5-ebce-4d9b-b544-e470959b498b', 'INSERT', '{"op": "DELETE", "uuid": "ccdf92f5-ebce-4d9b-b544-e470959b498b", "objectuuid": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6bcdce43-ebe8-48a8-8bbe-757ac3d22f62', 'INSERT', '{"uuid": "6bcdce43-ebe8-48a8-8bbe-757ac3d22f62", "assumed": true, "ascendantuuid": "9a93e3c2-b1c1-47d1-8761-0cafe9b42917", "descendantuuid": "ccdf92f5-ebce-4d9b-b544-e470959b498b", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fc944320-20a9-4b02-bb1f-8a8692b477c4', 'INSERT', '{"uuid": "fc944320-20a9-4b02-bb1f-8a8692b477c4", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "9a93e3c2-b1c1-47d1-8761-0cafe9b42917", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f3462b23-10d0-4491-9f6f-f938b0479eff', 'INSERT', '{"uuid": "f3462b23-10d0-4491-9f6f-f938b0479eff", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "9a93e3c2-b1c1-47d1-8761-0cafe9b42917", "grantedbyroleuuid": "9a93e3c2-b1c1-47d1-8761-0cafe9b42917", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'acf8c4b2-7c5f-4e89-9696-77a598b5f8b8', 'INSERT', '{"uuid": "acf8c4b2-7c5f-4e89-9696-77a598b5f8b8", "roletype": "ADMIN", "objectuuid": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '307b971b-39bf-4a5d-8595-ad080abafbb0', 'INSERT', '{"op": "UPDATE", "uuid": "307b971b-39bf-4a5d-8595-ad080abafbb0", "objectuuid": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '80aa3cff-e661-4853-868e-66706ce46d96', 'INSERT', '{"uuid": "80aa3cff-e661-4853-868e-66706ce46d96", "assumed": true, "ascendantuuid": "acf8c4b2-7c5f-4e89-9696-77a598b5f8b8", "descendantuuid": "307b971b-39bf-4a5d-8595-ad080abafbb0", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ef9ac178-79d4-460f-9cbc-3c1f1d9fcfee', 'INSERT', '{"uuid": "ef9ac178-79d4-460f-9cbc-3c1f1d9fcfee", "assumed": true, "ascendantuuid": "9a93e3c2-b1c1-47d1-8761-0cafe9b42917", "descendantuuid": "acf8c4b2-7c5f-4e89-9696-77a598b5f8b8", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ed2f5f84-cc30-4f29-aef7-48eb64a5fb15', 'INSERT', '{"uuid": "ed2f5f84-cc30-4f29-aef7-48eb64a5fb15", "roletype": "AGENT", "objectuuid": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '34113cca-7848-4dd1-85b5-1137c93de73b', 'INSERT', '{"uuid": "34113cca-7848-4dd1-85b5-1137c93de73b", "assumed": true, "ascendantuuid": "acf8c4b2-7c5f-4e89-9696-77a598b5f8b8", "descendantuuid": "ed2f5f84-cc30-4f29-aef7-48eb64a5fb15", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'c3aff634-452d-47fc-954f-9edebe3a0c74', 'INSERT', '{"uuid": "c3aff634-452d-47fc-954f-9edebe3a0c74", "roletype": "TENANT", "objectuuid": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '37dc0f00-4620-46dc-83a6-3d64cbc7a1a2', 'INSERT', '{"op": "SELECT", "uuid": "37dc0f00-4620-46dc-83a6-3d64cbc7a1a2", "objectuuid": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '041d4019-8ada-401a-8cff-3c3d5eb68344', 'INSERT', '{"uuid": "041d4019-8ada-401a-8cff-3c3d5eb68344", "assumed": true, "ascendantuuid": "c3aff634-452d-47fc-954f-9edebe3a0c74", "descendantuuid": "37dc0f00-4620-46dc-83a6-3d64cbc7a1a2", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bab7f934-c15a-4ea4-925c-97df5c2f07c9', 'INSERT', '{"uuid": "bab7f934-c15a-4ea4-925c-97df5c2f07c9", "assumed": true, "ascendantuuid": "b9592474-79f3-42d9-828f-8cc2e5c8ba7c", "descendantuuid": "c3aff634-452d-47fc-954f-9edebe3a0c74", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '22fabbc7-68d6-4067-9389-4df1f0fc81b6', 'INSERT', '{"uuid": "22fabbc7-68d6-4067-9389-4df1f0fc81b6", "assumed": true, "ascendantuuid": "ed2f5f84-cc30-4f29-aef7-48eb64a5fb15", "descendantuuid": "c3aff634-452d-47fc-954f-9edebe3a0c74", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3eefa810-8bf3-465e-8fc8-0b9be1454ced', 'INSERT', '{"uuid": "3eefa810-8bf3-465e-8fc8-0b9be1454ced", "assumed": true, "ascendantuuid": "c3aff634-452d-47fc-954f-9edebe3a0c74", "descendantuuid": "1280183b-c71a-4b86-bdec-7f3800679ef4", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c1c89eb6-d2a7-42d0-a8eb-2cc7432baa6c', 'INSERT', '{"uuid": "c1c89eb6-d2a7-42d0-a8eb-2cc7432baa6c", "assumed": true, "ascendantuuid": "c3aff634-452d-47fc-954f-9edebe3a0c74", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '60a5a33a-e2b7-4160-800d-740251613ddd', 'INSERT', '{"uuid": "60a5a33a-e2b7-4160-800d-740251613ddd", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "ed2f5f84-cc30-4f29-aef7-48eb64a5fb15", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4f17fa4e-ae1e-40c7-9047-321e1e52c84a', 'INSERT', '{"uuid": "4f17fa4e-ae1e-40c7-9047-321e1e52c84a", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "9a93e3c2-b1c1-47d1-8761-0cafe9b42917", "grantedbyroleuuid": null, "grantedbytriggerof": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "fb23d39f-0150-4503-8bcc-090b1ed3d0e4", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "contactuuid": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '06917568-e508-436a-a50f-246ea2afe064', 'INSERT', '{"uuid": "06917568-e508-436a-a50f-246ea2afe064", "roletype": "OWNER", "objectuuid": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '84fffac0-e3e1-4374-a4e1-6d16b91d9e8f', 'INSERT', '{"op": "DELETE", "uuid": "84fffac0-e3e1-4374-a4e1-6d16b91d9e8f", "objectuuid": "86b706e2-9225-482e-b82a-d4ac4adab065", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '53c499fa-1699-45a5-b113-9a952c73fd17', 'INSERT', '{"uuid": "53c499fa-1699-45a5-b113-9a952c73fd17", "assumed": true, "ascendantuuid": "06917568-e508-436a-a50f-246ea2afe064", "descendantuuid": "84fffac0-e3e1-4374-a4e1-6d16b91d9e8f", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '65c5505d-1600-476b-8580-fb6084cf1d7d', 'INSERT', '{"uuid": "65c5505d-1600-476b-8580-fb6084cf1d7d", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "06917568-e508-436a-a50f-246ea2afe064", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ffa4fc5b-0677-4cae-832f-11382c2ce292', 'INSERT', '{"uuid": "ffa4fc5b-0677-4cae-832f-11382c2ce292", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "06917568-e508-436a-a50f-246ea2afe064", "grantedbyroleuuid": "06917568-e508-436a-a50f-246ea2afe064", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b152c130-be97-416c-b531-52656dd3c38d', 'INSERT', '{"uuid": "b152c130-be97-416c-b531-52656dd3c38d", "roletype": "ADMIN", "objectuuid": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7a5ed45e-7096-4f48-a0d9-83df51f3349c', 'INSERT', '{"op": "UPDATE", "uuid": "7a5ed45e-7096-4f48-a0d9-83df51f3349c", "objectuuid": "86b706e2-9225-482e-b82a-d4ac4adab065", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e48f9681-c424-4348-8fc6-c0303d4f01ec', 'INSERT', '{"uuid": "e48f9681-c424-4348-8fc6-c0303d4f01ec", "assumed": true, "ascendantuuid": "b152c130-be97-416c-b531-52656dd3c38d", "descendantuuid": "7a5ed45e-7096-4f48-a0d9-83df51f3349c", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '340a557e-8439-4bf8-ba93-5c7747dce2d4', 'INSERT', '{"uuid": "340a557e-8439-4bf8-ba93-5c7747dce2d4", "assumed": true, "ascendantuuid": "06917568-e508-436a-a50f-246ea2afe064", "descendantuuid": "b152c130-be97-416c-b531-52656dd3c38d", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd6c011ff-bf38-4f09-be3e-45f89eca1ed4', 'INSERT', '{"uuid": "d6c011ff-bf38-4f09-be3e-45f89eca1ed4", "roletype": "AGENT", "objectuuid": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '460cb051-c5db-4d1f-bd66-36fc267c2ff2', 'INSERT', '{"uuid": "460cb051-c5db-4d1f-bd66-36fc267c2ff2", "assumed": true, "ascendantuuid": "b152c130-be97-416c-b531-52656dd3c38d", "descendantuuid": "d6c011ff-bf38-4f09-be3e-45f89eca1ed4", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11', 'INSERT', '{"uuid": "b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11", "roletype": "TENANT", "objectuuid": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'f2395c78-9098-4d15-9ac4-b330a6802390', 'INSERT', '{"op": "SELECT", "uuid": "f2395c78-9098-4d15-9ac4-b330a6802390", "objectuuid": "86b706e2-9225-482e-b82a-d4ac4adab065", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7719c65b-f997-4b81-8773-8ea6ac2551ac', 'INSERT', '{"uuid": "7719c65b-f997-4b81-8773-8ea6ac2551ac", "assumed": true, "ascendantuuid": "b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11", "descendantuuid": "f2395c78-9098-4d15-9ac4-b330a6802390", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bc2eeae8-cd95-498d-8790-d139c352019d', 'INSERT', '{"uuid": "bc2eeae8-cd95-498d-8790-d139c352019d", "assumed": true, "ascendantuuid": "b9592474-79f3-42d9-828f-8cc2e5c8ba7c", "descendantuuid": "b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bec9f28c-f43f-4611-ac52-8f6965ba934c', 'INSERT', '{"uuid": "bec9f28c-f43f-4611-ac52-8f6965ba934c", "assumed": true, "ascendantuuid": "d6c011ff-bf38-4f09-be3e-45f89eca1ed4", "descendantuuid": "b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'da004904-0957-4585-8c99-9990099e48bc', 'INSERT', '{"uuid": "da004904-0957-4585-8c99-9990099e48bc", "assumed": true, "ascendantuuid": "b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11", "descendantuuid": "1280183b-c71a-4b86-bdec-7f3800679ef4", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '20123f90-13d3-4b79-8200-84c570c86645', 'INSERT', '{"uuid": "20123f90-13d3-4b79-8200-84c570c86645", "assumed": true, "ascendantuuid": "b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11", "descendantuuid": "2bcadf08-a16f-4ab6-afbe-83db1b1424d0", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f4964fb4-c46b-4bc5-b7a6-36526dcbc16c', 'INSERT', '{"uuid": "f4964fb4-c46b-4bc5-b7a6-36526dcbc16c", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "d6c011ff-bf38-4f09-be3e-45f89eca1ed4", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '186482a3-b3aa-4f41-b3c0-878bc178afab', 'INSERT', '{"uuid": "186482a3-b3aa-4f41-b3c0-878bc178afab", "assumed": true, "ascendantuuid": "f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b", "descendantuuid": "06917568-e508-436a-a50f-246ea2afe064", "grantedbyroleuuid": null, "grantedbytriggerof": "86b706e2-9225-482e-b82a-d4ac4adab065"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '86b706e2-9225-482e-b82a-d4ac4adab065', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "86b706e2-9225-482e-b82a-d4ac4adab065", "version": 0, "anchoruuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "holderuuid": "cd48cfd6-6313-408f-ae7d-9af047d0c22e", "contactuuid": "d363745a-e94f-48be-8397-4b361570a54d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', 'INSERT', '{"uuid": "2db1a3ce-910d-4f3d-be67-b3a0a598d834", "serialid": 184, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '52fd5f0b-55be-4e14-abfd-6b94ff5b830d', 'INSERT', '{"uuid": "52fd5f0b-55be-4e14-abfd-6b94ff5b830d", "roletype": "OWNER", "objectuuid": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'b371c978-c2d9-4b06-94be-a0944f0e8b34', 'INSERT', '{"op": "DELETE", "uuid": "b371c978-c2d9-4b06-94be-a0944f0e8b34", "objectuuid": "2db1a3ce-910d-4f3d-be67-b3a0a598d834", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7305f3c9-8235-4a92-85bb-9ce6188edfaa', 'INSERT', '{"uuid": "7305f3c9-8235-4a92-85bb-9ce6188edfaa", "assumed": true, "ascendantuuid": "52fd5f0b-55be-4e14-abfd-6b94ff5b830d", "descendantuuid": "b371c978-c2d9-4b06-94be-a0944f0e8b34", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '40d08a9d-d990-4a9e-a5b1-6c60e8a70881', 'INSERT', '{"uuid": "40d08a9d-d990-4a9e-a5b1-6c60e8a70881", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "52fd5f0b-55be-4e14-abfd-6b94ff5b830d", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c7b75a52-20e3-4d01-ba1c-bc18ad58cfa0', 'INSERT', '{"uuid": "c7b75a52-20e3-4d01-ba1c-bc18ad58cfa0", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "52fd5f0b-55be-4e14-abfd-6b94ff5b830d", "grantedbyroleuuid": "52fd5f0b-55be-4e14-abfd-6b94ff5b830d", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'a81d830d-68c5-44ea-bd6b-968a28f90197', 'INSERT', '{"uuid": "a81d830d-68c5-44ea-bd6b-968a28f90197", "roletype": "ADMIN", "objectuuid": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'f8fd6f7e-9507-47ad-ab42-fbd72c3718f1', 'INSERT', '{"op": "UPDATE", "uuid": "f8fd6f7e-9507-47ad-ab42-fbd72c3718f1", "objectuuid": "2db1a3ce-910d-4f3d-be67-b3a0a598d834", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bfdbce82-4e8b-415a-b5bc-36dfac77faaf', 'INSERT', '{"uuid": "bfdbce82-4e8b-415a-b5bc-36dfac77faaf", "assumed": true, "ascendantuuid": "a81d830d-68c5-44ea-bd6b-968a28f90197", "descendantuuid": "f8fd6f7e-9507-47ad-ab42-fbd72c3718f1", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dd0a6ede-4366-40d2-8355-6fd331cf91f3', 'INSERT', '{"uuid": "dd0a6ede-4366-40d2-8355-6fd331cf91f3", "assumed": true, "ascendantuuid": "52fd5f0b-55be-4e14-abfd-6b94ff5b830d", "descendantuuid": "a81d830d-68c5-44ea-bd6b-968a28f90197", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'a64973bb-c814-4af9-b020-99f5f726dd24', 'INSERT', '{"uuid": "a64973bb-c814-4af9-b020-99f5f726dd24", "roletype": "AGENT", "objectuuid": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b54dffd4-9a6a-46f9-b66d-dc4b3a71ed1a', 'INSERT', '{"uuid": "b54dffd4-9a6a-46f9-b66d-dc4b3a71ed1a", "assumed": true, "ascendantuuid": "a81d830d-68c5-44ea-bd6b-968a28f90197", "descendantuuid": "a64973bb-c814-4af9-b020-99f5f726dd24", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'aa3db109-7ed1-496a-9490-62dabce849e2', 'INSERT', '{"uuid": "aa3db109-7ed1-496a-9490-62dabce849e2", "roletype": "TENANT", "objectuuid": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '9fb3f5e1-472b-4679-a4a8-099557352ec7', 'INSERT', '{"op": "SELECT", "uuid": "9fb3f5e1-472b-4679-a4a8-099557352ec7", "objectuuid": "2db1a3ce-910d-4f3d-be67-b3a0a598d834", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6b621671-5dfc-49c2-8900-a243c08cd4d1', 'INSERT', '{"uuid": "6b621671-5dfc-49c2-8900-a243c08cd4d1", "assumed": true, "ascendantuuid": "aa3db109-7ed1-496a-9490-62dabce849e2", "descendantuuid": "9fb3f5e1-472b-4679-a4a8-099557352ec7", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3792e102-fc0a-41bc-9c09-dff0f2c6ee17', 'INSERT', '{"uuid": "3792e102-fc0a-41bc-9c09-dff0f2c6ee17", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "aa3db109-7ed1-496a-9490-62dabce849e2", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '49cf2839-3725-4c1b-839f-69006291fa6a', 'INSERT', '{"uuid": "49cf2839-3725-4c1b-839f-69006291fa6a", "assumed": true, "ascendantuuid": "a64973bb-c814-4af9-b020-99f5f726dd24", "descendantuuid": "aa3db109-7ed1-496a-9490-62dabce849e2", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd49825b7-cd73-44c8-b642-fc6e1a2e8343', 'INSERT', '{"uuid": "d49825b7-cd73-44c8-b642-fc6e1a2e8343", "assumed": true, "ascendantuuid": "aa3db109-7ed1-496a-9490-62dabce849e2", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f19b508b-3f4f-40ed-add1-f4cf0f0f3f44', 'INSERT', '{"uuid": "f19b508b-3f4f-40ed-add1-f4cf0f0f3f44", "assumed": true, "ascendantuuid": "aa3db109-7ed1-496a-9490-62dabce849e2", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f2c14dae-2c58-49a3-bb69-1179e3e07155', 'INSERT', '{"uuid": "f2c14dae-2c58-49a3-bb69-1179e3e07155", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "a64973bb-c814-4af9-b020-99f5f726dd24", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bce6bc63-111c-4b80-be4b-1af2234d732a', 'INSERT', '{"uuid": "bce6bc63-111c-4b80-be4b-1af2234d732a", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "52fd5f0b-55be-4e14-abfd-6b94ff5b830d", "grantedbyroleuuid": null, "grantedbytriggerof": "2db1a3ce-910d-4f3d-be67-b3a0a598d834"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "2db1a3ce-910d-4f3d-be67-b3a0a598d834", "version": 0, "anchoruuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "holderuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "contactuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 'INSERT', '{"uuid": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5", "serialid": 185, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5c2537c8-eb2c-4da1-b78e-071377668767', 'INSERT', '{"uuid": "5c2537c8-eb2c-4da1-b78e-071377668767", "roletype": "OWNER", "objectuuid": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '909ff58a-4c4c-410d-a3eb-f17cf15c330c', 'INSERT', '{"op": "DELETE", "uuid": "909ff58a-4c4c-410d-a3eb-f17cf15c330c", "objectuuid": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a2a9410b-7cc0-4cb4-a9fc-b3d3af01872e', 'INSERT', '{"uuid": "a2a9410b-7cc0-4cb4-a9fc-b3d3af01872e", "assumed": true, "ascendantuuid": "5c2537c8-eb2c-4da1-b78e-071377668767", "descendantuuid": "909ff58a-4c4c-410d-a3eb-f17cf15c330c", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8f34f92d-555d-4a02-86cb-4353761e58f5', 'INSERT', '{"uuid": "8f34f92d-555d-4a02-86cb-4353761e58f5", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "5c2537c8-eb2c-4da1-b78e-071377668767", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0f0950ef-2899-4385-8256-9c7dd9c70628', 'INSERT', '{"uuid": "0f0950ef-2899-4385-8256-9c7dd9c70628", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "5c2537c8-eb2c-4da1-b78e-071377668767", "grantedbyroleuuid": "5c2537c8-eb2c-4da1-b78e-071377668767", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '07b606b4-e386-4d2d-8ecd-438aa4b3cd80', 'INSERT', '{"uuid": "07b606b4-e386-4d2d-8ecd-438aa4b3cd80", "roletype": "ADMIN", "objectuuid": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2b643877-6882-4d24-bf51-fb39d8a59287', 'INSERT', '{"op": "UPDATE", "uuid": "2b643877-6882-4d24-bf51-fb39d8a59287", "objectuuid": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e4bcfb5b-8fee-42b3-a716-306448e99696', 'INSERT', '{"uuid": "e4bcfb5b-8fee-42b3-a716-306448e99696", "assumed": true, "ascendantuuid": "07b606b4-e386-4d2d-8ecd-438aa4b3cd80", "descendantuuid": "2b643877-6882-4d24-bf51-fb39d8a59287", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5c958c7b-c36f-4565-b5ea-2ce0ea2aacda', 'INSERT', '{"uuid": "5c958c7b-c36f-4565-b5ea-2ce0ea2aacda", "assumed": true, "ascendantuuid": "5c2537c8-eb2c-4da1-b78e-071377668767", "descendantuuid": "07b606b4-e386-4d2d-8ecd-438aa4b3cd80", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ce71b519-42cc-4674-8bc0-a2df3c13b6c7', 'INSERT', '{"uuid": "ce71b519-42cc-4674-8bc0-a2df3c13b6c7", "roletype": "AGENT", "objectuuid": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'c2ccc14e-f11b-497f-95db-5397aa38012b', 'INSERT', '{"op": "SELECT", "uuid": "c2ccc14e-f11b-497f-95db-5397aa38012b", "objectuuid": "219baf3d-0bb7-4252-b92f-4cfa97cb633c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '295e2bec-5586-4a30-8d27-f5462136389e', 'INSERT', '{"uuid": "295e2bec-5586-4a30-8d27-f5462136389e", "assumed": true, "ascendantuuid": "07b606b4-e386-4d2d-8ecd-438aa4b3cd80", "descendantuuid": "ce71b519-42cc-4674-8bc0-a2df3c13b6c7", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '425b6cf7-172a-4e48-9f66-5592d4e25a99', 'INSERT', '{"uuid": "425b6cf7-172a-4e48-9f66-5592d4e25a99", "roletype": "TENANT", "objectuuid": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '51982882-3575-40c4-86a1-c05fedc436db', 'INSERT', '{"op": "SELECT", "uuid": "51982882-3575-40c4-86a1-c05fedc436db", "objectuuid": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ec03b430-bd0f-4553-bea1-756f4442d5ad', 'INSERT', '{"uuid": "ec03b430-bd0f-4553-bea1-756f4442d5ad", "assumed": true, "ascendantuuid": "425b6cf7-172a-4e48-9f66-5592d4e25a99", "descendantuuid": "51982882-3575-40c4-86a1-c05fedc436db", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c486f6cf-9037-4fb2-828b-c29110390e98', 'INSERT', '{"uuid": "c486f6cf-9037-4fb2-828b-c29110390e98", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "425b6cf7-172a-4e48-9f66-5592d4e25a99", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '18b7e9cb-354d-4eb2-a06a-11d19c91adb9', 'INSERT', '{"uuid": "18b7e9cb-354d-4eb2-a06a-11d19c91adb9", "assumed": true, "ascendantuuid": "ce71b519-42cc-4674-8bc0-a2df3c13b6c7", "descendantuuid": "425b6cf7-172a-4e48-9f66-5592d4e25a99", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c5644335-3b7f-4438-8814-e098d72c2772', 'INSERT', '{"uuid": "c5644335-3b7f-4438-8814-e098d72c2772", "assumed": true, "ascendantuuid": "425b6cf7-172a-4e48-9f66-5592d4e25a99", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '08630602-93c4-4caf-8086-fe3910ba48f0', 'INSERT', '{"uuid": "08630602-93c4-4caf-8086-fe3910ba48f0", "assumed": true, "ascendantuuid": "425b6cf7-172a-4e48-9f66-5592d4e25a99", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e130a4fa-c05f-45b6-a232-e526c0c20c15', 'INSERT', '{"uuid": "e130a4fa-c05f-45b6-a232-e526c0c20c15", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "ce71b519-42cc-4674-8bc0-a2df3c13b6c7", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9bb65a3b-e712-46c4-9bd8-f7a77494e24a', 'INSERT', '{"uuid": "9bb65a3b-e712-46c4-9bd8-f7a77494e24a", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "5c2537c8-eb2c-4da1-b78e-071377668767", "grantedbyroleuuid": null, "grantedbytriggerof": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "b5cfc5c1-b775-4c59-8967-66d2cf7851e5", "version": 0, "anchoruuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "holderuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "contactuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', 'INSERT', '{"uuid": "ddbda55a-0143-4224-bb6c-7ec5e8b79465", "serialid": 186, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5b5433b1-b6eb-4034-841b-559cba014f35', 'INSERT', '{"uuid": "5b5433b1-b6eb-4034-841b-559cba014f35", "roletype": "OWNER", "objectuuid": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '5ce74841-55a0-48a2-86ff-253dcfdf8a6f', 'INSERT', '{"op": "DELETE", "uuid": "5ce74841-55a0-48a2-86ff-253dcfdf8a6f", "objectuuid": "ddbda55a-0143-4224-bb6c-7ec5e8b79465", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fe96ea19-f953-40d1-9745-b36f78493abb', 'INSERT', '{"uuid": "fe96ea19-f953-40d1-9745-b36f78493abb", "assumed": true, "ascendantuuid": "5b5433b1-b6eb-4034-841b-559cba014f35", "descendantuuid": "5ce74841-55a0-48a2-86ff-253dcfdf8a6f", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fd38daf1-62fa-4edf-a316-dbe4945b4ae8', 'INSERT', '{"uuid": "fd38daf1-62fa-4edf-a316-dbe4945b4ae8", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "5b5433b1-b6eb-4034-841b-559cba014f35", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '336f1895-1533-4773-b907-18b4a4beec3c', 'INSERT', '{"uuid": "336f1895-1533-4773-b907-18b4a4beec3c", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "5b5433b1-b6eb-4034-841b-559cba014f35", "grantedbyroleuuid": "5b5433b1-b6eb-4034-841b-559cba014f35", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '9851392a-7c6e-4642-881b-dd7728556b86', 'INSERT', '{"uuid": "9851392a-7c6e-4642-881b-dd7728556b86", "roletype": "ADMIN", "objectuuid": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'fe903d29-2b20-4f62-8973-ce885b0d03ab', 'INSERT', '{"op": "UPDATE", "uuid": "fe903d29-2b20-4f62-8973-ce885b0d03ab", "objectuuid": "ddbda55a-0143-4224-bb6c-7ec5e8b79465", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cd6e2e18-034c-40bf-bf34-86481d40edb8', 'INSERT', '{"uuid": "cd6e2e18-034c-40bf-bf34-86481d40edb8", "assumed": true, "ascendantuuid": "9851392a-7c6e-4642-881b-dd7728556b86", "descendantuuid": "fe903d29-2b20-4f62-8973-ce885b0d03ab", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '720713e2-c2f4-47f2-9479-0f9a518f6895', 'INSERT', '{"uuid": "720713e2-c2f4-47f2-9479-0f9a518f6895", "assumed": true, "ascendantuuid": "5b5433b1-b6eb-4034-841b-559cba014f35", "descendantuuid": "9851392a-7c6e-4642-881b-dd7728556b86", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7c6415c0-9900-4de6-9459-e4d50b8e9ae4', 'INSERT', '{"uuid": "7c6415c0-9900-4de6-9459-e4d50b8e9ae4", "roletype": "AGENT", "objectuuid": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c4b87697-d656-47d7-88ed-9bf46fae9de7', 'INSERT', '{"uuid": "c4b87697-d656-47d7-88ed-9bf46fae9de7", "assumed": true, "ascendantuuid": "9851392a-7c6e-4642-881b-dd7728556b86", "descendantuuid": "7c6415c0-9900-4de6-9459-e4d50b8e9ae4", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6035bf8e-466b-47f7-a3e8-96bab2e8033a', 'INSERT', '{"uuid": "6035bf8e-466b-47f7-a3e8-96bab2e8033a", "roletype": "TENANT", "objectuuid": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'fa80b5e8-d9c5-4d4e-b7c7-3eb28a90f991', 'INSERT', '{"op": "SELECT", "uuid": "fa80b5e8-d9c5-4d4e-b7c7-3eb28a90f991", "objectuuid": "ddbda55a-0143-4224-bb6c-7ec5e8b79465", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '855c8310-eb6b-4026-80ea-ed56ff9c25bd', 'INSERT', '{"uuid": "855c8310-eb6b-4026-80ea-ed56ff9c25bd", "assumed": true, "ascendantuuid": "6035bf8e-466b-47f7-a3e8-96bab2e8033a", "descendantuuid": "fa80b5e8-d9c5-4d4e-b7c7-3eb28a90f991", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3b8c7961-f697-4f50-a6b6-a0f27ee09ec6', 'INSERT', '{"uuid": "3b8c7961-f697-4f50-a6b6-a0f27ee09ec6", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "6035bf8e-466b-47f7-a3e8-96bab2e8033a", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'aab2538a-a511-4780-8607-34f99eee440f', 'INSERT', '{"uuid": "aab2538a-a511-4780-8607-34f99eee440f", "assumed": true, "ascendantuuid": "7c6415c0-9900-4de6-9459-e4d50b8e9ae4", "descendantuuid": "6035bf8e-466b-47f7-a3e8-96bab2e8033a", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '98256c44-181e-4e8b-bc97-e044d8b8b0f4', 'INSERT', '{"uuid": "98256c44-181e-4e8b-bc97-e044d8b8b0f4", "assumed": true, "ascendantuuid": "6035bf8e-466b-47f7-a3e8-96bab2e8033a", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ffa67fff-4ec5-4d34-92df-6ababcbe29a0', 'INSERT', '{"uuid": "ffa67fff-4ec5-4d34-92df-6ababcbe29a0", "assumed": true, "ascendantuuid": "6035bf8e-466b-47f7-a3e8-96bab2e8033a", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '80052042-d14f-4e9e-98a7-c3fd9daf423c', 'INSERT', '{"uuid": "80052042-d14f-4e9e-98a7-c3fd9daf423c", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "7c6415c0-9900-4de6-9459-e4d50b8e9ae4", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cd293115-6fe8-457e-9010-870320be69bf', 'INSERT', '{"uuid": "cd293115-6fe8-457e-9010-870320be69bf", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "5b5433b1-b6eb-4034-841b-559cba014f35", "grantedbyroleuuid": null, "grantedbytriggerof": "ddbda55a-0143-4224-bb6c-7ec5e8b79465"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', 'INSERT', '{"mark": "operations-discussion", "type": "SUBSCRIBER", "uuid": "ddbda55a-0143-4224-bb6c-7ec5e8b79465", "version": 0, "anchoruuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "holderuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "contactuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '47b7bd3f-8668-4934-bee9-56708e835d7f', 'INSERT', '{"uuid": "47b7bd3f-8668-4934-bee9-56708e835d7f", "serialid": 187, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1326d07c-623b-40fc-942a-659f5c7308ee', 'INSERT', '{"uuid": "1326d07c-623b-40fc-942a-659f5c7308ee", "roletype": "OWNER", "objectuuid": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '118e8006-bf10-4b7d-8f07-fb4b8d9de592', 'INSERT', '{"op": "DELETE", "uuid": "118e8006-bf10-4b7d-8f07-fb4b8d9de592", "objectuuid": "47b7bd3f-8668-4934-bee9-56708e835d7f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2e8ae0f2-98ff-4656-978f-e2fffec36ce9', 'INSERT', '{"uuid": "2e8ae0f2-98ff-4656-978f-e2fffec36ce9", "assumed": true, "ascendantuuid": "1326d07c-623b-40fc-942a-659f5c7308ee", "descendantuuid": "118e8006-bf10-4b7d-8f07-fb4b8d9de592", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8c2b7fff-9921-445b-857c-de9de2dfcc0d', 'INSERT', '{"uuid": "8c2b7fff-9921-445b-857c-de9de2dfcc0d", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "1326d07c-623b-40fc-942a-659f5c7308ee", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '24ff72b7-f6cb-445e-a246-24a39f837a21', 'INSERT', '{"uuid": "24ff72b7-f6cb-445e-a246-24a39f837a21", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "1326d07c-623b-40fc-942a-659f5c7308ee", "grantedbyroleuuid": "1326d07c-623b-40fc-942a-659f5c7308ee", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5310f493-97fb-4203-b41b-71423252cc4e', 'INSERT', '{"uuid": "5310f493-97fb-4203-b41b-71423252cc4e", "roletype": "ADMIN", "objectuuid": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a2f2cc36-6c62-44e0-aaec-b4749ed25558', 'INSERT', '{"op": "UPDATE", "uuid": "a2f2cc36-6c62-44e0-aaec-b4749ed25558", "objectuuid": "47b7bd3f-8668-4934-bee9-56708e835d7f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2da62c4f-9568-4013-b1e6-d1f91ded337e', 'INSERT', '{"uuid": "2da62c4f-9568-4013-b1e6-d1f91ded337e", "assumed": true, "ascendantuuid": "5310f493-97fb-4203-b41b-71423252cc4e", "descendantuuid": "a2f2cc36-6c62-44e0-aaec-b4749ed25558", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '20286312-5e98-4ef1-b0ff-0439187b7f4c', 'INSERT', '{"uuid": "20286312-5e98-4ef1-b0ff-0439187b7f4c", "assumed": true, "ascendantuuid": "1326d07c-623b-40fc-942a-659f5c7308ee", "descendantuuid": "5310f493-97fb-4203-b41b-71423252cc4e", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '09d8befe-d786-4023-b10e-5479f6d09bc1', 'INSERT', '{"uuid": "09d8befe-d786-4023-b10e-5479f6d09bc1", "roletype": "AGENT", "objectuuid": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4efe1a38-ea34-4c3f-bdff-a511210ce018', 'INSERT', '{"uuid": "4efe1a38-ea34-4c3f-bdff-a511210ce018", "assumed": true, "ascendantuuid": "5310f493-97fb-4203-b41b-71423252cc4e", "descendantuuid": "09d8befe-d786-4023-b10e-5479f6d09bc1", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '03b9f057-a59e-4253-a83a-ed4d7058a663', 'INSERT', '{"uuid": "03b9f057-a59e-4253-a83a-ed4d7058a663", "roletype": "TENANT", "objectuuid": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '252d4677-4f71-4719-a287-37245b03a8bf', 'INSERT', '{"op": "SELECT", "uuid": "252d4677-4f71-4719-a287-37245b03a8bf", "objectuuid": "47b7bd3f-8668-4934-bee9-56708e835d7f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b8aa7fbb-8bee-44d6-b98f-072f6d26a269', 'INSERT', '{"uuid": "b8aa7fbb-8bee-44d6-b98f-072f6d26a269", "assumed": true, "ascendantuuid": "03b9f057-a59e-4253-a83a-ed4d7058a663", "descendantuuid": "252d4677-4f71-4719-a287-37245b03a8bf", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '767f78b2-90e0-4c86-b7cc-ba112668c7a1', 'INSERT', '{"uuid": "767f78b2-90e0-4c86-b7cc-ba112668c7a1", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "03b9f057-a59e-4253-a83a-ed4d7058a663", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd5c7c0d3-5e91-4abf-8729-c2e6045550cc', 'INSERT', '{"uuid": "d5c7c0d3-5e91-4abf-8729-c2e6045550cc", "assumed": true, "ascendantuuid": "09d8befe-d786-4023-b10e-5479f6d09bc1", "descendantuuid": "03b9f057-a59e-4253-a83a-ed4d7058a663", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8f30f856-f8c4-4fe4-aab3-30613db0380f', 'INSERT', '{"uuid": "8f30f856-f8c4-4fe4-aab3-30613db0380f", "assumed": true, "ascendantuuid": "03b9f057-a59e-4253-a83a-ed4d7058a663", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8533c3db-8c1d-4d0b-ab2d-6087562d07c6', 'INSERT', '{"uuid": "8533c3db-8c1d-4d0b-ab2d-6087562d07c6", "assumed": true, "ascendantuuid": "03b9f057-a59e-4253-a83a-ed4d7058a663", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '77b6e4a5-a112-4d8c-89cf-9b9442283a17', 'INSERT', '{"uuid": "77b6e4a5-a112-4d8c-89cf-9b9442283a17", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "09d8befe-d786-4023-b10e-5479f6d09bc1", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ebb76242-19c3-4f3b-a669-8400acf4abda', 'INSERT', '{"uuid": "ebb76242-19c3-4f3b-a669-8400acf4abda", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "1326d07c-623b-40fc-942a-659f5c7308ee", "grantedbyroleuuid": null, "grantedbytriggerof": "47b7bd3f-8668-4934-bee9-56708e835d7f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '47b7bd3f-8668-4934-bee9-56708e835d7f', 'INSERT', '{"mark": "operations-announce", "type": "SUBSCRIBER", "uuid": "47b7bd3f-8668-4934-bee9-56708e835d7f", "version": 0, "anchoruuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "holderuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "contactuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '80a9daef-e282-499a-ab2f-98a016edb8f7', 'INSERT', '{"uuid": "80a9daef-e282-499a-ab2f-98a016edb8f7", "serialid": 188, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '108a7577-6cac-417f-a0dc-84c799c54797', 'INSERT', '{"uuid": "108a7577-6cac-417f-a0dc-84c799c54797", "roletype": "OWNER", "objectuuid": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '5367452a-5726-452f-a76b-8393cc5e6689', 'INSERT', '{"op": "DELETE", "uuid": "5367452a-5726-452f-a76b-8393cc5e6689", "objectuuid": "80a9daef-e282-499a-ab2f-98a016edb8f7", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '97156b91-a452-4cf3-8c14-fa7f5c5a26da', 'INSERT', '{"uuid": "97156b91-a452-4cf3-8c14-fa7f5c5a26da", "assumed": true, "ascendantuuid": "108a7577-6cac-417f-a0dc-84c799c54797", "descendantuuid": "5367452a-5726-452f-a76b-8393cc5e6689", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '59ee3338-5e2f-4d01-9316-c79338de9aa3', 'INSERT', '{"uuid": "59ee3338-5e2f-4d01-9316-c79338de9aa3", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "108a7577-6cac-417f-a0dc-84c799c54797", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b42ffc07-cefe-4607-b3f4-4fa5827bd0df', 'INSERT', '{"uuid": "b42ffc07-cefe-4607-b3f4-4fa5827bd0df", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "108a7577-6cac-417f-a0dc-84c799c54797", "grantedbyroleuuid": "108a7577-6cac-417f-a0dc-84c799c54797", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '4538eaad-57b6-4089-a058-2e7b2adfc2ec', 'INSERT', '{"uuid": "4538eaad-57b6-4089-a058-2e7b2adfc2ec", "roletype": "ADMIN", "objectuuid": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '1a32ebbf-8e70-4268-bb9e-dbcc7a501b71', 'INSERT', '{"op": "UPDATE", "uuid": "1a32ebbf-8e70-4268-bb9e-dbcc7a501b71", "objectuuid": "80a9daef-e282-499a-ab2f-98a016edb8f7", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '46f25ed8-a3cf-422a-bc12-0617d0cfdeed', 'INSERT', '{"uuid": "46f25ed8-a3cf-422a-bc12-0617d0cfdeed", "assumed": true, "ascendantuuid": "4538eaad-57b6-4089-a058-2e7b2adfc2ec", "descendantuuid": "1a32ebbf-8e70-4268-bb9e-dbcc7a501b71", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b920e47d-1424-4935-85cb-5ca323c0fd9c', 'INSERT', '{"uuid": "b920e47d-1424-4935-85cb-5ca323c0fd9c", "assumed": true, "ascendantuuid": "108a7577-6cac-417f-a0dc-84c799c54797", "descendantuuid": "4538eaad-57b6-4089-a058-2e7b2adfc2ec", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb', 'INSERT', '{"uuid": "4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb", "roletype": "AGENT", "objectuuid": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f2d7c381-8560-4361-a49a-32f3cfb4d099', 'INSERT', '{"uuid": "f2d7c381-8560-4361-a49a-32f3cfb4d099", "assumed": true, "ascendantuuid": "4538eaad-57b6-4089-a058-2e7b2adfc2ec", "descendantuuid": "4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b8faa38e-6fff-42fc-a1ce-b84070077a61', 'INSERT', '{"uuid": "b8faa38e-6fff-42fc-a1ce-b84070077a61", "roletype": "TENANT", "objectuuid": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'af6f87de-0aa9-4320-b5ba-96a8ac23c9e6', 'INSERT', '{"op": "SELECT", "uuid": "af6f87de-0aa9-4320-b5ba-96a8ac23c9e6", "objectuuid": "80a9daef-e282-499a-ab2f-98a016edb8f7", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c7e7ddea-f5fb-4abb-8f2d-766ead997fc8', 'INSERT', '{"uuid": "c7e7ddea-f5fb-4abb-8f2d-766ead997fc8", "assumed": true, "ascendantuuid": "b8faa38e-6fff-42fc-a1ce-b84070077a61", "descendantuuid": "af6f87de-0aa9-4320-b5ba-96a8ac23c9e6", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f7b646a0-5cf2-4ea9-a0ef-76976503827c', 'INSERT', '{"uuid": "f7b646a0-5cf2-4ea9-a0ef-76976503827c", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "b8faa38e-6fff-42fc-a1ce-b84070077a61", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e21ef4f6-3d46-431b-9c1e-17d15c3bd777', 'INSERT', '{"uuid": "e21ef4f6-3d46-431b-9c1e-17d15c3bd777", "assumed": true, "ascendantuuid": "4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb", "descendantuuid": "b8faa38e-6fff-42fc-a1ce-b84070077a61", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '773184a7-0b28-431c-a763-9cf445a30a53', 'INSERT', '{"uuid": "773184a7-0b28-431c-a763-9cf445a30a53", "assumed": true, "ascendantuuid": "b8faa38e-6fff-42fc-a1ce-b84070077a61", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '33651c0b-74a1-4a23-a7c0-77e843306d26', 'INSERT', '{"uuid": "33651c0b-74a1-4a23-a7c0-77e843306d26", "assumed": true, "ascendantuuid": "b8faa38e-6fff-42fc-a1ce-b84070077a61", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8cc78d3c-5ae4-42f5-82b0-2431472de78a', 'INSERT', '{"uuid": "8cc78d3c-5ae4-42f5-82b0-2431472de78a", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '076c544a-24c9-4ce7-81d9-08e4fa51a4ed', 'INSERT', '{"uuid": "076c544a-24c9-4ce7-81d9-08e4fa51a4ed", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "108a7577-6cac-417f-a0dc-84c799c54797", "grantedbyroleuuid": null, "grantedbytriggerof": "80a9daef-e282-499a-ab2f-98a016edb8f7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '80a9daef-e282-499a-ab2f-98a016edb8f7', 'INSERT', '{"mark": "generalversammlung", "type": "SUBSCRIBER", "uuid": "80a9daef-e282-499a-ab2f-98a016edb8f7", "version": 0, "anchoruuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "holderuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "contactuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '93d9827e-63dc-418e-a021-25b400847b2e', 'INSERT', '{"uuid": "93d9827e-63dc-418e-a021-25b400847b2e", "serialid": 189, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6da9d98a-3318-403e-a948-bc33efe3d5ce', 'INSERT', '{"uuid": "6da9d98a-3318-403e-a948-bc33efe3d5ce", "roletype": "OWNER", "objectuuid": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '9821f69a-b029-4a8f-b1b3-229517380f60', 'INSERT', '{"op": "DELETE", "uuid": "9821f69a-b029-4a8f-b1b3-229517380f60", "objectuuid": "93d9827e-63dc-418e-a021-25b400847b2e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'c17186dc-564d-4f82-914b-202ad8bc9941', 'INSERT', '{"uuid": "c17186dc-564d-4f82-914b-202ad8bc9941", "roletype": "OWNER", "objectuuid": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6c9fc22d-63c8-4f7a-98aa-ba8fff1e3da8', 'INSERT', '{"uuid": "6c9fc22d-63c8-4f7a-98aa-ba8fff1e3da8", "assumed": true, "ascendantuuid": "6da9d98a-3318-403e-a948-bc33efe3d5ce", "descendantuuid": "9821f69a-b029-4a8f-b1b3-229517380f60", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8eccc366-4e62-4fbf-b02c-ec8f6e209e70', 'INSERT', '{"uuid": "8eccc366-4e62-4fbf-b02c-ec8f6e209e70", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "6da9d98a-3318-403e-a948-bc33efe3d5ce", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c38822e4-5e1e-4827-b360-b92d25c4d2ab', 'INSERT', '{"uuid": "c38822e4-5e1e-4827-b360-b92d25c4d2ab", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "6da9d98a-3318-403e-a948-bc33efe3d5ce", "grantedbyroleuuid": "6da9d98a-3318-403e-a948-bc33efe3d5ce", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b2f0d8a8-ad0c-4c52-9c05-967973c99f8a', 'INSERT', '{"uuid": "b2f0d8a8-ad0c-4c52-9c05-967973c99f8a", "roletype": "ADMIN", "objectuuid": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '8bee7b6c-05f5-4538-baf9-452d909f0657', 'INSERT', '{"op": "UPDATE", "uuid": "8bee7b6c-05f5-4538-baf9-452d909f0657", "objectuuid": "93d9827e-63dc-418e-a021-25b400847b2e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'de27e4ea-e17c-4a35-bcb5-b66bc1057793', 'INSERT', '{"uuid": "de27e4ea-e17c-4a35-bcb5-b66bc1057793", "assumed": true, "ascendantuuid": "b2f0d8a8-ad0c-4c52-9c05-967973c99f8a", "descendantuuid": "8bee7b6c-05f5-4538-baf9-452d909f0657", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2dc2a6a9-cc30-47e8-bda0-c0a824d3c0ed', 'INSERT', '{"uuid": "2dc2a6a9-cc30-47e8-bda0-c0a824d3c0ed", "assumed": true, "ascendantuuid": "6da9d98a-3318-403e-a948-bc33efe3d5ce", "descendantuuid": "b2f0d8a8-ad0c-4c52-9c05-967973c99f8a", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '03245b58-dd24-4cd4-bf3f-d9ba51a69810', 'INSERT', '{"uuid": "03245b58-dd24-4cd4-bf3f-d9ba51a69810", "roletype": "AGENT", "objectuuid": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '704bc599-a122-45b2-9dc4-86400b50c1c3', 'INSERT', '{"uuid": "704bc599-a122-45b2-9dc4-86400b50c1c3", "assumed": true, "ascendantuuid": "b2f0d8a8-ad0c-4c52-9c05-967973c99f8a", "descendantuuid": "03245b58-dd24-4cd4-bf3f-d9ba51a69810", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ff171f90-f6f2-4c7f-9128-051462cb2368', 'INSERT', '{"uuid": "ff171f90-f6f2-4c7f-9128-051462cb2368", "roletype": "TENANT", "objectuuid": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2c0faec0-6d09-48e9-9ba5-ef060e4d5f6b', 'INSERT', '{"op": "SELECT", "uuid": "2c0faec0-6d09-48e9-9ba5-ef060e4d5f6b", "objectuuid": "93d9827e-63dc-418e-a021-25b400847b2e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '117ac268-6306-4b8c-b8b3-b80dd1cdfabe', 'INSERT', '{"uuid": "117ac268-6306-4b8c-b8b3-b80dd1cdfabe", "assumed": true, "ascendantuuid": "ff171f90-f6f2-4c7f-9128-051462cb2368", "descendantuuid": "2c0faec0-6d09-48e9-9ba5-ef060e4d5f6b", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '70e95aa8-1ac0-47ce-a7d7-a0c5a79389bf', 'INSERT', '{"uuid": "70e95aa8-1ac0-47ce-a7d7-a0c5a79389bf", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "ff171f90-f6f2-4c7f-9128-051462cb2368", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '844fac0e-a516-4f70-90c5-563ddade6f22', 'INSERT', '{"uuid": "844fac0e-a516-4f70-90c5-563ddade6f22", "assumed": true, "ascendantuuid": "03245b58-dd24-4cd4-bf3f-d9ba51a69810", "descendantuuid": "ff171f90-f6f2-4c7f-9128-051462cb2368", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bfaf4e0e-12bd-40a5-bcaf-71f0f767975b', 'INSERT', '{"uuid": "bfaf4e0e-12bd-40a5-bcaf-71f0f767975b", "assumed": true, "ascendantuuid": "ff171f90-f6f2-4c7f-9128-051462cb2368", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '56586e9a-9626-4412-a088-168ba9ad0426', 'INSERT', '{"uuid": "56586e9a-9626-4412-a088-168ba9ad0426", "assumed": true, "ascendantuuid": "ff171f90-f6f2-4c7f-9128-051462cb2368", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dc02e27c-0c6f-4fc3-bc30-25984f8e205c', 'INSERT', '{"uuid": "dc02e27c-0c6f-4fc3-bc30-25984f8e205c", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "03245b58-dd24-4cd4-bf3f-d9ba51a69810", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4e23bc29-96ac-49cb-a2b0-df041b44f6b2', 'INSERT', '{"uuid": "4e23bc29-96ac-49cb-a2b0-df041b44f6b2", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "6da9d98a-3318-403e-a948-bc33efe3d5ce", "grantedbyroleuuid": null, "grantedbytriggerof": "93d9827e-63dc-418e-a021-25b400847b2e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '93d9827e-63dc-418e-a021-25b400847b2e', 'INSERT', '{"mark": "members-announce", "type": "SUBSCRIBER", "uuid": "93d9827e-63dc-418e-a021-25b400847b2e", "version": 0, "anchoruuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "holderuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "contactuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'f4219fae-353d-4324-90ca-9f313a8c1c17', 'INSERT', '{"uuid": "f4219fae-353d-4324-90ca-9f313a8c1c17", "serialid": 190, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1b1da9f7-1fb1-4b94-94d7-57275b028d54', 'INSERT', '{"uuid": "1b1da9f7-1fb1-4b94-94d7-57275b028d54", "roletype": "OWNER", "objectuuid": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '94866c63-1d9f-4b00-b0ff-c6f48c5d6462', 'INSERT', '{"op": "DELETE", "uuid": "94866c63-1d9f-4b00-b0ff-c6f48c5d6462", "objectuuid": "f4219fae-353d-4324-90ca-9f313a8c1c17", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'db7b07bc-cfd4-4009-b6a9-3de845ff39bc', 'INSERT', '{"uuid": "db7b07bc-cfd4-4009-b6a9-3de845ff39bc", "assumed": true, "ascendantuuid": "1b1da9f7-1fb1-4b94-94d7-57275b028d54", "descendantuuid": "94866c63-1d9f-4b00-b0ff-c6f48c5d6462", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '806bbe69-805c-4f05-8917-9ef45ae9c6aa', 'INSERT', '{"uuid": "806bbe69-805c-4f05-8917-9ef45ae9c6aa", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "1b1da9f7-1fb1-4b94-94d7-57275b028d54", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd49c29f2-d785-4043-890b-fe74dbb447dd', 'INSERT', '{"uuid": "d49c29f2-d785-4043-890b-fe74dbb447dd", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "1b1da9f7-1fb1-4b94-94d7-57275b028d54", "grantedbyroleuuid": "1b1da9f7-1fb1-4b94-94d7-57275b028d54", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '871fd02d-def7-4c83-b40e-23029a4019cd', 'INSERT', '{"uuid": "871fd02d-def7-4c83-b40e-23029a4019cd", "roletype": "ADMIN", "objectuuid": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'd86f4fc3-58a6-4464-8836-4ce8b34f25c9', 'INSERT', '{"op": "UPDATE", "uuid": "d86f4fc3-58a6-4464-8836-4ce8b34f25c9", "objectuuid": "f4219fae-353d-4324-90ca-9f313a8c1c17", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '600971dd-5188-43de-b278-03af494ee111', 'INSERT', '{"uuid": "600971dd-5188-43de-b278-03af494ee111", "assumed": true, "ascendantuuid": "871fd02d-def7-4c83-b40e-23029a4019cd", "descendantuuid": "d86f4fc3-58a6-4464-8836-4ce8b34f25c9", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2c45a296-31e4-40fd-ad10-dda3a8269d35', 'INSERT', '{"uuid": "2c45a296-31e4-40fd-ad10-dda3a8269d35", "assumed": true, "ascendantuuid": "1b1da9f7-1fb1-4b94-94d7-57275b028d54", "descendantuuid": "871fd02d-def7-4c83-b40e-23029a4019cd", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ae26c1c9-ca79-4a83-a050-0eaab121ce3e', 'INSERT', '{"uuid": "ae26c1c9-ca79-4a83-a050-0eaab121ce3e", "roletype": "AGENT", "objectuuid": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dd7c5212-9734-48af-9396-9f4ee835843e', 'INSERT', '{"uuid": "dd7c5212-9734-48af-9396-9f4ee835843e", "assumed": true, "ascendantuuid": "871fd02d-def7-4c83-b40e-23029a4019cd", "descendantuuid": "ae26c1c9-ca79-4a83-a050-0eaab121ce3e", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '11542ad4-cd41-4d26-b778-a25b29175f7b', 'INSERT', '{"uuid": "11542ad4-cd41-4d26-b778-a25b29175f7b", "roletype": "TENANT", "objectuuid": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'e6d44cf8-f6fa-4138-8410-982613c62c49', 'INSERT', '{"op": "SELECT", "uuid": "e6d44cf8-f6fa-4138-8410-982613c62c49", "objectuuid": "f4219fae-353d-4324-90ca-9f313a8c1c17", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bb4891cd-9c41-4275-bafc-a69557c3e3a7', 'INSERT', '{"uuid": "bb4891cd-9c41-4275-bafc-a69557c3e3a7", "assumed": true, "ascendantuuid": "11542ad4-cd41-4d26-b778-a25b29175f7b", "descendantuuid": "e6d44cf8-f6fa-4138-8410-982613c62c49", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '419450e7-127e-4866-b520-e79537284e7c', 'INSERT', '{"uuid": "419450e7-127e-4866-b520-e79537284e7c", "assumed": true, "ascendantuuid": "dfeb77e8-087e-423f-b4b5-8e8111a8b83e", "descendantuuid": "11542ad4-cd41-4d26-b778-a25b29175f7b", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5ecdbd09-d56b-43c4-96cd-3743963d23d4', 'INSERT', '{"uuid": "5ecdbd09-d56b-43c4-96cd-3743963d23d4", "assumed": true, "ascendantuuid": "ae26c1c9-ca79-4a83-a050-0eaab121ce3e", "descendantuuid": "11542ad4-cd41-4d26-b778-a25b29175f7b", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '289556ad-fea2-4e99-a222-7ab08c4f85dc', 'INSERT', '{"uuid": "289556ad-fea2-4e99-a222-7ab08c4f85dc", "assumed": true, "ascendantuuid": "11542ad4-cd41-4d26-b778-a25b29175f7b", "descendantuuid": "38aa2ac2-71e5-4805-94ae-61361288f235", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd07700f1-0709-4a9d-9f14-4f47e7d7b749', 'INSERT', '{"uuid": "d07700f1-0709-4a9d-9f14-4f47e7d7b749", "assumed": true, "ascendantuuid": "11542ad4-cd41-4d26-b778-a25b29175f7b", "descendantuuid": "8806c446-5551-4059-ba53-850a2d147c7c", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '346eefc8-8d2a-4b67-8f22-c6a0afea94e4', 'INSERT', '{"uuid": "346eefc8-8d2a-4b67-8f22-c6a0afea94e4", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "ae26c1c9-ca79-4a83-a050-0eaab121ce3e", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'be3bb7a6-7828-4047-a180-79fc7a7277b0', 'INSERT', '{"uuid": "be3bb7a6-7828-4047-a180-79fc7a7277b0", "assumed": true, "ascendantuuid": "b9d1cb3c-79f0-4640-b951-ad41f79d7b95", "descendantuuid": "1b1da9f7-1fb1-4b94-94d7-57275b028d54", "grantedbyroleuuid": null, "grantedbytriggerof": "f4219fae-353d-4324-90ca-9f313a8c1c17"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'f4219fae-353d-4324-90ca-9f313a8c1c17', 'INSERT', '{"mark": "members-discussion", "type": "SUBSCRIBER", "uuid": "f4219fae-353d-4324-90ca-9f313a8c1c17", "version": 0, "anchoruuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "holderuuid": "137fb47a-07d4-42cc-b2ef-8e371041cf41", "contactuuid": "691db509-b67e-46ec-a859-c4cb05fbbd70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', 'INSERT', '{"uuid": "219baf3d-0bb7-4252-b92f-4cfa97cb633c", "serialid": 191, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'dc7aa55a-ab16-47eb-a29b-79e64328fa31', 'INSERT', '{"uuid": "dc7aa55a-ab16-47eb-a29b-79e64328fa31", "roletype": "OWNER", "objectuuid": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '37c59916-a966-4dca-a1e3-0cffb78ad141', 'INSERT', '{"op": "DELETE", "uuid": "37c59916-a966-4dca-a1e3-0cffb78ad141", "objectuuid": "219baf3d-0bb7-4252-b92f-4cfa97cb633c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0df4ebf7-d987-4f0b-9bdb-3dcc8d762053', 'INSERT', '{"uuid": "0df4ebf7-d987-4f0b-9bdb-3dcc8d762053", "assumed": true, "ascendantuuid": "dc7aa55a-ab16-47eb-a29b-79e64328fa31", "descendantuuid": "37c59916-a966-4dca-a1e3-0cffb78ad141", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'aaca1433-4934-4751-8f67-71b7b61ba489', 'INSERT', '{"uuid": "aaca1433-4934-4751-8f67-71b7b61ba489", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "dc7aa55a-ab16-47eb-a29b-79e64328fa31", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a77c71d4-6631-4b14-aa50-50b0f9e79363', 'INSERT', '{"uuid": "a77c71d4-6631-4b14-aa50-50b0f9e79363", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "dc7aa55a-ab16-47eb-a29b-79e64328fa31", "grantedbyroleuuid": "dc7aa55a-ab16-47eb-a29b-79e64328fa31", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '08963816-c027-42e1-80a8-f55dcd6a02aa', 'INSERT', '{"uuid": "08963816-c027-42e1-80a8-f55dcd6a02aa", "roletype": "ADMIN", "objectuuid": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'b546d5b0-59f6-44af-a54d-d8e3097a3640', 'INSERT', '{"op": "UPDATE", "uuid": "b546d5b0-59f6-44af-a54d-d8e3097a3640", "objectuuid": "219baf3d-0bb7-4252-b92f-4cfa97cb633c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6147de7f-5796-4b80-b622-f5c3b70e01d0', 'INSERT', '{"uuid": "6147de7f-5796-4b80-b622-f5c3b70e01d0", "assumed": true, "ascendantuuid": "08963816-c027-42e1-80a8-f55dcd6a02aa", "descendantuuid": "b546d5b0-59f6-44af-a54d-d8e3097a3640", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'af96206c-1ae8-4350-96cb-71ed23f0baa9', 'INSERT', '{"uuid": "af96206c-1ae8-4350-96cb-71ed23f0baa9", "assumed": true, "ascendantuuid": "dc7aa55a-ab16-47eb-a29b-79e64328fa31", "descendantuuid": "08963816-c027-42e1-80a8-f55dcd6a02aa", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5e3ac214-0f11-4af9-b637-50ff3f841b76', 'INSERT', '{"uuid": "5e3ac214-0f11-4af9-b637-50ff3f841b76", "roletype": "AGENT", "objectuuid": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a60ac64a-4af6-48bc-a1aa-69a24ad48d3a', 'INSERT', '{"uuid": "a60ac64a-4af6-48bc-a1aa-69a24ad48d3a", "assumed": true, "ascendantuuid": "08963816-c027-42e1-80a8-f55dcd6a02aa", "descendantuuid": "5e3ac214-0f11-4af9-b637-50ff3f841b76", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '85d1d5a3-30a5-4bab-9670-878abc6bfe54', 'INSERT', '{"uuid": "85d1d5a3-30a5-4bab-9670-878abc6bfe54", "roletype": "TENANT", "objectuuid": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e38c4ccc-e949-4c40-8379-e3b601107c9b', 'INSERT', '{"uuid": "e38c4ccc-e949-4c40-8379-e3b601107c9b", "assumed": true, "ascendantuuid": "85d1d5a3-30a5-4bab-9670-878abc6bfe54", "descendantuuid": "c2ccc14e-f11b-497f-95db-5397aa38012b", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '462cc639-2ca8-40a8-a575-a49a045f3596', 'INSERT', '{"uuid": "462cc639-2ca8-40a8-a575-a49a045f3596", "assumed": true, "ascendantuuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "descendantuuid": "85d1d5a3-30a5-4bab-9670-878abc6bfe54", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fe8eaf38-c3c2-4221-8cdd-207155392d6c', 'INSERT', '{"uuid": "fe8eaf38-c3c2-4221-8cdd-207155392d6c", "assumed": true, "ascendantuuid": "5e3ac214-0f11-4af9-b637-50ff3f841b76", "descendantuuid": "85d1d5a3-30a5-4bab-9670-878abc6bfe54", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7df76f5f-b7cb-40eb-a86f-f83945ee8cd9', 'INSERT', '{"uuid": "7df76f5f-b7cb-40eb-a86f-f83945ee8cd9", "assumed": true, "ascendantuuid": "85d1d5a3-30a5-4bab-9670-878abc6bfe54", "descendantuuid": "5c9372e0-cb21-4ae7-a461-df086ad19426", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f655df71-ecd5-4f06-a268-f9d1b99454ce', 'INSERT', '{"uuid": "f655df71-ecd5-4f06-a268-f9d1b99454ce", "assumed": true, "ascendantuuid": "85d1d5a3-30a5-4bab-9670-878abc6bfe54", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '63c62f56-4b72-44c3-99ce-ddb029ab1283', 'INSERT', '{"uuid": "63c62f56-4b72-44c3-99ce-ddb029ab1283", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "5e3ac214-0f11-4af9-b637-50ff3f841b76", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fe2e422c-ffa6-4250-8470-2a3c97f57d08', 'INSERT', '{"uuid": "fe2e422c-ffa6-4250-8470-2a3c97f57d08", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "dc7aa55a-ab16-47eb-a29b-79e64328fa31", "grantedbyroleuuid": null, "grantedbytriggerof": "219baf3d-0bb7-4252-b92f-4cfa97cb633c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "219baf3d-0bb7-4252-b92f-4cfa97cb633c", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "contactuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'ed0fb977-6512-4452-8505-378fcbbd5060', 'INSERT', '{"uuid": "ed0fb977-6512-4452-8505-378fcbbd5060", "serialid": 192, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6', 'INSERT', '{"uuid": "f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6", "roletype": "OWNER", "objectuuid": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '36490d00-f5d4-4722-b285-9cac45e7dd5c', 'INSERT', '{"op": "DELETE", "uuid": "36490d00-f5d4-4722-b285-9cac45e7dd5c", "objectuuid": "ed0fb977-6512-4452-8505-378fcbbd5060", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '65414b52-aa15-4162-b018-eb4fd128283c', 'INSERT', '{"uuid": "65414b52-aa15-4162-b018-eb4fd128283c", "assumed": true, "ascendantuuid": "f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6", "descendantuuid": "36490d00-f5d4-4722-b285-9cac45e7dd5c", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '45c35d7f-f897-44dc-af54-127ab4bde8da', 'INSERT', '{"uuid": "45c35d7f-f897-44dc-af54-127ab4bde8da", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0d888bad-9424-4fcc-9d80-8ff53f437df0', 'INSERT', '{"uuid": "0d888bad-9424-4fcc-9d80-8ff53f437df0", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6", "grantedbyroleuuid": "f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ba13ab33-99ee-48ef-b205-73e9adea9651', 'INSERT', '{"uuid": "ba13ab33-99ee-48ef-b205-73e9adea9651", "roletype": "ADMIN", "objectuuid": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '891fe7ab-2113-4f20-ab6d-3d81cca0941a', 'INSERT', '{"op": "UPDATE", "uuid": "891fe7ab-2113-4f20-ab6d-3d81cca0941a", "objectuuid": "ed0fb977-6512-4452-8505-378fcbbd5060", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bd19286b-a328-4655-b49e-ebd8ae24e3ff', 'INSERT', '{"uuid": "bd19286b-a328-4655-b49e-ebd8ae24e3ff", "assumed": true, "ascendantuuid": "ba13ab33-99ee-48ef-b205-73e9adea9651", "descendantuuid": "891fe7ab-2113-4f20-ab6d-3d81cca0941a", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '31150614-93a5-4100-8c51-85a86e2f6de0', 'INSERT', '{"uuid": "31150614-93a5-4100-8c51-85a86e2f6de0", "assumed": true, "ascendantuuid": "f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6", "descendantuuid": "ba13ab33-99ee-48ef-b205-73e9adea9651", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '918840d4-592e-43eb-afa5-ad6ea37043a3', 'INSERT', '{"uuid": "918840d4-592e-43eb-afa5-ad6ea37043a3", "roletype": "AGENT", "objectuuid": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f50ccdba-1e3f-4c32-a7d0-064405737cb5', 'INSERT', '{"uuid": "f50ccdba-1e3f-4c32-a7d0-064405737cb5", "assumed": true, "ascendantuuid": "ba13ab33-99ee-48ef-b205-73e9adea9651", "descendantuuid": "918840d4-592e-43eb-afa5-ad6ea37043a3", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd48cd569-cc1f-4f27-bb9a-35154e5fc0b2', 'INSERT', '{"uuid": "d48cd569-cc1f-4f27-bb9a-35154e5fc0b2", "roletype": "TENANT", "objectuuid": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '10ff5603-7bfa-490e-a468-6d231db02ac6', 'INSERT', '{"op": "SELECT", "uuid": "10ff5603-7bfa-490e-a468-6d231db02ac6", "objectuuid": "ed0fb977-6512-4452-8505-378fcbbd5060", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '68007eb2-edad-4729-a1ac-87d36a60fab1', 'INSERT', '{"uuid": "68007eb2-edad-4729-a1ac-87d36a60fab1", "assumed": true, "ascendantuuid": "d48cd569-cc1f-4f27-bb9a-35154e5fc0b2", "descendantuuid": "10ff5603-7bfa-490e-a468-6d231db02ac6", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7c1e03f8-4df9-4ada-80fe-88264c146a13', 'INSERT', '{"uuid": "7c1e03f8-4df9-4ada-80fe-88264c146a13", "assumed": true, "ascendantuuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "descendantuuid": "d48cd569-cc1f-4f27-bb9a-35154e5fc0b2", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0da1294a-124d-4d64-868f-fa10e2bb50c6', 'INSERT', '{"uuid": "0da1294a-124d-4d64-868f-fa10e2bb50c6", "assumed": true, "ascendantuuid": "918840d4-592e-43eb-afa5-ad6ea37043a3", "descendantuuid": "d48cd569-cc1f-4f27-bb9a-35154e5fc0b2", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7266aa8d-0a18-4c1d-a2db-460e22082376', 'INSERT', '{"uuid": "7266aa8d-0a18-4c1d-a2db-460e22082376", "assumed": true, "ascendantuuid": "d48cd569-cc1f-4f27-bb9a-35154e5fc0b2", "descendantuuid": "5c9372e0-cb21-4ae7-a461-df086ad19426", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'eff379d8-ea07-45d8-b1b9-939d7bd504cf', 'INSERT', '{"uuid": "eff379d8-ea07-45d8-b1b9-939d7bd504cf", "assumed": true, "ascendantuuid": "d48cd569-cc1f-4f27-bb9a-35154e5fc0b2", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ba997a4e-e15a-4b7e-ab8d-8d18b7d77784', 'INSERT', '{"uuid": "ba997a4e-e15a-4b7e-ab8d-8d18b7d77784", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "918840d4-592e-43eb-afa5-ad6ea37043a3", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '44ee4667-fce9-4a32-94bd-c303ee429880', 'INSERT', '{"uuid": "44ee4667-fce9-4a32-94bd-c303ee429880", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6", "grantedbyroleuuid": null, "grantedbytriggerof": "ed0fb977-6512-4452-8505-378fcbbd5060"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'ed0fb977-6512-4452-8505-378fcbbd5060', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "ed0fb977-6512-4452-8505-378fcbbd5060", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "contactuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 'INSERT', '{"uuid": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af", "serialid": 193, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1ec552f6-834f-4b68-ae60-6d39e6d887e7', 'INSERT', '{"uuid": "1ec552f6-834f-4b68-ae60-6d39e6d887e7", "roletype": "OWNER", "objectuuid": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'd53e3095-38c0-4be0-b7c4-17d6c505c370', 'INSERT', '{"op": "DELETE", "uuid": "d53e3095-38c0-4be0-b7c4-17d6c505c370", "objectuuid": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '23114396-605b-4635-bfec-f5d19f9f2d61', 'INSERT', '{"uuid": "23114396-605b-4635-bfec-f5d19f9f2d61", "assumed": true, "ascendantuuid": "1ec552f6-834f-4b68-ae60-6d39e6d887e7", "descendantuuid": "d53e3095-38c0-4be0-b7c4-17d6c505c370", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6028e332-1d2e-4c7d-953b-8bbb2dcb3876', 'INSERT', '{"uuid": "6028e332-1d2e-4c7d-953b-8bbb2dcb3876", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "1ec552f6-834f-4b68-ae60-6d39e6d887e7", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '65248239-5a3e-4a20-bf6b-41c18985d3fb', 'INSERT', '{"uuid": "65248239-5a3e-4a20-bf6b-41c18985d3fb", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "1ec552f6-834f-4b68-ae60-6d39e6d887e7", "grantedbyroleuuid": "1ec552f6-834f-4b68-ae60-6d39e6d887e7", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '82982647-714a-4203-b8f0-3d9fa5d22b4e', 'INSERT', '{"uuid": "82982647-714a-4203-b8f0-3d9fa5d22b4e", "roletype": "ADMIN", "objectuuid": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '39a2c817-387a-4a54-a751-6dfc0d781f8c', 'INSERT', '{"op": "UPDATE", "uuid": "39a2c817-387a-4a54-a751-6dfc0d781f8c", "objectuuid": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '78166a30-6c96-48c2-b96d-1b0b9c1bd6ec', 'INSERT', '{"uuid": "78166a30-6c96-48c2-b96d-1b0b9c1bd6ec", "assumed": true, "ascendantuuid": "82982647-714a-4203-b8f0-3d9fa5d22b4e", "descendantuuid": "39a2c817-387a-4a54-a751-6dfc0d781f8c", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '845c483c-fadb-4d86-bc40-8f26ee15e3e2', 'INSERT', '{"uuid": "845c483c-fadb-4d86-bc40-8f26ee15e3e2", "assumed": true, "ascendantuuid": "1ec552f6-834f-4b68-ae60-6d39e6d887e7", "descendantuuid": "82982647-714a-4203-b8f0-3d9fa5d22b4e", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '76d74da3-9fbd-43bb-9083-093a9254af2b', 'INSERT', '{"uuid": "76d74da3-9fbd-43bb-9083-093a9254af2b", "roletype": "AGENT", "objectuuid": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fa56ac1c-a232-4e0b-98bb-82d3ecf4bb97', 'INSERT', '{"uuid": "fa56ac1c-a232-4e0b-98bb-82d3ecf4bb97", "assumed": true, "ascendantuuid": "82982647-714a-4203-b8f0-3d9fa5d22b4e", "descendantuuid": "76d74da3-9fbd-43bb-9083-093a9254af2b", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0303b9f3-8860-4ebc-b808-d4d2da18f5fb', 'INSERT', '{"uuid": "0303b9f3-8860-4ebc-b808-d4d2da18f5fb", "roletype": "TENANT", "objectuuid": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '09cb2efd-3998-4b84-a315-788b6375ffa6', 'INSERT', '{"op": "SELECT", "uuid": "09cb2efd-3998-4b84-a315-788b6375ffa6", "objectuuid": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '860c5bcf-0127-42e9-9057-86f63e8fb6d5', 'INSERT', '{"uuid": "860c5bcf-0127-42e9-9057-86f63e8fb6d5", "assumed": true, "ascendantuuid": "0303b9f3-8860-4ebc-b808-d4d2da18f5fb", "descendantuuid": "09cb2efd-3998-4b84-a315-788b6375ffa6", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'be6f5601-acce-4422-abd5-2dff417f828f', 'INSERT', '{"uuid": "be6f5601-acce-4422-abd5-2dff417f828f", "assumed": true, "ascendantuuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "descendantuuid": "0303b9f3-8860-4ebc-b808-d4d2da18f5fb", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '04497d4a-90e2-40cd-ae75-bce64fea3d95', 'INSERT', '{"uuid": "04497d4a-90e2-40cd-ae75-bce64fea3d95", "assumed": true, "ascendantuuid": "76d74da3-9fbd-43bb-9083-093a9254af2b", "descendantuuid": "0303b9f3-8860-4ebc-b808-d4d2da18f5fb", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1aa22445-4c2c-49e7-961c-d7ed77dca1c7', 'INSERT', '{"uuid": "1aa22445-4c2c-49e7-961c-d7ed77dca1c7", "assumed": true, "ascendantuuid": "0303b9f3-8860-4ebc-b808-d4d2da18f5fb", "descendantuuid": "5c9372e0-cb21-4ae7-a461-df086ad19426", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'af0093ed-2cdb-4c57-8b68-5f1871f83f90', 'INSERT', '{"uuid": "af0093ed-2cdb-4c57-8b68-5f1871f83f90", "assumed": true, "ascendantuuid": "0303b9f3-8860-4ebc-b808-d4d2da18f5fb", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '93b39756-48a6-4a58-b196-58b68de6bc32', 'INSERT', '{"uuid": "93b39756-48a6-4a58-b196-58b68de6bc32", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "76d74da3-9fbd-43bb-9083-093a9254af2b", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7c418ce5-d2e7-4609-a25c-854a77422da5', 'INSERT', '{"uuid": "7c418ce5-d2e7-4609-a25c-854a77422da5", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "1ec552f6-834f-4b68-ae60-6d39e6d887e7", "grantedbyroleuuid": null, "grantedbytriggerof": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 'INSERT', '{"mark": "operations-discussion", "type": "SUBSCRIBER", "uuid": "a6bb6f3a-eb45-44ff-918b-7a94f9f770af", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "contactuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'af82432c-09a8-42a7-9525-e9095025d4dd', 'INSERT', '{"uuid": "af82432c-09a8-42a7-9525-e9095025d4dd", "serialid": 194, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '5c5e2c73-6a91-4b38-a290-fb7fc94d6cc0', 'INSERT', '{"op": "DELETE", "uuid": "5c5e2c73-6a91-4b38-a290-fb7fc94d6cc0", "objectuuid": "af82432c-09a8-42a7-9525-e9095025d4dd", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5fccc27f-37d4-4c9f-9f50-5c431eeb5dd6', 'INSERT', '{"uuid": "5fccc27f-37d4-4c9f-9f50-5c431eeb5dd6", "assumed": true, "ascendantuuid": "c17186dc-564d-4f82-914b-202ad8bc9941", "descendantuuid": "5c5e2c73-6a91-4b38-a290-fb7fc94d6cc0", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5ffd40e9-d22a-453d-b88d-4c222412afc0', 'INSERT', '{"uuid": "5ffd40e9-d22a-453d-b88d-4c222412afc0", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "c17186dc-564d-4f82-914b-202ad8bc9941", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1173ee00-62e1-423f-96bc-10a009e581b1', 'INSERT', '{"uuid": "1173ee00-62e1-423f-96bc-10a009e581b1", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "c17186dc-564d-4f82-914b-202ad8bc9941", "grantedbyroleuuid": "c17186dc-564d-4f82-914b-202ad8bc9941", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b05450fd-5e5b-4aa1-b334-0b886ced9492', 'INSERT', '{"uuid": "b05450fd-5e5b-4aa1-b334-0b886ced9492", "roletype": "ADMIN", "objectuuid": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '708ff719-70c9-48f5-8664-dbf49352d261', 'INSERT', '{"op": "UPDATE", "uuid": "708ff719-70c9-48f5-8664-dbf49352d261", "objectuuid": "af82432c-09a8-42a7-9525-e9095025d4dd", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a4973160-2485-4357-b9d4-04533f62326d', 'INSERT', '{"uuid": "a4973160-2485-4357-b9d4-04533f62326d", "assumed": true, "ascendantuuid": "b05450fd-5e5b-4aa1-b334-0b886ced9492", "descendantuuid": "708ff719-70c9-48f5-8664-dbf49352d261", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3142f58d-1600-42d5-8c4d-002f325423cf', 'INSERT', '{"uuid": "3142f58d-1600-42d5-8c4d-002f325423cf", "assumed": true, "ascendantuuid": "c17186dc-564d-4f82-914b-202ad8bc9941", "descendantuuid": "b05450fd-5e5b-4aa1-b334-0b886ced9492", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '2710f7f0-f352-4e71-a527-38076d6966ce', 'INSERT', '{"uuid": "2710f7f0-f352-4e71-a527-38076d6966ce", "roletype": "AGENT", "objectuuid": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'eec039fc-3cdc-48b0-8d80-371f5ab98ca8', 'INSERT', '{"uuid": "eec039fc-3cdc-48b0-8d80-371f5ab98ca8", "assumed": true, "ascendantuuid": "b05450fd-5e5b-4aa1-b334-0b886ced9492", "descendantuuid": "2710f7f0-f352-4e71-a527-38076d6966ce", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b012ee61-8155-4fa3-bee0-9a0918452bae', 'INSERT', '{"uuid": "b012ee61-8155-4fa3-bee0-9a0918452bae", "roletype": "TENANT", "objectuuid": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7fd8da11-6a47-4ca3-8bf3-9713a6ac0305', 'INSERT', '{"op": "SELECT", "uuid": "7fd8da11-6a47-4ca3-8bf3-9713a6ac0305", "objectuuid": "af82432c-09a8-42a7-9525-e9095025d4dd", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '873674d6-8281-4362-9a73-630c8e00c62c', 'INSERT', '{"uuid": "873674d6-8281-4362-9a73-630c8e00c62c", "assumed": true, "ascendantuuid": "b012ee61-8155-4fa3-bee0-9a0918452bae", "descendantuuid": "7fd8da11-6a47-4ca3-8bf3-9713a6ac0305", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '86e1fa7a-fcc5-4cb1-835b-62995092ec69', 'INSERT', '{"uuid": "86e1fa7a-fcc5-4cb1-835b-62995092ec69", "assumed": true, "ascendantuuid": "a6ff0898-04e1-49b7-8621-b42846df06e1", "descendantuuid": "b012ee61-8155-4fa3-bee0-9a0918452bae", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1dca2eff-0e1e-4941-a54b-18ba818edaa4', 'INSERT', '{"uuid": "1dca2eff-0e1e-4941-a54b-18ba818edaa4", "assumed": true, "ascendantuuid": "2710f7f0-f352-4e71-a527-38076d6966ce", "descendantuuid": "b012ee61-8155-4fa3-bee0-9a0918452bae", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '42131f0b-59fd-4698-b74a-aa1817515792', 'INSERT', '{"uuid": "42131f0b-59fd-4698-b74a-aa1817515792", "assumed": true, "ascendantuuid": "b012ee61-8155-4fa3-bee0-9a0918452bae", "descendantuuid": "5c9372e0-cb21-4ae7-a461-df086ad19426", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '95481de2-ae7a-4657-b880-d0ee44b27bfc', 'INSERT', '{"uuid": "95481de2-ae7a-4657-b880-d0ee44b27bfc", "assumed": true, "ascendantuuid": "b012ee61-8155-4fa3-bee0-9a0918452bae", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'eabbd51a-4686-4d65-96e1-958c313ecf9b', 'INSERT', '{"uuid": "eabbd51a-4686-4d65-96e1-958c313ecf9b", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "2710f7f0-f352-4e71-a527-38076d6966ce", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '117b3c8e-3a79-4ad1-adca-c126ba5ce98a', 'INSERT', '{"uuid": "117b3c8e-3a79-4ad1-adca-c126ba5ce98a", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "c17186dc-564d-4f82-914b-202ad8bc9941", "grantedbyroleuuid": null, "grantedbytriggerof": "af82432c-09a8-42a7-9525-e9095025d4dd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'af82432c-09a8-42a7-9525-e9095025d4dd', 'INSERT', '{"mark": "operations-announce", "type": "SUBSCRIBER", "uuid": "af82432c-09a8-42a7-9525-e9095025d4dd", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "contactuuid": "b4a3b50d-1c1f-4052-b584-0b7f2aec1a42"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', 'INSERT', '{"uuid": "f691585e-eb5e-45bd-8d8a-8187094ed0a0", "serialid": 195, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '18fb2aed-c5ba-41ea-ac09-4ec940ff6eff', 'INSERT', '{"uuid": "18fb2aed-c5ba-41ea-ac09-4ec940ff6eff", "roletype": "OWNER", "objectuuid": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '63ab27e2-5a5b-483e-8346-0024da814b06', 'INSERT', '{"op": "DELETE", "uuid": "63ab27e2-5a5b-483e-8346-0024da814b06", "objectuuid": "f691585e-eb5e-45bd-8d8a-8187094ed0a0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '38d1b657-379e-4a9a-8527-c30fa1d7c78b', 'INSERT', '{"uuid": "38d1b657-379e-4a9a-8527-c30fa1d7c78b", "assumed": true, "ascendantuuid": "18fb2aed-c5ba-41ea-ac09-4ec940ff6eff", "descendantuuid": "63ab27e2-5a5b-483e-8346-0024da814b06", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '26b6b9d0-a985-4b9d-9b8e-e063ba480714', 'INSERT', '{"uuid": "26b6b9d0-a985-4b9d-9b8e-e063ba480714", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "18fb2aed-c5ba-41ea-ac09-4ec940ff6eff", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fb7994b8-3bb2-4381-9b28-5c5fffcf5500', 'INSERT', '{"uuid": "fb7994b8-3bb2-4381-9b28-5c5fffcf5500", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "18fb2aed-c5ba-41ea-ac09-4ec940ff6eff", "grantedbyroleuuid": "18fb2aed-c5ba-41ea-ac09-4ec940ff6eff", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6c83af72-d5d7-4076-b7b6-33ca23c80ff8', 'INSERT', '{"uuid": "6c83af72-d5d7-4076-b7b6-33ca23c80ff8", "roletype": "ADMIN", "objectuuid": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '14fd3310-5109-472b-9eb8-9b3aac0cc5c8', 'INSERT', '{"op": "UPDATE", "uuid": "14fd3310-5109-472b-9eb8-9b3aac0cc5c8", "objectuuid": "f691585e-eb5e-45bd-8d8a-8187094ed0a0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '25ef6910-d687-4255-936f-9738868b5bdb', 'INSERT', '{"uuid": "25ef6910-d687-4255-936f-9738868b5bdb", "assumed": true, "ascendantuuid": "6c83af72-d5d7-4076-b7b6-33ca23c80ff8", "descendantuuid": "14fd3310-5109-472b-9eb8-9b3aac0cc5c8", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ed7f532c-3caa-49ef-825b-e36c90d490f9', 'INSERT', '{"uuid": "ed7f532c-3caa-49ef-825b-e36c90d490f9", "assumed": true, "ascendantuuid": "18fb2aed-c5ba-41ea-ac09-4ec940ff6eff", "descendantuuid": "6c83af72-d5d7-4076-b7b6-33ca23c80ff8", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8833f9cb-d000-41ef-920f-6e6ba586c65d', 'INSERT', '{"uuid": "8833f9cb-d000-41ef-920f-6e6ba586c65d", "roletype": "AGENT", "objectuuid": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6e1a316c-be94-44a8-90b9-1e9bf3e03516', 'INSERT', '{"uuid": "6e1a316c-be94-44a8-90b9-1e9bf3e03516", "assumed": true, "ascendantuuid": "6c83af72-d5d7-4076-b7b6-33ca23c80ff8", "descendantuuid": "8833f9cb-d000-41ef-920f-6e6ba586c65d", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '49e8c569-1fe0-4215-8cc3-698054ff896f', 'INSERT', '{"uuid": "49e8c569-1fe0-4215-8cc3-698054ff896f", "roletype": "TENANT", "objectuuid": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a351e412-5f16-4c87-b09f-6c0290e20b7c', 'INSERT', '{"op": "SELECT", "uuid": "a351e412-5f16-4c87-b09f-6c0290e20b7c", "objectuuid": "f691585e-eb5e-45bd-8d8a-8187094ed0a0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3918e326-9f99-489b-8c87-5d3d95c8909b', 'INSERT', '{"uuid": "3918e326-9f99-489b-8c87-5d3d95c8909b", "assumed": true, "ascendantuuid": "49e8c569-1fe0-4215-8cc3-698054ff896f", "descendantuuid": "a351e412-5f16-4c87-b09f-6c0290e20b7c", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '264c36d3-405f-4eef-98f0-cff6a9f50783', 'INSERT', '{"uuid": "264c36d3-405f-4eef-98f0-cff6a9f50783", "assumed": true, "ascendantuuid": "939dafca-fe72-499d-979d-6fe0288e6807", "descendantuuid": "49e8c569-1fe0-4215-8cc3-698054ff896f", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cc1f086f-9232-4b67-a4d6-b270c1496cc7', 'INSERT', '{"uuid": "cc1f086f-9232-4b67-a4d6-b270c1496cc7", "assumed": true, "ascendantuuid": "8833f9cb-d000-41ef-920f-6e6ba586c65d", "descendantuuid": "49e8c569-1fe0-4215-8cc3-698054ff896f", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'de1c6bc8-f470-4c0d-b47f-353980576e29', 'INSERT', '{"uuid": "de1c6bc8-f470-4c0d-b47f-353980576e29", "assumed": true, "ascendantuuid": "49e8c569-1fe0-4215-8cc3-698054ff896f", "descendantuuid": "b91f7dd8-b4a4-4f9b-9192-300f8e982c6d", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c48e3a13-76e7-4ee6-acbd-6d88da4b0392', 'INSERT', '{"uuid": "c48e3a13-76e7-4ee6-acbd-6d88da4b0392", "assumed": true, "ascendantuuid": "49e8c569-1fe0-4215-8cc3-698054ff896f", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '860cf6b4-8697-4a7f-9c59-d65c3aa73067', 'INSERT', '{"uuid": "860cf6b4-8697-4a7f-9c59-d65c3aa73067", "assumed": true, "ascendantuuid": "49e8c569-1fe0-4215-8cc3-698054ff896f", "descendantuuid": "236b88d3-09bc-4750-9219-61529f7740af", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '927cd8d9-8a84-4b66-8a84-49ed4a4d93ca', 'INSERT', '{"uuid": "927cd8d9-8a84-4b66-8a84-49ed4a4d93ca", "assumed": true, "ascendantuuid": "f87398bc-225a-4eee-bea8-7983be6ae529", "descendantuuid": "8833f9cb-d000-41ef-920f-6e6ba586c65d", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5c324003-be19-4195-bb55-12ad791cfccd', 'INSERT', '{"uuid": "5c324003-be19-4195-bb55-12ad791cfccd", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "18fb2aed-c5ba-41ea-ac09-4ec940ff6eff", "grantedbyroleuuid": null, "grantedbytriggerof": "f691585e-eb5e-45bd-8d8a-8187094ed0a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', 'INSERT', '{"mark": null, "type": "EX_PARTNER", "uuid": "f691585e-eb5e-45bd-8d8a-8187094ed0a0", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "417b9a15-5e1b-4d15-b1b3-79dc19b49c50", "contactuuid": "7a334268-7d11-4765-8fa9-17e2c36cca7a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '65879210-cf7c-4e5b-a2d1-742a42fcb488', 'INSERT', '{"uuid": "65879210-cf7c-4e5b-a2d1-742a42fcb488", "serialid": 196, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0e190f5b-0333-4f70-aabc-71d2e810a712', 'INSERT', '{"uuid": "0e190f5b-0333-4f70-aabc-71d2e810a712", "roletype": "OWNER", "objectuuid": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '0fc0933c-0397-4b0d-ae81-18c41d3fe082', 'INSERT', '{"op": "DELETE", "uuid": "0fc0933c-0397-4b0d-ae81-18c41d3fe082", "objectuuid": "65879210-cf7c-4e5b-a2d1-742a42fcb488", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f04b5170-d247-4edb-bd83-4ce3c0199b3d', 'INSERT', '{"uuid": "f04b5170-d247-4edb-bd83-4ce3c0199b3d", "assumed": true, "ascendantuuid": "0e190f5b-0333-4f70-aabc-71d2e810a712", "descendantuuid": "0fc0933c-0397-4b0d-ae81-18c41d3fe082", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '014c9f70-9876-4685-b99a-d88338f16dc7', 'INSERT', '{"uuid": "014c9f70-9876-4685-b99a-d88338f16dc7", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0e190f5b-0333-4f70-aabc-71d2e810a712", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0f6d273a-ed72-414a-ba94-08f1cc96324c', 'INSERT', '{"uuid": "0f6d273a-ed72-414a-ba94-08f1cc96324c", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0e190f5b-0333-4f70-aabc-71d2e810a712", "grantedbyroleuuid": "0e190f5b-0333-4f70-aabc-71d2e810a712", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8eb1d02d-d44f-42a8-bd93-a05174ce15e0', 'INSERT', '{"uuid": "8eb1d02d-d44f-42a8-bd93-a05174ce15e0", "roletype": "ADMIN", "objectuuid": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '133a7879-3f1c-4daf-8b16-9160b4477288', 'INSERT', '{"op": "UPDATE", "uuid": "133a7879-3f1c-4daf-8b16-9160b4477288", "objectuuid": "65879210-cf7c-4e5b-a2d1-742a42fcb488", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '84c8d1c7-d62d-4bc8-a34d-aa9872a20ed2', 'INSERT', '{"uuid": "84c8d1c7-d62d-4bc8-a34d-aa9872a20ed2", "assumed": true, "ascendantuuid": "8eb1d02d-d44f-42a8-bd93-a05174ce15e0", "descendantuuid": "133a7879-3f1c-4daf-8b16-9160b4477288", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3a7de6b1-c26d-4a9a-9b98-27d65c1a4973', 'INSERT', '{"uuid": "3a7de6b1-c26d-4a9a-9b98-27d65c1a4973", "assumed": true, "ascendantuuid": "0e190f5b-0333-4f70-aabc-71d2e810a712", "descendantuuid": "8eb1d02d-d44f-42a8-bd93-a05174ce15e0", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '77ef9867-e939-4d36-85e1-4a573c4a9b55', 'INSERT', '{"uuid": "77ef9867-e939-4d36-85e1-4a573c4a9b55", "roletype": "AGENT", "objectuuid": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e07c7714-cc7d-47bc-b867-8f17d5b3150b', 'INSERT', '{"uuid": "e07c7714-cc7d-47bc-b867-8f17d5b3150b", "assumed": true, "ascendantuuid": "8eb1d02d-d44f-42a8-bd93-a05174ce15e0", "descendantuuid": "77ef9867-e939-4d36-85e1-4a573c4a9b55", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'cedad28c-ea54-48a9-b2f8-e16a29ec56a1', 'INSERT', '{"uuid": "cedad28c-ea54-48a9-b2f8-e16a29ec56a1", "roletype": "TENANT", "objectuuid": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'd2ef2562-a654-4af3-b1eb-6e8bcd35c03e', 'INSERT', '{"op": "SELECT", "uuid": "d2ef2562-a654-4af3-b1eb-6e8bcd35c03e", "objectuuid": "65879210-cf7c-4e5b-a2d1-742a42fcb488", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '04fbc978-15b2-4609-b13e-3a307803ca2d', 'INSERT', '{"uuid": "04fbc978-15b2-4609-b13e-3a307803ca2d", "assumed": true, "ascendantuuid": "cedad28c-ea54-48a9-b2f8-e16a29ec56a1", "descendantuuid": "d2ef2562-a654-4af3-b1eb-6e8bcd35c03e", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fc6074ef-ac17-4e01-a504-81232802ed49', 'INSERT', '{"uuid": "fc6074ef-ac17-4e01-a504-81232802ed49", "assumed": true, "ascendantuuid": "82d6e2a0-3c2d-4a8e-8638-4903696927d5", "descendantuuid": "cedad28c-ea54-48a9-b2f8-e16a29ec56a1", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c303b3da-aa0d-4b5a-a6ef-437aeaab8698', 'INSERT', '{"uuid": "c303b3da-aa0d-4b5a-a6ef-437aeaab8698", "assumed": true, "ascendantuuid": "77ef9867-e939-4d36-85e1-4a573c4a9b55", "descendantuuid": "cedad28c-ea54-48a9-b2f8-e16a29ec56a1", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '922f86ad-53a1-4643-a528-a0707127b2d4', 'INSERT', '{"uuid": "922f86ad-53a1-4643-a528-a0707127b2d4", "assumed": true, "ascendantuuid": "cedad28c-ea54-48a9-b2f8-e16a29ec56a1", "descendantuuid": "25acc71c-db8f-46e4-950a-8ea76637bb9b", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'eb764aac-d784-4ebc-874c-c6c5285137d8', 'INSERT', '{"uuid": "eb764aac-d784-4ebc-874c-c6c5285137d8", "assumed": true, "ascendantuuid": "cedad28c-ea54-48a9-b2f8-e16a29ec56a1", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '064926b6-0149-4518-bbe9-b201997cc90f', 'INSERT', '{"uuid": "064926b6-0149-4518-bbe9-b201997cc90f", "assumed": true, "ascendantuuid": "cedad28c-ea54-48a9-b2f8-e16a29ec56a1", "descendantuuid": "f913c978-1afc-4af0-9bb6-8c21eed95991", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b3132dbc-b482-486b-b02e-a8ad200cbdd2', 'INSERT', '{"uuid": "b3132dbc-b482-486b-b02e-a8ad200cbdd2", "assumed": true, "ascendantuuid": "da979efd-9d87-4dc5-a839-493e883cf292", "descendantuuid": "77ef9867-e939-4d36-85e1-4a573c4a9b55", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '38c323d4-bd10-48f2-86a9-ca9246ee0cc8', 'INSERT', '{"uuid": "38c323d4-bd10-48f2-86a9-ca9246ee0cc8", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "0e190f5b-0333-4f70-aabc-71d2e810a712", "grantedbyroleuuid": null, "grantedbytriggerof": "65879210-cf7c-4e5b-a2d1-742a42fcb488"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '65879210-cf7c-4e5b-a2d1-742a42fcb488', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "65879210-cf7c-4e5b-a2d1-742a42fcb488", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "contactuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '97e5ed67-e81c-4c12-b354-45db951901c0', 'INSERT', '{"uuid": "97e5ed67-e81c-4c12-b354-45db951901c0", "serialid": 197, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7377295c-c6d9-4826-b712-ea5df5c3d8d1', 'INSERT', '{"uuid": "7377295c-c6d9-4826-b712-ea5df5c3d8d1", "roletype": "OWNER", "objectuuid": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '5ae15451-1a59-45da-b59d-02884a418fc1', 'INSERT', '{"op": "DELETE", "uuid": "5ae15451-1a59-45da-b59d-02884a418fc1", "objectuuid": "97e5ed67-e81c-4c12-b354-45db951901c0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'be632038-c8e0-441e-a7cd-80f1fab0f7a5', 'INSERT', '{"uuid": "be632038-c8e0-441e-a7cd-80f1fab0f7a5", "assumed": true, "ascendantuuid": "7377295c-c6d9-4826-b712-ea5df5c3d8d1", "descendantuuid": "5ae15451-1a59-45da-b59d-02884a418fc1", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e513ed65-b37e-42c2-8d1b-d1eb96d5b988', 'INSERT', '{"uuid": "e513ed65-b37e-42c2-8d1b-d1eb96d5b988", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "7377295c-c6d9-4826-b712-ea5df5c3d8d1", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '18472c38-51a3-4360-b694-c118c3d75515', 'INSERT', '{"uuid": "18472c38-51a3-4360-b694-c118c3d75515", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "7377295c-c6d9-4826-b712-ea5df5c3d8d1", "grantedbyroleuuid": "7377295c-c6d9-4826-b712-ea5df5c3d8d1", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '638a0990-bb30-434c-80b5-65f3e33732f6', 'INSERT', '{"uuid": "638a0990-bb30-434c-80b5-65f3e33732f6", "roletype": "ADMIN", "objectuuid": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'c0844f33-c3b3-477f-9321-4b342474802a', 'INSERT', '{"op": "UPDATE", "uuid": "c0844f33-c3b3-477f-9321-4b342474802a", "objectuuid": "97e5ed67-e81c-4c12-b354-45db951901c0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1f9ef4b2-12f7-439d-b0a4-d67d1f0ef28e', 'INSERT', '{"uuid": "1f9ef4b2-12f7-439d-b0a4-d67d1f0ef28e", "assumed": true, "ascendantuuid": "638a0990-bb30-434c-80b5-65f3e33732f6", "descendantuuid": "c0844f33-c3b3-477f-9321-4b342474802a", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '010f9b91-c272-49ee-af70-30a378c35bd8', 'INSERT', '{"uuid": "010f9b91-c272-49ee-af70-30a378c35bd8", "assumed": true, "ascendantuuid": "7377295c-c6d9-4826-b712-ea5df5c3d8d1", "descendantuuid": "638a0990-bb30-434c-80b5-65f3e33732f6", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0de0bb80-9691-4f70-9bdb-53a862399dc1', 'INSERT', '{"uuid": "0de0bb80-9691-4f70-9bdb-53a862399dc1", "roletype": "AGENT", "objectuuid": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4d64baff-ceff-4ad1-9abc-ddcc92cf9c5e', 'INSERT', '{"uuid": "4d64baff-ceff-4ad1-9abc-ddcc92cf9c5e", "assumed": true, "ascendantuuid": "638a0990-bb30-434c-80b5-65f3e33732f6", "descendantuuid": "0de0bb80-9691-4f70-9bdb-53a862399dc1", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '701ea625-3ec6-4ee9-8fbb-fb95ab1137f7', 'INSERT', '{"uuid": "701ea625-3ec6-4ee9-8fbb-fb95ab1137f7", "roletype": "TENANT", "objectuuid": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'c8d78c39-6d4d-48a7-96f8-80fdc50b2059', 'INSERT', '{"op": "SELECT", "uuid": "c8d78c39-6d4d-48a7-96f8-80fdc50b2059", "objectuuid": "97e5ed67-e81c-4c12-b354-45db951901c0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ee7d3e9e-1c6d-4877-8d1f-3c26bf7709d7', 'INSERT', '{"uuid": "ee7d3e9e-1c6d-4877-8d1f-3c26bf7709d7", "assumed": true, "ascendantuuid": "701ea625-3ec6-4ee9-8fbb-fb95ab1137f7", "descendantuuid": "c8d78c39-6d4d-48a7-96f8-80fdc50b2059", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2fa47a46-e76f-441b-a411-cbba090ee3f1', 'INSERT', '{"uuid": "2fa47a46-e76f-441b-a411-cbba090ee3f1", "assumed": true, "ascendantuuid": "82d6e2a0-3c2d-4a8e-8638-4903696927d5", "descendantuuid": "701ea625-3ec6-4ee9-8fbb-fb95ab1137f7", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '38c385ef-16c5-471b-b065-dff65edf12ea', 'INSERT', '{"uuid": "38c385ef-16c5-471b-b065-dff65edf12ea", "assumed": true, "ascendantuuid": "0de0bb80-9691-4f70-9bdb-53a862399dc1", "descendantuuid": "701ea625-3ec6-4ee9-8fbb-fb95ab1137f7", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '274f5f7b-4e82-4e41-82ad-5ff7653d4209', 'INSERT', '{"uuid": "274f5f7b-4e82-4e41-82ad-5ff7653d4209", "assumed": true, "ascendantuuid": "701ea625-3ec6-4ee9-8fbb-fb95ab1137f7", "descendantuuid": "25acc71c-db8f-46e4-950a-8ea76637bb9b", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9f69e8b1-bc6d-4f52-996e-0d71cf466d34', 'INSERT', '{"uuid": "9f69e8b1-bc6d-4f52-996e-0d71cf466d34", "assumed": true, "ascendantuuid": "701ea625-3ec6-4ee9-8fbb-fb95ab1137f7", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9a96f7b8-8ddf-4868-a3d7-174813b2d180', 'INSERT', '{"uuid": "9a96f7b8-8ddf-4868-a3d7-174813b2d180", "assumed": true, "ascendantuuid": "701ea625-3ec6-4ee9-8fbb-fb95ab1137f7", "descendantuuid": "f913c978-1afc-4af0-9bb6-8c21eed95991", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '121f4ca4-da82-47ac-b2fb-96d63c8b897b', 'INSERT', '{"uuid": "121f4ca4-da82-47ac-b2fb-96d63c8b897b", "assumed": true, "ascendantuuid": "da979efd-9d87-4dc5-a839-493e883cf292", "descendantuuid": "0de0bb80-9691-4f70-9bdb-53a862399dc1", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9588e638-90a6-43c6-9a25-4a1293154772', 'INSERT', '{"uuid": "9588e638-90a6-43c6-9a25-4a1293154772", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "7377295c-c6d9-4826-b712-ea5df5c3d8d1", "grantedbyroleuuid": null, "grantedbytriggerof": "97e5ed67-e81c-4c12-b354-45db951901c0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '97e5ed67-e81c-4c12-b354-45db951901c0', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "97e5ed67-e81c-4c12-b354-45db951901c0", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "contactuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', 'INSERT', '{"uuid": "a0e5508f-533d-4f7c-9602-6f23fa85e601", "serialid": 198, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '84802890-6128-4134-8ad7-667491cfcbf7', 'INSERT', '{"uuid": "84802890-6128-4134-8ad7-667491cfcbf7", "roletype": "OWNER", "objectuuid": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '19932b77-d4fd-4664-a0c6-ff8fb707f697', 'INSERT', '{"op": "DELETE", "uuid": "19932b77-d4fd-4664-a0c6-ff8fb707f697", "objectuuid": "a0e5508f-533d-4f7c-9602-6f23fa85e601", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a0896ff6-bd78-44d7-87c0-37f267aef94c', 'INSERT', '{"uuid": "a0896ff6-bd78-44d7-87c0-37f267aef94c", "assumed": true, "ascendantuuid": "84802890-6128-4134-8ad7-667491cfcbf7", "descendantuuid": "19932b77-d4fd-4664-a0c6-ff8fb707f697", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6efe6567-1033-4081-ab3f-304926c7c1d3', 'INSERT', '{"uuid": "6efe6567-1033-4081-ab3f-304926c7c1d3", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "84802890-6128-4134-8ad7-667491cfcbf7", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7d0bd8b9-381a-4502-a4ee-2b91505447a6', 'INSERT', '{"uuid": "7d0bd8b9-381a-4502-a4ee-2b91505447a6", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "84802890-6128-4134-8ad7-667491cfcbf7", "grantedbyroleuuid": "84802890-6128-4134-8ad7-667491cfcbf7", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '63eb26c8-3d39-45f7-b2ef-5038f301bddc', 'INSERT', '{"uuid": "63eb26c8-3d39-45f7-b2ef-5038f301bddc", "roletype": "ADMIN", "objectuuid": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a71abf2a-ab11-4bdd-8591-6977673bdc32', 'INSERT', '{"op": "UPDATE", "uuid": "a71abf2a-ab11-4bdd-8591-6977673bdc32", "objectuuid": "a0e5508f-533d-4f7c-9602-6f23fa85e601", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd0458ece-a35f-487c-aa0f-633de255dc6b', 'INSERT', '{"uuid": "d0458ece-a35f-487c-aa0f-633de255dc6b", "assumed": true, "ascendantuuid": "63eb26c8-3d39-45f7-b2ef-5038f301bddc", "descendantuuid": "a71abf2a-ab11-4bdd-8591-6977673bdc32", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '16ef5805-c3da-46ef-865b-14b723110a2a', 'INSERT', '{"uuid": "16ef5805-c3da-46ef-865b-14b723110a2a", "assumed": true, "ascendantuuid": "84802890-6128-4134-8ad7-667491cfcbf7", "descendantuuid": "63eb26c8-3d39-45f7-b2ef-5038f301bddc", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'fadd73e5-eeca-4f5a-b07d-998d11eb411d', 'INSERT', '{"uuid": "fadd73e5-eeca-4f5a-b07d-998d11eb411d", "roletype": "AGENT", "objectuuid": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b0fd2ed3-afb3-4ea9-9f69-a572d7bb8425', 'INSERT', '{"uuid": "b0fd2ed3-afb3-4ea9-9f69-a572d7bb8425", "assumed": true, "ascendantuuid": "63eb26c8-3d39-45f7-b2ef-5038f301bddc", "descendantuuid": "fadd73e5-eeca-4f5a-b07d-998d11eb411d", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6dc07a2f-428b-4621-9f39-8679a5a5a780', 'INSERT', '{"uuid": "6dc07a2f-428b-4621-9f39-8679a5a5a780", "roletype": "TENANT", "objectuuid": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'e1cfb24e-d3c2-4279-b1b7-0e037766a0c3', 'INSERT', '{"op": "SELECT", "uuid": "e1cfb24e-d3c2-4279-b1b7-0e037766a0c3", "objectuuid": "a0e5508f-533d-4f7c-9602-6f23fa85e601", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '86dc0d91-08b4-47ae-b24e-b185c32deb05', 'INSERT', '{"uuid": "86dc0d91-08b4-47ae-b24e-b185c32deb05", "assumed": true, "ascendantuuid": "6dc07a2f-428b-4621-9f39-8679a5a5a780", "descendantuuid": "e1cfb24e-d3c2-4279-b1b7-0e037766a0c3", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e1e7a27b-2ca3-4ca6-938d-db8a130a56a4', 'INSERT', '{"uuid": "e1e7a27b-2ca3-4ca6-938d-db8a130a56a4", "assumed": true, "ascendantuuid": "82d6e2a0-3c2d-4a8e-8638-4903696927d5", "descendantuuid": "6dc07a2f-428b-4621-9f39-8679a5a5a780", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '54e6fe3c-946f-4ffe-b571-1683b975b1b6', 'INSERT', '{"uuid": "54e6fe3c-946f-4ffe-b571-1683b975b1b6", "assumed": true, "ascendantuuid": "fadd73e5-eeca-4f5a-b07d-998d11eb411d", "descendantuuid": "6dc07a2f-428b-4621-9f39-8679a5a5a780", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e1f74d3b-cd97-492b-baa2-8384d8cdfc97', 'INSERT', '{"uuid": "e1f74d3b-cd97-492b-baa2-8384d8cdfc97", "assumed": true, "ascendantuuid": "6dc07a2f-428b-4621-9f39-8679a5a5a780", "descendantuuid": "25acc71c-db8f-46e4-950a-8ea76637bb9b", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3f31fd85-c31c-4258-8219-2ed6f7a38f29', 'INSERT', '{"uuid": "3f31fd85-c31c-4258-8219-2ed6f7a38f29", "roletype": "TENANT", "objectuuid": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bb575fa2-0a38-404c-a280-bcc403c475f9', 'INSERT', '{"uuid": "bb575fa2-0a38-404c-a280-bcc403c475f9", "assumed": true, "ascendantuuid": "6dc07a2f-428b-4621-9f39-8679a5a5a780", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a808d0d0-8971-4236-ba01-ad2bc3ef73bf', 'INSERT', '{"uuid": "a808d0d0-8971-4236-ba01-ad2bc3ef73bf", "assumed": true, "ascendantuuid": "6dc07a2f-428b-4621-9f39-8679a5a5a780", "descendantuuid": "f913c978-1afc-4af0-9bb6-8c21eed95991", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4d19a35a-143f-4b27-8056-19047cdc8e57', 'INSERT', '{"uuid": "4d19a35a-143f-4b27-8056-19047cdc8e57", "assumed": true, "ascendantuuid": "da979efd-9d87-4dc5-a839-493e883cf292", "descendantuuid": "fadd73e5-eeca-4f5a-b07d-998d11eb411d", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fc5672ca-4c2b-49ef-94a5-853622932577', 'INSERT', '{"uuid": "fc5672ca-4c2b-49ef-94a5-853622932577", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "84802890-6128-4134-8ad7-667491cfcbf7", "grantedbyroleuuid": null, "grantedbytriggerof": "a0e5508f-533d-4f7c-9602-6f23fa85e601"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', 'INSERT', '{"mark": null, "type": "VIP_CONTACT", "uuid": "a0e5508f-533d-4f7c-9602-6f23fa85e601", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "contactuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '2eec1138-d2ad-43de-a105-605d0182a1f8', 'INSERT', '{"uuid": "2eec1138-d2ad-43de-a105-605d0182a1f8", "serialid": 199, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d', 'INSERT', '{"uuid": "0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d", "roletype": "OWNER", "objectuuid": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '3c82a048-8d56-4f34-98c4-a20e193f815e', 'INSERT', '{"op": "DELETE", "uuid": "3c82a048-8d56-4f34-98c4-a20e193f815e", "objectuuid": "2eec1138-d2ad-43de-a105-605d0182a1f8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '55622a21-18b4-4889-a133-b0f9e999a5f8', 'INSERT', '{"uuid": "55622a21-18b4-4889-a133-b0f9e999a5f8", "assumed": true, "ascendantuuid": "0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d", "descendantuuid": "3c82a048-8d56-4f34-98c4-a20e193f815e", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bdec28d3-ff09-4651-a5cc-afb25e7cf5fd', 'INSERT', '{"uuid": "bdec28d3-ff09-4651-a5cc-afb25e7cf5fd", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '348bed58-906a-43d6-9fb5-789d99bc2448', 'INSERT', '{"uuid": "348bed58-906a-43d6-9fb5-789d99bc2448", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d", "grantedbyroleuuid": "0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '47388b74-46ec-45fb-a817-031c959a6c2e', 'INSERT', '{"uuid": "47388b74-46ec-45fb-a817-031c959a6c2e", "roletype": "ADMIN", "objectuuid": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a9ce43ae-4dd7-4ee8-bf8d-d2f3fba4c803', 'INSERT', '{"op": "UPDATE", "uuid": "a9ce43ae-4dd7-4ee8-bf8d-d2f3fba4c803", "objectuuid": "2eec1138-d2ad-43de-a105-605d0182a1f8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '57cb83c6-c9be-4a0d-9345-5c1d93dcbff5', 'INSERT', '{"uuid": "57cb83c6-c9be-4a0d-9345-5c1d93dcbff5", "assumed": true, "ascendantuuid": "47388b74-46ec-45fb-a817-031c959a6c2e", "descendantuuid": "a9ce43ae-4dd7-4ee8-bf8d-d2f3fba4c803", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bcfbb0b7-df3c-41ed-8493-c971aa14c270', 'INSERT', '{"uuid": "bcfbb0b7-df3c-41ed-8493-c971aa14c270", "assumed": true, "ascendantuuid": "0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d", "descendantuuid": "47388b74-46ec-45fb-a817-031c959a6c2e", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'fb0b7122-f782-414f-85b1-c1df876a3441', 'INSERT', '{"uuid": "fb0b7122-f782-414f-85b1-c1df876a3441", "roletype": "AGENT", "objectuuid": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '78f0fa7e-324e-4e4a-9321-5a1c72dae660', 'INSERT', '{"uuid": "78f0fa7e-324e-4e4a-9321-5a1c72dae660", "assumed": true, "ascendantuuid": "47388b74-46ec-45fb-a817-031c959a6c2e", "descendantuuid": "fb0b7122-f782-414f-85b1-c1df876a3441", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0195bb79-457f-42a6-a21f-ffd238256b28', 'INSERT', '{"uuid": "0195bb79-457f-42a6-a21f-ffd238256b28", "roletype": "TENANT", "objectuuid": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '1230adbc-b61a-4ba1-b298-c831c2862e8f', 'INSERT', '{"op": "SELECT", "uuid": "1230adbc-b61a-4ba1-b298-c831c2862e8f", "objectuuid": "2eec1138-d2ad-43de-a105-605d0182a1f8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '86c9a95d-c08a-4375-8be1-1a23d89903c8', 'INSERT', '{"uuid": "86c9a95d-c08a-4375-8be1-1a23d89903c8", "assumed": true, "ascendantuuid": "0195bb79-457f-42a6-a21f-ffd238256b28", "descendantuuid": "1230adbc-b61a-4ba1-b298-c831c2862e8f", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'da788239-e153-4071-b312-c43279d9ac87', 'INSERT', '{"uuid": "da788239-e153-4071-b312-c43279d9ac87", "assumed": true, "ascendantuuid": "82d6e2a0-3c2d-4a8e-8638-4903696927d5", "descendantuuid": "0195bb79-457f-42a6-a21f-ffd238256b28", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b0f97ffe-65a5-4b38-9839-c914830c41f5', 'INSERT', '{"uuid": "b0f97ffe-65a5-4b38-9839-c914830c41f5", "assumed": true, "ascendantuuid": "fb0b7122-f782-414f-85b1-c1df876a3441", "descendantuuid": "0195bb79-457f-42a6-a21f-ffd238256b28", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '53dd57a9-a5c4-4741-b922-e42cc3852f3c', 'INSERT', '{"uuid": "53dd57a9-a5c4-4741-b922-e42cc3852f3c", "assumed": true, "ascendantuuid": "0195bb79-457f-42a6-a21f-ffd238256b28", "descendantuuid": "25acc71c-db8f-46e4-950a-8ea76637bb9b", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b04b8eff-9ecd-41fc-beb0-3b9b92832d87', 'INSERT', '{"uuid": "b04b8eff-9ecd-41fc-beb0-3b9b92832d87", "assumed": true, "ascendantuuid": "0195bb79-457f-42a6-a21f-ffd238256b28", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a77fa2fe-84af-45a4-aaf5-adb8bdc09c61', 'INSERT', '{"uuid": "a77fa2fe-84af-45a4-aaf5-adb8bdc09c61", "assumed": true, "ascendantuuid": "0195bb79-457f-42a6-a21f-ffd238256b28", "descendantuuid": "f913c978-1afc-4af0-9bb6-8c21eed95991", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6d0caee6-f2e7-4f1e-adc4-3405bfa88867', 'INSERT', '{"uuid": "6d0caee6-f2e7-4f1e-adc4-3405bfa88867", "assumed": true, "ascendantuuid": "da979efd-9d87-4dc5-a839-493e883cf292", "descendantuuid": "fb0b7122-f782-414f-85b1-c1df876a3441", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '5feb8ea2-f497-4058-b056-dd96514c70c5', 'INSERT', '{"op": "SELECT", "uuid": "5feb8ea2-f497-4058-b056-dd96514c70c5", "objectuuid": "a84434fd-e879-4208-a8e8-8095e22b72bf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '35606a65-d96a-4b02-a621-af561e25d649', 'INSERT', '{"uuid": "35606a65-d96a-4b02-a621-af561e25d649", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d", "grantedbyroleuuid": null, "grantedbytriggerof": "2eec1138-d2ad-43de-a105-605d0182a1f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '2eec1138-d2ad-43de-a105-605d0182a1f8', 'INSERT', '{"mark": "operations-announce", "type": "SUBSCRIBER", "uuid": "2eec1138-d2ad-43de-a105-605d0182a1f8", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "177ab8a6-2f70-4c2d-b1ba-2153d0803b16", "contactuuid": "16da0560-e134-41c5-aafb-1f7a5b33692b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 'INSERT', '{"uuid": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c", "serialid": 200, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8280b446-c17d-4d5f-aff5-ab391cd0af09', 'INSERT', '{"uuid": "8280b446-c17d-4d5f-aff5-ab391cd0af09", "roletype": "OWNER", "objectuuid": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '8c70ecf7-82ce-4661-8cc5-0fadbcc4151a', 'INSERT', '{"op": "DELETE", "uuid": "8c70ecf7-82ce-4661-8cc5-0fadbcc4151a", "objectuuid": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b8cc05ae-3a13-4346-83c4-9449520e9ddf', 'INSERT', '{"uuid": "b8cc05ae-3a13-4346-83c4-9449520e9ddf", "assumed": true, "ascendantuuid": "8280b446-c17d-4d5f-aff5-ab391cd0af09", "descendantuuid": "8c70ecf7-82ce-4661-8cc5-0fadbcc4151a", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '876fd5a0-0810-43ca-b132-29311d103c67', 'INSERT', '{"uuid": "876fd5a0-0810-43ca-b132-29311d103c67", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "8280b446-c17d-4d5f-aff5-ab391cd0af09", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '94a375c1-4ab4-4f9b-b01b-7487db466f64', 'INSERT', '{"uuid": "94a375c1-4ab4-4f9b-b01b-7487db466f64", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "8280b446-c17d-4d5f-aff5-ab391cd0af09", "grantedbyroleuuid": "8280b446-c17d-4d5f-aff5-ab391cd0af09", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '53e80cc6-7e19-4c55-8c1a-3190844ae734', 'INSERT', '{"uuid": "53e80cc6-7e19-4c55-8c1a-3190844ae734", "roletype": "ADMIN", "objectuuid": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7aceef4b-2faa-48c5-8355-72db528f4822', 'INSERT', '{"op": "UPDATE", "uuid": "7aceef4b-2faa-48c5-8355-72db528f4822", "objectuuid": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bbc7e03b-d588-4412-99ef-f0cdd5559a26', 'INSERT', '{"uuid": "bbc7e03b-d588-4412-99ef-f0cdd5559a26", "assumed": true, "ascendantuuid": "53e80cc6-7e19-4c55-8c1a-3190844ae734", "descendantuuid": "7aceef4b-2faa-48c5-8355-72db528f4822", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '65dbca62-0240-4f81-a4a5-c0d002c6db26', 'INSERT', '{"uuid": "65dbca62-0240-4f81-a4a5-c0d002c6db26", "assumed": true, "ascendantuuid": "8280b446-c17d-4d5f-aff5-ab391cd0af09", "descendantuuid": "53e80cc6-7e19-4c55-8c1a-3190844ae734", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '4e5bc3c9-14f5-468c-8ef6-6bcb25c17948', 'INSERT', '{"uuid": "4e5bc3c9-14f5-468c-8ef6-6bcb25c17948", "roletype": "AGENT", "objectuuid": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '02019ab8-6ec7-4856-98f6-03c99788b6a7', 'INSERT', '{"uuid": "02019ab8-6ec7-4856-98f6-03c99788b6a7", "assumed": true, "ascendantuuid": "53e80cc6-7e19-4c55-8c1a-3190844ae734", "descendantuuid": "4e5bc3c9-14f5-468c-8ef6-6bcb25c17948", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '85e6093a-5013-45c3-a756-66e50d03b6bc', 'INSERT', '{"uuid": "85e6093a-5013-45c3-a756-66e50d03b6bc", "roletype": "TENANT", "objectuuid": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '24fab1b7-ae06-42e0-8746-4754b526994d', 'INSERT', '{"op": "SELECT", "uuid": "24fab1b7-ae06-42e0-8746-4754b526994d", "objectuuid": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '49c0af6d-f0aa-430f-b03c-ecdfade261e4', 'INSERT', '{"uuid": "49c0af6d-f0aa-430f-b03c-ecdfade261e4", "assumed": true, "ascendantuuid": "85e6093a-5013-45c3-a756-66e50d03b6bc", "descendantuuid": "24fab1b7-ae06-42e0-8746-4754b526994d", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '37ed1b92-de74-4f45-8ae0-b641fc11f0cd', 'INSERT', '{"uuid": "37ed1b92-de74-4f45-8ae0-b641fc11f0cd", "assumed": true, "ascendantuuid": "42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b", "descendantuuid": "85e6093a-5013-45c3-a756-66e50d03b6bc", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e827db1b-3a2b-4978-93b2-8cf996dd2487', 'INSERT', '{"uuid": "e827db1b-3a2b-4978-93b2-8cf996dd2487", "assumed": true, "ascendantuuid": "4e5bc3c9-14f5-468c-8ef6-6bcb25c17948", "descendantuuid": "85e6093a-5013-45c3-a756-66e50d03b6bc", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '13868160-f13c-4deb-91f9-d1bf6768d803', 'INSERT', '{"uuid": "13868160-f13c-4deb-91f9-d1bf6768d803", "assumed": true, "ascendantuuid": "85e6093a-5013-45c3-a756-66e50d03b6bc", "descendantuuid": "24f9488b-412f-4314-b160-2897f4dcff1b", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e7a500ad-1822-4607-9c36-c94a64bb8d60', 'INSERT', '{"uuid": "e7a500ad-1822-4607-9c36-c94a64bb8d60", "assumed": true, "ascendantuuid": "85e6093a-5013-45c3-a756-66e50d03b6bc", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '017ebbbd-4aa4-4c64-adf6-89fb2d5ce244', 'INSERT', '{"uuid": "017ebbbd-4aa4-4c64-adf6-89fb2d5ce244", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "4e5bc3c9-14f5-468c-8ef6-6bcb25c17948", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b970a351-ee05-41ec-b995-f75915afedec', 'INSERT', '{"uuid": "b970a351-ee05-41ec-b995-f75915afedec", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "8280b446-c17d-4d5f-aff5-ab391cd0af09", "grantedbyroleuuid": null, "grantedbytriggerof": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 'INSERT', '{"mark": "members-announce", "type": "SUBSCRIBER", "uuid": "7f24b032-3906-4b4c-9e91-4d0fd9f7855c", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "contactuuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'fad03414-b62b-45d4-93fd-51c52149762c', 'INSERT', '{"uuid": "fad03414-b62b-45d4-93fd-51c52149762c", "serialid": 201, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7044a856-3670-42b7-9719-4a8638fff92a', 'INSERT', '{"uuid": "7044a856-3670-42b7-9719-4a8638fff92a", "roletype": "OWNER", "objectuuid": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '13d82035-64c5-4ca9-a85e-988bc4a2eb4d', 'INSERT', '{"op": "DELETE", "uuid": "13d82035-64c5-4ca9-a85e-988bc4a2eb4d", "objectuuid": "fad03414-b62b-45d4-93fd-51c52149762c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5eb167f7-80c1-4c71-9c63-b9d6994ec251', 'INSERT', '{"uuid": "5eb167f7-80c1-4c71-9c63-b9d6994ec251", "roletype": "OWNER", "objectuuid": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '913004d0-3a2a-4c56-b24a-20575950dcb5', 'INSERT', '{"uuid": "913004d0-3a2a-4c56-b24a-20575950dcb5", "assumed": true, "ascendantuuid": "7044a856-3670-42b7-9719-4a8638fff92a", "descendantuuid": "13d82035-64c5-4ca9-a85e-988bc4a2eb4d", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8328274d-3393-48ff-b2ed-0eb3466e8298', 'INSERT', '{"uuid": "8328274d-3393-48ff-b2ed-0eb3466e8298", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "7044a856-3670-42b7-9719-4a8638fff92a", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd784639a-94ce-40b6-968a-295ff498aa7a', 'INSERT', '{"uuid": "d784639a-94ce-40b6-968a-295ff498aa7a", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "7044a856-3670-42b7-9719-4a8638fff92a", "grantedbyroleuuid": "7044a856-3670-42b7-9719-4a8638fff92a", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '20f04373-bbb4-4b9d-a89f-d21272d75d59', 'INSERT', '{"uuid": "20f04373-bbb4-4b9d-a89f-d21272d75d59", "roletype": "ADMIN", "objectuuid": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '62ca73f6-89b1-4113-92ba-a7823aabf31e', 'INSERT', '{"op": "UPDATE", "uuid": "62ca73f6-89b1-4113-92ba-a7823aabf31e", "objectuuid": "fad03414-b62b-45d4-93fd-51c52149762c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a41e82a4-97ef-4bc5-ad86-2840f3c37a11', 'INSERT', '{"uuid": "a41e82a4-97ef-4bc5-ad86-2840f3c37a11", "assumed": true, "ascendantuuid": "20f04373-bbb4-4b9d-a89f-d21272d75d59", "descendantuuid": "62ca73f6-89b1-4113-92ba-a7823aabf31e", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '84b09044-2858-4daf-bcac-bdc446c41aea', 'INSERT', '{"uuid": "84b09044-2858-4daf-bcac-bdc446c41aea", "assumed": true, "ascendantuuid": "7044a856-3670-42b7-9719-4a8638fff92a", "descendantuuid": "20f04373-bbb4-4b9d-a89f-d21272d75d59", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '367f629c-223d-456c-98cf-ddf6600d5858', 'INSERT', '{"uuid": "367f629c-223d-456c-98cf-ddf6600d5858", "roletype": "AGENT", "objectuuid": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '57713630-d87b-4811-9f01-ef736c0b4834', 'INSERT', '{"uuid": "57713630-d87b-4811-9f01-ef736c0b4834", "assumed": true, "ascendantuuid": "20f04373-bbb4-4b9d-a89f-d21272d75d59", "descendantuuid": "367f629c-223d-456c-98cf-ddf6600d5858", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '4c98fcb4-e0b6-4692-86e5-dabb78af17ed', 'INSERT', '{"uuid": "4c98fcb4-e0b6-4692-86e5-dabb78af17ed", "roletype": "TENANT", "objectuuid": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '740e371f-18b1-4e93-8408-2fcc777b7da6', 'INSERT', '{"op": "SELECT", "uuid": "740e371f-18b1-4e93-8408-2fcc777b7da6", "objectuuid": "fad03414-b62b-45d4-93fd-51c52149762c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5b522b03-0f33-43b4-90a0-cdb5d3842343', 'INSERT', '{"uuid": "5b522b03-0f33-43b4-90a0-cdb5d3842343", "assumed": true, "ascendantuuid": "4c98fcb4-e0b6-4692-86e5-dabb78af17ed", "descendantuuid": "740e371f-18b1-4e93-8408-2fcc777b7da6", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e0c22b32-549b-49e3-a838-172fa221eed6', 'INSERT', '{"uuid": "e0c22b32-549b-49e3-a838-172fa221eed6", "assumed": true, "ascendantuuid": "42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b", "descendantuuid": "4c98fcb4-e0b6-4692-86e5-dabb78af17ed", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '484d6f99-3537-4bce-b543-edec82063ebc', 'INSERT', '{"uuid": "484d6f99-3537-4bce-b543-edec82063ebc", "assumed": true, "ascendantuuid": "367f629c-223d-456c-98cf-ddf6600d5858", "descendantuuid": "4c98fcb4-e0b6-4692-86e5-dabb78af17ed", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '04e04fc5-fcec-47b4-b836-cf3210e750f3', 'INSERT', '{"uuid": "04e04fc5-fcec-47b4-b836-cf3210e750f3", "assumed": true, "ascendantuuid": "4c98fcb4-e0b6-4692-86e5-dabb78af17ed", "descendantuuid": "24f9488b-412f-4314-b160-2897f4dcff1b", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7b5cda60-6c9e-46ec-af67-3cf3d4c8d356', 'INSERT', '{"uuid": "7b5cda60-6c9e-46ec-af67-3cf3d4c8d356", "assumed": true, "ascendantuuid": "4c98fcb4-e0b6-4692-86e5-dabb78af17ed", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5bb50ffd-5bb4-4cb5-91eb-99b64004ebee', 'INSERT', '{"uuid": "5bb50ffd-5bb4-4cb5-91eb-99b64004ebee", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "367f629c-223d-456c-98cf-ddf6600d5858", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ef476770-55e8-4eb4-a752-69c38dddc033', 'INSERT', '{"uuid": "ef476770-55e8-4eb4-a752-69c38dddc033", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "7044a856-3670-42b7-9719-4a8638fff92a", "grantedbyroleuuid": null, "grantedbytriggerof": "fad03414-b62b-45d4-93fd-51c52149762c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'fad03414-b62b-45d4-93fd-51c52149762c', 'INSERT', '{"mark": "customers-announce", "type": "SUBSCRIBER", "uuid": "fad03414-b62b-45d4-93fd-51c52149762c", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "contactuuid": "1fc10779-390b-40ff-b641-b6b5e2634ebb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '48a0fa39-0d72-4c0a-800f-afed02865850', 'INSERT', '{"uuid": "48a0fa39-0d72-4c0a-800f-afed02865850", "serialid": 202, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'cdc318a4-f418-4564-a38c-f93562dda048', 'INSERT', '{"uuid": "cdc318a4-f418-4564-a38c-f93562dda048", "roletype": "OWNER", "objectuuid": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2c15e623-a22a-435b-a125-3edbf2a9b5f5', 'INSERT', '{"op": "DELETE", "uuid": "2c15e623-a22a-435b-a125-3edbf2a9b5f5", "objectuuid": "48a0fa39-0d72-4c0a-800f-afed02865850", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '71191ee7-aa74-4044-ace7-7951b0b3c0d2', 'INSERT', '{"uuid": "71191ee7-aa74-4044-ace7-7951b0b3c0d2", "assumed": true, "ascendantuuid": "cdc318a4-f418-4564-a38c-f93562dda048", "descendantuuid": "2c15e623-a22a-435b-a125-3edbf2a9b5f5", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3f0d820d-4d93-49b2-bcc1-7ee5c50e428c', 'INSERT', '{"uuid": "3f0d820d-4d93-49b2-bcc1-7ee5c50e428c", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "cdc318a4-f418-4564-a38c-f93562dda048", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b0cade10-f7f9-4b8b-8f42-0cf53b892b9c', 'INSERT', '{"uuid": "b0cade10-f7f9-4b8b-8f42-0cf53b892b9c", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "cdc318a4-f418-4564-a38c-f93562dda048", "grantedbyroleuuid": "cdc318a4-f418-4564-a38c-f93562dda048", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f2a2d3d5-165d-43c4-91fc-7912f8a96bcc', 'INSERT', '{"uuid": "f2a2d3d5-165d-43c4-91fc-7912f8a96bcc", "roletype": "ADMIN", "objectuuid": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '1c9c5558-dd2c-4293-bfcb-0160e981b6e0', 'INSERT', '{"op": "UPDATE", "uuid": "1c9c5558-dd2c-4293-bfcb-0160e981b6e0", "objectuuid": "48a0fa39-0d72-4c0a-800f-afed02865850", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9eba2405-6cf5-40a7-b426-9e6458318053', 'INSERT', '{"uuid": "9eba2405-6cf5-40a7-b426-9e6458318053", "assumed": true, "ascendantuuid": "f2a2d3d5-165d-43c4-91fc-7912f8a96bcc", "descendantuuid": "1c9c5558-dd2c-4293-bfcb-0160e981b6e0", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '18c5068e-048b-4510-9b18-9fd2fb0d4135', 'INSERT', '{"uuid": "18c5068e-048b-4510-9b18-9fd2fb0d4135", "assumed": true, "ascendantuuid": "cdc318a4-f418-4564-a38c-f93562dda048", "descendantuuid": "f2a2d3d5-165d-43c4-91fc-7912f8a96bcc", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ced737cc-1da8-4b12-808a-13e36b8bc37e', 'INSERT', '{"uuid": "ced737cc-1da8-4b12-808a-13e36b8bc37e", "roletype": "AGENT", "objectuuid": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e9079c64-7557-4ae1-a866-4a96e5e49ba1', 'INSERT', '{"uuid": "e9079c64-7557-4ae1-a866-4a96e5e49ba1", "assumed": true, "ascendantuuid": "f2a2d3d5-165d-43c4-91fc-7912f8a96bcc", "descendantuuid": "ced737cc-1da8-4b12-808a-13e36b8bc37e", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '79ef402f-0c51-4ae0-a0dd-f0a09505a273', 'INSERT', '{"uuid": "79ef402f-0c51-4ae0-a0dd-f0a09505a273", "roletype": "TENANT", "objectuuid": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '19241a87-0b31-4156-a479-cdb61cafaa66', 'INSERT', '{"op": "SELECT", "uuid": "19241a87-0b31-4156-a479-cdb61cafaa66", "objectuuid": "48a0fa39-0d72-4c0a-800f-afed02865850", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c21b9a49-8c79-4a8d-95f4-032db314e885', 'INSERT', '{"uuid": "c21b9a49-8c79-4a8d-95f4-032db314e885", "assumed": true, "ascendantuuid": "79ef402f-0c51-4ae0-a0dd-f0a09505a273", "descendantuuid": "19241a87-0b31-4156-a479-cdb61cafaa66", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '828e4453-5b83-4a3c-8e49-29fc212ee8ab', 'INSERT', '{"uuid": "828e4453-5b83-4a3c-8e49-29fc212ee8ab", "assumed": true, "ascendantuuid": "f9d5ba94-1514-4400-88af-7b7d3798f473", "descendantuuid": "79ef402f-0c51-4ae0-a0dd-f0a09505a273", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '12864cb0-ed29-4cbf-a00b-4716e6fcff00', 'INSERT', '{"uuid": "12864cb0-ed29-4cbf-a00b-4716e6fcff00", "assumed": true, "ascendantuuid": "ced737cc-1da8-4b12-808a-13e36b8bc37e", "descendantuuid": "79ef402f-0c51-4ae0-a0dd-f0a09505a273", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a52c39d7-3d61-4707-8d2c-b85e571c0c7a', 'INSERT', '{"uuid": "a52c39d7-3d61-4707-8d2c-b85e571c0c7a", "assumed": true, "ascendantuuid": "79ef402f-0c51-4ae0-a0dd-f0a09505a273", "descendantuuid": "20926d99-1f1f-497a-8e13-ce3cb4b1eb73", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'acc43637-f18c-46a9-9cbe-23c45b18ff7b', 'INSERT', '{"uuid": "acc43637-f18c-46a9-9cbe-23c45b18ff7b", "assumed": true, "ascendantuuid": "79ef402f-0c51-4ae0-a0dd-f0a09505a273", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '734b541b-498d-4e39-a136-8be5802563e1', 'INSERT', '{"uuid": "734b541b-498d-4e39-a136-8be5802563e1", "assumed": true, "ascendantuuid": "79ef402f-0c51-4ae0-a0dd-f0a09505a273", "descendantuuid": "ecdbb376-51c5-4de3-82f5-c5e73c0f43c5", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7321df72-9db0-4594-88ff-cc624280efc0', 'INSERT', '{"uuid": "7321df72-9db0-4594-88ff-cc624280efc0", "assumed": true, "ascendantuuid": "b28425cc-f859-43db-b3f5-64b5fb6a668b", "descendantuuid": "ced737cc-1da8-4b12-808a-13e36b8bc37e", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'aa207d78-61d8-4e6a-97e2-054f738a56a4', 'INSERT', '{"uuid": "aa207d78-61d8-4e6a-97e2-054f738a56a4", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "cdc318a4-f418-4564-a38c-f93562dda048", "grantedbyroleuuid": null, "grantedbytriggerof": "48a0fa39-0d72-4c0a-800f-afed02865850"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '48a0fa39-0d72-4c0a-800f-afed02865850', 'INSERT', '{"mark": null, "type": "VIP_CONTACT", "uuid": "48a0fa39-0d72-4c0a-800f-afed02865850", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "c8050a1b-0d28-4aa7-ac77-958c99152cd1", "contactuuid": "caac18bd-9277-47ac-99bb-368e2d64dac0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'a84434fd-e879-4208-a8e8-8095e22b72bf', 'INSERT', '{"uuid": "a84434fd-e879-4208-a8e8-8095e22b72bf", "serialid": 203, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0b67cb5e-3570-4ca7-945b-94f3390bec81', 'INSERT', '{"uuid": "0b67cb5e-3570-4ca7-945b-94f3390bec81", "roletype": "OWNER", "objectuuid": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '22b95a69-d861-4d90-bfef-a9c3f4ba5d52', 'INSERT', '{"op": "DELETE", "uuid": "22b95a69-d861-4d90-bfef-a9c3f4ba5d52", "objectuuid": "a84434fd-e879-4208-a8e8-8095e22b72bf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e419060c-9fbe-40a1-bece-ed26c86303f3', 'INSERT', '{"uuid": "e419060c-9fbe-40a1-bece-ed26c86303f3", "assumed": true, "ascendantuuid": "0b67cb5e-3570-4ca7-945b-94f3390bec81", "descendantuuid": "22b95a69-d861-4d90-bfef-a9c3f4ba5d52", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4fb4d523-f9fe-4577-a320-8de8b7018354', 'INSERT', '{"uuid": "4fb4d523-f9fe-4577-a320-8de8b7018354", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0b67cb5e-3570-4ca7-945b-94f3390bec81", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '58c42133-e753-42ec-9179-1343126f6a88', 'INSERT', '{"uuid": "58c42133-e753-42ec-9179-1343126f6a88", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0b67cb5e-3570-4ca7-945b-94f3390bec81", "grantedbyroleuuid": "0b67cb5e-3570-4ca7-945b-94f3390bec81", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5306f8ae-55c4-460d-a133-45f8eae30eb6', 'INSERT', '{"uuid": "5306f8ae-55c4-460d-a133-45f8eae30eb6", "roletype": "ADMIN", "objectuuid": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a1ad0f25-f3ab-4bfa-8e4d-674d7ddc3ae7', 'INSERT', '{"op": "UPDATE", "uuid": "a1ad0f25-f3ab-4bfa-8e4d-674d7ddc3ae7", "objectuuid": "a84434fd-e879-4208-a8e8-8095e22b72bf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'df06f05b-67e5-4a3a-bf44-25bae283b342', 'INSERT', '{"uuid": "df06f05b-67e5-4a3a-bf44-25bae283b342", "assumed": true, "ascendantuuid": "5306f8ae-55c4-460d-a133-45f8eae30eb6", "descendantuuid": "a1ad0f25-f3ab-4bfa-8e4d-674d7ddc3ae7", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8a317992-4d7b-4f96-a216-b3d76a67b058', 'INSERT', '{"uuid": "8a317992-4d7b-4f96-a216-b3d76a67b058", "assumed": true, "ascendantuuid": "0b67cb5e-3570-4ca7-945b-94f3390bec81", "descendantuuid": "5306f8ae-55c4-460d-a133-45f8eae30eb6", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '39500fd6-4dcf-4c33-9766-c9b4071e4754', 'INSERT', '{"uuid": "39500fd6-4dcf-4c33-9766-c9b4071e4754", "roletype": "AGENT", "objectuuid": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '62f04d9c-09d7-4a80-a932-aba12d4a9258', 'INSERT', '{"uuid": "62f04d9c-09d7-4a80-a932-aba12d4a9258", "assumed": true, "ascendantuuid": "5306f8ae-55c4-460d-a133-45f8eae30eb6", "descendantuuid": "39500fd6-4dcf-4c33-9766-c9b4071e4754", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b22cccac-454e-46d4-b440-f238db43371b', 'INSERT', '{"uuid": "b22cccac-454e-46d4-b440-f238db43371b", "assumed": true, "ascendantuuid": "3f31fd85-c31c-4258-8219-2ed6f7a38f29", "descendantuuid": "5feb8ea2-f497-4058-b056-dd96514c70c5", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c700dd59-b6cf-4d50-8fa2-d7bd1582cf98', 'INSERT', '{"uuid": "c700dd59-b6cf-4d50-8fa2-d7bd1582cf98", "assumed": true, "ascendantuuid": "57ee73c6-769e-461e-9cea-7bfe56970bf7", "descendantuuid": "3f31fd85-c31c-4258-8219-2ed6f7a38f29", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '39514d32-b8b2-4191-8e3d-c339263c630f', 'INSERT', '{"uuid": "39514d32-b8b2-4191-8e3d-c339263c630f", "assumed": true, "ascendantuuid": "39500fd6-4dcf-4c33-9766-c9b4071e4754", "descendantuuid": "3f31fd85-c31c-4258-8219-2ed6f7a38f29", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b5739fe2-cbc1-45a7-957c-1da1866ef72f', 'INSERT', '{"uuid": "b5739fe2-cbc1-45a7-957c-1da1866ef72f", "assumed": true, "ascendantuuid": "3f31fd85-c31c-4258-8219-2ed6f7a38f29", "descendantuuid": "e65ad361-79d6-46a3-a7c7-a18048b7237a", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8d1f8a60-937f-44c1-bb27-ec4b42159618', 'INSERT', '{"uuid": "8d1f8a60-937f-44c1-bb27-ec4b42159618", "assumed": true, "ascendantuuid": "3f31fd85-c31c-4258-8219-2ed6f7a38f29", "descendantuuid": "ea1789f5-11fe-4ec3-8d12-2623ba592c7f", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9270ca1c-1b92-45a2-ae06-6b81a4fd9d49', 'INSERT', '{"uuid": "9270ca1c-1b92-45a2-ae06-6b81a4fd9d49", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "39500fd6-4dcf-4c33-9766-c9b4071e4754", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '51aca5fc-851d-42e4-9d27-d41280eca08a', 'INSERT', '{"uuid": "51aca5fc-851d-42e4-9d27-d41280eca08a", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "0b67cb5e-3570-4ca7-945b-94f3390bec81", "grantedbyroleuuid": null, "grantedbytriggerof": "a84434fd-e879-4208-a8e8-8095e22b72bf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'a84434fd-e879-4208-a8e8-8095e22b72bf', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "a84434fd-e879-4208-a8e8-8095e22b72bf", "version": 0, "anchoruuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "holderuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "contactuuid": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '93d87d13-efdb-4d31-83e6-3b13db983c12', 'INSERT', '{"uuid": "93d87d13-efdb-4d31-83e6-3b13db983c12", "serialid": 204, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3461faee-7a67-45d3-af18-7de8686c381d', 'INSERT', '{"uuid": "3461faee-7a67-45d3-af18-7de8686c381d", "roletype": "OWNER", "objectuuid": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '164e7fa0-ccac-4331-be5a-dc965b1c31d6', 'INSERT', '{"op": "DELETE", "uuid": "164e7fa0-ccac-4331-be5a-dc965b1c31d6", "objectuuid": "93d87d13-efdb-4d31-83e6-3b13db983c12", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e1f676e2-21fd-4689-88c8-800518d22080', 'INSERT', '{"uuid": "e1f676e2-21fd-4689-88c8-800518d22080", "assumed": true, "ascendantuuid": "3461faee-7a67-45d3-af18-7de8686c381d", "descendantuuid": "164e7fa0-ccac-4331-be5a-dc965b1c31d6", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd16fb908-a8c8-4be1-b52e-e7e39c12ea07', 'INSERT', '{"uuid": "d16fb908-a8c8-4be1-b52e-e7e39c12ea07", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "3461faee-7a67-45d3-af18-7de8686c381d", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f22de112-02a1-48f0-8a9c-0ff8dd22c8d0', 'INSERT', '{"uuid": "f22de112-02a1-48f0-8a9c-0ff8dd22c8d0", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "3461faee-7a67-45d3-af18-7de8686c381d", "grantedbyroleuuid": "3461faee-7a67-45d3-af18-7de8686c381d", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8', 'INSERT', '{"uuid": "1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8", "roletype": "ADMIN", "objectuuid": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'dbee33c8-80d8-40c9-9d16-af5c99aea9ae', 'INSERT', '{"op": "UPDATE", "uuid": "dbee33c8-80d8-40c9-9d16-af5c99aea9ae", "objectuuid": "93d87d13-efdb-4d31-83e6-3b13db983c12", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '780fd786-74cf-4b97-81b9-ac4b909fef18', 'INSERT', '{"uuid": "780fd786-74cf-4b97-81b9-ac4b909fef18", "assumed": true, "ascendantuuid": "1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8", "descendantuuid": "dbee33c8-80d8-40c9-9d16-af5c99aea9ae", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '85faf70c-058e-4612-b290-4141325917a5', 'INSERT', '{"uuid": "85faf70c-058e-4612-b290-4141325917a5", "assumed": true, "ascendantuuid": "3461faee-7a67-45d3-af18-7de8686c381d", "descendantuuid": "1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3d17a863-17af-48a5-a6aa-abc815209773', 'INSERT', '{"uuid": "3d17a863-17af-48a5-a6aa-abc815209773", "roletype": "AGENT", "objectuuid": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1a293898-9590-4232-99d0-c839bac38a4b', 'INSERT', '{"uuid": "1a293898-9590-4232-99d0-c839bac38a4b", "assumed": true, "ascendantuuid": "1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8", "descendantuuid": "3d17a863-17af-48a5-a6aa-abc815209773", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0447c01c-fae5-4c80-a59f-a9f330321b9c', 'INSERT', '{"uuid": "0447c01c-fae5-4c80-a59f-a9f330321b9c", "roletype": "TENANT", "objectuuid": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '1b4208a5-e7ba-460e-922f-a9fb5c7e79e7', 'INSERT', '{"op": "SELECT", "uuid": "1b4208a5-e7ba-460e-922f-a9fb5c7e79e7", "objectuuid": "93d87d13-efdb-4d31-83e6-3b13db983c12", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '974163d5-e3e7-4703-9b47-768296eb4c57', 'INSERT', '{"uuid": "974163d5-e3e7-4703-9b47-768296eb4c57", "assumed": true, "ascendantuuid": "0447c01c-fae5-4c80-a59f-a9f330321b9c", "descendantuuid": "1b4208a5-e7ba-460e-922f-a9fb5c7e79e7", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6638829e-b4a4-4148-bed1-1df9bd27bc83', 'INSERT', '{"uuid": "6638829e-b4a4-4148-bed1-1df9bd27bc83", "assumed": true, "ascendantuuid": "57ee73c6-769e-461e-9cea-7bfe56970bf7", "descendantuuid": "0447c01c-fae5-4c80-a59f-a9f330321b9c", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '21c8f5cf-38b2-4fb7-a4fd-8b6893a55394', 'INSERT', '{"uuid": "21c8f5cf-38b2-4fb7-a4fd-8b6893a55394", "assumed": true, "ascendantuuid": "3d17a863-17af-48a5-a6aa-abc815209773", "descendantuuid": "0447c01c-fae5-4c80-a59f-a9f330321b9c", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cc6788b2-65f0-406e-a3dd-3b58eb3ebeb7', 'INSERT', '{"uuid": "cc6788b2-65f0-406e-a3dd-3b58eb3ebeb7", "assumed": true, "ascendantuuid": "0447c01c-fae5-4c80-a59f-a9f330321b9c", "descendantuuid": "e65ad361-79d6-46a3-a7c7-a18048b7237a", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '52109c52-b432-4d0c-8aca-dd0a99ca35eb', 'INSERT', '{"uuid": "52109c52-b432-4d0c-8aca-dd0a99ca35eb", "assumed": true, "ascendantuuid": "0447c01c-fae5-4c80-a59f-a9f330321b9c", "descendantuuid": "ea1789f5-11fe-4ec3-8d12-2623ba592c7f", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5fbff0ee-6d38-412a-bafe-d2017b2155b3', 'INSERT', '{"uuid": "5fbff0ee-6d38-412a-bafe-d2017b2155b3", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "3d17a863-17af-48a5-a6aa-abc815209773", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dde7f3bd-0a6b-4da2-8db7-92d54b443c7e', 'INSERT', '{"uuid": "dde7f3bd-0a6b-4da2-8db7-92d54b443c7e", "assumed": true, "ascendantuuid": "6ef557f3-0b1e-41e9-bde7-8abea686f965", "descendantuuid": "3461faee-7a67-45d3-af18-7de8686c381d", "grantedbyroleuuid": null, "grantedbytriggerof": "93d87d13-efdb-4d31-83e6-3b13db983c12"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '93d87d13-efdb-4d31-83e6-3b13db983c12', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "93d87d13-efdb-4d31-83e6-3b13db983c12", "version": 0, "anchoruuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "holderuuid": "89bca3fd-d7b2-46f5-821a-64c5566d03f1", "contactuuid": "eead6995-dd54-475f-8194-74445c421305"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'bad214a0-5220-4433-8714-52e4c736585a', 'INSERT', '{"uuid": "bad214a0-5220-4433-8714-52e4c736585a", "serialid": 205, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'fd1b146c-609a-486f-afe5-c87430e1be15', 'INSERT', '{"uuid": "fd1b146c-609a-486f-afe5-c87430e1be15", "roletype": "OWNER", "objectuuid": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'cebd9ecc-f841-4d44-a3fe-3c82827f2918', 'INSERT', '{"op": "DELETE", "uuid": "cebd9ecc-f841-4d44-a3fe-3c82827f2918", "objectuuid": "bad214a0-5220-4433-8714-52e4c736585a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b62e2ba3-fd5e-41dd-b36e-a4df8d27cc84', 'INSERT', '{"uuid": "b62e2ba3-fd5e-41dd-b36e-a4df8d27cc84", "assumed": true, "ascendantuuid": "fd1b146c-609a-486f-afe5-c87430e1be15", "descendantuuid": "cebd9ecc-f841-4d44-a3fe-3c82827f2918", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '342a26e0-01be-4477-8505-bb177f76f81d', 'INSERT', '{"uuid": "342a26e0-01be-4477-8505-bb177f76f81d", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "fd1b146c-609a-486f-afe5-c87430e1be15", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ea164af9-46a4-4691-bf45-39c089a3907f', 'INSERT', '{"uuid": "ea164af9-46a4-4691-bf45-39c089a3907f", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "fd1b146c-609a-486f-afe5-c87430e1be15", "grantedbyroleuuid": "fd1b146c-609a-486f-afe5-c87430e1be15", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd09b10a6-f74d-4e87-898d-851cfdb9dffb', 'INSERT', '{"uuid": "d09b10a6-f74d-4e87-898d-851cfdb9dffb", "roletype": "ADMIN", "objectuuid": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'ac3ee728-8957-4b2e-91d7-9f7a0e543931', 'INSERT', '{"op": "UPDATE", "uuid": "ac3ee728-8957-4b2e-91d7-9f7a0e543931", "objectuuid": "bad214a0-5220-4433-8714-52e4c736585a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '682f1b6c-bbe9-4229-bd9a-1782cd6296d6', 'INSERT', '{"uuid": "682f1b6c-bbe9-4229-bd9a-1782cd6296d6", "assumed": true, "ascendantuuid": "d09b10a6-f74d-4e87-898d-851cfdb9dffb", "descendantuuid": "ac3ee728-8957-4b2e-91d7-9f7a0e543931", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1d7a2de3-3754-4b1d-a763-d5a0d920dedb', 'INSERT', '{"uuid": "1d7a2de3-3754-4b1d-a763-d5a0d920dedb", "assumed": true, "ascendantuuid": "fd1b146c-609a-486f-afe5-c87430e1be15", "descendantuuid": "d09b10a6-f74d-4e87-898d-851cfdb9dffb", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3a1e0eb9-bf91-4bda-b804-8707d753644e', 'INSERT', '{"uuid": "3a1e0eb9-bf91-4bda-b804-8707d753644e", "roletype": "AGENT", "objectuuid": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4fe44a04-1c1b-4046-91b2-54f0c6560020', 'INSERT', '{"uuid": "4fe44a04-1c1b-4046-91b2-54f0c6560020", "assumed": true, "ascendantuuid": "d09b10a6-f74d-4e87-898d-851cfdb9dffb", "descendantuuid": "3a1e0eb9-bf91-4bda-b804-8707d753644e", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3', 'INSERT', '{"uuid": "c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3", "roletype": "TENANT", "objectuuid": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '30b91518-31ef-4b3f-a539-c1f7566e0c77', 'INSERT', '{"op": "SELECT", "uuid": "30b91518-31ef-4b3f-a539-c1f7566e0c77", "objectuuid": "bad214a0-5220-4433-8714-52e4c736585a", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '420dd5f5-07b6-4e88-803d-23281381b7b9', 'INSERT', '{"uuid": "420dd5f5-07b6-4e88-803d-23281381b7b9", "assumed": true, "ascendantuuid": "c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3", "descendantuuid": "30b91518-31ef-4b3f-a539-c1f7566e0c77", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '97796f5f-c386-44ab-b15a-8be0b6b8ce89', 'INSERT', '{"uuid": "97796f5f-c386-44ab-b15a-8be0b6b8ce89", "assumed": true, "ascendantuuid": "d206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e", "descendantuuid": "c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fddf76f7-6c95-4af7-841f-fe2ce0200617', 'INSERT', '{"uuid": "fddf76f7-6c95-4af7-841f-fe2ce0200617", "assumed": true, "ascendantuuid": "3a1e0eb9-bf91-4bda-b804-8707d753644e", "descendantuuid": "c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'df62b4b8-bc0d-4a5b-9285-7c489e5a7e13', 'INSERT', '{"uuid": "df62b4b8-bc0d-4a5b-9285-7c489e5a7e13", "assumed": true, "ascendantuuid": "c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3", "descendantuuid": "6c787015-c910-455d-8b2c-c3ae7bece7e7", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2eaa6dc6-2561-4bc8-b138-16b73f9df2a5', 'INSERT', '{"uuid": "2eaa6dc6-2561-4bc8-b138-16b73f9df2a5", "assumed": true, "ascendantuuid": "c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3", "descendantuuid": "e668cce4-9f01-4c71-b28c-79859e02971b", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '36a8ac7a-fff5-4bf0-b3c6-99fbc1901d48', 'INSERT', '{"uuid": "36a8ac7a-fff5-4bf0-b3c6-99fbc1901d48", "assumed": true, "ascendantuuid": "c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3", "descendantuuid": "4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4276e2db-6b2f-413b-a29e-6e8a82b16ba9', 'INSERT', '{"uuid": "4276e2db-6b2f-413b-a29e-6e8a82b16ba9", "assumed": true, "ascendantuuid": "9e5fa680-2abc-4f25-bb22-bd2fe04fd860", "descendantuuid": "3a1e0eb9-bf91-4bda-b804-8707d753644e", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '769e962a-57dc-45ab-92b3-68c217f8b495', 'INSERT', '{"uuid": "769e962a-57dc-45ab-92b3-68c217f8b495", "assumed": true, "ascendantuuid": "b4224d96-af95-4008-9a96-9ae04b44913f", "descendantuuid": "fd1b146c-609a-486f-afe5-c87430e1be15", "grantedbyroleuuid": null, "grantedbytriggerof": "bad214a0-5220-4433-8714-52e4c736585a"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '3a64d35c-f155-4420-a87f-ddd771f7e500', 'INSERT', '{"op": "DELETE", "uuid": "3a64d35c-f155-4420-a87f-ddd771f7e500", "objectuuid": "f7ddff21-e58a-426b-a693-46a2b45c9d4e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'bad214a0-5220-4433-8714-52e4c736585a', 'INSERT', '{"mark": "operations-announce", "type": "SUBSCRIBER", "uuid": "bad214a0-5220-4433-8714-52e4c736585a", "version": 0, "anchoruuid": "ff030436-d19e-4606-9d48-7e192eaf469f", "holderuuid": "2fd1ba30-936a-41a8-8fbe-e93be547f44b", "contactuuid": "4b68de11-a658-44bb-be49-ad592e73e3d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '5add96a4-6fff-4fe2-8628-669d72252417', 'INSERT', '{"uuid": "5add96a4-6fff-4fe2-8628-669d72252417", "serialid": 206, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8e9971fb-270c-4897-ae63-50f457d9d0d5', 'INSERT', '{"uuid": "8e9971fb-270c-4897-ae63-50f457d9d0d5", "roletype": "OWNER", "objectuuid": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'fa9a7713-93f2-46c6-b3de-9d6e42bce983', 'INSERT', '{"op": "DELETE", "uuid": "fa9a7713-93f2-46c6-b3de-9d6e42bce983", "objectuuid": "5add96a4-6fff-4fe2-8628-669d72252417", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4d1f8cfe-9901-4ba6-a66f-3a859d8c3669', 'INSERT', '{"uuid": "4d1f8cfe-9901-4ba6-a66f-3a859d8c3669", "assumed": true, "ascendantuuid": "8e9971fb-270c-4897-ae63-50f457d9d0d5", "descendantuuid": "fa9a7713-93f2-46c6-b3de-9d6e42bce983", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'afd8494c-f583-4ba5-8b40-e67b5f56bc03', 'INSERT', '{"uuid": "afd8494c-f583-4ba5-8b40-e67b5f56bc03", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "8e9971fb-270c-4897-ae63-50f457d9d0d5", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '654992e9-98eb-4f59-a8dc-37068c28dcae', 'INSERT', '{"uuid": "654992e9-98eb-4f59-a8dc-37068c28dcae", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "8e9971fb-270c-4897-ae63-50f457d9d0d5", "grantedbyroleuuid": "8e9971fb-270c-4897-ae63-50f457d9d0d5", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'a352a7f2-6caf-48bd-8f2e-90a1b3d248fd', 'INSERT', '{"uuid": "a352a7f2-6caf-48bd-8f2e-90a1b3d248fd", "roletype": "ADMIN", "objectuuid": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '052b4092-a5bf-47f3-8ba2-0734ec9129d4', 'INSERT', '{"op": "UPDATE", "uuid": "052b4092-a5bf-47f3-8ba2-0734ec9129d4", "objectuuid": "5add96a4-6fff-4fe2-8628-669d72252417", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd23139da-5dba-4b5c-8471-596a168c8fe4', 'INSERT', '{"uuid": "d23139da-5dba-4b5c-8471-596a168c8fe4", "assumed": true, "ascendantuuid": "a352a7f2-6caf-48bd-8f2e-90a1b3d248fd", "descendantuuid": "052b4092-a5bf-47f3-8ba2-0734ec9129d4", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '984f748c-bef5-4ffd-a9f3-1af2e470d8ff', 'INSERT', '{"uuid": "984f748c-bef5-4ffd-a9f3-1af2e470d8ff", "assumed": true, "ascendantuuid": "8e9971fb-270c-4897-ae63-50f457d9d0d5", "descendantuuid": "a352a7f2-6caf-48bd-8f2e-90a1b3d248fd", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7bdb3dd3-ed56-43ff-8a99-a49101ba7d48', 'INSERT', '{"uuid": "7bdb3dd3-ed56-43ff-8a99-a49101ba7d48", "roletype": "AGENT", "objectuuid": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e2247b4c-a6cf-4cbf-bdf8-a64aeaf6933a', 'INSERT', '{"uuid": "e2247b4c-a6cf-4cbf-bdf8-a64aeaf6933a", "assumed": true, "ascendantuuid": "a352a7f2-6caf-48bd-8f2e-90a1b3d248fd", "descendantuuid": "7bdb3dd3-ed56-43ff-8a99-a49101ba7d48", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0caafe33-8257-4550-9e75-c8a828d5dbc6', 'INSERT', '{"uuid": "0caafe33-8257-4550-9e75-c8a828d5dbc6", "roletype": "TENANT", "objectuuid": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '4c75b994-e714-4781-a51d-6f582ae07f6e', 'INSERT', '{"op": "SELECT", "uuid": "4c75b994-e714-4781-a51d-6f582ae07f6e", "objectuuid": "5add96a4-6fff-4fe2-8628-669d72252417", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '36b6b1e1-03f8-45e0-b810-7f506aa69c67', 'INSERT', '{"uuid": "36b6b1e1-03f8-45e0-b810-7f506aa69c67", "assumed": true, "ascendantuuid": "0caafe33-8257-4550-9e75-c8a828d5dbc6", "descendantuuid": "4c75b994-e714-4781-a51d-6f582ae07f6e", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b7427b8f-db70-496a-b5a4-ce1e704c8246', 'INSERT', '{"uuid": "b7427b8f-db70-496a-b5a4-ce1e704c8246", "assumed": true, "ascendantuuid": "93ec1b20-de2b-4af1-924f-047a7afa0276", "descendantuuid": "0caafe33-8257-4550-9e75-c8a828d5dbc6", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b9f6bf0a-34e9-4783-ac50-a2e294cd2722', 'INSERT', '{"uuid": "b9f6bf0a-34e9-4783-ac50-a2e294cd2722", "assumed": true, "ascendantuuid": "7bdb3dd3-ed56-43ff-8a99-a49101ba7d48", "descendantuuid": "0caafe33-8257-4550-9e75-c8a828d5dbc6", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3f430afe-ae59-4e28-8a56-7bd911f9eac7', 'INSERT', '{"uuid": "3f430afe-ae59-4e28-8a56-7bd911f9eac7", "assumed": true, "ascendantuuid": "0caafe33-8257-4550-9e75-c8a828d5dbc6", "descendantuuid": "4330591d-61d5-4435-827a-c71b8328a700", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '08e80826-b815-426c-b59c-60e089174ff7', 'INSERT', '{"uuid": "08e80826-b815-426c-b59c-60e089174ff7", "assumed": true, "ascendantuuid": "0caafe33-8257-4550-9e75-c8a828d5dbc6", "descendantuuid": "a7ff4f1c-7c33-43e0-b264-37339141f7f9", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '856b0f90-83dc-4f65-b862-b9e69c5d4608', 'INSERT', '{"uuid": "856b0f90-83dc-4f65-b862-b9e69c5d4608", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "7bdb3dd3-ed56-43ff-8a99-a49101ba7d48", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dc3c5bd9-f54c-48c2-b912-4750f16d7485', 'INSERT', '{"uuid": "dc3c5bd9-f54c-48c2-b912-4750f16d7485", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "8e9971fb-270c-4897-ae63-50f457d9d0d5", "grantedbyroleuuid": null, "grantedbytriggerof": "5add96a4-6fff-4fe2-8628-669d72252417"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '5add96a4-6fff-4fe2-8628-669d72252417', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "5add96a4-6fff-4fe2-8628-669d72252417", "version": 0, "anchoruuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "holderuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "contactuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '2185083d-3134-4b30-9dcb-674058feaac2', 'INSERT', '{"uuid": "2185083d-3134-4b30-9dcb-674058feaac2", "serialid": 207, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7f74a25b-753a-4534-bd83-0db07cc6df2f', 'INSERT', '{"uuid": "7f74a25b-753a-4534-bd83-0db07cc6df2f", "roletype": "OWNER", "objectuuid": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '05a6b2b6-58dc-4310-bcf1-d923168e2070', 'INSERT', '{"op": "DELETE", "uuid": "05a6b2b6-58dc-4310-bcf1-d923168e2070", "objectuuid": "2185083d-3134-4b30-9dcb-674058feaac2", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dfcfbf97-4d74-47e5-8ff6-58d4d15c1961', 'INSERT', '{"uuid": "dfcfbf97-4d74-47e5-8ff6-58d4d15c1961", "assumed": true, "ascendantuuid": "7f74a25b-753a-4534-bd83-0db07cc6df2f", "descendantuuid": "05a6b2b6-58dc-4310-bcf1-d923168e2070", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '596f965f-b224-495b-9f5f-5150af69979f', 'INSERT', '{"op": "SELECT", "uuid": "596f965f-b224-495b-9f5f-5150af69979f", "objectuuid": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a4a3c7b3-c797-4956-8f17-b8234b3a8839', 'INSERT', '{"uuid": "a4a3c7b3-c797-4956-8f17-b8234b3a8839", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "7f74a25b-753a-4534-bd83-0db07cc6df2f", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5018f5b5-e839-4c10-8272-5784e4c709fa', 'INSERT', '{"uuid": "5018f5b5-e839-4c10-8272-5784e4c709fa", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "7f74a25b-753a-4534-bd83-0db07cc6df2f", "grantedbyroleuuid": "7f74a25b-753a-4534-bd83-0db07cc6df2f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '64229d80-11aa-4910-9e0c-a211d9a5ca95', 'INSERT', '{"uuid": "64229d80-11aa-4910-9e0c-a211d9a5ca95", "roletype": "ADMIN", "objectuuid": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '9ddb3c98-f345-4f59-b067-7673d0e06673', 'INSERT', '{"op": "UPDATE", "uuid": "9ddb3c98-f345-4f59-b067-7673d0e06673", "objectuuid": "2185083d-3134-4b30-9dcb-674058feaac2", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '64348744-47d9-4c5c-b851-a6eb71c1baad', 'INSERT', '{"uuid": "64348744-47d9-4c5c-b851-a6eb71c1baad", "assumed": true, "ascendantuuid": "64229d80-11aa-4910-9e0c-a211d9a5ca95", "descendantuuid": "9ddb3c98-f345-4f59-b067-7673d0e06673", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1e4e4775-1354-4816-8818-b11d5abdb247', 'INSERT', '{"uuid": "1e4e4775-1354-4816-8818-b11d5abdb247", "assumed": true, "ascendantuuid": "7f74a25b-753a-4534-bd83-0db07cc6df2f", "descendantuuid": "64229d80-11aa-4910-9e0c-a211d9a5ca95", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '98f81765-6d0e-4cb5-ab49-da912f668f5d', 'INSERT', '{"uuid": "98f81765-6d0e-4cb5-ab49-da912f668f5d", "roletype": "AGENT", "objectuuid": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cff9d5f6-722e-4d0b-9631-53cb1078c8ab', 'INSERT', '{"uuid": "cff9d5f6-722e-4d0b-9631-53cb1078c8ab", "assumed": true, "ascendantuuid": "64229d80-11aa-4910-9e0c-a211d9a5ca95", "descendantuuid": "98f81765-6d0e-4cb5-ab49-da912f668f5d", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f4bed22e-44be-4ce4-9d95-5d9be630012a', 'INSERT', '{"uuid": "f4bed22e-44be-4ce4-9d95-5d9be630012a", "roletype": "TENANT", "objectuuid": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '8a7273c3-5012-45bd-9d3f-72dd52163117', 'INSERT', '{"op": "SELECT", "uuid": "8a7273c3-5012-45bd-9d3f-72dd52163117", "objectuuid": "2185083d-3134-4b30-9dcb-674058feaac2", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b8fcfba2-925f-41b3-a68d-9f5e282ee1d6', 'INSERT', '{"uuid": "b8fcfba2-925f-41b3-a68d-9f5e282ee1d6", "assumed": true, "ascendantuuid": "f4bed22e-44be-4ce4-9d95-5d9be630012a", "descendantuuid": "8a7273c3-5012-45bd-9d3f-72dd52163117", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2e09df1b-489e-4f3a-add9-eecca44a15a7', 'INSERT', '{"uuid": "2e09df1b-489e-4f3a-add9-eecca44a15a7", "assumed": true, "ascendantuuid": "93ec1b20-de2b-4af1-924f-047a7afa0276", "descendantuuid": "f4bed22e-44be-4ce4-9d95-5d9be630012a", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f50fdd37-fce2-49aa-bb36-bf91c808a68a', 'INSERT', '{"uuid": "f50fdd37-fce2-49aa-bb36-bf91c808a68a", "assumed": true, "ascendantuuid": "98f81765-6d0e-4cb5-ab49-da912f668f5d", "descendantuuid": "f4bed22e-44be-4ce4-9d95-5d9be630012a", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1bc31c7c-b350-408c-9da4-811d0151766a', 'INSERT', '{"uuid": "1bc31c7c-b350-408c-9da4-811d0151766a", "assumed": true, "ascendantuuid": "f4bed22e-44be-4ce4-9d95-5d9be630012a", "descendantuuid": "4330591d-61d5-4435-827a-c71b8328a700", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '497285ad-4b61-4108-89af-9341718f8570', 'INSERT', '{"uuid": "497285ad-4b61-4108-89af-9341718f8570", "assumed": true, "ascendantuuid": "f4bed22e-44be-4ce4-9d95-5d9be630012a", "descendantuuid": "a7ff4f1c-7c33-43e0-b264-37339141f7f9", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0750ea1a-1e29-498b-93cf-5b9bb974d6e3', 'INSERT', '{"uuid": "0750ea1a-1e29-498b-93cf-5b9bb974d6e3", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "98f81765-6d0e-4cb5-ab49-da912f668f5d", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4e95f12e-e96e-48ea-acfc-6f5c81541152', 'INSERT', '{"uuid": "4e95f12e-e96e-48ea-acfc-6f5c81541152", "assumed": true, "ascendantuuid": "f32f51d5-3384-426e-a1c1-b5b6a263b647", "descendantuuid": "7f74a25b-753a-4534-bd83-0db07cc6df2f", "grantedbyroleuuid": null, "grantedbytriggerof": "2185083d-3134-4b30-9dcb-674058feaac2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '2185083d-3134-4b30-9dcb-674058feaac2', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "2185083d-3134-4b30-9dcb-674058feaac2", "version": 0, "anchoruuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "holderuuid": "450cf76f-d9bb-4308-ae8f-bd09bbbafd31", "contactuuid": "8e7648e6-e74e-4a37-b9c0-3a5998921e1f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', 'INSERT', '{"uuid": "c60e1d4e-01a1-42a8-9521-1681c77b350f", "serialid": 208, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8772af22-67d6-4721-bc48-20f841f171e6', 'INSERT', '{"uuid": "8772af22-67d6-4721-bc48-20f841f171e6", "roletype": "OWNER", "objectuuid": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'b31618ff-d749-4aa9-86b8-08eb2de9dcac', 'INSERT', '{"op": "DELETE", "uuid": "b31618ff-d749-4aa9-86b8-08eb2de9dcac", "objectuuid": "c60e1d4e-01a1-42a8-9521-1681c77b350f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '91f4f621-48ec-4953-90a5-29e8c96da6d2', 'INSERT', '{"uuid": "91f4f621-48ec-4953-90a5-29e8c96da6d2", "assumed": true, "ascendantuuid": "8772af22-67d6-4721-bc48-20f841f171e6", "descendantuuid": "b31618ff-d749-4aa9-86b8-08eb2de9dcac", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ee5f23de-7bc0-486a-af2b-ce8ca809a8a7', 'INSERT', '{"uuid": "ee5f23de-7bc0-486a-af2b-ce8ca809a8a7", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "8772af22-67d6-4721-bc48-20f841f171e6", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3d46e72a-eae9-4ce6-81da-08bd21c11e09', 'INSERT', '{"uuid": "3d46e72a-eae9-4ce6-81da-08bd21c11e09", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "8772af22-67d6-4721-bc48-20f841f171e6", "grantedbyroleuuid": "8772af22-67d6-4721-bc48-20f841f171e6", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '2899fdb3-40ae-4885-8d6b-7c0f07493ef8', 'INSERT', '{"uuid": "2899fdb3-40ae-4885-8d6b-7c0f07493ef8", "roletype": "ADMIN", "objectuuid": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '9b229b0a-e7b9-4fce-a134-c6f5199ce495', 'INSERT', '{"op": "UPDATE", "uuid": "9b229b0a-e7b9-4fce-a134-c6f5199ce495", "objectuuid": "c60e1d4e-01a1-42a8-9521-1681c77b350f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1783ac20-fc60-4574-a39b-8f8cabb6c84b', 'INSERT', '{"uuid": "1783ac20-fc60-4574-a39b-8f8cabb6c84b", "assumed": true, "ascendantuuid": "2899fdb3-40ae-4885-8d6b-7c0f07493ef8", "descendantuuid": "9b229b0a-e7b9-4fce-a134-c6f5199ce495", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '361867cb-91aa-4ee1-b95a-5e4c1abd3725', 'INSERT', '{"uuid": "361867cb-91aa-4ee1-b95a-5e4c1abd3725", "assumed": true, "ascendantuuid": "8772af22-67d6-4721-bc48-20f841f171e6", "descendantuuid": "2899fdb3-40ae-4885-8d6b-7c0f07493ef8", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3', 'INSERT', '{"uuid": "f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3", "roletype": "AGENT", "objectuuid": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1f578f1d-cf4c-404a-9d05-d39bb050b9dc', 'INSERT', '{"uuid": "1f578f1d-cf4c-404a-9d05-d39bb050b9dc", "assumed": true, "ascendantuuid": "2899fdb3-40ae-4885-8d6b-7c0f07493ef8", "descendantuuid": "f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ce3d8199-1a11-409c-8f0f-99a8344f1d1a', 'INSERT', '{"uuid": "ce3d8199-1a11-409c-8f0f-99a8344f1d1a", "roletype": "TENANT", "objectuuid": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '46ba8c49-58f7-441b-a7c0-290a9f490a1f', 'INSERT', '{"op": "SELECT", "uuid": "46ba8c49-58f7-441b-a7c0-290a9f490a1f", "objectuuid": "c60e1d4e-01a1-42a8-9521-1681c77b350f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a4f9d60c-0e9a-4d31-8516-ad679c978264', 'INSERT', '{"uuid": "a4f9d60c-0e9a-4d31-8516-ad679c978264", "assumed": true, "ascendantuuid": "ce3d8199-1a11-409c-8f0f-99a8344f1d1a", "descendantuuid": "46ba8c49-58f7-441b-a7c0-290a9f490a1f", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '935e8f3b-8569-4b85-8c4f-771a8b2c0deb', 'INSERT', '{"uuid": "935e8f3b-8569-4b85-8c4f-771a8b2c0deb", "assumed": true, "ascendantuuid": "5b391d1b-439d-4ba6-9be1-dc9e8c161c7c", "descendantuuid": "ce3d8199-1a11-409c-8f0f-99a8344f1d1a", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e0e15d6c-1f34-4ad9-99bb-dae9bea370e0', 'INSERT', '{"uuid": "e0e15d6c-1f34-4ad9-99bb-dae9bea370e0", "assumed": true, "ascendantuuid": "f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3", "descendantuuid": "ce3d8199-1a11-409c-8f0f-99a8344f1d1a", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '54344d9d-5501-48d4-b021-efb561be481a', 'INSERT', '{"uuid": "54344d9d-5501-48d4-b021-efb561be481a", "assumed": true, "ascendantuuid": "ce3d8199-1a11-409c-8f0f-99a8344f1d1a", "descendantuuid": "5167487b-90ee-40b9-9c34-535b74b3186e", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '87faed89-6652-4ebd-a2c2-183e88046dab', 'INSERT', '{"uuid": "87faed89-6652-4ebd-a2c2-183e88046dab", "assumed": true, "ascendantuuid": "ce3d8199-1a11-409c-8f0f-99a8344f1d1a", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ce026d6a-238b-4663-8a6a-63b30be9a7e0', 'INSERT', '{"uuid": "ce026d6a-238b-4663-8a6a-63b30be9a7e0", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5ada012b-e322-4928-a6b4-c08620cceadb', 'INSERT', '{"uuid": "5ada012b-e322-4928-a6b4-c08620cceadb", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "8772af22-67d6-4721-bc48-20f841f171e6", "grantedbyroleuuid": null, "grantedbytriggerof": "c60e1d4e-01a1-42a8-9521-1681c77b350f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', 'INSERT', '{"mark": "generalversammlung", "type": "SUBSCRIBER", "uuid": "c60e1d4e-01a1-42a8-9521-1681c77b350f", "version": 0, "anchoruuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "holderuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "contactuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '17ea3654-289d-4892-a837-3ddcaea2d7db', 'INSERT', '{"uuid": "17ea3654-289d-4892-a837-3ddcaea2d7db", "serialid": 209, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'bd1cdc2f-13aa-490d-84bf-1cea1d91fd05', 'INSERT', '{"uuid": "bd1cdc2f-13aa-490d-84bf-1cea1d91fd05", "roletype": "OWNER", "objectuuid": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '1be877de-9e9e-478b-855b-f4f0e6dfb842', 'INSERT', '{"op": "DELETE", "uuid": "1be877de-9e9e-478b-855b-f4f0e6dfb842", "objectuuid": "17ea3654-289d-4892-a837-3ddcaea2d7db", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6b7b8728-4071-4b75-b2a7-1ddd2e1bc468', 'INSERT', '{"uuid": "6b7b8728-4071-4b75-b2a7-1ddd2e1bc468", "assumed": true, "ascendantuuid": "bd1cdc2f-13aa-490d-84bf-1cea1d91fd05", "descendantuuid": "1be877de-9e9e-478b-855b-f4f0e6dfb842", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3715d066-6c22-4d60-a579-859b3340ffdc', 'INSERT', '{"uuid": "3715d066-6c22-4d60-a579-859b3340ffdc", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "bd1cdc2f-13aa-490d-84bf-1cea1d91fd05", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bc4ccda5-cc3c-44a0-b079-795628799f81', 'INSERT', '{"uuid": "bc4ccda5-cc3c-44a0-b079-795628799f81", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "bd1cdc2f-13aa-490d-84bf-1cea1d91fd05", "grantedbyroleuuid": "bd1cdc2f-13aa-490d-84bf-1cea1d91fd05", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ec3bede7-5502-40df-bcaf-d2782c15ed50', 'INSERT', '{"uuid": "ec3bede7-5502-40df-bcaf-d2782c15ed50", "roletype": "ADMIN", "objectuuid": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7a48ec29-24be-4d13-b788-264eb6fe6327', 'INSERT', '{"op": "UPDATE", "uuid": "7a48ec29-24be-4d13-b788-264eb6fe6327", "objectuuid": "17ea3654-289d-4892-a837-3ddcaea2d7db", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '84b30d19-36de-4e02-bf21-3d3571be13c5', 'INSERT', '{"uuid": "84b30d19-36de-4e02-bf21-3d3571be13c5", "assumed": true, "ascendantuuid": "ec3bede7-5502-40df-bcaf-d2782c15ed50", "descendantuuid": "7a48ec29-24be-4d13-b788-264eb6fe6327", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '044cd5d9-8e21-4ae8-89a6-3308958528d3', 'INSERT', '{"uuid": "044cd5d9-8e21-4ae8-89a6-3308958528d3", "assumed": true, "ascendantuuid": "bd1cdc2f-13aa-490d-84bf-1cea1d91fd05", "descendantuuid": "ec3bede7-5502-40df-bcaf-d2782c15ed50", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '98c6c409-250f-4977-89da-f3c242f4be8b', 'INSERT', '{"uuid": "98c6c409-250f-4977-89da-f3c242f4be8b", "roletype": "AGENT", "objectuuid": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd2e8f68d-5efb-4926-9ba3-6bbc84b41544', 'INSERT', '{"uuid": "d2e8f68d-5efb-4926-9ba3-6bbc84b41544", "assumed": true, "ascendantuuid": "ec3bede7-5502-40df-bcaf-d2782c15ed50", "descendantuuid": "98c6c409-250f-4977-89da-f3c242f4be8b", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'bf5371a6-e09c-4484-b57c-62aa6befdd0c', 'INSERT', '{"uuid": "bf5371a6-e09c-4484-b57c-62aa6befdd0c", "roletype": "TENANT", "objectuuid": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2fc229bc-25f7-407d-bdfc-e9469c17ca34', 'INSERT', '{"op": "SELECT", "uuid": "2fc229bc-25f7-407d-bdfc-e9469c17ca34", "objectuuid": "17ea3654-289d-4892-a837-3ddcaea2d7db", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '201bce64-1c53-4047-bfd3-1892e4bb545f', 'INSERT', '{"uuid": "201bce64-1c53-4047-bfd3-1892e4bb545f", "roletype": "OWNER", "objectuuid": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9a50a114-f2e1-4465-8c3d-df1fde31e0c4', 'INSERT', '{"uuid": "9a50a114-f2e1-4465-8c3d-df1fde31e0c4", "assumed": true, "ascendantuuid": "bf5371a6-e09c-4484-b57c-62aa6befdd0c", "descendantuuid": "2fc229bc-25f7-407d-bdfc-e9469c17ca34", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dc1d7bd9-a178-4b6f-8ddd-88f6a01afe4e', 'INSERT', '{"uuid": "dc1d7bd9-a178-4b6f-8ddd-88f6a01afe4e", "assumed": true, "ascendantuuid": "5b391d1b-439d-4ba6-9be1-dc9e8c161c7c", "descendantuuid": "bf5371a6-e09c-4484-b57c-62aa6befdd0c", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b691f5d4-921f-4f4a-9e96-d4d962d90bb0', 'INSERT', '{"uuid": "b691f5d4-921f-4f4a-9e96-d4d962d90bb0", "assumed": true, "ascendantuuid": "98c6c409-250f-4977-89da-f3c242f4be8b", "descendantuuid": "bf5371a6-e09c-4484-b57c-62aa6befdd0c", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f9442aed-5ca1-4bcf-9552-cb5a35ecbd8d', 'INSERT', '{"uuid": "f9442aed-5ca1-4bcf-9552-cb5a35ecbd8d", "assumed": true, "ascendantuuid": "bf5371a6-e09c-4484-b57c-62aa6befdd0c", "descendantuuid": "5167487b-90ee-40b9-9c34-535b74b3186e", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '91e2ffc4-0265-42d1-ba63-f35be286e999', 'INSERT', '{"uuid": "91e2ffc4-0265-42d1-ba63-f35be286e999", "assumed": true, "ascendantuuid": "bf5371a6-e09c-4484-b57c-62aa6befdd0c", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b9fc0e8c-5f9f-4781-b485-379d44c53792', 'INSERT', '{"uuid": "b9fc0e8c-5f9f-4781-b485-379d44c53792", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "98c6c409-250f-4977-89da-f3c242f4be8b", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a906bcfa-8745-41df-a97f-691c5a303f1a', 'INSERT', '{"uuid": "a906bcfa-8745-41df-a97f-691c5a303f1a", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "bd1cdc2f-13aa-490d-84bf-1cea1d91fd05", "grantedbyroleuuid": null, "grantedbytriggerof": "17ea3654-289d-4892-a837-3ddcaea2d7db"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '17ea3654-289d-4892-a837-3ddcaea2d7db', 'INSERT', '{"mark": "members-announce", "type": "SUBSCRIBER", "uuid": "17ea3654-289d-4892-a837-3ddcaea2d7db", "version": 0, "anchoruuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "holderuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "contactuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '60702c01-7285-4eea-a937-6019d6e3661d', 'INSERT', '{"uuid": "60702c01-7285-4eea-a937-6019d6e3661d", "serialid": 210, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6093331c-adb2-44e9-baac-ef073278751f', 'INSERT', '{"uuid": "6093331c-adb2-44e9-baac-ef073278751f", "roletype": "OWNER", "objectuuid": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '46d04d79-5187-44ec-8f30-e6f823bc47e6', 'INSERT', '{"op": "DELETE", "uuid": "46d04d79-5187-44ec-8f30-e6f823bc47e6", "objectuuid": "60702c01-7285-4eea-a937-6019d6e3661d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd9fbd26a-a4b0-4ad1-8c38-3281b7b4b992', 'INSERT', '{"uuid": "d9fbd26a-a4b0-4ad1-8c38-3281b7b4b992", "assumed": true, "ascendantuuid": "6093331c-adb2-44e9-baac-ef073278751f", "descendantuuid": "46d04d79-5187-44ec-8f30-e6f823bc47e6", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '71a02cb0-4e2d-49ad-8ebc-e91cefaf35bd', 'INSERT', '{"uuid": "71a02cb0-4e2d-49ad-8ebc-e91cefaf35bd", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "6093331c-adb2-44e9-baac-ef073278751f", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4ca42285-8620-423d-833e-591a0c311ef9', 'INSERT', '{"uuid": "4ca42285-8620-423d-833e-591a0c311ef9", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "6093331c-adb2-44e9-baac-ef073278751f", "grantedbyroleuuid": "6093331c-adb2-44e9-baac-ef073278751f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'a0cf1824-6284-4031-980e-1df923d144e0', 'INSERT', '{"uuid": "a0cf1824-6284-4031-980e-1df923d144e0", "roletype": "ADMIN", "objectuuid": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '3817a2b3-7031-4489-8c87-23babe729843', 'INSERT', '{"op": "UPDATE", "uuid": "3817a2b3-7031-4489-8c87-23babe729843", "objectuuid": "60702c01-7285-4eea-a937-6019d6e3661d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '16fdb069-9d57-40a4-8993-547d5a39c03e', 'INSERT', '{"uuid": "16fdb069-9d57-40a4-8993-547d5a39c03e", "assumed": true, "ascendantuuid": "a0cf1824-6284-4031-980e-1df923d144e0", "descendantuuid": "3817a2b3-7031-4489-8c87-23babe729843", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b37eb949-13ea-455c-a7da-cb958219a181', 'INSERT', '{"uuid": "b37eb949-13ea-455c-a7da-cb958219a181", "assumed": true, "ascendantuuid": "6093331c-adb2-44e9-baac-ef073278751f", "descendantuuid": "a0cf1824-6284-4031-980e-1df923d144e0", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0a93387c-682c-45d7-8a24-e538678f5cf4', 'INSERT', '{"uuid": "0a93387c-682c-45d7-8a24-e538678f5cf4", "roletype": "AGENT", "objectuuid": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '45c9a1c0-a672-495c-a16c-37e8b92d4a7d', 'INSERT', '{"uuid": "45c9a1c0-a672-495c-a16c-37e8b92d4a7d", "assumed": true, "ascendantuuid": "a0cf1824-6284-4031-980e-1df923d144e0", "descendantuuid": "0a93387c-682c-45d7-8a24-e538678f5cf4", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '35a0a69f-e93c-43f7-b406-3c2d01e1cd8c', 'INSERT', '{"uuid": "35a0a69f-e93c-43f7-b406-3c2d01e1cd8c", "roletype": "TENANT", "objectuuid": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'd241e268-fffd-4d21-9936-819ae9975f85', 'INSERT', '{"op": "SELECT", "uuid": "d241e268-fffd-4d21-9936-819ae9975f85", "objectuuid": "60702c01-7285-4eea-a937-6019d6e3661d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6feec489-d95d-4a2f-8d34-76f11e5a0276', 'INSERT', '{"uuid": "6feec489-d95d-4a2f-8d34-76f11e5a0276", "assumed": true, "ascendantuuid": "35a0a69f-e93c-43f7-b406-3c2d01e1cd8c", "descendantuuid": "d241e268-fffd-4d21-9936-819ae9975f85", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd63c04ff-728e-4847-bfb3-b8780540a025', 'INSERT', '{"uuid": "d63c04ff-728e-4847-bfb3-b8780540a025", "assumed": true, "ascendantuuid": "5b391d1b-439d-4ba6-9be1-dc9e8c161c7c", "descendantuuid": "35a0a69f-e93c-43f7-b406-3c2d01e1cd8c", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '31b7bb2a-4e2c-401a-9f51-160a53e4cc3c', 'INSERT', '{"uuid": "31b7bb2a-4e2c-401a-9f51-160a53e4cc3c", "assumed": true, "ascendantuuid": "0a93387c-682c-45d7-8a24-e538678f5cf4", "descendantuuid": "35a0a69f-e93c-43f7-b406-3c2d01e1cd8c", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4e6714ed-44b6-4846-9158-030ab6e876eb', 'INSERT', '{"uuid": "4e6714ed-44b6-4846-9158-030ab6e876eb", "assumed": true, "ascendantuuid": "35a0a69f-e93c-43f7-b406-3c2d01e1cd8c", "descendantuuid": "5167487b-90ee-40b9-9c34-535b74b3186e", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '46508dd1-469a-45be-81bd-6346a9bbc63e', 'INSERT', '{"uuid": "46508dd1-469a-45be-81bd-6346a9bbc63e", "assumed": true, "ascendantuuid": "35a0a69f-e93c-43f7-b406-3c2d01e1cd8c", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd171cf8a-9426-4276-aedc-3e137be04705', 'INSERT', '{"uuid": "d171cf8a-9426-4276-aedc-3e137be04705", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "0a93387c-682c-45d7-8a24-e538678f5cf4", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '92aca332-eddc-4be4-8811-e2a99cacf5fd', 'INSERT', '{"uuid": "92aca332-eddc-4be4-8811-e2a99cacf5fd", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "6093331c-adb2-44e9-baac-ef073278751f", "grantedbyroleuuid": null, "grantedbytriggerof": "60702c01-7285-4eea-a937-6019d6e3661d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '60702c01-7285-4eea-a937-6019d6e3661d', 'INSERT', '{"mark": "members-discussion", "type": "SUBSCRIBER", "uuid": "60702c01-7285-4eea-a937-6019d6e3661d", "version": 0, "anchoruuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "holderuuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "contactuuid": "25358342-4f90-4397-b4c4-d90524ac0b7b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', 'INSERT', '{"uuid": "a66a844c-e5b3-4569-96cf-06197abc0d2f", "serialid": 211, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '86514079-9959-4ffe-9563-4be364780b39', 'INSERT', '{"uuid": "86514079-9959-4ffe-9563-4be364780b39", "roletype": "OWNER", "objectuuid": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '1bc97522-8adf-4246-bb4f-9a870002fbd4', 'INSERT', '{"op": "DELETE", "uuid": "1bc97522-8adf-4246-bb4f-9a870002fbd4", "objectuuid": "a66a844c-e5b3-4569-96cf-06197abc0d2f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7afeee51-a00e-4f79-afcc-7be6f4b53665', 'INSERT', '{"uuid": "7afeee51-a00e-4f79-afcc-7be6f4b53665", "assumed": true, "ascendantuuid": "86514079-9959-4ffe-9563-4be364780b39", "descendantuuid": "1bc97522-8adf-4246-bb4f-9a870002fbd4", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8a007e81-834c-46cd-a09a-35e7992b74b4', 'INSERT', '{"uuid": "8a007e81-834c-46cd-a09a-35e7992b74b4", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "86514079-9959-4ffe-9563-4be364780b39", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3f5d16e1-aca2-4017-86f9-0ec97c86886f', 'INSERT', '{"uuid": "3f5d16e1-aca2-4017-86f9-0ec97c86886f", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "86514079-9959-4ffe-9563-4be364780b39", "grantedbyroleuuid": "86514079-9959-4ffe-9563-4be364780b39", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '94fb08b4-d5d1-43a5-a395-b1e261a46e0b', 'INSERT', '{"uuid": "94fb08b4-d5d1-43a5-a395-b1e261a46e0b", "roletype": "ADMIN", "objectuuid": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7ee9690d-ebff-4afb-95db-fad387eb4255', 'INSERT', '{"op": "UPDATE", "uuid": "7ee9690d-ebff-4afb-95db-fad387eb4255", "objectuuid": "a66a844c-e5b3-4569-96cf-06197abc0d2f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8fb309bc-79ef-4085-b25e-58e7b0827fbf', 'INSERT', '{"uuid": "8fb309bc-79ef-4085-b25e-58e7b0827fbf", "assumed": true, "ascendantuuid": "94fb08b4-d5d1-43a5-a395-b1e261a46e0b", "descendantuuid": "7ee9690d-ebff-4afb-95db-fad387eb4255", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a98c8ed6-d9d3-4420-9da7-900372a76869', 'INSERT', '{"uuid": "a98c8ed6-d9d3-4420-9da7-900372a76869", "assumed": true, "ascendantuuid": "86514079-9959-4ffe-9563-4be364780b39", "descendantuuid": "94fb08b4-d5d1-43a5-a395-b1e261a46e0b", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd6e4ad57-a163-4508-a694-99a87eeeb986', 'INSERT', '{"uuid": "d6e4ad57-a163-4508-a694-99a87eeeb986", "roletype": "AGENT", "objectuuid": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b8b3f481-4402-4ea0-850e-8a52ab5e8703', 'INSERT', '{"uuid": "b8b3f481-4402-4ea0-850e-8a52ab5e8703", "assumed": true, "ascendantuuid": "94fb08b4-d5d1-43a5-a395-b1e261a46e0b", "descendantuuid": "d6e4ad57-a163-4508-a694-99a87eeeb986", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a', 'INSERT', '{"uuid": "67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a", "roletype": "TENANT", "objectuuid": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2d00deb0-bb73-447f-b867-71be2d2dbfda', 'INSERT', '{"op": "SELECT", "uuid": "2d00deb0-bb73-447f-b867-71be2d2dbfda", "objectuuid": "a66a844c-e5b3-4569-96cf-06197abc0d2f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7987aafb-1726-4434-b942-f3e03f2944a0', 'INSERT', '{"uuid": "7987aafb-1726-4434-b942-f3e03f2944a0", "assumed": true, "ascendantuuid": "67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a", "descendantuuid": "2d00deb0-bb73-447f-b867-71be2d2dbfda", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '60dcb967-6300-4985-adcb-5a49474e2f7b', 'INSERT', '{"uuid": "60dcb967-6300-4985-adcb-5a49474e2f7b", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c423d783-e419-49f1-8804-296f71d6c254', 'INSERT', '{"uuid": "c423d783-e419-49f1-8804-296f71d6c254", "assumed": true, "ascendantuuid": "d6e4ad57-a163-4508-a694-99a87eeeb986", "descendantuuid": "67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '47c7c631-f6bb-40ad-8b2b-05274dd958f0', 'INSERT', '{"uuid": "47c7c631-f6bb-40ad-8b2b-05274dd958f0", "assumed": true, "ascendantuuid": "67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a", "descendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bf19153e-8a52-4339-ae59-971174f639f2', 'INSERT', '{"uuid": "bf19153e-8a52-4339-ae59-971174f639f2", "assumed": true, "ascendantuuid": "67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c9bc9ea4-66ff-43f0-86b1-4f6f8fd31e5c', 'INSERT', '{"uuid": "c9bc9ea4-66ff-43f0-86b1-4f6f8fd31e5c", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "d6e4ad57-a163-4508-a694-99a87eeeb986", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bbe4f41e-6ecd-4688-b44a-8a94a9badd9b', 'INSERT', '{"uuid": "bbe4f41e-6ecd-4688-b44a-8a94a9badd9b", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "86514079-9959-4ffe-9563-4be364780b39", "grantedbyroleuuid": null, "grantedbytriggerof": "a66a844c-e5b3-4569-96cf-06197abc0d2f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "a66a844c-e5b3-4569-96cf-06197abc0d2f", "version": 0, "anchoruuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "holderuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "contactuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', 'INSERT', '{"uuid": "f7ddff21-e58a-426b-a693-46a2b45c9d4e", "serialid": 212, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e743b05d-4d77-4167-be21-b86213521704', 'INSERT', '{"uuid": "e743b05d-4d77-4167-be21-b86213521704", "assumed": true, "ascendantuuid": "5eb167f7-80c1-4c71-9c63-b9d6994ec251", "descendantuuid": "3a64d35c-f155-4420-a87f-ddd771f7e500", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '48e818a3-167f-4dc8-8aff-c22b63aba62b', 'INSERT', '{"uuid": "48e818a3-167f-4dc8-8aff-c22b63aba62b", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "5eb167f7-80c1-4c71-9c63-b9d6994ec251", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '92b37cad-3482-4ece-8be4-dd7f5bc524ab', 'INSERT', '{"uuid": "92b37cad-3482-4ece-8be4-dd7f5bc524ab", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "5eb167f7-80c1-4c71-9c63-b9d6994ec251", "grantedbyroleuuid": "5eb167f7-80c1-4c71-9c63-b9d6994ec251", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '44c0b607-7d0a-4701-9570-8d339189020f', 'INSERT', '{"uuid": "44c0b607-7d0a-4701-9570-8d339189020f", "roletype": "ADMIN", "objectuuid": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '238a91bb-2186-41f0-a97b-6e4c62a2c6a8', 'INSERT', '{"op": "UPDATE", "uuid": "238a91bb-2186-41f0-a97b-6e4c62a2c6a8", "objectuuid": "f7ddff21-e58a-426b-a693-46a2b45c9d4e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b0021ca7-6132-406c-ab5d-e981e394586e', 'INSERT', '{"uuid": "b0021ca7-6132-406c-ab5d-e981e394586e", "assumed": true, "ascendantuuid": "44c0b607-7d0a-4701-9570-8d339189020f", "descendantuuid": "238a91bb-2186-41f0-a97b-6e4c62a2c6a8", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0d7f87c0-db06-4a82-a3d6-d64698f34c55', 'INSERT', '{"uuid": "0d7f87c0-db06-4a82-a3d6-d64698f34c55", "assumed": true, "ascendantuuid": "5eb167f7-80c1-4c71-9c63-b9d6994ec251", "descendantuuid": "44c0b607-7d0a-4701-9570-8d339189020f", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '91f36783-f411-4708-a88e-b30fb94d849a', 'INSERT', '{"uuid": "91f36783-f411-4708-a88e-b30fb94d849a", "roletype": "AGENT", "objectuuid": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6100fa03-8dc5-4f16-85b6-65546e1bef7a', 'INSERT', '{"uuid": "6100fa03-8dc5-4f16-85b6-65546e1bef7a", "assumed": true, "ascendantuuid": "44c0b607-7d0a-4701-9570-8d339189020f", "descendantuuid": "91f36783-f411-4708-a88e-b30fb94d849a", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '52c74fa2-27f4-4046-8712-759b3f47e48a', 'INSERT', '{"uuid": "52c74fa2-27f4-4046-8712-759b3f47e48a", "roletype": "TENANT", "objectuuid": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '0dc256f1-c7eb-4c52-95b6-a05ef1f92d4f', 'INSERT', '{"op": "SELECT", "uuid": "0dc256f1-c7eb-4c52-95b6-a05ef1f92d4f", "objectuuid": "f7ddff21-e58a-426b-a693-46a2b45c9d4e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cf8cb48d-1d87-4b11-b2d1-df908149d755', 'INSERT', '{"uuid": "cf8cb48d-1d87-4b11-b2d1-df908149d755", "assumed": true, "ascendantuuid": "52c74fa2-27f4-4046-8712-759b3f47e48a", "descendantuuid": "0dc256f1-c7eb-4c52-95b6-a05ef1f92d4f", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7fd305af-57be-43a7-a732-f26418a1ca53', 'INSERT', '{"uuid": "7fd305af-57be-43a7-a732-f26418a1ca53", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "52c74fa2-27f4-4046-8712-759b3f47e48a", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '57536f03-fcb5-44ff-a589-e98cd3df123b', 'INSERT', '{"uuid": "57536f03-fcb5-44ff-a589-e98cd3df123b", "assumed": true, "ascendantuuid": "91f36783-f411-4708-a88e-b30fb94d849a", "descendantuuid": "52c74fa2-27f4-4046-8712-759b3f47e48a", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8ed30d78-487b-468d-aa73-e3bb5e4b5d17', 'INSERT', '{"uuid": "8ed30d78-487b-468d-aa73-e3bb5e4b5d17", "assumed": true, "ascendantuuid": "52c74fa2-27f4-4046-8712-759b3f47e48a", "descendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '72bdf079-cbb7-4a67-8666-4583db5d3cca', 'INSERT', '{"uuid": "72bdf079-cbb7-4a67-8666-4583db5d3cca", "assumed": true, "ascendantuuid": "52c74fa2-27f4-4046-8712-759b3f47e48a", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '805468da-74ec-4b41-93c6-6bee7da7cd0b', 'INSERT', '{"uuid": "805468da-74ec-4b41-93c6-6bee7da7cd0b", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "91f36783-f411-4708-a88e-b30fb94d849a", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b0e8d9f5-6d48-4cef-9ef7-0730917a3d14', 'INSERT', '{"uuid": "b0e8d9f5-6d48-4cef-9ef7-0730917a3d14", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "5eb167f7-80c1-4c71-9c63-b9d6994ec251", "grantedbyroleuuid": null, "grantedbytriggerof": "f7ddff21-e58a-426b-a693-46a2b45c9d4e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "f7ddff21-e58a-426b-a693-46a2b45c9d4e", "version": 0, "anchoruuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "holderuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "contactuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '8363ec62-6d90-4dd9-940b-6073b3246c39', 'INSERT', '{"uuid": "8363ec62-6d90-4dd9-940b-6073b3246c39", "serialid": 213, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '2a60ab65-5d4d-49bf-b184-3b1ef563bd62', 'INSERT', '{"uuid": "2a60ab65-5d4d-49bf-b184-3b1ef563bd62", "roletype": "OWNER", "objectuuid": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '8b30e218-5562-41af-82ce-bf3f633d1f3d', 'INSERT', '{"op": "DELETE", "uuid": "8b30e218-5562-41af-82ce-bf3f633d1f3d", "objectuuid": "8363ec62-6d90-4dd9-940b-6073b3246c39", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bed9a100-fd78-4b56-bfc8-2f484b955947', 'INSERT', '{"uuid": "bed9a100-fd78-4b56-bfc8-2f484b955947", "assumed": true, "ascendantuuid": "2a60ab65-5d4d-49bf-b184-3b1ef563bd62", "descendantuuid": "8b30e218-5562-41af-82ce-bf3f633d1f3d", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '213e0b7e-5f3e-4e42-bdf6-30a0ac699b28', 'INSERT', '{"uuid": "213e0b7e-5f3e-4e42-bdf6-30a0ac699b28", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "2a60ab65-5d4d-49bf-b184-3b1ef563bd62", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '80161fac-c749-4b08-8c84-0ebafd2d3a98', 'INSERT', '{"uuid": "80161fac-c749-4b08-8c84-0ebafd2d3a98", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "2a60ab65-5d4d-49bf-b184-3b1ef563bd62", "grantedbyroleuuid": "2a60ab65-5d4d-49bf-b184-3b1ef563bd62", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '553adc79-d3f6-4b92-88d3-8c9328e5a616', 'INSERT', '{"uuid": "553adc79-d3f6-4b92-88d3-8c9328e5a616", "roletype": "ADMIN", "objectuuid": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '31a9442f-92c2-4f7d-9895-a7095ee96952', 'INSERT', '{"op": "UPDATE", "uuid": "31a9442f-92c2-4f7d-9895-a7095ee96952", "objectuuid": "8363ec62-6d90-4dd9-940b-6073b3246c39", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b01e33b6-b72e-4ff8-bce3-5e4fee5d954d', 'INSERT', '{"uuid": "b01e33b6-b72e-4ff8-bce3-5e4fee5d954d", "assumed": true, "ascendantuuid": "553adc79-d3f6-4b92-88d3-8c9328e5a616", "descendantuuid": "31a9442f-92c2-4f7d-9895-a7095ee96952", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '166f5922-7578-4ecb-b9ac-b89136e7ef33', 'INSERT', '{"uuid": "166f5922-7578-4ecb-b9ac-b89136e7ef33", "assumed": true, "ascendantuuid": "2a60ab65-5d4d-49bf-b184-3b1ef563bd62", "descendantuuid": "553adc79-d3f6-4b92-88d3-8c9328e5a616", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '832cde07-7e08-41a0-84e0-201f12393e15', 'INSERT', '{"uuid": "832cde07-7e08-41a0-84e0-201f12393e15", "roletype": "AGENT", "objectuuid": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4290306a-ac53-43a6-84a2-c234e41835a0', 'INSERT', '{"uuid": "4290306a-ac53-43a6-84a2-c234e41835a0", "assumed": true, "ascendantuuid": "553adc79-d3f6-4b92-88d3-8c9328e5a616", "descendantuuid": "832cde07-7e08-41a0-84e0-201f12393e15", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '4e1db019-7622-4ba1-aec7-4046419a7b28', 'INSERT', '{"uuid": "4e1db019-7622-4ba1-aec7-4046419a7b28", "roletype": "TENANT", "objectuuid": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'bacb714c-ac84-4f51-b8e3-fc74b27e1388', 'INSERT', '{"op": "SELECT", "uuid": "bacb714c-ac84-4f51-b8e3-fc74b27e1388", "objectuuid": "8363ec62-6d90-4dd9-940b-6073b3246c39", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '34d62e8e-b3d7-468b-a291-fc969c3b9cb0', 'INSERT', '{"uuid": "34d62e8e-b3d7-468b-a291-fc969c3b9cb0", "assumed": true, "ascendantuuid": "4e1db019-7622-4ba1-aec7-4046419a7b28", "descendantuuid": "bacb714c-ac84-4f51-b8e3-fc74b27e1388", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd196d344-99a6-4eda-8a2c-9a589cd035dd', 'INSERT', '{"uuid": "d196d344-99a6-4eda-8a2c-9a589cd035dd", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "4e1db019-7622-4ba1-aec7-4046419a7b28", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1938ede4-bf20-4e00-af7c-e2824876b1c8', 'INSERT', '{"uuid": "1938ede4-bf20-4e00-af7c-e2824876b1c8", "assumed": true, "ascendantuuid": "832cde07-7e08-41a0-84e0-201f12393e15", "descendantuuid": "4e1db019-7622-4ba1-aec7-4046419a7b28", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5d6d973a-91c3-446a-8265-c561784b9469', 'INSERT', '{"uuid": "5d6d973a-91c3-446a-8265-c561784b9469", "assumed": true, "ascendantuuid": "4e1db019-7622-4ba1-aec7-4046419a7b28", "descendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e37e4ee5-9e16-48d3-8f4f-a830266ea4f8', 'INSERT', '{"uuid": "e37e4ee5-9e16-48d3-8f4f-a830266ea4f8", "assumed": true, "ascendantuuid": "4e1db019-7622-4ba1-aec7-4046419a7b28", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'aabbd5f7-d31b-41e3-a111-736caf90ba92', 'INSERT', '{"uuid": "aabbd5f7-d31b-41e3-a111-736caf90ba92", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "832cde07-7e08-41a0-84e0-201f12393e15", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '13193ab0-7409-4371-9d99-43fc3d4b3c38', 'INSERT', '{"uuid": "13193ab0-7409-4371-9d99-43fc3d4b3c38", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "2a60ab65-5d4d-49bf-b184-3b1ef563bd62", "grantedbyroleuuid": null, "grantedbytriggerof": "8363ec62-6d90-4dd9-940b-6073b3246c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '8363ec62-6d90-4dd9-940b-6073b3246c39', 'INSERT', '{"mark": "operations-discussion", "type": "SUBSCRIBER", "uuid": "8363ec62-6d90-4dd9-940b-6073b3246c39", "version": 0, "anchoruuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "holderuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "contactuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 'INSERT', '{"uuid": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3", "serialid": 214, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '4e4469ab-f0e8-4927-a374-33384a97811f', 'INSERT', '{"uuid": "4e4469ab-f0e8-4927-a374-33384a97811f", "roletype": "OWNER", "objectuuid": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '4f6ce070-55e4-4d2c-9429-5d4b3fa25077', 'INSERT', '{"op": "DELETE", "uuid": "4f6ce070-55e4-4d2c-9429-5d4b3fa25077", "objectuuid": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '87762c8c-7d03-493c-a236-12373e0eee27', 'INSERT', '{"uuid": "87762c8c-7d03-493c-a236-12373e0eee27", "assumed": true, "ascendantuuid": "4e4469ab-f0e8-4927-a374-33384a97811f", "descendantuuid": "4f6ce070-55e4-4d2c-9429-5d4b3fa25077", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '99fc01f9-b91b-4df6-a9eb-35c880f38117', 'INSERT', '{"uuid": "99fc01f9-b91b-4df6-a9eb-35c880f38117", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "4e4469ab-f0e8-4927-a374-33384a97811f", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fd064544-7017-4079-954e-2557cb22467c', 'INSERT', '{"uuid": "fd064544-7017-4079-954e-2557cb22467c", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "4e4469ab-f0e8-4927-a374-33384a97811f", "grantedbyroleuuid": "4e4469ab-f0e8-4927-a374-33384a97811f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1', 'INSERT', '{"uuid": "f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1", "roletype": "ADMIN", "objectuuid": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '274595e4-31af-488a-997e-688d10886a47', 'INSERT', '{"op": "UPDATE", "uuid": "274595e4-31af-488a-997e-688d10886a47", "objectuuid": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c12808fb-f852-4149-8745-207250682761', 'INSERT', '{"uuid": "c12808fb-f852-4149-8745-207250682761", "assumed": true, "ascendantuuid": "f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1", "descendantuuid": "274595e4-31af-488a-997e-688d10886a47", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b19b89e1-320b-4676-b2e1-878d02e24a0c', 'INSERT', '{"uuid": "b19b89e1-320b-4676-b2e1-878d02e24a0c", "assumed": true, "ascendantuuid": "4e4469ab-f0e8-4927-a374-33384a97811f", "descendantuuid": "f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'c110be44-7852-4eaa-b52a-c87a93de1076', 'INSERT', '{"uuid": "c110be44-7852-4eaa-b52a-c87a93de1076", "roletype": "AGENT", "objectuuid": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '96fce452-6a70-41b3-b800-a0a9aa31461a', 'INSERT', '{"uuid": "96fce452-6a70-41b3-b800-a0a9aa31461a", "assumed": true, "ascendantuuid": "f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1", "descendantuuid": "c110be44-7852-4eaa-b52a-c87a93de1076", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b9ad5d7e-cf8d-4265-9271-2e32128b69d2', 'INSERT', '{"uuid": "b9ad5d7e-cf8d-4265-9271-2e32128b69d2", "roletype": "TENANT", "objectuuid": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '07568fe6-b570-4eb9-b88e-9eeab35ca495', 'INSERT', '{"uuid": "07568fe6-b570-4eb9-b88e-9eeab35ca495", "assumed": true, "ascendantuuid": "b9ad5d7e-cf8d-4265-9271-2e32128b69d2", "descendantuuid": "596f965f-b224-495b-9f5f-5150af69979f", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'af0c2637-5a4b-46ee-a5d1-dc6d671266bb', 'INSERT', '{"uuid": "af0c2637-5a4b-46ee-a5d1-dc6d671266bb", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "b9ad5d7e-cf8d-4265-9271-2e32128b69d2", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6de23849-34f4-4c8c-b947-9a8e40f7c7a7', 'INSERT', '{"uuid": "6de23849-34f4-4c8c-b947-9a8e40f7c7a7", "assumed": true, "ascendantuuid": "c110be44-7852-4eaa-b52a-c87a93de1076", "descendantuuid": "b9ad5d7e-cf8d-4265-9271-2e32128b69d2", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '470a225c-108e-4d1d-8ea2-483a412b9bbf', 'INSERT', '{"uuid": "470a225c-108e-4d1d-8ea2-483a412b9bbf", "assumed": true, "ascendantuuid": "b9ad5d7e-cf8d-4265-9271-2e32128b69d2", "descendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cd11068c-9a45-48e7-808e-fb0dd02f45b9', 'INSERT', '{"uuid": "cd11068c-9a45-48e7-808e-fb0dd02f45b9", "assumed": true, "ascendantuuid": "b9ad5d7e-cf8d-4265-9271-2e32128b69d2", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dff92d19-dc34-4296-a0d7-91b0d9631d30', 'INSERT', '{"uuid": "dff92d19-dc34-4296-a0d7-91b0d9631d30", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "c110be44-7852-4eaa-b52a-c87a93de1076", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ec2adc5b-1930-45b7-86c7-2accc5f02e6a', 'INSERT', '{"uuid": "ec2adc5b-1930-45b7-86c7-2accc5f02e6a", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "4e4469ab-f0e8-4927-a374-33384a97811f", "grantedbyroleuuid": null, "grantedbytriggerof": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 'INSERT', '{"mark": "operations-announce", "type": "SUBSCRIBER", "uuid": "6561ab8d-b9a0-497c-ba5e-60403c5eb5d3", "version": 0, "anchoruuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "holderuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "contactuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', 'INSERT', '{"uuid": "bc9fabea-d44b-455c-87d6-a0b0428e7768", "serialid": 215, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f', 'INSERT', '{"uuid": "b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f", "roletype": "OWNER", "objectuuid": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'e77c42c3-559a-44af-90cd-304eab1646a5', 'INSERT', '{"op": "DELETE", "uuid": "e77c42c3-559a-44af-90cd-304eab1646a5", "objectuuid": "bc9fabea-d44b-455c-87d6-a0b0428e7768", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '35ab9b66-1ade-4b49-bb31-ebe516a34c67', 'INSERT', '{"uuid": "35ab9b66-1ade-4b49-bb31-ebe516a34c67", "assumed": true, "ascendantuuid": "b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f", "descendantuuid": "e77c42c3-559a-44af-90cd-304eab1646a5", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '750eda48-2032-4eb7-842e-f212a05cb566', 'INSERT', '{"uuid": "750eda48-2032-4eb7-842e-f212a05cb566", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9a2a51d9-3e9a-4524-9093-b622c3183afc', 'INSERT', '{"uuid": "9a2a51d9-3e9a-4524-9093-b622c3183afc", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f", "grantedbyroleuuid": "b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ba6c1883-e891-4628-bea0-78b9787b1403', 'INSERT', '{"uuid": "ba6c1883-e891-4628-bea0-78b9787b1403", "roletype": "ADMIN", "objectuuid": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '0ab92d43-0a98-4d77-9f65-44d74acfe5b8', 'INSERT', '{"op": "UPDATE", "uuid": "0ab92d43-0a98-4d77-9f65-44d74acfe5b8", "objectuuid": "bc9fabea-d44b-455c-87d6-a0b0428e7768", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '290221cd-e520-4a1c-8119-df58ec4dfae0', 'INSERT', '{"uuid": "290221cd-e520-4a1c-8119-df58ec4dfae0", "assumed": true, "ascendantuuid": "ba6c1883-e891-4628-bea0-78b9787b1403", "descendantuuid": "0ab92d43-0a98-4d77-9f65-44d74acfe5b8", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '92df1b96-88c6-436f-9a5d-9590b4e1a0b1', 'INSERT', '{"uuid": "92df1b96-88c6-436f-9a5d-9590b4e1a0b1", "assumed": true, "ascendantuuid": "b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f", "descendantuuid": "ba6c1883-e891-4628-bea0-78b9787b1403", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3877cf69-dfcc-4ff3-83a1-65ef1471f919', 'INSERT', '{"uuid": "3877cf69-dfcc-4ff3-83a1-65ef1471f919", "roletype": "AGENT", "objectuuid": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6fef9941-52e9-4692-aa2b-e986773bacef', 'INSERT', '{"uuid": "6fef9941-52e9-4692-aa2b-e986773bacef", "assumed": true, "ascendantuuid": "ba6c1883-e891-4628-bea0-78b9787b1403", "descendantuuid": "3877cf69-dfcc-4ff3-83a1-65ef1471f919", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '4d8fb33e-f5de-4716-a301-a753f59c5aed', 'INSERT', '{"uuid": "4d8fb33e-f5de-4716-a301-a753f59c5aed", "roletype": "TENANT", "objectuuid": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'f6542fe1-149a-4244-b812-18ad82ff555f', 'INSERT', '{"op": "SELECT", "uuid": "f6542fe1-149a-4244-b812-18ad82ff555f", "objectuuid": "bc9fabea-d44b-455c-87d6-a0b0428e7768", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cc3ccd82-fa75-402e-a188-337c8f44c64d', 'INSERT', '{"uuid": "cc3ccd82-fa75-402e-a188-337c8f44c64d", "assumed": true, "ascendantuuid": "4d8fb33e-f5de-4716-a301-a753f59c5aed", "descendantuuid": "f6542fe1-149a-4244-b812-18ad82ff555f", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '47dc5cdb-3e87-4e5d-950c-16ba19152b64', 'INSERT', '{"uuid": "47dc5cdb-3e87-4e5d-950c-16ba19152b64", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "4d8fb33e-f5de-4716-a301-a753f59c5aed", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b88a2bef-44ca-479c-8eef-704a5e217691', 'INSERT', '{"uuid": "b88a2bef-44ca-479c-8eef-704a5e217691", "assumed": true, "ascendantuuid": "3877cf69-dfcc-4ff3-83a1-65ef1471f919", "descendantuuid": "4d8fb33e-f5de-4716-a301-a753f59c5aed", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd0aa8661-c85f-4de9-8ca1-cf86c25d15f7', 'INSERT', '{"uuid": "d0aa8661-c85f-4de9-8ca1-cf86c25d15f7", "assumed": true, "ascendantuuid": "4d8fb33e-f5de-4716-a301-a753f59c5aed", "descendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2dc93f8b-9342-4f0c-8031-9340353d364d', 'INSERT', '{"uuid": "2dc93f8b-9342-4f0c-8031-9340353d364d", "assumed": true, "ascendantuuid": "4d8fb33e-f5de-4716-a301-a753f59c5aed", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '410cf3aa-8db7-4683-9fec-069ab6073afd', 'INSERT', '{"uuid": "410cf3aa-8db7-4683-9fec-069ab6073afd", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "3877cf69-dfcc-4ff3-83a1-65ef1471f919", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd4ee96b0-fd17-4bbd-b1e8-98f9ce015c9e', 'INSERT', '{"uuid": "d4ee96b0-fd17-4bbd-b1e8-98f9ce015c9e", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f", "grantedbyroleuuid": null, "grantedbytriggerof": "bc9fabea-d44b-455c-87d6-a0b0428e7768"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', 'INSERT', '{"mark": "generalversammlung", "type": "SUBSCRIBER", "uuid": "bc9fabea-d44b-455c-87d6-a0b0428e7768", "version": 0, "anchoruuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "holderuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "contactuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'a13af5de-4315-46dd-ae08-427ea72b35a0', 'INSERT', '{"uuid": "a13af5de-4315-46dd-ae08-427ea72b35a0", "serialid": 216, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '80da5984-53fc-4439-a4b2-2aa030416ddf', 'INSERT', '{"uuid": "80da5984-53fc-4439-a4b2-2aa030416ddf", "roletype": "OWNER", "objectuuid": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2715a520-f38d-486b-9053-055f6289c966', 'INSERT', '{"op": "DELETE", "uuid": "2715a520-f38d-486b-9053-055f6289c966", "objectuuid": "a13af5de-4315-46dd-ae08-427ea72b35a0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '869b3806-564d-4c47-a7ca-bb7285365647', 'INSERT', '{"uuid": "869b3806-564d-4c47-a7ca-bb7285365647", "assumed": true, "ascendantuuid": "80da5984-53fc-4439-a4b2-2aa030416ddf", "descendantuuid": "2715a520-f38d-486b-9053-055f6289c966", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '774a242d-e8b0-416f-9c72-a68ffebe0315', 'INSERT', '{"uuid": "774a242d-e8b0-416f-9c72-a68ffebe0315", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "80da5984-53fc-4439-a4b2-2aa030416ddf", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '45130952-0637-4191-88e6-9398918afd0d', 'INSERT', '{"uuid": "45130952-0637-4191-88e6-9398918afd0d", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "80da5984-53fc-4439-a4b2-2aa030416ddf", "grantedbyroleuuid": "80da5984-53fc-4439-a4b2-2aa030416ddf", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8f1fbdf5-7aba-43d7-932e-a9e4f386ae84', 'INSERT', '{"uuid": "8f1fbdf5-7aba-43d7-932e-a9e4f386ae84", "roletype": "ADMIN", "objectuuid": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '1a09398f-873b-4c9a-9392-c129ccf0d636', 'INSERT', '{"op": "UPDATE", "uuid": "1a09398f-873b-4c9a-9392-c129ccf0d636", "objectuuid": "a13af5de-4315-46dd-ae08-427ea72b35a0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'face9f8a-f956-4f10-a47c-0f7af36fda49', 'INSERT', '{"uuid": "face9f8a-f956-4f10-a47c-0f7af36fda49", "assumed": true, "ascendantuuid": "8f1fbdf5-7aba-43d7-932e-a9e4f386ae84", "descendantuuid": "1a09398f-873b-4c9a-9392-c129ccf0d636", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '22d3b5e6-c4d4-45cd-99da-8008b2040278', 'INSERT', '{"uuid": "22d3b5e6-c4d4-45cd-99da-8008b2040278", "assumed": true, "ascendantuuid": "80da5984-53fc-4439-a4b2-2aa030416ddf", "descendantuuid": "8f1fbdf5-7aba-43d7-932e-a9e4f386ae84", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '46a6fc92-c738-40d2-be20-7762997fdd21', 'INSERT', '{"uuid": "46a6fc92-c738-40d2-be20-7762997fdd21", "roletype": "AGENT", "objectuuid": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b0dd85e2-83d4-4f03-b24a-db9db12cf607', 'INSERT', '{"uuid": "b0dd85e2-83d4-4f03-b24a-db9db12cf607", "assumed": true, "ascendantuuid": "8f1fbdf5-7aba-43d7-932e-a9e4f386ae84", "descendantuuid": "46a6fc92-c738-40d2-be20-7762997fdd21", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '9fc0d602-3a23-4ce9-b8eb-216e58c23cb6', 'INSERT', '{"uuid": "9fc0d602-3a23-4ce9-b8eb-216e58c23cb6", "roletype": "TENANT", "objectuuid": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '44074e80-79cc-4965-9525-29ed20419544', 'INSERT', '{"op": "SELECT", "uuid": "44074e80-79cc-4965-9525-29ed20419544", "objectuuid": "a13af5de-4315-46dd-ae08-427ea72b35a0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dac85b6b-4dd2-42b2-a151-b8dfce5b2bd5', 'INSERT', '{"uuid": "dac85b6b-4dd2-42b2-a151-b8dfce5b2bd5", "assumed": true, "ascendantuuid": "9fc0d602-3a23-4ce9-b8eb-216e58c23cb6", "descendantuuid": "44074e80-79cc-4965-9525-29ed20419544", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3878bbdd-11c5-47b0-9e20-c70896c918cb', 'INSERT', '{"uuid": "3878bbdd-11c5-47b0-9e20-c70896c918cb", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "9fc0d602-3a23-4ce9-b8eb-216e58c23cb6", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9b63a093-30f1-4628-80e9-a7baf79a4ebc', 'INSERT', '{"uuid": "9b63a093-30f1-4628-80e9-a7baf79a4ebc", "assumed": true, "ascendantuuid": "46a6fc92-c738-40d2-be20-7762997fdd21", "descendantuuid": "9fc0d602-3a23-4ce9-b8eb-216e58c23cb6", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fd33e269-1be7-4616-b094-5e0ae35a65a7', 'INSERT', '{"uuid": "fd33e269-1be7-4616-b094-5e0ae35a65a7", "assumed": true, "ascendantuuid": "9fc0d602-3a23-4ce9-b8eb-216e58c23cb6", "descendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '26b6187d-24dd-4f65-b5a4-a6d8095a4c16', 'INSERT', '{"uuid": "26b6187d-24dd-4f65-b5a4-a6d8095a4c16", "assumed": true, "ascendantuuid": "9fc0d602-3a23-4ce9-b8eb-216e58c23cb6", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c9e8265f-376e-454c-a97b-aff7a2e3cf3d', 'INSERT', '{"uuid": "c9e8265f-376e-454c-a97b-aff7a2e3cf3d", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "46a6fc92-c738-40d2-be20-7762997fdd21", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '313114d1-83cc-4289-959b-e5068b98e0ea', 'INSERT', '{"uuid": "313114d1-83cc-4289-959b-e5068b98e0ea", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "80da5984-53fc-4439-a4b2-2aa030416ddf", "grantedbyroleuuid": null, "grantedbytriggerof": "a13af5de-4315-46dd-ae08-427ea72b35a0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'a13af5de-4315-46dd-ae08-427ea72b35a0', 'INSERT', '{"mark": "members-announce", "type": "SUBSCRIBER", "uuid": "a13af5de-4315-46dd-ae08-427ea72b35a0", "version": 0, "anchoruuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "holderuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "contactuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', 'INSERT', '{"uuid": "cea1bd90-a42c-4cbf-97c3-33c134537bfc", "serialid": 217, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'ab127630-3367-4898-b0d7-f3ef0f6fb7cf', 'INSERT', '{"op": "DELETE", "uuid": "ab127630-3367-4898-b0d7-f3ef0f6fb7cf", "objectuuid": "cea1bd90-a42c-4cbf-97c3-33c134537bfc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd114921e-f2b3-4530-aeac-c318b0456251', 'INSERT', '{"uuid": "d114921e-f2b3-4530-aeac-c318b0456251", "assumed": true, "ascendantuuid": "201bce64-1c53-4047-bfd3-1892e4bb545f", "descendantuuid": "ab127630-3367-4898-b0d7-f3ef0f6fb7cf", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '549a494a-cb4c-4b9e-ae81-c386e0cd0ab1', 'INSERT', '{"uuid": "549a494a-cb4c-4b9e-ae81-c386e0cd0ab1", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "201bce64-1c53-4047-bfd3-1892e4bb545f", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c48c846e-f9c3-43c7-adea-e54cddfe9f2a', 'INSERT', '{"uuid": "c48c846e-f9c3-43c7-adea-e54cddfe9f2a", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "201bce64-1c53-4047-bfd3-1892e4bb545f", "grantedbyroleuuid": "201bce64-1c53-4047-bfd3-1892e4bb545f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5927cb7b-54a9-429d-a229-d3ab87cccecb', 'INSERT', '{"uuid": "5927cb7b-54a9-429d-a229-d3ab87cccecb", "roletype": "ADMIN", "objectuuid": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '53f0c6bb-a76b-4f8d-81f9-a476c9106436', 'INSERT', '{"op": "UPDATE", "uuid": "53f0c6bb-a76b-4f8d-81f9-a476c9106436", "objectuuid": "cea1bd90-a42c-4cbf-97c3-33c134537bfc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '01aa4b8c-b7d7-446b-80a8-d2ed6eaeb321', 'INSERT', '{"uuid": "01aa4b8c-b7d7-446b-80a8-d2ed6eaeb321", "assumed": true, "ascendantuuid": "5927cb7b-54a9-429d-a229-d3ab87cccecb", "descendantuuid": "53f0c6bb-a76b-4f8d-81f9-a476c9106436", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dd21baf1-92df-4d7b-9b61-ac7870a870a5', 'INSERT', '{"uuid": "dd21baf1-92df-4d7b-9b61-ac7870a870a5", "assumed": true, "ascendantuuid": "201bce64-1c53-4047-bfd3-1892e4bb545f", "descendantuuid": "5927cb7b-54a9-429d-a229-d3ab87cccecb", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b2c4c782-4afe-4518-8c92-0de8c70b70b2', 'INSERT', '{"uuid": "b2c4c782-4afe-4518-8c92-0de8c70b70b2", "roletype": "AGENT", "objectuuid": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'db27b1dc-0c50-4cf4-a029-1496adfdbcd0', 'INSERT', '{"uuid": "db27b1dc-0c50-4cf4-a029-1496adfdbcd0", "assumed": true, "ascendantuuid": "5927cb7b-54a9-429d-a229-d3ab87cccecb", "descendantuuid": "b2c4c782-4afe-4518-8c92-0de8c70b70b2", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5a04d74f-230c-451d-ad05-3f08d0e95b0b', 'INSERT', '{"uuid": "5a04d74f-230c-451d-ad05-3f08d0e95b0b", "roletype": "TENANT", "objectuuid": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '88d7ad95-2568-4cfe-8f1c-e09ac9fe8983', 'INSERT', '{"op": "SELECT", "uuid": "88d7ad95-2568-4cfe-8f1c-e09ac9fe8983", "objectuuid": "cea1bd90-a42c-4cbf-97c3-33c134537bfc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd9dc0aac-67e0-4844-a34f-5f5485f9fb49', 'INSERT', '{"uuid": "d9dc0aac-67e0-4844-a34f-5f5485f9fb49", "assumed": true, "ascendantuuid": "5a04d74f-230c-451d-ad05-3f08d0e95b0b", "descendantuuid": "88d7ad95-2568-4cfe-8f1c-e09ac9fe8983", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0b50edc0-4338-44b7-8053-be59f47bf734', 'INSERT', '{"uuid": "0b50edc0-4338-44b7-8053-be59f47bf734", "assumed": true, "ascendantuuid": "4241127c-1c6d-41b4-9350-3aa73785f6c5", "descendantuuid": "5a04d74f-230c-451d-ad05-3f08d0e95b0b", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '31f4ead0-bcc1-4092-a334-0252cb746d85', 'INSERT', '{"uuid": "31f4ead0-bcc1-4092-a334-0252cb746d85", "assumed": true, "ascendantuuid": "b2c4c782-4afe-4518-8c92-0de8c70b70b2", "descendantuuid": "5a04d74f-230c-451d-ad05-3f08d0e95b0b", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bca29c27-e651-4eaa-823b-e6f257666696', 'INSERT', '{"uuid": "bca29c27-e651-4eaa-823b-e6f257666696", "assumed": true, "ascendantuuid": "5a04d74f-230c-451d-ad05-3f08d0e95b0b", "descendantuuid": "206fcdf2-c22e-480f-9029-42183cc2990e", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '03d88972-e76d-48da-8474-86285c42fb0a', 'INSERT', '{"uuid": "03d88972-e76d-48da-8474-86285c42fb0a", "assumed": true, "ascendantuuid": "5a04d74f-230c-451d-ad05-3f08d0e95b0b", "descendantuuid": "bdeffe17-405f-4ad0-8131-82728ea0e382", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '020a2ccd-31a8-4a54-8dbe-2acbd6bac42f', 'INSERT', '{"uuid": "020a2ccd-31a8-4a54-8dbe-2acbd6bac42f", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "b2c4c782-4afe-4518-8c92-0de8c70b70b2", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '01125877-8fa2-42f1-a7df-a0dc6e7a6789', 'INSERT', '{"uuid": "01125877-8fa2-42f1-a7df-a0dc6e7a6789", "assumed": true, "ascendantuuid": "1373e547-4804-4c8d-9014-ce51c65f3a06", "descendantuuid": "201bce64-1c53-4047-bfd3-1892e4bb545f", "grantedbyroleuuid": null, "grantedbytriggerof": "cea1bd90-a42c-4cbf-97c3-33c134537bfc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', 'INSERT', '{"mark": "members-discussion", "type": "SUBSCRIBER", "uuid": "cea1bd90-a42c-4cbf-97c3-33c134537bfc", "version": 0, "anchoruuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "holderuuid": "a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763", "contactuuid": "4997dce8-4927-4a10-a7b3-16c574eb79c9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', 'INSERT', '{"uuid": "fac4bfec-9f0b-427f-b032-ca54188d0a76", "serialid": 218, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '32326817-2750-452c-8898-bcb42c36d85f', 'INSERT', '{"uuid": "32326817-2750-452c-8898-bcb42c36d85f", "roletype": "OWNER", "objectuuid": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'dd52b6d9-4a90-4a10-9ca8-3d8094a0aadd', 'INSERT', '{"op": "DELETE", "uuid": "dd52b6d9-4a90-4a10-9ca8-3d8094a0aadd", "objectuuid": "fac4bfec-9f0b-427f-b032-ca54188d0a76", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4ea51bc6-c651-4d38-bf2a-ab9686d376ca', 'INSERT', '{"uuid": "4ea51bc6-c651-4d38-bf2a-ab9686d376ca", "assumed": true, "ascendantuuid": "32326817-2750-452c-8898-bcb42c36d85f", "descendantuuid": "dd52b6d9-4a90-4a10-9ca8-3d8094a0aadd", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '282e731f-a9ff-4f44-9c93-431614440eb3', 'INSERT', '{"uuid": "282e731f-a9ff-4f44-9c93-431614440eb3", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "32326817-2750-452c-8898-bcb42c36d85f", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8ed063cd-8a99-4619-913e-961b3c5d538b', 'INSERT', '{"uuid": "8ed063cd-8a99-4619-913e-961b3c5d538b", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "32326817-2750-452c-8898-bcb42c36d85f", "grantedbyroleuuid": "32326817-2750-452c-8898-bcb42c36d85f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'f7c2a405-965c-48a4-aecb-4312952d072e', 'INSERT', '{"uuid": "f7c2a405-965c-48a4-aecb-4312952d072e", "roletype": "ADMIN", "objectuuid": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '138ab6b6-1b04-4565-bbcf-db30047e0050', 'INSERT', '{"op": "UPDATE", "uuid": "138ab6b6-1b04-4565-bbcf-db30047e0050", "objectuuid": "fac4bfec-9f0b-427f-b032-ca54188d0a76", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '696f7628-61c5-4406-820d-e85d8774e048', 'INSERT', '{"uuid": "696f7628-61c5-4406-820d-e85d8774e048", "assumed": true, "ascendantuuid": "f7c2a405-965c-48a4-aecb-4312952d072e", "descendantuuid": "138ab6b6-1b04-4565-bbcf-db30047e0050", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '803c73ee-d210-430d-939d-47e2ec8b4bf0', 'INSERT', '{"uuid": "803c73ee-d210-430d-939d-47e2ec8b4bf0", "assumed": true, "ascendantuuid": "32326817-2750-452c-8898-bcb42c36d85f", "descendantuuid": "f7c2a405-965c-48a4-aecb-4312952d072e", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'a67d167a-e0da-4fe0-b2a1-cc320687f44a', 'INSERT', '{"uuid": "a67d167a-e0da-4fe0-b2a1-cc320687f44a", "roletype": "AGENT", "objectuuid": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dd56533a-5068-4349-837b-7847a26884b0', 'INSERT', '{"uuid": "dd56533a-5068-4349-837b-7847a26884b0", "assumed": true, "ascendantuuid": "f7c2a405-965c-48a4-aecb-4312952d072e", "descendantuuid": "a67d167a-e0da-4fe0-b2a1-cc320687f44a", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ab46de32-5a21-4029-b5c2-517f6d6002c3', 'INSERT', '{"uuid": "ab46de32-5a21-4029-b5c2-517f6d6002c3", "roletype": "TENANT", "objectuuid": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'beec505c-c47c-46ff-bdb5-7fe04a5595c6', 'INSERT', '{"op": "SELECT", "uuid": "beec505c-c47c-46ff-bdb5-7fe04a5595c6", "objectuuid": "fac4bfec-9f0b-427f-b032-ca54188d0a76", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cc35556d-69d7-40f7-9d44-103a60e2d871', 'INSERT', '{"uuid": "cc35556d-69d7-40f7-9d44-103a60e2d871", "assumed": true, "ascendantuuid": "ab46de32-5a21-4029-b5c2-517f6d6002c3", "descendantuuid": "beec505c-c47c-46ff-bdb5-7fe04a5595c6", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '41500a4e-22af-47f9-a4f4-8af1b28c4c33', 'INSERT', '{"uuid": "41500a4e-22af-47f9-a4f4-8af1b28c4c33", "assumed": true, "ascendantuuid": "d3aa37e9-88d7-4099-8fa8-0bb25f6db328", "descendantuuid": "ab46de32-5a21-4029-b5c2-517f6d6002c3", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6d9a0688-78d3-499e-89cb-3cec3597c28b', 'INSERT', '{"uuid": "6d9a0688-78d3-499e-89cb-3cec3597c28b", "assumed": true, "ascendantuuid": "a67d167a-e0da-4fe0-b2a1-cc320687f44a", "descendantuuid": "ab46de32-5a21-4029-b5c2-517f6d6002c3", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2d444fb7-5554-4721-ba46-9b3d7fa1255b', 'INSERT', '{"uuid": "2d444fb7-5554-4721-ba46-9b3d7fa1255b", "assumed": true, "ascendantuuid": "ab46de32-5a21-4029-b5c2-517f6d6002c3", "descendantuuid": "3f62e7fa-ffed-4a15-88c2-2d4a231c7db0", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5b99af89-725d-472e-996f-8a0cabbddef1', 'INSERT', '{"uuid": "5b99af89-725d-472e-996f-8a0cabbddef1", "assumed": true, "ascendantuuid": "ab46de32-5a21-4029-b5c2-517f6d6002c3", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c3376d95-4f15-4c1d-94a5-1cb9ecaa819d', 'INSERT', '{"uuid": "c3376d95-4f15-4c1d-94a5-1cb9ecaa819d", "assumed": true, "ascendantuuid": "ab46de32-5a21-4029-b5c2-517f6d6002c3", "descendantuuid": "96d81c1c-7d32-4b58-b7d3-7d7d88d250b7", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd21c8c1e-b2f3-4aa6-8e1d-15fdbaaf521e', 'INSERT', '{"uuid": "d21c8c1e-b2f3-4aa6-8e1d-15fdbaaf521e", "assumed": true, "ascendantuuid": "957da54d-43eb-45d5-a3c4-34976d178bf3", "descendantuuid": "a67d167a-e0da-4fe0-b2a1-cc320687f44a", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e1ab8227-6ba0-4a77-a029-625d58c33d7e', 'INSERT', '{"uuid": "e1ab8227-6ba0-4a77-a029-625d58c33d7e", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "32326817-2750-452c-8898-bcb42c36d85f", "grantedbyroleuuid": null, "grantedbytriggerof": "fac4bfec-9f0b-427f-b032-ca54188d0a76"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "fac4bfec-9f0b-427f-b032-ca54188d0a76", "version": 0, "anchoruuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "holderuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "contactuuid": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 'INSERT', '{"uuid": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3", "serialid": 219, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd5048fcc-cb35-4f37-bfdc-611473026b50', 'INSERT', '{"uuid": "d5048fcc-cb35-4f37-bfdc-611473026b50", "roletype": "OWNER", "objectuuid": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'ebf101f3-6206-4cd7-a5df-276dcec51cba', 'INSERT', '{"op": "DELETE", "uuid": "ebf101f3-6206-4cd7-a5df-276dcec51cba", "objectuuid": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '711505a2-74a7-46e5-bcf7-f78f7abe07c2', 'INSERT', '{"uuid": "711505a2-74a7-46e5-bcf7-f78f7abe07c2", "assumed": true, "ascendantuuid": "d5048fcc-cb35-4f37-bfdc-611473026b50", "descendantuuid": "ebf101f3-6206-4cd7-a5df-276dcec51cba", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6400872d-bfea-4616-92c5-3a5b9e49b568', 'INSERT', '{"uuid": "6400872d-bfea-4616-92c5-3a5b9e49b568", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "d5048fcc-cb35-4f37-bfdc-611473026b50", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1b459f37-35d9-461e-b10f-619a69fd5d1f', 'INSERT', '{"uuid": "1b459f37-35d9-461e-b10f-619a69fd5d1f", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "d5048fcc-cb35-4f37-bfdc-611473026b50", "grantedbyroleuuid": "d5048fcc-cb35-4f37-bfdc-611473026b50", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7', 'INSERT', '{"uuid": "2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7", "roletype": "ADMIN", "objectuuid": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '31faa035-267f-46d2-b9b1-af688c393431', 'INSERT', '{"op": "UPDATE", "uuid": "31faa035-267f-46d2-b9b1-af688c393431", "objectuuid": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2bdd1162-d22a-41f1-8d62-76d00859b2dd', 'INSERT', '{"uuid": "2bdd1162-d22a-41f1-8d62-76d00859b2dd", "assumed": true, "ascendantuuid": "2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7", "descendantuuid": "31faa035-267f-46d2-b9b1-af688c393431", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1069eeff-cd63-4704-9fb0-5d90f52e2d1f', 'INSERT', '{"uuid": "1069eeff-cd63-4704-9fb0-5d90f52e2d1f", "assumed": true, "ascendantuuid": "d5048fcc-cb35-4f37-bfdc-611473026b50", "descendantuuid": "2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '13854f26-4d9d-411f-a6a8-d1cf8c267a32', 'INSERT', '{"uuid": "13854f26-4d9d-411f-a6a8-d1cf8c267a32", "roletype": "AGENT", "objectuuid": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0b6a0e6c-a348-4012-afcd-31559085775a', 'INSERT', '{"uuid": "0b6a0e6c-a348-4012-afcd-31559085775a", "assumed": true, "ascendantuuid": "2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7", "descendantuuid": "13854f26-4d9d-411f-a6a8-d1cf8c267a32", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '44900785-555c-468f-9aa1-277c191fc3a6', 'INSERT', '{"uuid": "44900785-555c-468f-9aa1-277c191fc3a6", "roletype": "TENANT", "objectuuid": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '2b33fc20-f3b2-474c-9d9e-40be8240e900', 'INSERT', '{"op": "SELECT", "uuid": "2b33fc20-f3b2-474c-9d9e-40be8240e900", "objectuuid": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3fa17011-0e90-454f-943c-f287b530fb2a', 'INSERT', '{"uuid": "3fa17011-0e90-454f-943c-f287b530fb2a", "assumed": true, "ascendantuuid": "44900785-555c-468f-9aa1-277c191fc3a6", "descendantuuid": "2b33fc20-f3b2-474c-9d9e-40be8240e900", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '79f93e0c-49f6-4906-a2b8-d95b28c23d9f', 'INSERT', '{"uuid": "79f93e0c-49f6-4906-a2b8-d95b28c23d9f", "assumed": true, "ascendantuuid": "d3aa37e9-88d7-4099-8fa8-0bb25f6db328", "descendantuuid": "44900785-555c-468f-9aa1-277c191fc3a6", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9b98cf31-9486-4214-a564-1f60b7a71abb', 'INSERT', '{"uuid": "9b98cf31-9486-4214-a564-1f60b7a71abb", "assumed": true, "ascendantuuid": "13854f26-4d9d-411f-a6a8-d1cf8c267a32", "descendantuuid": "44900785-555c-468f-9aa1-277c191fc3a6", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5e524f54-2607-45cd-a168-6e9d84211128', 'INSERT', '{"uuid": "5e524f54-2607-45cd-a168-6e9d84211128", "assumed": true, "ascendantuuid": "44900785-555c-468f-9aa1-277c191fc3a6", "descendantuuid": "3f62e7fa-ffed-4a15-88c2-2d4a231c7db0", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '05854007-d696-4479-a4fe-abece95d2523', 'INSERT', '{"uuid": "05854007-d696-4479-a4fe-abece95d2523", "assumed": true, "ascendantuuid": "44900785-555c-468f-9aa1-277c191fc3a6", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a23ef302-960c-4bfb-885e-116acbddeaba', 'INSERT', '{"uuid": "a23ef302-960c-4bfb-885e-116acbddeaba", "assumed": true, "ascendantuuid": "44900785-555c-468f-9aa1-277c191fc3a6", "descendantuuid": "96d81c1c-7d32-4b58-b7d3-7d7d88d250b7", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ba50a550-d607-4a56-94a9-e41246052b1e', 'INSERT', '{"uuid": "ba50a550-d607-4a56-94a9-e41246052b1e", "assumed": true, "ascendantuuid": "957da54d-43eb-45d5-a3c4-34976d178bf3", "descendantuuid": "13854f26-4d9d-411f-a6a8-d1cf8c267a32", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dc55d2f6-b265-44bb-a98e-b7c3592e3291', 'INSERT', '{"uuid": "dc55d2f6-b265-44bb-a98e-b7c3592e3291", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "d5048fcc-cb35-4f37-bfdc-611473026b50", "grantedbyroleuuid": null, "grantedbytriggerof": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "867a7a28-0ad7-4310-b7de-3d5615d0bfa3", "version": 0, "anchoruuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "holderuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "contactuuid": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '18124f89-8ce6-4813-8efe-3ed47b7eb453', 'INSERT', '{"uuid": "18124f89-8ce6-4813-8efe-3ed47b7eb453", "serialid": 220, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'a24b3dcc-92b3-475f-8741-4399f604e189', 'INSERT', '{"uuid": "a24b3dcc-92b3-475f-8741-4399f604e189", "roletype": "OWNER", "objectuuid": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '36c7d299-20b9-47b4-a2ed-bd7031ad3dd1', 'INSERT', '{"op": "DELETE", "uuid": "36c7d299-20b9-47b4-a2ed-bd7031ad3dd1", "objectuuid": "18124f89-8ce6-4813-8efe-3ed47b7eb453", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dbe1cefb-01f0-4b91-8cb0-6e2c52397406', 'INSERT', '{"uuid": "dbe1cefb-01f0-4b91-8cb0-6e2c52397406", "assumed": true, "ascendantuuid": "a24b3dcc-92b3-475f-8741-4399f604e189", "descendantuuid": "36c7d299-20b9-47b4-a2ed-bd7031ad3dd1", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b644db95-825b-45ad-9154-7c6eb6ff1acd', 'INSERT', '{"uuid": "b644db95-825b-45ad-9154-7c6eb6ff1acd", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "a24b3dcc-92b3-475f-8741-4399f604e189", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4755567d-e545-4f6d-b64a-963637a12b87', 'INSERT', '{"uuid": "4755567d-e545-4f6d-b64a-963637a12b87", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "a24b3dcc-92b3-475f-8741-4399f604e189", "grantedbyroleuuid": "a24b3dcc-92b3-475f-8741-4399f604e189", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1d6da0f9-048c-4b62-bedd-5f4d4d35b284', 'INSERT', '{"uuid": "1d6da0f9-048c-4b62-bedd-5f4d4d35b284", "roletype": "ADMIN", "objectuuid": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '95ad7ff4-f585-48c5-945a-1a87c3bb2229', 'INSERT', '{"op": "UPDATE", "uuid": "95ad7ff4-f585-48c5-945a-1a87c3bb2229", "objectuuid": "18124f89-8ce6-4813-8efe-3ed47b7eb453", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '450d6656-4d24-44d4-b9ce-7423e413dbfb', 'INSERT', '{"uuid": "450d6656-4d24-44d4-b9ce-7423e413dbfb", "assumed": true, "ascendantuuid": "1d6da0f9-048c-4b62-bedd-5f4d4d35b284", "descendantuuid": "95ad7ff4-f585-48c5-945a-1a87c3bb2229", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '6479f241-dfad-499f-bc9e-45ccfa2f19eb', 'INSERT', '{"uuid": "6479f241-dfad-499f-bc9e-45ccfa2f19eb", "assumed": true, "ascendantuuid": "a24b3dcc-92b3-475f-8741-4399f604e189", "descendantuuid": "1d6da0f9-048c-4b62-bedd-5f4d4d35b284", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '33bff6f5-22a5-4a5c-bcf1-1e3003bcf530', 'INSERT', '{"uuid": "33bff6f5-22a5-4a5c-bcf1-1e3003bcf530", "roletype": "AGENT", "objectuuid": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '76b61779-3f11-44af-aab5-48fa969c9a5b', 'INSERT', '{"uuid": "76b61779-3f11-44af-aab5-48fa969c9a5b", "assumed": true, "ascendantuuid": "1d6da0f9-048c-4b62-bedd-5f4d4d35b284", "descendantuuid": "33bff6f5-22a5-4a5c-bcf1-1e3003bcf530", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'eebc57f5-8fbd-4665-9328-78b0a6600478', 'INSERT', '{"uuid": "eebc57f5-8fbd-4665-9328-78b0a6600478", "roletype": "TENANT", "objectuuid": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '1be5be35-a23a-4f02-967b-f4a7237f482a', 'INSERT', '{"op": "SELECT", "uuid": "1be5be35-a23a-4f02-967b-f4a7237f482a", "objectuuid": "18124f89-8ce6-4813-8efe-3ed47b7eb453", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f3c72143-eeca-460a-a7cc-6f9220c810af', 'INSERT', '{"uuid": "f3c72143-eeca-460a-a7cc-6f9220c810af", "assumed": true, "ascendantuuid": "eebc57f5-8fbd-4665-9328-78b0a6600478", "descendantuuid": "1be5be35-a23a-4f02-967b-f4a7237f482a", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a16d0761-a5ec-4dcb-8921-41d145e326dd', 'INSERT', '{"uuid": "a16d0761-a5ec-4dcb-8921-41d145e326dd", "assumed": true, "ascendantuuid": "d3aa37e9-88d7-4099-8fa8-0bb25f6db328", "descendantuuid": "eebc57f5-8fbd-4665-9328-78b0a6600478", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3fe5ffb0-c3a5-45b6-9f8f-25c200062b8d', 'INSERT', '{"uuid": "3fe5ffb0-c3a5-45b6-9f8f-25c200062b8d", "assumed": true, "ascendantuuid": "33bff6f5-22a5-4a5c-bcf1-1e3003bcf530", "descendantuuid": "eebc57f5-8fbd-4665-9328-78b0a6600478", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fbb0d745-15bc-4e97-a72d-383ff3ce3b91', 'INSERT', '{"uuid": "fbb0d745-15bc-4e97-a72d-383ff3ce3b91", "assumed": true, "ascendantuuid": "eebc57f5-8fbd-4665-9328-78b0a6600478", "descendantuuid": "3f62e7fa-ffed-4a15-88c2-2d4a231c7db0", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5205f110-721f-4e35-a47b-94b36cf3c7f2', 'INSERT', '{"uuid": "5205f110-721f-4e35-a47b-94b36cf3c7f2", "assumed": true, "ascendantuuid": "eebc57f5-8fbd-4665-9328-78b0a6600478", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '97c8d585-7e82-439a-b062-a010baf72200', 'INSERT', '{"uuid": "97c8d585-7e82-439a-b062-a010baf72200", "assumed": true, "ascendantuuid": "eebc57f5-8fbd-4665-9328-78b0a6600478", "descendantuuid": "96d81c1c-7d32-4b58-b7d3-7d7d88d250b7", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9b9e5987-ef87-43a0-ab02-aa74a30a81a8', 'INSERT', '{"uuid": "9b9e5987-ef87-43a0-ab02-aa74a30a81a8", "assumed": true, "ascendantuuid": "957da54d-43eb-45d5-a3c4-34976d178bf3", "descendantuuid": "33bff6f5-22a5-4a5c-bcf1-1e3003bcf530", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b66437d8-25cc-48f6-9fed-56ebb854d5dd', 'INSERT', '{"uuid": "b66437d8-25cc-48f6-9fed-56ebb854d5dd", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "a24b3dcc-92b3-475f-8741-4399f604e189", "grantedbyroleuuid": null, "grantedbytriggerof": "18124f89-8ce6-4813-8efe-3ed47b7eb453"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '18124f89-8ce6-4813-8efe-3ed47b7eb453', 'INSERT', '{"mark": "operations-discussion", "type": "SUBSCRIBER", "uuid": "18124f89-8ce6-4813-8efe-3ed47b7eb453", "version": 0, "anchoruuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "holderuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "contactuuid": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'cbda6432-b849-4787-84ab-88e680dbfa72', 'INSERT', '{"uuid": "cbda6432-b849-4787-84ab-88e680dbfa72", "serialid": 221, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'cf88430b-e0a1-431e-9912-098933e6771c', 'INSERT', '{"uuid": "cf88430b-e0a1-431e-9912-098933e6771c", "roletype": "OWNER", "objectuuid": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'eb9181ce-7b72-4ed9-93aa-49eb66db32eb', 'INSERT', '{"op": "DELETE", "uuid": "eb9181ce-7b72-4ed9-93aa-49eb66db32eb", "objectuuid": "cbda6432-b849-4787-84ab-88e680dbfa72", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f47d3670-a996-43b9-ac56-bc64167bf8e9', 'INSERT', '{"uuid": "f47d3670-a996-43b9-ac56-bc64167bf8e9", "assumed": true, "ascendantuuid": "cf88430b-e0a1-431e-9912-098933e6771c", "descendantuuid": "eb9181ce-7b72-4ed9-93aa-49eb66db32eb", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bf388cd5-754d-4a67-a900-74c8ae8d0763', 'INSERT', '{"uuid": "bf388cd5-754d-4a67-a900-74c8ae8d0763", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "cf88430b-e0a1-431e-9912-098933e6771c", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '04ee36e9-7e18-455b-bec1-f850ccc4fa03', 'INSERT', '{"uuid": "04ee36e9-7e18-455b-bec1-f850ccc4fa03", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "cf88430b-e0a1-431e-9912-098933e6771c", "grantedbyroleuuid": "cf88430b-e0a1-431e-9912-098933e6771c", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5f9120b4-56a8-4a73-96bb-2fd1edcfbf43', 'INSERT', '{"uuid": "5f9120b4-56a8-4a73-96bb-2fd1edcfbf43", "roletype": "ADMIN", "objectuuid": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'f9768956-c483-4cf1-852d-b6767a8d96cc', 'INSERT', '{"op": "UPDATE", "uuid": "f9768956-c483-4cf1-852d-b6767a8d96cc", "objectuuid": "cbda6432-b849-4787-84ab-88e680dbfa72", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b8521069-8984-42f5-ad51-92f0bf13da89', 'INSERT', '{"uuid": "b8521069-8984-42f5-ad51-92f0bf13da89", "assumed": true, "ascendantuuid": "5f9120b4-56a8-4a73-96bb-2fd1edcfbf43", "descendantuuid": "f9768956-c483-4cf1-852d-b6767a8d96cc", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '832b6b8c-1734-43e9-b1a9-15b3fbf6bf25', 'INSERT', '{"uuid": "832b6b8c-1734-43e9-b1a9-15b3fbf6bf25", "assumed": true, "ascendantuuid": "cf88430b-e0a1-431e-9912-098933e6771c", "descendantuuid": "5f9120b4-56a8-4a73-96bb-2fd1edcfbf43", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '12a30425-8c0e-4e0d-b9ae-da96e2776217', 'INSERT', '{"uuid": "12a30425-8c0e-4e0d-b9ae-da96e2776217", "roletype": "AGENT", "objectuuid": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '86891920-aabe-4630-a89e-4bce541e351c', 'INSERT', '{"uuid": "86891920-aabe-4630-a89e-4bce541e351c", "assumed": true, "ascendantuuid": "5f9120b4-56a8-4a73-96bb-2fd1edcfbf43", "descendantuuid": "12a30425-8c0e-4e0d-b9ae-da96e2776217", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '917b274c-a8da-403c-9ac2-5be884f4a47f', 'INSERT', '{"uuid": "917b274c-a8da-403c-9ac2-5be884f4a47f", "roletype": "TENANT", "objectuuid": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'a37b1549-de63-4830-81ab-816dbea5ddf9', 'INSERT', '{"op": "SELECT", "uuid": "a37b1549-de63-4830-81ab-816dbea5ddf9", "objectuuid": "cbda6432-b849-4787-84ab-88e680dbfa72", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'df32434f-3f53-4421-9a54-91a734df8b09', 'INSERT', '{"uuid": "df32434f-3f53-4421-9a54-91a734df8b09", "assumed": true, "ascendantuuid": "917b274c-a8da-403c-9ac2-5be884f4a47f", "descendantuuid": "a37b1549-de63-4830-81ab-816dbea5ddf9", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'da816bce-54d8-4bfd-be4a-107ff0e28ae9', 'INSERT', '{"uuid": "da816bce-54d8-4bfd-be4a-107ff0e28ae9", "assumed": true, "ascendantuuid": "d3aa37e9-88d7-4099-8fa8-0bb25f6db328", "descendantuuid": "917b274c-a8da-403c-9ac2-5be884f4a47f", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7b905937-6603-4649-b2fc-f3c294a5506e', 'INSERT', '{"uuid": "7b905937-6603-4649-b2fc-f3c294a5506e", "assumed": true, "ascendantuuid": "12a30425-8c0e-4e0d-b9ae-da96e2776217", "descendantuuid": "917b274c-a8da-403c-9ac2-5be884f4a47f", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '601bf4bf-ed9e-4d04-bfcc-f50e7d9720fc', 'INSERT', '{"uuid": "601bf4bf-ed9e-4d04-bfcc-f50e7d9720fc", "assumed": true, "ascendantuuid": "917b274c-a8da-403c-9ac2-5be884f4a47f", "descendantuuid": "3f62e7fa-ffed-4a15-88c2-2d4a231c7db0", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd18a77de-532d-44d3-8759-87b41db913e9', 'INSERT', '{"uuid": "d18a77de-532d-44d3-8759-87b41db913e9", "assumed": true, "ascendantuuid": "917b274c-a8da-403c-9ac2-5be884f4a47f", "descendantuuid": "e97003a9-9162-4142-8d08-814e6c8fabd9", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8629ae4f-a025-4264-a2ad-24cdb50f24fd', 'INSERT', '{"uuid": "8629ae4f-a025-4264-a2ad-24cdb50f24fd", "assumed": true, "ascendantuuid": "917b274c-a8da-403c-9ac2-5be884f4a47f", "descendantuuid": "96d81c1c-7d32-4b58-b7d3-7d7d88d250b7", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ec402129-b125-44df-8dd1-919c43709a99', 'INSERT', '{"uuid": "ec402129-b125-44df-8dd1-919c43709a99", "assumed": true, "ascendantuuid": "957da54d-43eb-45d5-a3c4-34976d178bf3", "descendantuuid": "12a30425-8c0e-4e0d-b9ae-da96e2776217", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b986a66d-e06f-4c7c-a71b-b8ba4dd9ffd8', 'INSERT', '{"uuid": "b986a66d-e06f-4c7c-a71b-b8ba4dd9ffd8", "assumed": true, "ascendantuuid": "95f09796-be4b-4b39-a759-a1f5a4fe54fb", "descendantuuid": "cf88430b-e0a1-431e-9912-098933e6771c", "grantedbyroleuuid": null, "grantedbytriggerof": "cbda6432-b849-4787-84ab-88e680dbfa72"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'cbda6432-b849-4787-84ab-88e680dbfa72', 'INSERT', '{"mark": "operations-announce", "type": "SUBSCRIBER", "uuid": "cbda6432-b849-4787-84ab-88e680dbfa72", "version": 0, "anchoruuid": "38cc5d59-085f-449e-aeb3-439febbabd9b", "holderuuid": "d7485220-e4f2-4683-9e84-7728a2ef4ebf", "contactuuid": "9dcab961-1465-40e3-8d83-357b22af2674"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', 'INSERT', '{"uuid": "f3b07a47-e7ac-4fea-850e-1d785edfea34", "serialid": 222, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7bddc04e-775b-48f6-acb1-c1c9e638f836', 'INSERT', '{"uuid": "7bddc04e-775b-48f6-acb1-c1c9e638f836", "roletype": "OWNER", "objectuuid": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '283a7da7-7cf5-489b-bd81-a370cd694f3a', 'INSERT', '{"op": "DELETE", "uuid": "283a7da7-7cf5-489b-bd81-a370cd694f3a", "objectuuid": "f3b07a47-e7ac-4fea-850e-1d785edfea34", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '34b11791-5906-4753-b722-7fa782ef8ef2', 'INSERT', '{"uuid": "34b11791-5906-4753-b722-7fa782ef8ef2", "assumed": true, "ascendantuuid": "7bddc04e-775b-48f6-acb1-c1c9e638f836", "descendantuuid": "283a7da7-7cf5-489b-bd81-a370cd694f3a", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f5db57a6-93dd-4658-b13b-827f28d9ef59', 'INSERT', '{"uuid": "f5db57a6-93dd-4658-b13b-827f28d9ef59", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "7bddc04e-775b-48f6-acb1-c1c9e638f836", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '75685f6f-2403-40ef-b08b-1625bd699a13', 'INSERT', '{"uuid": "75685f6f-2403-40ef-b08b-1625bd699a13", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "7bddc04e-775b-48f6-acb1-c1c9e638f836", "grantedbyroleuuid": "7bddc04e-775b-48f6-acb1-c1c9e638f836", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd8668032-3755-4ef6-8ea7-7c34e0109e25', 'INSERT', '{"uuid": "d8668032-3755-4ef6-8ea7-7c34e0109e25", "roletype": "ADMIN", "objectuuid": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'fe2d0171-effb-42e9-ad87-d877454fa221', 'INSERT', '{"op": "UPDATE", "uuid": "fe2d0171-effb-42e9-ad87-d877454fa221", "objectuuid": "f3b07a47-e7ac-4fea-850e-1d785edfea34", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd34d2490-26a3-40dd-8417-faec7508092e', 'INSERT', '{"uuid": "d34d2490-26a3-40dd-8417-faec7508092e", "assumed": true, "ascendantuuid": "d8668032-3755-4ef6-8ea7-7c34e0109e25", "descendantuuid": "fe2d0171-effb-42e9-ad87-d877454fa221", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '75f5c8b1-9e1c-4dbf-85c8-c119cfe29326', 'INSERT', '{"uuid": "75f5c8b1-9e1c-4dbf-85c8-c119cfe29326", "assumed": true, "ascendantuuid": "7bddc04e-775b-48f6-acb1-c1c9e638f836", "descendantuuid": "d8668032-3755-4ef6-8ea7-7c34e0109e25", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '9dc88526-27f4-4c56-aef0-740429a8c457', 'INSERT', '{"uuid": "9dc88526-27f4-4c56-aef0-740429a8c457", "roletype": "AGENT", "objectuuid": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f93454ce-5594-4cc7-a797-35fc38e745a3', 'INSERT', '{"uuid": "f93454ce-5594-4cc7-a797-35fc38e745a3", "assumed": true, "ascendantuuid": "d8668032-3755-4ef6-8ea7-7c34e0109e25", "descendantuuid": "9dc88526-27f4-4c56-aef0-740429a8c457", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '67d9bcbb-574f-405a-b48c-f7ccfb9e0a06', 'INSERT', '{"uuid": "67d9bcbb-574f-405a-b48c-f7ccfb9e0a06", "roletype": "TENANT", "objectuuid": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'c4f3311d-618c-4e1b-9e0e-925465a5f932', 'INSERT', '{"op": "SELECT", "uuid": "c4f3311d-618c-4e1b-9e0e-925465a5f932", "objectuuid": "f3b07a47-e7ac-4fea-850e-1d785edfea34", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '541ddc9b-d0eb-4f83-a647-f4047f2135db', 'INSERT', '{"uuid": "541ddc9b-d0eb-4f83-a647-f4047f2135db", "assumed": true, "ascendantuuid": "67d9bcbb-574f-405a-b48c-f7ccfb9e0a06", "descendantuuid": "c4f3311d-618c-4e1b-9e0e-925465a5f932", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fb7d467d-75bb-443f-897b-124fa953f729', 'INSERT', '{"uuid": "fb7d467d-75bb-443f-897b-124fa953f729", "assumed": true, "ascendantuuid": "ba7a634b-c352-418c-a8c0-58918f32f8a7", "descendantuuid": "67d9bcbb-574f-405a-b48c-f7ccfb9e0a06", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a0391c4f-dff7-4778-a463-002d9e935bbd', 'INSERT', '{"uuid": "a0391c4f-dff7-4778-a463-002d9e935bbd", "assumed": true, "ascendantuuid": "9dc88526-27f4-4c56-aef0-740429a8c457", "descendantuuid": "67d9bcbb-574f-405a-b48c-f7ccfb9e0a06", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4652cf4f-b896-4c22-bea8-a0ce0f862fc0', 'INSERT', '{"uuid": "4652cf4f-b896-4c22-bea8-a0ce0f862fc0", "assumed": true, "ascendantuuid": "67d9bcbb-574f-405a-b48c-f7ccfb9e0a06", "descendantuuid": "ed0f7762-a094-4a88-abde-8472da33bcfb", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c8c5f426-06e7-4ad2-a82b-048f51ac1beb', 'INSERT', '{"uuid": "c8c5f426-06e7-4ad2-a82b-048f51ac1beb", "assumed": true, "ascendantuuid": "67d9bcbb-574f-405a-b48c-f7ccfb9e0a06", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b043c952-cab2-4c4c-b6b6-668548bac175', 'INSERT', '{"uuid": "b043c952-cab2-4c4c-b6b6-668548bac175", "assumed": true, "ascendantuuid": "67d9bcbb-574f-405a-b48c-f7ccfb9e0a06", "descendantuuid": "b29939d1-67c0-4527-88fd-41812023f402", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1e109da8-4793-473a-9a19-ec9a228f9eea', 'INSERT', '{"uuid": "1e109da8-4793-473a-9a19-ec9a228f9eea", "assumed": true, "ascendantuuid": "d8668032-3755-4ef6-8ea7-7c34e0109e25", "descendantuuid": "a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c6d9e156-e05a-4104-8be8-16d50b6450f2', 'INSERT', '{"uuid": "c6d9e156-e05a-4104-8be8-16d50b6450f2", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "9dc88526-27f4-4c56-aef0-740429a8c457", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b381a17d-1961-4aec-9ce1-b475906f1ac0', 'INSERT', '{"uuid": "b381a17d-1961-4aec-9ce1-b475906f1ac0", "assumed": true, "ascendantuuid": "2812b2d9-15c6-479c-b59d-bf980f4bc9d7", "descendantuuid": "7bddc04e-775b-48f6-acb1-c1c9e638f836", "grantedbyroleuuid": null, "grantedbytriggerof": "f3b07a47-e7ac-4fea-850e-1d785edfea34"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', 'INSERT', '{"mark": null, "type": "REPRESENTATIVE", "uuid": "f3b07a47-e7ac-4fea-850e-1d785edfea34", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "contactuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '4761d35a-2de3-4415-a91d-f53d15162aea', 'INSERT', '{"uuid": "4761d35a-2de3-4415-a91d-f53d15162aea", "serialid": 223, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ec817efa-d1de-4264-91e4-608b736b59fd', 'INSERT', '{"uuid": "ec817efa-d1de-4264-91e4-608b736b59fd", "roletype": "OWNER", "objectuuid": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'f276aa53-a904-46ec-863b-18e593fd2c3e', 'INSERT', '{"op": "DELETE", "uuid": "f276aa53-a904-46ec-863b-18e593fd2c3e", "objectuuid": "4761d35a-2de3-4415-a91d-f53d15162aea", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9c7f8f52-49c5-4f65-b0e9-2620f0c113bc', 'INSERT', '{"uuid": "9c7f8f52-49c5-4f65-b0e9-2620f0c113bc", "assumed": true, "ascendantuuid": "ec817efa-d1de-4264-91e4-608b736b59fd", "descendantuuid": "f276aa53-a904-46ec-863b-18e593fd2c3e", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c2534fb6-fa15-41a5-9d0c-8445406cdd70', 'INSERT', '{"uuid": "c2534fb6-fa15-41a5-9d0c-8445406cdd70", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "ec817efa-d1de-4264-91e4-608b736b59fd", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e22b72b0-fcf6-4b88-9166-2d94b2496746', 'INSERT', '{"uuid": "e22b72b0-fcf6-4b88-9166-2d94b2496746", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "ec817efa-d1de-4264-91e4-608b736b59fd", "grantedbyroleuuid": "ec817efa-d1de-4264-91e4-608b736b59fd", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0fae86ec-61fc-4f23-9713-a51f3f49505d', 'INSERT', '{"uuid": "0fae86ec-61fc-4f23-9713-a51f3f49505d", "roletype": "ADMIN", "objectuuid": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '17df9716-97f3-4970-813b-d144044d718f', 'INSERT', '{"op": "UPDATE", "uuid": "17df9716-97f3-4970-813b-d144044d718f", "objectuuid": "4761d35a-2de3-4415-a91d-f53d15162aea", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b641e4cf-6ea1-474e-b301-1f468f0373ba', 'INSERT', '{"uuid": "b641e4cf-6ea1-474e-b301-1f468f0373ba", "assumed": true, "ascendantuuid": "0fae86ec-61fc-4f23-9713-a51f3f49505d", "descendantuuid": "17df9716-97f3-4970-813b-d144044d718f", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f61ec4c4-d206-4ee7-8722-062ba7b07b79', 'INSERT', '{"uuid": "f61ec4c4-d206-4ee7-8722-062ba7b07b79", "assumed": true, "ascendantuuid": "ec817efa-d1de-4264-91e4-608b736b59fd", "descendantuuid": "0fae86ec-61fc-4f23-9713-a51f3f49505d", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '57070af3-92a3-4285-b6e8-8644989f8fce', 'INSERT', '{"uuid": "57070af3-92a3-4285-b6e8-8644989f8fce", "roletype": "AGENT", "objectuuid": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd629a3a2-6161-48ce-a520-646f49c89e15', 'INSERT', '{"uuid": "d629a3a2-6161-48ce-a520-646f49c89e15", "assumed": true, "ascendantuuid": "0fae86ec-61fc-4f23-9713-a51f3f49505d", "descendantuuid": "57070af3-92a3-4285-b6e8-8644989f8fce", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '087d73fd-3c94-4735-b59a-189efda4a80e', 'INSERT', '{"uuid": "087d73fd-3c94-4735-b59a-189efda4a80e", "roletype": "TENANT", "objectuuid": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '82813289-dc57-4c85-8c73-8e7f71966bbc', 'INSERT', '{"op": "SELECT", "uuid": "82813289-dc57-4c85-8c73-8e7f71966bbc", "objectuuid": "4761d35a-2de3-4415-a91d-f53d15162aea", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4a55cc2e-66f0-4d08-aff1-67405a9ae037', 'INSERT', '{"uuid": "4a55cc2e-66f0-4d08-aff1-67405a9ae037", "assumed": true, "ascendantuuid": "087d73fd-3c94-4735-b59a-189efda4a80e", "descendantuuid": "82813289-dc57-4c85-8c73-8e7f71966bbc", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9c2ddc22-9324-4687-bd2c-6b59c22dc953', 'INSERT', '{"uuid": "9c2ddc22-9324-4687-bd2c-6b59c22dc953", "assumed": true, "ascendantuuid": "ba7a634b-c352-418c-a8c0-58918f32f8a7", "descendantuuid": "087d73fd-3c94-4735-b59a-189efda4a80e", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bf80cf56-1b0d-4a25-8b71-a86863d888de', 'INSERT', '{"uuid": "bf80cf56-1b0d-4a25-8b71-a86863d888de", "assumed": true, "ascendantuuid": "57070af3-92a3-4285-b6e8-8644989f8fce", "descendantuuid": "087d73fd-3c94-4735-b59a-189efda4a80e", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'afda5e1d-620c-4bff-a0cd-f321fb6b8580', 'INSERT', '{"uuid": "afda5e1d-620c-4bff-a0cd-f321fb6b8580", "assumed": true, "ascendantuuid": "087d73fd-3c94-4735-b59a-189efda4a80e", "descendantuuid": "ed0f7762-a094-4a88-abde-8472da33bcfb", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a9a302d7-c9e3-4025-8c2a-a0007c270277', 'INSERT', '{"uuid": "a9a302d7-c9e3-4025-8c2a-a0007c270277", "assumed": true, "ascendantuuid": "087d73fd-3c94-4735-b59a-189efda4a80e", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1bd5d7d2-6de0-4b56-b53a-86b113907e3c', 'INSERT', '{"uuid": "1bd5d7d2-6de0-4b56-b53a-86b113907e3c", "assumed": true, "ascendantuuid": "087d73fd-3c94-4735-b59a-189efda4a80e", "descendantuuid": "b29939d1-67c0-4527-88fd-41812023f402", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1c75fd2c-8206-4872-8c63-78da5890be1b', 'INSERT', '{"uuid": "1c75fd2c-8206-4872-8c63-78da5890be1b", "assumed": true, "ascendantuuid": "2812b2d9-15c6-479c-b59d-bf980f4bc9d7", "descendantuuid": "57070af3-92a3-4285-b6e8-8644989f8fce", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fea36da2-ee0d-4001-8c9f-e7e17f3654c3', 'INSERT', '{"uuid": "fea36da2-ee0d-4001-8c9f-e7e17f3654c3", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "ec817efa-d1de-4264-91e4-608b736b59fd", "grantedbyroleuuid": null, "grantedbytriggerof": "4761d35a-2de3-4415-a91d-f53d15162aea"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '4761d35a-2de3-4415-a91d-f53d15162aea', 'INSERT', '{"mark": "generalversammlung", "type": "SUBSCRIBER", "uuid": "4761d35a-2de3-4415-a91d-f53d15162aea", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "contactuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', 'INSERT', '{"uuid": "04c248f9-20e0-42e1-adf3-b24d2ff7a272", "serialid": 224, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '6d7c3c90-cec2-472a-b143-3f730bb92d11', 'INSERT', '{"uuid": "6d7c3c90-cec2-472a-b143-3f730bb92d11", "roletype": "OWNER", "objectuuid": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '54ab8484-47e5-432c-afd4-7791561e09a7', 'INSERT', '{"op": "DELETE", "uuid": "54ab8484-47e5-432c-afd4-7791561e09a7", "objectuuid": "04c248f9-20e0-42e1-adf3-b24d2ff7a272", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0a6c8d17-c23e-4caa-8966-9911542ccd0f', 'INSERT', '{"uuid": "0a6c8d17-c23e-4caa-8966-9911542ccd0f", "assumed": true, "ascendantuuid": "6d7c3c90-cec2-472a-b143-3f730bb92d11", "descendantuuid": "54ab8484-47e5-432c-afd4-7791561e09a7", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '688a5723-8b60-4795-8993-7879f8fbe8f2', 'INSERT', '{"uuid": "688a5723-8b60-4795-8993-7879f8fbe8f2", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "6d7c3c90-cec2-472a-b143-3f730bb92d11", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '459eda2a-d5c1-4328-aee8-952a50b2d3a1', 'INSERT', '{"uuid": "459eda2a-d5c1-4328-aee8-952a50b2d3a1", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "6d7c3c90-cec2-472a-b143-3f730bb92d11", "grantedbyroleuuid": "6d7c3c90-cec2-472a-b143-3f730bb92d11", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '0e9f7adf-90bd-4ec9-bf40-82963cd51410', 'INSERT', '{"uuid": "0e9f7adf-90bd-4ec9-bf40-82963cd51410", "roletype": "ADMIN", "objectuuid": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '846820c5-9147-4f79-9b06-62110498d191', 'INSERT', '{"op": "UPDATE", "uuid": "846820c5-9147-4f79-9b06-62110498d191", "objectuuid": "04c248f9-20e0-42e1-adf3-b24d2ff7a272", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9d5a0b69-d7af-41a4-9d64-847c56a45de8', 'INSERT', '{"uuid": "9d5a0b69-d7af-41a4-9d64-847c56a45de8", "assumed": true, "ascendantuuid": "0e9f7adf-90bd-4ec9-bf40-82963cd51410", "descendantuuid": "846820c5-9147-4f79-9b06-62110498d191", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fe8a68e5-e01e-4402-b135-5b94ce2f6d89', 'INSERT', '{"uuid": "fe8a68e5-e01e-4402-b135-5b94ce2f6d89", "assumed": true, "ascendantuuid": "6d7c3c90-cec2-472a-b143-3f730bb92d11", "descendantuuid": "0e9f7adf-90bd-4ec9-bf40-82963cd51410", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '54c33e22-f4c5-45c4-a86d-fb8ed86afbf7', 'INSERT', '{"uuid": "54c33e22-f4c5-45c4-a86d-fb8ed86afbf7", "roletype": "AGENT", "objectuuid": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd3743c67-560e-4f22-9090-32a0c779b346', 'INSERT', '{"uuid": "d3743c67-560e-4f22-9090-32a0c779b346", "assumed": true, "ascendantuuid": "0e9f7adf-90bd-4ec9-bf40-82963cd51410", "descendantuuid": "54c33e22-f4c5-45c4-a86d-fb8ed86afbf7", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'd5007585-6703-493f-a24d-f99f4fb1b09c', 'INSERT', '{"uuid": "d5007585-6703-493f-a24d-f99f4fb1b09c", "roletype": "TENANT", "objectuuid": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7cfdc7ad-f7bc-42d1-9b72-ce871adf665b', 'INSERT', '{"op": "SELECT", "uuid": "7cfdc7ad-f7bc-42d1-9b72-ce871adf665b", "objectuuid": "04c248f9-20e0-42e1-adf3-b24d2ff7a272", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '84b5def8-230d-4b1d-b2f2-2789341c1eaf', 'INSERT', '{"uuid": "84b5def8-230d-4b1d-b2f2-2789341c1eaf", "assumed": true, "ascendantuuid": "d5007585-6703-493f-a24d-f99f4fb1b09c", "descendantuuid": "7cfdc7ad-f7bc-42d1-9b72-ce871adf665b", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8a643ea9-487d-4bc5-bee0-394c5c62d309', 'INSERT', '{"uuid": "8a643ea9-487d-4bc5-bee0-394c5c62d309", "assumed": true, "ascendantuuid": "ba7a634b-c352-418c-a8c0-58918f32f8a7", "descendantuuid": "d5007585-6703-493f-a24d-f99f4fb1b09c", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dbf2917f-3aa0-405f-b6bb-2d0e7f080cbb', 'INSERT', '{"uuid": "dbf2917f-3aa0-405f-b6bb-2d0e7f080cbb", "assumed": true, "ascendantuuid": "54c33e22-f4c5-45c4-a86d-fb8ed86afbf7", "descendantuuid": "d5007585-6703-493f-a24d-f99f4fb1b09c", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f0cdc2ac-fe93-44f2-8f07-72f307737241', 'INSERT', '{"uuid": "f0cdc2ac-fe93-44f2-8f07-72f307737241", "assumed": true, "ascendantuuid": "d5007585-6703-493f-a24d-f99f4fb1b09c", "descendantuuid": "ed0f7762-a094-4a88-abde-8472da33bcfb", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '34c5eff9-432f-4da6-af1e-9944aa43a831', 'INSERT', '{"uuid": "34c5eff9-432f-4da6-af1e-9944aa43a831", "assumed": true, "ascendantuuid": "d5007585-6703-493f-a24d-f99f4fb1b09c", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '493c6d1d-d431-4d2f-8dc1-560810ef9f70', 'INSERT', '{"uuid": "493c6d1d-d431-4d2f-8dc1-560810ef9f70", "assumed": true, "ascendantuuid": "d5007585-6703-493f-a24d-f99f4fb1b09c", "descendantuuid": "b29939d1-67c0-4527-88fd-41812023f402", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fed98897-4115-4492-ba35-be1025525650', 'INSERT', '{"uuid": "fed98897-4115-4492-ba35-be1025525650", "assumed": true, "ascendantuuid": "2812b2d9-15c6-479c-b59d-bf980f4bc9d7", "descendantuuid": "54c33e22-f4c5-45c4-a86d-fb8ed86afbf7", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8db51064-73b9-4a5c-8051-5ab121cd52c5', 'INSERT', '{"uuid": "8db51064-73b9-4a5c-8051-5ab121cd52c5", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "6d7c3c90-cec2-472a-b143-3f730bb92d11", "grantedbyroleuuid": null, "grantedbytriggerof": "04c248f9-20e0-42e1-adf3-b24d2ff7a272"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', 'INSERT', '{"mark": "members-announce", "type": "SUBSCRIBER", "uuid": "04c248f9-20e0-42e1-adf3-b24d2ff7a272", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "contactuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', 'INSERT', '{"uuid": "7113f4da-b942-4f17-97f8-d3fdfd2966c6", "serialid": 225, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '330cd455-c002-4416-8074-feb6c6b4849d', 'INSERT', '{"uuid": "330cd455-c002-4416-8074-feb6c6b4849d", "roletype": "OWNER", "objectuuid": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'b0f7eade-7384-445b-9f6a-76f19007d9b7', 'INSERT', '{"op": "DELETE", "uuid": "b0f7eade-7384-445b-9f6a-76f19007d9b7", "objectuuid": "7113f4da-b942-4f17-97f8-d3fdfd2966c6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '5e2c18c6-89af-4344-b9f9-58b2a860eff9', 'INSERT', '{"uuid": "5e2c18c6-89af-4344-b9f9-58b2a860eff9", "assumed": true, "ascendantuuid": "330cd455-c002-4416-8074-feb6c6b4849d", "descendantuuid": "b0f7eade-7384-445b-9f6a-76f19007d9b7", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '58f9a354-5b5f-4740-9314-533ce8e92515', 'INSERT', '{"uuid": "58f9a354-5b5f-4740-9314-533ce8e92515", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "330cd455-c002-4416-8074-feb6c6b4849d", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd621455c-aa20-4281-aa4f-d06346979700', 'INSERT', '{"uuid": "d621455c-aa20-4281-aa4f-d06346979700", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "330cd455-c002-4416-8074-feb6c6b4849d", "grantedbyroleuuid": "330cd455-c002-4416-8074-feb6c6b4849d", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'e2eddb4e-842b-450a-a9a4-54a3875b33c5', 'INSERT', '{"uuid": "e2eddb4e-842b-450a-a9a4-54a3875b33c5", "roletype": "ADMIN", "objectuuid": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '4a4b0f7b-8506-4ed5-be19-7c0baa476c45', 'INSERT', '{"op": "UPDATE", "uuid": "4a4b0f7b-8506-4ed5-be19-7c0baa476c45", "objectuuid": "7113f4da-b942-4f17-97f8-d3fdfd2966c6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd4007d15-842b-4bb6-8424-02102c1b6610', 'INSERT', '{"uuid": "d4007d15-842b-4bb6-8424-02102c1b6610", "assumed": true, "ascendantuuid": "e2eddb4e-842b-450a-a9a4-54a3875b33c5", "descendantuuid": "4a4b0f7b-8506-4ed5-be19-7c0baa476c45", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e78f06d6-b048-4d2e-b189-c90c3081af1c', 'INSERT', '{"uuid": "e78f06d6-b048-4d2e-b189-c90c3081af1c", "assumed": true, "ascendantuuid": "330cd455-c002-4416-8074-feb6c6b4849d", "descendantuuid": "e2eddb4e-842b-450a-a9a4-54a3875b33c5", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '256a2cac-4d33-46c0-833c-fd12d91af365', 'INSERT', '{"uuid": "256a2cac-4d33-46c0-833c-fd12d91af365", "roletype": "AGENT", "objectuuid": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '522ba310-4163-4c47-8afa-f69784d4545e', 'INSERT', '{"uuid": "522ba310-4163-4c47-8afa-f69784d4545e", "assumed": true, "ascendantuuid": "e2eddb4e-842b-450a-a9a4-54a3875b33c5", "descendantuuid": "256a2cac-4d33-46c0-833c-fd12d91af365", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c', 'INSERT', '{"uuid": "5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c", "roletype": "TENANT", "objectuuid": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '815ba931-a309-42fc-8865-b077937d4bd5', 'INSERT', '{"op": "SELECT", "uuid": "815ba931-a309-42fc-8865-b077937d4bd5", "objectuuid": "7113f4da-b942-4f17-97f8-d3fdfd2966c6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '279aebd0-8e1d-4322-86c4-1b19dfef89e1', 'INSERT', '{"uuid": "279aebd0-8e1d-4322-86c4-1b19dfef89e1", "assumed": true, "ascendantuuid": "5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c", "descendantuuid": "815ba931-a309-42fc-8865-b077937d4bd5", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dfff69c7-ce5b-4b67-a425-2b649e7cec7c', 'INSERT', '{"uuid": "dfff69c7-ce5b-4b67-a425-2b649e7cec7c", "assumed": true, "ascendantuuid": "ba7a634b-c352-418c-a8c0-58918f32f8a7", "descendantuuid": "5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '05bef46b-e96c-485d-a6b9-9d80d682da9a', 'INSERT', '{"uuid": "05bef46b-e96c-485d-a6b9-9d80d682da9a", "assumed": true, "ascendantuuid": "256a2cac-4d33-46c0-833c-fd12d91af365", "descendantuuid": "5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '54ababde-0fa4-4e1b-973b-ac63cc1f610a', 'INSERT', '{"uuid": "54ababde-0fa4-4e1b-973b-ac63cc1f610a", "assumed": true, "ascendantuuid": "5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c", "descendantuuid": "ed0f7762-a094-4a88-abde-8472da33bcfb", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '67a037de-9171-4712-af63-3d455334e3a6', 'INSERT', '{"uuid": "67a037de-9171-4712-af63-3d455334e3a6", "assumed": true, "ascendantuuid": "5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b7527a2d-767e-4282-ace1-499ec24c6346', 'INSERT', '{"uuid": "b7527a2d-767e-4282-ace1-499ec24c6346", "assumed": true, "ascendantuuid": "5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c", "descendantuuid": "b29939d1-67c0-4527-88fd-41812023f402", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7de75775-7af6-43cd-830c-13e8789fd9f2', 'INSERT', '{"uuid": "7de75775-7af6-43cd-830c-13e8789fd9f2", "assumed": true, "ascendantuuid": "2812b2d9-15c6-479c-b59d-bf980f4bc9d7", "descendantuuid": "256a2cac-4d33-46c0-833c-fd12d91af365", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd30e86da-adad-4745-8a48-e5be9b0f9d76', 'INSERT', '{"uuid": "d30e86da-adad-4745-8a48-e5be9b0f9d76", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "330cd455-c002-4416-8074-feb6c6b4849d", "grantedbyroleuuid": null, "grantedbytriggerof": "7113f4da-b942-4f17-97f8-d3fdfd2966c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', 'INSERT', '{"mark": "members-discussion", "type": "SUBSCRIBER", "uuid": "7113f4da-b942-4f17-97f8-d3fdfd2966c6", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "7c10a7d7-bac2-41e2-a5c0-963e191239a8", "contactuuid": "627a274d-55b0-42e7-963c-8b0cc3e204b4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '4dbf555d-3375-442e-a87d-815d1492af55', 'INSERT', '{"uuid": "4dbf555d-3375-442e-a87d-815d1492af55", "serialid": 226, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '34bbf849-5720-4440-bf30-378dd9748533', 'INSERT', '{"uuid": "34bbf849-5720-4440-bf30-378dd9748533", "roletype": "OWNER", "objectuuid": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'd7dd1750-2c6a-48b1-bfa7-ad708c3df73a', 'INSERT', '{"op": "DELETE", "uuid": "d7dd1750-2c6a-48b1-bfa7-ad708c3df73a", "objectuuid": "4dbf555d-3375-442e-a87d-815d1492af55", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bc0c3692-931f-47cd-a978-6b047013867e', 'INSERT', '{"uuid": "bc0c3692-931f-47cd-a978-6b047013867e", "assumed": true, "ascendantuuid": "34bbf849-5720-4440-bf30-378dd9748533", "descendantuuid": "d7dd1750-2c6a-48b1-bfa7-ad708c3df73a", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '71496d88-e1c8-4873-af0c-2844c46002e0', 'INSERT', '{"uuid": "71496d88-e1c8-4873-af0c-2844c46002e0", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "34bbf849-5720-4440-bf30-378dd9748533", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a2a50664-25d9-46ab-837d-becb88e61928', 'INSERT', '{"uuid": "a2a50664-25d9-46ab-837d-becb88e61928", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "34bbf849-5720-4440-bf30-378dd9748533", "grantedbyroleuuid": "34bbf849-5720-4440-bf30-378dd9748533", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '4d252783-00e1-4fec-a661-ec1154d98a2c', 'INSERT', '{"uuid": "4d252783-00e1-4fec-a661-ec1154d98a2c", "roletype": "ADMIN", "objectuuid": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '20af1fdc-7bf2-4f7c-941d-5294057a2148', 'INSERT', '{"op": "UPDATE", "uuid": "20af1fdc-7bf2-4f7c-941d-5294057a2148", "objectuuid": "4dbf555d-3375-442e-a87d-815d1492af55", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd029e4df-1abc-450f-992c-f533359f5e8e', 'INSERT', '{"uuid": "d029e4df-1abc-450f-992c-f533359f5e8e", "assumed": true, "ascendantuuid": "4d252783-00e1-4fec-a661-ec1154d98a2c", "descendantuuid": "20af1fdc-7bf2-4f7c-941d-5294057a2148", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7db91226-ca55-49e2-9092-61070d586bc7', 'INSERT', '{"uuid": "7db91226-ca55-49e2-9092-61070d586bc7", "assumed": true, "ascendantuuid": "34bbf849-5720-4440-bf30-378dd9748533", "descendantuuid": "4d252783-00e1-4fec-a661-ec1154d98a2c", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '830e7013-1330-4974-925e-20e142b148fb', 'INSERT', '{"uuid": "830e7013-1330-4974-925e-20e142b148fb", "roletype": "AGENT", "objectuuid": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '482c8a90-0346-46dc-967e-bf83a0073a4e', 'INSERT', '{"uuid": "482c8a90-0346-46dc-967e-bf83a0073a4e", "assumed": true, "ascendantuuid": "4d252783-00e1-4fec-a661-ec1154d98a2c", "descendantuuid": "830e7013-1330-4974-925e-20e142b148fb", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '85b69ad4-c6cb-4ef4-8d96-94abd80c9352', 'INSERT', '{"uuid": "85b69ad4-c6cb-4ef4-8d96-94abd80c9352", "roletype": "TENANT", "objectuuid": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'd0bcff97-900b-4660-9245-993dee9485eb', 'INSERT', '{"op": "SELECT", "uuid": "d0bcff97-900b-4660-9245-993dee9485eb", "objectuuid": "4dbf555d-3375-442e-a87d-815d1492af55", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8af3c1cf-a2be-4bef-855f-795538afc814', 'INSERT', '{"uuid": "8af3c1cf-a2be-4bef-855f-795538afc814", "assumed": true, "ascendantuuid": "85b69ad4-c6cb-4ef4-8d96-94abd80c9352", "descendantuuid": "d0bcff97-900b-4660-9245-993dee9485eb", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '41ab30df-d7a0-45d4-9c5c-2ddbc5175fa8', 'INSERT', '{"uuid": "41ab30df-d7a0-45d4-9c5c-2ddbc5175fa8", "assumed": true, "ascendantuuid": "fdcffa04-a455-4869-ab8f-2f2fa05e4b02", "descendantuuid": "85b69ad4-c6cb-4ef4-8d96-94abd80c9352", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'dd0ab251-a266-4d40-8d7a-c313d6b3f980', 'INSERT', '{"uuid": "dd0ab251-a266-4d40-8d7a-c313d6b3f980", "assumed": true, "ascendantuuid": "830e7013-1330-4974-925e-20e142b148fb", "descendantuuid": "85b69ad4-c6cb-4ef4-8d96-94abd80c9352", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c373196d-e4d9-4972-8993-cb5c1167ec97', 'INSERT', '{"uuid": "c373196d-e4d9-4972-8993-cb5c1167ec97", "assumed": true, "ascendantuuid": "85b69ad4-c6cb-4ef4-8d96-94abd80c9352", "descendantuuid": "67b756a8-aff9-439d-8ac8-b8965b63ac32", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '51279ced-5bad-4531-86c3-c589a640dd86', 'INSERT', '{"uuid": "51279ced-5bad-4531-86c3-c589a640dd86", "assumed": true, "ascendantuuid": "85b69ad4-c6cb-4ef4-8d96-94abd80c9352", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2b72c665-ba86-405a-8ab6-e9afd3404b9b', 'INSERT', '{"uuid": "2b72c665-ba86-405a-8ab6-e9afd3404b9b", "assumed": true, "ascendantuuid": "85b69ad4-c6cb-4ef4-8d96-94abd80c9352", "descendantuuid": "814e38c8-c053-4c27-9487-997cf318a550", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd822aedb-9ebd-4813-b0f2-f21ba2abfef6', 'INSERT', '{"uuid": "d822aedb-9ebd-4813-b0f2-f21ba2abfef6", "assumed": true, "ascendantuuid": "5f936257-6096-4792-a496-b92e46d93d0a", "descendantuuid": "830e7013-1330-4974-925e-20e142b148fb", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c65c112f-6b3e-49e4-adac-342db3aaec5e', 'INSERT', '{"uuid": "c65c112f-6b3e-49e4-adac-342db3aaec5e", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "34bbf849-5720-4440-bf30-378dd9748533", "grantedbyroleuuid": null, "grantedbytriggerof": "4dbf555d-3375-442e-a87d-815d1492af55"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '4dbf555d-3375-442e-a87d-815d1492af55', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "4dbf555d-3375-442e-a87d-815d1492af55", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "contactuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 'INSERT', '{"uuid": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f", "serialid": 227, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1d4bc5a7-76c0-49a2-93dd-22e0554d886f', 'INSERT', '{"uuid": "1d4bc5a7-76c0-49a2-93dd-22e0554d886f", "roletype": "OWNER", "objectuuid": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '36e09c9c-05d3-46fd-ba19-91e3dbb1ded0', 'INSERT', '{"op": "DELETE", "uuid": "36e09c9c-05d3-46fd-ba19-91e3dbb1ded0", "objectuuid": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e3a970d4-3ece-4205-8b85-e5e409b25f1f', 'INSERT', '{"uuid": "e3a970d4-3ece-4205-8b85-e5e409b25f1f", "assumed": true, "ascendantuuid": "1d4bc5a7-76c0-49a2-93dd-22e0554d886f", "descendantuuid": "36e09c9c-05d3-46fd-ba19-91e3dbb1ded0", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '010c767c-b0b7-4368-974d-e840e9af432e', 'INSERT', '{"uuid": "010c767c-b0b7-4368-974d-e840e9af432e", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "1d4bc5a7-76c0-49a2-93dd-22e0554d886f", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '68f695bb-bd44-4a4a-8c4c-b2ee85778c8b', 'INSERT', '{"uuid": "68f695bb-bd44-4a4a-8c4c-b2ee85778c8b", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "1d4bc5a7-76c0-49a2-93dd-22e0554d886f", "grantedbyroleuuid": "1d4bc5a7-76c0-49a2-93dd-22e0554d886f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'aab86d81-273f-48e2-91ec-8379a4097dea', 'INSERT', '{"uuid": "aab86d81-273f-48e2-91ec-8379a4097dea", "roletype": "ADMIN", "objectuuid": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'ae3d0091-aa98-44a3-adbb-2552b6179e97', 'INSERT', '{"op": "UPDATE", "uuid": "ae3d0091-aa98-44a3-adbb-2552b6179e97", "objectuuid": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '19026f01-4f3d-4272-9bf5-1f3aa61ee0d1', 'INSERT', '{"uuid": "19026f01-4f3d-4272-9bf5-1f3aa61ee0d1", "assumed": true, "ascendantuuid": "aab86d81-273f-48e2-91ec-8379a4097dea", "descendantuuid": "ae3d0091-aa98-44a3-adbb-2552b6179e97", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f429870b-65ce-4de9-949e-cef531e9b9e6', 'INSERT', '{"uuid": "f429870b-65ce-4de9-949e-cef531e9b9e6", "assumed": true, "ascendantuuid": "1d4bc5a7-76c0-49a2-93dd-22e0554d886f", "descendantuuid": "aab86d81-273f-48e2-91ec-8379a4097dea", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'e16ceaa4-25a8-449a-9d9c-59a87fdc228a', 'INSERT', '{"uuid": "e16ceaa4-25a8-449a-9d9c-59a87fdc228a", "roletype": "AGENT", "objectuuid": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '25adbcc6-4ec3-4740-8bc4-95a703509008', 'INSERT', '{"uuid": "25adbcc6-4ec3-4740-8bc4-95a703509008", "assumed": true, "ascendantuuid": "aab86d81-273f-48e2-91ec-8379a4097dea", "descendantuuid": "e16ceaa4-25a8-449a-9d9c-59a87fdc228a", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '5885b073-ed04-4ac7-9f4b-664507df0de1', 'INSERT', '{"uuid": "5885b073-ed04-4ac7-9f4b-664507df0de1", "roletype": "TENANT", "objectuuid": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '7ac91a3d-9409-471f-b6f6-8f50ea03a292', 'INSERT', '{"op": "SELECT", "uuid": "7ac91a3d-9409-471f-b6f6-8f50ea03a292", "objectuuid": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '04c69432-1659-4037-99db-a715d90d4a31', 'INSERT', '{"uuid": "04c69432-1659-4037-99db-a715d90d4a31", "assumed": true, "ascendantuuid": "5885b073-ed04-4ac7-9f4b-664507df0de1", "descendantuuid": "7ac91a3d-9409-471f-b6f6-8f50ea03a292", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '930a02fa-7b02-489e-a327-6b748881ab5b', 'INSERT', '{"uuid": "930a02fa-7b02-489e-a327-6b748881ab5b", "assumed": true, "ascendantuuid": "fdcffa04-a455-4869-ab8f-2f2fa05e4b02", "descendantuuid": "5885b073-ed04-4ac7-9f4b-664507df0de1", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1337009b-a5a6-46a4-8fa1-04094d858e72', 'INSERT', '{"uuid": "1337009b-a5a6-46a4-8fa1-04094d858e72", "assumed": true, "ascendantuuid": "e16ceaa4-25a8-449a-9d9c-59a87fdc228a", "descendantuuid": "5885b073-ed04-4ac7-9f4b-664507df0de1", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0ceaf7d3-822e-497e-a790-7a876018d747', 'INSERT', '{"uuid": "0ceaf7d3-822e-497e-a790-7a876018d747", "assumed": true, "ascendantuuid": "5885b073-ed04-4ac7-9f4b-664507df0de1", "descendantuuid": "67b756a8-aff9-439d-8ac8-b8965b63ac32", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e465d748-4151-4c5a-9786-7a2abac4a32f', 'INSERT', '{"uuid": "e465d748-4151-4c5a-9786-7a2abac4a32f", "assumed": true, "ascendantuuid": "5885b073-ed04-4ac7-9f4b-664507df0de1", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '28f51aaa-a34d-472c-b28b-a67e469b585d', 'INSERT', '{"uuid": "28f51aaa-a34d-472c-b28b-a67e469b585d", "assumed": true, "ascendantuuid": "5885b073-ed04-4ac7-9f4b-664507df0de1", "descendantuuid": "814e38c8-c053-4c27-9487-997cf318a550", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bd90ce06-c899-4c68-8bea-367c8d5d20be', 'INSERT', '{"uuid": "bd90ce06-c899-4c68-8bea-367c8d5d20be", "assumed": true, "ascendantuuid": "5f936257-6096-4792-a496-b92e46d93d0a", "descendantuuid": "e16ceaa4-25a8-449a-9d9c-59a87fdc228a", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '64abbebf-3e7a-49f7-95d4-b8eb8cb2d9a6', 'INSERT', '{"uuid": "64abbebf-3e7a-49f7-95d4-b8eb8cb2d9a6", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "1d4bc5a7-76c0-49a2-93dd-22e0554d886f", "grantedbyroleuuid": null, "grantedbytriggerof": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "ac44bd92-4e10-441c-8af3-6fc7cd6b242f", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "contactuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'e74992df-66a8-4572-9e55-ec7b210f04e0', 'INSERT', '{"uuid": "e74992df-66a8-4572-9e55-ec7b210f04e0", "serialid": 228, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '1a2692a7-05c3-433a-990c-54a184a91661', 'INSERT', '{"uuid": "1a2692a7-05c3-433a-990c-54a184a91661", "roletype": "OWNER", "objectuuid": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'b0a82131-7ecd-4685-be5a-89dd1c4cc7de', 'INSERT', '{"op": "DELETE", "uuid": "b0a82131-7ecd-4685-be5a-89dd1c4cc7de", "objectuuid": "e74992df-66a8-4572-9e55-ec7b210f04e0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e37467aa-eee1-4f42-aac8-fa3219b8c712', 'INSERT', '{"uuid": "e37467aa-eee1-4f42-aac8-fa3219b8c712", "assumed": true, "ascendantuuid": "1a2692a7-05c3-433a-990c-54a184a91661", "descendantuuid": "b0a82131-7ecd-4685-be5a-89dd1c4cc7de", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '774d40b1-0544-4e8f-a6d9-feeae437ec88', 'INSERT', '{"uuid": "774d40b1-0544-4e8f-a6d9-feeae437ec88", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "1a2692a7-05c3-433a-990c-54a184a91661", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0f85a127-53ac-4858-841e-bdbb56283a00', 'INSERT', '{"uuid": "0f85a127-53ac-4858-841e-bdbb56283a00", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "1a2692a7-05c3-433a-990c-54a184a91661", "grantedbyroleuuid": "1a2692a7-05c3-433a-990c-54a184a91661", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'b27f42df-1a56-4626-a3cf-1eb46e7e8770', 'INSERT', '{"uuid": "b27f42df-1a56-4626-a3cf-1eb46e7e8770", "roletype": "ADMIN", "objectuuid": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '0897f76b-9b66-45ae-a884-5c7edd121433', 'INSERT', '{"op": "UPDATE", "uuid": "0897f76b-9b66-45ae-a884-5c7edd121433", "objectuuid": "e74992df-66a8-4572-9e55-ec7b210f04e0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a119e799-70dd-4717-a1bd-a35f90d15523', 'INSERT', '{"uuid": "a119e799-70dd-4717-a1bd-a35f90d15523", "assumed": true, "ascendantuuid": "b27f42df-1a56-4626-a3cf-1eb46e7e8770", "descendantuuid": "0897f76b-9b66-45ae-a884-5c7edd121433", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8535405b-0693-40f0-b2b8-8c088e2aa0be', 'INSERT', '{"uuid": "8535405b-0693-40f0-b2b8-8c088e2aa0be", "assumed": true, "ascendantuuid": "1a2692a7-05c3-433a-990c-54a184a91661", "descendantuuid": "b27f42df-1a56-4626-a3cf-1eb46e7e8770", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'aa81a9b0-86ef-4ebe-98d3-54359961608d', 'INSERT', '{"uuid": "aa81a9b0-86ef-4ebe-98d3-54359961608d", "roletype": "AGENT", "objectuuid": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'bc5cd623-3012-46ed-bcfc-48022264d99e', 'INSERT', '{"uuid": "bc5cd623-3012-46ed-bcfc-48022264d99e", "assumed": true, "ascendantuuid": "b27f42df-1a56-4626-a3cf-1eb46e7e8770", "descendantuuid": "aa81a9b0-86ef-4ebe-98d3-54359961608d", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '51727d0c-b455-4171-9bc3-23ff5c73ed81', 'INSERT', '{"uuid": "51727d0c-b455-4171-9bc3-23ff5c73ed81", "roletype": "TENANT", "objectuuid": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '4d79f2a1-1130-4416-8c72-b6cc85740644', 'INSERT', '{"op": "SELECT", "uuid": "4d79f2a1-1130-4416-8c72-b6cc85740644", "objectuuid": "e74992df-66a8-4572-9e55-ec7b210f04e0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '25c8818e-bb35-48a0-b4ac-3c6f1bd40298', 'INSERT', '{"uuid": "25c8818e-bb35-48a0-b4ac-3c6f1bd40298", "assumed": true, "ascendantuuid": "51727d0c-b455-4171-9bc3-23ff5c73ed81", "descendantuuid": "4d79f2a1-1130-4416-8c72-b6cc85740644", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a864b583-edb7-464f-921f-c56ca092edad', 'INSERT', '{"uuid": "a864b583-edb7-464f-921f-c56ca092edad", "assumed": true, "ascendantuuid": "fdcffa04-a455-4869-ab8f-2f2fa05e4b02", "descendantuuid": "51727d0c-b455-4171-9bc3-23ff5c73ed81", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b03eb30c-1c1d-480e-b772-619994aec55e', 'INSERT', '{"uuid": "b03eb30c-1c1d-480e-b772-619994aec55e", "assumed": true, "ascendantuuid": "aa81a9b0-86ef-4ebe-98d3-54359961608d", "descendantuuid": "51727d0c-b455-4171-9bc3-23ff5c73ed81", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd8ac1b4c-0a68-49b7-bc54-4efa3f22acca', 'INSERT', '{"uuid": "d8ac1b4c-0a68-49b7-bc54-4efa3f22acca", "assumed": true, "ascendantuuid": "51727d0c-b455-4171-9bc3-23ff5c73ed81", "descendantuuid": "67b756a8-aff9-439d-8ac8-b8965b63ac32", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f21beb4a-baab-4547-977a-7f91103b548b', 'INSERT', '{"uuid": "f21beb4a-baab-4547-977a-7f91103b548b", "assumed": true, "ascendantuuid": "51727d0c-b455-4171-9bc3-23ff5c73ed81", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fa89309d-7016-4782-8076-26c126b8fe5f', 'INSERT', '{"uuid": "fa89309d-7016-4782-8076-26c126b8fe5f", "assumed": true, "ascendantuuid": "51727d0c-b455-4171-9bc3-23ff5c73ed81", "descendantuuid": "814e38c8-c053-4c27-9487-997cf318a550", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0d1b286c-9f93-45a5-9ccf-6d2ce623c427', 'INSERT', '{"uuid": "0d1b286c-9f93-45a5-9ccf-6d2ce623c427", "assumed": true, "ascendantuuid": "5f936257-6096-4792-a496-b92e46d93d0a", "descendantuuid": "aa81a9b0-86ef-4ebe-98d3-54359961608d", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3580f37b-438d-415e-9c63-c10f78c769e6', 'INSERT', '{"uuid": "3580f37b-438d-415e-9c63-c10f78c769e6", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "1a2692a7-05c3-433a-990c-54a184a91661", "grantedbyroleuuid": null, "grantedbytriggerof": "e74992df-66a8-4572-9e55-ec7b210f04e0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'e74992df-66a8-4572-9e55-ec7b210f04e0', 'INSERT', '{"mark": "operations-discussion", "type": "SUBSCRIBER", "uuid": "e74992df-66a8-4572-9e55-ec7b210f04e0", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "contactuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 'INSERT', '{"uuid": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3", "serialid": 229, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'e062ff79-b8a3-4f75-8e9f-ae3b31f92022', 'INSERT', '{"uuid": "e062ff79-b8a3-4f75-8e9f-ae3b31f92022", "roletype": "OWNER", "objectuuid": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '44a911af-8a2f-431f-9e1e-004746901334', 'INSERT', '{"op": "DELETE", "uuid": "44a911af-8a2f-431f-9e1e-004746901334", "objectuuid": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8fb85ae7-6857-4fde-a081-155245d8eab1', 'INSERT', '{"uuid": "8fb85ae7-6857-4fde-a081-155245d8eab1", "assumed": true, "ascendantuuid": "e062ff79-b8a3-4f75-8e9f-ae3b31f92022", "descendantuuid": "44a911af-8a2f-431f-9e1e-004746901334", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a2c9543c-270a-4401-a46d-63c780af7d7b', 'INSERT', '{"uuid": "a2c9543c-270a-4401-a46d-63c780af7d7b", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "e062ff79-b8a3-4f75-8e9f-ae3b31f92022", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '060a3faf-27c1-420c-bae4-5f8eff13d866', 'INSERT', '{"uuid": "060a3faf-27c1-420c-bae4-5f8eff13d866", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "e062ff79-b8a3-4f75-8e9f-ae3b31f92022", "grantedbyroleuuid": "e062ff79-b8a3-4f75-8e9f-ae3b31f92022", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'af3322a3-54cc-4315-b815-607a8c362d2e', 'INSERT', '{"uuid": "af3322a3-54cc-4315-b815-607a8c362d2e", "roletype": "ADMIN", "objectuuid": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'c885871c-5f3b-4a02-a550-f962132d898b', 'INSERT', '{"op": "UPDATE", "uuid": "c885871c-5f3b-4a02-a550-f962132d898b", "objectuuid": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '49cc28f1-0933-4f2d-a7b0-ee521012359f', 'INSERT', '{"uuid": "49cc28f1-0933-4f2d-a7b0-ee521012359f", "assumed": true, "ascendantuuid": "af3322a3-54cc-4315-b815-607a8c362d2e", "descendantuuid": "c885871c-5f3b-4a02-a550-f962132d898b", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e7f93905-e0a2-495f-ab86-a028e30f82fd', 'INSERT', '{"uuid": "e7f93905-e0a2-495f-ab86-a028e30f82fd", "assumed": true, "ascendantuuid": "e062ff79-b8a3-4f75-8e9f-ae3b31f92022", "descendantuuid": "af3322a3-54cc-4315-b815-607a8c362d2e", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'dc730495-43f8-42be-af37-a084da0f568e', 'INSERT', '{"uuid": "dc730495-43f8-42be-af37-a084da0f568e", "roletype": "AGENT", "objectuuid": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b21d98df-7db5-4df5-b481-393062d2133f', 'INSERT', '{"uuid": "b21d98df-7db5-4df5-b481-393062d2133f", "assumed": true, "ascendantuuid": "af3322a3-54cc-4315-b815-607a8c362d2e", "descendantuuid": "dc730495-43f8-42be-af37-a084da0f568e", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '8ea7ce48-b945-4053-8255-be69b2aa688d', 'INSERT', '{"uuid": "8ea7ce48-b945-4053-8255-be69b2aa688d", "roletype": "TENANT", "objectuuid": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'cfdfa9ee-7570-4a4f-bad4-0e18fdff5004', 'INSERT', '{"op": "SELECT", "uuid": "cfdfa9ee-7570-4a4f-bad4-0e18fdff5004", "objectuuid": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '59ac54a3-5532-4652-a621-4ef9c6c7490a', 'INSERT', '{"uuid": "59ac54a3-5532-4652-a621-4ef9c6c7490a", "assumed": true, "ascendantuuid": "8ea7ce48-b945-4053-8255-be69b2aa688d", "descendantuuid": "cfdfa9ee-7570-4a4f-bad4-0e18fdff5004", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd279712e-e2a3-495c-aeb0-e881ff3db933', 'INSERT', '{"uuid": "d279712e-e2a3-495c-aeb0-e881ff3db933", "assumed": true, "ascendantuuid": "fdcffa04-a455-4869-ab8f-2f2fa05e4b02", "descendantuuid": "8ea7ce48-b945-4053-8255-be69b2aa688d", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '9c2723b2-c46c-4eff-ba9c-ea0773327d33', 'INSERT', '{"uuid": "9c2723b2-c46c-4eff-ba9c-ea0773327d33", "assumed": true, "ascendantuuid": "dc730495-43f8-42be-af37-a084da0f568e", "descendantuuid": "8ea7ce48-b945-4053-8255-be69b2aa688d", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cad13977-cb2d-427c-a558-7755afa1ac4b', 'INSERT', '{"uuid": "cad13977-cb2d-427c-a558-7755afa1ac4b", "assumed": true, "ascendantuuid": "8ea7ce48-b945-4053-8255-be69b2aa688d", "descendantuuid": "67b756a8-aff9-439d-8ac8-b8965b63ac32", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '54cc9e09-e776-4fbd-9e4a-3f9393b8dff4', 'INSERT', '{"uuid": "54cc9e09-e776-4fbd-9e4a-3f9393b8dff4", "assumed": true, "ascendantuuid": "8ea7ce48-b945-4053-8255-be69b2aa688d", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '764751d6-792b-46c2-8df1-b55e317852c2', 'INSERT', '{"uuid": "764751d6-792b-46c2-8df1-b55e317852c2", "assumed": true, "ascendantuuid": "8ea7ce48-b945-4053-8255-be69b2aa688d", "descendantuuid": "814e38c8-c053-4c27-9487-997cf318a550", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0b9fd4d4-d98a-45b0-8901-b03a9865b31a', 'INSERT', '{"uuid": "0b9fd4d4-d98a-45b0-8901-b03a9865b31a", "assumed": true, "ascendantuuid": "5f936257-6096-4792-a496-b92e46d93d0a", "descendantuuid": "dc730495-43f8-42be-af37-a084da0f568e", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'a6954b44-80a1-4de4-993c-be0c0aace38a', 'INSERT', '{"uuid": "a6954b44-80a1-4de4-993c-be0c0aace38a", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "e062ff79-b8a3-4f75-8e9f-ae3b31f92022", "grantedbyroleuuid": null, "grantedbytriggerof": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 'INSERT', '{"mark": "operations-announce", "type": "SUBSCRIBER", "uuid": "50f79f83-f693-49c9-8b35-f1eb3c5f80a3", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "c3d97013-0ceb-4cc7-a59b-a4f70107acea", "contactuuid": "e8151525-ae0c-44fb-9755-72be88f7f6b1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 'INSERT', '{"uuid": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9", "serialid": 230, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3df1d2db-6ed7-4d0a-ae22-6e90140ca432', 'INSERT', '{"uuid": "3df1d2db-6ed7-4d0a-ae22-6e90140ca432", "roletype": "OWNER", "objectuuid": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'f7eab9a0-7f14-487c-9434-669dca849b40', 'INSERT', '{"op": "DELETE", "uuid": "f7eab9a0-7f14-487c-9434-669dca849b40", "objectuuid": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '243f16ba-3250-4bba-ae2b-95ceaf3fa138', 'INSERT', '{"uuid": "243f16ba-3250-4bba-ae2b-95ceaf3fa138", "assumed": true, "ascendantuuid": "3df1d2db-6ed7-4d0a-ae22-6e90140ca432", "descendantuuid": "f7eab9a0-7f14-487c-9434-669dca849b40", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '1122e7d5-c3e4-4212-aef9-15f1b147fe30', 'INSERT', '{"uuid": "1122e7d5-c3e4-4212-aef9-15f1b147fe30", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "3df1d2db-6ed7-4d0a-ae22-6e90140ca432", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '71b37f6f-05ba-43d4-9d42-cc421d9fca97', 'INSERT', '{"uuid": "71b37f6f-05ba-43d4-9d42-cc421d9fca97", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "3df1d2db-6ed7-4d0a-ae22-6e90140ca432", "grantedbyroleuuid": "3df1d2db-6ed7-4d0a-ae22-6e90140ca432", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '656d1c2d-2ad1-42df-9774-62e931e3bb0e', 'INSERT', '{"uuid": "656d1c2d-2ad1-42df-9774-62e931e3bb0e", "roletype": "ADMIN", "objectuuid": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '819393f7-e96d-499b-8663-3adaaf1b0a73', 'INSERT', '{"op": "UPDATE", "uuid": "819393f7-e96d-499b-8663-3adaaf1b0a73", "objectuuid": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0e431e76-37ba-4074-b377-106fb435cd6a', 'INSERT', '{"uuid": "0e431e76-37ba-4074-b377-106fb435cd6a", "assumed": true, "ascendantuuid": "656d1c2d-2ad1-42df-9774-62e931e3bb0e", "descendantuuid": "819393f7-e96d-499b-8663-3adaaf1b0a73", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '53dbd2dc-766f-4223-a777-e4b44a598be5', 'INSERT', '{"uuid": "53dbd2dc-766f-4223-a777-e4b44a598be5", "assumed": true, "ascendantuuid": "3df1d2db-6ed7-4d0a-ae22-6e90140ca432", "descendantuuid": "656d1c2d-2ad1-42df-9774-62e931e3bb0e", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '7c142ae8-d190-4c1f-aa85-24f12eeefc9f', 'INSERT', '{"uuid": "7c142ae8-d190-4c1f-aa85-24f12eeefc9f", "roletype": "AGENT", "objectuuid": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '0977ed6c-1fb6-48f0-b7c7-b4807c5bb672', 'INSERT', '{"uuid": "0977ed6c-1fb6-48f0-b7c7-b4807c5bb672", "assumed": true, "ascendantuuid": "656d1c2d-2ad1-42df-9774-62e931e3bb0e", "descendantuuid": "7c142ae8-d190-4c1f-aa85-24f12eeefc9f", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '3abf8555-9c07-447d-af5b-47bacb517ad5', 'INSERT', '{"uuid": "3abf8555-9c07-447d-af5b-47bacb517ad5", "roletype": "TENANT", "objectuuid": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'f3d00781-37e2-4b9a-8107-bdc123df38d7', 'INSERT', '{"op": "SELECT", "uuid": "f3d00781-37e2-4b9a-8107-bdc123df38d7", "objectuuid": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c36ef648-581e-40b6-9f92-30be50403890', 'INSERT', '{"uuid": "c36ef648-581e-40b6-9f92-30be50403890", "assumed": true, "ascendantuuid": "3abf8555-9c07-447d-af5b-47bacb517ad5", "descendantuuid": "f3d00781-37e2-4b9a-8107-bdc123df38d7", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ef219bf7-5838-4fe9-8a6c-74d76637e6e5', 'INSERT', '{"uuid": "ef219bf7-5838-4fe9-8a6c-74d76637e6e5", "assumed": true, "ascendantuuid": "60297e5d-2f7d-4734-9a25-f2639ffb7fb4", "descendantuuid": "3abf8555-9c07-447d-af5b-47bacb517ad5", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'f60bb8d7-0347-4230-9b72-80808087df82', 'INSERT', '{"uuid": "f60bb8d7-0347-4230-9b72-80808087df82", "assumed": true, "ascendantuuid": "7c142ae8-d190-4c1f-aa85-24f12eeefc9f", "descendantuuid": "3abf8555-9c07-447d-af5b-47bacb517ad5", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2472c680-5e4d-4a27-bd39-0dfb5198f2d3', 'INSERT', '{"uuid": "2472c680-5e4d-4a27-bd39-0dfb5198f2d3", "assumed": true, "ascendantuuid": "3abf8555-9c07-447d-af5b-47bacb517ad5", "descendantuuid": "7454ce37-a2ba-4f52-a5da-2190203ca089", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2efb9a32-db0b-4d3e-8488-71a6ba91d792', 'INSERT', '{"uuid": "2efb9a32-db0b-4d3e-8488-71a6ba91d792", "assumed": true, "ascendantuuid": "3abf8555-9c07-447d-af5b-47bacb517ad5", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '8e95ae46-bb81-4895-97b3-90c50307a381', 'INSERT', '{"uuid": "8e95ae46-bb81-4895-97b3-90c50307a381", "assumed": true, "ascendantuuid": "3abf8555-9c07-447d-af5b-47bacb517ad5", "descendantuuid": "779e4c3b-97f0-4218-8eab-5575a6afa54a", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '79603765-e912-4ce3-9f88-70645bafa009', 'INSERT', '{"uuid": "79603765-e912-4ce3-9f88-70645bafa009", "assumed": true, "ascendantuuid": "de10229b-be9d-45dc-b1bf-8f832ebffe68", "descendantuuid": "7c142ae8-d190-4c1f-aa85-24f12eeefc9f", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'eda5060e-6818-415e-afaf-49ad637375b1', 'INSERT', '{"uuid": "eda5060e-6818-415e-afaf-49ad637375b1", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "3df1d2db-6ed7-4d0a-ae22-6e90140ca432", "grantedbyroleuuid": null, "grantedbytriggerof": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 'INSERT', '{"mark": null, "type": "OPERATIONS_ALERT", "uuid": "a5f231d1-0fee-4e1a-a4b6-7840ad531ad9", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "e50c983a-060c-47c9-9d47-efd552b1e618", "contactuuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '047364a5-9dcb-4027-a94c-e35f4646860e', 'INSERT', '{"uuid": "047364a5-9dcb-4027-a94c-e35f4646860e", "serialid": 231, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '89218636-1f65-41ed-b729-d5967f17d33e', 'INSERT', '{"uuid": "89218636-1f65-41ed-b729-d5967f17d33e", "roletype": "OWNER", "objectuuid": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'cbff4b85-4722-4e87-8adb-34923d9987c0', 'INSERT', '{"op": "DELETE", "uuid": "cbff4b85-4722-4e87-8adb-34923d9987c0", "objectuuid": "047364a5-9dcb-4027-a94c-e35f4646860e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b60442b9-5c5f-4d82-bf66-8eb20ca9b708', 'INSERT', '{"uuid": "b60442b9-5c5f-4d82-bf66-8eb20ca9b708", "assumed": true, "ascendantuuid": "89218636-1f65-41ed-b729-d5967f17d33e", "descendantuuid": "cbff4b85-4722-4e87-8adb-34923d9987c0", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e142a048-63a4-4c13-bffa-8cad6d6f9f68', 'INSERT', '{"uuid": "e142a048-63a4-4c13-bffa-8cad6d6f9f68", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "89218636-1f65-41ed-b729-d5967f17d33e", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd47adf1c-911c-4340-96a3-69e98005dfe1', 'INSERT', '{"uuid": "d47adf1c-911c-4340-96a3-69e98005dfe1", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "89218636-1f65-41ed-b729-d5967f17d33e", "grantedbyroleuuid": "89218636-1f65-41ed-b729-d5967f17d33e", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '52ae0923-db99-48e9-95b5-d6884b6d4642', 'INSERT', '{"uuid": "52ae0923-db99-48e9-95b5-d6884b6d4642", "roletype": "ADMIN", "objectuuid": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '6f009e98-a9a4-4d93-92e2-e955d04bb7e4', 'INSERT', '{"op": "UPDATE", "uuid": "6f009e98-a9a4-4d93-92e2-e955d04bb7e4", "objectuuid": "047364a5-9dcb-4027-a94c-e35f4646860e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'badcbce7-e648-4f6f-900a-796cee8ef977', 'INSERT', '{"uuid": "badcbce7-e648-4f6f-900a-796cee8ef977", "assumed": true, "ascendantuuid": "52ae0923-db99-48e9-95b5-d6884b6d4642", "descendantuuid": "6f009e98-a9a4-4d93-92e2-e955d04bb7e4", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'cbdc254f-7d1b-4836-80a0-7e4bca791478', 'INSERT', '{"uuid": "cbdc254f-7d1b-4836-80a0-7e4bca791478", "assumed": true, "ascendantuuid": "89218636-1f65-41ed-b729-d5967f17d33e", "descendantuuid": "52ae0923-db99-48e9-95b5-d6884b6d4642", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '58769cf3-490e-4d20-8255-3e0854d8384b', 'INSERT', '{"uuid": "58769cf3-490e-4d20-8255-3e0854d8384b", "roletype": "AGENT", "objectuuid": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c38c5ce9-bed2-465a-9d34-71a63868e2f7', 'INSERT', '{"uuid": "c38c5ce9-bed2-465a-9d34-71a63868e2f7", "assumed": true, "ascendantuuid": "52ae0923-db99-48e9-95b5-d6884b6d4642", "descendantuuid": "58769cf3-490e-4d20-8255-3e0854d8384b", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '212a3a64-9d05-44ae-a394-e335cb98cdf7', 'INSERT', '{"uuid": "212a3a64-9d05-44ae-a394-e335cb98cdf7", "roletype": "TENANT", "objectuuid": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '21a21577-f8e6-4856-8c80-996000f525c9', 'INSERT', '{"op": "SELECT", "uuid": "21a21577-f8e6-4856-8c80-996000f525c9", "objectuuid": "047364a5-9dcb-4027-a94c-e35f4646860e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7bd30426-477a-42ae-9fea-53e31754a3a5', 'INSERT', '{"uuid": "7bd30426-477a-42ae-9fea-53e31754a3a5", "assumed": true, "ascendantuuid": "212a3a64-9d05-44ae-a394-e335cb98cdf7", "descendantuuid": "21a21577-f8e6-4856-8c80-996000f525c9", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '66bd8d3a-ecd2-4db1-a54c-d614df92bc66', 'INSERT', '{"uuid": "66bd8d3a-ecd2-4db1-a54c-d614df92bc66", "assumed": true, "ascendantuuid": "60297e5d-2f7d-4734-9a25-f2639ffb7fb4", "descendantuuid": "212a3a64-9d05-44ae-a394-e335cb98cdf7", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'b69b4a82-d843-4121-b4a6-22b5223d4832', 'INSERT', '{"uuid": "b69b4a82-d843-4121-b4a6-22b5223d4832", "assumed": true, "ascendantuuid": "58769cf3-490e-4d20-8255-3e0854d8384b", "descendantuuid": "212a3a64-9d05-44ae-a394-e335cb98cdf7", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '7a4ad26e-9bdd-4202-bf55-d3a23dd92889', 'INSERT', '{"uuid": "7a4ad26e-9bdd-4202-bf55-d3a23dd92889", "assumed": true, "ascendantuuid": "212a3a64-9d05-44ae-a394-e335cb98cdf7", "descendantuuid": "7454ce37-a2ba-4f52-a5da-2190203ca089", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'de10b491-4a7f-411f-976b-c1a71d76e4aa', 'INSERT', '{"uuid": "de10b491-4a7f-411f-976b-c1a71d76e4aa", "assumed": true, "ascendantuuid": "212a3a64-9d05-44ae-a394-e335cb98cdf7", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '443baeb4-d1b5-4ff8-9f6e-80630b9064f3', 'INSERT', '{"uuid": "443baeb4-d1b5-4ff8-9f6e-80630b9064f3", "assumed": true, "ascendantuuid": "212a3a64-9d05-44ae-a394-e335cb98cdf7", "descendantuuid": "779e4c3b-97f0-4218-8eab-5575a6afa54a", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'ae35d44c-8134-4128-a4cb-ebf18b227ced', 'INSERT', '{"uuid": "ae35d44c-8134-4128-a4cb-ebf18b227ced", "assumed": true, "ascendantuuid": "de10229b-be9d-45dc-b1bf-8f832ebffe68", "descendantuuid": "58769cf3-490e-4d20-8255-3e0854d8384b", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '21b13641-89e2-4a8f-9d9a-2e6f3cbafe35', 'INSERT', '{"uuid": "21b13641-89e2-4a8f-9d9a-2e6f3cbafe35", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "89218636-1f65-41ed-b729-d5967f17d33e", "grantedbyroleuuid": null, "grantedbytriggerof": "047364a5-9dcb-4027-a94c-e35f4646860e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '047364a5-9dcb-4027-a94c-e35f4646860e', 'INSERT', '{"mark": null, "type": "OPERATIONS", "uuid": "047364a5-9dcb-4027-a94c-e35f4646860e", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "e50c983a-060c-47c9-9d47-efd552b1e618", "contactuuid": "7857f7cb-c93d-4d21-a4e8-b91a28eb7007"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.object', '08e80808-fb86-4503-ab9b-9652af82d5b5', 'INSERT', '{"uuid": "08e80808-fb86-4503-ab9b-9652af82d5b5", "serialid": 232, "objecttable": "hs_office.relation"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f', 'INSERT', '{"uuid": "cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f", "roletype": "OWNER", "objectuuid": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', '160977ed-ef11-43d8-9ff7-af86c743d2ab', 'INSERT', '{"op": "DELETE", "uuid": "160977ed-ef11-43d8-9ff7-af86c743d2ab", "objectuuid": "08e80808-fb86-4503-ab9b-9652af82d5b5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '327d53e3-9645-413b-a8b9-1abf80ef6caf', 'INSERT', '{"uuid": "327d53e3-9645-413b-a8b9-1abf80ef6caf", "assumed": true, "ascendantuuid": "cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f", "descendantuuid": "160977ed-ef11-43d8-9ff7-af86c743d2ab", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'eda23614-3b16-4346-b096-0db44dd02912', 'INSERT', '{"uuid": "eda23614-3b16-4346-b096-0db44dd02912", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'de5b93fc-d1c5-4d4e-be69-e0187b58b96f', 'INSERT', '{"uuid": "de5b93fc-d1c5-4d4e-be69-e0187b58b96f", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f", "grantedbyroleuuid": "cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', '9a4fdac1-5925-464e-848b-1532c780ebdf', 'INSERT', '{"uuid": "9a4fdac1-5925-464e-848b-1532c780ebdf", "roletype": "ADMIN", "objectuuid": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'd94fd859-6e03-44a1-ac1d-059ed72e23d3', 'INSERT', '{"op": "UPDATE", "uuid": "d94fd859-6e03-44a1-ac1d-059ed72e23d3", "objectuuid": "08e80808-fb86-4503-ab9b-9652af82d5b5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'e0f9ae70-cf38-40c4-bb77-8a65344f1d24', 'INSERT', '{"uuid": "e0f9ae70-cf38-40c4-bb77-8a65344f1d24", "assumed": true, "ascendantuuid": "9a4fdac1-5925-464e-848b-1532c780ebdf", "descendantuuid": "d94fd859-6e03-44a1-ac1d-059ed72e23d3", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '85eda66a-0840-4cba-8b1b-0ec996e7ea1a', 'INSERT', '{"uuid": "85eda66a-0840-4cba-8b1b-0ec996e7ea1a", "assumed": true, "ascendantuuid": "cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f", "descendantuuid": "9a4fdac1-5925-464e-848b-1532c780ebdf", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'e108043f-3dcd-498c-9560-cde4ed35680e', 'INSERT', '{"uuid": "e108043f-3dcd-498c-9560-cde4ed35680e", "roletype": "AGENT", "objectuuid": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '2e20ecf3-6dfc-4e0a-8587-a2f9f76949a1', 'INSERT', '{"uuid": "2e20ecf3-6dfc-4e0a-8587-a2f9f76949a1", "assumed": true, "ascendantuuid": "9a4fdac1-5925-464e-848b-1532c780ebdf", "descendantuuid": "e108043f-3dcd-498c-9560-cde4ed35680e", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.role', 'ac5044f1-1f16-43fa-afe2-24d80506ae5b', 'INSERT', '{"uuid": "ac5044f1-1f16-43fa-afe2-24d80506ae5b", "roletype": "TENANT", "objectuuid": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.permission', 'ebb468b1-047a-492c-a76c-5031645e7824', 'INSERT', '{"op": "SELECT", "uuid": "ebb468b1-047a-492c-a76c-5031645e7824", "objectuuid": "08e80808-fb86-4503-ab9b-9652af82d5b5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'c944cfbc-96e9-4936-acc1-fd156480f511', 'INSERT', '{"uuid": "c944cfbc-96e9-4936-acc1-fd156480f511", "assumed": true, "ascendantuuid": "ac5044f1-1f16-43fa-afe2-24d80506ae5b", "descendantuuid": "ebb468b1-047a-492c-a76c-5031645e7824", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '62f3ce10-f42c-4106-a6ea-40aa0e018eed', 'INSERT', '{"uuid": "62f3ce10-f42c-4106-a6ea-40aa0e018eed", "assumed": true, "ascendantuuid": "da9600c2-7dcc-4a7d-87f1-33f4a441e807", "descendantuuid": "ac5044f1-1f16-43fa-afe2-24d80506ae5b", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4fe21ec9-c4cd-462d-8754-e16bbf8a180a', 'INSERT', '{"uuid": "4fe21ec9-c4cd-462d-8754-e16bbf8a180a", "assumed": true, "ascendantuuid": "e108043f-3dcd-498c-9560-cde4ed35680e", "descendantuuid": "ac5044f1-1f16-43fa-afe2-24d80506ae5b", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'fa4aad7d-a9e0-40a4-9075-10e1bab8f777', 'INSERT', '{"uuid": "fa4aad7d-a9e0-40a4-9075-10e1bab8f777", "assumed": true, "ascendantuuid": "ac5044f1-1f16-43fa-afe2-24d80506ae5b", "descendantuuid": "f1afc7a2-588d-4b7e-9975-7b0eda21f846", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '4200700a-6aa6-4949-80e8-a2ccbe1de26e', 'INSERT', '{"uuid": "4200700a-6aa6-4949-80e8-a2ccbe1de26e", "assumed": true, "ascendantuuid": "ac5044f1-1f16-43fa-afe2-24d80506ae5b", "descendantuuid": "95cfeaa7-1c01-4090-8f37-fc3306cc0ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '407d18e1-5185-41fd-9073-afe3b884826c', 'INSERT', '{"uuid": "407d18e1-5185-41fd-9073-afe3b884826c", "assumed": true, "ascendantuuid": "ac5044f1-1f16-43fa-afe2-24d80506ae5b", "descendantuuid": "779e4c3b-97f0-4218-8eab-5575a6afa54a", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', '3b1cf5ad-8b58-4229-a6db-e9927917d0dc', 'INSERT', '{"uuid": "3b1cf5ad-8b58-4229-a6db-e9927917d0dc", "assumed": true, "ascendantuuid": "de10229b-be9d-45dc-b1bf-8f832ebffe68", "descendantuuid": "e108043f-3dcd-498c-9560-cde4ed35680e", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'rbac.grant', 'd84e7cc1-e0f0-47ba-a815-56e1817601ab', 'INSERT', '{"uuid": "d84e7cc1-e0f0-47ba-a815-56e1817601ab", "assumed": true, "ascendantuuid": "e03da822-f071-4c66-890f-f93a458aec28", "descendantuuid": "cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f", "grantedbyroleuuid": null, "grantedbytriggerof": "08e80808-fb86-4503-ab9b-9652af82d5b5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('1823', 'hs_office.relation', '08e80808-fb86-4503-ab9b-9652af82d5b5', 'INSERT', '{"mark": "operations-announce", "type": "SUBSCRIBER", "uuid": "08e80808-fb86-4503-ab9b-9652af82d5b5", "version": 0, "anchoruuid": "ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f", "holderuuid": "e50c983a-060c-47c9-9d47-efd552b1e618", "contactuuid": "c3b8c521-37f4-46b8-89f7-1931159e9a14"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', '6da29bfa-4744-437f-aed3-2695571c58bf', 'INSERT', '{"uuid": "6da29bfa-4744-437f-aed3-2695571c58bf", "serialid": 233, "objecttable": "hs_office.partner_details"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner_details', '6da29bfa-4744-437f-aed3-2695571c58bf', 'INSERT', '{"uuid": "6da29bfa-4744-437f-aed3-2695571c58bf", "version": 0, "birthday": null, "birthname": null, "birthplace": null, "dateofdeath": null, "registrationnumber": null, "registrationoffice": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', '91b63591-b1e2-4c65-8ad2-c607be4c1238', 'INSERT', '{"uuid": "91b63591-b1e2-4c65-8ad2-c607be4c1238", "serialid": 234, "objecttable": "hs_office.partner"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'a2effc4a-acdc-4660-973d-e5313a9df528', 'INSERT', '{"op": "DELETE", "uuid": "a2effc4a-acdc-4660-973d-e5313a9df528", "objectuuid": "91b63591-b1e2-4c65-8ad2-c607be4c1238", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '45db4d06-7181-409f-89d2-fb2135f4eac0', 'INSERT', '{"uuid": "45db4d06-7181-409f-89d2-fb2135f4eac0", "assumed": true, "ascendantuuid": "1b453f97-a12c-4d51-bf95-2e782b425385", "descendantuuid": "a2effc4a-acdc-4660-973d-e5313a9df528", "grantedbyroleuuid": null, "grantedbytriggerof": "91b63591-b1e2-4c65-8ad2-c607be4c1238"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '42491f82-8223-4dbf-8660-688e35fc5694', 'INSERT', '{"op": "SELECT", "uuid": "42491f82-8223-4dbf-8660-688e35fc5694", "objectuuid": "91b63591-b1e2-4c65-8ad2-c607be4c1238", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '6dbff4f0-9c28-498d-918b-cee99b6d3aa4', 'INSERT', '{"uuid": "6dbff4f0-9c28-498d-918b-cee99b6d3aa4", "assumed": true, "ascendantuuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "descendantuuid": "42491f82-8223-4dbf-8660-688e35fc5694", "grantedbyroleuuid": null, "grantedbytriggerof": "91b63591-b1e2-4c65-8ad2-c607be4c1238"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'aaaf21f7-baff-4867-b84f-36a16f0fcbf1', 'INSERT', '{"op": "UPDATE", "uuid": "aaaf21f7-baff-4867-b84f-36a16f0fcbf1", "objectuuid": "91b63591-b1e2-4c65-8ad2-c607be4c1238", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'd589ebc2-533a-442d-959d-ccaddaad53b3', 'INSERT', '{"uuid": "d589ebc2-533a-442d-959d-ccaddaad53b3", "assumed": true, "ascendantuuid": "3b195996-371c-41e4-9b66-a50553582e17", "descendantuuid": "aaaf21f7-baff-4867-b84f-36a16f0fcbf1", "grantedbyroleuuid": null, "grantedbytriggerof": "91b63591-b1e2-4c65-8ad2-c607be4c1238"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '66b246c1-b389-40b7-b238-48903a3dae95', 'INSERT', '{"op": "DELETE", "uuid": "66b246c1-b389-40b7-b238-48903a3dae95", "objectuuid": "6da29bfa-4744-437f-aed3-2695571c58bf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '3900e6fa-5de9-4c36-a9e6-a17103f97901', 'INSERT', '{"uuid": "3900e6fa-5de9-4c36-a9e6-a17103f97901", "assumed": true, "ascendantuuid": "1b453f97-a12c-4d51-bf95-2e782b425385", "descendantuuid": "66b246c1-b389-40b7-b238-48903a3dae95", "grantedbyroleuuid": null, "grantedbytriggerof": "91b63591-b1e2-4c65-8ad2-c607be4c1238"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'ddcec555-0f99-4cec-9d45-b0ddd4e7fb26', 'INSERT', '{"op": "SELECT", "uuid": "ddcec555-0f99-4cec-9d45-b0ddd4e7fb26", "objectuuid": "6da29bfa-4744-437f-aed3-2695571c58bf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'c21da043-c691-4c28-a26d-4db1c008d239', 'INSERT', '{"uuid": "c21da043-c691-4c28-a26d-4db1c008d239", "assumed": true, "ascendantuuid": "7de2ab25-6b6a-4b59-ba8d-818110ae4ccb", "descendantuuid": "ddcec555-0f99-4cec-9d45-b0ddd4e7fb26", "grantedbyroleuuid": null, "grantedbytriggerof": "91b63591-b1e2-4c65-8ad2-c607be4c1238"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '76d3e38c-0889-4169-814d-5f7e36c0c767', 'INSERT', '{"op": "UPDATE", "uuid": "76d3e38c-0889-4169-814d-5f7e36c0c767", "objectuuid": "6da29bfa-4744-437f-aed3-2695571c58bf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'c5d88362-dfd3-4039-b867-4a7466a8b34a', 'INSERT', '{"uuid": "c5d88362-dfd3-4039-b867-4a7466a8b34a", "assumed": true, "ascendantuuid": "7de2ab25-6b6a-4b59-ba8d-818110ae4ccb", "descendantuuid": "76d3e38c-0889-4169-814d-5f7e36c0c767", "grantedbyroleuuid": null, "grantedbytriggerof": "91b63591-b1e2-4c65-8ad2-c607be4c1238"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner', '91b63591-b1e2-4c65-8ad2-c607be4c1238', 'INSERT', '{"uuid": "91b63591-b1e2-4c65-8ad2-c607be4c1238", "version": 0, "detailsuuid": "6da29bfa-4744-437f-aed3-2695571c58bf", "partnernumber": 10003, "partnerreluuid": "48618c28-9304-4ccb-b022-e2cbb1832944"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', '7b7a528d-a284-4d0d-99ce-73f2a7585f78', 'INSERT', '{"uuid": "7b7a528d-a284-4d0d-99ce-73f2a7585f78", "serialid": 235, "objecttable": "hs_office.partner_details"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner_details', '7b7a528d-a284-4d0d-99ce-73f2a7585f78', 'INSERT', '{"uuid": "7b7a528d-a284-4d0d-99ce-73f2a7585f78", "version": 0, "birthday": null, "birthname": null, "birthplace": null, "dateofdeath": null, "registrationnumber": null, "registrationoffice": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', 'db7f287e-dfd7-4627-88e3-407cac226472', 'INSERT', '{"uuid": "db7f287e-dfd7-4627-88e3-407cac226472", "serialid": 236, "objecttable": "hs_office.partner"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '4d9e1a7c-84fa-43c7-a1d7-e898b20df129', 'INSERT', '{"op": "DELETE", "uuid": "4d9e1a7c-84fa-43c7-a1d7-e898b20df129", "objectuuid": "db7f287e-dfd7-4627-88e3-407cac226472", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '23fe6f7c-4bd4-4450-9cd0-5e2f26b0f3e4', 'INSERT', '{"uuid": "23fe6f7c-4bd4-4450-9cd0-5e2f26b0f3e4", "assumed": true, "ascendantuuid": "7db53bc9-99f3-478e-abb0-437dcbd32051", "descendantuuid": "4d9e1a7c-84fa-43c7-a1d7-e898b20df129", "grantedbyroleuuid": null, "grantedbytriggerof": "db7f287e-dfd7-4627-88e3-407cac226472"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '8c236a58-3fab-421e-b8a3-6c9df1269fed', 'INSERT', '{"op": "SELECT", "uuid": "8c236a58-3fab-421e-b8a3-6c9df1269fed", "objectuuid": "db7f287e-dfd7-4627-88e3-407cac226472", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'be124201-7708-49e7-9cbe-6e129694e33a', 'INSERT', '{"uuid": "be124201-7708-49e7-9cbe-6e129694e33a", "assumed": true, "ascendantuuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "descendantuuid": "8c236a58-3fab-421e-b8a3-6c9df1269fed", "grantedbyroleuuid": null, "grantedbytriggerof": "db7f287e-dfd7-4627-88e3-407cac226472"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'a4b5890e-c3d9-4eda-8a8c-3ebc20a39061', 'INSERT', '{"op": "UPDATE", "uuid": "a4b5890e-c3d9-4eda-8a8c-3ebc20a39061", "objectuuid": "db7f287e-dfd7-4627-88e3-407cac226472", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'dd3c3ef8-59bd-4633-9555-cdf9c6440489', 'INSERT', '{"uuid": "dd3c3ef8-59bd-4633-9555-cdf9c6440489", "assumed": true, "ascendantuuid": "9771d06d-8352-404c-aaba-743800e621e9", "descendantuuid": "a4b5890e-c3d9-4eda-8a8c-3ebc20a39061", "grantedbyroleuuid": null, "grantedbytriggerof": "db7f287e-dfd7-4627-88e3-407cac226472"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'f35bc896-c93b-42ca-994d-4f5f4e2e5b5f', 'INSERT', '{"op": "DELETE", "uuid": "f35bc896-c93b-42ca-994d-4f5f4e2e5b5f", "objectuuid": "7b7a528d-a284-4d0d-99ce-73f2a7585f78", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '12748785-e835-4f51-ac95-ee436ca09f2c', 'INSERT', '{"uuid": "12748785-e835-4f51-ac95-ee436ca09f2c", "assumed": true, "ascendantuuid": "7db53bc9-99f3-478e-abb0-437dcbd32051", "descendantuuid": "f35bc896-c93b-42ca-994d-4f5f4e2e5b5f", "grantedbyroleuuid": null, "grantedbytriggerof": "db7f287e-dfd7-4627-88e3-407cac226472"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'a5aac82c-b1b9-43d0-90bc-e7c0e0341e1c', 'INSERT', '{"op": "SELECT", "uuid": "a5aac82c-b1b9-43d0-90bc-e7c0e0341e1c", "objectuuid": "7b7a528d-a284-4d0d-99ce-73f2a7585f78", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '4f4cb4de-0905-4b8a-86d0-a4066d2b5d01', 'INSERT', '{"uuid": "4f4cb4de-0905-4b8a-86d0-a4066d2b5d01", "assumed": true, "ascendantuuid": "b34392da-5070-40dd-ab44-d411a9742f6d", "descendantuuid": "a5aac82c-b1b9-43d0-90bc-e7c0e0341e1c", "grantedbyroleuuid": null, "grantedbytriggerof": "db7f287e-dfd7-4627-88e3-407cac226472"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '6372e9ae-f522-468e-95b5-06a527854b0f', 'INSERT', '{"op": "UPDATE", "uuid": "6372e9ae-f522-468e-95b5-06a527854b0f", "objectuuid": "7b7a528d-a284-4d0d-99ce-73f2a7585f78", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '72c6fe2f-604a-4512-aada-2d1e36242727', 'INSERT', '{"uuid": "72c6fe2f-604a-4512-aada-2d1e36242727", "assumed": true, "ascendantuuid": "b34392da-5070-40dd-ab44-d411a9742f6d", "descendantuuid": "6372e9ae-f522-468e-95b5-06a527854b0f", "grantedbyroleuuid": null, "grantedbytriggerof": "db7f287e-dfd7-4627-88e3-407cac226472"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner', 'db7f287e-dfd7-4627-88e3-407cac226472', 'INSERT', '{"uuid": "db7f287e-dfd7-4627-88e3-407cac226472", "version": 0, "detailsuuid": "7b7a528d-a284-4d0d-99ce-73f2a7585f78", "partnernumber": 10020, "partnerreluuid": "164d3cde-e2ab-4239-9dbf-de1c963158ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', 'f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787', 'INSERT', '{"uuid": "f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787", "serialid": 237, "objecttable": "hs_office.partner_details"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner_details', 'f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787', 'INSERT', '{"uuid": "f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787", "version": 0, "birthday": null, "birthname": null, "birthplace": null, "dateofdeath": null, "registrationnumber": null, "registrationoffice": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', 'INSERT', '{"uuid": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215", "serialid": 238, "objecttable": "hs_office.partner"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '35f61da7-bd75-4482-ad05-d50ba7e099ca', 'INSERT', '{"op": "DELETE", "uuid": "35f61da7-bd75-4482-ad05-d50ba7e099ca", "objectuuid": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'c962f39e-7dd6-4cf9-a532-952952bdbd58', 'INSERT', '{"uuid": "c962f39e-7dd6-4cf9-a532-952952bdbd58", "assumed": true, "ascendantuuid": "0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d", "descendantuuid": "35f61da7-bd75-4482-ad05-d50ba7e099ca", "grantedbyroleuuid": null, "grantedbytriggerof": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '3c22ad48-dc16-4af3-8bbb-54ce2b7d91d1', 'INSERT', '{"op": "SELECT", "uuid": "3c22ad48-dc16-4af3-8bbb-54ce2b7d91d1", "objectuuid": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'b5be48c3-0721-406c-bf86-b7dc1d6a7016', 'INSERT', '{"op": "DELETE", "uuid": "b5be48c3-0721-406c-bf86-b7dc1d6a7016", "objectuuid": "58ca016b-15ea-41e3-80ba-2603bf736619", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'c137a79c-b6ab-45fe-863b-992198c9d355', 'INSERT', '{"uuid": "c137a79c-b6ab-45fe-863b-992198c9d355", "assumed": true, "ascendantuuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "descendantuuid": "3c22ad48-dc16-4af3-8bbb-54ce2b7d91d1", "grantedbyroleuuid": null, "grantedbytriggerof": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'd5009976-c8c8-4d64-b39e-08f019999ae9', 'INSERT', '{"op": "UPDATE", "uuid": "d5009976-c8c8-4d64-b39e-08f019999ae9", "objectuuid": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '40fa767a-79ed-4981-996f-f6a0bcb00df4', 'INSERT', '{"uuid": "40fa767a-79ed-4981-996f-f6a0bcb00df4", "assumed": true, "ascendantuuid": "cb295fdb-e294-4b05-944e-f0a4929ebeeb", "descendantuuid": "d5009976-c8c8-4d64-b39e-08f019999ae9", "grantedbyroleuuid": null, "grantedbytriggerof": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '9f2f2eae-80dc-49c7-810a-69b10fcc3421', 'INSERT', '{"op": "DELETE", "uuid": "9f2f2eae-80dc-49c7-810a-69b10fcc3421", "objectuuid": "f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '06e50120-1cfd-43d9-9f05-d69054dab845', 'INSERT', '{"uuid": "06e50120-1cfd-43d9-9f05-d69054dab845", "assumed": true, "ascendantuuid": "0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d", "descendantuuid": "9f2f2eae-80dc-49c7-810a-69b10fcc3421", "grantedbyroleuuid": null, "grantedbytriggerof": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '42557861-103c-4fb7-b3c6-0acd3d7737c2', 'INSERT', '{"op": "SELECT", "uuid": "42557861-103c-4fb7-b3c6-0acd3d7737c2", "objectuuid": "f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '07ec525f-703b-4d10-a693-4ef61afe606a', 'INSERT', '{"uuid": "07ec525f-703b-4d10-a693-4ef61afe606a", "assumed": true, "ascendantuuid": "f3af3c81-a512-47ea-8b47-0386291e6590", "descendantuuid": "42557861-103c-4fb7-b3c6-0acd3d7737c2", "grantedbyroleuuid": null, "grantedbytriggerof": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '85dbc28b-c5c3-4914-b645-a36056f4cf17', 'INSERT', '{"op": "UPDATE", "uuid": "85dbc28b-c5c3-4914-b645-a36056f4cf17", "objectuuid": "f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '8ef3b8c5-8286-42fe-bf20-011d1f5931e4', 'INSERT', '{"uuid": "8ef3b8c5-8286-42fe-bf20-011d1f5931e4", "assumed": true, "ascendantuuid": "f3af3c81-a512-47ea-8b47-0386291e6590", "descendantuuid": "85dbc28b-c5c3-4914-b645-a36056f4cf17", "grantedbyroleuuid": null, "grantedbytriggerof": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', 'INSERT', '{"uuid": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215", "version": 0, "detailsuuid": "f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787", "partnernumber": 11022, "partnerreluuid": "a85fd289-2383-4abe-b796-9b0b47d702d2"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', '90604765-0e48-4363-83e4-1c2e9e4a8f33', 'INSERT', '{"uuid": "90604765-0e48-4363-83e4-1c2e9e4a8f33", "serialid": 239, "objecttable": "hs_office.partner_details"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner_details', '90604765-0e48-4363-83e4-1c2e9e4a8f33', 'INSERT', '{"uuid": "90604765-0e48-4363-83e4-1c2e9e4a8f33", "version": 0, "birthday": null, "birthname": null, "birthplace": null, "dateofdeath": null, "registrationnumber": null, "registrationoffice": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', 'INSERT', '{"uuid": "029b1c78-d68b-48e6-83e5-8883b9cefe7c", "serialid": 240, "objecttable": "hs_office.partner"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '45cfb9f8-8e5e-438d-90f7-6b1ee872c003', 'INSERT', '{"op": "DELETE", "uuid": "45cfb9f8-8e5e-438d-90f7-6b1ee872c003", "objectuuid": "029b1c78-d68b-48e6-83e5-8883b9cefe7c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '14c82607-a49e-45fa-aa03-92c48062069c', 'INSERT', '{"uuid": "14c82607-a49e-45fa-aa03-92c48062069c", "assumed": true, "ascendantuuid": "b26cca89-03f0-4498-bf64-7385c0b7244a", "descendantuuid": "45cfb9f8-8e5e-438d-90f7-6b1ee872c003", "grantedbyroleuuid": null, "grantedbytriggerof": "029b1c78-d68b-48e6-83e5-8883b9cefe7c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'ac1f7518-f255-47bd-bf31-29d3cd2bb57a', 'INSERT', '{"op": "SELECT", "uuid": "ac1f7518-f255-47bd-bf31-29d3cd2bb57a", "objectuuid": "029b1c78-d68b-48e6-83e5-8883b9cefe7c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'd276fd29-2bdd-4567-9276-5996c2c75389', 'INSERT', '{"uuid": "d276fd29-2bdd-4567-9276-5996c2c75389", "assumed": true, "ascendantuuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "descendantuuid": "ac1f7518-f255-47bd-bf31-29d3cd2bb57a", "grantedbyroleuuid": null, "grantedbytriggerof": "029b1c78-d68b-48e6-83e5-8883b9cefe7c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'b45ba485-ee82-447e-8a4d-42679a233455', 'INSERT', '{"op": "UPDATE", "uuid": "b45ba485-ee82-447e-8a4d-42679a233455", "objectuuid": "029b1c78-d68b-48e6-83e5-8883b9cefe7c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'b1bd4e7c-e01c-406a-b272-bf5a51e749d4', 'INSERT', '{"uuid": "b1bd4e7c-e01c-406a-b272-bf5a51e749d4", "assumed": true, "ascendantuuid": "76968391-174d-4530-b310-1244c4b1897a", "descendantuuid": "b45ba485-ee82-447e-8a4d-42679a233455", "grantedbyroleuuid": null, "grantedbytriggerof": "029b1c78-d68b-48e6-83e5-8883b9cefe7c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'ac9bd6e7-e7b5-4f25-a873-79ff3436fa66', 'INSERT', '{"op": "DELETE", "uuid": "ac9bd6e7-e7b5-4f25-a873-79ff3436fa66", "objectuuid": "90604765-0e48-4363-83e4-1c2e9e4a8f33", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'e0e072c2-8f36-4c5c-9948-0e8ce20b00e6', 'INSERT', '{"uuid": "e0e072c2-8f36-4c5c-9948-0e8ce20b00e6", "assumed": true, "ascendantuuid": "b26cca89-03f0-4498-bf64-7385c0b7244a", "descendantuuid": "ac9bd6e7-e7b5-4f25-a873-79ff3436fa66", "grantedbyroleuuid": null, "grantedbytriggerof": "029b1c78-d68b-48e6-83e5-8883b9cefe7c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '52d12930-5ca0-4344-bf72-32faf8dc5d9c', 'INSERT', '{"op": "SELECT", "uuid": "52d12930-5ca0-4344-bf72-32faf8dc5d9c", "objectuuid": "90604765-0e48-4363-83e4-1c2e9e4a8f33", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '465d0cea-7e8b-47b3-9a57-93a283ae5582', 'INSERT', '{"uuid": "465d0cea-7e8b-47b3-9a57-93a283ae5582", "assumed": true, "ascendantuuid": "863eea7c-8b49-494a-9654-9963f2dbb4e5", "descendantuuid": "52d12930-5ca0-4344-bf72-32faf8dc5d9c", "grantedbyroleuuid": null, "grantedbytriggerof": "029b1c78-d68b-48e6-83e5-8883b9cefe7c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'ba038cc8-3ca3-4c25-9805-08eef60945b5', 'INSERT', '{"op": "UPDATE", "uuid": "ba038cc8-3ca3-4c25-9805-08eef60945b5", "objectuuid": "90604765-0e48-4363-83e4-1c2e9e4a8f33", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '6821e41f-9460-485c-9b29-7017ab5668df', 'INSERT', '{"uuid": "6821e41f-9460-485c-9b29-7017ab5668df", "assumed": true, "ascendantuuid": "863eea7c-8b49-494a-9654-9963f2dbb4e5", "descendantuuid": "ba038cc8-3ca3-4c25-9805-08eef60945b5", "grantedbyroleuuid": null, "grantedbytriggerof": "029b1c78-d68b-48e6-83e5-8883b9cefe7c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', 'INSERT', '{"uuid": "029b1c78-d68b-48e6-83e5-8883b9cefe7c", "version": 0, "detailsuuid": "90604765-0e48-4363-83e4-1c2e9e4a8f33", "partnernumber": 10152, "partnerreluuid": "201b417e-4ebe-458b-a7ce-a287c0ad9287"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', 'a7494bd0-af97-421e-bfa3-53bd97fb1df8', 'INSERT', '{"uuid": "a7494bd0-af97-421e-bfa3-53bd97fb1df8", "serialid": 241, "objecttable": "hs_office.partner_details"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner_details', 'a7494bd0-af97-421e-bfa3-53bd97fb1df8', 'INSERT', '{"uuid": "a7494bd0-af97-421e-bfa3-53bd97fb1df8", "version": 0, "birthday": null, "birthname": null, "birthplace": null, "dateofdeath": null, "registrationnumber": null, "registrationoffice": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', '58ca016b-15ea-41e3-80ba-2603bf736619', 'INSERT', '{"uuid": "58ca016b-15ea-41e3-80ba-2603bf736619", "serialid": 242, "objecttable": "hs_office.partner"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '8d1d4277-038f-4ee0-a7a7-e2eda624508a', 'INSERT', '{"uuid": "8d1d4277-038f-4ee0-a7a7-e2eda624508a", "assumed": true, "ascendantuuid": "7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff", "descendantuuid": "b5be48c3-0721-406c-bf86-b7dc1d6a7016", "grantedbyroleuuid": null, "grantedbytriggerof": "58ca016b-15ea-41e3-80ba-2603bf736619"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'ba8ff028-06d6-4536-8e79-6c46f8e4b9a2', 'INSERT', '{"op": "SELECT", "uuid": "ba8ff028-06d6-4536-8e79-6c46f8e4b9a2", "objectuuid": "58ca016b-15ea-41e3-80ba-2603bf736619", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '3d74caa2-f602-4234-aeac-cfeb0c8b2695', 'INSERT', '{"uuid": "3d74caa2-f602-4234-aeac-cfeb0c8b2695", "assumed": true, "ascendantuuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "descendantuuid": "ba8ff028-06d6-4536-8e79-6c46f8e4b9a2", "grantedbyroleuuid": null, "grantedbytriggerof": "58ca016b-15ea-41e3-80ba-2603bf736619"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '470fa9af-f292-4516-be71-346b1e987d83', 'INSERT', '{"op": "UPDATE", "uuid": "470fa9af-f292-4516-be71-346b1e987d83", "objectuuid": "58ca016b-15ea-41e3-80ba-2603bf736619", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '772c9fde-aea0-425e-aa68-9c2141974334', 'INSERT', '{"uuid": "772c9fde-aea0-425e-aa68-9c2141974334", "assumed": true, "ascendantuuid": "f101cc07-ed84-4e34-9f70-62ec6a646e81", "descendantuuid": "470fa9af-f292-4516-be71-346b1e987d83", "grantedbyroleuuid": null, "grantedbytriggerof": "58ca016b-15ea-41e3-80ba-2603bf736619"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'e62715a8-2e69-4a59-806e-000886fedd92', 'INSERT', '{"op": "DELETE", "uuid": "e62715a8-2e69-4a59-806e-000886fedd92", "objectuuid": "a7494bd0-af97-421e-bfa3-53bd97fb1df8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '3a9cff2c-733b-41a8-a37c-d1853a3d5913', 'INSERT', '{"uuid": "3a9cff2c-733b-41a8-a37c-d1853a3d5913", "assumed": true, "ascendantuuid": "7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff", "descendantuuid": "e62715a8-2e69-4a59-806e-000886fedd92", "grantedbyroleuuid": null, "grantedbytriggerof": "58ca016b-15ea-41e3-80ba-2603bf736619"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '0f8fd73f-526c-4e76-a5f1-043e44386cc3', 'INSERT', '{"op": "SELECT", "uuid": "0f8fd73f-526c-4e76-a5f1-043e44386cc3", "objectuuid": "a7494bd0-af97-421e-bfa3-53bd97fb1df8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '500200b0-6973-4ae5-85cd-7386c6f9465b', 'INSERT', '{"uuid": "500200b0-6973-4ae5-85cd-7386c6f9465b", "assumed": true, "ascendantuuid": "1d4c6f1f-200f-4a68-ae7b-6fda13687e41", "descendantuuid": "0f8fd73f-526c-4e76-a5f1-043e44386cc3", "grantedbyroleuuid": null, "grantedbytriggerof": "58ca016b-15ea-41e3-80ba-2603bf736619"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '0e0eb247-f0a2-435b-b44c-34ffc5ecfda6', 'INSERT', '{"op": "UPDATE", "uuid": "0e0eb247-f0a2-435b-b44c-34ffc5ecfda6", "objectuuid": "a7494bd0-af97-421e-bfa3-53bd97fb1df8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '2548a412-57f7-41fa-9d02-1790339303be', 'INSERT', '{"uuid": "2548a412-57f7-41fa-9d02-1790339303be", "assumed": true, "ascendantuuid": "1d4c6f1f-200f-4a68-ae7b-6fda13687e41", "descendantuuid": "0e0eb247-f0a2-435b-b44c-34ffc5ecfda6", "grantedbyroleuuid": null, "grantedbytriggerof": "58ca016b-15ea-41e3-80ba-2603bf736619"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner', '58ca016b-15ea-41e3-80ba-2603bf736619', 'INSERT', '{"uuid": "58ca016b-15ea-41e3-80ba-2603bf736619", "version": 0, "detailsuuid": "a7494bd0-af97-421e-bfa3-53bd97fb1df8", "partnernumber": 19090, "partnerreluuid": "bcd0fdb5-7415-40d2-8265-85113a4b66be"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', 'f1048d9f-e560-459a-91fe-f769ef049648', 'INSERT', '{"uuid": "f1048d9f-e560-459a-91fe-f769ef049648", "serialid": 243, "objecttable": "hs_office.partner_details"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner_details', 'f1048d9f-e560-459a-91fe-f769ef049648', 'INSERT', '{"uuid": "f1048d9f-e560-459a-91fe-f769ef049648", "version": 0, "birthday": null, "birthname": null, "birthplace": null, "dateofdeath": null, "registrationnumber": null, "registrationoffice": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', 'INSERT', '{"uuid": "defa6288-bed7-4ed8-ae6d-fbbb3530a632", "serialid": 244, "objecttable": "hs_office.partner"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '1aa9a0f2-47a7-498d-b0e8-9e73ef9f5b00', 'INSERT', '{"op": "DELETE", "uuid": "1aa9a0f2-47a7-498d-b0e8-9e73ef9f5b00", "objectuuid": "defa6288-bed7-4ed8-ae6d-fbbb3530a632", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'b3544903-2ae4-4b16-84f7-01adc31301f8', 'INSERT', '{"uuid": "b3544903-2ae4-4b16-84f7-01adc31301f8", "assumed": true, "ascendantuuid": "5242e0b6-12e3-4a59-bf06-de114cb69ff4", "descendantuuid": "1aa9a0f2-47a7-498d-b0e8-9e73ef9f5b00", "grantedbyroleuuid": null, "grantedbytriggerof": "defa6288-bed7-4ed8-ae6d-fbbb3530a632"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '57130e2a-328a-4402-bd54-a76cb815503c', 'INSERT', '{"op": "SELECT", "uuid": "57130e2a-328a-4402-bd54-a76cb815503c", "objectuuid": "defa6288-bed7-4ed8-ae6d-fbbb3530a632", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '889edabb-a1de-44f3-8051-788e2e6b61c2', 'INSERT', '{"uuid": "889edabb-a1de-44f3-8051-788e2e6b61c2", "assumed": true, "ascendantuuid": "c85e8116-355e-408a-93fa-c699da2a76f3", "descendantuuid": "57130e2a-328a-4402-bd54-a76cb815503c", "grantedbyroleuuid": null, "grantedbytriggerof": "defa6288-bed7-4ed8-ae6d-fbbb3530a632"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '0baaa10d-4abf-42df-9689-d6d72a9cc418', 'INSERT', '{"op": "UPDATE", "uuid": "0baaa10d-4abf-42df-9689-d6d72a9cc418", "objectuuid": "defa6288-bed7-4ed8-ae6d-fbbb3530a632", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '96ae4fa2-366d-42fd-b690-f0c1e50d547a', 'INSERT', '{"uuid": "96ae4fa2-366d-42fd-b690-f0c1e50d547a", "assumed": true, "ascendantuuid": "b8350678-d30a-422a-bb5d-79c65af2f890", "descendantuuid": "0baaa10d-4abf-42df-9689-d6d72a9cc418", "grantedbyroleuuid": null, "grantedbytriggerof": "defa6288-bed7-4ed8-ae6d-fbbb3530a632"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '7c958983-efb4-4117-a2a6-4a3d35c233b5', 'INSERT', '{"op": "DELETE", "uuid": "7c958983-efb4-4117-a2a6-4a3d35c233b5", "objectuuid": "f1048d9f-e560-459a-91fe-f769ef049648", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '91d8e718-9d56-47f8-8aaa-66db5bf22f91', 'INSERT', '{"uuid": "91d8e718-9d56-47f8-8aaa-66db5bf22f91", "assumed": true, "ascendantuuid": "5242e0b6-12e3-4a59-bf06-de114cb69ff4", "descendantuuid": "7c958983-efb4-4117-a2a6-4a3d35c233b5", "grantedbyroleuuid": null, "grantedbytriggerof": "defa6288-bed7-4ed8-ae6d-fbbb3530a632"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'c9732223-5e57-4d36-b412-91122ecb900f', 'INSERT', '{"op": "SELECT", "uuid": "c9732223-5e57-4d36-b412-91122ecb900f", "objectuuid": "f1048d9f-e560-459a-91fe-f769ef049648", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '68f4fe6b-261d-448c-bce0-adff94a81deb', 'INSERT', '{"uuid": "68f4fe6b-261d-448c-bce0-adff94a81deb", "assumed": true, "ascendantuuid": "0f833f5a-8afb-4934-a8a6-9dadbdcf89dd", "descendantuuid": "c9732223-5e57-4d36-b412-91122ecb900f", "grantedbyroleuuid": null, "grantedbytriggerof": "defa6288-bed7-4ed8-ae6d-fbbb3530a632"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'a1476e12-e8fd-4bdc-a1a1-68177652431d', 'INSERT', '{"op": "UPDATE", "uuid": "a1476e12-e8fd-4bdc-a1a1-68177652431d", "objectuuid": "f1048d9f-e560-459a-91fe-f769ef049648", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '95012cd0-a5ed-4671-a445-782b25924c4c', 'INSERT', '{"uuid": "95012cd0-a5ed-4671-a445-782b25924c4c", "assumed": true, "ascendantuuid": "0f833f5a-8afb-4934-a8a6-9dadbdcf89dd", "descendantuuid": "a1476e12-e8fd-4bdc-a1a1-68177652431d", "grantedbyroleuuid": null, "grantedbytriggerof": "defa6288-bed7-4ed8-ae6d-fbbb3530a632"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', 'INSERT', '{"uuid": "defa6288-bed7-4ed8-ae6d-fbbb3530a632", "version": 0, "detailsuuid": "f1048d9f-e560-459a-91fe-f769ef049648", "partnernumber": 10000, "partnerreluuid": "f85f9a58-7651-417f-b1b2-cf522bcce415"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', 'b2cd9234-6651-4c9a-818d-f48610d76095', 'INSERT', '{"uuid": "b2cd9234-6651-4c9a-818d-f48610d76095", "serialid": 245, "objecttable": "hs_office.partner_details"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner_details', 'b2cd9234-6651-4c9a-818d-f48610d76095', 'INSERT', '{"uuid": "b2cd9234-6651-4c9a-818d-f48610d76095", "version": 0, "birthday": null, "birthname": null, "birthplace": null, "dateofdeath": null, "registrationnumber": null, "registrationoffice": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', '25b8066a-59fd-4733-90f2-8ea80c826fff', 'INSERT', '{"uuid": "25b8066a-59fd-4733-90f2-8ea80c826fff", "serialid": 246, "objecttable": "hs_office.partner"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'b12dcf3d-9b06-4d32-938c-209adc18ce37', 'INSERT', '{"op": "DELETE", "uuid": "b12dcf3d-9b06-4d32-938c-209adc18ce37", "objectuuid": "25b8066a-59fd-4733-90f2-8ea80c826fff", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'e17b347d-7ad8-422a-9418-1c55851e6e63', 'INSERT', '{"uuid": "e17b347d-7ad8-422a-9418-1c55851e6e63", "assumed": true, "ascendantuuid": "0726dd6c-118e-4cbc-9077-d4dcb0e61643", "descendantuuid": "b12dcf3d-9b06-4d32-938c-209adc18ce37", "grantedbyroleuuid": null, "grantedbytriggerof": "25b8066a-59fd-4733-90f2-8ea80c826fff"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'daeaae1b-5d88-45a8-8697-cd2e22e519a4', 'INSERT', '{"op": "SELECT", "uuid": "daeaae1b-5d88-45a8-8697-cd2e22e519a4", "objectuuid": "25b8066a-59fd-4733-90f2-8ea80c826fff", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'b0b5748b-2977-41d8-b60c-4cd0cdf6227e', 'INSERT', '{"uuid": "b0b5748b-2977-41d8-b60c-4cd0cdf6227e", "assumed": true, "ascendantuuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "descendantuuid": "daeaae1b-5d88-45a8-8697-cd2e22e519a4", "grantedbyroleuuid": null, "grantedbytriggerof": "25b8066a-59fd-4733-90f2-8ea80c826fff"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'fd07e597-fc5d-4c64-b491-76a5420aec78', 'INSERT', '{"op": "UPDATE", "uuid": "fd07e597-fc5d-4c64-b491-76a5420aec78", "objectuuid": "25b8066a-59fd-4733-90f2-8ea80c826fff", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '15aaed6e-7f22-4d6e-b2b3-30466982b87b', 'INSERT', '{"uuid": "15aaed6e-7f22-4d6e-b2b3-30466982b87b", "assumed": true, "ascendantuuid": "8dfb5e53-1554-4e5c-a045-85121ce4bd71", "descendantuuid": "fd07e597-fc5d-4c64-b491-76a5420aec78", "grantedbyroleuuid": null, "grantedbytriggerof": "25b8066a-59fd-4733-90f2-8ea80c826fff"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'ecde7ac8-3b81-4864-8b26-2e07cdc49190', 'INSERT', '{"op": "DELETE", "uuid": "ecde7ac8-3b81-4864-8b26-2e07cdc49190", "objectuuid": "b2cd9234-6651-4c9a-818d-f48610d76095", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '66111571-a50d-45ce-894e-8c9fa6fc3ae8', 'INSERT', '{"uuid": "66111571-a50d-45ce-894e-8c9fa6fc3ae8", "assumed": true, "ascendantuuid": "0726dd6c-118e-4cbc-9077-d4dcb0e61643", "descendantuuid": "ecde7ac8-3b81-4864-8b26-2e07cdc49190", "grantedbyroleuuid": null, "grantedbytriggerof": "25b8066a-59fd-4733-90f2-8ea80c826fff"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'fc871f18-a6a5-4cb7-9f23-fee703a845c4', 'INSERT', '{"op": "SELECT", "uuid": "fc871f18-a6a5-4cb7-9f23-fee703a845c4", "objectuuid": "b2cd9234-6651-4c9a-818d-f48610d76095", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '87d42752-e7b0-44e5-837e-0b58675d5d57', 'INSERT', '{"uuid": "87d42752-e7b0-44e5-837e-0b58675d5d57", "assumed": true, "ascendantuuid": "13a3ca39-6352-48e1-b1fb-82f3fc5558f2", "descendantuuid": "fc871f18-a6a5-4cb7-9f23-fee703a845c4", "grantedbyroleuuid": null, "grantedbytriggerof": "25b8066a-59fd-4733-90f2-8ea80c826fff"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '1e643070-dafa-46db-8294-fecd8249232e', 'INSERT', '{"op": "UPDATE", "uuid": "1e643070-dafa-46db-8294-fecd8249232e", "objectuuid": "b2cd9234-6651-4c9a-818d-f48610d76095", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'aa201d37-3a49-454e-a630-16cfa631aa89', 'INSERT', '{"uuid": "aa201d37-3a49-454e-a630-16cfa631aa89", "assumed": true, "ascendantuuid": "13a3ca39-6352-48e1-b1fb-82f3fc5558f2", "descendantuuid": "1e643070-dafa-46db-8294-fecd8249232e", "grantedbyroleuuid": null, "grantedbytriggerof": "25b8066a-59fd-4733-90f2-8ea80c826fff"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner', '25b8066a-59fd-4733-90f2-8ea80c826fff', 'INSERT', '{"uuid": "25b8066a-59fd-4733-90f2-8ea80c826fff", "version": 0, "detailsuuid": "b2cd9234-6651-4c9a-818d-f48610d76095", "partnernumber": 11018, "partnerreluuid": "463c4856-495f-4ab3-b26c-7b2f96b05ab5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', '871eadbe-c143-444a-966c-cc4494ba93bf', 'INSERT', '{"uuid": "871eadbe-c143-444a-966c-cc4494ba93bf", "serialid": 247, "objecttable": "hs_office.partner_details"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner_details', '871eadbe-c143-444a-966c-cc4494ba93bf', 'INSERT', '{"uuid": "871eadbe-c143-444a-966c-cc4494ba93bf", "version": 0, "birthday": null, "birthname": null, "birthplace": null, "dateofdeath": null, "registrationnumber": null, "registrationoffice": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.object', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', 'INSERT', '{"uuid": "c83c9583-a825-4a2d-96b7-fec9dd635fbc", "serialid": 248, "objecttable": "hs_office.partner"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '08c5e34a-9a18-445b-9fbb-85a3ff34927b', 'INSERT', '{"op": "DELETE", "uuid": "08c5e34a-9a18-445b-9fbb-85a3ff34927b", "objectuuid": "c83c9583-a825-4a2d-96b7-fec9dd635fbc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'e25cf8b4-6034-4849-854b-d94e4dd4a2fc', 'INSERT', '{"uuid": "e25cf8b4-6034-4849-854b-d94e4dd4a2fc", "assumed": true, "ascendantuuid": "256083e7-90ac-4f38-9bc1-deedb0f78d2c", "descendantuuid": "08c5e34a-9a18-445b-9fbb-85a3ff34927b", "grantedbyroleuuid": null, "grantedbytriggerof": "c83c9583-a825-4a2d-96b7-fec9dd635fbc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '71520b2b-f697-4135-a748-8ba36939915d', 'INSERT', '{"op": "SELECT", "uuid": "71520b2b-f697-4135-a748-8ba36939915d", "objectuuid": "c83c9583-a825-4a2d-96b7-fec9dd635fbc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'd0f7b382-1feb-40be-9537-b27801c05498', 'INSERT', '{"uuid": "d0f7b382-1feb-40be-9537-b27801c05498", "assumed": true, "ascendantuuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "descendantuuid": "71520b2b-f697-4135-a748-8ba36939915d", "grantedbyroleuuid": null, "grantedbytriggerof": "c83c9583-a825-4a2d-96b7-fec9dd635fbc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'ffbddcbf-8922-4b3f-9248-47b86638a1b6', 'INSERT', '{"op": "UPDATE", "uuid": "ffbddcbf-8922-4b3f-9248-47b86638a1b6", "objectuuid": "c83c9583-a825-4a2d-96b7-fec9dd635fbc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'a340ffd7-89fd-462a-9c8d-53e6446f6b4b', 'INSERT', '{"uuid": "a340ffd7-89fd-462a-9c8d-53e6446f6b4b", "assumed": true, "ascendantuuid": "28bf24da-eb68-4a99-8ff9-6e4145f5e805", "descendantuuid": "ffbddcbf-8922-4b3f-9248-47b86638a1b6", "grantedbyroleuuid": null, "grantedbytriggerof": "c83c9583-a825-4a2d-96b7-fec9dd635fbc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '07b70014-fbf6-480a-a128-6dadf6ea6c49', 'INSERT', '{"op": "DELETE", "uuid": "07b70014-fbf6-480a-a128-6dadf6ea6c49", "objectuuid": "871eadbe-c143-444a-966c-cc4494ba93bf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', 'ec59d5b3-2b86-4122-a4b4-602b1a0cabbd', 'INSERT', '{"uuid": "ec59d5b3-2b86-4122-a4b4-602b1a0cabbd", "assumed": true, "ascendantuuid": "256083e7-90ac-4f38-9bc1-deedb0f78d2c", "descendantuuid": "07b70014-fbf6-480a-a128-6dadf6ea6c49", "grantedbyroleuuid": null, "grantedbytriggerof": "c83c9583-a825-4a2d-96b7-fec9dd635fbc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', '193ceb34-df58-46b9-92e5-62ce50a367c9', 'INSERT', '{"op": "SELECT", "uuid": "193ceb34-df58-46b9-92e5-62ce50a367c9", "objectuuid": "871eadbe-c143-444a-966c-cc4494ba93bf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '269cf1ee-af0c-4446-85c4-bead23beac87', 'INSERT', '{"uuid": "269cf1ee-af0c-4446-85c4-bead23beac87", "assumed": true, "ascendantuuid": "f93693fa-7dc5-4513-8537-be9541d6e5dc", "descendantuuid": "193ceb34-df58-46b9-92e5-62ce50a367c9", "grantedbyroleuuid": null, "grantedbytriggerof": "c83c9583-a825-4a2d-96b7-fec9dd635fbc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.permission', 'c198dbfe-def4-43ff-ae55-8e0a58f068c7', 'INSERT', '{"op": "UPDATE", "uuid": "c198dbfe-def4-43ff-ae55-8e0a58f068c7", "objectuuid": "871eadbe-c143-444a-966c-cc4494ba93bf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '17e8a223-4aa0-4e35-aca3-f381f9ce1328', 'INSERT', '{"op": "DELETE", "uuid": "17e8a223-4aa0-4e35-aca3-f381f9ce1328", "objectuuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'rbac.grant', '854cef44-9dd6-413c-99f1-34f4f09e727c', 'INSERT', '{"uuid": "854cef44-9dd6-413c-99f1-34f4f09e727c", "assumed": true, "ascendantuuid": "f93693fa-7dc5-4513-8537-be9541d6e5dc", "descendantuuid": "c198dbfe-def4-43ff-ae55-8e0a58f068c7", "grantedbyroleuuid": null, "grantedbytriggerof": "c83c9583-a825-4a2d-96b7-fec9dd635fbc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2033', 'hs_office.partner', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', 'INSERT', '{"uuid": "c83c9583-a825-4a2d-96b7-fec9dd635fbc", "version": 0, "detailsuuid": "871eadbe-c143-444a-966c-cc4494ba93bf", "partnernumber": 11019, "partnerreluuid": "ecf9603d-1bc4-417b-b953-552b8f08f6f3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.object', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', 'INSERT', '{"uuid": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61", "serialid": 249, "objecttable": "hs_office.debitor"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'fbcdbc8e-c599-43b4-85cc-4853a56dc0dd', 'INSERT', '{"uuid": "fbcdbc8e-c599-43b4-85cc-4853a56dc0dd", "assumed": true, "ascendantuuid": "3b195996-371c-41e4-9b66-a50553582e17", "descendantuuid": "0f5c3f08-d249-404a-b740-d759fced2d09", "grantedbyroleuuid": null, "grantedbytriggerof": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '67d27951-28c5-4bc7-932e-87ef90fa8d4e', 'INSERT', '{"uuid": "67d27951-28c5-4bc7-932e-87ef90fa8d4e", "assumed": true, "ascendantuuid": "7de2ab25-6b6a-4b59-ba8d-818110ae4ccb", "descendantuuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "grantedbyroleuuid": null, "grantedbytriggerof": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '24044b00-dcd1-4b61-92bf-40dfded44629', 'INSERT', '{"uuid": "24044b00-dcd1-4b61-92bf-40dfded44629", "assumed": true, "ascendantuuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "descendantuuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "grantedbyroleuuid": null, "grantedbytriggerof": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '5f37d6b1-5ec6-4c91-8f11-32f95dac7b9e', 'INSERT', '{"op": "DELETE", "uuid": "5f37d6b1-5ec6-4c91-8f11-32f95dac7b9e", "objectuuid": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'e3cb6e12-2d16-416b-9121-73ba15fa74c1', 'INSERT', '{"uuid": "e3cb6e12-2d16-416b-9121-73ba15fa74c1", "assumed": true, "ascendantuuid": "98d81696-7c71-4ffe-bfc2-1fea37613440", "descendantuuid": "5f37d6b1-5ec6-4c91-8f11-32f95dac7b9e", "grantedbyroleuuid": null, "grantedbytriggerof": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '68136a56-de73-425b-bc05-ab6fed1cdfd1', 'INSERT', '{"op": "SELECT", "uuid": "68136a56-de73-425b-bc05-ab6fed1cdfd1", "objectuuid": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '4b8e69b8-385c-4148-8487-927bad14fd5c', 'INSERT', '{"uuid": "4b8e69b8-385c-4148-8487-927bad14fd5c", "assumed": true, "ascendantuuid": "8ad792c1-10e1-43fa-8d5a-a6f3810878a2", "descendantuuid": "68136a56-de73-425b-bc05-ab6fed1cdfd1", "grantedbyroleuuid": null, "grantedbytriggerof": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '43c48616-3e31-4bed-9727-f9e6d6447378', 'INSERT', '{"op": "UPDATE", "uuid": "43c48616-3e31-4bed-9727-f9e6d6447378", "objectuuid": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '0d2aa1bd-9da9-4906-9e3f-46b26aab00ad', 'INSERT', '{"uuid": "0d2aa1bd-9da9-4906-9e3f-46b26aab00ad", "assumed": true, "ascendantuuid": "0f5c3f08-d249-404a-b740-d759fced2d09", "descendantuuid": "43c48616-3e31-4bed-9727-f9e6d6447378", "grantedbyroleuuid": null, "grantedbytriggerof": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'hs_office.debitor', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', 'INSERT', '{"uuid": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61", "vatid": "DE217249198", "version": 0, "billable": false, "vatbusiness": true, "defaultprefix": "mim", "debitorreluuid": "f415978e-b5c2-4a99-962e-3d31a4658780", "vatcountrycode": null, "vatreversecharge": false, "debitornumbersuffix": "00", "refundbankaccountuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.object', '84d4763e-0133-4d81-946b-fb64d1a3fd26', 'INSERT', '{"uuid": "84d4763e-0133-4d81-946b-fb64d1a3fd26", "serialid": 250, "objecttable": "hs_office.debitor"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '5bf37920-28fd-4ed4-86ed-b43c3d049f68', 'INSERT', '{"uuid": "5bf37920-28fd-4ed4-86ed-b43c3d049f68", "assumed": true, "ascendantuuid": "9771d06d-8352-404c-aaba-743800e621e9", "descendantuuid": "ba80c834-f5a8-4243-98a6-9a3be63c4f47", "grantedbyroleuuid": null, "grantedbytriggerof": "84d4763e-0133-4d81-946b-fb64d1a3fd26"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'de2295a1-4150-4761-8fd3-7e80e29c7ceb', 'INSERT', '{"uuid": "de2295a1-4150-4761-8fd3-7e80e29c7ceb", "assumed": true, "ascendantuuid": "b34392da-5070-40dd-ab44-d411a9742f6d", "descendantuuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "grantedbyroleuuid": null, "grantedbytriggerof": "84d4763e-0133-4d81-946b-fb64d1a3fd26"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'd38557f0-0b84-4ba4-bb4e-bb869d15e5e5', 'INSERT', '{"uuid": "d38557f0-0b84-4ba4-bb4e-bb869d15e5e5", "assumed": true, "ascendantuuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "descendantuuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "grantedbyroleuuid": null, "grantedbytriggerof": "84d4763e-0133-4d81-946b-fb64d1a3fd26"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'a6a56680-46da-47fa-b5a0-5012f91bb3d9', 'INSERT', '{"op": "DELETE", "uuid": "a6a56680-46da-47fa-b5a0-5012f91bb3d9", "objectuuid": "84d4763e-0133-4d81-946b-fb64d1a3fd26", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'd23335f1-253d-4772-8afb-8bd754a70442', 'INSERT', '{"uuid": "d23335f1-253d-4772-8afb-8bd754a70442", "assumed": true, "ascendantuuid": "0d96a253-347e-4903-9db9-b362335e4341", "descendantuuid": "a6a56680-46da-47fa-b5a0-5012f91bb3d9", "grantedbyroleuuid": null, "grantedbytriggerof": "84d4763e-0133-4d81-946b-fb64d1a3fd26"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'ca68370e-d560-42ec-bb93-b14df8eacdd8', 'INSERT', '{"op": "SELECT", "uuid": "ca68370e-d560-42ec-bb93-b14df8eacdd8", "objectuuid": "84d4763e-0133-4d81-946b-fb64d1a3fd26", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'd786be06-bb72-43ce-9600-b77a9d8b6d74', 'INSERT', '{"uuid": "d786be06-bb72-43ce-9600-b77a9d8b6d74", "assumed": true, "ascendantuuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "descendantuuid": "ca68370e-d560-42ec-bb93-b14df8eacdd8", "grantedbyroleuuid": null, "grantedbytriggerof": "84d4763e-0133-4d81-946b-fb64d1a3fd26"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '48f6d390-367b-4e7c-ab30-c2e7009248a6', 'INSERT', '{"op": "UPDATE", "uuid": "48f6d390-367b-4e7c-ab30-c2e7009248a6", "objectuuid": "84d4763e-0133-4d81-946b-fb64d1a3fd26", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '5c1c68dd-959c-418e-977b-f8e53b84d588', 'INSERT', '{"uuid": "5c1c68dd-959c-418e-977b-f8e53b84d588", "assumed": true, "ascendantuuid": "ba80c834-f5a8-4243-98a6-9a3be63c4f47", "descendantuuid": "48f6d390-367b-4e7c-ab30-c2e7009248a6", "grantedbyroleuuid": null, "grantedbytriggerof": "84d4763e-0133-4d81-946b-fb64d1a3fd26"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'hs_office.debitor', '84d4763e-0133-4d81-946b-fb64d1a3fd26', 'INSERT', '{"uuid": "84d4763e-0133-4d81-946b-fb64d1a3fd26", "vatid": "", "version": 0, "billable": false, "vatbusiness": true, "defaultprefix": "xyz", "debitorreluuid": "e9bb6489-3e78-4707-bbe4-70b1fe6212ac", "vatcountrycode": null, "vatreversecharge": false, "debitornumbersuffix": "00", "refundbankaccountuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.object', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', 'INSERT', '{"uuid": "bdfc3748-abd1-4bce-a239-f5b4df6715c4", "serialid": 251, "objecttable": "hs_office.debitor"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '633f0e7b-90cd-474c-a9ac-a97a1d91c075', 'INSERT', '{"uuid": "633f0e7b-90cd-474c-a9ac-a97a1d91c075", "assumed": true, "ascendantuuid": "cb295fdb-e294-4b05-944e-f0a4929ebeeb", "descendantuuid": "3010c421-5c96-4f0d-b214-c773e0915564", "grantedbyroleuuid": null, "grantedbytriggerof": "bdfc3748-abd1-4bce-a239-f5b4df6715c4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'bf58a617-cb18-42a8-b34a-56b584e6daf1', 'INSERT', '{"op": "INSERT", "uuid": "bf58a617-cb18-42a8-b34a-56b584e6daf1", "objectuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f", "optablename": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'bf2fdad1-c055-46da-aacb-656703ee3e86', 'INSERT', '{"uuid": "bf2fdad1-c055-46da-aacb-656703ee3e86", "assumed": true, "ascendantuuid": "f3af3c81-a512-47ea-8b47-0386291e6590", "descendantuuid": "270aac69-03bb-4429-b925-3019bd92cf32", "grantedbyroleuuid": null, "grantedbytriggerof": "bdfc3748-abd1-4bce-a239-f5b4df6715c4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'dfbc7ea6-1400-47f9-8ebf-f7dee78aa28a', 'INSERT', '{"uuid": "dfbc7ea6-1400-47f9-8ebf-f7dee78aa28a", "assumed": true, "ascendantuuid": "270aac69-03bb-4429-b925-3019bd92cf32", "descendantuuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "grantedbyroleuuid": null, "grantedbytriggerof": "bdfc3748-abd1-4bce-a239-f5b4df6715c4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'cd8e900a-3f5f-4b54-abdd-72b79c3f3203', 'INSERT', '{"op": "DELETE", "uuid": "cd8e900a-3f5f-4b54-abdd-72b79c3f3203", "objectuuid": "bdfc3748-abd1-4bce-a239-f5b4df6715c4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '3d37a820-124b-4c74-8445-09e712c1f403', 'INSERT', '{"uuid": "3d37a820-124b-4c74-8445-09e712c1f403", "assumed": true, "ascendantuuid": "dc8ae2b6-d20e-4592-8356-3547bcc58f80", "descendantuuid": "cd8e900a-3f5f-4b54-abdd-72b79c3f3203", "grantedbyroleuuid": null, "grantedbytriggerof": "bdfc3748-abd1-4bce-a239-f5b4df6715c4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'f47459e8-dfd5-41e2-8b4b-c7999197f56e', 'INSERT', '{"op": "SELECT", "uuid": "f47459e8-dfd5-41e2-8b4b-c7999197f56e", "objectuuid": "bdfc3748-abd1-4bce-a239-f5b4df6715c4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '8d29d43c-bbf5-425a-b6e5-1a145ace1c01', 'INSERT', '{"uuid": "8d29d43c-bbf5-425a-b6e5-1a145ace1c01", "assumed": true, "ascendantuuid": "7d632200-5506-4856-a3c0-d806b1ee708b", "descendantuuid": "f47459e8-dfd5-41e2-8b4b-c7999197f56e", "grantedbyroleuuid": null, "grantedbytriggerof": "bdfc3748-abd1-4bce-a239-f5b4df6715c4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'cddce99f-aca2-44e6-aa84-b1fc98c35c8a', 'INSERT', '{"op": "UPDATE", "uuid": "cddce99f-aca2-44e6-aa84-b1fc98c35c8a", "objectuuid": "bdfc3748-abd1-4bce-a239-f5b4df6715c4", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'd70a1cb5-cf04-4190-9eea-dbd80c16c4d2', 'INSERT', '{"uuid": "d70a1cb5-cf04-4190-9eea-dbd80c16c4d2", "assumed": true, "ascendantuuid": "3010c421-5c96-4f0d-b214-c773e0915564", "descendantuuid": "cddce99f-aca2-44e6-aa84-b1fc98c35c8a", "grantedbyroleuuid": null, "grantedbytriggerof": "bdfc3748-abd1-4bce-a239-f5b4df6715c4"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'hs_office.debitor', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', 'INSERT', '{"uuid": "bdfc3748-abd1-4bce-a239-f5b4df6715c4", "vatid": "", "version": 0, "billable": false, "vatbusiness": true, "defaultprefix": "xxx", "debitorreluuid": "bc8c4b35-c55b-4c3e-9122-94485909b17e", "vatcountrycode": null, "vatreversecharge": true, "debitornumbersuffix": "00", "refundbankaccountuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.object', '67c2d793-212f-4ce0-a750-b18224a93c73', 'INSERT', '{"uuid": "67c2d793-212f-4ce0-a750-b18224a93c73", "serialid": 252, "objecttable": "hs_office.debitor"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'd163cdba-ab70-4256-ad3f-d971748540e6', 'INSERT', '{"uuid": "d163cdba-ab70-4256-ad3f-d971748540e6", "assumed": true, "ascendantuuid": "76968391-174d-4530-b310-1244c4b1897a", "descendantuuid": "8255ff29-5961-496b-9fda-c71078e47e51", "grantedbyroleuuid": null, "grantedbytriggerof": "67c2d793-212f-4ce0-a750-b18224a93c73"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '98ee8921-16e1-434b-8887-aff3718c8f18', 'INSERT', '{"uuid": "98ee8921-16e1-434b-8887-aff3718c8f18", "assumed": true, "ascendantuuid": "863eea7c-8b49-494a-9654-9963f2dbb4e5", "descendantuuid": "fe0228ea-649c-45a4-b729-181aba7f3294", "grantedbyroleuuid": null, "grantedbytriggerof": "67c2d793-212f-4ce0-a750-b18224a93c73"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '58918d45-f28a-478a-a871-2afee40c3c79', 'INSERT', '{"uuid": "58918d45-f28a-478a-a871-2afee40c3c79", "assumed": true, "ascendantuuid": "fe0228ea-649c-45a4-b729-181aba7f3294", "descendantuuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "grantedbyroleuuid": null, "grantedbytriggerof": "67c2d793-212f-4ce0-a750-b18224a93c73"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '4386a60e-d5b7-4f36-bd53-1de1e52ea755', 'INSERT', '{"op": "DELETE", "uuid": "4386a60e-d5b7-4f36-bd53-1de1e52ea755", "objectuuid": "67c2d793-212f-4ce0-a750-b18224a93c73", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '874563ee-3587-4569-b418-9f080682f631', 'INSERT', '{"uuid": "874563ee-3587-4569-b418-9f080682f631", "assumed": true, "ascendantuuid": "eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe", "descendantuuid": "4386a60e-d5b7-4f36-bd53-1de1e52ea755", "grantedbyroleuuid": null, "grantedbytriggerof": "67c2d793-212f-4ce0-a750-b18224a93c73"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'e19225c5-a87b-464e-8c63-3f52a45b107f', 'INSERT', '{"op": "SELECT", "uuid": "e19225c5-a87b-464e-8c63-3f52a45b107f", "objectuuid": "67c2d793-212f-4ce0-a750-b18224a93c73", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'a52465da-bde2-4c5f-96f8-ccfc3d97f1e1', 'INSERT', '{"uuid": "a52465da-bde2-4c5f-96f8-ccfc3d97f1e1", "assumed": true, "ascendantuuid": "f218c4d9-d10b-4445-b381-b73a71f5848c", "descendantuuid": "e19225c5-a87b-464e-8c63-3f52a45b107f", "grantedbyroleuuid": null, "grantedbytriggerof": "67c2d793-212f-4ce0-a750-b18224a93c73"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'ab491da9-8661-485f-90f4-a85c7f3310f6', 'INSERT', '{"op": "UPDATE", "uuid": "ab491da9-8661-485f-90f4-a85c7f3310f6", "objectuuid": "67c2d793-212f-4ce0-a750-b18224a93c73", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'b4e45383-d41c-44e1-a227-94b7e34b1cfe', 'INSERT', '{"uuid": "b4e45383-d41c-44e1-a227-94b7e34b1cfe", "assumed": true, "ascendantuuid": "8255ff29-5961-496b-9fda-c71078e47e51", "descendantuuid": "ab491da9-8661-485f-90f4-a85c7f3310f6", "grantedbyroleuuid": null, "grantedbytriggerof": "67c2d793-212f-4ce0-a750-b18224a93c73"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'hs_office.debitor', '67c2d793-212f-4ce0-a750-b18224a93c73', 'INSERT', '{"uuid": "67c2d793-212f-4ce0-a750-b18224a93c73", "vatid": "DE 236 109 136", "version": 0, "billable": false, "vatbusiness": true, "defaultprefix": "rar", "debitorreluuid": "ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc", "vatcountrycode": null, "vatreversecharge": false, "debitornumbersuffix": "00", "refundbankaccountuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.object', '3692b171-10ef-4f20-97de-ed5fa562ca46', 'INSERT', '{"uuid": "3692b171-10ef-4f20-97de-ed5fa562ca46", "serialid": 253, "objecttable": "hs_office.debitor"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'db8ecbf3-1287-46b1-a205-d91a8305d8fc', 'INSERT', '{"uuid": "db8ecbf3-1287-46b1-a205-d91a8305d8fc", "assumed": true, "ascendantuuid": "f101cc07-ed84-4e34-9f70-62ec6a646e81", "descendantuuid": "6ec65964-76d1-4e7d-aacc-6a18e4eadf67", "grantedbyroleuuid": null, "grantedbytriggerof": "3692b171-10ef-4f20-97de-ed5fa562ca46"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'dab47748-a3c4-4eac-8c99-9213bb8d3541', 'INSERT', '{"uuid": "dab47748-a3c4-4eac-8c99-9213bb8d3541", "assumed": true, "ascendantuuid": "1d4c6f1f-200f-4a68-ae7b-6fda13687e41", "descendantuuid": "7e71f107-6953-42c7-a560-dc9036094198", "grantedbyroleuuid": null, "grantedbytriggerof": "3692b171-10ef-4f20-97de-ed5fa562ca46"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '58820fb8-453c-4209-aaf0-9e7b125b0ce0', 'INSERT', '{"uuid": "58820fb8-453c-4209-aaf0-9e7b125b0ce0", "assumed": true, "ascendantuuid": "7e71f107-6953-42c7-a560-dc9036094198", "descendantuuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "grantedbyroleuuid": null, "grantedbytriggerof": "3692b171-10ef-4f20-97de-ed5fa562ca46"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'b0214c88-ae13-4faf-9870-01872398bbab', 'INSERT', '{"op": "DELETE", "uuid": "b0214c88-ae13-4faf-9870-01872398bbab", "objectuuid": "3692b171-10ef-4f20-97de-ed5fa562ca46", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'e1cd2ca9-d31d-40f3-9ce3-94b08d9b4c38', 'INSERT', '{"uuid": "e1cd2ca9-d31d-40f3-9ce3-94b08d9b4c38", "assumed": true, "ascendantuuid": "3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c", "descendantuuid": "b0214c88-ae13-4faf-9870-01872398bbab", "grantedbyroleuuid": null, "grantedbytriggerof": "3692b171-10ef-4f20-97de-ed5fa562ca46"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '9398d762-ff69-44a0-a07f-2149bf07bb4f', 'INSERT', '{"op": "SELECT", "uuid": "9398d762-ff69-44a0-a07f-2149bf07bb4f", "objectuuid": "3692b171-10ef-4f20-97de-ed5fa562ca46", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '75781d3a-e6f0-4e6e-bcb1-91ac1f28de4b', 'INSERT', '{"uuid": "75781d3a-e6f0-4e6e-bcb1-91ac1f28de4b", "assumed": true, "ascendantuuid": "51bb98dd-9201-40e4-b008-221337eeb471", "descendantuuid": "9398d762-ff69-44a0-a07f-2149bf07bb4f", "grantedbyroleuuid": null, "grantedbytriggerof": "3692b171-10ef-4f20-97de-ed5fa562ca46"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'eebe4432-38e2-44dc-85c6-995cbecd173b', 'INSERT', '{"op": "UPDATE", "uuid": "eebe4432-38e2-44dc-85c6-995cbecd173b", "objectuuid": "3692b171-10ef-4f20-97de-ed5fa562ca46", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'd5b448f7-a22c-4470-8289-f451c32187a0', 'INSERT', '{"uuid": "d5b448f7-a22c-4470-8289-f451c32187a0", "assumed": true, "ascendantuuid": "6ec65964-76d1-4e7d-aacc-6a18e4eadf67", "descendantuuid": "eebe4432-38e2-44dc-85c6-995cbecd173b", "grantedbyroleuuid": null, "grantedbytriggerof": "3692b171-10ef-4f20-97de-ed5fa562ca46"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'hs_office.debitor', '3692b171-10ef-4f20-97de-ed5fa562ca46', 'INSERT', '{"uuid": "3692b171-10ef-4f20-97de-ed5fa562ca46", "vatid": "", "version": 0, "billable": false, "vatbusiness": true, "defaultprefix": "yyy", "debitorreluuid": "268c2ce6-8945-4393-9916-ac90050f064a", "vatcountrycode": null, "vatreversecharge": true, "debitornumbersuffix": "00", "refundbankaccountuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.object', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', 'INSERT', '{"uuid": "ce424fb0-bcc4-43ef-bc62-e923fb337fde", "serialid": 254, "objecttable": "hs_office.debitor"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '5178fb97-8a32-41b3-831e-db6dd08a5bc2', 'INSERT', '{"uuid": "5178fb97-8a32-41b3-831e-db6dd08a5bc2", "assumed": true, "ascendantuuid": "b8350678-d30a-422a-bb5d-79c65af2f890", "descendantuuid": "bb8fc553-9dbe-4ea5-a3ea-02d129841f68", "grantedbyroleuuid": null, "grantedbytriggerof": "ce424fb0-bcc4-43ef-bc62-e923fb337fde"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'a77cc0db-2956-44a5-8824-78e2354c8428', 'INSERT', '{"uuid": "a77cc0db-2956-44a5-8824-78e2354c8428", "assumed": true, "ascendantuuid": "0f833f5a-8afb-4934-a8a6-9dadbdcf89dd", "descendantuuid": "bbfb4fc6-80f7-4a82-aa82-3d787539ebeb", "grantedbyroleuuid": null, "grantedbytriggerof": "ce424fb0-bcc4-43ef-bc62-e923fb337fde"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '2d448cac-f8dc-423c-9a1e-a1c1c9c1f1d2', 'INSERT', '{"uuid": "2d448cac-f8dc-423c-9a1e-a1c1c9c1f1d2", "assumed": true, "ascendantuuid": "bbfb4fc6-80f7-4a82-aa82-3d787539ebeb", "descendantuuid": "c85e8116-355e-408a-93fa-c699da2a76f3", "grantedbyroleuuid": null, "grantedbytriggerof": "ce424fb0-bcc4-43ef-bc62-e923fb337fde"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'f1838834-17f4-45ae-823d-cfd97b9ad7d0', 'INSERT', '{"op": "DELETE", "uuid": "f1838834-17f4-45ae-823d-cfd97b9ad7d0", "objectuuid": "ce424fb0-bcc4-43ef-bc62-e923fb337fde", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '069de646-00f2-401b-8d34-976428e4f868', 'INSERT', '{"uuid": "069de646-00f2-401b-8d34-976428e4f868", "assumed": true, "ascendantuuid": "3de42185-1e32-4936-b305-d990b85c45c2", "descendantuuid": "f1838834-17f4-45ae-823d-cfd97b9ad7d0", "grantedbyroleuuid": null, "grantedbytriggerof": "ce424fb0-bcc4-43ef-bc62-e923fb337fde"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '94815866-8e0d-4177-9026-3fdad0866fc2', 'INSERT', '{"op": "SELECT", "uuid": "94815866-8e0d-4177-9026-3fdad0866fc2", "objectuuid": "ce424fb0-bcc4-43ef-bc62-e923fb337fde", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '634ae328-cc40-4bb1-9c5f-0aed06ed0a2c', 'INSERT', '{"uuid": "634ae328-cc40-4bb1-9c5f-0aed06ed0a2c", "assumed": true, "ascendantuuid": "07aa8ca8-e06f-4335-9cb0-99e98d45b2c6", "descendantuuid": "94815866-8e0d-4177-9026-3fdad0866fc2", "grantedbyroleuuid": null, "grantedbytriggerof": "ce424fb0-bcc4-43ef-bc62-e923fb337fde"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'c9448020-2d88-456d-827c-0b24917a78c6', 'INSERT', '{"op": "UPDATE", "uuid": "c9448020-2d88-456d-827c-0b24917a78c6", "objectuuid": "ce424fb0-bcc4-43ef-bc62-e923fb337fde", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '631ea533-9bc0-4935-aad9-376cf672e370', 'INSERT', '{"uuid": "631ea533-9bc0-4935-aad9-376cf672e370", "assumed": true, "ascendantuuid": "bb8fc553-9dbe-4ea5-a3ea-02d129841f68", "descendantuuid": "c9448020-2d88-456d-827c-0b24917a78c6", "grantedbyroleuuid": null, "grantedbytriggerof": "ce424fb0-bcc4-43ef-bc62-e923fb337fde"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'hs_office.debitor', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', 'INSERT', '{"uuid": "ce424fb0-bcc4-43ef-bc62-e923fb337fde", "vatid": "", "version": 0, "billable": false, "vatbusiness": true, "defaultprefix": "hsh", "debitorreluuid": "78123dac-fed2-4e3e-817b-0c13a2129dfe", "vatcountrycode": null, "vatreversecharge": false, "debitornumbersuffix": "00", "refundbankaccountuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.object', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', 'INSERT', '{"uuid": "ccbd7baa-494d-4bfc-b5bb-4310e607df04", "serialid": 255, "objecttable": "hs_office.debitor"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '6dcce6d4-feb6-4a43-99af-2b85bea67e0d', 'INSERT', '{"uuid": "6dcce6d4-feb6-4a43-99af-2b85bea67e0d", "assumed": true, "ascendantuuid": "8dfb5e53-1554-4e5c-a045-85121ce4bd71", "descendantuuid": "834d7138-e338-4517-aacb-1c6319fa34d8", "grantedbyroleuuid": null, "grantedbytriggerof": "ccbd7baa-494d-4bfc-b5bb-4310e607df04"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '118241f6-e1f6-42ad-9ba7-e0450e4f74d7', 'INSERT', '{"uuid": "118241f6-e1f6-42ad-9ba7-e0450e4f74d7", "assumed": true, "ascendantuuid": "13a3ca39-6352-48e1-b1fb-82f3fc5558f2", "descendantuuid": "e6409531-6513-43a9-84a7-eff44b18285a", "grantedbyroleuuid": null, "grantedbytriggerof": "ccbd7baa-494d-4bfc-b5bb-4310e607df04"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'c787f3a6-d143-4fa1-99bf-6232351dc221', 'INSERT', '{"uuid": "c787f3a6-d143-4fa1-99bf-6232351dc221", "assumed": true, "ascendantuuid": "e6409531-6513-43a9-84a7-eff44b18285a", "descendantuuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "grantedbyroleuuid": null, "grantedbytriggerof": "ccbd7baa-494d-4bfc-b5bb-4310e607df04"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '8b8b38a3-679a-4331-962c-c540eada4c22', 'INSERT', '{"op": "DELETE", "uuid": "8b8b38a3-679a-4331-962c-c540eada4c22", "objectuuid": "ccbd7baa-494d-4bfc-b5bb-4310e607df04", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '192cdc24-cc97-4cef-a33d-ce6f0574e3fc', 'INSERT', '{"uuid": "192cdc24-cc97-4cef-a33d-ce6f0574e3fc", "assumed": true, "ascendantuuid": "e5871fb2-3928-4139-9468-10f0f12d5e5f", "descendantuuid": "8b8b38a3-679a-4331-962c-c540eada4c22", "grantedbyroleuuid": null, "grantedbytriggerof": "ccbd7baa-494d-4bfc-b5bb-4310e607df04"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'a59c2244-46ef-42ce-9a35-9efeb0a02068', 'INSERT', '{"op": "SELECT", "uuid": "a59c2244-46ef-42ce-9a35-9efeb0a02068", "objectuuid": "ccbd7baa-494d-4bfc-b5bb-4310e607df04", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '4e9d7489-d21e-4fed-aad7-035614acf3ed', 'INSERT', '{"uuid": "4e9d7489-d21e-4fed-aad7-035614acf3ed", "assumed": true, "ascendantuuid": "d00a14ad-fe79-40fc-8f72-722fb5cd30bd", "descendantuuid": "a59c2244-46ef-42ce-9a35-9efeb0a02068", "grantedbyroleuuid": null, "grantedbytriggerof": "ccbd7baa-494d-4bfc-b5bb-4310e607df04"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '4556335e-4c02-4879-a850-cc792db27b5b', 'INSERT', '{"op": "UPDATE", "uuid": "4556335e-4c02-4879-a850-cc792db27b5b", "objectuuid": "ccbd7baa-494d-4bfc-b5bb-4310e607df04", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'bda55f4c-43bb-443e-b853-b4716ae85897', 'INSERT', '{"uuid": "bda55f4c-43bb-443e-b853-b4716ae85897", "assumed": true, "ascendantuuid": "834d7138-e338-4517-aacb-1c6319fa34d8", "descendantuuid": "4556335e-4c02-4879-a850-cc792db27b5b", "grantedbyroleuuid": null, "grantedbytriggerof": "ccbd7baa-494d-4bfc-b5bb-4310e607df04"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'hs_office.debitor', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', 'INSERT', '{"uuid": "ccbd7baa-494d-4bfc-b5bb-4310e607df04", "vatid": "", "version": 0, "billable": false, "vatbusiness": true, "defaultprefix": "wws", "debitorreluuid": "b9854fdd-5192-4e2b-b82f-62639ff1a3cd", "vatcountrycode": null, "vatreversecharge": false, "debitornumbersuffix": "00", "refundbankaccountuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.object', 'ade3baa7-760f-488b-962d-7e365ad1402f', 'INSERT', '{"uuid": "ade3baa7-760f-488b-962d-7e365ad1402f", "serialid": 256, "objecttable": "hs_office.debitor"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '15e635e4-4269-4feb-829c-120b0df1861c', 'INSERT', '{"uuid": "15e635e4-4269-4feb-829c-120b0df1861c", "assumed": true, "ascendantuuid": "28bf24da-eb68-4a99-8ff9-6e4145f5e805", "descendantuuid": "bb40b3e2-f355-491e-a3cd-fb3ee258d4b8", "grantedbyroleuuid": null, "grantedbytriggerof": "ade3baa7-760f-488b-962d-7e365ad1402f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '133dcb7b-48f7-4b23-a5db-b092084e0726', 'INSERT', '{"uuid": "133dcb7b-48f7-4b23-a5db-b092084e0726", "assumed": true, "ascendantuuid": "f93693fa-7dc5-4513-8537-be9541d6e5dc", "descendantuuid": "6e7feeb7-4891-4ea3-96b6-00d883da37c5", "grantedbyroleuuid": null, "grantedbytriggerof": "ade3baa7-760f-488b-962d-7e365ad1402f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '1c7a832b-fafa-433d-bc00-8d082a9cf8de', 'INSERT', '{"uuid": "1c7a832b-fafa-433d-bc00-8d082a9cf8de", "assumed": true, "ascendantuuid": "6e7feeb7-4891-4ea3-96b6-00d883da37c5", "descendantuuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "grantedbyroleuuid": null, "grantedbytriggerof": "ade3baa7-760f-488b-962d-7e365ad1402f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '88eaec32-bd9e-4fd9-973d-1aaa932c8115', 'INSERT', '{"op": "DELETE", "uuid": "88eaec32-bd9e-4fd9-973d-1aaa932c8115", "objectuuid": "ade3baa7-760f-488b-962d-7e365ad1402f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '33350472-45ed-4180-bc0c-4bdd58ebe062', 'INSERT', '{"uuid": "33350472-45ed-4180-bc0c-4bdd58ebe062", "assumed": true, "ascendantuuid": "d5a60c82-347b-4ebb-b95f-afff297bf966", "descendantuuid": "88eaec32-bd9e-4fd9-973d-1aaa932c8115", "grantedbyroleuuid": null, "grantedbytriggerof": "ade3baa7-760f-488b-962d-7e365ad1402f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', '62c26e94-cc22-4558-9bee-8ec8e6d29b95', 'INSERT', '{"op": "SELECT", "uuid": "62c26e94-cc22-4558-9bee-8ec8e6d29b95", "objectuuid": "ade3baa7-760f-488b-962d-7e365ad1402f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', 'd240af3f-e83e-4cc5-8bcb-35fefcb4eb39', 'INSERT', '{"uuid": "d240af3f-e83e-4cc5-8bcb-35fefcb4eb39", "assumed": true, "ascendantuuid": "1ed7ff07-778c-4920-a550-563b27223228", "descendantuuid": "62c26e94-cc22-4558-9bee-8ec8e6d29b95", "grantedbyroleuuid": null, "grantedbytriggerof": "ade3baa7-760f-488b-962d-7e365ad1402f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.permission', 'a0c34da0-2ce5-4877-8172-1306a2599c87', 'INSERT', '{"op": "UPDATE", "uuid": "a0c34da0-2ce5-4877-8172-1306a2599c87", "objectuuid": "ade3baa7-760f-488b-962d-7e365ad1402f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'rbac.grant', '82cc5748-33be-4c93-807a-65645f980b3e', 'INSERT', '{"uuid": "82cc5748-33be-4c93-807a-65645f980b3e", "assumed": true, "ascendantuuid": "bb40b3e2-f355-491e-a3cd-fb3ee258d4b8", "descendantuuid": "a0c34da0-2ce5-4877-8172-1306a2599c87", "grantedbyroleuuid": null, "grantedbytriggerof": "ade3baa7-760f-488b-962d-7e365ad1402f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2082', 'hs_office.debitor', 'ade3baa7-760f-488b-962d-7e365ad1402f', 'INSERT', '{"uuid": "ade3baa7-760f-488b-962d-7e365ad1402f", "vatid": "", "version": 0, "billable": false, "vatbusiness": true, "defaultprefix": "dph", "debitorreluuid": "dd0eae3e-7f45-45dd-b686-f39e046918b0", "vatcountrycode": null, "vatreversecharge": false, "debitornumbersuffix": "00", "refundbankaccountuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.object', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'INSERT', '{"uuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "serialid": 257, "objecttable": "hs_office.membership"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c', 'INSERT', '{"uuid": "5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c", "roletype": "OWNER", "objectuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'fe68c4df-a2af-4751-acb5-8bcac36abf8b', 'INSERT', '{"uuid": "fe68c4df-a2af-4751-acb5-8bcac36abf8b", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c", "grantedbyroleuuid": "5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '0eabdcfb-e308-4e52-8c7f-27643332c947', 'INSERT', '{"uuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "roletype": "ADMIN", "objectuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '14e4dbf5-5fa3-4010-91e0-c56e71623ba9', 'INSERT', '{"op": "DELETE", "uuid": "14e4dbf5-5fa3-4010-91e0-c56e71623ba9", "objectuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'd52457c6-dd11-4e4f-b98c-fc4ef145f4b2', 'INSERT', '{"uuid": "d52457c6-dd11-4e4f-b98c-fc4ef145f4b2", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "14e4dbf5-5fa3-4010-91e0-c56e71623ba9", "grantedbyroleuuid": null, "grantedbytriggerof": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '359f9b02-63f0-47eb-955b-52a344462735', 'INSERT', '{"op": "UPDATE", "uuid": "359f9b02-63f0-47eb-955b-52a344462735", "objectuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'f35e02ca-b71a-418e-b942-920580b39932', 'INSERT', '{"uuid": "f35e02ca-b71a-418e-b942-920580b39932", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "359f9b02-63f0-47eb-955b-52a344462735", "grantedbyroleuuid": null, "grantedbytriggerof": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '9e05c2de-12c7-4065-9ae5-02773dffc646', 'INSERT', '{"uuid": "9e05c2de-12c7-4065-9ae5-02773dffc646", "assumed": true, "ascendantuuid": "5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c", "descendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "grantedbyroleuuid": null, "grantedbytriggerof": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'a8db9091-2b28-4f65-931d-4111ebfcb13f', 'INSERT', '{"uuid": "a8db9091-2b28-4f65-931d-4111ebfcb13f", "assumed": true, "ascendantuuid": "3b195996-371c-41e4-9b66-a50553582e17", "descendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "grantedbyroleuuid": null, "grantedbytriggerof": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '345b8b7b-a948-446f-949a-2a903b460032', 'INSERT', '{"uuid": "345b8b7b-a948-446f-949a-2a903b460032", "roletype": "AGENT", "objectuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '05d18d2f-a5be-4b65-9e78-8fa91db4c68f', 'INSERT', '{"op": "SELECT", "uuid": "05d18d2f-a5be-4b65-9e78-8fa91db4c68f", "objectuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '811dde92-bb69-4530-9989-c78422f69805', 'INSERT', '{"uuid": "811dde92-bb69-4530-9989-c78422f69805", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "05d18d2f-a5be-4b65-9e78-8fa91db4c68f", "grantedbyroleuuid": null, "grantedbytriggerof": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '7bd909a9-e3a5-4f7d-87b6-54263713d4e7', 'INSERT', '{"uuid": "7bd909a9-e3a5-4f7d-87b6-54263713d4e7", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "grantedbyroleuuid": null, "grantedbytriggerof": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'fed61c45-c1e4-4f84-9194-de069d3b53da', 'INSERT', '{"uuid": "fed61c45-c1e4-4f84-9194-de069d3b53da", "assumed": true, "ascendantuuid": "7de2ab25-6b6a-4b59-ba8d-818110ae4ccb", "descendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "grantedbyroleuuid": null, "grantedbytriggerof": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'c3293bca-6879-4d1c-bf2d-d48595971608', 'INSERT', '{"uuid": "c3293bca-6879-4d1c-bf2d-d48595971608", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8", "grantedbyroleuuid": null, "grantedbytriggerof": "f97e9751-6e67-40fb-b840-b818dc69afcf"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'f049b588-1279-40e7-be2d-2e691e8a4090', 'INSERT', '{"op": "INSERT", "uuid": "f049b588-1279-40e7-be2d-2e691e8a4090", "objectuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "optablename": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '949cf562-60aa-4323-b75e-580d318e6bca', 'INSERT', '{"uuid": "949cf562-60aa-4323-b75e-580d318e6bca", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "f049b588-1279-40e7-be2d-2e691e8a4090", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'a41ad44b-e566-492a-b2b7-9a1ed2bdd18b', 'INSERT', '{"op": "INSERT", "uuid": "a41ad44b-e566-492a-b2b7-9a1ed2bdd18b", "objectuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "optablename": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'ed631e28-2c9a-4a4f-9540-c3b1af10d5dc', 'INSERT', '{"uuid": "ed631e28-2c9a-4a4f-9540-c3b1af10d5dc", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "a41ad44b-e566-492a-b2b7-9a1ed2bdd18b", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'hs_office.membership', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'INSERT', '{"uuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "status": "ACTIVE", "version": 0, "validity": "[2000-12-06,)", "partneruuid": "91b63591-b1e2-4c65-8ad2-c607be4c1238", "membernumbersuffix": "00", "membershipfeebillable": false}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.object', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'INSERT', '{"uuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "serialid": 258, "objecttable": "hs_office.membership"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '39bc569a-8594-4a3e-954f-3055b382af9a', 'INSERT', '{"uuid": "39bc569a-8594-4a3e-954f-3055b382af9a", "roletype": "OWNER", "objectuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'f1585e8b-446a-460e-833e-1d9433ae70ad', 'INSERT', '{"uuid": "f1585e8b-446a-460e-833e-1d9433ae70ad", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "39bc569a-8594-4a3e-954f-3055b382af9a", "grantedbyroleuuid": "39bc569a-8594-4a3e-954f-3055b382af9a", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '6df50d79-b958-456a-ac84-a8786f0f18a7', 'INSERT', '{"uuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "roletype": "ADMIN", "objectuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '5879bb5b-1171-41e2-bff7-707e18fc0582', 'INSERT', '{"op": "DELETE", "uuid": "5879bb5b-1171-41e2-bff7-707e18fc0582", "objectuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '01a32603-f9bb-454b-baf0-d7c39ed5e584', 'INSERT', '{"uuid": "01a32603-f9bb-454b-baf0-d7c39ed5e584", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "5879bb5b-1171-41e2-bff7-707e18fc0582", "grantedbyroleuuid": null, "grantedbytriggerof": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'a277424f-d7f0-4568-8cd9-5299a13d0f4e', 'INSERT', '{"op": "UPDATE", "uuid": "a277424f-d7f0-4568-8cd9-5299a13d0f4e", "objectuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'b0fa636e-9a00-40e1-8e5e-12c885f91cb7', 'INSERT', '{"uuid": "b0fa636e-9a00-40e1-8e5e-12c885f91cb7", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "a277424f-d7f0-4568-8cd9-5299a13d0f4e", "grantedbyroleuuid": null, "grantedbytriggerof": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '6676bb28-ea3c-496f-8a74-ba255c27f47b', 'INSERT', '{"uuid": "6676bb28-ea3c-496f-8a74-ba255c27f47b", "assumed": true, "ascendantuuid": "39bc569a-8594-4a3e-954f-3055b382af9a", "descendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "grantedbyroleuuid": null, "grantedbytriggerof": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'a4e394f5-8eee-4cd7-ae31-ac8848eed47d', 'INSERT', '{"uuid": "a4e394f5-8eee-4cd7-ae31-ac8848eed47d", "assumed": true, "ascendantuuid": "9771d06d-8352-404c-aaba-743800e621e9", "descendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "grantedbyroleuuid": null, "grantedbytriggerof": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', 'INSERT', '{"uuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "roletype": "AGENT", "objectuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '66c939e9-0515-4cb0-ab1a-8dcd9243c53f', 'INSERT', '{"op": "SELECT", "uuid": "66c939e9-0515-4cb0-ab1a-8dcd9243c53f", "objectuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'c36a1b03-32bc-4c21-8b98-dfb6ea6d2de4', 'INSERT', '{"uuid": "c36a1b03-32bc-4c21-8b98-dfb6ea6d2de4", "assumed": true, "ascendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "descendantuuid": "66c939e9-0515-4cb0-ab1a-8dcd9243c53f", "grantedbyroleuuid": null, "grantedbytriggerof": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '0b37d7ad-4248-4de2-9d59-67364db91066', 'INSERT', '{"uuid": "0b37d7ad-4248-4de2-9d59-67364db91066", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "grantedbyroleuuid": null, "grantedbytriggerof": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '96b83c48-cd0d-416c-8e7d-0c4cc652afe5', 'INSERT', '{"uuid": "96b83c48-cd0d-416c-8e7d-0c4cc652afe5", "assumed": true, "ascendantuuid": "b34392da-5070-40dd-ab44-d411a9742f6d", "descendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "grantedbyroleuuid": null, "grantedbytriggerof": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'ce2c8b8a-09c3-40c5-ba23-0f632d49dfec', 'INSERT', '{"uuid": "ce2c8b8a-09c3-40c5-ba23-0f632d49dfec", "assumed": true, "ascendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "descendantuuid": "e37e21bc-4d4f-4d41-8c24-399be1680a15", "grantedbyroleuuid": null, "grantedbytriggerof": "db1fa6bf-85ff-4302-b7c3-9a66f9761830"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'ad1241d8-512f-4589-aed2-958e1fd6441b', 'INSERT', '{"op": "INSERT", "uuid": "ad1241d8-512f-4589-aed2-958e1fd6441b", "objectuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "optablename": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'b53df30d-a8a0-4485-bbd6-c827ac428ee6', 'INSERT', '{"uuid": "b53df30d-a8a0-4485-bbd6-c827ac428ee6", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "ad1241d8-512f-4589-aed2-958e1fd6441b", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '39a2eb59-2ba9-486d-8146-0a9a4d85769b', 'INSERT', '{"op": "INSERT", "uuid": "39a2eb59-2ba9-486d-8146-0a9a4d85769b", "objectuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "optablename": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'ccf1a982-03c0-4069-a93f-48efe0edc4fd', 'INSERT', '{"uuid": "ccf1a982-03c0-4069-a93f-48efe0edc4fd", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "39a2eb59-2ba9-486d-8146-0a9a4d85769b", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'hs_office.membership', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'INSERT', '{"uuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "status": "UNKNOWN", "version": 0, "validity": "[2000-12-06,2016-01-01)", "partneruuid": "db7f287e-dfd7-4627-88e3-407cac226472", "membernumbersuffix": "00", "membershipfeebillable": true}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.object', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'INSERT', '{"uuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af", "serialid": 259, "objecttable": "hs_office.membership"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '539a38db-5f7d-4bbc-896d-616bd32f0f06', 'INSERT', '{"uuid": "539a38db-5f7d-4bbc-896d-616bd32f0f06", "roletype": "OWNER", "objectuuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '5db7b9ab-85de-4337-9d4f-d8dfad2276c1', 'INSERT', '{"uuid": "5db7b9ab-85de-4337-9d4f-d8dfad2276c1", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "539a38db-5f7d-4bbc-896d-616bd32f0f06", "grantedbyroleuuid": "539a38db-5f7d-4bbc-896d-616bd32f0f06", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '209720a4-ab91-4b78-9fc0-ad5780a97934', 'INSERT', '{"uuid": "209720a4-ab91-4b78-9fc0-ad5780a97934", "roletype": "ADMIN", "objectuuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '725794f0-c526-4854-b498-401caec8b1b5', 'INSERT', '{"uuid": "725794f0-c526-4854-b498-401caec8b1b5", "assumed": true, "ascendantuuid": "209720a4-ab91-4b78-9fc0-ad5780a97934", "descendantuuid": "17e8a223-4aa0-4e35-aca3-f381f9ce1328", "grantedbyroleuuid": null, "grantedbytriggerof": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'a24d0918-c78b-44a2-8c90-965940f30b95', 'INSERT', '{"op": "UPDATE", "uuid": "a24d0918-c78b-44a2-8c90-965940f30b95", "objectuuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '702ad75d-7582-41db-ad5d-7df4a8ac6e4b', 'INSERT', '{"uuid": "702ad75d-7582-41db-ad5d-7df4a8ac6e4b", "assumed": true, "ascendantuuid": "209720a4-ab91-4b78-9fc0-ad5780a97934", "descendantuuid": "a24d0918-c78b-44a2-8c90-965940f30b95", "grantedbyroleuuid": null, "grantedbytriggerof": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '99a93554-7343-44de-987b-a35b06c8a8a6', 'INSERT', '{"uuid": "99a93554-7343-44de-987b-a35b06c8a8a6", "assumed": true, "ascendantuuid": "539a38db-5f7d-4bbc-896d-616bd32f0f06", "descendantuuid": "209720a4-ab91-4b78-9fc0-ad5780a97934", "grantedbyroleuuid": null, "grantedbytriggerof": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '99de5054-1c52-481d-9536-d39795f0ce19', 'INSERT', '{"uuid": "99de5054-1c52-481d-9536-d39795f0ce19", "assumed": true, "ascendantuuid": "cb295fdb-e294-4b05-944e-f0a4929ebeeb", "descendantuuid": "209720a4-ab91-4b78-9fc0-ad5780a97934", "grantedbyroleuuid": null, "grantedbytriggerof": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '34a3d0d7-b889-4d5a-80f9-a74d0b56f74a', 'INSERT', '{"uuid": "34a3d0d7-b889-4d5a-80f9-a74d0b56f74a", "roletype": "AGENT", "objectuuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '10971aec-daed-47b5-8514-f88f9ca1016c', 'INSERT', '{"op": "SELECT", "uuid": "10971aec-daed-47b5-8514-f88f9ca1016c", "objectuuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'f7000b2a-f204-46a1-9689-d355cf929bb9', 'INSERT', '{"uuid": "f7000b2a-f204-46a1-9689-d355cf929bb9", "assumed": true, "ascendantuuid": "34a3d0d7-b889-4d5a-80f9-a74d0b56f74a", "descendantuuid": "10971aec-daed-47b5-8514-f88f9ca1016c", "grantedbyroleuuid": null, "grantedbytriggerof": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'af8fadc7-e1f9-4d47-9581-5d8805d4f6d8', 'INSERT', '{"uuid": "af8fadc7-e1f9-4d47-9581-5d8805d4f6d8", "assumed": true, "ascendantuuid": "209720a4-ab91-4b78-9fc0-ad5780a97934", "descendantuuid": "34a3d0d7-b889-4d5a-80f9-a74d0b56f74a", "grantedbyroleuuid": null, "grantedbytriggerof": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '7a45f88b-2b3e-471f-9ded-45b3cf3520f9', 'INSERT', '{"uuid": "7a45f88b-2b3e-471f-9ded-45b3cf3520f9", "assumed": true, "ascendantuuid": "f3af3c81-a512-47ea-8b47-0386291e6590", "descendantuuid": "34a3d0d7-b889-4d5a-80f9-a74d0b56f74a", "grantedbyroleuuid": null, "grantedbytriggerof": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '68707555-e302-4a1d-9bf1-f7f06686a8fd', 'INSERT', '{"uuid": "68707555-e302-4a1d-9bf1-f7f06686a8fd", "assumed": true, "ascendantuuid": "34a3d0d7-b889-4d5a-80f9-a74d0b56f74a", "descendantuuid": "a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29", "grantedbyroleuuid": null, "grantedbytriggerof": "cf4c2c71-c6a0-4887-83a3-67509371b8af"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'e0c2115c-f70e-4c77-87a7-d1f524f47df4', 'INSERT', '{"op": "INSERT", "uuid": "e0c2115c-f70e-4c77-87a7-d1f524f47df4", "objectuuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af", "optablename": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'd6832b5b-41f8-40cb-99ca-7456ea3c9c20', 'INSERT', '{"uuid": "d6832b5b-41f8-40cb-99ca-7456ea3c9c20", "assumed": true, "ascendantuuid": "209720a4-ab91-4b78-9fc0-ad5780a97934", "descendantuuid": "e0c2115c-f70e-4c77-87a7-d1f524f47df4", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '6cfb3c88-43bd-41a3-9c01-29bbcb67752e', 'INSERT', '{"op": "INSERT", "uuid": "6cfb3c88-43bd-41a3-9c01-29bbcb67752e", "objectuuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af", "optablename": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '022c8d18-6746-49bf-b153-1a10c788debd', 'INSERT', '{"uuid": "022c8d18-6746-49bf-b153-1a10c788debd", "assumed": true, "ascendantuuid": "209720a4-ab91-4b78-9fc0-ad5780a97934", "descendantuuid": "6cfb3c88-43bd-41a3-9c01-29bbcb67752e", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'hs_office.membership', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'INSERT', '{"uuid": "cf4c2c71-c6a0-4887-83a3-67509371b8af", "status": "ACTIVE", "version": 0, "validity": "[2021-04-01,)", "partneruuid": "a083dfa1-afb0-4531-8a1b-8f4ba78a6215", "membernumbersuffix": "00", "membershipfeebillable": true}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.object', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'INSERT', '{"uuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "serialid": 260, "objecttable": "hs_office.membership"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '2bb03c85-0eba-4ef2-be45-7bd03fb60936', 'INSERT', '{"uuid": "2bb03c85-0eba-4ef2-be45-7bd03fb60936", "roletype": "OWNER", "objectuuid": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'a74df0e5-a5a6-4e0e-8969-7058dc5ed655', 'INSERT', '{"uuid": "a74df0e5-a5a6-4e0e-8969-7058dc5ed655", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "2bb03c85-0eba-4ef2-be45-7bd03fb60936", "grantedbyroleuuid": "2bb03c85-0eba-4ef2-be45-7bd03fb60936", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', 'INSERT', '{"uuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "roletype": "ADMIN", "objectuuid": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '7e91e09c-a072-44b1-af1f-bc1e6430d371', 'INSERT', '{"op": "DELETE", "uuid": "7e91e09c-a072-44b1-af1f-bc1e6430d371", "objectuuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'c9949370-fd5c-47b3-9697-82cdd744085d', 'INSERT', '{"uuid": "c9949370-fd5c-47b3-9697-82cdd744085d", "assumed": true, "ascendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "descendantuuid": "7e91e09c-a072-44b1-af1f-bc1e6430d371", "grantedbyroleuuid": null, "grantedbytriggerof": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '4dc88a9e-38e7-426b-a598-f246cef849ed', 'INSERT', '{"op": "UPDATE", "uuid": "4dc88a9e-38e7-426b-a598-f246cef849ed", "objectuuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'fd96b18b-eea4-4e2e-9035-0f23fd1e5a46', 'INSERT', '{"uuid": "fd96b18b-eea4-4e2e-9035-0f23fd1e5a46", "assumed": true, "ascendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "descendantuuid": "4dc88a9e-38e7-426b-a598-f246cef849ed", "grantedbyroleuuid": null, "grantedbytriggerof": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'ad75c325-6003-4329-bb7f-8ab63e0aacf0', 'INSERT', '{"uuid": "ad75c325-6003-4329-bb7f-8ab63e0aacf0", "assumed": true, "ascendantuuid": "2bb03c85-0eba-4ef2-be45-7bd03fb60936", "descendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "grantedbyroleuuid": null, "grantedbytriggerof": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '21a9c4a3-8b53-49ab-a851-3d99572abcbd', 'INSERT', '{"uuid": "21a9c4a3-8b53-49ab-a851-3d99572abcbd", "assumed": true, "ascendantuuid": "76968391-174d-4530-b310-1244c4b1897a", "descendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "grantedbyroleuuid": null, "grantedbytriggerof": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '5fd54e69-2513-4413-95d6-dde58ed6d8ae', 'INSERT', '{"uuid": "5fd54e69-2513-4413-95d6-dde58ed6d8ae", "roletype": "AGENT", "objectuuid": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '7db8de4f-b7d3-4a3f-b2d7-4abf43a4235f', 'INSERT', '{"op": "SELECT", "uuid": "7db8de4f-b7d3-4a3f-b2d7-4abf43a4235f", "objectuuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '3a01050f-832f-45d3-8fb4-05fae7151156', 'INSERT', '{"uuid": "3a01050f-832f-45d3-8fb4-05fae7151156", "assumed": true, "ascendantuuid": "5fd54e69-2513-4413-95d6-dde58ed6d8ae", "descendantuuid": "7db8de4f-b7d3-4a3f-b2d7-4abf43a4235f", "grantedbyroleuuid": null, "grantedbytriggerof": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'ef29ef0c-c3c2-47e6-b046-e86081456208', 'INSERT', '{"uuid": "ef29ef0c-c3c2-47e6-b046-e86081456208", "assumed": true, "ascendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "descendantuuid": "5fd54e69-2513-4413-95d6-dde58ed6d8ae", "grantedbyroleuuid": null, "grantedbytriggerof": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '72d3e92d-21c2-4de7-86b8-42fd12445585', 'INSERT', '{"uuid": "72d3e92d-21c2-4de7-86b8-42fd12445585", "assumed": true, "ascendantuuid": "863eea7c-8b49-494a-9654-9963f2dbb4e5", "descendantuuid": "5fd54e69-2513-4413-95d6-dde58ed6d8ae", "grantedbyroleuuid": null, "grantedbytriggerof": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '46587926-e3fb-49a4-a5e8-2c980833071f', 'INSERT', '{"uuid": "46587926-e3fb-49a4-a5e8-2c980833071f", "assumed": true, "ascendantuuid": "5fd54e69-2513-4413-95d6-dde58ed6d8ae", "descendantuuid": "b67105de-0348-4d4c-8ccc-aab9ed905eb6", "grantedbyroleuuid": null, "grantedbytriggerof": "af682fb0-f06d-4a2b-affb-40487a079a70"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '3333c620-ed65-4a4a-af0b-71106e0b5b30', 'INSERT', '{"op": "INSERT", "uuid": "3333c620-ed65-4a4a-af0b-71106e0b5b30", "objectuuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "optablename": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'dcb7676b-137a-4769-9823-979963f60316', 'INSERT', '{"uuid": "dcb7676b-137a-4769-9823-979963f60316", "assumed": true, "ascendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "descendantuuid": "3333c620-ed65-4a4a-af0b-71106e0b5b30", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'f8591833-ef9e-42fd-b91b-f66b56267b0a', 'INSERT', '{"op": "INSERT", "uuid": "f8591833-ef9e-42fd-b91b-f66b56267b0a", "objectuuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "optablename": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '4ac63eeb-7776-4255-829b-cb5a29f9de16', 'INSERT', '{"uuid": "4ac63eeb-7776-4255-829b-cb5a29f9de16", "assumed": true, "ascendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "descendantuuid": "f8591833-ef9e-42fd-b91b-f66b56267b0a", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'hs_office.membership', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'INSERT', '{"uuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "status": "ACTIVE", "version": 0, "validity": "[2003-07-12,)", "partneruuid": "029b1c78-d68b-48e6-83e5-8883b9cefe7c", "membernumbersuffix": "00", "membershipfeebillable": true}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.object', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'INSERT', '{"uuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f", "serialid": 261, "objecttable": "hs_office.membership"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '0ee9e55c-9b0f-41fc-9bd5-981f124846d3', 'INSERT', '{"uuid": "0ee9e55c-9b0f-41fc-9bd5-981f124846d3", "roletype": "OWNER", "objectuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '5e9523d8-2ad4-4d64-b686-57576aa20f77', 'INSERT', '{"uuid": "5e9523d8-2ad4-4d64-b686-57576aa20f77", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0ee9e55c-9b0f-41fc-9bd5-981f124846d3", "grantedbyroleuuid": "0ee9e55c-9b0f-41fc-9bd5-981f124846d3", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', 'bf27b482-99fb-43fe-8789-b926b9131a32', 'INSERT', '{"uuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "roletype": "ADMIN", "objectuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '51da6c66-df21-4619-bb68-2538c6ef2c31', 'INSERT', '{"op": "DELETE", "uuid": "51da6c66-df21-4619-bb68-2538c6ef2c31", "objectuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '1766a9c6-2146-4c3e-a857-ea04e8f44164', 'INSERT', '{"uuid": "1766a9c6-2146-4c3e-a857-ea04e8f44164", "assumed": true, "ascendantuuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "descendantuuid": "51da6c66-df21-4619-bb68-2538c6ef2c31", "grantedbyroleuuid": null, "grantedbytriggerof": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'a16e2346-b56a-4ea3-b07b-f5f494b2b42b', 'INSERT', '{"op": "UPDATE", "uuid": "a16e2346-b56a-4ea3-b07b-f5f494b2b42b", "objectuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '956a5f3f-c580-4e65-aae5-43fd79a449b1', 'INSERT', '{"uuid": "956a5f3f-c580-4e65-aae5-43fd79a449b1", "assumed": true, "ascendantuuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "descendantuuid": "a16e2346-b56a-4ea3-b07b-f5f494b2b42b", "grantedbyroleuuid": null, "grantedbytriggerof": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'b2a2e5b9-cbc3-4a1c-b1e1-a562ab5d95d8', 'INSERT', '{"uuid": "b2a2e5b9-cbc3-4a1c-b1e1-a562ab5d95d8", "assumed": true, "ascendantuuid": "0ee9e55c-9b0f-41fc-9bd5-981f124846d3", "descendantuuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "grantedbyroleuuid": null, "grantedbytriggerof": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '3fd89676-3561-4958-a6c4-35ef51e64316', 'INSERT', '{"uuid": "3fd89676-3561-4958-a6c4-35ef51e64316", "assumed": true, "ascendantuuid": "f101cc07-ed84-4e34-9f70-62ec6a646e81", "descendantuuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "grantedbyroleuuid": null, "grantedbytriggerof": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '1d24331c-d029-4539-8b40-2b891f6a75a9', 'INSERT', '{"uuid": "1d24331c-d029-4539-8b40-2b891f6a75a9", "roletype": "AGENT", "objectuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '7514b6f6-f31f-4397-bb3d-eefe138ebb9d', 'INSERT', '{"op": "SELECT", "uuid": "7514b6f6-f31f-4397-bb3d-eefe138ebb9d", "objectuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '523208c9-177d-457e-873c-2ef5dcc79132', 'INSERT', '{"uuid": "523208c9-177d-457e-873c-2ef5dcc79132", "assumed": true, "ascendantuuid": "1d24331c-d029-4539-8b40-2b891f6a75a9", "descendantuuid": "7514b6f6-f31f-4397-bb3d-eefe138ebb9d", "grantedbyroleuuid": null, "grantedbytriggerof": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '09a84d00-9a3e-462f-84b3-e957d0c8fd39', 'INSERT', '{"uuid": "09a84d00-9a3e-462f-84b3-e957d0c8fd39", "assumed": true, "ascendantuuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "descendantuuid": "1d24331c-d029-4539-8b40-2b891f6a75a9", "grantedbyroleuuid": null, "grantedbytriggerof": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '509316eb-0cd6-4d50-a8ff-8e8ac1d98928', 'INSERT', '{"uuid": "509316eb-0cd6-4d50-a8ff-8e8ac1d98928", "assumed": true, "ascendantuuid": "1d4c6f1f-200f-4a68-ae7b-6fda13687e41", "descendantuuid": "1d24331c-d029-4539-8b40-2b891f6a75a9", "grantedbyroleuuid": null, "grantedbytriggerof": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'f0a81e14-722d-4f40-b3dd-5ebc7b5b3df3', 'INSERT', '{"uuid": "f0a81e14-722d-4f40-b3dd-5ebc7b5b3df3", "assumed": true, "ascendantuuid": "1d24331c-d029-4539-8b40-2b891f6a75a9", "descendantuuid": "53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc", "grantedbyroleuuid": null, "grantedbytriggerof": "9c468212-9e05-4b29-9d75-5a2c147b2b8f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '0b188bb5-5eaa-4c5b-9989-7ccccbc9f2c1', 'INSERT', '{"op": "INSERT", "uuid": "0b188bb5-5eaa-4c5b-9989-7ccccbc9f2c1", "objectuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f", "optablename": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '20538e3b-737b-40f6-aa1b-b0ede047f65e', 'INSERT', '{"uuid": "20538e3b-737b-40f6-aa1b-b0ede047f65e", "assumed": true, "ascendantuuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "descendantuuid": "0b188bb5-5eaa-4c5b-9989-7ccccbc9f2c1", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '9ee673c2-196b-4f00-b226-4b5978063f56', 'INSERT', '{"uuid": "9ee673c2-196b-4f00-b226-4b5978063f56", "assumed": true, "ascendantuuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "descendantuuid": "bf58a617-cb18-42a8-b34a-56b584e6daf1", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'hs_office.membership', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'INSERT', '{"uuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f", "status": "INVALID", "version": 0, "validity": "empty", "partneruuid": "58ca016b-15ea-41e3-80ba-2603bf736619", "membernumbersuffix": "00", "membershipfeebillable": false}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.object', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'INSERT', '{"uuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc", "serialid": 262, "objecttable": "hs_office.membership"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '0860ac5c-ce03-4f7b-abcb-562676bca90d', 'INSERT', '{"uuid": "0860ac5c-ce03-4f7b-abcb-562676bca90d", "roletype": "OWNER", "objectuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'ec90a9db-bff2-4777-8e96-b791e4c05729', 'INSERT', '{"uuid": "ec90a9db-bff2-4777-8e96-b791e4c05729", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0860ac5c-ce03-4f7b-abcb-562676bca90d", "grantedbyroleuuid": "0860ac5c-ce03-4f7b-abcb-562676bca90d", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '173a65d3-7eb4-4910-a83f-08ce5ed65583', 'INSERT', '{"uuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "roletype": "ADMIN", "objectuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'd3e00370-8788-4a7c-83d6-693a01ccac0f', 'INSERT', '{"op": "DELETE", "uuid": "d3e00370-8788-4a7c-83d6-693a01ccac0f", "objectuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '55a00373-09ec-4006-a3c0-3ec42352dca4', 'INSERT', '{"uuid": "55a00373-09ec-4006-a3c0-3ec42352dca4", "assumed": true, "ascendantuuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "descendantuuid": "d3e00370-8788-4a7c-83d6-693a01ccac0f", "grantedbyroleuuid": null, "grantedbytriggerof": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'fd972637-8015-4a7a-9591-683814d6dc1c', 'INSERT', '{"op": "UPDATE", "uuid": "fd972637-8015-4a7a-9591-683814d6dc1c", "objectuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '81e14d92-f7fe-4f0c-945e-5805f8e7e7a8', 'INSERT', '{"uuid": "81e14d92-f7fe-4f0c-945e-5805f8e7e7a8", "assumed": true, "ascendantuuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "descendantuuid": "fd972637-8015-4a7a-9591-683814d6dc1c", "grantedbyroleuuid": null, "grantedbytriggerof": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'c961c759-99a7-49e0-8bca-f2965cb44f2e', 'INSERT', '{"uuid": "c961c759-99a7-49e0-8bca-f2965cb44f2e", "assumed": true, "ascendantuuid": "0860ac5c-ce03-4f7b-abcb-562676bca90d", "descendantuuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "grantedbyroleuuid": null, "grantedbytriggerof": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '5ea574bc-77f5-4161-9382-50c091378fc6', 'INSERT', '{"uuid": "5ea574bc-77f5-4161-9382-50c091378fc6", "assumed": true, "ascendantuuid": "8dfb5e53-1554-4e5c-a045-85121ce4bd71", "descendantuuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "grantedbyroleuuid": null, "grantedbytriggerof": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '81aefd8d-c7aa-48a5-869f-1df15b4b68ae', 'INSERT', '{"uuid": "81aefd8d-c7aa-48a5-869f-1df15b4b68ae", "roletype": "AGENT", "objectuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'c1f4725e-747e-4d03-8a86-b2f4fa4459ee', 'INSERT', '{"op": "SELECT", "uuid": "c1f4725e-747e-4d03-8a86-b2f4fa4459ee", "objectuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'df45901b-777d-4579-ad7d-4412d63a3b3b', 'INSERT', '{"uuid": "df45901b-777d-4579-ad7d-4412d63a3b3b", "assumed": true, "ascendantuuid": "81aefd8d-c7aa-48a5-869f-1df15b4b68ae", "descendantuuid": "c1f4725e-747e-4d03-8a86-b2f4fa4459ee", "grantedbyroleuuid": null, "grantedbytriggerof": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'c6c52b4b-949a-4d5f-a1e6-60f132463f2e', 'INSERT', '{"uuid": "c6c52b4b-949a-4d5f-a1e6-60f132463f2e", "assumed": true, "ascendantuuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "descendantuuid": "81aefd8d-c7aa-48a5-869f-1df15b4b68ae", "grantedbyroleuuid": null, "grantedbytriggerof": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '9c6410ef-986a-4475-93bb-19ed17429a79', 'INSERT', '{"uuid": "9c6410ef-986a-4475-93bb-19ed17429a79", "assumed": true, "ascendantuuid": "13a3ca39-6352-48e1-b1fb-82f3fc5558f2", "descendantuuid": "81aefd8d-c7aa-48a5-869f-1df15b4b68ae", "grantedbyroleuuid": null, "grantedbytriggerof": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '1e9bd925-2f8e-4ce7-b2bd-50814738eff6', 'INSERT', '{"uuid": "1e9bd925-2f8e-4ce7-b2bd-50814738eff6", "assumed": true, "ascendantuuid": "81aefd8d-c7aa-48a5-869f-1df15b4b68ae", "descendantuuid": "d04aeefe-4ba4-466f-a563-b811674c6de9", "grantedbyroleuuid": null, "grantedbytriggerof": "ace60d06-0635-4c2c-bb4b-7233c19862fc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'c57ee5ea-1e8e-4a28-bfed-0bd4477fcb06', 'INSERT', '{"op": "INSERT", "uuid": "c57ee5ea-1e8e-4a28-bfed-0bd4477fcb06", "objectuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc", "optablename": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '164cba6b-2aa2-4ace-b9a5-9efdd016aa02', 'INSERT', '{"uuid": "164cba6b-2aa2-4ace-b9a5-9efdd016aa02", "assumed": true, "ascendantuuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "descendantuuid": "c57ee5ea-1e8e-4a28-bfed-0bd4477fcb06", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'e2c9d05c-4e79-48cf-8093-e8fa4b0a655e', 'INSERT', '{"op": "INSERT", "uuid": "e2c9d05c-4e79-48cf-8093-e8fa4b0a655e", "objectuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc", "optablename": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '23915a94-192d-4217-8cd4-fee7bd301f5d', 'INSERT', '{"uuid": "23915a94-192d-4217-8cd4-fee7bd301f5d", "assumed": true, "ascendantuuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "descendantuuid": "e2c9d05c-4e79-48cf-8093-e8fa4b0a655e", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'hs_office.membership', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'INSERT', '{"uuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc", "status": "ACTIVE", "version": 0, "validity": "[2021-05-17,)", "partneruuid": "25b8066a-59fd-4733-90f2-8ea80c826fff", "membernumbersuffix": "00", "membershipfeebillable": true}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.object', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'INSERT', '{"uuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769", "serialid": 263, "objecttable": "hs_office.membership"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '79cf3f87-a87d-40d8-a91a-cdd257866de7', 'INSERT', '{"uuid": "79cf3f87-a87d-40d8-a91a-cdd257866de7", "roletype": "OWNER", "objectuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'baecfc84-663c-40b8-972d-e84a89fd2dd4', 'INSERT', '{"uuid": "baecfc84-663c-40b8-972d-e84a89fd2dd4", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "79cf3f87-a87d-40d8-a91a-cdd257866de7", "grantedbyroleuuid": "79cf3f87-a87d-40d8-a91a-cdd257866de7", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', 'INSERT', '{"uuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "roletype": "ADMIN", "objectuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '408d2e43-8fa7-4c98-a0f8-4a52ebcce3bb', 'INSERT', '{"op": "DELETE", "uuid": "408d2e43-8fa7-4c98-a0f8-4a52ebcce3bb", "objectuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '9daa29f8-e2cc-47ed-bd9f-b382cccd8b99', 'INSERT', '{"uuid": "9daa29f8-e2cc-47ed-bd9f-b382cccd8b99", "assumed": true, "ascendantuuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "descendantuuid": "408d2e43-8fa7-4c98-a0f8-4a52ebcce3bb", "grantedbyroleuuid": null, "grantedbytriggerof": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '48607eac-4413-48eb-9b01-bd264a9b607c', 'INSERT', '{"op": "UPDATE", "uuid": "48607eac-4413-48eb-9b01-bd264a9b607c", "objectuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '70d57a02-1537-46d0-a900-51f461152cd1', 'INSERT', '{"uuid": "70d57a02-1537-46d0-a900-51f461152cd1", "assumed": true, "ascendantuuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "descendantuuid": "48607eac-4413-48eb-9b01-bd264a9b607c", "grantedbyroleuuid": null, "grantedbytriggerof": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'beffc78a-2738-4b01-87a5-168e0acd253c', 'INSERT', '{"uuid": "beffc78a-2738-4b01-87a5-168e0acd253c", "assumed": true, "ascendantuuid": "79cf3f87-a87d-40d8-a91a-cdd257866de7", "descendantuuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "grantedbyroleuuid": null, "grantedbytriggerof": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '2d0557e4-0a48-443e-8a26-99cb0e411fa6', 'INSERT', '{"uuid": "2d0557e4-0a48-443e-8a26-99cb0e411fa6", "assumed": true, "ascendantuuid": "28bf24da-eb68-4a99-8ff9-6e4145f5e805", "descendantuuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "grantedbyroleuuid": null, "grantedbytriggerof": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.role', '08c7995c-a7e7-4093-8aa0-6e6e8449f1e4', 'INSERT', '{"uuid": "08c7995c-a7e7-4093-8aa0-6e6e8449f1e4", "roletype": "AGENT", "objectuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'fc0b7f19-723c-46f3-b40c-a8973fb5cce6', 'INSERT', '{"op": "SELECT", "uuid": "fc0b7f19-723c-46f3-b40c-a8973fb5cce6", "objectuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'adecdbe8-eb20-4782-b977-0ee777193a68', 'INSERT', '{"uuid": "adecdbe8-eb20-4782-b977-0ee777193a68", "assumed": true, "ascendantuuid": "08c7995c-a7e7-4093-8aa0-6e6e8449f1e4", "descendantuuid": "fc0b7f19-723c-46f3-b40c-a8973fb5cce6", "grantedbyroleuuid": null, "grantedbytriggerof": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '4abce187-6e61-41b6-91c4-04d9f4f44323', 'INSERT', '{"uuid": "4abce187-6e61-41b6-91c4-04d9f4f44323", "assumed": true, "ascendantuuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "descendantuuid": "08c7995c-a7e7-4093-8aa0-6e6e8449f1e4", "grantedbyroleuuid": null, "grantedbytriggerof": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '2d6bab91-b2e2-4662-b802-72d42948d878', 'INSERT', '{"uuid": "2d6bab91-b2e2-4662-b802-72d42948d878", "assumed": true, "ascendantuuid": "f93693fa-7dc5-4513-8537-be9541d6e5dc", "descendantuuid": "08c7995c-a7e7-4093-8aa0-6e6e8449f1e4", "grantedbyroleuuid": null, "grantedbytriggerof": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'aa6f9a2d-c1c5-48d4-9fac-0ecabf17edf4', 'INSERT', '{"uuid": "aa6f9a2d-c1c5-48d4-9fac-0ecabf17edf4", "assumed": true, "ascendantuuid": "08c7995c-a7e7-4093-8aa0-6e6e8449f1e4", "descendantuuid": "33a45f49-ac74-4444-a193-2ed1e0be110d", "grantedbyroleuuid": null, "grantedbytriggerof": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', 'e131dff7-b974-4e12-8324-732296676146', 'INSERT', '{"op": "INSERT", "uuid": "e131dff7-b974-4e12-8324-732296676146", "objectuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769", "optablename": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', 'fd3f1211-bf61-49a3-9691-1bdd5c95d90d', 'INSERT', '{"uuid": "fd3f1211-bf61-49a3-9691-1bdd5c95d90d", "assumed": true, "ascendantuuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "descendantuuid": "e131dff7-b974-4e12-8324-732296676146", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.permission', '99188a87-efa3-4365-9135-700c0899d0dc', 'INSERT', '{"op": "INSERT", "uuid": "99188a87-efa3-4365-9135-700c0899d0dc", "objectuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769", "optablename": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'rbac.grant', '7f536e71-b099-442e-b004-698fe14198c9', 'INSERT', '{"uuid": "7f536e71-b099-442e-b004-698fe14198c9", "assumed": true, "ascendantuuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "descendantuuid": "99188a87-efa3-4365-9135-700c0899d0dc", "grantedbyroleuuid": null, "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2107', 'hs_office.membership', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'INSERT', '{"uuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769", "status": "ACTIVE", "version": 0, "validity": "[2021-05-25,)", "partneruuid": "c83c9583-a825-4a2d-96b7-fec9dd635fbc", "membernumbersuffix": "00", "membershipfeebillable": true}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.object', '9b403ef6-3fae-4698-9b21-2627c51fa254', 'INSERT', '{"uuid": "9b403ef6-3fae-4698-9b21-2627c51fa254", "serialid": 264, "objecttable": "hs_office.bankaccount"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '30ec4923-e756-46cf-ac20-79065a4f36bd', 'INSERT', '{"uuid": "30ec4923-e756-46cf-ac20-79065a4f36bd", "roletype": "OWNER", "objectuuid": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '59adeeef-e54c-4b26-8a36-f4dbe0b05273', 'INSERT', '{"op": "DELETE", "uuid": "59adeeef-e54c-4b26-8a36-f4dbe0b05273", "objectuuid": "9b403ef6-3fae-4698-9b21-2627c51fa254", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'e6ac71d5-f63f-4d77-8379-9a7805e8d117', 'INSERT', '{"uuid": "e6ac71d5-f63f-4d77-8379-9a7805e8d117", "assumed": true, "ascendantuuid": "30ec4923-e756-46cf-ac20-79065a4f36bd", "descendantuuid": "59adeeef-e54c-4b26-8a36-f4dbe0b05273", "grantedbyroleuuid": null, "grantedbytriggerof": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '466eb9f7-9139-4e30-a2bd-966888e498ea', 'INSERT', '{"uuid": "466eb9f7-9139-4e30-a2bd-966888e498ea", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "30ec4923-e756-46cf-ac20-79065a4f36bd", "grantedbyroleuuid": null, "grantedbytriggerof": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'a968bc32-85be-46f4-9a88-228adbe2d5c1', 'INSERT', '{"uuid": "a968bc32-85be-46f4-9a88-228adbe2d5c1", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "30ec4923-e756-46cf-ac20-79065a4f36bd", "grantedbyroleuuid": "30ec4923-e756-46cf-ac20-79065a4f36bd", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '0ae403ca-5143-44f0-b997-be330a72ee97', 'INSERT', '{"uuid": "0ae403ca-5143-44f0-b997-be330a72ee97", "roletype": "ADMIN", "objectuuid": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '01635d74-7e94-46e0-aba2-a1c8d471aaff', 'INSERT', '{"op": "UPDATE", "uuid": "01635d74-7e94-46e0-aba2-a1c8d471aaff", "objectuuid": "9b403ef6-3fae-4698-9b21-2627c51fa254", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'b0261acc-fdce-44a4-9c1a-f9500ee85839', 'INSERT', '{"uuid": "b0261acc-fdce-44a4-9c1a-f9500ee85839", "assumed": true, "ascendantuuid": "0ae403ca-5143-44f0-b997-be330a72ee97", "descendantuuid": "01635d74-7e94-46e0-aba2-a1c8d471aaff", "grantedbyroleuuid": null, "grantedbytriggerof": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'c6cdea8d-a1f7-4136-8fd2-66d0aee4a994', 'INSERT', '{"uuid": "c6cdea8d-a1f7-4136-8fd2-66d0aee4a994", "assumed": true, "ascendantuuid": "30ec4923-e756-46cf-ac20-79065a4f36bd", "descendantuuid": "0ae403ca-5143-44f0-b997-be330a72ee97", "grantedbyroleuuid": null, "grantedbytriggerof": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'aca34128-8a96-494d-a9e7-4e891208b023', 'INSERT', '{"uuid": "aca34128-8a96-494d-a9e7-4e891208b023", "roletype": "REFERRER", "objectuuid": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '2f8771ba-3650-43d8-af99-ffc413066a42', 'INSERT', '{"op": "SELECT", "uuid": "2f8771ba-3650-43d8-af99-ffc413066a42", "objectuuid": "9b403ef6-3fae-4698-9b21-2627c51fa254", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'ed11e005-8563-4462-89aa-b090c3065c03', 'INSERT', '{"uuid": "ed11e005-8563-4462-89aa-b090c3065c03", "assumed": true, "ascendantuuid": "aca34128-8a96-494d-a9e7-4e891208b023", "descendantuuid": "2f8771ba-3650-43d8-af99-ffc413066a42", "grantedbyroleuuid": null, "grantedbytriggerof": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '7b0f5c01-a564-4ccc-8bb3-d1716665bcca', 'INSERT', '{"uuid": "7b0f5c01-a564-4ccc-8bb3-d1716665bcca", "assumed": true, "ascendantuuid": "0ae403ca-5143-44f0-b997-be330a72ee97", "descendantuuid": "aca34128-8a96-494d-a9e7-4e891208b023", "grantedbyroleuuid": null, "grantedbytriggerof": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'hs_office.bankaccount', '9b403ef6-3fae-4698-9b21-2627c51fa254', 'INSERT', '{"bic": "GENODEM1GLS", "iban": "DE02300209000106531065", "uuid": "9b403ef6-3fae-4698-9b21-2627c51fa254", "holder": "Ragnar Richter", "version": 0}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.object', 'f9811182-d400-43e0-ba9e-de745c9e82a3', 'INSERT', '{"uuid": "f9811182-d400-43e0-ba9e-de745c9e82a3", "serialid": 265, "objecttable": "hs_office.bankaccount"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '2dbbeed2-ba1a-4781-85e4-28f1620f8f7c', 'INSERT', '{"uuid": "2dbbeed2-ba1a-4781-85e4-28f1620f8f7c", "roletype": "OWNER", "objectuuid": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '59e7f9e1-fa76-4f88-9ccd-da4eb105f0e2', 'INSERT', '{"op": "DELETE", "uuid": "59e7f9e1-fa76-4f88-9ccd-da4eb105f0e2", "objectuuid": "f9811182-d400-43e0-ba9e-de745c9e82a3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '210d5d54-1715-49bf-9934-c44ee016281a', 'INSERT', '{"uuid": "210d5d54-1715-49bf-9934-c44ee016281a", "assumed": true, "ascendantuuid": "2dbbeed2-ba1a-4781-85e4-28f1620f8f7c", "descendantuuid": "59e7f9e1-fa76-4f88-9ccd-da4eb105f0e2", "grantedbyroleuuid": null, "grantedbytriggerof": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'd2ae3143-a8c1-4493-90b4-deb8ee7cc5bb', 'INSERT', '{"uuid": "d2ae3143-a8c1-4493-90b4-deb8ee7cc5bb", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "2dbbeed2-ba1a-4781-85e4-28f1620f8f7c", "grantedbyroleuuid": null, "grantedbytriggerof": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '09ea6e4e-ab32-45b7-bd7d-b2e6691290f4', 'INSERT', '{"uuid": "09ea6e4e-ab32-45b7-bd7d-b2e6691290f4", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "2dbbeed2-ba1a-4781-85e4-28f1620f8f7c", "grantedbyroleuuid": "2dbbeed2-ba1a-4781-85e4-28f1620f8f7c", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea', 'INSERT', '{"uuid": "5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea", "roletype": "ADMIN", "objectuuid": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '0aa2520b-5481-4d8c-a478-964e4441d5e0', 'INSERT', '{"op": "UPDATE", "uuid": "0aa2520b-5481-4d8c-a478-964e4441d5e0", "objectuuid": "f9811182-d400-43e0-ba9e-de745c9e82a3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '69612d77-058f-44ae-b8e9-5657d6ab718f', 'INSERT', '{"uuid": "69612d77-058f-44ae-b8e9-5657d6ab718f", "assumed": true, "ascendantuuid": "5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea", "descendantuuid": "0aa2520b-5481-4d8c-a478-964e4441d5e0", "grantedbyroleuuid": null, "grantedbytriggerof": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '09dc6fbc-fb45-473e-97af-1bc4e973b91d', 'INSERT', '{"uuid": "09dc6fbc-fb45-473e-97af-1bc4e973b91d", "assumed": true, "ascendantuuid": "2dbbeed2-ba1a-4781-85e4-28f1620f8f7c", "descendantuuid": "5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea", "grantedbyroleuuid": null, "grantedbytriggerof": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '89ac1223-5561-4835-8c9d-681ab874a47a', 'INSERT', '{"uuid": "89ac1223-5561-4835-8c9d-681ab874a47a", "roletype": "REFERRER", "objectuuid": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'f5f51c10-010d-4d5b-bb8e-b2dc353ba051', 'INSERT', '{"op": "SELECT", "uuid": "f5f51c10-010d-4d5b-bb8e-b2dc353ba051", "objectuuid": "f9811182-d400-43e0-ba9e-de745c9e82a3", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'fca5d327-f653-4649-b1dd-3deb5b55fc68', 'INSERT', '{"uuid": "fca5d327-f653-4649-b1dd-3deb5b55fc68", "assumed": true, "ascendantuuid": "89ac1223-5561-4835-8c9d-681ab874a47a", "descendantuuid": "f5f51c10-010d-4d5b-bb8e-b2dc353ba051", "grantedbyroleuuid": null, "grantedbytriggerof": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '29bd21b9-2cf9-49e6-94ec-17eefad89b94', 'INSERT', '{"uuid": "29bd21b9-2cf9-49e6-94ec-17eefad89b94", "assumed": true, "ascendantuuid": "5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea", "descendantuuid": "89ac1223-5561-4835-8c9d-681ab874a47a", "grantedbyroleuuid": null, "grantedbytriggerof": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'hs_office.bankaccount', 'f9811182-d400-43e0-ba9e-de745c9e82a3', 'INSERT', '{"bic": "GENODEF1HH2", "iban": "DE37500105177419788228", "uuid": "f9811182-d400-43e0-ba9e-de745c9e82a3", "holder": "Michael Mellis", "version": 0}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.object', '4924877c-c487-4e4d-8b14-901e9b6069ac', 'INSERT', '{"uuid": "4924877c-c487-4e4d-8b14-901e9b6069ac", "serialid": 266, "objecttable": "hs_office.bankaccount"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '9827f746-1f3a-4c83-ad01-b5cd89f4d5a6', 'INSERT', '{"uuid": "9827f746-1f3a-4c83-ad01-b5cd89f4d5a6", "roletype": "OWNER", "objectuuid": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'd71a8b9b-b0da-4675-a6c5-45d2664c70f5', 'INSERT', '{"op": "DELETE", "uuid": "d71a8b9b-b0da-4675-a6c5-45d2664c70f5", "objectuuid": "4924877c-c487-4e4d-8b14-901e9b6069ac", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '79f35b59-eee1-4929-9cea-0bb600b9a157', 'INSERT', '{"uuid": "79f35b59-eee1-4929-9cea-0bb600b9a157", "assumed": true, "ascendantuuid": "9827f746-1f3a-4c83-ad01-b5cd89f4d5a6", "descendantuuid": "d71a8b9b-b0da-4675-a6c5-45d2664c70f5", "grantedbyroleuuid": null, "grantedbytriggerof": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '20464d07-6b81-4746-85fb-3c4f4ed87bd2', 'INSERT', '{"uuid": "20464d07-6b81-4746-85fb-3c4f4ed87bd2", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "9827f746-1f3a-4c83-ad01-b5cd89f4d5a6", "grantedbyroleuuid": null, "grantedbytriggerof": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'cbd6eb58-0ac6-41ea-98b9-82bf5d5b5428', 'INSERT', '{"uuid": "cbd6eb58-0ac6-41ea-98b9-82bf5d5b5428", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "9827f746-1f3a-4c83-ad01-b5cd89f4d5a6", "grantedbyroleuuid": "9827f746-1f3a-4c83-ad01-b5cd89f4d5a6", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '03089301-5a05-4c2d-abf3-b95267b2edef', 'INSERT', '{"uuid": "03089301-5a05-4c2d-abf3-b95267b2edef", "roletype": "ADMIN", "objectuuid": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'b32ebf6e-d5bb-4b03-9d03-10bcec3a6172', 'INSERT', '{"op": "UPDATE", "uuid": "b32ebf6e-d5bb-4b03-9d03-10bcec3a6172", "objectuuid": "4924877c-c487-4e4d-8b14-901e9b6069ac", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '7c3e19f3-5e89-4bbc-a577-ca82951fe335', 'INSERT', '{"uuid": "7c3e19f3-5e89-4bbc-a577-ca82951fe335", "assumed": true, "ascendantuuid": "03089301-5a05-4c2d-abf3-b95267b2edef", "descendantuuid": "b32ebf6e-d5bb-4b03-9d03-10bcec3a6172", "grantedbyroleuuid": null, "grantedbytriggerof": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '1fdbeb95-1bb7-4fb5-b9d1-e417e1c38f37', 'INSERT', '{"uuid": "1fdbeb95-1bb7-4fb5-b9d1-e417e1c38f37", "assumed": true, "ascendantuuid": "9827f746-1f3a-4c83-ad01-b5cd89f4d5a6", "descendantuuid": "03089301-5a05-4c2d-abf3-b95267b2edef", "grantedbyroleuuid": null, "grantedbytriggerof": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'b204ae10-065f-4969-aedd-4c25602a821c', 'INSERT', '{"uuid": "b204ae10-065f-4969-aedd-4c25602a821c", "roletype": "REFERRER", "objectuuid": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '5fdcc08b-295c-4853-957d-d171b1accd40', 'INSERT', '{"op": "SELECT", "uuid": "5fdcc08b-295c-4853-957d-d171b1accd40", "objectuuid": "4924877c-c487-4e4d-8b14-901e9b6069ac", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '1bf68e49-2a97-4686-a8b9-8cdb46475326', 'INSERT', '{"op": "SELECT", "uuid": "1bf68e49-2a97-4686-a8b9-8cdb46475326", "objectuuid": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '385d12e6-e689-491a-b503-5b699e008380', 'INSERT', '{"uuid": "385d12e6-e689-491a-b503-5b699e008380", "assumed": true, "ascendantuuid": "b204ae10-065f-4969-aedd-4c25602a821c", "descendantuuid": "5fdcc08b-295c-4853-957d-d171b1accd40", "grantedbyroleuuid": null, "grantedbytriggerof": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '564ef107-8d59-4db0-a926-e22f65276242', 'INSERT', '{"uuid": "564ef107-8d59-4db0-a926-e22f65276242", "assumed": true, "ascendantuuid": "03089301-5a05-4c2d-abf3-b95267b2edef", "descendantuuid": "b204ae10-065f-4969-aedd-4c25602a821c", "grantedbyroleuuid": null, "grantedbytriggerof": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'hs_office.bankaccount', '4924877c-c487-4e4d-8b14-901e9b6069ac', 'INSERT', '{"bic": "NOLADE21WHO", "iban": "DE49500105174516484892", "uuid": "4924877c-c487-4e4d-8b14-901e9b6069ac", "holder": "Wasserwerk Suedholstein", "version": 0}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.object', '831a608f-fefe-425b-b740-1786f856c680', 'INSERT', '{"uuid": "831a608f-fefe-425b-b740-1786f856c680", "serialid": 267, "objecttable": "hs_office.bankaccount"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'e7101997-a1b9-43bd-93a7-8b24fd506f05', 'INSERT', '{"uuid": "e7101997-a1b9-43bd-93a7-8b24fd506f05", "roletype": "OWNER", "objectuuid": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'dfb1ef2c-af28-40d5-b625-9f157f1323d4', 'INSERT', '{"op": "DELETE", "uuid": "dfb1ef2c-af28-40d5-b625-9f157f1323d4", "objectuuid": "831a608f-fefe-425b-b740-1786f856c680", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'bc94d775-510c-42fa-b5b0-fe4afe51d2e1', 'INSERT', '{"uuid": "bc94d775-510c-42fa-b5b0-fe4afe51d2e1", "assumed": true, "ascendantuuid": "e7101997-a1b9-43bd-93a7-8b24fd506f05", "descendantuuid": "dfb1ef2c-af28-40d5-b625-9f157f1323d4", "grantedbyroleuuid": null, "grantedbytriggerof": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '5ed62729-d2a8-4e5f-a863-bc4df6a19b94', 'INSERT', '{"uuid": "5ed62729-d2a8-4e5f-a863-bc4df6a19b94", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "e7101997-a1b9-43bd-93a7-8b24fd506f05", "grantedbyroleuuid": null, "grantedbytriggerof": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '84b03919-d440-4956-9a4c-746b226836c2', 'INSERT', '{"uuid": "84b03919-d440-4956-9a4c-746b226836c2", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "e7101997-a1b9-43bd-93a7-8b24fd506f05", "grantedbyroleuuid": "e7101997-a1b9-43bd-93a7-8b24fd506f05", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'dceec9d4-d2a5-444e-a27b-4a16c01b155b', 'INSERT', '{"uuid": "dceec9d4-d2a5-444e-a27b-4a16c01b155b", "roletype": "ADMIN", "objectuuid": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '2d5f609d-aac6-41b8-b7dc-ebb66f4b3833', 'INSERT', '{"op": "UPDATE", "uuid": "2d5f609d-aac6-41b8-b7dc-ebb66f4b3833", "objectuuid": "831a608f-fefe-425b-b740-1786f856c680", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '6ef83b69-925d-4f06-8e8f-4dea17c49543', 'INSERT', '{"uuid": "6ef83b69-925d-4f06-8e8f-4dea17c49543", "assumed": true, "ascendantuuid": "dceec9d4-d2a5-444e-a27b-4a16c01b155b", "descendantuuid": "2d5f609d-aac6-41b8-b7dc-ebb66f4b3833", "grantedbyroleuuid": null, "grantedbytriggerof": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '268d211e-943a-4fe8-8f2f-cd150a8edc64', 'INSERT', '{"uuid": "268d211e-943a-4fe8-8f2f-cd150a8edc64", "assumed": true, "ascendantuuid": "e7101997-a1b9-43bd-93a7-8b24fd506f05", "descendantuuid": "dceec9d4-d2a5-444e-a27b-4a16c01b155b", "grantedbyroleuuid": null, "grantedbytriggerof": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '3a07b077-aebc-48ad-ab29-6d375afab845', 'INSERT', '{"uuid": "3a07b077-aebc-48ad-ab29-6d375afab845", "roletype": "REFERRER", "objectuuid": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'e4c728ed-535a-40cc-a460-3174b695f899', 'INSERT', '{"op": "SELECT", "uuid": "e4c728ed-535a-40cc-a460-3174b695f899", "objectuuid": "831a608f-fefe-425b-b740-1786f856c680", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'b69cb6a8-e8b1-40de-b6a2-ed8250be0dfc', 'INSERT', '{"uuid": "b69cb6a8-e8b1-40de-b6a2-ed8250be0dfc", "assumed": true, "ascendantuuid": "3a07b077-aebc-48ad-ab29-6d375afab845", "descendantuuid": "e4c728ed-535a-40cc-a460-3174b695f899", "grantedbyroleuuid": null, "grantedbytriggerof": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'aff048df-13b6-4de7-beb6-20dce53d0f3b', 'INSERT', '{"uuid": "aff048df-13b6-4de7-beb6-20dce53d0f3b", "assumed": true, "ascendantuuid": "dceec9d4-d2a5-444e-a27b-4a16c01b155b", "descendantuuid": "3a07b077-aebc-48ad-ab29-6d375afab845", "grantedbyroleuuid": null, "grantedbytriggerof": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'hs_office.bankaccount', '831a608f-fefe-425b-b740-1786f856c680', 'INSERT', '{"bic": "COBADEFFXXX", "iban": "DE89370400440532013000", "uuid": "831a608f-fefe-425b-b740-1786f856c680", "holder": "Richard Wiese Das Perfekte Haus", "version": 0}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.object', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 'INSERT', '{"uuid": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7", "serialid": 268, "objecttable": "hs_office.bankaccount"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310', 'INSERT', '{"uuid": "abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310", "roletype": "OWNER", "objectuuid": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'b491c0ef-e4c3-4692-94f3-bf13b2dfff8a', 'INSERT', '{"op": "DELETE", "uuid": "b491c0ef-e4c3-4692-94f3-bf13b2dfff8a", "objectuuid": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'e02f41ca-d599-4b1d-8dca-c73730eec80b', 'INSERT', '{"uuid": "e02f41ca-d599-4b1d-8dca-c73730eec80b", "assumed": true, "ascendantuuid": "abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310", "descendantuuid": "b491c0ef-e4c3-4692-94f3-bf13b2dfff8a", "grantedbyroleuuid": null, "grantedbytriggerof": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'd79ad457-a8a4-4d4e-8c13-9f8bfabfa5e8', 'INSERT', '{"uuid": "d79ad457-a8a4-4d4e-8c13-9f8bfabfa5e8", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310", "grantedbyroleuuid": null, "grantedbytriggerof": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '7837d771-39f8-4519-9016-473396225565', 'INSERT', '{"uuid": "7837d771-39f8-4519-9016-473396225565", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310", "grantedbyroleuuid": "abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '2a9d3ef1-e293-4301-914b-0ed781b63689', 'INSERT', '{"uuid": "2a9d3ef1-e293-4301-914b-0ed781b63689", "roletype": "ADMIN", "objectuuid": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'fdad2cc6-4985-4407-ade1-857bd91c5518', 'INSERT', '{"op": "UPDATE", "uuid": "fdad2cc6-4985-4407-ade1-857bd91c5518", "objectuuid": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '03f2d39d-2345-4e7e-875f-7316003d16b9', 'INSERT', '{"uuid": "03f2d39d-2345-4e7e-875f-7316003d16b9", "assumed": true, "ascendantuuid": "2a9d3ef1-e293-4301-914b-0ed781b63689", "descendantuuid": "fdad2cc6-4985-4407-ade1-857bd91c5518", "grantedbyroleuuid": null, "grantedbytriggerof": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'df47ac59-c0d0-489b-b8ef-3089743d378b', 'INSERT', '{"uuid": "df47ac59-c0d0-489b-b8ef-3089743d378b", "assumed": true, "ascendantuuid": "abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310", "descendantuuid": "2a9d3ef1-e293-4301-914b-0ed781b63689", "grantedbyroleuuid": null, "grantedbytriggerof": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'e1ddefd3-730f-4085-8651-a24dc88b7330', 'INSERT', '{"uuid": "e1ddefd3-730f-4085-8651-a24dc88b7330", "roletype": "REFERRER", "objectuuid": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'e7e387cb-6b6d-48b0-a0ca-732d2c821b3a', 'INSERT', '{"uuid": "e7e387cb-6b6d-48b0-a0ca-732d2c821b3a", "assumed": true, "ascendantuuid": "e1ddefd3-730f-4085-8651-a24dc88b7330", "descendantuuid": "1bf68e49-2a97-4686-a8b9-8cdb46475326", "grantedbyroleuuid": null, "grantedbytriggerof": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'b7ff6ee8-21af-4fb7-8531-7f2102cdd928', 'INSERT', '{"uuid": "b7ff6ee8-21af-4fb7-8531-7f2102cdd928", "assumed": true, "ascendantuuid": "2a9d3ef1-e293-4301-914b-0ed781b63689", "descendantuuid": "e1ddefd3-730f-4085-8651-a24dc88b7330", "grantedbyroleuuid": null, "grantedbytriggerof": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'hs_office.bankaccount', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 'INSERT', '{"bic": "INGDDEFFXXX", "iban": "DE37500105177419788228", "uuid": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7", "holder": "Michael Mellis", "version": 0}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.object', '0bae3550-be89-4c0e-9ba4-01bae0419be0', 'INSERT', '{"uuid": "0bae3550-be89-4c0e-9ba4-01bae0419be0", "serialid": 269, "objecttable": "hs_office.bankaccount"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '0bb4851a-2274-44cd-85ff-fc4b4710f602', 'INSERT', '{"uuid": "0bb4851a-2274-44cd-85ff-fc4b4710f602", "roletype": "OWNER", "objectuuid": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'ccb79609-4c10-4c53-bd5b-3a128e7f7ebf', 'INSERT', '{"op": "DELETE", "uuid": "ccb79609-4c10-4c53-bd5b-3a128e7f7ebf", "objectuuid": "0bae3550-be89-4c0e-9ba4-01bae0419be0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'b7f710e1-4fff-4a34-950c-6ae91da5653a', 'INSERT', '{"uuid": "b7f710e1-4fff-4a34-950c-6ae91da5653a", "assumed": true, "ascendantuuid": "0bb4851a-2274-44cd-85ff-fc4b4710f602", "descendantuuid": "ccb79609-4c10-4c53-bd5b-3a128e7f7ebf", "grantedbyroleuuid": null, "grantedbytriggerof": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '7c23a1c7-821d-4e7a-85e9-9e02a3618827', 'INSERT', '{"uuid": "7c23a1c7-821d-4e7a-85e9-9e02a3618827", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0bb4851a-2274-44cd-85ff-fc4b4710f602", "grantedbyroleuuid": null, "grantedbytriggerof": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '5fd1ae74-8b0f-4ac0-a1e7-d503452dc79c', 'INSERT', '{"uuid": "5fd1ae74-8b0f-4ac0-a1e7-d503452dc79c", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0bb4851a-2274-44cd-85ff-fc4b4710f602", "grantedbyroleuuid": "0bb4851a-2274-44cd-85ff-fc4b4710f602", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'fdfd2976-fc7d-422e-8b5f-91f401927b18', 'INSERT', '{"uuid": "fdfd2976-fc7d-422e-8b5f-91f401927b18", "roletype": "ADMIN", "objectuuid": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '4e5c24fc-e3d1-49f7-963c-e386a72be2f8', 'INSERT', '{"op": "UPDATE", "uuid": "4e5c24fc-e3d1-49f7-963c-e386a72be2f8", "objectuuid": "0bae3550-be89-4c0e-9ba4-01bae0419be0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'fbec2137-bead-4315-b323-cfab02e185a5', 'INSERT', '{"uuid": "fbec2137-bead-4315-b323-cfab02e185a5", "assumed": true, "ascendantuuid": "fdfd2976-fc7d-422e-8b5f-91f401927b18", "descendantuuid": "4e5c24fc-e3d1-49f7-963c-e386a72be2f8", "grantedbyroleuuid": null, "grantedbytriggerof": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'e1a6da3c-dfc3-484f-8185-938c414326cb', 'INSERT', '{"uuid": "e1a6da3c-dfc3-484f-8185-938c414326cb", "assumed": true, "ascendantuuid": "0bb4851a-2274-44cd-85ff-fc4b4710f602", "descendantuuid": "fdfd2976-fc7d-422e-8b5f-91f401927b18", "grantedbyroleuuid": null, "grantedbytriggerof": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'ffe77615-7fe9-4dd7-8a55-9459ff2d2b43', 'INSERT', '{"uuid": "ffe77615-7fe9-4dd7-8a55-9459ff2d2b43", "roletype": "REFERRER", "objectuuid": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'a8dc5128-f0db-4f0e-b599-a87eeb73603c', 'INSERT', '{"op": "SELECT", "uuid": "a8dc5128-f0db-4f0e-b599-a87eeb73603c", "objectuuid": "0bae3550-be89-4c0e-9ba4-01bae0419be0", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'dc28beaf-2488-4ab3-995e-2174df1954cb', 'INSERT', '{"uuid": "dc28beaf-2488-4ab3-995e-2174df1954cb", "assumed": true, "ascendantuuid": "ffe77615-7fe9-4dd7-8a55-9459ff2d2b43", "descendantuuid": "a8dc5128-f0db-4f0e-b599-a87eeb73603c", "grantedbyroleuuid": null, "grantedbytriggerof": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '9cfb524c-ccf1-4171-8043-bf2116536699', 'INSERT', '{"uuid": "9cfb524c-ccf1-4171-8043-bf2116536699", "assumed": true, "ascendantuuid": "fdfd2976-fc7d-422e-8b5f-91f401927b18", "descendantuuid": "ffe77615-7fe9-4dd7-8a55-9459ff2d2b43", "grantedbyroleuuid": null, "grantedbytriggerof": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'hs_office.bankaccount', '0bae3550-be89-4c0e-9ba4-01bae0419be0', 'INSERT', '{"bic": "CMCIDEDD", "iban": "DE02300209000106531065", "uuid": "0bae3550-be89-4c0e-9ba4-01bae0419be0", "holder": "JM e.K.", "version": 0}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.object', 'f3140f7e-5045-4534-92aa-e918895bfafb', 'INSERT', '{"uuid": "f3140f7e-5045-4534-92aa-e918895bfafb", "serialid": 270, "objecttable": "hs_office.bankaccount"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', '93f3cd3e-9b10-4a7c-88a9-39c29118fa8d', 'INSERT', '{"uuid": "93f3cd3e-9b10-4a7c-88a9-39c29118fa8d", "roletype": "OWNER", "objectuuid": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '0fd249e7-1454-4914-957a-b3ec7bf25bee', 'INSERT', '{"op": "DELETE", "uuid": "0fd249e7-1454-4914-957a-b3ec7bf25bee", "objectuuid": "f3140f7e-5045-4534-92aa-e918895bfafb", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '5127038b-2074-42f5-a599-7cdce776b05d', 'INSERT', '{"uuid": "5127038b-2074-42f5-a599-7cdce776b05d", "assumed": true, "ascendantuuid": "93f3cd3e-9b10-4a7c-88a9-39c29118fa8d", "descendantuuid": "0fd249e7-1454-4914-957a-b3ec7bf25bee", "grantedbyroleuuid": null, "grantedbytriggerof": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '7b382b2e-1daa-4b6f-ad14-f765d768348e', 'INSERT', '{"uuid": "7b382b2e-1daa-4b6f-ad14-f765d768348e", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "93f3cd3e-9b10-4a7c-88a9-39c29118fa8d", "grantedbyroleuuid": null, "grantedbytriggerof": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '46a43889-233e-4322-97a7-77fd9716980b', 'INSERT', '{"uuid": "46a43889-233e-4322-97a7-77fd9716980b", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "93f3cd3e-9b10-4a7c-88a9-39c29118fa8d", "grantedbyroleuuid": "93f3cd3e-9b10-4a7c-88a9-39c29118fa8d", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'e9daa877-1886-48db-abab-5516000c4d8e', 'INSERT', '{"uuid": "e9daa877-1886-48db-abab-5516000c4d8e", "roletype": "ADMIN", "objectuuid": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', '0334125d-2eca-4694-9cc3-abfbb58b49f7', 'INSERT', '{"op": "UPDATE", "uuid": "0334125d-2eca-4694-9cc3-abfbb58b49f7", "objectuuid": "f3140f7e-5045-4534-92aa-e918895bfafb", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'bd7e0fd5-4ae5-4dfd-b029-4d037b63b6e6', 'INSERT', '{"uuid": "bd7e0fd5-4ae5-4dfd-b029-4d037b63b6e6", "assumed": true, "ascendantuuid": "e9daa877-1886-48db-abab-5516000c4d8e", "descendantuuid": "0334125d-2eca-4694-9cc3-abfbb58b49f7", "grantedbyroleuuid": null, "grantedbytriggerof": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'e8991a3f-7e11-413b-a946-c381890c8fcb', 'INSERT', '{"uuid": "e8991a3f-7e11-413b-a946-c381890c8fcb", "assumed": true, "ascendantuuid": "93f3cd3e-9b10-4a7c-88a9-39c29118fa8d", "descendantuuid": "e9daa877-1886-48db-abab-5516000c4d8e", "grantedbyroleuuid": null, "grantedbytriggerof": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.role', 'edf9d085-dbfc-4e3a-9f0e-9eb407423ff6', 'INSERT', '{"uuid": "edf9d085-dbfc-4e3a-9f0e-9eb407423ff6", "roletype": "REFERRER", "objectuuid": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.permission', 'bb74107e-cd5f-4207-87e2-69f4d67eb7f3', 'INSERT', '{"op": "SELECT", "uuid": "bb74107e-cd5f-4207-87e2-69f4d67eb7f3", "objectuuid": "f3140f7e-5045-4534-92aa-e918895bfafb", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', '8ed6a950-8f04-421b-8c2b-523ea5513b7c', 'INSERT', '{"uuid": "8ed6a950-8f04-421b-8c2b-523ea5513b7c", "assumed": true, "ascendantuuid": "edf9d085-dbfc-4e3a-9f0e-9eb407423ff6", "descendantuuid": "bb74107e-cd5f-4207-87e2-69f4d67eb7f3", "grantedbyroleuuid": null, "grantedbytriggerof": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'rbac.grant', 'baab9056-95ba-489e-af8f-3c8500316ded', 'INSERT', '{"uuid": "baab9056-95ba-489e-af8f-3c8500316ded", "assumed": true, "ascendantuuid": "e9daa877-1886-48db-abab-5516000c4d8e", "descendantuuid": "edf9d085-dbfc-4e3a-9f0e-9eb407423ff6", "grantedbyroleuuid": null, "grantedbytriggerof": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2143', 'hs_office.bankaccount', 'f3140f7e-5045-4534-92aa-e918895bfafb', 'INSERT', '{"bic": "INGDDEFFXXX", "iban": "DE49500105174516484892", "uuid": "f3140f7e-5045-4534-92aa-e918895bfafb", "holder": "JM GmbH", "version": 0}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.object', '3d0e6bb5-a62e-4225-a2bb-967c76926705', 'INSERT', '{"uuid": "3d0e6bb5-a62e-4225-a2bb-967c76926705", "serialid": 271, "objecttable": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '7a4d5839-8342-48c3-95e1-d7032ce2a6a0', 'INSERT', '{"uuid": "7a4d5839-8342-48c3-95e1-d7032ce2a6a0", "roletype": "OWNER", "objectuuid": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', 'eb46cc8c-d08e-4b43-aecd-b0d73b4c7a4c', 'INSERT', '{"op": "DELETE", "uuid": "eb46cc8c-d08e-4b43-aecd-b0d73b4c7a4c", "objectuuid": "3d0e6bb5-a62e-4225-a2bb-967c76926705", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '418fe050-167d-494f-b368-5b79cf68ed2c', 'INSERT', '{"uuid": "418fe050-167d-494f-b368-5b79cf68ed2c", "assumed": true, "ascendantuuid": "7a4d5839-8342-48c3-95e1-d7032ce2a6a0", "descendantuuid": "eb46cc8c-d08e-4b43-aecd-b0d73b4c7a4c", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'f1a34ea5-fa78-4061-9856-fc05184b21af', 'INSERT', '{"uuid": "f1a34ea5-fa78-4061-9856-fc05184b21af", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "7a4d5839-8342-48c3-95e1-d7032ce2a6a0", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '323ca3e8-6c46-430d-abc4-26b350c76ad9', 'INSERT', '{"uuid": "323ca3e8-6c46-430d-abc4-26b350c76ad9", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "7a4d5839-8342-48c3-95e1-d7032ce2a6a0", "grantedbyroleuuid": "7a4d5839-8342-48c3-95e1-d7032ce2a6a0", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '232fe9ca-d6b6-4105-869b-435f0b1357cd', 'INSERT', '{"uuid": "232fe9ca-d6b6-4105-869b-435f0b1357cd", "roletype": "ADMIN", "objectuuid": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '5fcac9c5-86b0-46ec-9eda-fa65d8ae1a9f', 'INSERT', '{"op": "UPDATE", "uuid": "5fcac9c5-86b0-46ec-9eda-fa65d8ae1a9f", "objectuuid": "3d0e6bb5-a62e-4225-a2bb-967c76926705", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'fb717805-588e-4af1-8a4d-d469bb1fd4d9', 'INSERT', '{"uuid": "fb717805-588e-4af1-8a4d-d469bb1fd4d9", "assumed": true, "ascendantuuid": "232fe9ca-d6b6-4105-869b-435f0b1357cd", "descendantuuid": "5fcac9c5-86b0-46ec-9eda-fa65d8ae1a9f", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'f712c42a-e9da-4a52-91f0-cf1adcbcb472', 'INSERT', '{"uuid": "f712c42a-e9da-4a52-91f0-cf1adcbcb472", "assumed": true, "ascendantuuid": "7a4d5839-8342-48c3-95e1-d7032ce2a6a0", "descendantuuid": "232fe9ca-d6b6-4105-869b-435f0b1357cd", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '8f422852-c9d5-4c4f-bac1-ea4950ea77d4', 'INSERT', '{"uuid": "8f422852-c9d5-4c4f-bac1-ea4950ea77d4", "roletype": "AGENT", "objectuuid": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '0d2930ac-000e-485c-92e0-4181aef8062d', 'INSERT', '{"uuid": "0d2930ac-000e-485c-92e0-4181aef8062d", "assumed": true, "ascendantuuid": "232fe9ca-d6b6-4105-869b-435f0b1357cd", "descendantuuid": "8f422852-c9d5-4c4f-bac1-ea4950ea77d4", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'dda57fac-9899-4895-bf24-8608b837e16e', 'INSERT', '{"uuid": "dda57fac-9899-4895-bf24-8608b837e16e", "assumed": true, "ascendantuuid": "8f422852-c9d5-4c4f-bac1-ea4950ea77d4", "descendantuuid": "aca34128-8a96-494d-a9e7-4e891208b023", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '548710bb-7879-4f1e-999a-c4f0cbd00ad4', 'INSERT', '{"uuid": "548710bb-7879-4f1e-999a-c4f0cbd00ad4", "assumed": true, "ascendantuuid": "8f422852-c9d5-4c4f-bac1-ea4950ea77d4", "descendantuuid": "fe0228ea-649c-45a4-b729-181aba7f3294", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '8d53905b-418d-4c91-aa71-d4c49184cbae', 'INSERT', '{"uuid": "8d53905b-418d-4c91-aa71-d4c49184cbae", "roletype": "REFERRER", "objectuuid": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '06d170a1-f3a5-453e-9a08-3dedf2ecc0d4', 'INSERT', '{"op": "SELECT", "uuid": "06d170a1-f3a5-453e-9a08-3dedf2ecc0d4", "objectuuid": "3d0e6bb5-a62e-4225-a2bb-967c76926705", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '0fed22c9-81a7-4e0d-b785-e0f526ae584d', 'INSERT', '{"uuid": "0fed22c9-81a7-4e0d-b785-e0f526ae584d", "assumed": true, "ascendantuuid": "8d53905b-418d-4c91-aa71-d4c49184cbae", "descendantuuid": "06d170a1-f3a5-453e-9a08-3dedf2ecc0d4", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'a113f072-ed17-43ad-9a44-a15836d419a7', 'INSERT', '{"uuid": "a113f072-ed17-43ad-9a44-a15836d419a7", "assumed": true, "ascendantuuid": "0ae403ca-5143-44f0-b997-be330a72ee97", "descendantuuid": "8d53905b-418d-4c91-aa71-d4c49184cbae", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'e82498ba-ea7e-4b5c-8999-80bdd4a12cb9', 'INSERT', '{"uuid": "e82498ba-ea7e-4b5c-8999-80bdd4a12cb9", "assumed": true, "ascendantuuid": "fe0228ea-649c-45a4-b729-181aba7f3294", "descendantuuid": "8d53905b-418d-4c91-aa71-d4c49184cbae", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '6548161a-1fa6-4aba-8474-9f4ac5eb0365', 'INSERT', '{"uuid": "6548161a-1fa6-4aba-8474-9f4ac5eb0365", "assumed": true, "ascendantuuid": "8f422852-c9d5-4c4f-bac1-ea4950ea77d4", "descendantuuid": "8d53905b-418d-4c91-aa71-d4c49184cbae", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '779a7b69-138a-42e9-b856-9baec41f7298', 'INSERT', '{"uuid": "779a7b69-138a-42e9-b856-9baec41f7298", "assumed": true, "ascendantuuid": "8d53905b-418d-4c91-aa71-d4c49184cbae", "descendantuuid": "f218c4d9-d10b-4445-b381-b73a71f5848c", "grantedbyroleuuid": null, "grantedbytriggerof": "3d0e6bb5-a62e-4225-a2bb-967c76926705"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'hs_office.sepamandate', '3d0e6bb5-a62e-4225-a2bb-967c76926705', 'INSERT', '{"uuid": "3d0e6bb5-a62e-4225-a2bb-967c76926705", "version": 0, "validity": "[2013-12-01,2016-02-16)", "agreement": "2013-12-01", "reference": "HS-10152-20140801", "debitoruuid": "67c2d793-212f-4ce0-a750-b18224a93c73", "bankaccountuuid": "9b403ef6-3fae-4698-9b21-2627c51fa254"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.object', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 'INSERT', '{"uuid": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c", "serialid": 272, "objecttable": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '1ea18a1f-6676-43b8-9fca-20b7e575c31e', 'INSERT', '{"uuid": "1ea18a1f-6676-43b8-9fca-20b7e575c31e", "roletype": "OWNER", "objectuuid": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '2194c042-0182-42cc-8174-6f219e3c4e65', 'INSERT', '{"op": "DELETE", "uuid": "2194c042-0182-42cc-8174-6f219e3c4e65", "objectuuid": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'fecc2be7-6d8b-4329-9233-6adc0bdcc8ff', 'INSERT', '{"uuid": "fecc2be7-6d8b-4329-9233-6adc0bdcc8ff", "assumed": true, "ascendantuuid": "1ea18a1f-6676-43b8-9fca-20b7e575c31e", "descendantuuid": "2194c042-0182-42cc-8174-6f219e3c4e65", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'f5487eeb-c486-4918-82cb-ceaf2865be9d', 'INSERT', '{"uuid": "f5487eeb-c486-4918-82cb-ceaf2865be9d", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "1ea18a1f-6676-43b8-9fca-20b7e575c31e", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'fe06dfb0-6da8-4343-8959-2b1fe0c48f99', 'INSERT', '{"uuid": "fe06dfb0-6da8-4343-8959-2b1fe0c48f99", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "1ea18a1f-6676-43b8-9fca-20b7e575c31e", "grantedbyroleuuid": "1ea18a1f-6676-43b8-9fca-20b7e575c31e", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'e5bb95d7-2fcd-4767-a200-c7c48e01401c', 'INSERT', '{"uuid": "e5bb95d7-2fcd-4767-a200-c7c48e01401c", "roletype": "ADMIN", "objectuuid": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', 'f792f250-1f61-4efa-a515-d04af7ad5e18', 'INSERT', '{"op": "UPDATE", "uuid": "f792f250-1f61-4efa-a515-d04af7ad5e18", "objectuuid": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'e4382c8a-b934-42be-b255-86a68b313e52', 'INSERT', '{"uuid": "e4382c8a-b934-42be-b255-86a68b313e52", "assumed": true, "ascendantuuid": "e5bb95d7-2fcd-4767-a200-c7c48e01401c", "descendantuuid": "f792f250-1f61-4efa-a515-d04af7ad5e18", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '3d08cdaa-3b4c-4a41-be4b-c02ff4d8d5b1', 'INSERT', '{"uuid": "3d08cdaa-3b4c-4a41-be4b-c02ff4d8d5b1", "assumed": true, "ascendantuuid": "1ea18a1f-6676-43b8-9fca-20b7e575c31e", "descendantuuid": "e5bb95d7-2fcd-4767-a200-c7c48e01401c", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'b83a49eb-39d3-4c98-8c0c-5a1fb1862079', 'INSERT', '{"uuid": "b83a49eb-39d3-4c98-8c0c-5a1fb1862079", "roletype": "AGENT", "objectuuid": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'fe7f66e1-5f12-465f-892e-831c6eb8eca6', 'INSERT', '{"uuid": "fe7f66e1-5f12-465f-892e-831c6eb8eca6", "assumed": true, "ascendantuuid": "e5bb95d7-2fcd-4767-a200-c7c48e01401c", "descendantuuid": "b83a49eb-39d3-4c98-8c0c-5a1fb1862079", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '98694180-1334-428d-88ba-f590b4bd0f9b', 'INSERT', '{"uuid": "98694180-1334-428d-88ba-f590b4bd0f9b", "assumed": true, "ascendantuuid": "b83a49eb-39d3-4c98-8c0c-5a1fb1862079", "descendantuuid": "89ac1223-5561-4835-8c9d-681ab874a47a", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '7c34d13b-6f59-4951-9f67-86175240b61e', 'INSERT', '{"uuid": "7c34d13b-6f59-4951-9f67-86175240b61e", "assumed": true, "ascendantuuid": "b83a49eb-39d3-4c98-8c0c-5a1fb1862079", "descendantuuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '7564d2ce-d4ad-48e2-baf4-2fc08cc249a8', 'INSERT', '{"uuid": "7564d2ce-d4ad-48e2-baf4-2fc08cc249a8", "roletype": "REFERRER", "objectuuid": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '0c5a46ce-1c25-4f5b-9dff-5f5be50cf6a6', 'INSERT', '{"op": "SELECT", "uuid": "0c5a46ce-1c25-4f5b-9dff-5f5be50cf6a6", "objectuuid": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'b5844430-3cc8-411b-b13f-b79b231cf9ec', 'INSERT', '{"uuid": "b5844430-3cc8-411b-b13f-b79b231cf9ec", "assumed": true, "ascendantuuid": "7564d2ce-d4ad-48e2-baf4-2fc08cc249a8", "descendantuuid": "0c5a46ce-1c25-4f5b-9dff-5f5be50cf6a6", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'b50ba954-ffce-4a4f-bad5-0df732c28759', 'INSERT', '{"uuid": "b50ba954-ffce-4a4f-bad5-0df732c28759", "assumed": true, "ascendantuuid": "5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea", "descendantuuid": "7564d2ce-d4ad-48e2-baf4-2fc08cc249a8", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '94051685-ca75-4b71-9f62-48e8f8b64dcf', 'INSERT', '{"uuid": "94051685-ca75-4b71-9f62-48e8f8b64dcf", "assumed": true, "ascendantuuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "descendantuuid": "7564d2ce-d4ad-48e2-baf4-2fc08cc249a8", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'f0997e3b-25ec-478a-89cb-2ceb281db00b', 'INSERT', '{"uuid": "f0997e3b-25ec-478a-89cb-2ceb281db00b", "assumed": true, "ascendantuuid": "b83a49eb-39d3-4c98-8c0c-5a1fb1862079", "descendantuuid": "7564d2ce-d4ad-48e2-baf4-2fc08cc249a8", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '34aaa5e2-cfdb-441e-a83c-235b50c3d095', 'INSERT', '{"uuid": "34aaa5e2-cfdb-441e-a83c-235b50c3d095", "assumed": true, "ascendantuuid": "7564d2ce-d4ad-48e2-baf4-2fc08cc249a8", "descendantuuid": "8ad792c1-10e1-43fa-8d5a-a6f3810878a2", "grantedbyroleuuid": null, "grantedbytriggerof": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'hs_office.sepamandate', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 'INSERT', '{"uuid": "6c0ad97f-fb44-471b-b53a-d834cd4ac04c", "version": 0, "validity": "[2013-12-01,)", "agreement": "2013-12-01", "reference": "HS-10003-20140801", "debitoruuid": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61", "bankaccountuuid": "f9811182-d400-43e0-ba9e-de745c9e82a3"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.object', '850aa448-3a14-440c-9834-0b7ef6d83c39', 'INSERT', '{"uuid": "850aa448-3a14-440c-9834-0b7ef6d83c39", "serialid": 273, "objecttable": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '71c29d57-de3e-4f00-9303-2d51e8c11b20', 'INSERT', '{"uuid": "71c29d57-de3e-4f00-9303-2d51e8c11b20", "roletype": "OWNER", "objectuuid": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '02748d62-3212-4465-8c05-aabc3f919a08', 'INSERT', '{"op": "DELETE", "uuid": "02748d62-3212-4465-8c05-aabc3f919a08", "objectuuid": "850aa448-3a14-440c-9834-0b7ef6d83c39", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '1f014ff1-f4fc-428b-9c97-567d7d7aeca6', 'INSERT', '{"uuid": "1f014ff1-f4fc-428b-9c97-567d7d7aeca6", "assumed": true, "ascendantuuid": "71c29d57-de3e-4f00-9303-2d51e8c11b20", "descendantuuid": "02748d62-3212-4465-8c05-aabc3f919a08", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'ebeae76d-0a04-4574-9ff8-bda63915a39f', 'INSERT', '{"uuid": "ebeae76d-0a04-4574-9ff8-bda63915a39f", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "71c29d57-de3e-4f00-9303-2d51e8c11b20", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'e326cafc-77e1-457c-96e5-72ede9f4c721', 'INSERT', '{"uuid": "e326cafc-77e1-457c-96e5-72ede9f4c721", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "71c29d57-de3e-4f00-9303-2d51e8c11b20", "grantedbyroleuuid": "71c29d57-de3e-4f00-9303-2d51e8c11b20", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'adaeb8bf-e22b-4bb9-ab33-66e19053ab31', 'INSERT', '{"uuid": "adaeb8bf-e22b-4bb9-ab33-66e19053ab31", "roletype": "ADMIN", "objectuuid": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '0cde804f-7eed-49d3-8eb4-d55e806f8957', 'INSERT', '{"op": "UPDATE", "uuid": "0cde804f-7eed-49d3-8eb4-d55e806f8957", "objectuuid": "850aa448-3a14-440c-9834-0b7ef6d83c39", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '656c7f0a-a22b-47db-8a70-04e089949578', 'INSERT', '{"uuid": "656c7f0a-a22b-47db-8a70-04e089949578", "assumed": true, "ascendantuuid": "adaeb8bf-e22b-4bb9-ab33-66e19053ab31", "descendantuuid": "0cde804f-7eed-49d3-8eb4-d55e806f8957", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'bf6e7bdf-0223-4f6a-9b18-83c7f32de12b', 'INSERT', '{"uuid": "bf6e7bdf-0223-4f6a-9b18-83c7f32de12b", "assumed": true, "ascendantuuid": "71c29d57-de3e-4f00-9303-2d51e8c11b20", "descendantuuid": "adaeb8bf-e22b-4bb9-ab33-66e19053ab31", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'bb372939-0891-4068-bf4b-651e8f2a03c8', 'INSERT', '{"uuid": "bb372939-0891-4068-bf4b-651e8f2a03c8", "roletype": "AGENT", "objectuuid": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'ea19f91f-d0e1-4612-84de-136e1c687a95', 'INSERT', '{"uuid": "ea19f91f-d0e1-4612-84de-136e1c687a95", "assumed": true, "ascendantuuid": "adaeb8bf-e22b-4bb9-ab33-66e19053ab31", "descendantuuid": "bb372939-0891-4068-bf4b-651e8f2a03c8", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '3f67f755-72fa-435b-8f11-dee88ec0d5ff', 'INSERT', '{"uuid": "3f67f755-72fa-435b-8f11-dee88ec0d5ff", "assumed": true, "ascendantuuid": "bb372939-0891-4068-bf4b-651e8f2a03c8", "descendantuuid": "b204ae10-065f-4969-aedd-4c25602a821c", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '396be5ea-4bc6-4379-a8fe-052cddc952f6', 'INSERT', '{"uuid": "396be5ea-4bc6-4379-a8fe-052cddc952f6", "assumed": true, "ascendantuuid": "bb372939-0891-4068-bf4b-651e8f2a03c8", "descendantuuid": "e6409531-6513-43a9-84a7-eff44b18285a", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '88d51826-68ce-4d8a-9a65-91429e00d053', 'INSERT', '{"uuid": "88d51826-68ce-4d8a-9a65-91429e00d053", "roletype": "REFERRER", "objectuuid": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', 'b04e429b-3f95-4dea-b61e-3e96d114ecd1', 'INSERT', '{"op": "SELECT", "uuid": "b04e429b-3f95-4dea-b61e-3e96d114ecd1", "objectuuid": "850aa448-3a14-440c-9834-0b7ef6d83c39", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '7d60b8f3-b636-4774-9627-f1bf0da5161d', 'INSERT', '{"uuid": "7d60b8f3-b636-4774-9627-f1bf0da5161d", "assumed": true, "ascendantuuid": "88d51826-68ce-4d8a-9a65-91429e00d053", "descendantuuid": "b04e429b-3f95-4dea-b61e-3e96d114ecd1", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'a07e0d52-8691-4ed9-929b-0874ec22e207', 'INSERT', '{"uuid": "a07e0d52-8691-4ed9-929b-0874ec22e207", "assumed": true, "ascendantuuid": "03089301-5a05-4c2d-abf3-b95267b2edef", "descendantuuid": "88d51826-68ce-4d8a-9a65-91429e00d053", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '1fa5268e-4a20-4733-a5ef-16250ee16686', 'INSERT', '{"uuid": "1fa5268e-4a20-4733-a5ef-16250ee16686", "assumed": true, "ascendantuuid": "e6409531-6513-43a9-84a7-eff44b18285a", "descendantuuid": "88d51826-68ce-4d8a-9a65-91429e00d053", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '37485252-ae63-47cc-badd-e551a9840214', 'INSERT', '{"uuid": "37485252-ae63-47cc-badd-e551a9840214", "assumed": true, "ascendantuuid": "bb372939-0891-4068-bf4b-651e8f2a03c8", "descendantuuid": "88d51826-68ce-4d8a-9a65-91429e00d053", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '81b57d10-68d0-4a5b-b4bd-22ef77b245b0', 'INSERT', '{"uuid": "81b57d10-68d0-4a5b-b4bd-22ef77b245b0", "assumed": true, "ascendantuuid": "88d51826-68ce-4d8a-9a65-91429e00d053", "descendantuuid": "d00a14ad-fe79-40fc-8f72-722fb5cd30bd", "grantedbyroleuuid": null, "grantedbytriggerof": "850aa448-3a14-440c-9834-0b7ef6d83c39"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'hs_office.sepamandate', '850aa448-3a14-440c-9834-0b7ef6d83c39', 'INSERT', '{"uuid": "850aa448-3a14-440c-9834-0b7ef6d83c39", "version": 0, "validity": "[2021-05-17,)", "agreement": "2021-05-12", "reference": "HS-11018-20210512", "debitoruuid": "ccbd7baa-494d-4bfc-b5bb-4310e607df04", "bankaccountuuid": "4924877c-c487-4e4d-8b14-901e9b6069ac"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.object', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 'INSERT', '{"uuid": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc", "serialid": 274, "objecttable": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8', 'INSERT', '{"uuid": "63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8", "roletype": "OWNER", "objectuuid": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '3014663a-10bc-4a8b-b47c-2c805b198d7f', 'INSERT', '{"op": "DELETE", "uuid": "3014663a-10bc-4a8b-b47c-2c805b198d7f", "objectuuid": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '715fcbc2-a193-4ad7-83b7-c4f455b5a7f8', 'INSERT', '{"uuid": "715fcbc2-a193-4ad7-83b7-c4f455b5a7f8", "assumed": true, "ascendantuuid": "63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8", "descendantuuid": "3014663a-10bc-4a8b-b47c-2c805b198d7f", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '94782817-2d75-467d-bb1b-bf257174d08a', 'INSERT', '{"uuid": "94782817-2d75-467d-bb1b-bf257174d08a", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '38b49585-c8b6-4060-a002-4313aba14115', 'INSERT', '{"uuid": "38b49585-c8b6-4060-a002-4313aba14115", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8", "grantedbyroleuuid": "63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '74b8c100-35a5-4a9e-882b-d106b0656e15', 'INSERT', '{"uuid": "74b8c100-35a5-4a9e-882b-d106b0656e15", "roletype": "ADMIN", "objectuuid": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '702c700c-a440-4771-b203-9c030c1c100f', 'INSERT', '{"op": "UPDATE", "uuid": "702c700c-a440-4771-b203-9c030c1c100f", "objectuuid": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'a65ff09c-84e5-484f-9e3d-6fc6b0910745', 'INSERT', '{"uuid": "a65ff09c-84e5-484f-9e3d-6fc6b0910745", "assumed": true, "ascendantuuid": "74b8c100-35a5-4a9e-882b-d106b0656e15", "descendantuuid": "702c700c-a440-4771-b203-9c030c1c100f", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '98fe55f4-9a13-4719-8332-9556d414cffd', 'INSERT', '{"uuid": "98fe55f4-9a13-4719-8332-9556d414cffd", "assumed": true, "ascendantuuid": "63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8", "descendantuuid": "74b8c100-35a5-4a9e-882b-d106b0656e15", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'c73f5078-0505-44ea-b0e1-57390f4d5a3b', 'INSERT', '{"uuid": "c73f5078-0505-44ea-b0e1-57390f4d5a3b", "roletype": "AGENT", "objectuuid": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '869e59ed-914a-4779-a1ee-9989dace7aa5', 'INSERT', '{"uuid": "869e59ed-914a-4779-a1ee-9989dace7aa5", "assumed": true, "ascendantuuid": "74b8c100-35a5-4a9e-882b-d106b0656e15", "descendantuuid": "c73f5078-0505-44ea-b0e1-57390f4d5a3b", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'f26117f0-9761-4e50-858d-0a5e70242649', 'INSERT', '{"uuid": "f26117f0-9761-4e50-858d-0a5e70242649", "assumed": true, "ascendantuuid": "c73f5078-0505-44ea-b0e1-57390f4d5a3b", "descendantuuid": "3a07b077-aebc-48ad-ab29-6d375afab845", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '49e38887-66ff-4548-9077-88858312127c', 'INSERT', '{"uuid": "49e38887-66ff-4548-9077-88858312127c", "assumed": true, "ascendantuuid": "c73f5078-0505-44ea-b0e1-57390f4d5a3b", "descendantuuid": "6e7feeb7-4891-4ea3-96b6-00d883da37c5", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '86454239-fb95-484e-9f75-142ee5ca2a5d', 'INSERT', '{"uuid": "86454239-fb95-484e-9f75-142ee5ca2a5d", "roletype": "REFERRER", "objectuuid": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '69067b5f-41d0-447b-aba4-31764c6d6e04', 'INSERT', '{"op": "SELECT", "uuid": "69067b5f-41d0-447b-aba4-31764c6d6e04", "objectuuid": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'dcee72e3-0c00-4de2-a42b-0e270c2d8f9c', 'INSERT', '{"uuid": "dcee72e3-0c00-4de2-a42b-0e270c2d8f9c", "assumed": true, "ascendantuuid": "86454239-fb95-484e-9f75-142ee5ca2a5d", "descendantuuid": "69067b5f-41d0-447b-aba4-31764c6d6e04", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'f8802f34-52da-44d5-9797-78e0dc3583a8', 'INSERT', '{"uuid": "f8802f34-52da-44d5-9797-78e0dc3583a8", "assumed": true, "ascendantuuid": "dceec9d4-d2a5-444e-a27b-4a16c01b155b", "descendantuuid": "86454239-fb95-484e-9f75-142ee5ca2a5d", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '4fc7cfb9-2782-4b2c-9c3f-a8eb0e573d76', 'INSERT', '{"uuid": "4fc7cfb9-2782-4b2c-9c3f-a8eb0e573d76", "assumed": true, "ascendantuuid": "6e7feeb7-4891-4ea3-96b6-00d883da37c5", "descendantuuid": "86454239-fb95-484e-9f75-142ee5ca2a5d", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '582a665f-fb6e-4a1d-9c34-544805cb2290', 'INSERT', '{"uuid": "582a665f-fb6e-4a1d-9c34-544805cb2290", "assumed": true, "ascendantuuid": "c73f5078-0505-44ea-b0e1-57390f4d5a3b", "descendantuuid": "86454239-fb95-484e-9f75-142ee5ca2a5d", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'de1fa34f-307c-43aa-b9f9-0de34a7e55eb', 'INSERT', '{"uuid": "de1fa34f-307c-43aa-b9f9-0de34a7e55eb", "assumed": true, "ascendantuuid": "86454239-fb95-484e-9f75-142ee5ca2a5d", "descendantuuid": "1ed7ff07-778c-4920-a550-563b27223228", "grantedbyroleuuid": null, "grantedbytriggerof": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'hs_office.sepamandate', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 'INSERT', '{"uuid": "1c7e3e8a-59c7-4567-8102-f18694d5a1dc", "version": 0, "validity": "[2021-05-25,)", "agreement": "2021-05-19", "reference": "HS-11019-20210519", "debitoruuid": "ade3baa7-760f-488b-962d-7e365ad1402f", "bankaccountuuid": "831a608f-fefe-425b-b740-1786f856c680"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.object', '466056f2-efc6-45d6-b778-fa111db7a18b', 'INSERT', '{"uuid": "466056f2-efc6-45d6-b778-fa111db7a18b", "serialid": 275, "objecttable": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '0017035a-e8ef-4e77-a43d-938cfc7962f5', 'INSERT', '{"uuid": "0017035a-e8ef-4e77-a43d-938cfc7962f5", "roletype": "OWNER", "objectuuid": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', 'a3d6ce3f-655b-452b-91b1-539956c8580d', 'INSERT', '{"op": "DELETE", "uuid": "a3d6ce3f-655b-452b-91b1-539956c8580d", "objectuuid": "466056f2-efc6-45d6-b778-fa111db7a18b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '9295097d-a6bb-4f56-872c-786a6e030c4d', 'INSERT', '{"uuid": "9295097d-a6bb-4f56-872c-786a6e030c4d", "assumed": true, "ascendantuuid": "0017035a-e8ef-4e77-a43d-938cfc7962f5", "descendantuuid": "a3d6ce3f-655b-452b-91b1-539956c8580d", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '2f1d9ae4-4df3-4b51-bd68-0140f715fc71', 'INSERT', '{"uuid": "2f1d9ae4-4df3-4b51-bd68-0140f715fc71", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "0017035a-e8ef-4e77-a43d-938cfc7962f5", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '829228f5-33c6-47e3-b6d5-4eae06004c3b', 'INSERT', '{"uuid": "829228f5-33c6-47e3-b6d5-4eae06004c3b", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "0017035a-e8ef-4e77-a43d-938cfc7962f5", "grantedbyroleuuid": "0017035a-e8ef-4e77-a43d-938cfc7962f5", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'ad177311-3c0c-4d93-9ff7-c0b5665fd0ca', 'INSERT', '{"uuid": "ad177311-3c0c-4d93-9ff7-c0b5665fd0ca", "roletype": "ADMIN", "objectuuid": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '0198a5da-a2fc-4f7e-bf41-54642325d8dd', 'INSERT', '{"op": "UPDATE", "uuid": "0198a5da-a2fc-4f7e-bf41-54642325d8dd", "objectuuid": "466056f2-efc6-45d6-b778-fa111db7a18b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'b7ab4650-c744-4560-8e9b-bffde55f24f5', 'INSERT', '{"uuid": "b7ab4650-c744-4560-8e9b-bffde55f24f5", "assumed": true, "ascendantuuid": "ad177311-3c0c-4d93-9ff7-c0b5665fd0ca", "descendantuuid": "0198a5da-a2fc-4f7e-bf41-54642325d8dd", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '718c7a90-f8ca-4b20-aab8-d6470acc3cb0', 'INSERT', '{"uuid": "718c7a90-f8ca-4b20-aab8-d6470acc3cb0", "assumed": true, "ascendantuuid": "0017035a-e8ef-4e77-a43d-938cfc7962f5", "descendantuuid": "ad177311-3c0c-4d93-9ff7-c0b5665fd0ca", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'e2f03c7d-5026-42a3-a18f-ce770314c22b', 'INSERT', '{"uuid": "e2f03c7d-5026-42a3-a18f-ce770314c22b", "roletype": "AGENT", "objectuuid": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'eaec616a-0014-4399-a500-41918750c501', 'INSERT', '{"uuid": "eaec616a-0014-4399-a500-41918750c501", "assumed": true, "ascendantuuid": "ad177311-3c0c-4d93-9ff7-c0b5665fd0ca", "descendantuuid": "e2f03c7d-5026-42a3-a18f-ce770314c22b", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '4085dd28-9917-4acd-a438-188c6de4ae47', 'INSERT', '{"uuid": "4085dd28-9917-4acd-a438-188c6de4ae47", "assumed": true, "ascendantuuid": "e2f03c7d-5026-42a3-a18f-ce770314c22b", "descendantuuid": "e1ddefd3-730f-4085-8651-a24dc88b7330", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'b2216acc-616a-43ac-9f46-9526a658a586', 'INSERT', '{"uuid": "b2216acc-616a-43ac-9f46-9526a658a586", "assumed": true, "ascendantuuid": "e2f03c7d-5026-42a3-a18f-ce770314c22b", "descendantuuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '8e019651-e0a0-490f-8592-55c7016cec2c', 'INSERT', '{"uuid": "8e019651-e0a0-490f-8592-55c7016cec2c", "roletype": "REFERRER", "objectuuid": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', 'ca0cb3e0-c89b-45a1-8614-c6a6f7a5e80f', 'INSERT', '{"op": "SELECT", "uuid": "ca0cb3e0-c89b-45a1-8614-c6a6f7a5e80f", "objectuuid": "466056f2-efc6-45d6-b778-fa111db7a18b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '03d92a07-9316-4168-816e-34416a2ec8d7', 'INSERT', '{"uuid": "03d92a07-9316-4168-816e-34416a2ec8d7", "assumed": true, "ascendantuuid": "8e019651-e0a0-490f-8592-55c7016cec2c", "descendantuuid": "ca0cb3e0-c89b-45a1-8614-c6a6f7a5e80f", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '156cd874-18f0-4914-879b-3abb92658f0b', 'INSERT', '{"uuid": "156cd874-18f0-4914-879b-3abb92658f0b", "assumed": true, "ascendantuuid": "2a9d3ef1-e293-4301-914b-0ed781b63689", "descendantuuid": "8e019651-e0a0-490f-8592-55c7016cec2c", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '74df7196-1406-4904-a395-f8ca0070adfe', 'INSERT', '{"uuid": "74df7196-1406-4904-a395-f8ca0070adfe", "assumed": true, "ascendantuuid": "6c0656b5-472b-4859-af3a-b8f1c53231a5", "descendantuuid": "8e019651-e0a0-490f-8592-55c7016cec2c", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '05a0f74b-4a19-44a0-bf45-bb01e3a3c542', 'INSERT', '{"uuid": "05a0f74b-4a19-44a0-bf45-bb01e3a3c542", "assumed": true, "ascendantuuid": "e2f03c7d-5026-42a3-a18f-ce770314c22b", "descendantuuid": "8e019651-e0a0-490f-8592-55c7016cec2c", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '32de1c62-58ac-4e44-9eb9-c9728cbcd99d', 'INSERT', '{"uuid": "32de1c62-58ac-4e44-9eb9-c9728cbcd99d", "assumed": true, "ascendantuuid": "8e019651-e0a0-490f-8592-55c7016cec2c", "descendantuuid": "8ad792c1-10e1-43fa-8d5a-a6f3810878a2", "grantedbyroleuuid": null, "grantedbytriggerof": "466056f2-efc6-45d6-b778-fa111db7a18b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'hs_office.sepamandate', '466056f2-efc6-45d6-b778-fa111db7a18b', 'INSERT', '{"uuid": "466056f2-efc6-45d6-b778-fa111db7a18b", "version": 0, "validity": "[2004-06-15,)", "agreement": "2004-06-12", "reference": "MH12345", "debitoruuid": "6fc20aab-5dcf-4b04-8a33-1d1512fe8c61", "bankaccountuuid": "4f95f38e-08e8-497a-8edb-b74f67e3f2b7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.object', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', 'INSERT', '{"uuid": "e2dd08d5-2083-44ef-bf22-57898af08e3e", "serialid": 276, "objecttable": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'ee5eda97-ff2a-4646-ae01-dcec47a7688b', 'INSERT', '{"uuid": "ee5eda97-ff2a-4646-ae01-dcec47a7688b", "roletype": "OWNER", "objectuuid": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '41bf1ce4-7d32-4bc9-a240-6f37aa7c5311', 'INSERT', '{"op": "DELETE", "uuid": "41bf1ce4-7d32-4bc9-a240-6f37aa7c5311", "objectuuid": "e2dd08d5-2083-44ef-bf22-57898af08e3e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '57fae3e0-faa4-4a5d-9578-3be81426c9ed', 'INSERT', '{"uuid": "57fae3e0-faa4-4a5d-9578-3be81426c9ed", "assumed": true, "ascendantuuid": "ee5eda97-ff2a-4646-ae01-dcec47a7688b", "descendantuuid": "41bf1ce4-7d32-4bc9-a240-6f37aa7c5311", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '76e98e3c-8e48-403f-a3a7-21e543cd1f43', 'INSERT', '{"uuid": "76e98e3c-8e48-403f-a3a7-21e543cd1f43", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "ee5eda97-ff2a-4646-ae01-dcec47a7688b", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '994806f8-555b-4852-84ea-46f1042cc8a7', 'INSERT', '{"uuid": "994806f8-555b-4852-84ea-46f1042cc8a7", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "ee5eda97-ff2a-4646-ae01-dcec47a7688b", "grantedbyroleuuid": "ee5eda97-ff2a-4646-ae01-dcec47a7688b", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '2214774f-6235-4cb9-8713-e2ee51b213d2', 'INSERT', '{"uuid": "2214774f-6235-4cb9-8713-e2ee51b213d2", "roletype": "ADMIN", "objectuuid": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '008b96bf-c732-4063-95fa-8660cc3e378a', 'INSERT', '{"op": "UPDATE", "uuid": "008b96bf-c732-4063-95fa-8660cc3e378a", "objectuuid": "e2dd08d5-2083-44ef-bf22-57898af08e3e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'd0f378b9-9b9e-43ad-8d06-dddf272d656f', 'INSERT', '{"uuid": "d0f378b9-9b9e-43ad-8d06-dddf272d656f", "assumed": true, "ascendantuuid": "2214774f-6235-4cb9-8713-e2ee51b213d2", "descendantuuid": "008b96bf-c732-4063-95fa-8660cc3e378a", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '9dec48cd-6775-407c-ae5b-96bb7cc9bd03', 'INSERT', '{"uuid": "9dec48cd-6775-407c-ae5b-96bb7cc9bd03", "assumed": true, "ascendantuuid": "ee5eda97-ff2a-4646-ae01-dcec47a7688b", "descendantuuid": "2214774f-6235-4cb9-8713-e2ee51b213d2", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '919c64ed-015d-4a71-9287-69f554378b69', 'INSERT', '{"uuid": "919c64ed-015d-4a71-9287-69f554378b69", "roletype": "AGENT", "objectuuid": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '4363884b-cec6-4d16-a544-aa7851fbe568', 'INSERT', '{"uuid": "4363884b-cec6-4d16-a544-aa7851fbe568", "assumed": true, "ascendantuuid": "2214774f-6235-4cb9-8713-e2ee51b213d2", "descendantuuid": "919c64ed-015d-4a71-9287-69f554378b69", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '009da81d-2778-4058-a777-f2a1a49a7dbb', 'INSERT', '{"uuid": "009da81d-2778-4058-a777-f2a1a49a7dbb", "assumed": true, "ascendantuuid": "919c64ed-015d-4a71-9287-69f554378b69", "descendantuuid": "ffe77615-7fe9-4dd7-8a55-9459ff2d2b43", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'b0fff766-3126-4558-8543-023fd7919a4a', 'INSERT', '{"uuid": "b0fff766-3126-4558-8543-023fd7919a4a", "assumed": true, "ascendantuuid": "919c64ed-015d-4a71-9287-69f554378b69", "descendantuuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '67f93c8d-a31d-4d14-ad7a-6bae4f8202e8', 'INSERT', '{"uuid": "67f93c8d-a31d-4d14-ad7a-6bae4f8202e8", "roletype": "REFERRER", "objectuuid": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', 'a8ca5cc1-5e21-4837-9f78-bc4f8aed2d4d', 'INSERT', '{"op": "SELECT", "uuid": "a8ca5cc1-5e21-4837-9f78-bc4f8aed2d4d", "objectuuid": "e2dd08d5-2083-44ef-bf22-57898af08e3e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '35138f25-fa9f-411b-bbf9-ea90747ec053', 'INSERT', '{"uuid": "35138f25-fa9f-411b-bbf9-ea90747ec053", "assumed": true, "ascendantuuid": "67f93c8d-a31d-4d14-ad7a-6bae4f8202e8", "descendantuuid": "a8ca5cc1-5e21-4837-9f78-bc4f8aed2d4d", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '88d0fcab-468c-434d-bba5-b8ea58e367cf', 'INSERT', '{"uuid": "88d0fcab-468c-434d-bba5-b8ea58e367cf", "assumed": true, "ascendantuuid": "fdfd2976-fc7d-422e-8b5f-91f401927b18", "descendantuuid": "67f93c8d-a31d-4d14-ad7a-6bae4f8202e8", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '36714b48-ab50-4ca0-b817-643b3b724da1', 'INSERT', '{"uuid": "36714b48-ab50-4ca0-b817-643b3b724da1", "assumed": true, "ascendantuuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "descendantuuid": "67f93c8d-a31d-4d14-ad7a-6bae4f8202e8", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'f43465dc-80e3-42d4-8f70-2e081827f14f', 'INSERT', '{"uuid": "f43465dc-80e3-42d4-8f70-2e081827f14f", "assumed": true, "ascendantuuid": "919c64ed-015d-4a71-9287-69f554378b69", "descendantuuid": "67f93c8d-a31d-4d14-ad7a-6bae4f8202e8", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '12a8f987-2cca-4849-84e9-ab90c5e17815', 'INSERT', '{"uuid": "12a8f987-2cca-4849-84e9-ab90c5e17815", "assumed": true, "ascendantuuid": "67f93c8d-a31d-4d14-ad7a-6bae4f8202e8", "descendantuuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "grantedbyroleuuid": null, "grantedbytriggerof": "e2dd08d5-2083-44ef-bf22-57898af08e3e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', 'eb40ed40-ebf5-401a-b498-ecc46928a17d', 'INSERT', '{"uuid": "eb40ed40-ebf5-401a-b498-ecc46928a17d", "serialid": 288, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'hs_office.sepamandate', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', 'INSERT', '{"uuid": "e2dd08d5-2083-44ef-bf22-57898af08e3e", "version": 0, "validity": "[2004-01-20,2005-06-28)", "agreement": "2004-01-15", "reference": "JM33344", "debitoruuid": "84d4763e-0133-4d81-946b-fb64d1a3fd26", "bankaccountuuid": "0bae3550-be89-4c0e-9ba4-01bae0419be0"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.object', '51a4690c-bb0e-4be2-a285-31552f900db6', 'INSERT', '{"uuid": "51a4690c-bb0e-4be2-a285-31552f900db6", "serialid": 277, "objecttable": "hs_office.sepamandate"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'a48e5290-7207-469f-85ea-c5f5b2150d1f', 'INSERT', '{"uuid": "a48e5290-7207-469f-85ea-c5f5b2150d1f", "roletype": "OWNER", "objectuuid": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '74d9ec93-6755-4198-bba3-b900d1391ddf', 'INSERT', '{"op": "DELETE", "uuid": "74d9ec93-6755-4198-bba3-b900d1391ddf", "objectuuid": "51a4690c-bb0e-4be2-a285-31552f900db6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '57902b9d-783f-4a58-9f83-6224b3f4a6bc', 'INSERT', '{"uuid": "57902b9d-783f-4a58-9f83-6224b3f4a6bc", "assumed": true, "ascendantuuid": "a48e5290-7207-469f-85ea-c5f5b2150d1f", "descendantuuid": "74d9ec93-6755-4198-bba3-b900d1391ddf", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'dcf355cc-ab44-4b22-a55e-d5f99b85af29', 'INSERT', '{"uuid": "dcf355cc-ab44-4b22-a55e-d5f99b85af29", "assumed": true, "ascendantuuid": "ce47754e-0d06-4b12-bc91-8034a4a046e7", "descendantuuid": "a48e5290-7207-469f-85ea-c5f5b2150d1f", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '8f7b7ef3-16bc-4304-9b94-3db035baaed1', 'INSERT', '{"uuid": "8f7b7ef3-16bc-4304-9b94-3db035baaed1", "assumed": true, "ascendantuuid": "3706fd53-e952-408a-aedd-93ec6d5129be", "descendantuuid": "a48e5290-7207-469f-85ea-c5f5b2150d1f", "grantedbyroleuuid": "a48e5290-7207-469f-85ea-c5f5b2150d1f", "grantedbytriggerof": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '39c84db0-c0b8-48bc-9602-f6371fee499b', 'INSERT', '{"uuid": "39c84db0-c0b8-48bc-9602-f6371fee499b", "roletype": "ADMIN", "objectuuid": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '9cf52144-7c0c-4031-a0dc-b5f7d0581115', 'INSERT', '{"op": "UPDATE", "uuid": "9cf52144-7c0c-4031-a0dc-b5f7d0581115", "objectuuid": "51a4690c-bb0e-4be2-a285-31552f900db6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'f994f54c-8f7c-4507-9b4e-4544c14c0ad0', 'INSERT', '{"uuid": "f994f54c-8f7c-4507-9b4e-4544c14c0ad0", "assumed": true, "ascendantuuid": "39c84db0-c0b8-48bc-9602-f6371fee499b", "descendantuuid": "9cf52144-7c0c-4031-a0dc-b5f7d0581115", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '258ddb5c-2b75-40b9-8898-b9c627298806', 'INSERT', '{"uuid": "258ddb5c-2b75-40b9-8898-b9c627298806", "assumed": true, "ascendantuuid": "a48e5290-7207-469f-85ea-c5f5b2150d1f", "descendantuuid": "39c84db0-c0b8-48bc-9602-f6371fee499b", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', 'a9998fe5-2760-4309-a904-8e4f6787110e', 'INSERT', '{"uuid": "a9998fe5-2760-4309-a904-8e4f6787110e", "roletype": "AGENT", "objectuuid": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '9717685f-d479-46d1-885a-4cb17a430342', 'INSERT', '{"uuid": "9717685f-d479-46d1-885a-4cb17a430342", "assumed": true, "ascendantuuid": "39c84db0-c0b8-48bc-9602-f6371fee499b", "descendantuuid": "a9998fe5-2760-4309-a904-8e4f6787110e", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '7ec462f2-83f8-42de-af55-8b6b5e2de3f4', 'INSERT', '{"uuid": "7ec462f2-83f8-42de-af55-8b6b5e2de3f4", "assumed": true, "ascendantuuid": "a9998fe5-2760-4309-a904-8e4f6787110e", "descendantuuid": "edf9d085-dbfc-4e3a-9f0e-9eb407423ff6", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '204b62fa-20c9-47bd-bf32-ff24d7fb7ffb', 'INSERT', '{"uuid": "204b62fa-20c9-47bd-bf32-ff24d7fb7ffb", "assumed": true, "ascendantuuid": "a9998fe5-2760-4309-a904-8e4f6787110e", "descendantuuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.role', '81268148-75ff-467a-8d73-b8e4f734d83c', 'INSERT', '{"uuid": "81268148-75ff-467a-8d73-b8e4f734d83c", "roletype": "REFERRER", "objectuuid": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.permission', '7878934b-1841-4918-85e7-ce853fe8fdba', 'INSERT', '{"op": "SELECT", "uuid": "7878934b-1841-4918-85e7-ce853fe8fdba", "objectuuid": "51a4690c-bb0e-4be2-a285-31552f900db6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'bc6d5658-ce6e-4b26-871d-1ccc1df07c6d', 'INSERT', '{"uuid": "bc6d5658-ce6e-4b26-871d-1ccc1df07c6d", "assumed": true, "ascendantuuid": "81268148-75ff-467a-8d73-b8e4f734d83c", "descendantuuid": "7878934b-1841-4918-85e7-ce853fe8fdba", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '60a9ee92-68f5-4335-8ce4-67107e5309ed', 'INSERT', '{"uuid": "60a9ee92-68f5-4335-8ce4-67107e5309ed", "assumed": true, "ascendantuuid": "e9daa877-1886-48db-abab-5516000c4d8e", "descendantuuid": "81268148-75ff-467a-8d73-b8e4f734d83c", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '79d673f7-e093-49c4-8cab-fcd4a340c39c', 'INSERT', '{"uuid": "79d673f7-e093-49c4-8cab-fcd4a340c39c", "assumed": true, "ascendantuuid": "6f90fa6f-da1f-41aa-a74e-bd06ef60f48b", "descendantuuid": "81268148-75ff-467a-8d73-b8e4f734d83c", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', 'dab64a81-9b1f-4c93-9a53-13a4f4b2c022', 'INSERT', '{"uuid": "dab64a81-9b1f-4c93-9a53-13a4f4b2c022", "assumed": true, "ascendantuuid": "a9998fe5-2760-4309-a904-8e4f6787110e", "descendantuuid": "81268148-75ff-467a-8d73-b8e4f734d83c", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'rbac.grant', '74fe3b51-2a5a-4d27-a527-6efdd14214fb', 'INSERT', '{"uuid": "74fe3b51-2a5a-4d27-a527-6efdd14214fb", "assumed": true, "ascendantuuid": "81268148-75ff-467a-8d73-b8e4f734d83c", "descendantuuid": "42f0c634-d86b-4129-822b-f103cd6e0755", "grantedbyroleuuid": null, "grantedbytriggerof": "51a4690c-bb0e-4be2-a285-31552f900db6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2165', 'hs_office.sepamandate', '51a4690c-bb0e-4be2-a285-31552f900db6', 'INSERT', '{"uuid": "51a4690c-bb0e-4be2-a285-31552f900db6", "version": 0, "validity": "[2005-07-01,)", "agreement": "2005-06-28", "reference": "JM33344", "debitoruuid": "84d4763e-0133-4d81-946b-fb64d1a3fd26", "bankaccountuuid": "f3140f7e-5045-4534-92aa-e918895bfafb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', '925e61ee-5120-4205-b609-18083af2c4d6', 'INSERT', '{"uuid": "925e61ee-5120-4205-b609-18083af2c4d6", "serialid": 278, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '18630744-5484-4f55-94a4-15b6f8a8c791', 'INSERT', '{"op": "SELECT", "uuid": "18630744-5484-4f55-94a4-15b6f8a8c791", "objectuuid": "925e61ee-5120-4205-b609-18083af2c4d6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '67eb1bec-83ec-4876-aa00-5c13ee29717f', 'INSERT', '{"uuid": "67eb1bec-83ec-4876-aa00-5c13ee29717f", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "18630744-5484-4f55-94a4-15b6f8a8c791", "grantedbyroleuuid": null, "grantedbytriggerof": "925e61ee-5120-4205-b609-18083af2c4d6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '7e2d1a3e-03f8-463c-9300-7e0b9bfd0eb5', 'INSERT', '{"op": "UPDATE", "uuid": "7e2d1a3e-03f8-463c-9300-7e0b9bfd0eb5", "objectuuid": "925e61ee-5120-4205-b609-18083af2c4d6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'f7036040-6df9-44df-a4a4-40b8065234b3', 'INSERT', '{"op": "SELECT", "uuid": "f7036040-6df9-44df-a4a4-40b8065234b3", "objectuuid": "eb40ed40-ebf5-401a-b498-ecc46928a17d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '7d7eb6df-a1e5-417d-b885-010094347b53', 'INSERT', '{"uuid": "7d7eb6df-a1e5-417d-b885-010094347b53", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "7e2d1a3e-03f8-463c-9300-7e0b9bfd0eb5", "grantedbyroleuuid": null, "grantedbytriggerof": "925e61ee-5120-4205-b609-18083af2c4d6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', '925e61ee-5120-4205-b609-18083af2c4d6', 'INSERT', '{"uuid": "925e61ee-5120-4205-b609-18083af2c4d6", "comment": "initial share subscription", "version": 0, "reference": "1000300", "valuedate": "2000-12-06", "sharecount": 80, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', '76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9', 'INSERT', '{"uuid": "76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9", "serialid": 279, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '23115d61-dd0d-4545-8240-2415ab603868', 'INSERT', '{"op": "SELECT", "uuid": "23115d61-dd0d-4545-8240-2415ab603868", "objectuuid": "76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '3a7f512f-841d-42c1-a380-b04e86d9220f', 'INSERT', '{"uuid": "3a7f512f-841d-42c1-a380-b04e86d9220f", "assumed": true, "ascendantuuid": "5fd54e69-2513-4413-95d6-dde58ed6d8ae", "descendantuuid": "23115d61-dd0d-4545-8240-2415ab603868", "grantedbyroleuuid": null, "grantedbytriggerof": "76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '4b8fc5ce-2f77-43cc-8c11-caefef50e9e0', 'INSERT', '{"op": "UPDATE", "uuid": "4b8fc5ce-2f77-43cc-8c11-caefef50e9e0", "objectuuid": "76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '6422bf87-17e1-4a44-8620-369cdb981f46', 'INSERT', '{"uuid": "6422bf87-17e1-4a44-8620-369cdb981f46", "assumed": true, "ascendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "descendantuuid": "4b8fc5ce-2f77-43cc-8c11-caefef50e9e0", "grantedbyroleuuid": null, "grantedbytriggerof": "76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', '76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9', 'INSERT', '{"uuid": "76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9", "comment": "", "version": 0, "reference": "1015200", "valuedate": "2003-07-12", "sharecount": 1, "membershipuuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', 'e27e543b-f15b-4e0b-98fc-ce72bcd5d258', 'INSERT', '{"uuid": "e27e543b-f15b-4e0b-98fc-ce72bcd5d258", "serialid": 280, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '7ba7e7db-d2a0-4d8a-a982-4b592a6519d3', 'INSERT', '{"op": "SELECT", "uuid": "7ba7e7db-d2a0-4d8a-a982-4b592a6519d3", "objectuuid": "e27e543b-f15b-4e0b-98fc-ce72bcd5d258", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'daa6daef-4605-4ff7-8092-8ce36182aecd', 'INSERT', '{"uuid": "daa6daef-4605-4ff7-8092-8ce36182aecd", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "7ba7e7db-d2a0-4d8a-a982-4b592a6519d3", "grantedbyroleuuid": null, "grantedbytriggerof": "e27e543b-f15b-4e0b-98fc-ce72bcd5d258"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '28a1da29-5665-4481-be2c-23484fede329', 'INSERT', '{"op": "UPDATE", "uuid": "28a1da29-5665-4481-be2c-23484fede329", "objectuuid": "e27e543b-f15b-4e0b-98fc-ce72bcd5d258", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'af304e37-6161-49b4-a07f-9d2ff0fc83e8', 'INSERT', '{"uuid": "af304e37-6161-49b4-a07f-9d2ff0fc83e8", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "28a1da29-5665-4481-be2c-23484fede329", "grantedbyroleuuid": null, "grantedbytriggerof": "e27e543b-f15b-4e0b-98fc-ce72bcd5d258"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', 'e27e543b-f15b-4e0b-98fc-ce72bcd5d258', 'INSERT', '{"uuid": "e27e543b-f15b-4e0b-98fc-ce72bcd5d258", "comment": "", "version": 0, "reference": "1000300", "valuedate": "2011-12-05", "sharecount": 16, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', 'd9c28f32-a87e-4f2e-af07-75a76004907b', 'INSERT', '{"uuid": "d9c28f32-a87e-4f2e-af07-75a76004907b", "serialid": 281, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'ad772eba-1cc4-4973-b407-ee1292c8cefb', 'INSERT', '{"op": "SELECT", "uuid": "ad772eba-1cc4-4973-b407-ee1292c8cefb", "objectuuid": "d9c28f32-a87e-4f2e-af07-75a76004907b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '200fb76f-7c36-4210-916c-6cc3770a8e20', 'INSERT', '{"uuid": "200fb76f-7c36-4210-916c-6cc3770a8e20", "assumed": true, "ascendantuuid": "5fd54e69-2513-4413-95d6-dde58ed6d8ae", "descendantuuid": "ad772eba-1cc4-4973-b407-ee1292c8cefb", "grantedbyroleuuid": null, "grantedbytriggerof": "d9c28f32-a87e-4f2e-af07-75a76004907b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '2b1bd996-ed42-4b6f-941f-a02115b5c49c', 'INSERT', '{"op": "UPDATE", "uuid": "2b1bd996-ed42-4b6f-941f-a02115b5c49c", "objectuuid": "d9c28f32-a87e-4f2e-af07-75a76004907b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'd7bf8f19-245f-407c-a279-8c6a8ac4cb4d', 'INSERT', '{"uuid": "d7bf8f19-245f-407c-a279-8c6a8ac4cb4d", "assumed": true, "ascendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "descendantuuid": "2b1bd996-ed42-4b6f-941f-a02115b5c49c", "grantedbyroleuuid": null, "grantedbytriggerof": "d9c28f32-a87e-4f2e-af07-75a76004907b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', 'd9c28f32-a87e-4f2e-af07-75a76004907b', 'INSERT', '{"uuid": "d9c28f32-a87e-4f2e-af07-75a76004907b", "comment": "", "version": 0, "reference": "1015200", "valuedate": "2013-10-21", "sharecount": 1, "membershipuuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', 'b0a9b8a6-8709-4210-b4ad-eadcab6f7866', 'INSERT', '{"uuid": "b0a9b8a6-8709-4210-b4ad-eadcab6f7866", "serialid": 282, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '114ce5a9-0704-4f91-98d1-7f4f2e6d6ac3', 'INSERT', '{"op": "SELECT", "uuid": "114ce5a9-0704-4f91-98d1-7f4f2e6d6ac3", "objectuuid": "b0a9b8a6-8709-4210-b4ad-eadcab6f7866", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'dbcc10e6-1f85-4e5b-b8f1-d30aae66e623', 'INSERT', '{"uuid": "dbcc10e6-1f85-4e5b-b8f1-d30aae66e623", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "114ce5a9-0704-4f91-98d1-7f4f2e6d6ac3", "grantedbyroleuuid": null, "grantedbytriggerof": "b0a9b8a6-8709-4210-b4ad-eadcab6f7866"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '9532739f-1149-42ed-bb1d-cac1d14d4380', 'INSERT', '{"op": "UPDATE", "uuid": "9532739f-1149-42ed-bb1d-cac1d14d4380", "objectuuid": "b0a9b8a6-8709-4210-b4ad-eadcab6f7866", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '5fc992c1-6639-471a-87a4-a80a0896e70c', 'INSERT', '{"uuid": "5fc992c1-6639-471a-87a4-a80a0896e70c", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "9532739f-1149-42ed-bb1d-cac1d14d4380", "grantedbyroleuuid": null, "grantedbytriggerof": "b0a9b8a6-8709-4210-b4ad-eadcab6f7866"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', 'b0a9b8a6-8709-4210-b4ad-eadcab6f7866', 'INSERT', '{"uuid": "b0a9b8a6-8709-4210-b4ad-eadcab6f7866", "comment": "Kapitalerhoehung", "version": 0, "reference": "1000300", "valuedate": "2020-12-08", "sharecount": 96, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', 'd3e130d9-9288-4d74-8699-1778d2f5c151', 'INSERT', '{"uuid": "d3e130d9-9288-4d74-8699-1778d2f5c151", "serialid": 283, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '04a9b874-65cc-460a-83be-47366ec3c35e', 'INSERT', '{"op": "SELECT", "uuid": "04a9b874-65cc-460a-83be-47366ec3c35e", "objectuuid": "d3e130d9-9288-4d74-8699-1778d2f5c151", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'f246d972-475b-4606-ac2f-94c0d79db3ff', 'INSERT', '{"uuid": "f246d972-475b-4606-ac2f-94c0d79db3ff", "assumed": true, "ascendantuuid": "81aefd8d-c7aa-48a5-869f-1df15b4b68ae", "descendantuuid": "04a9b874-65cc-460a-83be-47366ec3c35e", "grantedbyroleuuid": null, "grantedbytriggerof": "d3e130d9-9288-4d74-8699-1778d2f5c151"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'fac002b1-7dd0-4def-9c60-ce441ae74bf0', 'INSERT', '{"op": "UPDATE", "uuid": "fac002b1-7dd0-4def-9c60-ce441ae74bf0", "objectuuid": "d3e130d9-9288-4d74-8699-1778d2f5c151", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '339606b6-0f4d-412a-8fcf-c23c49cb362b', 'INSERT', '{"uuid": "339606b6-0f4d-412a-8fcf-c23c49cb362b", "assumed": true, "ascendantuuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "descendantuuid": "fac002b1-7dd0-4def-9c60-ce441ae74bf0", "grantedbyroleuuid": null, "grantedbytriggerof": "d3e130d9-9288-4d74-8699-1778d2f5c151"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', 'd3e130d9-9288-4d74-8699-1778d2f5c151', 'INSERT', '{"uuid": "d3e130d9-9288-4d74-8699-1778d2f5c151", "comment": "Beitritt", "version": 0, "reference": "1101800", "valuedate": "2021-05-17", "sharecount": 4, "membershipuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', '110138a4-46e3-418b-8ce2-095da9c6b98c', 'INSERT', '{"uuid": "110138a4-46e3-418b-8ce2-095da9c6b98c", "serialid": 284, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'd0c2aec5-df1e-4a43-accc-292636a196ee', 'INSERT', '{"op": "SELECT", "uuid": "d0c2aec5-df1e-4a43-accc-292636a196ee", "objectuuid": "110138a4-46e3-418b-8ce2-095da9c6b98c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'cef6afa7-a6d2-4100-8d23-55559217b4b5', 'INSERT', '{"uuid": "cef6afa7-a6d2-4100-8d23-55559217b4b5", "assumed": true, "ascendantuuid": "08c7995c-a7e7-4093-8aa0-6e6e8449f1e4", "descendantuuid": "d0c2aec5-df1e-4a43-accc-292636a196ee", "grantedbyroleuuid": null, "grantedbytriggerof": "110138a4-46e3-418b-8ce2-095da9c6b98c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'c16db138-0d91-44b1-bd5a-b8361d1773a6', 'INSERT', '{"op": "UPDATE", "uuid": "c16db138-0d91-44b1-bd5a-b8361d1773a6", "objectuuid": "110138a4-46e3-418b-8ce2-095da9c6b98c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'faf97694-ad24-4965-9e64-432da96eb398', 'INSERT', '{"uuid": "faf97694-ad24-4965-9e64-432da96eb398", "assumed": true, "ascendantuuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "descendantuuid": "c16db138-0d91-44b1-bd5a-b8361d1773a6", "grantedbyroleuuid": null, "grantedbytriggerof": "110138a4-46e3-418b-8ce2-095da9c6b98c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', '110138a4-46e3-418b-8ce2-095da9c6b98c', 'INSERT', '{"uuid": "110138a4-46e3-418b-8ce2-095da9c6b98c", "comment": "Beitritt", "version": 0, "reference": "1101900", "valuedate": "2021-05-25", "sharecount": 1, "membershipuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', '0565d216-af16-45aa-86e5-9ca55751322f', 'INSERT', '{"uuid": "0565d216-af16-45aa-86e5-9ca55751322f", "serialid": 285, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'b299282d-1cfc-41b1-8936-2dcbfe1017ca', 'INSERT', '{"op": "SELECT", "uuid": "b299282d-1cfc-41b1-8936-2dcbfe1017ca", "objectuuid": "0565d216-af16-45aa-86e5-9ca55751322f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '2d664d49-5717-4a5f-a4f5-ec7743b5710b', 'INSERT', '{"uuid": "2d664d49-5717-4a5f-a4f5-ec7743b5710b", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "b299282d-1cfc-41b1-8936-2dcbfe1017ca", "grantedbyroleuuid": null, "grantedbytriggerof": "0565d216-af16-45aa-86e5-9ca55751322f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'bb211784-8f68-44ff-833c-3f501a33ad0f', 'INSERT', '{"op": "UPDATE", "uuid": "bb211784-8f68-44ff-833c-3f501a33ad0f", "objectuuid": "0565d216-af16-45aa-86e5-9ca55751322f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '53fb7a01-cb8a-496e-a74b-c18aead55996', 'INSERT', '{"uuid": "53fb7a01-cb8a-496e-a74b-c18aead55996", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "bb211784-8f68-44ff-833c-3f501a33ad0f", "grantedbyroleuuid": null, "grantedbytriggerof": "0565d216-af16-45aa-86e5-9ca55751322f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', '0565d216-af16-45aa-86e5-9ca55751322f', 'INSERT', '{"uuid": "0565d216-af16-45aa-86e5-9ca55751322f", "comment": "Kapitalerhoehung", "version": 0, "reference": "1000300", "valuedate": "2023-10-10", "sharecount": 96, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', 'c7d34de2-7cbd-480a-9ce5-a574ef7248d8', 'INSERT', '{"uuid": "c7d34de2-7cbd-480a-9ce5-a574ef7248d8", "serialid": 286, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'd80e22b5-9ba3-4ad6-a392-fddaa4a5532e', 'INSERT', '{"op": "SELECT", "uuid": "d80e22b5-9ba3-4ad6-a392-fddaa4a5532e", "objectuuid": "c7d34de2-7cbd-480a-9ce5-a574ef7248d8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'cf757bfb-f62d-42be-8bd3-cb2dfe1a9b3d', 'INSERT', '{"uuid": "cf757bfb-f62d-42be-8bd3-cb2dfe1a9b3d", "assumed": true, "ascendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "descendantuuid": "d80e22b5-9ba3-4ad6-a392-fddaa4a5532e", "grantedbyroleuuid": null, "grantedbytriggerof": "c7d34de2-7cbd-480a-9ce5-a574ef7248d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '2afe8e61-bfb1-44c3-8685-bb5390e9ffa9', 'INSERT', '{"op": "UPDATE", "uuid": "2afe8e61-bfb1-44c3-8685-bb5390e9ffa9", "objectuuid": "c7d34de2-7cbd-480a-9ce5-a574ef7248d8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '242bbed6-71bd-47d7-a1a5-1cf3495c0366', 'INSERT', '{"uuid": "242bbed6-71bd-47d7-a1a5-1cf3495c0366", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "2afe8e61-bfb1-44c3-8685-bb5390e9ffa9", "grantedbyroleuuid": null, "grantedbytriggerof": "c7d34de2-7cbd-480a-9ce5-a574ef7248d8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', 'c7d34de2-7cbd-480a-9ce5-a574ef7248d8', 'INSERT', '{"uuid": "c7d34de2-7cbd-480a-9ce5-a574ef7248d8", "comment": "initial share subscription", "version": 0, "reference": "1002000", "valuedate": "2000-12-06", "sharecount": 2, "membershipuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.object', '147820f5-533d-471d-9f54-99e087ec37c6', 'INSERT', '{"uuid": "147820f5-533d-471d-9f54-99e087ec37c6", "serialid": 287, "objecttable": "hs_office.coopsharetx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'd1fb0181-59a4-4c35-a6da-9c4c8c420f4b', 'INSERT', '{"op": "SELECT", "uuid": "d1fb0181-59a4-4c35-a6da-9c4c8c420f4b", "objectuuid": "147820f5-533d-471d-9f54-99e087ec37c6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'dcca4c69-4263-4bb9-a811-e6d89c8c3ecd', 'INSERT', '{"uuid": "dcca4c69-4263-4bb9-a811-e6d89c8c3ecd", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "d1fb0181-59a4-4c35-a6da-9c4c8c420f4b", "grantedbyroleuuid": null, "grantedbytriggerof": "147820f5-533d-471d-9f54-99e087ec37c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', '7f04b4ff-ce51-4c25-b924-eda9c80beab9', 'INSERT', '{"op": "UPDATE", "uuid": "7f04b4ff-ce51-4c25-b924-eda9c80beab9", "objectuuid": "147820f5-533d-471d-9f54-99e087ec37c6", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '4201e516-0d85-43c6-934e-41980b5f07a6', 'INSERT', '{"uuid": "4201e516-0d85-43c6-934e-41980b5f07a6", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "7f04b4ff-ce51-4c25-b924-eda9c80beab9", "grantedbyroleuuid": null, "grantedbytriggerof": "147820f5-533d-471d-9f54-99e087ec37c6"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', '147820f5-533d-471d-9f54-99e087ec37c6', 'INSERT', '{"uuid": "147820f5-533d-471d-9f54-99e087ec37c6", "comment": "increase", "version": 0, "reference": "1000300", "valuedate": "2005-01-10", "sharecount": 40, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "SUBSCRIPTION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', 'a710ad6d-cc4f-4a1a-8cd8-09eae7e33591', 'INSERT', '{"uuid": "a710ad6d-cc4f-4a1a-8cd8-09eae7e33591", "assumed": true, "ascendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "descendantuuid": "f7036040-6df9-44df-a4a4-40b8065234b3", "grantedbyroleuuid": null, "grantedbytriggerof": "eb40ed40-ebf5-401a-b498-ecc46928a17d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.permission', 'aa8c9c0b-ac3d-4fe4-85ee-22876b77a346', 'INSERT', '{"op": "UPDATE", "uuid": "aa8c9c0b-ac3d-4fe4-85ee-22876b77a346", "objectuuid": "eb40ed40-ebf5-401a-b498-ecc46928a17d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'rbac.grant', '00ddbf09-cee4-4880-a4c7-3dfe2c7b831a', 'INSERT', '{"uuid": "00ddbf09-cee4-4880-a4c7-3dfe2c7b831a", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "aa8c9c0b-ac3d-4fe4-85ee-22876b77a346", "grantedbyroleuuid": null, "grantedbytriggerof": "eb40ed40-ebf5-401a-b498-ecc46928a17d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2187', 'hs_office.coopsharetx', 'eb40ed40-ebf5-401a-b498-ecc46928a17d', 'INSERT', '{"uuid": "eb40ed40-ebf5-401a-b498-ecc46928a17d", "comment": "membership ended", "version": 0, "reference": "1002000", "valuedate": "2016-12-31", "sharecount": 22, "membershipuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "transactiontype": "CANCELLATION", "revertedsharetxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', 'f9c724b4-3965-4cfa-bc93-5b780b2362e7', 'INSERT', '{"uuid": "f9c724b4-3965-4cfa-bc93-5b780b2362e7", "serialid": 289, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '5612b460-e9f4-4c7f-8f30-fabca1954260', 'INSERT', '{"op": "SELECT", "uuid": "5612b460-e9f4-4c7f-8f30-fabca1954260", "objectuuid": "f9c724b4-3965-4cfa-bc93-5b780b2362e7", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'c863aeb6-d294-4b38-9cb5-a746d88ae3bb', 'INSERT', '{"uuid": "c863aeb6-d294-4b38-9cb5-a746d88ae3bb", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "5612b460-e9f4-4c7f-8f30-fabca1954260", "grantedbyroleuuid": null, "grantedbytriggerof": "f9c724b4-3965-4cfa-bc93-5b780b2362e7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '793d3808-9277-4bc1-b39e-46fd0b5028d1', 'INSERT', '{"op": "UPDATE", "uuid": "793d3808-9277-4bc1-b39e-46fd0b5028d1", "objectuuid": "f9c724b4-3965-4cfa-bc93-5b780b2362e7", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '9b17f569-8476-4251-a789-cfb74e3d3f98', 'INSERT', '{"uuid": "9b17f569-8476-4251-a789-cfb74e3d3f98", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "793d3808-9277-4bc1-b39e-46fd0b5028d1", "grantedbyroleuuid": null, "grantedbytriggerof": "f9c724b4-3965-4cfa-bc93-5b780b2362e7"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', 'f9c724b4-3965-4cfa-bc93-5b780b2362e7', 'INSERT', '{"uuid": "f9c724b4-3965-4cfa-bc93-5b780b2362e7", "comment": "for subscription A", "version": 0, "reference": "1000300", "valuedate": "2000-12-06", "assetvalue": 5120.00, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '1b444a8f-352d-4812-97aa-bd1e649201f8', 'INSERT', '{"uuid": "1b444a8f-352d-4812-97aa-bd1e649201f8", "serialid": 290, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'a46e7e72-094a-4677-a2ba-b027e117c814', 'INSERT', '{"op": "SELECT", "uuid": "a46e7e72-094a-4677-a2ba-b027e117c814", "objectuuid": "1b444a8f-352d-4812-97aa-bd1e649201f8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'bbde51c9-e683-4ff4-a012-a554ae9bf2bb', 'INSERT', '{"uuid": "bbde51c9-e683-4ff4-a012-a554ae9bf2bb", "assumed": true, "ascendantuuid": "5fd54e69-2513-4413-95d6-dde58ed6d8ae", "descendantuuid": "a46e7e72-094a-4677-a2ba-b027e117c814", "grantedbyroleuuid": null, "grantedbytriggerof": "1b444a8f-352d-4812-97aa-bd1e649201f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '34608829-3d7a-475c-b734-f3692e102b82', 'INSERT', '{"op": "UPDATE", "uuid": "34608829-3d7a-475c-b734-f3692e102b82", "objectuuid": "1b444a8f-352d-4812-97aa-bd1e649201f8", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '6e566df6-3722-4285-b7c9-529dae12bf44', 'INSERT', '{"uuid": "6e566df6-3722-4285-b7c9-529dae12bf44", "assumed": true, "ascendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "descendantuuid": "34608829-3d7a-475c-b734-f3692e102b82", "grantedbyroleuuid": null, "grantedbytriggerof": "1b444a8f-352d-4812-97aa-bd1e649201f8"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '1b444a8f-352d-4812-97aa-bd1e649201f8', 'INSERT', '{"uuid": "1b444a8f-352d-4812-97aa-bd1e649201f8", "comment": "", "version": 0, "reference": "1015200", "valuedate": "2003-07-07", "assetvalue": 64.00, "membershipuuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '2b1590f1-c1b8-4318-9879-8e2d898fa4a5', 'INSERT', '{"uuid": "2b1590f1-c1b8-4318-9879-8e2d898fa4a5", "serialid": 291, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '176b447d-ce47-44da-8219-a00244a3d5e0', 'INSERT', '{"op": "SELECT", "uuid": "176b447d-ce47-44da-8219-a00244a3d5e0", "objectuuid": "2b1590f1-c1b8-4318-9879-8e2d898fa4a5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'bfc8f1bb-1257-42d3-aeb9-dff5b7f3b217', 'INSERT', '{"uuid": "bfc8f1bb-1257-42d3-aeb9-dff5b7f3b217", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "176b447d-ce47-44da-8219-a00244a3d5e0", "grantedbyroleuuid": null, "grantedbytriggerof": "2b1590f1-c1b8-4318-9879-8e2d898fa4a5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '22500be4-6daf-4c50-9120-a4d0c6491720', 'INSERT', '{"op": "UPDATE", "uuid": "22500be4-6daf-4c50-9120-a4d0c6491720", "objectuuid": "2b1590f1-c1b8-4318-9879-8e2d898fa4a5", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '0037af31-dbef-4d05-b8de-d96df9a4823c', 'INSERT', '{"uuid": "0037af31-dbef-4d05-b8de-d96df9a4823c", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "22500be4-6daf-4c50-9120-a4d0c6491720", "grantedbyroleuuid": null, "grantedbytriggerof": "2b1590f1-c1b8-4318-9879-8e2d898fa4a5"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '2b1590f1-c1b8-4318-9879-8e2d898fa4a5', 'INSERT', '{"uuid": "2b1590f1-c1b8-4318-9879-8e2d898fa4a5", "comment": "", "version": 0, "reference": "1000300", "valuedate": "2011-12-12", "assetvalue": 1024.00, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '0f05f1bd-403c-4239-8595-d317bba58a32', 'INSERT', '{"uuid": "0f05f1bd-403c-4239-8595-d317bba58a32", "serialid": 292, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'c772675e-39bf-48b0-b10a-1a2ff065c3a6', 'INSERT', '{"op": "SELECT", "uuid": "c772675e-39bf-48b0-b10a-1a2ff065c3a6", "objectuuid": "0f05f1bd-403c-4239-8595-d317bba58a32", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '76d8fb6c-b943-48ad-881b-2e2bd0fa4a76', 'INSERT', '{"uuid": "76d8fb6c-b943-48ad-881b-2e2bd0fa4a76", "assumed": true, "ascendantuuid": "5fd54e69-2513-4413-95d6-dde58ed6d8ae", "descendantuuid": "c772675e-39bf-48b0-b10a-1a2ff065c3a6", "grantedbyroleuuid": null, "grantedbytriggerof": "0f05f1bd-403c-4239-8595-d317bba58a32"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'b096450c-b5aa-4a9e-9b80-8633ca2243a4', 'INSERT', '{"op": "UPDATE", "uuid": "b096450c-b5aa-4a9e-9b80-8633ca2243a4", "objectuuid": "0f05f1bd-403c-4239-8595-d317bba58a32", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '57a68c1c-1fc9-4739-b67d-f61282cd36f1', 'INSERT', '{"uuid": "57a68c1c-1fc9-4739-b67d-f61282cd36f1", "assumed": true, "ascendantuuid": "9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772", "descendantuuid": "b096450c-b5aa-4a9e-9b80-8633ca2243a4", "grantedbyroleuuid": null, "grantedbytriggerof": "0f05f1bd-403c-4239-8595-d317bba58a32"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '96383615-0c59-4cc9-9292-723a1c0f4a52', 'INSERT', '{"op": "UPDATE", "uuid": "96383615-0c59-4cc9-9292-723a1c0f4a52", "objectuuid": "9f3ea248-0492-43af-8430-2cbe4ae3338b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '0f05f1bd-403c-4239-8595-d317bba58a32', 'INSERT', '{"uuid": "0f05f1bd-403c-4239-8595-d317bba58a32", "comment": "", "version": 0, "reference": "1015200", "valuedate": "2013-10-21", "assetvalue": 64.00, "membershipuuid": "af682fb0-f06d-4a2b-affb-40487a079a70", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '2cca894b-c08a-4b36-b809-d417cf0b305c', 'INSERT', '{"uuid": "2cca894b-c08a-4b36-b809-d417cf0b305c", "serialid": 293, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '651a87c6-db56-4963-88a5-5dd7b74d53ce', 'INSERT', '{"op": "SELECT", "uuid": "651a87c6-db56-4963-88a5-5dd7b74d53ce", "objectuuid": "2cca894b-c08a-4b36-b809-d417cf0b305c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '693be01f-b73e-4ff2-934c-c8401a2d54b6', 'INSERT', '{"uuid": "693be01f-b73e-4ff2-934c-c8401a2d54b6", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "651a87c6-db56-4963-88a5-5dd7b74d53ce", "grantedbyroleuuid": null, "grantedbytriggerof": "2cca894b-c08a-4b36-b809-d417cf0b305c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'cf345447-6015-474d-9c1f-2fe7b879edf0', 'INSERT', '{"op": "UPDATE", "uuid": "cf345447-6015-474d-9c1f-2fe7b879edf0", "objectuuid": "2cca894b-c08a-4b36-b809-d417cf0b305c", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '4589614b-cdeb-47aa-a747-83ba244d6100', 'INSERT', '{"uuid": "4589614b-cdeb-47aa-a747-83ba244d6100", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "cf345447-6015-474d-9c1f-2fe7b879edf0", "grantedbyroleuuid": null, "grantedbytriggerof": "2cca894b-c08a-4b36-b809-d417cf0b305c"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '2cca894b-c08a-4b36-b809-d417cf0b305c', 'INSERT', '{"uuid": "2cca894b-c08a-4b36-b809-d417cf0b305c", "comment": "Einzahlung", "version": 0, "reference": "1000300", "valuedate": "2020-12-15", "assetvalue": 6144.00, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', 'b4acab9a-7a54-42df-bd35-717f052b407d', 'INSERT', '{"uuid": "b4acab9a-7a54-42df-bd35-717f052b407d", "serialid": 294, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '9654e7cb-b714-4f8d-9a7a-5a2e9dcbe09b', 'INSERT', '{"op": "SELECT", "uuid": "9654e7cb-b714-4f8d-9a7a-5a2e9dcbe09b", "objectuuid": "b4acab9a-7a54-42df-bd35-717f052b407d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '6b78ec2b-56c2-4f95-a57e-4e227ae4c4a9', 'INSERT', '{"uuid": "6b78ec2b-56c2-4f95-a57e-4e227ae4c4a9", "assumed": true, "ascendantuuid": "81aefd8d-c7aa-48a5-869f-1df15b4b68ae", "descendantuuid": "9654e7cb-b714-4f8d-9a7a-5a2e9dcbe09b", "grantedbyroleuuid": null, "grantedbytriggerof": "b4acab9a-7a54-42df-bd35-717f052b407d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '6eb3f2e6-4f80-4ec5-b121-e0e6ab166e6f', 'INSERT', '{"op": "UPDATE", "uuid": "6eb3f2e6-4f80-4ec5-b121-e0e6ab166e6f", "objectuuid": "b4acab9a-7a54-42df-bd35-717f052b407d", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'fcd6e589-bdd7-49c2-a4a4-f1033039ba84', 'INSERT', '{"uuid": "fcd6e589-bdd7-49c2-a4a4-f1033039ba84", "assumed": true, "ascendantuuid": "173a65d3-7eb4-4910-a83f-08ce5ed65583", "descendantuuid": "6eb3f2e6-4f80-4ec5-b121-e0e6ab166e6f", "grantedbyroleuuid": null, "grantedbytriggerof": "b4acab9a-7a54-42df-bd35-717f052b407d"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', 'b4acab9a-7a54-42df-bd35-717f052b407d', 'INSERT', '{"uuid": "b4acab9a-7a54-42df-bd35-717f052b407d", "comment": "Beitritt - Lastschrift", "version": 0, "reference": "1101800", "valuedate": "2021-05-21", "assetvalue": 256.00, "membershipuuid": "ace60d06-0635-4c2c-bb4b-7233c19862fc", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', 'fab99b6c-dd05-451f-a9e7-80891ec94db1', 'INSERT', '{"uuid": "fab99b6c-dd05-451f-a9e7-80891ec94db1", "serialid": 295, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'c7a074b6-6e8b-4570-a8b3-baf483e67c14', 'INSERT', '{"op": "SELECT", "uuid": "c7a074b6-6e8b-4570-a8b3-baf483e67c14", "objectuuid": "fab99b6c-dd05-451f-a9e7-80891ec94db1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '976d530f-a6a7-4ea1-bda1-087b3605a970', 'INSERT', '{"uuid": "976d530f-a6a7-4ea1-bda1-087b3605a970", "assumed": true, "ascendantuuid": "08c7995c-a7e7-4093-8aa0-6e6e8449f1e4", "descendantuuid": "c7a074b6-6e8b-4570-a8b3-baf483e67c14", "grantedbyroleuuid": null, "grantedbytriggerof": "fab99b6c-dd05-451f-a9e7-80891ec94db1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '16c5c51a-6b85-48fc-a19b-b1d0319c414d', 'INSERT', '{"op": "UPDATE", "uuid": "16c5c51a-6b85-48fc-a19b-b1d0319c414d", "objectuuid": "fab99b6c-dd05-451f-a9e7-80891ec94db1", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '59529140-a688-4039-8ca5-9c6bb81e1e5e', 'INSERT', '{"uuid": "59529140-a688-4039-8ca5-9c6bb81e1e5e", "assumed": true, "ascendantuuid": "e4d265c4-fe4a-468d-9cc9-3a77267ddcb3", "descendantuuid": "16c5c51a-6b85-48fc-a19b-b1d0319c414d", "grantedbyroleuuid": null, "grantedbytriggerof": "fab99b6c-dd05-451f-a9e7-80891ec94db1"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', 'fab99b6c-dd05-451f-a9e7-80891ec94db1', 'INSERT', '{"uuid": "fab99b6c-dd05-451f-a9e7-80891ec94db1", "comment": "Beitritt - Lastschrift", "version": 0, "reference": "1101900", "valuedate": "2021-05-31", "assetvalue": 64.00, "membershipuuid": "183d5ad7-4cc1-46c1-8f4e-5d7c24583769", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb', 'INSERT', '{"uuid": "34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb", "serialid": 296, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'ef9747c5-e7b2-4a22-b4cf-cb05c7cc0d6c', 'INSERT', '{"op": "SELECT", "uuid": "ef9747c5-e7b2-4a22-b4cf-cb05c7cc0d6c", "objectuuid": "34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '1c95e864-7f9e-4d8d-a834-225c93cfdc2d', 'INSERT', '{"uuid": "1c95e864-7f9e-4d8d-a834-225c93cfdc2d", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "ef9747c5-e7b2-4a22-b4cf-cb05c7cc0d6c", "grantedbyroleuuid": null, "grantedbytriggerof": "34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'a5de5a65-81f3-482b-baac-4054940ea7b5', 'INSERT', '{"op": "UPDATE", "uuid": "a5de5a65-81f3-482b-baac-4054940ea7b5", "objectuuid": "34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '0b668bc5-920c-4c00-ad0a-752ec371bc25', 'INSERT', '{"uuid": "0b668bc5-920c-4c00-ad0a-752ec371bc25", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "a5de5a65-81f3-482b-baac-4054940ea7b5", "grantedbyroleuuid": null, "grantedbytriggerof": "34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb', 'INSERT', '{"uuid": "34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb", "comment": "Kapitalerhoehung - Ueberweisung", "version": 0, "reference": "1000300", "valuedate": "2023-10-05", "assetvalue": 3072.00, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '9f3ea248-0492-43af-8430-2cbe4ae3338b', 'INSERT', '{"uuid": "9f3ea248-0492-43af-8430-2cbe4ae3338b", "serialid": 297, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'c32e6121-a5fc-4345-b6e6-26eda31d266e', 'INSERT', '{"op": "SELECT", "uuid": "c32e6121-a5fc-4345-b6e6-26eda31d266e", "objectuuid": "9f3ea248-0492-43af-8430-2cbe4ae3338b", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '6e7918ee-dfb7-4d0e-8aba-e0f281e40ecd', 'INSERT', '{"uuid": "6e7918ee-dfb7-4d0e-8aba-e0f281e40ecd", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "c32e6121-a5fc-4345-b6e6-26eda31d266e", "grantedbyroleuuid": null, "grantedbytriggerof": "9f3ea248-0492-43af-8430-2cbe4ae3338b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'c5313615-0a03-4ff3-bd3b-f38fc7bd68f0', 'INSERT', '{"uuid": "c5313615-0a03-4ff3-bd3b-f38fc7bd68f0", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "96383615-0c59-4cc9-9292-723a1c0f4a52", "grantedbyroleuuid": null, "grantedbytriggerof": "9f3ea248-0492-43af-8430-2cbe4ae3338b"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '9f3ea248-0492-43af-8430-2cbe4ae3338b', 'INSERT', '{"uuid": "9f3ea248-0492-43af-8430-2cbe4ae3338b", "comment": "Kapitalerhoehung - Ueberweisung", "version": 0, "reference": "1000300", "valuedate": "2023-10-06", "assetvalue": 3072.00, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '02362331-8069-4712-9c39-371973edb192', 'INSERT', '{"uuid": "02362331-8069-4712-9c39-371973edb192", "serialid": 298, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'db092336-0de9-4c19-b5a7-9f035596b364', 'INSERT', '{"op": "SELECT", "uuid": "db092336-0de9-4c19-b5a7-9f035596b364", "objectuuid": "02362331-8069-4712-9c39-371973edb192", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'e7c0f355-8789-4d74-bd38-6a7f77902823', 'INSERT', '{"uuid": "e7c0f355-8789-4d74-bd38-6a7f77902823", "assumed": true, "ascendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "descendantuuid": "db092336-0de9-4c19-b5a7-9f035596b364", "grantedbyroleuuid": null, "grantedbytriggerof": "02362331-8069-4712-9c39-371973edb192"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '63dd3ba5-db8d-481b-8eb5-ee982522f4d0', 'INSERT', '{"op": "UPDATE", "uuid": "63dd3ba5-db8d-481b-8eb5-ee982522f4d0", "objectuuid": "02362331-8069-4712-9c39-371973edb192", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '4f2835bf-09ce-44c1-8dc7-fe4ff02fc494', 'INSERT', '{"uuid": "4f2835bf-09ce-44c1-8dc7-fe4ff02fc494", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "63dd3ba5-db8d-481b-8eb5-ee982522f4d0", "grantedbyroleuuid": null, "grantedbytriggerof": "02362331-8069-4712-9c39-371973edb192"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '02362331-8069-4712-9c39-371973edb192', 'INSERT', '{"uuid": "02362331-8069-4712-9c39-371973edb192", "comment": "for subscription B", "version": 0, "reference": "1002000", "valuedate": "2000-12-06", "assetvalue": 128.00, "membershipuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '899a89c3-6715-4a37-bb69-1ed124e0a23f', 'INSERT', '{"uuid": "899a89c3-6715-4a37-bb69-1ed124e0a23f", "serialid": 299, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '67f40c40-c638-4350-a11b-951b0bf73bf0', 'INSERT', '{"op": "SELECT", "uuid": "67f40c40-c638-4350-a11b-951b0bf73bf0", "objectuuid": "899a89c3-6715-4a37-bb69-1ed124e0a23f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'b7428b9a-e165-4a81-b1b9-5187e0fe4cd6', 'INSERT', '{"uuid": "b7428b9a-e165-4a81-b1b9-5187e0fe4cd6", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "67f40c40-c638-4350-a11b-951b0bf73bf0", "grantedbyroleuuid": null, "grantedbytriggerof": "899a89c3-6715-4a37-bb69-1ed124e0a23f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '0166244a-b22b-4567-a09d-bd113f3430b0', 'INSERT', '{"op": "UPDATE", "uuid": "0166244a-b22b-4567-a09d-bd113f3430b0", "objectuuid": "899a89c3-6715-4a37-bb69-1ed124e0a23f", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '3ca77977-6015-4ace-9665-be334d0128ad', 'INSERT', '{"uuid": "3ca77977-6015-4ace-9665-be334d0128ad", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "0166244a-b22b-4567-a09d-bd113f3430b0", "grantedbyroleuuid": null, "grantedbytriggerof": "899a89c3-6715-4a37-bb69-1ed124e0a23f"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '899a89c3-6715-4a37-bb69-1ed124e0a23f', 'INSERT', '{"uuid": "899a89c3-6715-4a37-bb69-1ed124e0a23f", "comment": "for subscription C", "version": 0, "reference": "1000300", "valuedate": "2005-01-10", "assetvalue": 2560.00, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', 'a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', 'INSERT', '{"uuid": "a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd", "serialid": 300, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'b969f3ba-2936-4937-80ff-c440300d3f10', 'INSERT', '{"op": "SELECT", "uuid": "b969f3ba-2936-4937-80ff-c440300d3f10", "objectuuid": "a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'bbe6ea5d-c6bb-448d-a92e-0ec2e61f9985', 'INSERT', '{"uuid": "bbe6ea5d-c6bb-448d-a92e-0ec2e61f9985", "assumed": true, "ascendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "descendantuuid": "b969f3ba-2936-4937-80ff-c440300d3f10", "grantedbyroleuuid": null, "grantedbytriggerof": "a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'f6d1a800-dbfe-44d3-a939-e168760203dd', 'INSERT', '{"op": "UPDATE", "uuid": "f6d1a800-dbfe-44d3-a939-e168760203dd", "objectuuid": "a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '0d245a6d-d759-4b8f-b1b7-44d6ce23ea8e', 'INSERT', '{"uuid": "0d245a6d-d759-4b8f-b1b7-44d6ce23ea8e", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "f6d1a800-dbfe-44d3-a939-e168760203dd", "grantedbyroleuuid": null, "grantedbytriggerof": "a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', 'a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', 'INSERT', '{"uuid": "a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd", "comment": "for transfer from 7", "version": 0, "reference": "1002000", "valuedate": "2005-01-10", "assetvalue": 512.00, "membershipuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "transactiontype": "ADOPTION", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '568b153a-13dd-4510-b681-13b53f866091', 'INSERT', '{"uuid": "568b153a-13dd-4510-b681-13b53f866091", "serialid": 301, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '44a7f281-7acd-4536-a7da-db74fc7d5a30', 'INSERT', '{"op": "SELECT", "uuid": "44a7f281-7acd-4536-a7da-db74fc7d5a30", "objectuuid": "568b153a-13dd-4510-b681-13b53f866091", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '80101a12-d237-46ed-b8bc-27eab76c14a7', 'INSERT', '{"uuid": "80101a12-d237-46ed-b8bc-27eab76c14a7", "assumed": true, "ascendantuuid": "345b8b7b-a948-446f-949a-2a903b460032", "descendantuuid": "44a7f281-7acd-4536-a7da-db74fc7d5a30", "grantedbyroleuuid": null, "grantedbytriggerof": "568b153a-13dd-4510-b681-13b53f866091"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '51278cdf-daff-4fe9-90b2-1e651847e0d8', 'INSERT', '{"op": "UPDATE", "uuid": "51278cdf-daff-4fe9-90b2-1e651847e0d8", "objectuuid": "568b153a-13dd-4510-b681-13b53f866091", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '6154c85c-c362-4b71-b842-8b2bd73e4285', 'INSERT', '{"uuid": "6154c85c-c362-4b71-b842-8b2bd73e4285", "assumed": true, "ascendantuuid": "0eabdcfb-e308-4e52-8c7f-27643332c947", "descendantuuid": "51278cdf-daff-4fe9-90b2-1e651847e0d8", "grantedbyroleuuid": null, "grantedbytriggerof": "568b153a-13dd-4510-b681-13b53f866091"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '568b153a-13dd-4510-b681-13b53f866091', 'INSERT', '{"uuid": "568b153a-13dd-4510-b681-13b53f866091", "comment": "for transfer to 10", "version": 0, "reference": "1000300", "valuedate": "2005-01-10", "assetvalue": -512.00, "membershipuuid": "f97e9751-6e67-40fb-b840-b818dc69afcf", "transactiontype": "TRANSFER", "assetadoptiontxuuid": "a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd", "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '6d4e335b-f22c-48d8-98b3-0da4ad759e65', 'INSERT', '{"uuid": "6d4e335b-f22c-48d8-98b3-0da4ad759e65", "serialid": 302, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '852d7666-33fb-4246-b2c4-1efbecba4da0', 'INSERT', '{"op": "SELECT", "uuid": "852d7666-33fb-4246-b2c4-1efbecba4da0", "objectuuid": "6d4e335b-f22c-48d8-98b3-0da4ad759e65", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '050e2230-78e6-43ae-9278-eb70a4a6909b', 'INSERT', '{"uuid": "050e2230-78e6-43ae-9278-eb70a4a6909b", "assumed": true, "ascendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "descendantuuid": "852d7666-33fb-4246-b2c4-1efbecba4da0", "grantedbyroleuuid": null, "grantedbytriggerof": "6d4e335b-f22c-48d8-98b3-0da4ad759e65"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'fcc39eac-cca5-44fb-b728-9b4df8aa3874', 'INSERT', '{"op": "UPDATE", "uuid": "fcc39eac-cca5-44fb-b728-9b4df8aa3874", "objectuuid": "6d4e335b-f22c-48d8-98b3-0da4ad759e65", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '7d5320cb-c8ce-4c24-988b-72d8fcc43b0f', 'INSERT', '{"uuid": "7d5320cb-c8ce-4c24-988b-72d8fcc43b0f", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "fcc39eac-cca5-44fb-b728-9b4df8aa3874", "grantedbyroleuuid": null, "grantedbytriggerof": "6d4e335b-f22c-48d8-98b3-0da4ad759e65"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '6d4e335b-f22c-48d8-98b3-0da4ad759e65', 'INSERT', '{"uuid": "6d4e335b-f22c-48d8-98b3-0da4ad759e65", "comment": "for cancellation D", "version": 0, "reference": "1002000", "valuedate": "2016-12-31", "assetvalue": -8.00, "membershipuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "transactiontype": "CLEARING", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '105e8365-c8b6-4d69-bef4-8bc388524462', 'INSERT', '{"uuid": "105e8365-c8b6-4d69-bef4-8bc388524462", "serialid": 303, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '6a568f34-8ab2-4a74-941c-266e28a52836', 'INSERT', '{"op": "SELECT", "uuid": "6a568f34-8ab2-4a74-941c-266e28a52836", "objectuuid": "105e8365-c8b6-4d69-bef4-8bc388524462", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '261a0a0b-a0a8-4493-96f1-10f8eb18e01f', 'INSERT', '{"uuid": "261a0a0b-a0a8-4493-96f1-10f8eb18e01f", "assumed": true, "ascendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "descendantuuid": "6a568f34-8ab2-4a74-941c-266e28a52836", "grantedbyroleuuid": null, "grantedbytriggerof": "105e8365-c8b6-4d69-bef4-8bc388524462"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '8a4f7331-7bdf-41a9-85c3-5ea327063d71', 'INSERT', '{"op": "UPDATE", "uuid": "8a4f7331-7bdf-41a9-85c3-5ea327063d71", "objectuuid": "105e8365-c8b6-4d69-bef4-8bc388524462", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'c1c5ea35-68d0-4e81-b659-9b0e7894364e', 'INSERT', '{"uuid": "c1c5ea35-68d0-4e81-b659-9b0e7894364e", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "8a4f7331-7bdf-41a9-85c3-5ea327063d71", "grantedbyroleuuid": null, "grantedbytriggerof": "105e8365-c8b6-4d69-bef4-8bc388524462"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '105e8365-c8b6-4d69-bef4-8bc388524462', 'INSERT', '{"uuid": "105e8365-c8b6-4d69-bef4-8bc388524462", "comment": "for cancellation D", "version": 0, "reference": "1002000", "valuedate": "2016-12-31", "assetvalue": -100.00, "membershipuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "transactiontype": "DISBURSAL", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', '5b516553-2772-4591-b4bf-4f353e598c79', 'INSERT', '{"uuid": "5b516553-2772-4591-b4bf-4f353e598c79", "serialid": 304, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '526ae830-0342-4a87-a95f-07d760391fb7', 'INSERT', '{"op": "SELECT", "uuid": "526ae830-0342-4a87-a95f-07d760391fb7", "objectuuid": "5b516553-2772-4591-b4bf-4f353e598c79", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'c57e5955-fca4-4ddf-8cb1-c6731cd7bd70', 'INSERT', '{"uuid": "c57e5955-fca4-4ddf-8cb1-c6731cd7bd70", "assumed": true, "ascendantuuid": "ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c", "descendantuuid": "526ae830-0342-4a87-a95f-07d760391fb7", "grantedbyroleuuid": null, "grantedbytriggerof": "5b516553-2772-4591-b4bf-4f353e598c79"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '08a87b5d-d5eb-4d77-aa10-1afa61c87e38', 'INSERT', '{"op": "UPDATE", "uuid": "08a87b5d-d5eb-4d77-aa10-1afa61c87e38", "objectuuid": "5b516553-2772-4591-b4bf-4f353e598c79", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '2b408520-c1ed-4d41-8457-7d9496910c56', 'INSERT', '{"uuid": "2b408520-c1ed-4d41-8457-7d9496910c56", "assumed": true, "ascendantuuid": "6df50d79-b958-456a-ac84-a8786f0f18a7", "descendantuuid": "08a87b5d-d5eb-4d77-aa10-1afa61c87e38", "grantedbyroleuuid": null, "grantedbytriggerof": "5b516553-2772-4591-b4bf-4f353e598c79"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', '5b516553-2772-4591-b4bf-4f353e598c79', 'INSERT', '{"uuid": "5b516553-2772-4591-b4bf-4f353e598c79", "comment": "for cancellation D", "version": 0, "reference": "1002000", "valuedate": "2016-12-31", "assetvalue": -20.00, "membershipuuid": "db1fa6bf-85ff-4302-b7c3-9a66f9761830", "transactiontype": "LOSS", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', 'df223672-3c4b-4044-8f54-1794a50c957e', 'INSERT', '{"uuid": "df223672-3c4b-4044-8f54-1794a50c957e", "serialid": 305, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '63c07ed8-5b6d-4cb7-b663-6a5ce5e63fcb', 'INSERT', '{"op": "SELECT", "uuid": "63c07ed8-5b6d-4cb7-b663-6a5ce5e63fcb", "objectuuid": "df223672-3c4b-4044-8f54-1794a50c957e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '6cc382ac-c4f0-4341-80ac-32d9d2eb28f3', 'INSERT', '{"uuid": "6cc382ac-c4f0-4341-80ac-32d9d2eb28f3", "assumed": true, "ascendantuuid": "1d24331c-d029-4539-8b40-2b891f6a75a9", "descendantuuid": "63c07ed8-5b6d-4cb7-b663-6a5ce5e63fcb", "grantedbyroleuuid": null, "grantedbytriggerof": "df223672-3c4b-4044-8f54-1794a50c957e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'cc4e1270-9d63-449f-ae27-a492326f72b1', 'INSERT', '{"op": "UPDATE", "uuid": "cc4e1270-9d63-449f-ae27-a492326f72b1", "objectuuid": "df223672-3c4b-4044-8f54-1794a50c957e", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', 'a6994a91-4291-4342-bc50-9a7bd25f7b20', 'INSERT', '{"uuid": "a6994a91-4291-4342-bc50-9a7bd25f7b20", "assumed": true, "ascendantuuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "descendantuuid": "cc4e1270-9d63-449f-ae27-a492326f72b1", "grantedbyroleuuid": null, "grantedbytriggerof": "df223672-3c4b-4044-8f54-1794a50c957e"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', 'df223672-3c4b-4044-8f54-1794a50c957e', 'INSERT', '{"uuid": "df223672-3c4b-4044-8f54-1794a50c957e", "comment": "for subscription E", "version": 0, "reference": "1909000", "valuedate": "2024-01-15", "assetvalue": 128.00, "membershipuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f", "transactiontype": "DEPOSIT", "assetadoptiontxuuid": null, "revertedassettxuuid": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.object', 'cd8cd45a-a4af-46ce-a434-5b5208095346', 'INSERT', '{"uuid": "cd8cd45a-a4af-46ce-a434-5b5208095346", "serialid": 306, "objecttable": "hs_office.coopassettx"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', 'f03cc85a-b722-43f4-8d56-a29f1387e692', 'INSERT', '{"op": "SELECT", "uuid": "f03cc85a-b722-43f4-8d56-a29f1387e692", "objectuuid": "cd8cd45a-a4af-46ce-a434-5b5208095346", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '72e5484a-06b8-4fcb-b039-42dd92d1b54a', 'INSERT', '{"uuid": "72e5484a-06b8-4fcb-b039-42dd92d1b54a", "assumed": true, "ascendantuuid": "1d24331c-d029-4539-8b40-2b891f6a75a9", "descendantuuid": "f03cc85a-b722-43f4-8d56-a29f1387e692", "grantedbyroleuuid": null, "grantedbytriggerof": "cd8cd45a-a4af-46ce-a434-5b5208095346"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.permission', '16994a15-ef4b-4c7f-b123-e9c2e03919d0', 'INSERT', '{"op": "UPDATE", "uuid": "16994a15-ef4b-4c7f-b123-e9c2e03919d0", "objectuuid": "cd8cd45a-a4af-46ce-a434-5b5208095346", "optablename": null}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'rbac.grant', '2f57e665-78f6-48fa-b811-d8537ff580e3', 'INSERT', '{"uuid": "2f57e665-78f6-48fa-b811-d8537ff580e3", "assumed": true, "ascendantuuid": "bf27b482-99fb-43fe-8789-b926b9131a32", "descendantuuid": "16994a15-ef4b-4c7f-b123-e9c2e03919d0", "grantedbyroleuuid": null, "grantedbytriggerof": "cd8cd45a-a4af-46ce-a434-5b5208095346"}');
INSERT INTO base.tx_journal (txid, targettable, targetuuid, targetop, targetdelta) VALUES ('2210', 'hs_office.coopassettx', 'cd8cd45a-a4af-46ce-a434-5b5208095346', 'INSERT', '{"uuid": "cd8cd45a-a4af-46ce-a434-5b5208095346", "comment": "chargeback for subscription E", "version": 0, "reference": "1909000", "valuedate": "2024-01-20", "assetvalue": -128.00, "membershipuuid": "9c468212-9e05-4b29-9d75-5a2c147b2b8f", "transactiontype": "REVERSAL", "assetadoptiontxuuid": null, "revertedassettxuuid": "df223672-3c4b-4044-8f54-1794a50c957e"}');


--
-- Data for Name: bankaccount; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.bankaccount (uuid, version, holder, iban, bic) VALUES ('9b403ef6-3fae-4698-9b21-2627c51fa254', 0, 'Ragnar Richter', 'DE02300209000106531065', 'GENODEM1GLS');
INSERT INTO hs_office.bankaccount (uuid, version, holder, iban, bic) VALUES ('f9811182-d400-43e0-ba9e-de745c9e82a3', 0, 'Michael Mellis', 'DE37500105177419788228', 'GENODEF1HH2');
INSERT INTO hs_office.bankaccount (uuid, version, holder, iban, bic) VALUES ('4924877c-c487-4e4d-8b14-901e9b6069ac', 0, 'Wasserwerk Suedholstein', 'DE49500105174516484892', 'NOLADE21WHO');
INSERT INTO hs_office.bankaccount (uuid, version, holder, iban, bic) VALUES ('831a608f-fefe-425b-b740-1786f856c680', 0, 'Richard Wiese Das Perfekte Haus', 'DE89370400440532013000', 'COBADEFFXXX');
INSERT INTO hs_office.bankaccount (uuid, version, holder, iban, bic) VALUES ('4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 0, 'Michael Mellis', 'DE37500105177419788228', 'INGDDEFFXXX');
INSERT INTO hs_office.bankaccount (uuid, version, holder, iban, bic) VALUES ('0bae3550-be89-4c0e-9ba4-01bae0419be0', 0, 'JM e.K.', 'DE02300209000106531065', 'CMCIDEDD');
INSERT INTO hs_office.bankaccount (uuid, version, holder, iban, bic) VALUES ('f3140f7e-5045-4534-92aa-e918895bfafb', 0, 'JM GmbH', 'DE49500105174516484892', 'INGDDEFFXXX');


--
-- Data for Name: contact; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('691db509-b67e-46ec-a859-c4cb05fbbd70', 0, 'Michael Mellis, Herr Michael Mellis', '{"city": "Hage", "firm": "Herr Michael Mellis", "name": "Herr Michael Mellis", "street": "Dr. Bolte Str. 50", "country": "Germany", "zipcode": "26524"}', '{"main": "michael@Mellis.example.org"}', '{"fax": "+49 40 912345-9", "phone_mobile": "+49/1522123455", "phone_office": "+49 4931/1234567"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 0, 'Ragnar IT-Beratung, Herr Ragnar Richter', '{"city": "Stuttgart", "firm": "Herr Ragnar Richter", "name": "Herr Ragnar Richter", "street": "Vioktoriastraße 114", "country": "Germany", "zipcode": "70197"}', '{"main": "hostsharing@ragnar-richter.de"}', '{"fax": "+49 711 87654-3", "phone_office": "+49 711 987654-2", "phone_private": "+49 711 987654-1"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('d363745a-e94f-48be-8397-4b361570a54d', 0, 'Hostsharing e.G., Hostmaster Hostsharing', '{"firm": "Hostmaster Hostsharing", "name": "Hostmaster Hostsharing", "country": "Germany"}', '{"main": "hostmaster@hostsharing.net"}', '{}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('7a334268-7d11-4765-8fa9-17e2c36cca7a', 0, 'JM e.K.', '{"city": "Berlin", "firm": "", "street": "Wiesenweg 15", "country": "DE", "zipcode": "12335"}', '{"main": "jm-ex-partner@example.org"}', '{"fax": "+49 30 6666666", "phone_office": "+49 30 5555555", "phone_private": "+49 30 6666666"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('33b40eee-30ed-4924-859d-6c58b5aa4124', 0, 'JM GmbH, Frau Dr. Jenny Meyer-Billing', '{"city": "Berlin", "firm": "Frau Dr. Jenny Meyer-Billing", "name": "Frau Dr. Jenny Meyer-Billing", "street": "Waldweg 5", "country": "DE", "zipcode": "11001"}', '{"main": "jm-billing@example.org"}', '{"fax": "+49 30 2222222", "phone_office": "+49 30 1111111", "phone_private": "+49 30 7777777"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('16da0560-e134-41c5-aafb-1f7a5b33692b', 0, 'JM GmbH, Herr Andrew Meyer-Operation', '{"city": "Berlin", "firm": "Herr Andrew Meyer-Operation", "name": "Herr Andrew Meyer-Operation", "street": "Waldweg 5", "country": "DE", "zipcode": "11001"}', '{"main": "am-operation@example.org"}', '{"fax": "+49 30 4444444", "phone_office": "+49 30 3333333", "phone_private": "+49 30 6666666"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('1fc10779-390b-40ff-b641-b6b5e2634ebb', 0, 'JM GmbH, Herr Philip Meyer-Contract', '{"city": "Berlin", "firm": "Herr Philip Meyer-Contract", "name": "Herr Philip Meyer-Contract", "street": "Waldweg 5", "country": "DE", "zipcode": "11001"}', '{"main": "pm-partner@example.org"}', '{"fax": "+49 30 6666666", "phone_office": "+49 30 5555555", "phone_private": "+49 30 6666666"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('caac18bd-9277-47ac-99bb-368e2d64dac0', 0, 'JM GmbH, Frau Tammy Meyer-VIP', '{"city": "Berlin", "firm": "Frau Tammy Meyer-VIP", "name": "Frau Tammy Meyer-VIP", "street": "Waldweg 5", "country": "DE", "zipcode": "11001"}', '{"main": "tm-vip@example.org"}', '{"fax": "+49 30 6666666", "phone_office": "+49 30 999999", "phone_private": "+49 30 999999"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('eead6995-dd54-475f-8194-74445c421305', 0, 'Test PS, Petra Schmidt', '{"firm": "Petra Schmidt", "name": "Petra Schmidt"}', '{"main": "ps@example.com"}', '{}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('4b68de11-a658-44bb-be49-ad592e73e3d8', 0, 'Frau Frauke Fanninga', '{"city": "Hitzacker", "name": "Frau Frauke Fanninga", "street": "Am Walde 1", "country": "DE", "zipcode": "29456"}', '{"main": "ff@example.org"}', '{}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 0, 'Frau Cecilia Camus', '{"city": "Orléans", "name": "Frau Cecilia Camus", "street": "Rue d''Avignion 60", "country": "FR", "zipcode": "45000"}', '{"main": "cc@example.org"}', '{}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('25358342-4f90-4397-b4c4-d90524ac0b7b', 0, 'Wasserwerk Südholstein, Frau Christiane Milberg', '{"city": "Hetlingen", "firm": "Frau Christiane Milberg", "name": "Frau Christiane Milberg", "street": "Am Wasserwerk 1-3", "country": "Germany", "zipcode": "25491"}', '{"main": "rechnung@ww-sholst.example.org"}', '{"phone_mobile": "+49 4103 12345-1"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('4997dce8-4927-4a10-a7b3-16c574eb79c9', 0, 'Das Perfekte Haus, Herr Richard Wiese', '{"city": "Essen", "firm": "Herr Richard Wiese", "name": "Herr Richard Wiese", "street": "Kennedyplatz 11", "country": "Germany", "zipcode": "45279"}', '{"main": "admin@das-perfekte-haus.example.org"}', '{"phone_mobile": "+49-172-12345"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('9dcab961-1465-40e3-8d83-357b22af2674', 0, 'Wasswerwerk Südholstein, Herr Karim Metzger', '{"city": "Hetlingen", "firm": "Herr Karim Metzger", "name": "Herr Karim Metzger", "street": "Am Wasserwerk 1-3", "country": "Germany", "zipcode": "25491"}', '{"main": "karim.metzger@ww-sholst.example.org"}', '{"phone_office": "+49 4103 12345-2"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('29e2d42f-5f00-467f-ab73-f2ff59f2792d', 0, 'Das Perfekte Haus, Herr Inhaber R. Wiese', '{"co": "Client-ID 515217", "city": "Hannover", "firm": "Herr Inhaber R. Wiese", "name": "Herr Inhaber R. Wiese", "street": "Essen, Kastanienallee 81", "country": "Germany", "zipcode": "30127"}', '{"main": "515217@kkemail.example.org"}', '{}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('627a274d-55b0-42e7-963c-8b0cc3e204b4', 0, 'Ragnar Richter', '{"name": "Ragnar Richter"}', '{"main": "mail@ragnar-richter..example.org"}', '{}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('e8151525-ae0c-44fb-9755-72be88f7f6b1', 0, 'Eike Henning', '{"name": "Eike Henning"}', '{"main": "hostsharing@eike-henning..example.org"}', '{}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 0, 'Jan Henning', '{"name": "Jan Henning"}', '{"main": "mail@jan-henning.example.org"}', '{"phone_office": "01577 12345678"}');
INSERT INTO hs_office.contact (uuid, version, caption, postaladdress, emailaddresses, phonenumbers) VALUES ('c3b8c521-37f4-46b8-89f7-1931159e9a14', 0, 'Jan Henning', '{"name": "Jan Henning"}', '{"main": "lists@jan-henning.example.org"}', '{"phone_office": "01577 12345678"}');


--
-- Data for Name: contact_legacy_id; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('691db509-b67e-46ec-a859-c4cb05fbbd70', 100);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 132);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('d363745a-e94f-48be-8397-4b361570a54d', 212);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('7a334268-7d11-4765-8fa9-17e2c36cca7a', 1200);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('33b40eee-30ed-4924-859d-6c58b5aa4124', 1201);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('16da0560-e134-41c5-aafb-1f7a5b33692b', 1202);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('1fc10779-390b-40ff-b641-b6b5e2634ebb', 1203);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('caac18bd-9277-47ac-99bb-368e2d64dac0', 1204);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('eead6995-dd54-475f-8194-74445c421305', 1301);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('4b68de11-a658-44bb-be49-ad592e73e3d8', 1401);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 1501);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('25358342-4f90-4397-b4c4-d90524ac0b7b', 90436);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('4997dce8-4927-4a10-a7b3-16c574eb79c9', 90437);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('9dcab961-1465-40e3-8d83-357b22af2674', 90438);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('29e2d42f-5f00-467f-ab73-f2ff59f2792d', 90590);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('627a274d-55b0-42e7-963c-8b0cc3e204b4', 90629);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('e8151525-ae0c-44fb-9755-72be88f7f6b1', 90677);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 90698);
INSERT INTO hs_office.contact_legacy_id (uuid, contact_id) VALUES ('c3b8c521-37f4-46b8-89f7-1931159e9a14', 90699);


--
-- Data for Name: coopassettx; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('f9c724b4-3965-4cfa-bc93-5b780b2362e7', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'DEPOSIT', '2000-12-06', 5120.00, '1000300', NULL, NULL, 'for subscription A');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('1b444a8f-352d-4812-97aa-bd1e649201f8', 0, 'af682fb0-f06d-4a2b-affb-40487a079a70', 'DEPOSIT', '2003-07-07', 64.00, '1015200', NULL, NULL, '');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('2b1590f1-c1b8-4318-9879-8e2d898fa4a5', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'DEPOSIT', '2011-12-12', 1024.00, '1000300', NULL, NULL, '');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('0f05f1bd-403c-4239-8595-d317bba58a32', 0, 'af682fb0-f06d-4a2b-affb-40487a079a70', 'DEPOSIT', '2013-10-21', 64.00, '1015200', NULL, NULL, '');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('2cca894b-c08a-4b36-b809-d417cf0b305c', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'DEPOSIT', '2020-12-15', 6144.00, '1000300', NULL, NULL, 'Einzahlung');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('b4acab9a-7a54-42df-bd35-717f052b407d', 0, 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'DEPOSIT', '2021-05-21', 256.00, '1101800', NULL, NULL, 'Beitritt - Lastschrift');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('fab99b6c-dd05-451f-a9e7-80891ec94db1', 0, '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'DEPOSIT', '2021-05-31', 64.00, '1101900', NULL, NULL, 'Beitritt - Lastschrift');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'DEPOSIT', '2023-10-05', 3072.00, '1000300', NULL, NULL, 'Kapitalerhoehung - Ueberweisung');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('9f3ea248-0492-43af-8430-2cbe4ae3338b', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'DEPOSIT', '2023-10-06', 3072.00, '1000300', NULL, NULL, 'Kapitalerhoehung - Ueberweisung');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('02362331-8069-4712-9c39-371973edb192', 0, 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'DEPOSIT', '2000-12-06', 128.00, '1002000', NULL, NULL, 'for subscription B');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('899a89c3-6715-4a37-bb69-1ed124e0a23f', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'DEPOSIT', '2005-01-10', 2560.00, '1000300', NULL, NULL, 'for subscription C');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', 0, 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'ADOPTION', '2005-01-10', 512.00, '1002000', NULL, NULL, 'for transfer from 7');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('568b153a-13dd-4510-b681-13b53f866091', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'TRANSFER', '2005-01-10', -512.00, '1000300', NULL, 'a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', 'for transfer to 10');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('6d4e335b-f22c-48d8-98b3-0da4ad759e65', 0, 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'CLEARING', '2016-12-31', -8.00, '1002000', NULL, NULL, 'for cancellation D');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('105e8365-c8b6-4d69-bef4-8bc388524462', 0, 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'DISBURSAL', '2016-12-31', -100.00, '1002000', NULL, NULL, 'for cancellation D');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('5b516553-2772-4591-b4bf-4f353e598c79', 0, 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'LOSS', '2016-12-31', -20.00, '1002000', NULL, NULL, 'for cancellation D');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('df223672-3c4b-4044-8f54-1794a50c957e', 0, '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'DEPOSIT', '2024-01-15', 128.00, '1909000', NULL, NULL, 'for subscription E');
INSERT INTO hs_office.coopassettx (uuid, version, membershipuuid, transactiontype, valuedate, assetvalue, reference, revertedassettxuuid, assetadoptiontxuuid, comment) VALUES ('cd8cd45a-a4af-46ce-a434-5b5208095346', 0, '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'REVERSAL', '2024-01-20', -128.00, '1909000', 'df223672-3c4b-4044-8f54-1794a50c957e', NULL, 'chargeback for subscription E');


--
-- Data for Name: coopassettx_legacy_id; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('f9c724b4-3965-4cfa-bc93-5b780b2362e7', 358);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('1b444a8f-352d-4812-97aa-bd1e649201f8', 442);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('2b1590f1-c1b8-4318-9879-8e2d898fa4a5', 577);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('0f05f1bd-403c-4239-8595-d317bba58a32', 632);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('2cca894b-c08a-4b36-b809-d417cf0b305c', 885);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('b4acab9a-7a54-42df-bd35-717f052b407d', 924);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('fab99b6c-dd05-451f-a9e7-80891ec94db1', 925);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb', 1093);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('9f3ea248-0492-43af-8430-2cbe4ae3338b', 1094);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('02362331-8069-4712-9c39-371973edb192', 31000);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('899a89c3-6715-4a37-bb69-1ed124e0a23f', 32000);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('568b153a-13dd-4510-b681-13b53f866091', 33001);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', 33002);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('6d4e335b-f22c-48d8-98b3-0da4ad759e65', 34001);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('105e8365-c8b6-4d69-bef4-8bc388524462', 34002);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('5b516553-2772-4591-b4bf-4f353e598c79', 34003);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('df223672-3c4b-4044-8f54-1794a50c957e', 35001);
INSERT INTO hs_office.coopassettx_legacy_id (uuid, member_asset_id) VALUES ('cd8cd45a-a4af-46ce-a434-5b5208095346', 35002);


--
-- Data for Name: coopsharetx; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('925e61ee-5120-4205-b609-18083af2c4d6', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'SUBSCRIPTION', '2000-12-06', 80, '1000300', NULL, 'initial share subscription');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9', 0, 'af682fb0-f06d-4a2b-affb-40487a079a70', 'SUBSCRIPTION', '2003-07-12', 1, '1015200', NULL, '');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('e27e543b-f15b-4e0b-98fc-ce72bcd5d258', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'SUBSCRIPTION', '2011-12-05', 16, '1000300', NULL, '');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('d9c28f32-a87e-4f2e-af07-75a76004907b', 0, 'af682fb0-f06d-4a2b-affb-40487a079a70', 'SUBSCRIPTION', '2013-10-21', 1, '1015200', NULL, '');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('b0a9b8a6-8709-4210-b4ad-eadcab6f7866', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'SUBSCRIPTION', '2020-12-08', 96, '1000300', NULL, 'Kapitalerhoehung');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('d3e130d9-9288-4d74-8699-1778d2f5c151', 0, 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'SUBSCRIPTION', '2021-05-17', 4, '1101800', NULL, 'Beitritt');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('110138a4-46e3-418b-8ce2-095da9c6b98c', 0, '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'SUBSCRIPTION', '2021-05-25', 1, '1101900', NULL, 'Beitritt');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('0565d216-af16-45aa-86e5-9ca55751322f', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'SUBSCRIPTION', '2023-10-10', 96, '1000300', NULL, 'Kapitalerhoehung');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('c7d34de2-7cbd-480a-9ce5-a574ef7248d8', 0, 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'SUBSCRIPTION', '2000-12-06', 2, '1002000', NULL, 'initial share subscription');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('147820f5-533d-471d-9f54-99e087ec37c6', 0, 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'SUBSCRIPTION', '2005-01-10', 40, '1000300', NULL, 'increase');
INSERT INTO hs_office.coopsharetx (uuid, version, membershipuuid, transactiontype, valuedate, sharecount, reference, revertedsharetxuuid, comment) VALUES ('eb40ed40-ebf5-401a-b498-ecc46928a17d', 0, 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'CANCELLATION', '2016-12-31', 22, '1002000', NULL, 'membership ended');


--
-- Data for Name: coopsharetx_legacy_id; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('925e61ee-5120-4205-b609-18083af2c4d6', 3);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9', 90);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('e27e543b-f15b-4e0b-98fc-ce72bcd5d258', 241);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('d9c28f32-a87e-4f2e-af07-75a76004907b', 279);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('b0a9b8a6-8709-4210-b4ad-eadcab6f7866', 523);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('d3e130d9-9288-4d74-8699-1778d2f5c151', 562);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('110138a4-46e3-418b-8ce2-095da9c6b98c', 563);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('0565d216-af16-45aa-86e5-9ca55751322f', 721);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('c7d34de2-7cbd-480a-9ce5-a574ef7248d8', 33451);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('147820f5-533d-471d-9f54-99e087ec37c6', 33701);
INSERT INTO hs_office.coopsharetx_legacy_id (uuid, member_share_id) VALUES ('eb40ed40-ebf5-401a-b498-ecc46928a17d', 33810);


--
-- Data for Name: debitor; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.debitor (uuid, version, debitornumbersuffix, debitorreluuid, billable, vatid, vatcountrycode, vatbusiness, vatreversecharge, refundbankaccountuuid, defaultprefix) VALUES ('6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', 0, '00', 'f415978e-b5c2-4a99-962e-3d31a4658780', false, 'DE217249198', NULL, true, false, NULL, 'mim');
INSERT INTO hs_office.debitor (uuid, version, debitornumbersuffix, debitorreluuid, billable, vatid, vatcountrycode, vatbusiness, vatreversecharge, refundbankaccountuuid, defaultprefix) VALUES ('84d4763e-0133-4d81-946b-fb64d1a3fd26', 0, '00', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', false, '', NULL, true, false, NULL, 'xyz');
INSERT INTO hs_office.debitor (uuid, version, debitornumbersuffix, debitorreluuid, billable, vatid, vatcountrycode, vatbusiness, vatreversecharge, refundbankaccountuuid, defaultprefix) VALUES ('bdfc3748-abd1-4bce-a239-f5b4df6715c4', 0, '00', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', false, '', NULL, true, true, NULL, 'xxx');
INSERT INTO hs_office.debitor (uuid, version, debitornumbersuffix, debitorreluuid, billable, vatid, vatcountrycode, vatbusiness, vatreversecharge, refundbankaccountuuid, defaultprefix) VALUES ('67c2d793-212f-4ce0-a750-b18224a93c73', 0, '00', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', false, 'DE 236 109 136', NULL, true, false, NULL, 'rar');
INSERT INTO hs_office.debitor (uuid, version, debitornumbersuffix, debitorreluuid, billable, vatid, vatcountrycode, vatbusiness, vatreversecharge, refundbankaccountuuid, defaultprefix) VALUES ('3692b171-10ef-4f20-97de-ed5fa562ca46', 0, '00', '268c2ce6-8945-4393-9916-ac90050f064a', false, '', NULL, true, true, NULL, 'yyy');
INSERT INTO hs_office.debitor (uuid, version, debitornumbersuffix, debitorreluuid, billable, vatid, vatcountrycode, vatbusiness, vatreversecharge, refundbankaccountuuid, defaultprefix) VALUES ('ce424fb0-bcc4-43ef-bc62-e923fb337fde', 0, '00', '78123dac-fed2-4e3e-817b-0c13a2129dfe', false, '', NULL, true, false, NULL, 'hsh');
INSERT INTO hs_office.debitor (uuid, version, debitornumbersuffix, debitorreluuid, billable, vatid, vatcountrycode, vatbusiness, vatreversecharge, refundbankaccountuuid, defaultprefix) VALUES ('ccbd7baa-494d-4bfc-b5bb-4310e607df04', 0, '00', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', false, '', NULL, true, false, NULL, 'wws');
INSERT INTO hs_office.debitor (uuid, version, debitornumbersuffix, debitorreluuid, billable, vatid, vatcountrycode, vatbusiness, vatreversecharge, refundbankaccountuuid, defaultprefix) VALUES ('ade3baa7-760f-488b-962d-7e365ad1402f', 0, '00', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', false, '', NULL, true, false, NULL, 'dph');


--
-- Data for Name: membership; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.membership (uuid, version, partneruuid, membernumbersuffix, validity, status, membershipfeebillable) VALUES ('f97e9751-6e67-40fb-b840-b818dc69afcf', 0, '91b63591-b1e2-4c65-8ad2-c607be4c1238', '00', '[2000-12-06,)', 'ACTIVE', false);
INSERT INTO hs_office.membership (uuid, version, partneruuid, membernumbersuffix, validity, status, membershipfeebillable) VALUES ('db1fa6bf-85ff-4302-b7c3-9a66f9761830', 0, 'db7f287e-dfd7-4627-88e3-407cac226472', '00', '[2000-12-06,2016-01-01)', 'UNKNOWN', true);
INSERT INTO hs_office.membership (uuid, version, partneruuid, membernumbersuffix, validity, status, membershipfeebillable) VALUES ('cf4c2c71-c6a0-4887-83a3-67509371b8af', 0, 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', '00', '[2021-04-01,)', 'ACTIVE', true);
INSERT INTO hs_office.membership (uuid, version, partneruuid, membernumbersuffix, validity, status, membershipfeebillable) VALUES ('af682fb0-f06d-4a2b-affb-40487a079a70', 0, '029b1c78-d68b-48e6-83e5-8883b9cefe7c', '00', '[2003-07-12,)', 'ACTIVE', true);
INSERT INTO hs_office.membership (uuid, version, partneruuid, membernumbersuffix, validity, status, membershipfeebillable) VALUES ('9c468212-9e05-4b29-9d75-5a2c147b2b8f', 0, '58ca016b-15ea-41e3-80ba-2603bf736619', '00', 'empty', 'INVALID', false);
INSERT INTO hs_office.membership (uuid, version, partneruuid, membernumbersuffix, validity, status, membershipfeebillable) VALUES ('ace60d06-0635-4c2c-bb4b-7233c19862fc', 0, '25b8066a-59fd-4733-90f2-8ea80c826fff', '00', '[2021-05-17,)', 'ACTIVE', true);
INSERT INTO hs_office.membership (uuid, version, partneruuid, membernumbersuffix, validity, status, membershipfeebillable) VALUES ('183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 0, 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', '00', '[2021-05-25,)', 'ACTIVE', true);


--
-- Data for Name: partner; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.partner (uuid, version, partnernumber, partnerreluuid, detailsuuid) VALUES ('91b63591-b1e2-4c65-8ad2-c607be4c1238', 0, 10003, '48618c28-9304-4ccb-b022-e2cbb1832944', '6da29bfa-4744-437f-aed3-2695571c58bf');
INSERT INTO hs_office.partner (uuid, version, partnernumber, partnerreluuid, detailsuuid) VALUES ('db7f287e-dfd7-4627-88e3-407cac226472', 0, 10020, '164d3cde-e2ab-4239-9dbf-de1c963158ac', '7b7a528d-a284-4d0d-99ce-73f2a7585f78');
INSERT INTO hs_office.partner (uuid, version, partnernumber, partnerreluuid, detailsuuid) VALUES ('a083dfa1-afb0-4531-8a1b-8f4ba78a6215', 0, 11022, 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787');
INSERT INTO hs_office.partner (uuid, version, partnernumber, partnerreluuid, detailsuuid) VALUES ('029b1c78-d68b-48e6-83e5-8883b9cefe7c', 0, 10152, '201b417e-4ebe-458b-a7ce-a287c0ad9287', '90604765-0e48-4363-83e4-1c2e9e4a8f33');
INSERT INTO hs_office.partner (uuid, version, partnernumber, partnerreluuid, detailsuuid) VALUES ('58ca016b-15ea-41e3-80ba-2603bf736619', 0, 19090, 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'a7494bd0-af97-421e-bfa3-53bd97fb1df8');
INSERT INTO hs_office.partner (uuid, version, partnernumber, partnerreluuid, detailsuuid) VALUES ('defa6288-bed7-4ed8-ae6d-fbbb3530a632', 0, 10000, 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'f1048d9f-e560-459a-91fe-f769ef049648');
INSERT INTO hs_office.partner (uuid, version, partnernumber, partnerreluuid, detailsuuid) VALUES ('25b8066a-59fd-4733-90f2-8ea80c826fff', 0, 11018, '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'b2cd9234-6651-4c9a-818d-f48610d76095');
INSERT INTO hs_office.partner (uuid, version, partnernumber, partnerreluuid, detailsuuid) VALUES ('c83c9583-a825-4a2d-96b7-fec9dd635fbc', 0, 11019, 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', '871eadbe-c143-444a-966c-cc4494ba93bf');


--
-- Data for Name: partner_details; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.partner_details (uuid, version, registrationoffice, registrationnumber, birthplace, birthname, birthday, dateofdeath) VALUES ('6da29bfa-4744-437f-aed3-2695571c58bf', 0, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO hs_office.partner_details (uuid, version, registrationoffice, registrationnumber, birthplace, birthname, birthday, dateofdeath) VALUES ('7b7a528d-a284-4d0d-99ce-73f2a7585f78', 0, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO hs_office.partner_details (uuid, version, registrationoffice, registrationnumber, birthplace, birthname, birthday, dateofdeath) VALUES ('f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787', 0, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO hs_office.partner_details (uuid, version, registrationoffice, registrationnumber, birthplace, birthname, birthday, dateofdeath) VALUES ('90604765-0e48-4363-83e4-1c2e9e4a8f33', 0, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO hs_office.partner_details (uuid, version, registrationoffice, registrationnumber, birthplace, birthname, birthday, dateofdeath) VALUES ('a7494bd0-af97-421e-bfa3-53bd97fb1df8', 0, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO hs_office.partner_details (uuid, version, registrationoffice, registrationnumber, birthplace, birthname, birthday, dateofdeath) VALUES ('f1048d9f-e560-459a-91fe-f769ef049648', 0, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO hs_office.partner_details (uuid, version, registrationoffice, registrationnumber, birthplace, birthname, birthday, dateofdeath) VALUES ('b2cd9234-6651-4c9a-818d-f48610d76095', 0, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO hs_office.partner_details (uuid, version, registrationoffice, registrationnumber, birthplace, birthname, birthday, dateofdeath) VALUES ('871eadbe-c143-444a-966c-cc4494ba93bf', 0, NULL, NULL, NULL, NULL, NULL, NULL);


--
-- Data for Name: partner_legacy_id; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.partner_legacy_id (uuid, bp_id) VALUES ('91b63591-b1e2-4c65-8ad2-c607be4c1238', 100);
INSERT INTO hs_office.partner_legacy_id (uuid, bp_id) VALUES ('db7f287e-dfd7-4627-88e3-407cac226472', 120);
INSERT INTO hs_office.partner_legacy_id (uuid, bp_id) VALUES ('a083dfa1-afb0-4531-8a1b-8f4ba78a6215', 122);
INSERT INTO hs_office.partner_legacy_id (uuid, bp_id) VALUES ('029b1c78-d68b-48e6-83e5-8883b9cefe7c', 132);
INSERT INTO hs_office.partner_legacy_id (uuid, bp_id) VALUES ('58ca016b-15ea-41e3-80ba-2603bf736619', 190);
INSERT INTO hs_office.partner_legacy_id (uuid, bp_id) VALUES ('defa6288-bed7-4ed8-ae6d-fbbb3530a632', 213);
INSERT INTO hs_office.partner_legacy_id (uuid, bp_id) VALUES ('25b8066a-59fd-4733-90f2-8ea80c826fff', 541);
INSERT INTO hs_office.partner_legacy_id (uuid, bp_id) VALUES ('c83c9583-a825-4a2d-96b7-fec9dd635fbc', 542);


--
-- Data for Name: person; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('137fb47a-07d4-42cc-b2ef-8e371041cf41', 0, '??', 'Michael Mellis', 'Herr', '', 'Michael', 'Mellis');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 0, '??', 'Ragnar IT-Beratung', 'Herr', '', 'Ragnar', 'Richter');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('cd48cfd6-6313-408f-ae7d-9af047d0c22e', 0, 'LP', 'Hostsharing e.G.', 'Firma', '', 'Hostmaster', 'Hostsharing');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 0, 'LP', 'JM e.K.', '', '', '', '');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 0, 'LP', 'JM GmbH', 'Frau', 'Dr.', 'Jenny', 'Meyer-Billing');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 0, 'LP', 'JM GmbH', 'Herr', '', 'Andrew', 'Meyer-Operation');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('ff030436-d19e-4606-9d48-7e192eaf469f', 0, 'LP', 'JM GmbH', 'Herr', '', 'Philip', 'Meyer-Contract');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('c8050a1b-0d28-4aa7-ac77-958c99152cd1', 0, 'LP', 'JM GmbH', 'Frau', '', 'Tammy', 'Meyer-VIP');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('89bca3fd-d7b2-46f5-821a-64c5566d03f1', 0, '??', 'Test PS', '', '', 'Petra', 'Schmidt');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('2fd1ba30-936a-41a8-8fbe-e93be547f44b', 0, 'NP', '', 'Frau', '', 'Frauke', 'Fanninga');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 0, 'NP', '', 'Frau', '', 'Cecilia', 'Camus');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('38cc5d59-085f-449e-aeb3-439febbabd9b', 0, '??', 'Wasserwerk Südholstein', 'Frau', '', 'Christiane', 'Milberg');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 0, '??', 'Das Perfekte Haus', 'Herr', '', 'Richard', 'Wiese');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('d7485220-e4f2-4683-9e84-7728a2ef4ebf', 0, '??', 'Wasswerwerk Südholstein', 'Herr', '', 'Karim', 'Metzger');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('d6488771-b5c0-4f39-a6d6-81af6ca982f4', 0, '??', 'Das Perfekte Haus', 'Herr', '', 'Inhaber R.', 'Wiese');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('7c10a7d7-bac2-41e2-a5c0-963e191239a8', 0, 'NP', '', '', '', 'Ragnar', 'Richter');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('c3d97013-0ceb-4cc7-a59b-a4f70107acea', 0, 'NP', '', '', '', 'Eike', 'Henning');
INSERT INTO hs_office.person (uuid, version, persontype, tradename, salutation, title, givenname, familyname) VALUES ('e50c983a-060c-47c9-9d47-efd552b1e618', 0, 'NP', '', '', '', 'Jan', 'Henning');


--
-- Data for Name: relation; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('48618c28-9304-4ccb-b022-e2cbb1832944', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', '137fb47a-07d4-42cc-b2ef-8e371041cf41', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'PARTNER', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('f415978e-b5c2-4a99-962e-3d31a4658780', 0, '137fb47a-07d4-42cc-b2ef-8e371041cf41', '137fb47a-07d4-42cc-b2ef-8e371041cf41', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'DEBITOR', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('201b417e-4ebe-458b-a7ce-a287c0ad9287', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'PARTNER', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'DEBITOR', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('f85f9a58-7651-417f-b1b2-cf522bcce415', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'd363745a-e94f-48be-8397-4b361570a54d', 'PARTNER', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('78123dac-fed2-4e3e-817b-0c13a2129dfe', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'd363745a-e94f-48be-8397-4b361570a54d', 'DEBITOR', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('463c4856-495f-4ab3-b26c-7b2f96b05ab5', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', '38cc5d59-085f-449e-aeb3-439febbabd9b', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'PARTNER', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 0, '38cc5d59-085f-449e-aeb3-439febbabd9b', '38cc5d59-085f-449e-aeb3-439febbabd9b', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'DEBITOR', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('ecf9603d-1bc4-417b-b953-552b8f08f6f3', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'PARTNER', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('dd0eae3e-7f45-45dd-b686-f39e046918b0', 0, 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', 'DEBITOR', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('164d3cde-e2ab-4239-9dbf-de1c963158ac', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'ff030436-d19e-4606-9d48-7e192eaf469f', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'PARTNER', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', '33b40eee-30ed-4924-859d-6c58b5aa4124', 'DEBITOR', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('a85fd289-2383-4abe-b796-9b0b47d702d2', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'eead6995-dd54-475f-8194-74445c421305', 'PARTNER', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('bc8c4b35-c55b-4c3e-9122-94485909b17e', 0, '89bca3fd-d7b2-46f5-821a-64c5566d03f1', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'eead6995-dd54-475f-8194-74445c421305', 'DEBITOR', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('bcd0fdb5-7415-40d2-8265-85113a4b66be', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'PARTNER', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('268c2ce6-8945-4393-9916-ac90050f064a', 0, '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'DEBITOR', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'd363745a-e94f-48be-8397-4b361570a54d', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('86b706e2-9225-482e-b82a-d4ac4adab065', 0, 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'd363745a-e94f-48be-8397-4b361570a54d', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('2db1a3ce-910d-4f3d-be67-b3a0a598d834', 0, '137fb47a-07d4-42cc-b2ef-8e371041cf41', '137fb47a-07d4-42cc-b2ef-8e371041cf41', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 0, '137fb47a-07d4-42cc-b2ef-8e371041cf41', '137fb47a-07d4-42cc-b2ef-8e371041cf41', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('ddbda55a-0143-4224-bb6c-7ec5e8b79465', 0, '137fb47a-07d4-42cc-b2ef-8e371041cf41', '137fb47a-07d4-42cc-b2ef-8e371041cf41', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'SUBSCRIBER', 'operations-discussion');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('47b7bd3f-8668-4934-bee9-56708e835d7f', 0, '137fb47a-07d4-42cc-b2ef-8e371041cf41', '137fb47a-07d4-42cc-b2ef-8e371041cf41', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'SUBSCRIBER', 'operations-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('80a9daef-e282-499a-ab2f-98a016edb8f7', 0, '137fb47a-07d4-42cc-b2ef-8e371041cf41', '137fb47a-07d4-42cc-b2ef-8e371041cf41', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'SUBSCRIBER', 'generalversammlung');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('93d9827e-63dc-418e-a021-25b400847b2e', 0, '137fb47a-07d4-42cc-b2ef-8e371041cf41', '137fb47a-07d4-42cc-b2ef-8e371041cf41', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'SUBSCRIBER', 'members-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('f4219fae-353d-4324-90ca-9f313a8c1c17', 0, '137fb47a-07d4-42cc-b2ef-8e371041cf41', '137fb47a-07d4-42cc-b2ef-8e371041cf41', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'SUBSCRIBER', 'members-discussion');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('219baf3d-0bb7-4252-b92f-4cfa97cb633c', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('ed0fb977-6512-4452-8505-378fcbbd5060', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'SUBSCRIBER', 'operations-discussion');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('af82432c-09a8-42a7-9525-e9095025d4dd', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'SUBSCRIBER', 'operations-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('f691585e-eb5e-45bd-8d8a-8187094ed0a0', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', '7a334268-7d11-4765-8fa9-17e2c36cca7a', 'EX_PARTNER', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('65879210-cf7c-4e5b-a2d1-742a42fcb488', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('97e5ed67-e81c-4c12-b354-45db951901c0', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('a0e5508f-533d-4f7c-9602-6f23fa85e601', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'VIP_CONTACT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('2eec1138-d2ad-43de-a105-605d0182a1f8', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'SUBSCRIBER', 'operations-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', 'ff030436-d19e-4606-9d48-7e192eaf469f', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'SUBSCRIBER', 'members-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('fad03414-b62b-45d4-93fd-51c52149762c', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', 'ff030436-d19e-4606-9d48-7e192eaf469f', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'SUBSCRIBER', 'customers-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('48a0fa39-0d72-4c0a-800f-afed02865850', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'caac18bd-9277-47ac-99bb-368e2d64dac0', 'VIP_CONTACT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('a84434fd-e879-4208-a8e8-8095e22b72bf', 0, '89bca3fd-d7b2-46f5-821a-64c5566d03f1', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'eead6995-dd54-475f-8194-74445c421305', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('93d87d13-efdb-4d31-83e6-3b13db983c12', 0, '89bca3fd-d7b2-46f5-821a-64c5566d03f1', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'eead6995-dd54-475f-8194-74445c421305', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('bad214a0-5220-4433-8714-52e4c736585a', 0, 'ff030436-d19e-4606-9d48-7e192eaf469f', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', '4b68de11-a658-44bb-be49-ad592e73e3d8', 'SUBSCRIBER', 'operations-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('5add96a4-6fff-4fe2-8628-669d72252417', 0, '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('2185083d-3134-4b30-9dcb-674058feaac2', 0, '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('c60e1d4e-01a1-42a8-9521-1681c77b350f', 0, '38cc5d59-085f-449e-aeb3-439febbabd9b', '38cc5d59-085f-449e-aeb3-439febbabd9b', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'SUBSCRIBER', 'generalversammlung');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('17ea3654-289d-4892-a837-3ddcaea2d7db', 0, '38cc5d59-085f-449e-aeb3-439febbabd9b', '38cc5d59-085f-449e-aeb3-439febbabd9b', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'SUBSCRIBER', 'members-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('60702c01-7285-4eea-a937-6019d6e3661d', 0, '38cc5d59-085f-449e-aeb3-439febbabd9b', '38cc5d59-085f-449e-aeb3-439febbabd9b', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'SUBSCRIBER', 'members-discussion');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('a66a844c-e5b3-4569-96cf-06197abc0d2f', 0, 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('f7ddff21-e58a-426b-a693-46a2b45c9d4e', 0, 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('8363ec62-6d90-4dd9-940b-6073b3246c39', 0, 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'SUBSCRIBER', 'operations-discussion');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 0, 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'SUBSCRIBER', 'operations-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('bc9fabea-d44b-455c-87d6-a0b0428e7768', 0, 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'SUBSCRIBER', 'generalversammlung');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('a13af5de-4315-46dd-ae08-427ea72b35a0', 0, 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'SUBSCRIBER', 'members-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('cea1bd90-a42c-4cbf-97c3-33c134537bfc', 0, 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'SUBSCRIBER', 'members-discussion');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('fac4bfec-9f0b-427f-b032-ca54188d0a76', 0, '38cc5d59-085f-449e-aeb3-439febbabd9b', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', '9dcab961-1465-40e3-8d83-357b22af2674', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 0, '38cc5d59-085f-449e-aeb3-439febbabd9b', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', '9dcab961-1465-40e3-8d83-357b22af2674', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('18124f89-8ce6-4813-8efe-3ed47b7eb453', 0, '38cc5d59-085f-449e-aeb3-439febbabd9b', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', '9dcab961-1465-40e3-8d83-357b22af2674', 'SUBSCRIBER', 'operations-discussion');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('cbda6432-b849-4787-84ab-88e680dbfa72', 0, '38cc5d59-085f-449e-aeb3-439febbabd9b', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', '9dcab961-1465-40e3-8d83-357b22af2674', 'SUBSCRIBER', 'operations-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('f3b07a47-e7ac-4fea-850e-1d785edfea34', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'REPRESENTATIVE', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('4761d35a-2de3-4415-a91d-f53d15162aea', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'SUBSCRIBER', 'generalversammlung');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('04c248f9-20e0-42e1-adf3-b24d2ff7a272', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'SUBSCRIBER', 'members-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('7113f4da-b942-4f17-97f8-d3fdfd2966c6', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'SUBSCRIBER', 'members-discussion');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('4dbf555d-3375-442e-a87d-815d1492af55', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('e74992df-66a8-4572-9e55-ec7b210f04e0', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'SUBSCRIBER', 'operations-discussion');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'SUBSCRIBER', 'operations-announce');
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'e50c983a-060c-47c9-9d47-efd552b1e618', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'OPERATIONS_ALERT', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('047364a5-9dcb-4027-a94c-e35f4646860e', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'e50c983a-060c-47c9-9d47-efd552b1e618', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'OPERATIONS', NULL);
INSERT INTO hs_office.relation (uuid, version, anchoruuid, holderuuid, contactuuid, type, mark) VALUES ('08e80808-fb86-4503-ab9b-9652af82d5b5', 0, 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', 'SUBSCRIBER', 'operations-announce');


--
-- Data for Name: sepamandate; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.sepamandate (uuid, version, debitoruuid, bankaccountuuid, reference, agreement, validity) VALUES ('3d0e6bb5-a62e-4225-a2bb-967c76926705', 0, '67c2d793-212f-4ce0-a750-b18224a93c73', '9b403ef6-3fae-4698-9b21-2627c51fa254', 'HS-10152-20140801', '2013-12-01', '[2013-12-01,2016-02-16)');
INSERT INTO hs_office.sepamandate (uuid, version, debitoruuid, bankaccountuuid, reference, agreement, validity) VALUES ('6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 0, '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', 'f9811182-d400-43e0-ba9e-de745c9e82a3', 'HS-10003-20140801', '2013-12-01', '[2013-12-01,)');
INSERT INTO hs_office.sepamandate (uuid, version, debitoruuid, bankaccountuuid, reference, agreement, validity) VALUES ('850aa448-3a14-440c-9834-0b7ef6d83c39', 0, 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', '4924877c-c487-4e4d-8b14-901e9b6069ac', 'HS-11018-20210512', '2021-05-12', '[2021-05-17,)');
INSERT INTO hs_office.sepamandate (uuid, version, debitoruuid, bankaccountuuid, reference, agreement, validity) VALUES ('1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 0, 'ade3baa7-760f-488b-962d-7e365ad1402f', '831a608f-fefe-425b-b740-1786f856c680', 'HS-11019-20210519', '2021-05-19', '[2021-05-25,)');
INSERT INTO hs_office.sepamandate (uuid, version, debitoruuid, bankaccountuuid, reference, agreement, validity) VALUES ('466056f2-efc6-45d6-b778-fa111db7a18b', 0, '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 'MH12345', '2004-06-12', '[2004-06-15,)');
INSERT INTO hs_office.sepamandate (uuid, version, debitoruuid, bankaccountuuid, reference, agreement, validity) VALUES ('e2dd08d5-2083-44ef-bf22-57898af08e3e', 0, '84d4763e-0133-4d81-946b-fb64d1a3fd26', '0bae3550-be89-4c0e-9ba4-01bae0419be0', 'JM33344', '2004-01-15', '[2004-01-20,2005-06-28)');
INSERT INTO hs_office.sepamandate (uuid, version, debitoruuid, bankaccountuuid, reference, agreement, validity) VALUES ('51a4690c-bb0e-4be2-a285-31552f900db6', 0, '84d4763e-0133-4d81-946b-fb64d1a3fd26', 'f3140f7e-5045-4534-92aa-e918895bfafb', 'JM33344', '2005-06-28', '[2005-07-01,)');


--
-- Data for Name: sepamandate_legacy_id; Type: TABLE DATA; Schema: hs_office; Owner: test
--

INSERT INTO hs_office.sepamandate_legacy_id (uuid, sepa_mandate_id) VALUES ('3d0e6bb5-a62e-4225-a2bb-967c76926705', 30);
INSERT INTO hs_office.sepamandate_legacy_id (uuid, sepa_mandate_id) VALUES ('6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 132);
INSERT INTO hs_office.sepamandate_legacy_id (uuid, sepa_mandate_id) VALUES ('850aa448-3a14-440c-9834-0b7ef6d83c39', 386);
INSERT INTO hs_office.sepamandate_legacy_id (uuid, sepa_mandate_id) VALUES ('1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 387);
INSERT INTO hs_office.sepamandate_legacy_id (uuid, sepa_mandate_id) VALUES ('466056f2-efc6-45d6-b778-fa111db7a18b', 234234);
INSERT INTO hs_office.sepamandate_legacy_id (uuid, sepa_mandate_id) VALUES ('e2dd08d5-2083-44ef-bf22-57898af08e3e', 235600);
INSERT INTO hs_office.sepamandate_legacy_id (uuid, sepa_mandate_id) VALUES ('51a4690c-bb0e-4be2-a285-31552f900db6', 235662);


--
-- Data for Name: databasechangelog; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('base-SCHEMA', 'michael.hoennig', 'db/changelog/0-base/000-base-schema.sql', '2025-01-30 16:35:49.973591', 1, 'EXECUTED', '9:5ad38f09c5cfce85000d90157413112e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('last-row-count', 'michael.hoennig', 'db/changelog/0-base/001-last-row-count.sql', '2025-01-30 16:35:49.998027', 2, 'EXECUTED', '9:40f27b3837ad530535302a833a9cfe3e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('int-to-var', 'michael.hoennig', 'db/changelog/0-base/002-int-to-var.sql', '2025-01-30 16:35:50.018972', 3, 'EXECUTED', '9:8c101fdc053b1b04fd570e6692b6a853', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('random-in-range', 'michael.hoennig', 'db/changelog/0-base/003-random-in-range.sql', '2025-01-30 16:35:50.040057', 4, 'EXECUTED', '9:379a1f08adead68b798107aee5737184', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('JSONB-CHANGES-DELTA', 'michael.hoennig', 'db/changelog/0-base/004-jsonb-changes-delta.sql', '2025-01-30 16:35:50.100446', 5, 'EXECUTED', '9:e636e0d4ed3617a70b459617c2cc8b3c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('uuid-ossp-extension', 'michael.hoennig', 'db/changelog/0-base/005-uuid-ossp-extension.sql', '2025-01-30 16:35:50.118038', 6, 'EXECUTED', '9:a8abcc99c84d1e19bdf591a0f5af3f56', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('numeric-hash-functions', 'michael.hoennig', 'db/changelog/0-base/006-numeric-hash-functions.sql', '2025-01-30 16:35:50.130319', 7, 'EXECUTED', '9:7835429124ebbea01c598f26e6537c6a', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('table-columns-function', 'michael.hoennig', 'db/changelog/0-base/007-table-columns.sql', '2025-01-30 16:35:50.150082', 8, 'EXECUTED', '9:bb868191fbe9c3ba4ac1f8bdc6a75f8c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('RAISE-FUNCTIONS', 'michael.hoennig', 'db/changelog/0-base/008-raise-functions.sql', '2025-01-30 16:35:50.162025', 9, 'EXECUTED', '9:3ceaffba52919b6bfc90a902a944a616', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('ASSERT-FUNCTIONS', 'michael.hoennig', 'db/changelog/0-base/008-raise-functions.sql', '2025-01-30 16:35:50.172505', 10, 'EXECUTED', '9:a0ed7624c59909966e06875f59cfeccb', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hash', 'michael.hoennig', 'db/changelog/0-base/009-check-environment.sql', '2025-01-30 16:35:50.183741', 11, 'EXECUTED', '9:034a82679cf5cf1be4b9729c55621158', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('context-DEFINE', 'michael.hoennig', 'db/changelog/0-base/010-context.sql', '2025-01-30 16:35:50.202274', 12, 'EXECUTED', '9:a8d195345229a2cd835f398b086ee21c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('context-CURRENT-TASK', 'michael.hoennig', 'db/changelog/0-base/010-context.sql', '2025-01-30 16:35:50.213926', 13, 'EXECUTED', '9:4919efeac14bf86c57bed35de501a2b2', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('context-CURRENT-REQUEST', 'michael.hoennig', 'db/changelog/0-base/010-context.sql', '2025-01-30 16:35:50.22341', 14, 'EXECUTED', '9:d1c3bcc3a5b3468daa69e8ed0b324ea5', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('context-current-subject', 'michael.hoennig', 'db/changelog/0-base/010-context.sql', '2025-01-30 16:35:50.238617', 15, 'EXECUTED', '9:663c11875733a9bab362d06086722023', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('context-base.ASSUMED-ROLES', 'michael.hoennig', 'db/changelog/0-base/010-context.sql', '2025-01-30 16:35:50.268168', 16, 'EXECUTED', '9:e2885ddc509186e66c51200d7965ea71', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('base-COMBINE-TABLE-SCHEMA-AND-NAME', 'michael.hoennig', 'db/changelog/0-base/011-table-schema-and-name.sql', '2025-01-30 16:35:50.28754', 17, 'EXECUTED', '9:9345df8e57b4d96e7f7e90f2b6f9db15', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('audit-OPERATION-TYPE', 'michael.hoennig', 'db/changelog/0-base/020-audit-log.sql', '2025-01-30 16:35:50.31383', 18, 'EXECUTED', '9:c0876a331d8559a47e56c386c44a766c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('audit-TX-CONTEXT-TABLE', 'michael.hoennig', 'db/changelog/0-base/020-audit-log.sql', '2025-01-30 16:35:50.33644', 19, 'EXECUTED', '9:203f45b5021e65040704071a01aead4c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('audit-TX-JOURNAL-TABLE', 'michael.hoennig', 'db/changelog/0-base/020-audit-log.sql', '2025-01-30 16:35:50.359416', 20, 'EXECUTED', '9:534f075b40b1d50fcf273c448c5c2703', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('audit-TX-JOURNAL-VIEW', 'michael.hoennig', 'db/changelog/0-base/020-audit-log.sql', '2025-01-30 16:35:50.372867', 21, 'EXECUTED', '9:b0633c27d7b16fab52029b65ba883213', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('audit-TX-JOURNAL-TRIGGER', 'michael.hoennig', 'db/changelog/0-base/020-audit-log.sql', '2025-01-30 16:35:50.434567', 22, 'EXECUTED', '9:414f25221a87a701087b3b7bb4868865', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('audit-CREATE-JOURNAL-LOG', 'michael.hoennig', 'db/changelog/0-base/020-audit-log.sql', '2025-01-30 16:35:50.461024', 23, 'EXECUTED', '9:c6559436bc007f797d5c4b4bfdb68f18', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-global-historization-tx-history-txid', 'michael.hoennig', 'db/changelog/0-base/030-historization.sql', '2025-01-30 16:35:50.481851', 24, 'EXECUTED', '9:c736085285073ed50bf00997240e616d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-global-historization-tx-historicize-tf', 'michael.hoennig', 'db/changelog/0-base/030-historization.sql', '2025-01-30 16:35:50.512946', 25, 'EXECUTED', '9:345716cca165c108edbab1771c3619c1', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-global-historization-tx-create-historicization', 'michael.hoennig', 'db/changelog/0-base/030-historization.sql', '2025-01-30 16:35:50.534851', 26, 'EXECUTED', '9:5b127ea60101bf0fa368cf4c0077a6cf', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-SCHEMA', 'michael.hoennig', 'db/changelog/1-rbac/1000-rbac-schema.sql', '2025-01-30 16:35:50.549214', 27, 'EXECUTED', '9:f08498d55a283e30a44ba6a59728e5a8', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-REFERENCE', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.570793', 28, 'EXECUTED', '9:84d675573e2e88733ee10c4c09b015ce', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-SUBJECT', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.596942', 29, 'EXECUTED', '9:10f7dc267fdd8b001809507858f9d44e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-OBJECT', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.629131', 30, 'EXECUTED', '9:aa3a9e05103db455ce3d31089fdf9521', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-GENERATE-RELATED-OBJECT', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.646429', 31, 'EXECUTED', '9:a79fd4336db173a1743f3ee3950be02b', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-ROLE', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.669947', 32, 'EXECUTED', '9:09df25cdcf2508acd8c5ae4a685c6fda', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-ROLE-DESCRIPTOR', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.691202', 33, 'EXECUTED', '9:3a685a915da4783e308e9c456c4b834a', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-IDNAME-FUNCTIONS', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.719205', 34, 'EXECUTED', '9:5a2be2e0339bebb8f25c92407d4158ba', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-ROLE-FUNCTIONS', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.758104', 35, 'EXECUTED', '9:336c90101a4c61aa9e3e9f917a8318f0', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-BEFORE-DELETE-ROLE-TRIGGER', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.780391', 36, 'EXECUTED', '9:4eda349ef330fa85a57756e4a99ff0f1', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-BEFORE-DELETE-OBJECT-TRIGGER', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.799483', 37, 'EXECUTED', '9:82f081b70545f7f1d1a38c639ff15b89', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-PERMISSION', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.842312', 38, 'EXECUTED', '9:9d5e9d323c630d1d7e49f1088374d28a', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-duplicate-role-grant-exception', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.863667', 39, 'EXECUTED', '9:abcf51b5de6cc4ba064479c7c2e7741e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-GRANTS', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.930335', 40, 'EXECUTED', '9:0dd702f26c3d617fe7a71f7218ffaced', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-QUERY-ACCESSIBLE-OBJECT-UUIDS', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.949724', 41, 'EXECUTED', '9:458e3f137c8fdeb9862e5d0e95b0094f', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-QUERY-GRANTED-PERMISSIONS', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:50.974771', 42, 'EXECUTED', '9:05bcbf6d56c95c400042f100c38637f0', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-QUERY-SUBJECTS-WITH-PERMISSION-FOR-OBJECT', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:51.000185', 43, 'EXECUTED', '9:ebd6a7182547ddcdb9217838c53e7d68', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-base-PGSQL-ROLES', 'michael.hoennig', 'db/changelog/1-rbac/1050-rbac-base.sql', '2025-01-30 16:35:51.018202', 44, 'EXECUTED', '9:a50fd61a191459e25fb01f5fc079f3e7', 'sql', '', NULL, '4.29.2', '!external-db', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-user-grant-GRANT-ROLE-TO-USER', 'michael.hoennig', 'db/changelog/1-rbac/1051-rbac-subject-grant.sql', '2025-01-30 16:35:51.044431', 45, 'EXECUTED', '9:7d0785b50901582050221d58ab11b1e2', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-user-grant-REVOKE-ROLE-FROM-USER', 'michael.hoennig', 'db/changelog/1-rbac/1051-rbac-subject-grant.sql', '2025-01-30 16:35:51.065385', 46, 'EXECUTED', '9:ce6e0a7157afbfdb482a432e2b6e3f43', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-user-grant-REVOKE-PERMISSION-FROM-ROLE', 'michael.hoennig', 'db/changelog/1-rbac/1051-rbac-subject-grant.sql', '2025-01-30 16:35:51.082008', 47, 'EXECUTED', '9:cab4dd9c2a2b8a2a746dfbf1f17946cb', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-context-DETERMINE', 'michael.hoennig', 'db/changelog/1-rbac/1054-rbac-context.sql', '2025-01-30 16:35:51.11175', 48, 'EXECUTED', '9:94e05896d964f327901b72004f1de5a3', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-context-CONTEXT-DEFINED', 'michael.hoennig', 'db/changelog/1-rbac/1054-rbac-context.sql', '2025-01-30 16:35:51.134052', 49, 'EXECUTED', '9:a5520c3244d9fcd8071349c37150400a', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-context-current-subject-ID', 'michael.hoennig', 'db/changelog/1-rbac/1054-rbac-context.sql', '2025-01-30 16:35:51.154847', 50, 'EXECUTED', '9:763774fe9bf9d9d453feef641c685e71', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-context-CURRENT-SUBJECT-UUIDS', 'michael.hoennig', 'db/changelog/1-rbac/1054-rbac-context.sql', '2025-01-30 16:35:51.175992', 51, 'EXECUTED', '9:d43c6fb58da7532a2821f82800618a4d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-ROLE-ENHANCED-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.200154', 52, 'EXECUTED', '9:fbc2f7166cebb5d0211736da2d522ef1', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-ROLE-RESTRICTED-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.215715', 53, 'EXECUTED', '9:cf0b8bfb094b852b639d21b624ac9576', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-GRANT-ENHANCED-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.242757', 54, 'EXECUTED', '9:b1d4a50e1525a300bcda9916d6c49d1c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-GRANT-RESTRICTED-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.261653', 55, 'EXECUTED', '9:e2840e3f1fabbc91d2476894e1a40764', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-GRANTS-RV-INSERT-TRIGGER', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.276935', 56, 'EXECUTED', '9:b809276f65f12a861e50b04a0507d5ee', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-GRANTS-RV-DELETE-TRIGGER', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.28937', 57, 'EXECUTED', '9:acc6fde38d60effa54128d9462484d04', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-USER-ENHANCED-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.309428', 58, 'EXECUTED', '9:12662bbb1b705dc0392ff681501488bf', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-USER-RESTRICTED-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.330571', 59, 'EXECUTED', '9:13148aa24511cb9e5b7737ac32b78eae', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-USER-RV-INSERT-TRIGGER', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.347816', 60, 'EXECUTED', '9:c286e7c287522d0cb1c5f0c9f2bd2967', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-USER-RV-DELETE-TRIGGER', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.365997', 61, 'EXECUTED', '9:03a4e6989597a284bad81440870eed4f', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-OWN-GRANTED-PERMISSIONS-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.393139', 62, 'EXECUTED', '9:5c702b2aa8819205d8c25efce99b1bbd', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-views-GRANTED-PERMISSIONS', 'michael.hoennig', 'db/changelog/1-rbac/1055-rbac-views.sql', '2025-01-30 16:35:51.411062', 63, 'EXECUTED', '9:fb1576f4d379e7cb66b93a9d53de45b2', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-trigger-context-ENTER', 'michael.hoennig', 'db/changelog/1-rbac/1056-rbac-trigger-context.sql', '2025-01-30 16:35:51.425841', 64, 'EXECUTED', '9:e891b11a112193e9316148a42a8f3525', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-trigger-context-CURRENT-ID', 'michael.hoennig', 'db/changelog/1-rbac/1056-rbac-trigger-context.sql', '2025-01-30 16:35:51.442215', 65, 'EXECUTED', '9:975b972288f0de5d8052248f6084c200', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-trigger-context-LEAVE', 'michael.hoennig', 'db/changelog/1-rbac/1056-rbac-trigger-context.sql', '2025-01-30 16:35:51.458871', 66, 'EXECUTED', '9:68f9acbd7d2fd41daa761ecc728d3128', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-role-builder-define-role', 'michael.hoennig', 'db/changelog/1-rbac/1057-rbac-role-builder.sql', '2025-01-30 16:35:51.484875', 67, 'EXECUTED', '9:6a327b337505f8afa5f2db873429636e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-generators-RELATED-OBJECT', 'michael.hoennig', 'db/changelog/1-rbac/1058-rbac-generators.sql', '2025-01-30 16:35:51.506488', 68, 'EXECUTED', '9:0006cac3f0c7a57ddea68f8080214b56', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-generators-ROLE-DESCRIPTORS', 'michael.hoennig', 'db/changelog/1-rbac/1058-rbac-generators.sql', '2025-01-30 16:35:51.534162', 69, 'EXECUTED', '9:3bc9635289e427a065bbeb4118a041fe', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-generators-IDENTITY-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1058-rbac-generators.sql', '2025-01-30 16:35:51.559298', 70, 'EXECUTED', '9:3bc394e73ca91776450708efe5ae213a', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-generators-RESTRICTED-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1058-rbac-generators.sql', '2025-01-30 16:35:51.60381', 71, 'EXECUTED', '9:a486bfc49e34405ba5da0d97e496d909', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-statistics', 'michael.hoennig', 'db/changelog/1-rbac/1059-rbac-statistics.sql', '2025-01-30 16:35:51.629223', 72, 'EXECUTED', '9:b6919db9e9815057048fe612bd431d68', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-OBJECT', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.659427', 73, 'EXECUTED', '9:288acb3380a2a0bcb4ddfd120c08d3a9', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-IS-GLOBAL-ADMIN', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.683964', 74, 'EXECUTED', '9:59f9cde6ee354642d62addebeedf9f05', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-HAS-GLOBAL-ADMIN-ROLE', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.701377', 75, 'EXECUTED', '9:8c449086f4dd8ce63b32d28c16b1a723', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-HAS-GLOBAL-PERMISSION', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.718634', 76, 'EXECUTED', '9:b39359e1f60917b2ee5f373333654f80', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-IDENTITY-VIEW', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.747644', 77, 'EXECUTED', '9:fd11fbd2509564a48b40394e46ff3920', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-PSEUDO-OBJECT', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.77644', 78, 'EXECUTED', '9:f1a0139f0f049753fbd26092ec00b4e2', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-ADMIN-ROLE', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.798335', 79, 'EXECUTED', '9:b8ce7d33d7b7469614010953ee05ab83', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-GUEST-ROLE', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.820593', 80, 'EXECUTED', '9:f5f124a1d50c7b3b9816b554fbd12d11', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-ADMIN-USERS', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.867391', 81, 'EXECUTED', '9:defcefd72b25de449be69d3e3df7134b', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbac-global-TEST', 'michael.hoennig', 'db/changelog/1-rbac/1080-rbac-global.sql', '2025-01-30 16:35:51.890426', 82, 'EXECUTED', '9:8e3fd77650d35f24e56b99ae54ba77f1', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-SCHEMA', 'michael.hoennig', 'db/changelog/2-rbactest/200-rbactest-schema.sql', '2025-01-30 16:35:51.909758', 83, 'EXECUTED', '9:d3ac51d27712286855b340c8a8966231', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('test-customer-MAIN-TABLE', 'michael.hoennig', 'db/changelog/2-rbactest/201-rbactest-customer/2010-rbactest-customer.sql', '2025-01-30 16:35:51.925473', 84, 'EXECUTED', '9:c99c30902fec715c651b38cb2208aab4', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-customer-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/2-rbactest/201-rbactest-customer/2013-rbactest-customer-rbac.sql', '2025-01-30 16:35:51.939866', 85, 'EXECUTED', '9:fc4c1dd970025e35cb8f01ad15e979f9', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-customer-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/2-rbactest/201-rbactest-customer/2013-rbactest-customer-rbac.sql', '2025-01-30 16:35:51.955322', 86, 'EXECUTED', '9:67799ab25eb0e05f61bd0eceeb6e3d9c', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-customer-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/2-rbactest/201-rbactest-customer/2013-rbactest-customer-rbac.sql', '2025-01-30 16:35:51.974256', 87, 'EXECUTED', '9:68c49363f0cf1f86e73ce8d32b975321', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-customer-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/2-rbactest/201-rbactest-customer/2013-rbactest-customer-rbac.sql', '2025-01-30 16:35:52.017303', 88, 'EXECUTED', '9:d26e94936c25c1602bbf9b5f1a4ee257', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-customer-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/2-rbactest/201-rbactest-customer/2013-rbactest-customer-rbac.sql', '2025-01-30 16:35:52.03694', 89, 'EXECUTED', '9:119f0509d140c723342b28a5056b75ad', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-customer-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/2-rbactest/201-rbactest-customer/2013-rbactest-customer-rbac.sql', '2025-01-30 16:35:52.054903', 90, 'EXECUTED', '9:5c06eb501b643f87c63d98d7d1837fcb', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-customer-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/2-rbactest/201-rbactest-customer/2013-rbactest-customer-rbac.sql', '2025-01-30 16:35:52.092842', 91, 'EXECUTED', '9:621dbf5116ee6945b0c198ab9b9fd7a7', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-customer-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/2-rbactest/201-rbactest-customer/2013-rbactest-customer-rbac.sql', '2025-01-30 16:35:52.10949', 92, 'EXECUTED', '9:74a006c77ba4c72c8513860a8215a816', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('test-customer-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/2-rbactest/201-rbactest-customer/2018-rbactest-customer-test-data.sql', '2025-01-30 16:35:52.128069', 93, 'EXECUTED', '9:b86dd5b1bbdd5e74f3ce5badbe58ff4b', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('test-customer-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/2-rbactest/201-rbactest-customer/2018-rbactest-customer-test-data.sql', '2025-01-30 16:35:52.181613', 94, 'EXECUTED', '9:6a1f3542ff30373925a4588f75915fe0', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('test-package-MAIN-TABLE', 'michael.hoennig', 'db/changelog/2-rbactest/202-rbactest-package/2020-rbactest-package.sql', '2025-01-30 16:35:52.193817', 95, 'EXECUTED', '9:b1207c3cbeec15b17583a560d497db8e', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-package-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/2-rbactest/202-rbactest-package/2023-rbactest-package-rbac.sql', '2025-01-30 16:35:52.203239', 96, 'EXECUTED', '9:fe2229e14382e520e6b059929696d807', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-package-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/2-rbactest/202-rbactest-package/2023-rbactest-package-rbac.sql', '2025-01-30 16:35:52.21293', 97, 'EXECUTED', '9:ecd086a55811cec0ed3661c041542fa1', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-package-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/2-rbactest/202-rbactest-package/2023-rbactest-package-rbac.sql', '2025-01-30 16:35:52.228335', 98, 'EXECUTED', '9:77738b7734868c70dad1ff4e4413b4bc', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-package-rbac-update-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/2-rbactest/202-rbactest-package/2023-rbactest-package-rbac.sql', '2025-01-30 16:35:52.255285', 99, 'EXECUTED', '9:9fe9d3fdb0a100a95317e751b6f331ac', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-package-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/2-rbactest/202-rbactest-package/2023-rbactest-package-rbac.sql', '2025-01-30 16:35:52.275929', 100, 'EXECUTED', '9:2e1b24f4168dbf50608f012f0864a043', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-package-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/2-rbactest/202-rbactest-package/2023-rbactest-package-rbac.sql', '2025-01-30 16:35:52.289938', 101, 'EXECUTED', '9:9c3bedfb1f3994c89bfb4b11c2add36b', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-package-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/2-rbactest/202-rbactest-package/2023-rbactest-package-rbac.sql', '2025-01-30 16:35:52.309847', 102, 'EXECUTED', '9:fa6b1290dcfcd0dd889a77b5e474d684', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-package-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/2-rbactest/202-rbactest-package/2023-rbactest-package-rbac.sql', '2025-01-30 16:35:52.339435', 103, 'EXECUTED', '9:3ea749e8c2b32cf54b8a2d24c5e78ba6', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-package-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/2-rbactest/202-rbactest-package/2023-rbactest-package-rbac.sql', '2025-01-30 16:35:52.369331', 104, 'EXECUTED', '9:2b9cc64914d8b21a4457a5a2b33427ec', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('test-package-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/2-rbactest/202-rbactest-package/2028-rbactest-package-test-data.sql', '2025-01-30 16:35:52.392091', 105, 'EXECUTED', '9:7e55635cc0c5d735b9305780b604ad09', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('test-package-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/2-rbactest/202-rbactest-package/2028-rbactest-package-test-data.sql', '2025-01-30 16:35:52.533303', 106, 'EXECUTED', '9:bdd9ef02d8105d1636c33f47885a8e51', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('test-domain-MAIN-TABLE', 'michael.hoennig', 'db/changelog/2-rbactest/203-rbactest-domain/2030-rbactest-domain.sql', '2025-01-30 16:35:52.561072', 107, 'EXECUTED', '9:53f4d2582458bb388217e7b5ab0e9664', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-domain-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/2-rbactest/203-rbactest-domain/2033-rbactest-domain-rbac.sql', '2025-01-30 16:35:52.588086', 108, 'EXECUTED', '9:d204bab1152a2efaed1e5dc05e7369c8', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-domain-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/2-rbactest/203-rbactest-domain/2033-rbactest-domain-rbac.sql', '2025-01-30 16:35:52.614669', 109, 'EXECUTED', '9:2a0a0dc7c11bfd5974cf5d446a39a51a', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-domain-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/2-rbactest/203-rbactest-domain/2033-rbactest-domain-rbac.sql', '2025-01-30 16:35:52.64179', 110, 'EXECUTED', '9:87af80188676c50bf296dc67528a2364', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-domain-rbac-update-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/2-rbactest/203-rbactest-domain/2033-rbactest-domain-rbac.sql', '2025-01-30 16:35:52.680521', 111, 'EXECUTED', '9:01d80772c124a78c5a1288bc704b9977', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-domain-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/2-rbactest/203-rbactest-domain/2033-rbactest-domain-rbac.sql', '2025-01-30 16:35:52.714471', 112, 'EXECUTED', '9:06a1011f8b783fef17e9fd48a1a9ca49', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-domain-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/2-rbactest/203-rbactest-domain/2033-rbactest-domain-rbac.sql', '2025-01-30 16:35:52.726662', 113, 'EXECUTED', '9:b6e2a6fa8c27365969393661debb4101', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-domain-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/2-rbactest/203-rbactest-domain/2033-rbactest-domain-rbac.sql', '2025-01-30 16:35:52.738945', 114, 'EXECUTED', '9:5e0146fd8331675fbbb81e7e2826016b', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-domain-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/2-rbactest/203-rbactest-domain/2033-rbactest-domain-rbac.sql', '2025-01-30 16:35:52.770847', 115, 'EXECUTED', '9:698ebc486e2704e875e4aaea85a2c144', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('rbactest-domain-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/2-rbactest/203-rbactest-domain/2033-rbactest-domain-rbac.sql', '2025-01-30 16:35:52.785751', 116, 'EXECUTED', '9:102757b00137fae714c516caad4e52ff', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-domain-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/2-rbactest/203-rbactest-domain/2038-rbactest-domain-test-data.sql', '2025-01-30 16:35:52.819916', 117, 'EXECUTED', '9:7ff9deffb24493195e5cfee796492a7a', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-domain-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/2-rbactest/203-rbactest-domain/2038-rbactest-domain-test-data.sql', '2025-01-30 16:35:52.998514', 118, 'EXECUTED', '9:02a0d097decd631c52f3504252a8e25f', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-SCHEMA', 'michael.hoennig', 'db/changelog/5-hs-office/500-hs-office-schema.sql', '2025-01-30 16:35:53.012059', 119, 'EXECUTED', '9:95af3304188550e45b497aacc9552a0e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-MAIN-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5010-hs-office-contact.sql', '2025-01-30 16:35:53.028073', 120, 'EXECUTED', '9:bd3868a9d6417d250c8fa5eaf06cdda1', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-MAIN-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5010-hs-office-contact.sql', '2025-01-30 16:35:53.036963', 121, 'EXECUTED', '9:53c099cb757a95e71a86f8f5211c9c2f', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/501-contact/5013-hs-office-contact-rbac.sql', '2025-01-30 16:35:53.04859', 122, 'EXECUTED', '9:e8a20b6295686c71c125d77f579194f2', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/501-contact/5013-hs-office-contact-rbac.sql', '2025-01-30 16:35:53.065843', 123, 'EXECUTED', '9:87dae05d3dfb3030a7c56927a4da7f45', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/501-contact/5013-hs-office-contact-rbac.sql', '2025-01-30 16:35:53.079835', 124, 'EXECUTED', '9:0bcfe1779f0ffbacab92db389872e096', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/501-contact/5013-hs-office-contact-rbac.sql', '2025-01-30 16:35:53.089925', 125, 'EXECUTED', '9:97aa885eefed9ed6a62a9b9888838431', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/501-contact/5013-hs-office-contact-rbac.sql', '2025-01-30 16:35:53.115237', 126, 'EXECUTED', '9:093e1b9419923dc0055110229adaee14', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/501-contact/5013-hs-office-contact-rbac.sql', '2025-01-30 16:35:53.128438', 127, 'EXECUTED', '9:eb2ad24e9d7090e2a8f876a597beeff8', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-MIGRATION-legacy-mapping', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5016-hs-office-contact-migration.sql', '2025-01-30 16:35:53.13962', 128, 'EXECUTED', '9:e9e8e9301086e3790ad67fe484a4043c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-MIGRATION-sequence', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5016-hs-office-contact-migration.sql', '2025-01-30 16:35:53.148568', 129, 'EXECUTED', '9:a8afcc443b88cdbd828e26b058ed36db', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-MIGRATION-default', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5016-hs-office-contact-migration.sql', '2025-01-30 16:35:53.157126', 130, 'EXECUTED', '9:a101121181b4470b757a4cdacc14659e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-MIGRATION-insert', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5016-hs-office-contact-migration.sql', '2025-01-30 16:35:53.170045', 131, 'EXECUTED', '9:8e1511d5bc132902db31485841bd1a48', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-MIGRATION-insert-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5016-hs-office-contact-migration.sql', '2025-01-30 16:35:53.195146', 132, 'EXECUTED', '9:bd39d996cabd921232ebec69b749985e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-MIGRATION-delete-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5016-hs-office-contact-migration.sql', '2025-01-30 16:35:53.213928', 133, 'EXECUTED', '9:114fb1ab2b30bca25d060fa574c45c41', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5018-hs-office-contact-test-data.sql', '2025-01-30 16:35:53.234426', 134, 'EXECUTED', '9:f95a0ee739481fc948d751336d3a53ce', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-contact-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/501-contact/5018-hs-office-contact-test-data.sql', '2025-01-30 16:35:53.381073', 135, 'EXECUTED', '9:aefb1653864621419bbc33d21a80623a', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-MAIN-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/502-person/5020-hs-office-person.sql', '2025-01-30 16:35:53.395597', 136, 'EXECUTED', '9:b21ba5a82adefc2bab915f5abcc1a54d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-MAIN-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/502-person/5020-hs-office-person.sql', '2025-01-30 16:35:53.40733', 137, 'EXECUTED', '9:06b9a35487c7405e08d13753df1818c4', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/502-person/5023-hs-office-person-rbac.sql', '2025-01-30 16:35:53.415847', 138, 'EXECUTED', '9:7271b4a8bee2993867280c01973b1038', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/502-person/5023-hs-office-person-rbac.sql', '2025-01-30 16:35:53.428768', 139, 'EXECUTED', '9:febbde4cf2b9ae6b0492bc0f8683878d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/502-person/5023-hs-office-person-rbac.sql', '2025-01-30 16:35:53.44894', 140, 'EXECUTED', '9:a2b9fcf71c677f27b8336373a43769f3', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/502-person/5023-hs-office-person-rbac.sql', '2025-01-30 16:35:53.465367', 141, 'EXECUTED', '9:996ec48861e791fcc446495368290e4d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/502-person/5023-hs-office-person-rbac.sql', '2025-01-30 16:35:53.495557', 142, 'EXECUTED', '9:46d217d0f46a225e463b77ee32320efe', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/502-person/5023-hs-office-person-rbac.sql', '2025-01-30 16:35:53.523838', 143, 'EXECUTED', '9:204efdb868707ac9a7f358ca84e64d7b', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/502-person/5028-hs-office-person-test-data.sql', '2025-01-30 16:35:53.543763', 144, 'EXECUTED', '9:560570c48ec48107b3b0f896933e4e9c', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-person-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/502-person/5028-hs-office-person-test-data.sql', '2025-01-30 16:35:53.688962', 145, 'EXECUTED', '9:975c5d6793e83a2c876753d6cceff8d9', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-MAIN-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/503-relation/5030-hs-office-relation.sql', '2025-01-30 16:35:53.701285', 146, 'EXECUTED', '9:86cdab39361d2c0d41ec13c3007cdeee', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-unique-constraints', 'michael.hoennig', 'db/changelog/5-hs-office/503-relation/5030-hs-office-relation.sql', '2025-01-30 16:35:53.714662', 147, 'EXECUTED', '9:4a455dac69cc17c9a21bde5bb1d72123', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-MAIN-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/503-relation/5030-hs-office-relation.sql', '2025-01-30 16:35:53.72458', 148, 'EXECUTED', '9:13f528e4b745751dfcf6e0aa8b31a86e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/503-relation/5033-hs-office-relation-rbac.sql', '2025-01-30 16:35:53.733054', 149, 'EXECUTED', '9:62d3835be0ca79ae9a5c397ba36ccf18', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/503-relation/5033-hs-office-relation-rbac.sql', '2025-01-30 16:35:53.741999', 150, 'EXECUTED', '9:8f604a50201fcc189ef4ad6465b0f87d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/503-relation/5033-hs-office-relation-rbac.sql', '2025-01-30 16:35:53.768735', 151, 'EXECUTED', '9:8d3b3682fd4f331d560f9609e9df3611', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-rbac-update-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/503-relation/5033-hs-office-relation-rbac.sql', '2025-01-30 16:35:53.790859', 152, 'EXECUTED', '9:843a2d517a737612f679b586b22dfa1f', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/503-relation/5033-hs-office-relation-rbac.sql', '2025-01-30 16:35:53.815683', 153, 'EXECUTED', '9:16a25331076d4fe2529906937e513eb0', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/503-relation/5033-hs-office-relation-rbac.sql', '2025-01-30 16:35:53.826696', 154, 'EXECUTED', '9:6b8fb2185819dac7871c748fec67c19c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/503-relation/5033-hs-office-relation-rbac.sql', '2025-01-30 16:35:53.836762', 155, 'EXECUTED', '9:837d545cc3a79d543491e2d76ae76918', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/503-relation/5033-hs-office-relation-rbac.sql', '2025-01-30 16:35:53.856212', 156, 'EXECUTED', '9:5350c22ca984311f09a102000551a06a', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/503-relation/5033-hs-office-relation-rbac.sql', '2025-01-30 16:35:53.869776', 157, 'EXECUTED', '9:aef36d49fbfd9e9e6b44408a56e0dc4e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/503-relation/5038-hs-office-relation-test-data.sql', '2025-01-30 16:35:53.889871', 158, 'EXECUTED', '9:a606bdf3b74daaf68e89b771ab5a5f83', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-relation-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/503-relation/5038-hs-office-relation-test-data.sql', '2025-01-30 16:35:54.178985', 159, 'EXECUTED', '9:444d28cfb2fa8234930dc9912f7dbf97', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-DETAILS-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5040-hs-office-partner.sql', '2025-01-30 16:35:54.188929', 160, 'EXECUTED', '9:07885059d4d27b328da5cb98518640fe', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-DETAILS-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5040-hs-office-partner.sql', '2025-01-30 16:35:54.196025', 161, 'EXECUTED', '9:37bd59be01e36bef353fedf2ab699098', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-MAIN-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5040-hs-office-partner.sql', '2025-01-30 16:35:54.208783', 162, 'EXECUTED', '9:0201fea673d545f158bb5910fc9d0d17', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-DELETE-DEPENDENTS-TRIGGER', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5040-hs-office-partner.sql', '2025-01-30 16:35:54.220898', 163, 'EXECUTED', '9:4b849a6a05772609a448564e839445e3', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-MAIN-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5040-hs-office-partner.sql', '2025-01-30 16:35:54.228367', 164, 'EXECUTED', '9:5d9a0eab674f574b199594f056bd0b32', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/504-partner/5043-hs-office-partner-rbac.sql', '2025-01-30 16:35:54.235883', 165, 'EXECUTED', '9:99fb95a8e62697841e58a1bb4b10c949', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/504-partner/5043-hs-office-partner-rbac.sql', '2025-01-30 16:35:54.244952', 166, 'EXECUTED', '9:133005f2f871355ae47a9f648fe9c12f', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/504-partner/5043-hs-office-partner-rbac.sql', '2025-01-30 16:35:54.268493', 167, 'EXECUTED', '9:fae9a12e3dc592bb62711b8d1770ce46', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-rbac-update-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/504-partner/5043-hs-office-partner-rbac.sql', '2025-01-30 16:35:54.298118', 168, 'EXECUTED', '9:5f673c674692de67315c230c74de1cbf', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/504-partner/5043-hs-office-partner-rbac.sql', '2025-01-30 16:35:54.317863', 169, 'EXECUTED', '9:7828179bad8fd8a82a54075753da17a7', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/504-partner/5043-hs-office-partner-rbac.sql', '2025-01-30 16:35:54.329602', 170, 'EXECUTED', '9:3efc4e4a17da6e225c808c6fcc159603', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/504-partner/5043-hs-office-partner-rbac.sql', '2025-01-30 16:35:54.342114', 171, 'EXECUTED', '9:97c7a6e0462732c51130e1b3fb8bdb81', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/504-partner/5043-hs-office-partner-rbac.sql', '2025-01-30 16:35:54.359789', 172, 'EXECUTED', '9:2cf5ed77894e41337859cfb8d5d6232c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/504-partner/5043-hs-office-partner-rbac.sql', '2025-01-30 16:35:54.37219', 173, 'EXECUTED', '9:e7ac0d2761e29703e7d6da089962ac89', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-details-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/504-partner/5044-hs-office-partner-details-rbac.sql', '2025-01-30 16:35:54.383438', 174, 'EXECUTED', '9:100aa26a8e93898e56c1779a7453fb67', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-details-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/504-partner/5044-hs-office-partner-details-rbac.sql', '2025-01-30 16:35:54.392662', 175, 'EXECUTED', '9:9529764d7ae47527e87aac4b5ad58c7d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-details-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/504-partner/5044-hs-office-partner-details-rbac.sql', '2025-01-30 16:35:54.403912', 176, 'EXECUTED', '9:96cf3d4a24ca5d100282c7f788d43b3b', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-details-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/504-partner/5044-hs-office-partner-details-rbac.sql', '2025-01-30 16:35:54.420931', 177, 'EXECUTED', '9:8f57444b7ba0dce36772c994af77e49f', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-details-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/504-partner/5044-hs-office-partner-details-rbac.sql', '2025-01-30 16:35:54.432754', 178, 'EXECUTED', '9:e690b91d50d17b6bb41cfb27766066b0', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-details-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/504-partner/5044-hs-office-partner-details-rbac.sql', '2025-01-30 16:35:54.44664', 179, 'EXECUTED', '9:79e0da7d5107ed61f17ea4e165dc8945', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-details-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/504-partner/5044-hs-office-partner-details-rbac.sql', '2025-01-30 16:35:54.477827', 180, 'EXECUTED', '9:9eb01d87b429f2c138b7d5176bf5db26', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-details-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/504-partner/5044-hs-office-partner-details-rbac.sql', '2025-01-30 16:35:54.49124', 181, 'EXECUTED', '9:967f05730d37d71cdfb18e2382937a57', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-MIGRATION-legacy-mapping', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5046-hs-office-partner-migration.sql', '2025-01-30 16:35:54.502027', 182, 'EXECUTED', '9:00f12db8bec33a1276b8f597decae0a6', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-MIGRATION-sequence', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5046-hs-office-partner-migration.sql', '2025-01-30 16:35:54.511549', 183, 'EXECUTED', '9:78db6dfb3b1778869277a8e42cc063ba', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-MIGRATION-default', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5046-hs-office-partner-migration.sql', '2025-01-30 16:35:54.523583', 184, 'EXECUTED', '9:97805e89d388a278a1071618e26e2f91', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-MIGRATION-insert', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5046-hs-office-partner-migration.sql', '2025-01-30 16:35:54.535984', 185, 'EXECUTED', '9:06826ce261f4ead46c2ffe68f79f520c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-MIGRATION-insert-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5046-hs-office-partner-migration.sql', '2025-01-30 16:35:54.547777', 186, 'EXECUTED', '9:801e5870315de722dd90b1ae212eb3c9', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-MIGRATION-delete-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5046-hs-office-partner-migration.sql', '2025-01-30 16:35:54.558795', 187, 'EXECUTED', '9:d18c1da68e3e6d51cb4f5338eb59c40d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5048-hs-office-partner-test-data.sql', '2025-01-30 16:35:54.577261', 188, 'EXECUTED', '9:5784e97b2806466ed4eba66bcfd49767', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-partner-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/504-partner/5048-hs-office-partner-test-data.sql', '2025-01-30 16:35:54.638584', 189, 'EXECUTED', '9:68954862172fa707bfa0893ba1f991c7', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('raw', 'includeAll', 'db/changelog/5-hs-office/505-bankaccount/5050-hs-office-bankaccount.sql', '2025-01-30 16:35:54.655374', 190, 'EXECUTED', '9:00022f725212f8ae1909262841948bb1', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-bankaccount-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/505-bankaccount/5053-hs-office-bankaccount-rbac.sql', '2025-01-30 16:35:54.665161', 191, 'EXECUTED', '9:7b14c584ffa7061a57ff5142dbc851f4', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-bankaccount-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/505-bankaccount/5053-hs-office-bankaccount-rbac.sql', '2025-01-30 16:35:54.677493', 192, 'EXECUTED', '9:26e78f0ccb9239d8ba1be81f48293fcd', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-bankaccount-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/505-bankaccount/5053-hs-office-bankaccount-rbac.sql', '2025-01-30 16:35:54.694486', 193, 'EXECUTED', '9:f09c1aa5e54888fe71cc6f38d6e6d1dc', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-bankaccount-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/505-bankaccount/5053-hs-office-bankaccount-rbac.sql', '2025-01-30 16:35:54.703942', 194, 'EXECUTED', '9:b1409959b111083b3cf0e3c669f5024b', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-bankaccount-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/505-bankaccount/5053-hs-office-bankaccount-rbac.sql', '2025-01-30 16:35:54.724254', 195, 'EXECUTED', '9:6915edcb6fda80537e3876ce890b021a', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-bankaccount-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/505-bankaccount/5053-hs-office-bankaccount-rbac.sql', '2025-01-30 16:35:54.73739', 196, 'EXECUTED', '9:912589683b5a8710bd01c70f3ae91e7b', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-bankaccount-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/505-bankaccount/5058-hs-office-bankaccount-test-data.sql', '2025-01-30 16:35:54.74712', 197, 'EXECUTED', '9:6c8c2360466515f1d5404d8446222ac4', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-bankaccount-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/505-bankaccount/5058-hs-office-bankaccount-test-data.sql', '2025-01-30 16:35:54.809968', 198, 'EXECUTED', '9:df706b6d445dabec00fbfb90d13aebc9', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-MAIN-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/506-debitor/5060-hs-office-debitor.sql', '2025-01-30 16:35:54.827604', 199, 'EXECUTED', '9:e35607826fc17ead65711ac55a63d62e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-DELETE-DEPENDENTS-TRIGGER', 'michael.hoennig', 'db/changelog/5-hs-office/506-debitor/5060-hs-office-debitor.sql', '2025-01-30 16:35:54.83874', 200, 'EXECUTED', '9:c2f4ce2f8fa13549a8566edd29ac25f0', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-MAIN-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/506-debitor/5060-hs-office-debitor.sql', '2025-01-30 16:35:54.845727', 201, 'EXECUTED', '9:942a0ffeb44c31900d60a854c8e21529', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/506-debitor/5063-hs-office-debitor-rbac.sql', '2025-01-30 16:35:54.854105', 202, 'EXECUTED', '9:097db1b8d04268c1c8e472b318d6198f', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/506-debitor/5063-hs-office-debitor-rbac.sql', '2025-01-30 16:35:54.862437', 203, 'EXECUTED', '9:4ff230a43a56670eb11167f26095fd00', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/506-debitor/5063-hs-office-debitor-rbac.sql', '2025-01-30 16:35:54.884524', 204, 'EXECUTED', '9:5833902da14fd902bdd61f962ddc4d89', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-rbac-update-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/506-debitor/5063-hs-office-debitor-rbac.sql', '2025-01-30 16:35:54.900037', 205, 'EXECUTED', '9:0417bc8650f40e08ff8325c211d6a4db', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/506-debitor/5063-hs-office-debitor-rbac.sql', '2025-01-30 16:35:54.916098', 206, 'EXECUTED', '9:0bbd61a430bd2857a0aa8b8efbc811f3', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/506-debitor/5063-hs-office-debitor-rbac.sql', '2025-01-30 16:35:54.926816', 207, 'EXECUTED', '9:4f767b3b03c431b83259c199b2d4214b', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/506-debitor/5063-hs-office-debitor-rbac.sql', '2025-01-30 16:35:54.942518', 208, 'EXECUTED', '9:e7a4ecf70b9d0427ba4aea1f1cc3f5f0', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/506-debitor/5063-hs-office-debitor-rbac.sql', '2025-01-30 16:35:54.958972', 209, 'EXECUTED', '9:759a74535fd82b597a4e407f7c0031e3', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/506-debitor/5063-hs-office-debitor-rbac.sql', '2025-01-30 16:35:54.973382', 210, 'EXECUTED', '9:f7511c63df1fc5fada3aaf29732576b8', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/506-debitor/5068-hs-office-debitor-test-data.sql', '2025-01-30 16:35:54.98627', 211, 'EXECUTED', '9:5814acc278280e3626fdba84ff8305e6', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-debitor-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/506-debitor/5068-hs-office-debitor-test-data.sql', '2025-01-30 16:35:55.057428', 212, 'EXECUTED', '9:0e8e69092abdd93ae7bff89f45495ac2', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-MAIN-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5070-hs-office-sepamandate.sql', '2025-01-30 16:35:55.072636', 213, 'EXECUTED', '9:7094f5fd111cb53c5cfe3d352744fd36', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-MAIN-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5070-hs-office-sepamandate.sql', '2025-01-30 16:35:55.081129', 214, 'EXECUTED', '9:7b387b6dbaeac43b2c33445a6709b2c7', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/507-sepamandate/5073-hs-office-sepamandate-rbac.sql', '2025-01-30 16:35:55.091225', 215, 'EXECUTED', '9:be4e6cdfc4ad11a7e025bf38651f34d1', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/507-sepamandate/5073-hs-office-sepamandate-rbac.sql', '2025-01-30 16:35:55.099651', 216, 'EXECUTED', '9:44b3251af2898fde9813eb7398b906a3', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/507-sepamandate/5073-hs-office-sepamandate-rbac.sql', '2025-01-30 16:35:55.114884', 217, 'EXECUTED', '9:17cb0a4439da270ab15600fed60b257d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/507-sepamandate/5073-hs-office-sepamandate-rbac.sql', '2025-01-30 16:35:55.132829', 218, 'EXECUTED', '9:83f68f08d1b37c3bd228a8d322ab3fe7', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/507-sepamandate/5073-hs-office-sepamandate-rbac.sql', '2025-01-30 16:35:55.144481', 219, 'EXECUTED', '9:3cb7b97d9ac43a2fc1a46873af943d78', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/507-sepamandate/5073-hs-office-sepamandate-rbac.sql', '2025-01-30 16:35:55.154192', 220, 'EXECUTED', '9:77bc5f87dd7cc5757e2e3eccd9e8ba90', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/507-sepamandate/5073-hs-office-sepamandate-rbac.sql', '2025-01-30 16:35:55.174818', 221, 'EXECUTED', '9:56cb083ac90933d246be79b750bfe6c9', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/507-sepamandate/5073-hs-office-sepamandate-rbac.sql', '2025-01-30 16:35:55.201317', 222, 'EXECUTED', '9:0c9130f70f86c9512e57c035375b4081', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-MIGRATION-legacy-mapping', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5076-hs-office-sepamandate-migration.sql', '2025-01-30 16:35:55.220551', 223, 'EXECUTED', '9:85c63a4e5f2880f9cc27cba3f513a693', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-MIGRATION-sequence', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5076-hs-office-sepamandate-migration.sql', '2025-01-30 16:35:55.242552', 224, 'EXECUTED', '9:e4a182f0eea5ab0db7eb7c115f3aba90', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-MIGRATION-default', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5076-hs-office-sepamandate-migration.sql', '2025-01-30 16:35:55.258286', 225, 'EXECUTED', '9:5341a47b4c52b16b5493eb2b6fe8e391', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-MIGRATION-insert', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5076-hs-office-sepamandate-migration.sql', '2025-01-30 16:35:55.279889', 226, 'EXECUTED', '9:0cac585727746de1df9bd85e43c3253f', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-MIGRATION-insert-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5076-hs-office-sepamandate-migration.sql', '2025-01-30 16:35:55.299508', 227, 'EXECUTED', '9:4e13d6ba612be4d16ac470eff321ac55', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepamandate-MIGRATION-delete-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5076-hs-office-sepamandate-migration.sql', '2025-01-30 16:35:55.308592', 228, 'EXECUTED', '9:6a438bb2441c476f19c8adecfc0ada7e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepaMandate-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5078-hs-office-sepamandate-test-data.sql', '2025-01-30 16:35:55.324084', 229, 'EXECUTED', '9:da502a02cd3b95f897fbaa82d5d2711e', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-sepaMandate-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/507-sepamandate/5078-hs-office-sepamandate-test-data.sql', '2025-01-30 16:35:55.424733', 230, 'EXECUTED', '9:d0dfa2ba5d05e930884952d5c833f27b', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-MAIN-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/510-membership/5100-hs-office-membership.sql', '2025-01-30 16:35:55.442306', 231, 'EXECUTED', '9:5cb327f0ee0e6dad2ff7b2add1046b31', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-MAIN-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/510-membership/5100-hs-office-membership.sql', '2025-01-30 16:35:55.451835', 232, 'EXECUTED', '9:ebca1dd23c9ebcd49f948628a04eab96', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/510-membership/5103-hs-office-membership-rbac.sql', '2025-01-30 16:35:55.461096', 233, 'EXECUTED', '9:38e75a8432730f0abb7eb57bcac7d15d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/510-membership/5103-hs-office-membership-rbac.sql', '2025-01-30 16:35:55.470803', 234, 'EXECUTED', '9:9f9dc3a42a2c807edb65d9c8e689c227', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/510-membership/5103-hs-office-membership-rbac.sql', '2025-01-30 16:35:55.48822', 235, 'EXECUTED', '9:d35b18a0737ac5278f837ebcc96f0083', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/510-membership/5103-hs-office-membership-rbac.sql', '2025-01-30 16:35:55.508002', 236, 'EXECUTED', '9:31da52dd1bb16e3c6fcbb843c0b9806b', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/510-membership/5103-hs-office-membership-rbac.sql', '2025-01-30 16:35:55.520183', 237, 'EXECUTED', '9:fefecd0ba599565d22076b6841661401', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/510-membership/5103-hs-office-membership-rbac.sql', '2025-01-30 16:35:55.532733', 238, 'EXECUTED', '9:5f2dd8c715fdf8e9ef499ee80fcea24b', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/510-membership/5103-hs-office-membership-rbac.sql', '2025-01-30 16:35:55.54932', 239, 'EXECUTED', '9:79db5ea41b711b2607b92ac0ea1d569a', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/510-membership/5103-hs-office-membership-rbac.sql', '2025-01-30 16:35:55.582087', 240, 'EXECUTED', '9:8baae4dbdd21b162cd3ca7c8a939223d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/510-membership/5108-hs-office-membership-test-data.sql', '2025-01-30 16:35:55.591488', 241, 'EXECUTED', '9:37c578f9a81df435f496dc7e7e5c6200', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-membership-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/510-membership/5108-hs-office-membership-test-data.sql', '2025-01-30 16:35:55.662757', 242, 'EXECUTED', '9:d1d9cb1a678983f3860e4865362fcffc', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopshares-MAIN-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5110-hs-office-coopshares.sql', '2025-01-30 16:35:55.679669', 243, 'EXECUTED', '9:dd5642d53c66a58f6b90d5e8f0b2eefd', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopshares-BUSINESS-RULES', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5110-hs-office-coopshares.sql', '2025-01-30 16:35:55.689921', 244, 'EXECUTED', '9:be3db6ea2b92031072765cdcc1c0ad38', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopshares-SHARE-COUNT-CONSTRAINT', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5110-hs-office-coopshares.sql', '2025-01-30 16:35:55.702202', 245, 'EXECUTED', '9:d8433344adbc9d103f77a152bfe150c0', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopshares-MAIN-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5110-hs-office-coopshares.sql', '2025-01-30 16:35:55.711809', 246, 'EXECUTED', '9:5e302243d9bfabf507630b5e074ac4ec', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopsharetx-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/511-coopshares/5113-hs-office-coopshares-rbac.sql', '2025-01-30 16:35:55.72191', 247, 'EXECUTED', '9:d3421993f41f43c4b99cb1afbb614d39', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopsharetx-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/511-coopshares/5113-hs-office-coopshares-rbac.sql', '2025-01-30 16:35:55.73353', 248, 'EXECUTED', '9:48097391a78abef6b3b3bfec2a92b338', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopsharetx-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/511-coopshares/5113-hs-office-coopshares-rbac.sql', '2025-01-30 16:35:55.750221', 249, 'EXECUTED', '9:dca08c5d3d8f82e02438878022b1f81d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopsharetx-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/511-coopshares/5113-hs-office-coopshares-rbac.sql', '2025-01-30 16:35:55.77195', 250, 'EXECUTED', '9:50469fbd535cd90ae0eacb79083067e3', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopsharetx-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/511-coopshares/5113-hs-office-coopshares-rbac.sql', '2025-01-30 16:35:55.787179', 251, 'EXECUTED', '9:dff51f901834806905f0a032960b3da3', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopsharetx-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/511-coopshares/5113-hs-office-coopshares-rbac.sql', '2025-01-30 16:35:55.801551', 252, 'EXECUTED', '9:324a03d0c8858aff81b457aff02feeb4', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopsharetx-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/511-coopshares/5113-hs-office-coopshares-rbac.sql', '2025-01-30 16:35:55.821001', 253, 'EXECUTED', '9:1ea81886c6351b59f1408645c17b8dbe', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopsharetx-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/511-coopshares/5113-hs-office-coopshares-rbac.sql', '2025-01-30 16:35:55.834715', 254, 'EXECUTED', '9:952da62b0a67d7d1e9f951d14d37889f', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopshares-MIGRATION-legacy-mapping', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5116-hs-office-coopshares-migration.sql', '2025-01-30 16:35:55.846525', 255, 'EXECUTED', '9:361f46900a3867db4cdea155550a9694', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopshares-MIGRATION-sequence', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5116-hs-office-coopshares-migration.sql', '2025-01-30 16:35:55.858677', 256, 'EXECUTED', '9:dfa74018490986a7aa2d28c890fa8b1d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopshares-MIGRATION-default', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5116-hs-office-coopshares-migration.sql', '2025-01-30 16:35:55.866964', 257, 'EXECUTED', '9:3e3d01d4d5416ce58b51e2823153a934', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopshares-MIGRATION-insert', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5116-hs-office-coopshares-migration.sql', '2025-01-30 16:35:55.876658', 258, 'EXECUTED', '9:8b5ed8e4e8376ba793aaa55219e0d0f9', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopShares-MIGRATION-insert-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5116-hs-office-coopshares-migration.sql', '2025-01-30 16:35:55.88681', 259, 'EXECUTED', '9:465888aa1bf6053a5a76bcaeda506fa7', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopShares-MIGRATION-delete-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5116-hs-office-coopshares-migration.sql', '2025-01-30 16:35:55.897586', 260, 'EXECUTED', '9:ace1b952c692a0f453a2878a5796041c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopSharesTransaction-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5118-hs-office-coopshares-test-data.sql', '2025-01-30 16:35:55.911455', 261, 'EXECUTED', '9:ee804e35a6ef6f17acb96a9dc7630622', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopSharesTransaction-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/511-coopshares/5118-hs-office-coopshares-test-data.sql', '2025-01-30 16:35:55.961931', 262, 'EXECUTED', '9:efc373aebc1de8e6fb9904225e372b8f', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassets-MAIN-TABLE', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5120-hs-office-coopassets.sql', '2025-01-30 16:35:55.980647', 263, 'EXECUTED', '9:5157878ebca481817b080219de4ec9d0', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassets-BUSINESS-RULES', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5120-hs-office-coopassets.sql', '2025-01-30 16:35:55.99333', 264, 'EXECUTED', '9:008c73cb2883353bfad0a7b4b91ec16d', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassets-ASSET-VALUE-CONSTRAINT', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5120-hs-office-coopassets.sql', '2025-01-30 16:35:56.003201', 265, 'EXECUTED', '9:cf831a455813de1d54dbaaea5f0588fc', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassets-MAIN-TABLE-JOURNAL', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5120-hs-office-coopassets.sql', '2025-01-30 16:35:56.01028', 266, 'EXECUTED', '9:13ee6812125cb02968ada8a92af47c75', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassettx-rbac-OBJECT', 'RbacObjectGenerator', 'db/changelog/5-hs-office/512-coopassets/5123-hs-office-coopassets-rbac.sql', '2025-01-30 16:35:56.017627', 267, 'EXECUTED', '9:571ffbd8c6ce5070fa72e25434e2d819', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassettx-rbac-ROLE-DESCRIPTORS', 'RbacRoleDescriptorsGenerator', 'db/changelog/5-hs-office/512-coopassets/5123-hs-office-coopassets-rbac.sql', '2025-01-30 16:35:56.026042', 268, 'EXECUTED', '9:81ea7ebfba6746f9b82c4dc4b2cd247b', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassettx-rbac-insert-trigger', 'RolesGrantsAndPermissionsGenerator', 'db/changelog/5-hs-office/512-coopassets/5123-hs-office-coopassets-rbac.sql', '2025-01-30 16:35:56.039202', 269, 'EXECUTED', '9:bc0a4b78b806fbe53c62425612812467', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassettx-rbac-GRANTING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/512-coopassets/5123-hs-office-coopassets-rbac.sql', '2025-01-30 16:35:56.058545', 270, 'EXECUTED', '9:72c95623dd7b39dd7ee9cf8f4557a182', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassettx-rbac-CHECKING-INSERT-PERMISSION', 'InsertTriggerGenerator', 'db/changelog/5-hs-office/512-coopassets/5123-hs-office-coopassets-rbac.sql', '2025-01-30 16:35:56.068465', 271, 'EXECUTED', '9:d76e9461931e5143dafe96cd88335bb2', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassettx-rbac-IDENTITY-VIEW', 'RbacIdentityViewGenerator', 'db/changelog/5-hs-office/512-coopassets/5123-hs-office-coopassets-rbac.sql', '2025-01-30 16:35:56.078692', 272, 'EXECUTED', '9:2fcdd71e8c918eda052e10fbde75278e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassettx-rbac-RESTRICTED-VIEW', 'RbacRestrictedViewGenerator', 'db/changelog/5-hs-office/512-coopassets/5123-hs-office-coopassets-rbac.sql', '2025-01-30 16:35:56.093114', 273, 'EXECUTED', '9:83f4252251daaa81aa670520a1a13a06', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassettx-rbac-rebuild', 'RbacRbacSystemRebuildGenerator', 'db/changelog/5-hs-office/512-coopassets/5123-hs-office-coopassets-rbac.sql', '2025-01-30 16:35:56.110089', 274, 'EXECUTED', '9:d607c71372e6059880bc905c817451d8', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassets-MIGRATION-legacy-mapping', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5126-hs-office-coopassets-migration.sql', '2025-01-30 16:35:56.122734', 275, 'EXECUTED', '9:c5ff3e7587acde442cae7de66fb2001c', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassets-MIGRATION-sequence', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5126-hs-office-coopassets-migration.sql', '2025-01-30 16:35:56.136155', 276, 'EXECUTED', '9:cf6ab0aefc52d21bae832899f0523d1e', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassets-MIGRATION-default', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5126-hs-office-coopassets-migration.sql', '2025-01-30 16:35:56.144265', 277, 'EXECUTED', '9:ef2459889790a7d6950d1acddee76a21', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopassets-MIGRATION-insert', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5126-hs-office-coopassets-migration.sql', '2025-01-30 16:35:56.153227', 278, 'EXECUTED', '9:3c77d48e979b54d2cc3864228fc5d234', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopAssets-MIGRATION-insert-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5126-hs-office-coopassets-migration.sql', '2025-01-30 16:35:56.163376', 279, 'EXECUTED', '9:110c20c2c46897bafcf994ddf426d2b3', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopAssets-MIGRATION-delete-trigger', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5126-hs-office-coopassets-migration.sql', '2025-01-30 16:35:56.175489', 280, 'EXECUTED', '9:51e3f23a1d481d94050287be951a66e2', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopAssetsTransaction-TEST-DATA-GENERATOR', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5128-hs-office-coopassets-test-data.sql', '2025-01-30 16:35:56.212391', 281, 'EXECUTED', '9:e497c8dd7bf732f16ef2bb604b7cd6b1', 'sql', '', NULL, '4.29.2', '!without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-office-coopAssetsTransaction-TEST-DATA-GENERATION', 'michael.hoennig', 'db/changelog/5-hs-office/512-coopassets/5128-hs-office-coopassets-test-data.sql', '2025-01-30 16:35:56.307614', 282, 'EXECUTED', '9:265f1ceabada82c20fd2ee16cfe6453e', 'sql', '', NULL, '4.29.2', '!without-test-data AND !without-test-data', NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-integration-SCHEMA', 'timotheus.pokorra', 'db/changelog/9-hs-global/9100-hs-integration-schema.sql', '2025-01-30 16:35:56.318693', 283, 'EXECUTED', '9:e6e03e675664bdbad9bb11fc2875e822', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-global-integration-kimai', 'timotheus.pokorra', 'db/changelog/9-hs-global/9110-integration-kimai.sql', '2025-01-30 16:35:56.331936', 284, 'EXECUTED', '9:56e481a555f86b471b74aaceacc4b520', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-global-integration-znuny', 'timotheus.pokorra', 'db/changelog/9-hs-global/9120-integration-znuny.sql', '2025-01-30 16:35:56.380155', 285, 'EXECUTED', '9:48685a4882797575f8bb8c83d5fc9380', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');
INSERT INTO public.databasechangelog (id, author, filename, dateexecuted, orderexecuted, exectype, md5sum, description, comments, tag, liquibase, contexts, labels, deployment_id) VALUES ('hs-global-integration-mlmmj', 'timotheus.pokorra', 'db/changelog/9-hs-global/9130-integration-mlmmj.sql', '2025-01-30 16:35:56.391364', 286, 'EXECUTED', '9:df6c8a724cfdd0c0aa013ba996655ed1', 'sql', '', NULL, '4.29.2', NULL, NULL, '8251349802');


--
-- Data for Name: databasechangeloglock; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO public.databasechangeloglock (id, locked, lockgranted, lockedby) VALUES (1, false, NULL, NULL);


--
-- Data for Name: global; Type: TABLE DATA; Schema: rbac; Owner: test
--

INSERT INTO rbac.global (uuid, name) VALUES ('33af1d05-a7de-4552-9118-7900fe5fde7d', 'global');


--
-- Data for Name: grant; Type: TABLE DATA; Schema: rbac; Owner: test
--

INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0209d9e5-197a-448f-9249-46549f500058', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '3706fd53-e952-408a-aedd-93ec6d5129be', 'ce47754e-0d06-4b12-bc91-8034a4a046e7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ac11d7d8-f6ca-4c3d-aab0-a1b5a1a04713', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '9ae5d7ce-d996-4510-9513-9b352cf4427f', 'ce47754e-0d06-4b12-bc91-8034a4a046e7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('65be3e59-c9cb-4ec1-8263-77acd074fa71', NULL, NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '47b0efd3-0e9a-4275-b2c5-d50dd2b22024', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6d4c6f56-c91c-470b-aaa4-e0efa854a521', NULL, NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'ae085da6-9278-48f0-a2d2-b214f0cd55ab', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7443e4db-05b1-4a12-8daf-1d1cf20d2867', NULL, NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'e4082d20-6277-4b51-b70b-1d41375748c4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6fe9c371-a519-4fc6-8a02-51db66d9f4cf', NULL, NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '9c5062d4-6ed6-4284-967e-7e661a0f8016', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('13649546-9e0a-4278-a106-b661a967cb56', NULL, NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '41688207-eecb-4233-b9b2-5f18eee23546', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('255896f7-49d0-4818-a8ef-ab89e09fe220', '691db509-b67e-46ec-a859-c4cb05fbbd70', NULL, '7fe86d82-1b9d-485e-a206-a4c9bb39125c', '8a96713c-f52a-494b-9856-5a7cc869449b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b7267fb0-0ba2-4e9a-ac10-7fa7d23b252b', '691db509-b67e-46ec-a859-c4cb05fbbd70', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '7fe86d82-1b9d-485e-a206-a4c9bb39125c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dce4e633-96ab-42a0-91d8-d70d968fa9c3', NULL, '7fe86d82-1b9d-485e-a206-a4c9bb39125c', '3706fd53-e952-408a-aedd-93ec6d5129be', '7fe86d82-1b9d-485e-a206-a4c9bb39125c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aee0fd67-8819-4c8c-b2a1-9b6b2724d985', '691db509-b67e-46ec-a859-c4cb05fbbd70', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', '0debf423-4128-4959-94b6-c4e17adfd25f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6d33a2d2-8318-412a-b2a2-f4903e243634', '691db509-b67e-46ec-a859-c4cb05fbbd70', NULL, '7fe86d82-1b9d-485e-a206-a4c9bb39125c', 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8886335c-b86c-4482-855a-8bba58430513', '691db509-b67e-46ec-a859-c4cb05fbbd70', NULL, '38aa2ac2-71e5-4805-94ae-61361288f235', 'bd35e25f-a9d7-41f9-835d-55026654c03c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3fe9949e-fe13-4ebe-ac9c-175d91704d68', '691db509-b67e-46ec-a859-c4cb05fbbd70', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cb309ec8-023d-4a2f-8fc7-33ea3b0a17ee', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', NULL, 'eba5fbe1-b196-4df3-8d92-fd9023668744', 'd0ee13fb-5f61-40d3-b38e-02eafd89160f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fff94117-2a2b-4640-912f-054e98076714', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'eba5fbe1-b196-4df3-8d92-fd9023668744', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a5da7c37-b49f-481e-af99-be5f00420901', NULL, 'eba5fbe1-b196-4df3-8d92-fd9023668744', '3706fd53-e952-408a-aedd-93ec6d5129be', 'eba5fbe1-b196-4df3-8d92-fd9023668744', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9bf28023-0b2e-4ecf-8b19-e2c33708aac5', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', NULL, 'a6ff0898-04e1-49b7-8621-b42846df06e1', 'e6970814-b140-4805-95f3-610c215eb5ab', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ad469a06-3a5c-4501-947b-4cbff6d3c4be', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', NULL, 'eba5fbe1-b196-4df3-8d92-fd9023668744', 'a6ff0898-04e1-49b7-8621-b42846df06e1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('030d63fc-2357-4bb7-8828-527aeddb3f37', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', NULL, '5c9372e0-cb21-4ae7-a461-df086ad19426', 'e3c18d7e-cb24-4063-b0ac-dcb8fd3d2b68', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dec9b37f-9f1c-414c-b499-15d6c2ac2633', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', NULL, 'a6ff0898-04e1-49b7-8621-b42846df06e1', '5c9372e0-cb21-4ae7-a461-df086ad19426', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d2fb1e9f-ccc3-4316-9aed-b4ddd25cd865', 'd363745a-e94f-48be-8397-4b361570a54d', NULL, 'a930208f-7ef8-4296-9f70-24c50656ac58', 'eb43edcb-0d20-4614-b45c-736ef4f56380', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('52f8abd9-2cc0-42d1-a514-8f03b8ae64db', 'd363745a-e94f-48be-8397-4b361570a54d', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'a930208f-7ef8-4296-9f70-24c50656ac58', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ee92f6ef-83f7-42c3-9987-7a2849b7392d', NULL, 'a930208f-7ef8-4296-9f70-24c50656ac58', '3706fd53-e952-408a-aedd-93ec6d5129be', 'a930208f-7ef8-4296-9f70-24c50656ac58', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('097f8881-5e6b-4870-8d07-307ee55359c9', 'd363745a-e94f-48be-8397-4b361570a54d', NULL, 'b9592474-79f3-42d9-828f-8cc2e5c8ba7c', 'db94672f-1fbf-4898-bff8-2bfb5b2450a3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5dcf4fa9-caca-4c5f-911c-0556ee8526cc', 'd363745a-e94f-48be-8397-4b361570a54d', NULL, 'a930208f-7ef8-4296-9f70-24c50656ac58', 'b9592474-79f3-42d9-828f-8cc2e5c8ba7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('18de6002-7109-44c8-b001-38af17fbb126', 'd363745a-e94f-48be-8397-4b361570a54d', NULL, '1280183b-c71a-4b86-bdec-7f3800679ef4', '3cdad6bf-60f7-4dd7-80b8-4b1bfbc0f7b7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('422119f8-cf6b-47a7-a6e5-f07fc59d1ff3', 'd363745a-e94f-48be-8397-4b361570a54d', NULL, 'b9592474-79f3-42d9-828f-8cc2e5c8ba7c', '1280183b-c71a-4b86-bdec-7f3800679ef4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5341c201-1e05-4750-ad24-7bba63bbb0a4', '7a334268-7d11-4765-8fa9-17e2c36cca7a', NULL, 'd1d8fae9-566a-4a6b-8a1c-372b63108fe6', '684d7313-c093-4da0-83e8-bd73c6cc0bb6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2fc7b67b-c746-475c-b2fb-f2140117db64', '7a334268-7d11-4765-8fa9-17e2c36cca7a', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'd1d8fae9-566a-4a6b-8a1c-372b63108fe6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('069f69db-d07b-47c1-a7dc-2c02f32599b3', NULL, 'd1d8fae9-566a-4a6b-8a1c-372b63108fe6', '3706fd53-e952-408a-aedd-93ec6d5129be', 'd1d8fae9-566a-4a6b-8a1c-372b63108fe6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dc86a67f-b62e-45b4-b14b-d93272c79756', '7a334268-7d11-4765-8fa9-17e2c36cca7a', NULL, '939dafca-fe72-499d-979d-6fe0288e6807', '42a22abb-f604-4980-b6fa-adb1aa4e0adf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2296270c-0122-4ebf-a894-5eba96a788cc', '7a334268-7d11-4765-8fa9-17e2c36cca7a', NULL, 'd1d8fae9-566a-4a6b-8a1c-372b63108fe6', '939dafca-fe72-499d-979d-6fe0288e6807', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b693f79e-8185-4c6f-9b30-5160c6f5d5fb', '7a334268-7d11-4765-8fa9-17e2c36cca7a', NULL, 'b91f7dd8-b4a4-4f9b-9192-300f8e982c6d', 'd226bd12-192c-43f1-bc65-45803a17c4a3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0485fd95-27e8-484c-8bba-e8144bc0ba15', '7a334268-7d11-4765-8fa9-17e2c36cca7a', NULL, '939dafca-fe72-499d-979d-6fe0288e6807', 'b91f7dd8-b4a4-4f9b-9192-300f8e982c6d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e98e8e5a-a249-4da7-bfca-0c74d828d0db', '33b40eee-30ed-4924-859d-6c58b5aa4124', NULL, '2b70b335-e6b6-4b11-b138-4e7b3c4c50d4', 'deebf94a-2ef8-40bd-8538-9227bb901fee', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3a7316b4-ca96-4991-a2dd-b3404ebe7ccb', '33b40eee-30ed-4924-859d-6c58b5aa4124', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '2b70b335-e6b6-4b11-b138-4e7b3c4c50d4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e3046b32-105c-45dd-a5e4-9684f43ef739', NULL, '2b70b335-e6b6-4b11-b138-4e7b3c4c50d4', '3706fd53-e952-408a-aedd-93ec6d5129be', '2b70b335-e6b6-4b11-b138-4e7b3c4c50d4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d0c4f7e2-feb4-4559-894a-6d60593f7935', '33b40eee-30ed-4924-859d-6c58b5aa4124', NULL, '06bf2ac2-61c5-42e9-917b-8b68afcc0d47', 'a3aee0e9-b8f3-4262-80ae-5cc6154cdc10', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d0480f7e-3066-4cc5-b5a4-dcbe3e661b2a', '33b40eee-30ed-4924-859d-6c58b5aa4124', NULL, '2b70b335-e6b6-4b11-b138-4e7b3c4c50d4', '06bf2ac2-61c5-42e9-917b-8b68afcc0d47', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2edfcd56-1985-4bec-b683-f23909acb1ee', '33b40eee-30ed-4924-859d-6c58b5aa4124', NULL, '7a8959c2-e6c0-4af3-9d64-117811ec0d02', '4fe450ed-3a24-49b8-98cc-fa85de9ce889', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('558ee33d-5b2a-44e2-a5b8-31b80bcc32ca', '33b40eee-30ed-4924-859d-6c58b5aa4124', NULL, '06bf2ac2-61c5-42e9-917b-8b68afcc0d47', '7a8959c2-e6c0-4af3-9d64-117811ec0d02', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ea2432fa-f049-4858-8279-8a039d9c6d30', '16da0560-e134-41c5-aafb-1f7a5b33692b', NULL, '9d6a3750-0d32-469a-a476-2d8525f7e692', 'c11382ee-e0e3-4b25-b8ba-640dde8c20bf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5147ee1c-b04a-4add-96a7-c52e72186004', '16da0560-e134-41c5-aafb-1f7a5b33692b', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '9d6a3750-0d32-469a-a476-2d8525f7e692', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a3c0ef7e-f9ac-43e3-9674-7d4a4d3f935a', NULL, '9d6a3750-0d32-469a-a476-2d8525f7e692', '3706fd53-e952-408a-aedd-93ec6d5129be', '9d6a3750-0d32-469a-a476-2d8525f7e692', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('25ec885b-5885-47a0-89ea-cbaf2838f16d', '16da0560-e134-41c5-aafb-1f7a5b33692b', NULL, '82d6e2a0-3c2d-4a8e-8638-4903696927d5', '0d98be37-8ae9-48c8-9bff-6b7581e256fa', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3e4bcbd6-e9e8-4667-b082-65ab49cdd047', '16da0560-e134-41c5-aafb-1f7a5b33692b', NULL, '9d6a3750-0d32-469a-a476-2d8525f7e692', '82d6e2a0-3c2d-4a8e-8638-4903696927d5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7df1503a-19d3-4c58-bce8-72dcabf3ee17', '16da0560-e134-41c5-aafb-1f7a5b33692b', NULL, '25acc71c-db8f-46e4-950a-8ea76637bb9b', 'de8da2bb-9e4d-44e7-ad03-e9763db4331f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('97a3cb59-87c2-4aa5-a20d-c49726d852cb', '16da0560-e134-41c5-aafb-1f7a5b33692b', NULL, '82d6e2a0-3c2d-4a8e-8638-4903696927d5', '25acc71c-db8f-46e4-950a-8ea76637bb9b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1234271b-e26d-4f40-91ce-b88639be5579', '1fc10779-390b-40ff-b641-b6b5e2634ebb', NULL, '0b754d22-82a2-4349-af85-2cee67716f66', '390087c9-9c6f-4c2f-9c77-af65112c520a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('313ed510-dd9c-4336-94cc-49f4b9764237', '1fc10779-390b-40ff-b641-b6b5e2634ebb', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0b754d22-82a2-4349-af85-2cee67716f66', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('534ad46c-147e-4223-9965-14c1b80fc096', NULL, '0b754d22-82a2-4349-af85-2cee67716f66', '3706fd53-e952-408a-aedd-93ec6d5129be', '0b754d22-82a2-4349-af85-2cee67716f66', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('482020d5-4755-47e3-8e37-2a53dbfc51da', '1fc10779-390b-40ff-b641-b6b5e2634ebb', NULL, '42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b', 'ea4baec8-4128-4e59-b0e1-69b450c46755', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7ba8e044-7762-4b42-9383-dfca5f38f2d5', '1fc10779-390b-40ff-b641-b6b5e2634ebb', NULL, '0b754d22-82a2-4349-af85-2cee67716f66', '42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('04398c2b-0517-4dde-a377-c3bb6aa6acbb', '1fc10779-390b-40ff-b641-b6b5e2634ebb', NULL, '24f9488b-412f-4314-b160-2897f4dcff1b', 'e9887f07-65e4-4b5b-a134-f023fb127cbf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a48c0d05-44c2-4f14-9bf6-6872a0e643a3', '1fc10779-390b-40ff-b641-b6b5e2634ebb', NULL, '42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b', '24f9488b-412f-4314-b160-2897f4dcff1b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1ec460a0-94c2-4faf-869e-02a6edf7d16c', 'caac18bd-9277-47ac-99bb-368e2d64dac0', NULL, '310cdf00-c863-4ea0-9e4e-9eac8a74f51a', '2e07da63-f1f6-4342-b090-f3c465e9093a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('be53f5ee-7a75-45fe-b438-2b11efbf210d', 'caac18bd-9277-47ac-99bb-368e2d64dac0', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '310cdf00-c863-4ea0-9e4e-9eac8a74f51a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('eac7fcd2-b8db-4b32-834c-41c717ba4a56', NULL, '310cdf00-c863-4ea0-9e4e-9eac8a74f51a', '3706fd53-e952-408a-aedd-93ec6d5129be', '310cdf00-c863-4ea0-9e4e-9eac8a74f51a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f29ecf53-d978-406a-9b5d-06af83228fb2', 'caac18bd-9277-47ac-99bb-368e2d64dac0', NULL, 'f9d5ba94-1514-4400-88af-7b7d3798f473', 'c8cc9a24-e3d0-412d-867b-8e617e40f1e3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6236b09e-2522-435a-850a-734c1951691b', 'caac18bd-9277-47ac-99bb-368e2d64dac0', NULL, '310cdf00-c863-4ea0-9e4e-9eac8a74f51a', 'f9d5ba94-1514-4400-88af-7b7d3798f473', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('653a28d9-f2c5-414a-a31a-b9fc2afd9a08', 'caac18bd-9277-47ac-99bb-368e2d64dac0', NULL, '20926d99-1f1f-497a-8e13-ce3cb4b1eb73', '32b78d45-4a5c-48a5-bec2-efacd97dc76b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1aaddb85-a79a-48fd-a09e-27aff2656351', 'caac18bd-9277-47ac-99bb-368e2d64dac0', NULL, 'f9d5ba94-1514-4400-88af-7b7d3798f473', '20926d99-1f1f-497a-8e13-ce3cb4b1eb73', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c890dba3-59b0-43ce-b4a7-8b72d56c9bd5', 'eead6995-dd54-475f-8194-74445c421305', NULL, 'b54d5034-1898-4712-a472-5ecac0e22a1a', 'caa58c78-6540-4f75-a24c-d4ea5f218cb0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('566a1aaa-cf4c-4af0-abab-f2df16e450e0', 'eead6995-dd54-475f-8194-74445c421305', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'b54d5034-1898-4712-a472-5ecac0e22a1a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4787badb-20d1-4e0e-864c-0077a956f204', NULL, 'b54d5034-1898-4712-a472-5ecac0e22a1a', '3706fd53-e952-408a-aedd-93ec6d5129be', 'b54d5034-1898-4712-a472-5ecac0e22a1a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aa6b4d7a-976f-4ae2-a60b-91e0db033b4f', 'eead6995-dd54-475f-8194-74445c421305', NULL, '57ee73c6-769e-461e-9cea-7bfe56970bf7', 'ae30faa4-b82e-4e65-8324-360fdba2d504', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('65aeb029-27df-41e0-9ece-d8530348e84f', 'eead6995-dd54-475f-8194-74445c421305', NULL, 'b54d5034-1898-4712-a472-5ecac0e22a1a', '57ee73c6-769e-461e-9cea-7bfe56970bf7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ba911597-a4e0-4850-80dc-570d22a66b38', 'eead6995-dd54-475f-8194-74445c421305', NULL, 'e65ad361-79d6-46a3-a7c7-a18048b7237a', 'f38fcb66-ea16-41fb-abdc-ea3df857d5e4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('180e3c3c-0f8f-4403-9892-fecd79374318', 'eead6995-dd54-475f-8194-74445c421305', NULL, '57ee73c6-769e-461e-9cea-7bfe56970bf7', 'e65ad361-79d6-46a3-a7c7-a18048b7237a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('03f51fe7-db78-4b8d-996f-cbee3ba752ab', '4b68de11-a658-44bb-be49-ad592e73e3d8', NULL, '97344c39-24d3-4df5-8dba-ba41ff28a020', '81ea98dc-258a-4ab6-8537-8de22e9e90be', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d0280cb3-1d1d-4ec4-b00b-c220caa3729f', '4b68de11-a658-44bb-be49-ad592e73e3d8', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '97344c39-24d3-4df5-8dba-ba41ff28a020', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9682d9f3-0cd6-4a25-8d44-8adf95190ad3', NULL, '97344c39-24d3-4df5-8dba-ba41ff28a020', '3706fd53-e952-408a-aedd-93ec6d5129be', '97344c39-24d3-4df5-8dba-ba41ff28a020', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e948b309-9135-4960-9694-a299c6b71082', '4b68de11-a658-44bb-be49-ad592e73e3d8', NULL, 'd206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e', '0a2e575c-9d22-42e7-8446-546ac3cda8ed', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('595b65be-6f68-4ec5-9413-e546774b27b7', '4b68de11-a658-44bb-be49-ad592e73e3d8', NULL, '97344c39-24d3-4df5-8dba-ba41ff28a020', 'd206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ed3d99d6-01d6-47f4-afcd-fc6960dc94be', '4b68de11-a658-44bb-be49-ad592e73e3d8', NULL, '6c787015-c910-455d-8b2c-c3ae7bece7e7', 'b1efc8c9-2f6c-4ec2-84e5-29444c0fcd29', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('96aa9986-9d0c-4303-9eb3-34f0cc531cd0', '4b68de11-a658-44bb-be49-ad592e73e3d8', NULL, 'd206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e', '6c787015-c910-455d-8b2c-c3ae7bece7e7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5e8e7789-e43a-4b38-8693-e79f25490293', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', NULL, '680b8464-0536-4f87-a952-56e549a70a99', '9444adae-37a0-434e-97b7-3304b5577498', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a939473c-c689-453d-a436-5abff20fa354', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '680b8464-0536-4f87-a952-56e549a70a99', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7691369b-8338-436e-b4c9-97fdda157ad9', NULL, '680b8464-0536-4f87-a952-56e549a70a99', '3706fd53-e952-408a-aedd-93ec6d5129be', '680b8464-0536-4f87-a952-56e549a70a99', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a2121061-5baa-4333-88da-95df06ddc21a', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', NULL, '93ec1b20-de2b-4af1-924f-047a7afa0276', 'e17045f7-b4ef-4c12-beee-56b1b5ef7190', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0bcd4e3e-e6c5-48df-aa5e-bc4b31f241ec', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', NULL, '680b8464-0536-4f87-a952-56e549a70a99', '93ec1b20-de2b-4af1-924f-047a7afa0276', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('32bff958-41ea-4b9f-972c-c7dfbca82caa', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', NULL, '4330591d-61d5-4435-827a-c71b8328a700', 'd6d69027-db1a-444c-be6a-e14232b71647', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4ecaab39-97ff-4034-9826-0023beaa8f75', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', NULL, '93ec1b20-de2b-4af1-924f-047a7afa0276', '4330591d-61d5-4435-827a-c71b8328a700', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('65143c28-70ba-4227-aca5-44d39e0fb9b0', '25358342-4f90-4397-b4c4-d90524ac0b7b', NULL, '0ca35f5d-778f-4207-88ae-beb5a648a6f6', '511d8f3d-266d-4c3a-9091-a7b16d8e61bc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('35ba2de2-3f5c-4f0d-82e0-ca7cfaf14bb4', '25358342-4f90-4397-b4c4-d90524ac0b7b', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0ca35f5d-778f-4207-88ae-beb5a648a6f6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('261bdd26-069f-492d-94c1-37002eeeaad2', NULL, '0ca35f5d-778f-4207-88ae-beb5a648a6f6', '3706fd53-e952-408a-aedd-93ec6d5129be', '0ca35f5d-778f-4207-88ae-beb5a648a6f6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b08f5236-cdc2-44b9-b9a9-d7696970d60e', '25358342-4f90-4397-b4c4-d90524ac0b7b', NULL, '5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', '61aef2e8-ca62-4a62-8a4c-6a56f6fa6880', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('98c73e4b-bf68-4de3-8b95-522b70836830', '25358342-4f90-4397-b4c4-d90524ac0b7b', NULL, '0ca35f5d-778f-4207-88ae-beb5a648a6f6', '5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cbc774db-9885-4387-89e7-a07bd21d1197', '25358342-4f90-4397-b4c4-d90524ac0b7b', NULL, '5167487b-90ee-40b9-9c34-535b74b3186e', 'f03d3fab-a32c-40a8-9fb3-ff456bbb7f45', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('639d2da7-6cde-485e-a12c-047e5345ec38', '25358342-4f90-4397-b4c4-d90524ac0b7b', NULL, '5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', '5167487b-90ee-40b9-9c34-535b74b3186e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e58bbe06-9100-4157-8366-e69f6535d72c', '4997dce8-4927-4a10-a7b3-16c574eb79c9', NULL, 'a0a8a5e1-e11f-44ec-984f-163e049c81e1', '4a861961-b89b-4ed1-8a22-076edb1fe182', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0cb20f17-8aa9-462d-bae3-4f7cae45bb4a', '4997dce8-4927-4a10-a7b3-16c574eb79c9', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'a0a8a5e1-e11f-44ec-984f-163e049c81e1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0489eda3-8f56-426a-9be6-f9f689c0e29c', NULL, 'a0a8a5e1-e11f-44ec-984f-163e049c81e1', '3706fd53-e952-408a-aedd-93ec6d5129be', 'a0a8a5e1-e11f-44ec-984f-163e049c81e1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('70d7d9f3-1b2e-4257-88c3-28884d0d6c03', '4997dce8-4927-4a10-a7b3-16c574eb79c9', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', '0c9f6461-5ab3-4c39-870d-e66aacd5d522', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('88d40a3a-1282-4655-a268-c2095662d402', '4997dce8-4927-4a10-a7b3-16c574eb79c9', NULL, 'a0a8a5e1-e11f-44ec-984f-163e049c81e1', '4241127c-1c6d-41b4-9350-3aa73785f6c5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6d609f65-3a9a-4ef3-a184-29c63d54bb41', '4997dce8-4927-4a10-a7b3-16c574eb79c9', NULL, '206fcdf2-c22e-480f-9029-42183cc2990e', '7d188b98-3755-4753-b776-7226df8db3bb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c84f3466-1307-4db5-87e0-69216ef0e261', '4997dce8-4927-4a10-a7b3-16c574eb79c9', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', '206fcdf2-c22e-480f-9029-42183cc2990e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d18a6927-8a9f-45ce-8554-99aabdc230c0', '9dcab961-1465-40e3-8d83-357b22af2674', NULL, '51c51fa2-3706-470a-9d15-0bad421ea7d4', '8973550c-23a8-40d5-bd36-4b4f8608841e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5b65a62a-3150-4e79-a90e-58b7a31cbada', '9dcab961-1465-40e3-8d83-357b22af2674', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '51c51fa2-3706-470a-9d15-0bad421ea7d4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7bc4246e-62a8-41a4-a057-93d2d0554b06', NULL, '51c51fa2-3706-470a-9d15-0bad421ea7d4', '3706fd53-e952-408a-aedd-93ec6d5129be', '51c51fa2-3706-470a-9d15-0bad421ea7d4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('770efe1f-9453-43ee-afcb-5cd49c3892c3', '9dcab961-1465-40e3-8d83-357b22af2674', NULL, 'd3aa37e9-88d7-4099-8fa8-0bb25f6db328', 'e887ff28-0576-46a5-8faa-b4167f9cab6a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1b729cee-fb30-418a-a54a-36e1451ff572', '9dcab961-1465-40e3-8d83-357b22af2674', NULL, '51c51fa2-3706-470a-9d15-0bad421ea7d4', 'd3aa37e9-88d7-4099-8fa8-0bb25f6db328', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('037d9131-fdbd-4a05-9713-571bc29a4c5f', '9dcab961-1465-40e3-8d83-357b22af2674', NULL, '3f62e7fa-ffed-4a15-88c2-2d4a231c7db0', '6becffbf-7ca9-422d-a429-c022f023d9ae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cc1ad7a3-7342-42a8-b4e7-7fb740cb582f', '9dcab961-1465-40e3-8d83-357b22af2674', NULL, 'd3aa37e9-88d7-4099-8fa8-0bb25f6db328', '3f62e7fa-ffed-4a15-88c2-2d4a231c7db0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cfae6716-5c5d-4660-860a-23a4e38d7195', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', NULL, 'e1947aaf-5b7f-4597-b296-25830e9c945b', '32860409-f9d0-41f3-b19e-25a38bdabc3f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fae58d16-9c53-4135-b39d-992743c48c95', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'e1947aaf-5b7f-4597-b296-25830e9c945b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('45c1954e-b8f8-47fe-b0cc-d458567060f9', NULL, 'e1947aaf-5b7f-4597-b296-25830e9c945b', '3706fd53-e952-408a-aedd-93ec6d5129be', 'e1947aaf-5b7f-4597-b296-25830e9c945b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('97a6f3c4-8311-42b1-a519-cdf832ea682f', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', NULL, 'a822e970-7b6a-417d-81d0-a8db0c985427', '44f00bec-0091-4523-9235-84aa669de6df', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dbde9321-b71c-4e2e-a4d0-fc7233d09904', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', NULL, 'e1947aaf-5b7f-4597-b296-25830e9c945b', 'a822e970-7b6a-417d-81d0-a8db0c985427', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('db770b7e-a585-4a52-9bdb-586c846f50f4', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', NULL, '6fc5eacb-5328-41c3-a71b-e7712338862a', 'efb67518-722d-4f1b-8280-e3f894406dd5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9802498c-ba4f-455b-99e0-7d3d74aaf888', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', NULL, 'a822e970-7b6a-417d-81d0-a8db0c985427', '6fc5eacb-5328-41c3-a71b-e7712338862a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e0c6a190-5a5b-49cb-b6cd-3aa97d65effd', '627a274d-55b0-42e7-963c-8b0cc3e204b4', NULL, '87f8ac1d-b082-4961-979c-cd3de0e46b21', 'b8a958a1-b18b-4198-995c-7057791c7b6f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7a7b3b25-55a2-45a7-8e73-3965f6d42114', '627a274d-55b0-42e7-963c-8b0cc3e204b4', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '87f8ac1d-b082-4961-979c-cd3de0e46b21', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9cc8dbdf-4ffa-4c8c-9eeb-3dc4f291cb58', NULL, '87f8ac1d-b082-4961-979c-cd3de0e46b21', '3706fd53-e952-408a-aedd-93ec6d5129be', '87f8ac1d-b082-4961-979c-cd3de0e46b21', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a24d7161-01ec-47ee-8290-1881e4330e97', '627a274d-55b0-42e7-963c-8b0cc3e204b4', NULL, 'ba7a634b-c352-418c-a8c0-58918f32f8a7', 'e3eeab03-d7bd-4dcc-b076-3bca06fcedcd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1f5371fd-18c4-452c-bf30-f45a8c955118', '627a274d-55b0-42e7-963c-8b0cc3e204b4', NULL, '87f8ac1d-b082-4961-979c-cd3de0e46b21', 'ba7a634b-c352-418c-a8c0-58918f32f8a7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8b2e92c5-76d2-44a9-88b8-72059bf35a81', '627a274d-55b0-42e7-963c-8b0cc3e204b4', NULL, 'ed0f7762-a094-4a88-abde-8472da33bcfb', '1be4a900-49fe-4fef-b4f5-47643f463859', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3b14bdbd-9cb9-4aeb-8e52-bec6d5560cda', '627a274d-55b0-42e7-963c-8b0cc3e204b4', NULL, 'ba7a634b-c352-418c-a8c0-58918f32f8a7', 'ed0f7762-a094-4a88-abde-8472da33bcfb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('77236f22-0606-4573-a7c3-7d5f21cf9486', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', NULL, '9455fccb-71fa-4cff-bf89-5dfc719f3374', 'ea674a43-6195-4c02-8bbf-88c2255030ce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d13c0466-206b-4584-ac93-2be555771c4b', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '9455fccb-71fa-4cff-bf89-5dfc719f3374', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4804c996-c47f-4784-beae-80a51ee0d044', NULL, '9455fccb-71fa-4cff-bf89-5dfc719f3374', '3706fd53-e952-408a-aedd-93ec6d5129be', '9455fccb-71fa-4cff-bf89-5dfc719f3374', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6f889e57-27bc-4441-be05-633783ab6321', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', NULL, 'fdcffa04-a455-4869-ab8f-2f2fa05e4b02', 'e6b918a1-edaa-4170-b6eb-9c8257b9a72a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bd9e86d9-db1d-4fae-9ad6-79692780436a', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', NULL, '9455fccb-71fa-4cff-bf89-5dfc719f3374', 'fdcffa04-a455-4869-ab8f-2f2fa05e4b02', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('090e641c-573b-47d3-b254-f0ce4c80861b', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', NULL, '67b756a8-aff9-439d-8ac8-b8965b63ac32', 'c3fa6a59-6d7a-4f1a-a5a5-3ebf64250a5d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c65ea937-2e00-4ac5-8662-3411d66bca56', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', NULL, 'fdcffa04-a455-4869-ab8f-2f2fa05e4b02', '67b756a8-aff9-439d-8ac8-b8965b63ac32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('47db507d-3dd0-47db-bed5-e37816975659', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', NULL, 'd85c013c-e791-4bec-ac0d-a217472cf425', 'c21abea9-6973-44c7-91f4-2d163d97764d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cd5c0a3d-5b3c-4f9f-953d-a2950af2ca73', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'd85c013c-e791-4bec-ac0d-a217472cf425', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ce7f6e0e-e793-4c9f-921c-4432f946d110', NULL, 'd85c013c-e791-4bec-ac0d-a217472cf425', '3706fd53-e952-408a-aedd-93ec6d5129be', 'd85c013c-e791-4bec-ac0d-a217472cf425', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e3dd23a9-7be6-4ba0-8799-4a420de0b930', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', NULL, '60297e5d-2f7d-4734-9a25-f2639ffb7fb4', 'b94eb65e-0105-4cf9-b238-cd3e4715c08d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('31a6e718-6d5a-4c09-b12f-076bec7e334d', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', NULL, 'd85c013c-e791-4bec-ac0d-a217472cf425', '60297e5d-2f7d-4734-9a25-f2639ffb7fb4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('de0e18ad-bff5-42bd-9384-30a5eec6ef5f', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', NULL, '7454ce37-a2ba-4f52-a5da-2190203ca089', '98ecef93-9816-44dc-a028-61cc9403efb9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c58f4061-42f2-4606-9ea7-ffbcf8889610', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', NULL, '60297e5d-2f7d-4734-9a25-f2639ffb7fb4', '7454ce37-a2ba-4f52-a5da-2190203ca089', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('54f14461-8203-4ba6-a130-81ece6161f31', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', NULL, 'd8bc6523-20de-42c3-93e6-5884924a7cdb', 'eed193d1-f65d-4738-b8ee-d991aeea4389', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5b48c930-e321-426a-a187-8f91c01d9e35', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'd8bc6523-20de-42c3-93e6-5884924a7cdb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c5de6e0e-6325-4985-b5da-83c71d1cfd7e', NULL, 'd8bc6523-20de-42c3-93e6-5884924a7cdb', '3706fd53-e952-408a-aedd-93ec6d5129be', 'd8bc6523-20de-42c3-93e6-5884924a7cdb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f52af204-37d3-428e-a836-5ee0b68136e2', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', NULL, 'da9600c2-7dcc-4a7d-87f1-33f4a441e807', '03602c91-9c55-4264-8c24-9f9d3cbaf869', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3bdcb54f-c406-4e62-9240-b03ed38f3589', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', NULL, 'd8bc6523-20de-42c3-93e6-5884924a7cdb', 'da9600c2-7dcc-4a7d-87f1-33f4a441e807', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4ab945c4-6298-4b12-84ab-6df6fd717d71', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', NULL, 'f1afc7a2-588d-4b7e-9975-7b0eda21f846', 'f8a806d8-a37b-4513-a77d-26cf05108c68', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1543772a-3456-474b-926f-6b03d2c47866', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', NULL, 'da9600c2-7dcc-4a7d-87f1-33f4a441e807', 'f1afc7a2-588d-4b7e-9975-7b0eda21f846', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8d35045d-6964-481a-8073-ddc2553fe80f', '137fb47a-07d4-42cc-b2ef-8e371041cf41', NULL, 'c184a3f4-ab4e-4263-a14c-70243c83e166', 'd53e98ff-47a8-4be8-a668-c3b45398f278', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2fb0cd1f-5746-4352-8eab-99c9c7b253be', '137fb47a-07d4-42cc-b2ef-8e371041cf41', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'c184a3f4-ab4e-4263-a14c-70243c83e166', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('068b7e74-a547-4ad7-988a-ec1193a9b829', NULL, 'c184a3f4-ab4e-4263-a14c-70243c83e166', '3706fd53-e952-408a-aedd-93ec6d5129be', 'c184a3f4-ab4e-4263-a14c-70243c83e166', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5091c7fa-0b70-4a94-a588-925d1f424c62', '137fb47a-07d4-42cc-b2ef-8e371041cf41', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', 'cad96a06-91b7-43d8-897d-7bfb1d7054fc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('23447319-b6db-408b-8619-4b5dff4af765', '137fb47a-07d4-42cc-b2ef-8e371041cf41', NULL, 'c184a3f4-ab4e-4263-a14c-70243c83e166', 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('309ef53b-eb20-4341-b25e-cff936c534e5', '137fb47a-07d4-42cc-b2ef-8e371041cf41', NULL, '8806c446-5551-4059-ba53-850a2d147c7c', '11749bf4-1bba-4698-93cc-41cd8d261166', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a7fd6d4d-db5f-422b-a4bc-6784cf5276ac', '137fb47a-07d4-42cc-b2ef-8e371041cf41', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6f3efb91-1a3a-45a2-8026-5c961b89178c', NULL, NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '3807de9b-30c6-4a1a-a434-85e80560d3b5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3ac85c19-6eb7-47d7-8f20-537a040385bb', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', NULL, 'a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b', '0beca0d8-2895-476e-afce-0923bba7e701', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5ec2354d-edde-4757-96da-970c87e89500', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f4f90dbf-44f4-492a-a6b4-8d7991d8fcc0', NULL, 'a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b', '3706fd53-e952-408a-aedd-93ec6d5129be', 'a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0b9344e1-c62d-4e82-b513-5b45513dc96b', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', 'c8f5fe32-5429-4991-8d88-ba9a79aead8a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dad9011e-c9c9-4779-b743-fdf4f50a3bbe', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', NULL, 'a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b', 'e03da822-f071-4c66-890f-f93a458aec28', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6ed6fa54-5b96-4dbb-a5c7-c3fbedf24aee', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', NULL, '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', 'ff0dff7c-9ef6-4ffd-916b-7a4fad718e8e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0d0534a7-6e05-4f81-b748-0402a99351b1', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('26da6601-35ce-4b64-98c7-96c61c2a2f2f', NULL, NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '7880ca8d-9bf6-4ae4-9056-5677ef591442', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5e5b44c3-3e7d-4fe2-bde4-97dbb16454ed', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', NULL, 'e811eb41-9645-43d9-86b4-d3b522acede9', '3f16c617-f9ff-4634-b4b6-2cee590e2cd0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('823337c9-d747-4b49-8790-14852096547c', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'e811eb41-9645-43d9-86b4-d3b522acede9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('22225af4-299f-4f44-b72c-c6be5446566b', NULL, 'e811eb41-9645-43d9-86b4-d3b522acede9', '3706fd53-e952-408a-aedd-93ec6d5129be', 'e811eb41-9645-43d9-86b4-d3b522acede9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('21b50e96-4f64-4e8d-8165-3801e3f86512', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '4812d3ef-02dc-4a03-8d13-7661dd92477d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c45c3ae4-41a5-4285-92ab-e00121bee2ab', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', NULL, 'e811eb41-9645-43d9-86b4-d3b522acede9', 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('204f5c32-4252-4adc-9fd7-469b54468378', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', NULL, '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', '624f1c38-a8ba-40a3-8f6b-dfe76cc36034', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('257ace34-9815-492a-b745-785738584840', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('df3d2b46-0a7d-4aee-92b6-d54733b3eeea', NULL, NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '195afe34-3bc9-43cb-86f7-7eadfb5d25cf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b3cbea4e-8ccf-4922-a338-052705e9d0ef', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', NULL, '02e3a73a-07fc-46df-a14f-569f31249c16', '08a3ffd0-77e4-4759-ad73-d42ca4d2d807', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7f83a692-c740-4cff-a20e-92bcf4c18035', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '02e3a73a-07fc-46df-a14f-569f31249c16', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('64b9ff61-121d-43f0-b9a1-0f7eb0246a16', NULL, '02e3a73a-07fc-46df-a14f-569f31249c16', '3706fd53-e952-408a-aedd-93ec6d5129be', '02e3a73a-07fc-46df-a14f-569f31249c16', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c2e7ae6a-e0db-4209-91b6-4999c8d03f73', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', NULL, 'f87398bc-225a-4eee-bea8-7983be6ae529', '6e962b9c-39cd-4cec-9750-c36419ff6319', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bc56b982-1a71-4c2b-89e4-e0a39549780e', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', NULL, '02e3a73a-07fc-46df-a14f-569f31249c16', 'f87398bc-225a-4eee-bea8-7983be6ae529', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e0827c85-5cc3-4910-97c3-583c99f782a1', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', NULL, '236b88d3-09bc-4750-9219-61529f7740af', 'a5eeaa7d-bf09-41e9-9414-470442665789', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('13f0edf1-7d44-46bc-86d1-cc993ca16624', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', NULL, 'f87398bc-225a-4eee-bea8-7983be6ae529', '236b88d3-09bc-4750-9219-61529f7740af', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4a2a86e1-b2b5-40d2-b9f1-d1dfc4440845', NULL, NULL, 'f87398bc-225a-4eee-bea8-7983be6ae529', '1f552123-71ce-43f0-b091-a43adb7a8a0c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e17d863a-af45-4f34-9af7-32054e6c8cd4', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', NULL, '09a6064d-a472-48e9-9755-d0117f2af6fe', '4cc5242e-7cc3-426c-9025-ccab1d8a895a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2cd5f7a6-1c48-40b6-85dd-97b4730d1e6e', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '09a6064d-a472-48e9-9755-d0117f2af6fe', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cfec797b-bb3f-460b-a498-1d3d18eb7ba5', NULL, '09a6064d-a472-48e9-9755-d0117f2af6fe', '3706fd53-e952-408a-aedd-93ec6d5129be', '09a6064d-a472-48e9-9755-d0117f2af6fe', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0f0fd76f-bd0f-47bf-b9a9-88c77f533484', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', NULL, 'bab68a5a-2016-454e-b143-8c334188d2c4', '60dbf8ee-3263-4878-990f-ab43fe96e48c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ed2e685b-1e10-4252-a32c-7377cf225c03', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', NULL, '09a6064d-a472-48e9-9755-d0117f2af6fe', 'bab68a5a-2016-454e-b143-8c334188d2c4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('10659beb-ccc1-47c6-afca-0821a2b3587e', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', NULL, '9115be3d-2bef-40ce-b0c9-339e460c751d', 'ba27345e-0699-437d-b4ca-24a8e326c345', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a4b8b81e-4b83-4a44-bc00-1496f9697af7', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', NULL, 'bab68a5a-2016-454e-b143-8c334188d2c4', '9115be3d-2bef-40ce-b0c9-339e460c751d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('164308f2-2289-4518-bc42-3770b0725b15', NULL, NULL, 'bab68a5a-2016-454e-b143-8c334188d2c4', 'f2850544-cbc8-4add-ad35-4b634370b913', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a0d0e550-c7fd-4b7c-b33b-fdffba64003f', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', NULL, 'ce0b0564-7cda-4c03-afcc-0854f3c5e519', 'd1767f98-0fc1-48e6-ab30-0cab02504ee2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('55281d1d-424a-4c7e-80a1-907d61c30b64', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'ce0b0564-7cda-4c03-afcc-0854f3c5e519', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('910b67d8-af35-4af5-b349-023fdf38e40f', NULL, 'ce0b0564-7cda-4c03-afcc-0854f3c5e519', '3706fd53-e952-408a-aedd-93ec6d5129be', 'ce0b0564-7cda-4c03-afcc-0854f3c5e519', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f9ae28dd-a2fb-4141-aa60-75c2faf05f18', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', NULL, 'da979efd-9d87-4dc5-a839-493e883cf292', 'c1816e75-de8d-480d-9a62-30805b9d2f99', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9e773e6e-6a9a-45a0-870d-7b56be46e253', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', NULL, 'ce0b0564-7cda-4c03-afcc-0854f3c5e519', 'da979efd-9d87-4dc5-a839-493e883cf292', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5ea26201-6404-4ad8-a066-d6a4a355da56', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', NULL, 'f913c978-1afc-4af0-9bb6-8c21eed95991', '374b8a48-00ec-4df2-9320-848bedfad9de', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('37ccbf6b-e3c7-4b19-b884-0bfef6a98517', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', NULL, 'da979efd-9d87-4dc5-a839-493e883cf292', 'f913c978-1afc-4af0-9bb6-8c21eed95991', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('082d7c3b-6070-4ff0-999c-fb4be3b5dc62', NULL, NULL, 'da979efd-9d87-4dc5-a839-493e883cf292', 'c55c0032-b1a4-47ac-89da-bb9c527a4a73', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bd6475f8-ba0c-4b5b-b820-74c8c8a26c13', 'ff030436-d19e-4606-9d48-7e192eaf469f', NULL, 'cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8', 'cf0de0eb-126c-4c60-aaf0-626f5c17820a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f0c593c3-6aa7-43b0-b622-b036d303e7e6', 'ff030436-d19e-4606-9d48-7e192eaf469f', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2f3d60a9-93d1-43b7-9e05-905451f01c3a', NULL, 'cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8', '3706fd53-e952-408a-aedd-93ec6d5129be', 'cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0601a335-404a-4943-8e99-569022721247', 'ff030436-d19e-4606-9d48-7e192eaf469f', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '38061696-b53f-42a9-86c0-77b7196a871a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('efe4417b-8511-40fd-b9d8-9c543cb11579', 'ff030436-d19e-4606-9d48-7e192eaf469f', NULL, 'cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8', 'b4224d96-af95-4008-9a96-9ae04b44913f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9a46f201-3a46-4d72-bf3d-682fd0068c18', 'ff030436-d19e-4606-9d48-7e192eaf469f', NULL, 'e668cce4-9f01-4c71-b28c-79859e02971b', '594d657f-567a-4e69-b28d-f2b79136ca2d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fe29d736-dd13-4a6c-8525-d6eb3bbcdab8', 'ff030436-d19e-4606-9d48-7e192eaf469f', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('db43eeac-3853-4784-a242-f338a986f32c', NULL, NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '99c49e4f-cfe3-41d3-940e-915c2a2e9641', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f69144bb-368b-4d22-b69d-af23526ba7a4', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', NULL, '22600f05-6955-48f7-8930-c884c9c31b06', 'd7a0d94a-c274-439a-b500-0f69b13c49fc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('111141e6-d131-4706-ae7a-95f3552e1bdd', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '22600f05-6955-48f7-8930-c884c9c31b06', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dd532bd8-a252-4365-8e4c-2735d5fc5878', NULL, '22600f05-6955-48f7-8930-c884c9c31b06', '3706fd53-e952-408a-aedd-93ec6d5129be', '22600f05-6955-48f7-8930-c884c9c31b06', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7cd9022a-9f45-4d2a-bf6b-27b831272c43', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', NULL, 'b28425cc-f859-43db-b3f5-64b5fb6a668b', 'eb7e6ebf-472b-40b5-9d88-47263fdb01cf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8cb620e9-a1c8-43bd-b617-07124fab53a9', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', NULL, '22600f05-6955-48f7-8930-c884c9c31b06', 'b28425cc-f859-43db-b3f5-64b5fb6a668b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a42f0b71-244c-444f-9e90-891b760e40b0', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', NULL, 'ecdbb376-51c5-4de3-82f5-c5e73c0f43c5', 'de1d831c-b96c-44fa-80a3-725856c6f998', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2a2ce413-d255-4aaf-b59d-ec55fd4c0a4c', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', NULL, 'b28425cc-f859-43db-b3f5-64b5fb6a668b', 'ecdbb376-51c5-4de3-82f5-c5e73c0f43c5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('25b98f12-7a6b-45a4-b080-0e45097c58fd', NULL, NULL, 'b28425cc-f859-43db-b3f5-64b5fb6a668b', '8cc95b98-8edc-4652-ae4b-9752d3cfd6b1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('86a4a239-e595-41ad-828a-c18f2e0177f7', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', NULL, 'c573267e-79c1-4e2a-9e95-55613006a3c8', '1bcffd04-b60d-4cdc-8fe7-df9bd04caf47', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aa038d8f-8369-4dcc-888a-8c8e67a66105', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'c573267e-79c1-4e2a-9e95-55613006a3c8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e3891199-3367-4c2c-91e1-15dc790f84dc', NULL, 'c573267e-79c1-4e2a-9e95-55613006a3c8', '3706fd53-e952-408a-aedd-93ec6d5129be', 'c573267e-79c1-4e2a-9e95-55613006a3c8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cc5145e3-55d3-48f2-ba2f-c45ae131b1ae', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', '7637bd59-9da5-4cdc-a37c-dd588769d092', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0b0c83b0-8990-4712-ad91-de9339fa1304', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', NULL, 'c573267e-79c1-4e2a-9e95-55613006a3c8', '6ef557f3-0b1e-41e9-bde7-8abea686f965', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('252fb082-66ff-4c49-8dcd-a3b9d109cd09', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', NULL, 'ea1789f5-11fe-4ec3-8d12-2623ba592c7f', 'b66e76e3-086f-4edd-86f7-b052ada8397d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('73e6cc12-8b24-4691-9401-5dcb37bfbb5e', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', 'ea1789f5-11fe-4ec3-8d12-2623ba592c7f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3c2baaa2-96b1-4840-9a60-d8359ec4e959', NULL, NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', 'c1d3e826-4d68-4ec3-b3c4-5617a1c14371', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4acc2c76-ba7f-4074-b649-4f2e2aa99c51', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', NULL, '32defb6c-2a81-44f2-ae79-7d8544d807dc', '0144b94f-8302-4eeb-bc90-d09e06966ac7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fa04af88-ae33-4ab5-bcc8-1c36fb1afd9f', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '32defb6c-2a81-44f2-ae79-7d8544d807dc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('705609ae-4009-47e5-99a4-57798dfe93e4', NULL, '32defb6c-2a81-44f2-ae79-7d8544d807dc', '3706fd53-e952-408a-aedd-93ec6d5129be', '32defb6c-2a81-44f2-ae79-7d8544d807dc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('82ec6c0e-0e4a-425a-9410-38747ceab809', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', NULL, '9e5fa680-2abc-4f25-bb22-bd2fe04fd860', '6587000d-2225-474f-a5c3-480188036398', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('75c4a5d5-b64d-4aa6-9b68-34a7666c6511', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', NULL, '32defb6c-2a81-44f2-ae79-7d8544d807dc', '9e5fa680-2abc-4f25-bb22-bd2fe04fd860', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4c4a01d2-ef9c-4b38-800b-48e24561e0fb', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', NULL, '4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7', '353d7a47-2248-4875-9776-469e7a028cae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ca9bb2f8-49af-452c-a0aa-283c283ba4d1', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', NULL, '9e5fa680-2abc-4f25-bb22-bd2fe04fd860', '4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('06ff60b9-6bdc-44e9-98f6-1a32d6f30512', NULL, NULL, '9e5fa680-2abc-4f25-bb22-bd2fe04fd860', '0488a5bf-a825-4105-965f-3fa793d5b9c4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('34695474-4403-4045-a3f5-2e77f28a3257', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', NULL, '7c817da8-f355-4456-8074-7bf433924285', '2d7800a6-63a8-4017-9613-6c693d3cd171', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('96b0229c-13b6-48ef-a5c1-d5202c716c52', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '7c817da8-f355-4456-8074-7bf433924285', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9c5c8582-9832-4bbf-8bf1-0c828c121337', NULL, '7c817da8-f355-4456-8074-7bf433924285', '3706fd53-e952-408a-aedd-93ec6d5129be', '7c817da8-f355-4456-8074-7bf433924285', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6839d4c2-94b8-4fa2-84c8-ebda6ae471f9', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', '2f06897d-859c-4e56-b9c2-947d128e3d63', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0798a57d-c298-47e9-9942-dbc39bb20c9b', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', NULL, '7c817da8-f355-4456-8074-7bf433924285', 'f32f51d5-3384-426e-a1c1-b5b6a263b647', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fc136f9e-2bbc-4f9a-b9d7-277e1818e141', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', NULL, 'a7ff4f1c-7c33-43e0-b264-37339141f7f9', '4d6a853b-5d93-4400-ba4c-a28a96721af5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f3a2f756-33e9-421c-bed1-b3ba44b61a97', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', 'a7ff4f1c-7c33-43e0-b264-37339141f7f9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f4afe3a7-e4c7-4d56-b1da-53af2568bfc9', NULL, NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', 'cb9db0cb-6a60-4f56-85e9-97ca9734071e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e156520b-d63f-4bf3-8a02-32fa64cdd3e2', '38cc5d59-085f-449e-aeb3-439febbabd9b', NULL, 'b70eca31-fcf6-40f6-9792-2fdb66bb129b', 'b38a6e56-e439-44d2-9ed6-3223e21c6224', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7d856866-730a-4037-95dd-a50906705098', '38cc5d59-085f-449e-aeb3-439febbabd9b', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'b70eca31-fcf6-40f6-9792-2fdb66bb129b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a68e0755-9441-4b22-ae6b-1bdfef94e3e4', NULL, 'b70eca31-fcf6-40f6-9792-2fdb66bb129b', '3706fd53-e952-408a-aedd-93ec6d5129be', 'b70eca31-fcf6-40f6-9792-2fdb66bb129b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('443f5495-98be-4580-89eb-a2afa2d7f7d9', '38cc5d59-085f-449e-aeb3-439febbabd9b', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'c3a212dc-036f-4e84-84b9-6e7367b407a1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ed164724-8168-4a4f-8445-ff973110a77f', '38cc5d59-085f-449e-aeb3-439febbabd9b', NULL, 'b70eca31-fcf6-40f6-9792-2fdb66bb129b', '95f09796-be4b-4b39-a759-a1f5a4fe54fb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8dea3c47-7171-4101-a215-15c7371b3a6d', '38cc5d59-085f-449e-aeb3-439febbabd9b', NULL, 'e97003a9-9162-4142-8d08-814e6c8fabd9', 'd96f1d59-085b-4c42-9e01-1513b232a067', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6a3344ed-1f0d-43a5-8e0a-a791472b7ffc', '38cc5d59-085f-449e-aeb3-439febbabd9b', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7340d2f8-170d-4eb6-8218-1cac9432d709', NULL, NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'd8d23634-f1c6-4a13-bb39-bae8e187df04', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('26d1fa5a-b06c-40d0-829b-f014bf33975e', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', NULL, '4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3', 'f3e17013-eb06-49e1-94a8-2e81e0f8a706', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('76e9493e-a2db-4b94-b324-77f11f2d5b80', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('97286182-f6c9-4684-8634-7c28a099043d', NULL, '4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3', '3706fd53-e952-408a-aedd-93ec6d5129be', '4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4a0f7682-96b0-4078-bf24-b816ffe12616', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '6712a948-ac81-455e-8d87-cb05438ac85d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0a4bd37d-fe74-4667-8832-81acfd7d88dd', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', NULL, '4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3', '1373e547-4804-4c8d-9014-ce51c65f3a06', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('88771617-b8ff-48ed-86e1-24a097fdc443', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', NULL, 'bdeffe17-405f-4ad0-8131-82728ea0e382', '3e298df0-8c98-4e48-a103-cfd3bbe2bec6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b11a3cd2-4e11-4cb7-b704-640e80d04647', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a9787820-a6e2-43ca-8934-63e56a28b694', NULL, NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', 'afceedea-4a23-4f6f-a0a2-a210ac148935', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('576f1a0c-739b-42b5-a888-2dd8c5789baa', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', NULL, '3f156460-0b5e-4e31-9ffe-bd27ad172ade', '9fe16585-5125-43c0-a683-f4d1579f784b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d326a63a-bcfa-44ca-91db-c6de702e9bd4', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '3f156460-0b5e-4e31-9ffe-bd27ad172ade', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('85c18c00-90e0-462c-bdb4-60428d3e7b0e', NULL, '3f156460-0b5e-4e31-9ffe-bd27ad172ade', '3706fd53-e952-408a-aedd-93ec6d5129be', '3f156460-0b5e-4e31-9ffe-bd27ad172ade', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('060c2174-e50d-4912-91c1-f1572a148dad', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', NULL, '957da54d-43eb-45d5-a3c4-34976d178bf3', '9405dc92-3dc7-4f4a-b799-514ce78ac05a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('10790a03-fb59-468f-ad85-d7ab74d790f6', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', NULL, '3f156460-0b5e-4e31-9ffe-bd27ad172ade', '957da54d-43eb-45d5-a3c4-34976d178bf3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cb3b7398-6065-4c42-a456-41bc192ce327', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', NULL, '96d81c1c-7d32-4b58-b7d3-7d7d88d250b7', '0b519921-7548-446f-a6e2-0986f0cec622', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bdd47305-1888-4f01-9320-e68d3dd73b9e', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', NULL, '957da54d-43eb-45d5-a3c4-34976d178bf3', '96d81c1c-7d32-4b58-b7d3-7d7d88d250b7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('40085698-b003-4234-86c6-76eff547ea0f', NULL, NULL, '957da54d-43eb-45d5-a3c4-34976d178bf3', '6d013dc5-c320-4873-99bb-d3cbd287ccf5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('507a9fe5-cf54-4d19-927b-ce85943cc782', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', NULL, '5c561605-0895-4a2b-b850-9572156e6635', '08008ffa-675e-46e6-8f5c-bbb701d67fd1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3f28348f-ce57-4a07-80b6-7fc85ca9153c', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '5c561605-0895-4a2b-b850-9572156e6635', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5da8c927-3d13-486e-b3c5-dad2a31a70fd', NULL, '5c561605-0895-4a2b-b850-9572156e6635', '3706fd53-e952-408a-aedd-93ec6d5129be', '5c561605-0895-4a2b-b850-9572156e6635', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c4ab1a59-0e67-47bc-a48f-a553a8b50794', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', NULL, '8bfcdf97-8c34-46ca-8159-1314cbb42105', 'c8583847-e84a-4286-b04f-368c61118b00', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('284fd022-3236-4ee0-ae0e-1a2899a8f2c9', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', NULL, '5c561605-0895-4a2b-b850-9572156e6635', '8bfcdf97-8c34-46ca-8159-1314cbb42105', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('94be11ba-9d31-480d-b264-47adfa74df20', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', NULL, 'd8c41124-ff96-4bc4-b3be-d0a8091128b6', 'ea2e5ea3-6e8e-473e-9bca-3972c30c727a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c695866c-6901-442a-a657-c32fb5320bd4', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', NULL, '8bfcdf97-8c34-46ca-8159-1314cbb42105', 'd8c41124-ff96-4bc4-b3be-d0a8091128b6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b631b878-8ffe-4a79-9e49-30f7b0c08c6c', NULL, NULL, '8bfcdf97-8c34-46ca-8159-1314cbb42105', 'c33ab3ab-3d3d-44be-987e-9f1ad950f25c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cafa308f-ea72-49c3-b221-a6aba5fcfb74', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', NULL, '84f70526-107d-4b57-b7c2-653c8efc2737', 'ede31012-fbaa-4a4a-b5db-001a2ded08ea', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('85fb9a91-865f-4f7c-84db-df341ae37a8f', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '84f70526-107d-4b57-b7c2-653c8efc2737', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3019aa7a-378d-4f1e-8805-5ed585007161', NULL, '84f70526-107d-4b57-b7c2-653c8efc2737', '3706fd53-e952-408a-aedd-93ec6d5129be', '84f70526-107d-4b57-b7c2-653c8efc2737', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('81204f4a-102e-49f9-a5d9-f32c3854109f', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', NULL, '2812b2d9-15c6-479c-b59d-bf980f4bc9d7', 'dbc52a0b-fe89-46a8-89a8-f155a437fe07', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('69cde6f0-839d-4b94-8045-f65521ef864e', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', NULL, '84f70526-107d-4b57-b7c2-653c8efc2737', '2812b2d9-15c6-479c-b59d-bf980f4bc9d7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0e9156e0-bfc5-4e7b-aa50-29bb214577cd', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', NULL, 'b29939d1-67c0-4527-88fd-41812023f402', 'cd5218c0-fc28-464c-bb9e-ea0eb9698f66', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e0b94c3c-ea4c-485e-9ad9-a58cddffa3cb', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', NULL, '2812b2d9-15c6-479c-b59d-bf980f4bc9d7', 'b29939d1-67c0-4527-88fd-41812023f402', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aeeb2346-c0c5-44c3-9378-2c28cd25ccf5', NULL, NULL, '2812b2d9-15c6-479c-b59d-bf980f4bc9d7', '10cd909b-0099-491f-9a73-0cf1d7765f35', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('75de0bbe-b77e-4328-a30a-3173eb7ac971', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', NULL, 'db6edaf5-7e57-4e26-8172-20fe06d19e16', 'bd7f4de4-1435-42c2-a275-b56e49670e52', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('54a35482-3a81-4513-a2a4-6f820ee9ca7e', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'db6edaf5-7e57-4e26-8172-20fe06d19e16', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a0755eae-b481-4e5d-80de-867fc275bbcf', NULL, 'db6edaf5-7e57-4e26-8172-20fe06d19e16', '3706fd53-e952-408a-aedd-93ec6d5129be', 'db6edaf5-7e57-4e26-8172-20fe06d19e16', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9ef9980c-19c0-4387-b05d-b036f03bd1ae', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', NULL, '5f936257-6096-4792-a496-b92e46d93d0a', '3086d58a-42c3-4c88-ba4c-a1025e79218d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b368b9e7-c014-4179-838f-5e5f39a319c2', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', NULL, 'db6edaf5-7e57-4e26-8172-20fe06d19e16', '5f936257-6096-4792-a496-b92e46d93d0a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d404ab50-71f3-4e9f-8d11-d9a79c724b4d', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', NULL, '814e38c8-c053-4c27-9487-997cf318a550', 'c123b9c1-7755-4fa5-a0c8-ab6bcb0c7156', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('76051553-cbf2-4278-b0b0-c3359028d7e6', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', NULL, '5f936257-6096-4792-a496-b92e46d93d0a', '814e38c8-c053-4c27-9487-997cf318a550', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b9b34809-b46f-4557-9a2a-c05d8ffdd1b9', NULL, NULL, '5f936257-6096-4792-a496-b92e46d93d0a', '529abd87-8855-4eab-a795-a83717bfa4b1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('41d012ed-2283-4f2b-beb3-837b6da3359c', 'e50c983a-060c-47c9-9d47-efd552b1e618', NULL, '0e51c89f-6101-4b6e-be17-53df018b88f5', '6aa26a03-2515-4b88-97aa-1d100dfe872b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3c9fa558-256a-446c-bc5f-48f9d61d8fcb', 'e50c983a-060c-47c9-9d47-efd552b1e618', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0e51c89f-6101-4b6e-be17-53df018b88f5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('37138c2b-aa91-4cf2-8c2b-45dd96aaa5f4', NULL, '0e51c89f-6101-4b6e-be17-53df018b88f5', '3706fd53-e952-408a-aedd-93ec6d5129be', '0e51c89f-6101-4b6e-be17-53df018b88f5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6f109a2d-c0c0-4fa4-8efb-2ebe1eb7b9de', 'e50c983a-060c-47c9-9d47-efd552b1e618', NULL, 'de10229b-be9d-45dc-b1bf-8f832ebffe68', '8695131e-a5fe-4e01-81da-99769f924a12', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('09b015f6-1d81-42ca-a008-c0b3f48a4aba', 'e50c983a-060c-47c9-9d47-efd552b1e618', NULL, '0e51c89f-6101-4b6e-be17-53df018b88f5', 'de10229b-be9d-45dc-b1bf-8f832ebffe68', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d0cf16aa-f119-492d-8b84-c1d904b7da07', 'e50c983a-060c-47c9-9d47-efd552b1e618', NULL, '779e4c3b-97f0-4218-8eab-5575a6afa54a', '10063dba-d6d4-43fa-ab89-d682c47a91fe', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3298e787-5a10-45a0-a0dc-51cb4c595eb3', 'e50c983a-060c-47c9-9d47-efd552b1e618', NULL, 'de10229b-be9d-45dc-b1bf-8f832ebffe68', '779e4c3b-97f0-4218-8eab-5575a6afa54a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('84c142bb-1cd2-41bc-b4d0-be850a736ef0', NULL, NULL, 'de10229b-be9d-45dc-b1bf-8f832ebffe68', '70cf4eb5-99e5-49d1-9c03-70316381bb21', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b1863909-c091-4e66-b1ee-eeb427986f97', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, '1b453f97-a12c-4d51-bf95-2e782b425385', 'cf95f6ed-2e24-45ae-824d-8cc58ee2c2e4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('53c8a05d-7dd8-4faa-9c1b-02c02dff47df', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '1b453f97-a12c-4d51-bf95-2e782b425385', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8213d9da-f8ca-437e-aa92-cbc5d9d458ba', NULL, '1b453f97-a12c-4d51-bf95-2e782b425385', '3706fd53-e952-408a-aedd-93ec6d5129be', '1b453f97-a12c-4d51-bf95-2e782b425385', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('17e46161-8f22-4300-afec-7cb6d8644ca9', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, '3b195996-371c-41e4-9b66-a50553582e17', '8e9ae339-2166-48b7-82e7-f319413db079', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4c13c9aa-805a-4030-9543-a594366d3dd5', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, '1b453f97-a12c-4d51-bf95-2e782b425385', '3b195996-371c-41e4-9b66-a50553582e17', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a291504c-661a-439f-8724-3b57ca8da672', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, '3b195996-371c-41e4-9b66-a50553582e17', '7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f50b89e6-f34a-463f-af85-aeb520a7d831', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', 'ddcd1293-8e77-4cef-91ac-9abfbc2bcd44', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('41b763e3-60c6-40d7-ac4a-89e75e49eec6', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('350cabf5-9716-493a-9cd2-2f954536faa4', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, '7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2f4f0313-b62e-4932-9f41-cae6963a88af', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d7196d34-18f9-4ed4-b703-6534333cf8e2', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3c25862f-829c-49fb-90a2-61bd22edf060', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bc27b1c7-0d02-49cb-959d-023a49c84fd7', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2c78b77e-b708-4198-835c-2fbcabcea7c1', '48618c28-9304-4ccb-b022-e2cbb1832944', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '1b453f97-a12c-4d51-bf95-2e782b425385', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('13875afa-e93d-4e1b-83f6-666292ebae24', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, '98d81696-7c71-4ffe-bfc2-1fea37613440', '43b09570-1e0c-43b9-811c-4aeb27eba284', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('73eb3d48-4daf-4dfe-9c23-2928dea6de58', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '98d81696-7c71-4ffe-bfc2-1fea37613440', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('760fbe86-6b00-4c68-bd19-a65fd477a818', NULL, '98d81696-7c71-4ffe-bfc2-1fea37613440', '3706fd53-e952-408a-aedd-93ec6d5129be', '98d81696-7c71-4ffe-bfc2-1fea37613440', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('50d75c09-191f-4132-8e8a-d1a1aa072443', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, '0f5c3f08-d249-404a-b740-d759fced2d09', '756acc01-691c-46c1-b2f4-53321cc442a2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b30af129-1376-4bcb-9538-f21a660dd6cb', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, '98d81696-7c71-4ffe-bfc2-1fea37613440', '0f5c3f08-d249-404a-b740-d759fced2d09', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('23259cd9-4388-43ec-9d6f-4f8fdac89b91', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, '0f5c3f08-d249-404a-b740-d759fced2d09', '6c0656b5-472b-4859-af3a-b8f1c53231a5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c9f10142-c1f0-4639-a9b3-08b195830787', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, '8ad792c1-10e1-43fa-8d5a-a6f3810878a2', '75550e48-c62e-4734-9406-ad720b5b1f90', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fb781f97-f5ee-44a6-a83b-89952ceb9706', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', '8ad792c1-10e1-43fa-8d5a-a6f3810878a2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('73ffa08f-31ae-4101-bd02-a0de9144f82b', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, '6c0656b5-472b-4859-af3a-b8f1c53231a5', '8ad792c1-10e1-43fa-8d5a-a6f3810878a2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('eea1adff-7c6b-47ae-9bc4-1a54dbfd027d', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, '8ad792c1-10e1-43fa-8d5a-a6f3810878a2', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('818fd81d-cca1-4416-a26d-8f02d8a19a2d', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, '8ad792c1-10e1-43fa-8d5a-a6f3810878a2', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9b8a35d0-0790-4749-90ad-bbaf2a62753f', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '6c0656b5-472b-4859-af3a-b8f1c53231a5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('67455246-3c3c-410d-9465-574f5651c698', 'f415978e-b5c2-4a99-962e-3d31a4658780', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '98d81696-7c71-4ffe-bfc2-1fea37613440', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('134c2594-fd40-4cf9-b55d-34a2c0927521', NULL, NULL, '0f5c3f08-d249-404a-b740-d759fced2d09', 'f3bf0870-b546-4607-a032-a3da135dda48', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('20ae8592-3c34-4ff5-a08a-4b78b6f06ec4', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'b26cca89-03f0-4498-bf64-7385c0b7244a', '9998b7f8-aa0f-44b9-813c-61a2861e242e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f0e59d15-a201-4e8a-8429-d12f6c5e85d1', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'b26cca89-03f0-4498-bf64-7385c0b7244a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('199a84b3-9e30-4a9e-a7e4-1a1e193c7744', NULL, 'b26cca89-03f0-4498-bf64-7385c0b7244a', '3706fd53-e952-408a-aedd-93ec6d5129be', 'b26cca89-03f0-4498-bf64-7385c0b7244a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('27356c34-8a36-42c9-8df3-b631c85beb9f', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, '76968391-174d-4530-b310-1244c4b1897a', '7ffabc42-58db-42c2-a3cb-e4ed830f47af', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c8ec3f73-a9da-437b-8210-5fac4f461a76', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'b26cca89-03f0-4498-bf64-7385c0b7244a', '76968391-174d-4530-b310-1244c4b1897a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4147266e-d023-4753-92ec-07a66f831815', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, '76968391-174d-4530-b310-1244c4b1897a', '863eea7c-8b49-494a-9654-9963f2dbb4e5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bdf804a6-d255-43bf-b752-934d962f7a9a', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', '11a4c50e-451c-4041-92c6-671263f82f2d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ce23e4aa-4648-4b1c-871b-0e23b3913ef1', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'a6ff0898-04e1-49b7-8621-b42846df06e1', 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1a1ec60e-8a1e-472e-80c4-c795e0705237', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, '863eea7c-8b49-494a-9654-9963f2dbb4e5', 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b67f3a92-1dc2-4375-b581-7e2f6984c6ff', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', '5c9372e0-cb21-4ae7-a461-df086ad19426', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('81fd75b4-f29e-4a07-91fe-579bc357d4ad', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1a8ac30e-dfc4-4a15-a89f-5ae76e346844', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a454e188-5f6a-4ce7-bf19-16b55f88482a', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '863eea7c-8b49-494a-9654-9963f2dbb4e5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ab85381b-5249-47ac-88d0-c89c412d0fda', '201b417e-4ebe-458b-a7ce-a287c0ad9287', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', 'b26cca89-03f0-4498-bf64-7385c0b7244a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('957e1c17-2ade-4622-b9c1-958a3ddda746', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', 'a78188dd-3129-488c-b6e1-4889725f5215', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6d28e53e-2724-4968-bdcd-e9bbba70bf30', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7da60e3d-0309-46d0-afbc-da2269a30e81', NULL, 'eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', '3706fd53-e952-408a-aedd-93ec6d5129be', 'eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('16bd32c5-1fb8-47c8-835b-ef21c321916a', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, '8255ff29-5961-496b-9fda-c71078e47e51', '19382a5a-b982-49ac-9005-9358fa7a670a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b5a66d0f-f2e8-4ad4-9048-f23e80d29869', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', '8255ff29-5961-496b-9fda-c71078e47e51', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('31338810-20f5-449d-8270-13a4d48162a2', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, '8255ff29-5961-496b-9fda-c71078e47e51', 'fe0228ea-649c-45a4-b729-181aba7f3294', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e1f74e4b-3283-4892-b61a-3d73d3c2232b', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'f218c4d9-d10b-4445-b381-b73a71f5848c', '6ebe0c4d-1649-4d08-897e-805019faced9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e6958262-cfeb-4a7c-8004-1943ab79b429', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'a6ff0898-04e1-49b7-8621-b42846df06e1', 'f218c4d9-d10b-4445-b381-b73a71f5848c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6b066f12-6113-4016-a776-45feb5fa565d', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'fe0228ea-649c-45a4-b729-181aba7f3294', 'f218c4d9-d10b-4445-b381-b73a71f5848c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f84e3e07-910e-40cc-9b82-bd739fa3754d', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'f218c4d9-d10b-4445-b381-b73a71f5848c', '5c9372e0-cb21-4ae7-a461-df086ad19426', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c05042dd-31c3-4353-99aa-7b2728751fd3', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'f218c4d9-d10b-4445-b381-b73a71f5848c', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('af03a3ed-0a14-42ea-b6cd-60675f1785ac', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', 'fe0228ea-649c-45a4-b729-181aba7f3294', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d9f780ca-ba82-4279-85c8-6ca168938d2e', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', 'eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2458ddeb-be02-4d0d-b7c7-c3c75981b32d', NULL, NULL, '8255ff29-5961-496b-9fda-c71078e47e51', 'f5fc0f70-790b-460b-a072-d1f9c01bc7de', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('213b814a-4f8f-4eb5-9a06-ef7ebd9006bd', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, '5242e0b6-12e3-4a59-bf06-de114cb69ff4', 'fc09e45c-99c6-46ff-a51f-39de6d561c93', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e24b7e89-1446-4179-af6e-ffff06252b2d', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '5242e0b6-12e3-4a59-bf06-de114cb69ff4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c47f555a-4a8e-4bdb-a879-bbcf15fd9b43', NULL, '5242e0b6-12e3-4a59-bf06-de114cb69ff4', '3706fd53-e952-408a-aedd-93ec6d5129be', '5242e0b6-12e3-4a59-bf06-de114cb69ff4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e38a8794-b4db-46e4-b67d-837a7c1a3b14', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, 'b8350678-d30a-422a-bb5d-79c65af2f890', '87567caf-5abc-4511-9191-27dbdbbee88b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('068f8780-cc84-478f-a854-bf547462928c', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, '5242e0b6-12e3-4a59-bf06-de114cb69ff4', 'b8350678-d30a-422a-bb5d-79c65af2f890', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('451ef309-629c-4ae8-8a77-2ea3031ddf5b', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, 'b8350678-d30a-422a-bb5d-79c65af2f890', '0f833f5a-8afb-4934-a8a6-9dadbdcf89dd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('da4d7c96-becf-4375-91eb-2796ad6a6080', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, 'c85e8116-355e-408a-93fa-c699da2a76f3', '5fe9a533-2cd3-4433-811c-fcc415acdf60', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5398a652-1892-4d2c-8a04-d9e4797e7b74', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, 'b9592474-79f3-42d9-828f-8cc2e5c8ba7c', 'c85e8116-355e-408a-93fa-c699da2a76f3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cd8cea28-0a51-4138-b8f4-c4ab1434be57', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, '0f833f5a-8afb-4934-a8a6-9dadbdcf89dd', 'c85e8116-355e-408a-93fa-c699da2a76f3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('03061e1b-65d1-4d11-abc7-d8e7ec1fe19f', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, 'c85e8116-355e-408a-93fa-c699da2a76f3', '1280183b-c71a-4b86-bdec-7f3800679ef4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a37e1b17-c3d5-4a4d-bfc5-3acbdf1f6aa3', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, 'c85e8116-355e-408a-93fa-c699da2a76f3', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1ece18ff-7bab-4131-a86f-29e228905d29', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '0f833f5a-8afb-4934-a8a6-9dadbdcf89dd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f0ef38f9-1f74-4ece-9545-becfca68e4b0', 'f85f9a58-7651-417f-b1b2-cf522bcce415', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '5242e0b6-12e3-4a59-bf06-de114cb69ff4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f0e8cfe6-a221-45da-9365-1db2038523a7', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, '3de42185-1e32-4936-b305-d990b85c45c2', '359d8691-dc07-4b5a-9179-0f78927b4660', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('76b536c1-96bb-400b-bb19-428eabb921bf', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '3de42185-1e32-4936-b305-d990b85c45c2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('28073fd9-9f01-4cb8-9d16-253af4a81e30', NULL, '3de42185-1e32-4936-b305-d990b85c45c2', '3706fd53-e952-408a-aedd-93ec6d5129be', '3de42185-1e32-4936-b305-d990b85c45c2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('27d55740-9964-46b5-9442-6db33186a8ff', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, 'bb8fc553-9dbe-4ea5-a3ea-02d129841f68', '2698d560-1c07-48e5-9d9a-78ccfb2c0631', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c3164a0f-34dc-4915-84c6-cbf8447290e4', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, '3de42185-1e32-4936-b305-d990b85c45c2', 'bb8fc553-9dbe-4ea5-a3ea-02d129841f68', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('223e16ac-ae1d-41f0-bd5a-97ad8d7a8f02', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, 'bb8fc553-9dbe-4ea5-a3ea-02d129841f68', 'bbfb4fc6-80f7-4a82-aa82-3d787539ebeb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7083d2a0-ecb2-47c7-a857-60b9d4c52044', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, '07aa8ca8-e06f-4335-9cb0-99e98d45b2c6', '21bc4186-042f-4643-bbea-61f44563225d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5015e0ca-124a-4250-9e0b-8ead9f6595f9', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, 'b9592474-79f3-42d9-828f-8cc2e5c8ba7c', '07aa8ca8-e06f-4335-9cb0-99e98d45b2c6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('308a364e-b65d-4599-a29d-c0948a1c79a4', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, 'bbfb4fc6-80f7-4a82-aa82-3d787539ebeb', '07aa8ca8-e06f-4335-9cb0-99e98d45b2c6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('026ce7a1-3001-441f-b1e0-c4634da6e3a0', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, '07aa8ca8-e06f-4335-9cb0-99e98d45b2c6', '1280183b-c71a-4b86-bdec-7f3800679ef4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6fc95ac7-9ceb-45f2-86b8-dc1fe34c3cce', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, '07aa8ca8-e06f-4335-9cb0-99e98d45b2c6', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fefb4326-1b6b-451a-b502-67094bb01d18', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', 'bbfb4fc6-80f7-4a82-aa82-3d787539ebeb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('36a2fb6f-578c-41e4-9581-0ff42f0d1aac', '78123dac-fed2-4e3e-817b-0c13a2129dfe', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '3de42185-1e32-4936-b305-d990b85c45c2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a28bf37e-a03d-4b03-98e5-498b1ada6ea2', NULL, NULL, 'bb8fc553-9dbe-4ea5-a3ea-02d129841f68', '7ceb0f31-aa57-433f-a2e3-0408c2b88b10', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('242a0315-97b6-47a0-a863-2f7c98806c03', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, '0726dd6c-118e-4cbc-9077-d4dcb0e61643', '24c34e16-c5e6-4571-b850-fb64b5ddb61f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ae05d838-209a-4997-89f9-21d4b03bc0ee', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0726dd6c-118e-4cbc-9077-d4dcb0e61643', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6e48a3f5-7017-43ec-8ced-b6ce9e72cd2d', NULL, '0726dd6c-118e-4cbc-9077-d4dcb0e61643', '3706fd53-e952-408a-aedd-93ec6d5129be', '0726dd6c-118e-4cbc-9077-d4dcb0e61643', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9381ce69-6119-44b8-828b-09aa0cc57960', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, '8dfb5e53-1554-4e5c-a045-85121ce4bd71', '8aa371b8-dd2d-4471-95ae-149e30502e54', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f498d771-bf9c-41fb-9566-26de20cf27cf', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, '0726dd6c-118e-4cbc-9077-d4dcb0e61643', '8dfb5e53-1554-4e5c-a045-85121ce4bd71', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8b1cdea5-a267-4c69-82ae-58fcaae807d3', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, '8dfb5e53-1554-4e5c-a045-85121ce4bd71', '13a3ca39-6352-48e1-b1fb-82f3fc5558f2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('407f1720-30d6-43e9-a867-00a4d074e948', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, 'd04aeefe-4ba4-466f-a563-b811674c6de9', '6aa35ccf-fc0c-4fa9-baf3-383bd7c6bc42', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('33b013b4-54f5-4d45-86f4-f60db0af72f7', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, '5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', 'd04aeefe-4ba4-466f-a563-b811674c6de9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5e79c737-6e71-4ba3-a7e2-b5ca9a882536', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, '13a3ca39-6352-48e1-b1fb-82f3fc5558f2', 'd04aeefe-4ba4-466f-a563-b811674c6de9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a46e4f67-0994-4181-9ef4-dd8a56c92a56', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, 'd04aeefe-4ba4-466f-a563-b811674c6de9', '5167487b-90ee-40b9-9c34-535b74b3186e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7ba2475f-ffc9-4cd6-80bf-98699d50ad1c', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, 'd04aeefe-4ba4-466f-a563-b811674c6de9', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('13ff71cb-74b0-4da6-b531-352cc8103e88', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, 'd04aeefe-4ba4-466f-a563-b811674c6de9', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a0a06ef2-c846-444c-b9e8-955a69675e0e', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', '13a3ca39-6352-48e1-b1fb-82f3fc5558f2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c1f1f854-ce70-4ef5-bc5d-04ec3910964d', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '0726dd6c-118e-4cbc-9077-d4dcb0e61643', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2613adb7-f2b0-4d19-b369-8341afa1111e', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, 'e5871fb2-3928-4139-9468-10f0f12d5e5f', '12bf1e90-3965-415a-b2fa-de48afca81f5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('427f8a0e-c26d-452c-b014-8788b80170a7', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'e5871fb2-3928-4139-9468-10f0f12d5e5f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2cf9cc9c-6158-435d-8659-bd875bcbe273', NULL, 'e5871fb2-3928-4139-9468-10f0f12d5e5f', '3706fd53-e952-408a-aedd-93ec6d5129be', 'e5871fb2-3928-4139-9468-10f0f12d5e5f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('634ef36a-4dce-4fc2-b4be-43c1b8a12327', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, '834d7138-e338-4517-aacb-1c6319fa34d8', 'e3026ecc-4a37-438b-b53e-e4ac2d4acd87', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('79861ade-1702-4c55-99bf-ada2f02af12e', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, 'e5871fb2-3928-4139-9468-10f0f12d5e5f', '834d7138-e338-4517-aacb-1c6319fa34d8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('db6cea6c-2d27-4e85-8b38-77fad5a97678', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, '834d7138-e338-4517-aacb-1c6319fa34d8', 'e6409531-6513-43a9-84a7-eff44b18285a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('df1e3b6b-beb5-4797-b5b6-a8762c0f1b13', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, 'd00a14ad-fe79-40fc-8f72-722fb5cd30bd', 'a9296dcc-a040-460e-9319-d93938975fc1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('77ed9bdb-9264-4997-9b33-2997a3203acd', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, '5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', 'd00a14ad-fe79-40fc-8f72-722fb5cd30bd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8f24b7d8-6c62-4b60-9fef-7d79d0d3e931', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, 'e6409531-6513-43a9-84a7-eff44b18285a', 'd00a14ad-fe79-40fc-8f72-722fb5cd30bd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d344d956-9fe8-4d35-b363-ee47c946fae1', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, 'd00a14ad-fe79-40fc-8f72-722fb5cd30bd', '5167487b-90ee-40b9-9c34-535b74b3186e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('102f6591-fa00-4465-9e71-ee89f913f98f', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, 'd00a14ad-fe79-40fc-8f72-722fb5cd30bd', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9070bb47-7db9-4937-b262-4503e9e429a7', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'e6409531-6513-43a9-84a7-eff44b18285a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('147bc926-4d72-47f5-bab4-88736d9fad9b', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'e5871fb2-3928-4139-9468-10f0f12d5e5f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('57e9cd92-8b26-4c73-bb31-364522a91b60', NULL, NULL, '834d7138-e338-4517-aacb-1c6319fa34d8', '7b9008d5-0555-4209-8594-8d2c11e376d2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e5cc260e-4aed-4440-b9b1-8adf3b00c2f2', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '256083e7-90ac-4f38-9bc1-deedb0f78d2c', 'c470f55a-75fd-4754-95d8-02db7679b5e6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b169456f-0f65-4ce0-9ea1-1b183da6768e', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '256083e7-90ac-4f38-9bc1-deedb0f78d2c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3ce3aae9-6498-4e4c-9786-b649933facde', NULL, '256083e7-90ac-4f38-9bc1-deedb0f78d2c', '3706fd53-e952-408a-aedd-93ec6d5129be', '256083e7-90ac-4f38-9bc1-deedb0f78d2c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7dbe679a-2572-4055-a6e1-853e56732c13', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '28bf24da-eb68-4a99-8ff9-6e4145f5e805', '306c497c-f967-41e4-88a6-6d357955a6b4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('25dc18d5-53b0-46fe-9fbc-42617019c65c', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '256083e7-90ac-4f38-9bc1-deedb0f78d2c', '28bf24da-eb68-4a99-8ff9-6e4145f5e805', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d36852bf-fee9-4762-b982-c5c1180f1021', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '28bf24da-eb68-4a99-8ff9-6e4145f5e805', 'f93693fa-7dc5-4513-8537-be9541d6e5dc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d49e8c2a-9535-4791-b5b2-27b4c6449571', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '33a45f49-ac74-4444-a193-2ed1e0be110d', 'a43a17b9-e207-4edd-9184-790b10b105ce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d62c308b-5aeb-4b38-bf3c-1971873ebb7e', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', '33a45f49-ac74-4444-a193-2ed1e0be110d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bae734bf-c252-413a-9f8f-0db3f5fe41da', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, 'f93693fa-7dc5-4513-8537-be9541d6e5dc', '33a45f49-ac74-4444-a193-2ed1e0be110d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1b06c14e-8822-4076-a95c-53c23fae06e7', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '33a45f49-ac74-4444-a193-2ed1e0be110d', '206fcdf2-c22e-480f-9029-42183cc2990e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bb5d5c36-8545-4b0c-83b3-3e6ffe79d064', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '33a45f49-ac74-4444-a193-2ed1e0be110d', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2fb41844-154f-49af-afe1-f145ac823698', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '33a45f49-ac74-4444-a193-2ed1e0be110d', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7be6ff60-48f4-4727-a3b1-ccc76c4bf5f9', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', 'f93693fa-7dc5-4513-8537-be9541d6e5dc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b54d49d5-8b35-4a08-8062-15f1488e1248', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '256083e7-90ac-4f38-9bc1-deedb0f78d2c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d1581eac-a086-44fb-bb09-61971de7d2fd', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, 'd5a60c82-347b-4ebb-b95f-afff297bf966', 'b93cca78-ac4f-497a-90b4-2fbb41ece3a5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('33d71c3e-14d6-4360-b2a1-7cfe03fc8e7c', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'd5a60c82-347b-4ebb-b95f-afff297bf966', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('55d421be-867d-484d-81cf-b4435b645647', NULL, 'd5a60c82-347b-4ebb-b95f-afff297bf966', '3706fd53-e952-408a-aedd-93ec6d5129be', 'd5a60c82-347b-4ebb-b95f-afff297bf966', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ee7dcf77-7d14-4ac3-ac68-75848ce80b37', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, 'bb40b3e2-f355-491e-a3cd-fb3ee258d4b8', '78de8932-0d41-49a3-bd52-4b01648d77c4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6ac62d07-14f8-4e7b-b32a-cdbc01d233d7', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, 'd5a60c82-347b-4ebb-b95f-afff297bf966', 'bb40b3e2-f355-491e-a3cd-fb3ee258d4b8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1ef30096-215a-4465-af6e-df991c630f42', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, 'bb40b3e2-f355-491e-a3cd-fb3ee258d4b8', '6e7feeb7-4891-4ea3-96b6-00d883da37c5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5225abae-81af-491d-8e67-d0d955af7a6b', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, '1ed7ff07-778c-4920-a550-563b27223228', '73fbb1f4-99ac-43f3-8d7c-e032f636754d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('58f3482b-0190-433d-8169-dda40ccdefd6', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, 'a822e970-7b6a-417d-81d0-a8db0c985427', '1ed7ff07-778c-4920-a550-563b27223228', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('132567eb-499c-41ed-8306-0bb3f70fd887', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, '6e7feeb7-4891-4ea3-96b6-00d883da37c5', '1ed7ff07-778c-4920-a550-563b27223228', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e2b5210b-9f82-4aa3-a5e4-db165eff8c82', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, '1ed7ff07-778c-4920-a550-563b27223228', '6fc5eacb-5328-41c3-a71b-e7712338862a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('323c5ab0-83d2-499d-843c-3e2087d129a7', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, '1ed7ff07-778c-4920-a550-563b27223228', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d47916af-37ad-4693-90b9-ab5861a26b19', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, '1ed7ff07-778c-4920-a550-563b27223228', 'd8c41124-ff96-4bc4-b3be-d0a8091128b6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f958dfdb-2482-4a6c-b04f-c48adef089b3', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, '8bfcdf97-8c34-46ca-8159-1314cbb42105', '6e7feeb7-4891-4ea3-96b6-00d883da37c5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3978866a-2fd9-4fe5-829f-cb20953123d2', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', 'd5a60c82-347b-4ebb-b95f-afff297bf966', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c59e8c34-016f-4cde-8f01-d26ce93dfd19', NULL, NULL, 'bb40b3e2-f355-491e-a3cd-fb3ee258d4b8', '57083628-836d-4f19-9359-5fb11537f81d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e638e901-b72b-445d-bccd-010251464101', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, '7db53bc9-99f3-478e-abb0-437dcbd32051', '65238cdd-b9f4-40ce-87db-581432f3c7b8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('181658a3-893e-4d06-ace8-513ddf36c13f', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '7db53bc9-99f3-478e-abb0-437dcbd32051', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8accb64a-32a0-46c8-8cf2-8444799bf14b', NULL, '7db53bc9-99f3-478e-abb0-437dcbd32051', '3706fd53-e952-408a-aedd-93ec6d5129be', '7db53bc9-99f3-478e-abb0-437dcbd32051', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3c27d5a9-f3e3-4d78-815b-eac8aacbac70', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, '9771d06d-8352-404c-aaba-743800e621e9', '31b17fc6-f132-43a5-8e48-652c48306331', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('53650829-a412-4b78-8071-23af27a3767a', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, '7db53bc9-99f3-478e-abb0-437dcbd32051', '9771d06d-8352-404c-aaba-743800e621e9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('21990b68-f8c1-492e-8b58-584f9373f011', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, '9771d06d-8352-404c-aaba-743800e621e9', 'b34392da-5070-40dd-ab44-d411a9742f6d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('254c6299-81b1-40b6-80bc-01140b2e3f21', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, 'e37e21bc-4d4f-4d41-8c24-399be1680a15', 'aa9b0636-bcef-4296-bfc4-2beb3c99da38', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3ffc38c4-6668-4096-b172-1f6d2d4dc409', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, '42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b', 'e37e21bc-4d4f-4d41-8c24-399be1680a15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d6cdd1c4-0d36-48f2-8747-a47762496474', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, 'b34392da-5070-40dd-ab44-d411a9742f6d', 'e37e21bc-4d4f-4d41-8c24-399be1680a15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9e939ad9-00b2-4a23-8875-72a5ac7ff728', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, 'e37e21bc-4d4f-4d41-8c24-399be1680a15', '24f9488b-412f-4314-b160-2897f4dcff1b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9d271802-89ff-4d61-bb61-21f47e44c357', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, 'e37e21bc-4d4f-4d41-8c24-399be1680a15', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0e3b55cc-cda2-4c8a-980c-aa0824656de2', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, 'e37e21bc-4d4f-4d41-8c24-399be1680a15', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2b6cbd8c-5a91-4081-a2df-01ab5d477416', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', 'b34392da-5070-40dd-ab44-d411a9742f6d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('96f807f2-391c-49f1-aa63-d14cf9fe4c7f', '164d3cde-e2ab-4239-9dbf-de1c963158ac', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '7db53bc9-99f3-478e-abb0-437dcbd32051', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9efd3573-3fd0-4838-b700-9e2d528d6dae', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, '0d96a253-347e-4903-9db9-b362335e4341', '1350b6fe-91ee-4c79-bc87-e2632a01100f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0fcaf240-6815-4712-a320-6463135f4624', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0d96a253-347e-4903-9db9-b362335e4341', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3ff9ad8b-f7fc-4d25-aaf7-8c5937ca379f', NULL, '0d96a253-347e-4903-9db9-b362335e4341', '3706fd53-e952-408a-aedd-93ec6d5129be', '0d96a253-347e-4903-9db9-b362335e4341', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ae6cb6c2-c690-4527-8ec8-1c2b1d7e44df', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, 'ba80c834-f5a8-4243-98a6-9a3be63c4f47', 'bff60077-ab16-4e5d-8667-1ad2b801b961', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('308438c8-a6b8-4e79-8d69-67f7589d9175', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, '0d96a253-347e-4903-9db9-b362335e4341', 'ba80c834-f5a8-4243-98a6-9a3be63c4f47', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1d4f1080-13a6-4011-bf9f-bb67a3c7be94', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, 'ba80c834-f5a8-4243-98a6-9a3be63c4f47', '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('77f6392c-dc17-4c22-92af-4462666916c1', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, '42f0c634-d86b-4129-822b-f103cd6e0755', '2b36563d-caee-4170-b444-ec02ca919165', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('744c3088-f933-4c59-ae37-d83f2357f83c', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, '06bf2ac2-61c5-42e9-917b-8b68afcc0d47', '42f0c634-d86b-4129-822b-f103cd6e0755', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('077b5b92-2620-489c-97c8-f32c5013437b', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', '42f0c634-d86b-4129-822b-f103cd6e0755', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4e176c48-1f1f-4e8d-8698-565f62041d2b', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, '42f0c634-d86b-4129-822b-f103cd6e0755', '7a8959c2-e6c0-4af3-9d64-117811ec0d02', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e8ba8789-050f-4ac4-9bd2-ea16bd83ac7a', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, '42f0c634-d86b-4129-822b-f103cd6e0755', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ef21d6e1-e714-4d9e-bdbe-86408d6acc87', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, '42f0c634-d86b-4129-822b-f103cd6e0755', '9115be3d-2bef-40ce-b0c9-339e460c751d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8c126907-db23-4e7f-b375-7109fe72f2c6', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, 'bab68a5a-2016-454e-b143-8c334188d2c4', '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bc3130a1-8534-426a-9dea-7744b423ee9c', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '0d96a253-347e-4903-9db9-b362335e4341', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d5a8ffce-04bb-4fa3-b9a7-d4f9e15564aa', NULL, NULL, 'ba80c834-f5a8-4243-98a6-9a3be63c4f47', 'dbead323-2088-4b0b-ac6c-599696219411', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d5305aaf-e2ab-4f48-8a2e-374e8d5b181e', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, '0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', 'b6f28163-8b15-403b-ad8e-8322ae8bb5b9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('36f25015-ab5d-478b-b8e9-bcfb12daa23f', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0d5c34e2-7fd3-4008-806f-c71fbc354439', NULL, '0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', '3706fd53-e952-408a-aedd-93ec6d5129be', '0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('97bb7d46-c076-472f-9210-7756f0d3b1de', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, 'cb295fdb-e294-4b05-944e-f0a4929ebeeb', '9cf4d386-c968-40c4-8af9-401c58cca6b4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('77bb249a-a506-4b22-8ade-3c3a211e98fc', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, '0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', 'cb295fdb-e294-4b05-944e-f0a4929ebeeb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5fb16788-c6df-4a8e-b9f5-9b32668de76c', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, 'cb295fdb-e294-4b05-944e-f0a4929ebeeb', 'f3af3c81-a512-47ea-8b47-0386291e6590', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c49d231c-9b99-4bf1-a5b3-9fd54ea13026', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', '14b3a0c2-46d5-409e-bd0d-ff369c37950a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b02fa45d-4e3f-4117-b702-6567d9197965', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, '57ee73c6-769e-461e-9cea-7bfe56970bf7', 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c1061599-40fe-498d-b569-e66220a277fa', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, 'f3af3c81-a512-47ea-8b47-0386291e6590', 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3a244791-44c8-4eff-8361-7e12ebc10375', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', 'e65ad361-79d6-46a3-a7c7-a18048b7237a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2852d47f-a898-42ff-aa68-0d63a4bfd696', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6af132d3-5e42-4379-bceb-c27b9a4a27c7', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', 'ea1789f5-11fe-4ec3-8d12-2623ba592c7f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3537239c-f45c-4357-abd7-7ff36e7bc90b', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', 'f3af3c81-a512-47ea-8b47-0386291e6590', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e7352fb4-4789-4398-bca1-5e02ffb184af', 'a85fd289-2383-4abe-b796-9b0b47d702d2', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bf8dc5e3-3d2b-4a20-82c9-345b886a902f', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, 'dc8ae2b6-d20e-4592-8356-3547bcc58f80', 'd6ea4d88-241f-4430-9590-918a5de2a3d4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e824602d-53bf-49ba-b6c5-c78b826bf94c', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'dc8ae2b6-d20e-4592-8356-3547bcc58f80', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bef40c9e-b569-417c-a8c3-a46bd4a1c43c', NULL, 'dc8ae2b6-d20e-4592-8356-3547bcc58f80', '3706fd53-e952-408a-aedd-93ec6d5129be', 'dc8ae2b6-d20e-4592-8356-3547bcc58f80', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8be44ea3-3a15-45bf-80cf-da0dd7168dcf', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, '3010c421-5c96-4f0d-b214-c773e0915564', '5c038c2d-e3f8-4593-9733-0e1d2c85e318', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e72f6461-12f1-49dd-8fee-e7e4b1cd0ab4', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, 'dc8ae2b6-d20e-4592-8356-3547bcc58f80', '3010c421-5c96-4f0d-b214-c773e0915564', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3985a8c6-9cbf-4e1a-a95f-1f83030eb7a4', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, '3010c421-5c96-4f0d-b214-c773e0915564', '270aac69-03bb-4429-b925-3019bd92cf32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('81b68632-0cb7-41d8-bf15-61048ff1bc3c', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, '7d632200-5506-4856-a3c0-d806b1ee708b', '63a0e010-3a4d-4ec7-bcd5-2fa63a1cca23', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('24b19f50-1f29-4879-a6d4-d5f40fcab1c2', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, '57ee73c6-769e-461e-9cea-7bfe56970bf7', '7d632200-5506-4856-a3c0-d806b1ee708b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0084180b-3df7-42bd-976d-54d2f30fe5e6', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, '270aac69-03bb-4429-b925-3019bd92cf32', '7d632200-5506-4856-a3c0-d806b1ee708b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2d7e7850-06e8-4f75-9a32-bc7af55f0187', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, '7d632200-5506-4856-a3c0-d806b1ee708b', 'e65ad361-79d6-46a3-a7c7-a18048b7237a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0be56d6-9d14-4de6-8b86-c67b8466a25c', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, '7d632200-5506-4856-a3c0-d806b1ee708b', 'ea1789f5-11fe-4ec3-8d12-2623ba592c7f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0f722b48-de60-4b11-a39f-e3dfcf5aa326', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', '270aac69-03bb-4429-b925-3019bd92cf32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('358cfa61-0b40-46eb-a240-dc3320284148', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', 'dc8ae2b6-d20e-4592-8356-3547bcc58f80', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2155b641-8562-4ad5-a883-3d5c12b71564', NULL, NULL, '3010c421-5c96-4f0d-b214-c773e0915564', 'fc2159a0-53c2-416b-9daf-506258c420e3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('14b41604-025f-45cf-a1fa-92b91a7b060e', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, '7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', '9de4eb42-73cf-4178-ad43-0bc7b9042c76', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c2077db5-79fb-481f-bc9d-95337bfb2577', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4cda3b7b-bf01-4342-b3db-fc8998b6ef1e', NULL, '7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', '3706fd53-e952-408a-aedd-93ec6d5129be', '7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('670460c6-e47b-48b6-bf0e-e5a5dbf0d43b', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, 'f101cc07-ed84-4e34-9f70-62ec6a646e81', 'e1cd9ef3-11e4-4907-bb78-b30f83f576e8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0a0f5572-7ef2-4996-b7f9-9092b99b70ba', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, '7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', 'f101cc07-ed84-4e34-9f70-62ec6a646e81', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4e574ad9-8a38-413e-8bfa-55930363707f', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, 'f101cc07-ed84-4e34-9f70-62ec6a646e81', '1d4c6f1f-200f-4a68-ae7b-6fda13687e41', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5dc0084d-25cb-4af7-a2a9-ff2446a4a797', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', '2877af8d-ece8-4b33-8b68-a4985caa2635', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('60ca4436-2f6e-4152-8551-4e9a465a7b29', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, '93ec1b20-de2b-4af1-924f-047a7afa0276', '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6be28944-7289-4924-adfa-9d613a1903d0', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, '1d4c6f1f-200f-4a68-ae7b-6fda13687e41', '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4589acd9-b04f-432a-91ea-f157d75e0b16', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', '4330591d-61d5-4435-827a-c71b8328a700', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e30e4485-5f53-41aa-9d5c-e580d98e8adf', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7969599c-5bef-42c7-8513-9c7e545e804c', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', 'a7ff4f1c-7c33-43e0-b264-37339141f7f9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c0c021ee-8650-4478-964f-0e7297484724', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', '1d4c6f1f-200f-4a68-ae7b-6fda13687e41', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('25a3a86f-88d4-48b5-8b49-9ab3a0cb9d41', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('014daf58-1e7c-4367-8913-001885ac18ba', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, '3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', 'a4b7dd17-bc12-4152-80e0-4186caab003a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('55252844-1a23-453b-86da-d8a61347ea8e', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0897358d-6a31-4239-840a-5643616ceefa', NULL, '3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', '3706fd53-e952-408a-aedd-93ec6d5129be', '3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('472f52b4-1b7b-4194-b8f0-d7c23686f721', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, '6ec65964-76d1-4e7d-aacc-6a18e4eadf67', '3dec9bdf-06fc-4a27-b26d-5918ad1e5990', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1741dfae-e362-4172-a594-d9c43da3c695', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, '3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', '6ec65964-76d1-4e7d-aacc-6a18e4eadf67', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f8534a79-f9a6-433e-ad0a-670a242adb12', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, '6ec65964-76d1-4e7d-aacc-6a18e4eadf67', '7e71f107-6953-42c7-a560-dc9036094198', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('71f86f97-8d99-488a-837d-63fb7391647b', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, '51bb98dd-9201-40e4-b008-221337eeb471', '7efca22b-d9ff-4331-a718-ddfca5ebac59', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('57645ef6-c6b1-42f2-a8ff-d92ff3c5728f', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, '93ec1b20-de2b-4af1-924f-047a7afa0276', '51bb98dd-9201-40e4-b008-221337eeb471', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f1a7d8e4-712d-4e30-bf71-4b0c79489a29', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, '7e71f107-6953-42c7-a560-dc9036094198', '51bb98dd-9201-40e4-b008-221337eeb471', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6fbae586-ade0-46b4-9d3d-abd641e5da1e', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, '51bb98dd-9201-40e4-b008-221337eeb471', '4330591d-61d5-4435-827a-c71b8328a700', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ab6f00c4-88be-4613-b44c-4760760877a3', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, '51bb98dd-9201-40e4-b008-221337eeb471', 'a7ff4f1c-7c33-43e0-b264-37339141f7f9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('869d177e-9bf1-44ad-b890-efab238568ac', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', '7e71f107-6953-42c7-a560-dc9036094198', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fa3d3a8c-40e6-4c39-9be7-3225af11ad34', '268c2ce6-8945-4393-9916-ac90050f064a', NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', '3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('afc35729-f746-43f6-bfe2-cdc1688c89a3', NULL, NULL, '6ec65964-76d1-4e7d-aacc-6a18e4eadf67', '85505863-6857-4ae9-82de-f9394eebd7df', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6bcdce43-ebe8-48a8-8bbe-757ac3d22f62', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, '9a93e3c2-b1c1-47d1-8761-0cafe9b42917', 'ccdf92f5-ebce-4d9b-b544-e470959b498b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fc944320-20a9-4b02-bb1f-8a8692b477c4', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '9a93e3c2-b1c1-47d1-8761-0cafe9b42917', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f3462b23-10d0-4491-9f6f-f938b0479eff', NULL, '9a93e3c2-b1c1-47d1-8761-0cafe9b42917', '3706fd53-e952-408a-aedd-93ec6d5129be', '9a93e3c2-b1c1-47d1-8761-0cafe9b42917', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('80aa3cff-e661-4853-868e-66706ce46d96', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'acf8c4b2-7c5f-4e89-9696-77a598b5f8b8', '307b971b-39bf-4a5d-8595-ad080abafbb0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ef9ac178-79d4-460f-9cbc-3c1f1d9fcfee', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, '9a93e3c2-b1c1-47d1-8761-0cafe9b42917', 'acf8c4b2-7c5f-4e89-9696-77a598b5f8b8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('34113cca-7848-4dd1-85b5-1137c93de73b', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'acf8c4b2-7c5f-4e89-9696-77a598b5f8b8', 'ed2f5f84-cc30-4f29-aef7-48eb64a5fb15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('041d4019-8ada-401a-8cff-3c3d5eb68344', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'c3aff634-452d-47fc-954f-9edebe3a0c74', '37dc0f00-4620-46dc-83a6-3d64cbc7a1a2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bab7f934-c15a-4ea4-925c-97df5c2f07c9', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'b9592474-79f3-42d9-828f-8cc2e5c8ba7c', 'c3aff634-452d-47fc-954f-9edebe3a0c74', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('22fabbc7-68d6-4067-9389-4df1f0fc81b6', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'ed2f5f84-cc30-4f29-aef7-48eb64a5fb15', 'c3aff634-452d-47fc-954f-9edebe3a0c74', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3eefa810-8bf3-465e-8fc8-0b9be1454ced', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'c3aff634-452d-47fc-954f-9edebe3a0c74', '1280183b-c71a-4b86-bdec-7f3800679ef4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c1c89eb6-d2a7-42d0-a8eb-2cc7432baa6c', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'c3aff634-452d-47fc-954f-9edebe3a0c74', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('60a5a33a-e2b7-4160-800d-740251613ddd', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', 'ed2f5f84-cc30-4f29-aef7-48eb64a5fb15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4f17fa4e-ae1e-40c7-9047-321e1e52c84a', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '9a93e3c2-b1c1-47d1-8761-0cafe9b42917', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('53c499fa-1699-45a5-b113-9a952c73fd17', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, '06917568-e508-436a-a50f-246ea2afe064', '84fffac0-e3e1-4374-a4e1-6d16b91d9e8f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('65c5505d-1600-476b-8580-fb6084cf1d7d', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '06917568-e508-436a-a50f-246ea2afe064', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ffa4fc5b-0677-4cae-832f-11382c2ce292', NULL, '06917568-e508-436a-a50f-246ea2afe064', '3706fd53-e952-408a-aedd-93ec6d5129be', '06917568-e508-436a-a50f-246ea2afe064', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e48f9681-c424-4348-8fc6-c0303d4f01ec', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'b152c130-be97-416c-b531-52656dd3c38d', '7a5ed45e-7096-4f48-a0d9-83df51f3349c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('340a557e-8439-4bf8-ba93-5c7747dce2d4', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, '06917568-e508-436a-a50f-246ea2afe064', 'b152c130-be97-416c-b531-52656dd3c38d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('460cb051-c5db-4d1f-bd66-36fc267c2ff2', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'b152c130-be97-416c-b531-52656dd3c38d', 'd6c011ff-bf38-4f09-be3e-45f89eca1ed4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7719c65b-f997-4b81-8773-8ea6ac2551ac', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11', 'f2395c78-9098-4d15-9ac4-b330a6802390', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bc2eeae8-cd95-498d-8790-d139c352019d', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'b9592474-79f3-42d9-828f-8cc2e5c8ba7c', 'b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bec9f28c-f43f-4611-ac52-8f6965ba934c', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'd6c011ff-bf38-4f09-be3e-45f89eca1ed4', 'b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('da004904-0957-4585-8c99-9990099e48bc', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11', '1280183b-c71a-4b86-bdec-7f3800679ef4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('20123f90-13d3-4b79-8200-84c570c86645', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11', '2bcadf08-a16f-4ab6-afbe-83db1b1424d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f4964fb4-c46b-4bc5-b7a6-36526dcbc16c', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', 'd6c011ff-bf38-4f09-be3e-45f89eca1ed4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('186482a3-b3aa-4f41-b3c0-878bc178afab', '86b706e2-9225-482e-b82a-d4ac4adab065', NULL, 'f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', '06917568-e508-436a-a50f-246ea2afe064', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7305f3c9-8235-4a92-85bb-9ce6188edfaa', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, '52fd5f0b-55be-4e14-abfd-6b94ff5b830d', 'b371c978-c2d9-4b06-94be-a0944f0e8b34', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('40d08a9d-d990-4a9e-a5b1-6c60e8a70881', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '52fd5f0b-55be-4e14-abfd-6b94ff5b830d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c7b75a52-20e3-4d01-ba1c-bc18ad58cfa0', NULL, '52fd5f0b-55be-4e14-abfd-6b94ff5b830d', '3706fd53-e952-408a-aedd-93ec6d5129be', '52fd5f0b-55be-4e14-abfd-6b94ff5b830d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bfdbce82-4e8b-415a-b5bc-36dfac77faaf', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'a81d830d-68c5-44ea-bd6b-968a28f90197', 'f8fd6f7e-9507-47ad-ab42-fbd72c3718f1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dd0a6ede-4366-40d2-8355-6fd331cf91f3', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, '52fd5f0b-55be-4e14-abfd-6b94ff5b830d', 'a81d830d-68c5-44ea-bd6b-968a28f90197', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b54dffd4-9a6a-46f9-b66d-dc4b3a71ed1a', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'a81d830d-68c5-44ea-bd6b-968a28f90197', 'a64973bb-c814-4af9-b020-99f5f726dd24', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6b621671-5dfc-49c2-8900-a243c08cd4d1', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'aa3db109-7ed1-496a-9490-62dabce849e2', '9fb3f5e1-472b-4679-a4a8-099557352ec7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3792e102-fc0a-41bc-9c09-dff0f2c6ee17', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', 'aa3db109-7ed1-496a-9490-62dabce849e2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('49cf2839-3725-4c1b-839f-69006291fa6a', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'a64973bb-c814-4af9-b020-99f5f726dd24', 'aa3db109-7ed1-496a-9490-62dabce849e2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d49825b7-cd73-44c8-b642-fc6e1a2e8343', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'aa3db109-7ed1-496a-9490-62dabce849e2', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f19b508b-3f4f-40ed-add1-f4cf0f0f3f44', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'aa3db109-7ed1-496a-9490-62dabce849e2', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f2c14dae-2c58-49a3-bb69-1179e3e07155', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', 'a64973bb-c814-4af9-b020-99f5f726dd24', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bce6bc63-111c-4b80-be4b-1af2234d732a', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '52fd5f0b-55be-4e14-abfd-6b94ff5b830d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a2a9410b-7cc0-4cb4-a9fc-b3d3af01872e', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, '5c2537c8-eb2c-4da1-b78e-071377668767', '909ff58a-4c4c-410d-a3eb-f17cf15c330c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8f34f92d-555d-4a02-86cb-4353761e58f5', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '5c2537c8-eb2c-4da1-b78e-071377668767', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0f0950ef-2899-4385-8256-9c7dd9c70628', NULL, '5c2537c8-eb2c-4da1-b78e-071377668767', '3706fd53-e952-408a-aedd-93ec6d5129be', '5c2537c8-eb2c-4da1-b78e-071377668767', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e4bcfb5b-8fee-42b3-a716-306448e99696', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, '07b606b4-e386-4d2d-8ecd-438aa4b3cd80', '2b643877-6882-4d24-bf51-fb39d8a59287', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5c958c7b-c36f-4565-b5ea-2ce0ea2aacda', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, '5c2537c8-eb2c-4da1-b78e-071377668767', '07b606b4-e386-4d2d-8ecd-438aa4b3cd80', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('295e2bec-5586-4a30-8d27-f5462136389e', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, '07b606b4-e386-4d2d-8ecd-438aa4b3cd80', 'ce71b519-42cc-4674-8bc0-a2df3c13b6c7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ec03b430-bd0f-4553-bea1-756f4442d5ad', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, '425b6cf7-172a-4e48-9f66-5592d4e25a99', '51982882-3575-40c4-86a1-c05fedc436db', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c486f6cf-9037-4fb2-828b-c29110390e98', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', '425b6cf7-172a-4e48-9f66-5592d4e25a99', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('18b7e9cb-354d-4eb2-a06a-11d19c91adb9', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, 'ce71b519-42cc-4674-8bc0-a2df3c13b6c7', '425b6cf7-172a-4e48-9f66-5592d4e25a99', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c5644335-3b7f-4438-8814-e098d72c2772', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, '425b6cf7-172a-4e48-9f66-5592d4e25a99', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('08630602-93c4-4caf-8086-fe3910ba48f0', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, '425b6cf7-172a-4e48-9f66-5592d4e25a99', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e130a4fa-c05f-45b6-a232-e526c0c20c15', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', 'ce71b519-42cc-4674-8bc0-a2df3c13b6c7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9bb65a3b-e712-46c4-9bd8-f7a77494e24a', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '5c2537c8-eb2c-4da1-b78e-071377668767', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fe96ea19-f953-40d1-9745-b36f78493abb', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, '5b5433b1-b6eb-4034-841b-559cba014f35', '5ce74841-55a0-48a2-86ff-253dcfdf8a6f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fd38daf1-62fa-4edf-a316-dbe4945b4ae8', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '5b5433b1-b6eb-4034-841b-559cba014f35', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('336f1895-1533-4773-b907-18b4a4beec3c', NULL, '5b5433b1-b6eb-4034-841b-559cba014f35', '3706fd53-e952-408a-aedd-93ec6d5129be', '5b5433b1-b6eb-4034-841b-559cba014f35', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cd6e2e18-034c-40bf-bf34-86481d40edb8', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, '9851392a-7c6e-4642-881b-dd7728556b86', 'fe903d29-2b20-4f62-8973-ce885b0d03ab', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('720713e2-c2f4-47f2-9479-0f9a518f6895', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, '5b5433b1-b6eb-4034-841b-559cba014f35', '9851392a-7c6e-4642-881b-dd7728556b86', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c4b87697-d656-47d7-88ed-9bf46fae9de7', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, '9851392a-7c6e-4642-881b-dd7728556b86', '7c6415c0-9900-4de6-9459-e4d50b8e9ae4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('855c8310-eb6b-4026-80ea-ed56ff9c25bd', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, '6035bf8e-466b-47f7-a3e8-96bab2e8033a', 'fa80b5e8-d9c5-4d4e-b7c7-3eb28a90f991', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3b8c7961-f697-4f50-a6b6-a0f27ee09ec6', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', '6035bf8e-466b-47f7-a3e8-96bab2e8033a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aab2538a-a511-4780-8607-34f99eee440f', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, '7c6415c0-9900-4de6-9459-e4d50b8e9ae4', '6035bf8e-466b-47f7-a3e8-96bab2e8033a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('98256c44-181e-4e8b-bc97-e044d8b8b0f4', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, '6035bf8e-466b-47f7-a3e8-96bab2e8033a', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ffa67fff-4ec5-4d34-92df-6ababcbe29a0', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, '6035bf8e-466b-47f7-a3e8-96bab2e8033a', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('80052042-d14f-4e9e-98a7-c3fd9daf423c', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '7c6415c0-9900-4de6-9459-e4d50b8e9ae4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cd293115-6fe8-457e-9010-870320be69bf', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '5b5433b1-b6eb-4034-841b-559cba014f35', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2e8ae0f2-98ff-4656-978f-e2fffec36ce9', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, '1326d07c-623b-40fc-942a-659f5c7308ee', '118e8006-bf10-4b7d-8f07-fb4b8d9de592', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8c2b7fff-9921-445b-857c-de9de2dfcc0d', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '1326d07c-623b-40fc-942a-659f5c7308ee', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('24ff72b7-f6cb-445e-a246-24a39f837a21', NULL, '1326d07c-623b-40fc-942a-659f5c7308ee', '3706fd53-e952-408a-aedd-93ec6d5129be', '1326d07c-623b-40fc-942a-659f5c7308ee', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2da62c4f-9568-4013-b1e6-d1f91ded337e', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, '5310f493-97fb-4203-b41b-71423252cc4e', 'a2f2cc36-6c62-44e0-aaec-b4749ed25558', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('20286312-5e98-4ef1-b0ff-0439187b7f4c', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, '1326d07c-623b-40fc-942a-659f5c7308ee', '5310f493-97fb-4203-b41b-71423252cc4e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4efe1a38-ea34-4c3f-bdff-a511210ce018', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, '5310f493-97fb-4203-b41b-71423252cc4e', '09d8befe-d786-4023-b10e-5479f6d09bc1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b8aa7fbb-8bee-44d6-b98f-072f6d26a269', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, '03b9f057-a59e-4253-a83a-ed4d7058a663', '252d4677-4f71-4719-a287-37245b03a8bf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('767f78b2-90e0-4c86-b7cc-ba112668c7a1', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', '03b9f057-a59e-4253-a83a-ed4d7058a663', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d5c7c0d3-5e91-4abf-8729-c2e6045550cc', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, '09d8befe-d786-4023-b10e-5479f6d09bc1', '03b9f057-a59e-4253-a83a-ed4d7058a663', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8f30f856-f8c4-4fe4-aab3-30613db0380f', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, '03b9f057-a59e-4253-a83a-ed4d7058a663', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8533c3db-8c1d-4d0b-ab2d-6087562d07c6', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, '03b9f057-a59e-4253-a83a-ed4d7058a663', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('77b6e4a5-a112-4d8c-89cf-9b9442283a17', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '09d8befe-d786-4023-b10e-5479f6d09bc1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ebb76242-19c3-4f3b-a669-8400acf4abda', '47b7bd3f-8668-4934-bee9-56708e835d7f', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '1326d07c-623b-40fc-942a-659f5c7308ee', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('97156b91-a452-4cf3-8c14-fa7f5c5a26da', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, '108a7577-6cac-417f-a0dc-84c799c54797', '5367452a-5726-452f-a76b-8393cc5e6689', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('59ee3338-5e2f-4d01-9316-c79338de9aa3', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '108a7577-6cac-417f-a0dc-84c799c54797', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b42ffc07-cefe-4607-b3f4-4fa5827bd0df', NULL, '108a7577-6cac-417f-a0dc-84c799c54797', '3706fd53-e952-408a-aedd-93ec6d5129be', '108a7577-6cac-417f-a0dc-84c799c54797', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('46f25ed8-a3cf-422a-bc12-0617d0cfdeed', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, '4538eaad-57b6-4089-a058-2e7b2adfc2ec', '1a32ebbf-8e70-4268-bb9e-dbcc7a501b71', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b920e47d-1424-4935-85cb-5ca323c0fd9c', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, '108a7577-6cac-417f-a0dc-84c799c54797', '4538eaad-57b6-4089-a058-2e7b2adfc2ec', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f2d7c381-8560-4361-a49a-32f3cfb4d099', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, '4538eaad-57b6-4089-a058-2e7b2adfc2ec', '4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c7e7ddea-f5fb-4abb-8f2d-766ead997fc8', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, 'b8faa38e-6fff-42fc-a1ce-b84070077a61', 'af6f87de-0aa9-4320-b5ba-96a8ac23c9e6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f7b646a0-5cf2-4ea9-a0ef-76976503827c', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', 'b8faa38e-6fff-42fc-a1ce-b84070077a61', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e21ef4f6-3d46-431b-9c1e-17d15c3bd777', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, '4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb', 'b8faa38e-6fff-42fc-a1ce-b84070077a61', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('773184a7-0b28-431c-a763-9cf445a30a53', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, 'b8faa38e-6fff-42fc-a1ce-b84070077a61', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('33651c0b-74a1-4a23-a7c0-77e843306d26', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, 'b8faa38e-6fff-42fc-a1ce-b84070077a61', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8cc78d3c-5ae4-42f5-82b0-2431472de78a', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('076c544a-24c9-4ce7-81d9-08e4fa51a4ed', '80a9daef-e282-499a-ab2f-98a016edb8f7', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '108a7577-6cac-417f-a0dc-84c799c54797', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6c9fc22d-63c8-4f7a-98aa-ba8fff1e3da8', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, '6da9d98a-3318-403e-a948-bc33efe3d5ce', '9821f69a-b029-4a8f-b1b3-229517380f60', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8eccc366-4e62-4fbf-b02c-ec8f6e209e70', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '6da9d98a-3318-403e-a948-bc33efe3d5ce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c38822e4-5e1e-4827-b360-b92d25c4d2ab', NULL, '6da9d98a-3318-403e-a948-bc33efe3d5ce', '3706fd53-e952-408a-aedd-93ec6d5129be', '6da9d98a-3318-403e-a948-bc33efe3d5ce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('de27e4ea-e17c-4a35-bcb5-b66bc1057793', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, 'b2f0d8a8-ad0c-4c52-9c05-967973c99f8a', '8bee7b6c-05f5-4538-baf9-452d909f0657', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2dc2a6a9-cc30-47e8-bda0-c0a824d3c0ed', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, '6da9d98a-3318-403e-a948-bc33efe3d5ce', 'b2f0d8a8-ad0c-4c52-9c05-967973c99f8a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('704bc599-a122-45b2-9dc4-86400b50c1c3', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, 'b2f0d8a8-ad0c-4c52-9c05-967973c99f8a', '03245b58-dd24-4cd4-bf3f-d9ba51a69810', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('117ac268-6306-4b8c-b8b3-b80dd1cdfabe', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, 'ff171f90-f6f2-4c7f-9128-051462cb2368', '2c0faec0-6d09-48e9-9ba5-ef060e4d5f6b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('70e95aa8-1ac0-47ce-a7d7-a0c5a79389bf', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', 'ff171f90-f6f2-4c7f-9128-051462cb2368', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('844fac0e-a516-4f70-90c5-563ddade6f22', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, '03245b58-dd24-4cd4-bf3f-d9ba51a69810', 'ff171f90-f6f2-4c7f-9128-051462cb2368', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bfaf4e0e-12bd-40a5-bcaf-71f0f767975b', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, 'ff171f90-f6f2-4c7f-9128-051462cb2368', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('56586e9a-9626-4412-a088-168ba9ad0426', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, 'ff171f90-f6f2-4c7f-9128-051462cb2368', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dc02e27c-0c6f-4fc3-bc30-25984f8e205c', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '03245b58-dd24-4cd4-bf3f-d9ba51a69810', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4e23bc29-96ac-49cb-a2b0-df041b44f6b2', '93d9827e-63dc-418e-a021-25b400847b2e', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '6da9d98a-3318-403e-a948-bc33efe3d5ce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('db7b07bc-cfd4-4009-b6a9-3de845ff39bc', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, '1b1da9f7-1fb1-4b94-94d7-57275b028d54', '94866c63-1d9f-4b00-b0ff-c6f48c5d6462', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('806bbe69-805c-4f05-8917-9ef45ae9c6aa', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '1b1da9f7-1fb1-4b94-94d7-57275b028d54', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d49c29f2-d785-4043-890b-fe74dbb447dd', NULL, '1b1da9f7-1fb1-4b94-94d7-57275b028d54', '3706fd53-e952-408a-aedd-93ec6d5129be', '1b1da9f7-1fb1-4b94-94d7-57275b028d54', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('600971dd-5188-43de-b278-03af494ee111', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, '871fd02d-def7-4c83-b40e-23029a4019cd', 'd86f4fc3-58a6-4464-8836-4ce8b34f25c9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2c45a296-31e4-40fd-ad10-dda3a8269d35', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, '1b1da9f7-1fb1-4b94-94d7-57275b028d54', '871fd02d-def7-4c83-b40e-23029a4019cd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dd7c5212-9734-48af-9396-9f4ee835843e', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, '871fd02d-def7-4c83-b40e-23029a4019cd', 'ae26c1c9-ca79-4a83-a050-0eaab121ce3e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bb4891cd-9c41-4275-bafc-a69557c3e3a7', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, '11542ad4-cd41-4d26-b778-a25b29175f7b', 'e6d44cf8-f6fa-4138-8410-982613c62c49', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('419450e7-127e-4866-b520-e79537284e7c', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, 'dfeb77e8-087e-423f-b4b5-8e8111a8b83e', '11542ad4-cd41-4d26-b778-a25b29175f7b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5ecdbd09-d56b-43c4-96cd-3743963d23d4', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, 'ae26c1c9-ca79-4a83-a050-0eaab121ce3e', '11542ad4-cd41-4d26-b778-a25b29175f7b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('289556ad-fea2-4e99-a222-7ab08c4f85dc', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, '11542ad4-cd41-4d26-b778-a25b29175f7b', '38aa2ac2-71e5-4805-94ae-61361288f235', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d07700f1-0709-4a9d-9f14-4f47e7d7b749', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, '11542ad4-cd41-4d26-b778-a25b29175f7b', '8806c446-5551-4059-ba53-850a2d147c7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('346eefc8-8d2a-4b67-8f22-c6a0afea94e4', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', 'ae26c1c9-ca79-4a83-a050-0eaab121ce3e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('be3bb7a6-7828-4047-a180-79fc7a7277b0', 'f4219fae-353d-4324-90ca-9f313a8c1c17', NULL, 'b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '1b1da9f7-1fb1-4b94-94d7-57275b028d54', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0df4ebf7-d987-4f0b-9bdb-3dcc8d762053', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, 'dc7aa55a-ab16-47eb-a29b-79e64328fa31', '37c59916-a966-4dca-a1e3-0cffb78ad141', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aaca1433-4934-4751-8f67-71b7b61ba489', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'dc7aa55a-ab16-47eb-a29b-79e64328fa31', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a77c71d4-6631-4b14-aa50-50b0f9e79363', NULL, 'dc7aa55a-ab16-47eb-a29b-79e64328fa31', '3706fd53-e952-408a-aedd-93ec6d5129be', 'dc7aa55a-ab16-47eb-a29b-79e64328fa31', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6147de7f-5796-4b80-b622-f5c3b70e01d0', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, '08963816-c027-42e1-80a8-f55dcd6a02aa', 'b546d5b0-59f6-44af-a54d-d8e3097a3640', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('af96206c-1ae8-4350-96cb-71ed23f0baa9', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, 'dc7aa55a-ab16-47eb-a29b-79e64328fa31', '08963816-c027-42e1-80a8-f55dcd6a02aa', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a60ac64a-4af6-48bc-a1aa-69a24ad48d3a', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, '08963816-c027-42e1-80a8-f55dcd6a02aa', '5e3ac214-0f11-4af9-b637-50ff3f841b76', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e38c4ccc-e949-4c40-8379-e3b601107c9b', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, '85d1d5a3-30a5-4bab-9670-878abc6bfe54', 'c2ccc14e-f11b-497f-95db-5397aa38012b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('462cc639-2ca8-40a8-a575-a49a045f3596', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, 'a6ff0898-04e1-49b7-8621-b42846df06e1', '85d1d5a3-30a5-4bab-9670-878abc6bfe54', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fe8eaf38-c3c2-4221-8cdd-207155392d6c', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, '5e3ac214-0f11-4af9-b637-50ff3f841b76', '85d1d5a3-30a5-4bab-9670-878abc6bfe54', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7df76f5f-b7cb-40eb-a86f-f83945ee8cd9', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, '85d1d5a3-30a5-4bab-9670-878abc6bfe54', '5c9372e0-cb21-4ae7-a461-df086ad19426', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f655df71-ecd5-4f06-a268-f9d1b99454ce', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, '85d1d5a3-30a5-4bab-9670-878abc6bfe54', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('63c62f56-4b72-44c3-99ce-ddb029ab1283', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '5e3ac214-0f11-4af9-b637-50ff3f841b76', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fe2e422c-ffa6-4250-8470-2a3c97f57d08', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', 'dc7aa55a-ab16-47eb-a29b-79e64328fa31', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('65414b52-aa15-4162-b018-eb4fd128283c', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6', '36490d00-f5d4-4722-b285-9cac45e7dd5c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('45c35d7f-f897-44dc-af54-127ab4bde8da', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0d888bad-9424-4fcc-9d80-8ff53f437df0', NULL, 'f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6', '3706fd53-e952-408a-aedd-93ec6d5129be', 'f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bd19286b-a328-4655-b49e-ebd8ae24e3ff', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'ba13ab33-99ee-48ef-b205-73e9adea9651', '891fe7ab-2113-4f20-ab6d-3d81cca0941a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('31150614-93a5-4100-8c51-85a86e2f6de0', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6', 'ba13ab33-99ee-48ef-b205-73e9adea9651', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f50ccdba-1e3f-4c32-a7d0-064405737cb5', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'ba13ab33-99ee-48ef-b205-73e9adea9651', '918840d4-592e-43eb-afa5-ad6ea37043a3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('68007eb2-edad-4729-a1ac-87d36a60fab1', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'd48cd569-cc1f-4f27-bb9a-35154e5fc0b2', '10ff5603-7bfa-490e-a468-6d231db02ac6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7c1e03f8-4df9-4ada-80fe-88264c146a13', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'a6ff0898-04e1-49b7-8621-b42846df06e1', 'd48cd569-cc1f-4f27-bb9a-35154e5fc0b2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0da1294a-124d-4d64-868f-fa10e2bb50c6', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, '918840d4-592e-43eb-afa5-ad6ea37043a3', 'd48cd569-cc1f-4f27-bb9a-35154e5fc0b2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7266aa8d-0a18-4c1d-a2db-460e22082376', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'd48cd569-cc1f-4f27-bb9a-35154e5fc0b2', '5c9372e0-cb21-4ae7-a461-df086ad19426', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('eff379d8-ea07-45d8-b1b9-939d7bd504cf', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'd48cd569-cc1f-4f27-bb9a-35154e5fc0b2', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ba997a4e-e15a-4b7e-ab8d-8d18b7d77784', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '918840d4-592e-43eb-afa5-ad6ea37043a3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('44ee4667-fce9-4a32-94bd-c303ee429880', 'ed0fb977-6512-4452-8505-378fcbbd5060', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', 'f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('23114396-605b-4635-bfec-f5d19f9f2d61', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, '1ec552f6-834f-4b68-ae60-6d39e6d887e7', 'd53e3095-38c0-4be0-b7c4-17d6c505c370', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6028e332-1d2e-4c7d-953b-8bbb2dcb3876', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '1ec552f6-834f-4b68-ae60-6d39e6d887e7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('65248239-5a3e-4a20-bf6b-41c18985d3fb', NULL, '1ec552f6-834f-4b68-ae60-6d39e6d887e7', '3706fd53-e952-408a-aedd-93ec6d5129be', '1ec552f6-834f-4b68-ae60-6d39e6d887e7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('78166a30-6c96-48c2-b96d-1b0b9c1bd6ec', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, '82982647-714a-4203-b8f0-3d9fa5d22b4e', '39a2c817-387a-4a54-a751-6dfc0d781f8c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('845c483c-fadb-4d86-bc40-8f26ee15e3e2', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, '1ec552f6-834f-4b68-ae60-6d39e6d887e7', '82982647-714a-4203-b8f0-3d9fa5d22b4e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fa56ac1c-a232-4e0b-98bb-82d3ecf4bb97', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, '82982647-714a-4203-b8f0-3d9fa5d22b4e', '76d74da3-9fbd-43bb-9083-093a9254af2b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('860c5bcf-0127-42e9-9057-86f63e8fb6d5', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, '0303b9f3-8860-4ebc-b808-d4d2da18f5fb', '09cb2efd-3998-4b84-a315-788b6375ffa6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('be6f5601-acce-4422-abd5-2dff417f828f', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, 'a6ff0898-04e1-49b7-8621-b42846df06e1', '0303b9f3-8860-4ebc-b808-d4d2da18f5fb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('04497d4a-90e2-40cd-ae75-bce64fea3d95', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, '76d74da3-9fbd-43bb-9083-093a9254af2b', '0303b9f3-8860-4ebc-b808-d4d2da18f5fb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1aa22445-4c2c-49e7-961c-d7ed77dca1c7', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, '0303b9f3-8860-4ebc-b808-d4d2da18f5fb', '5c9372e0-cb21-4ae7-a461-df086ad19426', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('af0093ed-2cdb-4c57-8b68-5f1871f83f90', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, '0303b9f3-8860-4ebc-b808-d4d2da18f5fb', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('93b39756-48a6-4a58-b196-58b68de6bc32', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '76d74da3-9fbd-43bb-9083-093a9254af2b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7c418ce5-d2e7-4609-a25c-854a77422da5', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '1ec552f6-834f-4b68-ae60-6d39e6d887e7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5fccc27f-37d4-4c9f-9f50-5c431eeb5dd6', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'c17186dc-564d-4f82-914b-202ad8bc9941', '5c5e2c73-6a91-4b38-a290-fb7fc94d6cc0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5ffd40e9-d22a-453d-b88d-4c222412afc0', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'c17186dc-564d-4f82-914b-202ad8bc9941', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1173ee00-62e1-423f-96bc-10a009e581b1', NULL, 'c17186dc-564d-4f82-914b-202ad8bc9941', '3706fd53-e952-408a-aedd-93ec6d5129be', 'c17186dc-564d-4f82-914b-202ad8bc9941', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a4973160-2485-4357-b9d4-04533f62326d', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'b05450fd-5e5b-4aa1-b334-0b886ced9492', '708ff719-70c9-48f5-8664-dbf49352d261', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3142f58d-1600-42d5-8c4d-002f325423cf', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'c17186dc-564d-4f82-914b-202ad8bc9941', 'b05450fd-5e5b-4aa1-b334-0b886ced9492', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('eec039fc-3cdc-48b0-8d80-371f5ab98ca8', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'b05450fd-5e5b-4aa1-b334-0b886ced9492', '2710f7f0-f352-4e71-a527-38076d6966ce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('873674d6-8281-4362-9a73-630c8e00c62c', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'b012ee61-8155-4fa3-bee0-9a0918452bae', '7fd8da11-6a47-4ca3-8bf3-9713a6ac0305', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('86e1fa7a-fcc5-4cb1-835b-62995092ec69', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'a6ff0898-04e1-49b7-8621-b42846df06e1', 'b012ee61-8155-4fa3-bee0-9a0918452bae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1dca2eff-0e1e-4941-a54b-18ba818edaa4', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, '2710f7f0-f352-4e71-a527-38076d6966ce', 'b012ee61-8155-4fa3-bee0-9a0918452bae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('42131f0b-59fd-4698-b74a-aa1817515792', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'b012ee61-8155-4fa3-bee0-9a0918452bae', '5c9372e0-cb21-4ae7-a461-df086ad19426', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('95481de2-ae7a-4657-b880-d0ee44b27bfc', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'b012ee61-8155-4fa3-bee0-9a0918452bae', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('eabbd51a-4686-4d65-96e1-958c313ecf9b', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '2710f7f0-f352-4e71-a527-38076d6966ce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('117b3c8e-3a79-4ad1-adca-c126ba5ce98a', 'af82432c-09a8-42a7-9525-e9095025d4dd', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', 'c17186dc-564d-4f82-914b-202ad8bc9941', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('38d1b657-379e-4a9a-8527-c30fa1d7c78b', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '18fb2aed-c5ba-41ea-ac09-4ec940ff6eff', '63ab27e2-5a5b-483e-8346-0024da814b06', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('26b6b9d0-a985-4b9d-9b8e-e063ba480714', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '18fb2aed-c5ba-41ea-ac09-4ec940ff6eff', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fb7994b8-3bb2-4381-9b28-5c5fffcf5500', NULL, '18fb2aed-c5ba-41ea-ac09-4ec940ff6eff', '3706fd53-e952-408a-aedd-93ec6d5129be', '18fb2aed-c5ba-41ea-ac09-4ec940ff6eff', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('25ef6910-d687-4255-936f-9738868b5bdb', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '6c83af72-d5d7-4076-b7b6-33ca23c80ff8', '14fd3310-5109-472b-9eb8-9b3aac0cc5c8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ed7f532c-3caa-49ef-825b-e36c90d490f9', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '18fb2aed-c5ba-41ea-ac09-4ec940ff6eff', '6c83af72-d5d7-4076-b7b6-33ca23c80ff8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6e1a316c-be94-44a8-90b9-1e9bf3e03516', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '6c83af72-d5d7-4076-b7b6-33ca23c80ff8', '8833f9cb-d000-41ef-920f-6e6ba586c65d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3918e326-9f99-489b-8c87-5d3d95c8909b', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '49e8c569-1fe0-4215-8cc3-698054ff896f', 'a351e412-5f16-4c87-b09f-6c0290e20b7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('264c36d3-405f-4eef-98f0-cff6a9f50783', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '939dafca-fe72-499d-979d-6fe0288e6807', '49e8c569-1fe0-4215-8cc3-698054ff896f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cc1f086f-9232-4b67-a4d6-b270c1496cc7', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '8833f9cb-d000-41ef-920f-6e6ba586c65d', '49e8c569-1fe0-4215-8cc3-698054ff896f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('de1c6bc8-f470-4c0d-b47f-353980576e29', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '49e8c569-1fe0-4215-8cc3-698054ff896f', 'b91f7dd8-b4a4-4f9b-9192-300f8e982c6d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c48e3a13-76e7-4ee6-acbd-6d88da4b0392', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '49e8c569-1fe0-4215-8cc3-698054ff896f', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('860cf6b4-8697-4a7f-9c59-d65c3aa73067', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, '49e8c569-1fe0-4215-8cc3-698054ff896f', '236b88d3-09bc-4750-9219-61529f7740af', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('927cd8d9-8a84-4b66-8a84-49ed4a4d93ca', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, 'f87398bc-225a-4eee-bea8-7983be6ae529', '8833f9cb-d000-41ef-920f-6e6ba586c65d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5c324003-be19-4195-bb55-12ad791cfccd', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '18fb2aed-c5ba-41ea-ac09-4ec940ff6eff', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f04b5170-d247-4edb-bd83-4ce3c0199b3d', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, '0e190f5b-0333-4f70-aabc-71d2e810a712', '0fc0933c-0397-4b0d-ae81-18c41d3fe082', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('014c9f70-9876-4685-b99a-d88338f16dc7', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0e190f5b-0333-4f70-aabc-71d2e810a712', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0f6d273a-ed72-414a-ba94-08f1cc96324c', NULL, '0e190f5b-0333-4f70-aabc-71d2e810a712', '3706fd53-e952-408a-aedd-93ec6d5129be', '0e190f5b-0333-4f70-aabc-71d2e810a712', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('84c8d1c7-d62d-4bc8-a34d-aa9872a20ed2', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, '8eb1d02d-d44f-42a8-bd93-a05174ce15e0', '133a7879-3f1c-4daf-8b16-9160b4477288', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3a7de6b1-c26d-4a9a-9b98-27d65c1a4973', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, '0e190f5b-0333-4f70-aabc-71d2e810a712', '8eb1d02d-d44f-42a8-bd93-a05174ce15e0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e07c7714-cc7d-47bc-b867-8f17d5b3150b', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, '8eb1d02d-d44f-42a8-bd93-a05174ce15e0', '77ef9867-e939-4d36-85e1-4a573c4a9b55', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('04fbc978-15b2-4609-b13e-3a307803ca2d', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, 'cedad28c-ea54-48a9-b2f8-e16a29ec56a1', 'd2ef2562-a654-4af3-b1eb-6e8bcd35c03e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fc6074ef-ac17-4e01-a504-81232802ed49', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, '82d6e2a0-3c2d-4a8e-8638-4903696927d5', 'cedad28c-ea54-48a9-b2f8-e16a29ec56a1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c303b3da-aa0d-4b5a-a6ef-437aeaab8698', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, '77ef9867-e939-4d36-85e1-4a573c4a9b55', 'cedad28c-ea54-48a9-b2f8-e16a29ec56a1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('922f86ad-53a1-4643-a528-a0707127b2d4', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, 'cedad28c-ea54-48a9-b2f8-e16a29ec56a1', '25acc71c-db8f-46e4-950a-8ea76637bb9b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('eb764aac-d784-4ebc-874c-c6c5285137d8', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, 'cedad28c-ea54-48a9-b2f8-e16a29ec56a1', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('064926b6-0149-4518-bbe9-b201997cc90f', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, 'cedad28c-ea54-48a9-b2f8-e16a29ec56a1', 'f913c978-1afc-4af0-9bb6-8c21eed95991', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b3132dbc-b482-486b-b02e-a8ad200cbdd2', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, 'da979efd-9d87-4dc5-a839-493e883cf292', '77ef9867-e939-4d36-85e1-4a573c4a9b55', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('38c323d4-bd10-48f2-86a9-ca9246ee0cc8', '65879210-cf7c-4e5b-a2d1-742a42fcb488', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '0e190f5b-0333-4f70-aabc-71d2e810a712', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('be632038-c8e0-441e-a7cd-80f1fab0f7a5', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '7377295c-c6d9-4826-b712-ea5df5c3d8d1', '5ae15451-1a59-45da-b59d-02884a418fc1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e513ed65-b37e-42c2-8d1b-d1eb96d5b988', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '7377295c-c6d9-4826-b712-ea5df5c3d8d1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('18472c38-51a3-4360-b694-c118c3d75515', NULL, '7377295c-c6d9-4826-b712-ea5df5c3d8d1', '3706fd53-e952-408a-aedd-93ec6d5129be', '7377295c-c6d9-4826-b712-ea5df5c3d8d1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1f9ef4b2-12f7-439d-b0a4-d67d1f0ef28e', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '638a0990-bb30-434c-80b5-65f3e33732f6', 'c0844f33-c3b3-477f-9321-4b342474802a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('010f9b91-c272-49ee-af70-30a378c35bd8', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '7377295c-c6d9-4826-b712-ea5df5c3d8d1', '638a0990-bb30-434c-80b5-65f3e33732f6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4d64baff-ceff-4ad1-9abc-ddcc92cf9c5e', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '638a0990-bb30-434c-80b5-65f3e33732f6', '0de0bb80-9691-4f70-9bdb-53a862399dc1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ee7d3e9e-1c6d-4877-8d1f-3c26bf7709d7', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '701ea625-3ec6-4ee9-8fbb-fb95ab1137f7', 'c8d78c39-6d4d-48a7-96f8-80fdc50b2059', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2fa47a46-e76f-441b-a411-cbba090ee3f1', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '82d6e2a0-3c2d-4a8e-8638-4903696927d5', '701ea625-3ec6-4ee9-8fbb-fb95ab1137f7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('38c385ef-16c5-471b-b065-dff65edf12ea', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '0de0bb80-9691-4f70-9bdb-53a862399dc1', '701ea625-3ec6-4ee9-8fbb-fb95ab1137f7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('274f5f7b-4e82-4e41-82ad-5ff7653d4209', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '701ea625-3ec6-4ee9-8fbb-fb95ab1137f7', '25acc71c-db8f-46e4-950a-8ea76637bb9b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9f69e8b1-bc6d-4f52-996e-0d71cf466d34', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '701ea625-3ec6-4ee9-8fbb-fb95ab1137f7', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9a96f7b8-8ddf-4868-a3d7-174813b2d180', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, '701ea625-3ec6-4ee9-8fbb-fb95ab1137f7', 'f913c978-1afc-4af0-9bb6-8c21eed95991', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('121f4ca4-da82-47ac-b2fb-96d63c8b897b', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, 'da979efd-9d87-4dc5-a839-493e883cf292', '0de0bb80-9691-4f70-9bdb-53a862399dc1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9588e638-90a6-43c6-9a25-4a1293154772', '97e5ed67-e81c-4c12-b354-45db951901c0', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '7377295c-c6d9-4826-b712-ea5df5c3d8d1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a0896ff6-bd78-44d7-87c0-37f267aef94c', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, '84802890-6128-4134-8ad7-667491cfcbf7', '19932b77-d4fd-4664-a0c6-ff8fb707f697', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6efe6567-1033-4081-ab3f-304926c7c1d3', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '84802890-6128-4134-8ad7-667491cfcbf7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7d0bd8b9-381a-4502-a4ee-2b91505447a6', NULL, '84802890-6128-4134-8ad7-667491cfcbf7', '3706fd53-e952-408a-aedd-93ec6d5129be', '84802890-6128-4134-8ad7-667491cfcbf7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d0458ece-a35f-487c-aa0f-633de255dc6b', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, '63eb26c8-3d39-45f7-b2ef-5038f301bddc', 'a71abf2a-ab11-4bdd-8591-6977673bdc32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('16ef5805-c3da-46ef-865b-14b723110a2a', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, '84802890-6128-4134-8ad7-667491cfcbf7', '63eb26c8-3d39-45f7-b2ef-5038f301bddc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0fd2ed3-afb3-4ea9-9f69-a572d7bb8425', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, '63eb26c8-3d39-45f7-b2ef-5038f301bddc', 'fadd73e5-eeca-4f5a-b07d-998d11eb411d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('86dc0d91-08b4-47ae-b24e-b185c32deb05', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, '6dc07a2f-428b-4621-9f39-8679a5a5a780', 'e1cfb24e-d3c2-4279-b1b7-0e037766a0c3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e1e7a27b-2ca3-4ca6-938d-db8a130a56a4', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, '82d6e2a0-3c2d-4a8e-8638-4903696927d5', '6dc07a2f-428b-4621-9f39-8679a5a5a780', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('54e6fe3c-946f-4ffe-b571-1683b975b1b6', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, 'fadd73e5-eeca-4f5a-b07d-998d11eb411d', '6dc07a2f-428b-4621-9f39-8679a5a5a780', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e1f74d3b-cd97-492b-baa2-8384d8cdfc97', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, '6dc07a2f-428b-4621-9f39-8679a5a5a780', '25acc71c-db8f-46e4-950a-8ea76637bb9b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bb575fa2-0a38-404c-a280-bcc403c475f9', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, '6dc07a2f-428b-4621-9f39-8679a5a5a780', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a808d0d0-8971-4236-ba01-ad2bc3ef73bf', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, '6dc07a2f-428b-4621-9f39-8679a5a5a780', 'f913c978-1afc-4af0-9bb6-8c21eed95991', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4d19a35a-143f-4b27-8056-19047cdc8e57', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, 'da979efd-9d87-4dc5-a839-493e883cf292', 'fadd73e5-eeca-4f5a-b07d-998d11eb411d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fc5672ca-4c2b-49ef-94a5-853622932577', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '84802890-6128-4134-8ad7-667491cfcbf7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('55622a21-18b4-4889-a133-b0f9e999a5f8', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, '0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d', '3c82a048-8d56-4f34-98c4-a20e193f815e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bdec28d3-ff09-4651-a5cc-afb25e7cf5fd', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('348bed58-906a-43d6-9fb5-789d99bc2448', NULL, '0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d', '3706fd53-e952-408a-aedd-93ec6d5129be', '0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('57cb83c6-c9be-4a0d-9345-5c1d93dcbff5', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, '47388b74-46ec-45fb-a817-031c959a6c2e', 'a9ce43ae-4dd7-4ee8-bf8d-d2f3fba4c803', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bcfbb0b7-df3c-41ed-8493-c971aa14c270', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, '0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d', '47388b74-46ec-45fb-a817-031c959a6c2e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('78f0fa7e-324e-4e4a-9321-5a1c72dae660', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, '47388b74-46ec-45fb-a817-031c959a6c2e', 'fb0b7122-f782-414f-85b1-c1df876a3441', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('86c9a95d-c08a-4375-8be1-1a23d89903c8', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, '0195bb79-457f-42a6-a21f-ffd238256b28', '1230adbc-b61a-4ba1-b298-c831c2862e8f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('da788239-e153-4071-b312-c43279d9ac87', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, '82d6e2a0-3c2d-4a8e-8638-4903696927d5', '0195bb79-457f-42a6-a21f-ffd238256b28', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0f97ffe-65a5-4b38-9839-c914830c41f5', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, 'fb0b7122-f782-414f-85b1-c1df876a3441', '0195bb79-457f-42a6-a21f-ffd238256b28', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('53dd57a9-a5c4-4741-b922-e42cc3852f3c', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, '0195bb79-457f-42a6-a21f-ffd238256b28', '25acc71c-db8f-46e4-950a-8ea76637bb9b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b04b8eff-9ecd-41fc-beb0-3b9b92832d87', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, '0195bb79-457f-42a6-a21f-ffd238256b28', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a77fa2fe-84af-45a4-aaf5-adb8bdc09c61', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, '0195bb79-457f-42a6-a21f-ffd238256b28', 'f913c978-1afc-4af0-9bb6-8c21eed95991', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6d0caee6-f2e7-4f1e-adc4-3405bfa88867', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, 'da979efd-9d87-4dc5-a839-493e883cf292', 'fb0b7122-f782-414f-85b1-c1df876a3441', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('35606a65-d96a-4b02-a621-af561e25d649', '2eec1138-d2ad-43de-a105-605d0182a1f8', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b8cc05ae-3a13-4346-83c4-9449520e9ddf', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, '8280b446-c17d-4d5f-aff5-ab391cd0af09', '8c70ecf7-82ce-4661-8cc5-0fadbcc4151a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('876fd5a0-0810-43ca-b132-29311d103c67', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '8280b446-c17d-4d5f-aff5-ab391cd0af09', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('94a375c1-4ab4-4f9b-b01b-7487db466f64', NULL, '8280b446-c17d-4d5f-aff5-ab391cd0af09', '3706fd53-e952-408a-aedd-93ec6d5129be', '8280b446-c17d-4d5f-aff5-ab391cd0af09', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bbc7e03b-d588-4412-99ef-f0cdd5559a26', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, '53e80cc6-7e19-4c55-8c1a-3190844ae734', '7aceef4b-2faa-48c5-8355-72db528f4822', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('65dbca62-0240-4f81-a4a5-c0d002c6db26', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, '8280b446-c17d-4d5f-aff5-ab391cd0af09', '53e80cc6-7e19-4c55-8c1a-3190844ae734', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('02019ab8-6ec7-4856-98f6-03c99788b6a7', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, '53e80cc6-7e19-4c55-8c1a-3190844ae734', '4e5bc3c9-14f5-468c-8ef6-6bcb25c17948', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('49c0af6d-f0aa-430f-b03c-ecdfade261e4', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, '85e6093a-5013-45c3-a756-66e50d03b6bc', '24fab1b7-ae06-42e0-8746-4754b526994d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('37ed1b92-de74-4f45-8ae0-b641fc11f0cd', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, '42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b', '85e6093a-5013-45c3-a756-66e50d03b6bc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e827db1b-3a2b-4978-93b2-8cf996dd2487', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, '4e5bc3c9-14f5-468c-8ef6-6bcb25c17948', '85e6093a-5013-45c3-a756-66e50d03b6bc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('13868160-f13c-4deb-91f9-d1bf6768d803', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, '85e6093a-5013-45c3-a756-66e50d03b6bc', '24f9488b-412f-4314-b160-2897f4dcff1b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e7a500ad-1822-4607-9c36-c94a64bb8d60', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, '85e6093a-5013-45c3-a756-66e50d03b6bc', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('017ebbbd-4aa4-4c64-adf6-89fb2d5ce244', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '4e5bc3c9-14f5-468c-8ef6-6bcb25c17948', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b970a351-ee05-41ec-b995-f75915afedec', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '8280b446-c17d-4d5f-aff5-ab391cd0af09', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('913004d0-3a2a-4c56-b24a-20575950dcb5', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, '7044a856-3670-42b7-9719-4a8638fff92a', '13d82035-64c5-4ca9-a85e-988bc4a2eb4d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8328274d-3393-48ff-b2ed-0eb3466e8298', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '7044a856-3670-42b7-9719-4a8638fff92a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d784639a-94ce-40b6-968a-295ff498aa7a', NULL, '7044a856-3670-42b7-9719-4a8638fff92a', '3706fd53-e952-408a-aedd-93ec6d5129be', '7044a856-3670-42b7-9719-4a8638fff92a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a41e82a4-97ef-4bc5-ad86-2840f3c37a11', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, '20f04373-bbb4-4b9d-a89f-d21272d75d59', '62ca73f6-89b1-4113-92ba-a7823aabf31e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('84b09044-2858-4daf-bcac-bdc446c41aea', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, '7044a856-3670-42b7-9719-4a8638fff92a', '20f04373-bbb4-4b9d-a89f-d21272d75d59', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('57713630-d87b-4811-9f01-ef736c0b4834', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, '20f04373-bbb4-4b9d-a89f-d21272d75d59', '367f629c-223d-456c-98cf-ddf6600d5858', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5b522b03-0f33-43b4-90a0-cdb5d3842343', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, '4c98fcb4-e0b6-4692-86e5-dabb78af17ed', '740e371f-18b1-4e93-8408-2fcc777b7da6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e0c22b32-549b-49e3-a838-172fa221eed6', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, '42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b', '4c98fcb4-e0b6-4692-86e5-dabb78af17ed', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('484d6f99-3537-4bce-b543-edec82063ebc', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, '367f629c-223d-456c-98cf-ddf6600d5858', '4c98fcb4-e0b6-4692-86e5-dabb78af17ed', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('04e04fc5-fcec-47b4-b836-cf3210e750f3', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, '4c98fcb4-e0b6-4692-86e5-dabb78af17ed', '24f9488b-412f-4314-b160-2897f4dcff1b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7b5cda60-6c9e-46ec-af67-3cf3d4c8d356', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, '4c98fcb4-e0b6-4692-86e5-dabb78af17ed', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5bb50ffd-5bb4-4cb5-91eb-99b64004ebee', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '367f629c-223d-456c-98cf-ddf6600d5858', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ef476770-55e8-4eb4-a752-69c38dddc033', 'fad03414-b62b-45d4-93fd-51c52149762c', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', '7044a856-3670-42b7-9719-4a8638fff92a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('71191ee7-aa74-4044-ace7-7951b0b3c0d2', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, 'cdc318a4-f418-4564-a38c-f93562dda048', '2c15e623-a22a-435b-a125-3edbf2a9b5f5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3f0d820d-4d93-49b2-bcc1-7ee5c50e428c', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'cdc318a4-f418-4564-a38c-f93562dda048', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0cade10-f7f9-4b8b-8f42-0cf53b892b9c', NULL, 'cdc318a4-f418-4564-a38c-f93562dda048', '3706fd53-e952-408a-aedd-93ec6d5129be', 'cdc318a4-f418-4564-a38c-f93562dda048', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9eba2405-6cf5-40a7-b426-9e6458318053', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, 'f2a2d3d5-165d-43c4-91fc-7912f8a96bcc', '1c9c5558-dd2c-4293-bfcb-0160e981b6e0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('18c5068e-048b-4510-9b18-9fd2fb0d4135', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, 'cdc318a4-f418-4564-a38c-f93562dda048', 'f2a2d3d5-165d-43c4-91fc-7912f8a96bcc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e9079c64-7557-4ae1-a866-4a96e5e49ba1', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, 'f2a2d3d5-165d-43c4-91fc-7912f8a96bcc', 'ced737cc-1da8-4b12-808a-13e36b8bc37e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c21b9a49-8c79-4a8d-95f4-032db314e885', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, '79ef402f-0c51-4ae0-a0dd-f0a09505a273', '19241a87-0b31-4156-a479-cdb61cafaa66', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('828e4453-5b83-4a3c-8e49-29fc212ee8ab', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, 'f9d5ba94-1514-4400-88af-7b7d3798f473', '79ef402f-0c51-4ae0-a0dd-f0a09505a273', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('12864cb0-ed29-4cbf-a00b-4716e6fcff00', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, 'ced737cc-1da8-4b12-808a-13e36b8bc37e', '79ef402f-0c51-4ae0-a0dd-f0a09505a273', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a52c39d7-3d61-4707-8d2c-b85e571c0c7a', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, '79ef402f-0c51-4ae0-a0dd-f0a09505a273', '20926d99-1f1f-497a-8e13-ce3cb4b1eb73', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('acc43637-f18c-46a9-9cbe-23c45b18ff7b', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, '79ef402f-0c51-4ae0-a0dd-f0a09505a273', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('734b541b-498d-4e39-a136-8be5802563e1', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, '79ef402f-0c51-4ae0-a0dd-f0a09505a273', 'ecdbb376-51c5-4de3-82f5-c5e73c0f43c5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7321df72-9db0-4594-88ff-cc624280efc0', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, 'b28425cc-f859-43db-b3f5-64b5fb6a668b', 'ced737cc-1da8-4b12-808a-13e36b8bc37e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aa207d78-61d8-4e6a-97e2-054f738a56a4', '48a0fa39-0d72-4c0a-800f-afed02865850', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', 'cdc318a4-f418-4564-a38c-f93562dda048', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e419060c-9fbe-40a1-bece-ed26c86303f3', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '0b67cb5e-3570-4ca7-945b-94f3390bec81', '22b95a69-d861-4d90-bfef-a9c3f4ba5d52', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4fb4d523-f9fe-4577-a320-8de8b7018354', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0b67cb5e-3570-4ca7-945b-94f3390bec81', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('58c42133-e753-42ec-9179-1343126f6a88', NULL, '0b67cb5e-3570-4ca7-945b-94f3390bec81', '3706fd53-e952-408a-aedd-93ec6d5129be', '0b67cb5e-3570-4ca7-945b-94f3390bec81', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('df06f05b-67e5-4a3a-bf44-25bae283b342', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '5306f8ae-55c4-460d-a133-45f8eae30eb6', 'a1ad0f25-f3ab-4bfa-8e4d-674d7ddc3ae7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8a317992-4d7b-4f96-a216-b3d76a67b058', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '0b67cb5e-3570-4ca7-945b-94f3390bec81', '5306f8ae-55c4-460d-a133-45f8eae30eb6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('62f04d9c-09d7-4a80-a932-aba12d4a9258', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '5306f8ae-55c4-460d-a133-45f8eae30eb6', '39500fd6-4dcf-4c33-9766-c9b4071e4754', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b22cccac-454e-46d4-b440-f238db43371b', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '3f31fd85-c31c-4258-8219-2ed6f7a38f29', '5feb8ea2-f497-4058-b056-dd96514c70c5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c700dd59-b6cf-4d50-8fa2-d7bd1582cf98', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '57ee73c6-769e-461e-9cea-7bfe56970bf7', '3f31fd85-c31c-4258-8219-2ed6f7a38f29', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('39514d32-b8b2-4191-8e3d-c339263c630f', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '39500fd6-4dcf-4c33-9766-c9b4071e4754', '3f31fd85-c31c-4258-8219-2ed6f7a38f29', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b5739fe2-cbc1-45a7-957c-1da1866ef72f', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '3f31fd85-c31c-4258-8219-2ed6f7a38f29', 'e65ad361-79d6-46a3-a7c7-a18048b7237a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8d1f8a60-937f-44c1-bb27-ec4b42159618', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '3f31fd85-c31c-4258-8219-2ed6f7a38f29', 'ea1789f5-11fe-4ec3-8d12-2623ba592c7f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9270ca1c-1b92-45a2-ae06-6b81a4fd9d49', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', '39500fd6-4dcf-4c33-9766-c9b4071e4754', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('51aca5fc-851d-42e4-9d27-d41280eca08a', 'a84434fd-e879-4208-a8e8-8095e22b72bf', NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', '0b67cb5e-3570-4ca7-945b-94f3390bec81', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e1f676e2-21fd-4689-88c8-800518d22080', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '3461faee-7a67-45d3-af18-7de8686c381d', '164e7fa0-ccac-4331-be5a-dc965b1c31d6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d16fb908-a8c8-4be1-b52e-e7e39c12ea07', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '3461faee-7a67-45d3-af18-7de8686c381d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f22de112-02a1-48f0-8a9c-0ff8dd22c8d0', NULL, '3461faee-7a67-45d3-af18-7de8686c381d', '3706fd53-e952-408a-aedd-93ec6d5129be', '3461faee-7a67-45d3-af18-7de8686c381d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('780fd786-74cf-4b97-81b9-ac4b909fef18', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8', 'dbee33c8-80d8-40c9-9d16-af5c99aea9ae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('85faf70c-058e-4612-b290-4141325917a5', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '3461faee-7a67-45d3-af18-7de8686c381d', '1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1a293898-9590-4232-99d0-c839bac38a4b', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8', '3d17a863-17af-48a5-a6aa-abc815209773', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('974163d5-e3e7-4703-9b47-768296eb4c57', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '0447c01c-fae5-4c80-a59f-a9f330321b9c', '1b4208a5-e7ba-460e-922f-a9fb5c7e79e7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6638829e-b4a4-4148-bed1-1df9bd27bc83', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '57ee73c6-769e-461e-9cea-7bfe56970bf7', '0447c01c-fae5-4c80-a59f-a9f330321b9c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('21c8f5cf-38b2-4fb7-a4fd-8b6893a55394', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '3d17a863-17af-48a5-a6aa-abc815209773', '0447c01c-fae5-4c80-a59f-a9f330321b9c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cc6788b2-65f0-406e-a3dd-3b58eb3ebeb7', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '0447c01c-fae5-4c80-a59f-a9f330321b9c', 'e65ad361-79d6-46a3-a7c7-a18048b7237a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('52109c52-b432-4d0c-8aca-dd0a99ca35eb', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '0447c01c-fae5-4c80-a59f-a9f330321b9c', 'ea1789f5-11fe-4ec3-8d12-2623ba592c7f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5fbff0ee-6d38-412a-bafe-d2017b2155b3', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', '3d17a863-17af-48a5-a6aa-abc815209773', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dde7f3bd-0a6b-4da2-8db7-92d54b443c7e', '93d87d13-efdb-4d31-83e6-3b13db983c12', NULL, '6ef557f3-0b1e-41e9-bde7-8abea686f965', '3461faee-7a67-45d3-af18-7de8686c381d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b62e2ba3-fd5e-41dd-b36e-a4df8d27cc84', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'fd1b146c-609a-486f-afe5-c87430e1be15', 'cebd9ecc-f841-4d44-a3fe-3c82827f2918', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('342a26e0-01be-4477-8505-bb177f76f81d', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'fd1b146c-609a-486f-afe5-c87430e1be15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ea164af9-46a4-4691-bf45-39c089a3907f', NULL, 'fd1b146c-609a-486f-afe5-c87430e1be15', '3706fd53-e952-408a-aedd-93ec6d5129be', 'fd1b146c-609a-486f-afe5-c87430e1be15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('682f1b6c-bbe9-4229-bd9a-1782cd6296d6', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'd09b10a6-f74d-4e87-898d-851cfdb9dffb', 'ac3ee728-8957-4b2e-91d7-9f7a0e543931', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1d7a2de3-3754-4b1d-a763-d5a0d920dedb', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'fd1b146c-609a-486f-afe5-c87430e1be15', 'd09b10a6-f74d-4e87-898d-851cfdb9dffb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4fe44a04-1c1b-4046-91b2-54f0c6560020', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'd09b10a6-f74d-4e87-898d-851cfdb9dffb', '3a1e0eb9-bf91-4bda-b804-8707d753644e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('420dd5f5-07b6-4e88-803d-23281381b7b9', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3', '30b91518-31ef-4b3f-a539-c1f7566e0c77', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('97796f5f-c386-44ab-b15a-8be0b6b8ce89', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'd206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e', 'c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fddf76f7-6c95-4af7-841f-fe2ce0200617', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, '3a1e0eb9-bf91-4bda-b804-8707d753644e', 'c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('df62b4b8-bc0d-4a5b-9285-7c489e5a7e13', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3', '6c787015-c910-455d-8b2c-c3ae7bece7e7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2eaa6dc6-2561-4bc8-b138-16b73f9df2a5', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3', 'e668cce4-9f01-4c71-b28c-79859e02971b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('36a8ac7a-fff5-4bf0-b3c6-99fbc1901d48', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3', '4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4276e2db-6b2f-413b-a29e-6e8a82b16ba9', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, '9e5fa680-2abc-4f25-bb22-bd2fe04fd860', '3a1e0eb9-bf91-4bda-b804-8707d753644e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('769e962a-57dc-45ab-92b3-68c217f8b495', 'bad214a0-5220-4433-8714-52e4c736585a', NULL, 'b4224d96-af95-4008-9a96-9ae04b44913f', 'fd1b146c-609a-486f-afe5-c87430e1be15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4d1f8cfe-9901-4ba6-a66f-3a859d8c3669', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, '8e9971fb-270c-4897-ae63-50f457d9d0d5', 'fa9a7713-93f2-46c6-b3de-9d6e42bce983', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('afd8494c-f583-4ba5-8b40-e67b5f56bc03', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '8e9971fb-270c-4897-ae63-50f457d9d0d5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('654992e9-98eb-4f59-a8dc-37068c28dcae', NULL, '8e9971fb-270c-4897-ae63-50f457d9d0d5', '3706fd53-e952-408a-aedd-93ec6d5129be', '8e9971fb-270c-4897-ae63-50f457d9d0d5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d23139da-5dba-4b5c-8471-596a168c8fe4', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, 'a352a7f2-6caf-48bd-8f2e-90a1b3d248fd', '052b4092-a5bf-47f3-8ba2-0734ec9129d4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('984f748c-bef5-4ffd-a9f3-1af2e470d8ff', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, '8e9971fb-270c-4897-ae63-50f457d9d0d5', 'a352a7f2-6caf-48bd-8f2e-90a1b3d248fd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e2247b4c-a6cf-4cbf-bdf8-a64aeaf6933a', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, 'a352a7f2-6caf-48bd-8f2e-90a1b3d248fd', '7bdb3dd3-ed56-43ff-8a99-a49101ba7d48', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('36b6b1e1-03f8-45e0-b810-7f506aa69c67', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, '0caafe33-8257-4550-9e75-c8a828d5dbc6', '4c75b994-e714-4781-a51d-6f582ae07f6e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b7427b8f-db70-496a-b5a4-ce1e704c8246', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, '93ec1b20-de2b-4af1-924f-047a7afa0276', '0caafe33-8257-4550-9e75-c8a828d5dbc6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b9f6bf0a-34e9-4783-ac50-a2e294cd2722', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, '7bdb3dd3-ed56-43ff-8a99-a49101ba7d48', '0caafe33-8257-4550-9e75-c8a828d5dbc6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3f430afe-ae59-4e28-8a56-7bd911f9eac7', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, '0caafe33-8257-4550-9e75-c8a828d5dbc6', '4330591d-61d5-4435-827a-c71b8328a700', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('08e80826-b815-426c-b59c-60e089174ff7', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, '0caafe33-8257-4550-9e75-c8a828d5dbc6', 'a7ff4f1c-7c33-43e0-b264-37339141f7f9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('856b0f90-83dc-4f65-b862-b9e69c5d4608', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', '7bdb3dd3-ed56-43ff-8a99-a49101ba7d48', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dc3c5bd9-f54c-48c2-b912-4750f16d7485', '5add96a4-6fff-4fe2-8628-669d72252417', NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', '8e9971fb-270c-4897-ae63-50f457d9d0d5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dfcfbf97-4d74-47e5-8ff6-58d4d15c1961', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, '7f74a25b-753a-4534-bd83-0db07cc6df2f', '05a6b2b6-58dc-4310-bcf1-d923168e2070', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a4a3c7b3-c797-4956-8f17-b8234b3a8839', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '7f74a25b-753a-4534-bd83-0db07cc6df2f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5018f5b5-e839-4c10-8272-5784e4c709fa', NULL, '7f74a25b-753a-4534-bd83-0db07cc6df2f', '3706fd53-e952-408a-aedd-93ec6d5129be', '7f74a25b-753a-4534-bd83-0db07cc6df2f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('64348744-47d9-4c5c-b851-a6eb71c1baad', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, '64229d80-11aa-4910-9e0c-a211d9a5ca95', '9ddb3c98-f345-4f59-b067-7673d0e06673', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1e4e4775-1354-4816-8818-b11d5abdb247', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, '7f74a25b-753a-4534-bd83-0db07cc6df2f', '64229d80-11aa-4910-9e0c-a211d9a5ca95', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cff9d5f6-722e-4d0b-9631-53cb1078c8ab', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, '64229d80-11aa-4910-9e0c-a211d9a5ca95', '98f81765-6d0e-4cb5-ab49-da912f668f5d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b8fcfba2-925f-41b3-a68d-9f5e282ee1d6', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, 'f4bed22e-44be-4ce4-9d95-5d9be630012a', '8a7273c3-5012-45bd-9d3f-72dd52163117', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2e09df1b-489e-4f3a-add9-eecca44a15a7', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, '93ec1b20-de2b-4af1-924f-047a7afa0276', 'f4bed22e-44be-4ce4-9d95-5d9be630012a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f50fdd37-fce2-49aa-bb36-bf91c808a68a', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, '98f81765-6d0e-4cb5-ab49-da912f668f5d', 'f4bed22e-44be-4ce4-9d95-5d9be630012a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1bc31c7c-b350-408c-9da4-811d0151766a', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, 'f4bed22e-44be-4ce4-9d95-5d9be630012a', '4330591d-61d5-4435-827a-c71b8328a700', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('497285ad-4b61-4108-89af-9341718f8570', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, 'f4bed22e-44be-4ce4-9d95-5d9be630012a', 'a7ff4f1c-7c33-43e0-b264-37339141f7f9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0750ea1a-1e29-498b-93cf-5b9bb974d6e3', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', '98f81765-6d0e-4cb5-ab49-da912f668f5d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4e95f12e-e96e-48ea-acfc-6f5c81541152', '2185083d-3134-4b30-9dcb-674058feaac2', NULL, 'f32f51d5-3384-426e-a1c1-b5b6a263b647', '7f74a25b-753a-4534-bd83-0db07cc6df2f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('91f4f621-48ec-4953-90a5-29e8c96da6d2', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, '8772af22-67d6-4721-bc48-20f841f171e6', 'b31618ff-d749-4aa9-86b8-08eb2de9dcac', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ee5f23de-7bc0-486a-af2b-ce8ca809a8a7', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '8772af22-67d6-4721-bc48-20f841f171e6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3d46e72a-eae9-4ce6-81da-08bd21c11e09', NULL, '8772af22-67d6-4721-bc48-20f841f171e6', '3706fd53-e952-408a-aedd-93ec6d5129be', '8772af22-67d6-4721-bc48-20f841f171e6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1783ac20-fc60-4574-a39b-8f8cabb6c84b', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, '2899fdb3-40ae-4885-8d6b-7c0f07493ef8', '9b229b0a-e7b9-4fce-a134-c6f5199ce495', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('361867cb-91aa-4ee1-b95a-5e4c1abd3725', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, '8772af22-67d6-4721-bc48-20f841f171e6', '2899fdb3-40ae-4885-8d6b-7c0f07493ef8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1f578f1d-cf4c-404a-9d05-d39bb050b9dc', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, '2899fdb3-40ae-4885-8d6b-7c0f07493ef8', 'f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a4f9d60c-0e9a-4d31-8516-ad679c978264', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, 'ce3d8199-1a11-409c-8f0f-99a8344f1d1a', '46ba8c49-58f7-441b-a7c0-290a9f490a1f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('935e8f3b-8569-4b85-8c4f-771a8b2c0deb', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, '5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', 'ce3d8199-1a11-409c-8f0f-99a8344f1d1a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e0e15d6c-1f34-4ad9-99bb-dae9bea370e0', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, 'f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3', 'ce3d8199-1a11-409c-8f0f-99a8344f1d1a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('54344d9d-5501-48d4-b021-efb561be481a', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, 'ce3d8199-1a11-409c-8f0f-99a8344f1d1a', '5167487b-90ee-40b9-9c34-535b74b3186e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('87faed89-6652-4ebd-a2c2-183e88046dab', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, 'ce3d8199-1a11-409c-8f0f-99a8344f1d1a', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ce026d6a-238b-4663-8a6a-63b30be9a7e0', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5ada012b-e322-4928-a6b4-c08620cceadb', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', '8772af22-67d6-4721-bc48-20f841f171e6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6b7b8728-4071-4b75-b2a7-1ddd2e1bc468', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, 'bd1cdc2f-13aa-490d-84bf-1cea1d91fd05', '1be877de-9e9e-478b-855b-f4f0e6dfb842', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3715d066-6c22-4d60-a579-859b3340ffdc', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'bd1cdc2f-13aa-490d-84bf-1cea1d91fd05', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bc4ccda5-cc3c-44a0-b079-795628799f81', NULL, 'bd1cdc2f-13aa-490d-84bf-1cea1d91fd05', '3706fd53-e952-408a-aedd-93ec6d5129be', 'bd1cdc2f-13aa-490d-84bf-1cea1d91fd05', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('84b30d19-36de-4e02-bf21-3d3571be13c5', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, 'ec3bede7-5502-40df-bcaf-d2782c15ed50', '7a48ec29-24be-4d13-b788-264eb6fe6327', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('044cd5d9-8e21-4ae8-89a6-3308958528d3', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, 'bd1cdc2f-13aa-490d-84bf-1cea1d91fd05', 'ec3bede7-5502-40df-bcaf-d2782c15ed50', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d2e8f68d-5efb-4926-9ba3-6bbc84b41544', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, 'ec3bede7-5502-40df-bcaf-d2782c15ed50', '98c6c409-250f-4977-89da-f3c242f4be8b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9a50a114-f2e1-4465-8c3d-df1fde31e0c4', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, 'bf5371a6-e09c-4484-b57c-62aa6befdd0c', '2fc229bc-25f7-407d-bdfc-e9469c17ca34', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dc1d7bd9-a178-4b6f-8ddd-88f6a01afe4e', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, '5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', 'bf5371a6-e09c-4484-b57c-62aa6befdd0c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b691f5d4-921f-4f4a-9e96-d4d962d90bb0', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, '98c6c409-250f-4977-89da-f3c242f4be8b', 'bf5371a6-e09c-4484-b57c-62aa6befdd0c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f9442aed-5ca1-4bcf-9552-cb5a35ecbd8d', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, 'bf5371a6-e09c-4484-b57c-62aa6befdd0c', '5167487b-90ee-40b9-9c34-535b74b3186e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('91e2ffc4-0265-42d1-ba63-f35be286e999', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, 'bf5371a6-e09c-4484-b57c-62aa6befdd0c', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b9fc0e8c-5f9f-4781-b485-379d44c53792', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', '98c6c409-250f-4977-89da-f3c242f4be8b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a906bcfa-8745-41df-a97f-691c5a303f1a', '17ea3654-289d-4892-a837-3ddcaea2d7db', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'bd1cdc2f-13aa-490d-84bf-1cea1d91fd05', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d9fbd26a-a4b0-4ad1-8c38-3281b7b4b992', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, '6093331c-adb2-44e9-baac-ef073278751f', '46d04d79-5187-44ec-8f30-e6f823bc47e6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('71a02cb0-4e2d-49ad-8ebc-e91cefaf35bd', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '6093331c-adb2-44e9-baac-ef073278751f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4ca42285-8620-423d-833e-591a0c311ef9', NULL, '6093331c-adb2-44e9-baac-ef073278751f', '3706fd53-e952-408a-aedd-93ec6d5129be', '6093331c-adb2-44e9-baac-ef073278751f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('16fdb069-9d57-40a4-8993-547d5a39c03e', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, 'a0cf1824-6284-4031-980e-1df923d144e0', '3817a2b3-7031-4489-8c87-23babe729843', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b37eb949-13ea-455c-a7da-cb958219a181', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, '6093331c-adb2-44e9-baac-ef073278751f', 'a0cf1824-6284-4031-980e-1df923d144e0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('45c9a1c0-a672-495c-a16c-37e8b92d4a7d', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, 'a0cf1824-6284-4031-980e-1df923d144e0', '0a93387c-682c-45d7-8a24-e538678f5cf4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6feec489-d95d-4a2f-8d34-76f11e5a0276', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, '35a0a69f-e93c-43f7-b406-3c2d01e1cd8c', 'd241e268-fffd-4d21-9936-819ae9975f85', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d63c04ff-728e-4847-bfb3-b8780540a025', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, '5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', '35a0a69f-e93c-43f7-b406-3c2d01e1cd8c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('31b7bb2a-4e2c-401a-9f51-160a53e4cc3c', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, '0a93387c-682c-45d7-8a24-e538678f5cf4', '35a0a69f-e93c-43f7-b406-3c2d01e1cd8c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4e6714ed-44b6-4846-9158-030ab6e876eb', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, '35a0a69f-e93c-43f7-b406-3c2d01e1cd8c', '5167487b-90ee-40b9-9c34-535b74b3186e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('46508dd1-469a-45be-81bd-6346a9bbc63e', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, '35a0a69f-e93c-43f7-b406-3c2d01e1cd8c', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d171cf8a-9426-4276-aedc-3e137be04705', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', '0a93387c-682c-45d7-8a24-e538678f5cf4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('92aca332-eddc-4be4-8811-e2a99cacf5fd', '60702c01-7285-4eea-a937-6019d6e3661d', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', '6093331c-adb2-44e9-baac-ef073278751f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7afeee51-a00e-4f79-afcc-7be6f4b53665', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '86514079-9959-4ffe-9563-4be364780b39', '1bc97522-8adf-4246-bb4f-9a870002fbd4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8a007e81-834c-46cd-a09a-35e7992b74b4', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '86514079-9959-4ffe-9563-4be364780b39', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3f5d16e1-aca2-4017-86f9-0ec97c86886f', NULL, '86514079-9959-4ffe-9563-4be364780b39', '3706fd53-e952-408a-aedd-93ec6d5129be', '86514079-9959-4ffe-9563-4be364780b39', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8fb309bc-79ef-4085-b25e-58e7b0827fbf', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '94fb08b4-d5d1-43a5-a395-b1e261a46e0b', '7ee9690d-ebff-4afb-95db-fad387eb4255', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a98c8ed6-d9d3-4420-9da7-900372a76869', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '86514079-9959-4ffe-9563-4be364780b39', '94fb08b4-d5d1-43a5-a395-b1e261a46e0b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b8b3f481-4402-4ea0-850e-8a52ab5e8703', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '94fb08b4-d5d1-43a5-a395-b1e261a46e0b', 'd6e4ad57-a163-4508-a694-99a87eeeb986', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7987aafb-1726-4434-b942-f3e03f2944a0', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a', '2d00deb0-bb73-447f-b867-71be2d2dbfda', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('60dcb967-6300-4985-adcb-5a49474e2f7b', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', '67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c423d783-e419-49f1-8804-296f71d6c254', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, 'd6e4ad57-a163-4508-a694-99a87eeeb986', '67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('47c7c631-f6bb-40ad-8b2b-05274dd958f0', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a', '206fcdf2-c22e-480f-9029-42183cc2990e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bf19153e-8a52-4339-ae59-971174f639f2', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c9bc9ea4-66ff-43f0-86b1-4f6f8fd31e5c', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', 'd6e4ad57-a163-4508-a694-99a87eeeb986', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bbe4f41e-6ecd-4688-b44a-8a94a9badd9b', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '86514079-9959-4ffe-9563-4be364780b39', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e743b05d-4d77-4167-be21-b86213521704', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '5eb167f7-80c1-4c71-9c63-b9d6994ec251', '3a64d35c-f155-4420-a87f-ddd771f7e500', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('48e818a3-167f-4dc8-8aff-c22b63aba62b', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '5eb167f7-80c1-4c71-9c63-b9d6994ec251', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('92b37cad-3482-4ece-8be4-dd7f5bc524ab', NULL, '5eb167f7-80c1-4c71-9c63-b9d6994ec251', '3706fd53-e952-408a-aedd-93ec6d5129be', '5eb167f7-80c1-4c71-9c63-b9d6994ec251', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0021ca7-6132-406c-ab5d-e981e394586e', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '44c0b607-7d0a-4701-9570-8d339189020f', '238a91bb-2186-41f0-a97b-6e4c62a2c6a8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0d7f87c0-db06-4a82-a3d6-d64698f34c55', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '5eb167f7-80c1-4c71-9c63-b9d6994ec251', '44c0b607-7d0a-4701-9570-8d339189020f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6100fa03-8dc5-4f16-85b6-65546e1bef7a', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '44c0b607-7d0a-4701-9570-8d339189020f', '91f36783-f411-4708-a88e-b30fb94d849a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cf8cb48d-1d87-4b11-b2d1-df908149d755', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '52c74fa2-27f4-4046-8712-759b3f47e48a', '0dc256f1-c7eb-4c52-95b6-a05ef1f92d4f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7fd305af-57be-43a7-a732-f26418a1ca53', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', '52c74fa2-27f4-4046-8712-759b3f47e48a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('57536f03-fcb5-44ff-a589-e98cd3df123b', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '91f36783-f411-4708-a88e-b30fb94d849a', '52c74fa2-27f4-4046-8712-759b3f47e48a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8ed30d78-487b-468d-aa73-e3bb5e4b5d17', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '52c74fa2-27f4-4046-8712-759b3f47e48a', '206fcdf2-c22e-480f-9029-42183cc2990e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('72bdf079-cbb7-4a67-8666-4583db5d3cca', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '52c74fa2-27f4-4046-8712-759b3f47e48a', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('805468da-74ec-4b41-93c6-6bee7da7cd0b', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '91f36783-f411-4708-a88e-b30fb94d849a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0e8d9f5-6d48-4cef-9ef7-0730917a3d14', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '5eb167f7-80c1-4c71-9c63-b9d6994ec251', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bed9a100-fd78-4b56-bfc8-2f484b955947', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '2a60ab65-5d4d-49bf-b184-3b1ef563bd62', '8b30e218-5562-41af-82ce-bf3f633d1f3d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('213e0b7e-5f3e-4e42-bdf6-30a0ac699b28', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '2a60ab65-5d4d-49bf-b184-3b1ef563bd62', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('80161fac-c749-4b08-8c84-0ebafd2d3a98', NULL, '2a60ab65-5d4d-49bf-b184-3b1ef563bd62', '3706fd53-e952-408a-aedd-93ec6d5129be', '2a60ab65-5d4d-49bf-b184-3b1ef563bd62', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b01e33b6-b72e-4ff8-bce3-5e4fee5d954d', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '553adc79-d3f6-4b92-88d3-8c9328e5a616', '31a9442f-92c2-4f7d-9895-a7095ee96952', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('166f5922-7578-4ecb-b9ac-b89136e7ef33', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '2a60ab65-5d4d-49bf-b184-3b1ef563bd62', '553adc79-d3f6-4b92-88d3-8c9328e5a616', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4290306a-ac53-43a6-84a2-c234e41835a0', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '553adc79-d3f6-4b92-88d3-8c9328e5a616', '832cde07-7e08-41a0-84e0-201f12393e15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('34d62e8e-b3d7-468b-a291-fc969c3b9cb0', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '4e1db019-7622-4ba1-aec7-4046419a7b28', 'bacb714c-ac84-4f51-b8e3-fc74b27e1388', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d196d344-99a6-4eda-8a2c-9a589cd035dd', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', '4e1db019-7622-4ba1-aec7-4046419a7b28', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1938ede4-bf20-4e00-af7c-e2824876b1c8', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '832cde07-7e08-41a0-84e0-201f12393e15', '4e1db019-7622-4ba1-aec7-4046419a7b28', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5d6d973a-91c3-446a-8265-c561784b9469', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '4e1db019-7622-4ba1-aec7-4046419a7b28', '206fcdf2-c22e-480f-9029-42183cc2990e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e37e4ee5-9e16-48d3-8f4f-a830266ea4f8', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '4e1db019-7622-4ba1-aec7-4046419a7b28', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aabbd5f7-d31b-41e3-a111-736caf90ba92', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '832cde07-7e08-41a0-84e0-201f12393e15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('13193ab0-7409-4371-9d99-43fc3d4b3c38', '8363ec62-6d90-4dd9-940b-6073b3246c39', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '2a60ab65-5d4d-49bf-b184-3b1ef563bd62', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('87762c8c-7d03-493c-a236-12373e0eee27', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, '4e4469ab-f0e8-4927-a374-33384a97811f', '4f6ce070-55e4-4d2c-9429-5d4b3fa25077', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('99fc01f9-b91b-4df6-a9eb-35c880f38117', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '4e4469ab-f0e8-4927-a374-33384a97811f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fd064544-7017-4079-954e-2557cb22467c', NULL, '4e4469ab-f0e8-4927-a374-33384a97811f', '3706fd53-e952-408a-aedd-93ec6d5129be', '4e4469ab-f0e8-4927-a374-33384a97811f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c12808fb-f852-4149-8745-207250682761', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, 'f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1', '274595e4-31af-488a-997e-688d10886a47', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b19b89e1-320b-4676-b2e1-878d02e24a0c', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, '4e4469ab-f0e8-4927-a374-33384a97811f', 'f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('96fce452-6a70-41b3-b800-a0a9aa31461a', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, 'f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1', 'c110be44-7852-4eaa-b52a-c87a93de1076', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('07568fe6-b570-4eb9-b88e-9eeab35ca495', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, 'b9ad5d7e-cf8d-4265-9271-2e32128b69d2', '596f965f-b224-495b-9f5f-5150af69979f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('af0c2637-5a4b-46ee-a5d1-dc6d671266bb', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', 'b9ad5d7e-cf8d-4265-9271-2e32128b69d2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6de23849-34f4-4c8c-b947-9a8e40f7c7a7', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, 'c110be44-7852-4eaa-b52a-c87a93de1076', 'b9ad5d7e-cf8d-4265-9271-2e32128b69d2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('470a225c-108e-4d1d-8ea2-483a412b9bbf', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, 'b9ad5d7e-cf8d-4265-9271-2e32128b69d2', '206fcdf2-c22e-480f-9029-42183cc2990e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cd11068c-9a45-48e7-808e-fb0dd02f45b9', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, 'b9ad5d7e-cf8d-4265-9271-2e32128b69d2', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dff92d19-dc34-4296-a0d7-91b0d9631d30', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', 'c110be44-7852-4eaa-b52a-c87a93de1076', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ec2adc5b-1930-45b7-86c7-2accc5f02e6a', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '4e4469ab-f0e8-4927-a374-33384a97811f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('35ab9b66-1ade-4b49-bb31-ebe516a34c67', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, 'b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f', 'e77c42c3-559a-44af-90cd-304eab1646a5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('750eda48-2032-4eb7-842e-f212a05cb566', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9a2a51d9-3e9a-4524-9093-b622c3183afc', NULL, 'b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f', '3706fd53-e952-408a-aedd-93ec6d5129be', 'b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('290221cd-e520-4a1c-8119-df58ec4dfae0', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, 'ba6c1883-e891-4628-bea0-78b9787b1403', '0ab92d43-0a98-4d77-9f65-44d74acfe5b8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('92df1b96-88c6-436f-9a5d-9590b4e1a0b1', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, 'b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f', 'ba6c1883-e891-4628-bea0-78b9787b1403', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6fef9941-52e9-4692-aa2b-e986773bacef', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, 'ba6c1883-e891-4628-bea0-78b9787b1403', '3877cf69-dfcc-4ff3-83a1-65ef1471f919', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cc3ccd82-fa75-402e-a188-337c8f44c64d', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, '4d8fb33e-f5de-4716-a301-a753f59c5aed', 'f6542fe1-149a-4244-b812-18ad82ff555f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('47dc5cdb-3e87-4e5d-950c-16ba19152b64', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', '4d8fb33e-f5de-4716-a301-a753f59c5aed', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b88a2bef-44ca-479c-8eef-704a5e217691', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, '3877cf69-dfcc-4ff3-83a1-65ef1471f919', '4d8fb33e-f5de-4716-a301-a753f59c5aed', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d0aa8661-c85f-4de9-8ca1-cf86c25d15f7', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, '4d8fb33e-f5de-4716-a301-a753f59c5aed', '206fcdf2-c22e-480f-9029-42183cc2990e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2dc93f8b-9342-4f0c-8031-9340353d364d', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, '4d8fb33e-f5de-4716-a301-a753f59c5aed', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('410cf3aa-8db7-4683-9fec-069ab6073afd', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '3877cf69-dfcc-4ff3-83a1-65ef1471f919', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d4ee96b0-fd17-4bbd-b1e8-98f9ce015c9e', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', 'b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('869b3806-564d-4c47-a7ca-bb7285365647', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '80da5984-53fc-4439-a4b2-2aa030416ddf', '2715a520-f38d-486b-9053-055f6289c966', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('774a242d-e8b0-416f-9c72-a68ffebe0315', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '80da5984-53fc-4439-a4b2-2aa030416ddf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('45130952-0637-4191-88e6-9398918afd0d', NULL, '80da5984-53fc-4439-a4b2-2aa030416ddf', '3706fd53-e952-408a-aedd-93ec6d5129be', '80da5984-53fc-4439-a4b2-2aa030416ddf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('face9f8a-f956-4f10-a47c-0f7af36fda49', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '8f1fbdf5-7aba-43d7-932e-a9e4f386ae84', '1a09398f-873b-4c9a-9392-c129ccf0d636', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('22d3b5e6-c4d4-45cd-99da-8008b2040278', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '80da5984-53fc-4439-a4b2-2aa030416ddf', '8f1fbdf5-7aba-43d7-932e-a9e4f386ae84', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0dd85e2-83d4-4f03-b24a-db9db12cf607', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '8f1fbdf5-7aba-43d7-932e-a9e4f386ae84', '46a6fc92-c738-40d2-be20-7762997fdd21', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dac85b6b-4dd2-42b2-a151-b8dfce5b2bd5', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '9fc0d602-3a23-4ce9-b8eb-216e58c23cb6', '44074e80-79cc-4965-9525-29ed20419544', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3878bbdd-11c5-47b0-9e20-c70896c918cb', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', '9fc0d602-3a23-4ce9-b8eb-216e58c23cb6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9b63a093-30f1-4628-80e9-a7baf79a4ebc', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '46a6fc92-c738-40d2-be20-7762997fdd21', '9fc0d602-3a23-4ce9-b8eb-216e58c23cb6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fd33e269-1be7-4616-b094-5e0ae35a65a7', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '9fc0d602-3a23-4ce9-b8eb-216e58c23cb6', '206fcdf2-c22e-480f-9029-42183cc2990e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('26b6187d-24dd-4f65-b5a4-a6d8095a4c16', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '9fc0d602-3a23-4ce9-b8eb-216e58c23cb6', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c9e8265f-376e-454c-a97b-aff7a2e3cf3d', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '46a6fc92-c738-40d2-be20-7762997fdd21', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('313114d1-83cc-4289-959b-e5068b98e0ea', 'a13af5de-4315-46dd-ae08-427ea72b35a0', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '80da5984-53fc-4439-a4b2-2aa030416ddf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d114921e-f2b3-4530-aeac-c318b0456251', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '201bce64-1c53-4047-bfd3-1892e4bb545f', 'ab127630-3367-4898-b0d7-f3ef0f6fb7cf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('549a494a-cb4c-4b9e-ae81-c386e0cd0ab1', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '201bce64-1c53-4047-bfd3-1892e4bb545f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c48c846e-f9c3-43c7-adea-e54cddfe9f2a', NULL, '201bce64-1c53-4047-bfd3-1892e4bb545f', '3706fd53-e952-408a-aedd-93ec6d5129be', '201bce64-1c53-4047-bfd3-1892e4bb545f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('01aa4b8c-b7d7-446b-80a8-d2ed6eaeb321', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '5927cb7b-54a9-429d-a229-d3ab87cccecb', '53f0c6bb-a76b-4f8d-81f9-a476c9106436', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dd21baf1-92df-4d7b-9b61-ac7870a870a5', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '201bce64-1c53-4047-bfd3-1892e4bb545f', '5927cb7b-54a9-429d-a229-d3ab87cccecb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('db27b1dc-0c50-4cf4-a029-1496adfdbcd0', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '5927cb7b-54a9-429d-a229-d3ab87cccecb', 'b2c4c782-4afe-4518-8c92-0de8c70b70b2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d9dc0aac-67e0-4844-a34f-5f5485f9fb49', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '5a04d74f-230c-451d-ad05-3f08d0e95b0b', '88d7ad95-2568-4cfe-8f1c-e09ac9fe8983', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0b50edc0-4338-44b7-8053-be59f47bf734', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '4241127c-1c6d-41b4-9350-3aa73785f6c5', '5a04d74f-230c-451d-ad05-3f08d0e95b0b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('31f4ead0-bcc1-4092-a334-0252cb746d85', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, 'b2c4c782-4afe-4518-8c92-0de8c70b70b2', '5a04d74f-230c-451d-ad05-3f08d0e95b0b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bca29c27-e651-4eaa-823b-e6f257666696', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '5a04d74f-230c-451d-ad05-3f08d0e95b0b', '206fcdf2-c22e-480f-9029-42183cc2990e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('03d88972-e76d-48da-8474-86285c42fb0a', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '5a04d74f-230c-451d-ad05-3f08d0e95b0b', 'bdeffe17-405f-4ad0-8131-82728ea0e382', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('020a2ccd-31a8-4a54-8dbe-2acbd6bac42f', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', 'b2c4c782-4afe-4518-8c92-0de8c70b70b2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('01125877-8fa2-42f1-a7df-a0dc6e7a6789', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', NULL, '1373e547-4804-4c8d-9014-ce51c65f3a06', '201bce64-1c53-4047-bfd3-1892e4bb545f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4ea51bc6-c651-4d38-bf2a-ab9686d376ca', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, '32326817-2750-452c-8898-bcb42c36d85f', 'dd52b6d9-4a90-4a10-9ca8-3d8094a0aadd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('282e731f-a9ff-4f44-9c93-431614440eb3', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '32326817-2750-452c-8898-bcb42c36d85f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8ed063cd-8a99-4619-913e-961b3c5d538b', NULL, '32326817-2750-452c-8898-bcb42c36d85f', '3706fd53-e952-408a-aedd-93ec6d5129be', '32326817-2750-452c-8898-bcb42c36d85f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('696f7628-61c5-4406-820d-e85d8774e048', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, 'f7c2a405-965c-48a4-aecb-4312952d072e', '138ab6b6-1b04-4565-bbcf-db30047e0050', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('803c73ee-d210-430d-939d-47e2ec8b4bf0', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, '32326817-2750-452c-8898-bcb42c36d85f', 'f7c2a405-965c-48a4-aecb-4312952d072e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dd56533a-5068-4349-837b-7847a26884b0', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, 'f7c2a405-965c-48a4-aecb-4312952d072e', 'a67d167a-e0da-4fe0-b2a1-cc320687f44a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cc35556d-69d7-40f7-9d44-103a60e2d871', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, 'ab46de32-5a21-4029-b5c2-517f6d6002c3', 'beec505c-c47c-46ff-bdb5-7fe04a5595c6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('41500a4e-22af-47f9-a4f4-8af1b28c4c33', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, 'd3aa37e9-88d7-4099-8fa8-0bb25f6db328', 'ab46de32-5a21-4029-b5c2-517f6d6002c3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6d9a0688-78d3-499e-89cb-3cec3597c28b', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, 'a67d167a-e0da-4fe0-b2a1-cc320687f44a', 'ab46de32-5a21-4029-b5c2-517f6d6002c3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2d444fb7-5554-4721-ba46-9b3d7fa1255b', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, 'ab46de32-5a21-4029-b5c2-517f6d6002c3', '3f62e7fa-ffed-4a15-88c2-2d4a231c7db0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5b99af89-725d-472e-996f-8a0cabbddef1', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, 'ab46de32-5a21-4029-b5c2-517f6d6002c3', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c3376d95-4f15-4c1d-94a5-1cb9ecaa819d', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, 'ab46de32-5a21-4029-b5c2-517f6d6002c3', '96d81c1c-7d32-4b58-b7d3-7d7d88d250b7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d21c8c1e-b2f3-4aa6-8e1d-15fdbaaf521e', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, '957da54d-43eb-45d5-a3c4-34976d178bf3', 'a67d167a-e0da-4fe0-b2a1-cc320687f44a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e1ab8227-6ba0-4a77-a029-625d58c33d7e', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', '32326817-2750-452c-8898-bcb42c36d85f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('711505a2-74a7-46e5-bcf7-f78f7abe07c2', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, 'd5048fcc-cb35-4f37-bfdc-611473026b50', 'ebf101f3-6206-4cd7-a5df-276dcec51cba', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6400872d-bfea-4616-92c5-3a5b9e49b568', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'd5048fcc-cb35-4f37-bfdc-611473026b50', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1b459f37-35d9-461e-b10f-619a69fd5d1f', NULL, 'd5048fcc-cb35-4f37-bfdc-611473026b50', '3706fd53-e952-408a-aedd-93ec6d5129be', 'd5048fcc-cb35-4f37-bfdc-611473026b50', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2bdd1162-d22a-41f1-8d62-76d00859b2dd', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, '2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7', '31faa035-267f-46d2-b9b1-af688c393431', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1069eeff-cd63-4704-9fb0-5d90f52e2d1f', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, 'd5048fcc-cb35-4f37-bfdc-611473026b50', '2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0b6a0e6c-a348-4012-afcd-31559085775a', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, '2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7', '13854f26-4d9d-411f-a6a8-d1cf8c267a32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3fa17011-0e90-454f-943c-f287b530fb2a', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, '44900785-555c-468f-9aa1-277c191fc3a6', '2b33fc20-f3b2-474c-9d9e-40be8240e900', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('79f93e0c-49f6-4906-a2b8-d95b28c23d9f', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, 'd3aa37e9-88d7-4099-8fa8-0bb25f6db328', '44900785-555c-468f-9aa1-277c191fc3a6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9b98cf31-9486-4214-a564-1f60b7a71abb', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, '13854f26-4d9d-411f-a6a8-d1cf8c267a32', '44900785-555c-468f-9aa1-277c191fc3a6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5e524f54-2607-45cd-a168-6e9d84211128', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, '44900785-555c-468f-9aa1-277c191fc3a6', '3f62e7fa-ffed-4a15-88c2-2d4a231c7db0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('05854007-d696-4479-a4fe-abece95d2523', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, '44900785-555c-468f-9aa1-277c191fc3a6', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a23ef302-960c-4bfb-885e-116acbddeaba', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, '44900785-555c-468f-9aa1-277c191fc3a6', '96d81c1c-7d32-4b58-b7d3-7d7d88d250b7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ba50a550-d607-4a56-94a9-e41246052b1e', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, '957da54d-43eb-45d5-a3c4-34976d178bf3', '13854f26-4d9d-411f-a6a8-d1cf8c267a32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dc55d2f6-b265-44bb-a98e-b7c3592e3291', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'd5048fcc-cb35-4f37-bfdc-611473026b50', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dbe1cefb-01f0-4b91-8cb0-6e2c52397406', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, 'a24b3dcc-92b3-475f-8741-4399f604e189', '36c7d299-20b9-47b4-a2ed-bd7031ad3dd1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b644db95-825b-45ad-9154-7c6eb6ff1acd', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'a24b3dcc-92b3-475f-8741-4399f604e189', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4755567d-e545-4f6d-b64a-963637a12b87', NULL, 'a24b3dcc-92b3-475f-8741-4399f604e189', '3706fd53-e952-408a-aedd-93ec6d5129be', 'a24b3dcc-92b3-475f-8741-4399f604e189', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('450d6656-4d24-44d4-b9ce-7423e413dbfb', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, '1d6da0f9-048c-4b62-bedd-5f4d4d35b284', '95ad7ff4-f585-48c5-945a-1a87c3bb2229', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6479f241-dfad-499f-bc9e-45ccfa2f19eb', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, 'a24b3dcc-92b3-475f-8741-4399f604e189', '1d6da0f9-048c-4b62-bedd-5f4d4d35b284', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('76b61779-3f11-44af-aab5-48fa969c9a5b', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, '1d6da0f9-048c-4b62-bedd-5f4d4d35b284', '33bff6f5-22a5-4a5c-bcf1-1e3003bcf530', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f3c72143-eeca-460a-a7cc-6f9220c810af', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, 'eebc57f5-8fbd-4665-9328-78b0a6600478', '1be5be35-a23a-4f02-967b-f4a7237f482a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a16d0761-a5ec-4dcb-8921-41d145e326dd', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, 'd3aa37e9-88d7-4099-8fa8-0bb25f6db328', 'eebc57f5-8fbd-4665-9328-78b0a6600478', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3fe5ffb0-c3a5-45b6-9f8f-25c200062b8d', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, '33bff6f5-22a5-4a5c-bcf1-1e3003bcf530', 'eebc57f5-8fbd-4665-9328-78b0a6600478', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fbb0d745-15bc-4e97-a72d-383ff3ce3b91', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, 'eebc57f5-8fbd-4665-9328-78b0a6600478', '3f62e7fa-ffed-4a15-88c2-2d4a231c7db0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5205f110-721f-4e35-a47b-94b36cf3c7f2', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, 'eebc57f5-8fbd-4665-9328-78b0a6600478', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('97c8d585-7e82-439a-b062-a010baf72200', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, 'eebc57f5-8fbd-4665-9328-78b0a6600478', '96d81c1c-7d32-4b58-b7d3-7d7d88d250b7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9b9e5987-ef87-43a0-ab02-aa74a30a81a8', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, '957da54d-43eb-45d5-a3c4-34976d178bf3', '33bff6f5-22a5-4a5c-bcf1-1e3003bcf530', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b66437d8-25cc-48f6-9fed-56ebb854d5dd', '18124f89-8ce6-4813-8efe-3ed47b7eb453', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'a24b3dcc-92b3-475f-8741-4399f604e189', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f47d3670-a996-43b9-ac56-bc64167bf8e9', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, 'cf88430b-e0a1-431e-9912-098933e6771c', 'eb9181ce-7b72-4ed9-93aa-49eb66db32eb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bf388cd5-754d-4a67-a900-74c8ae8d0763', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'cf88430b-e0a1-431e-9912-098933e6771c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('04ee36e9-7e18-455b-bec1-f850ccc4fa03', NULL, 'cf88430b-e0a1-431e-9912-098933e6771c', '3706fd53-e952-408a-aedd-93ec6d5129be', 'cf88430b-e0a1-431e-9912-098933e6771c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b8521069-8984-42f5-ad51-92f0bf13da89', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, '5f9120b4-56a8-4a73-96bb-2fd1edcfbf43', 'f9768956-c483-4cf1-852d-b6767a8d96cc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('832b6b8c-1734-43e9-b1a9-15b3fbf6bf25', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, 'cf88430b-e0a1-431e-9912-098933e6771c', '5f9120b4-56a8-4a73-96bb-2fd1edcfbf43', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('86891920-aabe-4630-a89e-4bce541e351c', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, '5f9120b4-56a8-4a73-96bb-2fd1edcfbf43', '12a30425-8c0e-4e0d-b9ae-da96e2776217', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('df32434f-3f53-4421-9a54-91a734df8b09', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, '917b274c-a8da-403c-9ac2-5be884f4a47f', 'a37b1549-de63-4830-81ab-816dbea5ddf9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('da816bce-54d8-4bfd-be4a-107ff0e28ae9', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, 'd3aa37e9-88d7-4099-8fa8-0bb25f6db328', '917b274c-a8da-403c-9ac2-5be884f4a47f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7b905937-6603-4649-b2fc-f3c294a5506e', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, '12a30425-8c0e-4e0d-b9ae-da96e2776217', '917b274c-a8da-403c-9ac2-5be884f4a47f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('601bf4bf-ed9e-4d04-bfcc-f50e7d9720fc', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, '917b274c-a8da-403c-9ac2-5be884f4a47f', '3f62e7fa-ffed-4a15-88c2-2d4a231c7db0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d18a77de-532d-44d3-8759-87b41db913e9', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, '917b274c-a8da-403c-9ac2-5be884f4a47f', 'e97003a9-9162-4142-8d08-814e6c8fabd9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8629ae4f-a025-4264-a2ad-24cdb50f24fd', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, '917b274c-a8da-403c-9ac2-5be884f4a47f', '96d81c1c-7d32-4b58-b7d3-7d7d88d250b7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ec402129-b125-44df-8dd1-919c43709a99', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, '957da54d-43eb-45d5-a3c4-34976d178bf3', '12a30425-8c0e-4e0d-b9ae-da96e2776217', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b986a66d-e06f-4c7c-a71b-b8ba4dd9ffd8', 'cbda6432-b849-4787-84ab-88e680dbfa72', NULL, '95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'cf88430b-e0a1-431e-9912-098933e6771c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('34b11791-5906-4753-b722-7fa782ef8ef2', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, '7bddc04e-775b-48f6-acb1-c1c9e638f836', '283a7da7-7cf5-489b-bd81-a370cd694f3a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f5db57a6-93dd-4658-b13b-827f28d9ef59', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '7bddc04e-775b-48f6-acb1-c1c9e638f836', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('75685f6f-2403-40ef-b08b-1625bd699a13', NULL, '7bddc04e-775b-48f6-acb1-c1c9e638f836', '3706fd53-e952-408a-aedd-93ec6d5129be', '7bddc04e-775b-48f6-acb1-c1c9e638f836', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d34d2490-26a3-40dd-8417-faec7508092e', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, 'd8668032-3755-4ef6-8ea7-7c34e0109e25', 'fe2d0171-effb-42e9-ad87-d877454fa221', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('75f5c8b1-9e1c-4dbf-85c8-c119cfe29326', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, '7bddc04e-775b-48f6-acb1-c1c9e638f836', 'd8668032-3755-4ef6-8ea7-7c34e0109e25', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f93454ce-5594-4cc7-a797-35fc38e745a3', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, 'd8668032-3755-4ef6-8ea7-7c34e0109e25', '9dc88526-27f4-4c56-aef0-740429a8c457', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('541ddc9b-d0eb-4f83-a647-f4047f2135db', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, '67d9bcbb-574f-405a-b48c-f7ccfb9e0a06', 'c4f3311d-618c-4e1b-9e0e-925465a5f932', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fb7d467d-75bb-443f-897b-124fa953f729', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, 'ba7a634b-c352-418c-a8c0-58918f32f8a7', '67d9bcbb-574f-405a-b48c-f7ccfb9e0a06', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a0391c4f-dff7-4778-a463-002d9e935bbd', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, '9dc88526-27f4-4c56-aef0-740429a8c457', '67d9bcbb-574f-405a-b48c-f7ccfb9e0a06', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4652cf4f-b896-4c22-bea8-a0ce0f862fc0', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, '67d9bcbb-574f-405a-b48c-f7ccfb9e0a06', 'ed0f7762-a094-4a88-abde-8472da33bcfb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c8c5f426-06e7-4ad2-a82b-048f51ac1beb', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, '67d9bcbb-574f-405a-b48c-f7ccfb9e0a06', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b043c952-cab2-4c4c-b6b6-668548bac175', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, '67d9bcbb-574f-405a-b48c-f7ccfb9e0a06', 'b29939d1-67c0-4527-88fd-41812023f402', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1e109da8-4793-473a-9a19-ec9a228f9eea', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, 'd8668032-3755-4ef6-8ea7-7c34e0109e25', 'a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c6d9e156-e05a-4104-8be8-16d50b6450f2', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '9dc88526-27f4-4c56-aef0-740429a8c457', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b381a17d-1961-4aec-9ce1-b475906f1ac0', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', NULL, '2812b2d9-15c6-479c-b59d-bf980f4bc9d7', '7bddc04e-775b-48f6-acb1-c1c9e638f836', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9c7f8f52-49c5-4f65-b0e9-2620f0c113bc', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, 'ec817efa-d1de-4264-91e4-608b736b59fd', 'f276aa53-a904-46ec-863b-18e593fd2c3e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c2534fb6-fa15-41a5-9d0c-8445406cdd70', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'ec817efa-d1de-4264-91e4-608b736b59fd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e22b72b0-fcf6-4b88-9166-2d94b2496746', NULL, 'ec817efa-d1de-4264-91e4-608b736b59fd', '3706fd53-e952-408a-aedd-93ec6d5129be', 'ec817efa-d1de-4264-91e4-608b736b59fd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b641e4cf-6ea1-474e-b301-1f468f0373ba', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, '0fae86ec-61fc-4f23-9713-a51f3f49505d', '17df9716-97f3-4970-813b-d144044d718f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f61ec4c4-d206-4ee7-8722-062ba7b07b79', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, 'ec817efa-d1de-4264-91e4-608b736b59fd', '0fae86ec-61fc-4f23-9713-a51f3f49505d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d629a3a2-6161-48ce-a520-646f49c89e15', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, '0fae86ec-61fc-4f23-9713-a51f3f49505d', '57070af3-92a3-4285-b6e8-8644989f8fce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4a55cc2e-66f0-4d08-aff1-67405a9ae037', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, '087d73fd-3c94-4735-b59a-189efda4a80e', '82813289-dc57-4c85-8c73-8e7f71966bbc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9c2ddc22-9324-4687-bd2c-6b59c22dc953', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, 'ba7a634b-c352-418c-a8c0-58918f32f8a7', '087d73fd-3c94-4735-b59a-189efda4a80e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bf80cf56-1b0d-4a25-8b71-a86863d888de', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, '57070af3-92a3-4285-b6e8-8644989f8fce', '087d73fd-3c94-4735-b59a-189efda4a80e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('afda5e1d-620c-4bff-a0cd-f321fb6b8580', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, '087d73fd-3c94-4735-b59a-189efda4a80e', 'ed0f7762-a094-4a88-abde-8472da33bcfb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a9a302d7-c9e3-4025-8c2a-a0007c270277', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, '087d73fd-3c94-4735-b59a-189efda4a80e', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1bd5d7d2-6de0-4b56-b53a-86b113907e3c', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, '087d73fd-3c94-4735-b59a-189efda4a80e', 'b29939d1-67c0-4527-88fd-41812023f402', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1c75fd2c-8206-4872-8c63-78da5890be1b', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, '2812b2d9-15c6-479c-b59d-bf980f4bc9d7', '57070af3-92a3-4285-b6e8-8644989f8fce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fea36da2-ee0d-4001-8c9f-e7e17f3654c3', '4761d35a-2de3-4415-a91d-f53d15162aea', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', 'ec817efa-d1de-4264-91e4-608b736b59fd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0a6c8d17-c23e-4caa-8966-9911542ccd0f', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, '6d7c3c90-cec2-472a-b143-3f730bb92d11', '54ab8484-47e5-432c-afd4-7791561e09a7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('688a5723-8b60-4795-8993-7879f8fbe8f2', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '6d7c3c90-cec2-472a-b143-3f730bb92d11', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('459eda2a-d5c1-4328-aee8-952a50b2d3a1', NULL, '6d7c3c90-cec2-472a-b143-3f730bb92d11', '3706fd53-e952-408a-aedd-93ec6d5129be', '6d7c3c90-cec2-472a-b143-3f730bb92d11', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9d5a0b69-d7af-41a4-9d64-847c56a45de8', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, '0e9f7adf-90bd-4ec9-bf40-82963cd51410', '846820c5-9147-4f79-9b06-62110498d191', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fe8a68e5-e01e-4402-b135-5b94ce2f6d89', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, '6d7c3c90-cec2-472a-b143-3f730bb92d11', '0e9f7adf-90bd-4ec9-bf40-82963cd51410', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d3743c67-560e-4f22-9090-32a0c779b346', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, '0e9f7adf-90bd-4ec9-bf40-82963cd51410', '54c33e22-f4c5-45c4-a86d-fb8ed86afbf7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('84b5def8-230d-4b1d-b2f2-2789341c1eaf', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, 'd5007585-6703-493f-a24d-f99f4fb1b09c', '7cfdc7ad-f7bc-42d1-9b72-ce871adf665b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8a643ea9-487d-4bc5-bee0-394c5c62d309', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, 'ba7a634b-c352-418c-a8c0-58918f32f8a7', 'd5007585-6703-493f-a24d-f99f4fb1b09c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dbf2917f-3aa0-405f-b6bb-2d0e7f080cbb', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, '54c33e22-f4c5-45c4-a86d-fb8ed86afbf7', 'd5007585-6703-493f-a24d-f99f4fb1b09c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f0cdc2ac-fe93-44f2-8f07-72f307737241', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, 'd5007585-6703-493f-a24d-f99f4fb1b09c', 'ed0f7762-a094-4a88-abde-8472da33bcfb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('34c5eff9-432f-4da6-af1e-9944aa43a831', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, 'd5007585-6703-493f-a24d-f99f4fb1b09c', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('493c6d1d-d431-4d2f-8dc1-560810ef9f70', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, 'd5007585-6703-493f-a24d-f99f4fb1b09c', 'b29939d1-67c0-4527-88fd-41812023f402', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fed98897-4115-4492-ba35-be1025525650', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, '2812b2d9-15c6-479c-b59d-bf980f4bc9d7', '54c33e22-f4c5-45c4-a86d-fb8ed86afbf7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8db51064-73b9-4a5c-8051-5ab121cd52c5', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '6d7c3c90-cec2-472a-b143-3f730bb92d11', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5e2c18c6-89af-4344-b9f9-58b2a860eff9', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, '330cd455-c002-4416-8074-feb6c6b4849d', 'b0f7eade-7384-445b-9f6a-76f19007d9b7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('58f9a354-5b5f-4740-9314-533ce8e92515', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '330cd455-c002-4416-8074-feb6c6b4849d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d621455c-aa20-4281-aa4f-d06346979700', NULL, '330cd455-c002-4416-8074-feb6c6b4849d', '3706fd53-e952-408a-aedd-93ec6d5129be', '330cd455-c002-4416-8074-feb6c6b4849d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d4007d15-842b-4bb6-8424-02102c1b6610', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, 'e2eddb4e-842b-450a-a9a4-54a3875b33c5', '4a4b0f7b-8506-4ed5-be19-7c0baa476c45', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e78f06d6-b048-4d2e-b189-c90c3081af1c', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, '330cd455-c002-4416-8074-feb6c6b4849d', 'e2eddb4e-842b-450a-a9a4-54a3875b33c5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('522ba310-4163-4c47-8afa-f69784d4545e', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, 'e2eddb4e-842b-450a-a9a4-54a3875b33c5', '256a2cac-4d33-46c0-833c-fd12d91af365', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('279aebd0-8e1d-4322-86c4-1b19dfef89e1', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, '5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c', '815ba931-a309-42fc-8865-b077937d4bd5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dfff69c7-ce5b-4b67-a425-2b649e7cec7c', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, 'ba7a634b-c352-418c-a8c0-58918f32f8a7', '5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('05bef46b-e96c-485d-a6b9-9d80d682da9a', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, '256a2cac-4d33-46c0-833c-fd12d91af365', '5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('54ababde-0fa4-4e1b-973b-ac63cc1f610a', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, '5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c', 'ed0f7762-a094-4a88-abde-8472da33bcfb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('67a037de-9171-4712-af63-3d455334e3a6', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, '5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b7527a2d-767e-4282-ace1-499ec24c6346', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, '5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c', 'b29939d1-67c0-4527-88fd-41812023f402', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7de75775-7af6-43cd-830c-13e8789fd9f2', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, '2812b2d9-15c6-479c-b59d-bf980f4bc9d7', '256a2cac-4d33-46c0-833c-fd12d91af365', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d30e86da-adad-4745-8a48-e5be9b0f9d76', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '330cd455-c002-4416-8074-feb6c6b4849d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bc0c3692-931f-47cd-a978-6b047013867e', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '34bbf849-5720-4440-bf30-378dd9748533', 'd7dd1750-2c6a-48b1-bfa7-ad708c3df73a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('71496d88-e1c8-4873-af0c-2844c46002e0', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '34bbf849-5720-4440-bf30-378dd9748533', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a2a50664-25d9-46ab-837d-becb88e61928', NULL, '34bbf849-5720-4440-bf30-378dd9748533', '3706fd53-e952-408a-aedd-93ec6d5129be', '34bbf849-5720-4440-bf30-378dd9748533', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d029e4df-1abc-450f-992c-f533359f5e8e', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '4d252783-00e1-4fec-a661-ec1154d98a2c', '20af1fdc-7bf2-4f7c-941d-5294057a2148', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7db91226-ca55-49e2-9092-61070d586bc7', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '34bbf849-5720-4440-bf30-378dd9748533', '4d252783-00e1-4fec-a661-ec1154d98a2c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('482c8a90-0346-46dc-967e-bf83a0073a4e', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '4d252783-00e1-4fec-a661-ec1154d98a2c', '830e7013-1330-4974-925e-20e142b148fb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8af3c1cf-a2be-4bef-855f-795538afc814', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '85b69ad4-c6cb-4ef4-8d96-94abd80c9352', 'd0bcff97-900b-4660-9245-993dee9485eb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('41ab30df-d7a0-45d4-9c5c-2ddbc5175fa8', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, 'fdcffa04-a455-4869-ab8f-2f2fa05e4b02', '85b69ad4-c6cb-4ef4-8d96-94abd80c9352', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dd0ab251-a266-4d40-8d7a-c313d6b3f980', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '830e7013-1330-4974-925e-20e142b148fb', '85b69ad4-c6cb-4ef4-8d96-94abd80c9352', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c373196d-e4d9-4972-8993-cb5c1167ec97', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '85b69ad4-c6cb-4ef4-8d96-94abd80c9352', '67b756a8-aff9-439d-8ac8-b8965b63ac32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('51279ced-5bad-4531-86c3-c589a640dd86', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '85b69ad4-c6cb-4ef4-8d96-94abd80c9352', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2b72c665-ba86-405a-8ab6-e9afd3404b9b', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '85b69ad4-c6cb-4ef4-8d96-94abd80c9352', '814e38c8-c053-4c27-9487-997cf318a550', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d822aedb-9ebd-4813-b0f2-f21ba2abfef6', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, '5f936257-6096-4792-a496-b92e46d93d0a', '830e7013-1330-4974-925e-20e142b148fb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c65c112f-6b3e-49e4-adac-342db3aaec5e', '4dbf555d-3375-442e-a87d-815d1492af55', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '34bbf849-5720-4440-bf30-378dd9748533', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e3a970d4-3ece-4205-8b85-e5e409b25f1f', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, '1d4bc5a7-76c0-49a2-93dd-22e0554d886f', '36e09c9c-05d3-46fd-ba19-91e3dbb1ded0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('010c767c-b0b7-4368-974d-e840e9af432e', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '1d4bc5a7-76c0-49a2-93dd-22e0554d886f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('68f695bb-bd44-4a4a-8c4c-b2ee85778c8b', NULL, '1d4bc5a7-76c0-49a2-93dd-22e0554d886f', '3706fd53-e952-408a-aedd-93ec6d5129be', '1d4bc5a7-76c0-49a2-93dd-22e0554d886f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('19026f01-4f3d-4272-9bf5-1f3aa61ee0d1', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, 'aab86d81-273f-48e2-91ec-8379a4097dea', 'ae3d0091-aa98-44a3-adbb-2552b6179e97', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f429870b-65ce-4de9-949e-cef531e9b9e6', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, '1d4bc5a7-76c0-49a2-93dd-22e0554d886f', 'aab86d81-273f-48e2-91ec-8379a4097dea', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('25adbcc6-4ec3-4740-8bc4-95a703509008', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, 'aab86d81-273f-48e2-91ec-8379a4097dea', 'e16ceaa4-25a8-449a-9d9c-59a87fdc228a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('04c69432-1659-4037-99db-a715d90d4a31', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, '5885b073-ed04-4ac7-9f4b-664507df0de1', '7ac91a3d-9409-471f-b6f6-8f50ea03a292', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('930a02fa-7b02-489e-a327-6b748881ab5b', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, 'fdcffa04-a455-4869-ab8f-2f2fa05e4b02', '5885b073-ed04-4ac7-9f4b-664507df0de1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1337009b-a5a6-46a4-8fa1-04094d858e72', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, 'e16ceaa4-25a8-449a-9d9c-59a87fdc228a', '5885b073-ed04-4ac7-9f4b-664507df0de1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0ceaf7d3-822e-497e-a790-7a876018d747', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, '5885b073-ed04-4ac7-9f4b-664507df0de1', '67b756a8-aff9-439d-8ac8-b8965b63ac32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e465d748-4151-4c5a-9786-7a2abac4a32f', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, '5885b073-ed04-4ac7-9f4b-664507df0de1', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('28f51aaa-a34d-472c-b28b-a67e469b585d', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, '5885b073-ed04-4ac7-9f4b-664507df0de1', '814e38c8-c053-4c27-9487-997cf318a550', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bd90ce06-c899-4c68-8bea-367c8d5d20be', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, '5f936257-6096-4792-a496-b92e46d93d0a', 'e16ceaa4-25a8-449a-9d9c-59a87fdc228a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('64abbebf-3e7a-49f7-95d4-b8eb8cb2d9a6', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '1d4bc5a7-76c0-49a2-93dd-22e0554d886f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e37467aa-eee1-4f42-aac8-fa3219b8c712', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, '1a2692a7-05c3-433a-990c-54a184a91661', 'b0a82131-7ecd-4685-be5a-89dd1c4cc7de', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('774d40b1-0544-4e8f-a6d9-feeae437ec88', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '1a2692a7-05c3-433a-990c-54a184a91661', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0f85a127-53ac-4858-841e-bdbb56283a00', NULL, '1a2692a7-05c3-433a-990c-54a184a91661', '3706fd53-e952-408a-aedd-93ec6d5129be', '1a2692a7-05c3-433a-990c-54a184a91661', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a119e799-70dd-4717-a1bd-a35f90d15523', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, 'b27f42df-1a56-4626-a3cf-1eb46e7e8770', '0897f76b-9b66-45ae-a884-5c7edd121433', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8535405b-0693-40f0-b2b8-8c088e2aa0be', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, '1a2692a7-05c3-433a-990c-54a184a91661', 'b27f42df-1a56-4626-a3cf-1eb46e7e8770', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bc5cd623-3012-46ed-bcfc-48022264d99e', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, 'b27f42df-1a56-4626-a3cf-1eb46e7e8770', 'aa81a9b0-86ef-4ebe-98d3-54359961608d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('25c8818e-bb35-48a0-b4ac-3c6f1bd40298', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, '51727d0c-b455-4171-9bc3-23ff5c73ed81', '4d79f2a1-1130-4416-8c72-b6cc85740644', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a864b583-edb7-464f-921f-c56ca092edad', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, 'fdcffa04-a455-4869-ab8f-2f2fa05e4b02', '51727d0c-b455-4171-9bc3-23ff5c73ed81', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b03eb30c-1c1d-480e-b772-619994aec55e', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, 'aa81a9b0-86ef-4ebe-98d3-54359961608d', '51727d0c-b455-4171-9bc3-23ff5c73ed81', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d8ac1b4c-0a68-49b7-bc54-4efa3f22acca', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, '51727d0c-b455-4171-9bc3-23ff5c73ed81', '67b756a8-aff9-439d-8ac8-b8965b63ac32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f21beb4a-baab-4547-977a-7f91103b548b', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, '51727d0c-b455-4171-9bc3-23ff5c73ed81', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fa89309d-7016-4782-8076-26c126b8fe5f', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, '51727d0c-b455-4171-9bc3-23ff5c73ed81', '814e38c8-c053-4c27-9487-997cf318a550', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0d1b286c-9f93-45a5-9ccf-6d2ce623c427', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, '5f936257-6096-4792-a496-b92e46d93d0a', 'aa81a9b0-86ef-4ebe-98d3-54359961608d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3580f37b-438d-415e-9c63-c10f78c769e6', 'e74992df-66a8-4572-9e55-ec7b210f04e0', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '1a2692a7-05c3-433a-990c-54a184a91661', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8fb85ae7-6857-4fde-a081-155245d8eab1', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, 'e062ff79-b8a3-4f75-8e9f-ae3b31f92022', '44a911af-8a2f-431f-9e1e-004746901334', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a2c9543c-270a-4401-a46d-63c780af7d7b', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'e062ff79-b8a3-4f75-8e9f-ae3b31f92022', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('060a3faf-27c1-420c-bae4-5f8eff13d866', NULL, 'e062ff79-b8a3-4f75-8e9f-ae3b31f92022', '3706fd53-e952-408a-aedd-93ec6d5129be', 'e062ff79-b8a3-4f75-8e9f-ae3b31f92022', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('49cc28f1-0933-4f2d-a7b0-ee521012359f', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, 'af3322a3-54cc-4315-b815-607a8c362d2e', 'c885871c-5f3b-4a02-a550-f962132d898b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e7f93905-e0a2-495f-ab86-a028e30f82fd', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, 'e062ff79-b8a3-4f75-8e9f-ae3b31f92022', 'af3322a3-54cc-4315-b815-607a8c362d2e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b21d98df-7db5-4df5-b481-393062d2133f', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, 'af3322a3-54cc-4315-b815-607a8c362d2e', 'dc730495-43f8-42be-af37-a084da0f568e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('59ac54a3-5532-4652-a621-4ef9c6c7490a', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, '8ea7ce48-b945-4053-8255-be69b2aa688d', 'cfdfa9ee-7570-4a4f-bad4-0e18fdff5004', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d279712e-e2a3-495c-aeb0-e881ff3db933', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, 'fdcffa04-a455-4869-ab8f-2f2fa05e4b02', '8ea7ce48-b945-4053-8255-be69b2aa688d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9c2723b2-c46c-4eff-ba9c-ea0773327d33', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, 'dc730495-43f8-42be-af37-a084da0f568e', '8ea7ce48-b945-4053-8255-be69b2aa688d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cad13977-cb2d-427c-a558-7755afa1ac4b', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, '8ea7ce48-b945-4053-8255-be69b2aa688d', '67b756a8-aff9-439d-8ac8-b8965b63ac32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('54cc9e09-e776-4fbd-9e4a-3f9393b8dff4', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, '8ea7ce48-b945-4053-8255-be69b2aa688d', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('764751d6-792b-46c2-8df1-b55e317852c2', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, '8ea7ce48-b945-4053-8255-be69b2aa688d', '814e38c8-c053-4c27-9487-997cf318a550', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0b9fd4d4-d98a-45b0-8901-b03a9865b31a', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, '5f936257-6096-4792-a496-b92e46d93d0a', 'dc730495-43f8-42be-af37-a084da0f568e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a6954b44-80a1-4de4-993c-be0c0aace38a', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', 'e062ff79-b8a3-4f75-8e9f-ae3b31f92022', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('243f16ba-3250-4bba-ae2b-95ceaf3fa138', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '3df1d2db-6ed7-4d0a-ae22-6e90140ca432', 'f7eab9a0-7f14-487c-9434-669dca849b40', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1122e7d5-c3e4-4212-aef9-15f1b147fe30', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '3df1d2db-6ed7-4d0a-ae22-6e90140ca432', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('71b37f6f-05ba-43d4-9d42-cc421d9fca97', NULL, '3df1d2db-6ed7-4d0a-ae22-6e90140ca432', '3706fd53-e952-408a-aedd-93ec6d5129be', '3df1d2db-6ed7-4d0a-ae22-6e90140ca432', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0e431e76-37ba-4074-b377-106fb435cd6a', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '656d1c2d-2ad1-42df-9774-62e931e3bb0e', '819393f7-e96d-499b-8663-3adaaf1b0a73', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('53dbd2dc-766f-4223-a777-e4b44a598be5', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '3df1d2db-6ed7-4d0a-ae22-6e90140ca432', '656d1c2d-2ad1-42df-9774-62e931e3bb0e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0977ed6c-1fb6-48f0-b7c7-b4807c5bb672', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '656d1c2d-2ad1-42df-9774-62e931e3bb0e', '7c142ae8-d190-4c1f-aa85-24f12eeefc9f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c36ef648-581e-40b6-9f92-30be50403890', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '3abf8555-9c07-447d-af5b-47bacb517ad5', 'f3d00781-37e2-4b9a-8107-bdc123df38d7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ef219bf7-5838-4fe9-8a6c-74d76637e6e5', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '60297e5d-2f7d-4734-9a25-f2639ffb7fb4', '3abf8555-9c07-447d-af5b-47bacb517ad5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f60bb8d7-0347-4230-9b72-80808087df82', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '7c142ae8-d190-4c1f-aa85-24f12eeefc9f', '3abf8555-9c07-447d-af5b-47bacb517ad5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2472c680-5e4d-4a27-bd39-0dfb5198f2d3', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '3abf8555-9c07-447d-af5b-47bacb517ad5', '7454ce37-a2ba-4f52-a5da-2190203ca089', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2efb9a32-db0b-4d3e-8488-71a6ba91d792', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '3abf8555-9c07-447d-af5b-47bacb517ad5', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8e95ae46-bb81-4895-97b3-90c50307a381', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, '3abf8555-9c07-447d-af5b-47bacb517ad5', '779e4c3b-97f0-4218-8eab-5575a6afa54a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('79603765-e912-4ce3-9f88-70645bafa009', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, 'de10229b-be9d-45dc-b1bf-8f832ebffe68', '7c142ae8-d190-4c1f-aa85-24f12eeefc9f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('eda5060e-6818-415e-afaf-49ad637375b1', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '3df1d2db-6ed7-4d0a-ae22-6e90140ca432', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b60442b9-5c5f-4d82-bf66-8eb20ca9b708', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '89218636-1f65-41ed-b729-d5967f17d33e', 'cbff4b85-4722-4e87-8adb-34923d9987c0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e142a048-63a4-4c13-bffa-8cad6d6f9f68', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '89218636-1f65-41ed-b729-d5967f17d33e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d47adf1c-911c-4340-96a3-69e98005dfe1', NULL, '89218636-1f65-41ed-b729-d5967f17d33e', '3706fd53-e952-408a-aedd-93ec6d5129be', '89218636-1f65-41ed-b729-d5967f17d33e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('badcbce7-e648-4f6f-900a-796cee8ef977', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '52ae0923-db99-48e9-95b5-d6884b6d4642', '6f009e98-a9a4-4d93-92e2-e955d04bb7e4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cbdc254f-7d1b-4836-80a0-7e4bca791478', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '89218636-1f65-41ed-b729-d5967f17d33e', '52ae0923-db99-48e9-95b5-d6884b6d4642', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c38c5ce9-bed2-465a-9d34-71a63868e2f7', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '52ae0923-db99-48e9-95b5-d6884b6d4642', '58769cf3-490e-4d20-8255-3e0854d8384b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7bd30426-477a-42ae-9fea-53e31754a3a5', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '212a3a64-9d05-44ae-a394-e335cb98cdf7', '21a21577-f8e6-4856-8c80-996000f525c9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('66bd8d3a-ecd2-4db1-a54c-d614df92bc66', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '60297e5d-2f7d-4734-9a25-f2639ffb7fb4', '212a3a64-9d05-44ae-a394-e335cb98cdf7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b69b4a82-d843-4121-b4a6-22b5223d4832', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '58769cf3-490e-4d20-8255-3e0854d8384b', '212a3a64-9d05-44ae-a394-e335cb98cdf7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7a4ad26e-9bdd-4202-bf55-d3a23dd92889', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '212a3a64-9d05-44ae-a394-e335cb98cdf7', '7454ce37-a2ba-4f52-a5da-2190203ca089', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('de10b491-4a7f-411f-976b-c1a71d76e4aa', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '212a3a64-9d05-44ae-a394-e335cb98cdf7', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('443baeb4-d1b5-4ff8-9f6e-80630b9064f3', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, '212a3a64-9d05-44ae-a394-e335cb98cdf7', '779e4c3b-97f0-4218-8eab-5575a6afa54a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ae35d44c-8134-4128-a4cb-ebf18b227ced', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, 'de10229b-be9d-45dc-b1bf-8f832ebffe68', '58769cf3-490e-4d20-8255-3e0854d8384b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('21b13641-89e2-4a8f-9d9a-2e6f3cbafe35', '047364a5-9dcb-4027-a94c-e35f4646860e', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', '89218636-1f65-41ed-b729-d5967f17d33e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('327d53e3-9645-413b-a8b9-1abf80ef6caf', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f', '160977ed-ef11-43d8-9ff7-af86c743d2ab', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('eda23614-3b16-4346-b096-0db44dd02912', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('de5b93fc-d1c5-4d4e-be69-e0187b58b96f', NULL, 'cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f', '3706fd53-e952-408a-aedd-93ec6d5129be', 'cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e0f9ae70-cf38-40c4-bb77-8a65344f1d24', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, '9a4fdac1-5925-464e-848b-1532c780ebdf', 'd94fd859-6e03-44a1-ac1d-059ed72e23d3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('85eda66a-0840-4cba-8b1b-0ec996e7ea1a', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f', '9a4fdac1-5925-464e-848b-1532c780ebdf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2e20ecf3-6dfc-4e0a-8587-a2f9f76949a1', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, '9a4fdac1-5925-464e-848b-1532c780ebdf', 'e108043f-3dcd-498c-9560-cde4ed35680e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c944cfbc-96e9-4936-acc1-fd156480f511', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'ac5044f1-1f16-43fa-afe2-24d80506ae5b', 'ebb468b1-047a-492c-a76c-5031645e7824', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('62f3ce10-f42c-4106-a6ea-40aa0e018eed', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'da9600c2-7dcc-4a7d-87f1-33f4a441e807', 'ac5044f1-1f16-43fa-afe2-24d80506ae5b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4fe21ec9-c4cd-462d-8754-e16bbf8a180a', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'e108043f-3dcd-498c-9560-cde4ed35680e', 'ac5044f1-1f16-43fa-afe2-24d80506ae5b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fa4aad7d-a9e0-40a4-9075-10e1bab8f777', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'ac5044f1-1f16-43fa-afe2-24d80506ae5b', 'f1afc7a2-588d-4b7e-9975-7b0eda21f846', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4200700a-6aa6-4949-80e8-a2ccbe1de26e', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'ac5044f1-1f16-43fa-afe2-24d80506ae5b', '95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('407d18e1-5185-41fd-9073-afe3b884826c', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'ac5044f1-1f16-43fa-afe2-24d80506ae5b', '779e4c3b-97f0-4218-8eab-5575a6afa54a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3b1cf5ad-8b58-4229-a6db-e9927917d0dc', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'de10229b-be9d-45dc-b1bf-8f832ebffe68', 'e108043f-3dcd-498c-9560-cde4ed35680e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d84e7cc1-e0f0-47ba-a815-56e1817601ab', '08e80808-fb86-4503-ab9b-9652af82d5b5', NULL, 'e03da822-f071-4c66-890f-f93a458aec28', 'cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('45db4d06-7181-409f-89d2-fb2135f4eac0', '91b63591-b1e2-4c65-8ad2-c607be4c1238', NULL, '1b453f97-a12c-4d51-bf95-2e782b425385', 'a2effc4a-acdc-4660-973d-e5313a9df528', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6dbff4f0-9c28-498d-918b-cee99b6d3aa4', '91b63591-b1e2-4c65-8ad2-c607be4c1238', NULL, '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', '42491f82-8223-4dbf-8660-688e35fc5694', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d589ebc2-533a-442d-959d-ccaddaad53b3', '91b63591-b1e2-4c65-8ad2-c607be4c1238', NULL, '3b195996-371c-41e4-9b66-a50553582e17', 'aaaf21f7-baff-4867-b84f-36a16f0fcbf1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3900e6fa-5de9-4c36-a9e6-a17103f97901', '91b63591-b1e2-4c65-8ad2-c607be4c1238', NULL, '1b453f97-a12c-4d51-bf95-2e782b425385', '66b246c1-b389-40b7-b238-48903a3dae95', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c21da043-c691-4c28-a26d-4db1c008d239', '91b63591-b1e2-4c65-8ad2-c607be4c1238', NULL, '7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', 'ddcec555-0f99-4cec-9d45-b0ddd4e7fb26', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c5d88362-dfd3-4039-b867-4a7466a8b34a', '91b63591-b1e2-4c65-8ad2-c607be4c1238', NULL, '7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', '76d3e38c-0889-4169-814d-5f7e36c0c767', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('23fe6f7c-4bd4-4450-9cd0-5e2f26b0f3e4', 'db7f287e-dfd7-4627-88e3-407cac226472', NULL, '7db53bc9-99f3-478e-abb0-437dcbd32051', '4d9e1a7c-84fa-43c7-a1d7-e898b20df129', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('be124201-7708-49e7-9cbe-6e129694e33a', 'db7f287e-dfd7-4627-88e3-407cac226472', NULL, 'e37e21bc-4d4f-4d41-8c24-399be1680a15', '8c236a58-3fab-421e-b8a3-6c9df1269fed', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dd3c3ef8-59bd-4633-9555-cdf9c6440489', 'db7f287e-dfd7-4627-88e3-407cac226472', NULL, '9771d06d-8352-404c-aaba-743800e621e9', 'a4b5890e-c3d9-4eda-8a8c-3ebc20a39061', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('12748785-e835-4f51-ac95-ee436ca09f2c', 'db7f287e-dfd7-4627-88e3-407cac226472', NULL, '7db53bc9-99f3-478e-abb0-437dcbd32051', 'f35bc896-c93b-42ca-994d-4f5f4e2e5b5f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4f4cb4de-0905-4b8a-86d0-a4066d2b5d01', 'db7f287e-dfd7-4627-88e3-407cac226472', NULL, 'b34392da-5070-40dd-ab44-d411a9742f6d', 'a5aac82c-b1b9-43d0-90bc-e7c0e0341e1c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('72c6fe2f-604a-4512-aada-2d1e36242727', 'db7f287e-dfd7-4627-88e3-407cac226472', NULL, 'b34392da-5070-40dd-ab44-d411a9742f6d', '6372e9ae-f522-468e-95b5-06a527854b0f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c962f39e-7dd6-4cf9-a532-952952bdbd58', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', NULL, '0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', '35f61da7-bd75-4482-ad05-d50ba7e099ca', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c137a79c-b6ab-45fe-863b-992198c9d355', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', NULL, 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', '3c22ad48-dc16-4af3-8bbb-54ce2b7d91d1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('40fa767a-79ed-4981-996f-f6a0bcb00df4', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', NULL, 'cb295fdb-e294-4b05-944e-f0a4929ebeeb', 'd5009976-c8c8-4d64-b39e-08f019999ae9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('06e50120-1cfd-43d9-9f05-d69054dab845', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', NULL, '0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', '9f2f2eae-80dc-49c7-810a-69b10fcc3421', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('07ec525f-703b-4d10-a693-4ef61afe606a', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', NULL, 'f3af3c81-a512-47ea-8b47-0386291e6590', '42557861-103c-4fb7-b3c6-0acd3d7737c2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8ef3b8c5-8286-42fe-bf20-011d1f5931e4', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', NULL, 'f3af3c81-a512-47ea-8b47-0386291e6590', '85dbc28b-c5c3-4914-b645-a36056f4cf17', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('14c82607-a49e-45fa-aa03-92c48062069c', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', NULL, 'b26cca89-03f0-4498-bf64-7385c0b7244a', '45cfb9f8-8e5e-438d-90f7-6b1ee872c003', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d276fd29-2bdd-4567-9276-5996c2c75389', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', NULL, 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', 'ac1f7518-f255-47bd-bf31-29d3cd2bb57a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b1bd4e7c-e01c-406a-b272-bf5a51e749d4', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', NULL, '76968391-174d-4530-b310-1244c4b1897a', 'b45ba485-ee82-447e-8a4d-42679a233455', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e0e072c2-8f36-4c5c-9948-0e8ce20b00e6', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', NULL, 'b26cca89-03f0-4498-bf64-7385c0b7244a', 'ac9bd6e7-e7b5-4f25-a873-79ff3436fa66', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('465d0cea-7e8b-47b3-9a57-93a283ae5582', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', NULL, '863eea7c-8b49-494a-9654-9963f2dbb4e5', '52d12930-5ca0-4344-bf72-32faf8dc5d9c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6821e41f-9460-485c-9b29-7017ab5668df', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', NULL, '863eea7c-8b49-494a-9654-9963f2dbb4e5', 'ba038cc8-3ca3-4c25-9805-08eef60945b5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8d1d4277-038f-4ee0-a7a7-e2eda624508a', '58ca016b-15ea-41e3-80ba-2603bf736619', NULL, '7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', 'b5be48c3-0721-406c-bf86-b7dc1d6a7016', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3d74caa2-f602-4234-aeac-cfeb0c8b2695', '58ca016b-15ea-41e3-80ba-2603bf736619', NULL, '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', 'ba8ff028-06d6-4536-8e79-6c46f8e4b9a2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('772c9fde-aea0-425e-aa68-9c2141974334', '58ca016b-15ea-41e3-80ba-2603bf736619', NULL, 'f101cc07-ed84-4e34-9f70-62ec6a646e81', '470fa9af-f292-4516-be71-346b1e987d83', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3a9cff2c-733b-41a8-a37c-d1853a3d5913', '58ca016b-15ea-41e3-80ba-2603bf736619', NULL, '7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', 'e62715a8-2e69-4a59-806e-000886fedd92', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('500200b0-6973-4ae5-85cd-7386c6f9465b', '58ca016b-15ea-41e3-80ba-2603bf736619', NULL, '1d4c6f1f-200f-4a68-ae7b-6fda13687e41', '0f8fd73f-526c-4e76-a5f1-043e44386cc3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2548a412-57f7-41fa-9d02-1790339303be', '58ca016b-15ea-41e3-80ba-2603bf736619', NULL, '1d4c6f1f-200f-4a68-ae7b-6fda13687e41', '0e0eb247-f0a2-435b-b44c-34ffc5ecfda6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b3544903-2ae4-4b16-84f7-01adc31301f8', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', NULL, '5242e0b6-12e3-4a59-bf06-de114cb69ff4', '1aa9a0f2-47a7-498d-b0e8-9e73ef9f5b00', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('889edabb-a1de-44f3-8051-788e2e6b61c2', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', NULL, 'c85e8116-355e-408a-93fa-c699da2a76f3', '57130e2a-328a-4402-bd54-a76cb815503c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('96ae4fa2-366d-42fd-b690-f0c1e50d547a', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', NULL, 'b8350678-d30a-422a-bb5d-79c65af2f890', '0baaa10d-4abf-42df-9689-d6d72a9cc418', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('91d8e718-9d56-47f8-8aaa-66db5bf22f91', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', NULL, '5242e0b6-12e3-4a59-bf06-de114cb69ff4', '7c958983-efb4-4117-a2a6-4a3d35c233b5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('68f4fe6b-261d-448c-bce0-adff94a81deb', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', NULL, '0f833f5a-8afb-4934-a8a6-9dadbdcf89dd', 'c9732223-5e57-4d36-b412-91122ecb900f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('95012cd0-a5ed-4671-a445-782b25924c4c', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', NULL, '0f833f5a-8afb-4934-a8a6-9dadbdcf89dd', 'a1476e12-e8fd-4bdc-a1a1-68177652431d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e17b347d-7ad8-422a-9418-1c55851e6e63', '25b8066a-59fd-4733-90f2-8ea80c826fff', NULL, '0726dd6c-118e-4cbc-9077-d4dcb0e61643', 'b12dcf3d-9b06-4d32-938c-209adc18ce37', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0b5748b-2977-41d8-b60c-4cd0cdf6227e', '25b8066a-59fd-4733-90f2-8ea80c826fff', NULL, 'd04aeefe-4ba4-466f-a563-b811674c6de9', 'daeaae1b-5d88-45a8-8697-cd2e22e519a4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('15aaed6e-7f22-4d6e-b2b3-30466982b87b', '25b8066a-59fd-4733-90f2-8ea80c826fff', NULL, '8dfb5e53-1554-4e5c-a045-85121ce4bd71', 'fd07e597-fc5d-4c64-b491-76a5420aec78', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('66111571-a50d-45ce-894e-8c9fa6fc3ae8', '25b8066a-59fd-4733-90f2-8ea80c826fff', NULL, '0726dd6c-118e-4cbc-9077-d4dcb0e61643', 'ecde7ac8-3b81-4864-8b26-2e07cdc49190', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('87d42752-e7b0-44e5-837e-0b58675d5d57', '25b8066a-59fd-4733-90f2-8ea80c826fff', NULL, '13a3ca39-6352-48e1-b1fb-82f3fc5558f2', 'fc871f18-a6a5-4cb7-9f23-fee703a845c4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aa201d37-3a49-454e-a630-16cfa631aa89', '25b8066a-59fd-4733-90f2-8ea80c826fff', NULL, '13a3ca39-6352-48e1-b1fb-82f3fc5558f2', '1e643070-dafa-46db-8294-fecd8249232e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e25cf8b4-6034-4849-854b-d94e4dd4a2fc', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', NULL, '256083e7-90ac-4f38-9bc1-deedb0f78d2c', '08c5e34a-9a18-445b-9fbb-85a3ff34927b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d0f7b382-1feb-40be-9537-b27801c05498', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', NULL, '33a45f49-ac74-4444-a193-2ed1e0be110d', '71520b2b-f697-4135-a748-8ba36939915d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a340ffd7-89fd-462a-9c8d-53e6446f6b4b', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', NULL, '28bf24da-eb68-4a99-8ff9-6e4145f5e805', 'ffbddcbf-8922-4b3f-9248-47b86638a1b6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ec59d5b3-2b86-4122-a4b4-602b1a0cabbd', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', NULL, '256083e7-90ac-4f38-9bc1-deedb0f78d2c', '07b70014-fbf6-480a-a128-6dadf6ea6c49', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('269cf1ee-af0c-4446-85c4-bead23beac87', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', NULL, 'f93693fa-7dc5-4513-8537-be9541d6e5dc', '193ceb34-df58-46b9-92e5-62ce50a367c9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('854cef44-9dd6-413c-99f1-34f4f09e727c', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', NULL, 'f93693fa-7dc5-4513-8537-be9541d6e5dc', 'c198dbfe-def4-43ff-ae55-8e0a58f068c7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fbcdbc8e-c599-43b4-85cc-4853a56dc0dd', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', NULL, '3b195996-371c-41e4-9b66-a50553582e17', '0f5c3f08-d249-404a-b740-d759fced2d09', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('67d27951-28c5-4bc7-932e-87ef90fa8d4e', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', NULL, '7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', '6c0656b5-472b-4859-af3a-b8f1c53231a5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('24044b00-dcd1-4b61-92bf-40dfded44629', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', NULL, '6c0656b5-472b-4859-af3a-b8f1c53231a5', '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e3cb6e12-2d16-416b-9121-73ba15fa74c1', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', NULL, '98d81696-7c71-4ffe-bfc2-1fea37613440', '5f37d6b1-5ec6-4c91-8f11-32f95dac7b9e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4b8e69b8-385c-4148-8487-927bad14fd5c', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', NULL, '8ad792c1-10e1-43fa-8d5a-a6f3810878a2', '68136a56-de73-425b-bc05-ab6fed1cdfd1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0d2aa1bd-9da9-4906-9e3f-46b26aab00ad', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', NULL, '0f5c3f08-d249-404a-b740-d759fced2d09', '43c48616-3e31-4bed-9727-f9e6d6447378', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5bf37920-28fd-4ed4-86ed-b43c3d049f68', '84d4763e-0133-4d81-946b-fb64d1a3fd26', NULL, '9771d06d-8352-404c-aaba-743800e621e9', 'ba80c834-f5a8-4243-98a6-9a3be63c4f47', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('de2295a1-4150-4761-8fd3-7e80e29c7ceb', '84d4763e-0133-4d81-946b-fb64d1a3fd26', NULL, 'b34392da-5070-40dd-ab44-d411a9742f6d', '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d38557f0-0b84-4ba4-bb4e-bb869d15e5e5', '84d4763e-0133-4d81-946b-fb64d1a3fd26', NULL, '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', 'e37e21bc-4d4f-4d41-8c24-399be1680a15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d23335f1-253d-4772-8afb-8bd754a70442', '84d4763e-0133-4d81-946b-fb64d1a3fd26', NULL, '0d96a253-347e-4903-9db9-b362335e4341', 'a6a56680-46da-47fa-b5a0-5012f91bb3d9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d786be06-bb72-43ce-9600-b77a9d8b6d74', '84d4763e-0133-4d81-946b-fb64d1a3fd26', NULL, '42f0c634-d86b-4129-822b-f103cd6e0755', 'ca68370e-d560-42ec-bb93-b14df8eacdd8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5c1c68dd-959c-418e-977b-f8e53b84d588', '84d4763e-0133-4d81-946b-fb64d1a3fd26', NULL, 'ba80c834-f5a8-4243-98a6-9a3be63c4f47', '48f6d390-367b-4e7c-ab30-c2e7009248a6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('633f0e7b-90cd-474c-a9ac-a97a1d91c075', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', NULL, 'cb295fdb-e294-4b05-944e-f0a4929ebeeb', '3010c421-5c96-4f0d-b214-c773e0915564', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bf2fdad1-c055-46da-aacb-656703ee3e86', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', NULL, 'f3af3c81-a512-47ea-8b47-0386291e6590', '270aac69-03bb-4429-b925-3019bd92cf32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dfbc7ea6-1400-47f9-8ebf-f7dee78aa28a', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', NULL, '270aac69-03bb-4429-b925-3019bd92cf32', 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3d37a820-124b-4c74-8445-09e712c1f403', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', NULL, 'dc8ae2b6-d20e-4592-8356-3547bcc58f80', 'cd8e900a-3f5f-4b54-abdd-72b79c3f3203', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8d29d43c-bbf5-425a-b6e5-1a145ace1c01', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', NULL, '7d632200-5506-4856-a3c0-d806b1ee708b', 'f47459e8-dfd5-41e2-8b4b-c7999197f56e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d70a1cb5-cf04-4190-9eea-dbd80c16c4d2', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', NULL, '3010c421-5c96-4f0d-b214-c773e0915564', 'cddce99f-aca2-44e6-aa84-b1fc98c35c8a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d163cdba-ab70-4256-ad3f-d971748540e6', '67c2d793-212f-4ce0-a750-b18224a93c73', NULL, '76968391-174d-4530-b310-1244c4b1897a', '8255ff29-5961-496b-9fda-c71078e47e51', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('98ee8921-16e1-434b-8887-aff3718c8f18', '67c2d793-212f-4ce0-a750-b18224a93c73', NULL, '863eea7c-8b49-494a-9654-9963f2dbb4e5', 'fe0228ea-649c-45a4-b729-181aba7f3294', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('58918d45-f28a-478a-a871-2afee40c3c79', '67c2d793-212f-4ce0-a750-b18224a93c73', NULL, 'fe0228ea-649c-45a4-b729-181aba7f3294', 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('874563ee-3587-4569-b418-9f080682f631', '67c2d793-212f-4ce0-a750-b18224a93c73', NULL, 'eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', '4386a60e-d5b7-4f36-bd53-1de1e52ea755', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a52465da-bde2-4c5f-96f8-ccfc3d97f1e1', '67c2d793-212f-4ce0-a750-b18224a93c73', NULL, 'f218c4d9-d10b-4445-b381-b73a71f5848c', 'e19225c5-a87b-464e-8c63-3f52a45b107f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b4e45383-d41c-44e1-a227-94b7e34b1cfe', '67c2d793-212f-4ce0-a750-b18224a93c73', NULL, '8255ff29-5961-496b-9fda-c71078e47e51', 'ab491da9-8661-485f-90f4-a85c7f3310f6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('db8ecbf3-1287-46b1-a205-d91a8305d8fc', '3692b171-10ef-4f20-97de-ed5fa562ca46', NULL, 'f101cc07-ed84-4e34-9f70-62ec6a646e81', '6ec65964-76d1-4e7d-aacc-6a18e4eadf67', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dab47748-a3c4-4eac-8c99-9213bb8d3541', '3692b171-10ef-4f20-97de-ed5fa562ca46', NULL, '1d4c6f1f-200f-4a68-ae7b-6fda13687e41', '7e71f107-6953-42c7-a560-dc9036094198', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('58820fb8-453c-4209-aaf0-9e7b125b0ce0', '3692b171-10ef-4f20-97de-ed5fa562ca46', NULL, '7e71f107-6953-42c7-a560-dc9036094198', '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e1cd2ca9-d31d-40f3-9ce3-94b08d9b4c38', '3692b171-10ef-4f20-97de-ed5fa562ca46', NULL, '3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', 'b0214c88-ae13-4faf-9870-01872398bbab', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('75781d3a-e6f0-4e6e-bcb1-91ac1f28de4b', '3692b171-10ef-4f20-97de-ed5fa562ca46', NULL, '51bb98dd-9201-40e4-b008-221337eeb471', '9398d762-ff69-44a0-a07f-2149bf07bb4f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d5b448f7-a22c-4470-8289-f451c32187a0', '3692b171-10ef-4f20-97de-ed5fa562ca46', NULL, '6ec65964-76d1-4e7d-aacc-6a18e4eadf67', 'eebe4432-38e2-44dc-85c6-995cbecd173b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5178fb97-8a32-41b3-831e-db6dd08a5bc2', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', NULL, 'b8350678-d30a-422a-bb5d-79c65af2f890', 'bb8fc553-9dbe-4ea5-a3ea-02d129841f68', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a77cc0db-2956-44a5-8824-78e2354c8428', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', NULL, '0f833f5a-8afb-4934-a8a6-9dadbdcf89dd', 'bbfb4fc6-80f7-4a82-aa82-3d787539ebeb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2d448cac-f8dc-423c-9a1e-a1c1c9c1f1d2', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', NULL, 'bbfb4fc6-80f7-4a82-aa82-3d787539ebeb', 'c85e8116-355e-408a-93fa-c699da2a76f3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('069de646-00f2-401b-8d34-976428e4f868', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', NULL, '3de42185-1e32-4936-b305-d990b85c45c2', 'f1838834-17f4-45ae-823d-cfd97b9ad7d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('634ae328-cc40-4bb1-9c5f-0aed06ed0a2c', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', NULL, '07aa8ca8-e06f-4335-9cb0-99e98d45b2c6', '94815866-8e0d-4177-9026-3fdad0866fc2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('631ea533-9bc0-4935-aad9-376cf672e370', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', NULL, 'bb8fc553-9dbe-4ea5-a3ea-02d129841f68', 'c9448020-2d88-456d-827c-0b24917a78c6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6dcce6d4-feb6-4a43-99af-2b85bea67e0d', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', NULL, '8dfb5e53-1554-4e5c-a045-85121ce4bd71', '834d7138-e338-4517-aacb-1c6319fa34d8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('118241f6-e1f6-42ad-9ba7-e0450e4f74d7', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', NULL, '13a3ca39-6352-48e1-b1fb-82f3fc5558f2', 'e6409531-6513-43a9-84a7-eff44b18285a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c787f3a6-d143-4fa1-99bf-6232351dc221', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', NULL, 'e6409531-6513-43a9-84a7-eff44b18285a', 'd04aeefe-4ba4-466f-a563-b811674c6de9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('192cdc24-cc97-4cef-a33d-ce6f0574e3fc', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', NULL, 'e5871fb2-3928-4139-9468-10f0f12d5e5f', '8b8b38a3-679a-4331-962c-c540eada4c22', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4e9d7489-d21e-4fed-aad7-035614acf3ed', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', NULL, 'd00a14ad-fe79-40fc-8f72-722fb5cd30bd', 'a59c2244-46ef-42ce-9a35-9efeb0a02068', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bda55f4c-43bb-443e-b853-b4716ae85897', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', NULL, '834d7138-e338-4517-aacb-1c6319fa34d8', '4556335e-4c02-4879-a850-cc792db27b5b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('15e635e4-4269-4feb-829c-120b0df1861c', 'ade3baa7-760f-488b-962d-7e365ad1402f', NULL, '28bf24da-eb68-4a99-8ff9-6e4145f5e805', 'bb40b3e2-f355-491e-a3cd-fb3ee258d4b8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('133dcb7b-48f7-4b23-a5db-b092084e0726', 'ade3baa7-760f-488b-962d-7e365ad1402f', NULL, 'f93693fa-7dc5-4513-8537-be9541d6e5dc', '6e7feeb7-4891-4ea3-96b6-00d883da37c5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1c7a832b-fafa-433d-bc00-8d082a9cf8de', 'ade3baa7-760f-488b-962d-7e365ad1402f', NULL, '6e7feeb7-4891-4ea3-96b6-00d883da37c5', '33a45f49-ac74-4444-a193-2ed1e0be110d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('33350472-45ed-4180-bc0c-4bdd58ebe062', 'ade3baa7-760f-488b-962d-7e365ad1402f', NULL, 'd5a60c82-347b-4ebb-b95f-afff297bf966', '88eaec32-bd9e-4fd9-973d-1aaa932c8115', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d240af3f-e83e-4cc5-8bcb-35fefcb4eb39', 'ade3baa7-760f-488b-962d-7e365ad1402f', NULL, '1ed7ff07-778c-4920-a550-563b27223228', '62c26e94-cc22-4558-9bee-8ec8e6d29b95', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('82cc5748-33be-4c93-807a-65645f980b3e', 'ade3baa7-760f-488b-962d-7e365ad1402f', NULL, 'bb40b3e2-f355-491e-a3cd-fb3ee258d4b8', 'a0c34da0-2ce5-4877-8172-1306a2599c87', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fe68c4df-a2af-4751-acb5-8bcac36abf8b', NULL, '5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c', '3706fd53-e952-408a-aedd-93ec6d5129be', '5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d52457c6-dd11-4e4f-b98c-fc4ef145f4b2', 'f97e9751-6e67-40fb-b840-b818dc69afcf', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '14e4dbf5-5fa3-4010-91e0-c56e71623ba9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f35e02ca-b71a-418e-b942-920580b39932', 'f97e9751-6e67-40fb-b840-b818dc69afcf', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '359f9b02-63f0-47eb-955b-52a344462735', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9e05c2de-12c7-4065-9ae5-02773dffc646', 'f97e9751-6e67-40fb-b840-b818dc69afcf', NULL, '5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c', '0eabdcfb-e308-4e52-8c7f-27643332c947', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a8db9091-2b28-4f65-931d-4111ebfcb13f', 'f97e9751-6e67-40fb-b840-b818dc69afcf', NULL, '3b195996-371c-41e4-9b66-a50553582e17', '0eabdcfb-e308-4e52-8c7f-27643332c947', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('811dde92-bb69-4530-9989-c78422f69805', 'f97e9751-6e67-40fb-b840-b818dc69afcf', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '05d18d2f-a5be-4b65-9e78-8fa91db4c68f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7bd909a9-e3a5-4f7d-87b6-54263713d4e7', 'f97e9751-6e67-40fb-b840-b818dc69afcf', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '345b8b7b-a948-446f-949a-2a903b460032', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fed61c45-c1e4-4f84-9194-de069d3b53da', 'f97e9751-6e67-40fb-b840-b818dc69afcf', NULL, '7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', '345b8b7b-a948-446f-949a-2a903b460032', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c3293bca-6879-4d1c-bf2d-d48595971608', 'f97e9751-6e67-40fb-b840-b818dc69afcf', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('949cf562-60aa-4323-b75e-580d318e6bca', NULL, NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', 'f049b588-1279-40e7-be2d-2e691e8a4090', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ed631e28-2c9a-4a4f-9540-c3b1af10d5dc', NULL, NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', 'a41ad44b-e566-492a-b2b7-9a1ed2bdd18b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f1585e8b-446a-460e-833e-1d9433ae70ad', NULL, '39bc569a-8594-4a3e-954f-3055b382af9a', '3706fd53-e952-408a-aedd-93ec6d5129be', '39bc569a-8594-4a3e-954f-3055b382af9a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('01a32603-f9bb-454b-baf0-d7c39ed5e584', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', '5879bb5b-1171-41e2-bff7-707e18fc0582', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0fa636e-9a00-40e1-8e5e-12c885f91cb7', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', 'a277424f-d7f0-4568-8cd9-5299a13d0f4e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6676bb28-ea3c-496f-8a74-ba255c27f47b', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', NULL, '39bc569a-8594-4a3e-954f-3055b382af9a', '6df50d79-b958-456a-ac84-a8786f0f18a7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a4e394f5-8eee-4cd7-ae31-ac8848eed47d', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', NULL, '9771d06d-8352-404c-aaba-743800e621e9', '6df50d79-b958-456a-ac84-a8786f0f18a7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c36a1b03-32bc-4c21-8b98-dfb6ea6d2de4', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', NULL, 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', '66c939e9-0515-4cb0-ab1a-8dcd9243c53f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0b37d7ad-4248-4de2-9d59-67364db91066', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('96b83c48-cd0d-416c-8e7d-0c4cc652afe5', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', NULL, 'b34392da-5070-40dd-ab44-d411a9742f6d', 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ce2c8b8a-09c3-40c5-ba23-0f632d49dfec', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', NULL, 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', 'e37e21bc-4d4f-4d41-8c24-399be1680a15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b53df30d-a8a0-4485-bbd6-c827ac428ee6', NULL, NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', 'ad1241d8-512f-4589-aed2-958e1fd6441b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ccf1a982-03c0-4069-a93f-48efe0edc4fd', NULL, NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', '39a2eb59-2ba9-486d-8146-0a9a4d85769b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5db7b9ab-85de-4337-9d4f-d8dfad2276c1', NULL, '539a38db-5f7d-4bbc-896d-616bd32f0f06', '3706fd53-e952-408a-aedd-93ec6d5129be', '539a38db-5f7d-4bbc-896d-616bd32f0f06', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('725794f0-c526-4854-b498-401caec8b1b5', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', NULL, '209720a4-ab91-4b78-9fc0-ad5780a97934', '17e8a223-4aa0-4e35-aca3-f381f9ce1328', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('702ad75d-7582-41db-ad5d-7df4a8ac6e4b', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', NULL, '209720a4-ab91-4b78-9fc0-ad5780a97934', 'a24d0918-c78b-44a2-8c90-965940f30b95', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('99a93554-7343-44de-987b-a35b06c8a8a6', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', NULL, '539a38db-5f7d-4bbc-896d-616bd32f0f06', '209720a4-ab91-4b78-9fc0-ad5780a97934', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('99de5054-1c52-481d-9536-d39795f0ce19', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', NULL, 'cb295fdb-e294-4b05-944e-f0a4929ebeeb', '209720a4-ab91-4b78-9fc0-ad5780a97934', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f7000b2a-f204-46a1-9689-d355cf929bb9', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', NULL, '34a3d0d7-b889-4d5a-80f9-a74d0b56f74a', '10971aec-daed-47b5-8514-f88f9ca1016c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('af8fadc7-e1f9-4d47-9581-5d8805d4f6d8', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', NULL, '209720a4-ab91-4b78-9fc0-ad5780a97934', '34a3d0d7-b889-4d5a-80f9-a74d0b56f74a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7a45f88b-2b3e-471f-9ded-45b3cf3520f9', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', NULL, 'f3af3c81-a512-47ea-8b47-0386291e6590', '34a3d0d7-b889-4d5a-80f9-a74d0b56f74a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('68707555-e302-4a1d-9bf1-f7f06686a8fd', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', NULL, '34a3d0d7-b889-4d5a-80f9-a74d0b56f74a', 'a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d6832b5b-41f8-40cb-99ca-7456ea3c9c20', NULL, NULL, '209720a4-ab91-4b78-9fc0-ad5780a97934', 'e0c2115c-f70e-4c77-87a7-d1f524f47df4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('022c8d18-6746-49bf-b153-1a10c788debd', NULL, NULL, '209720a4-ab91-4b78-9fc0-ad5780a97934', '6cfb3c88-43bd-41a3-9c01-29bbcb67752e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a74df0e5-a5a6-4e0e-8969-7058dc5ed655', NULL, '2bb03c85-0eba-4ef2-be45-7bd03fb60936', '3706fd53-e952-408a-aedd-93ec6d5129be', '2bb03c85-0eba-4ef2-be45-7bd03fb60936', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c9949370-fd5c-47b3-9697-82cdd744085d', 'af682fb0-f06d-4a2b-affb-40487a079a70', NULL, '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', '7e91e09c-a072-44b1-af1f-bc1e6430d371', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fd96b18b-eea4-4e2e-9035-0f23fd1e5a46', 'af682fb0-f06d-4a2b-affb-40487a079a70', NULL, '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', '4dc88a9e-38e7-426b-a598-f246cef849ed', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ad75c325-6003-4329-bb7f-8ab63e0aacf0', 'af682fb0-f06d-4a2b-affb-40487a079a70', NULL, '2bb03c85-0eba-4ef2-be45-7bd03fb60936', '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('21a9c4a3-8b53-49ab-a851-3d99572abcbd', 'af682fb0-f06d-4a2b-affb-40487a079a70', NULL, '76968391-174d-4530-b310-1244c4b1897a', '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3a01050f-832f-45d3-8fb4-05fae7151156', 'af682fb0-f06d-4a2b-affb-40487a079a70', NULL, '5fd54e69-2513-4413-95d6-dde58ed6d8ae', '7db8de4f-b7d3-4a3f-b2d7-4abf43a4235f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ef29ef0c-c3c2-47e6-b046-e86081456208', 'af682fb0-f06d-4a2b-affb-40487a079a70', NULL, '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', '5fd54e69-2513-4413-95d6-dde58ed6d8ae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('72d3e92d-21c2-4de7-86b8-42fd12445585', 'af682fb0-f06d-4a2b-affb-40487a079a70', NULL, '863eea7c-8b49-494a-9654-9963f2dbb4e5', '5fd54e69-2513-4413-95d6-dde58ed6d8ae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('46587926-e3fb-49a4-a5e8-2c980833071f', 'af682fb0-f06d-4a2b-affb-40487a079a70', NULL, '5fd54e69-2513-4413-95d6-dde58ed6d8ae', 'b67105de-0348-4d4c-8ccc-aab9ed905eb6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dcb7676b-137a-4769-9823-979963f60316', NULL, NULL, '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', '3333c620-ed65-4a4a-af0b-71106e0b5b30', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4ac63eeb-7776-4255-829b-cb5a29f9de16', NULL, NULL, '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', 'f8591833-ef9e-42fd-b91b-f66b56267b0a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5e9523d8-2ad4-4d64-b686-57576aa20f77', NULL, '0ee9e55c-9b0f-41fc-9bd5-981f124846d3', '3706fd53-e952-408a-aedd-93ec6d5129be', '0ee9e55c-9b0f-41fc-9bd5-981f124846d3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1766a9c6-2146-4c3e-a857-ea04e8f44164', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', NULL, 'bf27b482-99fb-43fe-8789-b926b9131a32', '51da6c66-df21-4619-bb68-2538c6ef2c31', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('956a5f3f-c580-4e65-aae5-43fd79a449b1', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', NULL, 'bf27b482-99fb-43fe-8789-b926b9131a32', 'a16e2346-b56a-4ea3-b07b-f5f494b2b42b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b2a2e5b9-cbc3-4a1c-b1e1-a562ab5d95d8', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', NULL, '0ee9e55c-9b0f-41fc-9bd5-981f124846d3', 'bf27b482-99fb-43fe-8789-b926b9131a32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3fd89676-3561-4958-a6c4-35ef51e64316', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', NULL, 'f101cc07-ed84-4e34-9f70-62ec6a646e81', 'bf27b482-99fb-43fe-8789-b926b9131a32', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('523208c9-177d-457e-873c-2ef5dcc79132', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', NULL, '1d24331c-d029-4539-8b40-2b891f6a75a9', '7514b6f6-f31f-4397-bb3d-eefe138ebb9d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('09a84d00-9a3e-462f-84b3-e957d0c8fd39', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', NULL, 'bf27b482-99fb-43fe-8789-b926b9131a32', '1d24331c-d029-4539-8b40-2b891f6a75a9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('509316eb-0cd6-4d50-a8ff-8e8ac1d98928', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', NULL, '1d4c6f1f-200f-4a68-ae7b-6fda13687e41', '1d24331c-d029-4539-8b40-2b891f6a75a9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f0a81e14-722d-4f40-b3dd-5ebc7b5b3df3', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', NULL, '1d24331c-d029-4539-8b40-2b891f6a75a9', '53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('20538e3b-737b-40f6-aa1b-b0ede047f65e', NULL, NULL, 'bf27b482-99fb-43fe-8789-b926b9131a32', '0b188bb5-5eaa-4c5b-9989-7ccccbc9f2c1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9ee673c2-196b-4f00-b226-4b5978063f56', NULL, NULL, 'bf27b482-99fb-43fe-8789-b926b9131a32', 'bf58a617-cb18-42a8-b34a-56b584e6daf1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ec90a9db-bff2-4777-8e96-b791e4c05729', NULL, '0860ac5c-ce03-4f7b-abcb-562676bca90d', '3706fd53-e952-408a-aedd-93ec6d5129be', '0860ac5c-ce03-4f7b-abcb-562676bca90d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('55a00373-09ec-4006-a3c0-3ec42352dca4', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', NULL, '173a65d3-7eb4-4910-a83f-08ce5ed65583', 'd3e00370-8788-4a7c-83d6-693a01ccac0f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('81e14d92-f7fe-4f0c-945e-5805f8e7e7a8', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', NULL, '173a65d3-7eb4-4910-a83f-08ce5ed65583', 'fd972637-8015-4a7a-9591-683814d6dc1c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c961c759-99a7-49e0-8bca-f2965cb44f2e', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', NULL, '0860ac5c-ce03-4f7b-abcb-562676bca90d', '173a65d3-7eb4-4910-a83f-08ce5ed65583', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5ea574bc-77f5-4161-9382-50c091378fc6', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', NULL, '8dfb5e53-1554-4e5c-a045-85121ce4bd71', '173a65d3-7eb4-4910-a83f-08ce5ed65583', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('df45901b-777d-4579-ad7d-4412d63a3b3b', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', NULL, '81aefd8d-c7aa-48a5-869f-1df15b4b68ae', 'c1f4725e-747e-4d03-8a86-b2f4fa4459ee', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c6c52b4b-949a-4d5f-a1e6-60f132463f2e', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', NULL, '173a65d3-7eb4-4910-a83f-08ce5ed65583', '81aefd8d-c7aa-48a5-869f-1df15b4b68ae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9c6410ef-986a-4475-93bb-19ed17429a79', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', NULL, '13a3ca39-6352-48e1-b1fb-82f3fc5558f2', '81aefd8d-c7aa-48a5-869f-1df15b4b68ae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1e9bd925-2f8e-4ce7-b2bd-50814738eff6', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', NULL, '81aefd8d-c7aa-48a5-869f-1df15b4b68ae', 'd04aeefe-4ba4-466f-a563-b811674c6de9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('164cba6b-2aa2-4ace-b9a5-9efdd016aa02', NULL, NULL, '173a65d3-7eb4-4910-a83f-08ce5ed65583', 'c57ee5ea-1e8e-4a28-bfed-0bd4477fcb06', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('23915a94-192d-4217-8cd4-fee7bd301f5d', NULL, NULL, '173a65d3-7eb4-4910-a83f-08ce5ed65583', 'e2c9d05c-4e79-48cf-8093-e8fa4b0a655e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('baecfc84-663c-40b8-972d-e84a89fd2dd4', NULL, '79cf3f87-a87d-40d8-a91a-cdd257866de7', '3706fd53-e952-408a-aedd-93ec6d5129be', '79cf3f87-a87d-40d8-a91a-cdd257866de7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9daa29f8-e2cc-47ed-bd9f-b382cccd8b99', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', NULL, 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', '408d2e43-8fa7-4c98-a0f8-4a52ebcce3bb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('70d57a02-1537-46d0-a900-51f461152cd1', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', NULL, 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', '48607eac-4413-48eb-9b01-bd264a9b607c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('beffc78a-2738-4b01-87a5-168e0acd253c', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', NULL, '79cf3f87-a87d-40d8-a91a-cdd257866de7', 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2d0557e4-0a48-443e-8a26-99cb0e411fa6', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', NULL, '28bf24da-eb68-4a99-8ff9-6e4145f5e805', 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('adecdbe8-eb20-4782-b977-0ee777193a68', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', NULL, '08c7995c-a7e7-4093-8aa0-6e6e8449f1e4', 'fc0b7f19-723c-46f3-b40c-a8973fb5cce6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4abce187-6e61-41b6-91c4-04d9f4f44323', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', NULL, 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', '08c7995c-a7e7-4093-8aa0-6e6e8449f1e4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2d6bab91-b2e2-4662-b802-72d42948d878', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', NULL, 'f93693fa-7dc5-4513-8537-be9541d6e5dc', '08c7995c-a7e7-4093-8aa0-6e6e8449f1e4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aa6f9a2d-c1c5-48d4-9fac-0ecabf17edf4', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', NULL, '08c7995c-a7e7-4093-8aa0-6e6e8449f1e4', '33a45f49-ac74-4444-a193-2ed1e0be110d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fd3f1211-bf61-49a3-9691-1bdd5c95d90d', NULL, NULL, 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', 'e131dff7-b974-4e12-8324-732296676146', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7f536e71-b099-442e-b004-698fe14198c9', NULL, NULL, 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', '99188a87-efa3-4365-9135-700c0899d0dc', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e6ac71d5-f63f-4d77-8379-9a7805e8d117', '9b403ef6-3fae-4698-9b21-2627c51fa254', NULL, '30ec4923-e756-46cf-ac20-79065a4f36bd', '59adeeef-e54c-4b26-8a36-f4dbe0b05273', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('466eb9f7-9139-4e30-a2bd-966888e498ea', '9b403ef6-3fae-4698-9b21-2627c51fa254', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '30ec4923-e756-46cf-ac20-79065a4f36bd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a968bc32-85be-46f4-9a88-228adbe2d5c1', NULL, '30ec4923-e756-46cf-ac20-79065a4f36bd', '3706fd53-e952-408a-aedd-93ec6d5129be', '30ec4923-e756-46cf-ac20-79065a4f36bd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0261acc-fdce-44a4-9c1a-f9500ee85839', '9b403ef6-3fae-4698-9b21-2627c51fa254', NULL, '0ae403ca-5143-44f0-b997-be330a72ee97', '01635d74-7e94-46e0-aba2-a1c8d471aaff', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c6cdea8d-a1f7-4136-8fd2-66d0aee4a994', '9b403ef6-3fae-4698-9b21-2627c51fa254', NULL, '30ec4923-e756-46cf-ac20-79065a4f36bd', '0ae403ca-5143-44f0-b997-be330a72ee97', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ed11e005-8563-4462-89aa-b090c3065c03', '9b403ef6-3fae-4698-9b21-2627c51fa254', NULL, 'aca34128-8a96-494d-a9e7-4e891208b023', '2f8771ba-3650-43d8-af99-ffc413066a42', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7b0f5c01-a564-4ccc-8bb3-d1716665bcca', '9b403ef6-3fae-4698-9b21-2627c51fa254', NULL, '0ae403ca-5143-44f0-b997-be330a72ee97', 'aca34128-8a96-494d-a9e7-4e891208b023', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('210d5d54-1715-49bf-9934-c44ee016281a', 'f9811182-d400-43e0-ba9e-de745c9e82a3', NULL, '2dbbeed2-ba1a-4781-85e4-28f1620f8f7c', '59e7f9e1-fa76-4f88-9ccd-da4eb105f0e2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d2ae3143-a8c1-4493-90b4-deb8ee7cc5bb', 'f9811182-d400-43e0-ba9e-de745c9e82a3', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '2dbbeed2-ba1a-4781-85e4-28f1620f8f7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('09ea6e4e-ab32-45b7-bd7d-b2e6691290f4', NULL, '2dbbeed2-ba1a-4781-85e4-28f1620f8f7c', '3706fd53-e952-408a-aedd-93ec6d5129be', '2dbbeed2-ba1a-4781-85e4-28f1620f8f7c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('69612d77-058f-44ae-b8e9-5657d6ab718f', 'f9811182-d400-43e0-ba9e-de745c9e82a3', NULL, '5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea', '0aa2520b-5481-4d8c-a478-964e4441d5e0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('09dc6fbc-fb45-473e-97af-1bc4e973b91d', 'f9811182-d400-43e0-ba9e-de745c9e82a3', NULL, '2dbbeed2-ba1a-4781-85e4-28f1620f8f7c', '5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fca5d327-f653-4649-b1dd-3deb5b55fc68', 'f9811182-d400-43e0-ba9e-de745c9e82a3', NULL, '89ac1223-5561-4835-8c9d-681ab874a47a', 'f5f51c10-010d-4d5b-bb8e-b2dc353ba051', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('29bd21b9-2cf9-49e6-94ec-17eefad89b94', 'f9811182-d400-43e0-ba9e-de745c9e82a3', NULL, '5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea', '89ac1223-5561-4835-8c9d-681ab874a47a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('79f35b59-eee1-4929-9cea-0bb600b9a157', '4924877c-c487-4e4d-8b14-901e9b6069ac', NULL, '9827f746-1f3a-4c83-ad01-b5cd89f4d5a6', 'd71a8b9b-b0da-4675-a6c5-45d2664c70f5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('20464d07-6b81-4746-85fb-3c4f4ed87bd2', '4924877c-c487-4e4d-8b14-901e9b6069ac', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '9827f746-1f3a-4c83-ad01-b5cd89f4d5a6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cbd6eb58-0ac6-41ea-98b9-82bf5d5b5428', NULL, '9827f746-1f3a-4c83-ad01-b5cd89f4d5a6', '3706fd53-e952-408a-aedd-93ec6d5129be', '9827f746-1f3a-4c83-ad01-b5cd89f4d5a6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7c3e19f3-5e89-4bbc-a577-ca82951fe335', '4924877c-c487-4e4d-8b14-901e9b6069ac', NULL, '03089301-5a05-4c2d-abf3-b95267b2edef', 'b32ebf6e-d5bb-4b03-9d03-10bcec3a6172', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1fdbeb95-1bb7-4fb5-b9d1-e417e1c38f37', '4924877c-c487-4e4d-8b14-901e9b6069ac', NULL, '9827f746-1f3a-4c83-ad01-b5cd89f4d5a6', '03089301-5a05-4c2d-abf3-b95267b2edef', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('385d12e6-e689-491a-b503-5b699e008380', '4924877c-c487-4e4d-8b14-901e9b6069ac', NULL, 'b204ae10-065f-4969-aedd-4c25602a821c', '5fdcc08b-295c-4853-957d-d171b1accd40', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('564ef107-8d59-4db0-a926-e22f65276242', '4924877c-c487-4e4d-8b14-901e9b6069ac', NULL, '03089301-5a05-4c2d-abf3-b95267b2edef', 'b204ae10-065f-4969-aedd-4c25602a821c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bc94d775-510c-42fa-b5b0-fe4afe51d2e1', '831a608f-fefe-425b-b740-1786f856c680', NULL, 'e7101997-a1b9-43bd-93a7-8b24fd506f05', 'dfb1ef2c-af28-40d5-b625-9f157f1323d4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5ed62729-d2a8-4e5f-a863-bc4df6a19b94', '831a608f-fefe-425b-b740-1786f856c680', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'e7101997-a1b9-43bd-93a7-8b24fd506f05', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('84b03919-d440-4956-9a4c-746b226836c2', NULL, 'e7101997-a1b9-43bd-93a7-8b24fd506f05', '3706fd53-e952-408a-aedd-93ec6d5129be', 'e7101997-a1b9-43bd-93a7-8b24fd506f05', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6ef83b69-925d-4f06-8e8f-4dea17c49543', '831a608f-fefe-425b-b740-1786f856c680', NULL, 'dceec9d4-d2a5-444e-a27b-4a16c01b155b', '2d5f609d-aac6-41b8-b7dc-ebb66f4b3833', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('268d211e-943a-4fe8-8f2f-cd150a8edc64', '831a608f-fefe-425b-b740-1786f856c680', NULL, 'e7101997-a1b9-43bd-93a7-8b24fd506f05', 'dceec9d4-d2a5-444e-a27b-4a16c01b155b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b69cb6a8-e8b1-40de-b6a2-ed8250be0dfc', '831a608f-fefe-425b-b740-1786f856c680', NULL, '3a07b077-aebc-48ad-ab29-6d375afab845', 'e4c728ed-535a-40cc-a460-3174b695f899', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('aff048df-13b6-4de7-beb6-20dce53d0f3b', '831a608f-fefe-425b-b740-1786f856c680', NULL, 'dceec9d4-d2a5-444e-a27b-4a16c01b155b', '3a07b077-aebc-48ad-ab29-6d375afab845', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e02f41ca-d599-4b1d-8dca-c73730eec80b', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', NULL, 'abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310', 'b491c0ef-e4c3-4692-94f3-bf13b2dfff8a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d79ad457-a8a4-4d4e-8c13-9f8bfabfa5e8', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7837d771-39f8-4519-9016-473396225565', NULL, 'abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310', '3706fd53-e952-408a-aedd-93ec6d5129be', 'abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('03f2d39d-2345-4e7e-875f-7316003d16b9', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', NULL, '2a9d3ef1-e293-4301-914b-0ed781b63689', 'fdad2cc6-4985-4407-ade1-857bd91c5518', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('df47ac59-c0d0-489b-b8ef-3089743d378b', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', NULL, 'abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310', '2a9d3ef1-e293-4301-914b-0ed781b63689', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e7e387cb-6b6d-48b0-a0ca-732d2c821b3a', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', NULL, 'e1ddefd3-730f-4085-8651-a24dc88b7330', '1bf68e49-2a97-4686-a8b9-8cdb46475326', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b7ff6ee8-21af-4fb7-8531-7f2102cdd928', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', NULL, '2a9d3ef1-e293-4301-914b-0ed781b63689', 'e1ddefd3-730f-4085-8651-a24dc88b7330', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b7f710e1-4fff-4a34-950c-6ae91da5653a', '0bae3550-be89-4c0e-9ba4-01bae0419be0', NULL, '0bb4851a-2274-44cd-85ff-fc4b4710f602', 'ccb79609-4c10-4c53-bd5b-3a128e7f7ebf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7c23a1c7-821d-4e7a-85e9-9e02a3618827', '0bae3550-be89-4c0e-9ba4-01bae0419be0', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0bb4851a-2274-44cd-85ff-fc4b4710f602', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5fd1ae74-8b0f-4ac0-a1e7-d503452dc79c', NULL, '0bb4851a-2274-44cd-85ff-fc4b4710f602', '3706fd53-e952-408a-aedd-93ec6d5129be', '0bb4851a-2274-44cd-85ff-fc4b4710f602', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fbec2137-bead-4315-b323-cfab02e185a5', '0bae3550-be89-4c0e-9ba4-01bae0419be0', NULL, 'fdfd2976-fc7d-422e-8b5f-91f401927b18', '4e5c24fc-e3d1-49f7-963c-e386a72be2f8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e1a6da3c-dfc3-484f-8185-938c414326cb', '0bae3550-be89-4c0e-9ba4-01bae0419be0', NULL, '0bb4851a-2274-44cd-85ff-fc4b4710f602', 'fdfd2976-fc7d-422e-8b5f-91f401927b18', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dc28beaf-2488-4ab3-995e-2174df1954cb', '0bae3550-be89-4c0e-9ba4-01bae0419be0', NULL, 'ffe77615-7fe9-4dd7-8a55-9459ff2d2b43', 'a8dc5128-f0db-4f0e-b599-a87eeb73603c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9cfb524c-ccf1-4171-8043-bf2116536699', '0bae3550-be89-4c0e-9ba4-01bae0419be0', NULL, 'fdfd2976-fc7d-422e-8b5f-91f401927b18', 'ffe77615-7fe9-4dd7-8a55-9459ff2d2b43', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5127038b-2074-42f5-a599-7cdce776b05d', 'f3140f7e-5045-4534-92aa-e918895bfafb', NULL, '93f3cd3e-9b10-4a7c-88a9-39c29118fa8d', '0fd249e7-1454-4914-957a-b3ec7bf25bee', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7b382b2e-1daa-4b6f-ad14-f765d768348e', 'f3140f7e-5045-4534-92aa-e918895bfafb', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '93f3cd3e-9b10-4a7c-88a9-39c29118fa8d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('46a43889-233e-4322-97a7-77fd9716980b', NULL, '93f3cd3e-9b10-4a7c-88a9-39c29118fa8d', '3706fd53-e952-408a-aedd-93ec6d5129be', '93f3cd3e-9b10-4a7c-88a9-39c29118fa8d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bd7e0fd5-4ae5-4dfd-b029-4d037b63b6e6', 'f3140f7e-5045-4534-92aa-e918895bfafb', NULL, 'e9daa877-1886-48db-abab-5516000c4d8e', '0334125d-2eca-4694-9cc3-abfbb58b49f7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e8991a3f-7e11-413b-a946-c381890c8fcb', 'f3140f7e-5045-4534-92aa-e918895bfafb', NULL, '93f3cd3e-9b10-4a7c-88a9-39c29118fa8d', 'e9daa877-1886-48db-abab-5516000c4d8e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8ed6a950-8f04-421b-8c2b-523ea5513b7c', 'f3140f7e-5045-4534-92aa-e918895bfafb', NULL, 'edf9d085-dbfc-4e3a-9f0e-9eb407423ff6', 'bb74107e-cd5f-4207-87e2-69f4d67eb7f3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('baab9056-95ba-489e-af8f-3c8500316ded', 'f3140f7e-5045-4534-92aa-e918895bfafb', NULL, 'e9daa877-1886-48db-abab-5516000c4d8e', 'edf9d085-dbfc-4e3a-9f0e-9eb407423ff6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('418fe050-167d-494f-b368-5b79cf68ed2c', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '7a4d5839-8342-48c3-95e1-d7032ce2a6a0', 'eb46cc8c-d08e-4b43-aecd-b0d73b4c7a4c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f1a34ea5-fa78-4061-9856-fc05184b21af', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '7a4d5839-8342-48c3-95e1-d7032ce2a6a0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('323ca3e8-6c46-430d-abc4-26b350c76ad9', NULL, '7a4d5839-8342-48c3-95e1-d7032ce2a6a0', '3706fd53-e952-408a-aedd-93ec6d5129be', '7a4d5839-8342-48c3-95e1-d7032ce2a6a0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fb717805-588e-4af1-8a4d-d469bb1fd4d9', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '232fe9ca-d6b6-4105-869b-435f0b1357cd', '5fcac9c5-86b0-46ec-9eda-fa65d8ae1a9f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f712c42a-e9da-4a52-91f0-cf1adcbcb472', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '7a4d5839-8342-48c3-95e1-d7032ce2a6a0', '232fe9ca-d6b6-4105-869b-435f0b1357cd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0d2930ac-000e-485c-92e0-4181aef8062d', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '232fe9ca-d6b6-4105-869b-435f0b1357cd', '8f422852-c9d5-4c4f-bac1-ea4950ea77d4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dda57fac-9899-4895-bf24-8608b837e16e', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '8f422852-c9d5-4c4f-bac1-ea4950ea77d4', 'aca34128-8a96-494d-a9e7-4e891208b023', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('548710bb-7879-4f1e-999a-c4f0cbd00ad4', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '8f422852-c9d5-4c4f-bac1-ea4950ea77d4', 'fe0228ea-649c-45a4-b729-181aba7f3294', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0fed22c9-81a7-4e0d-b785-e0f526ae584d', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '8d53905b-418d-4c91-aa71-d4c49184cbae', '06d170a1-f3a5-453e-9a08-3dedf2ecc0d4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a113f072-ed17-43ad-9a44-a15836d419a7', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '0ae403ca-5143-44f0-b997-be330a72ee97', '8d53905b-418d-4c91-aa71-d4c49184cbae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e82498ba-ea7e-4b5c-8999-80bdd4a12cb9', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, 'fe0228ea-649c-45a4-b729-181aba7f3294', '8d53905b-418d-4c91-aa71-d4c49184cbae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6548161a-1fa6-4aba-8474-9f4ac5eb0365', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '8f422852-c9d5-4c4f-bac1-ea4950ea77d4', '8d53905b-418d-4c91-aa71-d4c49184cbae', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('779a7b69-138a-42e9-b856-9baec41f7298', '3d0e6bb5-a62e-4225-a2bb-967c76926705', NULL, '8d53905b-418d-4c91-aa71-d4c49184cbae', 'f218c4d9-d10b-4445-b381-b73a71f5848c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fecc2be7-6d8b-4329-9233-6adc0bdcc8ff', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, '1ea18a1f-6676-43b8-9fca-20b7e575c31e', '2194c042-0182-42cc-8174-6f219e3c4e65', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f5487eeb-c486-4918-82cb-ceaf2865be9d', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '1ea18a1f-6676-43b8-9fca-20b7e575c31e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fe06dfb0-6da8-4343-8959-2b1fe0c48f99', NULL, '1ea18a1f-6676-43b8-9fca-20b7e575c31e', '3706fd53-e952-408a-aedd-93ec6d5129be', '1ea18a1f-6676-43b8-9fca-20b7e575c31e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e4382c8a-b934-42be-b255-86a68b313e52', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, 'e5bb95d7-2fcd-4767-a200-c7c48e01401c', 'f792f250-1f61-4efa-a515-d04af7ad5e18', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3d08cdaa-3b4c-4a41-be4b-c02ff4d8d5b1', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, '1ea18a1f-6676-43b8-9fca-20b7e575c31e', 'e5bb95d7-2fcd-4767-a200-c7c48e01401c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fe7f66e1-5f12-465f-892e-831c6eb8eca6', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, 'e5bb95d7-2fcd-4767-a200-c7c48e01401c', 'b83a49eb-39d3-4c98-8c0c-5a1fb1862079', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('98694180-1334-428d-88ba-f590b4bd0f9b', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, 'b83a49eb-39d3-4c98-8c0c-5a1fb1862079', '89ac1223-5561-4835-8c9d-681ab874a47a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7c34d13b-6f59-4951-9f67-86175240b61e', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, 'b83a49eb-39d3-4c98-8c0c-5a1fb1862079', '6c0656b5-472b-4859-af3a-b8f1c53231a5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b5844430-3cc8-411b-b13f-b79b231cf9ec', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, '7564d2ce-d4ad-48e2-baf4-2fc08cc249a8', '0c5a46ce-1c25-4f5b-9dff-5f5be50cf6a6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b50ba954-ffce-4a4f-bad5-0df732c28759', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, '5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea', '7564d2ce-d4ad-48e2-baf4-2fc08cc249a8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('94051685-ca75-4b71-9f62-48e8f8b64dcf', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, '6c0656b5-472b-4859-af3a-b8f1c53231a5', '7564d2ce-d4ad-48e2-baf4-2fc08cc249a8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f0997e3b-25ec-478a-89cb-2ceb281db00b', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, 'b83a49eb-39d3-4c98-8c0c-5a1fb1862079', '7564d2ce-d4ad-48e2-baf4-2fc08cc249a8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('34aaa5e2-cfdb-441e-a83c-235b50c3d095', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', NULL, '7564d2ce-d4ad-48e2-baf4-2fc08cc249a8', '8ad792c1-10e1-43fa-8d5a-a6f3810878a2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1f014ff1-f4fc-428b-9c97-567d7d7aeca6', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, '71c29d57-de3e-4f00-9303-2d51e8c11b20', '02748d62-3212-4465-8c05-aabc3f919a08', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ebeae76d-0a04-4574-9ff8-bda63915a39f', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '71c29d57-de3e-4f00-9303-2d51e8c11b20', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e326cafc-77e1-457c-96e5-72ede9f4c721', NULL, '71c29d57-de3e-4f00-9303-2d51e8c11b20', '3706fd53-e952-408a-aedd-93ec6d5129be', '71c29d57-de3e-4f00-9303-2d51e8c11b20', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('656c7f0a-a22b-47db-8a70-04e089949578', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, 'adaeb8bf-e22b-4bb9-ab33-66e19053ab31', '0cde804f-7eed-49d3-8eb4-d55e806f8957', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bf6e7bdf-0223-4f6a-9b18-83c7f32de12b', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, '71c29d57-de3e-4f00-9303-2d51e8c11b20', 'adaeb8bf-e22b-4bb9-ab33-66e19053ab31', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('ea19f91f-d0e1-4612-84de-136e1c687a95', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, 'adaeb8bf-e22b-4bb9-ab33-66e19053ab31', 'bb372939-0891-4068-bf4b-651e8f2a03c8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3f67f755-72fa-435b-8f11-dee88ec0d5ff', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, 'bb372939-0891-4068-bf4b-651e8f2a03c8', 'b204ae10-065f-4969-aedd-4c25602a821c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('396be5ea-4bc6-4379-a8fe-052cddc952f6', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, 'bb372939-0891-4068-bf4b-651e8f2a03c8', 'e6409531-6513-43a9-84a7-eff44b18285a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7d60b8f3-b636-4774-9627-f1bf0da5161d', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, '88d51826-68ce-4d8a-9a65-91429e00d053', 'b04e429b-3f95-4dea-b61e-3e96d114ecd1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a07e0d52-8691-4ed9-929b-0874ec22e207', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, '03089301-5a05-4c2d-abf3-b95267b2edef', '88d51826-68ce-4d8a-9a65-91429e00d053', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1fa5268e-4a20-4733-a5ef-16250ee16686', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, 'e6409531-6513-43a9-84a7-eff44b18285a', '88d51826-68ce-4d8a-9a65-91429e00d053', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('37485252-ae63-47cc-badd-e551a9840214', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, 'bb372939-0891-4068-bf4b-651e8f2a03c8', '88d51826-68ce-4d8a-9a65-91429e00d053', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('81b57d10-68d0-4a5b-b4bd-22ef77b245b0', '850aa448-3a14-440c-9834-0b7ef6d83c39', NULL, '88d51826-68ce-4d8a-9a65-91429e00d053', 'd00a14ad-fe79-40fc-8f72-722fb5cd30bd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('715fcbc2-a193-4ad7-83b7-c4f455b5a7f8', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, '63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8', '3014663a-10bc-4a8b-b47c-2c805b198d7f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('94782817-2d75-467d-bb1b-bf257174d08a', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('38b49585-c8b6-4060-a002-4313aba14115', NULL, '63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8', '3706fd53-e952-408a-aedd-93ec6d5129be', '63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a65ff09c-84e5-484f-9e3d-6fc6b0910745', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, '74b8c100-35a5-4a9e-882b-d106b0656e15', '702c700c-a440-4771-b203-9c030c1c100f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('98fe55f4-9a13-4719-8332-9556d414cffd', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, '63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8', '74b8c100-35a5-4a9e-882b-d106b0656e15', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('869e59ed-914a-4779-a1ee-9989dace7aa5', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, '74b8c100-35a5-4a9e-882b-d106b0656e15', 'c73f5078-0505-44ea-b0e1-57390f4d5a3b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f26117f0-9761-4e50-858d-0a5e70242649', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, 'c73f5078-0505-44ea-b0e1-57390f4d5a3b', '3a07b077-aebc-48ad-ab29-6d375afab845', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('49e38887-66ff-4548-9077-88858312127c', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, 'c73f5078-0505-44ea-b0e1-57390f4d5a3b', '6e7feeb7-4891-4ea3-96b6-00d883da37c5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dcee72e3-0c00-4de2-a42b-0e270c2d8f9c', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, '86454239-fb95-484e-9f75-142ee5ca2a5d', '69067b5f-41d0-447b-aba4-31764c6d6e04', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f8802f34-52da-44d5-9797-78e0dc3583a8', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, 'dceec9d4-d2a5-444e-a27b-4a16c01b155b', '86454239-fb95-484e-9f75-142ee5ca2a5d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4fc7cfb9-2782-4b2c-9c3f-a8eb0e573d76', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, '6e7feeb7-4891-4ea3-96b6-00d883da37c5', '86454239-fb95-484e-9f75-142ee5ca2a5d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('582a665f-fb6e-4a1d-9c34-544805cb2290', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, 'c73f5078-0505-44ea-b0e1-57390f4d5a3b', '86454239-fb95-484e-9f75-142ee5ca2a5d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('de1fa34f-307c-43aa-b9f9-0de34a7e55eb', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', NULL, '86454239-fb95-484e-9f75-142ee5ca2a5d', '1ed7ff07-778c-4920-a550-563b27223228', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9295097d-a6bb-4f56-872c-786a6e030c4d', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, '0017035a-e8ef-4e77-a43d-938cfc7962f5', 'a3d6ce3f-655b-452b-91b1-539956c8580d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2f1d9ae4-4df3-4b51-bd68-0140f715fc71', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', '0017035a-e8ef-4e77-a43d-938cfc7962f5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('829228f5-33c6-47e3-b6d5-4eae06004c3b', NULL, '0017035a-e8ef-4e77-a43d-938cfc7962f5', '3706fd53-e952-408a-aedd-93ec6d5129be', '0017035a-e8ef-4e77-a43d-938cfc7962f5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b7ab4650-c744-4560-8e9b-bffde55f24f5', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, 'ad177311-3c0c-4d93-9ff7-c0b5665fd0ca', '0198a5da-a2fc-4f7e-bf41-54642325d8dd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('718c7a90-f8ca-4b20-aab8-d6470acc3cb0', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, '0017035a-e8ef-4e77-a43d-938cfc7962f5', 'ad177311-3c0c-4d93-9ff7-c0b5665fd0ca', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('eaec616a-0014-4399-a500-41918750c501', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, 'ad177311-3c0c-4d93-9ff7-c0b5665fd0ca', 'e2f03c7d-5026-42a3-a18f-ce770314c22b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4085dd28-9917-4acd-a438-188c6de4ae47', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, 'e2f03c7d-5026-42a3-a18f-ce770314c22b', 'e1ddefd3-730f-4085-8651-a24dc88b7330', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b2216acc-616a-43ac-9f46-9526a658a586', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, 'e2f03c7d-5026-42a3-a18f-ce770314c22b', '6c0656b5-472b-4859-af3a-b8f1c53231a5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('03d92a07-9316-4168-816e-34416a2ec8d7', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, '8e019651-e0a0-490f-8592-55c7016cec2c', 'ca0cb3e0-c89b-45a1-8614-c6a6f7a5e80f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('156cd874-18f0-4914-879b-3abb92658f0b', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, '2a9d3ef1-e293-4301-914b-0ed781b63689', '8e019651-e0a0-490f-8592-55c7016cec2c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('74df7196-1406-4904-a395-f8ca0070adfe', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, '6c0656b5-472b-4859-af3a-b8f1c53231a5', '8e019651-e0a0-490f-8592-55c7016cec2c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('05a0f74b-4a19-44a0-bf45-bb01e3a3c542', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, 'e2f03c7d-5026-42a3-a18f-ce770314c22b', '8e019651-e0a0-490f-8592-55c7016cec2c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('32de1c62-58ac-4e44-9eb9-c9728cbcd99d', '466056f2-efc6-45d6-b778-fa111db7a18b', NULL, '8e019651-e0a0-490f-8592-55c7016cec2c', '8ad792c1-10e1-43fa-8d5a-a6f3810878a2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('57fae3e0-faa4-4a5d-9578-3be81426c9ed', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, 'ee5eda97-ff2a-4646-ae01-dcec47a7688b', '41bf1ce4-7d32-4bc9-a240-6f37aa7c5311', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('76e98e3c-8e48-403f-a3a7-21e543cd1f43', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'ee5eda97-ff2a-4646-ae01-dcec47a7688b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('994806f8-555b-4852-84ea-46f1042cc8a7', NULL, 'ee5eda97-ff2a-4646-ae01-dcec47a7688b', '3706fd53-e952-408a-aedd-93ec6d5129be', 'ee5eda97-ff2a-4646-ae01-dcec47a7688b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d0f378b9-9b9e-43ad-8d06-dddf272d656f', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, '2214774f-6235-4cb9-8713-e2ee51b213d2', '008b96bf-c732-4063-95fa-8660cc3e378a', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9dec48cd-6775-407c-ae5b-96bb7cc9bd03', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, 'ee5eda97-ff2a-4646-ae01-dcec47a7688b', '2214774f-6235-4cb9-8713-e2ee51b213d2', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4363884b-cec6-4d16-a544-aa7851fbe568', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, '2214774f-6235-4cb9-8713-e2ee51b213d2', '919c64ed-015d-4a71-9287-69f554378b69', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('009da81d-2778-4058-a777-f2a1a49a7dbb', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, '919c64ed-015d-4a71-9287-69f554378b69', 'ffe77615-7fe9-4dd7-8a55-9459ff2d2b43', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b0fff766-3126-4558-8543-023fd7919a4a', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, '919c64ed-015d-4a71-9287-69f554378b69', '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('35138f25-fa9f-411b-bbf9-ea90747ec053', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, '67f93c8d-a31d-4d14-ad7a-6bae4f8202e8', 'a8ca5cc1-5e21-4837-9f78-bc4f8aed2d4d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('88d0fcab-468c-434d-bba5-b8ea58e367cf', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, 'fdfd2976-fc7d-422e-8b5f-91f401927b18', '67f93c8d-a31d-4d14-ad7a-6bae4f8202e8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('36714b48-ab50-4ca0-b817-643b3b724da1', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', '67f93c8d-a31d-4d14-ad7a-6bae4f8202e8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f43465dc-80e3-42d4-8f70-2e081827f14f', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, '919c64ed-015d-4a71-9287-69f554378b69', '67f93c8d-a31d-4d14-ad7a-6bae4f8202e8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('12a8f987-2cca-4849-84e9-ab90c5e17815', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', NULL, '67f93c8d-a31d-4d14-ad7a-6bae4f8202e8', '42f0c634-d86b-4129-822b-f103cd6e0755', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('57902b9d-783f-4a58-9f83-6224b3f4a6bc', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, 'a48e5290-7207-469f-85ea-c5f5b2150d1f', '74d9ec93-6755-4198-bba3-b900d1391ddf', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dcf355cc-ab44-4b22-a55e-d5f99b85af29', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, 'ce47754e-0d06-4b12-bc91-8034a4a046e7', 'a48e5290-7207-469f-85ea-c5f5b2150d1f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('8f7b7ef3-16bc-4304-9b94-3db035baaed1', NULL, 'a48e5290-7207-469f-85ea-c5f5b2150d1f', '3706fd53-e952-408a-aedd-93ec6d5129be', 'a48e5290-7207-469f-85ea-c5f5b2150d1f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f994f54c-8f7c-4507-9b4e-4544c14c0ad0', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, '39c84db0-c0b8-48bc-9602-f6371fee499b', '9cf52144-7c0c-4031-a0dc-b5f7d0581115', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('258ddb5c-2b75-40b9-8898-b9c627298806', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, 'a48e5290-7207-469f-85ea-c5f5b2150d1f', '39c84db0-c0b8-48bc-9602-f6371fee499b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9717685f-d479-46d1-885a-4cb17a430342', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, '39c84db0-c0b8-48bc-9602-f6371fee499b', 'a9998fe5-2760-4309-a904-8e4f6787110e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7ec462f2-83f8-42de-af55-8b6b5e2de3f4', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, 'a9998fe5-2760-4309-a904-8e4f6787110e', 'edf9d085-dbfc-4e3a-9f0e-9eb407423ff6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('204b62fa-20c9-47bd-bf32-ff24d7fb7ffb', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, 'a9998fe5-2760-4309-a904-8e4f6787110e', '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bc6d5658-ce6e-4b26-871d-1ccc1df07c6d', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, '81268148-75ff-467a-8d73-b8e4f734d83c', '7878934b-1841-4918-85e7-ce853fe8fdba', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('60a9ee92-68f5-4335-8ce4-67107e5309ed', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, 'e9daa877-1886-48db-abab-5516000c4d8e', '81268148-75ff-467a-8d73-b8e4f734d83c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('79d673f7-e093-49c4-8cab-fcd4a340c39c', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, '6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', '81268148-75ff-467a-8d73-b8e4f734d83c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dab64a81-9b1f-4c93-9a53-13a4f4b2c022', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, 'a9998fe5-2760-4309-a904-8e4f6787110e', '81268148-75ff-467a-8d73-b8e4f734d83c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('74fe3b51-2a5a-4d27-a527-6efdd14214fb', '51a4690c-bb0e-4be2-a285-31552f900db6', NULL, '81268148-75ff-467a-8d73-b8e4f734d83c', '42f0c634-d86b-4129-822b-f103cd6e0755', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('67eb1bec-83ec-4876-aa00-5c13ee29717f', '925e61ee-5120-4205-b609-18083af2c4d6', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '18630744-5484-4f55-94a4-15b6f8a8c791', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7d7eb6df-a1e5-417d-b885-010094347b53', '925e61ee-5120-4205-b609-18083af2c4d6', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '7e2d1a3e-03f8-463c-9300-7e0b9bfd0eb5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3a7f512f-841d-42c1-a380-b04e86d9220f', '76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9', NULL, '5fd54e69-2513-4413-95d6-dde58ed6d8ae', '23115d61-dd0d-4545-8240-2415ab603868', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6422bf87-17e1-4a44-8620-369cdb981f46', '76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9', NULL, '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', '4b8fc5ce-2f77-43cc-8c11-caefef50e9e0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('daa6daef-4605-4ff7-8092-8ce36182aecd', 'e27e543b-f15b-4e0b-98fc-ce72bcd5d258', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '7ba7e7db-d2a0-4d8a-a982-4b592a6519d3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('af304e37-6161-49b4-a07f-9d2ff0fc83e8', 'e27e543b-f15b-4e0b-98fc-ce72bcd5d258', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '28a1da29-5665-4481-be2c-23484fede329', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('200fb76f-7c36-4210-916c-6cc3770a8e20', 'd9c28f32-a87e-4f2e-af07-75a76004907b', NULL, '5fd54e69-2513-4413-95d6-dde58ed6d8ae', 'ad772eba-1cc4-4973-b407-ee1292c8cefb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('d7bf8f19-245f-407c-a279-8c6a8ac4cb4d', 'd9c28f32-a87e-4f2e-af07-75a76004907b', NULL, '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', '2b1bd996-ed42-4b6f-941f-a02115b5c49c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dbcc10e6-1f85-4e5b-b8f1-d30aae66e623', 'b0a9b8a6-8709-4210-b4ad-eadcab6f7866', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '114ce5a9-0704-4f91-98d1-7f4f2e6d6ac3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('5fc992c1-6639-471a-87a4-a80a0896e70c', 'b0a9b8a6-8709-4210-b4ad-eadcab6f7866', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '9532739f-1149-42ed-bb1d-cac1d14d4380', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('f246d972-475b-4606-ac2f-94c0d79db3ff', 'd3e130d9-9288-4d74-8699-1778d2f5c151', NULL, '81aefd8d-c7aa-48a5-869f-1df15b4b68ae', '04a9b874-65cc-460a-83be-47366ec3c35e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('339606b6-0f4d-412a-8fcf-c23c49cb362b', 'd3e130d9-9288-4d74-8699-1778d2f5c151', NULL, '173a65d3-7eb4-4910-a83f-08ce5ed65583', 'fac002b1-7dd0-4def-9c60-ce441ae74bf0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cef6afa7-a6d2-4100-8d23-55559217b4b5', '110138a4-46e3-418b-8ce2-095da9c6b98c', NULL, '08c7995c-a7e7-4093-8aa0-6e6e8449f1e4', 'd0c2aec5-df1e-4a43-accc-292636a196ee', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('faf97694-ad24-4965-9e64-432da96eb398', '110138a4-46e3-418b-8ce2-095da9c6b98c', NULL, 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', 'c16db138-0d91-44b1-bd5a-b8361d1773a6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2d664d49-5717-4a5f-a4f5-ec7743b5710b', '0565d216-af16-45aa-86e5-9ca55751322f', NULL, '345b8b7b-a948-446f-949a-2a903b460032', 'b299282d-1cfc-41b1-8936-2dcbfe1017ca', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('53fb7a01-cb8a-496e-a74b-c18aead55996', '0565d216-af16-45aa-86e5-9ca55751322f', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', 'bb211784-8f68-44ff-833c-3f501a33ad0f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('cf757bfb-f62d-42be-8bd3-cb2dfe1a9b3d', 'c7d34de2-7cbd-480a-9ce5-a574ef7248d8', NULL, 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', 'd80e22b5-9ba3-4ad6-a392-fddaa4a5532e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('242bbed6-71bd-47d7-a1a5-1cf3495c0366', 'c7d34de2-7cbd-480a-9ce5-a574ef7248d8', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', '2afe8e61-bfb1-44c3-8685-bb5390e9ffa9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('dcca4c69-4263-4bb9-a811-e6d89c8c3ecd', '147820f5-533d-471d-9f54-99e087ec37c6', NULL, '345b8b7b-a948-446f-949a-2a903b460032', 'd1fb0181-59a4-4c35-a6da-9c4c8c420f4b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4201e516-0d85-43c6-934e-41980b5f07a6', '147820f5-533d-471d-9f54-99e087ec37c6', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '7f04b4ff-ce51-4c25-b924-eda9c80beab9', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a710ad6d-cc4f-4a1a-8cd8-09eae7e33591', 'eb40ed40-ebf5-401a-b498-ecc46928a17d', NULL, 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', 'f7036040-6df9-44df-a4a4-40b8065234b3', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('00ddbf09-cee4-4880-a4c7-3dfe2c7b831a', 'eb40ed40-ebf5-401a-b498-ecc46928a17d', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', 'aa8c9c0b-ac3d-4fe4-85ee-22876b77a346', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c863aeb6-d294-4b38-9cb5-a746d88ae3bb', 'f9c724b4-3965-4cfa-bc93-5b780b2362e7', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '5612b460-e9f4-4c7f-8f30-fabca1954260', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('9b17f569-8476-4251-a789-cfb74e3d3f98', 'f9c724b4-3965-4cfa-bc93-5b780b2362e7', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '793d3808-9277-4bc1-b39e-46fd0b5028d1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bbde51c9-e683-4ff4-a012-a554ae9bf2bb', '1b444a8f-352d-4812-97aa-bd1e649201f8', NULL, '5fd54e69-2513-4413-95d6-dde58ed6d8ae', 'a46e7e72-094a-4677-a2ba-b027e117c814', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6e566df6-3722-4285-b7c9-529dae12bf44', '1b444a8f-352d-4812-97aa-bd1e649201f8', NULL, '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', '34608829-3d7a-475c-b734-f3692e102b82', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bfc8f1bb-1257-42d3-aeb9-dff5b7f3b217', '2b1590f1-c1b8-4318-9879-8e2d898fa4a5', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '176b447d-ce47-44da-8219-a00244a3d5e0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0037af31-dbef-4d05-b8de-d96df9a4823c', '2b1590f1-c1b8-4318-9879-8e2d898fa4a5', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '22500be4-6daf-4c50-9120-a4d0c6491720', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('76d8fb6c-b943-48ad-881b-2e2bd0fa4a76', '0f05f1bd-403c-4239-8595-d317bba58a32', NULL, '5fd54e69-2513-4413-95d6-dde58ed6d8ae', 'c772675e-39bf-48b0-b10a-1a2ff065c3a6', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('57a68c1c-1fc9-4739-b67d-f61282cd36f1', '0f05f1bd-403c-4239-8595-d317bba58a32', NULL, '9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', 'b096450c-b5aa-4a9e-9b80-8633ca2243a4', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('693be01f-b73e-4ff2-934c-c8401a2d54b6', '2cca894b-c08a-4b36-b809-d417cf0b305c', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '651a87c6-db56-4963-88a5-5dd7b74d53ce', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4589614b-cdeb-47aa-a747-83ba244d6100', '2cca894b-c08a-4b36-b809-d417cf0b305c', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', 'cf345447-6015-474d-9c1f-2fe7b879edf0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6b78ec2b-56c2-4f95-a57e-4e227ae4c4a9', 'b4acab9a-7a54-42df-bd35-717f052b407d', NULL, '81aefd8d-c7aa-48a5-869f-1df15b4b68ae', '9654e7cb-b714-4f8d-9a7a-5a2e9dcbe09b', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('fcd6e589-bdd7-49c2-a4a4-f1033039ba84', 'b4acab9a-7a54-42df-bd35-717f052b407d', NULL, '173a65d3-7eb4-4910-a83f-08ce5ed65583', '6eb3f2e6-4f80-4ec5-b121-e0e6ab166e6f', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('976d530f-a6a7-4ea1-bda1-087b3605a970', 'fab99b6c-dd05-451f-a9e7-80891ec94db1', NULL, '08c7995c-a7e7-4093-8aa0-6e6e8449f1e4', 'c7a074b6-6e8b-4570-a8b3-baf483e67c14', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('59529140-a688-4039-8ca5-9c6bb81e1e5e', 'fab99b6c-dd05-451f-a9e7-80891ec94db1', NULL, 'e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', '16c5c51a-6b85-48fc-a19b-b1d0319c414d', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('1c95e864-7f9e-4d8d-a834-225c93cfdc2d', '34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb', NULL, '345b8b7b-a948-446f-949a-2a903b460032', 'ef9747c5-e7b2-4a22-b4cf-cb05c7cc0d6c', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0b668bc5-920c-4c00-ad0a-752ec371bc25', '34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', 'a5de5a65-81f3-482b-baac-4054940ea7b5', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6e7918ee-dfb7-4d0e-8aba-e0f281e40ecd', '9f3ea248-0492-43af-8430-2cbe4ae3338b', NULL, '345b8b7b-a948-446f-949a-2a903b460032', 'c32e6121-a5fc-4345-b6e6-26eda31d266e', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c5313615-0a03-4ff3-bd3b-f38fc7bd68f0', '9f3ea248-0492-43af-8430-2cbe4ae3338b', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '96383615-0c59-4cc9-9292-723a1c0f4a52', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('e7c0f355-8789-4d74-bd38-6a7f77902823', '02362331-8069-4712-9c39-371973edb192', NULL, 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', 'db092336-0de9-4c19-b5a7-9f035596b364', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('4f2835bf-09ce-44c1-8dc7-fe4ff02fc494', '02362331-8069-4712-9c39-371973edb192', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', '63dd3ba5-db8d-481b-8eb5-ee982522f4d0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('b7428b9a-e165-4a81-b1b9-5187e0fe4cd6', '899a89c3-6715-4a37-bb69-1ed124e0a23f', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '67f40c40-c638-4350-a11b-951b0bf73bf0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('3ca77977-6015-4ace-9665-be334d0128ad', '899a89c3-6715-4a37-bb69-1ed124e0a23f', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '0166244a-b22b-4567-a09d-bd113f3430b0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('bbe6ea5d-c6bb-448d-a92e-0ec2e61f9985', 'a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', NULL, 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', 'b969f3ba-2936-4937-80ff-c440300d3f10', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('0d245a6d-d759-4b8f-b1b7-44d6ce23ea8e', 'a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', 'f6d1a800-dbfe-44d3-a939-e168760203dd', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('80101a12-d237-46ed-b8bc-27eab76c14a7', '568b153a-13dd-4510-b681-13b53f866091', NULL, '345b8b7b-a948-446f-949a-2a903b460032', '44a7f281-7acd-4536-a7da-db74fc7d5a30', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6154c85c-c362-4b71-b842-8b2bd73e4285', '568b153a-13dd-4510-b681-13b53f866091', NULL, '0eabdcfb-e308-4e52-8c7f-27643332c947', '51278cdf-daff-4fe9-90b2-1e651847e0d8', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('050e2230-78e6-43ae-9278-eb70a4a6909b', '6d4e335b-f22c-48d8-98b3-0da4ad759e65', NULL, 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', '852d7666-33fb-4246-b2c4-1efbecba4da0', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('7d5320cb-c8ce-4c24-988b-72d8fcc43b0f', '6d4e335b-f22c-48d8-98b3-0da4ad759e65', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', 'fcc39eac-cca5-44fb-b728-9b4df8aa3874', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('261a0a0b-a0a8-4493-96f1-10f8eb18e01f', '105e8365-c8b6-4d69-bef4-8bc388524462', NULL, 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', '6a568f34-8ab2-4a74-941c-266e28a52836', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c1c5ea35-68d0-4e81-b659-9b0e7894364e', '105e8365-c8b6-4d69-bef4-8bc388524462', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', '8a4f7331-7bdf-41a9-85c3-5ea327063d71', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('c57e5955-fca4-4ddf-8cb1-c6731cd7bd70', '5b516553-2772-4591-b4bf-4f353e598c79', NULL, 'ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', '526ae830-0342-4a87-a95f-07d760391fb7', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2b408520-c1ed-4d41-8457-7d9496910c56', '5b516553-2772-4591-b4bf-4f353e598c79', NULL, '6df50d79-b958-456a-ac84-a8786f0f18a7', '08a87b5d-d5eb-4d77-aa10-1afa61c87e38', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('6cc382ac-c4f0-4341-80ac-32d9d2eb28f3', 'df223672-3c4b-4044-8f54-1794a50c957e', NULL, '1d24331c-d029-4539-8b40-2b891f6a75a9', '63c07ed8-5b6d-4cb7-b663-6a5ce5e63fcb', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('a6994a91-4291-4342-bc50-9a7bd25f7b20', 'df223672-3c4b-4044-8f54-1794a50c957e', NULL, 'bf27b482-99fb-43fe-8789-b926b9131a32', 'cc4e1270-9d63-449f-ae27-a492326f72b1', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('72e5484a-06b8-4fcb-b039-42dd92d1b54a', 'cd8cd45a-a4af-46ce-a434-5b5208095346', NULL, '1d24331c-d029-4539-8b40-2b891f6a75a9', 'f03cc85a-b722-43f4-8d56-a29f1387e692', true);
INSERT INTO rbac."grant" (uuid, grantedbytriggerof, grantedbyroleuuid, ascendantuuid, descendantuuid, assumed) VALUES ('2f57e665-78f6-48fa-b811-d8537ff580e3', 'cd8cd45a-a4af-46ce-a434-5b5208095346', NULL, 'bf27b482-99fb-43fe-8789-b926b9131a32', '16994a15-ef4b-4c7f-b123-e9c2e03919d0', true);


--
-- Data for Name: object; Type: TABLE DATA; Schema: rbac; Owner: test
--

INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('33af1d05-a7de-4552-9118-7900fe5fde7d', 1, 'rbac.global');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('691db509-b67e-46ec-a859-c4cb05fbbd70', 129, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 130, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('d363745a-e94f-48be-8397-4b361570a54d', 131, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('7a334268-7d11-4765-8fa9-17e2c36cca7a', 132, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('33b40eee-30ed-4924-859d-6c58b5aa4124', 133, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('16da0560-e134-41c5-aafb-1f7a5b33692b', 134, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('1fc10779-390b-40ff-b641-b6b5e2634ebb', 135, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('caac18bd-9277-47ac-99bb-368e2d64dac0', 136, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('eead6995-dd54-475f-8194-74445c421305', 137, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('4b68de11-a658-44bb-be49-ad592e73e3d8', 138, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 139, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('25358342-4f90-4397-b4c4-d90524ac0b7b', 140, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('4997dce8-4927-4a10-a7b3-16c574eb79c9', 141, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('9dcab961-1465-40e3-8d83-357b22af2674', 142, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('29e2d42f-5f00-467f-ab73-f2ff59f2792d', 143, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('627a274d-55b0-42e7-963c-8b0cc3e204b4', 144, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('e8151525-ae0c-44fb-9755-72be88f7f6b1', 145, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 146, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('c3b8c521-37f4-46b8-89f7-1931159e9a14', 147, 'hs_office.contact');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('137fb47a-07d4-42cc-b2ef-8e371041cf41', 148, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 149, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('cd48cfd6-6313-408f-ae7d-9af047d0c22e', 150, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 151, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 152, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 153, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ff030436-d19e-4606-9d48-7e192eaf469f', 154, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('c8050a1b-0d28-4aa7-ac77-958c99152cd1', 155, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('89bca3fd-d7b2-46f5-821a-64c5566d03f1', 156, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('2fd1ba30-936a-41a8-8fbe-e93be547f44b', 157, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 158, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('38cc5d59-085f-449e-aeb3-439febbabd9b', 159, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 160, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('d7485220-e4f2-4683-9e84-7728a2ef4ebf', 161, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('d6488771-b5c0-4f39-a6d6-81af6ca982f4', 162, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('7c10a7d7-bac2-41e2-a5c0-963e191239a8', 163, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('c3d97013-0ceb-4cc7-a59b-a4f70107acea', 164, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('e50c983a-060c-47c9-9d47-efd552b1e618', 165, 'hs_office.person');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('48618c28-9304-4ccb-b022-e2cbb1832944', 166, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f415978e-b5c2-4a99-962e-3d31a4658780', 167, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('201b417e-4ebe-458b-a7ce-a287c0ad9287', 168, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 169, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f85f9a58-7651-417f-b1b2-cf522bcce415', 170, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('78123dac-fed2-4e3e-817b-0c13a2129dfe', 171, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('463c4856-495f-4ab3-b26c-7b2f96b05ab5', 172, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 173, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ecf9603d-1bc4-417b-b953-552b8f08f6f3', 174, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('dd0eae3e-7f45-45dd-b686-f39e046918b0', 175, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('164d3cde-e2ab-4239-9dbf-de1c963158ac', 176, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 177, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a85fd289-2383-4abe-b796-9b0b47d702d2', 178, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('bc8c4b35-c55b-4c3e-9122-94485909b17e', 179, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('bcd0fdb5-7415-40d2-8265-85113a4b66be', 180, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('268c2ce6-8945-4393-9916-ac90050f064a', 181, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 182, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('86b706e2-9225-482e-b82a-d4ac4adab065', 183, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('2db1a3ce-910d-4f3d-be67-b3a0a598d834', 184, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 185, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ddbda55a-0143-4224-bb6c-7ec5e8b79465', 186, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('47b7bd3f-8668-4934-bee9-56708e835d7f', 187, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('80a9daef-e282-499a-ab2f-98a016edb8f7', 188, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('93d9827e-63dc-418e-a021-25b400847b2e', 189, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f4219fae-353d-4324-90ca-9f313a8c1c17', 190, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('219baf3d-0bb7-4252-b92f-4cfa97cb633c', 191, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ed0fb977-6512-4452-8505-378fcbbd5060', 192, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 193, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('af82432c-09a8-42a7-9525-e9095025d4dd', 194, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f691585e-eb5e-45bd-8d8a-8187094ed0a0', 195, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('65879210-cf7c-4e5b-a2d1-742a42fcb488', 196, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('97e5ed67-e81c-4c12-b354-45db951901c0', 197, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a0e5508f-533d-4f7c-9602-6f23fa85e601', 198, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('2eec1138-d2ad-43de-a105-605d0182a1f8', 199, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 200, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('fad03414-b62b-45d4-93fd-51c52149762c', 201, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('48a0fa39-0d72-4c0a-800f-afed02865850', 202, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a84434fd-e879-4208-a8e8-8095e22b72bf', 203, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('93d87d13-efdb-4d31-83e6-3b13db983c12', 204, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('bad214a0-5220-4433-8714-52e4c736585a', 205, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('5add96a4-6fff-4fe2-8628-669d72252417', 206, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('2185083d-3134-4b30-9dcb-674058feaac2', 207, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('c60e1d4e-01a1-42a8-9521-1681c77b350f', 208, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('17ea3654-289d-4892-a837-3ddcaea2d7db', 209, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('60702c01-7285-4eea-a937-6019d6e3661d', 210, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a66a844c-e5b3-4569-96cf-06197abc0d2f', 211, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f7ddff21-e58a-426b-a693-46a2b45c9d4e', 212, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('8363ec62-6d90-4dd9-940b-6073b3246c39', 213, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 214, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('bc9fabea-d44b-455c-87d6-a0b0428e7768', 215, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a13af5de-4315-46dd-ae08-427ea72b35a0', 216, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('cea1bd90-a42c-4cbf-97c3-33c134537bfc', 217, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('fac4bfec-9f0b-427f-b032-ca54188d0a76', 218, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 219, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('18124f89-8ce6-4813-8efe-3ed47b7eb453', 220, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('cbda6432-b849-4787-84ab-88e680dbfa72', 221, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f3b07a47-e7ac-4fea-850e-1d785edfea34', 222, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('4761d35a-2de3-4415-a91d-f53d15162aea', 223, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('04c248f9-20e0-42e1-adf3-b24d2ff7a272', 224, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('7113f4da-b942-4f17-97f8-d3fdfd2966c6', 225, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('4dbf555d-3375-442e-a87d-815d1492af55', 226, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 227, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('e74992df-66a8-4572-9e55-ec7b210f04e0', 228, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 229, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 230, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('047364a5-9dcb-4027-a94c-e35f4646860e', 231, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('08e80808-fb86-4503-ab9b-9652af82d5b5', 232, 'hs_office.relation');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('6da29bfa-4744-437f-aed3-2695571c58bf', 233, 'hs_office.partner_details');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('91b63591-b1e2-4c65-8ad2-c607be4c1238', 234, 'hs_office.partner');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('7b7a528d-a284-4d0d-99ce-73f2a7585f78', 235, 'hs_office.partner_details');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('db7f287e-dfd7-4627-88e3-407cac226472', 236, 'hs_office.partner');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787', 237, 'hs_office.partner_details');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a083dfa1-afb0-4531-8a1b-8f4ba78a6215', 238, 'hs_office.partner');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('90604765-0e48-4363-83e4-1c2e9e4a8f33', 239, 'hs_office.partner_details');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('029b1c78-d68b-48e6-83e5-8883b9cefe7c', 240, 'hs_office.partner');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a7494bd0-af97-421e-bfa3-53bd97fb1df8', 241, 'hs_office.partner_details');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('58ca016b-15ea-41e3-80ba-2603bf736619', 242, 'hs_office.partner');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f1048d9f-e560-459a-91fe-f769ef049648', 243, 'hs_office.partner_details');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('defa6288-bed7-4ed8-ae6d-fbbb3530a632', 244, 'hs_office.partner');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('b2cd9234-6651-4c9a-818d-f48610d76095', 245, 'hs_office.partner_details');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('25b8066a-59fd-4733-90f2-8ea80c826fff', 246, 'hs_office.partner');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('871eadbe-c143-444a-966c-cc4494ba93bf', 247, 'hs_office.partner_details');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('c83c9583-a825-4a2d-96b7-fec9dd635fbc', 248, 'hs_office.partner');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', 249, 'hs_office.debitor');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('84d4763e-0133-4d81-946b-fb64d1a3fd26', 250, 'hs_office.debitor');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('bdfc3748-abd1-4bce-a239-f5b4df6715c4', 251, 'hs_office.debitor');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('67c2d793-212f-4ce0-a750-b18224a93c73', 252, 'hs_office.debitor');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('3692b171-10ef-4f20-97de-ed5fa562ca46', 253, 'hs_office.debitor');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ce424fb0-bcc4-43ef-bc62-e923fb337fde', 254, 'hs_office.debitor');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ccbd7baa-494d-4bfc-b5bb-4310e607df04', 255, 'hs_office.debitor');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ade3baa7-760f-488b-962d-7e365ad1402f', 256, 'hs_office.debitor');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f97e9751-6e67-40fb-b840-b818dc69afcf', 257, 'hs_office.membership');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('db1fa6bf-85ff-4302-b7c3-9a66f9761830', 258, 'hs_office.membership');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('cf4c2c71-c6a0-4887-83a3-67509371b8af', 259, 'hs_office.membership');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('af682fb0-f06d-4a2b-affb-40487a079a70', 260, 'hs_office.membership');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('9c468212-9e05-4b29-9d75-5a2c147b2b8f', 261, 'hs_office.membership');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('ace60d06-0635-4c2c-bb4b-7233c19862fc', 262, 'hs_office.membership');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 263, 'hs_office.membership');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('9b403ef6-3fae-4698-9b21-2627c51fa254', 264, 'hs_office.bankaccount');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f9811182-d400-43e0-ba9e-de745c9e82a3', 265, 'hs_office.bankaccount');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('4924877c-c487-4e4d-8b14-901e9b6069ac', 266, 'hs_office.bankaccount');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('831a608f-fefe-425b-b740-1786f856c680', 267, 'hs_office.bankaccount');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 268, 'hs_office.bankaccount');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('0bae3550-be89-4c0e-9ba4-01bae0419be0', 269, 'hs_office.bankaccount');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f3140f7e-5045-4534-92aa-e918895bfafb', 270, 'hs_office.bankaccount');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('3d0e6bb5-a62e-4225-a2bb-967c76926705', 271, 'hs_office.sepamandate');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 272, 'hs_office.sepamandate');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('850aa448-3a14-440c-9834-0b7ef6d83c39', 273, 'hs_office.sepamandate');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 274, 'hs_office.sepamandate');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('466056f2-efc6-45d6-b778-fa111db7a18b', 275, 'hs_office.sepamandate');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('e2dd08d5-2083-44ef-bf22-57898af08e3e', 276, 'hs_office.sepamandate');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('51a4690c-bb0e-4be2-a285-31552f900db6', 277, 'hs_office.sepamandate');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('925e61ee-5120-4205-b609-18083af2c4d6', 278, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9', 279, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('e27e543b-f15b-4e0b-98fc-ce72bcd5d258', 280, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('d9c28f32-a87e-4f2e-af07-75a76004907b', 281, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('b0a9b8a6-8709-4210-b4ad-eadcab6f7866', 282, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('d3e130d9-9288-4d74-8699-1778d2f5c151', 283, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('110138a4-46e3-418b-8ce2-095da9c6b98c', 284, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('0565d216-af16-45aa-86e5-9ca55751322f', 285, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('c7d34de2-7cbd-480a-9ce5-a574ef7248d8', 286, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('147820f5-533d-471d-9f54-99e087ec37c6', 287, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('eb40ed40-ebf5-401a-b498-ecc46928a17d', 288, 'hs_office.coopsharetx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('f9c724b4-3965-4cfa-bc93-5b780b2362e7', 289, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('1b444a8f-352d-4812-97aa-bd1e649201f8', 290, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('2b1590f1-c1b8-4318-9879-8e2d898fa4a5', 291, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('0f05f1bd-403c-4239-8595-d317bba58a32', 292, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('2cca894b-c08a-4b36-b809-d417cf0b305c', 293, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('b4acab9a-7a54-42df-bd35-717f052b407d', 294, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('fab99b6c-dd05-451f-a9e7-80891ec94db1', 295, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb', 296, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('9f3ea248-0492-43af-8430-2cbe4ae3338b', 297, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('02362331-8069-4712-9c39-371973edb192', 298, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('899a89c3-6715-4a37-bb69-1ed124e0a23f', 299, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', 300, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('568b153a-13dd-4510-b681-13b53f866091', 301, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('6d4e335b-f22c-48d8-98b3-0da4ad759e65', 302, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('105e8365-c8b6-4d69-bef4-8bc388524462', 303, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('5b516553-2772-4591-b4bf-4f353e598c79', 304, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('df223672-3c4b-4044-8f54-1794a50c957e', 305, 'hs_office.coopassettx');
INSERT INTO rbac.object (uuid, serialid, objecttable) VALUES ('cd8cd45a-a4af-46ce-a434-5b5208095346', 306, 'hs_office.coopassettx');


--
-- Data for Name: permission; Type: TABLE DATA; Schema: rbac; Owner: test
--

INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('47b0efd3-0e9a-4275-b2c5-d50dd2b22024', '33af1d05-a7de-4552-9118-7900fe5fde7d', 'INSERT', 'rbactest.customer');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ae085da6-9278-48f0-a2d2-b214f0cd55ab', '33af1d05-a7de-4552-9118-7900fe5fde7d', 'INSERT', 'hs_office.partner');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e4082d20-6277-4b51-b70b-1d41375748c4', '33af1d05-a7de-4552-9118-7900fe5fde7d', 'INSERT', 'hs_office.partner_details');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9c5062d4-6ed6-4284-967e-7e661a0f8016', '33af1d05-a7de-4552-9118-7900fe5fde7d', 'INSERT', 'hs_office.debitor');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('41688207-eecb-4233-b9b2-5f18eee23546', '33af1d05-a7de-4552-9118-7900fe5fde7d', 'INSERT', 'hs_office.membership');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8a96713c-f52a-494b-9856-5a7cc869449b', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0debf423-4128-4959-94b6-c4e17adfd25f', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('bd35e25f-a9d7-41f9-835d-55026654c03c', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d0ee13fb-5f61-40d3-b38e-02eafd89160f', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e6970814-b140-4805-95f3-610c215eb5ab', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e3c18d7e-cb24-4063-b0ac-dcb8fd3d2b68', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('eb43edcb-0d20-4614-b45c-736ef4f56380', 'd363745a-e94f-48be-8397-4b361570a54d', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('db94672f-1fbf-4898-bff8-2bfb5b2450a3', 'd363745a-e94f-48be-8397-4b361570a54d', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3cdad6bf-60f7-4dd7-80b8-4b1bfbc0f7b7', 'd363745a-e94f-48be-8397-4b361570a54d', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('684d7313-c093-4da0-83e8-bd73c6cc0bb6', '7a334268-7d11-4765-8fa9-17e2c36cca7a', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('42a22abb-f604-4980-b6fa-adb1aa4e0adf', '7a334268-7d11-4765-8fa9-17e2c36cca7a', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d226bd12-192c-43f1-bc65-45803a17c4a3', '7a334268-7d11-4765-8fa9-17e2c36cca7a', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('deebf94a-2ef8-40bd-8538-9227bb901fee', '33b40eee-30ed-4924-859d-6c58b5aa4124', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a3aee0e9-b8f3-4262-80ae-5cc6154cdc10', '33b40eee-30ed-4924-859d-6c58b5aa4124', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4fe450ed-3a24-49b8-98cc-fa85de9ce889', '33b40eee-30ed-4924-859d-6c58b5aa4124', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c11382ee-e0e3-4b25-b8ba-640dde8c20bf', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0d98be37-8ae9-48c8-9bff-6b7581e256fa', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('de8da2bb-9e4d-44e7-ad03-e9763db4331f', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('390087c9-9c6f-4c2f-9c77-af65112c520a', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ea4baec8-4128-4e59-b0e1-69b450c46755', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e9887f07-65e4-4b5b-a134-f023fb127cbf', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2e07da63-f1f6-4342-b090-f3c465e9093a', 'caac18bd-9277-47ac-99bb-368e2d64dac0', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c8cc9a24-e3d0-412d-867b-8e617e40f1e3', 'caac18bd-9277-47ac-99bb-368e2d64dac0', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('32b78d45-4a5c-48a5-bec2-efacd97dc76b', 'caac18bd-9277-47ac-99bb-368e2d64dac0', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('caa58c78-6540-4f75-a24c-d4ea5f218cb0', 'eead6995-dd54-475f-8194-74445c421305', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ae30faa4-b82e-4e65-8324-360fdba2d504', 'eead6995-dd54-475f-8194-74445c421305', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f38fcb66-ea16-41fb-abdc-ea3df857d5e4', 'eead6995-dd54-475f-8194-74445c421305', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('81ea98dc-258a-4ab6-8537-8de22e9e90be', '4b68de11-a658-44bb-be49-ad592e73e3d8', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0a2e575c-9d22-42e7-8446-546ac3cda8ed', '4b68de11-a658-44bb-be49-ad592e73e3d8', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b1efc8c9-2f6c-4ec2-84e5-29444c0fcd29', '4b68de11-a658-44bb-be49-ad592e73e3d8', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9444adae-37a0-434e-97b7-3304b5577498', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e17045f7-b4ef-4c12-beee-56b1b5ef7190', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d6d69027-db1a-444c-be6a-e14232b71647', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('511d8f3d-266d-4c3a-9091-a7b16d8e61bc', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('61aef2e8-ca62-4a62-8a4c-6a56f6fa6880', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f03d3fab-a32c-40a8-9fb3-ff456bbb7f45', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4a861961-b89b-4ed1-8a22-076edb1fe182', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0c9f6461-5ab3-4c39-870d-e66aacd5d522', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7d188b98-3755-4753-b776-7226df8db3bb', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8973550c-23a8-40d5-bd36-4b4f8608841e', '9dcab961-1465-40e3-8d83-357b22af2674', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e887ff28-0576-46a5-8faa-b4167f9cab6a', '9dcab961-1465-40e3-8d83-357b22af2674', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6becffbf-7ca9-422d-a429-c022f023d9ae', '9dcab961-1465-40e3-8d83-357b22af2674', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('32860409-f9d0-41f3-b19e-25a38bdabc3f', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('44f00bec-0091-4523-9235-84aa669de6df', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('efb67518-722d-4f1b-8280-e3f894406dd5', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b8a958a1-b18b-4198-995c-7057791c7b6f', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e3eeab03-d7bd-4dcc-b076-3bca06fcedcd', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1be4a900-49fe-4fef-b4f5-47643f463859', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ea674a43-6195-4c02-8bbf-88c2255030ce', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e6b918a1-edaa-4170-b6eb-9c8257b9a72a', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c3fa6a59-6d7a-4f1a-a5a5-3ebf64250a5d', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c21abea9-6973-44c7-91f4-2d163d97764d', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b94eb65e-0105-4cf9-b238-cd3e4715c08d', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('98ecef93-9816-44dc-a028-61cc9403efb9', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('eed193d1-f65d-4738-b8ee-d991aeea4389', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('03602c91-9c55-4264-8c24-9f9d3cbaf869', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f8a806d8-a37b-4513-a77d-26cf05108c68', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d53e98ff-47a8-4be8-a668-c3b45398f278', '137fb47a-07d4-42cc-b2ef-8e371041cf41', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cad96a06-91b7-43d8-897d-7bfb1d7054fc', '137fb47a-07d4-42cc-b2ef-8e371041cf41', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('11749bf4-1bba-4698-93cc-41cd8d261166', '137fb47a-07d4-42cc-b2ef-8e371041cf41', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3807de9b-30c6-4a1a-a434-85e80560d3b5', '137fb47a-07d4-42cc-b2ef-8e371041cf41', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0beca0d8-2895-476e-afce-0923bba7e701', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c8f5fe32-5429-4991-8d88-ba9a79aead8a', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ff0dff7c-9ef6-4ffd-916b-7a4fad718e8e', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7880ca8d-9bf6-4ae4-9056-5677ef591442', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3f16c617-f9ff-4634-b4b6-2cee590e2cd0', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4812d3ef-02dc-4a03-8d13-7661dd92477d', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('624f1c38-a8ba-40a3-8f6b-dfe76cc36034', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('195afe34-3bc9-43cb-86f7-7eadfb5d25cf', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('08a3ffd0-77e4-4759-ad73-d42ca4d2d807', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6e962b9c-39cd-4cec-9750-c36419ff6319', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a5eeaa7d-bf09-41e9-9414-470442665789', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1f552123-71ce-43f0-b091-a43adb7a8a0c', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4cc5242e-7cc3-426c-9025-ccab1d8a895a', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('60dbf8ee-3263-4878-990f-ab43fe96e48c', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ba27345e-0699-437d-b4ca-24a8e326c345', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f2850544-cbc8-4add-ad35-4b634370b913', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d1767f98-0fc1-48e6-ab30-0cab02504ee2', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c1816e75-de8d-480d-9a62-30805b9d2f99', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('374b8a48-00ec-4df2-9320-848bedfad9de', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c55c0032-b1a4-47ac-89da-bb9c527a4a73', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cf0de0eb-126c-4c60-aaf0-626f5c17820a', 'ff030436-d19e-4606-9d48-7e192eaf469f', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('38061696-b53f-42a9-86c0-77b7196a871a', 'ff030436-d19e-4606-9d48-7e192eaf469f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('594d657f-567a-4e69-b28d-f2b79136ca2d', 'ff030436-d19e-4606-9d48-7e192eaf469f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('99c49e4f-cfe3-41d3-940e-915c2a2e9641', 'ff030436-d19e-4606-9d48-7e192eaf469f', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d7a0d94a-c274-439a-b500-0f69b13c49fc', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('eb7e6ebf-472b-40b5-9d88-47263fdb01cf', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('de1d831c-b96c-44fa-80a3-725856c6f998', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8cc95b98-8edc-4652-ae4b-9752d3cfd6b1', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1bcffd04-b60d-4cdc-8fe7-df9bd04caf47', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7637bd59-9da5-4cdc-a37c-dd588769d092', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b66e76e3-086f-4edd-86f7-b052ada8397d', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c1d3e826-4d68-4ec3-b3c4-5617a1c14371', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0144b94f-8302-4eeb-bc90-d09e06966ac7', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6587000d-2225-474f-a5c3-480188036398', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('353d7a47-2248-4875-9776-469e7a028cae', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0488a5bf-a825-4105-965f-3fa793d5b9c4', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2d7800a6-63a8-4017-9613-6c693d3cd171', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2f06897d-859c-4e56-b9c2-947d128e3d63', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4d6a853b-5d93-4400-ba4c-a28a96721af5', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cb9db0cb-6a60-4f56-85e9-97ca9734071e', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b38a6e56-e439-44d2-9ed6-3223e21c6224', '38cc5d59-085f-449e-aeb3-439febbabd9b', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c3a212dc-036f-4e84-84b9-6e7367b407a1', '38cc5d59-085f-449e-aeb3-439febbabd9b', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d96f1d59-085b-4c42-9e01-1513b232a067', '38cc5d59-085f-449e-aeb3-439febbabd9b', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d8d23634-f1c6-4a13-bb39-bae8e187df04', '38cc5d59-085f-449e-aeb3-439febbabd9b', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f3e17013-eb06-49e1-94a8-2e81e0f8a706', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6712a948-ac81-455e-8d87-cb05438ac85d', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3e298df0-8c98-4e48-a103-cfd3bbe2bec6', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('afceedea-4a23-4f6f-a0a2-a210ac148935', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9fe16585-5125-43c0-a683-f4d1579f784b', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9405dc92-3dc7-4f4a-b799-514ce78ac05a', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0b519921-7548-446f-a6e2-0986f0cec622', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6d013dc5-c320-4873-99bb-d3cbd287ccf5', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('08008ffa-675e-46e6-8f5c-bbb701d67fd1', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c8583847-e84a-4286-b04f-368c61118b00', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ea2e5ea3-6e8e-473e-9bca-3972c30c727a', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c33ab3ab-3d3d-44be-987e-9f1ad950f25c', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ede31012-fbaa-4a4a-b5db-001a2ded08ea', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('dbc52a0b-fe89-46a8-89a8-f155a437fe07', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cd5218c0-fc28-464c-bb9e-ea0eb9698f66', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('10cd909b-0099-491f-9a73-0cf1d7765f35', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('bd7f4de4-1435-42c2-a275-b56e49670e52', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3086d58a-42c3-4c88-ba4c-a1025e79218d', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c123b9c1-7755-4fa5-a0c8-ab6bcb0c7156', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('529abd87-8855-4eab-a795-a83717bfa4b1', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6aa26a03-2515-4b88-97aa-1d100dfe872b', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8695131e-a5fe-4e01-81da-99769f924a12', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('10063dba-d6d4-43fa-ab89-d682c47a91fe', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('70cf4eb5-99e5-49d1-9c03-70316381bb21', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'INSERT', 'hs_office.relation');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cf95f6ed-2e24-45ae-824d-8cc58ee2c2e4', '48618c28-9304-4ccb-b022-e2cbb1832944', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8e9ae339-2166-48b7-82e7-f319413db079', '48618c28-9304-4ccb-b022-e2cbb1832944', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ddcd1293-8e77-4cef-91ac-9abfbc2bcd44', '48618c28-9304-4ccb-b022-e2cbb1832944', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('43b09570-1e0c-43b9-811c-4aeb27eba284', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('756acc01-691c-46c1-b2f4-53321cc442a2', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('75550e48-c62e-4734-9406-ad720b5b1f90', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f3bf0870-b546-4607-a032-a3da135dda48', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'INSERT', 'hs_office.sepamandate');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9998b7f8-aa0f-44b9-813c-61a2861e242e', '201b417e-4ebe-458b-a7ce-a287c0ad9287', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7ffabc42-58db-42c2-a3cb-e4ed830f47af', '201b417e-4ebe-458b-a7ce-a287c0ad9287', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('11a4c50e-451c-4041-92c6-671263f82f2d', '201b417e-4ebe-458b-a7ce-a287c0ad9287', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a78188dd-3129-488c-b6e1-4889725f5215', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('19382a5a-b982-49ac-9005-9358fa7a670a', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6ebe0c4d-1649-4d08-897e-805019faced9', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f5fc0f70-790b-460b-a072-d1f9c01bc7de', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'INSERT', 'hs_office.sepamandate');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fc09e45c-99c6-46ff-a51f-39de6d561c93', 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('87567caf-5abc-4511-9191-27dbdbbee88b', 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5fe9a533-2cd3-4433-811c-fcc415acdf60', 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('359d8691-dc07-4b5a-9179-0f78927b4660', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2698d560-1c07-48e5-9d9a-78ccfb2c0631', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('21bc4186-042f-4643-bbea-61f44563225d', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7ceb0f31-aa57-433f-a2e3-0408c2b88b10', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'INSERT', 'hs_office.sepamandate');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('24c34e16-c5e6-4571-b850-fb64b5ddb61f', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8aa371b8-dd2d-4471-95ae-149e30502e54', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6aa35ccf-fc0c-4fa9-baf3-383bd7c6bc42', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('12bf1e90-3965-415a-b2fa-de48afca81f5', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e3026ecc-4a37-438b-b53e-e4ac2d4acd87', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a9296dcc-a040-460e-9319-d93938975fc1', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7b9008d5-0555-4209-8594-8d2c11e376d2', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'INSERT', 'hs_office.sepamandate');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c470f55a-75fd-4754-95d8-02db7679b5e6', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('306c497c-f967-41e4-88a6-6d357955a6b4', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a43a17b9-e207-4edd-9184-790b10b105ce', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b93cca78-ac4f-497a-90b4-2fbb41ece3a5', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('78de8932-0d41-49a3-bd52-4b01648d77c4', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('73fbb1f4-99ac-43f3-8d7c-e032f636754d', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('57083628-836d-4f19-9359-5fb11537f81d', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'INSERT', 'hs_office.sepamandate');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('65238cdd-b9f4-40ce-87db-581432f3c7b8', '164d3cde-e2ab-4239-9dbf-de1c963158ac', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('31b17fc6-f132-43a5-8e48-652c48306331', '164d3cde-e2ab-4239-9dbf-de1c963158ac', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('aa9b0636-bcef-4296-bfc4-2beb3c99da38', '164d3cde-e2ab-4239-9dbf-de1c963158ac', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1350b6fe-91ee-4c79-bc87-e2632a01100f', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('bff60077-ab16-4e5d-8667-1ad2b801b961', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2b36563d-caee-4170-b444-ec02ca919165', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('dbead323-2088-4b0b-ac6c-599696219411', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'INSERT', 'hs_office.sepamandate');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b6f28163-8b15-403b-ad8e-8322ae8bb5b9', 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9cf4d386-c968-40c4-8af9-401c58cca6b4', 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('14b3a0c2-46d5-409e-bd0d-ff369c37950a', 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d6ea4d88-241f-4430-9590-918a5de2a3d4', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5c038c2d-e3f8-4593-9733-0e1d2c85e318', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('63a0e010-3a4d-4ec7-bcd5-2fa63a1cca23', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fc2159a0-53c2-416b-9daf-506258c420e3', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'INSERT', 'hs_office.sepamandate');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9de4eb42-73cf-4178-ad43-0bc7b9042c76', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e1cd9ef3-11e4-4907-bb78-b30f83f576e8', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2877af8d-ece8-4b33-8b68-a4985caa2635', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a4b7dd17-bc12-4152-80e0-4186caab003a', '268c2ce6-8945-4393-9916-ac90050f064a', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3dec9bdf-06fc-4a27-b26d-5918ad1e5990', '268c2ce6-8945-4393-9916-ac90050f064a', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7efca22b-d9ff-4331-a718-ddfca5ebac59', '268c2ce6-8945-4393-9916-ac90050f064a', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('85505863-6857-4ae9-82de-f9394eebd7df', '268c2ce6-8945-4393-9916-ac90050f064a', 'INSERT', 'hs_office.sepamandate');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ccdf92f5-ebce-4d9b-b544-e470959b498b', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('307b971b-39bf-4a5d-8595-ad080abafbb0', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('37dc0f00-4620-46dc-83a6-3d64cbc7a1a2', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('84fffac0-e3e1-4374-a4e1-6d16b91d9e8f', '86b706e2-9225-482e-b82a-d4ac4adab065', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7a5ed45e-7096-4f48-a0d9-83df51f3349c', '86b706e2-9225-482e-b82a-d4ac4adab065', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f2395c78-9098-4d15-9ac4-b330a6802390', '86b706e2-9225-482e-b82a-d4ac4adab065', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b371c978-c2d9-4b06-94be-a0944f0e8b34', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f8fd6f7e-9507-47ad-ab42-fbd72c3718f1', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9fb3f5e1-472b-4679-a4a8-099557352ec7', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('909ff58a-4c4c-410d-a3eb-f17cf15c330c', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2b643877-6882-4d24-bf51-fb39d8a59287', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('51982882-3575-40c4-86a1-c05fedc436db', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5ce74841-55a0-48a2-86ff-253dcfdf8a6f', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fe903d29-2b20-4f62-8973-ce885b0d03ab', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fa80b5e8-d9c5-4d4e-b7c7-3eb28a90f991', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('118e8006-bf10-4b7d-8f07-fb4b8d9de592', '47b7bd3f-8668-4934-bee9-56708e835d7f', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a2f2cc36-6c62-44e0-aaec-b4749ed25558', '47b7bd3f-8668-4934-bee9-56708e835d7f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('252d4677-4f71-4719-a287-37245b03a8bf', '47b7bd3f-8668-4934-bee9-56708e835d7f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5367452a-5726-452f-a76b-8393cc5e6689', '80a9daef-e282-499a-ab2f-98a016edb8f7', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1a32ebbf-8e70-4268-bb9e-dbcc7a501b71', '80a9daef-e282-499a-ab2f-98a016edb8f7', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('af6f87de-0aa9-4320-b5ba-96a8ac23c9e6', '80a9daef-e282-499a-ab2f-98a016edb8f7', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9821f69a-b029-4a8f-b1b3-229517380f60', '93d9827e-63dc-418e-a021-25b400847b2e', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8bee7b6c-05f5-4538-baf9-452d909f0657', '93d9827e-63dc-418e-a021-25b400847b2e', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2c0faec0-6d09-48e9-9ba5-ef060e4d5f6b', '93d9827e-63dc-418e-a021-25b400847b2e', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('94866c63-1d9f-4b00-b0ff-c6f48c5d6462', 'f4219fae-353d-4324-90ca-9f313a8c1c17', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d86f4fc3-58a6-4464-8836-4ce8b34f25c9', 'f4219fae-353d-4324-90ca-9f313a8c1c17', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e6d44cf8-f6fa-4138-8410-982613c62c49', 'f4219fae-353d-4324-90ca-9f313a8c1c17', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('37c59916-a966-4dca-a1e3-0cffb78ad141', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b546d5b0-59f6-44af-a54d-d8e3097a3640', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c2ccc14e-f11b-497f-95db-5397aa38012b', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('36490d00-f5d4-4722-b285-9cac45e7dd5c', 'ed0fb977-6512-4452-8505-378fcbbd5060', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('891fe7ab-2113-4f20-ab6d-3d81cca0941a', 'ed0fb977-6512-4452-8505-378fcbbd5060', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('10ff5603-7bfa-490e-a468-6d231db02ac6', 'ed0fb977-6512-4452-8505-378fcbbd5060', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d53e3095-38c0-4be0-b7c4-17d6c505c370', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('39a2c817-387a-4a54-a751-6dfc0d781f8c', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('09cb2efd-3998-4b84-a315-788b6375ffa6', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5c5e2c73-6a91-4b38-a290-fb7fc94d6cc0', 'af82432c-09a8-42a7-9525-e9095025d4dd', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('708ff719-70c9-48f5-8664-dbf49352d261', 'af82432c-09a8-42a7-9525-e9095025d4dd', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7fd8da11-6a47-4ca3-8bf3-9713a6ac0305', 'af82432c-09a8-42a7-9525-e9095025d4dd', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('63ab27e2-5a5b-483e-8346-0024da814b06', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('14fd3310-5109-472b-9eb8-9b3aac0cc5c8', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a351e412-5f16-4c87-b09f-6c0290e20b7c', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0fc0933c-0397-4b0d-ae81-18c41d3fe082', '65879210-cf7c-4e5b-a2d1-742a42fcb488', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('133a7879-3f1c-4daf-8b16-9160b4477288', '65879210-cf7c-4e5b-a2d1-742a42fcb488', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d2ef2562-a654-4af3-b1eb-6e8bcd35c03e', '65879210-cf7c-4e5b-a2d1-742a42fcb488', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5ae15451-1a59-45da-b59d-02884a418fc1', '97e5ed67-e81c-4c12-b354-45db951901c0', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c0844f33-c3b3-477f-9321-4b342474802a', '97e5ed67-e81c-4c12-b354-45db951901c0', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c8d78c39-6d4d-48a7-96f8-80fdc50b2059', '97e5ed67-e81c-4c12-b354-45db951901c0', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('19932b77-d4fd-4664-a0c6-ff8fb707f697', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a71abf2a-ab11-4bdd-8591-6977673bdc32', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e1cfb24e-d3c2-4279-b1b7-0e037766a0c3', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3c82a048-8d56-4f34-98c4-a20e193f815e', '2eec1138-d2ad-43de-a105-605d0182a1f8', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a9ce43ae-4dd7-4ee8-bf8d-d2f3fba4c803', '2eec1138-d2ad-43de-a105-605d0182a1f8', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1230adbc-b61a-4ba1-b298-c831c2862e8f', '2eec1138-d2ad-43de-a105-605d0182a1f8', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8c70ecf7-82ce-4661-8cc5-0fadbcc4151a', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7aceef4b-2faa-48c5-8355-72db528f4822', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('24fab1b7-ae06-42e0-8746-4754b526994d', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('13d82035-64c5-4ca9-a85e-988bc4a2eb4d', 'fad03414-b62b-45d4-93fd-51c52149762c', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('62ca73f6-89b1-4113-92ba-a7823aabf31e', 'fad03414-b62b-45d4-93fd-51c52149762c', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('740e371f-18b1-4e93-8408-2fcc777b7da6', 'fad03414-b62b-45d4-93fd-51c52149762c', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2c15e623-a22a-435b-a125-3edbf2a9b5f5', '48a0fa39-0d72-4c0a-800f-afed02865850', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1c9c5558-dd2c-4293-bfcb-0160e981b6e0', '48a0fa39-0d72-4c0a-800f-afed02865850', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('19241a87-0b31-4156-a479-cdb61cafaa66', '48a0fa39-0d72-4c0a-800f-afed02865850', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('22b95a69-d861-4d90-bfef-a9c3f4ba5d52', 'a84434fd-e879-4208-a8e8-8095e22b72bf', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a1ad0f25-f3ab-4bfa-8e4d-674d7ddc3ae7', 'a84434fd-e879-4208-a8e8-8095e22b72bf', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5feb8ea2-f497-4058-b056-dd96514c70c5', 'a84434fd-e879-4208-a8e8-8095e22b72bf', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('164e7fa0-ccac-4331-be5a-dc965b1c31d6', '93d87d13-efdb-4d31-83e6-3b13db983c12', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('dbee33c8-80d8-40c9-9d16-af5c99aea9ae', '93d87d13-efdb-4d31-83e6-3b13db983c12', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1b4208a5-e7ba-460e-922f-a9fb5c7e79e7', '93d87d13-efdb-4d31-83e6-3b13db983c12', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cebd9ecc-f841-4d44-a3fe-3c82827f2918', 'bad214a0-5220-4433-8714-52e4c736585a', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ac3ee728-8957-4b2e-91d7-9f7a0e543931', 'bad214a0-5220-4433-8714-52e4c736585a', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('30b91518-31ef-4b3f-a539-c1f7566e0c77', 'bad214a0-5220-4433-8714-52e4c736585a', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fa9a7713-93f2-46c6-b3de-9d6e42bce983', '5add96a4-6fff-4fe2-8628-669d72252417', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('052b4092-a5bf-47f3-8ba2-0734ec9129d4', '5add96a4-6fff-4fe2-8628-669d72252417', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4c75b994-e714-4781-a51d-6f582ae07f6e', '5add96a4-6fff-4fe2-8628-669d72252417', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('05a6b2b6-58dc-4310-bcf1-d923168e2070', '2185083d-3134-4b30-9dcb-674058feaac2', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9ddb3c98-f345-4f59-b067-7673d0e06673', '2185083d-3134-4b30-9dcb-674058feaac2', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8a7273c3-5012-45bd-9d3f-72dd52163117', '2185083d-3134-4b30-9dcb-674058feaac2', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b31618ff-d749-4aa9-86b8-08eb2de9dcac', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9b229b0a-e7b9-4fce-a134-c6f5199ce495', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('46ba8c49-58f7-441b-a7c0-290a9f490a1f', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1be877de-9e9e-478b-855b-f4f0e6dfb842', '17ea3654-289d-4892-a837-3ddcaea2d7db', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7a48ec29-24be-4d13-b788-264eb6fe6327', '17ea3654-289d-4892-a837-3ddcaea2d7db', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2fc229bc-25f7-407d-bdfc-e9469c17ca34', '17ea3654-289d-4892-a837-3ddcaea2d7db', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('46d04d79-5187-44ec-8f30-e6f823bc47e6', '60702c01-7285-4eea-a937-6019d6e3661d', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3817a2b3-7031-4489-8c87-23babe729843', '60702c01-7285-4eea-a937-6019d6e3661d', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d241e268-fffd-4d21-9936-819ae9975f85', '60702c01-7285-4eea-a937-6019d6e3661d', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1bc97522-8adf-4246-bb4f-9a870002fbd4', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7ee9690d-ebff-4afb-95db-fad387eb4255', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2d00deb0-bb73-447f-b867-71be2d2dbfda', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3a64d35c-f155-4420-a87f-ddd771f7e500', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('238a91bb-2186-41f0-a97b-6e4c62a2c6a8', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0dc256f1-c7eb-4c52-95b6-a05ef1f92d4f', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8b30e218-5562-41af-82ce-bf3f633d1f3d', '8363ec62-6d90-4dd9-940b-6073b3246c39', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('31a9442f-92c2-4f7d-9895-a7095ee96952', '8363ec62-6d90-4dd9-940b-6073b3246c39', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('bacb714c-ac84-4f51-b8e3-fc74b27e1388', '8363ec62-6d90-4dd9-940b-6073b3246c39', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4f6ce070-55e4-4d2c-9429-5d4b3fa25077', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('274595e4-31af-488a-997e-688d10886a47', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('596f965f-b224-495b-9f5f-5150af69979f', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e77c42c3-559a-44af-90cd-304eab1646a5', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0ab92d43-0a98-4d77-9f65-44d74acfe5b8', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f6542fe1-149a-4244-b812-18ad82ff555f', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2715a520-f38d-486b-9053-055f6289c966', 'a13af5de-4315-46dd-ae08-427ea72b35a0', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1a09398f-873b-4c9a-9392-c129ccf0d636', 'a13af5de-4315-46dd-ae08-427ea72b35a0', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('44074e80-79cc-4965-9525-29ed20419544', 'a13af5de-4315-46dd-ae08-427ea72b35a0', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ab127630-3367-4898-b0d7-f3ef0f6fb7cf', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('53f0c6bb-a76b-4f8d-81f9-a476c9106436', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('88d7ad95-2568-4cfe-8f1c-e09ac9fe8983', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('dd52b6d9-4a90-4a10-9ca8-3d8094a0aadd', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('138ab6b6-1b04-4565-bbcf-db30047e0050', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('beec505c-c47c-46ff-bdb5-7fe04a5595c6', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ebf101f3-6206-4cd7-a5df-276dcec51cba', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('31faa035-267f-46d2-b9b1-af688c393431', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2b33fc20-f3b2-474c-9d9e-40be8240e900', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('36c7d299-20b9-47b4-a2ed-bd7031ad3dd1', '18124f89-8ce6-4813-8efe-3ed47b7eb453', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('95ad7ff4-f585-48c5-945a-1a87c3bb2229', '18124f89-8ce6-4813-8efe-3ed47b7eb453', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1be5be35-a23a-4f02-967b-f4a7237f482a', '18124f89-8ce6-4813-8efe-3ed47b7eb453', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('eb9181ce-7b72-4ed9-93aa-49eb66db32eb', 'cbda6432-b849-4787-84ab-88e680dbfa72', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f9768956-c483-4cf1-852d-b6767a8d96cc', 'cbda6432-b849-4787-84ab-88e680dbfa72', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a37b1549-de63-4830-81ab-816dbea5ddf9', 'cbda6432-b849-4787-84ab-88e680dbfa72', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('283a7da7-7cf5-489b-bd81-a370cd694f3a', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fe2d0171-effb-42e9-ad87-d877454fa221', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c4f3311d-618c-4e1b-9e0e-925465a5f932', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f276aa53-a904-46ec-863b-18e593fd2c3e', '4761d35a-2de3-4415-a91d-f53d15162aea', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('17df9716-97f3-4970-813b-d144044d718f', '4761d35a-2de3-4415-a91d-f53d15162aea', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('82813289-dc57-4c85-8c73-8e7f71966bbc', '4761d35a-2de3-4415-a91d-f53d15162aea', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('54ab8484-47e5-432c-afd4-7791561e09a7', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('846820c5-9147-4f79-9b06-62110498d191', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7cfdc7ad-f7bc-42d1-9b72-ce871adf665b', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b0f7eade-7384-445b-9f6a-76f19007d9b7', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4a4b0f7b-8506-4ed5-be19-7c0baa476c45', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('815ba931-a309-42fc-8865-b077937d4bd5', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d7dd1750-2c6a-48b1-bfa7-ad708c3df73a', '4dbf555d-3375-442e-a87d-815d1492af55', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('20af1fdc-7bf2-4f7c-941d-5294057a2148', '4dbf555d-3375-442e-a87d-815d1492af55', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d0bcff97-900b-4660-9245-993dee9485eb', '4dbf555d-3375-442e-a87d-815d1492af55', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('36e09c9c-05d3-46fd-ba19-91e3dbb1ded0', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ae3d0091-aa98-44a3-adbb-2552b6179e97', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7ac91a3d-9409-471f-b6f6-8f50ea03a292', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b0a82131-7ecd-4685-be5a-89dd1c4cc7de', 'e74992df-66a8-4572-9e55-ec7b210f04e0', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0897f76b-9b66-45ae-a884-5c7edd121433', 'e74992df-66a8-4572-9e55-ec7b210f04e0', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4d79f2a1-1130-4416-8c72-b6cc85740644', 'e74992df-66a8-4572-9e55-ec7b210f04e0', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('44a911af-8a2f-431f-9e1e-004746901334', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c885871c-5f3b-4a02-a550-f962132d898b', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cfdfa9ee-7570-4a4f-bad4-0e18fdff5004', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f7eab9a0-7f14-487c-9434-669dca849b40', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('819393f7-e96d-499b-8663-3adaaf1b0a73', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f3d00781-37e2-4b9a-8107-bdc123df38d7', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cbff4b85-4722-4e87-8adb-34923d9987c0', '047364a5-9dcb-4027-a94c-e35f4646860e', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6f009e98-a9a4-4d93-92e2-e955d04bb7e4', '047364a5-9dcb-4027-a94c-e35f4646860e', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('21a21577-f8e6-4856-8c80-996000f525c9', '047364a5-9dcb-4027-a94c-e35f4646860e', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('160977ed-ef11-43d8-9ff7-af86c743d2ab', '08e80808-fb86-4503-ab9b-9652af82d5b5', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d94fd859-6e03-44a1-ac1d-059ed72e23d3', '08e80808-fb86-4503-ab9b-9652af82d5b5', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ebb468b1-047a-492c-a76c-5031645e7824', '08e80808-fb86-4503-ab9b-9652af82d5b5', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a2effc4a-acdc-4660-973d-e5313a9df528', '91b63591-b1e2-4c65-8ad2-c607be4c1238', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('42491f82-8223-4dbf-8660-688e35fc5694', '91b63591-b1e2-4c65-8ad2-c607be4c1238', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('aaaf21f7-baff-4867-b84f-36a16f0fcbf1', '91b63591-b1e2-4c65-8ad2-c607be4c1238', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('66b246c1-b389-40b7-b238-48903a3dae95', '6da29bfa-4744-437f-aed3-2695571c58bf', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ddcec555-0f99-4cec-9d45-b0ddd4e7fb26', '6da29bfa-4744-437f-aed3-2695571c58bf', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('76d3e38c-0889-4169-814d-5f7e36c0c767', '6da29bfa-4744-437f-aed3-2695571c58bf', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4d9e1a7c-84fa-43c7-a1d7-e898b20df129', 'db7f287e-dfd7-4627-88e3-407cac226472', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8c236a58-3fab-421e-b8a3-6c9df1269fed', 'db7f287e-dfd7-4627-88e3-407cac226472', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a4b5890e-c3d9-4eda-8a8c-3ebc20a39061', 'db7f287e-dfd7-4627-88e3-407cac226472', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f35bc896-c93b-42ca-994d-4f5f4e2e5b5f', '7b7a528d-a284-4d0d-99ce-73f2a7585f78', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a5aac82c-b1b9-43d0-90bc-e7c0e0341e1c', '7b7a528d-a284-4d0d-99ce-73f2a7585f78', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6372e9ae-f522-468e-95b5-06a527854b0f', '7b7a528d-a284-4d0d-99ce-73f2a7585f78', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('35f61da7-bd75-4482-ad05-d50ba7e099ca', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3c22ad48-dc16-4af3-8bbb-54ce2b7d91d1', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d5009976-c8c8-4d64-b39e-08f019999ae9', 'a083dfa1-afb0-4531-8a1b-8f4ba78a6215', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9f2f2eae-80dc-49c7-810a-69b10fcc3421', 'f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('42557861-103c-4fb7-b3c6-0acd3d7737c2', 'f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('85dbc28b-c5c3-4914-b645-a36056f4cf17', 'f7d7c4cd-e05c-4a38-8fe7-41ea99ef9787', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('45cfb9f8-8e5e-438d-90f7-6b1ee872c003', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ac1f7518-f255-47bd-bf31-29d3cd2bb57a', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b45ba485-ee82-447e-8a4d-42679a233455', '029b1c78-d68b-48e6-83e5-8883b9cefe7c', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ac9bd6e7-e7b5-4f25-a873-79ff3436fa66', '90604765-0e48-4363-83e4-1c2e9e4a8f33', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('52d12930-5ca0-4344-bf72-32faf8dc5d9c', '90604765-0e48-4363-83e4-1c2e9e4a8f33', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ba038cc8-3ca3-4c25-9805-08eef60945b5', '90604765-0e48-4363-83e4-1c2e9e4a8f33', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b5be48c3-0721-406c-bf86-b7dc1d6a7016', '58ca016b-15ea-41e3-80ba-2603bf736619', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ba8ff028-06d6-4536-8e79-6c46f8e4b9a2', '58ca016b-15ea-41e3-80ba-2603bf736619', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('470fa9af-f292-4516-be71-346b1e987d83', '58ca016b-15ea-41e3-80ba-2603bf736619', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e62715a8-2e69-4a59-806e-000886fedd92', 'a7494bd0-af97-421e-bfa3-53bd97fb1df8', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0f8fd73f-526c-4e76-a5f1-043e44386cc3', 'a7494bd0-af97-421e-bfa3-53bd97fb1df8', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0e0eb247-f0a2-435b-b44c-34ffc5ecfda6', 'a7494bd0-af97-421e-bfa3-53bd97fb1df8', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1aa9a0f2-47a7-498d-b0e8-9e73ef9f5b00', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('57130e2a-328a-4402-bd54-a76cb815503c', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0baaa10d-4abf-42df-9689-d6d72a9cc418', 'defa6288-bed7-4ed8-ae6d-fbbb3530a632', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7c958983-efb4-4117-a2a6-4a3d35c233b5', 'f1048d9f-e560-459a-91fe-f769ef049648', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c9732223-5e57-4d36-b412-91122ecb900f', 'f1048d9f-e560-459a-91fe-f769ef049648', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a1476e12-e8fd-4bdc-a1a1-68177652431d', 'f1048d9f-e560-459a-91fe-f769ef049648', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b12dcf3d-9b06-4d32-938c-209adc18ce37', '25b8066a-59fd-4733-90f2-8ea80c826fff', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('daeaae1b-5d88-45a8-8697-cd2e22e519a4', '25b8066a-59fd-4733-90f2-8ea80c826fff', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fd07e597-fc5d-4c64-b491-76a5420aec78', '25b8066a-59fd-4733-90f2-8ea80c826fff', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ecde7ac8-3b81-4864-8b26-2e07cdc49190', 'b2cd9234-6651-4c9a-818d-f48610d76095', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fc871f18-a6a5-4cb7-9f23-fee703a845c4', 'b2cd9234-6651-4c9a-818d-f48610d76095', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1e643070-dafa-46db-8294-fecd8249232e', 'b2cd9234-6651-4c9a-818d-f48610d76095', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('08c5e34a-9a18-445b-9fbb-85a3ff34927b', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('71520b2b-f697-4135-a748-8ba36939915d', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ffbddcbf-8922-4b3f-9248-47b86638a1b6', 'c83c9583-a825-4a2d-96b7-fec9dd635fbc', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('07b70014-fbf6-480a-a128-6dadf6ea6c49', '871eadbe-c143-444a-966c-cc4494ba93bf', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('193ceb34-df58-46b9-92e5-62ce50a367c9', '871eadbe-c143-444a-966c-cc4494ba93bf', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c198dbfe-def4-43ff-ae55-8e0a58f068c7', '871eadbe-c143-444a-966c-cc4494ba93bf', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5f37d6b1-5ec6-4c91-8f11-32f95dac7b9e', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('68136a56-de73-425b-bc05-ab6fed1cdfd1', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('43c48616-3e31-4bed-9727-f9e6d6447378', '6fc20aab-5dcf-4b04-8a33-1d1512fe8c61', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a6a56680-46da-47fa-b5a0-5012f91bb3d9', '84d4763e-0133-4d81-946b-fb64d1a3fd26', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ca68370e-d560-42ec-bb93-b14df8eacdd8', '84d4763e-0133-4d81-946b-fb64d1a3fd26', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('48f6d390-367b-4e7c-ab30-c2e7009248a6', '84d4763e-0133-4d81-946b-fb64d1a3fd26', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cd8e900a-3f5f-4b54-abdd-72b79c3f3203', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f47459e8-dfd5-41e2-8b4b-c7999197f56e', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cddce99f-aca2-44e6-aa84-b1fc98c35c8a', 'bdfc3748-abd1-4bce-a239-f5b4df6715c4', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4386a60e-d5b7-4f36-bd53-1de1e52ea755', '67c2d793-212f-4ce0-a750-b18224a93c73', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e19225c5-a87b-464e-8c63-3f52a45b107f', '67c2d793-212f-4ce0-a750-b18224a93c73', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ab491da9-8661-485f-90f4-a85c7f3310f6', '67c2d793-212f-4ce0-a750-b18224a93c73', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b0214c88-ae13-4faf-9870-01872398bbab', '3692b171-10ef-4f20-97de-ed5fa562ca46', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9398d762-ff69-44a0-a07f-2149bf07bb4f', '3692b171-10ef-4f20-97de-ed5fa562ca46', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('eebe4432-38e2-44dc-85c6-995cbecd173b', '3692b171-10ef-4f20-97de-ed5fa562ca46', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f1838834-17f4-45ae-823d-cfd97b9ad7d0', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('94815866-8e0d-4177-9026-3fdad0866fc2', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c9448020-2d88-456d-827c-0b24917a78c6', 'ce424fb0-bcc4-43ef-bc62-e923fb337fde', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8b8b38a3-679a-4331-962c-c540eada4c22', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a59c2244-46ef-42ce-9a35-9efeb0a02068', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4556335e-4c02-4879-a850-cc792db27b5b', 'ccbd7baa-494d-4bfc-b5bb-4310e607df04', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('88eaec32-bd9e-4fd9-973d-1aaa932c8115', 'ade3baa7-760f-488b-962d-7e365ad1402f', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('62c26e94-cc22-4558-9bee-8ec8e6d29b95', 'ade3baa7-760f-488b-962d-7e365ad1402f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a0c34da0-2ce5-4877-8172-1306a2599c87', 'ade3baa7-760f-488b-962d-7e365ad1402f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('14e4dbf5-5fa3-4010-91e0-c56e71623ba9', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('359f9b02-63f0-47eb-955b-52a344462735', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('05d18d2f-a5be-4b65-9e78-8fa91db4c68f', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f049b588-1279-40e7-be2d-2e691e8a4090', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'INSERT', 'hs_office.coopassettx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a41ad44b-e566-492a-b2b7-9a1ed2bdd18b', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'INSERT', 'hs_office.coopsharetx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5879bb5b-1171-41e2-bff7-707e18fc0582', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a277424f-d7f0-4568-8cd9-5299a13d0f4e', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('66c939e9-0515-4cb0-ab1a-8dcd9243c53f', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ad1241d8-512f-4589-aed2-958e1fd6441b', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'INSERT', 'hs_office.coopassettx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('39a2eb59-2ba9-486d-8146-0a9a4d85769b', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'INSERT', 'hs_office.coopsharetx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('17e8a223-4aa0-4e35-aca3-f381f9ce1328', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a24d0918-c78b-44a2-8c90-965940f30b95', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('10971aec-daed-47b5-8514-f88f9ca1016c', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e0c2115c-f70e-4c77-87a7-d1f524f47df4', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'INSERT', 'hs_office.coopassettx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6cfb3c88-43bd-41a3-9c01-29bbcb67752e', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'INSERT', 'hs_office.coopsharetx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7e91e09c-a072-44b1-af1f-bc1e6430d371', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4dc88a9e-38e7-426b-a598-f246cef849ed', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7db8de4f-b7d3-4a3f-b2d7-4abf43a4235f', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3333c620-ed65-4a4a-af0b-71106e0b5b30', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'INSERT', 'hs_office.coopassettx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f8591833-ef9e-42fd-b91b-f66b56267b0a', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'INSERT', 'hs_office.coopsharetx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('51da6c66-df21-4619-bb68-2538c6ef2c31', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a16e2346-b56a-4ea3-b07b-f5f494b2b42b', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7514b6f6-f31f-4397-bb3d-eefe138ebb9d', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0b188bb5-5eaa-4c5b-9989-7ccccbc9f2c1', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'INSERT', 'hs_office.coopassettx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('bf58a617-cb18-42a8-b34a-56b584e6daf1', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'INSERT', 'hs_office.coopsharetx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d3e00370-8788-4a7c-83d6-693a01ccac0f', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fd972637-8015-4a7a-9591-683814d6dc1c', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c1f4725e-747e-4d03-8a86-b2f4fa4459ee', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c57ee5ea-1e8e-4a28-bfed-0bd4477fcb06', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'INSERT', 'hs_office.coopassettx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e2c9d05c-4e79-48cf-8093-e8fa4b0a655e', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'INSERT', 'hs_office.coopsharetx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('408d2e43-8fa7-4c98-a0f8-4a52ebcce3bb', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('48607eac-4413-48eb-9b01-bd264a9b607c', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fc0b7f19-723c-46f3-b40c-a8973fb5cce6', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e131dff7-b974-4e12-8324-732296676146', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'INSERT', 'hs_office.coopassettx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('99188a87-efa3-4365-9135-700c0899d0dc', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'INSERT', 'hs_office.coopsharetx');
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('59adeeef-e54c-4b26-8a36-f4dbe0b05273', '9b403ef6-3fae-4698-9b21-2627c51fa254', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('01635d74-7e94-46e0-aba2-a1c8d471aaff', '9b403ef6-3fae-4698-9b21-2627c51fa254', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2f8771ba-3650-43d8-af99-ffc413066a42', '9b403ef6-3fae-4698-9b21-2627c51fa254', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('59e7f9e1-fa76-4f88-9ccd-da4eb105f0e2', 'f9811182-d400-43e0-ba9e-de745c9e82a3', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0aa2520b-5481-4d8c-a478-964e4441d5e0', 'f9811182-d400-43e0-ba9e-de745c9e82a3', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f5f51c10-010d-4d5b-bb8e-b2dc353ba051', 'f9811182-d400-43e0-ba9e-de745c9e82a3', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d71a8b9b-b0da-4675-a6c5-45d2664c70f5', '4924877c-c487-4e4d-8b14-901e9b6069ac', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b32ebf6e-d5bb-4b03-9d03-10bcec3a6172', '4924877c-c487-4e4d-8b14-901e9b6069ac', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5fdcc08b-295c-4853-957d-d171b1accd40', '4924877c-c487-4e4d-8b14-901e9b6069ac', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('dfb1ef2c-af28-40d5-b625-9f157f1323d4', '831a608f-fefe-425b-b740-1786f856c680', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2d5f609d-aac6-41b8-b7dc-ebb66f4b3833', '831a608f-fefe-425b-b740-1786f856c680', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('e4c728ed-535a-40cc-a460-3174b695f899', '831a608f-fefe-425b-b740-1786f856c680', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b491c0ef-e4c3-4692-94f3-bf13b2dfff8a', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fdad2cc6-4985-4407-ade1-857bd91c5518', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('1bf68e49-2a97-4686-a8b9-8cdb46475326', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ccb79609-4c10-4c53-bd5b-3a128e7f7ebf', '0bae3550-be89-4c0e-9ba4-01bae0419be0', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4e5c24fc-e3d1-49f7-963c-e386a72be2f8', '0bae3550-be89-4c0e-9ba4-01bae0419be0', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a8dc5128-f0db-4f0e-b599-a87eeb73603c', '0bae3550-be89-4c0e-9ba4-01bae0419be0', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0fd249e7-1454-4914-957a-b3ec7bf25bee', 'f3140f7e-5045-4534-92aa-e918895bfafb', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0334125d-2eca-4694-9cc3-abfbb58b49f7', 'f3140f7e-5045-4534-92aa-e918895bfafb', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('bb74107e-cd5f-4207-87e2-69f4d67eb7f3', 'f3140f7e-5045-4534-92aa-e918895bfafb', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('eb46cc8c-d08e-4b43-aecd-b0d73b4c7a4c', '3d0e6bb5-a62e-4225-a2bb-967c76926705', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5fcac9c5-86b0-46ec-9eda-fa65d8ae1a9f', '3d0e6bb5-a62e-4225-a2bb-967c76926705', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('06d170a1-f3a5-453e-9a08-3dedf2ecc0d4', '3d0e6bb5-a62e-4225-a2bb-967c76926705', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2194c042-0182-42cc-8174-6f219e3c4e65', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f792f250-1f61-4efa-a515-d04af7ad5e18', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0c5a46ce-1c25-4f5b-9dff-5f5be50cf6a6', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('02748d62-3212-4465-8c05-aabc3f919a08', '850aa448-3a14-440c-9834-0b7ef6d83c39', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0cde804f-7eed-49d3-8eb4-d55e806f8957', '850aa448-3a14-440c-9834-0b7ef6d83c39', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b04e429b-3f95-4dea-b61e-3e96d114ecd1', '850aa448-3a14-440c-9834-0b7ef6d83c39', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('3014663a-10bc-4a8b-b47c-2c805b198d7f', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('702c700c-a440-4771-b203-9c030c1c100f', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('69067b5f-41d0-447b-aba4-31764c6d6e04', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a3d6ce3f-655b-452b-91b1-539956c8580d', '466056f2-efc6-45d6-b778-fa111db7a18b', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0198a5da-a2fc-4f7e-bf41-54642325d8dd', '466056f2-efc6-45d6-b778-fa111db7a18b', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ca0cb3e0-c89b-45a1-8614-c6a6f7a5e80f', '466056f2-efc6-45d6-b778-fa111db7a18b', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('41bf1ce4-7d32-4bc9-a240-6f37aa7c5311', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('008b96bf-c732-4063-95fa-8660cc3e378a', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a8ca5cc1-5e21-4837-9f78-bc4f8aed2d4d', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('74d9ec93-6755-4198-bba3-b900d1391ddf', '51a4690c-bb0e-4be2-a285-31552f900db6', 'DELETE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9cf52144-7c0c-4031-a0dc-b5f7d0581115', '51a4690c-bb0e-4be2-a285-31552f900db6', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7878934b-1841-4918-85e7-ce853fe8fdba', '51a4690c-bb0e-4be2-a285-31552f900db6', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('18630744-5484-4f55-94a4-15b6f8a8c791', '925e61ee-5120-4205-b609-18083af2c4d6', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7e2d1a3e-03f8-463c-9300-7e0b9bfd0eb5', '925e61ee-5120-4205-b609-18083af2c4d6', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('23115d61-dd0d-4545-8240-2415ab603868', '76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('4b8fc5ce-2f77-43cc-8c11-caefef50e9e0', '76b7d3ec-14e4-4e72-89df-ffe2ae3cf4d9', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7ba7e7db-d2a0-4d8a-a982-4b592a6519d3', 'e27e543b-f15b-4e0b-98fc-ce72bcd5d258', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('28a1da29-5665-4481-be2c-23484fede329', 'e27e543b-f15b-4e0b-98fc-ce72bcd5d258', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ad772eba-1cc4-4973-b407-ee1292c8cefb', 'd9c28f32-a87e-4f2e-af07-75a76004907b', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2b1bd996-ed42-4b6f-941f-a02115b5c49c', 'd9c28f32-a87e-4f2e-af07-75a76004907b', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('114ce5a9-0704-4f91-98d1-7f4f2e6d6ac3', 'b0a9b8a6-8709-4210-b4ad-eadcab6f7866', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9532739f-1149-42ed-bb1d-cac1d14d4380', 'b0a9b8a6-8709-4210-b4ad-eadcab6f7866', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('04a9b874-65cc-460a-83be-47366ec3c35e', 'd3e130d9-9288-4d74-8699-1778d2f5c151', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fac002b1-7dd0-4def-9c60-ce441ae74bf0', 'd3e130d9-9288-4d74-8699-1778d2f5c151', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d0c2aec5-df1e-4a43-accc-292636a196ee', '110138a4-46e3-418b-8ce2-095da9c6b98c', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c16db138-0d91-44b1-bd5a-b8361d1773a6', '110138a4-46e3-418b-8ce2-095da9c6b98c', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b299282d-1cfc-41b1-8936-2dcbfe1017ca', '0565d216-af16-45aa-86e5-9ca55751322f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('bb211784-8f68-44ff-833c-3f501a33ad0f', '0565d216-af16-45aa-86e5-9ca55751322f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d80e22b5-9ba3-4ad6-a392-fddaa4a5532e', 'c7d34de2-7cbd-480a-9ce5-a574ef7248d8', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('2afe8e61-bfb1-44c3-8685-bb5390e9ffa9', 'c7d34de2-7cbd-480a-9ce5-a574ef7248d8', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('d1fb0181-59a4-4c35-a6da-9c4c8c420f4b', '147820f5-533d-471d-9f54-99e087ec37c6', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('7f04b4ff-ce51-4c25-b924-eda9c80beab9', '147820f5-533d-471d-9f54-99e087ec37c6', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f7036040-6df9-44df-a4a4-40b8065234b3', 'eb40ed40-ebf5-401a-b498-ecc46928a17d', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('aa8c9c0b-ac3d-4fe4-85ee-22876b77a346', 'eb40ed40-ebf5-401a-b498-ecc46928a17d', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('5612b460-e9f4-4c7f-8f30-fabca1954260', 'f9c724b4-3965-4cfa-bc93-5b780b2362e7', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('793d3808-9277-4bc1-b39e-46fd0b5028d1', 'f9c724b4-3965-4cfa-bc93-5b780b2362e7', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a46e7e72-094a-4677-a2ba-b027e117c814', '1b444a8f-352d-4812-97aa-bd1e649201f8', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('34608829-3d7a-475c-b734-f3692e102b82', '1b444a8f-352d-4812-97aa-bd1e649201f8', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('176b447d-ce47-44da-8219-a00244a3d5e0', '2b1590f1-c1b8-4318-9879-8e2d898fa4a5', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('22500be4-6daf-4c50-9120-a4d0c6491720', '2b1590f1-c1b8-4318-9879-8e2d898fa4a5', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c772675e-39bf-48b0-b10a-1a2ff065c3a6', '0f05f1bd-403c-4239-8595-d317bba58a32', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b096450c-b5aa-4a9e-9b80-8633ca2243a4', '0f05f1bd-403c-4239-8595-d317bba58a32', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('651a87c6-db56-4963-88a5-5dd7b74d53ce', '2cca894b-c08a-4b36-b809-d417cf0b305c', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cf345447-6015-474d-9c1f-2fe7b879edf0', '2cca894b-c08a-4b36-b809-d417cf0b305c', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('9654e7cb-b714-4f8d-9a7a-5a2e9dcbe09b', 'b4acab9a-7a54-42df-bd35-717f052b407d', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6eb3f2e6-4f80-4ec5-b121-e0e6ab166e6f', 'b4acab9a-7a54-42df-bd35-717f052b407d', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c7a074b6-6e8b-4570-a8b3-baf483e67c14', 'fab99b6c-dd05-451f-a9e7-80891ec94db1', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('16c5c51a-6b85-48fc-a19b-b1d0319c414d', 'fab99b6c-dd05-451f-a9e7-80891ec94db1', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('ef9747c5-e7b2-4a22-b4cf-cb05c7cc0d6c', '34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('a5de5a65-81f3-482b-baac-4054940ea7b5', '34b1a8f7-bbda-4b59-bf1a-1eb336bd2bcb', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('c32e6121-a5fc-4345-b6e6-26eda31d266e', '9f3ea248-0492-43af-8430-2cbe4ae3338b', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('96383615-0c59-4cc9-9292-723a1c0f4a52', '9f3ea248-0492-43af-8430-2cbe4ae3338b', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('db092336-0de9-4c19-b5a7-9f035596b364', '02362331-8069-4712-9c39-371973edb192', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('63dd3ba5-db8d-481b-8eb5-ee982522f4d0', '02362331-8069-4712-9c39-371973edb192', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('67f40c40-c638-4350-a11b-951b0bf73bf0', '899a89c3-6715-4a37-bb69-1ed124e0a23f', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('0166244a-b22b-4567-a09d-bd113f3430b0', '899a89c3-6715-4a37-bb69-1ed124e0a23f', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('b969f3ba-2936-4937-80ff-c440300d3f10', 'a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f6d1a800-dbfe-44d3-a939-e168760203dd', 'a660e5c3-c7c6-4cf2-9508-5fc2de46f1fd', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('44a7f281-7acd-4536-a7da-db74fc7d5a30', '568b153a-13dd-4510-b681-13b53f866091', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('51278cdf-daff-4fe9-90b2-1e651847e0d8', '568b153a-13dd-4510-b681-13b53f866091', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('852d7666-33fb-4246-b2c4-1efbecba4da0', '6d4e335b-f22c-48d8-98b3-0da4ad759e65', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('fcc39eac-cca5-44fb-b728-9b4df8aa3874', '6d4e335b-f22c-48d8-98b3-0da4ad759e65', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('6a568f34-8ab2-4a74-941c-266e28a52836', '105e8365-c8b6-4d69-bef4-8bc388524462', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('8a4f7331-7bdf-41a9-85c3-5ea327063d71', '105e8365-c8b6-4d69-bef4-8bc388524462', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('526ae830-0342-4a87-a95f-07d760391fb7', '5b516553-2772-4591-b4bf-4f353e598c79', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('08a87b5d-d5eb-4d77-aa10-1afa61c87e38', '5b516553-2772-4591-b4bf-4f353e598c79', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('63c07ed8-5b6d-4cb7-b663-6a5ce5e63fcb', 'df223672-3c4b-4044-8f54-1794a50c957e', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('cc4e1270-9d63-449f-ae27-a492326f72b1', 'df223672-3c4b-4044-8f54-1794a50c957e', 'UPDATE', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('f03cc85a-b722-43f4-8d56-a29f1387e692', 'cd8cd45a-a4af-46ce-a434-5b5208095346', 'SELECT', NULL);
INSERT INTO rbac.permission (uuid, objectuuid, op, optablename) VALUES ('16994a15-ef4b-4c7f-b123-e9c2e03919d0', 'cd8cd45a-a4af-46ce-a434-5b5208095346', 'UPDATE', NULL);


--
-- Data for Name: reference; Type: TABLE DATA; Schema: rbac; Owner: test
--

INSERT INTO rbac.reference (uuid, type) VALUES ('ce47754e-0d06-4b12-bc91-8034a4a046e7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d2e05c94-5c48-43bf-a263-307e9dafe466', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3706fd53-e952-408a-aedd-93ec6d5129be', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('9ae5d7ce-d996-4510-9513-9b352cf4427f', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('f19926e8-c484-4707-9dfe-2567bcf73517', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('43d7f5ce-6756-4b39-be31-5f2289a9861d', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('47b0efd3-0e9a-4275-b2c5-d50dd2b22024', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b7bb17e3-4bb5-4e56-8ea7-82c83f290e1b', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('f53edb60-9b71-488e-9cf9-b546b1a41a27', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('58e39438-c58f-4aad-ba36-c6cba38cbe10', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b4f88dad-496e-4943-86f9-0c0a53a8a086', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('622441da-6eb6-4769-b217-0517d120ae19', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9b54e093-e76b-4467-b601-2fd984a46eb8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cbd8ff6d-bd06-440b-ac59-c28e812f38fb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d0319d41-e3ac-4970-b937-3a6dfb1b87f6', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('261f9b22-f120-497f-b2d7-1743429cbdc7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('de3fc307-29f4-45fe-ad4d-b2d221a80dc6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f82d3673-e425-46aa-9313-c6beebadd556', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('68178d3f-a62f-4a8d-aba1-4c31e16ce245', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dffa9b00-9935-41ab-97f4-8e0dd64253a8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2eee7eaf-aedf-4963-9f91-1650705505a8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('77bd729e-de25-49f7-946a-8e2bb01ba937', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('9bd2654f-ab7c-4a27-a592-a6d88c297bcf', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8191b376-6d33-4ca0-99ae-48e8df1a4c8d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c7ea2fdb-14df-4e65-abba-932a8f299b0a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5a90164e-c8ba-4dc0-874a-fdf0fbbf049d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a9e463d4-7366-4bdc-a34f-8c3a4695eaaf', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7b14ab48-4340-4028-b5ec-4c63c3c74204', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('279792c1-89eb-4ce8-a408-6182eba0d5d5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cd1dcb29-0de5-4168-9533-4bf93aa9a1d3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('51745b8a-19bc-4fa2-a0d6-df1a95462ca5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('95578ba6-2639-48b3-b124-430862b413da', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('889a47b5-a856-4b2a-ac09-c8d5610c5208', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('62fb727e-926b-4d36-ba51-0755885df9c1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9340ed0f-3740-40bb-a4ad-d695ff86bd82', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ed0f8f52-41e7-4008-95ea-b2dc348f51f4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f498e9ce-465f-470c-b560-125e9f4bba17', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4086e329-1c2c-47e3-95b4-87200972b379', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('f6c0959a-c76b-48d4-a40e-6eed197f77d8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8b326d7d-bba8-45df-a00d-895f7c64ee22', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('836c9ba8-a972-44aa-b7f3-dc2cde577d76', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9336c198-ff90-44f0-9e69-58d0d730ea31', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4d9f2c35-3226-4fa8-b61b-c352ab0657aa', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('851a50d1-f075-43e8-8b04-4631aa4ac7e0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8a8806fc-fceb-488d-8c54-f54bdb252b96', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('77b4b7a8-1143-4be8-9e73-fdea50339047', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c645d340-b5dd-4eff-a041-c09ba34dde62', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b86f2991-86c0-4dd6-958c-94598f95e0c7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1435f302-f2df-4c70-9503-ba7c3d3c956a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bbff9028-689c-4b1f-bc48-fa82816f4779', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1fbc3b80-708a-4c16-89f4-f590476ce853', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5c6bb3b1-18e4-4544-887d-f1ca8d715599', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('c02e9eb6-82ba-49f2-a64a-4ca9caeeafd0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bfb672c7-40db-4c9d-be7c-66b73ff5c95d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fdcabb47-e267-4943-a466-cb22eb6acb40', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('587090ef-53ba-4090-bb60-07e7553a6735', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('014edbae-b8a0-433a-96cd-fb7ceec2eaec', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5503bf11-4c80-4342-bca0-12a813a75550', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('79fa42bf-1583-42c6-a45a-431a47c7e1fc', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('05657efb-bf3d-432a-84f2-e88d5357358f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c98d998b-86e8-4560-b7ee-32d886e09ca7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0b92722f-8703-4041-8a90-b3831b5e2636', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('64182ec7-44b5-4de0-9830-d4d502de2d72', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6999763d-206c-4c74-8c38-df461a2b5c08', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('64ee9c0f-19c6-4f95-ac35-98ccdc2ab6d9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('061689ed-e23a-495d-a83c-03cbeb6431b5', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('7e6a2f44-1341-4fde-a575-d735dc3d6167', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f56cf9dd-0b15-44bd-9936-180358f36dde', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('10cc55df-30bc-4162-b803-3e679382589b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('68c481da-6660-4ee4-b993-034035adaac3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f9215d44-2e5f-4643-8ad3-9c6f86336574', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('19f010cd-7960-4e7f-96cb-749b0b517d55', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9cd47ed0-a16b-4608-a05b-2384c69c14b3', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('87b5ee74-8272-47e0-8382-508e7826a9bd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('29bc9f72-fd5f-4e77-a1f5-b0c26e72f0e2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8be81938-4380-4e47-a531-7f75994b5c7b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5ec44c43-71d0-4fec-9e54-4668b09e43b7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('84052d8f-5425-44d3-9fbd-7074fa15b51d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('dba32261-10f4-4703-adfc-c709767a8089', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('36734f80-8b44-49a3-a276-8d30e2cbda80', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('83b63657-d41f-4a1c-b734-69fc0d931184', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b700ec87-f10c-4f8c-acca-b1f7b7bf0d86', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2da43f30-16da-45a7-81f6-655246785709', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('20e424c6-6960-4006-b5db-217495896189', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a5deb169-2600-4bd6-a1b0-cd396c0d01d2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6c7a7498-1020-4437-9462-b53188cac668', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d4025044-6f0c-4522-a2d6-a74e0d77e25c', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('81707abc-1b3c-4366-bf2e-88330dcedbf4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e03716b4-1f3c-49e3-85ec-987b2255b768', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cac9accb-2377-422e-aa28-099560ff5be7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5f633082-b98a-41e3-a7c1-a012344ed779', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6157265a-8060-4b5e-b3c5-d859148dfaac', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a429bcf1-ae88-461d-89ac-c3a6ab0b51f8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9db20e03-c433-43b8-b6fb-7be16948c1df', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('161f701d-19a4-4ec6-9532-add4a75c3cef', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e07ca871-e19f-4742-b502-83d1386db856', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('25aacb25-32b6-434e-a83d-1c6b6d2c7f88', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('44de04ce-8a6e-463e-b91b-0dff9d08f39f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('354d47f0-48f6-432c-9ca0-1a9e7b445575', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b58c60da-9bc7-415e-937a-ca9698feeb43', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('59a43fec-b8c0-4924-a551-795d76ede176', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2ddebf26-9ed2-47e1-8529-7bd6695f5ad5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('00d948f1-9b2f-4485-969f-9adff4ceefc8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bb4cbe5c-7a2d-40bb-93cb-f470c5cb1448', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6bf95086-8613-4e76-b4bd-373c5f4dd8ed', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f7a3c8a4-2dcd-4365-86a6-4a6815f27754', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d90575e7-fa65-4442-bc2a-594d402d48c7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cb4e710f-faa5-48fa-99cb-538bd199375f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e7bf6ee3-d4f8-40c4-9241-d9d7f8da50f4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f25e0132-b738-484c-b705-9f7daedf5f5e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a9733a34-f4ba-47a3-82ab-4d5c6dc2de48', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('79c76d08-ddc3-4340-867a-a4bf672ee561', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f6af9107-0028-4bb0-a84c-e05b2b563a8c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d445f823-74aa-4f13-b522-63f4ed72cf43', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('914f6ce6-4c3c-408b-b593-57fe5a655e8a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7b75fb08-d2ee-4ef7-8032-4b5a4e75bd76', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5afdcdd2-cae4-4e94-b960-394991740137', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('12631f3e-cf79-4ed3-83de-8e4aa5047558', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('926ddcf5-5e2e-4d0e-8367-aacff8a5f723', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e2560e60-c9ef-4a62-aa11-047aa2a881c0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('33dd1dfe-b50e-4b14-8605-686388194536', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4d5a14c5-ff9a-44aa-9e10-dbc7830be348', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('93bd7ad2-b02e-4683-93fe-18c8bccb572e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7c8c8fd0-6d59-42b4-83d3-d05f06823b8d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b625f6a4-5267-4ee9-90f8-a0bef13b601a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5e63775d-1703-4028-8d6f-1ac5bc9bc23e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ec3ce444-8daf-4e5e-b2fa-9ae177031b1e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a191eb5a-d446-474e-aa42-0e0f4b50805b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('21c7c55c-6297-4178-b3cc-6417c8750144', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6848b0de-277b-48f3-919e-1c35919478bf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d4093d6e-cbc8-472d-b34a-aef1973e5c91', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('81e6a20f-7423-49b4-82d1-64de6b39078c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f2c26ede-90e9-4dd5-ae99-f4378113611a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b2889cc0-5ac3-4404-a7a6-9f05f2f26b62', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e87e04b2-014c-4936-8910-d3c6367e0c17', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('11e792d9-140e-4350-8a25-2837432ad530', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fb2e7112-c206-413e-a26c-bc98d27ee77f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('60d6884d-d0cc-4638-a11c-ffcf7741d61d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9b25b6d5-ea8c-4fd9-a764-5c98b3d7a4b3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c70f69e2-04d2-4d4e-8618-700290784834', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('193e58b5-518d-4bcd-92e2-a9cfe5f8e822', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e7716785-7183-4ff2-8b84-ab215b0617f8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1a0dd9ff-2040-4bdc-8861-90b3c2c9a7e0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('448bfa3f-a9c4-48aa-b206-76bdf9d5b233', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8aaf41c3-600f-4b6f-be1c-d0e32761e3f4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1be597fc-dfbe-4811-9a69-84c966cab438', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3a12b0ee-7acd-45d8-9afc-83109e370f53', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e5dd2f30-ad8f-421a-a693-029dd090fed2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9bfc93ab-aa68-4d34-a1b9-18a7d380fdbb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4fb1647f-2f42-4308-bb7c-3f81d76ed6e9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f538912a-3586-4949-ac88-e0290e05793d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ad1e0e26-7598-44e5-bc52-23bfa4a3fa3a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a98f5b55-0301-41a0-af70-bdd66cc51ef4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2058dc59-6192-47bc-824f-083689b9236c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5b2ee85e-5fb0-4081-a0ec-b8dc450e3ca2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bface2ce-9df2-4781-9d1d-42d063dbddf9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('45ad1e27-9e7d-4de2-979b-26e9e1625472', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6a1e8dd7-d6c6-4d62-b724-3e8e734736c4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('90462639-f32b-4623-a611-d04d0e8c3af3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e59c27d8-8f2c-4f7f-900f-73c416fdc33c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7cf2ea28-9bbb-4f00-aa37-a57258ac913b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dfcb9a8d-5c77-454a-bb70-eb7b87736e3e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('66f08b23-5156-462b-afac-8e6ab2a0b3f2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('86375471-2207-46fb-bbad-169e6a47548d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ad146ecd-4b07-4f27-aa42-1ef082b2a11d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a3a6f3c0-e50f-4255-bcbb-9f8621d21cd5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('67c0accc-a873-4e2a-929e-457d3128a4da', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('786c9147-a632-481a-9df0-6381a6ab9adb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9c4319d9-b758-495a-a317-02c42f16beb5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ec027211-853d-498d-b9e0-50136338ba81', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('df8538df-8ca6-44e1-b749-48fa534ff060', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('448e55f7-b79e-46d9-bd48-7c3697b93367', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('da5b7e5c-6648-40f5-9e43-210a8c795fc4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cdc44225-e4ef-477b-b622-eceb2bcbf7aa', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('70c612b5-fa4e-4d28-9460-88df9b9c0c8a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3a1d242d-7474-4382-88b2-d9ca26c0fb8b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1febc3c4-916f-4022-bd21-47235f105530', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f774f68e-d26b-49ad-be57-1d6f00df85b7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d40106f1-12c9-4440-acfa-82a7ca690c71', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('75bcc779-10ba-4dd8-b1e6-eaa06661b721', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cbcce756-f68e-4128-be12-98d67a3ec870', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a137fda3-912f-41fa-bb2e-f6f20ccbe391', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5d4ef325-0433-4936-bcc5-88422ff3328b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('760c04d0-f20e-4490-9273-f7d637e8ada9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('73f04f81-a92a-498b-bdc0-2f5639b3cf4a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8f5e0d43-7552-4cb2-888e-8b5a63020e25', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e753752b-b4cf-46da-89be-73116e05729a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a166321a-5513-4619-9bdb-8b73d714de05', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f70f1dff-3633-4f1d-a1ba-3c8842a83f43', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4de65521-68b5-46f8-957b-f74974191c6a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3fc8a4bb-26c4-47d2-b927-98776311197f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a3256533-cd2c-43f5-add2-f71d381cdbe9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3fdf5d5f-ec7b-431a-984a-848f95bbe749', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('74efa1fd-8fe2-44d3-82ea-de125b6c3245', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('19cdc94b-d009-4396-92ab-7df7fdaf187e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('98b3661d-d16c-4bf2-a4df-cca378c62c3e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('badc7eae-cad2-4cfc-9c86-e33690da6ce6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7999d7ce-e625-4c32-9fda-c04e111104e3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2528d6b8-faad-4a11-b990-93d5aacc67c6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('801ec852-1701-472a-b0fd-02e1df4fdd4d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6cabd1a3-8097-4d6c-99d2-4240bf7a1364', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('8e7d0417-6d4f-42f8-99f5-f2b4bffb79be', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('84952335-9521-4274-89df-97081b4f20ed', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5d5a6b85-63e7-4c2a-8419-2e9e2f2ee92e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('30157dc8-070d-40bb-9bb3-e9f362a79b20', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('59604b99-4da7-46d3-8f94-560496047f62', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d2ade14d-ac50-407c-af35-d34aa3de7112', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f69ec9ea-6033-4d69-878c-9e86943e0849', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('f5eb22ba-9416-4629-82da-c70b5a69c59a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1528b9cc-bc3f-4212-9757-8d3561baa8fb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a2e37858-5b3f-4ac2-a66d-55b573eb0620', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a943d2d8-c4d5-4dc0-aceb-397ccb0e0e98', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('95b656d6-cf43-4ee2-85f2-e1bfbd04294c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('90e6061c-017a-4428-a3bc-de284850163c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d095ad34-1da8-4c90-8eb3-a613cb11ebd0', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('c67b717b-87cb-4272-9bf2-1adae808b092', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('59d3ebec-a4d2-4151-a982-895c9ac5f91d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cbc3ceae-6f8c-4bd8-9d6b-cd73e7ed07d2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7e162605-01d2-42f3-b242-bf5f633a14b2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('933c3664-1b01-4440-b494-1b03527abccc', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f6925557-e189-4cf9-bdf6-710bb6ef3d53', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('edfdccdd-4e73-4fa3-9b8c-410d643a2c2e', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('992f08c8-c77d-419e-a227-2dd1686d6e6b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e3cf1944-d3d8-467e-a70a-7c9457d9e858', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dec4450d-5cfc-4ff5-9d5b-019a7747e9fe', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d805187e-229f-4126-8818-cce8260ab65e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9fe19a72-607d-48f7-a992-4045dc1b983d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3be4b973-5d0c-49b6-ba74-784431b56cec', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c9befd2c-1ee0-4ef6-ad41-19134d9b6f6c', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('789cfb5a-1d39-49d7-ba6c-13eebb4001f6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cc414f18-8727-46ff-a6f1-19d39a64ddb8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c8bb86bc-fafc-4a69-b244-c47a24b030fc', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('437f6354-4fc0-4297-98b3-6d486affae60', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8da909f7-88dc-4021-ac65-41ea261a6094', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cd261e93-e58f-43e0-93a6-a8d8f4d7d108', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b821d95f-9913-4a83-b4bf-a851b818e72a', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('b1d76834-4f18-4316-a56d-c2a8ae935c46', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2a00622b-a1ad-481a-984b-1aa15b339490', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ed242038-35ab-4340-a9df-75adc9890cc7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4118526a-57ff-4e53-8755-86b3edcdf008', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('66252cb9-5891-44ed-8606-a5c439842416', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fc2e2b7a-574d-47f7-b275-94090bad4e2a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5fdec138-a875-42ea-b26e-beef34f2996d', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('0a77af39-b111-4ba1-bb29-d01fbe258230', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('222f7fdc-72bc-4e60-9739-7b9aaaf7e2ed', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5f1f9f27-551d-4cfd-ad0c-5a75cc40c812', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fced52c5-6b1f-4b59-ada6-e7491b4a9093', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f1d4efd3-5c86-42e1-9bb1-8750a2f3c761', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6d863bab-2207-4cb6-8bf5-c914763154de', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5e247f88-09f8-4919-9f18-8d28ec0fcaef', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('46457146-b7b7-493a-9a9b-52bea39d88a8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ae3680ff-6656-4bfc-9745-8a47d76e2c34', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a1faf426-c1ee-48e1-a019-e7cb37be31ed', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4ef293b9-aa72-442b-b686-7a410c1dd96c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('127cd0b6-de7d-47f1-bdf4-e9fb804dc864', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8ee94015-502e-4603-a25a-88ef7ec2ab5f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e2facd7e-f571-4d78-ab18-6852adfd8433', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('9273036d-c803-44c4-97a2-734938b17ab1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ce81a20e-b1ba-4baa-9486-04bddbcda145', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8aff4be6-1d01-41cb-8531-4cf3f16275f4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3e713234-8903-4570-ba0a-226e53204b19', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bc877dd3-dc47-4a31-9160-35c3d51f3ee6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b04e0e1d-075f-4519-8403-5c2138bf5922', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b5a746e4-7074-4499-976d-c80e310bf1dd', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('c939c84e-7f30-4659-8071-5249650c38aa', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('989681b5-af41-453b-ad08-3bf003f0ea6b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b5aa317c-e79b-49e3-aea0-613d7b21ccd8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5b4d0403-ef6b-466c-8ed5-03ccf8110bc6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d2207d3e-b974-44e2-a8df-1b9df3f5bfa3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c18655af-416e-46c2-b8ed-dcef6da068bf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f9b640cc-81fd-417c-bc90-759827548b3a', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('7beb3232-b58a-404e-a0be-87920b745415', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0c0c9ad9-d944-4e1b-8bb5-88bec1d68a61', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d150ac38-8526-4199-a387-989682ab0e80', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f701782a-945a-427b-b8d1-eb7aaf8a70fe', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cb6632a1-56b9-45d3-a4f7-d5f6358d5543', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0c8cd6e5-d5f5-434d-87ab-e8376f73f04f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e912b48f-b628-4b6f-946e-c8551c53a3a8', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('5b7baf26-6522-415a-b8ac-1814c9822030', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4f6d92d2-fe61-41f9-b764-d596d622b35b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f163a364-7ce1-44a9-b190-64dc5e5db218', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('aa6b3146-aeb8-421c-9c7e-a912110bfff5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5fababc8-75c1-4c4b-b033-13a1ce3424b7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('85481b32-da42-4542-92f5-6e5d85b485e4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b45fb51f-6632-47a8-a9bf-64214b133ed5', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('ec5c9879-5f1f-4edc-9593-f66dbfd23463', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('227b3c28-7a79-4f91-ae6b-148322c3d40a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1443481f-933e-4fc2-a36d-249ab3e409b9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('98df7445-5c89-4811-9d62-6ff4dad07580', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c2d51705-81de-4c08-875e-0199a4a662a7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bba5f750-df26-4fee-8766-bd9d120674d8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c02595e5-37aa-48a8-9c0b-795fe038b16e', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('a77da5b0-418f-40bc-bb16-4cf68496b69e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f2a456ed-bbf5-4dcc-820b-02f15deb85cb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8e3fe356-8d07-471f-ac7d-2fd2cc221c51', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('25be12bb-9667-4d14-8c0e-f1d5fe0d23f1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c47e70f5-9a06-4c04-8df5-8f5a1cf1334a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('140b4019-0b61-4cb8-9c0e-67ae32cc5df1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b2a5e380-82e4-4508-9209-c41de60dff60', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('dfb1526f-97b3-467c-9353-def252ee3fa4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('07c20dc9-492b-4312-b011-0f7f0e5a05f7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f16fdccd-62ff-4d76-ab81-954eba2829a5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1111c35d-e9c8-4ad9-8fc9-670bd8434471', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7b4384b9-b24c-43e7-84a8-1146b0658420', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0de0e8f1-ad88-456a-9f9d-0c0f7bc15e45', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7c171ccc-44f5-4b98-a935-607a33136ac6', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('48fcd828-17ca-4987-bfb9-88ff03d79d45', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9555e49d-c410-4dd6-b9d4-28e2fdb97eec', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('70419cf1-b91d-4e0e-a310-5f6bae23438e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('16de6e35-1477-4167-a673-ab39caaaea59', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5d405437-06fd-455f-b6bb-d3975a67dfcd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bd10630e-6fb4-46b7-ad0f-37c987ceb235', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('48e6b69e-6886-4af5-904a-478662c83492', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('4bb77a3d-359b-4c59-97c6-2b2d057f02b0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9edb117d-d8f3-40a5-b203-9d59d79cc58c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('81c56c69-3026-4f09-b12e-e1d7f5189323', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d8d8c187-6155-4dd7-b07d-09ea1ac099b6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('300d2c40-7194-43e2-8f2e-64f6fd618f34', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('96e9b0fc-c820-47fd-a9f1-205fce4bdee3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('19061874-d54a-4948-844e-8cedd1b003d2', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('6718cc14-a634-44b9-84b5-725bab3c9071', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('62bd240c-20ee-4ef1-95c5-e52dfbe6de2b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fc5a6d59-874e-42df-bd2b-fe9d6d0041bd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0ddc1db2-9b0e-4b9f-a142-19741a05b0d1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('769a625e-f766-4b62-9029-f2ac2fad55bb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7403c34d-a475-4918-b215-3f3692509aa1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dec8de87-0282-40b3-9f2d-e1f6e49a148a', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('a877eb2d-0398-4183-a767-b7aad0c43e1d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('59724e8e-d9fb-4a0f-abff-7b78c1c84409', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('83e922fb-97de-4816-9312-bfb5f38b72b9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7a73d726-1f2d-47e2-97f2-0ceb8645a081', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('912c4ac5-4a51-4a08-bf64-f8fafbcd72dc', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e3b1aa65-ae16-4320-946e-97d4d6102317', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2f85e53e-d6bb-4adb-9d94-7b74d1ad888b', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('46e716e7-0176-478d-b2a8-46a73a3cd04e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('02b73e38-e8e6-435b-be67-f24c921744e6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0e9475ea-2abc-4d44-972f-90261e404594', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f6a10e84-1ce4-48f9-a2d7-3dd53472453b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c0667e65-6262-4d55-8f1b-75891ba87b43', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('12ae58c9-2742-4499-953c-081e93f0020d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b34f7e7a-8025-4121-bb53-600b22a4cc18', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('bd653aa7-d852-4812-b705-7d710e98928f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e2b2fcc4-6250-46b3-bc60-3d9400012fbc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1f351971-9efb-4e62-b788-fd10b95475c9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7cf1797b-df8e-4760-969c-bf600b984f7a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7317cdc3-c578-4ad5-add1-437eb36f85e8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8f2f534a-7af0-4c96-809e-676894f93bfc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2b511f27-6e79-4af2-a068-8eb4f022f67e', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('4aae44c6-f86e-4206-ac82-14b1d7d7e80e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d98ed26e-3547-4aef-9a20-068877689f45', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('165f0036-f302-4822-b033-4a598efa8596', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b578ba6b-0188-4937-92bf-12e716b79b96', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6ce193de-3616-48ba-b6c8-d096c97fa63a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('50e7317a-915d-4eeb-93cc-7610407aeb18', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('eb0f0395-af8e-4158-955d-ad320c218363', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('fe45ce09-fb1c-48d8-a9d6-ab78428e4762', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9df8bd77-1f07-4c62-955d-4303f7101603', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ba696987-8506-49d7-802d-a8c0582d7492', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('45448b35-aade-4d69-bc2e-6ae8ff0e2429', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c31e39c3-6091-4f88-857c-1138d947b0ba', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a266a942-4714-4944-91ab-87a70bc21b4b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8857fd83-e188-4b83-92c0-e8675d2704cb', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('17ee3e11-774a-4a74-8580-82d78002b92d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f44dcd42-7c8e-4f71-a9b2-62fe8df62395', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('99199b97-236f-4ee7-bcc2-9a9e42ed3c78', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6d6875cd-0ec8-48c4-a475-e6c51b53e4e9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3418673e-f75c-4d2b-b883-d057a6f82389', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('57de3812-dd5c-41ef-9ced-d6a7ebc020fd', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('40cc2f02-7eb0-460f-a4ff-e8820df15b6f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b5ec802f-b80c-4662-8c1f-28d98cbb9eec', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('acf8d49b-faa5-4fb5-a582-fd14c8eba4e1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d4ed6718-32e0-4eee-9861-32d664c0edc9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9f9dcc85-30ee-4d06-a7b9-c31049986d0b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a26ab602-827e-433f-b7bb-ffcfd4808d0b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3344a63f-12d7-4ccb-b602-29a2c2282812', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8c323142-a153-42a9-9575-b44899cb888e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('111253af-eb02-43f1-bbd2-5a84dc893e6c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('264caa55-3f5b-4ddf-93db-f0bcf9f173fa', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a426d1b8-0a8c-4d37-916b-857f94f0c3a6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ac7cb66b-a676-425f-9283-1c0ff1ed7a41', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c94b6051-8824-4e95-89d0-aafc90538f79', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('49d730a6-d4e5-4299-9366-4b5fc7c608ad', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('dbe087f9-7740-4f17-a2ea-bf6a413d4917', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('74226628-a846-47a1-bc0a-a746321ac9a3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a10c1086-17e5-4d02-be1c-46407abe19f3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8ab00d8a-f618-4c34-943f-76611ac6e844', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d5c2623f-d7cc-456d-be5a-a72355bdcfb1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('286fc1d1-c6a5-42e3-bd87-40f4ca9494bc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4d2085b6-36ac-4663-b16a-ad89f1af0185', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a0b4a0d6-5ff8-4120-b3c8-0c0b5c9eea30', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('16f9c10b-4c4d-4228-a02d-4493da3d051c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('966e3f00-767d-49ab-84f6-0b678b4e0ee5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a83a9185-9054-4557-987d-c6086a85d191', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f18740fd-dfd0-4e94-8827-0511e11fdc6d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f047ead0-abf6-4809-865e-a0291f4d3583', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('23683202-f904-41ac-bffc-eb3ef688a2f1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9dbe7136-bc19-42a0-990a-5492fa009257', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6474d43b-7408-454f-8ed6-045c88ac8709', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('784c60b7-0043-44d7-925d-0ee643b5316e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('faa45dcf-229c-4fcf-b778-117fc26b8093', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('66e9485a-c9a0-490c-896b-286fb9729ee1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f6e49e38-4e9a-4ae7-b632-7d7f7ddb275f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c21f7488-e384-4431-9d4b-ae40b8d767f5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6644437c-1af3-41da-a698-cb9a5e0be97a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c7453585-2865-4464-ba7a-2e5a83ab2b07', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('16a57870-19c1-4020-8198-56fd7bfb032c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c7f76954-fd8e-4b03-a35a-757b523a5b46', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5dace3e2-5eac-44bc-9b7a-e221aa44d2e8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f646d6e2-d290-4052-a7fe-071a293ef6ea', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d73e996d-2b80-4a22-945f-3e31504ed859', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('875f7719-4fad-483d-97b4-4570aa9a9bc2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f0ac9ba3-d9ce-40b8-a4f4-d1b5d857fac2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e65e58d6-ab52-4db9-912d-49fbee2b9e93', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7b901509-cebc-4fce-a4cb-cfcbb6e09964', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5f911475-d7c4-4847-b43a-94e4568293db', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('138f92b0-e7b9-4bdf-ad1b-f83460966626', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ce2acdf4-5f80-4fca-8e2c-539bad84be41', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d24a9ae7-48b5-4b58-aa6f-4b6ab8ba4884', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2570afcb-757e-475c-91ee-2ae93bd22ea2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c0897451-3e4e-4131-9b57-4e60c7f005b5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('afdc94e2-1fbe-4d80-8e7a-863c8bbd9003', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2ee2dce1-c3eb-4af4-931e-1b03064d41be', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('99b81078-9588-404a-a4b2-d9bc075174f8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e6a59902-de78-4ce4-8685-9bc162575215', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d8215b01-e2a6-46f0-8872-9d92b8ea533c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('04b7a0fe-5daa-412f-9e3a-014505f9dfdd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f802db1a-56c6-4dd6-a31d-112f3b9ca20c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dd1bee3e-7901-4874-a2e6-d13f339ceff9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('758e8cf0-3a94-4d06-a9b1-487b3aef289e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e7c251c5-bd40-4cea-a3a1-4c29a5cb364a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4ccf8957-2844-4ce5-96eb-e0ee16f8add7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fca2a807-b07f-42b6-ae20-c568611da621', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c299f938-4701-423e-ad2d-65b779abc4c7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1f9de78a-e423-441f-87de-97391ca7acd7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f4676364-09f3-4357-9410-5d3c672e1db3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f7a43923-1403-4da2-86ba-f39eb91cc626', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ffc6ee88-9baf-4fa7-9012-1b8ad51f920c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5abb716c-4bd6-4879-8c4c-fb0b159c2a7d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ceaf9820-b48e-4126-8505-0b0310777450', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('58e43ec1-3abb-49c4-a62d-db3995f8ed16', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6c45aece-98c2-462d-a601-81ed588d0ba7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b1c08804-5c2b-4f20-8d99-e6279ff9baa6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7af6138f-41ed-4728-8842-58d7fafd8dc0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9055d992-d9d6-4565-bd67-7b386535ef6a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e2cdba53-f0f0-4b00-b955-544bec4e6900', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('64c7ecc0-30d0-4a29-860a-d86893e878bc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('966e8a9a-7f7d-41af-83a2-01b03c2c36ba', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('dcab0d12-7513-405a-84a4-bf8e2a8a63fe', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('445a32d8-8262-4e77-9600-15e245d2b508', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cb483b2e-77ea-450e-a927-0849a83532c1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2b1d5853-f666-4f44-bc69-63193d8dbd7e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('40a9c2b9-7487-42d9-b56e-9780083549a7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d4f780bf-8a0f-4a05-ad90-fc6b53d66650', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('828b7bb1-49dd-4389-af7c-ccd14a12a0f6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('077e0d19-2c32-49d9-8440-052d913b4a2a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dfeb60b4-fb6a-463a-85eb-d2313deaa126', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6335926b-f8bf-4002-b208-d815e5ad6b1b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('380419fa-12f5-487b-af03-bc43377b8734', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f4382bcf-af8d-4b7e-adc5-0392a61096ea', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f8d5871d-af52-4756-a10f-3ece4c33cf89', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('92fc973b-ee5d-4be9-8fa4-7838b27f2828', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e8214ee1-d2b4-4037-830f-e21a92bb10fb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('996648ab-df09-43d7-9d59-f13405d69362', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9e71a113-fc3b-4f0c-84ad-cc442c12aae2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e67c76ee-35b7-4f71-9ba7-fe05018cdd25', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('45113889-9554-4e23-b5d2-e54ab4ec1f47', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('888a956c-2985-4e87-8209-9010bdd33a03', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1dbdf007-fa0c-4811-a77e-7adf1f1d039f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4ba8a5d9-3529-49ab-90e9-24a137a64757', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('82a52e3c-eab0-4d61-aad1-0564e3c3ccc1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1f979f80-a286-4328-ac23-465199ca58b4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e51b1598-52dc-4f5d-9b07-f67987ff5ff1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('47b71190-dd48-4ab0-846e-94631dab1207', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('703a635a-38a4-47d3-81b7-501e99ac9583', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('793eb554-1b47-48f8-838b-6b15107fb4b8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bc94e434-5d36-4bec-b858-1d307487aafb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ee2a8d56-6119-4d7c-9ae7-4b8ae17395f9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fcf91d45-e57a-447e-b9ad-5b8899abcc09', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('af344f61-b33d-49d3-bb89-7337d073ea94', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('90494b0e-69be-45b8-a5fa-c71fe7ff70bb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8f8afacb-e9ff-4283-b1c5-54b8370c4f41', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('68437209-5c62-4337-9506-21be4687a277', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e753e59b-62c2-4862-b01a-3abd736fde2b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('95b22677-fe0b-4fc6-8af4-c7ae50705792', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0021f128-740c-4f4e-ab85-612d76ccbe67', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('34eb62ff-0428-4e83-9f0a-41854ea0b0ec', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ae085da6-9278-48f0-a2d2-b214f0cd55ab', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e4082d20-6277-4b51-b70b-1d41375748c4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('90d199e7-3d95-4d79-afa5-718df6ccc20d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4fba0059-339e-435f-8c6d-0b285376f4ba', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('25dfeaa1-30c4-45d0-b19b-3d0d88d65957', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a5600943-59d4-4ec2-8319-a727e28ec3b3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5da991a1-776a-489a-b56f-d5e089449f65', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ecd6fd34-6c33-41f2-b6f8-c3ad94a13835', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c19b8dba-ba9f-4926-a6fe-1abdaefd358d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f5a0a9e2-e859-47f0-a26e-8c20f06c4403', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('50ad278f-7bcd-478d-b3e0-1cdc256c0759', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0e2eed10-8946-4b80-ad65-5e22391178ec', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9ad5cc67-c734-4cc0-827e-3d2dca76266e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a33e3633-4ccf-4d55-8bfc-791127ffa636', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2e82259e-1776-4537-b7c3-e5044fd1ecb1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3724068b-69ac-46cf-b1a9-50c6d7c8db7f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c10e5a37-7f78-4bdf-887d-b681b5df5621', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dc6d1d21-3fce-4460-8f24-a41f763183c4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8f1e79cf-d61a-4a00-b380-660ad53d1bcf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1e38d376-11c2-4fa6-add4-a202aab7713b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fd3b6f6e-0fe2-40f2-9fc4-1fd3f88726d2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d189d2d5-40d9-47de-8fe0-1986ee10c700', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a8c4a6af-de61-447b-9bfa-a0d6472e32a6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2662bed8-44a4-4a1e-b090-a221d274e398', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3da874af-ba54-493e-b4c1-b7986e50fb6b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f1c64bda-8cc5-471e-9d9d-4ce9282c4ef4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7743adda-1219-470d-ab7e-89500ba728b8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6851da6d-16a0-452b-8244-f2c469bd8a3a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2787c036-4b7a-46ba-8ae2-47e0a70b4f8c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('209be47d-cb99-42f5-98b5-0cf434fa7ed4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9937daca-97c4-49ba-894f-758ee88bf500', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8ac1a2c5-ec64-4320-a83a-699b707fb0d7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ccc08255-d30c-4dec-acdf-183ad8d5c3fe', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('4529dbf4-114d-4479-b4e1-191b5025e094', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c7609f1d-8da6-4baf-bd56-aefedf998cac', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8e06becd-c599-44d0-938c-d1233bd828de', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('79951d69-b845-4536-a06d-ba9a0b87dd6d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5a2775af-58b4-4d5d-a011-1a678de1ba9c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('211e3097-d714-4c99-a2fb-b8b0d16243eb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0405d429-86b6-4e1a-b29c-62acdf173383', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('8c2a56ee-f375-4fe1-8008-dd4b895cf59e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a8ceb1e9-b86a-4732-add5-7199c74ccaae', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('90912fc8-e239-410f-99af-95a8eff5b426', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('32466c46-25ad-4e70-b799-925d8a0205cd', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7145ce25-b959-422f-8f2c-8097361bf6d6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7c110ffc-6b36-4564-8cd3-7e313f707a92', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0df77b11-b28c-415d-bd01-058936ce59f7', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('eb15c30a-339e-43d3-a169-3b93a6a635b3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('22041ed1-37da-4a86-bdd8-1eddc6101676', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('899a31d9-6c6e-4728-9a73-4ad2d8c7946f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('09d6dfed-fda0-409c-bbab-44a913a59559', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('53bf7dcf-d560-4389-bc5a-877c42e0c5c6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('21765a8c-4686-4dd7-902c-531dc124ff85', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9ee9004b-a6c1-40de-b2ba-ae3a0f81eb4d', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('bb813478-f30f-43b4-b7b8-b058970882d2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0e37fd60-58f5-49b3-b8c6-e4855c26714e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c038d764-61d5-4749-a4cc-c6e9aaddd5a9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6c1a1443-2334-4fb7-968a-bb4251e011f9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4dd5be50-ea24-4a6d-a70a-1697721c502c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('283e9cba-1f9c-4806-9f52-af3f0610e552', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0eb31fd9-2518-4d3d-8cb0-3c35e61d2927', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('e324421e-6f78-4b05-8ed5-0eb391f079fe', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8c390846-5420-4725-ae4c-33a23daccdd5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b08b3e26-1d84-44f6-96d1-a11104ed6e33', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1d019406-d406-4d17-9183-6430804405ea', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2d8b1a01-2b01-4ed6-9416-cabdd13e8fe8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('51967e11-58bf-41bb-add9-8561dc7e85da', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('644d653e-0b26-414e-b9c2-05627160e31e', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('274f45ec-aa1a-46e4-84c2-f15f0ee66124', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cdc88a5b-5845-419c-bb8f-be4171bf6108', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('932ccacc-fcc4-40c6-bdc5-f99f1de44d11', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3048fbd3-830e-4bf5-b3ca-c4b7cc460fb9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('200085b8-608a-4241-ac12-344db0b8e4e6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e72a5ba9-30e7-4ae2-ae53-6eae90d64983', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('38545759-12c4-47ef-a163-b8f4c100db73', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('0c790308-2239-4c34-a118-38795e3dac4b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d770c427-c0a6-4ab9-8553-875d0e9ab3fe', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('280536f4-7514-477f-915e-26c911eec776', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c509a545-b360-432f-8e0c-0aabdc2eb649', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7be4a71d-ca11-4d10-918f-3e0814d29be0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('476537b4-15f6-4690-b1c9-8431317dc5c6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('077a4207-e1de-4310-ab0e-f5e8d9623061', 'rbac.subject');
INSERT INTO rbac.reference (uuid, type) VALUES ('ce97c5cd-c3ce-48d1-900e-e78cb236c3f1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4f1cfe75-6134-4a07-9cd0-4cc1aa13ebc9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8e8a9f59-3907-4f80-a38b-ce3d31cede7a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('74972eb3-a884-4c04-9146-e49fc7579f89', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('48579cc2-7d55-4f0e-865d-8d6ae0d8b406', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e300d3e7-c99f-4e04-8173-2ee97171a948', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9c5062d4-6ed6-4284-967e-7e661a0f8016', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8e31bcfc-172a-462a-bfd3-0c4300a3be02', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('31b757ef-769b-4665-92cb-af4169c856bb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9bdb8232-d205-401f-ab93-376ea1c29dd9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9b7dda2d-32bc-4619-a319-25631494c9b5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('76d5fffa-389d-4f8a-b908-1814da8779d5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('53a5ba93-4f20-4c82-be4c-49e97c7d5740', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('22b020e2-d2fd-435c-8c50-7789753f35b5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b1cfb2eb-530d-422c-a94c-4165b900ec2c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ef9d8b84-a218-4eb7-80e1-597ca9083416', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c0127b61-407c-44c6-a115-805662b82bcb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('700637b7-43d0-4a0d-becd-3a75f346a013', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bd376b83-c602-4e69-9516-efbeb101652f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e01c7215-b127-4fad-a44b-8e10ee43442c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0a15d624-e4af-4a38-b0bc-b6699191133b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f4f73916-43d9-47b2-8d2c-58e85451ef54', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('014df2bd-80ce-45f9-b3eb-f796e50e96f8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6d30bac1-d0d4-49bc-8df1-f8d5f1226ecb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5a5a93ea-384a-45af-b24f-197597f90cd2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6d5ef625-4808-4497-99a7-557f47a4a187', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('be649d61-15ab-419e-82f1-ce1fbac7b7eb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7890b69b-a029-4d2a-8ad5-aa65dd28b7d0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('78463a7c-7bcb-4a42-9c19-6e651fab2aee', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d3a69474-fea4-4b50-8a72-871f0b1a1e2b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b2c60556-4128-4e9b-b251-d2906aefdc1a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('816a840c-6899-420c-978e-94ff3ce9ae09', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ea255c31-e1c4-4241-9f4d-423f91f1b480', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('606c7925-1fa0-44d8-80ec-af77a469d047', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cd70744b-54ba-41a1-a772-3f7dbbe48fb6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('855b58a1-8ccc-42ef-8b18-589f25e75ed9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5cf0c904-f99e-4530-b681-1010ed67236c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a96d1a54-365e-43d5-9057-49d95deb70e4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('be1f42d8-8342-4606-9968-56597df359e3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('01dfc7bf-5b8b-4ca4-8c07-03991e2e9a3c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('52836fa0-288e-4a96-b104-82d2171d78a9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6b120aea-e662-4c3e-b28c-7b6be4c905fe', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('41688207-eecb-4233-b9b2-5f18eee23546', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('173079a5-7ba3-4959-912b-aa7570609757', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('db07583e-7a04-411d-9b92-33d4c39e35aa', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('03d6a566-70fb-482e-b92b-34fffe706837', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2ee0ef16-10ff-4131-be9b-73bae9f2e60f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e6f238cc-d9ad-46e7-a13c-def16f0ce993', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d73d75b1-653a-4eba-8c58-8e0e9d16ef24', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bd62ce60-6055-422f-a8df-25340a69537c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9e749376-4446-4f84-a3a6-0126a209bb01', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('134f0b60-0526-41e8-b559-1c90dc1408b8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2f1a427a-f08d-4f12-92b8-a4d1cb70b217', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5131d1dc-c9ba-475c-b5ce-52634cd78b78', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0c39cf0b-aec5-45ba-a444-f499a6818acf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('eeeab670-63de-4a72-9982-514c8a6dcd0a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3c6ef604-c18b-4541-88fb-ca233fedfda0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1438527a-296e-41ef-b1c5-c8348df0c86a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f5a24155-8c78-41b7-a673-cff084b7c626', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('70cfe5cc-66b4-45b0-aab0-d5839cff4516', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0b616708-4042-412d-a57e-7cbf1b35af3e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d73e58f1-f9e9-4017-ab14-deb7117aa347', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ed8ccd28-b566-45f1-abac-68fe90cc85e8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e8740d62-698a-4d94-83e8-eab496600088', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('66d97e89-67a3-4bd5-8969-499d1b6d2158', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b0392950-e032-4957-be9e-f04112052716', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('abc194f9-c783-43d0-9787-f81c3cdba59a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5d67e8d1-2f98-498f-a099-d49231726531', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('85b81c91-a3a5-402b-99f9-204415b2a2f4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0d1bee63-fcba-4f5b-9a6b-5e4ac0a404d6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8b5a2b70-6f5e-43ad-be8d-cef2be011d6b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ff9918c9-e7e1-4f70-aa80-da9c49740d96', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b2c4dad5-14eb-4f90-a9f1-bf5dbd3a232b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cccceb39-7081-4fc8-8816-4f1836330660', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('22c1f87e-10b9-467d-86aa-0e9499ebf406', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5a2bd219-a88d-45b2-aa70-436d60dbc0cc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a1bd4a34-11dc-43f7-839c-0586857356b8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b683c93d-0ad3-4d7b-bfa0-d7a93dee54ee', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ba646cc4-0659-44ee-9105-09dc81d5b63e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('94f6efa8-91ab-4cfb-8aef-779607cc8445', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('473ce603-1451-4d7b-a349-3be047009fa4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('941c8c58-ddce-44a0-89ec-a6c49eadeaa1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4854884d-c0de-4615-a08e-62d0852977b8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e2acae6d-fb45-452e-8fd2-d16b5a61cf93', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('881ab218-4e1b-4999-881a-09dfbd85200c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('da431b6d-2c2b-45bc-b97e-5c727f8e5bd5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('261f2449-3d20-4c37-8e20-020eb39f6930', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7c3942e8-e704-4284-9b1e-464ad5a8df40', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d08840e3-fb92-4366-a80a-743a30784ffc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('88d1b63f-6aa9-4bdf-8641-40d407f46862', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b3c4e793-94fd-41a7-a15b-d3a2f8c53ae9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('83241904-b79b-4ea1-b026-695d0359bfbc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('94780232-eeda-470f-a5c5-ad56892571a7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ef0239b3-2b2b-4820-a0a4-586f61b0453c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('850acad0-2e40-4a2e-9b06-4641b6c2f739', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6fbe57f9-92d4-4dd7-84f0-146337f536a8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('29447a17-0a73-4b6c-a10d-e06e2ad6bb18', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b4673596-d93d-4e4c-8acc-dcbff8055b68', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('510ab9a4-2fed-4cec-8bd8-9755b2e2e2d6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d476b4b5-88f5-4851-a8e3-650431cbef96', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5eaddef8-ff4e-4471-b2e3-ffb9639d071d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2505ea88-3feb-47ad-b96a-2ee2db6cebd6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d42f8061-3c65-432b-85a6-070721a1485c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('267b5d1f-e09c-4217-88d4-e30e12086469', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('46b23b11-2e94-4ae0-bcd1-469564404aef', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4fb583d1-93e2-48af-abfb-bc30f4662096', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5954b710-2804-486c-9524-f05c267d675f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e7b5c809-59f7-4c67-b994-7b98fcb695ad', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b04e25ed-7c30-4260-ab50-0023cab71b1c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1ecf8b16-6ee8-44e1-902f-7a5fc2cd7473', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e38042d1-0858-453b-ae23-bf4664e538bc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cae6da95-0bb0-4ac6-b1f2-f95e9d72812c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4dc42612-0e8d-480e-bb20-72af1fdc211b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6a0282c6-ecc1-41db-87e3-bf99b54cc17d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1c5912d7-02e2-4309-949b-cca69728875f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1beb1243-6ef7-4fdd-9cbe-b4a910261fad', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('46671f1f-1fdf-4582-a0a2-c255a4ebc141', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8619f4a4-1e58-48ca-8a60-f6d15c0211e4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5ee5fc83-1e03-4788-a5fc-1019b4573937', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b56ac444-8847-4cbc-8f30-04c85ee63454', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1930516d-76b6-48f6-84f5-d472b5761d5d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('546fc944-7527-48dc-976d-5cbd1535562f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9baf8ed4-dee5-4014-9d91-6ca7c21297bd', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8fdefa16-5f91-4d5a-a6ad-df194c48a64b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('05c5872b-6a1d-45d8-803b-7797e06650cc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a4488ee9-b51c-4f44-96e5-81d36e6361e4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1301e219-cc77-4152-a0e6-fe81988a688d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7fe86d82-1b9d-485e-a206-a4c9bb39125c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8a96713c-f52a-494b-9856-5a7cc869449b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dfeb77e8-087e-423f-b4b5-8e8111a8b83e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0debf423-4128-4959-94b6-c4e17adfd25f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('38aa2ac2-71e5-4805-94ae-61361288f235', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bd35e25f-a9d7-41f9-835d-55026654c03c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('eba5fbe1-b196-4df3-8d92-fd9023668744', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d0ee13fb-5f61-40d3-b38e-02eafd89160f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a6ff0898-04e1-49b7-8621-b42846df06e1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e6970814-b140-4805-95f3-610c215eb5ab', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5c9372e0-cb21-4ae7-a461-df086ad19426', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e3c18d7e-cb24-4063-b0ac-dcb8fd3d2b68', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a930208f-7ef8-4296-9f70-24c50656ac58', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('eb43edcb-0d20-4614-b45c-736ef4f56380', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b9592474-79f3-42d9-828f-8cc2e5c8ba7c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('db94672f-1fbf-4898-bff8-2bfb5b2450a3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1280183b-c71a-4b86-bdec-7f3800679ef4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3cdad6bf-60f7-4dd7-80b8-4b1bfbc0f7b7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d1d8fae9-566a-4a6b-8a1c-372b63108fe6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('684d7313-c093-4da0-83e8-bd73c6cc0bb6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('939dafca-fe72-499d-979d-6fe0288e6807', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('42a22abb-f604-4980-b6fa-adb1aa4e0adf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b91f7dd8-b4a4-4f9b-9192-300f8e982c6d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d226bd12-192c-43f1-bc65-45803a17c4a3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2b70b335-e6b6-4b11-b138-4e7b3c4c50d4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('deebf94a-2ef8-40bd-8538-9227bb901fee', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('06bf2ac2-61c5-42e9-917b-8b68afcc0d47', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a3aee0e9-b8f3-4262-80ae-5cc6154cdc10', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7a8959c2-e6c0-4af3-9d64-117811ec0d02', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4fe450ed-3a24-49b8-98cc-fa85de9ce889', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9d6a3750-0d32-469a-a476-2d8525f7e692', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c11382ee-e0e3-4b25-b8ba-640dde8c20bf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('82d6e2a0-3c2d-4a8e-8638-4903696927d5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0d98be37-8ae9-48c8-9bff-6b7581e256fa', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('25acc71c-db8f-46e4-950a-8ea76637bb9b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('de8da2bb-9e4d-44e7-ad03-e9763db4331f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0b754d22-82a2-4349-af85-2cee67716f66', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('390087c9-9c6f-4c2f-9c77-af65112c520a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ea4baec8-4128-4e59-b0e1-69b450c46755', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('24f9488b-412f-4314-b160-2897f4dcff1b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e9887f07-65e4-4b5b-a134-f023fb127cbf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('310cdf00-c863-4ea0-9e4e-9eac8a74f51a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2e07da63-f1f6-4342-b090-f3c465e9093a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f9d5ba94-1514-4400-88af-7b7d3798f473', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c8cc9a24-e3d0-412d-867b-8e617e40f1e3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('20926d99-1f1f-497a-8e13-ce3cb4b1eb73', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('32b78d45-4a5c-48a5-bec2-efacd97dc76b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b54d5034-1898-4712-a472-5ecac0e22a1a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('caa58c78-6540-4f75-a24c-d4ea5f218cb0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('57ee73c6-769e-461e-9cea-7bfe56970bf7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ae30faa4-b82e-4e65-8324-360fdba2d504', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e65ad361-79d6-46a3-a7c7-a18048b7237a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f38fcb66-ea16-41fb-abdc-ea3df857d5e4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('97344c39-24d3-4df5-8dba-ba41ff28a020', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('81ea98dc-258a-4ab6-8537-8de22e9e90be', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0a2e575c-9d22-42e7-8446-546ac3cda8ed', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6c787015-c910-455d-8b2c-c3ae7bece7e7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b1efc8c9-2f6c-4ec2-84e5-29444c0fcd29', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('680b8464-0536-4f87-a952-56e549a70a99', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9444adae-37a0-434e-97b7-3304b5577498', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('93ec1b20-de2b-4af1-924f-047a7afa0276', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e17045f7-b4ef-4c12-beee-56b1b5ef7190', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4330591d-61d5-4435-827a-c71b8328a700', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d6d69027-db1a-444c-be6a-e14232b71647', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0ca35f5d-778f-4207-88ae-beb5a648a6f6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('511d8f3d-266d-4c3a-9091-a7b16d8e61bc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('61aef2e8-ca62-4a62-8a4c-6a56f6fa6880', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5167487b-90ee-40b9-9c34-535b74b3186e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f03d3fab-a32c-40a8-9fb3-ff456bbb7f45', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a0a8a5e1-e11f-44ec-984f-163e049c81e1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4a861961-b89b-4ed1-8a22-076edb1fe182', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4241127c-1c6d-41b4-9350-3aa73785f6c5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0c9f6461-5ab3-4c39-870d-e66aacd5d522', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('206fcdf2-c22e-480f-9029-42183cc2990e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7d188b98-3755-4753-b776-7226df8db3bb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('51c51fa2-3706-470a-9d15-0bad421ea7d4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8973550c-23a8-40d5-bd36-4b4f8608841e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d3aa37e9-88d7-4099-8fa8-0bb25f6db328', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e887ff28-0576-46a5-8faa-b4167f9cab6a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3f62e7fa-ffed-4a15-88c2-2d4a231c7db0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6becffbf-7ca9-422d-a429-c022f023d9ae', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e1947aaf-5b7f-4597-b296-25830e9c945b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('32860409-f9d0-41f3-b19e-25a38bdabc3f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a822e970-7b6a-417d-81d0-a8db0c985427', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('44f00bec-0091-4523-9235-84aa669de6df', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6fc5eacb-5328-41c3-a71b-e7712338862a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('efb67518-722d-4f1b-8280-e3f894406dd5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('87f8ac1d-b082-4961-979c-cd3de0e46b21', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b8a958a1-b18b-4198-995c-7057791c7b6f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ba7a634b-c352-418c-a8c0-58918f32f8a7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e3eeab03-d7bd-4dcc-b076-3bca06fcedcd', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ed0f7762-a094-4a88-abde-8472da33bcfb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1be4a900-49fe-4fef-b4f5-47643f463859', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9455fccb-71fa-4cff-bf89-5dfc719f3374', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ea674a43-6195-4c02-8bbf-88c2255030ce', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fdcffa04-a455-4869-ab8f-2f2fa05e4b02', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e6b918a1-edaa-4170-b6eb-9c8257b9a72a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('67b756a8-aff9-439d-8ac8-b8965b63ac32', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c3fa6a59-6d7a-4f1a-a5a5-3ebf64250a5d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d85c013c-e791-4bec-ac0d-a217472cf425', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c21abea9-6973-44c7-91f4-2d163d97764d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('60297e5d-2f7d-4734-9a25-f2639ffb7fb4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b94eb65e-0105-4cf9-b238-cd3e4715c08d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7454ce37-a2ba-4f52-a5da-2190203ca089', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('98ecef93-9816-44dc-a028-61cc9403efb9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d8bc6523-20de-42c3-93e6-5884924a7cdb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('eed193d1-f65d-4738-b8ee-d991aeea4389', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('da9600c2-7dcc-4a7d-87f1-33f4a441e807', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('03602c91-9c55-4264-8c24-9f9d3cbaf869', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f1afc7a2-588d-4b7e-9975-7b0eda21f846', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f8a806d8-a37b-4513-a77d-26cf05108c68', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c184a3f4-ab4e-4263-a14c-70243c83e166', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d53e98ff-47a8-4be8-a668-c3b45398f278', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b9d1cb3c-79f0-4640-b951-ad41f79d7b95', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cad96a06-91b7-43d8-897d-7bfb1d7054fc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8806c446-5551-4059-ba53-850a2d147c7c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('11749bf4-1bba-4698-93cc-41cd8d261166', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3807de9b-30c6-4a1a-a434-85e80560d3b5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0beca0d8-2895-476e-afce-0923bba7e701', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e03da822-f071-4c66-890f-f93a458aec28', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c8f5fe32-5429-4991-8d88-ba9a79aead8a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ff0dff7c-9ef6-4ffd-916b-7a4fad718e8e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7880ca8d-9bf6-4ae4-9056-5677ef591442', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e811eb41-9645-43d9-86b4-d3b522acede9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3f16c617-f9ff-4634-b4b6-2cee590e2cd0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4812d3ef-02dc-4a03-8d13-7661dd92477d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2bcadf08-a16f-4ab6-afbe-83db1b1424d0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('624f1c38-a8ba-40a3-8f6b-dfe76cc36034', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('195afe34-3bc9-43cb-86f7-7eadfb5d25cf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('02e3a73a-07fc-46df-a14f-569f31249c16', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('08a3ffd0-77e4-4759-ad73-d42ca4d2d807', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f87398bc-225a-4eee-bea8-7983be6ae529', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6e962b9c-39cd-4cec-9750-c36419ff6319', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('236b88d3-09bc-4750-9219-61529f7740af', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a5eeaa7d-bf09-41e9-9414-470442665789', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1f552123-71ce-43f0-b091-a43adb7a8a0c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('09a6064d-a472-48e9-9755-d0117f2af6fe', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4cc5242e-7cc3-426c-9025-ccab1d8a895a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bab68a5a-2016-454e-b143-8c334188d2c4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('60dbf8ee-3263-4878-990f-ab43fe96e48c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9115be3d-2bef-40ce-b0c9-339e460c751d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ba27345e-0699-437d-b4ca-24a8e326c345', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f2850544-cbc8-4add-ad35-4b634370b913', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ce0b0564-7cda-4c03-afcc-0854f3c5e519', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d1767f98-0fc1-48e6-ab30-0cab02504ee2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('da979efd-9d87-4dc5-a839-493e883cf292', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c1816e75-de8d-480d-9a62-30805b9d2f99', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f913c978-1afc-4af0-9bb6-8c21eed95991', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('374b8a48-00ec-4df2-9320-848bedfad9de', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c55c0032-b1a4-47ac-89da-bb9c527a4a73', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cf0de0eb-126c-4c60-aaf0-626f5c17820a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b4224d96-af95-4008-9a96-9ae04b44913f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('38061696-b53f-42a9-86c0-77b7196a871a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e668cce4-9f01-4c71-b28c-79859e02971b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('594d657f-567a-4e69-b28d-f2b79136ca2d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('99c49e4f-cfe3-41d3-940e-915c2a2e9641', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('22600f05-6955-48f7-8930-c884c9c31b06', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d7a0d94a-c274-439a-b500-0f69b13c49fc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b28425cc-f859-43db-b3f5-64b5fb6a668b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('eb7e6ebf-472b-40b5-9d88-47263fdb01cf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ecdbb376-51c5-4de3-82f5-c5e73c0f43c5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('de1d831c-b96c-44fa-80a3-725856c6f998', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8cc95b98-8edc-4652-ae4b-9752d3cfd6b1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c573267e-79c1-4e2a-9e95-55613006a3c8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1bcffd04-b60d-4cdc-8fe7-df9bd04caf47', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6ef557f3-0b1e-41e9-bde7-8abea686f965', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7637bd59-9da5-4cdc-a37c-dd588769d092', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ea1789f5-11fe-4ec3-8d12-2623ba592c7f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b66e76e3-086f-4edd-86f7-b052ada8397d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c1d3e826-4d68-4ec3-b3c4-5617a1c14371', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('32defb6c-2a81-44f2-ae79-7d8544d807dc', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0144b94f-8302-4eeb-bc90-d09e06966ac7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9e5fa680-2abc-4f25-bb22-bd2fe04fd860', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6587000d-2225-474f-a5c3-480188036398', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('353d7a47-2248-4875-9776-469e7a028cae', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0488a5bf-a825-4105-965f-3fa793d5b9c4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7c817da8-f355-4456-8074-7bf433924285', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2d7800a6-63a8-4017-9613-6c693d3cd171', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f32f51d5-3384-426e-a1c1-b5b6a263b647', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2f06897d-859c-4e56-b9c2-947d128e3d63', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a7ff4f1c-7c33-43e0-b264-37339141f7f9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4d6a853b-5d93-4400-ba4c-a28a96721af5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cb9db0cb-6a60-4f56-85e9-97ca9734071e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b70eca31-fcf6-40f6-9792-2fdb66bb129b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b38a6e56-e439-44d2-9ed6-3223e21c6224', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('95f09796-be4b-4b39-a759-a1f5a4fe54fb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c3a212dc-036f-4e84-84b9-6e7367b407a1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e97003a9-9162-4142-8d08-814e6c8fabd9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d96f1d59-085b-4c42-9e01-1513b232a067', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d8d23634-f1c6-4a13-bb39-bae8e187df04', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f3e17013-eb06-49e1-94a8-2e81e0f8a706', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1373e547-4804-4c8d-9014-ce51c65f3a06', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6712a948-ac81-455e-8d87-cb05438ac85d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bdeffe17-405f-4ad0-8131-82728ea0e382', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3e298df0-8c98-4e48-a103-cfd3bbe2bec6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('afceedea-4a23-4f6f-a0a2-a210ac148935', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3f156460-0b5e-4e31-9ffe-bd27ad172ade', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9fe16585-5125-43c0-a683-f4d1579f784b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('957da54d-43eb-45d5-a3c4-34976d178bf3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9405dc92-3dc7-4f4a-b799-514ce78ac05a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('96d81c1c-7d32-4b58-b7d3-7d7d88d250b7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0b519921-7548-446f-a6e2-0986f0cec622', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6d013dc5-c320-4873-99bb-d3cbd287ccf5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5c561605-0895-4a2b-b850-9572156e6635', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('08008ffa-675e-46e6-8f5c-bbb701d67fd1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8bfcdf97-8c34-46ca-8159-1314cbb42105', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c8583847-e84a-4286-b04f-368c61118b00', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d8c41124-ff96-4bc4-b3be-d0a8091128b6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ea2e5ea3-6e8e-473e-9bca-3972c30c727a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c33ab3ab-3d3d-44be-987e-9f1ad950f25c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('84f70526-107d-4b57-b7c2-653c8efc2737', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ede31012-fbaa-4a4a-b5db-001a2ded08ea', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2812b2d9-15c6-479c-b59d-bf980f4bc9d7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('dbc52a0b-fe89-46a8-89a8-f155a437fe07', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b29939d1-67c0-4527-88fd-41812023f402', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cd5218c0-fc28-464c-bb9e-ea0eb9698f66', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('10cd909b-0099-491f-9a73-0cf1d7765f35', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('db6edaf5-7e57-4e26-8172-20fe06d19e16', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bd7f4de4-1435-42c2-a275-b56e49670e52', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5f936257-6096-4792-a496-b92e46d93d0a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3086d58a-42c3-4c88-ba4c-a1025e79218d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('814e38c8-c053-4c27-9487-997cf318a550', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c123b9c1-7755-4fa5-a0c8-ab6bcb0c7156', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('529abd87-8855-4eab-a795-a83717bfa4b1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0e51c89f-6101-4b6e-be17-53df018b88f5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6aa26a03-2515-4b88-97aa-1d100dfe872b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('de10229b-be9d-45dc-b1bf-8f832ebffe68', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8695131e-a5fe-4e01-81da-99769f924a12', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('779e4c3b-97f0-4218-8eab-5575a6afa54a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('10063dba-d6d4-43fa-ab89-d682c47a91fe', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('70cf4eb5-99e5-49d1-9c03-70316381bb21', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1b453f97-a12c-4d51-bf95-2e782b425385', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cf95f6ed-2e24-45ae-824d-8cc58ee2c2e4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3b195996-371c-41e4-9b66-a50553582e17', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8e9ae339-2166-48b7-82e7-f319413db079', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ddcd1293-8e77-4cef-91ac-9abfbc2bcd44', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('98d81696-7c71-4ffe-bfc2-1fea37613440', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('43b09570-1e0c-43b9-811c-4aeb27eba284', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0f5c3f08-d249-404a-b740-d759fced2d09', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('756acc01-691c-46c1-b2f4-53321cc442a2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6c0656b5-472b-4859-af3a-b8f1c53231a5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8ad792c1-10e1-43fa-8d5a-a6f3810878a2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('75550e48-c62e-4734-9406-ad720b5b1f90', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f3bf0870-b546-4607-a032-a3da135dda48', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b26cca89-03f0-4498-bf64-7385c0b7244a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9998b7f8-aa0f-44b9-813c-61a2861e242e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('76968391-174d-4530-b310-1244c4b1897a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7ffabc42-58db-42c2-a3cb-e4ed830f47af', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('863eea7c-8b49-494a-9654-9963f2dbb4e5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b67105de-0348-4d4c-8ccc-aab9ed905eb6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('11a4c50e-451c-4041-92c6-671263f82f2d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a78188dd-3129-488c-b6e1-4889725f5215', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8255ff29-5961-496b-9fda-c71078e47e51', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('19382a5a-b982-49ac-9005-9358fa7a670a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fe0228ea-649c-45a4-b729-181aba7f3294', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f218c4d9-d10b-4445-b381-b73a71f5848c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6ebe0c4d-1649-4d08-897e-805019faced9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f5fc0f70-790b-460b-a072-d1f9c01bc7de', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5242e0b6-12e3-4a59-bf06-de114cb69ff4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fc09e45c-99c6-46ff-a51f-39de6d561c93', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b8350678-d30a-422a-bb5d-79c65af2f890', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('87567caf-5abc-4511-9191-27dbdbbee88b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0f833f5a-8afb-4934-a8a6-9dadbdcf89dd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c85e8116-355e-408a-93fa-c699da2a76f3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5fe9a533-2cd3-4433-811c-fcc415acdf60', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3de42185-1e32-4936-b305-d990b85c45c2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('359d8691-dc07-4b5a-9179-0f78927b4660', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bb8fc553-9dbe-4ea5-a3ea-02d129841f68', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2698d560-1c07-48e5-9d9a-78ccfb2c0631', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bbfb4fc6-80f7-4a82-aa82-3d787539ebeb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('07aa8ca8-e06f-4335-9cb0-99e98d45b2c6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('21bc4186-042f-4643-bbea-61f44563225d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7ceb0f31-aa57-433f-a2e3-0408c2b88b10', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0726dd6c-118e-4cbc-9077-d4dcb0e61643', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('24c34e16-c5e6-4571-b850-fb64b5ddb61f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8dfb5e53-1554-4e5c-a045-85121ce4bd71', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8aa371b8-dd2d-4471-95ae-149e30502e54', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('13a3ca39-6352-48e1-b1fb-82f3fc5558f2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d04aeefe-4ba4-466f-a563-b811674c6de9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6aa35ccf-fc0c-4fa9-baf3-383bd7c6bc42', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e5871fb2-3928-4139-9468-10f0f12d5e5f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('12bf1e90-3965-415a-b2fa-de48afca81f5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('834d7138-e338-4517-aacb-1c6319fa34d8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e3026ecc-4a37-438b-b53e-e4ac2d4acd87', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e6409531-6513-43a9-84a7-eff44b18285a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d00a14ad-fe79-40fc-8f72-722fb5cd30bd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a9296dcc-a040-460e-9319-d93938975fc1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7b9008d5-0555-4209-8594-8d2c11e376d2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('256083e7-90ac-4f38-9bc1-deedb0f78d2c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c470f55a-75fd-4754-95d8-02db7679b5e6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('28bf24da-eb68-4a99-8ff9-6e4145f5e805', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('306c497c-f967-41e4-88a6-6d357955a6b4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f93693fa-7dc5-4513-8537-be9541d6e5dc', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('33a45f49-ac74-4444-a193-2ed1e0be110d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a43a17b9-e207-4edd-9184-790b10b105ce', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d5a60c82-347b-4ebb-b95f-afff297bf966', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b93cca78-ac4f-497a-90b4-2fbb41ece3a5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bb40b3e2-f355-491e-a3cd-fb3ee258d4b8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('78de8932-0d41-49a3-bd52-4b01648d77c4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6e7feeb7-4891-4ea3-96b6-00d883da37c5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1ed7ff07-778c-4920-a550-563b27223228', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('73fbb1f4-99ac-43f3-8d7c-e032f636754d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('57083628-836d-4f19-9359-5fb11537f81d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7db53bc9-99f3-478e-abb0-437dcbd32051', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('65238cdd-b9f4-40ce-87db-581432f3c7b8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9771d06d-8352-404c-aaba-743800e621e9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('31b17fc6-f132-43a5-8e48-652c48306331', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b34392da-5070-40dd-ab44-d411a9742f6d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e37e21bc-4d4f-4d41-8c24-399be1680a15', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('aa9b0636-bcef-4296-bfc4-2beb3c99da38', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0d96a253-347e-4903-9db9-b362335e4341', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1350b6fe-91ee-4c79-bc87-e2632a01100f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ba80c834-f5a8-4243-98a6-9a3be63c4f47', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bff60077-ab16-4e5d-8667-1ad2b801b961', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('42f0c634-d86b-4129-822b-f103cd6e0755', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2b36563d-caee-4170-b444-ec02ca919165', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dbead323-2088-4b0b-ac6c-599696219411', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b6f28163-8b15-403b-ad8e-8322ae8bb5b9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cb295fdb-e294-4b05-944e-f0a4929ebeeb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9cf4d386-c968-40c4-8af9-401c58cca6b4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f3af3c81-a512-47ea-8b47-0386291e6590', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('14b3a0c2-46d5-409e-bd0d-ff369c37950a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dc8ae2b6-d20e-4592-8356-3547bcc58f80', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d6ea4d88-241f-4430-9590-918a5de2a3d4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3010c421-5c96-4f0d-b214-c773e0915564', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5c038c2d-e3f8-4593-9733-0e1d2c85e318', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('270aac69-03bb-4429-b925-3019bd92cf32', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7d632200-5506-4856-a3c0-d806b1ee708b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('63a0e010-3a4d-4ec7-bcd5-2fa63a1cca23', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fc2159a0-53c2-416b-9daf-506258c420e3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9de4eb42-73cf-4178-ad43-0bc7b9042c76', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f101cc07-ed84-4e34-9f70-62ec6a646e81', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e1cd9ef3-11e4-4907-bb78-b30f83f576e8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1d4c6f1f-200f-4a68-ae7b-6fda13687e41', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2877af8d-ece8-4b33-8b68-a4985caa2635', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a4b7dd17-bc12-4152-80e0-4186caab003a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6ec65964-76d1-4e7d-aacc-6a18e4eadf67', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3dec9bdf-06fc-4a27-b26d-5918ad1e5990', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7e71f107-6953-42c7-a560-dc9036094198', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('51bb98dd-9201-40e4-b008-221337eeb471', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7efca22b-d9ff-4331-a718-ddfca5ebac59', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('85505863-6857-4ae9-82de-f9394eebd7df', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9a93e3c2-b1c1-47d1-8761-0cafe9b42917', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ccdf92f5-ebce-4d9b-b544-e470959b498b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('acf8c4b2-7c5f-4e89-9696-77a598b5f8b8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('307b971b-39bf-4a5d-8595-ad080abafbb0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ed2f5f84-cc30-4f29-aef7-48eb64a5fb15', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c3aff634-452d-47fc-954f-9edebe3a0c74', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('37dc0f00-4620-46dc-83a6-3d64cbc7a1a2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('06917568-e508-436a-a50f-246ea2afe064', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('84fffac0-e3e1-4374-a4e1-6d16b91d9e8f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b152c130-be97-416c-b531-52656dd3c38d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7a5ed45e-7096-4f48-a0d9-83df51f3349c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d6c011ff-bf38-4f09-be3e-45f89eca1ed4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f2395c78-9098-4d15-9ac4-b330a6802390', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('52fd5f0b-55be-4e14-abfd-6b94ff5b830d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b371c978-c2d9-4b06-94be-a0944f0e8b34', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a81d830d-68c5-44ea-bd6b-968a28f90197', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f8fd6f7e-9507-47ad-ab42-fbd72c3718f1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a64973bb-c814-4af9-b020-99f5f726dd24', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('aa3db109-7ed1-496a-9490-62dabce849e2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9fb3f5e1-472b-4679-a4a8-099557352ec7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5c2537c8-eb2c-4da1-b78e-071377668767', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('909ff58a-4c4c-410d-a3eb-f17cf15c330c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('07b606b4-e386-4d2d-8ecd-438aa4b3cd80', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2b643877-6882-4d24-bf51-fb39d8a59287', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ce71b519-42cc-4674-8bc0-a2df3c13b6c7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('425b6cf7-172a-4e48-9f66-5592d4e25a99', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('51982882-3575-40c4-86a1-c05fedc436db', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5b5433b1-b6eb-4034-841b-559cba014f35', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5ce74841-55a0-48a2-86ff-253dcfdf8a6f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9851392a-7c6e-4642-881b-dd7728556b86', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fe903d29-2b20-4f62-8973-ce885b0d03ab', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7c6415c0-9900-4de6-9459-e4d50b8e9ae4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6035bf8e-466b-47f7-a3e8-96bab2e8033a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fa80b5e8-d9c5-4d4e-b7c7-3eb28a90f991', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1326d07c-623b-40fc-942a-659f5c7308ee', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('118e8006-bf10-4b7d-8f07-fb4b8d9de592', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5310f493-97fb-4203-b41b-71423252cc4e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a2f2cc36-6c62-44e0-aaec-b4749ed25558', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('09d8befe-d786-4023-b10e-5479f6d09bc1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('03b9f057-a59e-4253-a83a-ed4d7058a663', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('252d4677-4f71-4719-a287-37245b03a8bf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('108a7577-6cac-417f-a0dc-84c799c54797', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5367452a-5726-452f-a76b-8393cc5e6689', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4538eaad-57b6-4089-a058-2e7b2adfc2ec', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1a32ebbf-8e70-4268-bb9e-dbcc7a501b71', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b8faa38e-6fff-42fc-a1ce-b84070077a61', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('af6f87de-0aa9-4320-b5ba-96a8ac23c9e6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6da9d98a-3318-403e-a948-bc33efe3d5ce', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9821f69a-b029-4a8f-b1b3-229517380f60', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b2f0d8a8-ad0c-4c52-9c05-967973c99f8a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8bee7b6c-05f5-4538-baf9-452d909f0657', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('03245b58-dd24-4cd4-bf3f-d9ba51a69810', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ff171f90-f6f2-4c7f-9128-051462cb2368', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2c0faec0-6d09-48e9-9ba5-ef060e4d5f6b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1b1da9f7-1fb1-4b94-94d7-57275b028d54', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('94866c63-1d9f-4b00-b0ff-c6f48c5d6462', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('871fd02d-def7-4c83-b40e-23029a4019cd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d86f4fc3-58a6-4464-8836-4ce8b34f25c9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ae26c1c9-ca79-4a83-a050-0eaab121ce3e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('11542ad4-cd41-4d26-b778-a25b29175f7b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e6d44cf8-f6fa-4138-8410-982613c62c49', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dc7aa55a-ab16-47eb-a29b-79e64328fa31', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('37c59916-a966-4dca-a1e3-0cffb78ad141', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('08963816-c027-42e1-80a8-f55dcd6a02aa', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b546d5b0-59f6-44af-a54d-d8e3097a3640', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5e3ac214-0f11-4af9-b637-50ff3f841b76', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('85d1d5a3-30a5-4bab-9670-878abc6bfe54', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c2ccc14e-f11b-497f-95db-5397aa38012b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('36490d00-f5d4-4722-b285-9cac45e7dd5c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ba13ab33-99ee-48ef-b205-73e9adea9651', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('891fe7ab-2113-4f20-ab6d-3d81cca0941a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('918840d4-592e-43eb-afa5-ad6ea37043a3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d48cd569-cc1f-4f27-bb9a-35154e5fc0b2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('10ff5603-7bfa-490e-a468-6d231db02ac6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1ec552f6-834f-4b68-ae60-6d39e6d887e7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d53e3095-38c0-4be0-b7c4-17d6c505c370', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('82982647-714a-4203-b8f0-3d9fa5d22b4e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('39a2c817-387a-4a54-a751-6dfc0d781f8c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('76d74da3-9fbd-43bb-9083-093a9254af2b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0303b9f3-8860-4ebc-b808-d4d2da18f5fb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('09cb2efd-3998-4b84-a315-788b6375ffa6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c17186dc-564d-4f82-914b-202ad8bc9941', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5c5e2c73-6a91-4b38-a290-fb7fc94d6cc0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b05450fd-5e5b-4aa1-b334-0b886ced9492', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('708ff719-70c9-48f5-8664-dbf49352d261', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2710f7f0-f352-4e71-a527-38076d6966ce', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b012ee61-8155-4fa3-bee0-9a0918452bae', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7fd8da11-6a47-4ca3-8bf3-9713a6ac0305', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('18fb2aed-c5ba-41ea-ac09-4ec940ff6eff', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('63ab27e2-5a5b-483e-8346-0024da814b06', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6c83af72-d5d7-4076-b7b6-33ca23c80ff8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('14fd3310-5109-472b-9eb8-9b3aac0cc5c8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8833f9cb-d000-41ef-920f-6e6ba586c65d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('49e8c569-1fe0-4215-8cc3-698054ff896f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a351e412-5f16-4c87-b09f-6c0290e20b7c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0e190f5b-0333-4f70-aabc-71d2e810a712', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0fc0933c-0397-4b0d-ae81-18c41d3fe082', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8eb1d02d-d44f-42a8-bd93-a05174ce15e0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('133a7879-3f1c-4daf-8b16-9160b4477288', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('77ef9867-e939-4d36-85e1-4a573c4a9b55', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cedad28c-ea54-48a9-b2f8-e16a29ec56a1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d2ef2562-a654-4af3-b1eb-6e8bcd35c03e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7377295c-c6d9-4826-b712-ea5df5c3d8d1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5ae15451-1a59-45da-b59d-02884a418fc1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('638a0990-bb30-434c-80b5-65f3e33732f6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c0844f33-c3b3-477f-9321-4b342474802a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0de0bb80-9691-4f70-9bdb-53a862399dc1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('701ea625-3ec6-4ee9-8fbb-fb95ab1137f7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c8d78c39-6d4d-48a7-96f8-80fdc50b2059', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('84802890-6128-4134-8ad7-667491cfcbf7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('19932b77-d4fd-4664-a0c6-ff8fb707f697', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('63eb26c8-3d39-45f7-b2ef-5038f301bddc', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a71abf2a-ab11-4bdd-8591-6977673bdc32', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fadd73e5-eeca-4f5a-b07d-998d11eb411d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6dc07a2f-428b-4621-9f39-8679a5a5a780', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e1cfb24e-d3c2-4279-b1b7-0e037766a0c3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3c82a048-8d56-4f34-98c4-a20e193f815e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('47388b74-46ec-45fb-a817-031c959a6c2e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a9ce43ae-4dd7-4ee8-bf8d-d2f3fba4c803', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fb0b7122-f782-414f-85b1-c1df876a3441', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0195bb79-457f-42a6-a21f-ffd238256b28', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1230adbc-b61a-4ba1-b298-c831c2862e8f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8280b446-c17d-4d5f-aff5-ab391cd0af09', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8c70ecf7-82ce-4661-8cc5-0fadbcc4151a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('53e80cc6-7e19-4c55-8c1a-3190844ae734', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7aceef4b-2faa-48c5-8355-72db528f4822', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4e5bc3c9-14f5-468c-8ef6-6bcb25c17948', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('85e6093a-5013-45c3-a756-66e50d03b6bc', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('24fab1b7-ae06-42e0-8746-4754b526994d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7044a856-3670-42b7-9719-4a8638fff92a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('13d82035-64c5-4ca9-a85e-988bc4a2eb4d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('20f04373-bbb4-4b9d-a89f-d21272d75d59', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('62ca73f6-89b1-4113-92ba-a7823aabf31e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('367f629c-223d-456c-98cf-ddf6600d5858', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4c98fcb4-e0b6-4692-86e5-dabb78af17ed', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('740e371f-18b1-4e93-8408-2fcc777b7da6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cdc318a4-f418-4564-a38c-f93562dda048', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2c15e623-a22a-435b-a125-3edbf2a9b5f5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f2a2d3d5-165d-43c4-91fc-7912f8a96bcc', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1c9c5558-dd2c-4293-bfcb-0160e981b6e0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ced737cc-1da8-4b12-808a-13e36b8bc37e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('79ef402f-0c51-4ae0-a0dd-f0a09505a273', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('19241a87-0b31-4156-a479-cdb61cafaa66', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0b67cb5e-3570-4ca7-945b-94f3390bec81', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('22b95a69-d861-4d90-bfef-a9c3f4ba5d52', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5306f8ae-55c4-460d-a133-45f8eae30eb6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a1ad0f25-f3ab-4bfa-8e4d-674d7ddc3ae7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('39500fd6-4dcf-4c33-9766-c9b4071e4754', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3f31fd85-c31c-4258-8219-2ed6f7a38f29', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5feb8ea2-f497-4058-b056-dd96514c70c5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3461faee-7a67-45d3-af18-7de8686c381d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('164e7fa0-ccac-4331-be5a-dc965b1c31d6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('dbee33c8-80d8-40c9-9d16-af5c99aea9ae', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3d17a863-17af-48a5-a6aa-abc815209773', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0447c01c-fae5-4c80-a59f-a9f330321b9c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1b4208a5-e7ba-460e-922f-a9fb5c7e79e7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fd1b146c-609a-486f-afe5-c87430e1be15', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cebd9ecc-f841-4d44-a3fe-3c82827f2918', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d09b10a6-f74d-4e87-898d-851cfdb9dffb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ac3ee728-8957-4b2e-91d7-9f7a0e543931', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3a1e0eb9-bf91-4bda-b804-8707d753644e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('30b91518-31ef-4b3f-a539-c1f7566e0c77', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8e9971fb-270c-4897-ae63-50f457d9d0d5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fa9a7713-93f2-46c6-b3de-9d6e42bce983', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a352a7f2-6caf-48bd-8f2e-90a1b3d248fd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('052b4092-a5bf-47f3-8ba2-0734ec9129d4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7bdb3dd3-ed56-43ff-8a99-a49101ba7d48', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0caafe33-8257-4550-9e75-c8a828d5dbc6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4c75b994-e714-4781-a51d-6f582ae07f6e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7f74a25b-753a-4534-bd83-0db07cc6df2f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('05a6b2b6-58dc-4310-bcf1-d923168e2070', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('64229d80-11aa-4910-9e0c-a211d9a5ca95', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9ddb3c98-f345-4f59-b067-7673d0e06673', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('98f81765-6d0e-4cb5-ab49-da912f668f5d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f4bed22e-44be-4ce4-9d95-5d9be630012a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8a7273c3-5012-45bd-9d3f-72dd52163117', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8772af22-67d6-4721-bc48-20f841f171e6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b31618ff-d749-4aa9-86b8-08eb2de9dcac', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2899fdb3-40ae-4885-8d6b-7c0f07493ef8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9b229b0a-e7b9-4fce-a134-c6f5199ce495', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ce3d8199-1a11-409c-8f0f-99a8344f1d1a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('46ba8c49-58f7-441b-a7c0-290a9f490a1f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bd1cdc2f-13aa-490d-84bf-1cea1d91fd05', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1be877de-9e9e-478b-855b-f4f0e6dfb842', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ec3bede7-5502-40df-bcaf-d2782c15ed50', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7a48ec29-24be-4d13-b788-264eb6fe6327', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('98c6c409-250f-4977-89da-f3c242f4be8b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bf5371a6-e09c-4484-b57c-62aa6befdd0c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2fc229bc-25f7-407d-bdfc-e9469c17ca34', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6093331c-adb2-44e9-baac-ef073278751f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('46d04d79-5187-44ec-8f30-e6f823bc47e6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a0cf1824-6284-4031-980e-1df923d144e0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3817a2b3-7031-4489-8c87-23babe729843', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0a93387c-682c-45d7-8a24-e538678f5cf4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('35a0a69f-e93c-43f7-b406-3c2d01e1cd8c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d241e268-fffd-4d21-9936-819ae9975f85', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('86514079-9959-4ffe-9563-4be364780b39', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1bc97522-8adf-4246-bb4f-9a870002fbd4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('94fb08b4-d5d1-43a5-a395-b1e261a46e0b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7ee9690d-ebff-4afb-95db-fad387eb4255', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d6e4ad57-a163-4508-a694-99a87eeeb986', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2d00deb0-bb73-447f-b867-71be2d2dbfda', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5eb167f7-80c1-4c71-9c63-b9d6994ec251', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3a64d35c-f155-4420-a87f-ddd771f7e500', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('44c0b607-7d0a-4701-9570-8d339189020f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('238a91bb-2186-41f0-a97b-6e4c62a2c6a8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('91f36783-f411-4708-a88e-b30fb94d849a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('52c74fa2-27f4-4046-8712-759b3f47e48a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0dc256f1-c7eb-4c52-95b6-a05ef1f92d4f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2a60ab65-5d4d-49bf-b184-3b1ef563bd62', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8b30e218-5562-41af-82ce-bf3f633d1f3d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('553adc79-d3f6-4b92-88d3-8c9328e5a616', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('31a9442f-92c2-4f7d-9895-a7095ee96952', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('832cde07-7e08-41a0-84e0-201f12393e15', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4e1db019-7622-4ba1-aec7-4046419a7b28', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bacb714c-ac84-4f51-b8e3-fc74b27e1388', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4e4469ab-f0e8-4927-a374-33384a97811f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4f6ce070-55e4-4d2c-9429-5d4b3fa25077', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('274595e4-31af-488a-997e-688d10886a47', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c110be44-7852-4eaa-b52a-c87a93de1076', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b9ad5d7e-cf8d-4265-9271-2e32128b69d2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('596f965f-b224-495b-9f5f-5150af69979f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e77c42c3-559a-44af-90cd-304eab1646a5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ba6c1883-e891-4628-bea0-78b9787b1403', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0ab92d43-0a98-4d77-9f65-44d74acfe5b8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3877cf69-dfcc-4ff3-83a1-65ef1471f919', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4d8fb33e-f5de-4716-a301-a753f59c5aed', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f6542fe1-149a-4244-b812-18ad82ff555f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('80da5984-53fc-4439-a4b2-2aa030416ddf', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2715a520-f38d-486b-9053-055f6289c966', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8f1fbdf5-7aba-43d7-932e-a9e4f386ae84', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1a09398f-873b-4c9a-9392-c129ccf0d636', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('46a6fc92-c738-40d2-be20-7762997fdd21', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9fc0d602-3a23-4ce9-b8eb-216e58c23cb6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('44074e80-79cc-4965-9525-29ed20419544', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('201bce64-1c53-4047-bfd3-1892e4bb545f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ab127630-3367-4898-b0d7-f3ef0f6fb7cf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5927cb7b-54a9-429d-a229-d3ab87cccecb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('53f0c6bb-a76b-4f8d-81f9-a476c9106436', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b2c4c782-4afe-4518-8c92-0de8c70b70b2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5a04d74f-230c-451d-ad05-3f08d0e95b0b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('88d7ad95-2568-4cfe-8f1c-e09ac9fe8983', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('32326817-2750-452c-8898-bcb42c36d85f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('dd52b6d9-4a90-4a10-9ca8-3d8094a0aadd', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f7c2a405-965c-48a4-aecb-4312952d072e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('138ab6b6-1b04-4565-bbcf-db30047e0050', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a67d167a-e0da-4fe0-b2a1-cc320687f44a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ab46de32-5a21-4029-b5c2-517f6d6002c3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('beec505c-c47c-46ff-bdb5-7fe04a5595c6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d5048fcc-cb35-4f37-bfdc-611473026b50', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ebf101f3-6206-4cd7-a5df-276dcec51cba', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('31faa035-267f-46d2-b9b1-af688c393431', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('13854f26-4d9d-411f-a6a8-d1cf8c267a32', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('44900785-555c-468f-9aa1-277c191fc3a6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2b33fc20-f3b2-474c-9d9e-40be8240e900', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a24b3dcc-92b3-475f-8741-4399f604e189', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('36c7d299-20b9-47b4-a2ed-bd7031ad3dd1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1d6da0f9-048c-4b62-bedd-5f4d4d35b284', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('95ad7ff4-f585-48c5-945a-1a87c3bb2229', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('33bff6f5-22a5-4a5c-bcf1-1e3003bcf530', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('eebc57f5-8fbd-4665-9328-78b0a6600478', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1be5be35-a23a-4f02-967b-f4a7237f482a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cf88430b-e0a1-431e-9912-098933e6771c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('eb9181ce-7b72-4ed9-93aa-49eb66db32eb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5f9120b4-56a8-4a73-96bb-2fd1edcfbf43', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f9768956-c483-4cf1-852d-b6767a8d96cc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('12a30425-8c0e-4e0d-b9ae-da96e2776217', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('917b274c-a8da-403c-9ac2-5be884f4a47f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a37b1549-de63-4830-81ab-816dbea5ddf9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7bddc04e-775b-48f6-acb1-c1c9e638f836', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('283a7da7-7cf5-489b-bd81-a370cd694f3a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d8668032-3755-4ef6-8ea7-7c34e0109e25', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fe2d0171-effb-42e9-ad87-d877454fa221', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9dc88526-27f4-4c56-aef0-740429a8c457', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('67d9bcbb-574f-405a-b48c-f7ccfb9e0a06', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c4f3311d-618c-4e1b-9e0e-925465a5f932', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ec817efa-d1de-4264-91e4-608b736b59fd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f276aa53-a904-46ec-863b-18e593fd2c3e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0fae86ec-61fc-4f23-9713-a51f3f49505d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('17df9716-97f3-4970-813b-d144044d718f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('57070af3-92a3-4285-b6e8-8644989f8fce', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('087d73fd-3c94-4735-b59a-189efda4a80e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('82813289-dc57-4c85-8c73-8e7f71966bbc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6d7c3c90-cec2-472a-b143-3f730bb92d11', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('54ab8484-47e5-432c-afd4-7791561e09a7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0e9f7adf-90bd-4ec9-bf40-82963cd51410', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('846820c5-9147-4f79-9b06-62110498d191', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('54c33e22-f4c5-45c4-a86d-fb8ed86afbf7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d5007585-6703-493f-a24d-f99f4fb1b09c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7cfdc7ad-f7bc-42d1-9b72-ce871adf665b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('330cd455-c002-4416-8074-feb6c6b4849d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b0f7eade-7384-445b-9f6a-76f19007d9b7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e2eddb4e-842b-450a-a9a4-54a3875b33c5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4a4b0f7b-8506-4ed5-be19-7c0baa476c45', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('256a2cac-4d33-46c0-833c-fd12d91af365', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('815ba931-a309-42fc-8865-b077937d4bd5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('34bbf849-5720-4440-bf30-378dd9748533', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d7dd1750-2c6a-48b1-bfa7-ad708c3df73a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4d252783-00e1-4fec-a661-ec1154d98a2c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('20af1fdc-7bf2-4f7c-941d-5294057a2148', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('830e7013-1330-4974-925e-20e142b148fb', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('85b69ad4-c6cb-4ef4-8d96-94abd80c9352', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d0bcff97-900b-4660-9245-993dee9485eb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1d4bc5a7-76c0-49a2-93dd-22e0554d886f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('36e09c9c-05d3-46fd-ba19-91e3dbb1ded0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('aab86d81-273f-48e2-91ec-8379a4097dea', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ae3d0091-aa98-44a3-adbb-2552b6179e97', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e16ceaa4-25a8-449a-9d9c-59a87fdc228a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5885b073-ed04-4ac7-9f4b-664507df0de1', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7ac91a3d-9409-471f-b6f6-8f50ea03a292', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1a2692a7-05c3-433a-990c-54a184a91661', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b0a82131-7ecd-4685-be5a-89dd1c4cc7de', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b27f42df-1a56-4626-a3cf-1eb46e7e8770', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0897f76b-9b66-45ae-a884-5c7edd121433', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('aa81a9b0-86ef-4ebe-98d3-54359961608d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('51727d0c-b455-4171-9bc3-23ff5c73ed81', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4d79f2a1-1130-4416-8c72-b6cc85740644', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e062ff79-b8a3-4f75-8e9f-ae3b31f92022', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('44a911af-8a2f-431f-9e1e-004746901334', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('af3322a3-54cc-4315-b815-607a8c362d2e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c885871c-5f3b-4a02-a550-f962132d898b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dc730495-43f8-42be-af37-a084da0f568e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8ea7ce48-b945-4053-8255-be69b2aa688d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cfdfa9ee-7570-4a4f-bad4-0e18fdff5004', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3df1d2db-6ed7-4d0a-ae22-6e90140ca432', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f7eab9a0-7f14-487c-9434-669dca849b40', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('656d1c2d-2ad1-42df-9774-62e931e3bb0e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('819393f7-e96d-499b-8663-3adaaf1b0a73', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7c142ae8-d190-4c1f-aa85-24f12eeefc9f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3abf8555-9c07-447d-af5b-47bacb517ad5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f3d00781-37e2-4b9a-8107-bdc123df38d7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('89218636-1f65-41ed-b729-d5967f17d33e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('cbff4b85-4722-4e87-8adb-34923d9987c0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('52ae0923-db99-48e9-95b5-d6884b6d4642', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6f009e98-a9a4-4d93-92e2-e955d04bb7e4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('58769cf3-490e-4d20-8255-3e0854d8384b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('212a3a64-9d05-44ae-a394-e335cb98cdf7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('21a21577-f8e6-4856-8c80-996000f525c9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('160977ed-ef11-43d8-9ff7-af86c743d2ab', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9a4fdac1-5925-464e-848b-1532c780ebdf', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d94fd859-6e03-44a1-ac1d-059ed72e23d3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e108043f-3dcd-498c-9560-cde4ed35680e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ac5044f1-1f16-43fa-afe2-24d80506ae5b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ebb468b1-047a-492c-a76c-5031645e7824', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a2effc4a-acdc-4660-973d-e5313a9df528', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('42491f82-8223-4dbf-8660-688e35fc5694', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('aaaf21f7-baff-4867-b84f-36a16f0fcbf1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('66b246c1-b389-40b7-b238-48903a3dae95', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ddcec555-0f99-4cec-9d45-b0ddd4e7fb26', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('76d3e38c-0889-4169-814d-5f7e36c0c767', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4d9e1a7c-84fa-43c7-a1d7-e898b20df129', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8c236a58-3fab-421e-b8a3-6c9df1269fed', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a4b5890e-c3d9-4eda-8a8c-3ebc20a39061', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f35bc896-c93b-42ca-994d-4f5f4e2e5b5f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a5aac82c-b1b9-43d0-90bc-e7c0e0341e1c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6372e9ae-f522-468e-95b5-06a527854b0f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('35f61da7-bd75-4482-ad05-d50ba7e099ca', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3c22ad48-dc16-4af3-8bbb-54ce2b7d91d1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d5009976-c8c8-4d64-b39e-08f019999ae9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9f2f2eae-80dc-49c7-810a-69b10fcc3421', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('42557861-103c-4fb7-b3c6-0acd3d7737c2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('85dbc28b-c5c3-4914-b645-a36056f4cf17', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('45cfb9f8-8e5e-438d-90f7-6b1ee872c003', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ac1f7518-f255-47bd-bf31-29d3cd2bb57a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b45ba485-ee82-447e-8a4d-42679a233455', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ac9bd6e7-e7b5-4f25-a873-79ff3436fa66', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('52d12930-5ca0-4344-bf72-32faf8dc5d9c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ba038cc8-3ca3-4c25-9805-08eef60945b5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b5be48c3-0721-406c-bf86-b7dc1d6a7016', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ba8ff028-06d6-4536-8e79-6c46f8e4b9a2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('470fa9af-f292-4516-be71-346b1e987d83', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e62715a8-2e69-4a59-806e-000886fedd92', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0f8fd73f-526c-4e76-a5f1-043e44386cc3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0e0eb247-f0a2-435b-b44c-34ffc5ecfda6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1aa9a0f2-47a7-498d-b0e8-9e73ef9f5b00', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('57130e2a-328a-4402-bd54-a76cb815503c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0baaa10d-4abf-42df-9689-d6d72a9cc418', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7c958983-efb4-4117-a2a6-4a3d35c233b5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c9732223-5e57-4d36-b412-91122ecb900f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a1476e12-e8fd-4bdc-a1a1-68177652431d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b12dcf3d-9b06-4d32-938c-209adc18ce37', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('daeaae1b-5d88-45a8-8697-cd2e22e519a4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fd07e597-fc5d-4c64-b491-76a5420aec78', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ecde7ac8-3b81-4864-8b26-2e07cdc49190', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fc871f18-a6a5-4cb7-9f23-fee703a845c4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1e643070-dafa-46db-8294-fecd8249232e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('08c5e34a-9a18-445b-9fbb-85a3ff34927b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('71520b2b-f697-4135-a748-8ba36939915d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ffbddcbf-8922-4b3f-9248-47b86638a1b6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('07b70014-fbf6-480a-a128-6dadf6ea6c49', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('193ceb34-df58-46b9-92e5-62ce50a367c9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c198dbfe-def4-43ff-ae55-8e0a58f068c7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5f37d6b1-5ec6-4c91-8f11-32f95dac7b9e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('68136a56-de73-425b-bc05-ab6fed1cdfd1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('43c48616-3e31-4bed-9727-f9e6d6447378', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a6a56680-46da-47fa-b5a0-5012f91bb3d9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ca68370e-d560-42ec-bb93-b14df8eacdd8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('48f6d390-367b-4e7c-ab30-c2e7009248a6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cd8e900a-3f5f-4b54-abdd-72b79c3f3203', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f47459e8-dfd5-41e2-8b4b-c7999197f56e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cddce99f-aca2-44e6-aa84-b1fc98c35c8a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4386a60e-d5b7-4f36-bd53-1de1e52ea755', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e19225c5-a87b-464e-8c63-3f52a45b107f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ab491da9-8661-485f-90f4-a85c7f3310f6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b0214c88-ae13-4faf-9870-01872398bbab', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9398d762-ff69-44a0-a07f-2149bf07bb4f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('eebe4432-38e2-44dc-85c6-995cbecd173b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f1838834-17f4-45ae-823d-cfd97b9ad7d0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('94815866-8e0d-4177-9026-3fdad0866fc2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c9448020-2d88-456d-827c-0b24917a78c6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8b8b38a3-679a-4331-962c-c540eada4c22', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a59c2244-46ef-42ce-9a35-9efeb0a02068', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4556335e-4c02-4879-a850-cc792db27b5b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('88eaec32-bd9e-4fd9-973d-1aaa932c8115', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('62c26e94-cc22-4558-9bee-8ec8e6d29b95', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a0c34da0-2ce5-4877-8172-1306a2599c87', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0eabdcfb-e308-4e52-8c7f-27643332c947', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('14e4dbf5-5fa3-4010-91e0-c56e71623ba9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('359f9b02-63f0-47eb-955b-52a344462735', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('345b8b7b-a948-446f-949a-2a903b460032', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('05d18d2f-a5be-4b65-9e78-8fa91db4c68f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f049b588-1279-40e7-be2d-2e691e8a4090', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a41ad44b-e566-492a-b2b7-9a1ed2bdd18b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('39bc569a-8594-4a3e-954f-3055b382af9a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('6df50d79-b958-456a-ac84-a8786f0f18a7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5879bb5b-1171-41e2-bff7-707e18fc0582', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a277424f-d7f0-4568-8cd9-5299a13d0f4e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('66c939e9-0515-4cb0-ab1a-8dcd9243c53f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ad1241d8-512f-4589-aed2-958e1fd6441b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('39a2eb59-2ba9-486d-8146-0a9a4d85769b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('539a38db-5f7d-4bbc-896d-616bd32f0f06', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('209720a4-ab91-4b78-9fc0-ad5780a97934', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('17e8a223-4aa0-4e35-aca3-f381f9ce1328', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a24d0918-c78b-44a2-8c90-965940f30b95', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('34a3d0d7-b889-4d5a-80f9-a74d0b56f74a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('10971aec-daed-47b5-8514-f88f9ca1016c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e0c2115c-f70e-4c77-87a7-d1f524f47df4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6cfb3c88-43bd-41a3-9c01-29bbcb67752e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2bb03c85-0eba-4ef2-be45-7bd03fb60936', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7e91e09c-a072-44b1-af1f-bc1e6430d371', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4dc88a9e-38e7-426b-a598-f246cef849ed', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5fd54e69-2513-4413-95d6-dde58ed6d8ae', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7db8de4f-b7d3-4a3f-b2d7-4abf43a4235f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3333c620-ed65-4a4a-af0b-71106e0b5b30', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f8591833-ef9e-42fd-b91b-f66b56267b0a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0ee9e55c-9b0f-41fc-9bd5-981f124846d3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bf27b482-99fb-43fe-8789-b926b9131a32', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('51da6c66-df21-4619-bb68-2538c6ef2c31', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a16e2346-b56a-4ea3-b07b-f5f494b2b42b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1d24331c-d029-4539-8b40-2b891f6a75a9', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7514b6f6-f31f-4397-bb3d-eefe138ebb9d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0b188bb5-5eaa-4c5b-9989-7ccccbc9f2c1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bf58a617-cb18-42a8-b34a-56b584e6daf1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0860ac5c-ce03-4f7b-abcb-562676bca90d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('173a65d3-7eb4-4910-a83f-08ce5ed65583', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d3e00370-8788-4a7c-83d6-693a01ccac0f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fd972637-8015-4a7a-9591-683814d6dc1c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('81aefd8d-c7aa-48a5-869f-1df15b4b68ae', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('c1f4725e-747e-4d03-8a86-b2f4fa4459ee', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c57ee5ea-1e8e-4a28-bfed-0bd4477fcb06', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e2c9d05c-4e79-48cf-8093-e8fa4b0a655e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('79cf3f87-a87d-40d8-a91a-cdd257866de7', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('408d2e43-8fa7-4c98-a0f8-4a52ebcce3bb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('48607eac-4413-48eb-9b01-bd264a9b607c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('08c7995c-a7e7-4093-8aa0-6e6e8449f1e4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fc0b7f19-723c-46f3-b40c-a8973fb5cce6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e131dff7-b974-4e12-8324-732296676146', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('99188a87-efa3-4365-9135-700c0899d0dc', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('30ec4923-e756-46cf-ac20-79065a4f36bd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('59adeeef-e54c-4b26-8a36-f4dbe0b05273', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0ae403ca-5143-44f0-b997-be330a72ee97', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('01635d74-7e94-46e0-aba2-a1c8d471aaff', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('aca34128-8a96-494d-a9e7-4e891208b023', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2f8771ba-3650-43d8-af99-ffc413066a42', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2dbbeed2-ba1a-4781-85e4-28f1620f8f7c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('59e7f9e1-fa76-4f88-9ccd-da4eb105f0e2', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0aa2520b-5481-4d8c-a478-964e4441d5e0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('89ac1223-5561-4835-8c9d-681ab874a47a', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f5f51c10-010d-4d5b-bb8e-b2dc353ba051', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9827f746-1f3a-4c83-ad01-b5cd89f4d5a6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('d71a8b9b-b0da-4675-a6c5-45d2664c70f5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('03089301-5a05-4c2d-abf3-b95267b2edef', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b32ebf6e-d5bb-4b03-9d03-10bcec3a6172', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b204ae10-065f-4969-aedd-4c25602a821c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5fdcc08b-295c-4853-957d-d171b1accd40', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e7101997-a1b9-43bd-93a7-8b24fd506f05', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('dfb1ef2c-af28-40d5-b625-9f157f1323d4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('dceec9d4-d2a5-444e-a27b-4a16c01b155b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2d5f609d-aac6-41b8-b7dc-ebb66f4b3833', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('3a07b077-aebc-48ad-ab29-6d375afab845', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('e4c728ed-535a-40cc-a460-3174b695f899', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b491c0ef-e4c3-4692-94f3-bf13b2dfff8a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2a9d3ef1-e293-4301-914b-0ed781b63689', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('fdad2cc6-4985-4407-ade1-857bd91c5518', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e1ddefd3-730f-4085-8651-a24dc88b7330', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('1bf68e49-2a97-4686-a8b9-8cdb46475326', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0bb4851a-2274-44cd-85ff-fc4b4710f602', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ccb79609-4c10-4c53-bd5b-3a128e7f7ebf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fdfd2976-fc7d-422e-8b5f-91f401927b18', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('4e5c24fc-e3d1-49f7-963c-e386a72be2f8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ffe77615-7fe9-4dd7-8a55-9459ff2d2b43', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a8dc5128-f0db-4f0e-b599-a87eeb73603c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('93f3cd3e-9b10-4a7c-88a9-39c29118fa8d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0fd249e7-1454-4914-957a-b3ec7bf25bee', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e9daa877-1886-48db-abab-5516000c4d8e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0334125d-2eca-4694-9cc3-abfbb58b49f7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('edf9d085-dbfc-4e3a-9f0e-9eb407423ff6', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('bb74107e-cd5f-4207-87e2-69f4d67eb7f3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7a4d5839-8342-48c3-95e1-d7032ce2a6a0', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('eb46cc8c-d08e-4b43-aecd-b0d73b4c7a4c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('232fe9ca-d6b6-4105-869b-435f0b1357cd', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('5fcac9c5-86b0-46ec-9eda-fa65d8ae1a9f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8f422852-c9d5-4c4f-bac1-ea4950ea77d4', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8d53905b-418d-4c91-aa71-d4c49184cbae', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('06d170a1-f3a5-453e-9a08-3dedf2ecc0d4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('1ea18a1f-6676-43b8-9fca-20b7e575c31e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('2194c042-0182-42cc-8174-6f219e3c4e65', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e5bb95d7-2fcd-4767-a200-c7c48e01401c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('f792f250-1f61-4efa-a515-d04af7ad5e18', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b83a49eb-39d3-4c98-8c0c-5a1fb1862079', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7564d2ce-d4ad-48e2-baf4-2fc08cc249a8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0c5a46ce-1c25-4f5b-9dff-5f5be50cf6a6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('71c29d57-de3e-4f00-9303-2d51e8c11b20', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('02748d62-3212-4465-8c05-aabc3f919a08', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('adaeb8bf-e22b-4bb9-ab33-66e19053ab31', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0cde804f-7eed-49d3-8eb4-d55e806f8957', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bb372939-0891-4068-bf4b-651e8f2a03c8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('88d51826-68ce-4d8a-9a65-91429e00d053', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('b04e429b-3f95-4dea-b61e-3e96d114ecd1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('3014663a-10bc-4a8b-b47c-2c805b198d7f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('74b8c100-35a5-4a9e-882b-d106b0656e15', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('702c700c-a440-4771-b203-9c030c1c100f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c73f5078-0505-44ea-b0e1-57390f4d5a3b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('86454239-fb95-484e-9f75-142ee5ca2a5d', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('69067b5f-41d0-447b-aba4-31764c6d6e04', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0017035a-e8ef-4e77-a43d-938cfc7962f5', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a3d6ce3f-655b-452b-91b1-539956c8580d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ad177311-3c0c-4d93-9ff7-c0b5665fd0ca', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('0198a5da-a2fc-4f7e-bf41-54642325d8dd', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('e2f03c7d-5026-42a3-a18f-ce770314c22b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('8e019651-e0a0-490f-8592-55c7016cec2c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('ca0cb3e0-c89b-45a1-8614-c6a6f7a5e80f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ee5eda97-ff2a-4646-ae01-dcec47a7688b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('41bf1ce4-7d32-4bc9-a240-6f37aa7c5311', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2214774f-6235-4cb9-8713-e2ee51b213d2', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('008b96bf-c732-4063-95fa-8660cc3e378a', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('919c64ed-015d-4a71-9287-69f554378b69', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('67f93c8d-a31d-4d14-ad7a-6bae4f8202e8', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('a8ca5cc1-5e21-4837-9f78-bc4f8aed2d4d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a48e5290-7207-469f-85ea-c5f5b2150d1f', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('74d9ec93-6755-4198-bba3-b900d1391ddf', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('39c84db0-c0b8-48bc-9602-f6371fee499b', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('9cf52144-7c0c-4031-a0dc-b5f7d0581115', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a9998fe5-2760-4309-a904-8e4f6787110e', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('81268148-75ff-467a-8d73-b8e4f734d83c', 'rbac.role');
INSERT INTO rbac.reference (uuid, type) VALUES ('7878934b-1841-4918-85e7-ce853fe8fdba', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('18630744-5484-4f55-94a4-15b6f8a8c791', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7e2d1a3e-03f8-463c-9300-7e0b9bfd0eb5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('23115d61-dd0d-4545-8240-2415ab603868', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('4b8fc5ce-2f77-43cc-8c11-caefef50e9e0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7ba7e7db-d2a0-4d8a-a982-4b592a6519d3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('28a1da29-5665-4481-be2c-23484fede329', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ad772eba-1cc4-4973-b407-ee1292c8cefb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2b1bd996-ed42-4b6f-941f-a02115b5c49c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('114ce5a9-0704-4f91-98d1-7f4f2e6d6ac3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9532739f-1149-42ed-bb1d-cac1d14d4380', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('04a9b874-65cc-460a-83be-47366ec3c35e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fac002b1-7dd0-4def-9c60-ce441ae74bf0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d0c2aec5-df1e-4a43-accc-292636a196ee', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c16db138-0d91-44b1-bd5a-b8361d1773a6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b299282d-1cfc-41b1-8936-2dcbfe1017ca', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('bb211784-8f68-44ff-833c-3f501a33ad0f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d80e22b5-9ba3-4ad6-a392-fddaa4a5532e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('2afe8e61-bfb1-44c3-8685-bb5390e9ffa9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('d1fb0181-59a4-4c35-a6da-9c4c8c420f4b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('7f04b4ff-ce51-4c25-b924-eda9c80beab9', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f7036040-6df9-44df-a4a4-40b8065234b3', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('aa8c9c0b-ac3d-4fe4-85ee-22876b77a346', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('5612b460-e9f4-4c7f-8f30-fabca1954260', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('793d3808-9277-4bc1-b39e-46fd0b5028d1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a46e7e72-094a-4677-a2ba-b027e117c814', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('34608829-3d7a-475c-b734-f3692e102b82', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('176b447d-ce47-44da-8219-a00244a3d5e0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('22500be4-6daf-4c50-9120-a4d0c6491720', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c772675e-39bf-48b0-b10a-1a2ff065c3a6', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b096450c-b5aa-4a9e-9b80-8633ca2243a4', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('651a87c6-db56-4963-88a5-5dd7b74d53ce', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cf345447-6015-474d-9c1f-2fe7b879edf0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('9654e7cb-b714-4f8d-9a7a-5a2e9dcbe09b', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6eb3f2e6-4f80-4ec5-b121-e0e6ab166e6f', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c7a074b6-6e8b-4570-a8b3-baf483e67c14', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('16c5c51a-6b85-48fc-a19b-b1d0319c414d', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('ef9747c5-e7b2-4a22-b4cf-cb05c7cc0d6c', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('a5de5a65-81f3-482b-baac-4054940ea7b5', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('c32e6121-a5fc-4345-b6e6-26eda31d266e', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('96383615-0c59-4cc9-9292-723a1c0f4a52', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('db092336-0de9-4c19-b5a7-9f035596b364', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('63dd3ba5-db8d-481b-8eb5-ee982522f4d0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('67f40c40-c638-4350-a11b-951b0bf73bf0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('0166244a-b22b-4567-a09d-bd113f3430b0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('b969f3ba-2936-4937-80ff-c440300d3f10', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f6d1a800-dbfe-44d3-a939-e168760203dd', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('44a7f281-7acd-4536-a7da-db74fc7d5a30', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('51278cdf-daff-4fe9-90b2-1e651847e0d8', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('852d7666-33fb-4246-b2c4-1efbecba4da0', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('fcc39eac-cca5-44fb-b728-9b4df8aa3874', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('6a568f34-8ab2-4a74-941c-266e28a52836', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('8a4f7331-7bdf-41a9-85c3-5ea327063d71', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('526ae830-0342-4a87-a95f-07d760391fb7', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('08a87b5d-d5eb-4d77-aa10-1afa61c87e38', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('63c07ed8-5b6d-4cb7-b663-6a5ce5e63fcb', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('cc4e1270-9d63-449f-ae27-a492326f72b1', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('f03cc85a-b722-43f4-8d56-a29f1387e692', 'rbac.permission');
INSERT INTO rbac.reference (uuid, type) VALUES ('16994a15-ef4b-4c7f-b123-e9c2e03919d0', 'rbac.permission');


--
-- Data for Name: role; Type: TABLE DATA; Schema: rbac; Owner: test
--

INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ce47754e-0d06-4b12-bc91-8034a4a046e7', '33af1d05-a7de-4552-9118-7900fe5fde7d', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d2e05c94-5c48-43bf-a263-307e9dafe466', '33af1d05-a7de-4552-9118-7900fe5fde7d', 'GUEST');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7fe86d82-1b9d-485e-a206-a4c9bb39125c', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('dfeb77e8-087e-423f-b4b5-8e8111a8b83e', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('38aa2ac2-71e5-4805-94ae-61361288f235', '691db509-b67e-46ec-a859-c4cb05fbbd70', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('eba5fbe1-b196-4df3-8d92-fd9023668744', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a6ff0898-04e1-49b7-8621-b42846df06e1', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5c9372e0-cb21-4ae7-a461-df086ad19426', 'b4a3b50d-1c1f-4052-b584-0b7f2aec1a42', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a930208f-7ef8-4296-9f70-24c50656ac58', 'd363745a-e94f-48be-8397-4b361570a54d', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b9592474-79f3-42d9-828f-8cc2e5c8ba7c', 'd363745a-e94f-48be-8397-4b361570a54d', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1280183b-c71a-4b86-bdec-7f3800679ef4', 'd363745a-e94f-48be-8397-4b361570a54d', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d1d8fae9-566a-4a6b-8a1c-372b63108fe6', '7a334268-7d11-4765-8fa9-17e2c36cca7a', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('939dafca-fe72-499d-979d-6fe0288e6807', '7a334268-7d11-4765-8fa9-17e2c36cca7a', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b91f7dd8-b4a4-4f9b-9192-300f8e982c6d', '7a334268-7d11-4765-8fa9-17e2c36cca7a', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2b70b335-e6b6-4b11-b138-4e7b3c4c50d4', '33b40eee-30ed-4924-859d-6c58b5aa4124', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('06bf2ac2-61c5-42e9-917b-8b68afcc0d47', '33b40eee-30ed-4924-859d-6c58b5aa4124', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7a8959c2-e6c0-4af3-9d64-117811ec0d02', '33b40eee-30ed-4924-859d-6c58b5aa4124', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9d6a3750-0d32-469a-a476-2d8525f7e692', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('82d6e2a0-3c2d-4a8e-8638-4903696927d5', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('25acc71c-db8f-46e4-950a-8ea76637bb9b', '16da0560-e134-41c5-aafb-1f7a5b33692b', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0b754d22-82a2-4349-af85-2cee67716f66', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('42d9e5ef-8114-49d5-b6cd-1f5bf43c9d1b', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('24f9488b-412f-4314-b160-2897f4dcff1b', '1fc10779-390b-40ff-b641-b6b5e2634ebb', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('310cdf00-c863-4ea0-9e4e-9eac8a74f51a', 'caac18bd-9277-47ac-99bb-368e2d64dac0', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f9d5ba94-1514-4400-88af-7b7d3798f473', 'caac18bd-9277-47ac-99bb-368e2d64dac0', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('20926d99-1f1f-497a-8e13-ce3cb4b1eb73', 'caac18bd-9277-47ac-99bb-368e2d64dac0', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b54d5034-1898-4712-a472-5ecac0e22a1a', 'eead6995-dd54-475f-8194-74445c421305', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('57ee73c6-769e-461e-9cea-7bfe56970bf7', 'eead6995-dd54-475f-8194-74445c421305', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e65ad361-79d6-46a3-a7c7-a18048b7237a', 'eead6995-dd54-475f-8194-74445c421305', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('97344c39-24d3-4df5-8dba-ba41ff28a020', '4b68de11-a658-44bb-be49-ad592e73e3d8', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d206ab6d-9620-4bf3-8ea8-2c8b0b86cd8e', '4b68de11-a658-44bb-be49-ad592e73e3d8', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6c787015-c910-455d-8b2c-c3ae7bece7e7', '4b68de11-a658-44bb-be49-ad592e73e3d8', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('680b8464-0536-4f87-a952-56e549a70a99', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('93ec1b20-de2b-4af1-924f-047a7afa0276', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4330591d-61d5-4435-827a-c71b8328a700', '8e7648e6-e74e-4a37-b9c0-3a5998921e1f', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0ca35f5d-778f-4207-88ae-beb5a648a6f6', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5b391d1b-439d-4ba6-9be1-dc9e8c161c7c', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5167487b-90ee-40b9-9c34-535b74b3186e', '25358342-4f90-4397-b4c4-d90524ac0b7b', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a0a8a5e1-e11f-44ec-984f-163e049c81e1', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4241127c-1c6d-41b4-9350-3aa73785f6c5', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('206fcdf2-c22e-480f-9029-42183cc2990e', '4997dce8-4927-4a10-a7b3-16c574eb79c9', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('51c51fa2-3706-470a-9d15-0bad421ea7d4', '9dcab961-1465-40e3-8d83-357b22af2674', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d3aa37e9-88d7-4099-8fa8-0bb25f6db328', '9dcab961-1465-40e3-8d83-357b22af2674', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3f62e7fa-ffed-4a15-88c2-2d4a231c7db0', '9dcab961-1465-40e3-8d83-357b22af2674', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e1947aaf-5b7f-4597-b296-25830e9c945b', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a822e970-7b6a-417d-81d0-a8db0c985427', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6fc5eacb-5328-41c3-a71b-e7712338862a', '29e2d42f-5f00-467f-ab73-f2ff59f2792d', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('87f8ac1d-b082-4961-979c-cd3de0e46b21', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ba7a634b-c352-418c-a8c0-58918f32f8a7', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ed0f7762-a094-4a88-abde-8472da33bcfb', '627a274d-55b0-42e7-963c-8b0cc3e204b4', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9455fccb-71fa-4cff-bf89-5dfc719f3374', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('fdcffa04-a455-4869-ab8f-2f2fa05e4b02', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('67b756a8-aff9-439d-8ac8-b8965b63ac32', 'e8151525-ae0c-44fb-9755-72be88f7f6b1', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d85c013c-e791-4bec-ac0d-a217472cf425', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('60297e5d-2f7d-4734-9a25-f2639ffb7fb4', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7454ce37-a2ba-4f52-a5da-2190203ca089', '7857f7cb-c93d-4d21-a4e8-b91a28eb7007', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d8bc6523-20de-42c3-93e6-5884924a7cdb', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('da9600c2-7dcc-4a7d-87f1-33f4a441e807', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f1afc7a2-588d-4b7e-9975-7b0eda21f846', 'c3b8c521-37f4-46b8-89f7-1931159e9a14', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('c184a3f4-ab4e-4263-a14c-70243c83e166', '137fb47a-07d4-42cc-b2ef-8e371041cf41', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b9d1cb3c-79f0-4640-b951-ad41f79d7b95', '137fb47a-07d4-42cc-b2ef-8e371041cf41', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8806c446-5551-4059-ba53-850a2d147c7c', '137fb47a-07d4-42cc-b2ef-8e371041cf41', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a8e7eeaa-7dcd-4ff5-a04f-1d84eafa4b6b', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e03da822-f071-4c66-890f-f93a458aec28', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('95cfeaa7-1c01-4090-8f37-fc3306cc0ba9', 'ba6468f9-2d1a-45c9-8f5c-71edc1a4ad6f', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e811eb41-9645-43d9-86b4-d3b522acede9', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f2ef6ba7-3a5b-45fa-a4ac-1131df8acb1b', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2bcadf08-a16f-4ab6-afbe-83db1b1424d0', 'cd48cfd6-6313-408f-ae7d-9af047d0c22e', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('02e3a73a-07fc-46df-a14f-569f31249c16', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f87398bc-225a-4eee-bea8-7983be6ae529', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('236b88d3-09bc-4750-9219-61529f7740af', '417b9a15-5e1b-4d15-b1b3-79dc19b49c50', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('09a6064d-a472-48e9-9755-d0117f2af6fe', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('bab68a5a-2016-454e-b143-8c334188d2c4', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9115be3d-2bef-40ce-b0c9-339e460c751d', 'f5dd291e-f8f5-4240-93d5-9fc1e56c376a', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ce0b0564-7cda-4c03-afcc-0854f3c5e519', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('da979efd-9d87-4dc5-a839-493e883cf292', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f913c978-1afc-4af0-9bb6-8c21eed95991', '177ab8a6-2f70-4c2d-b1ba-2153d0803b16', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('cecee6dc-89dc-4b67-ba2b-adacbbc2c0c8', 'ff030436-d19e-4606-9d48-7e192eaf469f', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b4224d96-af95-4008-9a96-9ae04b44913f', 'ff030436-d19e-4606-9d48-7e192eaf469f', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e668cce4-9f01-4c71-b28c-79859e02971b', 'ff030436-d19e-4606-9d48-7e192eaf469f', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('22600f05-6955-48f7-8930-c884c9c31b06', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b28425cc-f859-43db-b3f5-64b5fb6a668b', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ecdbb376-51c5-4de3-82f5-c5e73c0f43c5', 'c8050a1b-0d28-4aa7-ac77-958c99152cd1', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('c573267e-79c1-4e2a-9e95-55613006a3c8', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6ef557f3-0b1e-41e9-bde7-8abea686f965', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ea1789f5-11fe-4ec3-8d12-2623ba592c7f', '89bca3fd-d7b2-46f5-821a-64c5566d03f1', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('32defb6c-2a81-44f2-ae79-7d8544d807dc', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9e5fa680-2abc-4f25-bb22-bd2fe04fd860', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4de8cdcf-ecc5-4f3b-b3c7-3d674d5c0ac7', '2fd1ba30-936a-41a8-8fbe-e93be547f44b', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7c817da8-f355-4456-8074-7bf433924285', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f32f51d5-3384-426e-a1c1-b5b6a263b647', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a7ff4f1c-7c33-43e0-b264-37339141f7f9', '450cf76f-d9bb-4308-ae8f-bd09bbbafd31', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b70eca31-fcf6-40f6-9792-2fdb66bb129b', '38cc5d59-085f-449e-aeb3-439febbabd9b', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('95f09796-be4b-4b39-a759-a1f5a4fe54fb', '38cc5d59-085f-449e-aeb3-439febbabd9b', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e97003a9-9162-4142-8d08-814e6c8fabd9', '38cc5d59-085f-449e-aeb3-439febbabd9b', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4d63a8ce-72e4-4bc4-8109-ec9e664cb5e3', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1373e547-4804-4c8d-9014-ce51c65f3a06', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('bdeffe17-405f-4ad0-8131-82728ea0e382', 'a3cb6be0-b9e4-42f8-ae29-ef2ba0f3a763', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3f156460-0b5e-4e31-9ffe-bd27ad172ade', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('957da54d-43eb-45d5-a3c4-34976d178bf3', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('96d81c1c-7d32-4b58-b7d3-7d7d88d250b7', 'd7485220-e4f2-4683-9e84-7728a2ef4ebf', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5c561605-0895-4a2b-b850-9572156e6635', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8bfcdf97-8c34-46ca-8159-1314cbb42105', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d8c41124-ff96-4bc4-b3be-d0a8091128b6', 'd6488771-b5c0-4f39-a6d6-81af6ca982f4', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('84f70526-107d-4b57-b7c2-653c8efc2737', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2812b2d9-15c6-479c-b59d-bf980f4bc9d7', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b29939d1-67c0-4527-88fd-41812023f402', '7c10a7d7-bac2-41e2-a5c0-963e191239a8', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('db6edaf5-7e57-4e26-8172-20fe06d19e16', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5f936257-6096-4792-a496-b92e46d93d0a', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('814e38c8-c053-4c27-9487-997cf318a550', 'c3d97013-0ceb-4cc7-a59b-a4f70107acea', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0e51c89f-6101-4b6e-be17-53df018b88f5', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('de10229b-be9d-45dc-b1bf-8f832ebffe68', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('779e4c3b-97f0-4218-8eab-5575a6afa54a', 'e50c983a-060c-47c9-9d47-efd552b1e618', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1b453f97-a12c-4d51-bf95-2e782b425385', '48618c28-9304-4ccb-b022-e2cbb1832944', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3b195996-371c-41e4-9b66-a50553582e17', '48618c28-9304-4ccb-b022-e2cbb1832944', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7de2ab25-6b6a-4b59-ba8d-818110ae4ccb', '48618c28-9304-4ccb-b022-e2cbb1832944', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5ca5bb1e-f56f-4dab-a86b-a9ec1959d3f8', '48618c28-9304-4ccb-b022-e2cbb1832944', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('98d81696-7c71-4ffe-bfc2-1fea37613440', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0f5c3f08-d249-404a-b740-d759fced2d09', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6c0656b5-472b-4859-af3a-b8f1c53231a5', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8ad792c1-10e1-43fa-8d5a-a6f3810878a2', 'f415978e-b5c2-4a99-962e-3d31a4658780', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b26cca89-03f0-4498-bf64-7385c0b7244a', '201b417e-4ebe-458b-a7ce-a287c0ad9287', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('76968391-174d-4530-b310-1244c4b1897a', '201b417e-4ebe-458b-a7ce-a287c0ad9287', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('863eea7c-8b49-494a-9654-9963f2dbb4e5', '201b417e-4ebe-458b-a7ce-a287c0ad9287', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b67105de-0348-4d4c-8ccc-aab9ed905eb6', '201b417e-4ebe-458b-a7ce-a287c0ad9287', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('eb1575ee-59a8-4bec-a1e1-7eaaf8ecc6fe', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8255ff29-5961-496b-9fda-c71078e47e51', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('fe0228ea-649c-45a4-b729-181aba7f3294', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f218c4d9-d10b-4445-b381-b73a71f5848c', 'ce2e4e6d-8b32-4ebd-b253-f4a59d5732fc', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5242e0b6-12e3-4a59-bf06-de114cb69ff4', 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b8350678-d30a-422a-bb5d-79c65af2f890', 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0f833f5a-8afb-4934-a8a6-9dadbdcf89dd', 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('c85e8116-355e-408a-93fa-c699da2a76f3', 'f85f9a58-7651-417f-b1b2-cf522bcce415', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3de42185-1e32-4936-b305-d990b85c45c2', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('bb8fc553-9dbe-4ea5-a3ea-02d129841f68', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('bbfb4fc6-80f7-4a82-aa82-3d787539ebeb', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('07aa8ca8-e06f-4335-9cb0-99e98d45b2c6', '78123dac-fed2-4e3e-817b-0c13a2129dfe', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0726dd6c-118e-4cbc-9077-d4dcb0e61643', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8dfb5e53-1554-4e5c-a045-85121ce4bd71', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('13a3ca39-6352-48e1-b1fb-82f3fc5558f2', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d04aeefe-4ba4-466f-a563-b811674c6de9', '463c4856-495f-4ab3-b26c-7b2f96b05ab5', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e5871fb2-3928-4139-9468-10f0f12d5e5f', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('834d7138-e338-4517-aacb-1c6319fa34d8', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e6409531-6513-43a9-84a7-eff44b18285a', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d00a14ad-fe79-40fc-8f72-722fb5cd30bd', 'b9854fdd-5192-4e2b-b82f-62639ff1a3cd', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('256083e7-90ac-4f38-9bc1-deedb0f78d2c', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('28bf24da-eb68-4a99-8ff9-6e4145f5e805', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f93693fa-7dc5-4513-8537-be9541d6e5dc', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('33a45f49-ac74-4444-a193-2ed1e0be110d', 'ecf9603d-1bc4-417b-b953-552b8f08f6f3', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d5a60c82-347b-4ebb-b95f-afff297bf966', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('bb40b3e2-f355-491e-a3cd-fb3ee258d4b8', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6e7feeb7-4891-4ea3-96b6-00d883da37c5', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1ed7ff07-778c-4920-a550-563b27223228', 'dd0eae3e-7f45-45dd-b686-f39e046918b0', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7db53bc9-99f3-478e-abb0-437dcbd32051', '164d3cde-e2ab-4239-9dbf-de1c963158ac', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9771d06d-8352-404c-aaba-743800e621e9', '164d3cde-e2ab-4239-9dbf-de1c963158ac', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b34392da-5070-40dd-ab44-d411a9742f6d', '164d3cde-e2ab-4239-9dbf-de1c963158ac', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e37e21bc-4d4f-4d41-8c24-399be1680a15', '164d3cde-e2ab-4239-9dbf-de1c963158ac', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0d96a253-347e-4903-9db9-b362335e4341', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ba80c834-f5a8-4243-98a6-9a3be63c4f47', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6f90fa6f-da1f-41aa-a74e-bd06ef60f48b', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('42f0c634-d86b-4129-822b-f103cd6e0755', 'e9bb6489-3e78-4707-bbe4-70b1fe6212ac', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0c87e31d-cca8-4fd2-bc7d-fd2c94312c0d', 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('cb295fdb-e294-4b05-944e-f0a4929ebeeb', 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f3af3c81-a512-47ea-8b47-0386291e6590', 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a0a1bcc1-9eeb-43a6-a2a5-f172ebb3df29', 'a85fd289-2383-4abe-b796-9b0b47d702d2', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('dc8ae2b6-d20e-4592-8356-3547bcc58f80', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3010c421-5c96-4f0d-b214-c773e0915564', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('270aac69-03bb-4429-b925-3019bd92cf32', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7d632200-5506-4856-a3c0-d806b1ee708b', 'bc8c4b35-c55b-4c3e-9122-94485909b17e', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7d40c68c-9bbe-4e81-97e3-bb14ed4bd6ff', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f101cc07-ed84-4e34-9f70-62ec6a646e81', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1d4c6f1f-200f-4a68-ae7b-6fda13687e41', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('53e3a9ce-b1e5-40d8-8bab-62ddc3b711fc', 'bcd0fdb5-7415-40d2-8265-85113a4b66be', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3996f1c9-f36a-4c5e-b0d8-d36e6f9bf08c', '268c2ce6-8945-4393-9916-ac90050f064a', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6ec65964-76d1-4e7d-aacc-6a18e4eadf67', '268c2ce6-8945-4393-9916-ac90050f064a', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7e71f107-6953-42c7-a560-dc9036094198', '268c2ce6-8945-4393-9916-ac90050f064a', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('51bb98dd-9201-40e4-b008-221337eeb471', '268c2ce6-8945-4393-9916-ac90050f064a', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9a93e3c2-b1c1-47d1-8761-0cafe9b42917', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('acf8c4b2-7c5f-4e89-9696-77a598b5f8b8', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ed2f5f84-cc30-4f29-aef7-48eb64a5fb15', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('c3aff634-452d-47fc-954f-9edebe3a0c74', 'fb23d39f-0150-4503-8bcc-090b1ed3d0e4', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('06917568-e508-436a-a50f-246ea2afe064', '86b706e2-9225-482e-b82a-d4ac4adab065', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b152c130-be97-416c-b531-52656dd3c38d', '86b706e2-9225-482e-b82a-d4ac4adab065', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d6c011ff-bf38-4f09-be3e-45f89eca1ed4', '86b706e2-9225-482e-b82a-d4ac4adab065', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b438e7a1-f5e3-4fb7-8f36-5d4b7b4bcd11', '86b706e2-9225-482e-b82a-d4ac4adab065', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('52fd5f0b-55be-4e14-abfd-6b94ff5b830d', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a81d830d-68c5-44ea-bd6b-968a28f90197', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a64973bb-c814-4af9-b020-99f5f726dd24', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('aa3db109-7ed1-496a-9490-62dabce849e2', '2db1a3ce-910d-4f3d-be67-b3a0a598d834', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5c2537c8-eb2c-4da1-b78e-071377668767', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('07b606b4-e386-4d2d-8ecd-438aa4b3cd80', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ce71b519-42cc-4674-8bc0-a2df3c13b6c7', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('425b6cf7-172a-4e48-9f66-5592d4e25a99', 'b5cfc5c1-b775-4c59-8967-66d2cf7851e5', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5b5433b1-b6eb-4034-841b-559cba014f35', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9851392a-7c6e-4642-881b-dd7728556b86', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7c6415c0-9900-4de6-9459-e4d50b8e9ae4', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6035bf8e-466b-47f7-a3e8-96bab2e8033a', 'ddbda55a-0143-4224-bb6c-7ec5e8b79465', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1326d07c-623b-40fc-942a-659f5c7308ee', '47b7bd3f-8668-4934-bee9-56708e835d7f', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5310f493-97fb-4203-b41b-71423252cc4e', '47b7bd3f-8668-4934-bee9-56708e835d7f', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('09d8befe-d786-4023-b10e-5479f6d09bc1', '47b7bd3f-8668-4934-bee9-56708e835d7f', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('03b9f057-a59e-4253-a83a-ed4d7058a663', '47b7bd3f-8668-4934-bee9-56708e835d7f', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('108a7577-6cac-417f-a0dc-84c799c54797', '80a9daef-e282-499a-ab2f-98a016edb8f7', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4538eaad-57b6-4089-a058-2e7b2adfc2ec', '80a9daef-e282-499a-ab2f-98a016edb8f7', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4a4d7c0b-0b78-488a-a2ef-740ea6dda2bb', '80a9daef-e282-499a-ab2f-98a016edb8f7', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b8faa38e-6fff-42fc-a1ce-b84070077a61', '80a9daef-e282-499a-ab2f-98a016edb8f7', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6da9d98a-3318-403e-a948-bc33efe3d5ce', '93d9827e-63dc-418e-a021-25b400847b2e', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b2f0d8a8-ad0c-4c52-9c05-967973c99f8a', '93d9827e-63dc-418e-a021-25b400847b2e', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('03245b58-dd24-4cd4-bf3f-d9ba51a69810', '93d9827e-63dc-418e-a021-25b400847b2e', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ff171f90-f6f2-4c7f-9128-051462cb2368', '93d9827e-63dc-418e-a021-25b400847b2e', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1b1da9f7-1fb1-4b94-94d7-57275b028d54', 'f4219fae-353d-4324-90ca-9f313a8c1c17', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('871fd02d-def7-4c83-b40e-23029a4019cd', 'f4219fae-353d-4324-90ca-9f313a8c1c17', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ae26c1c9-ca79-4a83-a050-0eaab121ce3e', 'f4219fae-353d-4324-90ca-9f313a8c1c17', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('11542ad4-cd41-4d26-b778-a25b29175f7b', 'f4219fae-353d-4324-90ca-9f313a8c1c17', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('dc7aa55a-ab16-47eb-a29b-79e64328fa31', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('08963816-c027-42e1-80a8-f55dcd6a02aa', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5e3ac214-0f11-4af9-b637-50ff3f841b76', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('85d1d5a3-30a5-4bab-9670-878abc6bfe54', '219baf3d-0bb7-4252-b92f-4cfa97cb633c', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f0ed7f00-c4cd-4c76-a9a4-e7a21bf59fa6', 'ed0fb977-6512-4452-8505-378fcbbd5060', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ba13ab33-99ee-48ef-b205-73e9adea9651', 'ed0fb977-6512-4452-8505-378fcbbd5060', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('918840d4-592e-43eb-afa5-ad6ea37043a3', 'ed0fb977-6512-4452-8505-378fcbbd5060', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d48cd569-cc1f-4f27-bb9a-35154e5fc0b2', 'ed0fb977-6512-4452-8505-378fcbbd5060', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1ec552f6-834f-4b68-ae60-6d39e6d887e7', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('82982647-714a-4203-b8f0-3d9fa5d22b4e', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('76d74da3-9fbd-43bb-9083-093a9254af2b', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0303b9f3-8860-4ebc-b808-d4d2da18f5fb', 'a6bb6f3a-eb45-44ff-918b-7a94f9f770af', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('c17186dc-564d-4f82-914b-202ad8bc9941', 'af82432c-09a8-42a7-9525-e9095025d4dd', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b05450fd-5e5b-4aa1-b334-0b886ced9492', 'af82432c-09a8-42a7-9525-e9095025d4dd', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2710f7f0-f352-4e71-a527-38076d6966ce', 'af82432c-09a8-42a7-9525-e9095025d4dd', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b012ee61-8155-4fa3-bee0-9a0918452bae', 'af82432c-09a8-42a7-9525-e9095025d4dd', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('18fb2aed-c5ba-41ea-ac09-4ec940ff6eff', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6c83af72-d5d7-4076-b7b6-33ca23c80ff8', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8833f9cb-d000-41ef-920f-6e6ba586c65d', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('49e8c569-1fe0-4215-8cc3-698054ff896f', 'f691585e-eb5e-45bd-8d8a-8187094ed0a0', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0e190f5b-0333-4f70-aabc-71d2e810a712', '65879210-cf7c-4e5b-a2d1-742a42fcb488', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8eb1d02d-d44f-42a8-bd93-a05174ce15e0', '65879210-cf7c-4e5b-a2d1-742a42fcb488', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('77ef9867-e939-4d36-85e1-4a573c4a9b55', '65879210-cf7c-4e5b-a2d1-742a42fcb488', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('cedad28c-ea54-48a9-b2f8-e16a29ec56a1', '65879210-cf7c-4e5b-a2d1-742a42fcb488', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7377295c-c6d9-4826-b712-ea5df5c3d8d1', '97e5ed67-e81c-4c12-b354-45db951901c0', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('638a0990-bb30-434c-80b5-65f3e33732f6', '97e5ed67-e81c-4c12-b354-45db951901c0', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0de0bb80-9691-4f70-9bdb-53a862399dc1', '97e5ed67-e81c-4c12-b354-45db951901c0', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('701ea625-3ec6-4ee9-8fbb-fb95ab1137f7', '97e5ed67-e81c-4c12-b354-45db951901c0', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('84802890-6128-4134-8ad7-667491cfcbf7', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('63eb26c8-3d39-45f7-b2ef-5038f301bddc', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('fadd73e5-eeca-4f5a-b07d-998d11eb411d', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6dc07a2f-428b-4621-9f39-8679a5a5a780', 'a0e5508f-533d-4f7c-9602-6f23fa85e601', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0eacfafa-b06b-47f6-8bd5-a4c4c7d4986d', '2eec1138-d2ad-43de-a105-605d0182a1f8', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('47388b74-46ec-45fb-a817-031c959a6c2e', '2eec1138-d2ad-43de-a105-605d0182a1f8', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('fb0b7122-f782-414f-85b1-c1df876a3441', '2eec1138-d2ad-43de-a105-605d0182a1f8', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0195bb79-457f-42a6-a21f-ffd238256b28', '2eec1138-d2ad-43de-a105-605d0182a1f8', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8280b446-c17d-4d5f-aff5-ab391cd0af09', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('53e80cc6-7e19-4c55-8c1a-3190844ae734', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4e5bc3c9-14f5-468c-8ef6-6bcb25c17948', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('85e6093a-5013-45c3-a756-66e50d03b6bc', '7f24b032-3906-4b4c-9e91-4d0fd9f7855c', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7044a856-3670-42b7-9719-4a8638fff92a', 'fad03414-b62b-45d4-93fd-51c52149762c', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('20f04373-bbb4-4b9d-a89f-d21272d75d59', 'fad03414-b62b-45d4-93fd-51c52149762c', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('367f629c-223d-456c-98cf-ddf6600d5858', 'fad03414-b62b-45d4-93fd-51c52149762c', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4c98fcb4-e0b6-4692-86e5-dabb78af17ed', 'fad03414-b62b-45d4-93fd-51c52149762c', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('cdc318a4-f418-4564-a38c-f93562dda048', '48a0fa39-0d72-4c0a-800f-afed02865850', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f2a2d3d5-165d-43c4-91fc-7912f8a96bcc', '48a0fa39-0d72-4c0a-800f-afed02865850', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ced737cc-1da8-4b12-808a-13e36b8bc37e', '48a0fa39-0d72-4c0a-800f-afed02865850', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('79ef402f-0c51-4ae0-a0dd-f0a09505a273', '48a0fa39-0d72-4c0a-800f-afed02865850', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0b67cb5e-3570-4ca7-945b-94f3390bec81', 'a84434fd-e879-4208-a8e8-8095e22b72bf', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5306f8ae-55c4-460d-a133-45f8eae30eb6', 'a84434fd-e879-4208-a8e8-8095e22b72bf', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('39500fd6-4dcf-4c33-9766-c9b4071e4754', 'a84434fd-e879-4208-a8e8-8095e22b72bf', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3f31fd85-c31c-4258-8219-2ed6f7a38f29', 'a84434fd-e879-4208-a8e8-8095e22b72bf', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3461faee-7a67-45d3-af18-7de8686c381d', '93d87d13-efdb-4d31-83e6-3b13db983c12', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1b8bd64a-cf02-4cbe-93d4-9b85a04d30c8', '93d87d13-efdb-4d31-83e6-3b13db983c12', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3d17a863-17af-48a5-a6aa-abc815209773', '93d87d13-efdb-4d31-83e6-3b13db983c12', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0447c01c-fae5-4c80-a59f-a9f330321b9c', '93d87d13-efdb-4d31-83e6-3b13db983c12', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('fd1b146c-609a-486f-afe5-c87430e1be15', 'bad214a0-5220-4433-8714-52e4c736585a', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d09b10a6-f74d-4e87-898d-851cfdb9dffb', 'bad214a0-5220-4433-8714-52e4c736585a', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3a1e0eb9-bf91-4bda-b804-8707d753644e', 'bad214a0-5220-4433-8714-52e4c736585a', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('c2fac16c-b4b6-4d83-9b57-7ac814d4a8a3', 'bad214a0-5220-4433-8714-52e4c736585a', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8e9971fb-270c-4897-ae63-50f457d9d0d5', '5add96a4-6fff-4fe2-8628-669d72252417', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a352a7f2-6caf-48bd-8f2e-90a1b3d248fd', '5add96a4-6fff-4fe2-8628-669d72252417', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7bdb3dd3-ed56-43ff-8a99-a49101ba7d48', '5add96a4-6fff-4fe2-8628-669d72252417', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0caafe33-8257-4550-9e75-c8a828d5dbc6', '5add96a4-6fff-4fe2-8628-669d72252417', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7f74a25b-753a-4534-bd83-0db07cc6df2f', '2185083d-3134-4b30-9dcb-674058feaac2', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('64229d80-11aa-4910-9e0c-a211d9a5ca95', '2185083d-3134-4b30-9dcb-674058feaac2', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('98f81765-6d0e-4cb5-ab49-da912f668f5d', '2185083d-3134-4b30-9dcb-674058feaac2', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f4bed22e-44be-4ce4-9d95-5d9be630012a', '2185083d-3134-4b30-9dcb-674058feaac2', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8772af22-67d6-4721-bc48-20f841f171e6', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2899fdb3-40ae-4885-8d6b-7c0f07493ef8', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f68f9b54-fcc3-45ed-b2a4-9db7bcc5add3', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ce3d8199-1a11-409c-8f0f-99a8344f1d1a', 'c60e1d4e-01a1-42a8-9521-1681c77b350f', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('bd1cdc2f-13aa-490d-84bf-1cea1d91fd05', '17ea3654-289d-4892-a837-3ddcaea2d7db', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ec3bede7-5502-40df-bcaf-d2782c15ed50', '17ea3654-289d-4892-a837-3ddcaea2d7db', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('98c6c409-250f-4977-89da-f3c242f4be8b', '17ea3654-289d-4892-a837-3ddcaea2d7db', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('bf5371a6-e09c-4484-b57c-62aa6befdd0c', '17ea3654-289d-4892-a837-3ddcaea2d7db', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6093331c-adb2-44e9-baac-ef073278751f', '60702c01-7285-4eea-a937-6019d6e3661d', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a0cf1824-6284-4031-980e-1df923d144e0', '60702c01-7285-4eea-a937-6019d6e3661d', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0a93387c-682c-45d7-8a24-e538678f5cf4', '60702c01-7285-4eea-a937-6019d6e3661d', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('35a0a69f-e93c-43f7-b406-3c2d01e1cd8c', '60702c01-7285-4eea-a937-6019d6e3661d', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('86514079-9959-4ffe-9563-4be364780b39', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('94fb08b4-d5d1-43a5-a395-b1e261a46e0b', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d6e4ad57-a163-4508-a694-99a87eeeb986', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('67e21e6a-6d23-4e9c-b9f5-5108ebd99d0a', 'a66a844c-e5b3-4569-96cf-06197abc0d2f', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5eb167f7-80c1-4c71-9c63-b9d6994ec251', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('44c0b607-7d0a-4701-9570-8d339189020f', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('91f36783-f411-4708-a88e-b30fb94d849a', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('52c74fa2-27f4-4046-8712-759b3f47e48a', 'f7ddff21-e58a-426b-a693-46a2b45c9d4e', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2a60ab65-5d4d-49bf-b184-3b1ef563bd62', '8363ec62-6d90-4dd9-940b-6073b3246c39', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('553adc79-d3f6-4b92-88d3-8c9328e5a616', '8363ec62-6d90-4dd9-940b-6073b3246c39', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('832cde07-7e08-41a0-84e0-201f12393e15', '8363ec62-6d90-4dd9-940b-6073b3246c39', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4e1db019-7622-4ba1-aec7-4046419a7b28', '8363ec62-6d90-4dd9-940b-6073b3246c39', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4e4469ab-f0e8-4927-a374-33384a97811f', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f5a65b3e-9c7b-4e32-9f50-9641e1df1ee1', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('c110be44-7852-4eaa-b52a-c87a93de1076', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b9ad5d7e-cf8d-4265-9271-2e32128b69d2', '6561ab8d-b9a0-497c-ba5e-60403c5eb5d3', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b5f86e7c-d33f-49a2-a2c9-3cf3a9c4802f', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ba6c1883-e891-4628-bea0-78b9787b1403', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3877cf69-dfcc-4ff3-83a1-65ef1471f919', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4d8fb33e-f5de-4716-a301-a753f59c5aed', 'bc9fabea-d44b-455c-87d6-a0b0428e7768', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('80da5984-53fc-4439-a4b2-2aa030416ddf', 'a13af5de-4315-46dd-ae08-427ea72b35a0', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8f1fbdf5-7aba-43d7-932e-a9e4f386ae84', 'a13af5de-4315-46dd-ae08-427ea72b35a0', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('46a6fc92-c738-40d2-be20-7762997fdd21', 'a13af5de-4315-46dd-ae08-427ea72b35a0', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9fc0d602-3a23-4ce9-b8eb-216e58c23cb6', 'a13af5de-4315-46dd-ae08-427ea72b35a0', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('201bce64-1c53-4047-bfd3-1892e4bb545f', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5927cb7b-54a9-429d-a229-d3ab87cccecb', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b2c4c782-4afe-4518-8c92-0de8c70b70b2', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5a04d74f-230c-451d-ad05-3f08d0e95b0b', 'cea1bd90-a42c-4cbf-97c3-33c134537bfc', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('32326817-2750-452c-8898-bcb42c36d85f', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('f7c2a405-965c-48a4-aecb-4312952d072e', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a67d167a-e0da-4fe0-b2a1-cc320687f44a', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ab46de32-5a21-4029-b5c2-517f6d6002c3', 'fac4bfec-9f0b-427f-b032-ca54188d0a76', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d5048fcc-cb35-4f37-bfdc-611473026b50', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2d30ed95-d7c7-46ec-bdf2-b84ffb7a20b7', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('13854f26-4d9d-411f-a6a8-d1cf8c267a32', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('44900785-555c-468f-9aa1-277c191fc3a6', '867a7a28-0ad7-4310-b7de-3d5615d0bfa3', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a24b3dcc-92b3-475f-8741-4399f604e189', '18124f89-8ce6-4813-8efe-3ed47b7eb453', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1d6da0f9-048c-4b62-bedd-5f4d4d35b284', '18124f89-8ce6-4813-8efe-3ed47b7eb453', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('33bff6f5-22a5-4a5c-bcf1-1e3003bcf530', '18124f89-8ce6-4813-8efe-3ed47b7eb453', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('eebc57f5-8fbd-4665-9328-78b0a6600478', '18124f89-8ce6-4813-8efe-3ed47b7eb453', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('cf88430b-e0a1-431e-9912-098933e6771c', 'cbda6432-b849-4787-84ab-88e680dbfa72', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5f9120b4-56a8-4a73-96bb-2fd1edcfbf43', 'cbda6432-b849-4787-84ab-88e680dbfa72', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('12a30425-8c0e-4e0d-b9ae-da96e2776217', 'cbda6432-b849-4787-84ab-88e680dbfa72', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('917b274c-a8da-403c-9ac2-5be884f4a47f', 'cbda6432-b849-4787-84ab-88e680dbfa72', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7bddc04e-775b-48f6-acb1-c1c9e638f836', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d8668032-3755-4ef6-8ea7-7c34e0109e25', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9dc88526-27f4-4c56-aef0-740429a8c457', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('67d9bcbb-574f-405a-b48c-f7ccfb9e0a06', 'f3b07a47-e7ac-4fea-850e-1d785edfea34', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ec817efa-d1de-4264-91e4-608b736b59fd', '4761d35a-2de3-4415-a91d-f53d15162aea', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0fae86ec-61fc-4f23-9713-a51f3f49505d', '4761d35a-2de3-4415-a91d-f53d15162aea', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('57070af3-92a3-4285-b6e8-8644989f8fce', '4761d35a-2de3-4415-a91d-f53d15162aea', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('087d73fd-3c94-4735-b59a-189efda4a80e', '4761d35a-2de3-4415-a91d-f53d15162aea', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6d7c3c90-cec2-472a-b143-3f730bb92d11', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0e9f7adf-90bd-4ec9-bf40-82963cd51410', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('54c33e22-f4c5-45c4-a86d-fb8ed86afbf7', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('d5007585-6703-493f-a24d-f99f4fb1b09c', '04c248f9-20e0-42e1-adf3-b24d2ff7a272', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('330cd455-c002-4416-8074-feb6c6b4849d', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e2eddb4e-842b-450a-a9a4-54a3875b33c5', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('256a2cac-4d33-46c0-833c-fd12d91af365', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5d68ab4a-34e6-4c71-bdb1-b6a0b7b0b17c', '7113f4da-b942-4f17-97f8-d3fdfd2966c6', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('34bbf849-5720-4440-bf30-378dd9748533', '4dbf555d-3375-442e-a87d-815d1492af55', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('4d252783-00e1-4fec-a661-ec1154d98a2c', '4dbf555d-3375-442e-a87d-815d1492af55', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('830e7013-1330-4974-925e-20e142b148fb', '4dbf555d-3375-442e-a87d-815d1492af55', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('85b69ad4-c6cb-4ef4-8d96-94abd80c9352', '4dbf555d-3375-442e-a87d-815d1492af55', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1d4bc5a7-76c0-49a2-93dd-22e0554d886f', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('aab86d81-273f-48e2-91ec-8379a4097dea', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e16ceaa4-25a8-449a-9d9c-59a87fdc228a', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5885b073-ed04-4ac7-9f4b-664507df0de1', 'ac44bd92-4e10-441c-8af3-6fc7cd6b242f', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1a2692a7-05c3-433a-990c-54a184a91661', 'e74992df-66a8-4572-9e55-ec7b210f04e0', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b27f42df-1a56-4626-a3cf-1eb46e7e8770', 'e74992df-66a8-4572-9e55-ec7b210f04e0', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('aa81a9b0-86ef-4ebe-98d3-54359961608d', 'e74992df-66a8-4572-9e55-ec7b210f04e0', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('51727d0c-b455-4171-9bc3-23ff5c73ed81', 'e74992df-66a8-4572-9e55-ec7b210f04e0', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e062ff79-b8a3-4f75-8e9f-ae3b31f92022', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('af3322a3-54cc-4315-b815-607a8c362d2e', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('dc730495-43f8-42be-af37-a084da0f568e', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8ea7ce48-b945-4053-8255-be69b2aa688d', '50f79f83-f693-49c9-8b35-f1eb3c5f80a3', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3df1d2db-6ed7-4d0a-ae22-6e90140ca432', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('656d1c2d-2ad1-42df-9774-62e931e3bb0e', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7c142ae8-d190-4c1f-aa85-24f12eeefc9f', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3abf8555-9c07-447d-af5b-47bacb517ad5', 'a5f231d1-0fee-4e1a-a4b6-7840ad531ad9', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('89218636-1f65-41ed-b729-d5967f17d33e', '047364a5-9dcb-4027-a94c-e35f4646860e', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('52ae0923-db99-48e9-95b5-d6884b6d4642', '047364a5-9dcb-4027-a94c-e35f4646860e', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('58769cf3-490e-4d20-8255-3e0854d8384b', '047364a5-9dcb-4027-a94c-e35f4646860e', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('212a3a64-9d05-44ae-a394-e335cb98cdf7', '047364a5-9dcb-4027-a94c-e35f4646860e', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('cc30c5f8-a9ef-453a-b95e-8dcdb6fac92f', '08e80808-fb86-4503-ab9b-9652af82d5b5', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9a4fdac1-5925-464e-848b-1532c780ebdf', '08e80808-fb86-4503-ab9b-9652af82d5b5', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e108043f-3dcd-498c-9560-cde4ed35680e', '08e80808-fb86-4503-ab9b-9652af82d5b5', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ac5044f1-1f16-43fa-afe2-24d80506ae5b', '08e80808-fb86-4503-ab9b-9652af82d5b5', 'TENANT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5be152b8-f32a-44a3-b7f5-3dbbd1d8d31c', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0eabdcfb-e308-4e52-8c7f-27643332c947', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('345b8b7b-a948-446f-949a-2a903b460032', 'f97e9751-6e67-40fb-b840-b818dc69afcf', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('39bc569a-8594-4a3e-954f-3055b382af9a', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('6df50d79-b958-456a-ac84-a8786f0f18a7', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ea2aeb09-dcee-4f6b-a5fb-03b3eb4a3c0c', 'db1fa6bf-85ff-4302-b7c3-9a66f9761830', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('539a38db-5f7d-4bbc-896d-616bd32f0f06', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('209720a4-ab91-4b78-9fc0-ad5780a97934', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('34a3d0d7-b889-4d5a-80f9-a74d0b56f74a', 'cf4c2c71-c6a0-4887-83a3-67509371b8af', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2bb03c85-0eba-4ef2-be45-7bd03fb60936', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9c725eaf-2d1b-43ed-b3cd-f7fcf75b2772', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5fd54e69-2513-4413-95d6-dde58ed6d8ae', 'af682fb0-f06d-4a2b-affb-40487a079a70', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0ee9e55c-9b0f-41fc-9bd5-981f124846d3', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('bf27b482-99fb-43fe-8789-b926b9131a32', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1d24331c-d029-4539-8b40-2b891f6a75a9', '9c468212-9e05-4b29-9d75-5a2c147b2b8f', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0860ac5c-ce03-4f7b-abcb-562676bca90d', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('173a65d3-7eb4-4910-a83f-08ce5ed65583', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('81aefd8d-c7aa-48a5-869f-1df15b4b68ae', 'ace60d06-0635-4c2c-bb4b-7233c19862fc', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('79cf3f87-a87d-40d8-a91a-cdd257866de7', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e4d265c4-fe4a-468d-9cc9-3a77267ddcb3', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('08c7995c-a7e7-4093-8aa0-6e6e8449f1e4', '183d5ad7-4cc1-46c1-8f4e-5d7c24583769', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('30ec4923-e756-46cf-ac20-79065a4f36bd', '9b403ef6-3fae-4698-9b21-2627c51fa254', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0ae403ca-5143-44f0-b997-be330a72ee97', '9b403ef6-3fae-4698-9b21-2627c51fa254', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('aca34128-8a96-494d-a9e7-4e891208b023', '9b403ef6-3fae-4698-9b21-2627c51fa254', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2dbbeed2-ba1a-4781-85e4-28f1620f8f7c', 'f9811182-d400-43e0-ba9e-de745c9e82a3', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('5675feaa-5e18-4f73-9fa2-fc5e5ca2b1ea', 'f9811182-d400-43e0-ba9e-de745c9e82a3', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('89ac1223-5561-4835-8c9d-681ab874a47a', 'f9811182-d400-43e0-ba9e-de745c9e82a3', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('9827f746-1f3a-4c83-ad01-b5cd89f4d5a6', '4924877c-c487-4e4d-8b14-901e9b6069ac', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('03089301-5a05-4c2d-abf3-b95267b2edef', '4924877c-c487-4e4d-8b14-901e9b6069ac', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b204ae10-065f-4969-aedd-4c25602a821c', '4924877c-c487-4e4d-8b14-901e9b6069ac', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e7101997-a1b9-43bd-93a7-8b24fd506f05', '831a608f-fefe-425b-b740-1786f856c680', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('dceec9d4-d2a5-444e-a27b-4a16c01b155b', '831a608f-fefe-425b-b740-1786f856c680', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('3a07b077-aebc-48ad-ab29-6d375afab845', '831a608f-fefe-425b-b740-1786f856c680', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('abc4d0f0-b87c-4515-a6a4-6e3e2fe0c310', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2a9d3ef1-e293-4301-914b-0ed781b63689', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e1ddefd3-730f-4085-8651-a24dc88b7330', '4f95f38e-08e8-497a-8edb-b74f67e3f2b7', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0bb4851a-2274-44cd-85ff-fc4b4710f602', '0bae3550-be89-4c0e-9ba4-01bae0419be0', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('fdfd2976-fc7d-422e-8b5f-91f401927b18', '0bae3550-be89-4c0e-9ba4-01bae0419be0', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ffe77615-7fe9-4dd7-8a55-9459ff2d2b43', '0bae3550-be89-4c0e-9ba4-01bae0419be0', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('93f3cd3e-9b10-4a7c-88a9-39c29118fa8d', 'f3140f7e-5045-4534-92aa-e918895bfafb', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e9daa877-1886-48db-abab-5516000c4d8e', 'f3140f7e-5045-4534-92aa-e918895bfafb', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('edf9d085-dbfc-4e3a-9f0e-9eb407423ff6', 'f3140f7e-5045-4534-92aa-e918895bfafb', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7a4d5839-8342-48c3-95e1-d7032ce2a6a0', '3d0e6bb5-a62e-4225-a2bb-967c76926705', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('232fe9ca-d6b6-4105-869b-435f0b1357cd', '3d0e6bb5-a62e-4225-a2bb-967c76926705', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8f422852-c9d5-4c4f-bac1-ea4950ea77d4', '3d0e6bb5-a62e-4225-a2bb-967c76926705', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8d53905b-418d-4c91-aa71-d4c49184cbae', '3d0e6bb5-a62e-4225-a2bb-967c76926705', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('1ea18a1f-6676-43b8-9fca-20b7e575c31e', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e5bb95d7-2fcd-4767-a200-c7c48e01401c', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('b83a49eb-39d3-4c98-8c0c-5a1fb1862079', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('7564d2ce-d4ad-48e2-baf4-2fc08cc249a8', '6c0ad97f-fb44-471b-b53a-d834cd4ac04c', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('71c29d57-de3e-4f00-9303-2d51e8c11b20', '850aa448-3a14-440c-9834-0b7ef6d83c39', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('adaeb8bf-e22b-4bb9-ab33-66e19053ab31', '850aa448-3a14-440c-9834-0b7ef6d83c39', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('bb372939-0891-4068-bf4b-651e8f2a03c8', '850aa448-3a14-440c-9834-0b7ef6d83c39', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('88d51826-68ce-4d8a-9a65-91429e00d053', '850aa448-3a14-440c-9834-0b7ef6d83c39', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('63c634f6-9a6a-4dc9-9da4-c80d47dc8ac8', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('74b8c100-35a5-4a9e-882b-d106b0656e15', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('c73f5078-0505-44ea-b0e1-57390f4d5a3b', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('86454239-fb95-484e-9f75-142ee5ca2a5d', '1c7e3e8a-59c7-4567-8102-f18694d5a1dc', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('0017035a-e8ef-4e77-a43d-938cfc7962f5', '466056f2-efc6-45d6-b778-fa111db7a18b', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ad177311-3c0c-4d93-9ff7-c0b5665fd0ca', '466056f2-efc6-45d6-b778-fa111db7a18b', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('e2f03c7d-5026-42a3-a18f-ce770314c22b', '466056f2-efc6-45d6-b778-fa111db7a18b', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('8e019651-e0a0-490f-8592-55c7016cec2c', '466056f2-efc6-45d6-b778-fa111db7a18b', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('ee5eda97-ff2a-4646-ae01-dcec47a7688b', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('2214774f-6235-4cb9-8713-e2ee51b213d2', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('919c64ed-015d-4a71-9287-69f554378b69', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('67f93c8d-a31d-4d14-ad7a-6bae4f8202e8', 'e2dd08d5-2083-44ef-bf22-57898af08e3e', 'REFERRER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a48e5290-7207-469f-85ea-c5f5b2150d1f', '51a4690c-bb0e-4be2-a285-31552f900db6', 'OWNER');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('39c84db0-c0b8-48bc-9602-f6371fee499b', '51a4690c-bb0e-4be2-a285-31552f900db6', 'ADMIN');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('a9998fe5-2760-4309-a904-8e4f6787110e', '51a4690c-bb0e-4be2-a285-31552f900db6', 'AGENT');
INSERT INTO rbac.role (uuid, objectuuid, roletype) VALUES ('81268148-75ff-467a-8d73-b8e4f734d83c', '51a4690c-bb0e-4be2-a285-31552f900db6', 'REFERRER');


--
-- Data for Name: subject; Type: TABLE DATA; Schema: rbac; Owner: test
--

INSERT INTO rbac.subject (uuid, name) VALUES ('3706fd53-e952-408a-aedd-93ec6d5129be', 'superuser-alex@hostsharing.net');
INSERT INTO rbac.subject (uuid, name) VALUES ('9ae5d7ce-d996-4510-9513-9b352cf4427f', 'superuser-fran@hostsharing.net');


--
-- Data for Name: customer; Type: TABLE DATA; Schema: rbactest; Owner: test
--



--
-- Data for Name: domain; Type: TABLE DATA; Schema: rbactest; Owner: test
--



--
-- Data for Name: package; Type: TABLE DATA; Schema: rbactest; Owner: test
--



--
-- Name: contact_legacy_id_seq; Type: SEQUENCE SET; Schema: hs_office; Owner: test
--

SELECT pg_catalog.setval('hs_office.contact_legacy_id_seq', 1000000018, true);


--
-- Name: coopassettx_legacy_id_seq; Type: SEQUENCE SET; Schema: hs_office; Owner: test
--

SELECT pg_catalog.setval('hs_office.coopassettx_legacy_id_seq', 1000000017, true);


--
-- Name: coopsharetx_legacy_id_seq; Type: SEQUENCE SET; Schema: hs_office; Owner: test
--

SELECT pg_catalog.setval('hs_office.coopsharetx_legacy_id_seq', 1000000022, true);


--
-- Name: partner_legacy_id_seq; Type: SEQUENCE SET; Schema: hs_office; Owner: test
--

SELECT pg_catalog.setval('hs_office.partner_legacy_id_seq', 1000000012, true);


--
-- Name: sepamandate_legacy_id_seq; Type: SEQUENCE SET; Schema: hs_office; Owner: test
--

SELECT pg_catalog.setval('hs_office.sepamandate_legacy_id_seq', 1000000009, true);


--
-- Name: object_serialid_seq; Type: SEQUENCE SET; Schema: rbac; Owner: test
--

SELECT pg_catalog.setval('rbac.object_serialid_seq', 306, true);


--
-- Name: tx_context tx_context_pkey; Type: CONSTRAINT; Schema: base; Owner: test
--

ALTER TABLE ONLY base.tx_context
    ADD CONSTRAINT tx_context_pkey PRIMARY KEY (txid);


--
-- Name: bankaccount bankaccount_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.bankaccount
    ADD CONSTRAINT bankaccount_uuid_key UNIQUE (uuid);


--
-- Name: contact_legacy_id contact_legacy_id_contact_id_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.contact_legacy_id
    ADD CONSTRAINT contact_legacy_id_contact_id_key UNIQUE (contact_id);


--
-- Name: contact_legacy_id contact_legacy_id_pkey; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.contact_legacy_id
    ADD CONSTRAINT contact_legacy_id_pkey PRIMARY KEY (uuid);


--
-- Name: contact contact_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.contact
    ADD CONSTRAINT contact_uuid_key UNIQUE (uuid);


--
-- Name: coopassettx coopassettx_assetadoptiontxuuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx
    ADD CONSTRAINT coopassettx_assetadoptiontxuuid_key UNIQUE (assetadoptiontxuuid);


--
-- Name: coopassettx_legacy_id coopassettx_legacy_id_member_asset_id_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx_legacy_id
    ADD CONSTRAINT coopassettx_legacy_id_member_asset_id_key UNIQUE (member_asset_id);


--
-- Name: coopassettx_legacy_id coopassettx_legacy_id_pkey; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx_legacy_id
    ADD CONSTRAINT coopassettx_legacy_id_pkey PRIMARY KEY (uuid);


--
-- Name: coopassettx coopassettx_revertedassettxuuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx
    ADD CONSTRAINT coopassettx_revertedassettxuuid_key UNIQUE (revertedassettxuuid);


--
-- Name: coopassettx coopassettx_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx
    ADD CONSTRAINT coopassettx_uuid_key UNIQUE (uuid);


--
-- Name: coopsharetx_legacy_id coopsharetx_legacy_id_member_share_id_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopsharetx_legacy_id
    ADD CONSTRAINT coopsharetx_legacy_id_member_share_id_key UNIQUE (member_share_id);


--
-- Name: coopsharetx_legacy_id coopsharetx_legacy_id_pkey; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopsharetx_legacy_id
    ADD CONSTRAINT coopsharetx_legacy_id_pkey PRIMARY KEY (uuid);


--
-- Name: coopsharetx coopsharetx_revertedsharetxuuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopsharetx
    ADD CONSTRAINT coopsharetx_revertedsharetxuuid_key UNIQUE (revertedsharetxuuid);


--
-- Name: coopsharetx coopsharetx_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopsharetx
    ADD CONSTRAINT coopsharetx_uuid_key UNIQUE (uuid);


--
-- Name: debitor debitor_defaultprefix_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.debitor
    ADD CONSTRAINT debitor_defaultprefix_key UNIQUE (defaultprefix);


--
-- Name: debitor debitor_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.debitor
    ADD CONSTRAINT debitor_uuid_key UNIQUE (uuid);


--
-- Name: membership membership_partneruuid_membernumbersuffix_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.membership
    ADD CONSTRAINT membership_partneruuid_membernumbersuffix_key UNIQUE (partneruuid, membernumbersuffix);


--
-- Name: membership membership_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.membership
    ADD CONSTRAINT membership_uuid_key UNIQUE (uuid);


--
-- Name: partner_details partner_details_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner_details
    ADD CONSTRAINT partner_details_uuid_key UNIQUE (uuid);


--
-- Name: partner_legacy_id partner_legacy_id_bp_id_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner_legacy_id
    ADD CONSTRAINT partner_legacy_id_bp_id_key UNIQUE (bp_id);


--
-- Name: partner_legacy_id partner_legacy_id_pkey; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner_legacy_id
    ADD CONSTRAINT partner_legacy_id_pkey PRIMARY KEY (uuid);


--
-- Name: partner partner_partnernumber_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner
    ADD CONSTRAINT partner_partnernumber_key UNIQUE (partnernumber);


--
-- Name: partner partner_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner
    ADD CONSTRAINT partner_uuid_key UNIQUE (uuid);


--
-- Name: person person_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.person
    ADD CONSTRAINT person_uuid_key UNIQUE (uuid);


--
-- Name: relation relation_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.relation
    ADD CONSTRAINT relation_uuid_key UNIQUE (uuid);


--
-- Name: sepamandate_legacy_id sepamandate_legacy_id_pkey; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.sepamandate_legacy_id
    ADD CONSTRAINT sepamandate_legacy_id_pkey PRIMARY KEY (uuid);


--
-- Name: sepamandate_legacy_id sepamandate_legacy_id_sepa_mandate_id_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.sepamandate_legacy_id
    ADD CONSTRAINT sepamandate_legacy_id_sepa_mandate_id_key UNIQUE (sepa_mandate_id);


--
-- Name: sepamandate sepamandate_uuid_key; Type: CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.sepamandate
    ADD CONSTRAINT sepamandate_uuid_key UNIQUE (uuid);


--
-- Name: databasechangeloglock databasechangeloglock_pkey; Type: CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY public.databasechangeloglock
    ADD CONSTRAINT databasechangeloglock_pkey PRIMARY KEY (id);


--
-- Name: global global_name_key; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.global
    ADD CONSTRAINT global_name_key UNIQUE (name);


--
-- Name: global global_pkey; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.global
    ADD CONSTRAINT global_pkey PRIMARY KEY (uuid);


--
-- Name: grant grant_ascendantuuid_descendantuuid_key; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac."grant"
    ADD CONSTRAINT grant_ascendantuuid_descendantuuid_key UNIQUE (ascendantuuid, descendantuuid);


--
-- Name: grant grant_pkey; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac."grant"
    ADD CONSTRAINT grant_pkey PRIMARY KEY (uuid);


--
-- Name: object object_objecttable_uuid_key; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.object
    ADD CONSTRAINT object_objecttable_uuid_key UNIQUE (objecttable, uuid);


--
-- Name: object object_pkey; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.object
    ADD CONSTRAINT object_pkey PRIMARY KEY (uuid);


--
-- Name: permission permission_pkey; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.permission
    ADD CONSTRAINT permission_pkey PRIMARY KEY (uuid);


--
-- Name: reference reference_uuid_key; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.reference
    ADD CONSTRAINT reference_uuid_key UNIQUE (uuid);


--
-- Name: role role_objectuuid_roletype_key; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.role
    ADD CONSTRAINT role_objectuuid_roletype_key UNIQUE (objectuuid, roletype);


--
-- Name: role role_pkey; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.role
    ADD CONSTRAINT role_pkey PRIMARY KEY (uuid);


--
-- Name: subject subject_name_key; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.subject
    ADD CONSTRAINT subject_name_key UNIQUE (name);


--
-- Name: subject subject_pkey; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.subject
    ADD CONSTRAINT subject_pkey PRIMARY KEY (uuid);


--
-- Name: permission unique_including_null_values; Type: CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.permission
    ADD CONSTRAINT unique_including_null_values UNIQUE NULLS NOT DISTINCT (objectuuid, op, optablename);


--
-- Name: customer customer_prefix_key; Type: CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.customer
    ADD CONSTRAINT customer_prefix_key UNIQUE (prefix);


--
-- Name: customer customer_reference_key; Type: CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.customer
    ADD CONSTRAINT customer_reference_key UNIQUE (reference);


--
-- Name: customer customer_uuid_key; Type: CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.customer
    ADD CONSTRAINT customer_uuid_key UNIQUE (uuid);


--
-- Name: domain domain_uuid_key; Type: CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.domain
    ADD CONSTRAINT domain_uuid_key UNIQUE (uuid);


--
-- Name: package package_uuid_key; Type: CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.package
    ADD CONSTRAINT package_uuid_key UNIQUE (uuid);


--
-- Name: tx_context_txtimestamp_idx; Type: INDEX; Schema: base; Owner: test
--

CREATE INDEX tx_context_txtimestamp_idx ON base.tx_context USING brin (txtimestamp);


--
-- Name: tx_journal_targettable_targetuuid_idx; Type: INDEX; Schema: base; Owner: test
--

CREATE INDEX tx_journal_targettable_targetuuid_idx ON base.tx_journal USING btree (targettable, targetuuid);


--
-- Name: unique_partner_relation; Type: INDEX; Schema: hs_office; Owner: test
--

CREATE UNIQUE INDEX unique_partner_relation ON hs_office.relation USING btree (type, anchoruuid, holderuuid) WHERE ((mark IS NULL) AND (type = 'PARTNER'::hs_office.relationtype));


--
-- Name: unique_relation_with_mark; Type: INDEX; Schema: hs_office; Owner: test
--

CREATE UNIQUE INDEX unique_relation_with_mark ON hs_office.relation USING btree (type, anchoruuid, holderuuid, contactuuid, mark) WHERE (mark IS NOT NULL);


--
-- Name: unique_relation_without_mark; Type: INDEX; Schema: hs_office; Owner: test
--

CREATE UNIQUE INDEX unique_relation_without_mark ON hs_office.relation USING btree (type, anchoruuid, holderuuid, contactuuid) WHERE (mark IS NULL);


--
-- Name: global_singleton; Type: INDEX; Schema: rbac; Owner: test
--

CREATE UNIQUE INDEX global_singleton ON rbac.global USING btree ((0));


--
-- Name: grant_ascendantuuid_idx; Type: INDEX; Schema: rbac; Owner: test
--

CREATE INDEX grant_ascendantuuid_idx ON rbac."grant" USING btree (ascendantuuid);


--
-- Name: grant_descendantuuid_idx; Type: INDEX; Schema: rbac; Owner: test
--

CREATE INDEX grant_descendantuuid_idx ON rbac."grant" USING btree (descendantuuid);


--
-- Name: permission_objectuuid_op_idx; Type: INDEX; Schema: rbac; Owner: test
--

CREATE INDEX permission_objectuuid_op_idx ON rbac.permission USING btree (objectuuid, op);


--
-- Name: permission_optablename_op_idx; Type: INDEX; Schema: rbac; Owner: test
--

CREATE INDEX permission_optablename_op_idx ON rbac.permission USING btree (optablename, op);


--
-- Name: bankaccount build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.bankaccount FOR EACH ROW EXECUTE FUNCTION hs_office.bankaccount_build_rbac_system_after_insert_tf();


--
-- Name: contact build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.contact FOR EACH ROW EXECUTE FUNCTION hs_office.contact_build_rbac_system_after_insert_tf();


--
-- Name: coopassettx build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.coopassettx FOR EACH ROW EXECUTE FUNCTION hs_office.coopassettx_build_rbac_system_after_insert_tf();


--
-- Name: coopsharetx build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.coopsharetx FOR EACH ROW EXECUTE FUNCTION hs_office.coopsharetx_build_rbac_system_after_insert_tf();


--
-- Name: debitor build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.debitor FOR EACH ROW EXECUTE FUNCTION hs_office.debitor_build_rbac_system_after_insert_tf();


--
-- Name: membership build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.membership FOR EACH ROW EXECUTE FUNCTION hs_office.membership_build_rbac_system_after_insert_tf();


--
-- Name: partner build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.partner FOR EACH ROW EXECUTE FUNCTION hs_office.partner_build_rbac_system_after_insert_tf();


--
-- Name: partner_details build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.partner_details FOR EACH ROW EXECUTE FUNCTION hs_office.partner_details_build_rbac_system_after_insert_tf();


--
-- Name: person build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.person FOR EACH ROW EXECUTE FUNCTION hs_office.person_build_rbac_system_after_insert_tf();


--
-- Name: relation build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.relation FOR EACH ROW EXECUTE FUNCTION hs_office.relation_build_rbac_system_after_insert_tf();


--
-- Name: sepamandate build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON hs_office.sepamandate FOR EACH ROW EXECUTE FUNCTION hs_office.sepamandate_build_rbac_system_after_insert_tf();


--
-- Name: coopassettx coopassettx_insert_permission_check_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER coopassettx_insert_permission_check_tg BEFORE INSERT ON hs_office.coopassettx FOR EACH ROW EXECUTE FUNCTION hs_office.coopassettx_insert_permission_check_tf();


--
-- Name: membership coopassettx_z_grants_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER coopassettx_z_grants_after_insert_tg AFTER INSERT ON hs_office.membership FOR EACH ROW EXECUTE FUNCTION hs_office.coopassettx_grants_insert_to_membership_tf();


--
-- Name: coopsharetx coopsharetx_insert_permission_check_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER coopsharetx_insert_permission_check_tg BEFORE INSERT ON hs_office.coopsharetx FOR EACH ROW EXECUTE FUNCTION hs_office.coopsharetx_insert_permission_check_tf();


--
-- Name: membership coopsharetx_z_grants_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER coopsharetx_z_grants_after_insert_tg AFTER INSERT ON hs_office.membership FOR EACH ROW EXECUTE FUNCTION hs_office.coopsharetx_grants_insert_to_membership_tf();


--
-- Name: bankaccount createrbacobjectfor_bankaccount_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_bankaccount_delete_tg_1058_35 AFTER DELETE ON hs_office.bankaccount FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: bankaccount createrbacobjectfor_bankaccount_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_bankaccount_insert_tg_1058_25 BEFORE INSERT ON hs_office.bankaccount FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: contact createrbacobjectfor_contact_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_contact_delete_tg_1058_35 AFTER DELETE ON hs_office.contact FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: contact createrbacobjectfor_contact_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_contact_insert_tg_1058_25 BEFORE INSERT ON hs_office.contact FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: coopassettx createrbacobjectfor_coopassettx_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_coopassettx_delete_tg_1058_35 AFTER DELETE ON hs_office.coopassettx FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: coopassettx createrbacobjectfor_coopassettx_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_coopassettx_insert_tg_1058_25 BEFORE INSERT ON hs_office.coopassettx FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: coopsharetx createrbacobjectfor_coopsharetx_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_coopsharetx_delete_tg_1058_35 AFTER DELETE ON hs_office.coopsharetx FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: coopsharetx createrbacobjectfor_coopsharetx_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_coopsharetx_insert_tg_1058_25 BEFORE INSERT ON hs_office.coopsharetx FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: debitor createrbacobjectfor_debitor_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_debitor_delete_tg_1058_35 AFTER DELETE ON hs_office.debitor FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: debitor createrbacobjectfor_debitor_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_debitor_insert_tg_1058_25 BEFORE INSERT ON hs_office.debitor FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: membership createrbacobjectfor_membership_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_membership_delete_tg_1058_35 AFTER DELETE ON hs_office.membership FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: membership createrbacobjectfor_membership_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_membership_insert_tg_1058_25 BEFORE INSERT ON hs_office.membership FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: partner createrbacobjectfor_partner_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_partner_delete_tg_1058_35 AFTER DELETE ON hs_office.partner FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: partner_details createrbacobjectfor_partner_details_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_partner_details_delete_tg_1058_35 AFTER DELETE ON hs_office.partner_details FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: partner_details createrbacobjectfor_partner_details_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_partner_details_insert_tg_1058_25 BEFORE INSERT ON hs_office.partner_details FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: partner createrbacobjectfor_partner_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_partner_insert_tg_1058_25 BEFORE INSERT ON hs_office.partner FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: person createrbacobjectfor_person_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_person_delete_tg_1058_35 AFTER DELETE ON hs_office.person FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: person createrbacobjectfor_person_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_person_insert_tg_1058_25 BEFORE INSERT ON hs_office.person FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: relation createrbacobjectfor_relation_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_relation_delete_tg_1058_35 AFTER DELETE ON hs_office.relation FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: relation createrbacobjectfor_relation_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_relation_insert_tg_1058_25 BEFORE INSERT ON hs_office.relation FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: sepamandate createrbacobjectfor_sepamandate_delete_tg_1058_35; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_sepamandate_delete_tg_1058_35 AFTER DELETE ON hs_office.sepamandate FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: sepamandate createrbacobjectfor_sepamandate_insert_tg_1058_25; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER createrbacobjectfor_sepamandate_insert_tg_1058_25 BEFORE INSERT ON hs_office.sepamandate FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: debitor debitor_delete_dependents_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER debitor_delete_dependents_tg AFTER DELETE ON hs_office.debitor FOR EACH ROW EXECUTE FUNCTION hs_office.debitor_delete_dependents_tf();


--
-- Name: debitor debitor_insert_permission_check_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER debitor_insert_permission_check_tg BEFORE INSERT ON hs_office.debitor FOR EACH ROW EXECUTE FUNCTION hs_office.debitor_insert_permission_check_tf();


--
-- Name: partner delete_dependents_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER delete_dependents_tg AFTER DELETE ON hs_office.partner FOR EACH ROW EXECUTE FUNCTION hs_office.partner_delete_dependents_tf();


--
-- Name: contact delete_legacy_id_mapping_tf; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER delete_legacy_id_mapping_tf BEFORE DELETE ON hs_office.contact FOR EACH ROW EXECUTE FUNCTION hs_office.contact_delete_legacy_id_mapping_tf();


--
-- Name: sepamandate delete_legacy_id_mapping_tf; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER delete_legacy_id_mapping_tf BEFORE DELETE ON hs_office.sepamandate FOR EACH ROW EXECUTE FUNCTION hs_office.sepamandate_delete_legacy_id_mapping_tf();


--
-- Name: coopassettx delete_legacy_id_mapping_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER delete_legacy_id_mapping_tg BEFORE DELETE ON hs_office.coopassettx FOR EACH ROW EXECUTE FUNCTION hs_office.coopassettx_delete_legacy_id_mapping_tf();


--
-- Name: coopsharetx delete_legacy_id_mapping_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER delete_legacy_id_mapping_tg BEFORE DELETE ON hs_office.coopsharetx FOR EACH ROW EXECUTE FUNCTION hs_office.coopsharetx_delete_legacy_id_mapping_tf();


--
-- Name: partner delete_legacy_id_mapping_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER delete_legacy_id_mapping_tg BEFORE DELETE ON hs_office.partner FOR EACH ROW EXECUTE FUNCTION hs_office.partner_delete_legacy_id_mapping_tf();


--
-- Name: coopassettx enforce_transaction_constraints; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER enforce_transaction_constraints AFTER INSERT OR UPDATE ON hs_office.coopassettx FOR EACH ROW EXECUTE FUNCTION public.validate_transaction_type();


--
-- Name: partner insert_legacy_id_mapping_tf; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER insert_legacy_id_mapping_tf AFTER INSERT ON hs_office.partner FOR EACH ROW EXECUTE FUNCTION hs_office.partner_insert_legacy_id_mapping_tf();


--
-- Name: contact insert_legacy_id_mapping_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER insert_legacy_id_mapping_tg AFTER INSERT ON hs_office.contact FOR EACH ROW EXECUTE FUNCTION hs_office.contact_insert_legacy_id_mapping_tf();


--
-- Name: coopassettx insert_legacy_id_mapping_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER insert_legacy_id_mapping_tg AFTER INSERT ON hs_office.coopassettx FOR EACH ROW EXECUTE FUNCTION hs_office.coopassettx_insert_legacy_id_mapping_tf();


--
-- Name: coopsharetx insert_legacy_id_mapping_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER insert_legacy_id_mapping_tg AFTER INSERT ON hs_office.coopsharetx FOR EACH ROW EXECUTE FUNCTION hs_office.coopsharetx_insert_legacy_id_mapping_tf();


--
-- Name: sepamandate insert_legacy_id_mapping_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER insert_legacy_id_mapping_tg AFTER INSERT ON hs_office.sepamandate FOR EACH ROW EXECUTE FUNCTION hs_office.sepamandate_insert_legacy_id_mapping_tf();


--
-- Name: bankaccount_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.bankaccount_rv FOR EACH ROW EXECUTE FUNCTION hs_office.bankaccount_instead_of_delete_tf();


--
-- Name: contact_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.contact_rv FOR EACH ROW EXECUTE FUNCTION hs_office.contact_instead_of_delete_tf();


--
-- Name: coopassettx_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.coopassettx_rv FOR EACH ROW EXECUTE FUNCTION hs_office.coopassettx_instead_of_delete_tf();


--
-- Name: coopsharetx_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.coopsharetx_rv FOR EACH ROW EXECUTE FUNCTION hs_office.coopsharetx_instead_of_delete_tf();


--
-- Name: debitor_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.debitor_rv FOR EACH ROW EXECUTE FUNCTION hs_office.debitor_instead_of_delete_tf();


--
-- Name: membership_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.membership_rv FOR EACH ROW EXECUTE FUNCTION hs_office.membership_instead_of_delete_tf();


--
-- Name: partner_details_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.partner_details_rv FOR EACH ROW EXECUTE FUNCTION hs_office.partner_details_instead_of_delete_tf();


--
-- Name: partner_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.partner_rv FOR EACH ROW EXECUTE FUNCTION hs_office.partner_instead_of_delete_tf();


--
-- Name: person_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.person_rv FOR EACH ROW EXECUTE FUNCTION hs_office.person_instead_of_delete_tf();


--
-- Name: relation_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.relation_rv FOR EACH ROW EXECUTE FUNCTION hs_office.relation_instead_of_delete_tf();


--
-- Name: sepamandate_rv instead_of_delete_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON hs_office.sepamandate_rv FOR EACH ROW EXECUTE FUNCTION hs_office.sepamandate_instead_of_delete_tf();


--
-- Name: bankaccount_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.bankaccount_rv FOR EACH ROW EXECUTE FUNCTION hs_office.bankaccount_instead_of_insert_tf();


--
-- Name: contact_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.contact_rv FOR EACH ROW EXECUTE FUNCTION hs_office.contact_instead_of_insert_tf();


--
-- Name: coopassettx_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.coopassettx_rv FOR EACH ROW EXECUTE FUNCTION hs_office.coopassettx_instead_of_insert_tf();


--
-- Name: coopsharetx_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.coopsharetx_rv FOR EACH ROW EXECUTE FUNCTION hs_office.coopsharetx_instead_of_insert_tf();


--
-- Name: debitor_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.debitor_rv FOR EACH ROW EXECUTE FUNCTION hs_office.debitor_instead_of_insert_tf();


--
-- Name: membership_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.membership_rv FOR EACH ROW EXECUTE FUNCTION hs_office.membership_instead_of_insert_tf();


--
-- Name: partner_details_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.partner_details_rv FOR EACH ROW EXECUTE FUNCTION hs_office.partner_details_instead_of_insert_tf();


--
-- Name: partner_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.partner_rv FOR EACH ROW EXECUTE FUNCTION hs_office.partner_instead_of_insert_tf();


--
-- Name: person_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.person_rv FOR EACH ROW EXECUTE FUNCTION hs_office.person_instead_of_insert_tf();


--
-- Name: relation_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.relation_rv FOR EACH ROW EXECUTE FUNCTION hs_office.relation_instead_of_insert_tf();


--
-- Name: sepamandate_rv instead_of_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON hs_office.sepamandate_rv FOR EACH ROW EXECUTE FUNCTION hs_office.sepamandate_instead_of_insert_tf();


--
-- Name: bankaccount_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.bankaccount_rv FOR EACH ROW EXECUTE FUNCTION hs_office.bankaccount_instead_of_update_tf();


--
-- Name: contact_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.contact_rv FOR EACH ROW EXECUTE FUNCTION hs_office.contact_instead_of_update_tf();


--
-- Name: coopassettx_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.coopassettx_rv FOR EACH ROW EXECUTE FUNCTION hs_office.coopassettx_instead_of_update_tf();


--
-- Name: coopsharetx_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.coopsharetx_rv FOR EACH ROW EXECUTE FUNCTION hs_office.coopsharetx_instead_of_update_tf();


--
-- Name: debitor_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.debitor_rv FOR EACH ROW EXECUTE FUNCTION hs_office.debitor_instead_of_update_tf();


--
-- Name: membership_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.membership_rv FOR EACH ROW EXECUTE FUNCTION hs_office.membership_instead_of_update_tf();


--
-- Name: partner_details_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.partner_details_rv FOR EACH ROW EXECUTE FUNCTION hs_office.partner_details_instead_of_update_tf();


--
-- Name: partner_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.partner_rv FOR EACH ROW EXECUTE FUNCTION hs_office.partner_instead_of_update_tf();


--
-- Name: person_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.person_rv FOR EACH ROW EXECUTE FUNCTION hs_office.person_instead_of_update_tf();


--
-- Name: relation_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.relation_rv FOR EACH ROW EXECUTE FUNCTION hs_office.relation_instead_of_update_tf();


--
-- Name: sepamandate_rv instead_of_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON hs_office.sepamandate_rv FOR EACH ROW EXECUTE FUNCTION hs_office.sepamandate_instead_of_update_tf();


--
-- Name: membership membership_insert_permission_check_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER membership_insert_permission_check_tg BEFORE INSERT ON hs_office.membership FOR EACH ROW EXECUTE FUNCTION hs_office.membership_insert_permission_check_tf();


--
-- Name: partner_details partner_details_insert_permission_check_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER partner_details_insert_permission_check_tg BEFORE INSERT ON hs_office.partner_details FOR EACH ROW EXECUTE FUNCTION hs_office.partner_details_insert_permission_check_tf();


--
-- Name: partner partner_insert_permission_check_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER partner_insert_permission_check_tg BEFORE INSERT ON hs_office.partner FOR EACH ROW EXECUTE FUNCTION hs_office.partner_insert_permission_check_tf();


--
-- Name: relation relation_insert_permission_check_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER relation_insert_permission_check_tg BEFORE INSERT ON hs_office.relation FOR EACH ROW EXECUTE FUNCTION hs_office.relation_insert_permission_check_tf();


--
-- Name: person relation_z_grants_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER relation_z_grants_after_insert_tg AFTER INSERT ON hs_office.person FOR EACH ROW EXECUTE FUNCTION hs_office.relation_grants_insert_to_person_tf();


--
-- Name: sepamandate sepamandate_insert_permission_check_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER sepamandate_insert_permission_check_tg BEFORE INSERT ON hs_office.sepamandate FOR EACH ROW EXECUTE FUNCTION hs_office.sepamandate_insert_permission_check_tf();


--
-- Name: relation sepamandate_z_grants_after_insert_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER sepamandate_z_grants_after_insert_tg AFTER INSERT ON hs_office.relation FOR EACH ROW EXECUTE FUNCTION hs_office.sepamandate_grants_insert_to_relation_tf();


--
-- Name: bankaccount tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.bankaccount FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: contact tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.contact FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: coopassettx tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.coopassettx FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: coopsharetx tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.coopsharetx FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: debitor tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.debitor FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: membership tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.membership FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: partner tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.partner FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: partner_details tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.partner_details FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: person tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.person FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: relation tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.relation FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: sepamandate tx_0_journal_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON hs_office.sepamandate FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: debitor update_rbac_system_after_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER update_rbac_system_after_update_tg AFTER UPDATE ON hs_office.debitor FOR EACH ROW EXECUTE FUNCTION hs_office.debitor_update_rbac_system_after_update_tf();


--
-- Name: partner update_rbac_system_after_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER update_rbac_system_after_update_tg AFTER UPDATE ON hs_office.partner FOR EACH ROW EXECUTE FUNCTION hs_office.partner_update_rbac_system_after_update_tf();


--
-- Name: relation update_rbac_system_after_update_tg; Type: TRIGGER; Schema: hs_office; Owner: test
--

CREATE TRIGGER update_rbac_system_after_update_tg AFTER UPDATE ON hs_office.relation FOR EACH ROW EXECUTE FUNCTION hs_office.relation_update_rbac_system_after_update_tf();


--
-- Name: global customer_z_grants_after_insert_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER customer_z_grants_after_insert_tg AFTER INSERT ON rbac.global FOR EACH ROW EXECUTE FUNCTION rbactest.customer_grants_insert_to_global_tf();


--
-- Name: global debitor_z_grants_after_insert_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER debitor_z_grants_after_insert_tg AFTER INSERT ON rbac.global FOR EACH ROW EXECUTE FUNCTION hs_office.debitor_grants_insert_to_global_tf();


--
-- Name: grant_rv delete_grant_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER delete_grant_tg INSTEAD OF DELETE ON rbac.grant_rv FOR EACH ROW EXECUTE FUNCTION rbac.delete_grant_tf();


--
-- Name: role delete_grants_of_role_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER delete_grants_of_role_tg BEFORE DELETE ON rbac.role FOR EACH ROW EXECUTE FUNCTION rbac.delete_grants_of_role_tf();


--
-- Name: object delete_roles_of_object_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER delete_roles_of_object_tg BEFORE DELETE ON rbac.object FOR EACH ROW EXECUTE FUNCTION rbac.delete_roles_of_object_tf();


--
-- Name: subject_rv delete_subject_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER delete_subject_tg INSTEAD OF DELETE ON rbac.subject_rv FOR EACH ROW EXECUTE FUNCTION rbac.delete_subject_tf();


--
-- Name: grant_rv insert_grant_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER insert_grant_tg INSTEAD OF INSERT ON rbac.grant_rv FOR EACH ROW EXECUTE FUNCTION rbac.insert_grant_tf();


--
-- Name: subject_rv insert_subject_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER insert_subject_tg INSTEAD OF INSERT ON rbac.subject_rv FOR EACH ROW EXECUTE FUNCTION rbac.insert_subject_tf();


--
-- Name: global membership_z_grants_after_insert_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER membership_z_grants_after_insert_tg AFTER INSERT ON rbac.global FOR EACH ROW EXECUTE FUNCTION hs_office.membership_grants_insert_to_global_tf();


--
-- Name: global partner_details_z_grants_after_insert_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER partner_details_z_grants_after_insert_tg AFTER INSERT ON rbac.global FOR EACH ROW EXECUTE FUNCTION hs_office.partner_details_grants_insert_to_global_tf();


--
-- Name: global partner_z_grants_after_insert_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER partner_z_grants_after_insert_tg AFTER INSERT ON rbac.global FOR EACH ROW EXECUTE FUNCTION hs_office.partner_grants_insert_to_global_tf();


--
-- Name: grant tx_0_journal_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON rbac."grant" FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: object tx_0_journal_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON rbac.object FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: permission tx_0_journal_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON rbac.permission FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: role tx_0_journal_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON rbac.role FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: subject tx_0_journal_tg; Type: TRIGGER; Schema: rbac; Owner: test
--

CREATE TRIGGER tx_0_journal_tg AFTER INSERT OR DELETE OR UPDATE ON rbac.subject FOR EACH ROW EXECUTE FUNCTION base.tx_journal_trigger();


--
-- Name: customer build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON rbactest.customer FOR EACH ROW EXECUTE FUNCTION rbactest.customer_build_rbac_system_after_insert_tf();


--
-- Name: domain build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON rbactest.domain FOR EACH ROW EXECUTE FUNCTION rbactest.domain_build_rbac_system_after_insert_tf();


--
-- Name: package build_rbac_system_after_insert_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER build_rbac_system_after_insert_tg AFTER INSERT ON rbactest.package FOR EACH ROW EXECUTE FUNCTION rbactest.package_build_rbac_system_after_insert_tf();


--
-- Name: customer createrbacobjectfor_customer_delete_tg_1058_35; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER createrbacobjectfor_customer_delete_tg_1058_35 AFTER DELETE ON rbactest.customer FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: customer createrbacobjectfor_customer_insert_tg_1058_25; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER createrbacobjectfor_customer_insert_tg_1058_25 BEFORE INSERT ON rbactest.customer FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: domain createrbacobjectfor_domain_delete_tg_1058_35; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER createrbacobjectfor_domain_delete_tg_1058_35 AFTER DELETE ON rbactest.domain FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: domain createrbacobjectfor_domain_insert_tg_1058_25; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER createrbacobjectfor_domain_insert_tg_1058_25 BEFORE INSERT ON rbactest.domain FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: package createrbacobjectfor_package_delete_tg_1058_35; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER createrbacobjectfor_package_delete_tg_1058_35 AFTER DELETE ON rbactest.package FOR EACH ROW EXECUTE FUNCTION rbac.delete_related_rbac_rules_tf();


--
-- Name: package createrbacobjectfor_package_insert_tg_1058_25; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER createrbacobjectfor_package_insert_tg_1058_25 BEFORE INSERT ON rbactest.package FOR EACH ROW EXECUTE FUNCTION rbac.insert_related_object();


--
-- Name: customer customer_insert_permission_check_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER customer_insert_permission_check_tg BEFORE INSERT ON rbactest.customer FOR EACH ROW EXECUTE FUNCTION rbactest.customer_insert_permission_check_tf();


--
-- Name: domain domain_insert_permission_check_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER domain_insert_permission_check_tg BEFORE INSERT ON rbactest.domain FOR EACH ROW EXECUTE FUNCTION rbactest.domain_insert_permission_check_tf();


--
-- Name: package domain_z_grants_after_insert_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER domain_z_grants_after_insert_tg AFTER INSERT ON rbactest.package FOR EACH ROW EXECUTE FUNCTION rbactest.domain_grants_insert_to_package_tf();


--
-- Name: customer_rv instead_of_delete_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON rbactest.customer_rv FOR EACH ROW EXECUTE FUNCTION rbactest.customer_instead_of_delete_tf();


--
-- Name: domain_rv instead_of_delete_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON rbactest.domain_rv FOR EACH ROW EXECUTE FUNCTION rbactest.domain_instead_of_delete_tf();


--
-- Name: package_rv instead_of_delete_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER instead_of_delete_tg INSTEAD OF DELETE ON rbactest.package_rv FOR EACH ROW EXECUTE FUNCTION rbactest.package_instead_of_delete_tf();


--
-- Name: customer_rv instead_of_insert_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON rbactest.customer_rv FOR EACH ROW EXECUTE FUNCTION rbactest.customer_instead_of_insert_tf();


--
-- Name: domain_rv instead_of_insert_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON rbactest.domain_rv FOR EACH ROW EXECUTE FUNCTION rbactest.domain_instead_of_insert_tf();


--
-- Name: package_rv instead_of_insert_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER instead_of_insert_tg INSTEAD OF INSERT ON rbactest.package_rv FOR EACH ROW EXECUTE FUNCTION rbactest.package_instead_of_insert_tf();


--
-- Name: customer_rv instead_of_update_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON rbactest.customer_rv FOR EACH ROW EXECUTE FUNCTION rbactest.customer_instead_of_update_tf();


--
-- Name: domain_rv instead_of_update_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON rbactest.domain_rv FOR EACH ROW EXECUTE FUNCTION rbactest.domain_instead_of_update_tf();


--
-- Name: package_rv instead_of_update_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER instead_of_update_tg INSTEAD OF UPDATE ON rbactest.package_rv FOR EACH ROW EXECUTE FUNCTION rbactest.package_instead_of_update_tf();


--
-- Name: package package_insert_permission_check_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER package_insert_permission_check_tg BEFORE INSERT ON rbactest.package FOR EACH ROW EXECUTE FUNCTION rbactest.package_insert_permission_check_tf();


--
-- Name: customer package_z_grants_after_insert_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER package_z_grants_after_insert_tg AFTER INSERT ON rbactest.customer FOR EACH ROW EXECUTE FUNCTION rbactest.package_grants_insert_to_customer_tf();


--
-- Name: domain update_rbac_system_after_update_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER update_rbac_system_after_update_tg AFTER UPDATE ON rbactest.domain FOR EACH ROW EXECUTE FUNCTION rbactest.domain_update_rbac_system_after_update_tf();


--
-- Name: package update_rbac_system_after_update_tg; Type: TRIGGER; Schema: rbactest; Owner: test
--

CREATE TRIGGER update_rbac_system_after_update_tg AFTER UPDATE ON rbactest.package FOR EACH ROW EXECUTE FUNCTION rbactest.package_update_rbac_system_after_update_tf();


--
-- Name: tx_journal tx_journal_txid_fkey; Type: FK CONSTRAINT; Schema: base; Owner: test
--

ALTER TABLE ONLY base.tx_journal
    ADD CONSTRAINT tx_journal_txid_fkey FOREIGN KEY (txid) REFERENCES base.tx_context(txid);


--
-- Name: bankaccount bankaccount_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.bankaccount
    ADD CONSTRAINT bankaccount_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_legacy_id contact_legacy_id_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.contact_legacy_id
    ADD CONSTRAINT contact_legacy_id_uuid_fkey FOREIGN KEY (uuid) REFERENCES hs_office.contact(uuid);


--
-- Name: contact contact_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.contact
    ADD CONSTRAINT contact_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: coopassettx coopassettx_assetadoptiontxuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx
    ADD CONSTRAINT coopassettx_assetadoptiontxuuid_fkey FOREIGN KEY (assetadoptiontxuuid) REFERENCES hs_office.coopassettx(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: coopassettx_legacy_id coopassettx_legacy_id_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx_legacy_id
    ADD CONSTRAINT coopassettx_legacy_id_uuid_fkey FOREIGN KEY (uuid) REFERENCES hs_office.coopassettx(uuid);


--
-- Name: coopassettx coopassettx_membershipuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx
    ADD CONSTRAINT coopassettx_membershipuuid_fkey FOREIGN KEY (membershipuuid) REFERENCES hs_office.membership(uuid);


--
-- Name: coopassettx coopassettx_revertedassettxuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx
    ADD CONSTRAINT coopassettx_revertedassettxuuid_fkey FOREIGN KEY (revertedassettxuuid) REFERENCES hs_office.coopassettx(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: coopassettx coopassettx_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopassettx
    ADD CONSTRAINT coopassettx_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: coopsharetx_legacy_id coopsharetx_legacy_id_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopsharetx_legacy_id
    ADD CONSTRAINT coopsharetx_legacy_id_uuid_fkey FOREIGN KEY (uuid) REFERENCES hs_office.coopsharetx(uuid);


--
-- Name: coopsharetx coopsharetx_membershipuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopsharetx
    ADD CONSTRAINT coopsharetx_membershipuuid_fkey FOREIGN KEY (membershipuuid) REFERENCES hs_office.membership(uuid);


--
-- Name: coopsharetx coopsharetx_revertedsharetxuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopsharetx
    ADD CONSTRAINT coopsharetx_revertedsharetxuuid_fkey FOREIGN KEY (revertedsharetxuuid) REFERENCES hs_office.coopsharetx(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: coopsharetx coopsharetx_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.coopsharetx
    ADD CONSTRAINT coopsharetx_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: debitor debitor_debitorreluuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.debitor
    ADD CONSTRAINT debitor_debitorreluuid_fkey FOREIGN KEY (debitorreluuid) REFERENCES hs_office.relation(uuid);


--
-- Name: debitor debitor_refundbankaccountuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.debitor
    ADD CONSTRAINT debitor_refundbankaccountuuid_fkey FOREIGN KEY (refundbankaccountuuid) REFERENCES hs_office.bankaccount(uuid);


--
-- Name: debitor debitor_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.debitor
    ADD CONSTRAINT debitor_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: membership membership_partneruuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.membership
    ADD CONSTRAINT membership_partneruuid_fkey FOREIGN KEY (partneruuid) REFERENCES hs_office.partner(uuid);


--
-- Name: membership membership_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.membership
    ADD CONSTRAINT membership_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: partner_details partner_details_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner_details
    ADD CONSTRAINT partner_details_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: partner partner_detailsuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner
    ADD CONSTRAINT partner_detailsuuid_fkey FOREIGN KEY (detailsuuid) REFERENCES hs_office.partner_details(uuid);


--
-- Name: partner_legacy_id partner_legacy_id_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner_legacy_id
    ADD CONSTRAINT partner_legacy_id_uuid_fkey FOREIGN KEY (uuid) REFERENCES hs_office.partner(uuid);


--
-- Name: partner partner_partnerreluuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner
    ADD CONSTRAINT partner_partnerreluuid_fkey FOREIGN KEY (partnerreluuid) REFERENCES hs_office.relation(uuid);


--
-- Name: partner partner_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.partner
    ADD CONSTRAINT partner_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: person person_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.person
    ADD CONSTRAINT person_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: relation relation_anchoruuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.relation
    ADD CONSTRAINT relation_anchoruuid_fkey FOREIGN KEY (anchoruuid) REFERENCES hs_office.person(uuid);


--
-- Name: relation relation_contactuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.relation
    ADD CONSTRAINT relation_contactuuid_fkey FOREIGN KEY (contactuuid) REFERENCES hs_office.contact(uuid);


--
-- Name: relation relation_holderuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.relation
    ADD CONSTRAINT relation_holderuuid_fkey FOREIGN KEY (holderuuid) REFERENCES hs_office.person(uuid);


--
-- Name: relation relation_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.relation
    ADD CONSTRAINT relation_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: sepamandate sepamandate_bankaccountuuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.sepamandate
    ADD CONSTRAINT sepamandate_bankaccountuuid_fkey FOREIGN KEY (bankaccountuuid) REFERENCES hs_office.bankaccount(uuid);


--
-- Name: sepamandate sepamandate_debitoruuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.sepamandate
    ADD CONSTRAINT sepamandate_debitoruuid_fkey FOREIGN KEY (debitoruuid) REFERENCES hs_office.debitor(uuid);


--
-- Name: sepamandate_legacy_id sepamandate_legacy_id_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.sepamandate_legacy_id
    ADD CONSTRAINT sepamandate_legacy_id_uuid_fkey FOREIGN KEY (uuid) REFERENCES hs_office.sepamandate(uuid);


--
-- Name: sepamandate sepamandate_uuid_fkey; Type: FK CONSTRAINT; Schema: hs_office; Owner: test
--

ALTER TABLE ONLY hs_office.sepamandate
    ADD CONSTRAINT sepamandate_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: global global_uuid_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.global
    ADD CONSTRAINT global_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid) ON DELETE CASCADE;


--
-- Name: grant grant_ascendantuuid_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac."grant"
    ADD CONSTRAINT grant_ascendantuuid_fkey FOREIGN KEY (ascendantuuid) REFERENCES rbac.reference(uuid);


--
-- Name: grant grant_descendantuuid_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac."grant"
    ADD CONSTRAINT grant_descendantuuid_fkey FOREIGN KEY (descendantuuid) REFERENCES rbac.reference(uuid);


--
-- Name: grant grant_grantedbyroleuuid_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac."grant"
    ADD CONSTRAINT grant_grantedbyroleuuid_fkey FOREIGN KEY (grantedbyroleuuid) REFERENCES rbac.role(uuid);


--
-- Name: grant grant_grantedbytriggerof_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac."grant"
    ADD CONSTRAINT grant_grantedbytriggerof_fkey FOREIGN KEY (grantedbytriggerof) REFERENCES rbac.object(uuid) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: permission permission_objectuuid_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.permission
    ADD CONSTRAINT permission_objectuuid_fkey FOREIGN KEY (objectuuid) REFERENCES rbac.object(uuid);


--
-- Name: permission permission_uuid_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.permission
    ADD CONSTRAINT permission_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.reference(uuid) ON DELETE CASCADE;


--
-- Name: role role_objectuuid_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.role
    ADD CONSTRAINT role_objectuuid_fkey FOREIGN KEY (objectuuid) REFERENCES rbac.object(uuid) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: role role_uuid_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.role
    ADD CONSTRAINT role_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.reference(uuid) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: subject subject_uuid_fkey; Type: FK CONSTRAINT; Schema: rbac; Owner: test
--

ALTER TABLE ONLY rbac.subject
    ADD CONSTRAINT subject_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.reference(uuid) ON DELETE CASCADE;


--
-- Name: customer customer_uuid_fkey; Type: FK CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.customer
    ADD CONSTRAINT customer_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid);


--
-- Name: domain domain_packageuuid_fkey; Type: FK CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.domain
    ADD CONSTRAINT domain_packageuuid_fkey FOREIGN KEY (packageuuid) REFERENCES rbactest.package(uuid);


--
-- Name: domain domain_uuid_fkey; Type: FK CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.domain
    ADD CONSTRAINT domain_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid);


--
-- Name: package package_customeruuid_fkey; Type: FK CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.package
    ADD CONSTRAINT package_customeruuid_fkey FOREIGN KEY (customeruuid) REFERENCES rbactest.customer(uuid);


--
-- Name: package package_uuid_fkey; Type: FK CONSTRAINT; Schema: rbactest; Owner: test
--

ALTER TABLE ONLY rbactest.package
    ADD CONSTRAINT package_uuid_fkey FOREIGN KEY (uuid) REFERENCES rbac.object(uuid);


--
-- Name: TABLE bankaccount_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.bankaccount_iv TO restricted;


--
-- Name: TABLE bankaccount_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.bankaccount_rv TO restricted;


--
-- Name: TABLE contact_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.contact_iv TO restricted;


--
-- Name: TABLE contact_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.contact_rv TO restricted;


--
-- Name: TABLE coopassettx_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.coopassettx_iv TO restricted;


--
-- Name: TABLE coopassettx_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.coopassettx_rv TO restricted;


--
-- Name: TABLE coopsharetx_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.coopsharetx_iv TO restricted;


--
-- Name: TABLE coopsharetx_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.coopsharetx_rv TO restricted;


--
-- Name: TABLE debitor_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.debitor_iv TO restricted;


--
-- Name: TABLE debitor_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.debitor_rv TO restricted;


--
-- Name: TABLE membership_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.membership_iv TO restricted;


--
-- Name: TABLE membership_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.membership_rv TO restricted;


--
-- Name: TABLE partner_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.partner_iv TO restricted;


--
-- Name: TABLE partner_details_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.partner_details_iv TO restricted;


--
-- Name: TABLE partner_details_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.partner_details_rv TO restricted;


--
-- Name: TABLE partner_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.partner_rv TO restricted;


--
-- Name: TABLE person_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.person_iv TO restricted;


--
-- Name: TABLE person_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.person_rv TO restricted;


--
-- Name: TABLE relation_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.relation_iv TO restricted;


--
-- Name: TABLE relation_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.relation_rv TO restricted;


--
-- Name: TABLE sepamandate_iv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.sepamandate_iv TO restricted;


--
-- Name: TABLE sepamandate_rv; Type: ACL; Schema: hs_office; Owner: test
--

GRANT ALL ON TABLE hs_office.sepamandate_rv TO restricted;


--
-- Name: TABLE databasechangelog; Type: ACL; Schema: public; Owner: test
--

GRANT ALL ON TABLE public.databasechangelog TO admin;
GRANT ALL ON TABLE public.databasechangelog TO restricted;


--
-- Name: TABLE databasechangeloglock; Type: ACL; Schema: public; Owner: test
--

GRANT ALL ON TABLE public.databasechangeloglock TO admin;
GRANT ALL ON TABLE public.databasechangeloglock TO restricted;


--
-- Name: TABLE global; Type: ACL; Schema: rbac; Owner: test
--

GRANT SELECT ON TABLE rbac.global TO restricted;


--
-- Name: TABLE global_iv; Type: ACL; Schema: rbac; Owner: test
--

GRANT ALL ON TABLE rbac.global_iv TO restricted;


--
-- Name: TABLE role_rv; Type: ACL; Schema: rbac; Owner: test
--

GRANT ALL ON TABLE rbac.role_rv TO restricted;


--
-- Name: TABLE own_granted_permissions_rv; Type: ACL; Schema: rbac; Owner: test
--

GRANT ALL ON TABLE rbac.own_granted_permissions_rv TO restricted;


--
-- Name: TABLE subject_rv; Type: ACL; Schema: rbac; Owner: test
--

GRANT ALL ON TABLE rbac.subject_rv TO restricted;


--
-- Name: TABLE customer_iv; Type: ACL; Schema: rbactest; Owner: test
--

GRANT ALL ON TABLE rbactest.customer_iv TO restricted;


--
-- Name: TABLE customer_rv; Type: ACL; Schema: rbactest; Owner: test
--

GRANT ALL ON TABLE rbactest.customer_rv TO restricted;


--
-- Name: TABLE domain_iv; Type: ACL; Schema: rbactest; Owner: test
--

GRANT ALL ON TABLE rbactest.domain_iv TO restricted;


--
-- Name: TABLE domain_rv; Type: ACL; Schema: rbactest; Owner: test
--

GRANT ALL ON TABLE rbactest.domain_rv TO restricted;


--
-- Name: TABLE package_iv; Type: ACL; Schema: rbactest; Owner: test
--

GRANT ALL ON TABLE rbactest.package_iv TO restricted;


--
-- Name: TABLE package_rv; Type: ACL; Schema: rbactest; Owner: test
--

GRANT ALL ON TABLE rbactest.package_rv TO restricted;


--
-- PostgreSQL database dump complete
--

